// Dafny 2.3.0.10506
// Command Line Options: /compile:0 /timeLimit:1 /print:boogies/Impl-JournalistImpl.i.dfy.bpl /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type Ty;

type Bv0 = int;

const unique TBool: Ty;

const unique TChar: Ty;

const unique TInt: Ty;

const unique TReal: Ty;

const unique TORDINAL: Ty;

function TBitvector(int) : Ty;

function TSet(Ty) : Ty;

function TISet(Ty) : Ty;

function TMultiSet(Ty) : Ty;

function TSeq(Ty) : Ty;

function TMap(Ty, Ty) : Ty;

function TIMap(Ty, Ty) : Ty;

function Inv0_TBitvector(Ty) : int;

axiom (forall w: int :: { TBitvector(w) } Inv0_TBitvector(TBitvector(w)) == w);

function Inv0_TSet(Ty) : Ty;

axiom (forall t: Ty :: { TSet(t) } Inv0_TSet(TSet(t)) == t);

function Inv0_TISet(Ty) : Ty;

axiom (forall t: Ty :: { TISet(t) } Inv0_TISet(TISet(t)) == t);

function Inv0_TSeq(Ty) : Ty;

axiom (forall t: Ty :: { TSeq(t) } Inv0_TSeq(TSeq(t)) == t);

function Inv0_TMultiSet(Ty) : Ty;

axiom (forall t: Ty :: { TMultiSet(t) } Inv0_TMultiSet(TMultiSet(t)) == t);

function Inv0_TMap(Ty) : Ty;

function Inv1_TMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv0_TMap(TMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv1_TMap(TMap(t, u)) == u);

function Inv0_TIMap(Ty) : Ty;

function Inv1_TIMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv0_TIMap(TIMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv1_TIMap(TIMap(t, u)) == u);

type TyTag;

function Tag(Ty) : TyTag;

const unique TagBool: TyTag;

const unique TagChar: TyTag;

const unique TagInt: TyTag;

const unique TagReal: TyTag;

const unique TagORDINAL: TyTag;

const unique TagSet: TyTag;

const unique TagISet: TyTag;

const unique TagMultiSet: TyTag;

const unique TagSeq: TyTag;

const unique TagMap: TyTag;

const unique TagIMap: TyTag;

const unique TagClass: TyTag;

axiom Tag(TBool) == TagBool;

axiom Tag(TChar) == TagChar;

axiom Tag(TInt) == TagInt;

axiom Tag(TReal) == TagReal;

axiom Tag(TORDINAL) == TagORDINAL;

axiom (forall t: Ty :: { TSet(t) } Tag(TSet(t)) == TagSet);

axiom (forall t: Ty :: { TISet(t) } Tag(TISet(t)) == TagISet);

axiom (forall t: Ty :: { TMultiSet(t) } Tag(TMultiSet(t)) == TagMultiSet);

axiom (forall t: Ty :: { TSeq(t) } Tag(TSeq(t)) == TagSeq);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Tag(TMap(t, u)) == TagMap);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Tag(TIMap(t, u)) == TagIMap);

function {:identity} Lit<T>(x: T) : T;

axiom (forall<T> x: T :: {:identity} { Lit(x): T } Lit(x): T == x);

axiom (forall<T> x: T :: { $Box(Lit(x)) } $Box(Lit(x)) == Lit($Box(x)));

function {:identity} LitInt(x: int) : int;

axiom (forall x: int :: {:identity} { LitInt(x): int } LitInt(x): int == x);

axiom (forall x: int :: { $Box(LitInt(x)) } $Box(LitInt(x)) == Lit($Box(x)));

function {:identity} LitReal(x: real) : real;

axiom (forall x: real :: {:identity} { LitReal(x): real } LitReal(x): real == x);

axiom (forall x: real :: { $Box(LitReal(x)) } $Box(LitReal(x)) == Lit($Box(x)));

type char;

function char#FromInt(int) : char;

function char#ToInt(char) : int;

axiom (forall ch: char :: 
  { char#ToInt(ch) } 
  char#FromInt(char#ToInt(ch)) == ch
     && 0 <= char#ToInt(ch)
     && char#ToInt(ch) < 65536);

axiom (forall n: int :: 
  { char#FromInt(n) } 
  0 <= n && n < 65536 ==> char#ToInt(char#FromInt(n)) == n);

function char#Plus(char, char) : char;

function char#Minus(char, char) : char;

axiom (forall a: char, b: char :: 
  { char#Plus(a, b) } 
  char#Plus(a, b) == char#FromInt(char#ToInt(a) + char#ToInt(b)));

axiom (forall a: char, b: char :: 
  { char#Minus(a, b) } 
  char#Minus(a, b) == char#FromInt(char#ToInt(a) - char#ToInt(b)));

type ref;

const null: ref;

function IsTraitParent(classOrTrait: ClassName, traitParent: ClassName) : bool;

type Box;

const $ArbitraryBoxValue: Box;

function $Box<T>(T) : Box;

function $Unbox<T>(Box) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall bx: Box :: 
  { $IsBox(bx, TInt) } 
  $IsBox(bx, TInt) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, TInt));

axiom (forall bx: Box :: 
  { $IsBox(bx, TReal) } 
  $IsBox(bx, TReal)
     ==> $Box($Unbox(bx): real) == bx && $Is($Unbox(bx): real, TReal));

axiom (forall bx: Box :: 
  { $IsBox(bx, TBool) } 
  $IsBox(bx, TBool)
     ==> $Box($Unbox(bx): bool) == bx && $Is($Unbox(bx): bool, TBool));

axiom (forall bx: Box :: 
  { $IsBox(bx, TChar) } 
  $IsBox(bx, TChar)
     ==> $Box($Unbox(bx): char) == bx && $Is($Unbox(bx): char, TChar));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSet(t)) } 
  $IsBox(bx, TSet(t))
     ==> $Box($Unbox(bx): Set Box) == bx && $Is($Unbox(bx): Set Box, TSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TISet(t)) } 
  $IsBox(bx, TISet(t))
     ==> $Box($Unbox(bx): ISet Box) == bx && $Is($Unbox(bx): ISet Box, TISet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TMultiSet(t)) } 
  $IsBox(bx, TMultiSet(t))
     ==> $Box($Unbox(bx): MultiSet Box) == bx
       && $Is($Unbox(bx): MultiSet Box, TMultiSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSeq(t)) } 
  $IsBox(bx, TSeq(t))
     ==> $Box($Unbox(bx): Seq Box) == bx && $Is($Unbox(bx): Seq Box, TSeq(t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TMap(s, t)) } 
  $IsBox(bx, TMap(s, t))
     ==> $Box($Unbox(bx): Map Box Box) == bx && $Is($Unbox(bx): Map Box Box, TMap(s, t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TIMap(s, t)) } 
  $IsBox(bx, TIMap(s, t))
     ==> $Box($Unbox(bx): IMap Box Box) == bx
       && $Is($Unbox(bx): IMap Box Box, TIMap(s, t)));

axiom (forall<T> v: T, t: Ty :: 
  { $IsBox($Box(v), t) } 
  $IsBox($Box(v), t) <==> $Is(v, t));

axiom (forall<T> v: T, t: Ty, h: Heap :: 
  { $IsAllocBox($Box(v), t, h) } 
  $IsAllocBox($Box(v), t, h) <==> $IsAlloc(v, t, h));

function $Is<T>(T, Ty) : bool;

function $IsAlloc<T>(T, Ty, Heap) : bool;

function $IsBox<T>(T, Ty) : bool;

function $IsAllocBox<T>(T, Ty, Heap) : bool;

axiom (forall v: int :: { $Is(v, TInt) } $Is(v, TInt));

axiom (forall v: real :: { $Is(v, TReal) } $Is(v, TReal));

axiom (forall v: bool :: { $Is(v, TBool) } $Is(v, TBool));

axiom (forall v: char :: { $Is(v, TChar) } $Is(v, TChar));

axiom (forall v: ORDINAL :: { $Is(v, TORDINAL) } $Is(v, TORDINAL));

axiom (forall h: Heap, v: int :: { $IsAlloc(v, TInt, h) } $IsAlloc(v, TInt, h));

axiom (forall h: Heap, v: real :: { $IsAlloc(v, TReal, h) } $IsAlloc(v, TReal, h));

axiom (forall h: Heap, v: bool :: { $IsAlloc(v, TBool, h) } $IsAlloc(v, TBool, h));

axiom (forall h: Heap, v: char :: { $IsAlloc(v, TChar, h) } $IsAlloc(v, TChar, h));

axiom (forall h: Heap, v: ORDINAL :: 
  { $IsAlloc(v, TORDINAL, h) } 
  $IsAlloc(v, TORDINAL, h));

axiom (forall v: Set Box, t0: Ty :: 
  { $Is(v, TSet(t0)) } 
  $Is(v, TSet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: ISet Box, t0: Ty :: 
  { $Is(v, TISet(t0)) } 
  $Is(v, TISet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0))
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0)) ==> $IsGoodMultiSet(v));

axiom (forall v: Seq Box, t0: Ty :: 
  { $Is(v, TSeq(t0)) } 
  $Is(v, TSeq(t0))
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsBox(Seq#Index(v, i), t0)));

axiom (forall v: Set Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSet(t0), h) } 
  $IsAlloc(v, TSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: ISet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TISet(t0), h) } 
  $IsAlloc(v, TISet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: MultiSet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TMultiSet(t0), h) } 
  $IsAlloc(v, TMultiSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: Seq Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSeq(t0), h) } 
  $IsAlloc(v, TSeq(t0), h)
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsAllocBox(Seq#Index(v, i), t0, h)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TMap(t0, t1)) } 
  $Is(v, TMap(t0, t1))
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx] ==> $IsBox(Map#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TMap(t0, t1), h) } 
  $IsAlloc(v, TMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx]
         ==> $IsAllocBox(Map#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TIMap(t0, t1)) } 
  $Is(v, TIMap(t0, t1))
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx] ==> $IsBox(IMap#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TIMap(t0, t1), h) } 
  $IsAlloc(v, TIMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx]
         ==> $IsAllocBox(IMap#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

type ClassName;

const unique class._System.int: ClassName;

const unique class._System.bool: ClassName;

const unique class._System.set: ClassName;

const unique class._System.seq: ClassName;

const unique class._System.multiset: ClassName;

function Tclass._System.object?() : Ty;

function dtype(ref) : Ty;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: 
  { TypeTuple(a, b) } 
  TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type HandleType;

function SetRef_to_SetBox(s: [ref]bool) : Set Box;

axiom (forall s: [ref]bool, bx: Box :: 
  { SetRef_to_SetBox(s)[bx] } 
  SetRef_to_SetBox(s)[bx] == s[$Unbox(bx): ref]);

axiom (forall s: [ref]bool :: 
  { SetRef_to_SetBox(s) } 
  $Is(SetRef_to_SetBox(s), TSet(Tclass._System.object?())));

function Apply1(Ty, Ty, Heap, HandleType, Box) : Box;

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

function BoxRank(Box) : int;

axiom (forall d: DatatypeType :: { BoxRank($Box(d)) } BoxRank($Box(d)) == DtRank(d));

type ORDINAL = Box;

function ORD#IsNat(ORDINAL) : bool;

function ORD#Offset(ORDINAL) : int;

axiom (forall o: ORDINAL :: { ORD#Offset(o) } 0 <= ORD#Offset(o));

function {:inline} ORD#IsLimit(o: ORDINAL) : bool
{
  ORD#Offset(o) == 0
}

function {:inline} ORD#IsSucc(o: ORDINAL) : bool
{
  0 < ORD#Offset(o)
}

function ORD#FromNat(int) : ORDINAL;

axiom (forall n: int :: 
  { ORD#FromNat(n) } 
  0 <= n ==> ORD#IsNat(ORD#FromNat(n)) && ORD#Offset(ORD#FromNat(n)) == n);

axiom (forall o: ORDINAL :: 
  { ORD#Offset(o) } { ORD#IsNat(o) } 
  ORD#IsNat(o) ==> o == ORD#FromNat(ORD#Offset(o)));

function ORD#Less(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p) } 
  (ORD#Less(o, p) ==> o != p)
     && (ORD#IsNat(o) && !ORD#IsNat(p) ==> ORD#Less(o, p))
     && (ORD#IsNat(o) && ORD#IsNat(p)
       ==> ORD#Less(o, p) == (ORD#Offset(o) < ORD#Offset(p)))
     && (ORD#Less(o, p) && ORD#IsNat(p) ==> ORD#IsNat(o)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, o) } 
  ORD#Less(o, p) || o == p || ORD#Less(p, o));

axiom (forall o: ORDINAL, p: ORDINAL, r: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, r) } { ORD#Less(o, p), ORD#Less(o, r) } 
  ORD#Less(o, p) && ORD#Less(p, r) ==> ORD#Less(o, r));

function ORD#LessThanLimit(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#LessThanLimit(o, p) } 
  ORD#LessThanLimit(o, p) == ORD#Less(o, p));

function ORD#Plus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (ORD#IsNat(ORD#Plus(o, p)) ==> ORD#IsNat(o) && ORD#IsNat(p))
     && (ORD#IsNat(p)
       ==> ORD#IsNat(ORD#Plus(o, p)) == ORD#IsNat(o)
         && ORD#Offset(ORD#Plus(o, p)) == ORD#Offset(o) + ORD#Offset(p)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#Plus(o, p) || ORD#Less(o, ORD#Plus(o, p)))
     && (p == ORD#Plus(o, p) || ORD#Less(p, ORD#Plus(o, p))));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#FromNat(0) ==> ORD#Plus(o, p) == p)
     && (p == ORD#FromNat(0) ==> ORD#Plus(o, p) == o));

function ORD#Minus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> ORD#IsNat(ORD#Minus(o, p)) == ORD#IsNat(o)
       && ORD#Offset(ORD#Minus(o, p)) == ORD#Offset(o) - ORD#Offset(p));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> (p == ORD#FromNat(0) && ORD#Minus(o, p) == o)
       || (p != ORD#FromNat(0) && ORD#Less(ORD#Minus(o, p), o)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n
     ==> ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Plus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && m + n <= ORD#Offset(o)
     ==> ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Minus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(n - m))));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(n - m))));

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

type LayerType;

const $LZ: LayerType;

function $LS(LayerType) : LayerType;

function AsFuelBottom(LayerType) : LayerType;

function AtLayer<A>([LayerType]A, LayerType) : A;

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, ly) } 
  AtLayer(f, ly) == f[ly]);

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, $LS(ly)) } 
  AtLayer(f, $LS(ly)) == AtLayer(f, ly));

type Field _;

function FDim<T>(Field T) : int;

function IndexField(int) : Field Box;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field Box, int) : Field Box;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  MultiIndexField_Inverse0(MultiIndexField(f, i)) == f
     && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

type NameFamily;

function DeclName<T>(Field T) : NameFamily;

function FieldOfDecl<alpha>(ClassName, NameFamily) : Field alpha;

axiom (forall<T> cl: ClassName, nm: NameFamily :: 
  { FieldOfDecl(cl, nm): Field T } 
  DeclType(FieldOfDecl(cl, nm): Field T) == cl
     && DeclName(FieldOfDecl(cl, nm): Field T) == nm);

function $IsGhostField<T>(Field T) : bool;

axiom (forall<T> h: Heap, k: Heap, v: T, t: Ty :: 
  { $HeapSucc(h, k), $IsAlloc(v, t, h) } 
  $HeapSucc(h, k) ==> $IsAlloc(v, t, h) ==> $IsAlloc(v, t, k));

axiom (forall h: Heap, k: Heap, bx: Box, t: Ty :: 
  { $HeapSucc(h, k), $IsAllocBox(bx, t, h) } 
  $HeapSucc(h, k) ==> $IsAllocBox(bx, t, h) ==> $IsAllocBox(bx, t, k));

const unique alloc: Field bool;

const unique allocName: NameFamily;

axiom FDim(alloc) == 0 && DeclName(alloc) == allocName && !$IsGhostField(alloc);

function _System.array.Length(a: ref) : int;

axiom (forall o: ref :: 0 <= _System.array.Length(o));

function Int(x: real) : int;

axiom (forall x: real :: { Int(x): int } Int(x): int == int(x));

function Real(x: int) : real;

axiom (forall x: int :: { Real(x): real } Real(x): real == real(x));

axiom (forall i: int :: { Int(Real(i)) } Int(Real(i)) == i);

function {:inline} _System.real.Floor(x: real) : int
{
  Int(x)
}

type Heap = [ref]<alpha>[Field alpha]alpha;

function {:inline} read<alpha>(H: Heap, r: ref, f: Field alpha) : alpha
{
  H[r][f]
}

function {:inline} update<alpha>(H: Heap, r: ref, f: Field alpha, v: alpha) : Heap
{
  H[r := H[r][f := v]]
}

function $IsGoodHeap(Heap) : bool;

function $IsHeapAnchor(Heap) : bool;

var $Heap: Heap where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap);

const $OneHeap: Heap;

axiom $IsGoodHeap($OneHeap);

function $HeapSucc(Heap, Heap) : bool;

axiom (forall<alpha> h: Heap, r: ref, f: Field alpha, x: alpha :: 
  { update(h, r, f, x) } 
  $IsGoodHeap(update(h, r, f, x)) ==> $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: Heap, b: Heap, c: Heap :: 
  { $HeapSucc(a, b), $HeapSucc(b, c) } 
  a != c ==> $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: Heap, k: Heap :: 
  { $HeapSucc(h, k) } 
  $HeapSucc(h, k)
     ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

function $HeapSuccGhost(Heap, Heap) : bool;

axiom (forall h: Heap, k: Heap :: 
  { $HeapSuccGhost(h, k) } 
  $HeapSuccGhost(h, k)
     ==> $HeapSucc(h, k)
       && (forall<alpha> o: ref, f: Field alpha :: 
        { read(k, o, f) } 
        !$IsGhostField(f) ==> read(h, o, f) == read(k, o, f)));

type TickType;

var $Tick: TickType;

procedure $YieldHavoc(this: ref, rds: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      $o == this || rds[$Box($o)] || nw[$Box($o)]
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc0(this: ref, rds: Set Box, modi: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      rds[$Box($o)] && !modi[$Box($o)] && $o != this
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc1(this: ref, modi: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)
         || $o == this
         || modi[$Box($o)]
         || nw[$Box($o)]);
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterCollectNewObjects(prevHeap: Heap, newHeap: Heap, this: ref, NW: Field (Set Box))
   returns (s: Set Box);
  ensures (forall bx: Box :: 
    { s[bx] } 
    s[bx]
       <==> read(newHeap, this, NW)[bx]
         || (
          $Unbox(bx) != null
           && !read(prevHeap, $Unbox(bx): ref, alloc)
           && read(newHeap, $Unbox(bx): ref, alloc)));



type Set T = [T]bool;

function Set#Card<T>(Set T) : int;

axiom (forall<T> s: Set T :: { Set#Card(s) } 0 <= Set#Card(s));

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

axiom (forall<T> s: Set T :: 
  { Set#Card(s) } 
  (Set#Card(s) == 0 <==> s == Set#Empty())
     && (Set#Card(s) != 0 ==> (exists x: T :: s[x])));

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: 
  { Set#Singleton(r)[o] } 
  Set#Singleton(r)[o] <==> r == o);

axiom (forall<T> r: T :: 
  { Set#Card(Set#Singleton(r)) } 
  Set#Card(Set#Singleton(r)) == 1);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: 
  { Set#UnionOne(a, x)[o] } 
  Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: 
  { Set#UnionOne(a, x), a[y] } 
  a[y] ==> Set#UnionOne(a, x)[y]);

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a));

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  !a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a) + 1);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Union(a, b)[o] } 
  Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), a[y] } 
  a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), b[y] } 
  b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, b) } 
  Set#Disjoint(a, b)
     ==> Set#Difference(Set#Union(a, b), a) == b
       && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Intersection(a, b)[o] } 
  Set#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(Set#Union(a, b), b) } 
  Set#Union(Set#Union(a, b), b) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, Set#Union(a, b)) } 
  Set#Union(a, Set#Union(a, b)) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(Set#Intersection(a, b), b) } 
  Set#Intersection(Set#Intersection(a, b), b) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(a, Set#Intersection(a, b)) } 
  Set#Intersection(a, Set#Intersection(a, b)) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Union(a, b)) } { Set#Card(Set#Intersection(a, b)) } 
  Set#Card(Set#Union(a, b)) + Set#Card(Set#Intersection(a, b))
     == Set#Card(a) + Set#Card(b));

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Difference(a, b)[o] } 
  Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Difference(a, b), b[y] } 
  b[y] ==> !Set#Difference(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Difference(a, b)) } 
  Set#Card(Set#Difference(a, b))
         + Set#Card(Set#Difference(b, a))
         + Set#Card(Set#Intersection(a, b))
       == Set#Card(Set#Union(a, b))
     && Set#Card(Set#Difference(a, b)) == Set#Card(a) - Set#Card(Set#Intersection(a, b)));

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Subset(a, b) } 
  Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Equal(a, b) } 
  Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Disjoint(a, b) } 
  Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type ISet T = [T]bool;

function ISet#Empty<T>() : Set T;

axiom (forall<T> o: T :: { ISet#Empty()[o] } !ISet#Empty()[o]);

function ISet#UnionOne<T>(ISet T, T) : ISet T;

axiom (forall<T> a: ISet T, x: T, o: T :: 
  { ISet#UnionOne(a, x)[o] } 
  ISet#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: ISet T, x: T :: { ISet#UnionOne(a, x) } ISet#UnionOne(a, x)[x]);

axiom (forall<T> a: ISet T, x: T, y: T :: 
  { ISet#UnionOne(a, x), a[y] } 
  a[y] ==> ISet#UnionOne(a, x)[y]);

function ISet#Union<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Union(a, b)[o] } 
  ISet#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Union(a, b), a[y] } 
  a[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { ISet#Union(a, b), b[y] } 
  b[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(a, b) } 
  ISet#Disjoint(a, b)
     ==> ISet#Difference(ISet#Union(a, b), a) == b
       && ISet#Difference(ISet#Union(a, b), b) == a);

function ISet#Intersection<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Intersection(a, b)[o] } 
  ISet#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(ISet#Union(a, b), b) } 
  ISet#Union(ISet#Union(a, b), b) == ISet#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { ISet#Union(a, ISet#Union(a, b)) } 
  ISet#Union(a, ISet#Union(a, b)) == ISet#Union(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(ISet#Intersection(a, b), b) } 
  ISet#Intersection(ISet#Intersection(a, b), b) == ISet#Intersection(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(a, ISet#Intersection(a, b)) } 
  ISet#Intersection(a, ISet#Intersection(a, b)) == ISet#Intersection(a, b));

function ISet#Difference<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Difference(a, b)[o] } 
  ISet#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Difference(a, b), b[y] } 
  b[y] ==> !ISet#Difference(a, b)[y]);

function ISet#Subset<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Subset(a, b) } 
  ISet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function ISet#Equal<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) ==> a == b);

function ISet#Disjoint<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Disjoint(a, b) } 
  ISet#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

function Math#min(a: int, b: int) : int;

axiom (forall a: int, b: int :: { Math#min(a, b) } a <= b <==> Math#min(a, b) == a);

axiom (forall a: int, b: int :: { Math#min(a, b) } b <= a <==> Math#min(a, b) == b);

axiom (forall a: int, b: int :: 
  { Math#min(a, b) } 
  Math#min(a, b) == a || Math#min(a, b) == b);

function Math#clip(a: int) : int;

axiom (forall a: int :: { Math#clip(a) } 0 <= a ==> Math#clip(a) == a);

axiom (forall a: int :: { Math#clip(a) } a < 0 ==> Math#clip(a) == 0);

type MultiSet T = [T]int;

function $IsGoodMultiSet<T>(ms: MultiSet T) : bool;

axiom (forall<T> ms: MultiSet T :: 
  { $IsGoodMultiSet(ms) } 
  $IsGoodMultiSet(ms)
     <==> (forall bx: T :: { ms[bx] } 0 <= ms[bx] && ms[bx] <= MultiSet#Card(ms)));

function MultiSet#Card<T>(MultiSet T) : int;

axiom (forall<T> s: MultiSet T :: { MultiSet#Card(s) } 0 <= MultiSet#Card(s));

axiom (forall<T> s: MultiSet T, x: T, n: int :: 
  { MultiSet#Card(s[x := n]) } 
  0 <= n ==> MultiSet#Card(s[x := n]) == MultiSet#Card(s) - s[x] + n);

function MultiSet#Empty<T>() : MultiSet T;

axiom (forall<T> o: T :: { MultiSet#Empty()[o] } MultiSet#Empty()[o] == 0);

axiom (forall<T> s: MultiSet T :: 
  { MultiSet#Card(s) } 
  (MultiSet#Card(s) == 0 <==> s == MultiSet#Empty())
     && (MultiSet#Card(s) != 0 ==> (exists x: T :: 0 < s[x])));

function MultiSet#Singleton<T>(T) : MultiSet T;

axiom (forall<T> r: T, o: T :: 
  { MultiSet#Singleton(r)[o] } 
  (MultiSet#Singleton(r)[o] == 1 <==> r == o)
     && (MultiSet#Singleton(r)[o] == 0 <==> r != o));

axiom (forall<T> r: T :: 
  { MultiSet#Singleton(r) } 
  MultiSet#Singleton(r) == MultiSet#UnionOne(MultiSet#Empty(), r));

function MultiSet#UnionOne<T>(MultiSet T, T) : MultiSet T;

axiom (forall<T> a: MultiSet T, x: T, o: T :: 
  { MultiSet#UnionOne(a, x)[o] } 
  0 < MultiSet#UnionOne(a, x)[o] <==> o == x || 0 < a[o]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#UnionOne(a, x) } 
  MultiSet#UnionOne(a, x)[x] == a[x] + 1);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  0 < a[y] ==> 0 < MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  x != y ==> a[y] == MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#Card(MultiSet#UnionOne(a, x)) } 
  MultiSet#Card(MultiSet#UnionOne(a, x)) == MultiSet#Card(a) + 1);

function MultiSet#Union<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Union(a, b)[o] } 
  MultiSet#Union(a, b)[o] == a[o] + b[o]);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Union(a, b)) } 
  MultiSet#Card(MultiSet#Union(a, b)) == MultiSet#Card(a) + MultiSet#Card(b));

function MultiSet#Intersection<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Intersection(a, b)[o] } 
  MultiSet#Intersection(a, b)[o] == Math#min(a[o], b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(MultiSet#Intersection(a, b), b) } 
  MultiSet#Intersection(MultiSet#Intersection(a, b), b)
     == MultiSet#Intersection(a, b));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(a, MultiSet#Intersection(a, b)) } 
  MultiSet#Intersection(a, MultiSet#Intersection(a, b))
     == MultiSet#Intersection(a, b));

function MultiSet#Difference<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Difference(a, b)[o] } 
  MultiSet#Difference(a, b)[o] == Math#clip(a[o] - b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T, y: T :: 
  { MultiSet#Difference(a, b), b[y], a[y] } 
  a[y] <= b[y] ==> MultiSet#Difference(a, b)[y] == 0);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Difference(a, b)) } 
  MultiSet#Card(MultiSet#Difference(a, b))
         + MultiSet#Card(MultiSet#Difference(b, a))
         + 2 * MultiSet#Card(MultiSet#Intersection(a, b))
       == MultiSet#Card(MultiSet#Union(a, b))
     && MultiSet#Card(MultiSet#Difference(a, b))
       == MultiSet#Card(a) - MultiSet#Card(MultiSet#Intersection(a, b)));

function MultiSet#Subset<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Subset(a, b) } 
  MultiSet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <= b[o]));

function MultiSet#Equal<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] == b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) ==> a == b);

function MultiSet#Disjoint<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Disjoint(a, b) } 
  MultiSet#Disjoint(a, b)
     <==> (forall o: T :: { a[o] } { b[o] } a[o] == 0 || b[o] == 0));

function MultiSet#FromSet<T>(Set T) : MultiSet T;

axiom (forall<T> s: Set T, a: T :: 
  { MultiSet#FromSet(s)[a] } 
  (MultiSet#FromSet(s)[a] == 0 <==> !s[a])
     && (MultiSet#FromSet(s)[a] == 1 <==> s[a]));

axiom (forall<T> s: Set T :: 
  { MultiSet#Card(MultiSet#FromSet(s)) } 
  MultiSet#Card(MultiSet#FromSet(s)) == Set#Card(s));

function MultiSet#FromSeq<T>(Seq T) : MultiSet T;

axiom (forall<T> s: Seq T :: 
  { MultiSet#FromSeq(s) } 
  $IsGoodMultiSet(MultiSet#FromSeq(s)));

axiom (forall<T> s: Seq T :: 
  { MultiSet#Card(MultiSet#FromSeq(s)) } 
  MultiSet#Card(MultiSet#FromSeq(s)) == Seq#Length(s));

axiom (forall<T> s: Seq T, v: T :: 
  { MultiSet#FromSeq(Seq#Build(s, v)) } 
  MultiSet#FromSeq(Seq#Build(s, v)) == MultiSet#UnionOne(MultiSet#FromSeq(s), v));

axiom (forall<T>  :: 
  MultiSet#FromSeq(Seq#Empty(): Seq T) == MultiSet#Empty(): MultiSet T);

axiom (forall<T> a: Seq T, b: Seq T :: 
  { MultiSet#FromSeq(Seq#Append(a, b)) } 
  MultiSet#FromSeq(Seq#Append(a, b))
     == MultiSet#Union(MultiSet#FromSeq(a), MultiSet#FromSeq(b)));

axiom (forall<T> s: Seq T, i: int, v: T, x: T :: 
  { MultiSet#FromSeq(Seq#Update(s, i, v))[x] } 
  0 <= i && i < Seq#Length(s)
     ==> MultiSet#FromSeq(Seq#Update(s, i, v))[x]
       == MultiSet#Union(MultiSet#Difference(MultiSet#FromSeq(s), MultiSet#Singleton(Seq#Index(s, i))), 
        MultiSet#Singleton(v))[x]);

axiom (forall<T> s: Seq T, x: T :: 
  { MultiSet#FromSeq(s)[x] } 
  (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && x == Seq#Index(s, i))
     <==> 0 < MultiSet#FromSeq(s)[x]);

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: { Seq#Empty(): Seq T } Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: 
  { Seq#Length(s) } 
  Seq#Length(s) == 0 ==> s == Seq#Empty());

axiom (forall<T> t: Ty :: { $Is(Seq#Empty(): Seq T, t) } $Is(Seq#Empty(): Seq T, t));

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: 
  { Seq#Length(Seq#Singleton(t)) } 
  Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, val: T) : Seq T;

function Seq#Build_inv0<T>(s: Seq T) : Seq T;

function Seq#Build_inv1<T>(s: Seq T) : T;

axiom (forall<T> s: Seq T, val: T :: 
  { Seq#Build(s, val) } 
  Seq#Build_inv0(Seq#Build(s, val)) == s
     && Seq#Build_inv1(Seq#Build(s, val)) == val);

axiom (forall<T> s: Seq T, v: T :: 
  { Seq#Build(s, v) } 
  Seq#Length(Seq#Build(s, v)) == 1 + Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Index(Seq#Build(s, v), i) } 
  (i == Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == v)
     && (i != Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == Seq#Index(s, i)));

axiom (forall s: Seq Box, bx: Box, t: Ty :: 
  { $Is(Seq#Build(s, bx), TSeq(t)) } 
  $Is(s, TSeq(t)) && $IsBox(bx, t) ==> $Is(Seq#Build(s, bx), TSeq(t)));

function Seq#Create(ty: Ty, heap: Heap, len: int, init: HandleType) : Seq Box;

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType :: 
  { Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) } 
  $IsGoodHeap(heap) && 0 <= len
     ==> Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) == len);

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType, i: int :: 
  { Seq#Index(Seq#Create(ty, heap, len, init), i) } 
  $IsGoodHeap(heap) && 0 <= i && i < len
     ==> Seq#Index(Seq#Create(ty, heap, len, init), i)
       == Apply1(TInt, TSeq(ty), heap, init, $Box(i)));

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Length(Seq#Append(s0, s1)) } 
  Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

axiom (forall s0: Seq Box, s1: Seq Box, t: Ty :: 
  { $Is(Seq#Append(s0, s1), t) } 
  $Is(s0, t) && $Is(s1, t) ==> $Is(Seq#Append(s0, s1), t));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: 
  { Seq#Index(Seq#Singleton(t), 0) } 
  Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#Index(Seq#Append(s0, s1), n) } 
  (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n))
     && (Seq#Length(s0) <= n
       ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Length(Seq#Update(s, i, v)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Index(Seq#Update(s, i, v), n) } 
  0 <= n && n < Seq#Length(s)
     ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v)
       && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: 
  { Seq#Contains(s, x) } 
  Seq#Contains(s, x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> x: T :: 
  { Seq#Contains(Seq#Empty(), x) } 
  !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: 
  { Seq#Contains(Seq#Append(s0, s1), x) } 
  Seq#Contains(Seq#Append(s0, s1), x)
     <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, v: T, x: T :: 
  { Seq#Contains(Seq#Build(s, v), x) } 
  Seq#Contains(Seq#Build(s, v), x) <==> v == x || Seq#Contains(s, x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Take(s, n), x) } 
  Seq#Contains(Seq#Take(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Drop(s, n), x) } 
  Seq#Contains(Seq#Drop(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Equal(s0, s1) } 
  Seq#Equal(s0, s1)
     <==> Seq#Length(s0) == Seq#Length(s1)
       && (forall j: int :: 
        { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
        0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#SameUntil(s0, s1, n) } 
  Seq#SameUntil(s0, s1, n)
     <==> (forall j: int :: 
      { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
      0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Take(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Take(s, n), j) } { Seq#Index(s, j), Seq#Take(s, n) } 
  0 <= j && j < n && j < Seq#Length(s)
     ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Drop(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 
  0 <= n && 0 <= j && j < Seq#Length(s) - n
     ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, n: int, k: int :: 
  {:weight 25} { Seq#Index(s, k), Seq#Drop(s, n) } 
  0 <= n && n <= k && k < Seq#Length(s)
     ==> Seq#Index(Seq#Drop(s, n), k - n) == Seq#Index(s, k));

axiom (forall<T> s: Seq T, t: Seq T, n: int :: 
  { Seq#Take(Seq#Append(s, t), n) } { Seq#Drop(Seq#Append(s, t), n) } 
  n == Seq#Length(s)
     ==> Seq#Take(Seq#Append(s, t), n) == s && Seq#Drop(Seq#Append(s, t), n) == t);

function Seq#FromArray(h: Heap, a: ref) : Seq Box;

axiom (forall h: Heap, a: ref :: 
  { Seq#Length(Seq#FromArray(h, a)) } 
  Seq#Length(Seq#FromArray(h, a)) == _System.array.Length(a));

axiom (forall h: Heap, a: ref :: 
  { Seq#FromArray(h, a) } 
  (forall i: int :: 
    { read(h, a, IndexField(i)) } { Seq#Index(Seq#FromArray(h, a): Seq Box, i) } 
    0 <= i && i < Seq#Length(Seq#FromArray(h, a))
       ==> Seq#Index(Seq#FromArray(h, a), i) == read(h, a, IndexField(i))));

axiom (forall h0: Heap, h1: Heap, a: ref :: 
  { Seq#FromArray(h1, a), $HeapSucc(h0, h1) } 
  $IsGoodHeap(h0) && $IsGoodHeap(h1) && $HeapSucc(h0, h1) && h0[a] == h1[a]
     ==> Seq#FromArray(h0, a) == Seq#FromArray(h1, a));

axiom (forall h: Heap, i: int, v: Box, a: ref :: 
  { Seq#FromArray(update(h, a, IndexField(i), v), a) } 
  0 <= i && i < _System.array.Length(a)
     ==> Seq#FromArray(update(h, a, IndexField(i), v), a)
       == Seq#Update(Seq#FromArray(h, a), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n <= Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Update(Seq#Take(s, n), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  n <= i && i < Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Take(s, n));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= n && n <= i && i < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Update(Seq#Drop(s, n), i - n, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Drop(s, n));

axiom (forall h: Heap, a: ref, n0: int, n1: int :: 
  { Seq#Take(Seq#FromArray(h, a), n0), Seq#Take(Seq#FromArray(h, a), n1) } 
  n0 + 1 == n1 && 0 <= n0 && n1 <= _System.array.Length(a)
     ==> Seq#Take(Seq#FromArray(h, a), n1)
       == Seq#Build(Seq#Take(Seq#FromArray(h, a), n0), read(h, a, IndexField(n0): Field Box)));

axiom (forall<T> s: Seq T, v: T, n: int :: 
  { Seq#Drop(Seq#Build(s, v), n) } 
  0 <= n && n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Build(s, v), n) == Seq#Build(Seq#Drop(s, n), v));

function Seq#Rank<T>(Seq T) : int;

axiom (forall s: Seq Box, i: int :: 
  { DtRank($Unbox(Seq#Index(s, i)): DatatypeType) } 
  0 <= i && i < Seq#Length(s)
     ==> DtRank($Unbox(Seq#Index(s, i)): DatatypeType) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Drop(s, i)) } 
  0 < i && i <= Seq#Length(s) ==> Seq#Rank(Seq#Drop(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Take(s, i)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Rank(Seq#Take(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int, j: int :: 
  { Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) } 
  0 <= i && i < j && j <= Seq#Length(s)
     ==> Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) < Seq#Rank(s));

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Drop(s, n) } 
  n == 0 ==> Seq#Drop(s, n) == s);

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Take(s, n) } 
  n == 0 ==> Seq#Take(s, n) == Seq#Empty());

axiom (forall<T> s: Seq T, m: int, n: int :: 
  { Seq#Drop(Seq#Drop(s, m), n) } 
  0 <= m && 0 <= n && m + n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Drop(s, m), n) == Seq#Drop(s, m + n));

type Map _ _;

function Map#Domain<U,V>(Map U V) : Set U;

function Map#Elements<U,V>(Map U V) : [U]V;

function Map#Card<U,V>(Map U V) : int;

axiom (forall<U,V> m: Map U V :: { Map#Card(m) } 0 <= Map#Card(m));

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Domain(m)) } 
  Set#Card(Map#Domain(m)) == Map#Card(m));

function Map#Values<U,V>(Map U V) : Set V;

axiom (forall<U,V> m: Map U V, v: V :: 
  { Map#Values(m)[v] } 
  Map#Values(m)[v]
     == (exists u: U :: 
      { Map#Domain(m)[u] } { Map#Elements(m)[u] } 
      Map#Domain(m)[u] && v == Map#Elements(m)[u]));

function Map#Items<U,V>(Map U V) : Set Box;

function _System.Tuple2._0(DatatypeType) : Box;

function _System.Tuple2._1(DatatypeType) : Box;

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Items(m)) } 
  Set#Card(Map#Items(m)) == Map#Card(m));

axiom (forall m: Map Box Box, item: Box :: 
  { Map#Items(m)[item] } 
  Map#Items(m)[item]
     <==> Map#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && Map#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function Map#Empty<U,V>() : Map U V;

axiom (forall<U,V> u: U :: 
  { Map#Domain(Map#Empty(): Map U V)[u] } 
  !Map#Domain(Map#Empty(): Map U V)[u]);

axiom (forall<U,V> m: Map U V :: 
  { Map#Card(m) } 
  (Map#Card(m) == 0 <==> m == Map#Empty())
     && (Map#Card(m) != 0 ==> (exists x: U :: Map#Domain(m)[x])));

function Map#Glue<U,V>([U]bool, [U]V, Ty) : Map U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Domain(Map#Glue(a, b, t)) } 
  Map#Domain(Map#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Elements(Map#Glue(a, b, t)) } 
  Map#Elements(Map#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(Map#Glue(a, b, t), t) } 
  $Is(Map#Glue(a, b, t), t));

function Map#Build<U,V>(Map U V, U, V) : Map U V;

axiom (forall<U,V> m: Map U V, u: U, u': U, v: V :: 
  { Map#Domain(Map#Build(m, u, v))[u'] } { Map#Elements(Map#Build(m, u, v))[u'] } 
  (u' == u
       ==> Map#Domain(Map#Build(m, u, v))[u'] && Map#Elements(Map#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> Map#Domain(Map#Build(m, u, v))[u'] == Map#Domain(m)[u']
         && Map#Elements(Map#Build(m, u, v))[u'] == Map#Elements(m)[u']));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  !Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m) + 1);

function Map#Equal<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m')
     <==> (forall u: U :: Map#Domain(m)[u] == Map#Domain(m')[u])
       && (forall u: U :: Map#Domain(m)[u] ==> Map#Elements(m)[u] == Map#Elements(m')[u]));

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m') ==> m == m');

function Map#Disjoint<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Disjoint(m, m') } 
  Map#Disjoint(m, m')
     <==> (forall o: U :: 
      { Map#Domain(m)[o] } { Map#Domain(m')[o] } 
      !Map#Domain(m)[o] || !Map#Domain(m')[o]));

type IMap _ _;

function IMap#Domain<U,V>(IMap U V) : Set U;

function IMap#Elements<U,V>(IMap U V) : [U]V;

function IMap#Values<U,V>(IMap U V) : Set V;

axiom (forall<U,V> m: IMap U V, v: V :: 
  { IMap#Values(m)[v] } 
  IMap#Values(m)[v]
     == (exists u: U :: 
      { IMap#Domain(m)[u] } { IMap#Elements(m)[u] } 
      IMap#Domain(m)[u] && v == IMap#Elements(m)[u]));

function IMap#Items<U,V>(IMap U V) : Set Box;

axiom (forall m: IMap Box Box, item: Box :: 
  { IMap#Items(m)[item] } 
  IMap#Items(m)[item]
     <==> IMap#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && IMap#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function IMap#Empty<U,V>() : IMap U V;

axiom (forall<U,V> u: U :: 
  { IMap#Domain(IMap#Empty(): IMap U V)[u] } 
  !IMap#Domain(IMap#Empty(): IMap U V)[u]);

function IMap#Glue<U,V>([U]bool, [U]V, Ty) : IMap U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Domain(IMap#Glue(a, b, t)) } 
  IMap#Domain(IMap#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Elements(IMap#Glue(a, b, t)) } 
  IMap#Elements(IMap#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(IMap#Glue(a, b, t), t) } 
  $Is(IMap#Glue(a, b, t), t));

function IMap#Build<U,V>(IMap U V, U, V) : IMap U V;

axiom (forall<U,V> m: IMap U V, u: U, u': U, v: V :: 
  { IMap#Domain(IMap#Build(m, u, v))[u'] } 
    { IMap#Elements(IMap#Build(m, u, v))[u'] } 
  (u' == u
       ==> IMap#Domain(IMap#Build(m, u, v))[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> IMap#Domain(IMap#Build(m, u, v))[u'] == IMap#Domain(m)[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == IMap#Elements(m)[u']));

function IMap#Equal<U,V>(IMap U V, IMap U V) : bool;

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m')
     <==> (forall u: U :: IMap#Domain(m)[u] == IMap#Domain(m')[u])
       && (forall u: U :: 
        IMap#Domain(m)[u] ==> IMap#Elements(m)[u] == IMap#Elements(m')[u]));

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m') ==> m == m');

function INTERNAL_add_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_add_boogie(x, y): int } 
  INTERNAL_add_boogie(x, y): int == x + y);

function INTERNAL_sub_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_sub_boogie(x, y): int } 
  INTERNAL_sub_boogie(x, y): int == x - y);

function INTERNAL_mul_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mul_boogie(x, y): int } 
  INTERNAL_mul_boogie(x, y): int == x * y);

function INTERNAL_div_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_div_boogie(x, y): int } 
  INTERNAL_div_boogie(x, y): int == x div y);

function INTERNAL_mod_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mod_boogie(x, y): int } 
  INTERNAL_mod_boogie(x, y): int == x mod y);

function {:never_pattern true} INTERNAL_lt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_lt_boogie(x, y): bool } 
  INTERNAL_lt_boogie(x, y): bool == (x < y));

function {:never_pattern true} INTERNAL_le_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_le_boogie(x, y): bool } 
  INTERNAL_le_boogie(x, y): bool == (x <= y));

function {:never_pattern true} INTERNAL_gt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_gt_boogie(x, y): bool } 
  INTERNAL_gt_boogie(x, y): bool == (x > y));

function {:never_pattern true} INTERNAL_ge_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_ge_boogie(x, y): bool } 
  INTERNAL_ge_boogie(x, y): bool == (x >= y));

function Mul(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mul(x, y): int } Mul(x, y): int == x * y);

function Div(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Div(x, y): int } Div(x, y): int == x div y);

function Mod(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mod(x, y): int } Mod(x, y): int == x mod y);

function Add(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Add(x, y): int } Add(x, y): int == x + y);

function Sub(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Sub(x, y): int } Sub(x, y): int == x - y);

function _System.__default.rank__is__less__than(A: Ty, B: Ty, a: Box, b: Box) : bool;

axiom (forall A: Ty, B: Ty, a: Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, a, b) ==> BoxRank(a) < BoxRank(b));

axiom (forall A: Ty, B: Ty, a: Box, b: Seq Box :: 
  { _System.__default.rank__is__less__than(A, B, a, $Box(b)), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, $Box(b)), Seq#Rank(b) } 
  _System.__default.rank__is__less__than(A, B, a, $Box(b))
     ==> BoxRank(a) < Seq#Rank(b));

axiom (forall A: Ty, B: Ty, a: Seq Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, $Box(a), b), Seq#Rank(a) } 
    { _System.__default.rank__is__less__than(A, B, $Box(a), b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, $Box(a), b)
     ==> Seq#Rank(a) < BoxRank(b));

function Tclass._System.nat() : Ty;

// Tclass._System.nat Tag
axiom Tag(Tclass._System.nat()) == Tagclass._System.nat;

const unique Tagclass._System.nat: TyTag;

// Box/unbox axiom for Tclass._System.nat
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.nat()) } 
  $IsBox(bx, Tclass._System.nat())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass._System.nat()));

// _System.nat: subset type $Is
axiom (forall x#0: int :: 
  { $Is(x#0, Tclass._System.nat()) } 
  $Is(x#0, Tclass._System.nat()) <==> LitInt(0) <= x#0);

// _System.nat: subset type $IsAlloc
axiom (forall x#0: int, $h: Heap :: 
  { $IsAlloc(x#0, Tclass._System.nat(), $h) } 
  $IsAlloc(x#0, Tclass._System.nat(), $h));

const unique class._System.object?: ClassName;

// Tclass._System.object? Tag
axiom Tag(Tclass._System.object?()) == Tagclass._System.object?;

const unique Tagclass._System.object?: TyTag;

// Box/unbox axiom for Tclass._System.object?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object?()) } 
  $IsBox(bx, Tclass._System.object?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object?()));

// object: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.object?()) } 
  $Is($o, Tclass._System.object?()));

// object: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.object?(), $h) } 
  $IsAlloc($o, Tclass._System.object?(), $h)
     <==> $o == null || read($h, $o, alloc));

function implements$_System.object(Ty) : bool;

function Tclass._System.object() : Ty;

// Tclass._System.object Tag
axiom Tag(Tclass._System.object()) == Tagclass._System.object;

const unique Tagclass._System.object: TyTag;

// Box/unbox axiom for Tclass._System.object
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object()) } 
  $IsBox(bx, Tclass._System.object())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object()));

// _System.object: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass._System.object()) } 
  $Is(c#0, Tclass._System.object())
     <==> $Is(c#0, Tclass._System.object?()) && c#0 != null);

// _System.object: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.object(), $h) } 
  $IsAlloc(c#0, Tclass._System.object(), $h)
     <==> $IsAlloc(c#0, Tclass._System.object?(), $h));

const unique class._System.array?: ClassName;

function Tclass._System.array?(Ty) : Ty;

// Tclass._System.array? Tag
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tag(Tclass._System.array?(#$arg)) == Tagclass._System.array?);

const unique Tagclass._System.array?: TyTag;

// Tclass._System.array? injectivity 0
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tclass._System.array?_0(Tclass._System.array?(#$arg)) == #$arg);

function Tclass._System.array?_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array?
axiom (forall #$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array?(#$arg)) } 
  $IsBox(bx, Tclass._System.array?(#$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array?(#$arg)));

// array.: Type axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
     ==> $IsBox(read($h, $o, IndexField($i0)), #$arg));

// array.: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
       && read($h, $o, alloc)
     ==> $IsAllocBox(read($h, $o, IndexField($i0)), #$arg, $h));

// array: Class $Is
axiom (forall #$arg: Ty, $o: ref :: 
  { $Is($o, Tclass._System.array?(#$arg)) } 
  $Is($o, Tclass._System.array?(#$arg))
     <==> $o == null || dtype($o) == Tclass._System.array?(#$arg));

// array: Class $IsAlloc
axiom (forall #$arg: Ty, $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.array?(#$arg), $h) } 
  $IsAlloc($o, Tclass._System.array?(#$arg), $h)
     <==> $o == null || read($h, $o, alloc));

// array.Length: Type axiom
axiom (forall #$arg: Ty, $o: ref :: 
  { _System.array.Length($o), Tclass._System.array?(#$arg) } 
  $o != null && dtype($o) == Tclass._System.array?(#$arg)
     ==> $Is(_System.array.Length($o), TInt));

// array.Length: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref :: 
  { _System.array.Length($o), read($h, $o, alloc), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && read($h, $o, alloc)
     ==> $IsAlloc(_System.array.Length($o), TInt, $h));

function Tclass._System.array(Ty) : Ty;

// Tclass._System.array Tag
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tag(Tclass._System.array(_System.array$arg)) == Tagclass._System.array);

const unique Tagclass._System.array: TyTag;

// Tclass._System.array injectivity 0
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tclass._System.array_0(Tclass._System.array(_System.array$arg))
     == _System.array$arg);

function Tclass._System.array_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array
axiom (forall _System.array$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array(_System.array$arg)) } 
  $IsBox(bx, Tclass._System.array(_System.array$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array(_System.array$arg)));

// _System.array: subset type $Is
axiom (forall _System.array$arg: Ty, c#0: ref :: 
  { $Is(c#0, Tclass._System.array(_System.array$arg)) } 
  $Is(c#0, Tclass._System.array(_System.array$arg))
     <==> $Is(c#0, Tclass._System.array?(_System.array$arg)) && c#0 != null);

// _System.array: subset type $IsAlloc
axiom (forall _System.array$arg: Ty, c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h) } 
  $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h)
     <==> $IsAlloc(c#0, Tclass._System.array?(_System.array$arg), $h));

function Tclass._System.___hFunc0(Ty) : Ty;

// Tclass._System.___hFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tag(Tclass._System.___hFunc0(#$R)) == Tagclass._System.___hFunc0);

const unique Tagclass._System.___hFunc0: TyTag;

// Tclass._System.___hFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tclass._System.___hFunc0_0(Tclass._System.___hFunc0(#$R)) == #$R);

function Tclass._System.___hFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc0(#$R)));

function Handle0([Heap]Box, [Heap]bool, [Heap]Set Box) : HandleType;

function Apply0(Ty, Heap, HandleType) : Box;

function Requires0(Ty, Heap, HandleType) : bool;

function Reads0(Ty, Heap, HandleType) : Set Box;

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Apply0(t0, heap, Handle0(h, r, rd)) } 
  Apply0(t0, heap, Handle0(h, r, rd)) == h[heap]);

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Requires0(t0, heap, Handle0(h, r, rd)) } 
  r[heap] ==> Requires0(t0, heap, Handle0(h, r, rd)));

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box, bx: Box :: 
  { Reads0(t0, heap, Handle0(h, r, rd))[bx] } 
  Reads0(t0, heap, Handle0(h, r, rd))[bx] == rd[heap][bx]);

function {:inline} Requires0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

function {:inline} Reads0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// empty-reads property for Reads0 
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Reads0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Reads0(t0, heap, f) } 
  $IsGoodHeap(heap) && $Is(f, Tclass._System.___hFunc0(t0))
     ==> (Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
       <==> Set#Equal(Reads0(t0, heap, f), Set#Empty(): Set Box)));

// empty-reads property for Requires0
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Requires0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Requires0(t0, heap, f) } 
  $IsGoodHeap(heap)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
     ==> Requires0(t0, $OneHeap, f) == Requires0(t0, heap, f));

axiom (forall f: HandleType, t0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
     <==> (forall h: Heap :: 
      { Apply0(t0, h, f) } 
      $IsGoodHeap(h) && Requires0(t0, h, f) ==> $IsBox(Apply0(t0, h, f), t0)));

axiom (forall f: HandleType, t0: Ty, u0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)), $Is(f, Tclass._System.___hFunc0(u0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t0) } { $IsBox(bx, u0) } 
        $IsBox(bx, t0) ==> $IsBox(bx, u0))
     ==> $Is(f, Tclass._System.___hFunc0(u0)));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc0(t0), h)
       <==> Requires0(t0, h, f)
         ==> (forall r: ref :: 
          { Reads0(t0, h, f)[$Box(r)] } 
          r != null && Reads0(t0, h, f)[$Box(r)] ==> read(h, r, alloc))));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc0(t0), h)
     ==> 
    Requires0(t0, h, f)
     ==> $IsAllocBox(Apply0(t0, h, f), t0, h));

function Tclass._System.___hPartialFunc0(Ty) : Ty;

// Tclass._System.___hPartialFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tag(Tclass._System.___hPartialFunc0(#$R)) == Tagclass._System.___hPartialFunc0);

const unique Tagclass._System.___hPartialFunc0: TyTag;

// Tclass._System.___hPartialFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tclass._System.___hPartialFunc0_0(Tclass._System.___hPartialFunc0(#$R)) == #$R);

function Tclass._System.___hPartialFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc0(#$R)));

// _System._#PartialFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hFunc0(#$R))
       && Set#Equal(Reads0(#$R, $OneHeap, f#0), Set#Empty(): Set Box));

// _System._#PartialFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc0(#$R), $h));

function Tclass._System.___hTotalFunc0(Ty) : Ty;

// Tclass._System.___hTotalFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tag(Tclass._System.___hTotalFunc0(#$R)) == Tagclass._System.___hTotalFunc0);

const unique Tagclass._System.___hTotalFunc0: TyTag;

// Tclass._System.___hTotalFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tclass._System.___hTotalFunc0_0(Tclass._System.___hTotalFunc0(#$R)) == #$R);

function Tclass._System.___hTotalFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc0(#$R)));

// _System._#TotalFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) && Requires0(#$R, $OneHeap, f#0));

// _System._#TotalFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h));

const unique class._System.__default: ClassName;

function Tclass._System.__default() : Ty;

// Tclass._System.__default Tag
axiom Tag(Tclass._System.__default()) == Tagclass._System.__default;

const unique Tagclass._System.__default: TyTag;

// Box/unbox axiom for Tclass._System.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.__default()) } 
  $IsBox(bx, Tclass._System.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.__default()) } 
  $Is($o, Tclass._System.__default())
     <==> $o == null || dtype($o) == Tclass._System.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.__default(), $h) } 
  $IsAlloc($o, Tclass._System.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function _System.__default.rank__is__less__than#canCall(#$A: Ty, #$B: Ty, a#0: Box, b#0: Box) : bool;

// consequence axiom for _System.__default.rank__is__less__than
axiom true
   ==> (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
    { _System.__default.rank__is__less__than(#$A, #$B, a#0, b#0) } 
    _System.__default.rank__is__less__than#canCall(#$A, #$B, a#0, b#0)
         || ($IsBox(a#0, #$A) && $IsBox(b#0, #$B))
       ==> true);

function _System.__default.rank__is__less__than#requires(Ty, Ty, Box, Box) : bool;

// #requires axiom for _System.__default.rank__is__less__than
axiom (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
  { _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) } 
  $IsBox(a#0, #$A) && $IsBox(b#0, #$B)
     ==> _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) == true);

function Tclass._System.___hFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hFunc2);

const unique Tagclass._System.___hFunc2: TyTag;

// Tclass._System.___hFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_0(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hFunc2_0(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_1(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hFunc2_1(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_2(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$R);

function Tclass._System.___hFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc2(#$T0, #$T1, #$R)));

function Handle2([Heap,Box,Box]Box, [Heap,Box,Box]bool, [Heap,Box,Box]Set Box) : HandleType;

function Apply2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Box;

function Requires2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : bool;

function Reads2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) == h[heap, bx0, bx1]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  r[heap, bx0, bx1] ==> Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx: Box :: 
  { Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx] } 
  Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx]
     == rd[heap, bx0, bx1][bx]);

function {:inline} Requires2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

function {:inline} Reads2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// empty-reads property for Reads2 
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Reads2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     ==> (Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
       <==> Set#Equal(Reads2(t0, t1, t2, heap, f, bx0, bx1), Set#Empty(): Set Box)));

// empty-reads property for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Requires2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
     ==> Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1)
       == Requires2(t0, t1, t2, heap, f, bx0, bx1));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     <==> (forall h: Heap, bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, u0: Ty, u1: Ty, u2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)), $Is(f, Tclass._System.___hFunc2(u0, u1, u2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, t2) } { $IsBox(bx, u2) } 
        $IsBox(bx, t2) ==> $IsBox(bx, u2))
     ==> $Is(f, Tclass._System.___hFunc2(u0, u1, u2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
       <==> (forall bx0: Box, bx1: Box :: 
        { Apply2(t0, t1, t2, h, f, bx0, bx1) } { Reads2(t0, t1, t2, h, f, bx0, bx1) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && Requires2(t0, t1, t2, h, f, bx0, bx1)
           ==> (forall r: ref :: 
            { Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] } 
            r != null && Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
     ==> (forall bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsAllocBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2, h)));

function Tclass._System.___hPartialFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hPartialFunc2);

const unique Tagclass._System.___hPartialFunc2: TyTag;

// Tclass._System.___hPartialFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_0(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc2_0(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_1(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc2_1(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_2(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hPartialFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)));

// _System._#PartialFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Set#Equal(Reads2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0), Set#Empty(): Set Box)));

// _System._#PartialFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hTotalFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hTotalFunc2);

const unique Tagclass._System.___hTotalFunc2: TyTag;

// Tclass._System.___hTotalFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_0(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc2_0(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_1(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc2_1(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_2(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hTotalFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)));

// _System._#TotalFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Requires2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0)));

// _System._#TotalFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h));

// Constructor function declaration
function #_System._tuple#2._#Make2(Box, Box) : DatatypeType;

const unique ##_System._tuple#2._#Make2: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#_System._tuple#2._#Make2(a#0#0#0, a#0#1#0))
     == ##_System._tuple#2._#Make2);

function _System.Tuple2.___hMake2_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#2._#Make2);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     ==> (exists a#1#0#0: Box, a#1#1#0: Box :: 
      d == #_System._tuple#2._#Make2(a#1#0#0, a#1#1#0)));

function Tclass._System.Tuple2(Ty, Ty) : Ty;

// Tclass._System.Tuple2 Tag
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tag(Tclass._System.Tuple2(#$T0, #$T1)) == Tagclass._System.Tuple2);

const unique Tagclass._System.Tuple2: TyTag;

// Tclass._System.Tuple2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_0(Tclass._System.Tuple2(#$T0, #$T1)) == #$T0);

function Tclass._System.Tuple2_0(Ty) : Ty;

// Tclass._System.Tuple2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_1(Tclass._System.Tuple2(#$T0, #$T1)) == #$T1);

function Tclass._System.Tuple2_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.Tuple2
axiom (forall #$T0: Ty, #$T1: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple2(#$T0, #$T1)));

// Constructor $Is
axiom (forall #$T0: Ty, #$T1: Ty, a#2#0#0: Box, a#2#1#0: Box :: 
  { $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1))
     <==> $IsBox(a#2#0#0, #$T0) && $IsBox(a#2#1#0, #$T1));

// Constructor $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, a#3#0#0: Box, a#3#1#0: Box, $h: Heap :: 
  { $IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
      Tclass._System.Tuple2(#$T0, #$T1), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
        Tclass._System.Tuple2(#$T0, #$T1), 
        $h)
       <==> $IsAllocBox(a#3#0#0, #$T0, $h) && $IsAllocBox(a#3#1#0, #$T1, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T0: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._0(d), #$T0, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T1: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._0(d), #$T0, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T1: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._1(d), #$T1, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T0: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._1(d), #$T1, $h));

// Constructor literal
axiom (forall a#4#0#0: Box, a#4#1#0: Box :: 
  { #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#_System._tuple#2._#Make2(a#4#0#0, a#4#1#0)));

// Constructor injectivity
axiom (forall a#5#0#0: Box, a#5#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#5#0#0, a#5#1#0) } 
  _System.Tuple2._0(#_System._tuple#2._#Make2(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: Box, a#6#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#6#0#0, a#6#1#0) } 
  BoxRank(a#6#0#0) < DtRank(#_System._tuple#2._#Make2(a#6#0#0, a#6#1#0)));

// Constructor injectivity
axiom (forall a#7#0#0: Box, a#7#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#7#0#0, a#7#1#0) } 
  _System.Tuple2._1(#_System._tuple#2._#Make2(a#7#0#0, a#7#1#0)) == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: Box, a#8#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#8#0#0, a#8#1#0) } 
  BoxRank(a#8#1#0) < DtRank(#_System._tuple#2._#Make2(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#_System.Tuple2(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple2(d) } 
  $IsA#_System.Tuple2(d) ==> _System.Tuple2.___hMake2_q(d));

// Questionmark data type disjunctivity
axiom (forall #$T0: Ty, #$T1: Ty, d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d), $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) ==> _System.Tuple2.___hMake2_q(d));

// Datatype extensional equality declaration
function _System.Tuple2#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#2._#Make2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  true
     ==> (_System.Tuple2#Equal(a, b)
       <==> _System.Tuple2._0(a) == _System.Tuple2._0(b)
         && _System.Tuple2._1(a) == _System.Tuple2._1(b)));

// Datatype extensionality axiom: _System._tuple#2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  _System.Tuple2#Equal(a, b) <==> a == b);

const unique class._System.Tuple2: ClassName;

function Tclass._System.___hFunc1(Ty, Ty) : Ty;

// Tclass._System.___hFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hFunc1(#$T0, #$R)) == Tagclass._System.___hFunc1);

const unique Tagclass._System.___hFunc1: TyTag;

// Tclass._System.___hFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_0(Tclass._System.___hFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hFunc1_0(Ty) : Ty;

// Tclass._System.___hFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_1(Tclass._System.___hFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc1(#$T0, #$R)));

function Handle1([Heap,Box]Box, [Heap,Box]bool, [Heap,Box]Set Box) : HandleType;

function Requires1(Ty, Ty, Heap, HandleType, Box) : bool;

function Reads1(Ty, Ty, Heap, HandleType, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) == h[heap, bx0]);

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Requires1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  r[heap, bx0] ==> Requires1(t0, t1, heap, Handle1(h, r, rd), bx0));

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box, 
    bx: Box :: 
  { Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] } 
  Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] == rd[heap, bx0][bx]);

function {:inline} Requires1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

function {:inline} Reads1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// empty-reads property for Reads1 
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Reads1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Reads1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1))
     ==> (Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
       <==> Set#Equal(Reads1(t0, t1, heap, f, bx0), Set#Empty(): Set Box)));

// empty-reads property for Requires1
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Requires1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Requires1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
     ==> Requires1(t0, t1, $OneHeap, f, bx0) == Requires1(t0, t1, heap, f, bx0));

axiom (forall f: HandleType, t0: Ty, t1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
     <==> (forall h: Heap, bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsGoodHeap(h) && $IsBox(bx0, t0) && Requires1(t0, t1, h, f, bx0)
         ==> $IsBox(Apply1(t0, t1, h, f, bx0), t1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, u0: Ty, u1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)), $Is(f, Tclass._System.___hFunc1(u0, u1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t1) } { $IsBox(bx, u1) } 
        $IsBox(bx, t1) ==> $IsBox(bx, u1))
     ==> $Is(f, Tclass._System.___hFunc1(u0, u1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
       <==> (forall bx0: Box :: 
        { Apply1(t0, t1, h, f, bx0) } { Reads1(t0, t1, h, f, bx0) } 
        $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
           ==> (forall r: ref :: 
            { Reads1(t0, t1, h, f, bx0)[$Box(r)] } 
            r != null && Reads1(t0, t1, h, f, bx0)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
     ==> (forall bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
         ==> $IsAllocBox(Apply1(t0, t1, h, f, bx0), t1, h)));

function Tclass._System.___hPartialFunc1(Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == Tagclass._System.___hPartialFunc1);

const unique Tagclass._System.___hPartialFunc1: TyTag;

// Tclass._System.___hPartialFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_0(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc1_0(Ty) : Ty;

// Tclass._System.___hPartialFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_1(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$R);

function Tclass._System.___hPartialFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc1(#$T0, #$R)));

// _System._#PartialFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0)
           ==> Set#Equal(Reads1(#$T0, #$R, $OneHeap, f#0, x0#0), Set#Empty(): Set Box)));

// _System._#PartialFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc1(#$T0, #$R), $h));

function Tclass._System.___hTotalFunc1(Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hTotalFunc1(#$T0, #$R)) == Tagclass._System.___hTotalFunc1);

const unique Tagclass._System.___hTotalFunc1: TyTag;

// Tclass._System.___hTotalFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_0(Tclass._System.___hTotalFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc1_0(Ty) : Ty;

// Tclass._System.___hTotalFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_1(Tclass._System.___hTotalFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hTotalFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc1(#$T0, #$R)));

// _System._#TotalFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0) ==> Requires1(#$T0, #$R, $OneHeap, f#0, x0#0)));

// _System._#TotalFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h));

function Tclass._System.___hFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hFunc3);

const unique Tagclass._System.___hFunc3: TyTag;

// Tclass._System.___hFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_0(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hFunc3_0(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_1(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hFunc3_1(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_2(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hFunc3_2(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_3(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)));

function Handle3([Heap,Box,Box,Box]Box, [Heap,Box,Box,Box]bool, [Heap,Box,Box,Box]Set Box)
   : HandleType;

function Apply3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Box;

function Requires3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : bool;

function Reads3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)
     == h[heap, bx0, bx1, bx2]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  r[heap, bx0, bx1, bx2]
     ==> Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx: Box :: 
  { Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx] } 
  Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx]
     == rd[heap, bx0, bx1, bx2][bx]);

function {:inline} Requires3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

function {:inline} Reads3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// empty-reads property for Reads3 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     ==> (Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
       <==> Set#Equal(Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2), Set#Empty(): Set Box)));

// empty-reads property for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
     ==> Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)), $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, t3) } { $IsBox(bx, u3) } 
        $IsBox(bx, t3) ==> $IsBox(bx, u3))
     ==> $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box :: 
        { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
          { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
           ==> (forall r: ref :: 
            { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)] } 
            r != null && Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsAllocBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3, h)));

function Tclass._System.___hPartialFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hPartialFunc3);

const unique Tagclass._System.___hPartialFunc3: TyTag;

// Tclass._System.___hPartialFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_0(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc3_0(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_1(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc3_1(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_2(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc3_2(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_3(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hPartialFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#PartialFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Set#Equal(Reads3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hTotalFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hTotalFunc3);

const unique Tagclass._System.___hTotalFunc3: TyTag;

// Tclass._System.___hTotalFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_0(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc3_0(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_1(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc3_1(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_2(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc3_2(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_3(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hTotalFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#TotalFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Requires3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0)));

// _System._#TotalFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hFunc4);

const unique Tagclass._System.___hFunc4: TyTag;

// Tclass._System.___hFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_0(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hFunc4_0(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_1(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hFunc4_1(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_2(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hFunc4_2(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_3(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hFunc4_3(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_4(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

function Handle4([Heap,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Box;

function Requires4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : bool;

function Reads4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)
     == h[heap, bx0, bx1, bx2, bx3]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  r[heap, bx0, bx1, bx2, bx3]
     ==> Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx: Box :: 
  { Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx] } 
  Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx]
     == rd[heap, bx0, bx1, bx2, bx3][bx]);

function {:inline} Requires4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

function {:inline} Reads4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// empty-reads property for Reads4 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     ==> (Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set Box)));

// empty-reads property for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
     ==> Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)), $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, t4) } { $IsBox(bx, u4) } 
        $IsBox(bx, t4) ==> $IsBox(bx, u4))
     ==> $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
        { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
          { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
           ==> (forall r: ref :: 
            { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)] } 
            r != null && Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsAllocBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4, h)));

function Tclass._System.___hPartialFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hPartialFunc4);

const unique Tagclass._System.___hPartialFunc4: TyTag;

// Tclass._System.___hPartialFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_0(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc4_0(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_1(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc4_1(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_2(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc4_2(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_3(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc4_3(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_4(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hPartialFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#PartialFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Set#Equal(Reads4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hTotalFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hTotalFunc4);

const unique Tagclass._System.___hTotalFunc4: TyTag;

// Tclass._System.___hTotalFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_0(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc4_0(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_1(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc4_1(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_2(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc4_2(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_3(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc4_3(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_4(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hTotalFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#TotalFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Requires4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0)));

// _System._#TotalFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hFunc5);

const unique Tagclass._System.___hFunc5: TyTag;

// Tclass._System.___hFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_0(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hFunc5_0(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_1(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hFunc5_1(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_2(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hFunc5_2(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_3(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hFunc5_3(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_4(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hFunc5_4(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_5(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

function Handle5([Heap,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Box;

function Requires5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : bool;

function Reads5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } 
  Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)
     == h[heap, bx0, bx1, bx2, bx3, bx4]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } 
  r[heap, bx0, bx1, bx2, bx3, bx4]
     ==> Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx: Box :: 
  { Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx] } 
  Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4][bx]);

function {:inline} Requires5#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box)
   : bool
{
  true
}

function {:inline} Reads5#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box)
   : bool
{
  true
}

// frame axiom for Reads5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Reads5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Apply5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Apply5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// empty-reads property for Reads5 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } 
    { Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
     ==> (Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } 
    { Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)
     ==> Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty :: 
  { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) } 
  $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
      { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
         ==> $IsBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty :: 
  { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)), $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)) } 
  $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, t5) } { $IsBox(bx, u5) } 
        $IsBox(bx, t5) ==> $IsBox(bx, u5))
     ==> $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
        { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
          { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
           ==> (forall r: ref :: 
            { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)] } 
            r != null
                 && Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
      { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
         ==> $IsAllocBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5, h)));

function Tclass._System.___hPartialFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hPartialFunc5);

const unique Tagclass._System.___hPartialFunc5: TyTag;

// Tclass._System.___hPartialFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_0(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc5_0(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_1(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc5_1(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_2(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc5_2(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_3(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc5_3(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_4(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc5_4(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_5(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hPartialFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

// _System._#PartialFunc5: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
           ==> Set#Equal(Reads5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc5: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

function Tclass._System.___hTotalFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hTotalFunc5);

const unique Tagclass._System.___hTotalFunc5: TyTag;

// Tclass._System.___hTotalFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_0(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc5_0(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_1(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc5_1(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_2(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc5_2(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_3(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc5_3(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_4(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc5_4(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_5(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hTotalFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

// _System._#TotalFunc5: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
           ==> Requires5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0)));

// _System._#TotalFunc5: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

function Tclass._System.___hFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hFunc6);

const unique Tagclass._System.___hFunc6: TyTag;

// Tclass._System.___hFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_0(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hFunc6_0(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_1(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hFunc6_1(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_2(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hFunc6_2(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_3(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hFunc6_3(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_4(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hFunc6_4(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_5(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hFunc6_5(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_6(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

function Handle6([Heap,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : Box;

function Requires6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : bool;

function Reads6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Apply6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5) } 
  Apply6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Requires6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5]
     ==> Requires6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx: Box :: 
  { Reads6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)[bx] } 
  Reads6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5][bx]);

function {:inline} Requires6#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box)
   : bool
{
  true
}

function {:inline} Reads6#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box)
   : bool
{
  true
}

// frame axiom for Reads6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Reads6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Apply6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Apply6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// empty-reads property for Reads6 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } 
    { Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
     ==> (Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } 
    { Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty :: 
  { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) } 
  $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
      { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
         ==> $IsBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty :: 
  { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)), $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)) } 
  $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, t6) } { $IsBox(bx, u6) } 
        $IsBox(bx, t6) ==> $IsBox(bx, u6))
     ==> $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
        { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
          { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
           ==> (forall r: ref :: 
            { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)] } 
            r != null
                 && Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
      { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
         ==> $IsAllocBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6, h)));

function Tclass._System.___hPartialFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hPartialFunc6);

const unique Tagclass._System.___hPartialFunc6: TyTag;

// Tclass._System.___hPartialFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_0(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc6_0(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_1(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc6_1(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_2(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc6_2(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_3(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc6_3(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_4(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc6_4(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_5(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc6_5(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_6(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hPartialFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

// _System._#PartialFunc6: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
           ==> Set#Equal(Reads6(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc6: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h));

function Tclass._System.___hTotalFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hTotalFunc6);

const unique Tagclass._System.___hTotalFunc6: TyTag;

// Tclass._System.___hTotalFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_0(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc6_0(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_1(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc6_1(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_2(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc6_2(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_3(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc6_3(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_4(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc6_4(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_5(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc6_5(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_6(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hTotalFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

// _System._#TotalFunc6: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
           ==> Requires6(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0)));

// _System._#TotalFunc6: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h));

function Tclass._System.___hFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hFunc7);

const unique Tagclass._System.___hFunc7: TyTag;

// Tclass._System.___hFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_0(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hFunc7_0(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_1(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hFunc7_1(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_2(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hFunc7_2(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_3(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hFunc7_3(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_4(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hFunc7_4(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_5(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hFunc7_5(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_6(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hFunc7_6(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_7(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

function Handle7([Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Box;

function Requires7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : bool;

function Reads7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Apply7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6) } 
  Apply7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Requires7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6]
     ==> Requires7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx: Box :: 
  { Reads7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)[bx] } 
  Reads7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6][bx]);

function {:inline} Requires7#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box)
   : bool
{
  true
}

function {:inline} Reads7#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box)
   : bool
{
  true
}

// frame axiom for Reads7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Reads7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Apply7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Apply7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// empty-reads property for Reads7 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), $IsGoodHeap(heap) } 
    { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
     ==> (Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Requires7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), $IsGoodHeap(heap) } 
    { Requires7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, t7: Ty :: 
  { $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7)) } 
  $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
      { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && $IsBox(bx6, t6)
           && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
         ==> $IsBox(Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
          t7)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty, 
    u7: Ty :: 
  { $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7)), $Is(f, Tclass._System.___hFunc7(u0, u1, u2, u3, u4, u5, u6, u7)) } 
  $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u6) } { $IsBox(bx, t6) } 
        $IsBox(bx, u6) ==> $IsBox(bx, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, t7) } { $IsBox(bx, u7) } 
        $IsBox(bx, t7) ==> $IsBox(bx, u7))
     ==> $Is(f, Tclass._System.___hFunc7(u0, u1, u2, u3, u4, u5, u6, u7)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
        { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
          { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && 
            $IsBox(bx6, t6)
             && $IsAllocBox(bx6, t6, h)
             && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
           ==> (forall r: ref :: 
            { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(r)] } 
            r != null
                 && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
      { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && $IsAllocBox(bx6, t6, h)
           && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
         ==> $IsAllocBox(Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
          t7, 
          h)));

function Tclass._System.___hPartialFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hPartialFunc7);

const unique Tagclass._System.___hPartialFunc7: TyTag;

// Tclass._System.___hPartialFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_0(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc7_0(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_1(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc7_1(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_2(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc7_2(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_3(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc7_3(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_4(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc7_4(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_5(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc7_5(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_6(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hPartialFunc7_6(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_7(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hPartialFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

// _System._#PartialFunc7: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box, x6#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
           ==> Set#Equal(Reads7(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$T6, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0, 
              x6#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc7: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), $h));

function Tclass._System.___hTotalFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hTotalFunc7);

const unique Tagclass._System.___hTotalFunc7: TyTag;

// Tclass._System.___hTotalFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_0(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc7_0(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_1(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc7_1(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_2(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc7_2(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_3(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc7_3(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_4(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc7_4(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_5(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc7_5(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_6(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hTotalFunc7_6(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_7(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hTotalFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

// _System._#TotalFunc7: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     <==> $Is(f#0, 
        Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box, x6#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
           ==> Requires7(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$T6, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0, 
            x6#0)));

// _System._#TotalFunc7: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h));

// Constructor function declaration
function #_System._tuple#0._#Make0() : DatatypeType;

const unique ##_System._tuple#0._#Make0: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#_System._tuple#0._#Make0()) == ##_System._tuple#0._#Make0;

function _System.Tuple0.___hMake0_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#0._#Make0);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d) ==> d == #_System._tuple#0._#Make0());

function Tclass._System.Tuple0() : Ty;

// Tclass._System.Tuple0 Tag
axiom Tag(Tclass._System.Tuple0()) == Tagclass._System.Tuple0;

const unique Tagclass._System.Tuple0: TyTag;

// Box/unbox axiom for Tclass._System.Tuple0
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple0()) } 
  $IsBox(bx, Tclass._System.Tuple0())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple0()));

// Constructor $Is
axiom $Is(#_System._tuple#0._#Make0(), Tclass._System.Tuple0());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h));

// Constructor literal
axiom #_System._tuple#0._#Make0() == Lit(#_System._tuple#0._#Make0());

// Depth-one case-split function
function $IsA#_System.Tuple0(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple0(d) } 
  $IsA#_System.Tuple0(d) ==> _System.Tuple0.___hMake0_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d), $Is(d, Tclass._System.Tuple0()) } 
  $Is(d, Tclass._System.Tuple0()) ==> _System.Tuple0.___hMake0_q(d));

// Datatype extensional equality declaration
function _System.Tuple0#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#0._#Make0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  true ==> (_System.Tuple0#Equal(a, b) <==> true));

// Datatype extensionality axiom: _System._tuple#0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  _System.Tuple0#Equal(a, b) <==> a == b);

const unique class._System.Tuple0: ClassName;

const BaseFuel_DiskLayout._default.ValidNodeAddr: LayerType;

const StartFuel_DiskLayout._default.ValidNodeAddr: LayerType;

const StartFuelAssert_DiskLayout._default.ValidNodeAddr: LayerType;

const BaseFuel_DiskLayout._default.ValidJournalLocation: LayerType;

const StartFuel_DiskLayout._default.ValidJournalLocation: LayerType;

const StartFuelAssert_DiskLayout._default.ValidJournalLocation: LayerType;

const BaseFuel_DiskLayout._default.JournalBlockIdx: LayerType;

const StartFuel_DiskLayout._default.JournalBlockIdx: LayerType;

const StartFuelAssert_DiskLayout._default.JournalBlockIdx: LayerType;

const BaseFuel_Sequences._default.NoDupes: LayerType;

const StartFuel_Sequences._default.NoDupes: LayerType;

const StartFuelAssert_Sequences._default.NoDupes: LayerType;

const BaseFuel_Sequences._default.Range: LayerType;

const StartFuel_Sequences._default.Range: LayerType;

const StartFuelAssert_Sequences._default.Range: LayerType;

const BaseFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuelAssert_Sequences._default.ApplyOpaque: LayerType;

const BaseFuel_Sequences._default.remove: LayerType;

const StartFuel_Sequences._default.remove: LayerType;

const StartFuelAssert_Sequences._default.remove: LayerType;

const BaseFuel_Sequences._default.insert: LayerType;

const StartFuel_Sequences._default.insert: LayerType;

const StartFuelAssert_Sequences._default.insert: LayerType;

const BaseFuel_Sequences._default.replace1with2: LayerType;

const StartFuel_Sequences._default.replace1with2: LayerType;

const StartFuelAssert_Sequences._default.replace1with2: LayerType;

const BaseFuel_Sequences._default.replace2with1: LayerType;

const StartFuel_Sequences._default.replace2with1: LayerType;

const StartFuelAssert_Sequences._default.replace2with1: LayerType;

const BaseFuel_Sequences._default.concat: LayerType;

const StartFuel_Sequences._default.concat: LayerType;

const StartFuelAssert_Sequences._default.concat: LayerType;

const BaseFuel_Sequences._default.concat3: LayerType;

const StartFuel_Sequences._default.concat3: LayerType;

const StartFuelAssert_Sequences._default.concat3: LayerType;

const BaseFuel_Sequences._default.concatSeq: LayerType;

const StartFuel_Sequences._default.concatSeq: LayerType;

const StartFuelAssert_Sequences._default.concatSeq: LayerType;

const BaseFuel_Sequences._default.IsPrefix: LayerType;

const StartFuel_Sequences._default.IsPrefix: LayerType;

const StartFuelAssert_Sequences._default.IsPrefix: LayerType;

const BaseFuel_Sequences._default.IsSuffix: LayerType;

const StartFuel_Sequences._default.IsSuffix: LayerType;

const StartFuelAssert_Sequences._default.IsSuffix: LayerType;

const BaseFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexIterate: LayerType;

const BaseFuel_Sequences._default.SeqIndex: LayerType;

const StartFuel_Sequences._default.SeqIndex: LayerType;

const StartFuelAssert_Sequences._default.SeqIndex: LayerType;

const BaseFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuelAssert_Sequences._default.SeqOfLength: LayerType;

const BaseFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexUpdate: LayerType;

const BaseFuel_Sequences._default.Zip: LayerType;

const StartFuel_Sequences._default.Zip: LayerType;

const StartFuelAssert_Sequences._default.Zip: LayerType;

const BaseFuel_Sequences._default.Unzip: LayerType;

const StartFuel_Sequences._default.Unzip: LayerType;

const StartFuelAssert_Sequences._default.Unzip: LayerType;

const BaseFuel_Sequences._default.FlattenShape: LayerType;

const StartFuel_Sequences._default.FlattenShape: LayerType;

const StartFuelAssert_Sequences._default.FlattenShape: LayerType;

const BaseFuel_Sequences._default.FlattenLength: LayerType;

const StartFuel_Sequences._default.FlattenLength: LayerType;

const StartFuelAssert_Sequences._default.FlattenLength: LayerType;

const BaseFuel_Sequences._default.Flatten: LayerType;

const StartFuel_Sequences._default.Flatten: LayerType;

const StartFuelAssert_Sequences._default.Flatten: LayerType;

const BaseFuel_Sequences._default.fill: LayerType;

const StartFuel_Sequences._default.fill: LayerType;

const StartFuelAssert_Sequences._default.fill: LayerType;

const BaseFuel_SeqComparison._default.lte: LayerType;

const StartFuel_SeqComparison._default.lte: LayerType;

const StartFuelAssert_SeqComparison._default.lte: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const BaseFuel_JournalRanges._default.parseHeader: LayerType;

const StartFuel_JournalRanges._default.parseHeader: LayerType;

const StartFuelAssert_JournalRanges._default.parseHeader: LayerType;

const BaseFuel_JournalRanges._default.WeightJournalEntries: LayerType;

const StartFuel_JournalRanges._default.WeightJournalEntries: LayerType;

const StartFuelAssert_JournalRanges._default.WeightJournalEntries: LayerType;

const BaseFuel_Maps._default.MapRemove: LayerType;

const StartFuel_Maps._default.MapRemove: LayerType;

const StartFuelAssert_Maps._default.MapRemove: LayerType;

const BaseFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuelAssert_Maps._default.MapRemoveStrong: LayerType;

const BaseFuel_Maps._default.MapRemove1: LayerType;

const StartFuel_Maps._default.MapRemove1: LayerType;

const StartFuelAssert_Maps._default.MapRemove1: LayerType;

const BaseFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuelAssert_Maps._default.MapRemove1Strong: LayerType;

const BaseFuel_Maps._default.IMapRemove: LayerType;

const StartFuel_Maps._default.IMapRemove: LayerType;

const StartFuelAssert_Maps._default.IMapRemove: LayerType;

const BaseFuel_Maps._default.IMapRemove1: LayerType;

const StartFuel_Maps._default.IMapRemove1: LayerType;

const StartFuelAssert_Maps._default.IMapRemove1: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion: LayerType;

const BaseFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferA: LayerType;

const BaseFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferB: LayerType;

const BaseFuel_Maps._default.MapUnion: LayerType;

const StartFuel_Maps._default.MapUnion: LayerType;

const StartFuelAssert_Maps._default.MapUnion: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferA: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferB: LayerType;

const BaseFuel_Maps._default.IMapUnion: LayerType;

const StartFuel_Maps._default.IMapUnion: LayerType;

const StartFuelAssert_Maps._default.IMapUnion: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion3: LayerType;

const BaseFuel_AsyncDisk._default.ChecksumChecksOut: LayerType;

const StartFuel_AsyncDisk._default.ChecksumChecksOut: LayerType;

const StartFuelAssert_AsyncDisk._default.ChecksumChecksOut: LayerType;

const BaseFuel_AsyncDisk._default.splice: LayerType;

const StartFuel_AsyncDisk._default.splice: LayerType;

const StartFuelAssert_AsyncDisk._default.splice: LayerType;

const BaseFuel_JournalBytes._default.JournalBlockOfByteSeq: LayerType;

const StartFuel_JournalBytes._default.JournalBlockOfByteSeq: LayerType;

const StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq: LayerType;

const BaseFuel_JournalBytes._default.JournalRangeOfByteSeq: LayerType;

const StartFuel_JournalBytes._default.JournalRangeOfByteSeq: LayerType;

const StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq: LayerType;

const BaseFuel_PackedIntsLib._default.pack_LittleEndian_Uint32: LayerType;

const StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32: LayerType;

const StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32: LayerType;

const BaseFuel_JournalistMarshallingModel._default.cyclicSlice: LayerType;

const StartFuel_JournalistMarshallingModel._default.cyclicSlice: LayerType;

const StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice: LayerType;

const BaseFuel_JournalistMarshallingModel._default.withoutChecksums: LayerType;

const StartFuel_JournalistMarshallingModel._default.withoutChecksums: LayerType;

const StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums: LayerType;

const BaseFuel_JournalistMarshallingModel._default.splice: LayerType;

const StartFuel_JournalistMarshallingModel._default.splice: LayerType;

const StartFuelAssert_JournalistMarshallingModel._default.splice: LayerType;

const BaseFuel_JournalistMarshallingModel._default.writeOnto: LayerType;

const StartFuel_JournalistMarshallingModel._default.writeOnto: LayerType;

const StartFuelAssert_JournalistMarshallingModel._default.writeOnto: LayerType;

const BaseFuel_JournalistMarshallingModel._default.writeIntOnto: LayerType;

const StartFuel_JournalistMarshallingModel._default.writeIntOnto: LayerType;

const StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto: LayerType;

const BaseFuel_JournalistMarshallingModel._default.writeJournalEntries: LayerType;

const StartFuel_JournalistMarshallingModel._default.writeJournalEntries: LayerType;

const StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries: LayerType;

const BaseFuel_JournalistMarshallingModel._default.fillInChecksums: LayerType;

const StartFuel_JournalistMarshallingModel._default.fillInChecksums: LayerType;

const StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums: LayerType;

const BaseFuel_JournalistMarshallingModel._default.hasHeader: LayerType;

const StartFuel_JournalistMarshallingModel._default.hasHeader: LayerType;

const StartFuelAssert_JournalistMarshallingModel._default.hasHeader: LayerType;

const BaseFuel_JournalistMarshallingModel._default.marshallJournalEntries: LayerType;

const StartFuel_JournalistMarshallingModel._default.marshallJournalEntries: LayerType;

const StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries: LayerType;

const BaseFuel_JournalistModel._default.JournalistConstructor: LayerType;

const StartFuel_JournalistModel._default.JournalistConstructor: LayerType;

const StartFuelAssert_JournalistModel._default.JournalistConstructor: LayerType;

const BaseFuel_JournalistModel._default.hasFrozenJournal: LayerType;

const StartFuel_JournalistModel._default.hasFrozenJournal: LayerType;

const StartFuelAssert_JournalistModel._default.hasFrozenJournal: LayerType;

const BaseFuel_JournalistModel._default.hasInMemoryJournal: LayerType;

const StartFuel_JournalistModel._default.hasInMemoryJournal: LayerType;

const StartFuelAssert_JournalistModel._default.hasInMemoryJournal: LayerType;

const BaseFuel_JournalistModel._default.packageFrozenJournal: LayerType;

const StartFuel_JournalistModel._default.packageFrozenJournal: LayerType;

const StartFuelAssert_JournalistModel._default.packageFrozenJournal: LayerType;

const BaseFuel_JournalistModel._default.packageInMemoryJournal: LayerType;

const StartFuel_JournalistModel._default.packageInMemoryJournal: LayerType;

const StartFuelAssert_JournalistModel._default.packageInMemoryJournal: LayerType;

const BaseFuel_JournalistModel._default.freeze: LayerType;

const StartFuel_JournalistModel._default.freeze: LayerType;

const StartFuelAssert_JournalistModel._default.freeze: LayerType;

const BaseFuel_JournalistModel._default.canAppend: LayerType;

const StartFuel_JournalistModel._default.canAppend: LayerType;

const StartFuelAssert_JournalistModel._default.canAppend: LayerType;

const BaseFuel_JournalistModel._default.append: LayerType;

const StartFuel_JournalistModel._default.append: LayerType;

const StartFuelAssert_JournalistModel._default.append: LayerType;

const BaseFuel_JournalistModel._default.isReplayEmpty: LayerType;

const StartFuel_JournalistModel._default.isReplayEmpty: LayerType;

const StartFuelAssert_JournalistModel._default.isReplayEmpty: LayerType;

const BaseFuel_JournalistModel._default.replayJournalTop: LayerType;

const StartFuel_JournalistModel._default.replayJournalTop: LayerType;

const StartFuelAssert_JournalistModel._default.replayJournalTop: LayerType;

const BaseFuel_JournalistModel._default.replayJournalPop: LayerType;

const StartFuel_JournalistModel._default.replayJournalPop: LayerType;

const StartFuelAssert_JournalistModel._default.replayJournalPop: LayerType;

const BaseFuel_JournalistModel._default.setFront: LayerType;

const StartFuel_JournalistModel._default.setFront: LayerType;

const StartFuelAssert_JournalistModel._default.setFront: LayerType;

const BaseFuel_JournalistModel._default.setBack: LayerType;

const StartFuel_JournalistModel._default.setBack: LayerType;

const StartFuelAssert_JournalistModel._default.setBack: LayerType;

const BaseFuel_JournalistModel._default.parseJournals: LayerType;

const StartFuel_JournalistModel._default.parseJournals: LayerType;

const StartFuelAssert_JournalistModel._default.parseJournals: LayerType;

const BaseFuel_JournalistModel._default.hasFront: LayerType;

const StartFuel_JournalistModel._default.hasFront: LayerType;

const StartFuelAssert_JournalistModel._default.hasFront: LayerType;

const BaseFuel_JournalistModel._default.hasBack: LayerType;

const StartFuel_JournalistModel._default.hasBack: LayerType;

const StartFuelAssert_JournalistModel._default.hasBack: LayerType;

const unique class.JournalistImpl.Journalist?: ClassName;

function Tclass.JournalistImpl.Journalist?() : Ty;

// Tclass.JournalistImpl.Journalist? Tag
axiom Tag(Tclass.JournalistImpl.Journalist?()) == Tagclass.JournalistImpl.Journalist?;

const unique Tagclass.JournalistImpl.Journalist?: TyTag;

// Box/unbox axiom for Tclass.JournalistImpl.Journalist?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistImpl.Journalist?()) } 
  $IsBox(bx, Tclass.JournalistImpl.Journalist?())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalistImpl.Journalist?()));

// Journalist: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalistImpl.Journalist?()) } 
  $Is($o, Tclass.JournalistImpl.Journalist?())
     <==> $o == null || dtype($o) == Tclass.JournalistImpl.Journalist?());

// Journalist: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalistImpl.Journalist?(), $h) } 
  $IsAlloc($o, Tclass.JournalistImpl.Journalist?(), $h)
     <==> $o == null || read($h, $o, alloc));

axiom FDim(JournalistImpl.Journalist.journalEntries) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$journalEntries)
     == JournalistImpl.Journalist.journalEntries
   && !$IsGhostField(JournalistImpl.Journalist.journalEntries);

const JournalistImpl.Journalist.journalEntries: Field ref;

function Tclass.Journal.JournalEntry() : Ty;

// Tclass.Journal.JournalEntry Tag
axiom Tag(Tclass.Journal.JournalEntry()) == Tagclass.Journal.JournalEntry;

const unique Tagclass.Journal.JournalEntry: TyTag;

// Box/unbox axiom for Tclass.Journal.JournalEntry
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Journal.JournalEntry()) } 
  $IsBox(bx, Tclass.Journal.JournalEntry())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Journal.JournalEntry()));

// Journalist.journalEntries: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.journalEntries) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.journalEntries), 
      Tclass._System.array(Tclass.Journal.JournalEntry())));

// Journalist.journalEntries: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.journalEntries) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.journalEntries), 
      Tclass._System.array(Tclass.Journal.JournalEntry()), 
      $h));

axiom FDim(JournalistImpl.Journalist.start) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$start)
     == JournalistImpl.Journalist.start
   && !$IsGhostField(JournalistImpl.Journalist.start);

const JournalistImpl.Journalist.start: Field int;

function Tclass.NativeTypes.uint64() : Ty;

// Tclass.NativeTypes.uint64 Tag
axiom Tag(Tclass.NativeTypes.uint64()) == Tagclass.NativeTypes.uint64;

const unique Tagclass.NativeTypes.uint64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint64()) } 
  $IsBox(bx, Tclass.NativeTypes.uint64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint64()));

// Journalist.start: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.start) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.start), Tclass.NativeTypes.uint64()));

// Journalist.start: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.start) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.start), Tclass.NativeTypes.uint64(), $h));

axiom FDim(JournalistImpl.Journalist.len1) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$len1)
     == JournalistImpl.Journalist.len1
   && !$IsGhostField(JournalistImpl.Journalist.len1);

const JournalistImpl.Journalist.len1: Field int;

// Journalist.len1: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.len1) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.len1), Tclass.NativeTypes.uint64()));

// Journalist.len1: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.len1) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.len1), Tclass.NativeTypes.uint64(), $h));

axiom FDim(JournalistImpl.Journalist.len2) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$len2)
     == JournalistImpl.Journalist.len2
   && !$IsGhostField(JournalistImpl.Journalist.len2);

const JournalistImpl.Journalist.len2: Field int;

// Journalist.len2: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.len2) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.len2), Tclass.NativeTypes.uint64()));

// Journalist.len2: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.len2) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.len2), Tclass.NativeTypes.uint64(), $h));

axiom FDim(JournalistImpl.Journalist.replayJournal) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$replayJournal)
     == JournalistImpl.Journalist.replayJournal
   && !$IsGhostField(JournalistImpl.Journalist.replayJournal);

const JournalistImpl.Journalist.replayJournal: Field (Seq Box);

// Journalist.replayJournal: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.replayJournal) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.replayJournal), 
      TSeq(Tclass.Journal.JournalEntry())));

// Journalist.replayJournal: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.replayJournal) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.replayJournal), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h));

axiom FDim(JournalistImpl.Journalist.replayIdx) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$replayIdx)
     == JournalistImpl.Journalist.replayIdx
   && !$IsGhostField(JournalistImpl.Journalist.replayIdx);

const JournalistImpl.Journalist.replayIdx: Field int;

// Journalist.replayIdx: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.replayIdx) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.replayIdx), Tclass.NativeTypes.uint64()));

// Journalist.replayIdx: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.replayIdx) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.replayIdx), 
      Tclass.NativeTypes.uint64(), 
      $h));

axiom FDim(JournalistImpl.Journalist.journalFront) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$journalFront)
     == JournalistImpl.Journalist.journalFront
   && !$IsGhostField(JournalistImpl.Journalist.journalFront);

const JournalistImpl.Journalist.journalFront: Field DatatypeType;

function Tclass.NativeTypes.byte() : Ty;

// Tclass.NativeTypes.byte Tag
axiom Tag(Tclass.NativeTypes.byte()) == Tagclass.NativeTypes.byte;

const unique Tagclass.NativeTypes.byte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.byte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.byte()) } 
  $IsBox(bx, Tclass.NativeTypes.byte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.byte()));

function Tclass.Options.Option(Ty) : Ty;

// Tclass.Options.Option Tag
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tag(Tclass.Options.Option(Options.Option$V)) == Tagclass.Options.Option);

const unique Tagclass.Options.Option: TyTag;

// Tclass.Options.Option injectivity 0
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tclass.Options.Option_0(Tclass.Options.Option(Options.Option$V))
     == Options.Option$V);

function Tclass.Options.Option_0(Ty) : Ty;

// Box/unbox axiom for Tclass.Options.Option
axiom (forall Options.Option$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.Options.Option(Options.Option$V)) } 
  $IsBox(bx, Tclass.Options.Option(Options.Option$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Options.Option(Options.Option$V)));

// Journalist.journalFront: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.journalFront) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.journalFront), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte())))));

// Journalist.journalFront: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.journalFront) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.journalFront), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h));

axiom FDim(JournalistImpl.Journalist.journalBack) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$journalBack)
     == JournalistImpl.Journalist.journalBack
   && !$IsGhostField(JournalistImpl.Journalist.journalBack);

const JournalistImpl.Journalist.journalBack: Field DatatypeType;

// Journalist.journalBack: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.journalBack) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.journalBack), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte())))));

// Journalist.journalBack: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.journalBack) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.journalBack), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h));

axiom FDim(JournalistImpl.Journalist.writtenJournalBlocks) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$writtenJournalBlocks)
     == JournalistImpl.Journalist.writtenJournalBlocks
   && !$IsGhostField(JournalistImpl.Journalist.writtenJournalBlocks);

const JournalistImpl.Journalist.writtenJournalBlocks: Field int;

// Journalist.writtenJournalBlocks: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.writtenJournalBlocks) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.writtenJournalBlocks), 
      Tclass.NativeTypes.uint64()));

// Journalist.writtenJournalBlocks: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.writtenJournalBlocks) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.writtenJournalBlocks), 
      Tclass.NativeTypes.uint64(), 
      $h));

axiom FDim(JournalistImpl.Journalist.frozenJournalBlocks) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$frozenJournalBlocks)
     == JournalistImpl.Journalist.frozenJournalBlocks
   && !$IsGhostField(JournalistImpl.Journalist.frozenJournalBlocks);

const JournalistImpl.Journalist.frozenJournalBlocks: Field int;

// Journalist.frozenJournalBlocks: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.frozenJournalBlocks) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.frozenJournalBlocks), 
      Tclass.NativeTypes.uint64()));

// Journalist.frozenJournalBlocks: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.frozenJournalBlocks) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.frozenJournalBlocks), 
      Tclass.NativeTypes.uint64(), 
      $h));

axiom FDim(JournalistImpl.Journalist.inMemoryWeight) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$inMemoryWeight)
     == JournalistImpl.Journalist.inMemoryWeight
   && !$IsGhostField(JournalistImpl.Journalist.inMemoryWeight);

const JournalistImpl.Journalist.inMemoryWeight: Field int;

// Journalist.inMemoryWeight: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.inMemoryWeight) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.inMemoryWeight), 
      Tclass.NativeTypes.uint64()));

// Journalist.inMemoryWeight: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.inMemoryWeight) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.inMemoryWeight), 
      Tclass.NativeTypes.uint64(), 
      $h));

axiom FDim(JournalistImpl.Journalist.Repr) == 0
   && FieldOfDecl(class.JournalistImpl.Journalist?, field$Repr)
     == JournalistImpl.Journalist.Repr
   && $IsGhostField(JournalistImpl.Journalist.Repr);

const JournalistImpl.Journalist.Repr: Field (Set Box);

// Journalist.Repr: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
     ==> $Is(read($h, $o, JournalistImpl.Journalist.Repr), TSet(Tclass._System.object())));

// Journalist.Repr: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, JournalistImpl.Journalist.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.JournalistImpl.Journalist?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, JournalistImpl.Journalist.Repr), TSet(Tclass._System.object()), $h));

// function declaration for JournalistImpl.Journalist.ReprInv
function JournalistImpl.Journalist.ReprInv($heap: Heap, this: ref) : bool;

function JournalistImpl.Journalist.ReprInv#canCall($heap: Heap, this: ref) : bool;

function Tclass.JournalistImpl.Journalist() : Ty;

// Tclass.JournalistImpl.Journalist Tag
axiom Tag(Tclass.JournalistImpl.Journalist()) == Tagclass.JournalistImpl.Journalist;

const unique Tagclass.JournalistImpl.Journalist: TyTag;

// Box/unbox axiom for Tclass.JournalistImpl.Journalist
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistImpl.Journalist()) } 
  $IsBox(bx, Tclass.JournalistImpl.Journalist())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalistImpl.Journalist()));

// frame axiom for JournalistImpl.Journalist.ReprInv
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), JournalistImpl.Journalist.ReprInv($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.JournalistImpl.Journalist())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> JournalistImpl.Journalist.ReprInv($h0, this)
       == JournalistImpl.Journalist.ReprInv($h1, this));

// consequence axiom for JournalistImpl.Journalist.ReprInv
axiom 1 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { JournalistImpl.Journalist.ReprInv($Heap, this) } 
    JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         || (1 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.JournalistImpl.Journalist())
           && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
       ==> 
      JournalistImpl.Journalist.ReprInv($Heap, this)
       ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(this)]);

function JournalistImpl.Journalist.ReprInv#requires(Heap, ref) : bool;

// #requires axiom for JournalistImpl.Journalist.ReprInv
axiom (forall $Heap: Heap, this: ref :: 
  { JournalistImpl.Journalist.ReprInv#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.JournalistImpl.Journalist())
       && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap)
     ==> JournalistImpl.Journalist.ReprInv#requires($Heap, this) == true);

// definition axiom for JournalistImpl.Journalist.ReprInv(revealed)
axiom 1 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { JournalistImpl.Journalist.ReprInv($Heap, this) } 
    JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         || (1 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.JournalistImpl.Journalist())
           && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         == Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));

procedure CheckWellformed$$JournalistImpl.Journalist.ReprInv(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures JournalistImpl.Journalist.ReprInv($Heap, this)
     ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(this)];



implementation CheckWellformed$$JournalistImpl.Journalist.ReprInv(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;

    // AddWellformednessCheck for function ReprInv
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(40,24): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == this);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    if (*)
    {
        if (*)
        {
            assert this == this
               || (Set#Subset(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  Set#UnionOne(Set#Empty(): Set Box, $Box(this)))
                 && !Set#Subset(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  Set#UnionOne(Set#Empty(): Set Box, $Box(this))));
            assume this == this || JournalistImpl.Journalist.ReprInv#canCall($Heap, this);
            assume JournalistImpl.Journalist.ReprInv($Heap, this);
            assume read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(this)];
        }
        else
        {
            assume JournalistImpl.Journalist.ReprInv($Heap, this)
               ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(this)];
        }

        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> $o == this);
        b$reqreads#0 := $_Frame[this, JournalistImpl.Journalist.Repr];
        b$reqreads#1 := $_Frame[this, JournalistImpl.Journalist.journalEntries];
        assume JournalistImpl.Journalist.ReprInv($Heap, this)
           == Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(JournalistImpl.Journalist.ReprInv($Heap, this), TBool);
        assert b$reqreads#0;
        assert b$reqreads#1;
    }
}



// function declaration for JournalistImpl.Journalist.I
function JournalistImpl.Journalist.I($heap: Heap, this: ref) : DatatypeType;

function JournalistImpl.Journalist.I#canCall($heap: Heap, this: ref) : bool;

// frame axiom for JournalistImpl.Journalist.I
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), JournalistImpl.Journalist.I($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.JournalistImpl.Journalist())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, JournalistImpl.Journalist.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> JournalistImpl.Journalist.I($h0, this) == JournalistImpl.Journalist.I($h1, this));

function Tclass.JournalistModel.JournalistModel() : Ty;

// Tclass.JournalistModel.JournalistModel Tag
axiom Tag(Tclass.JournalistModel.JournalistModel())
   == Tagclass.JournalistModel.JournalistModel;

const unique Tagclass.JournalistModel.JournalistModel: TyTag;

// Box/unbox axiom for Tclass.JournalistModel.JournalistModel
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistModel.JournalistModel()) } 
  $IsBox(bx, Tclass.JournalistModel.JournalistModel())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalistModel.JournalistModel()));

// consequence axiom for JournalistImpl.Journalist.I
axiom 2 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { JournalistImpl.Journalist.I($Heap, this) } 
    JournalistImpl.Journalist.I#canCall($Heap, this)
         || (2 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.JournalistImpl.Journalist())
           && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap)
           && JournalistImpl.Journalist.ReprInv($Heap, this))
       ==> $Is(JournalistImpl.Journalist.I($Heap, this), 
        Tclass.JournalistModel.JournalistModel()));

function JournalistImpl.Journalist.I#requires(Heap, ref) : bool;

// #requires axiom for JournalistImpl.Journalist.I
axiom (forall $Heap: Heap, this: ref :: 
  { JournalistImpl.Journalist.I#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.JournalistImpl.Journalist())
       && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap)
     ==> JournalistImpl.Journalist.I#requires($Heap, this)
       == JournalistImpl.Journalist.ReprInv($Heap, this));

// definition axiom for JournalistImpl.Journalist.I(revealed)
axiom 2 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { JournalistImpl.Journalist.I($Heap, this) } 
    JournalistImpl.Journalist.I#canCall($Heap, this)
         || (2 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.JournalistImpl.Journalist())
           && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap)
           && JournalistImpl.Journalist.ReprInv($Heap, this))
       ==> JournalistImpl.Journalist.I($Heap, this)
         == #JournalistModel.JournalistModel.JournalistModel(Seq#FromArray($Heap, read($Heap, this, JournalistImpl.Journalist.journalEntries)), 
          read($Heap, this, JournalistImpl.Journalist.start), 
          read($Heap, this, JournalistImpl.Journalist.len1), 
          read($Heap, this, JournalistImpl.Journalist.len2), 
          read($Heap, this, JournalistImpl.Journalist.replayJournal), 
          read($Heap, this, JournalistImpl.Journalist.replayIdx), 
          read($Heap, this, JournalistImpl.Journalist.journalFront), 
          read($Heap, this, JournalistImpl.Journalist.journalBack), 
          read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks), 
          read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks), 
          read($Heap, this, JournalistImpl.Journalist.inMemoryWeight)));

procedure CheckWellformed$$JournalistImpl.Journalist.I(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.I(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;
  var b$reqreads#7: bool;
  var b$reqreads#8: bool;
  var b$reqreads#9: bool;
  var b$reqreads#10: bool;
  var b$reqreads#11: bool;
  var b$reqreads#12: bool;
  var b$reqreads#13: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    b$reqreads#7 := true;
    b$reqreads#8 := true;
    b$reqreads#9 := true;
    b$reqreads#10 := true;
    b$reqreads#11 := true;
    b$reqreads#12 := true;
    b$reqreads#13 := true;

    // AddWellformednessCheck for function I
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(47,23): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == this ==> $_Frame[$o, $f]);
    assume JournalistImpl.Journalist.ReprInv#canCall($Heap, this);
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assert b$reqreads#0;
    b$reqreads#1 := $_Frame[this, JournalistImpl.Journalist.Repr];
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(JournalistImpl.Journalist.I($Heap, this), 
          Tclass.JournalistModel.JournalistModel());
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
        b$reqreads#2 := $_Frame[this, JournalistImpl.Journalist.journalEntries];
        assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
        b$reqreads#3 := (forall $i: int :: 
          { $_Frame[read($Heap, this, JournalistImpl.Journalist.journalEntries), IndexField($i)] } 
          0 <= $i
               && $i
                 < _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
             ==> $_Frame[read($Heap, this, JournalistImpl.Journalist.journalEntries), IndexField($i)]);
        b$reqreads#4 := $_Frame[this, JournalistImpl.Journalist.start];
        b$reqreads#5 := $_Frame[this, JournalistImpl.Journalist.len1];
        b$reqreads#6 := $_Frame[this, JournalistImpl.Journalist.len2];
        b$reqreads#7 := $_Frame[this, JournalistImpl.Journalist.replayJournal];
        b$reqreads#8 := $_Frame[this, JournalistImpl.Journalist.replayIdx];
        b$reqreads#9 := $_Frame[this, JournalistImpl.Journalist.journalFront];
        b$reqreads#10 := $_Frame[this, JournalistImpl.Journalist.journalBack];
        b$reqreads#11 := $_Frame[this, JournalistImpl.Journalist.writtenJournalBlocks];
        b$reqreads#12 := $_Frame[this, JournalistImpl.Journalist.frozenJournalBlocks];
        b$reqreads#13 := $_Frame[this, JournalistImpl.Journalist.inMemoryWeight];
        assume JournalistImpl.Journalist.I($Heap, this)
           == #JournalistModel.JournalistModel.JournalistModel(Seq#FromArray($Heap, read($Heap, this, JournalistImpl.Journalist.journalEntries)), 
            read($Heap, this, JournalistImpl.Journalist.start), 
            read($Heap, this, JournalistImpl.Journalist.len1), 
            read($Heap, this, JournalistImpl.Journalist.len2), 
            read($Heap, this, JournalistImpl.Journalist.replayJournal), 
            read($Heap, this, JournalistImpl.Journalist.replayIdx), 
            read($Heap, this, JournalistImpl.Journalist.journalFront), 
            read($Heap, this, JournalistImpl.Journalist.journalBack), 
            read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks), 
            read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks), 
            read($Heap, this, JournalistImpl.Journalist.inMemoryWeight));
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(JournalistImpl.Journalist.I($Heap, this), 
          Tclass.JournalistModel.JournalistModel());
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
        assert b$reqreads#6;
        assert b$reqreads#7;
        assert b$reqreads#8;
        assert b$reqreads#9;
        assert b$reqreads#10;
        assert b$reqreads#11;
        assert b$reqreads#12;
        assert b$reqreads#13;
    }
}



// function declaration for JournalistImpl.Journalist.WF
function JournalistImpl.Journalist.WF($heap: Heap, this: ref) : bool;

function JournalistImpl.Journalist.WF#canCall($heap: Heap, this: ref) : bool;

// frame axiom for JournalistImpl.Journalist.WF
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), JournalistImpl.Journalist.WF($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.JournalistImpl.Journalist())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, JournalistImpl.Journalist.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> JournalistImpl.Journalist.WF($h0, this)
       == JournalistImpl.Journalist.WF($h1, this));

// consequence axiom for JournalistImpl.Journalist.WF
axiom 18 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { JournalistImpl.Journalist.WF($Heap, this) } 
    JournalistImpl.Journalist.WF#canCall($Heap, this)
         || (18 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.JournalistImpl.Journalist())
           && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
       ==> true);

function JournalistImpl.Journalist.WF#requires(Heap, ref) : bool;

// #requires axiom for JournalistImpl.Journalist.WF
axiom (forall $Heap: Heap, this: ref :: 
  { JournalistImpl.Journalist.WF#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.JournalistImpl.Journalist())
       && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap)
     ==> JournalistImpl.Journalist.WF#requires($Heap, this) == true);

// definition axiom for JournalistImpl.Journalist.WF(revealed)
axiom 18 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { JournalistImpl.Journalist.WF($Heap, this) } 
    JournalistImpl.Journalist.WF#canCall($Heap, this)
         || (18 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.JournalistImpl.Journalist())
           && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
       ==> JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         && (JournalistImpl.Journalist.ReprInv($Heap, this)
           ==> JournalistImpl.Journalist.I#canCall($Heap, this)
             && JournalistModel.__default.WF#canCall(JournalistImpl.Journalist.I($Heap, this)))
         && JournalistImpl.Journalist.WF($Heap, this)
           == (JournalistImpl.Journalist.ReprInv($Heap, this)
             && JournalistModel.__default.WF(JournalistImpl.Journalist.I($Heap, this))));

procedure CheckWellformed$$JournalistImpl.Journalist.WF(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  free requires 18 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.WF(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var ##jm#0: DatatypeType;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;

    // AddWellformednessCheck for function WF
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(65,14): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    b$reqreads#0 := $_Frame[this, JournalistImpl.Journalist.Repr];
    assert b$reqreads#0;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) && $o == this ==> $_Frame[$o, $f]);
        assume JournalistImpl.Journalist.ReprInv#canCall($Heap, this);
        if (JournalistImpl.Journalist.ReprInv($Heap, this))
        {
            assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
               ==> JournalistImpl.Journalist.ReprInv($Heap, this)
                 || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
            assume JournalistImpl.Journalist.ReprInv($Heap, this);
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == this || read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume JournalistImpl.Journalist.I#canCall($Heap, this);
            assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
            ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
            b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume JournalistModel.__default.WF#canCall(JournalistImpl.Journalist.I($Heap, this));
        }

        assume JournalistImpl.Journalist.WF($Heap, this)
           == (JournalistImpl.Journalist.ReprInv($Heap, this)
             && JournalistModel.__default.WF(JournalistImpl.Journalist.I($Heap, this)));
        assume JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
           && (JournalistImpl.Journalist.ReprInv($Heap, this)
             ==> JournalistImpl.Journalist.I#canCall($Heap, this)
               && JournalistModel.__default.WF#canCall(JournalistImpl.Journalist.I($Heap, this)));
        // CheckWellformedWithResult: any expression
        assume $Is(JournalistImpl.Journalist.WF($Heap, this), TBool);
        assert b$reqreads#1;
        assert b$reqreads#2;
        assert b$reqreads#3;
    }
}



// function declaration for JournalistImpl.Journalist.Inv
function JournalistImpl.Journalist.Inv($heap: Heap, this: ref) : bool;

function JournalistImpl.Journalist.Inv#canCall($heap: Heap, this: ref) : bool;

// frame axiom for JournalistImpl.Journalist.Inv
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), JournalistImpl.Journalist.Inv($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.JournalistImpl.Journalist())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, JournalistImpl.Journalist.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> JournalistImpl.Journalist.Inv($h0, this)
       == JournalistImpl.Journalist.Inv($h1, this));

// consequence axiom for JournalistImpl.Journalist.Inv
axiom 4 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { JournalistImpl.Journalist.Inv($Heap, this) } 
    JournalistImpl.Journalist.Inv#canCall($Heap, this)
         || (4 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.JournalistImpl.Journalist())
           && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
       ==> 
      JournalistImpl.Journalist.Inv($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this));

function JournalistImpl.Journalist.Inv#requires(Heap, ref) : bool;

// #requires axiom for JournalistImpl.Journalist.Inv
axiom (forall $Heap: Heap, this: ref :: 
  { JournalistImpl.Journalist.Inv#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.JournalistImpl.Journalist())
       && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap)
     ==> JournalistImpl.Journalist.Inv#requires($Heap, this) == true);

// definition axiom for JournalistImpl.Journalist.Inv(revealed)
axiom 4 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { JournalistImpl.Journalist.Inv($Heap, this) } 
    JournalistImpl.Journalist.Inv#canCall($Heap, this)
         || (4 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.JournalistImpl.Journalist())
           && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
       ==> JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         && (JournalistImpl.Journalist.ReprInv($Heap, this)
           ==> JournalistImpl.Journalist.I#canCall($Heap, this)
             && JournalistModel.__default.Inv#canCall(JournalistImpl.Journalist.I($Heap, this)))
         && JournalistImpl.Journalist.Inv($Heap, this)
           == (JournalistImpl.Journalist.ReprInv($Heap, this)
             && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this))));

procedure CheckWellformed$$JournalistImpl.Journalist.Inv(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures JournalistImpl.Journalist.Inv($Heap, this)
     ==> 
    JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.ReprInv($Heap, this)
       || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
        Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));



implementation CheckWellformed$$JournalistImpl.Journalist.Inv(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var ##jm#0: DatatypeType;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;

    // AddWellformednessCheck for function Inv
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(72,24): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    b$reqreads#0 := $_Frame[this, JournalistImpl.Journalist.Repr];
    assert b$reqreads#0;
    if (*)
    {
        if (*)
        {
            assert this == this
               || (Set#Subset(Set#Union(read($Heap, this, JournalistImpl.Journalist.Repr), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(this))), 
                  Set#Union(read($Heap, this, JournalistImpl.Journalist.Repr), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(this))))
                 && !Set#Subset(Set#Union(read($Heap, this, JournalistImpl.Journalist.Repr), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(this))), 
                  Set#Union(read($Heap, this, JournalistImpl.Journalist.Repr), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(this)))));
            assume this == this || JournalistImpl.Journalist.Inv#canCall($Heap, this);
            assume JournalistImpl.Journalist.Inv($Heap, this);
            assume JournalistImpl.Journalist.ReprInv#canCall($Heap, this);
            assume JournalistImpl.Journalist.ReprInv($Heap, this);
        }
        else
        {
            assume JournalistImpl.Journalist.Inv($Heap, this)
               ==> JournalistImpl.Journalist.ReprInv($Heap, this);
        }

        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) && $o == this ==> $_Frame[$o, $f]);
        assume JournalistImpl.Journalist.ReprInv#canCall($Heap, this);
        if (JournalistImpl.Journalist.ReprInv($Heap, this))
        {
            assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
               ==> JournalistImpl.Journalist.ReprInv($Heap, this)
                 || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                    $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
            assume JournalistImpl.Journalist.ReprInv($Heap, this);
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == this || read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume JournalistImpl.Journalist.I#canCall($Heap, this);
            assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
            ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
            b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume JournalistModel.__default.Inv#canCall(JournalistImpl.Journalist.I($Heap, this));
        }

        assume JournalistImpl.Journalist.Inv($Heap, this)
           == (JournalistImpl.Journalist.ReprInv($Heap, this)
             && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this)));
        assume JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
           && (JournalistImpl.Journalist.ReprInv($Heap, this)
             ==> JournalistImpl.Journalist.I#canCall($Heap, this)
               && JournalistModel.__default.Inv#canCall(JournalistImpl.Journalist.I($Heap, this)));
        // CheckWellformedWithResult: any expression
        assume $Is(JournalistImpl.Journalist.Inv($Heap, this), TBool);
        assert b$reqreads#1;
        assert b$reqreads#2;
        assert b$reqreads#3;
    }
}



procedure CheckWellformed$$JournalistImpl.Journalist.__ctor(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.__ctor(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: _ctor, CheckWellformed$$JournalistImpl.Journalist.__ctor
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(80,4): initial state"} true;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(81,15): post-state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assume (forall $o: ref :: 
      { read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)] } 
      read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assume JournalistModel.__default.JournalistConstructor#canCall();
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.JournalistConstructor(StartFuel_JournalistModel._default.JournalistConstructor));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.JournalistConstructor(StartFuel_JournalistModel._default.JournalistConstructor));
}



procedure Call$$JournalistImpl.Journalist.__ctor()
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)] } 
    read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.JournalistConstructor(StartFuel_JournalistModel._default.JournalistConstructor))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.JournalistConstructor#canCall();
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.JournalistConstructor(StartFuelAssert_JournalistModel._default.JournalistConstructor));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.__ctor()
   returns (this: ref where this != null && $Is(this, Tclass.JournalistImpl.Journalist()), 
    $_reverifyPost: bool);
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)] } 
    read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.JournalistConstructor(StartFuel_JournalistModel._default.JournalistConstructor))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.JournalistConstructor#canCall();
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.JournalistConstructor(StartFuelAssert_JournalistModel._default.JournalistConstructor));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



function Tclass.KeyType.Key() : Ty;

// Tclass.KeyType.Key Tag
axiom Tag(Tclass.KeyType.Key()) == Tagclass.KeyType.Key;

const unique Tagclass.KeyType.Key: TyTag;

// Box/unbox axiom for Tclass.KeyType.Key
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KeyType.Key()) } 
  $IsBox(bx, Tclass.KeyType.Key())
     ==> $Box($Unbox(bx): Seq Box) == bx
       && $Is($Unbox(bx): Seq Box, Tclass.KeyType.Key()));

function Tclass.ValueType.Value() : Ty;

// Tclass.ValueType.Value Tag
axiom Tag(Tclass.ValueType.Value()) == Tagclass.ValueType.Value;

const unique Tagclass.ValueType.Value: TyTag;

// Box/unbox axiom for Tclass.ValueType.Value
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.Value()) } 
  $IsBox(bx, Tclass.ValueType.Value())
     ==> $Box($Unbox(bx): Seq Box) == bx
       && $Is($Unbox(bx): Seq Box, Tclass.ValueType.Value()));

implementation Impl$$JournalistImpl.Journalist.__ctor() returns (this: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var this.journalEntries: ref;
  var this.start: int;
  var this.len1: int;
  var this.len2: int;
  var this.replayJournal: Seq Box;
  var this.replayIdx: int;
  var this.journalFront: DatatypeType;
  var this.journalBack: DatatypeType;
  var this.writtenJournalBlocks: int;
  var this.frozenJournalBlocks: int;
  var this.inMemoryWeight: int;
  var this.Repr: Set Box;
  var $obj0: ref;
  var $rhs##0: ref
     where $Is($rhs##0, Tclass._System.array(Tclass.Journal.JournalEntry()))
       && $IsAlloc($rhs##0, Tclass._System.array(Tclass.Journal.JournalEntry()), $Heap);
  var n##0: int;
  var newtype$check#0: int;
  var t##0: Box;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;
  var newtype$check#1: int;
  var $rhs#1: int where LitInt(0) <= $rhs#1 && $rhs#1 < 18446744073709551616;
  var newtype$check#2: int;
  var $rhs#2: int where LitInt(0) <= $rhs#2 && $rhs#2 < 18446744073709551616;
  var newtype$check#3: int;
  var $rhs#3: Seq Box where $Is($rhs#3, TSeq(Tclass.Journal.JournalEntry()));
  var $rhs#4: int where LitInt(0) <= $rhs#4 && $rhs#4 < 18446744073709551616;
  var newtype$check#4: int;
  var $rhs#5: DatatypeType
     where $Is($rhs#5, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))));
  var $rhs#6: DatatypeType
     where $Is($rhs#6, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))));
  var $rhs#7: int where LitInt(0) <= $rhs#7 && $rhs#7 < 18446744073709551616;
  var newtype$check#5: int;
  var $rhs#8: int where LitInt(0) <= $rhs#8 && $rhs#8 < 18446744073709551616;
  var newtype$check#6: int;
  var $rhs#9: int where LitInt(0) <= $rhs#9 && $rhs#9 < 18446744073709551616;
  var newtype$check#7: int;
  var $rhs#10: Set Box where $Is($rhs#10, TSet(Tclass._System.object()));

    // AddMethodImpl: _ctor, Impl$$JournalistImpl.Journalist.__ctor
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(84,4): initial state"} true;
    $_reverifyPost := false;
    // ----- divided block before new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(84,5)
    // ----- new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(84,5)
    assume !read($Heap, this, alloc);
    assume read($Heap, this, JournalistImpl.Journalist.journalEntries)
       == this.journalEntries;
    assume read($Heap, this, JournalistImpl.Journalist.start) == this.start;
    assume read($Heap, this, JournalistImpl.Journalist.len1) == this.len1;
    assume read($Heap, this, JournalistImpl.Journalist.len2) == this.len2;
    assume read($Heap, this, JournalistImpl.Journalist.replayJournal) == this.replayJournal;
    assume read($Heap, this, JournalistImpl.Journalist.replayIdx) == this.replayIdx;
    assume read($Heap, this, JournalistImpl.Journalist.journalFront) == this.journalFront;
    assume read($Heap, this, JournalistImpl.Journalist.journalBack) == this.journalBack;
    assume read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks)
       == this.writtenJournalBlocks;
    assume read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks)
       == this.frozenJournalBlocks;
    assume read($Heap, this, JournalistImpl.Journalist.inMemoryWeight)
       == this.inMemoryWeight;
    assume read($Heap, this, JournalistImpl.Journalist.Repr) == this.Repr;
    $Heap := update($Heap, this, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    // ----- divided block after new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(84,5)
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(86,55)
    assume true;
    $obj0 := this;
    assert $_Frame[$obj0, JournalistImpl.Journalist.journalEntries];
    // TrCallStmt: Adding lhs Microsoft.Dafny.MemberSelectExpr with type array<JournalEntry>
    // TrCallStmt: Before ProcessCallStmt
    newtype$check#0 := LitInt(4096);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    n##0 := LitInt(4096);
    assert $Is(Lit(Seq#Empty(): Seq Box), Tclass.KeyType.Key());
    assert $Is(Lit(Seq#Empty(): Seq Box), Tclass.ValueType.Value());
    assume true;
    // ProcessCallStmt: CheckSubrange
    t##0 := $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box))));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$NativeArrays.__default.newArrayFill(Tclass.Journal.JournalEntry(), n##0, t##0);
    // TrCallStmt: After ProcessCallStmt
    $Heap := update($Heap, $obj0, JournalistImpl.Journalist.journalEntries, $rhs##0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(88,32)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(89,18)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.start];
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    $rhs#0 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.start, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(89,21)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(90,17)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.len1];
    newtype$check#2 := LitInt(0);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    $rhs#1 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.len1, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(90,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(91,17)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.len2];
    newtype$check#3 := LitInt(0);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume true;
    $rhs#2 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.len2, $rhs#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(91,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(92,26)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.replayJournal];
    assume true;
    $rhs#3 := Lit(Seq#Empty(): Seq Box);
    $Heap := update($Heap, this, JournalistImpl.Journalist.replayJournal, $rhs#3);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(92,30)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(93,22)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.replayIdx];
    newtype$check#4 := LitInt(0);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assume true;
    $rhs#4 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.replayIdx, $rhs#4);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(93,25)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(94,25)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.journalFront];
    assume true;
    $rhs#5 := Lit(#Options.Option.None());
    $Heap := update($Heap, this, JournalistImpl.Journalist.journalFront, $rhs#5);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(94,31)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(95,24)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.journalBack];
    assume true;
    $rhs#6 := Lit(#Options.Option.None());
    $Heap := update($Heap, this, JournalistImpl.Journalist.journalBack, $rhs#6);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(95,30)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(96,33)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.writtenJournalBlocks];
    newtype$check#5 := LitInt(0);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assume true;
    $rhs#7 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks, $rhs#7);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(96,36)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(97,32)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.frozenJournalBlocks];
    newtype$check#6 := LitInt(0);
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assume true;
    $rhs#8 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks, $rhs#8);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(97,35)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(98,27)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.inMemoryWeight];
    newtype$check#7 := LitInt(0);
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assume true;
    $rhs#9 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.inMemoryWeight, $rhs#9);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(98,30)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(100,12)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.Repr];
    assume true;
    $rhs#10 := Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)));
    $Heap := update($Heap, this, JournalistImpl.Journalist.Repr, $rhs#10);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(100,41)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(101,51)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__JournalistConstructor();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(101,52)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(102,7)
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assume JournalistModel.__default.JournalistConstructor#canCall();
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.JournalistConstructor(StartFuel_JournalistModel._default.JournalistConstructor));
    assume $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
       && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.JournalistConstructor(StartFuel_JournalistModel._default.JournalistConstructor))
       && 
      JournalistImpl.Journalist.I#canCall($Heap, this)
       && JournalistModel.__default.JournalistConstructor#canCall();
    assert {:subsumption 0} JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.JournalistConstructor(StartFuelAssert_JournalistModel._default.JournalistConstructor));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.JournalistConstructor(StartFuel_JournalistModel._default.JournalistConstructor));
}



procedure CheckWellformed$$JournalistImpl.Journalist.hasFrozenJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  free requires 20 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.hasFrozenJournal(this: ref) returns (b#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: hasFrozenJournal, CheckWellformed$$JournalistImpl.Journalist.hasFrozenJournal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(105,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc b#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(107,14): post-state"} true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.hasFrozenJournal#canCall(JournalistImpl.Journalist.I($Heap, this));
    assume b#0
       == JournalistModel.__default.hasFrozenJournal(StartFuel_JournalistModel._default.hasFrozenJournal, 
        JournalistImpl.Journalist.I($Heap, this));
}



procedure Call$$JournalistImpl.Journalist.hasFrozenJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.hasFrozenJournal#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.hasFrozenJournal(StartFuelAssert_JournalistModel._default.hasFrozenJournal, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.hasFrozenJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool, $_reverifyPost: bool);
  free requires 20 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.hasFrozenJournal#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.hasFrozenJournal(StartFuelAssert_JournalistModel._default.hasFrozenJournal, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.hasFrozenJournal(this: ref) returns (b#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;

    // AddMethodImpl: hasFrozenJournal, Impl$$JournalistImpl.Journalist.hasFrozenJournal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(108,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(109,46)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__hasFrozenJournal();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(109,47)"} true;
    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(110,7)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(110,7)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    b#0 := read($Heap, this, JournalistImpl.Journalist.len1) != 0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(110,27)"} true;
    return;
}



procedure CheckWellformed$$JournalistImpl.Journalist.hasInMemoryJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  free requires 21 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.hasInMemoryJournal(this: ref) returns (b#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: hasInMemoryJournal, CheckWellformed$$JournalistImpl.Journalist.hasInMemoryJournal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(113,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc b#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(115,14): post-state"} true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.hasInMemoryJournal#canCall(JournalistImpl.Journalist.I($Heap, this));
    assume b#0
       == JournalistModel.__default.hasInMemoryJournal(StartFuel_JournalistModel._default.hasInMemoryJournal, 
        JournalistImpl.Journalist.I($Heap, this));
}



procedure Call$$JournalistImpl.Journalist.hasInMemoryJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.hasInMemoryJournal#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.hasInMemoryJournal(StartFuelAssert_JournalistModel._default.hasInMemoryJournal, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.hasInMemoryJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool, $_reverifyPost: bool);
  free requires 21 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.hasInMemoryJournal#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.hasInMemoryJournal(StartFuelAssert_JournalistModel._default.hasInMemoryJournal, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.hasInMemoryJournal(this: ref) returns (b#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;

    // AddMethodImpl: hasInMemoryJournal, Impl$$JournalistImpl.Journalist.hasInMemoryJournal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(116,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(117,48)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__hasInMemoryJournal();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(117,49)"} true;
    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(118,7)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(118,7)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    b#0 := read($Heap, this, JournalistImpl.Journalist.len2) != 0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(118,27)"} true;
    return;
}



procedure CheckWellformed$$JournalistImpl.Journalist.packageFrozenJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function JournalistModel.__default.packageFrozenJournal#Handle(LayerType) : HandleType;

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: 
  { Apply1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageFrozenJournal#Handle($ly), 
      $fh$0x#0) } 
  Apply1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageFrozenJournal#Handle($ly), 
      $fh$0x#0)
     == $Box(JournalistModel.__default.packageFrozenJournal($ly, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: 
  { Requires1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageFrozenJournal#Handle($ly), 
      $fh$0x#0) } 
  Requires1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageFrozenJournal#Handle($ly), 
      $fh$0x#0)
     == JournalistModel.__default.packageFrozenJournal#requires($ly, $Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: 
  { Reads1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageFrozenJournal#Handle($ly), 
      $fh$0x#0)[$bx] } 
  Reads1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageFrozenJournal#Handle($ly), 
      $fh$0x#0)[$bx]
     == false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: DatatypeType :: 
  { JournalistModel.__default.packageFrozenJournal($ly, $fh$0x#0), $IsGoodHeap($heap) } 
  JournalistModel.__default.packageFrozenJournal($ly, $fh$0x#0)
     == $Unbox(Apply1(Tclass.JournalistModel.JournalistModel(), 
        Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
        $heap, 
        JournalistModel.__default.packageFrozenJournal#Handle($ly), 
        $Box($fh$0x#0))): DatatypeType);

implementation CheckWellformed$$JournalistImpl.Journalist.packageFrozenJournal(this: ref) returns (s#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##x0#0: DatatypeType;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: packageFrozenJournal, CheckWellformed$$JournalistImpl.Journalist.packageFrozenJournal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(121,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##x0#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##x0#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assume Requires1#canCall(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $Heap, 
      JournalistModel.__default.packageFrozenJournal#Handle(StartFuel_JournalistModel._default.packageFrozenJournal), 
      $Box(JournalistImpl.Journalist.I($Heap, this)));
    assume Requires1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $Heap, 
      JournalistModel.__default.packageFrozenJournal#Handle(StartFuel_JournalistModel._default.packageFrozenJournal), 
      $Box(JournalistImpl.Journalist.I($Heap, this)));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc s#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(125,17): post-state"} true;
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assume Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
      read(old($Heap), this, JournalistImpl.Journalist.Repr));
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#0 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assert {:subsumption 0} !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assume !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assume JournalistModel.__default.packageFrozenJournal#canCall(JournalistImpl.Journalist.I(old($Heap), this));
    assume _System.Tuple2.___hMake2_q(JournalistModel.__default.packageFrozenJournal(StartFuel_JournalistModel._default.packageFrozenJournal, 
        JournalistImpl.Journalist.I(old($Heap), this)));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(JournalistImpl.Journalist.I($Heap, this)), $Box(s#0)), 
      JournalistModel.__default.packageFrozenJournal(StartFuel_JournalistModel._default.packageFrozenJournal, 
        JournalistImpl.Journalist.I(old($Heap), this)));
}



procedure Call$$JournalistImpl.Journalist.packageFrozenJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  requires Requires1(Tclass.JournalistModel.JournalistModel(), 
    Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
    $Heap, 
    JournalistModel.__default.packageFrozenJournal#Handle(StartFuelAssert_JournalistModel._default.packageFrozenJournal), 
    $Box(JournalistImpl.Journalist.I($Heap, this)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures $IsA#_System.Tuple2(JournalistModel.__default.packageFrozenJournal(StartFuel_JournalistModel._default.packageFrozenJournal, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.packageFrozenJournal#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(JournalistImpl.Journalist.I($Heap, this)), $Box(s#0)), 
    JournalistModel.__default.packageFrozenJournal(StartFuelAssert_JournalistModel._default.packageFrozenJournal, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.packageFrozenJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    $_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  requires Requires1(Tclass.JournalistModel.JournalistModel(), 
    Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
    $Heap, 
    JournalistModel.__default.packageFrozenJournal#Handle(StartFuelAssert_JournalistModel._default.packageFrozenJournal), 
    $Box(JournalistImpl.Journalist.I($Heap, this)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures $IsA#_System.Tuple2(JournalistModel.__default.packageFrozenJournal(StartFuel_JournalistModel._default.packageFrozenJournal, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.packageFrozenJournal#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(JournalistImpl.Journalist.I($Heap, this)), $Box(s#0)), 
    JournalistModel.__default.packageFrozenJournal(StartFuelAssert_JournalistModel._default.packageFrozenJournal, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.packageFrozenJournal(this: ref) returns (s#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var jm##0: DatatypeType;
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc($rhs##0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var entries##0: ref;
  var start##0: int;
  var len##0: int;
  var numBlocks##0: int;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##x#0: int;
  var ##len#0: int;
  var $rhs#1: int where LitInt(0) <= $rhs#1 && $rhs#1 < 18446744073709551616;
  var newtype$check#2: int;
  var $rhs#2: int where LitInt(0) <= $rhs#2 && $rhs#2 < 18446744073709551616;
  var newtype$check#3: int;
  var $rhs#3: int where LitInt(0) <= $rhs#3 && $rhs#3 < 18446744073709551616;
  var newtype$check#4: int;

    // AddMethodImpl: packageFrozenJournal, Impl$$JournalistImpl.Journalist.packageFrozenJournal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(128,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(129,50)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__packageFrozenJournal();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(129,51)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(130,34)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalRanges.__default.reveal__WeightJournalEntries();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(130,35)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(131,31)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    // ProcessCallStmt: CheckSubrange
    jm##0 := JournalistImpl.Journalist.I($Heap, this);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__I(jm##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(131,35)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(133,34)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type seq<byte>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    entries##0 := read($Heap, this, JournalistImpl.Journalist.journalEntries);
    assume true;
    // ProcessCallStmt: CheckSubrange
    start##0 := read($Heap, this, JournalistImpl.Journalist.start);
    assume true;
    // ProcessCallStmt: CheckSubrange
    len##0 := read($Heap, this, JournalistImpl.Journalist.len1);
    assume true;
    // ProcessCallStmt: CheckSubrange
    numBlocks##0 := read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$JournalistMarshallingImpl.__default.MarshallJournalEntries(entries##0, start##0, len##0, numBlocks##0);
    // TrCallStmt: After ProcessCallStmt
    s#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(137,33)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(139,18)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.start];
    newtype$check#0 := read($Heap, this, JournalistImpl.Journalist.start)
       + read($Heap, this, JournalistImpl.Journalist.len1);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
    newtype$check#1 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    ##x#0 := read($Heap, this, JournalistImpl.Journalist.start)
       + read($Heap, this, JournalistImpl.Journalist.len1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##x#0, Tclass.NativeTypes.uint64(), $Heap);
    ##len#0 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
    // assume allocatedness for argument to function
    assume $IsAlloc(##len#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} ##len#0
       <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())));
    assume ##len#0
       <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())));
    assume JournalistModel.__default.basic__mod#canCall(read($Heap, this, JournalistImpl.Journalist.start)
         + read($Heap, this, JournalistImpl.Journalist.len1), 
      _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)));
    assume JournalistModel.__default.basic__mod#canCall(read($Heap, this, JournalistImpl.Journalist.start)
         + read($Heap, this, JournalistImpl.Journalist.len1), 
      _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)));
    $rhs#0 := JournalistModel.__default.basic__mod(read($Heap, this, JournalistImpl.Journalist.start)
         + read($Heap, this, JournalistImpl.Journalist.len1), 
      _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)));
    $Heap := update($Heap, this, JournalistImpl.Journalist.start, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(140,47)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(141,17)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.len1];
    newtype$check#2 := LitInt(0);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    $rhs#1 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.len1, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(141,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(142,33)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.writtenJournalBlocks];
    newtype$check#3 := read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks)
       + read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume true;
    $rhs#2 := read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks)
       + read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks);
    $Heap := update($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks, $rhs#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(143,62)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(144,32)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.frozenJournalBlocks];
    newtype$check#4 := LitInt(0);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assume true;
    $rhs#3 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks, $rhs#3);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(144,35)"} true;
}



procedure CheckWellformed$$JournalistImpl.Journalist.packageInMemoryJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function JournalistModel.__default.packageInMemoryJournal#Handle(LayerType) : HandleType;

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: 
  { Apply1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageInMemoryJournal#Handle($ly), 
      $fh$0x#0) } 
  Apply1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageInMemoryJournal#Handle($ly), 
      $fh$0x#0)
     == $Box(JournalistModel.__default.packageInMemoryJournal($ly, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: 
  { Requires1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageInMemoryJournal#Handle($ly), 
      $fh$0x#0) } 
  Requires1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageInMemoryJournal#Handle($ly), 
      $fh$0x#0)
     == JournalistModel.__default.packageInMemoryJournal#requires($ly, $Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: 
  { Reads1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageInMemoryJournal#Handle($ly), 
      $fh$0x#0)[$bx] } 
  Reads1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $heap, 
      JournalistModel.__default.packageInMemoryJournal#Handle($ly), 
      $fh$0x#0)[$bx]
     == false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: DatatypeType :: 
  { JournalistModel.__default.packageInMemoryJournal($ly, $fh$0x#0), $IsGoodHeap($heap) } 
  JournalistModel.__default.packageInMemoryJournal($ly, $fh$0x#0)
     == $Unbox(Apply1(Tclass.JournalistModel.JournalistModel(), 
        Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
        $heap, 
        JournalistModel.__default.packageInMemoryJournal#Handle($ly), 
        $Box($fh$0x#0))): DatatypeType);

implementation CheckWellformed$$JournalistImpl.Journalist.packageInMemoryJournal(this: ref) returns (s#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##x0#0: DatatypeType;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: packageInMemoryJournal, CheckWellformed$$JournalistImpl.Journalist.packageInMemoryJournal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(147,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##x0#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##x0#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assume Requires1#canCall(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $Heap, 
      JournalistModel.__default.packageInMemoryJournal#Handle(StartFuel_JournalistModel._default.packageInMemoryJournal), 
      $Box(JournalistImpl.Journalist.I($Heap, this)));
    assume Requires1(Tclass.JournalistModel.JournalistModel(), 
      Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
      $Heap, 
      JournalistModel.__default.packageInMemoryJournal#Handle(StartFuel_JournalistModel._default.packageInMemoryJournal), 
      $Box(JournalistImpl.Journalist.I($Heap, this)));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc s#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(151,17): post-state"} true;
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assume Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
      read(old($Heap), this, JournalistImpl.Journalist.Repr));
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#0 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assert {:subsumption 0} Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assume Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assert {:subsumption 0} !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assume !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assume JournalistModel.__default.packageInMemoryJournal#canCall(JournalistImpl.Journalist.I(old($Heap), this));
    assume _System.Tuple2.___hMake2_q(JournalistModel.__default.packageInMemoryJournal(StartFuel_JournalistModel._default.packageInMemoryJournal, 
        JournalistImpl.Journalist.I(old($Heap), this)));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(JournalistImpl.Journalist.I($Heap, this)), $Box(s#0)), 
      JournalistModel.__default.packageInMemoryJournal(StartFuel_JournalistModel._default.packageInMemoryJournal, 
        JournalistImpl.Journalist.I(old($Heap), this)));
}



procedure Call$$JournalistImpl.Journalist.packageInMemoryJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  requires Requires1(Tclass.JournalistModel.JournalistModel(), 
    Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
    $Heap, 
    JournalistModel.__default.packageInMemoryJournal#Handle(StartFuelAssert_JournalistModel._default.packageInMemoryJournal), 
    $Box(JournalistImpl.Journalist.I($Heap, this)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures $IsA#_System.Tuple2(JournalistModel.__default.packageInMemoryJournal(StartFuel_JournalistModel._default.packageInMemoryJournal, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.packageInMemoryJournal#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(JournalistImpl.Journalist.I($Heap, this)), $Box(s#0)), 
    JournalistModel.__default.packageInMemoryJournal(StartFuelAssert_JournalistModel._default.packageInMemoryJournal, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.packageInMemoryJournal(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    $_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  requires Requires1(Tclass.JournalistModel.JournalistModel(), 
    Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte())), 
    $Heap, 
    JournalistModel.__default.packageInMemoryJournal#Handle(StartFuelAssert_JournalistModel._default.packageInMemoryJournal), 
    $Box(JournalistImpl.Journalist.I($Heap, this)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures $IsA#_System.Tuple2(JournalistModel.__default.packageInMemoryJournal(StartFuel_JournalistModel._default.packageInMemoryJournal, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.packageInMemoryJournal#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(JournalistImpl.Journalist.I($Heap, this)), $Box(s#0)), 
    JournalistModel.__default.packageInMemoryJournal(StartFuelAssert_JournalistModel._default.packageInMemoryJournal, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.packageInMemoryJournal(this: ref) returns (s#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var jm##0: DatatypeType;
  var numBlocks#0: int
     where LitInt(0) <= numBlocks#0 && numBlocks#0 < 18446744073709551616;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc($rhs##0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var entries##0: ref;
  var start##0: int;
  var len##0: int;
  var numBlocks##0: int;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;
  var newtype$check#6: int;
  var $rhs#1: int where LitInt(0) <= $rhs#1 && $rhs#1 < 18446744073709551616;
  var newtype$check#7: int;
  var $rhs#2: int where LitInt(0) <= $rhs#2 && $rhs#2 < 18446744073709551616;
  var newtype$check#8: int;
  var $rhs#3: int where LitInt(0) <= $rhs#3 && $rhs#3 < 18446744073709551616;
  var newtype$check#9: int;

    // AddMethodImpl: packageInMemoryJournal, Impl$$JournalistImpl.Journalist.packageInMemoryJournal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(154,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(155,52)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__packageInMemoryJournal();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(155,53)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(156,34)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalRanges.__default.reveal__WeightJournalEntries();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(156,35)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(157,31)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    // ProcessCallStmt: CheckSubrange
    jm##0 := JournalistImpl.Journalist.I($Heap, this);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__I(jm##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(157,35)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(159,21)
    assume true;
    newtype$check#0 := LitInt(4064);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := read($Heap, this, JournalistImpl.Journalist.inMemoryWeight) + 4064;
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := LitInt(1);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := read($Heap, this, JournalistImpl.Journalist.inMemoryWeight) + 4064 - 1;
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := LitInt(4064);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assert LitInt(4064) != 0;
    newtype$check#5 := Div(read($Heap, this, JournalistImpl.Journalist.inMemoryWeight) + 4064 - 1, 
      LitInt(4064));
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assume true;
    numBlocks#0 := Div(read($Heap, this, JournalistImpl.Journalist.inMemoryWeight) + 4064 - 1, 
      LitInt(4064));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(159,62)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(160,34)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type seq<byte>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    entries##0 := read($Heap, this, JournalistImpl.Journalist.journalEntries);
    assume true;
    // ProcessCallStmt: CheckSubrange
    start##0 := read($Heap, this, JournalistImpl.Journalist.start);
    assume true;
    // ProcessCallStmt: CheckSubrange
    len##0 := read($Heap, this, JournalistImpl.Journalist.len2);
    assume true;
    // ProcessCallStmt: CheckSubrange
    numBlocks##0 := numBlocks#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$JournalistMarshallingImpl.__default.MarshallJournalEntries(entries##0, start##0, len##0, numBlocks##0);
    // TrCallStmt: After ProcessCallStmt
    s#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(164,18)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(166,18)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.start];
    newtype$check#6 := LitInt(0);
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assume true;
    $rhs#0 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.start, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(166,21)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(167,17)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.len2];
    newtype$check#7 := LitInt(0);
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assume true;
    $rhs#1 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.len2, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(167,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(168,27)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.inMemoryWeight];
    newtype$check#8 := LitInt(0);
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    assume true;
    $rhs#2 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.inMemoryWeight, $rhs#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(168,30)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(169,33)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.writtenJournalBlocks];
    newtype$check#9 := read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks) + numBlocks#0;
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    assume true;
    $rhs#3 := read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks) + numBlocks#0;
    $Heap := update($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks, $rhs#3);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(169,72)"} true;
}



procedure CheckWellformed$$JournalistImpl.Journalist.getWrittenJournalLen(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.getWrittenJournalLen(this: ref) returns (len#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: getWrittenJournalLen, CheckWellformed$$JournalistImpl.Journalist.getWrittenJournalLen
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(172,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc len#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(175,16): post-state"} true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.getWrittenJournalLen#canCall(JournalistImpl.Journalist.I($Heap, this));
    assume len#0
       == JournalistModel.__default.getWrittenJournalLen(JournalistImpl.Journalist.I($Heap, this));
}



procedure Call$$JournalistImpl.Journalist.getWrittenJournalLen(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.getWrittenJournalLen#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures len#0
     == JournalistModel.__default.getWrittenJournalLen(JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.getWrittenJournalLen(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.getWrittenJournalLen#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures len#0
     == JournalistModel.__default.getWrittenJournalLen(JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.getWrittenJournalLen(this: ref) returns (len#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: getWrittenJournalLen, Impl$$JournalistImpl.Journalist.getWrittenJournalLen
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(176,4): initial state"} true;
    $_reverifyPost := false;
    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(177,7)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(177,7)
    assume true;
    assume true;
    len#0 := read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(177,38)"} true;
    return;
}



procedure CheckWellformed$$JournalistImpl.Journalist.setWrittenJournalLen(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 9 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function JournalistModel.__default.setWrittenJournalLen#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Apply2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.setWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1) } 
  Apply2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.setWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)
     == $Box(JournalistModel.__default.setWrittenJournalLen($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): int)));

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Requires2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.setWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1) } 
  Requires2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.setWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)
     == JournalistModel.__default.setWrittenJournalLen#requires($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): int));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Reads2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.setWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)[$bx] } 
  Reads2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.setWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)[$bx]
     == false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType, $fh$0x#1: int :: 
  { JournalistModel.__default.setWrittenJournalLen($fh$0x#0, $fh$0x#1), $IsGoodHeap($heap) } 
  JournalistModel.__default.setWrittenJournalLen($fh$0x#0, $fh$0x#1)
     == $Unbox(Apply2(Tclass.JournalistModel.JournalistModel(), 
        Tclass.NativeTypes.uint64(), 
        Tclass.JournalistModel.JournalistModel(), 
        $heap, 
        JournalistModel.__default.setWrittenJournalLen#Handle(), 
        $Box($fh$0x#0), 
        $Box($fh$0x#1))): DatatypeType);

implementation CheckWellformed$$JournalistImpl.Journalist.setWrittenJournalLen(this: ref, len#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##x0#0: DatatypeType;
  var ##x1#0: int;
  var ##jm#0: DatatypeType;
  var ##len#0: int;

    // AddMethodImpl: setWrittenJournalLen, CheckWellformed$$JournalistImpl.Journalist.setWrittenJournalLen
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(180,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##x0#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##x0#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##x1#0 := len#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##x1#0, Tclass.NativeTypes.uint64(), $Heap);
    assume Requires2#canCall(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $Heap, 
      JournalistModel.__default.setWrittenJournalLen#Handle(), 
      $Box(JournalistImpl.Journalist.I($Heap, this)), 
      $Box(len#0));
    assume Requires2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $Heap, 
      JournalistModel.__default.setWrittenJournalLen#Handle(), 
      $Box(JournalistImpl.Journalist.I($Heap, this)), 
      $Box(len#0));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(184,17): post-state"} true;
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assume Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
      read(old($Heap), this, JournalistImpl.Journalist.Repr));
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#0 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##len#0 := len#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##len#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assert {:subsumption 0} Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assume Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assert {:subsumption 0} Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assume Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(##jm#0)), 
      Seq#Empty(): Seq Box);
    assert {:subsumption 0} LitInt(0) <= ##len#0;
    assert {:subsumption 0} ##len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assume LitInt(0) <= ##len#0
       && ##len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assume JournalistModel.__default.setWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.setWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.setWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
}



procedure Call$$JournalistImpl.Journalist.setWrittenJournalLen(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  requires Requires2(Tclass.JournalistModel.JournalistModel(), 
    Tclass.NativeTypes.uint64(), 
    Tclass.JournalistModel.JournalistModel(), 
    $Heap, 
    JournalistModel.__default.setWrittenJournalLen#Handle(), 
    $Box(JournalistImpl.Journalist.I($Heap, this)), 
    $Box(len#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.setWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.setWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.setWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.setWrittenJournalLen(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 9 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  requires Requires2(Tclass.JournalistModel.JournalistModel(), 
    Tclass.NativeTypes.uint64(), 
    Tclass.JournalistModel.JournalistModel(), 
    $Heap, 
    JournalistModel.__default.setWrittenJournalLen#Handle(), 
    $Box(JournalistImpl.Journalist.I($Heap, this)), 
    $Box(len#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.setWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.setWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.setWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.setWrittenJournalLen(this: ref, len#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;
  var $rhs#1: int where LitInt(0) <= $rhs#1 && $rhs#1 < 18446744073709551616;
  var newtype$check#0: int;
  var ##jm#1: DatatypeType;
  var ##len#1: int;

    // AddMethodImpl: setWrittenJournalLen, Impl$$JournalistImpl.Journalist.setWrittenJournalLen
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(187,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(188,33)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.writtenJournalBlocks];
    assume true;
    $rhs#0 := len#0;
    $Heap := update($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(188,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(189,32)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.frozenJournalBlocks];
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    $rhs#1 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(189,35)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(190,7)
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#1 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#1, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##len#1 := len#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##len#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.start(##jm#1)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.replayIdx(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                        i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                            i#2)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || (forall i#3: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                        i#3)): Seq Box } 
                  LitInt(0) <= i#3
                       && i#3
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                            i#3)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#1))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#1))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#1);
    assert {:subsumption 0} Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(##jm#1)), 
      Seq#Empty(): Seq Box);
    assert {:subsumption 0} Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(##jm#1)), 
      Seq#Empty(): Seq Box);
    assert {:subsumption 0} LitInt(0) <= ##len#1;
    assert {:subsumption 0} ##len#1 <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assume JournalistModel.__default.setWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.setWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
    assume $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
       && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.setWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0))
       && 
      JournalistImpl.Journalist.I#canCall($Heap, this)
       && 
      JournalistImpl.Journalist.I#canCall(old($Heap), this)
       && JournalistModel.__default.setWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
    assert JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.setWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
}



procedure CheckWellformed$$JournalistImpl.Journalist.updateWrittenJournalLen(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function JournalistModel.__default.updateWrittenJournalLen#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Apply2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.updateWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1) } 
  Apply2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.updateWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)
     == $Box(JournalistModel.__default.updateWrittenJournalLen($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): int)));

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Requires2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.updateWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1) } 
  Requires2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.updateWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)
     == JournalistModel.__default.updateWrittenJournalLen#requires($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): int));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Reads2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.updateWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)[$bx] } 
  Reads2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $heap, 
      JournalistModel.__default.updateWrittenJournalLen#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)[$bx]
     == false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType, $fh$0x#1: int :: 
  { JournalistModel.__default.updateWrittenJournalLen($fh$0x#0, $fh$0x#1), $IsGoodHeap($heap) } 
  JournalistModel.__default.updateWrittenJournalLen($fh$0x#0, $fh$0x#1)
     == $Unbox(Apply2(Tclass.JournalistModel.JournalistModel(), 
        Tclass.NativeTypes.uint64(), 
        Tclass.JournalistModel.JournalistModel(), 
        $heap, 
        JournalistModel.__default.updateWrittenJournalLen#Handle(), 
        $Box($fh$0x#0), 
        $Box($fh$0x#1))): DatatypeType);

implementation CheckWellformed$$JournalistImpl.Journalist.updateWrittenJournalLen(this: ref, len#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##x0#0: DatatypeType;
  var ##x1#0: int;
  var ##jm#0: DatatypeType;
  var ##len#0: int;

    // AddMethodImpl: updateWrittenJournalLen, CheckWellformed$$JournalistImpl.Journalist.updateWrittenJournalLen
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(193,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##x0#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##x0#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##x1#0 := len#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##x1#0, Tclass.NativeTypes.uint64(), $Heap);
    assume Requires2#canCall(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $Heap, 
      JournalistModel.__default.updateWrittenJournalLen#Handle(), 
      $Box(JournalistImpl.Journalist.I($Heap, this)), 
      $Box(len#0));
    assume Requires2(Tclass.JournalistModel.JournalistModel(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.JournalistModel.JournalistModel(), 
      $Heap, 
      JournalistModel.__default.updateWrittenJournalLen#Handle(), 
      $Box(JournalistImpl.Journalist.I($Heap, this)), 
      $Box(len#0));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(197,17): post-state"} true;
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assume Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
      read(old($Heap), this, JournalistImpl.Journalist.Repr));
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#0 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##len#0 := len#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##len#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assert {:subsumption 0} ##len#0
       <= JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(##jm#0));
    assume ##len#0
       <= JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(##jm#0));
    assume JournalistModel.__default.updateWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.updateWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.updateWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
}



procedure Call$$JournalistImpl.Journalist.updateWrittenJournalLen(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  requires Requires2(Tclass.JournalistModel.JournalistModel(), 
    Tclass.NativeTypes.uint64(), 
    Tclass.JournalistModel.JournalistModel(), 
    $Heap, 
    JournalistModel.__default.updateWrittenJournalLen#Handle(), 
    $Box(JournalistImpl.Journalist.I($Heap, this)), 
    $Box(len#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.updateWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.updateWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.updateWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.updateWrittenJournalLen(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 10 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  requires Requires2(Tclass.JournalistModel.JournalistModel(), 
    Tclass.NativeTypes.uint64(), 
    Tclass.JournalistModel.JournalistModel(), 
    $Heap, 
    JournalistModel.__default.updateWrittenJournalLen#Handle(), 
    $Box(JournalistImpl.Journalist.I($Heap, this)), 
    $Box(len#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.updateWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.updateWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.updateWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.updateWrittenJournalLen(this: ref, len#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;
  var ##jm#1: DatatypeType;
  var ##len#1: int;

    // AddMethodImpl: updateWrittenJournalLen, Impl$$JournalistImpl.Journalist.updateWrittenJournalLen
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(200,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(201,33)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.writtenJournalBlocks];
    assume true;
    $rhs#0 := len#0;
    $Heap := update($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(201,38)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(202,7)
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#1 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#1, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##len#1 := len#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##len#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.start(##jm#1)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.replayIdx(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                        i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                            i#2)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || (forall i#3: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                        i#3)): Seq Box } 
                  LitInt(0) <= i#3
                       && i#3
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                            i#3)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#1))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#1))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#1);
    assert {:subsumption 0} ##len#1
       <= JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(##jm#1));
    assume JournalistModel.__default.updateWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.updateWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
    assume $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
       && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.updateWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0))
       && 
      JournalistImpl.Journalist.I#canCall($Heap, this)
       && 
      JournalistImpl.Journalist.I#canCall(old($Heap), this)
       && JournalistModel.__default.updateWrittenJournalLen#canCall(JournalistImpl.Journalist.I(old($Heap), this), len#0);
    assert JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.updateWrittenJournalLen(JournalistImpl.Journalist.I(old($Heap), this), len#0));
}



procedure CheckWellformed$$JournalistImpl.Journalist.freeze(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  free requires 22 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.freeze(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: freeze, CheckWellformed$$JournalistImpl.Journalist.freeze
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(206,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(209,17): post-state"} true;
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assume Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
      read(old($Heap), this, JournalistImpl.Journalist.Repr));
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#0 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.freeze#canCall(JournalistImpl.Journalist.I(old($Heap), this));
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.freeze(StartFuel_JournalistModel._default.freeze, 
        JournalistImpl.Journalist.I(old($Heap), this)));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.freeze(StartFuel_JournalistModel._default.freeze, 
        JournalistImpl.Journalist.I(old($Heap), this)));
}



procedure Call$$JournalistImpl.Journalist.freeze(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.freeze(StartFuel_JournalistModel._default.freeze, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.freeze#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.freeze(StartFuelAssert_JournalistModel._default.freeze, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.freeze(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns ($_reverifyPost: bool);
  free requires 22 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.freeze(StartFuel_JournalistModel._default.freeze, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.freeze#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.freeze(StartFuelAssert_JournalistModel._default.freeze, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.freeze(this: ref) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;
  var newtype$check#0: int;
  var $rhs#1: int where LitInt(0) <= $rhs#1 && $rhs#1 < 18446744073709551616;
  var newtype$check#1: int;
  var $rhs#2: int where LitInt(0) <= $rhs#2 && $rhs#2 < 18446744073709551616;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var $rhs#3: int where LitInt(0) <= $rhs#3 && $rhs#3 < 18446744073709551616;
  var newtype$check#9: int;
  var ##jm#1: DatatypeType;

    // AddMethodImpl: freeze, Impl$$JournalistImpl.Journalist.freeze
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(212,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(213,36)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__freeze();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(213,37)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(215,17)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.len1];
    newtype$check#0 := read($Heap, this, JournalistImpl.Journalist.len1)
       + read($Heap, this, JournalistImpl.Journalist.len2);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    $rhs#0 := read($Heap, this, JournalistImpl.Journalist.len1)
       + read($Heap, this, JournalistImpl.Journalist.len2);
    $Heap := update($Heap, this, JournalistImpl.Journalist.len1, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(215,40)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(216,17)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.len2];
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    $rhs#1 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.len2, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(216,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(217,32)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.frozenJournalBlocks];
    newtype$check#2 := LitInt(4064);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := read($Heap, this, JournalistImpl.Journalist.inMemoryWeight) + 4064;
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := LitInt(1);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    newtype$check#5 := read($Heap, this, JournalistImpl.Journalist.inMemoryWeight) + 4064 - 1;
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    newtype$check#6 := LitInt(4064);
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assert LitInt(4064) != 0;
    newtype$check#7 := Div(read($Heap, this, JournalistImpl.Journalist.inMemoryWeight) + 4064 - 1, 
      LitInt(4064));
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    newtype$check#8 := read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks)
       + Div(read($Heap, this, JournalistImpl.Journalist.inMemoryWeight) + 4064 - 1, 
        LitInt(4064));
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    assume true;
    $rhs#2 := read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks)
       + Div(read($Heap, this, JournalistImpl.Journalist.inMemoryWeight) + 4064 - 1, 
        LitInt(4064));
    $Heap := update($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks, $rhs#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(218,51)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(219,27)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.inMemoryWeight];
    newtype$check#9 := LitInt(0);
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    assume true;
    $rhs#3 := LitInt(0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.inMemoryWeight, $rhs#3);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(219,30)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(221,7)
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#1 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#1, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.start(##jm#1)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.replayIdx(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                        i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                            i#2)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || (forall i#3: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                        i#3)): Seq Box } 
                  LitInt(0) <= i#3
                       && i#3
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                            i#3)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#1))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#1))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#1);
    assume JournalistModel.__default.freeze#canCall(JournalistImpl.Journalist.I(old($Heap), this));
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.freeze(StartFuel_JournalistModel._default.freeze, 
        JournalistImpl.Journalist.I(old($Heap), this)));
    assume $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
       && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.freeze(StartFuel_JournalistModel._default.freeze, 
          JournalistImpl.Journalist.I(old($Heap), this)))
       && 
      JournalistImpl.Journalist.I#canCall($Heap, this)
       && 
      JournalistImpl.Journalist.I#canCall(old($Heap), this)
       && JournalistModel.__default.freeze#canCall(JournalistImpl.Journalist.I(old($Heap), this));
    assert {:subsumption 0} JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.freeze(StartFuelAssert_JournalistModel._default.freeze, 
        JournalistImpl.Journalist.I(old($Heap), this)));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.freeze(StartFuel_JournalistModel._default.freeze, 
        JournalistImpl.Journalist.I(old($Heap), this)));
}



procedure CheckWellformed$$JournalistImpl.Journalist.canAppend(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    je#0: DatatypeType
       where $Is(je#0, Tclass.Journal.JournalEntry())
         && $IsAlloc(je#0, Tclass.Journal.JournalEntry(), $Heap)
         && $IsA#Journal.JournalEntry(je#0))
   returns (b#0: bool);
  free requires 12 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.canAppend(this: ref, je#0: DatatypeType) returns (b#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;
  var ##je#0: DatatypeType;

    // AddMethodImpl: canAppend, CheckWellformed$$JournalistImpl.Journalist.canAppend
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(224,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc b#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(227,14): post-state"} true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##je#0 := je#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##je#0, Tclass.Journal.JournalEntry(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.canAppend#canCall(JournalistImpl.Journalist.I($Heap, this), je#0);
    assume b#0
       == JournalistModel.__default.canAppend(StartFuel_JournalistModel._default.canAppend, 
        JournalistImpl.Journalist.I($Heap, this), 
        je#0);
}



procedure Call$$JournalistImpl.Journalist.canAppend(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    je#0: DatatypeType
       where $Is(je#0, Tclass.Journal.JournalEntry())
         && $IsAlloc(je#0, Tclass.Journal.JournalEntry(), $Heap)
         && $IsA#Journal.JournalEntry(je#0))
   returns (b#0: bool);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.canAppend#canCall(JournalistImpl.Journalist.I($Heap, this), je#0);
  ensures b#0
     == JournalistModel.__default.canAppend(StartFuelAssert_JournalistModel._default.canAppend, 
      JournalistImpl.Journalist.I($Heap, this), 
      je#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.canAppend(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    je#0: DatatypeType
       where $Is(je#0, Tclass.Journal.JournalEntry())
         && $IsAlloc(je#0, Tclass.Journal.JournalEntry(), $Heap)
         && $IsA#Journal.JournalEntry(je#0))
   returns (b#0: bool, $_reverifyPost: bool);
  free requires 12 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.canAppend#canCall(JournalistImpl.Journalist.I($Heap, this), je#0);
  ensures b#0
     == JournalistModel.__default.canAppend(StartFuelAssert_JournalistModel._default.canAppend, 
      JournalistImpl.Journalist.I($Heap, this), 
      je#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.canAppend(this: ref, je#0: DatatypeType) returns (b#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var ##s#0: DatatypeType;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;

    // AddMethodImpl: canAppend, Impl$$JournalistImpl.Journalist.canAppend
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(228,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(229,39)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__canAppend();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(229,40)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(231,9)
    assume true;
    newtype$check#0 := LitInt(4064);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks)
       + read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := Mul(LitInt(4064), 
      read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks)
         + read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks));
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := Mul(LitInt(4064), 
        read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks)
           + read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks))
       + read($Heap, this, JournalistImpl.Journalist.inMemoryWeight);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    ##s#0 := je#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, Tclass.Journal.JournalEntry(), $Heap);
    assume JournalRanges.__default.WeightJournalEntryUint64#canCall(je#0);
    newtype$check#4 := Mul(LitInt(4064), 
        read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks)
           + read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks))
       + read($Heap, this, JournalistImpl.Journalist.inMemoryWeight)
       + JournalRanges.__default.WeightJournalEntryUint64(je#0);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    newtype$check#5 := LitInt(0);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    if (read($Heap, this, JournalistImpl.Journalist.len2) == LitInt(0))
    {
        newtype$check#6 := LitInt(8);
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    }
    else
    {
        newtype$check#7 := LitInt(0);
        assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    }

    newtype$check#8 := Mul(LitInt(4064), 
        read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks)
           + read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks))
       + read($Heap, this, JournalistImpl.Journalist.inMemoryWeight)
       + JournalRanges.__default.WeightJournalEntryUint64(je#0)
       + (if read($Heap, this, JournalistImpl.Journalist.len2) == LitInt(0)
         then 8
         else 0);
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    newtype$check#9 := LitInt(4064);
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    assume DiskLayout.__default.NumJournalBlocks#canCall();
    newtype$check#10 := LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
    assume JournalRanges.__default.WeightJournalEntryUint64#canCall(je#0)
       && DiskLayout.__default.NumJournalBlocks#canCall();
    b#0 := Mul(LitInt(4064), 
          read($Heap, this, JournalistImpl.Journalist.writtenJournalBlocks)
             + read($Heap, this, JournalistImpl.Journalist.frozenJournalBlocks))
         + read($Heap, this, JournalistImpl.Journalist.inMemoryWeight)
         + JournalRanges.__default.WeightJournalEntryUint64(je#0)
         + (if read($Heap, this, JournalistImpl.Journalist.len2) == LitInt(0)
           then 8
           else 0)
       <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(235,36)"} true;
}



procedure CheckWellformed$$JournalistImpl.Journalist.append(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    je#0: DatatypeType
       where $Is(je#0, Tclass.Journal.JournalEntry())
         && $IsAlloc(je#0, Tclass.Journal.JournalEntry(), $Heap)
         && $IsA#Journal.JournalEntry(je#0));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.append(this: ref, je#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;
  var ##je#0: DatatypeType;
  var o#0: ref;
  var ##jm#1: DatatypeType;
  var ##je#1: DatatypeType;

    // AddMethodImpl: append, CheckWellformed$$JournalistImpl.Journalist.append
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(238,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##je#0 := je#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##je#0, Tclass.Journal.JournalEntry(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.canAppend#canCall(JournalistImpl.Journalist.I($Heap, this), je#0);
    assume JournalistModel.__default.canAppend(StartFuel_JournalistModel._default.canAppend, 
      JournalistImpl.Journalist.I($Heap, this), 
      je#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(242,12): post-state"} true;
    havoc o#0;
    assume $Is(o#0, Tclass._System.object());
    if (*)
    {
        assume read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(o#0)];
        if (*)
        {
            assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
            assume read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box(o#0)];
        }
        else
        {
            assume !read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box(o#0)];
            assume o#0 != null && !read(old($Heap), o#0, alloc);
        }
    }
    else
    {
        assume read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(o#0)]
           ==> read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box(o#0)]
             || (o#0 != null && !read(old($Heap), o#0, alloc));
    }

    assume (forall o#1: ref :: 
      { read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box(o#1)] } 
        { read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(o#1)] } 
      $Is(o#1, Tclass._System.object())
           && read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(o#1)]
         ==> read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box(o#1)]
           || (o#1 != null && !read(old($Heap), o#1, alloc)));
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#1 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#1, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##je#1 := je#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##je#1, Tclass.Journal.JournalEntry(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.start(##jm#1)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.replayIdx(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                        i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                            i#2)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || (forall i#3: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                        i#3)): Seq Box } 
                  LitInt(0) <= i#3
                       && i#3
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                            i#3)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#1))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#1))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#1);
    assume JournalistModel.__default.Inv(##jm#1);
    assert {:subsumption 0} JournalistModel.__default.canAppend(StartFuelAssert_JournalistModel._default.canAppend, ##jm#1, ##je#1);
    assume JournalistModel.__default.canAppend(StartFuel_JournalistModel._default.canAppend, ##jm#1, ##je#1);
    assume JournalistModel.__default.append#canCall(JournalistImpl.Journalist.I(old($Heap), this), je#0);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.append(StartFuel_JournalistModel._default.append, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        je#0));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.append(StartFuel_JournalistModel._default.append, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        je#0));
}



procedure Call$$JournalistImpl.Journalist.append(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    je#0: DatatypeType
       where $Is(je#0, Tclass.Journal.JournalEntry())
         && $IsAlloc(je#0, Tclass.Journal.JournalEntry(), $Heap)
         && $IsA#Journal.JournalEntry(je#0));
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  requires JournalistModel.__default.canAppend(StartFuelAssert_JournalistModel._default.canAppend, 
    JournalistImpl.Journalist.I($Heap, this), 
    je#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box(o#1)] } 
      { read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(o#1)]
       ==> read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box(o#1)]
         || (o#1 != null && !read(old($Heap), o#1, alloc)));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.append(StartFuel_JournalistModel._default.append, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        je#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.append#canCall(JournalistImpl.Journalist.I(old($Heap), this), je#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.append(StartFuelAssert_JournalistModel._default.append, 
      JournalistImpl.Journalist.I(old($Heap), this), 
      je#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.append(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    je#0: DatatypeType
       where $Is(je#0, Tclass.Journal.JournalEntry())
         && $IsAlloc(je#0, Tclass.Journal.JournalEntry(), $Heap)
         && $IsA#Journal.JournalEntry(je#0))
   returns ($_reverifyPost: bool);
  free requires 13 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  requires JournalistModel.__default.canAppend(StartFuelAssert_JournalistModel._default.canAppend, 
    JournalistImpl.Journalist.I($Heap, this), 
    je#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box(o#1)] } 
      { read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, JournalistImpl.Journalist.Repr)[$Box(o#1)]
       ==> read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box(o#1)]
         || (o#1 != null && !read(old($Heap), o#1, alloc)));
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.append(StartFuel_JournalistModel._default.append, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        je#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.append#canCall(JournalistImpl.Journalist.I(old($Heap), this), je#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.append(StartFuelAssert_JournalistModel._default.append, 
      JournalistImpl.Journalist.I(old($Heap), this), 
      je#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.append(this: ref, je#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var idx#0_0: int where LitInt(0) <= idx#0_0 && idx#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var ##x#0_0: int;
  var ##len#0_0: int;
  var $rhs#0_0: DatatypeType where $Is($rhs#0_0, Tclass.Journal.JournalEntry());
  var newLen#0: int where LitInt(0) <= newLen#0 && newLen#0 < 18446744073709551616;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newArray#0: ref
     where $Is(newArray#0, Tclass._System.array?(Tclass.Journal.JournalEntry()))
       && $IsAlloc(newArray#0, Tclass._System.array?(Tclass.Journal.JournalEntry()), $Heap);
  var $rhs##0: ref
     where $Is($rhs##0, Tclass._System.array(Tclass.Journal.JournalEntry()))
       && $IsAlloc($rhs##0, Tclass._System.array(Tclass.Journal.JournalEntry()), $Heap);
  var n##0: int;
  var t##0: Box;
  var src##0: ref;
  var srcIndex##0: int;
  var dst##0: ref;
  var dstIndex##0: int;
  var newtype$check#5: int;
  var len##0: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var src##1: ref;
  var srcIndex##1: int;
  var newtype$check#8: int;
  var dst##1: ref;
  var dstIndex##1: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var len##1: int;
  var newtype$check#11: int;
  var $rhs#0: DatatypeType where $Is($rhs#0, Tclass.Journal.JournalEntry());
  var ##n#1_0_0: int;
  var ##t#1_0_0: DatatypeType;
  var $rhs#1: ref
     where $Is($rhs#1, Tclass._System.array(Tclass.Journal.JournalEntry()));
  var $rhs#2: int where LitInt(0) <= $rhs#2 && $rhs#2 < 18446744073709551616;
  var newtype$check#12: int;
  var $rhs#3: int where LitInt(0) <= $rhs#3 && $rhs#3 < 18446744073709551616;
  var ##s#0: DatatypeType;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var $rhs#4: int where LitInt(0) <= $rhs#4 && $rhs#4 < 18446744073709551616;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var $rhs#5: Set Box where $Is($rhs#5, TSet(Tclass._System.object()));
  var ##jm#2: DatatypeType;
  var ##je#2: DatatypeType;

    // AddMethodImpl: append, Impl$$JournalistImpl.Journalist.append
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(245,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(246,36)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__append();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(246,37)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(248,7)
    newtype$check#0 := read($Heap, this, JournalistImpl.Journalist.len1)
       + read($Heap, this, JournalistImpl.Journalist.len2);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
    newtype$check#1 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    if (read($Heap, this, JournalistImpl.Journalist.len1)
         + read($Heap, this, JournalistImpl.Journalist.len2)
       < _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(249,17)
        assume true;
        newtype$check#0_0 := read($Heap, this, JournalistImpl.Journalist.start)
           + read($Heap, this, JournalistImpl.Journalist.len1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := read($Heap, this, JournalistImpl.Journalist.start)
           + read($Heap, this, JournalistImpl.Journalist.len1)
           + read($Heap, this, JournalistImpl.Journalist.len2);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
        newtype$check#0_2 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        ##x#0_0 := read($Heap, this, JournalistImpl.Journalist.start)
           + read($Heap, this, JournalistImpl.Journalist.len1)
           + read($Heap, this, JournalistImpl.Journalist.len2);
        // assume allocatedness for argument to function
        assume $IsAlloc(##x#0_0, Tclass.NativeTypes.uint64(), $Heap);
        ##len#0_0 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
        // assume allocatedness for argument to function
        assume $IsAlloc(##len#0_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} ##len#0_0
           <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())));
        assume ##len#0_0
           <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())));
        assume JournalistModel.__default.basic__mod#canCall(read($Heap, this, JournalistImpl.Journalist.start)
             + read($Heap, this, JournalistImpl.Journalist.len1)
             + read($Heap, this, JournalistImpl.Journalist.len2), 
          _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)));
        assume JournalistModel.__default.basic__mod#canCall(read($Heap, this, JournalistImpl.Journalist.start)
             + read($Heap, this, JournalistImpl.Journalist.len1)
             + read($Heap, this, JournalistImpl.Journalist.len2), 
          _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)));
        idx#0_0 := JournalistModel.__default.basic__mod(read($Heap, this, JournalistImpl.Journalist.start)
             + read($Heap, this, JournalistImpl.Journalist.len1)
             + read($Heap, this, JournalistImpl.Journalist.len2), 
          _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(251,49)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(252,34)
        assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
        assert 0 <= idx#0_0
           && idx#0_0
             < _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
        assume true;
        assert $_Frame[read($Heap, this, JournalistImpl.Journalist.journalEntries), IndexField(idx#0_0)];
        assume true;
        $rhs#0_0 := je#0;
        $Heap := update($Heap, 
          read($Heap, this, JournalistImpl.Journalist.journalEntries), 
          IndexField(idx#0_0), 
          $Box($rhs#0_0));
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(252,38)"} true;
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(254,28)
        assume true;
        assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
        newtype$check#2 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        newtype$check#3 := LitInt(2);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        newtype$check#4 := Mul(_System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)), 
          LitInt(2));
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        assume true;
        newLen#0 := Mul(_System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)), 
          LitInt(2));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(254,70)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(255,50)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type array?<JournalEntry>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        n##0 := newLen#0;
        assert $Is(Lit(Seq#Empty(): Seq Box), Tclass.KeyType.Key());
        assert $Is(Lit(Seq#Empty(): Seq Box), Tclass.ValueType.Value());
        assume true;
        // ProcessCallStmt: CheckSubrange
        t##0 := $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box))));
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0 := Call$$NativeArrays.__default.newArrayFill(Tclass.Journal.JournalEntry(), n##0, t##0);
        // TrCallStmt: After ProcessCallStmt
        newArray#0 := $rhs##0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(257,34)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(258,49)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        src##0 := read($Heap, this, JournalistImpl.Journalist.journalEntries);
        assume true;
        // ProcessCallStmt: CheckSubrange
        srcIndex##0 := read($Heap, this, JournalistImpl.Journalist.start);
        assume true;
        // ProcessCallStmt: CheckSubrange
        assert $Is(newArray#0, Tclass._System.array(Tclass.Journal.JournalEntry()));
        dst##0 := newArray#0;
        newtype$check#5 := LitInt(0);
        assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        dstIndex##0 := LitInt(0);
        assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
        newtype$check#6 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
        newtype$check#7 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
           - read($Heap, this, JournalistImpl.Journalist.start);
        assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        len##0 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
           - read($Heap, this, JournalistImpl.Journalist.start);
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) && $o == dst##0 ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$NativeArrays.__default.CopyArrayIntoDifferentArray(Tclass.Journal.JournalEntry(), src##0, srcIndex##0, dst##0, dstIndex##0, len##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(263,62)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(264,49)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        src##1 := read($Heap, this, JournalistImpl.Journalist.journalEntries);
        newtype$check#8 := LitInt(0);
        assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        srcIndex##1 := LitInt(0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        assert $Is(newArray#0, Tclass._System.array(Tclass.Journal.JournalEntry()));
        dst##1 := newArray#0;
        assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
        newtype$check#9 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
        assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
        newtype$check#10 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
           - read($Heap, this, JournalistImpl.Journalist.start);
        assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        dstIndex##1 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
           - read($Heap, this, JournalistImpl.Journalist.start);
        assume true;
        // ProcessCallStmt: CheckSubrange
        len##1 := read($Heap, this, JournalistImpl.Journalist.start);
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) && $o == dst##1 ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$NativeArrays.__default.CopyArrayIntoDifferentArray(Tclass.Journal.JournalEntry(), src##1, srcIndex##1, dst##1, dstIndex##1, len##1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(269,23)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(270,56)
        assert newArray#0 != null;
        assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
        newtype$check#11 := _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
        assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
        assert 0
             <= _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
           && _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
             < _System.array.Length(newArray#0);
        assume true;
        assert $_Frame[newArray#0, IndexField(_System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries)))];
        assume true;
        $rhs#0 := je#0;
        $Heap := update($Heap, 
          newArray#0, 
          IndexField(_System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))), 
          $Box($rhs#0));
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(270,60)"} true;
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(272,9)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(272,9)
            assert newArray#0 != null;
            assume true;
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(272,9)
            assume newArray#0 != null;
            assume true;
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(272,9)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(272,9)
            assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
            assert {:subsumption 0} 0 <= read($Heap, this, JournalistImpl.Journalist.start)
               && read($Heap, this, JournalistImpl.Journalist.start)
                 <= _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
            assert read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
            assert {:subsumption 0} 0 <= read($Heap, this, JournalistImpl.Journalist.start)
               && read($Heap, this, JournalistImpl.Journalist.start)
                 <= _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries));
            assert {:subsumption 0} read($Heap, this, JournalistImpl.Journalist.journalEntries) != null;
            assert $Is(Lit(Seq#Empty(): Seq Box), Tclass.KeyType.Key());
            assert $Is(Lit(Seq#Empty(): Seq Box), Tclass.ValueType.Value());
            ##n#1_0_0 := newLen#0
               - _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
               - 1;
            // assume allocatedness for argument to function
            assume $IsAlloc(##n#1_0_0, TInt, $Heap);
            ##t#1_0_0 := Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#1_0_0, Tclass.Journal.JournalEntry(), $Heap);
            assert {:subsumption 0} ##n#1_0_0 >= LitInt(0);
            assume Sequences.__default.fill#canCall(Tclass.Journal.JournalEntry(), 
              newLen#0
                 - _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
                 - 1, 
              $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))));
            assume Sequences.__default.fill#canCall(Tclass.Journal.JournalEntry(), 
              newLen#0
                 - _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
                 - 1, 
              $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))));
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(272,9)
            assert {:subsumption 0} Seq#Equal(Seq#FromArray($Heap, newArray#0), 
              Seq#Append(Seq#Append(Seq#Append(Seq#Drop(Seq#FromArray($Heap, read($Heap, this, JournalistImpl.Journalist.journalEntries)), 
                      read($Heap, this, JournalistImpl.Journalist.start)), 
                    Seq#Take(Seq#FromArray($Heap, read($Heap, this, JournalistImpl.Journalist.journalEntries)), 
                      read($Heap, this, JournalistImpl.Journalist.start))), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(je#0))), 
                Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
                  StartFuelAssert_Sequences._default.fill, 
                  newLen#0
                     - _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
                     - 1, 
                  $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))));
            assume false;
        }

        assume Seq#Equal(Seq#FromArray($Heap, newArray#0), 
          Seq#Append(Seq#Append(Seq#Append(Seq#Drop(Seq#FromArray($Heap, read($Heap, this, JournalistImpl.Journalist.journalEntries)), 
                  read($Heap, this, JournalistImpl.Journalist.start)), 
                Seq#Take(Seq#FromArray($Heap, read($Heap, this, JournalistImpl.Journalist.journalEntries)), 
                  read($Heap, this, JournalistImpl.Journalist.start))), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(je#0))), 
            Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
              StartFuel_Sequences._default.fill, 
              newLen#0
                 - _System.array.Length(read($Heap, this, JournalistImpl.Journalist.journalEntries))
                 - 1, 
              $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))));
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(280,29)
        assume true;
        assert $_Frame[this, JournalistImpl.Journalist.journalEntries];
        assume true;
        assert $Is(newArray#0, Tclass._System.array(Tclass.Journal.JournalEntry()));
        $rhs#1 := newArray#0;
        $Heap := update($Heap, this, JournalistImpl.Journalist.journalEntries, $rhs#1);
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(280,39)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(281,20)
        assume true;
        assert $_Frame[this, JournalistImpl.Journalist.start];
        newtype$check#12 := LitInt(0);
        assert LitInt(0) <= newtype$check#12 && newtype$check#12 < 18446744073709551616;
        assume true;
        $rhs#2 := LitInt(0);
        $Heap := update($Heap, this, JournalistImpl.Journalist.start, $rhs#2);
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(281,23)"} true;
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(284,27)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.inMemoryWeight];
    ##s#0 := je#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, Tclass.Journal.JournalEntry(), $Heap);
    assume JournalRanges.__default.WeightJournalEntryUint64#canCall(je#0);
    newtype$check#13 := read($Heap, this, JournalistImpl.Journalist.inMemoryWeight)
       + JournalRanges.__default.WeightJournalEntryUint64(je#0);
    assert LitInt(0) <= newtype$check#13 && newtype$check#13 < 18446744073709551616;
    newtype$check#14 := LitInt(0);
    assert LitInt(0) <= newtype$check#14 && newtype$check#14 < 18446744073709551616;
    if (read($Heap, this, JournalistImpl.Journalist.len2) == LitInt(0))
    {
        newtype$check#15 := LitInt(8);
        assert LitInt(0) <= newtype$check#15 && newtype$check#15 < 18446744073709551616;
    }
    else
    {
        newtype$check#16 := LitInt(0);
        assert LitInt(0) <= newtype$check#16 && newtype$check#16 < 18446744073709551616;
    }

    newtype$check#17 := read($Heap, this, JournalistImpl.Journalist.inMemoryWeight)
       + JournalRanges.__default.WeightJournalEntryUint64(je#0)
       + (if read($Heap, this, JournalistImpl.Journalist.len2) == LitInt(0)
         then 8
         else 0);
    assert LitInt(0) <= newtype$check#17 && newtype$check#17 < 18446744073709551616;
    assume JournalRanges.__default.WeightJournalEntryUint64#canCall(je#0);
    $rhs#3 := read($Heap, this, JournalistImpl.Journalist.inMemoryWeight)
       + JournalRanges.__default.WeightJournalEntryUint64(je#0)
       + (if read($Heap, this, JournalistImpl.Journalist.len2) == LitInt(0)
         then 8
         else 0);
    $Heap := update($Heap, this, JournalistImpl.Journalist.inMemoryWeight, $rhs#3);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(286,45)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(287,17)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.len2];
    newtype$check#18 := LitInt(1);
    assert LitInt(0) <= newtype$check#18 && newtype$check#18 < 18446744073709551616;
    newtype$check#19 := read($Heap, this, JournalistImpl.Journalist.len2) + 1;
    assert LitInt(0) <= newtype$check#19 && newtype$check#19 < 18446744073709551616;
    assume true;
    $rhs#4 := read($Heap, this, JournalistImpl.Journalist.len2) + 1;
    $Heap := update($Heap, this, JournalistImpl.Journalist.len2, $rhs#4);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(287,32)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(289,12)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.Repr];
    assume true;
    $rhs#5 := Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)));
    $Heap := update($Heap, this, JournalistImpl.Journalist.Repr, $rhs#5);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(289,41)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(292,7)
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#2 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#2, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##je#2 := je#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##je#2, Tclass.Journal.JournalEntry(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#2)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#2))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#2));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || JournalistModel.JournalistModel.start(##jm#2)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#2)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#2));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || JournalistModel.JournalistModel.len1(##jm#2)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#2)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#2));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || JournalistModel.JournalistModel.len2(##jm#2)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#2)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#2)
                 + JournalistModel.JournalistModel.len2(##jm#2));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || JournalistModel.JournalistModel.len1(##jm#2)
                 + JournalistModel.JournalistModel.len2(##jm#2)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#2)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#2));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || JournalistModel.JournalistModel.replayIdx(##jm#2)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#2)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#2))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#2))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#2))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#2))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#2))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#2))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#2))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#2))): Seq Box)
                 || (forall i#4: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#2))): Seq Box, 
                        i#4)): Seq Box } 
                  LitInt(0) <= i#4
                       && i#4
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#2))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#2))): Seq Box, 
                            i#4)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#2))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#2))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#2))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#2))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#2))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#2))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#2))): Seq Box)
                 || (forall i#5: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#2))): Seq Box, 
                        i#5)): Seq Box } 
                  LitInt(0) <= i#5
                       && i#5
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#2))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#2))): Seq Box, 
                            i#5)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#2));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#2)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#2));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#2)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#2));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || (JournalistModel.__default.WF#canCall(##jm#2)
           ==> JournalistModel.__default.WF(##jm#2)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#2)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#2)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#2), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#2)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#2))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#2), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#2)
       ==> JournalistModel.__default.Inv(##jm#2)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#2))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#2);
    assert {:subsumption 0} JournalistModel.__default.canAppend(StartFuelAssert_JournalistModel._default.canAppend, ##jm#2, ##je#2);
    assume JournalistModel.__default.append#canCall(JournalistImpl.Journalist.I(old($Heap), this), je#0);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.append(StartFuel_JournalistModel._default.append, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        je#0));
    assume $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
       && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.append(StartFuel_JournalistModel._default.append, 
          JournalistImpl.Journalist.I(old($Heap), this), 
          je#0))
       && 
      JournalistImpl.Journalist.I#canCall($Heap, this)
       && 
      JournalistImpl.Journalist.I#canCall(old($Heap), this)
       && JournalistModel.__default.append#canCall(JournalistImpl.Journalist.I(old($Heap), this), je#0);
    assert {:subsumption 0} JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.append(StartFuelAssert_JournalistModel._default.append, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        je#0));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.append(StartFuel_JournalistModel._default.append, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        je#0));
}



procedure CheckWellformed$$JournalistImpl.Journalist.isReplayEmpty(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  free requires 23 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.isReplayEmpty(this: ref) returns (b#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: isReplayEmpty, CheckWellformed$$JournalistImpl.Journalist.isReplayEmpty
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(295,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc b#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(298,14): post-state"} true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.isReplayEmpty#canCall(JournalistImpl.Journalist.I($Heap, this));
    assume b#0
       == JournalistModel.__default.isReplayEmpty(StartFuel_JournalistModel._default.isReplayEmpty, 
        JournalistImpl.Journalist.I($Heap, this));
}



procedure Call$$JournalistImpl.Journalist.isReplayEmpty(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.isReplayEmpty#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.isReplayEmpty(StartFuelAssert_JournalistModel._default.isReplayEmpty, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.isReplayEmpty(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool, $_reverifyPost: bool);
  free requires 23 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.isReplayEmpty#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.isReplayEmpty(StartFuelAssert_JournalistModel._default.isReplayEmpty, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.isReplayEmpty(this: ref) returns (b#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;

    // AddMethodImpl: isReplayEmpty, Impl$$JournalistImpl.Journalist.isReplayEmpty
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(299,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(300,43)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__isReplayEmpty();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(300,44)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(301,9)
    assume true;
    newtype$check#0 := Seq#Length(read($Heap, this, JournalistImpl.Journalist.replayJournal));
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    b#0 := read($Heap, this, JournalistImpl.Journalist.replayIdx)
       == Seq#Length(read($Heap, this, JournalistImpl.Journalist.replayJournal));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(301,51)"} true;
}



procedure CheckWellformed$$JournalistImpl.Journalist.replayJournalTop(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (je#0: DatatypeType
       where $Is(je#0, Tclass.Journal.JournalEntry())
         && $IsAlloc(je#0, Tclass.Journal.JournalEntry(), $Heap));
  free requires 14 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.replayJournalTop(this: ref) returns (je#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;
  var ##jm#1: DatatypeType;

    // AddMethodImpl: replayJournalTop, CheckWellformed$$JournalistImpl.Journalist.replayJournalTop
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(304,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
           <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.start(##jm#0)
           < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.len1(##jm#0)
           <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.len2(##jm#0)
           <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0)
           <= JournalistModel.JournalistModel.len1(##jm#0)
             + JournalistModel.JournalistModel.len2(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.len1(##jm#0)
             + JournalistModel.JournalistModel.len2(##jm#0)
           <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.replayIdx(##jm#0)
           <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
           <= LitInt(JournalistModel.__default.MaxPossibleEntries());
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
           ==> 
          JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
           ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
             || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
           ==> 
          JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
           ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
             || (forall i#0: int :: 
              { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                    i#0)): Seq Box } 
              LitInt(0) <= i#0
                   && i#0
                     < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box)
                   == LitInt(4064)));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
           ==> 
          JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
           ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
             || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
           ==> 
          JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
           ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
             || (forall i#1: int :: 
              { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                    i#1)): Seq Box } 
              LitInt(0) <= i#1
                   && i#1
                     < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box)
                   == LitInt(4064)));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
           <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
           <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));
    assume JournalistModel.__default.WF(##jm#0);
    assume JournalistModel.__default.I#canCall(JournalistImpl.Journalist.I($Heap, this));
    assume JournalistModel.JournalInfo.JournalInfo_q(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this)));
    assume JournalistModel.JournalInfo.JournalInfo_q(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this)));
    assume !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this))), 
      Seq#Empty(): Seq Box);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc je#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(308,15): post-state"} true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#1 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#1, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.start(##jm#1)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.replayIdx(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                        i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                            i#2)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || (forall i#3: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                        i#3)): Seq Box } 
                  LitInt(0) <= i#3
                       && i#3
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                            i#3)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#1))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#1))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#1);
    assume JournalistModel.__default.Inv(##jm#1);
    assert {:subsumption 0} !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(##jm#1)), 
      Seq#Empty(): Seq Box);
    assume !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(##jm#1)), 
      Seq#Empty(): Seq Box);
    assume JournalistModel.__default.replayJournalTop#canCall(JournalistImpl.Journalist.I($Heap, this));
    assume Journal.JournalEntry.JournalInsert_q(JournalistModel.__default.replayJournalTop(StartFuel_JournalistModel._default.replayJournalTop, 
        JournalistImpl.Journalist.I($Heap, this)));
    assume Journal.JournalEntry#Equal(je#0, 
      JournalistModel.__default.replayJournalTop(StartFuel_JournalistModel._default.replayJournalTop, 
        JournalistImpl.Journalist.I($Heap, this)));
}



procedure Call$$JournalistImpl.Journalist.replayJournalTop(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (je#0: DatatypeType
       where $Is(je#0, Tclass.Journal.JournalEntry())
         && $IsAlloc(je#0, Tclass.Journal.JournalEntry(), $Heap));
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  requires !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this))), 
    Seq#Empty(): Seq Box);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Journal.JournalEntry(je#0)
     && $IsA#Journal.JournalEntry(JournalistModel.__default.replayJournalTop(StartFuel_JournalistModel._default.replayJournalTop, 
        JournalistImpl.Journalist.I($Heap, this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.replayJournalTop#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures Journal.JournalEntry#Equal(je#0, 
    JournalistModel.__default.replayJournalTop(StartFuelAssert_JournalistModel._default.replayJournalTop, 
      JournalistImpl.Journalist.I($Heap, this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.replayJournalTop(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (je#0: DatatypeType
       where $Is(je#0, Tclass.Journal.JournalEntry())
         && $IsAlloc(je#0, Tclass.Journal.JournalEntry(), $Heap), 
    $_reverifyPost: bool);
  free requires 14 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  requires !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this))), 
    Seq#Empty(): Seq Box);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Journal.JournalEntry(je#0)
     && $IsA#Journal.JournalEntry(JournalistModel.__default.replayJournalTop(StartFuel_JournalistModel._default.replayJournalTop, 
        JournalistImpl.Journalist.I($Heap, this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.replayJournalTop#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures Journal.JournalEntry#Equal(je#0, 
    JournalistModel.__default.replayJournalTop(StartFuelAssert_JournalistModel._default.replayJournalTop, 
      JournalistImpl.Journalist.I($Heap, this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.replayJournalTop(this: ref) returns (je#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var jm##0: DatatypeType;

    // AddMethodImpl: replayJournalTop, Impl$$JournalistImpl.Journalist.replayJournalTop
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(309,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(310,46)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__replayJournalTop();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(310,47)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(311,31)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    // ProcessCallStmt: CheckSubrange
    jm##0 := JournalistImpl.Journalist.I($Heap, this);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__I(jm##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(311,35)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(312,10)
    assume true;
    assert 0 <= read($Heap, this, JournalistImpl.Journalist.replayIdx)
       && read($Heap, this, JournalistImpl.Journalist.replayIdx)
         < Seq#Length(read($Heap, this, JournalistImpl.Journalist.replayJournal));
    assume true;
    je#0 := $Unbox(Seq#Index(read($Heap, this, JournalistImpl.Journalist.replayJournal), 
        read($Heap, this, JournalistImpl.Journalist.replayIdx))): DatatypeType;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(312,36)"} true;
}



procedure CheckWellformed$$JournalistImpl.Journalist.replayJournalPop(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  free requires 24 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.replayJournalPop(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;
  var ##jm#1: DatatypeType;

    // AddMethodImpl: replayJournalPop, CheckWellformed$$JournalistImpl.Journalist.replayJournalPop
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(315,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
           <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.start(##jm#0)
           < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.len1(##jm#0)
           <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.len2(##jm#0)
           <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0)
           <= JournalistModel.JournalistModel.len1(##jm#0)
             + JournalistModel.JournalistModel.len2(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.len1(##jm#0)
             + JournalistModel.JournalistModel.len2(##jm#0)
           <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.replayIdx(##jm#0)
           <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
           <= LitInt(JournalistModel.__default.MaxPossibleEntries());
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
           ==> 
          JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
           ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
             || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
           ==> 
          JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
           ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
             || (forall i#0: int :: 
              { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                    i#0)): Seq Box } 
              LitInt(0) <= i#0
                   && i#0
                     < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box)
                   == LitInt(4064)));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
           ==> 
          JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
           ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
             || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
           ==> 
          JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
           ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
             || (forall i#1: int :: 
              { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                    i#1)): Seq Box } 
              LitInt(0) <= i#1
                   && i#1
                     < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box)
                   == LitInt(4064)));
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
           <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
           <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assert {:subsumption 0} JournalistModel.__default.WF#canCall(##jm#0)
       ==> JournalistModel.__default.WF(##jm#0)
         || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));
    assume JournalistModel.__default.WF(##jm#0);
    assume JournalistModel.__default.I#canCall(JournalistImpl.Journalist.I($Heap, this));
    assume JournalistModel.JournalInfo.JournalInfo_q(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this)));
    assume JournalistModel.JournalInfo.JournalInfo_q(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this)));
    assume !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this))), 
      Seq#Empty(): Seq Box);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(319,15): post-state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assume Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
      read(old($Heap), this, JournalistImpl.Journalist.Repr));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#1 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#1, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.start(##jm#1)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.len1(##jm#1)
                 + JournalistModel.JournalistModel.len2(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.replayIdx(##jm#1)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#1))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                        i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#1))): Seq Box, 
                            i#2)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#1))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                 || (forall i#3: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                        i#3)): Seq Box } 
                  LitInt(0) <= i#3
                       && i#3
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#1))): Seq Box, 
                            i#3)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#1));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || (JournalistModel.__default.WF#canCall(##jm#1)
           ==> JournalistModel.__default.WF(##jm#1)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#1)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#1)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#1))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#1), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#1)
       ==> JournalistModel.__default.Inv(##jm#1)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#1))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#1);
    assume JournalistModel.__default.Inv(##jm#1);
    assert {:subsumption 0} !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(##jm#1)), 
      Seq#Empty(): Seq Box);
    assume !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(##jm#1)), 
      Seq#Empty(): Seq Box);
    assume JournalistModel.__default.replayJournalPop#canCall(JournalistImpl.Journalist.I(old($Heap), this));
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.replayJournalPop(StartFuel_JournalistModel._default.replayJournalPop, 
        JournalistImpl.Journalist.I(old($Heap), this)));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.replayJournalPop(StartFuel_JournalistModel._default.replayJournalPop, 
        JournalistImpl.Journalist.I(old($Heap), this)));
}



procedure Call$$JournalistImpl.Journalist.replayJournalPop(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap));
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  requires !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this))), 
    Seq#Empty(): Seq Box);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.replayJournalPop(StartFuel_JournalistModel._default.replayJournalPop, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.replayJournalPop#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.replayJournalPop(StartFuelAssert_JournalistModel._default.replayJournalPop, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.replayJournalPop(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns ($_reverifyPost: bool);
  free requires 24 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  requires !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(JournalistImpl.Journalist.I($Heap, this))), 
    Seq#Empty(): Seq Box);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.replayJournalPop(StartFuel_JournalistModel._default.replayJournalPop, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.replayJournalPop#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.replayJournalPop(StartFuelAssert_JournalistModel._default.replayJournalPop, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.replayJournalPop(this: ref) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var jm##0: DatatypeType;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;
  var newtype$check#0: int;
  var newtype$check#1: int;

    // AddMethodImpl: replayJournalPop, Impl$$JournalistImpl.Journalist.replayJournalPop
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(322,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(323,46)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__replayJournalPop();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(323,47)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(324,31)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    // ProcessCallStmt: CheckSubrange
    jm##0 := JournalistImpl.Journalist.I($Heap, this);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__I(jm##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(324,35)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(325,17)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.replayIdx];
    newtype$check#0 := LitInt(1);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := read($Heap, this, JournalistImpl.Journalist.replayIdx) + 1;
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    $rhs#0 := read($Heap, this, JournalistImpl.Journalist.replayIdx) + 1;
    $Heap := update($Heap, this, JournalistImpl.Journalist.replayIdx, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(325,32)"} true;
}



procedure CheckWellformed$$JournalistImpl.Journalist.setFront(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 16 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.setFront(this: ref, jr#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#0: int;
  var ##jm#0: DatatypeType;
  var ##jr#0: Seq Box;

    // AddMethodImpl: setFront, CheckWellformed$$JournalistImpl.Journalist.setFront
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(328,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc i#0;
    if (*)
    {
        assume LitInt(0) <= i#0;
        assume i#0 < Seq#Length(jr#0);
        assert 0 <= i#0 && i#0 < Seq#Length(jr#0);
        assume Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064);
    }
    else
    {
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(jr#0)
           ==> Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064);
    }

    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
         ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064));
    assume DiskLayout.__default.NumJournalBlocks#canCall();
    assume Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(333,15): post-state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assume Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
      read(old($Heap), this, JournalistImpl.Journalist.Repr));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#0 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##jr#0 := jr#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#2)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#3: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#3)): Seq Box } 
                  LitInt(0) <= i#3
                       && i#3
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#3)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assert {:subsumption 0} (forall i#4: int :: 
      { $Unbox(Seq#Index(##jr#0, i#4)): Seq Box } 
      LitInt(0) <= i#4 && i#4 < Seq#Length(##jr#0)
         ==> Seq#Length($Unbox(Seq#Index(##jr#0, i#4)): Seq Box) == LitInt(4064));
    assume (forall i#4: int :: 
      { $Unbox(Seq#Index(##jr#0, i#4)): Seq Box } 
      LitInt(0) <= i#4 && i#4 < Seq#Length(##jr#0)
         ==> Seq#Length($Unbox(Seq#Index(##jr#0, i#4)): Seq Box) == LitInt(4064));
    assert {:subsumption 0} Seq#Length(##jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assume Seq#Length(##jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assume JournalistModel.__default.setFront#canCall(JournalistImpl.Journalist.I(old($Heap), this), jr#0);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.setFront(StartFuel_JournalistModel._default.setFront, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        jr#0));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.setFront(StartFuel_JournalistModel._default.setFront, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        jr#0));
}



procedure Call$$JournalistImpl.Journalist.setFront(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
       ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064));
  requires Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.setFront(StartFuel_JournalistModel._default.setFront, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        jr#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.setFront#canCall(JournalistImpl.Journalist.I(old($Heap), this), jr#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.setFront(StartFuelAssert_JournalistModel._default.setFront, 
      JournalistImpl.Journalist.I(old($Heap), this), 
      jr#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.setFront(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns ($_reverifyPost: bool);
  free requires 16 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
       ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064));
  requires Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.setFront(StartFuel_JournalistModel._default.setFront, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        jr#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.setFront#canCall(JournalistImpl.Journalist.I(old($Heap), this), jr#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.setFront(StartFuelAssert_JournalistModel._default.setFront, 
      JournalistImpl.Journalist.I(old($Heap), this), 
      jr#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.setFront(this: ref, jr#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs#0: DatatypeType
     where $Is($rhs#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))));

    // AddMethodImpl: setFront, Impl$$JournalistImpl.Journalist.setFront
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(336,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(337,38)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__setFront();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(337,39)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(338,20)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.journalFront];
    assume true;
    $rhs#0 := #Options.Option.Some($Box(jr#0));
    $Heap := update($Heap, this, JournalistImpl.Journalist.journalFront, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(338,30)"} true;
}



procedure CheckWellformed$$JournalistImpl.Journalist.setBack(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.setBack(this: ref, jr#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#0: int;
  var ##jm#0: DatatypeType;
  var ##jr#0: Seq Box;

    // AddMethodImpl: setBack, CheckWellformed$$JournalistImpl.Journalist.setBack
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(341,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc i#0;
    if (*)
    {
        assume LitInt(0) <= i#0;
        assume i#0 < Seq#Length(jr#0);
        assert 0 <= i#0 && i#0 < Seq#Length(jr#0);
        assume Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064);
    }
    else
    {
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(jr#0)
           ==> Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064);
    }

    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
         ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064));
    assume DiskLayout.__default.NumJournalBlocks#canCall();
    assume Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(346,15): post-state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assume Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
      read(old($Heap), this, JournalistImpl.Journalist.Repr));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#0 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    ##jr#0 := jr#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#2: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#2)): Seq Box } 
                  LitInt(0) <= i#2
                       && i#2
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#2)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#3: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#3)): Seq Box } 
                  LitInt(0) <= i#3
                       && i#3
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#3)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assert {:subsumption 0} (forall i#4: int :: 
      { $Unbox(Seq#Index(##jr#0, i#4)): Seq Box } 
      LitInt(0) <= i#4 && i#4 < Seq#Length(##jr#0)
         ==> Seq#Length($Unbox(Seq#Index(##jr#0, i#4)): Seq Box) == LitInt(4064));
    assume (forall i#4: int :: 
      { $Unbox(Seq#Index(##jr#0, i#4)): Seq Box } 
      LitInt(0) <= i#4 && i#4 < Seq#Length(##jr#0)
         ==> Seq#Length($Unbox(Seq#Index(##jr#0, i#4)): Seq Box) == LitInt(4064));
    assert {:subsumption 0} Seq#Length(##jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assume Seq#Length(##jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
    assume JournalistModel.__default.setBack#canCall(JournalistImpl.Journalist.I(old($Heap), this), jr#0);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistModel.__default.setBack(StartFuel_JournalistModel._default.setBack, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        jr#0));
    assume JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
      JournalistModel.__default.setBack(StartFuel_JournalistModel._default.setBack, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        jr#0));
}



procedure Call$$JournalistImpl.Journalist.setBack(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
       ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064));
  requires Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.setBack(StartFuel_JournalistModel._default.setBack, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        jr#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.setBack#canCall(JournalistImpl.Journalist.I(old($Heap), this), jr#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.setBack(StartFuelAssert_JournalistModel._default.setBack, 
      JournalistImpl.Journalist.I(old($Heap), this), 
      jr#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.setBack(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap), 
    jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns ($_reverifyPost: bool);
  free requires 17 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
       ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064));
  requires Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures $IsA#JournalistModel.JournalistModel(JournalistImpl.Journalist.I($Heap, this))
     && $IsA#JournalistModel.JournalistModel(JournalistModel.__default.setBack(StartFuel_JournalistModel._default.setBack, 
        JournalistImpl.Journalist.I(old($Heap), this), 
        jr#0))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.setBack#canCall(JournalistImpl.Journalist.I(old($Heap), this), jr#0);
  ensures JournalistModel.JournalistModel#Equal(JournalistImpl.Journalist.I($Heap, this), 
    JournalistModel.__default.setBack(StartFuelAssert_JournalistModel._default.setBack, 
      JournalistImpl.Journalist.I(old($Heap), this), 
      jr#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.setBack(this: ref, jr#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs#0: DatatypeType
     where $Is($rhs#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))));

    // AddMethodImpl: setBack, Impl$$JournalistImpl.Journalist.setBack
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(349,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(350,37)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__setBack();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(350,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(351,19)
    assume true;
    assert $_Frame[this, JournalistImpl.Journalist.journalBack];
    assume true;
    $rhs#0 := #Options.Option.Some($Box(jr#0));
    $Heap := update($Heap, this, JournalistImpl.Journalist.journalBack, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(351,29)"} true;
}



procedure CheckWellformed$$JournalistImpl.Journalist.parseJournals(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (success#0: bool);
  free requires 25 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.parseJournals(this: ref) returns (success#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: parseJournals, CheckWellformed$$JournalistImpl.Journalist.parseJournals
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(354,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc success#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(358,15): post-state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assume Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
      read(old($Heap), this, JournalistImpl.Journalist.Repr));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assert $IsAlloc(this, Tclass.JournalistImpl.Journalist(), old($Heap));
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall(old($Heap), this)
       ==> JournalistImpl.Journalist.ReprInv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read(old($Heap), this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv(old($Heap), this);
    assume JournalistImpl.Journalist.I#canCall(old($Heap), this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I(old($Heap), this));
    ##jm#0 := JournalistImpl.Journalist.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.parseJournals#canCall(JournalistImpl.Journalist.I(old($Heap), this));
    assume _System.Tuple2.___hMake2_q(JournalistModel.__default.parseJournals(StartFuel_JournalistModel._default.parseJournals, 
        JournalistImpl.Journalist.I(old($Heap), this)));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(JournalistImpl.Journalist.I($Heap, this)), $Box(success#0)), 
      JournalistModel.__default.parseJournals(StartFuel_JournalistModel._default.parseJournals, 
        JournalistImpl.Journalist.I(old($Heap), this)));
}



procedure Call$$JournalistImpl.Journalist.parseJournals(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (success#0: bool);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv($Heap, this);
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures $IsA#_System.Tuple2(JournalistModel.__default.parseJournals(StartFuel_JournalistModel._default.parseJournals, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.parseJournals#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(JournalistImpl.Journalist.I($Heap, this)), $Box(success#0)), 
    JournalistModel.__default.parseJournals(StartFuelAssert_JournalistModel._default.parseJournals, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.parseJournals(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (success#0: bool, $_reverifyPost: bool);
  free requires 25 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.Inv#canCall($Heap, this);
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || (JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
         ==> JournalistImpl.Journalist.ReprInv($Heap, this)
           || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries)))));
  ensures JournalistImpl.Journalist.Inv#canCall($Heap, this)
     ==> JournalistImpl.Journalist.Inv($Heap, this)
       || JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  free ensures true;
  ensures Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
    read(old($Heap), this, JournalistImpl.Journalist.Repr));
  free ensures $IsA#_System.Tuple2(JournalistModel.__default.parseJournals(StartFuel_JournalistModel._default.parseJournals, 
        JournalistImpl.Journalist.I(old($Heap), this)))
     && 
    JournalistImpl.Journalist.I#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.I#canCall(old($Heap), this)
     && JournalistModel.__default.parseJournals#canCall(JournalistImpl.Journalist.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(JournalistImpl.Journalist.I($Heap, this)), $Box(success#0)), 
    JournalistModel.__default.parseJournals(StartFuelAssert_JournalistModel._default.parseJournals, 
      JournalistImpl.Journalist.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, JournalistImpl.Journalist.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.parseJournals(this: ref) returns (success#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var jm##0: DatatypeType;
  var fullRange#0: Seq Box
     where $Is(fullRange#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(fullRange#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var p#0: DatatypeType
     where $Is(p#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
       && $IsAlloc(p#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
       && $IsAlloc($rhs##0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap);
  var jr##0: Seq Box;
  var newtype$check#0: int;
  var $rhs#0_0: DatatypeType
     where $Is($rhs#0_0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))));
  var $rhs#0_1: DatatypeType
     where $Is($rhs#0_1, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))));
  var $rhs#0_2: Seq Box where $Is($rhs#0_2, TSeq(Tclass.Journal.JournalEntry()));
  var $rhs#0_3: int where LitInt(0) <= $rhs#0_3 && $rhs#0_3 < 18446744073709551616;
  var newtype$check#0_0: int;

    // AddMethodImpl: parseJournals, Impl$$JournalistImpl.Journalist.parseJournals
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, JournalistImpl.Journalist.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(361,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(362,43)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__parseJournals();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(362,44)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(363,31)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    // ProcessCallStmt: CheckSubrange
    jm##0 := JournalistImpl.Journalist.I($Heap, this);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__I(jm##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(363,35)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(364,21)
    assume true;
    if (Options.Option.Some_q(read($Heap, this, JournalistImpl.Journalist.journalFront)))
    {
        assert Options.Option.Some_q(read($Heap, this, JournalistImpl.Journalist.journalFront));
    }
    else
    {
    }

    if (Options.Option.Some_q(read($Heap, this, JournalistImpl.Journalist.journalBack)))
    {
        assert Options.Option.Some_q(read($Heap, this, JournalistImpl.Journalist.journalBack));
    }
    else
    {
    }

    assume true;
    fullRange#0 := Seq#Append((if Options.Option.Some_q(read($Heap, this, JournalistImpl.Journalist.journalFront))
         then $Unbox(Options.Option.value(read($Heap, this, JournalistImpl.Journalist.journalFront))): Seq Box
         else Seq#Empty(): Seq Box), 
      (if Options.Option.Some_q(read($Heap, this, JournalistImpl.Journalist.journalBack))
         then $Unbox(Options.Option.value(read($Heap, this, JournalistImpl.Journalist.journalBack))): Seq Box
         else Seq#Empty(): Seq Box));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(366,61)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(367,55)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<seq<JournalEntry>>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    jr##0 := fullRange#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$JournalistParsingImpl.__default.ParseJournalRange(jr##0);
    // TrCallStmt: After ProcessCallStmt
    p#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(367,65)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(368,7)
    if (Options.Option.Some_q(p#0))
    {
        assert Options.Option.Some_q(p#0);
        newtype$check#0 := Seq#Length($Unbox(Options.Option.value(p#0)): Seq Box);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        assume JournalistModel.__default.MaxPossibleEntries#canCall();
    }

    assume Options.Option.Some_q(p#0)
       ==> JournalistModel.__default.MaxPossibleEntries#canCall();
    if (Options.Option.Some_q(p#0)
       && Seq#Length($Unbox(Options.Option.value(p#0)): Seq Box)
         <= LitInt(JournalistModel.__default.MaxPossibleEntries()))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(369,22)
        assume true;
        assert $_Frame[this, JournalistImpl.Journalist.journalFront];
        assume true;
        $rhs#0_0 := Lit(#Options.Option.None());
        $Heap := update($Heap, this, JournalistImpl.Journalist.journalFront, $rhs#0_0);
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(369,28)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(370,21)
        assume true;
        assert $_Frame[this, JournalistImpl.Journalist.journalBack];
        assume true;
        $rhs#0_1 := Lit(#Options.Option.None());
        $Heap := update($Heap, this, JournalistImpl.Journalist.journalBack, $rhs#0_1);
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(370,27)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(371,23)
        assume true;
        assert $_Frame[this, JournalistImpl.Journalist.replayJournal];
        assert Options.Option.Some_q(p#0);
        assume true;
        $rhs#0_2 := $Unbox(Options.Option.value(p#0)): Seq Box;
        $Heap := update($Heap, this, JournalistImpl.Journalist.replayJournal, $rhs#0_2);
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(371,32)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(372,19)
        assume true;
        assert $_Frame[this, JournalistImpl.Journalist.replayIdx];
        newtype$check#0_0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume true;
        $rhs#0_3 := LitInt(0);
        $Heap := update($Heap, this, JournalistImpl.Journalist.replayIdx, $rhs#0_3);
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(372,22)"} true;
        // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(373,9)
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(373,9)
        assume true;
        assume true;
        success#0 := Lit(true);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(373,19)"} true;
        return;
    }
    else
    {
        // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(375,9)
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(375,9)
        assume true;
        assume true;
        success#0 := Lit(false);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(375,20)"} true;
        return;
    }
}



procedure CheckWellformed$$JournalistImpl.Journalist.hasFront(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.hasFront(this: ref) returns (b#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: hasFront, CheckWellformed$$JournalistImpl.Journalist.hasFront
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(379,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc b#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(382,14): post-state"} true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.hasFront#canCall(JournalistImpl.Journalist.I($Heap, this));
    assume b#0
       == JournalistModel.__default.hasFront(StartFuel_JournalistModel._default.hasFront, 
        JournalistImpl.Journalist.I($Heap, this));
}



procedure Call$$JournalistImpl.Journalist.hasFront(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.hasFront#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.hasFront(StartFuelAssert_JournalistModel._default.hasFront, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.hasFront(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool, $_reverifyPost: bool);
  free requires 26 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.hasFront#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.hasFront(StartFuelAssert_JournalistModel._default.hasFront, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.hasFront(this: ref) returns (b#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: hasFront, Impl$$JournalistImpl.Journalist.hasFront
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(383,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(384,38)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__hasFront();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(384,39)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(385,9)
    assume true;
    assume true;
    b#0 := Options.Option.Some_q(read($Heap, this, JournalistImpl.Journalist.journalFront));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(385,29)"} true;
}



procedure CheckWellformed$$JournalistImpl.Journalist.hasBack(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  free requires 27 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistImpl.Journalist.hasBack(this: ref) returns (b#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##jm#0: DatatypeType;

    // AddMethodImpl: hasBack, CheckWellformed$$JournalistImpl.Journalist.hasBack
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(388,11): initial state"} true;
    assume JournalistImpl.Journalist.Inv#canCall($Heap, this);
    assume JournalistImpl.Journalist.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc b#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(391,14): post-state"} true;
    assert {:subsumption 0} JournalistImpl.Journalist.ReprInv#canCall($Heap, this)
       ==> JournalistImpl.Journalist.ReprInv($Heap, this)
         || Set#Equal(read($Heap, this, JournalistImpl.Journalist.Repr), 
          Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, JournalistImpl.Journalist.journalEntries))));
    assume JournalistImpl.Journalist.ReprInv($Heap, this);
    assume JournalistImpl.Journalist.I#canCall($Heap, this);
    assume JournalistModel.JournalistModel.JournalistModel_q(JournalistImpl.Journalist.I($Heap, this));
    ##jm#0 := JournalistImpl.Journalist.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##jm#0, Tclass.JournalistModel.JournalistModel(), $Heap);
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.start(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.start(##jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len1(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0)
               <= JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.len1(##jm#0)
                 + JournalistModel.JournalistModel.len2(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.replayIdx(##jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0)));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || Seq#Length(JournalistModel.JournalistModel.replayJournal(##jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                 || (forall i#0: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                        i#0)): Seq Box } 
                  LitInt(0) <= i#0
                       && i#0
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(##jm#0))): Seq Box, 
                            i#0)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(##jm#0))
               ==> 
              JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                 || (forall i#1: int :: 
                  { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                        i#1)): Seq Box } 
                  LitInt(0) <= i#1
                       && i#1
                         < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box)
                     ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(##jm#0))): Seq Box, 
                            i#1)): Seq Box)
                       == LitInt(4064))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks()));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(##jm#0));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || (JournalistModel.__default.WF#canCall(##jm#0)
           ==> JournalistModel.__default.WF(##jm#0)
             || JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096))));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || Mul(JournalistModel.JournalistModel.writtenJournalBlocks(##jm#0)
                 + JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), 
              LitInt(4064))
             + JournalistModel.JournalistModel.inMemoryWeight(##jm#0)
           <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournalFrozen(##jm#0))
           <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(##jm#0), LitInt(4064));
    assert {:subsumption 0} JournalistModel.__default.Inv#canCall(##jm#0)
       ==> JournalistModel.__default.Inv(##jm#0)
         || JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
            JournalistModel.__default.InMemoryJournal(##jm#0))
           == JournalistModel.JournalistModel.inMemoryWeight(##jm#0);
    assume JournalistModel.__default.Inv(##jm#0);
    assume JournalistModel.__default.hasBack#canCall(JournalistImpl.Journalist.I($Heap, this));
    assume b#0
       == JournalistModel.__default.hasBack(StartFuel_JournalistModel._default.hasBack, 
        JournalistImpl.Journalist.I($Heap, this));
}



procedure Call$$JournalistImpl.Journalist.hasBack(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool);
  // user-defined preconditions
  requires JournalistImpl.Journalist.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.hasBack#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.hasBack(StartFuelAssert_JournalistModel._default.hasBack, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistImpl.Journalist.hasBack(this: ref
       where this != null
         && 
        $Is(this, Tclass.JournalistImpl.Journalist())
         && $IsAlloc(this, Tclass.JournalistImpl.Journalist(), $Heap))
   returns (b#0: bool, $_reverifyPost: bool);
  free requires 27 == $FunctionContextHeight;
  // user-defined preconditions
  free requires JournalistImpl.Journalist.Inv#canCall($Heap, this)
     && 
    JournalistImpl.Journalist.Inv($Heap, this)
     && 
    JournalistImpl.Journalist.ReprInv($Heap, this)
     && JournalistModel.__default.Inv(JournalistImpl.Journalist.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistImpl.Journalist.I#canCall($Heap, this)
     && JournalistModel.__default.hasBack#canCall(JournalistImpl.Journalist.I($Heap, this));
  ensures b#0
     == JournalistModel.__default.hasBack(StartFuelAssert_JournalistModel._default.hasBack, 
      JournalistImpl.Journalist.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistImpl.Journalist.hasBack(this: ref) returns (b#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: hasBack, Impl$$JournalistImpl.Journalist.hasBack
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32)
       == StartFuelAssert_PackedIntsLib._default.pack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuel_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice)
       == StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuel_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.withoutChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.splice)
       == StartFuel_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.splice)
       == StartFuelAssert_JournalistMarshallingModel._default.splice;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeOnto)
       == StartFuel_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuel_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto)
       == StartFuelAssert_JournalistMarshallingModel._default.writeIntOnto;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.writeJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuel_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums)
       == StartFuelAssert_JournalistMarshallingModel._default.fillInChecksums;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.hasHeader)
       == StartFuel_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.hasHeader)
       == StartFuelAssert_JournalistMarshallingModel._default.hasHeader;
    assume AsFuelBottom(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuel_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries)
       == StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries;
    assume AsFuelBottom(StartFuel_JournalistModel._default.JournalistConstructor)
       == StartFuel_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.JournalistConstructor)
       == StartFuelAssert_JournalistModel._default.JournalistConstructor;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFrozenJournal)
       == StartFuel_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFrozenJournal)
       == StartFuelAssert_JournalistModel._default.hasFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasInMemoryJournal)
       == StartFuel_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.hasInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageFrozenJournal)
       == StartFuel_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageFrozenJournal)
       == StartFuelAssert_JournalistModel._default.packageFrozenJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.packageInMemoryJournal)
       == StartFuel_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.packageInMemoryJournal)
       == StartFuelAssert_JournalistModel._default.packageInMemoryJournal;
    assume AsFuelBottom(StartFuel_JournalistModel._default.freeze)
       == StartFuel_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.freeze)
       == StartFuelAssert_JournalistModel._default.freeze;
    assume AsFuelBottom(StartFuel_JournalistModel._default.canAppend)
       == StartFuel_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.canAppend)
       == StartFuelAssert_JournalistModel._default.canAppend;
    assume AsFuelBottom(StartFuel_JournalistModel._default.append)
       == StartFuel_JournalistModel._default.append;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.append)
       == StartFuelAssert_JournalistModel._default.append;
    assume AsFuelBottom(StartFuel_JournalistModel._default.isReplayEmpty)
       == StartFuel_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.isReplayEmpty)
       == StartFuelAssert_JournalistModel._default.isReplayEmpty;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalTop)
       == StartFuel_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalTop)
       == StartFuelAssert_JournalistModel._default.replayJournalTop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.replayJournalPop)
       == StartFuel_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.replayJournalPop)
       == StartFuelAssert_JournalistModel._default.replayJournalPop;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setFront)
       == StartFuel_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setFront)
       == StartFuelAssert_JournalistModel._default.setFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.setBack)
       == StartFuel_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.setBack)
       == StartFuelAssert_JournalistModel._default.setBack;
    assume AsFuelBottom(StartFuel_JournalistModel._default.parseJournals)
       == StartFuel_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.parseJournals)
       == StartFuelAssert_JournalistModel._default.parseJournals;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasFront)
       == StartFuel_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasFront)
       == StartFuelAssert_JournalistModel._default.hasFront;
    assume AsFuelBottom(StartFuel_JournalistModel._default.hasBack)
       == StartFuel_JournalistModel._default.hasBack;
    assume AsFuelBottom(StartFuelAssert_JournalistModel._default.hasBack)
       == StartFuelAssert_JournalistModel._default.hasBack;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(392,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(393,37)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalistModel.__default.reveal__hasBack();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(393,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(394,9)
    assume true;
    assume true;
    b#0 := Options.Option.Some_q(read($Heap, this, JournalistImpl.Journalist.journalBack));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistImpl.i.dfy(394,28)"} true;
}



// JournalistImpl.Journalist: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.JournalistImpl.Journalist()) } 
  $Is(c#0, Tclass.JournalistImpl.Journalist())
     <==> $Is(c#0, Tclass.JournalistImpl.Journalist?()) && c#0 != null);

// JournalistImpl.Journalist: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.JournalistImpl.Journalist(), $h) } 
  $IsAlloc(c#0, Tclass.JournalistImpl.Journalist(), $h)
     <==> $IsAlloc(c#0, Tclass.JournalistImpl.Journalist?(), $h));

const unique class.JournalistImpl.__default: ClassName;

function Tclass.JournalistImpl.__default() : Ty;

// Tclass.JournalistImpl.__default Tag
axiom Tag(Tclass.JournalistImpl.__default()) == Tagclass.JournalistImpl.__default;

const unique Tagclass.JournalistImpl.__default: TyTag;

// Box/unbox axiom for Tclass.JournalistImpl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistImpl.__default()) } 
  $IsBox(bx, Tclass.JournalistImpl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalistImpl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalistImpl.__default()) } 
  $Is($o, Tclass.JournalistImpl.__default())
     <==> $o == null || dtype($o) == Tclass.JournalistImpl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalistImpl.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalistImpl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function Tclass.NativeTypes.sbyte() : Ty;

// Tclass.NativeTypes.sbyte Tag
axiom Tag(Tclass.NativeTypes.sbyte()) == Tagclass.NativeTypes.sbyte;

const unique Tagclass.NativeTypes.sbyte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.sbyte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.sbyte()) } 
  $IsBox(bx, Tclass.NativeTypes.sbyte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.sbyte()));

// NativeTypes.sbyte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.sbyte()) } 
  $Is(i#0, Tclass.NativeTypes.sbyte()) <==> LitInt(0 - 128) <= i#0 && i#0 < 128);

// NativeTypes.sbyte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h));

const unique class.NativeTypes.sbyte: ClassName;

// NativeTypes.byte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.byte()) } 
  $Is(i#0, Tclass.NativeTypes.byte()) <==> LitInt(0) <= i#0 && i#0 < 256);

// NativeTypes.byte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h));

const unique class.NativeTypes.byte: ClassName;

function Tclass.NativeTypes.int16() : Ty;

// Tclass.NativeTypes.int16 Tag
axiom Tag(Tclass.NativeTypes.int16()) == Tagclass.NativeTypes.int16;

const unique Tagclass.NativeTypes.int16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int16()) } 
  $IsBox(bx, Tclass.NativeTypes.int16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int16()));

// NativeTypes.int16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int16()) } 
  $Is(i#0, Tclass.NativeTypes.int16())
     <==> LitInt(0 - 32768) <= i#0 && i#0 < 32768);

// NativeTypes.int16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h));

const unique class.NativeTypes.int16: ClassName;

function Tclass.NativeTypes.uint16() : Ty;

// Tclass.NativeTypes.uint16 Tag
axiom Tag(Tclass.NativeTypes.uint16()) == Tagclass.NativeTypes.uint16;

const unique Tagclass.NativeTypes.uint16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint16()) } 
  $IsBox(bx, Tclass.NativeTypes.uint16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint16()));

// NativeTypes.uint16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint16()) } 
  $Is(i#0, Tclass.NativeTypes.uint16()) <==> LitInt(0) <= i#0 && i#0 < 65536);

// NativeTypes.uint16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h));

const unique class.NativeTypes.uint16: ClassName;

function Tclass.NativeTypes.int32() : Ty;

// Tclass.NativeTypes.int32 Tag
axiom Tag(Tclass.NativeTypes.int32()) == Tagclass.NativeTypes.int32;

const unique Tagclass.NativeTypes.int32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int32()) } 
  $IsBox(bx, Tclass.NativeTypes.int32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int32()));

// NativeTypes.int32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int32()) } 
  $Is(i#0, Tclass.NativeTypes.int32())
     <==> LitInt(0 - 2147483648) <= i#0 && i#0 < 2147483648);

// NativeTypes.int32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h));

const unique class.NativeTypes.int32: ClassName;

function Tclass.NativeTypes.uint32() : Ty;

// Tclass.NativeTypes.uint32 Tag
axiom Tag(Tclass.NativeTypes.uint32()) == Tagclass.NativeTypes.uint32;

const unique Tagclass.NativeTypes.uint32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint32()) } 
  $IsBox(bx, Tclass.NativeTypes.uint32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint32()));

// NativeTypes.uint32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint32()) } 
  $Is(i#0, Tclass.NativeTypes.uint32()) <==> LitInt(0) <= i#0 && i#0 < 4294967296);

// NativeTypes.uint32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h));

const unique class.NativeTypes.uint32: ClassName;

function Tclass.NativeTypes.int64() : Ty;

// Tclass.NativeTypes.int64 Tag
axiom Tag(Tclass.NativeTypes.int64()) == Tagclass.NativeTypes.int64;

const unique Tagclass.NativeTypes.int64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int64()) } 
  $IsBox(bx, Tclass.NativeTypes.int64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int64()));

// NativeTypes.int64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int64()) } 
  $Is(i#0, Tclass.NativeTypes.int64())
     <==> LitInt(0 - 9223372036854775808) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.int64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h));

const unique class.NativeTypes.int64: ClassName;

// NativeTypes.uint64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint64()) } 
  $Is(i#0, Tclass.NativeTypes.uint64())
     <==> LitInt(0) <= i#0 && i#0 < 18446744073709551616);

// NativeTypes.uint64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h));

const unique class.NativeTypes.uint64: ClassName;

function Tclass.NativeTypes.nat8() : Ty;

// Tclass.NativeTypes.nat8 Tag
axiom Tag(Tclass.NativeTypes.nat8()) == Tagclass.NativeTypes.nat8;

const unique Tagclass.NativeTypes.nat8: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat8
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat8()) } 
  $IsBox(bx, Tclass.NativeTypes.nat8())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat8()));

// NativeTypes.nat8: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat8()) } 
  $Is(i#0, Tclass.NativeTypes.nat8()) <==> LitInt(0) <= i#0 && i#0 < 128);

// NativeTypes.nat8: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h));

const unique class.NativeTypes.nat8: ClassName;

function Tclass.NativeTypes.nat16() : Ty;

// Tclass.NativeTypes.nat16 Tag
axiom Tag(Tclass.NativeTypes.nat16()) == Tagclass.NativeTypes.nat16;

const unique Tagclass.NativeTypes.nat16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat16()) } 
  $IsBox(bx, Tclass.NativeTypes.nat16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat16()));

// NativeTypes.nat16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat16()) } 
  $Is(i#0, Tclass.NativeTypes.nat16()) <==> LitInt(0) <= i#0 && i#0 < 32768);

// NativeTypes.nat16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h));

const unique class.NativeTypes.nat16: ClassName;

function Tclass.NativeTypes.nat32() : Ty;

// Tclass.NativeTypes.nat32 Tag
axiom Tag(Tclass.NativeTypes.nat32()) == Tagclass.NativeTypes.nat32;

const unique Tagclass.NativeTypes.nat32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat32()) } 
  $IsBox(bx, Tclass.NativeTypes.nat32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat32()));

// NativeTypes.nat32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat32()) } 
  $Is(i#0, Tclass.NativeTypes.nat32()) <==> LitInt(0) <= i#0 && i#0 < 2147483648);

// NativeTypes.nat32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h));

const unique class.NativeTypes.nat32: ClassName;

function Tclass.NativeTypes.nat64() : Ty;

// Tclass.NativeTypes.nat64 Tag
axiom Tag(Tclass.NativeTypes.nat64()) == Tagclass.NativeTypes.nat64;

const unique Tagclass.NativeTypes.nat64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat64()) } 
  $IsBox(bx, Tclass.NativeTypes.nat64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat64()));

// NativeTypes.nat64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat64()) } 
  $Is(i#0, Tclass.NativeTypes.nat64())
     <==> LitInt(0) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.nat64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h));

const unique class.NativeTypes.nat64: ClassName;

const unique class.NativeTypes.__default: ClassName;

function Tclass.NativeTypes.__default() : Ty;

// Tclass.NativeTypes.__default Tag
axiom Tag(Tclass.NativeTypes.__default()) == Tagclass.NativeTypes.__default;

const unique Tagclass.NativeTypes.__default: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.__default()) } 
  $IsBox(bx, Tclass.NativeTypes.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeTypes.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeTypes.__default()) } 
  $Is($o, Tclass.NativeTypes.__default())
     <==> $o == null || dtype($o) == Tclass.NativeTypes.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeTypes.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeTypes.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativeTypes._default.Uint64Size
function NativeTypes.__default.Uint64Size() : int;

function NativeTypes.__default.Uint64Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint64Size()
     && NativeTypes.__default.Uint64Size() < 18446744073709551616;

function NativeTypes.__default.Uint64Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64Size
axiom NativeTypes.__default.Uint64Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint64Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// definition axiom for NativeTypes.__default.Uint64Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// function declaration for NativeTypes._default.Uint32Size
function NativeTypes.__default.Uint32Size() : int;

function NativeTypes.__default.Uint32Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint32Size()
     && NativeTypes.__default.Uint32Size() < 18446744073709551616;

function NativeTypes.__default.Uint32Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32Size
axiom NativeTypes.__default.Uint32Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint32Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// definition axiom for NativeTypes.__default.Uint32Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// function declaration for NativeTypes._default.Uint16Size
function NativeTypes.__default.Uint16Size() : int;

function NativeTypes.__default.Uint16Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint16Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint16Size()
     && NativeTypes.__default.Uint16Size() < 18446744073709551616;

function NativeTypes.__default.Uint16Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint16Size
axiom NativeTypes.__default.Uint16Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint16Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// definition axiom for NativeTypes.__default.Uint16Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// function declaration for NativeTypes._default.Uint64UpperBound
function NativeTypes.__default.Uint64UpperBound() : int;

function NativeTypes.__default.Uint64UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint64UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64UpperBound
axiom NativeTypes.__default.Uint64UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint64UpperBound(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// definition axiom for NativeTypes.__default.Uint64UpperBound for all literals(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// function declaration for NativeTypes._default.Uint32UpperBound
function NativeTypes.__default.Uint32UpperBound() : int;

function NativeTypes.__default.Uint32UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint32UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32UpperBound
axiom NativeTypes.__default.Uint32UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint32UpperBound(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// definition axiom for NativeTypes.__default.Uint32UpperBound for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// KeyType.Key: subset type $Is
axiom (forall s#0: Seq Box :: 
  { $Is(s#0, Tclass.KeyType.Key()) } 
  $Is(s#0, Tclass.KeyType.Key())
     <==> $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) <= LitInt(1024));

// KeyType.Key: subset type $IsAlloc
axiom (forall s#0: Seq Box, $h: Heap :: 
  { $IsAlloc(s#0, Tclass.KeyType.Key(), $h) } 
  $IsAlloc(s#0, Tclass.KeyType.Key(), $h)
     <==> $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $h));

const unique class.KeyType.__default: ClassName;

function Tclass.KeyType.__default() : Ty;

// Tclass.KeyType.__default Tag
axiom Tag(Tclass.KeyType.__default()) == Tagclass.KeyType.__default;

const unique Tagclass.KeyType.__default: TyTag;

// Box/unbox axiom for Tclass.KeyType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KeyType.__default()) } 
  $IsBox(bx, Tclass.KeyType.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.KeyType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.KeyType.__default()) } 
  $Is($o, Tclass.KeyType.__default())
     <==> $o == null || dtype($o) == Tclass.KeyType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.KeyType.__default(), $h) } 
  $IsAlloc($o, Tclass.KeyType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for KeyType._default.MaxLen
function KeyType.__default.MaxLen() : int;

function KeyType.__default.MaxLen#canCall() : bool;

// consequence axiom for KeyType.__default.MaxLen
axiom true
   ==> 
  true
   ==> LitInt(0) <= KeyType.__default.MaxLen()
     && KeyType.__default.MaxLen() < 18446744073709551616;

function KeyType.__default.MaxLen#requires() : bool;

// #requires axiom for KeyType.__default.MaxLen
axiom KeyType.__default.MaxLen#requires() == true;

// definition axiom for KeyType.__default.MaxLen(revealed)
axiom true ==> true ==> KeyType.__default.MaxLen() == LitInt(1024);

// definition axiom for KeyType.__default.MaxLen for all literals(revealed)
axiom true ==> true ==> KeyType.__default.MaxLen() == LitInt(1024);

const unique class.Bounds.__default: ClassName;

function Tclass.Bounds.__default() : Ty;

// Tclass.Bounds.__default Tag
axiom Tag(Tclass.Bounds.__default()) == Tagclass.Bounds.__default;

const unique Tagclass.Bounds.__default: TyTag;

// Box/unbox axiom for Tclass.Bounds.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Bounds.__default()) } 
  $IsBox(bx, Tclass.Bounds.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Bounds.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Bounds.__default()) } 
  $Is($o, Tclass.Bounds.__default())
     <==> $o == null || dtype($o) == Tclass.Bounds.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Bounds.__default(), $h) } 
  $IsAlloc($o, Tclass.Bounds.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Bounds._default.NodeBlockSizeUint64
function Bounds.__default.NodeBlockSizeUint64() : int;

function Bounds.__default.NodeBlockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.NodeBlockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.NodeBlockSizeUint64()
     && Bounds.__default.NodeBlockSizeUint64() < 18446744073709551616;

function Bounds.__default.NodeBlockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.NodeBlockSizeUint64
axiom Bounds.__default.NodeBlockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.NodeBlockSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)));

// definition axiom for Bounds.__default.NodeBlockSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)));

// function declaration for Bounds._default.MinNodeBlockIndexUint64
function Bounds.__default.MinNodeBlockIndexUint64() : int;

function Bounds.__default.MinNodeBlockIndexUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MinNodeBlockIndexUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MinNodeBlockIndexUint64()
     && Bounds.__default.MinNodeBlockIndexUint64() < 18446744073709551616;

function Bounds.__default.MinNodeBlockIndexUint64#requires() : bool;

// #requires axiom for Bounds.__default.MinNodeBlockIndexUint64
axiom Bounds.__default.MinNodeBlockIndexUint64#requires() == true;

// definition axiom for Bounds.__default.MinNodeBlockIndexUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && 
    Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.MinNodeBlockIndexUint64()
       == LitInt(Div(Mul(LitInt(2), LitInt(Bounds.__default.SuperblockSizeUint64()))
               + Mul(LitInt(Bounds.__default.DiskNumJournalBlocksUint64()), 
                LitInt(Bounds.__default.JournalBlockSizeUint64()))
               + Mul(LitInt(2), LitInt(Bounds.__default.IndirectionTableBlockSizeUint64()))
               + Bounds.__default.NodeBlockSizeUint64()
             - 1, 
          LitInt(Bounds.__default.NodeBlockSizeUint64())));

// definition axiom for Bounds.__default.MinNodeBlockIndexUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && 
    Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.MinNodeBlockIndexUint64()
       == LitInt(Div(Mul(LitInt(2), LitInt(Bounds.__default.SuperblockSizeUint64()))
               + Mul(LitInt(Bounds.__default.DiskNumJournalBlocksUint64()), 
                LitInt(Bounds.__default.JournalBlockSizeUint64()))
               + Mul(LitInt(2), LitInt(Bounds.__default.IndirectionTableBlockSizeUint64()))
               + Bounds.__default.NodeBlockSizeUint64()
             - 1, 
          LitInt(Bounds.__default.NodeBlockSizeUint64())));

// function declaration for Bounds._default.SuperblockSizeUint64
function Bounds.__default.SuperblockSizeUint64() : int;

function Bounds.__default.SuperblockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.SuperblockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.SuperblockSizeUint64()
     && Bounds.__default.SuperblockSizeUint64() < 18446744073709551616;

function Bounds.__default.SuperblockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.SuperblockSizeUint64
axiom Bounds.__default.SuperblockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.SuperblockSizeUint64(revealed)
axiom true ==> true ==> Bounds.__default.SuperblockSizeUint64() == LitInt(4096);

// definition axiom for Bounds.__default.SuperblockSizeUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.SuperblockSizeUint64() == LitInt(4096);

// function declaration for Bounds._default.JournalBlockSizeUint64
function Bounds.__default.JournalBlockSizeUint64() : int;

function Bounds.__default.JournalBlockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.JournalBlockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.JournalBlockSizeUint64()
     && Bounds.__default.JournalBlockSizeUint64() < 18446744073709551616;

function Bounds.__default.JournalBlockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.JournalBlockSizeUint64
axiom Bounds.__default.JournalBlockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.JournalBlockSizeUint64(revealed)
axiom true ==> true ==> Bounds.__default.JournalBlockSizeUint64() == LitInt(4096);

// definition axiom for Bounds.__default.JournalBlockSizeUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.JournalBlockSizeUint64() == LitInt(4096);

// function declaration for Bounds._default.DiskNumJournalBlocksUint64
function Bounds.__default.DiskNumJournalBlocksUint64() : int;

function Bounds.__default.DiskNumJournalBlocksUint64#canCall() : bool;

// consequence axiom for Bounds.__default.DiskNumJournalBlocksUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.DiskNumJournalBlocksUint64()
     && Bounds.__default.DiskNumJournalBlocksUint64() < 18446744073709551616;

function Bounds.__default.DiskNumJournalBlocksUint64#requires() : bool;

// #requires axiom for Bounds.__default.DiskNumJournalBlocksUint64
axiom Bounds.__default.DiskNumJournalBlocksUint64#requires() == true;

// definition axiom for Bounds.__default.DiskNumJournalBlocksUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64()
     == LitInt(Mul(LitInt(64), LitInt(1024)));

// definition axiom for Bounds.__default.DiskNumJournalBlocksUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64()
     == LitInt(Mul(LitInt(64), LitInt(1024)));

// function declaration for Bounds._default.IndirectionTableBlockSizeUint64
function Bounds.__default.IndirectionTableBlockSizeUint64() : int;

function Bounds.__default.IndirectionTableBlockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableBlockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.IndirectionTableBlockSizeUint64()
     && Bounds.__default.IndirectionTableBlockSizeUint64() < 18446744073709551616;

function Bounds.__default.IndirectionTableBlockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableBlockSizeUint64
axiom Bounds.__default.IndirectionTableBlockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableBlockSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(24), LitInt(1024))), LitInt(1024)));

// definition axiom for Bounds.__default.IndirectionTableBlockSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(24), LitInt(1024))), LitInt(1024)));

// function declaration for Bounds._default.LargestBlockSizeOfAnyTypeUint64
function Bounds.__default.LargestBlockSizeOfAnyTypeUint64() : int;

function Bounds.__default.LargestBlockSizeOfAnyTypeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64
axiom true
   ==> 
  true
   ==> LitInt(Bounds.__default.IndirectionTableBlockSizeUint64())
       <= Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
     && LitInt(Bounds.__default.NodeBlockSizeUint64())
       <= Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
     && 
    LitInt(0) <= Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
     && Bounds.__default.LargestBlockSizeOfAnyTypeUint64() < 18446744073709551616;

function Bounds.__default.LargestBlockSizeOfAnyTypeUint64#requires() : bool;

// #requires axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64
axiom Bounds.__default.LargestBlockSizeOfAnyTypeUint64#requires() == true;

// definition axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// definition axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// function declaration for Bounds._default.MaxTotalBucketWeightUint64
function Bounds.__default.MaxTotalBucketWeightUint64() : int;

function Bounds.__default.MaxTotalBucketWeightUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MaxTotalBucketWeightUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MaxTotalBucketWeightUint64()
     && Bounds.__default.MaxTotalBucketWeightUint64() < 18446744073709551616;

function Bounds.__default.MaxTotalBucketWeightUint64#requires() : bool;

// #requires axiom for Bounds.__default.MaxTotalBucketWeightUint64
axiom Bounds.__default.MaxTotalBucketWeightUint64#requires() == true;

// definition axiom for Bounds.__default.MaxTotalBucketWeightUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)) - 65536);

// definition axiom for Bounds.__default.MaxTotalBucketWeightUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)) - 65536);

// function declaration for Bounds._default.MaxCacheSizeUint64
function Bounds.__default.MaxCacheSizeUint64() : int;

function Bounds.__default.MaxCacheSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MaxCacheSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MaxCacheSizeUint64()
     && Bounds.__default.MaxCacheSizeUint64() < 18446744073709551616;

function Bounds.__default.MaxCacheSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.MaxCacheSizeUint64
axiom Bounds.__default.MaxCacheSizeUint64#requires() == true;

// definition axiom for Bounds.__default.MaxCacheSizeUint64(revealed)
axiom true ==> true ==> Bounds.__default.MaxCacheSizeUint64() == LitInt(100);

// definition axiom for Bounds.__default.MaxCacheSizeUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.MaxCacheSizeUint64() == LitInt(100);

// function declaration for Bounds._default.MaxNumChildrenUint64
function Bounds.__default.MaxNumChildrenUint64() : int;

function Bounds.__default.MaxNumChildrenUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MaxNumChildrenUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MaxNumChildrenUint64()
     && Bounds.__default.MaxNumChildrenUint64() < 18446744073709551616;

function Bounds.__default.MaxNumChildrenUint64#requires() : bool;

// #requires axiom for Bounds.__default.MaxNumChildrenUint64
axiom Bounds.__default.MaxNumChildrenUint64#requires() == true;

// definition axiom for Bounds.__default.MaxNumChildrenUint64(revealed)
axiom true ==> true ==> Bounds.__default.MaxNumChildrenUint64() == LitInt(8);

// definition axiom for Bounds.__default.MaxNumChildrenUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.MaxNumChildrenUint64() == LitInt(8);

// function declaration for Bounds._default.FlushTriggerWeightUint64
function Bounds.__default.FlushTriggerWeightUint64() : int;

function Bounds.__default.FlushTriggerWeightUint64#canCall() : bool;

// consequence axiom for Bounds.__default.FlushTriggerWeightUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.FlushTriggerWeightUint64()
     && Bounds.__default.FlushTriggerWeightUint64() < 18446744073709551616;

function Bounds.__default.FlushTriggerWeightUint64#requires() : bool;

// #requires axiom for Bounds.__default.FlushTriggerWeightUint64
axiom Bounds.__default.FlushTriggerWeightUint64#requires() == true;

// definition axiom for Bounds.__default.FlushTriggerWeightUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeightUint64()
       == LitInt(Div(Bounds.__default.MaxTotalBucketWeightUint64(), LitInt(8)));

// definition axiom for Bounds.__default.FlushTriggerWeightUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeightUint64()
       == LitInt(Div(Bounds.__default.MaxTotalBucketWeightUint64(), LitInt(8)));

// function declaration for Bounds._default.NumBlocksUint64
function Bounds.__default.NumBlocksUint64() : int;

function Bounds.__default.NumBlocksUint64#canCall() : bool;

// consequence axiom for Bounds.__default.NumBlocksUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.NumBlocksUint64()
     && Bounds.__default.NumBlocksUint64() < 18446744073709551616;

function Bounds.__default.NumBlocksUint64#requires() : bool;

// #requires axiom for Bounds.__default.NumBlocksUint64
axiom Bounds.__default.NumBlocksUint64#requires() == true;

// definition axiom for Bounds.__default.NumBlocksUint64(revealed)
axiom true ==> true ==> Bounds.__default.NumBlocksUint64() == LitInt(1048576);

// definition axiom for Bounds.__default.NumBlocksUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.NumBlocksUint64() == LitInt(1048576);

// function declaration for Bounds._default.IndirectionTableMaxSizeUint64
function Bounds.__default.IndirectionTableMaxSizeUint64() : int;

function Bounds.__default.IndirectionTableMaxSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableMaxSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.IndirectionTableMaxSizeUint64()
     && Bounds.__default.IndirectionTableMaxSizeUint64() < 18446744073709551616;

function Bounds.__default.IndirectionTableMaxSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableMaxSizeUint64
axiom Bounds.__default.IndirectionTableMaxSizeUint64#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableMaxSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64() == LitInt(4294967296);

// definition axiom for Bounds.__default.IndirectionTableMaxSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64() == LitInt(4294967296);

// function declaration for Bounds._default.SuperblockSize
function Bounds.__default.SuperblockSize() : int;

function Bounds.__default.SuperblockSize#canCall() : bool;

// consequence axiom for Bounds.__default.SuperblockSize
axiom true ==> true ==> true;

function Bounds.__default.SuperblockSize#requires() : bool;

// #requires axiom for Bounds.__default.SuperblockSize
axiom Bounds.__default.SuperblockSize#requires() == true;

// definition axiom for Bounds.__default.SuperblockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && Bounds.__default.SuperblockSize()
       == LitInt(Bounds.__default.SuperblockSizeUint64());

// definition axiom for Bounds.__default.SuperblockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && Bounds.__default.SuperblockSize()
       == LitInt(Bounds.__default.SuperblockSizeUint64());

// function declaration for Bounds._default.IndirectionTableBlockSize
function Bounds.__default.IndirectionTableBlockSize() : int;

function Bounds.__default.IndirectionTableBlockSize#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableBlockSize
axiom true ==> true ==> true;

function Bounds.__default.IndirectionTableBlockSize#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableBlockSize
axiom Bounds.__default.IndirectionTableBlockSize#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableBlockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSize()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// definition axiom for Bounds.__default.IndirectionTableBlockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSize()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// function declaration for Bounds._default.NodeBlockSize
function Bounds.__default.NodeBlockSize() : int;

function Bounds.__default.NodeBlockSize#canCall() : bool;

// consequence axiom for Bounds.__default.NodeBlockSize
axiom true ==> true ==> true;

function Bounds.__default.NodeBlockSize#requires() : bool;

// #requires axiom for Bounds.__default.NodeBlockSize
axiom Bounds.__default.NodeBlockSize#requires() == true;

// definition axiom for Bounds.__default.NodeBlockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSize()
       == LitInt(Bounds.__default.NodeBlockSizeUint64());

// definition axiom for Bounds.__default.NodeBlockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSize()
       == LitInt(Bounds.__default.NodeBlockSizeUint64());

// function declaration for Bounds._default.MinNodeBlockIndex
function Bounds.__default.MinNodeBlockIndex() : int;

function Bounds.__default.MinNodeBlockIndex#canCall() : bool;

// consequence axiom for Bounds.__default.MinNodeBlockIndex
axiom true ==> true ==> true;

function Bounds.__default.MinNodeBlockIndex#requires() : bool;

// #requires axiom for Bounds.__default.MinNodeBlockIndex
axiom Bounds.__default.MinNodeBlockIndex#requires() == true;

// definition axiom for Bounds.__default.MinNodeBlockIndex(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MinNodeBlockIndexUint64#canCall()
     && Bounds.__default.MinNodeBlockIndex()
       == LitInt(Bounds.__default.MinNodeBlockIndexUint64());

// definition axiom for Bounds.__default.MinNodeBlockIndex for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MinNodeBlockIndexUint64#canCall()
     && Bounds.__default.MinNodeBlockIndex()
       == LitInt(Bounds.__default.MinNodeBlockIndexUint64());

// function declaration for Bounds._default.MaxNumChildren
function Bounds.__default.MaxNumChildren() : int;

function Bounds.__default.MaxNumChildren#canCall() : bool;

// consequence axiom for Bounds.__default.MaxNumChildren
axiom true ==> true ==> true;

function Bounds.__default.MaxNumChildren#requires() : bool;

// #requires axiom for Bounds.__default.MaxNumChildren
axiom Bounds.__default.MaxNumChildren#requires() == true;

// definition axiom for Bounds.__default.MaxNumChildren(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxNumChildrenUint64#canCall()
     && Bounds.__default.MaxNumChildren()
       == LitInt(Bounds.__default.MaxNumChildrenUint64());

// definition axiom for Bounds.__default.MaxNumChildren for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxNumChildrenUint64#canCall()
     && Bounds.__default.MaxNumChildren()
       == LitInt(Bounds.__default.MaxNumChildrenUint64());

// function declaration for Bounds._default.MaxTotalBucketWeight
function Bounds.__default.MaxTotalBucketWeight() : int;

function Bounds.__default.MaxTotalBucketWeight#canCall() : bool;

// consequence axiom for Bounds.__default.MaxTotalBucketWeight
axiom true ==> true ==> true;

function Bounds.__default.MaxTotalBucketWeight#requires() : bool;

// #requires axiom for Bounds.__default.MaxTotalBucketWeight
axiom Bounds.__default.MaxTotalBucketWeight#requires() == true;

// definition axiom for Bounds.__default.MaxTotalBucketWeight(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.MaxTotalBucketWeight()
       == LitInt(Bounds.__default.MaxTotalBucketWeightUint64());

// definition axiom for Bounds.__default.MaxTotalBucketWeight for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.MaxTotalBucketWeight()
       == LitInt(Bounds.__default.MaxTotalBucketWeightUint64());

// function declaration for Bounds._default.MaxCacheSize
function Bounds.__default.MaxCacheSize() : int;

function Bounds.__default.MaxCacheSize#canCall() : bool;

// consequence axiom for Bounds.__default.MaxCacheSize
axiom true ==> true ==> true;

function Bounds.__default.MaxCacheSize#requires() : bool;

// #requires axiom for Bounds.__default.MaxCacheSize
axiom Bounds.__default.MaxCacheSize#requires() == true;

// definition axiom for Bounds.__default.MaxCacheSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxCacheSizeUint64#canCall()
     && Bounds.__default.MaxCacheSize() == LitInt(Bounds.__default.MaxCacheSizeUint64());

// definition axiom for Bounds.__default.MaxCacheSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxCacheSizeUint64#canCall()
     && Bounds.__default.MaxCacheSize() == LitInt(Bounds.__default.MaxCacheSizeUint64());

// function declaration for Bounds._default.FlushTriggerWeight
function Bounds.__default.FlushTriggerWeight() : int;

function Bounds.__default.FlushTriggerWeight#canCall() : bool;

// consequence axiom for Bounds.__default.FlushTriggerWeight
axiom true ==> true ==> true;

function Bounds.__default.FlushTriggerWeight#requires() : bool;

// #requires axiom for Bounds.__default.FlushTriggerWeight
axiom Bounds.__default.FlushTriggerWeight#requires() == true;

// definition axiom for Bounds.__default.FlushTriggerWeight(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.FlushTriggerWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeight()
       == LitInt(Bounds.__default.FlushTriggerWeightUint64());

// definition axiom for Bounds.__default.FlushTriggerWeight for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.FlushTriggerWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeight()
       == LitInt(Bounds.__default.FlushTriggerWeightUint64());

// function declaration for Bounds._default.NumBlocks
function Bounds.__default.NumBlocks() : int;

function Bounds.__default.NumBlocks#canCall() : bool;

// consequence axiom for Bounds.__default.NumBlocks
axiom true ==> true ==> true;

function Bounds.__default.NumBlocks#requires() : bool;

// #requires axiom for Bounds.__default.NumBlocks
axiom Bounds.__default.NumBlocks#requires() == true;

// definition axiom for Bounds.__default.NumBlocks(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NumBlocksUint64#canCall()
     && Bounds.__default.NumBlocks() == LitInt(Bounds.__default.NumBlocksUint64());

// definition axiom for Bounds.__default.NumBlocks for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NumBlocksUint64#canCall()
     && Bounds.__default.NumBlocks() == LitInt(Bounds.__default.NumBlocksUint64());

// function declaration for Bounds._default.IndirectionTableMaxSize
function Bounds.__default.IndirectionTableMaxSize() : int;

function Bounds.__default.IndirectionTableMaxSize#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableMaxSize
axiom true ==> true ==> true;

function Bounds.__default.IndirectionTableMaxSize#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableMaxSize
axiom Bounds.__default.IndirectionTableMaxSize#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableMaxSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64#canCall()
     && Bounds.__default.IndirectionTableMaxSize()
       == LitInt(Bounds.__default.IndirectionTableMaxSizeUint64());

// definition axiom for Bounds.__default.IndirectionTableMaxSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64#canCall()
     && Bounds.__default.IndirectionTableMaxSize()
       == LitInt(Bounds.__default.IndirectionTableMaxSizeUint64());

// function declaration for Bounds._default.JournalBlockSize
function Bounds.__default.JournalBlockSize() : int;

function Bounds.__default.JournalBlockSize#canCall() : bool;

// consequence axiom for Bounds.__default.JournalBlockSize
axiom true ==> true ==> true;

function Bounds.__default.JournalBlockSize#requires() : bool;

// #requires axiom for Bounds.__default.JournalBlockSize
axiom Bounds.__default.JournalBlockSize#requires() == true;

// definition axiom for Bounds.__default.JournalBlockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.JournalBlockSize()
       == LitInt(Bounds.__default.JournalBlockSizeUint64());

// definition axiom for Bounds.__default.JournalBlockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.JournalBlockSize()
       == LitInt(Bounds.__default.JournalBlockSizeUint64());

// function declaration for Bounds._default.DiskNumJournalBlocks
function Bounds.__default.DiskNumJournalBlocks() : int;

function Bounds.__default.DiskNumJournalBlocks#canCall() : bool;

// consequence axiom for Bounds.__default.DiskNumJournalBlocks
axiom true ==> true ==> true;

function Bounds.__default.DiskNumJournalBlocks#requires() : bool;

// #requires axiom for Bounds.__default.DiskNumJournalBlocks
axiom Bounds.__default.DiskNumJournalBlocks#requires() == true;

// definition axiom for Bounds.__default.DiskNumJournalBlocks(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.DiskNumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

// definition axiom for Bounds.__default.DiskNumJournalBlocks for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.DiskNumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

// Constructor function declaration
function #Options.Option.None() : DatatypeType;

const unique ##Options.Option.None: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#Options.Option.None()) == ##Options.Option.None;

function Options.Option.None_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) <==> DatatypeCtorId(d) == ##Options.Option.None);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) ==> d == #Options.Option.None());

// Constructor $Is
axiom (forall Options.Option$V: Ty :: 
  { $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, $h: Heap :: 
  { $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h));

// Constructor literal
axiom #Options.Option.None() == Lit(#Options.Option.None());

// Constructor function declaration
function #Options.Option.Some(Box) : DatatypeType;

const unique ##Options.Option.Some: DtCtorId;

// Constructor identifier
axiom (forall a#5#0#0: Box :: 
  { #Options.Option.Some(a#5#0#0) } 
  DatatypeCtorId(#Options.Option.Some(a#5#0#0)) == ##Options.Option.Some);

function Options.Option.Some_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d) <==> DatatypeCtorId(d) == ##Options.Option.Some);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d)
     ==> (exists a#6#0#0: Box :: d == #Options.Option.Some(a#6#0#0)));

// Constructor $Is
axiom (forall Options.Option$V: Ty, a#7#0#0: Box :: 
  { $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V))
     <==> $IsBox(a#7#0#0, Options.Option$V));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, a#8#0#0: Box, $h: Heap :: 
  { $IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h)
       <==> $IsAllocBox(a#8#0#0, Options.Option$V, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, Options.Option$V: Ty, $h: Heap :: 
  { $IsAllocBox(Options.Option.value(d), Options.Option$V, $h) } 
  $IsGoodHeap($h)
       && 
      Options.Option.Some_q(d)
       && $IsAlloc(d, Tclass.Options.Option(Options.Option$V), $h)
     ==> $IsAllocBox(Options.Option.value(d), Options.Option$V, $h));

// Constructor literal
axiom (forall a#9#0#0: Box :: 
  { #Options.Option.Some(Lit(a#9#0#0)) } 
  #Options.Option.Some(Lit(a#9#0#0)) == Lit(#Options.Option.Some(a#9#0#0)));

function Options.Option.value(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#10#0#0: Box :: 
  { #Options.Option.Some(a#10#0#0) } 
  Options.Option.value(#Options.Option.Some(a#10#0#0)) == a#10#0#0);

// Inductive rank
axiom (forall a#11#0#0: Box :: 
  { #Options.Option.Some(a#11#0#0) } 
  BoxRank(a#11#0#0) < DtRank(#Options.Option.Some(a#11#0#0)));

// Depth-one case-split function
function $IsA#Options.Option(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Options.Option(d) } 
  $IsA#Options.Option(d) ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Questionmark data type disjunctivity
axiom (forall Options.Option$V: Ty, d: DatatypeType :: 
  { Options.Option.Some_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
    { Options.Option.None_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
  $Is(d, Tclass.Options.Option(Options.Option$V))
     ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Datatype extensional equality declaration
function Options.Option#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Options.Option.None
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.None_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.None_q(b) } 
  Options.Option.None_q(a) && Options.Option.None_q(b)
     ==> (Options.Option#Equal(a, b) <==> true));

// Datatype extensional equality definition: #Options.Option.Some
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.Some_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.Some_q(b) } 
  Options.Option.Some_q(a) && Options.Option.Some_q(b)
     ==> (Options.Option#Equal(a, b)
       <==> Options.Option.value(a) == Options.Option.value(b)));

// Datatype extensionality axiom: Options.Option
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b) } 
  Options.Option#Equal(a, b) <==> a == b);

const unique class.Options.Option: ClassName;

const unique class.Options.__default: ClassName;

function Tclass.Options.__default() : Ty;

// Tclass.Options.__default Tag
axiom Tag(Tclass.Options.__default()) == Tagclass.Options.__default;

const unique Tagclass.Options.__default: TyTag;

// Box/unbox axiom for Tclass.Options.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Options.__default()) } 
  $IsBox(bx, Tclass.Options.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Options.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Options.__default()) } 
  $Is($o, Tclass.Options.__default())
     <==> $o == null || dtype($o) == Tclass.Options.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Options.__default(), $h) } 
  $IsAlloc($o, Tclass.Options.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Options._default.MapOption
function Options.__default.MapOption(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.MapOption#canCall(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
       == Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0));

// consequence axiom for Options.__default.MapOption
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
           <==> Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)))
         && (Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
           ==> Options.Option.value(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
             == Apply1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0)))
         && $Is(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0), 
          Tclass.Options.Option(Options._default.MapOption$V1)));

function Options.__default.MapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
     ==> Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.MapOption$V0, 
          Options._default.MapOption$V1, 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.MapOption(revealed)
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            #Options.Option.Some(Apply1(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, f#0, v#1)))));

// function declaration for Options._default.FlatMapOption
function Options.__default.FlatMapOption(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $h1, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $h0, 
          opt#0, 
          f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h0, 
        opt#0, 
        f#0)
       == Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h1, 
        opt#0, 
        f#0));

// consequence axiom for Options.__default.FlatMapOption
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.Some_q(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
              Options._default.FlatMapOption$V1, 
              $Heap, 
              opt#0, 
              f#0)))
         && (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.value(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
                Options._default.FlatMapOption$V1, 
                $Heap, 
                opt#0, 
                f#0))
             == Options.Option.value($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType))
         && $Is(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
            Options._default.FlatMapOption$V1, 
            $Heap, 
            opt#0, 
            f#0), 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)));

function Options.__default.FlatMapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $Heap, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)))
     ==> Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1), 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.FlatMapOption(revealed)
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            $Unbox(Apply1(Options._default.FlatMapOption$V0, 
                Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                $Heap, 
                f#0, 
                v#1)): DatatypeType)));

// Constructor function declaration
function #DiskLayout.Location.Location(int, int) : DatatypeType;

const unique ##DiskLayout.Location.Location: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: int :: 
  { #DiskLayout.Location.Location(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#DiskLayout.Location.Location(a#0#0#0, a#0#1#0))
     == ##DiskLayout.Location.Location);

function DiskLayout.Location.Location_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { DiskLayout.Location.Location_q(d) } 
  DiskLayout.Location.Location_q(d)
     <==> DatatypeCtorId(d) == ##DiskLayout.Location.Location);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { DiskLayout.Location.Location_q(d) } 
  DiskLayout.Location.Location_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: int :: 
      d == #DiskLayout.Location.Location(a#1#0#0, a#1#1#0)));

function Tclass.DiskLayout.Location() : Ty;

// Tclass.DiskLayout.Location Tag
axiom Tag(Tclass.DiskLayout.Location()) == Tagclass.DiskLayout.Location;

const unique Tagclass.DiskLayout.Location: TyTag;

// Box/unbox axiom for Tclass.DiskLayout.Location
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DiskLayout.Location()) } 
  $IsBox(bx, Tclass.DiskLayout.Location())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.DiskLayout.Location()));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: int :: 
  { $Is(#DiskLayout.Location.Location(a#2#0#0, a#2#1#0), Tclass.DiskLayout.Location()) } 
  $Is(#DiskLayout.Location.Location(a#2#0#0, a#2#1#0), Tclass.DiskLayout.Location())
     <==> $Is(a#2#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: int, $h: Heap :: 
  { $IsAlloc(#DiskLayout.Location.Location(a#3#0#0, a#3#1#0), 
      Tclass.DiskLayout.Location(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#DiskLayout.Location.Location(a#3#0#0, a#3#1#0), 
        Tclass.DiskLayout.Location(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DiskLayout.Location.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      DiskLayout.Location.Location_q(d)
       && $IsAlloc(d, Tclass.DiskLayout.Location(), $h)
     ==> $IsAlloc(DiskLayout.Location.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DiskLayout.Location.len(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      DiskLayout.Location.Location_q(d)
       && $IsAlloc(d, Tclass.DiskLayout.Location(), $h)
     ==> $IsAlloc(DiskLayout.Location.len(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: int :: 
  { #DiskLayout.Location.Location(LitInt(a#4#0#0), LitInt(a#4#1#0)) } 
  #DiskLayout.Location.Location(LitInt(a#4#0#0), LitInt(a#4#1#0))
     == Lit(#DiskLayout.Location.Location(a#4#0#0, a#4#1#0)));

function DiskLayout.Location.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: int :: 
  { #DiskLayout.Location.Location(a#5#0#0, a#5#1#0) } 
  DiskLayout.Location.addr(#DiskLayout.Location.Location(a#5#0#0, a#5#1#0))
     == a#5#0#0);

function DiskLayout.Location.len(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: int :: 
  { #DiskLayout.Location.Location(a#6#0#0, a#6#1#0) } 
  DiskLayout.Location.len(#DiskLayout.Location.Location(a#6#0#0, a#6#1#0))
     == a#6#1#0);

// Depth-one case-split function
function $IsA#DiskLayout.Location(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#DiskLayout.Location(d) } 
  $IsA#DiskLayout.Location(d) ==> DiskLayout.Location.Location_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { DiskLayout.Location.Location_q(d), $Is(d, Tclass.DiskLayout.Location()) } 
  $Is(d, Tclass.DiskLayout.Location()) ==> DiskLayout.Location.Location_q(d));

// Datatype extensional equality declaration
function DiskLayout.Location#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #DiskLayout.Location.Location
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DiskLayout.Location#Equal(a, b) } 
  true
     ==> (DiskLayout.Location#Equal(a, b)
       <==> DiskLayout.Location.addr(a) == DiskLayout.Location.addr(b)
         && DiskLayout.Location.len(a) == DiskLayout.Location.len(b)));

// Datatype extensionality axiom: DiskLayout.Location
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DiskLayout.Location#Equal(a, b) } 
  DiskLayout.Location#Equal(a, b) <==> a == b);

const unique class.DiskLayout.Location: ClassName;

const unique class.DiskLayout.__default: ClassName;

function Tclass.DiskLayout.__default() : Ty;

// Tclass.DiskLayout.__default Tag
axiom Tag(Tclass.DiskLayout.__default()) == Tagclass.DiskLayout.__default;

const unique Tagclass.DiskLayout.__default: TyTag;

// Box/unbox axiom for Tclass.DiskLayout.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DiskLayout.__default()) } 
  $IsBox(bx, Tclass.DiskLayout.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.DiskLayout.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.DiskLayout.__default()) } 
  $Is($o, Tclass.DiskLayout.__default())
     <==> $o == null || dtype($o) == Tclass.DiskLayout.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.DiskLayout.__default(), $h) } 
  $IsAlloc($o, Tclass.DiskLayout.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for DiskLayout._default.NumJournalBlocks
function DiskLayout.__default.NumJournalBlocks() : int;

function DiskLayout.__default.NumJournalBlocks#canCall() : bool;

// consequence axiom for DiskLayout.__default.NumJournalBlocks
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.NumJournalBlocks()
     && DiskLayout.__default.NumJournalBlocks() < 18446744073709551616;

function DiskLayout.__default.NumJournalBlocks#requires() : bool;

// #requires axiom for DiskLayout.__default.NumJournalBlocks
axiom DiskLayout.__default.NumJournalBlocks#requires() == true;

// definition axiom for DiskLayout.__default.NumJournalBlocks(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && DiskLayout.__default.NumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

// definition axiom for DiskLayout.__default.NumJournalBlocks for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && DiskLayout.__default.NumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

// function declaration for DiskLayout._default.IndirectionTableMaxLength
function DiskLayout.__default.IndirectionTableMaxLength() : int;

function DiskLayout.__default.IndirectionTableMaxLength#canCall() : bool;

// consequence axiom for DiskLayout.__default.IndirectionTableMaxLength
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.IndirectionTableMaxLength()
     && DiskLayout.__default.IndirectionTableMaxLength() < 18446744073709551616;

function DiskLayout.__default.IndirectionTableMaxLength#requires() : bool;

// #requires axiom for DiskLayout.__default.IndirectionTableMaxLength
axiom DiskLayout.__default.IndirectionTableMaxLength#requires() == true;

// definition axiom for DiskLayout.__default.IndirectionTableMaxLength(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && DiskLayout.__default.IndirectionTableMaxLength()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// definition axiom for DiskLayout.__default.IndirectionTableMaxLength for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && DiskLayout.__default.IndirectionTableMaxLength()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// function declaration for DiskLayout._default.IndirectionTable1Addr
function DiskLayout.__default.IndirectionTable1Addr() : int;

function DiskLayout.__default.IndirectionTable1Addr#canCall() : bool;

// consequence axiom for DiskLayout.__default.IndirectionTable1Addr
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.IndirectionTable1Addr()
     && DiskLayout.__default.IndirectionTable1Addr() < 18446744073709551616;

function DiskLayout.__default.IndirectionTable1Addr#requires() : bool;

// #requires axiom for DiskLayout.__default.IndirectionTable1Addr
axiom DiskLayout.__default.IndirectionTable1Addr#requires() == true;

// definition axiom for DiskLayout.__default.IndirectionTable1Addr(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.NumJournalBlocks#canCall()
     && DiskLayout.__default.IndirectionTable1Addr()
       == LitInt(Mul(LitInt(2), LitInt(4096))
           + Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));

// definition axiom for DiskLayout.__default.IndirectionTable1Addr for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.NumJournalBlocks#canCall()
     && DiskLayout.__default.IndirectionTable1Addr()
       == LitInt(Mul(LitInt(2), LitInt(4096))
           + Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));

// function declaration for DiskLayout._default.IndirectionTable2Addr
function DiskLayout.__default.IndirectionTable2Addr() : int;

function DiskLayout.__default.IndirectionTable2Addr#canCall() : bool;

// consequence axiom for DiskLayout.__default.IndirectionTable2Addr
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.IndirectionTable2Addr()
     && DiskLayout.__default.IndirectionTable2Addr() < 18446744073709551616;

function DiskLayout.__default.IndirectionTable2Addr#requires() : bool;

// #requires axiom for DiskLayout.__default.IndirectionTable2Addr
axiom DiskLayout.__default.IndirectionTable2Addr#requires() == true;

// definition axiom for DiskLayout.__default.IndirectionTable2Addr(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
     && DiskLayout.__default.IndirectionTableMaxLength#canCall()
     && DiskLayout.__default.IndirectionTable2Addr()
       == LitInt(DiskLayout.__default.IndirectionTable1Addr()
           + DiskLayout.__default.IndirectionTableMaxLength());

// definition axiom for DiskLayout.__default.IndirectionTable2Addr for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
     && DiskLayout.__default.IndirectionTableMaxLength#canCall()
     && DiskLayout.__default.IndirectionTable2Addr()
       == LitInt(DiskLayout.__default.IndirectionTable1Addr()
           + DiskLayout.__default.IndirectionTableMaxLength());

// function declaration for DiskLayout._default.JournalStartAddr
function DiskLayout.__default.JournalStartAddr() : int;

function DiskLayout.__default.JournalStartAddr#canCall() : bool;

// consequence axiom for DiskLayout.__default.JournalStartAddr
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.JournalStartAddr()
     && DiskLayout.__default.JournalStartAddr() < 18446744073709551616;

function DiskLayout.__default.JournalStartAddr#requires() : bool;

// #requires axiom for DiskLayout.__default.JournalStartAddr
axiom DiskLayout.__default.JournalStartAddr#requires() == true;

// definition axiom for DiskLayout.__default.JournalStartAddr(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.JournalStartAddr() == LitInt(Mul(LitInt(2), LitInt(4096)));

// definition axiom for DiskLayout.__default.JournalStartAddr for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.JournalStartAddr() == LitInt(Mul(LitInt(2), LitInt(4096)));

// function declaration for DiskLayout._default.JournalEndAddr
function DiskLayout.__default.JournalEndAddr() : int;

function DiskLayout.__default.JournalEndAddr#canCall() : bool;

// consequence axiom for DiskLayout.__default.JournalEndAddr
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.JournalEndAddr()
     && DiskLayout.__default.JournalEndAddr() < 18446744073709551616;

function DiskLayout.__default.JournalEndAddr#requires() : bool;

// #requires axiom for DiskLayout.__default.JournalEndAddr
axiom DiskLayout.__default.JournalEndAddr#requires() == true;

// definition axiom for DiskLayout.__default.JournalEndAddr(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.JournalStartAddr#canCall()
     && DiskLayout.__default.NumJournalBlocks#canCall()
     && DiskLayout.__default.JournalEndAddr()
       == LitInt(DiskLayout.__default.JournalStartAddr()
           + Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));

// definition axiom for DiskLayout.__default.JournalEndAddr for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.JournalStartAddr#canCall()
     && DiskLayout.__default.NumJournalBlocks#canCall()
     && DiskLayout.__default.JournalEndAddr()
       == LitInt(DiskLayout.__default.JournalStartAddr()
           + Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));

// function declaration for DiskLayout._default.JournalPoint
function DiskLayout.__default.JournalPoint(point#0: int) : int;

function DiskLayout.__default.JournalPoint#canCall(point#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalPoint
axiom true
   ==> (forall point#0: int :: 
    { DiskLayout.__default.JournalPoint(point#0) } 
    DiskLayout.__default.JournalPoint#canCall(point#0)
         || (
          LitInt(0) <= point#0
           && point#0 < 18446744073709551616
           && point#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> LitInt(0) <= DiskLayout.__default.JournalPoint(point#0)
         && DiskLayout.__default.JournalPoint(point#0) < 18446744073709551616);

function DiskLayout.__default.JournalPoint#requires(int) : bool;

// #requires axiom for DiskLayout.__default.JournalPoint
axiom (forall point#0: int :: 
  { DiskLayout.__default.JournalPoint#requires(point#0) } 
  LitInt(0) <= point#0 && point#0 < 18446744073709551616
     ==> DiskLayout.__default.JournalPoint#requires(point#0)
       == (point#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for DiskLayout.__default.JournalPoint(revealed)
axiom true
   ==> (forall point#0: int :: 
    { DiskLayout.__default.JournalPoint(point#0) } 
    DiskLayout.__default.JournalPoint#canCall(point#0)
         || (
          LitInt(0) <= point#0
           && point#0 < 18446744073709551616
           && point#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.JournalStartAddr#canCall()
         && DiskLayout.__default.JournalPoint(point#0)
           == DiskLayout.__default.JournalStartAddr() + Mul(point#0, LitInt(4096)));

// definition axiom for DiskLayout.__default.JournalPoint for all literals(revealed)
axiom true
   ==> (forall point#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalPoint(LitInt(point#0)) } 
    DiskLayout.__default.JournalPoint#canCall(LitInt(point#0))
         || (
          LitInt(0) <= point#0
           && point#0 < 18446744073709551616
           && LitInt(point#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.JournalStartAddr#canCall()
         && DiskLayout.__default.JournalPoint(LitInt(point#0))
           == LitInt(DiskLayout.__default.JournalStartAddr() + Mul(LitInt(point#0), LitInt(4096))));

// function declaration for DiskLayout._default.ValidIndirectionTableAddr
function DiskLayout.__default.ValidIndirectionTableAddr(addr#0: int) : bool;

function DiskLayout.__default.ValidIndirectionTableAddr#canCall(addr#0: int) : bool;

// consequence axiom for DiskLayout.__default.ValidIndirectionTableAddr
axiom true
   ==> (forall addr#0: int :: 
    { DiskLayout.__default.ValidIndirectionTableAddr(addr#0) } 
    DiskLayout.__default.ValidIndirectionTableAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> true);

function DiskLayout.__default.ValidIndirectionTableAddr#requires(int) : bool;

// #requires axiom for DiskLayout.__default.ValidIndirectionTableAddr
axiom (forall addr#0: int :: 
  { DiskLayout.__default.ValidIndirectionTableAddr#requires(addr#0) } 
  LitInt(0) <= addr#0 && addr#0 < 18446744073709551616
     ==> DiskLayout.__default.ValidIndirectionTableAddr#requires(addr#0) == true);

// definition axiom for DiskLayout.__default.ValidIndirectionTableAddr(revealed)
axiom true
   ==> (forall addr#0: int :: 
    { DiskLayout.__default.ValidIndirectionTableAddr(addr#0) } 
    DiskLayout.__default.ValidIndirectionTableAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> (Lit(true)
           ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
             && (addr#0 != LitInt(DiskLayout.__default.IndirectionTable1Addr())
               ==> DiskLayout.__default.IndirectionTable2Addr#canCall()))
         && DiskLayout.__default.ValidIndirectionTableAddr(addr#0)
           == (true
             && (addr#0 == LitInt(DiskLayout.__default.IndirectionTable1Addr())
               || addr#0 == LitInt(DiskLayout.__default.IndirectionTable2Addr()))));

// definition axiom for DiskLayout.__default.ValidIndirectionTableAddr for all literals(revealed)
axiom true
   ==> (forall addr#0: int :: 
    {:weight 3} { DiskLayout.__default.ValidIndirectionTableAddr(LitInt(addr#0)) } 
    DiskLayout.__default.ValidIndirectionTableAddr#canCall(LitInt(addr#0))
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> (Lit(true)
           ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
             && (LitInt(addr#0) != LitInt(DiskLayout.__default.IndirectionTable1Addr())
               ==> DiskLayout.__default.IndirectionTable2Addr#canCall()))
         && DiskLayout.__default.ValidIndirectionTableAddr(LitInt(addr#0))
           == (true
             && (LitInt(addr#0) == LitInt(DiskLayout.__default.IndirectionTable1Addr())
               || LitInt(addr#0) == LitInt(DiskLayout.__default.IndirectionTable2Addr()))));

// function declaration for DiskLayout._default.ValidNodeAddr
function DiskLayout.__default.ValidNodeAddr($ly: LayerType, addr#0: int) : bool;

function DiskLayout.__default.ValidNodeAddr#canCall(addr#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, addr#0: int :: 
  { DiskLayout.__default.ValidNodeAddr($LS($ly), addr#0) } 
  DiskLayout.__default.ValidNodeAddr($LS($ly), addr#0)
     == DiskLayout.__default.ValidNodeAddr($ly, addr#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, addr#0: int :: 
  { DiskLayout.__default.ValidNodeAddr(AsFuelBottom($ly), addr#0) } 
  DiskLayout.__default.ValidNodeAddr($ly, addr#0)
     == DiskLayout.__default.ValidNodeAddr($LZ, addr#0));

// consequence axiom for DiskLayout.__default.ValidNodeAddr
axiom true
   ==> (forall $ly: LayerType, addr#0: int :: 
    { DiskLayout.__default.ValidNodeAddr($ly, addr#0) } 
    DiskLayout.__default.ValidNodeAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> true);

function DiskLayout.__default.ValidNodeAddr#requires(LayerType, int) : bool;

// #requires axiom for DiskLayout.__default.ValidNodeAddr
axiom (forall $ly: LayerType, addr#0: int :: 
  { DiskLayout.__default.ValidNodeAddr#requires($ly, addr#0) } 
  LitInt(0) <= addr#0 && addr#0 < 18446744073709551616
     ==> DiskLayout.__default.ValidNodeAddr#requires($ly, addr#0) == true);

// definition axiom for DiskLayout.__default.ValidNodeAddr(revealed)
axiom true
   ==> (forall $ly: LayerType, addr#0: int :: 
    { DiskLayout.__default.ValidNodeAddr($LS($ly), addr#0) } 
    DiskLayout.__default.ValidNodeAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> Bounds.__default.NodeBlockSizeUint64#canCall()
         && (Mod(addr#0, LitInt(Bounds.__default.NodeBlockSizeUint64())) == LitInt(0)
           ==> Bounds.__default.NodeBlockSizeUint64#canCall()
             && Bounds.__default.MinNodeBlockIndexUint64#canCall())
         && DiskLayout.__default.ValidNodeAddr($LS($ly), addr#0)
           == (Mod(addr#0, LitInt(Bounds.__default.NodeBlockSizeUint64())) == LitInt(0)
             && addr#0
               >= LitInt(Mul(LitInt(Bounds.__default.NodeBlockSizeUint64()), 
                  LitInt(Bounds.__default.MinNodeBlockIndexUint64())))));

// definition axiom for DiskLayout.__default.ValidNodeAddr for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, addr#0: int :: 
    {:weight 3} { DiskLayout.__default.ValidNodeAddr($LS($ly), LitInt(addr#0)) } 
    DiskLayout.__default.ValidNodeAddr#canCall(LitInt(addr#0))
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> Bounds.__default.NodeBlockSizeUint64#canCall()
         && (LitInt(Mod(addr#0, LitInt(Bounds.__default.NodeBlockSizeUint64()))) == LitInt(0)
           ==> Bounds.__default.NodeBlockSizeUint64#canCall()
             && Bounds.__default.MinNodeBlockIndexUint64#canCall())
         && DiskLayout.__default.ValidNodeAddr($LS($ly), LitInt(addr#0))
           == (LitInt(Mod(addr#0, LitInt(Bounds.__default.NodeBlockSizeUint64()))) == LitInt(0)
             && LitInt(addr#0)
               >= LitInt(Mul(LitInt(Bounds.__default.NodeBlockSizeUint64()), 
                  LitInt(Bounds.__default.MinNodeBlockIndexUint64())))));

// function declaration for DiskLayout._default.ValidJournalLocation
function DiskLayout.__default.ValidJournalLocation($ly: LayerType, loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidJournalLocation#canCall(loc#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidJournalLocation($LS($ly), loc#0) } 
  DiskLayout.__default.ValidJournalLocation($LS($ly), loc#0)
     == DiskLayout.__default.ValidJournalLocation($ly, loc#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidJournalLocation(AsFuelBottom($ly), loc#0) } 
  DiskLayout.__default.ValidJournalLocation($ly, loc#0)
     == DiskLayout.__default.ValidJournalLocation($LZ, loc#0));

// consequence axiom for DiskLayout.__default.ValidJournalLocation
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidJournalLocation($ly, loc#0) } 
    DiskLayout.__default.ValidJournalLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> true);

function DiskLayout.__default.ValidJournalLocation#requires(LayerType, DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidJournalLocation
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidJournalLocation#requires($ly, loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidJournalLocation#requires($ly, loc#0) == true);

// definition axiom for DiskLayout.__default.ValidJournalLocation(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidJournalLocation($LS($ly), loc#0) } 
    DiskLayout.__default.ValidJournalLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(loc#0)
         && (Mod(DiskLayout.Location.addr(loc#0), LitInt(4096)) == LitInt(0)
           ==> DiskLayout.Location.Location_q(loc#0))
         && (DiskLayout.Location.Location_q(loc#0)
             && Mod(DiskLayout.Location.len(loc#0), LitInt(4096)) == LitInt(0)
           ==> DiskLayout.Location.Location_q(loc#0))
         && (DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.addr(loc#0) >= LitInt(Mul(LitInt(2), LitInt(4096)))
           ==> DiskLayout.Location.Location_q(loc#0)
             && (LitInt(0)
                 <= Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (DiskLayout.Location.Location_q(loc#0)
             && (LitInt(0)
                 <= Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0)
               <= Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
             && Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
               < DiskLayout.__default.NumJournalBlocks()
           ==> DiskLayout.Location.Location_q(loc#0) && DiskLayout.Location.Location_q(loc#0))
         && (DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.addr(loc#0)
               <= 18446744073709551615 - DiskLayout.Location.len(loc#0)
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && DiskLayout.__default.ValidJournalLocation($LS($ly), loc#0)
           == (
            Mod(DiskLayout.Location.addr(loc#0), LitInt(4096)) == LitInt(0)
             && Mod(DiskLayout.Location.len(loc#0), LitInt(4096)) == LitInt(0)
             && DiskLayout.Location.addr(loc#0) >= LitInt(Mul(LitInt(2), LitInt(4096)))
             && 
            LitInt(0)
               <= Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
             && Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
               < DiskLayout.__default.NumJournalBlocks()
             && DiskLayout.Location.addr(loc#0)
               <= 18446744073709551615 - DiskLayout.Location.len(loc#0)
             && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               <= LitInt(Mul(LitInt(2 + DiskLayout.__default.NumJournalBlocks()), LitInt(4096)))));

// definition axiom for DiskLayout.__default.ValidJournalLocation for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidJournalLocation($LS($ly), Lit(loc#0)) } 
    DiskLayout.__default.ValidJournalLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && (LitInt(Mod(DiskLayout.Location.addr(Lit(loc#0)), LitInt(4096))) == LitInt(0)
           ==> DiskLayout.Location.Location_q(Lit(loc#0)))
         && (DiskLayout.Location.Location_q(Lit(loc#0))
             && LitInt(Mod(DiskLayout.Location.len(Lit(loc#0)), LitInt(4096))) == LitInt(0)
           ==> DiskLayout.Location.Location_q(Lit(loc#0)))
         && (DiskLayout.Location.Location_q(Lit(loc#0))
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               >= LitInt(Mul(LitInt(2), LitInt(4096)))
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && (LitInt(0)
                 <= LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                    LitInt(4096)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (DiskLayout.Location.Location_q(Lit(loc#0))
             && (LitInt(0)
                 <= LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                    LitInt(4096)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0)
               <= LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                  LitInt(4096)))
             && Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                LitInt(4096))
               < DiskLayout.__default.NumJournalBlocks()
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0)))
         && (DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0))
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               <= LitInt(18446744073709551615 - DiskLayout.Location.len(Lit(loc#0)))
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && DiskLayout.__default.ValidJournalLocation($LS($ly), Lit(loc#0))
           == (
            LitInt(Mod(DiskLayout.Location.addr(Lit(loc#0)), LitInt(4096))) == LitInt(0)
             && LitInt(Mod(DiskLayout.Location.len(Lit(loc#0)), LitInt(4096))) == LitInt(0)
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               >= LitInt(Mul(LitInt(2), LitInt(4096)))
             && 
            LitInt(0)
               <= LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                  LitInt(4096)))
             && Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                LitInt(4096))
               < DiskLayout.__default.NumJournalBlocks()
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               <= LitInt(18446744073709551615 - DiskLayout.Location.len(Lit(loc#0)))
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
               <= LitInt(Mul(LitInt(2 + DiskLayout.__default.NumJournalBlocks()), LitInt(4096)))));

// function declaration for DiskLayout._default.ValidIndirectionTableLocation
function DiskLayout.__default.ValidIndirectionTableLocation(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidIndirectionTableLocation
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidIndirectionTableLocation(loc#0) } 
    DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> 
      DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
       ==> !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0));

function DiskLayout.__default.ValidIndirectionTableLocation#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidIndirectionTableLocation
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidIndirectionTableLocation#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidIndirectionTableLocation#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidIndirectionTableLocation(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidIndirectionTableLocation(loc#0) } 
    DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(loc#0)
         && DiskLayout.__default.ValidIndirectionTableAddr#canCall(DiskLayout.Location.addr(loc#0))
         && (DiskLayout.__default.ValidIndirectionTableAddr(DiskLayout.Location.addr(loc#0))
           ==> DiskLayout.Location.Location_q(loc#0)
             && (0 < DiskLayout.Location.len(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.IndirectionTableMaxLength#canCall()))
         && DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
           == (DiskLayout.__default.ValidIndirectionTableAddr(DiskLayout.Location.addr(loc#0))
             && 
            0 < DiskLayout.Location.len(loc#0)
             && DiskLayout.Location.len(loc#0)
               <= LitInt(DiskLayout.__default.IndirectionTableMaxLength())));

// definition axiom for DiskLayout.__default.ValidIndirectionTableLocation for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidIndirectionTableLocation(Lit(loc#0)) } 
    DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && DiskLayout.__default.ValidIndirectionTableAddr#canCall(LitInt(DiskLayout.Location.addr(Lit(loc#0))))
         && (Lit(DiskLayout.__default.ValidIndirectionTableAddr(LitInt(DiskLayout.Location.addr(Lit(loc#0)))))
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && (Lit(0 < DiskLayout.Location.len(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.IndirectionTableMaxLength#canCall()))
         && DiskLayout.__default.ValidIndirectionTableLocation(Lit(loc#0))
           == (DiskLayout.__default.ValidIndirectionTableAddr(LitInt(DiskLayout.Location.addr(Lit(loc#0))))
             && 
            0 < DiskLayout.Location.len(Lit(loc#0))
             && LitInt(DiskLayout.Location.len(Lit(loc#0)))
               <= LitInt(DiskLayout.__default.IndirectionTableMaxLength())));

// function declaration for DiskLayout._default.ValidNodeLocation
function DiskLayout.__default.ValidNodeLocation(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidNodeLocation#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidNodeLocation
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidNodeLocation(loc#0) } 
    DiskLayout.__default.ValidNodeLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> (DiskLayout.__default.ValidNodeLocation(loc#0)
           ==> !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
         && (DiskLayout.__default.ValidNodeLocation(loc#0)
           ==> !DiskLayout.__default.ValidIndirectionTableLocation(loc#0)));

function DiskLayout.__default.ValidNodeLocation#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidNodeLocation
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidNodeLocation#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidNodeLocation#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidNodeLocation(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidNodeLocation(loc#0) } 
    DiskLayout.__default.ValidNodeLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(loc#0)
         && DiskLayout.__default.ValidNodeAddr#canCall(DiskLayout.Location.addr(loc#0))
         && (DiskLayout.__default.ValidNodeAddr(StartFuel_DiskLayout._default.ValidNodeAddr, DiskLayout.Location.addr(loc#0))
           ==> DiskLayout.Location.Location_q(loc#0)
             && Bounds.__default.NodeBlockSizeUint64#canCall())
         && DiskLayout.__default.ValidNodeLocation(loc#0)
           == (DiskLayout.__default.ValidNodeAddr(StartFuel_DiskLayout._default.ValidNodeAddr, DiskLayout.Location.addr(loc#0))
             && DiskLayout.Location.len(loc#0) <= LitInt(Bounds.__default.NodeBlockSizeUint64())));

// definition axiom for DiskLayout.__default.ValidNodeLocation for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidNodeLocation(Lit(loc#0)) } 
    DiskLayout.__default.ValidNodeLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && DiskLayout.__default.ValidNodeAddr#canCall(LitInt(DiskLayout.Location.addr(Lit(loc#0))))
         && (DiskLayout.__default.ValidNodeAddr(StartFuel_DiskLayout._default.ValidNodeAddr, 
            LitInt(DiskLayout.Location.addr(Lit(loc#0))))
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && Bounds.__default.NodeBlockSizeUint64#canCall())
         && DiskLayout.__default.ValidNodeLocation(Lit(loc#0))
           == (DiskLayout.__default.ValidNodeAddr(StartFuel_DiskLayout._default.ValidNodeAddr, 
              LitInt(DiskLayout.Location.addr(Lit(loc#0))))
             && LitInt(DiskLayout.Location.len(Lit(loc#0)))
               <= LitInt(Bounds.__default.NodeBlockSizeUint64())));

// function declaration for DiskLayout._default.Superblock1Location
function DiskLayout.__default.Superblock1Location() : DatatypeType;

function DiskLayout.__default.Superblock1Location#canCall() : bool;

// consequence axiom for DiskLayout.__default.Superblock1Location
axiom true
   ==> 
  true
   ==> !Lit(DiskLayout.__default.ValidNodeLocation(Lit(DiskLayout.__default.Superblock1Location())))
     && !Lit(DiskLayout.__default.ValidIndirectionTableLocation(Lit(DiskLayout.__default.Superblock1Location())))
     && !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, 
      Lit(DiskLayout.__default.Superblock1Location()))
     && $Is(DiskLayout.__default.Superblock1Location(), Tclass.DiskLayout.Location());

function DiskLayout.__default.Superblock1Location#requires() : bool;

// #requires axiom for DiskLayout.__default.Superblock1Location
axiom DiskLayout.__default.Superblock1Location#requires() == true;

// definition axiom for DiskLayout.__default.Superblock1Location(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.Superblock1Location()
     == Lit(#DiskLayout.Location.Location(LitInt(0), LitInt(4096)));

// definition axiom for DiskLayout.__default.Superblock1Location for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.Superblock1Location()
     == Lit(#DiskLayout.Location.Location(LitInt(0), LitInt(4096)));

// function declaration for DiskLayout._default.Superblock2Location
function DiskLayout.__default.Superblock2Location() : DatatypeType;

function DiskLayout.__default.Superblock2Location#canCall() : bool;

// consequence axiom for DiskLayout.__default.Superblock2Location
axiom true
   ==> 
  true
   ==> !Lit(DiskLayout.__default.ValidNodeLocation(Lit(DiskLayout.__default.Superblock2Location())))
     && !Lit(DiskLayout.__default.ValidIndirectionTableLocation(Lit(DiskLayout.__default.Superblock2Location())))
     && !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, 
      Lit(DiskLayout.__default.Superblock2Location()))
     && $Is(DiskLayout.__default.Superblock2Location(), Tclass.DiskLayout.Location());

function DiskLayout.__default.Superblock2Location#requires() : bool;

// #requires axiom for DiskLayout.__default.Superblock2Location
axiom DiskLayout.__default.Superblock2Location#requires() == true;

// definition axiom for DiskLayout.__default.Superblock2Location(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.Superblock2Location()
     == Lit(#DiskLayout.Location.Location(LitInt(4096), LitInt(4096)));

// definition axiom for DiskLayout.__default.Superblock2Location for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.Superblock2Location()
     == Lit(#DiskLayout.Location.Location(LitInt(4096), LitInt(4096)));

// function declaration for DiskLayout._default.ValidSuperblock1Location
function DiskLayout.__default.ValidSuperblock1Location(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidSuperblock1Location#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidSuperblock1Location
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblock1Location(loc#0) } 
    DiskLayout.__default.ValidSuperblock1Location#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> (DiskLayout.__default.ValidSuperblock1Location(loc#0)
           ==> !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
         && (DiskLayout.__default.ValidSuperblock1Location(loc#0)
           ==> !DiskLayout.__default.ValidIndirectionTableLocation(loc#0))
         && (DiskLayout.__default.ValidSuperblock1Location(loc#0)
           ==> !DiskLayout.__default.ValidNodeLocation(loc#0)));

function DiskLayout.__default.ValidSuperblock1Location#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidSuperblock1Location
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidSuperblock1Location#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidSuperblock1Location#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidSuperblock1Location(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblock1Location(loc#0) } 
    DiskLayout.__default.ValidSuperblock1Location#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(loc#0)
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock1Location()))
         && DiskLayout.__default.Superblock1Location#canCall()
         && DiskLayout.__default.ValidSuperblock1Location(loc#0)
           == DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location()));

// definition axiom for DiskLayout.__default.ValidSuperblock1Location for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidSuperblock1Location(Lit(loc#0)) } 
    DiskLayout.__default.ValidSuperblock1Location#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(Lit(loc#0))
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock1Location()))
         && DiskLayout.__default.Superblock1Location#canCall()
         && DiskLayout.__default.ValidSuperblock1Location(Lit(loc#0))
           == DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location()));

// function declaration for DiskLayout._default.ValidSuperblock2Location
function DiskLayout.__default.ValidSuperblock2Location(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidSuperblock2Location
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblock2Location(loc#0) } 
    DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> (DiskLayout.__default.ValidSuperblock2Location(loc#0)
           ==> !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
         && (DiskLayout.__default.ValidSuperblock2Location(loc#0)
           ==> !DiskLayout.__default.ValidIndirectionTableLocation(loc#0))
         && (DiskLayout.__default.ValidSuperblock2Location(loc#0)
           ==> !DiskLayout.__default.ValidNodeLocation(loc#0)));

function DiskLayout.__default.ValidSuperblock2Location#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidSuperblock2Location
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidSuperblock2Location#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidSuperblock2Location#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidSuperblock2Location(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblock2Location(loc#0) } 
    DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(loc#0)
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock2Location()))
         && DiskLayout.__default.Superblock2Location#canCall()
         && DiskLayout.__default.ValidSuperblock2Location(loc#0)
           == DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock2Location()));

// definition axiom for DiskLayout.__default.ValidSuperblock2Location for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidSuperblock2Location(Lit(loc#0)) } 
    DiskLayout.__default.ValidSuperblock2Location#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(Lit(loc#0))
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock2Location()))
         && DiskLayout.__default.Superblock2Location#canCall()
         && DiskLayout.__default.ValidSuperblock2Location(Lit(loc#0))
           == DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock2Location()));

// function declaration for DiskLayout._default.ValidSuperblockLocation
function DiskLayout.__default.ValidSuperblockLocation(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidSuperblockLocation#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidSuperblockLocation
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblockLocation(loc#0) } 
    DiskLayout.__default.ValidSuperblockLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> 
      DiskLayout.__default.ValidSuperblockLocation(loc#0)
       ==> DiskLayout.__default.ValidSuperblock1Location(loc#0)
         || DiskLayout.__default.ValidSuperblock2Location(loc#0));

function DiskLayout.__default.ValidSuperblockLocation#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidSuperblockLocation
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidSuperblockLocation#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidSuperblockLocation#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidSuperblockLocation(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblockLocation(loc#0) } 
    DiskLayout.__default.ValidSuperblockLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(loc#0)
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock1Location()))
         && DiskLayout.__default.Superblock1Location#canCall()
         && (!DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location())
           ==> $IsA#DiskLayout.Location(loc#0)
             && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock2Location()))
             && DiskLayout.__default.Superblock2Location#canCall())
         && DiskLayout.__default.ValidSuperblockLocation(loc#0)
           == (DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location())
             || DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock2Location())));

// definition axiom for DiskLayout.__default.ValidSuperblockLocation for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidSuperblockLocation(Lit(loc#0)) } 
    DiskLayout.__default.ValidSuperblockLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(Lit(loc#0))
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock1Location()))
         && DiskLayout.__default.Superblock1Location#canCall()
         && (!DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location())
           ==> $IsA#DiskLayout.Location(Lit(loc#0))
             && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock2Location()))
             && DiskLayout.__default.Superblock2Location#canCall())
         && DiskLayout.__default.ValidSuperblockLocation(Lit(loc#0))
           == (DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location())
             || DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock2Location())));

// function declaration for DiskLayout._default.ValidLocation
function DiskLayout.__default.ValidLocation(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidLocation#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidLocation
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidLocation(loc#0) } 
    DiskLayout.__default.ValidLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> true);

function DiskLayout.__default.ValidLocation#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidLocation
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidLocation#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidLocation#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidLocation(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidLocation(loc#0) } 
    DiskLayout.__default.ValidLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.__default.ValidSuperblock1Location#canCall(loc#0)
         && (!DiskLayout.__default.ValidSuperblock1Location(loc#0)
           ==> DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0))
         && (DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0)
             && !DiskLayout.__default.ValidSuperblock2Location(loc#0)
           ==> DiskLayout.__default.ValidJournalLocation#canCall(loc#0))
         && (DiskLayout.__default.ValidJournalLocation#canCall(loc#0)
             && !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0)
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0))
         && (DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0)
             && !DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
           ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#0))
         && DiskLayout.__default.ValidLocation(loc#0)
           == (
            DiskLayout.__default.ValidSuperblock1Location(loc#0)
             || DiskLayout.__default.ValidSuperblock2Location(loc#0)
             || DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0)
             || DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
             || DiskLayout.__default.ValidNodeLocation(loc#0)));

// definition axiom for DiskLayout.__default.ValidLocation for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidLocation(Lit(loc#0)) } 
    DiskLayout.__default.ValidLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.__default.ValidSuperblock1Location#canCall(Lit(loc#0))
         && (!Lit(DiskLayout.__default.ValidSuperblock1Location(Lit(loc#0)))
           ==> DiskLayout.__default.ValidSuperblock2Location#canCall(Lit(loc#0)))
         && (DiskLayout.__default.ValidSuperblock2Location#canCall(Lit(loc#0))
             && !Lit(DiskLayout.__default.ValidSuperblock2Location(Lit(loc#0)))
           ==> DiskLayout.__default.ValidJournalLocation#canCall(Lit(loc#0)))
         && (DiskLayout.__default.ValidJournalLocation#canCall(Lit(loc#0))
             && !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, Lit(loc#0))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(loc#0)))
         && (DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(loc#0))
             && !Lit(DiskLayout.__default.ValidIndirectionTableLocation(Lit(loc#0)))
           ==> DiskLayout.__default.ValidNodeLocation#canCall(Lit(loc#0)))
         && DiskLayout.__default.ValidLocation(Lit(loc#0))
           == (
            DiskLayout.__default.ValidSuperblock1Location(Lit(loc#0))
             || DiskLayout.__default.ValidSuperblock2Location(Lit(loc#0))
             || DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, Lit(loc#0))
             || DiskLayout.__default.ValidIndirectionTableLocation(Lit(loc#0))
             || DiskLayout.__default.ValidNodeLocation(Lit(loc#0))));

// function declaration for DiskLayout._default.overlap
function DiskLayout.__default.overlap(loc#0: DatatypeType, loc'#0: DatatypeType) : bool;

function DiskLayout.__default.overlap#canCall(loc#0: DatatypeType, loc'#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.overlap
axiom true
   ==> (forall loc#0: DatatypeType, loc'#0: DatatypeType :: 
    { DiskLayout.__default.overlap(loc#0, loc'#0) } 
    DiskLayout.__default.overlap#canCall(loc#0, loc'#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && $Is(loc'#0, Tclass.DiskLayout.Location()))
       ==> true);

function DiskLayout.__default.overlap#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.overlap
axiom (forall loc#0: DatatypeType, loc'#0: DatatypeType :: 
  { DiskLayout.__default.overlap#requires(loc#0, loc'#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
       && $Is(loc'#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.overlap#requires(loc#0, loc'#0) == true);

// definition axiom for DiskLayout.__default.overlap(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, loc'#0: DatatypeType :: 
    { DiskLayout.__default.overlap(loc#0, loc'#0) } 
    DiskLayout.__default.overlap#canCall(loc#0, loc'#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && $Is(loc'#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(loc#0)
         && DiskLayout.Location.Location_q(loc#0)
         && DiskLayout.Location.Location_q(loc'#0)
         && (DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
             > DiskLayout.Location.addr(loc'#0)
           ==> DiskLayout.Location.Location_q(loc'#0)
             && DiskLayout.Location.Location_q(loc'#0)
             && DiskLayout.Location.Location_q(loc#0))
         && DiskLayout.__default.overlap(loc#0, loc'#0)
           == (DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               > DiskLayout.Location.addr(loc'#0)
             && DiskLayout.Location.addr(loc'#0) + DiskLayout.Location.len(loc'#0)
               > DiskLayout.Location.addr(loc#0)));

// definition axiom for DiskLayout.__default.overlap for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, loc'#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.overlap(Lit(loc#0), Lit(loc'#0)) } 
    DiskLayout.__default.overlap#canCall(Lit(loc#0), Lit(loc'#0))
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && $Is(loc'#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && DiskLayout.Location.Location_q(Lit(loc#0))
         && DiskLayout.Location.Location_q(Lit(loc'#0))
         && (Lit(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0))
               > DiskLayout.Location.addr(Lit(loc'#0)))
           ==> DiskLayout.Location.Location_q(Lit(loc'#0))
             && DiskLayout.Location.Location_q(Lit(loc'#0))
             && DiskLayout.Location.Location_q(Lit(loc#0)))
         && DiskLayout.__default.overlap(Lit(loc#0), Lit(loc'#0))
           == Lit(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0))
                 > DiskLayout.Location.addr(Lit(loc'#0))
               && DiskLayout.Location.addr(Lit(loc'#0)) + DiskLayout.Location.len(Lit(loc'#0))
                 > DiskLayout.Location.addr(Lit(loc#0))));

// function declaration for DiskLayout._default.JournalRangeLocation
function DiskLayout.__default.JournalRangeLocation(start#0: int, len#0: int) : DatatypeType;

function DiskLayout.__default.JournalRangeLocation#canCall(start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalRangeLocation
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalRangeLocation(start#0, len#0) } 
    DiskLayout.__default.JournalRangeLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          start#0 < DiskLayout.__default.NumJournalBlocks()
           && start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, 
          DiskLayout.__default.JournalRangeLocation(start#0, len#0))
         && $Is(DiskLayout.__default.JournalRangeLocation(start#0, len#0), 
          Tclass.DiskLayout.Location()));

function DiskLayout.__default.JournalRangeLocation#requires(int, int) : bool;

// #requires axiom for DiskLayout.__default.JournalRangeLocation
axiom (forall start#0: int, len#0: int :: 
  { DiskLayout.__default.JournalRangeLocation#requires(start#0, len#0) } 
  LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.JournalRangeLocation#requires(start#0, len#0)
       == (start#0 < DiskLayout.__default.NumJournalBlocks()
         && start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

const MoreFuel_DiskLayout._default.ValidJournalLocation0: LayerType;

// definition axiom for DiskLayout.__default.JournalRangeLocation(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalRangeLocation(start#0, len#0) } 
    DiskLayout.__default.JournalRangeLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          start#0 < DiskLayout.__default.NumJournalBlocks()
           && start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.JournalPoint#canCall(start#0)
         && 
        StartFuel_DiskLayout._default.ValidJournalLocation
           == $LS(MoreFuel_DiskLayout._default.ValidJournalLocation0)
         && StartFuelAssert_DiskLayout._default.ValidJournalLocation
           == $LS($LS(MoreFuel_DiskLayout._default.ValidJournalLocation0))
         && AsFuelBottom(MoreFuel_DiskLayout._default.ValidJournalLocation0)
           == MoreFuel_DiskLayout._default.ValidJournalLocation0
         && DiskLayout.__default.JournalRangeLocation(start#0, len#0)
           == #DiskLayout.Location.Location(DiskLayout.__default.JournalPoint(start#0), Mul(len#0, LitInt(4096))));

const MoreFuel_DiskLayout._default.ValidJournalLocation1: LayerType;

// definition axiom for DiskLayout.__default.JournalRangeLocation for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalRangeLocation(LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.JournalRangeLocation#canCall(LitInt(start#0), LitInt(len#0))
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Lit(start#0 < DiskLayout.__default.NumJournalBlocks())
           && LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.JournalPoint#canCall(LitInt(start#0))
         && 
        StartFuel_DiskLayout._default.ValidJournalLocation
           == $LS(MoreFuel_DiskLayout._default.ValidJournalLocation1)
         && StartFuelAssert_DiskLayout._default.ValidJournalLocation
           == $LS($LS(MoreFuel_DiskLayout._default.ValidJournalLocation1))
         && AsFuelBottom(MoreFuel_DiskLayout._default.ValidJournalLocation1)
           == MoreFuel_DiskLayout._default.ValidJournalLocation1
         && DiskLayout.__default.JournalRangeLocation(LitInt(start#0), LitInt(len#0))
           == Lit(#DiskLayout.Location.Location(LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0))), 
              LitInt(Mul(LitInt(len#0), LitInt(4096))))));

// function declaration for DiskLayout._default.locContainedInCircularJournalRange
function DiskLayout.__default.locContainedInCircularJournalRange(loc#0: DatatypeType, start#0: int, len#0: int) : bool;

function DiskLayout.__default.locContainedInCircularJournalRange#canCall(loc#0: DatatypeType, start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.locContainedInCircularJournalRange
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    { DiskLayout.__default.locContainedInCircularJournalRange(loc#0, start#0, len#0) } 
    DiskLayout.__default.locContainedInCircularJournalRange#canCall(loc#0, start#0, len#0)
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> true);

function DiskLayout.__default.locContainedInCircularJournalRange#requires(DatatypeType, int, int) : bool;

// #requires axiom for DiskLayout.__default.locContainedInCircularJournalRange
axiom (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
  { DiskLayout.__default.locContainedInCircularJournalRange#requires(loc#0, start#0, len#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.locContainedInCircularJournalRange#requires(loc#0, start#0, len#0)
       == (
        LitInt(0) <= start#0
         && start#0 < DiskLayout.__default.NumJournalBlocks()
         && 
        LitInt(0) <= len#0
         && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for DiskLayout.__default.locContainedInCircularJournalRange(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    { DiskLayout.__default.locContainedInCircularJournalRange(loc#0, start#0, len#0) } 
    DiskLayout.__default.locContainedInCircularJournalRange#canCall(loc#0, start#0, len#0)
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.JournalPoint#canCall(start#0)
             && (DiskLayout.Location.addr(loc#0) >= DiskLayout.__default.JournalPoint(start#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.JournalPoint#canCall(start#0 + len#0)))
         && (LitInt(DiskLayout.__default.NumJournalBlocks()) < start#0 + len#0
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.JournalPoint#canCall(start#0)
             && (DiskLayout.Location.addr(loc#0) >= DiskLayout.__default.JournalPoint(start#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks())))
             && (DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks()))
                 && LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
                   < DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(0))
                 && (DiskLayout.Location.addr(loc#0)
                     >= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                   ==> DiskLayout.Location.Location_q(loc#0)
                     && DiskLayout.Location.Location_q(loc#0)
                     && 
                    DiskLayout.__default.NumJournalBlocks#canCall()
                     && DiskLayout.__default.JournalPoint#canCall(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks()))))
         && DiskLayout.__default.locContainedInCircularJournalRange(loc#0, start#0, len#0)
           == (if start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then DiskLayout.Location.addr(loc#0) >= DiskLayout.__default.JournalPoint(start#0)
               && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                 <= DiskLayout.__default.JournalPoint(start#0 + len#0)
             else (DiskLayout.Location.addr(loc#0) >= DiskLayout.__default.JournalPoint(start#0)
                 && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                   <= LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks()))))
               || (DiskLayout.Location.addr(loc#0)
                   >= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                 && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                   <= DiskLayout.__default.JournalPoint(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks()))));

// definition axiom for DiskLayout.__default.locContainedInCircularJournalRange for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.locContainedInCircularJournalRange(Lit(loc#0), LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.locContainedInCircularJournalRange#canCall(Lit(loc#0), LitInt(start#0), LitInt(len#0))
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= LitInt(len#0)
           && LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0))
             && (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0 + len#0))))
         && (LitInt(DiskLayout.__default.NumJournalBlocks()) < LitInt(start#0 + len#0)
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0))
             && (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks())))
             && (DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks()))
                 && LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
                   < LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(0))
                 && (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                     >= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                   ==> DiskLayout.Location.Location_q(Lit(loc#0))
                     && DiskLayout.Location.Location_q(Lit(loc#0))
                     && 
                    DiskLayout.__default.NumJournalBlocks#canCall()
                     && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())))))
         && DiskLayout.__default.locContainedInCircularJournalRange(Lit(loc#0), LitInt(start#0), LitInt(len#0))
           == (if LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
               && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                 <= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0)))
             else (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                   >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
                 && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                   <= LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks()))))
               || (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                   >= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                 && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                   <= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks()))))));

// function declaration for DiskLayout._default.locDisjointFromCircularJournalRange
function DiskLayout.__default.locDisjointFromCircularJournalRange(loc#0: DatatypeType, start#0: int, len#0: int) : bool;

function DiskLayout.__default.locDisjointFromCircularJournalRange#canCall(loc#0: DatatypeType, start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.locDisjointFromCircularJournalRange
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    { DiskLayout.__default.locDisjointFromCircularJournalRange(loc#0, start#0, len#0) } 
    DiskLayout.__default.locDisjointFromCircularJournalRange#canCall(loc#0, start#0, len#0)
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> true);

function DiskLayout.__default.locDisjointFromCircularJournalRange#requires(DatatypeType, int, int) : bool;

// #requires axiom for DiskLayout.__default.locDisjointFromCircularJournalRange
axiom (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
  { DiskLayout.__default.locDisjointFromCircularJournalRange#requires(loc#0, start#0, len#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.locDisjointFromCircularJournalRange#requires(loc#0, start#0, len#0)
       == (
        LitInt(0) <= start#0
         && start#0 < DiskLayout.__default.NumJournalBlocks()
         && 
        LitInt(0) <= len#0
         && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for DiskLayout.__default.locDisjointFromCircularJournalRange(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    { DiskLayout.__default.locDisjointFromCircularJournalRange(loc#0, start#0, len#0) } 
    DiskLayout.__default.locDisjointFromCircularJournalRange#canCall(loc#0, start#0, len#0)
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.JournalPoint#canCall(start#0)
             && (DiskLayout.__default.JournalPoint(start#0)
                 < DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.JournalPoint#canCall(start#0 + len#0)))
         && (LitInt(DiskLayout.__default.NumJournalBlocks()) < start#0 + len#0
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.JournalPoint#canCall(LitInt(0))
             && (LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                 < DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks())))
             && (DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks()))
                 && LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
                   > DiskLayout.Location.addr(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())
                 && (DiskLayout.Location.addr(loc#0)
                     >= DiskLayout.__default.JournalPoint(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())
                   ==> DiskLayout.Location.Location_q(loc#0)
                     && DiskLayout.Location.Location_q(loc#0)
                     && DiskLayout.__default.JournalPoint#canCall(start#0))))
         && DiskLayout.__default.locDisjointFromCircularJournalRange(loc#0, start#0, len#0)
           == (if start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                 <= DiskLayout.__default.JournalPoint(start#0)
               || DiskLayout.Location.addr(loc#0)
                 >= DiskLayout.__default.JournalPoint(start#0 + len#0)
             else DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                 <= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
               || DiskLayout.Location.addr(loc#0)
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
               || (DiskLayout.Location.addr(loc#0)
                   >= DiskLayout.__default.JournalPoint(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())
                 && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                   <= DiskLayout.__default.JournalPoint(start#0))));

// definition axiom for DiskLayout.__default.locDisjointFromCircularJournalRange for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.locDisjointFromCircularJournalRange(Lit(loc#0), LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.locDisjointFromCircularJournalRange#canCall(Lit(loc#0), LitInt(start#0), LitInt(len#0))
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= LitInt(len#0)
           && LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0))
             && (LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
                 < LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0 + len#0))))
         && (LitInt(DiskLayout.__default.NumJournalBlocks()) < LitInt(start#0 + len#0)
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.JournalPoint#canCall(LitInt(0))
             && (LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                 < LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks())))
             && (DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks()))
                 && LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
                   > LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks()))
                 && (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                     >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())))
                   ==> DiskLayout.Location.Location_q(Lit(loc#0))
                     && DiskLayout.Location.Location_q(Lit(loc#0))
                     && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0)))))
         && DiskLayout.__default.locDisjointFromCircularJournalRange(Lit(loc#0), LitInt(start#0), LitInt(len#0))
           == (if LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                 <= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
               || LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0)))
             else LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                 <= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
               || LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
               || (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                   >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())))
                 && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                   <= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0))))));

// function declaration for DiskLayout._default.JournalPosAdd
function DiskLayout.__default.JournalPosAdd(start#0: int, span#0: int) : int;

function DiskLayout.__default.JournalPosAdd#canCall(start#0: int, span#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalPosAdd
axiom true
   ==> (forall start#0: int, span#0: int :: 
    { DiskLayout.__default.JournalPosAdd(start#0, span#0) } 
    true ==> true);

function DiskLayout.__default.JournalPosAdd#requires(int, int) : bool;

// #requires axiom for DiskLayout.__default.JournalPosAdd
axiom (forall start#0: int, span#0: int :: 
  { DiskLayout.__default.JournalPosAdd#requires(start#0, span#0) } 
  DiskLayout.__default.JournalPosAdd#requires(start#0, span#0) == true);

// definition axiom for DiskLayout.__default.JournalPosAdd(revealed)
axiom true
   ==> (forall start#0: int, span#0: int :: 
    { DiskLayout.__default.JournalPosAdd(start#0, span#0) } 
    true
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (start#0 + span#0 >= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && DiskLayout.__default.JournalPosAdd(start#0, span#0)
           == (if start#0 + span#0 >= LitInt(DiskLayout.__default.NumJournalBlocks())
             then start#0 + span#0 - DiskLayout.__default.NumJournalBlocks()
             else start#0 + span#0));

// definition axiom for DiskLayout.__default.JournalPosAdd for all literals(revealed)
axiom true
   ==> (forall start#0: int, span#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalPosAdd(LitInt(start#0), LitInt(span#0)) } 
    true
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (LitInt(start#0 + span#0) >= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && DiskLayout.__default.JournalPosAdd(LitInt(start#0), LitInt(span#0))
           == (if LitInt(start#0 + span#0) >= LitInt(DiskLayout.__default.NumJournalBlocks())
             then start#0 + span#0 - DiskLayout.__default.NumJournalBlocks()
             else start#0 + span#0));

// function declaration for DiskLayout._default.JournalFrontLocation
function DiskLayout.__default.JournalFrontLocation(start#0: int, len#0: int) : DatatypeType;

function DiskLayout.__default.JournalFrontLocation#canCall(start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalFrontLocation
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalFrontLocation(start#0, len#0) } 
    DiskLayout.__default.JournalFrontLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && start#0 < DiskLayout.__default.NumJournalBlocks())
       ==> $Is(DiskLayout.__default.JournalFrontLocation(start#0, len#0), 
        Tclass.Options.Option(Tclass.DiskLayout.Location())));

function DiskLayout.__default.JournalFrontLocation#requires(int, int) : bool;

// #requires axiom for DiskLayout.__default.JournalFrontLocation
axiom (forall start#0: int, len#0: int :: 
  { DiskLayout.__default.JournalFrontLocation#requires(start#0, len#0) } 
  LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.JournalFrontLocation#requires(start#0, len#0)
       == (start#0 < DiskLayout.__default.NumJournalBlocks()));

// definition axiom for DiskLayout.__default.JournalFrontLocation(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalFrontLocation(start#0, len#0) } 
    DiskLayout.__default.JournalFrontLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && start#0 < DiskLayout.__default.NumJournalBlocks())
       ==> (len#0 != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (DiskLayout.__default.NumJournalBlocks() - start#0 < len#0
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && DiskLayout.__default.JournalRangeLocation#canCall(start#0, 
              (if len#0 <= DiskLayout.__default.NumJournalBlocks() - start#0
                 then len#0
                 else DiskLayout.__default.NumJournalBlocks() - start#0)))
         && DiskLayout.__default.JournalFrontLocation(start#0, len#0)
           == (if len#0 == LitInt(0)
             then #Options.Option.None()
             else #Options.Option.Some($Box(DiskLayout.__default.JournalRangeLocation(start#0, 
                  (if len#0 <= DiskLayout.__default.NumJournalBlocks() - start#0
                     then len#0
                     else DiskLayout.__default.NumJournalBlocks() - start#0))))));

// definition axiom for DiskLayout.__default.JournalFrontLocation for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalFrontLocation(LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.JournalFrontLocation#canCall(LitInt(start#0), LitInt(len#0))
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && Lit(start#0 < DiskLayout.__default.NumJournalBlocks()))
       ==> (LitInt(len#0) != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (LitInt(DiskLayout.__default.NumJournalBlocks() - start#0) < LitInt(len#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && DiskLayout.__default.JournalRangeLocation#canCall(LitInt(start#0), 
              (if LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks() - start#0)
                 then len#0
                 else DiskLayout.__default.NumJournalBlocks() - start#0)))
         && DiskLayout.__default.JournalFrontLocation(LitInt(start#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.None()
             else #Options.Option.Some($Box(DiskLayout.__default.JournalRangeLocation(LitInt(start#0), 
                  (if LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks() - start#0)
                     then len#0
                     else DiskLayout.__default.NumJournalBlocks() - start#0))))));

// function declaration for DiskLayout._default.JournalBackLocation
function DiskLayout.__default.JournalBackLocation(start#0: int, len#0: int) : DatatypeType;

function DiskLayout.__default.JournalBackLocation#canCall(start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalBackLocation
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalBackLocation(start#0, len#0) } 
    DiskLayout.__default.JournalBackLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          start#0 < DiskLayout.__default.NumJournalBlocks()
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> $Is(DiskLayout.__default.JournalBackLocation(start#0, len#0), 
        Tclass.Options.Option(Tclass.DiskLayout.Location())));

function DiskLayout.__default.JournalBackLocation#requires(int, int) : bool;

// #requires axiom for DiskLayout.__default.JournalBackLocation
axiom (forall start#0: int, len#0: int :: 
  { DiskLayout.__default.JournalBackLocation#requires(start#0, len#0) } 
  LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.JournalBackLocation#requires(start#0, len#0)
       == (start#0 < DiskLayout.__default.NumJournalBlocks()
         && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for DiskLayout.__default.JournalBackLocation(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalBackLocation(start#0, len#0) } 
    DiskLayout.__default.JournalBackLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          start#0 < DiskLayout.__default.NumJournalBlocks()
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (len#0 != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (DiskLayout.__default.NumJournalBlocks() - start#0 < len#0
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalRangeLocation#canCall(LitInt(0), len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0))))
         && DiskLayout.__default.JournalBackLocation(start#0, len#0)
           == (if len#0 == LitInt(0)
             then #Options.Option.None()
             else (if len#0 <= DiskLayout.__default.NumJournalBlocks() - start#0
               then #Options.Option.None()
               else #Options.Option.Some($Box(DiskLayout.__default.JournalRangeLocation(LitInt(0), len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0)))))));

// definition axiom for DiskLayout.__default.JournalBackLocation for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalBackLocation(LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.JournalBackLocation#canCall(LitInt(start#0), LitInt(len#0))
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Lit(start#0 < DiskLayout.__default.NumJournalBlocks())
           && LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (LitInt(len#0) != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (LitInt(DiskLayout.__default.NumJournalBlocks() - start#0) < LitInt(len#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalRangeLocation#canCall(LitInt(0), LitInt(len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0)))))
         && DiskLayout.__default.JournalBackLocation(LitInt(start#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.None()
             else (if LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks() - start#0)
               then #Options.Option.None()
               else #Options.Option.Some($Box(Lit(DiskLayout.__default.JournalRangeLocation(LitInt(0), LitInt(len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0)))))))));

// function declaration for DiskLayout._default.LocationSub
function DiskLayout.__default.LocationSub(loc1#0: DatatypeType, loc2#0: DatatypeType) : bool;

function DiskLayout.__default.LocationSub#canCall(loc1#0: DatatypeType, loc2#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.LocationSub
axiom true
   ==> (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
    { DiskLayout.__default.LocationSub(loc1#0, loc2#0) } 
    DiskLayout.__default.LocationSub#canCall(loc1#0, loc2#0)
         || ($Is(loc1#0, Tclass.DiskLayout.Location())
           && $Is(loc2#0, Tclass.DiskLayout.Location()))
       ==> true);

function DiskLayout.__default.LocationSub#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.LocationSub
axiom (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
  { DiskLayout.__default.LocationSub#requires(loc1#0, loc2#0) } 
  $Is(loc1#0, Tclass.DiskLayout.Location())
       && $Is(loc2#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.LocationSub#requires(loc1#0, loc2#0) == true);

// definition axiom for DiskLayout.__default.LocationSub(revealed)
axiom true
   ==> (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
    { DiskLayout.__default.LocationSub(loc1#0, loc2#0) } 
    DiskLayout.__default.LocationSub#canCall(loc1#0, loc2#0)
         || ($Is(loc1#0, Tclass.DiskLayout.Location())
           && $Is(loc2#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(loc1#0)
         && DiskLayout.Location.Location_q(loc2#0)
         && (DiskLayout.Location.addr(loc1#0) >= DiskLayout.Location.addr(loc2#0)
           ==> DiskLayout.Location.Location_q(loc1#0)
             && DiskLayout.Location.Location_q(loc1#0)
             && 
            DiskLayout.Location.Location_q(loc2#0)
             && DiskLayout.Location.Location_q(loc2#0))
         && DiskLayout.__default.LocationSub(loc1#0, loc2#0)
           == (DiskLayout.Location.addr(loc1#0) >= DiskLayout.Location.addr(loc2#0)
             && DiskLayout.Location.addr(loc1#0) + DiskLayout.Location.len(loc1#0)
               <= DiskLayout.Location.addr(loc2#0) + DiskLayout.Location.len(loc2#0)));

// definition axiom for DiskLayout.__default.LocationSub for all literals(revealed)
axiom true
   ==> (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.LocationSub(Lit(loc1#0), Lit(loc2#0)) } 
    DiskLayout.__default.LocationSub#canCall(Lit(loc1#0), Lit(loc2#0))
         || ($Is(loc1#0, Tclass.DiskLayout.Location())
           && $Is(loc2#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(Lit(loc1#0))
         && DiskLayout.Location.Location_q(Lit(loc2#0))
         && (LitInt(DiskLayout.Location.addr(Lit(loc1#0)))
             >= LitInt(DiskLayout.Location.addr(Lit(loc2#0)))
           ==> DiskLayout.Location.Location_q(Lit(loc1#0))
             && DiskLayout.Location.Location_q(Lit(loc1#0))
             && 
            DiskLayout.Location.Location_q(Lit(loc2#0))
             && DiskLayout.Location.Location_q(Lit(loc2#0)))
         && DiskLayout.__default.LocationSub(Lit(loc1#0), Lit(loc2#0))
           == (LitInt(DiskLayout.Location.addr(Lit(loc1#0)))
               >= LitInt(DiskLayout.Location.addr(Lit(loc2#0)))
             && LitInt(DiskLayout.Location.addr(Lit(loc1#0)) + DiskLayout.Location.len(Lit(loc1#0)))
               <= LitInt(DiskLayout.Location.addr(Lit(loc2#0)) + DiskLayout.Location.len(Lit(loc2#0)))));

// function declaration for DiskLayout._default.JournalBlockIdx
function DiskLayout.__default.JournalBlockIdx($ly: LayerType, loc#0: DatatypeType) : int;

function DiskLayout.__default.JournalBlockIdx#canCall(loc#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.JournalBlockIdx($LS($ly), loc#0) } 
  DiskLayout.__default.JournalBlockIdx($LS($ly), loc#0)
     == DiskLayout.__default.JournalBlockIdx($ly, loc#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.JournalBlockIdx(AsFuelBottom($ly), loc#0) } 
  DiskLayout.__default.JournalBlockIdx($ly, loc#0)
     == DiskLayout.__default.JournalBlockIdx($LZ, loc#0));

// consequence axiom for DiskLayout.__default.JournalBlockIdx
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { DiskLayout.__default.JournalBlockIdx($ly, loc#0) } 
    DiskLayout.__default.JournalBlockIdx#canCall(loc#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
       ==> LitInt(0) <= DiskLayout.__default.JournalBlockIdx($ly, loc#0)
         && DiskLayout.__default.JournalBlockIdx($ly, loc#0)
           < DiskLayout.__default.NumJournalBlocks()
         && DiskLayout.Location.addr(loc#0)
           == DiskLayout.__default.JournalPoint(DiskLayout.__default.JournalBlockIdx($ly, loc#0)));

function DiskLayout.__default.JournalBlockIdx#requires(LayerType, DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.JournalBlockIdx
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.JournalBlockIdx#requires($ly, loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.JournalBlockIdx#requires($ly, loc#0)
       == DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0));

const MoreFuel_DiskLayout._default.ValidJournalLocation2: LayerType;

// definition axiom for DiskLayout.__default.JournalBlockIdx(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { DiskLayout.__default.JournalBlockIdx($LS($ly), loc#0) } 
    DiskLayout.__default.JournalBlockIdx#canCall(loc#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
       ==> DiskLayout.Location.Location_q(loc#0)
         && 
        StartFuel_DiskLayout._default.ValidJournalLocation
           == $LS(MoreFuel_DiskLayout._default.ValidJournalLocation2)
         && StartFuelAssert_DiskLayout._default.ValidJournalLocation
           == $LS($LS(MoreFuel_DiskLayout._default.ValidJournalLocation2))
         && AsFuelBottom(MoreFuel_DiskLayout._default.ValidJournalLocation2)
           == MoreFuel_DiskLayout._default.ValidJournalLocation2
         && DiskLayout.__default.JournalBlockIdx($LS($ly), loc#0)
           == Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096)));

const MoreFuel_DiskLayout._default.ValidJournalLocation3: LayerType;

// definition axiom for DiskLayout.__default.JournalBlockIdx for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.JournalBlockIdx($LS($ly), Lit(loc#0)) } 
    DiskLayout.__default.JournalBlockIdx#canCall(Lit(loc#0))
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, Lit(loc#0)))
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && 
        StartFuel_DiskLayout._default.ValidJournalLocation
           == $LS(MoreFuel_DiskLayout._default.ValidJournalLocation3)
         && StartFuelAssert_DiskLayout._default.ValidJournalLocation
           == $LS($LS(MoreFuel_DiskLayout._default.ValidJournalLocation3))
         && AsFuelBottom(MoreFuel_DiskLayout._default.ValidJournalLocation3)
           == MoreFuel_DiskLayout._default.ValidJournalLocation3
         && DiskLayout.__default.JournalBlockIdx($LS($ly), Lit(loc#0))
           == LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
              LitInt(4096))));

// function declaration for DiskLayout._default.otherIndirectionTableAddr
function DiskLayout.__default.otherIndirectionTableAddr(addr#0: int) : int;

function DiskLayout.__default.otherIndirectionTableAddr#canCall(addr#0: int) : bool;

// consequence axiom for DiskLayout.__default.otherIndirectionTableAddr
axiom true
   ==> (forall addr#0: int :: 
    { DiskLayout.__default.otherIndirectionTableAddr(addr#0) } 
    DiskLayout.__default.otherIndirectionTableAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> LitInt(0) <= DiskLayout.__default.otherIndirectionTableAddr(addr#0)
         && DiskLayout.__default.otherIndirectionTableAddr(addr#0) < 18446744073709551616);

function DiskLayout.__default.otherIndirectionTableAddr#requires(int) : bool;

// #requires axiom for DiskLayout.__default.otherIndirectionTableAddr
axiom (forall addr#0: int :: 
  { DiskLayout.__default.otherIndirectionTableAddr#requires(addr#0) } 
  LitInt(0) <= addr#0 && addr#0 < 18446744073709551616
     ==> DiskLayout.__default.otherIndirectionTableAddr#requires(addr#0) == true);

// definition axiom for DiskLayout.__default.otherIndirectionTableAddr(revealed)
axiom true
   ==> (forall addr#0: int :: 
    { DiskLayout.__default.otherIndirectionTableAddr(addr#0) } 
    DiskLayout.__default.otherIndirectionTableAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
         && (addr#0 == LitInt(DiskLayout.__default.IndirectionTable1Addr())
           ==> DiskLayout.__default.IndirectionTable2Addr#canCall())
         && (addr#0 != LitInt(DiskLayout.__default.IndirectionTable1Addr())
           ==> DiskLayout.__default.IndirectionTable1Addr#canCall())
         && DiskLayout.__default.otherIndirectionTableAddr(addr#0)
           == (if addr#0 == LitInt(DiskLayout.__default.IndirectionTable1Addr())
             then DiskLayout.__default.IndirectionTable2Addr()
             else DiskLayout.__default.IndirectionTable1Addr()));

// definition axiom for DiskLayout.__default.otherIndirectionTableAddr for all literals(revealed)
axiom true
   ==> (forall addr#0: int :: 
    {:weight 3} { DiskLayout.__default.otherIndirectionTableAddr(LitInt(addr#0)) } 
    DiskLayout.__default.otherIndirectionTableAddr#canCall(LitInt(addr#0))
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
         && (LitInt(addr#0) == LitInt(DiskLayout.__default.IndirectionTable1Addr())
           ==> DiskLayout.__default.IndirectionTable2Addr#canCall())
         && (LitInt(addr#0) != LitInt(DiskLayout.__default.IndirectionTable1Addr())
           ==> DiskLayout.__default.IndirectionTable1Addr#canCall())
         && DiskLayout.__default.otherIndirectionTableAddr(LitInt(addr#0))
           == (if LitInt(addr#0) == LitInt(DiskLayout.__default.IndirectionTable1Addr())
             then DiskLayout.__default.IndirectionTable2Addr()
             else DiskLayout.__default.IndirectionTable1Addr()));

const unique class.Sequences.__default: ClassName;

function Tclass.Sequences.__default() : Ty;

// Tclass.Sequences.__default Tag
axiom Tag(Tclass.Sequences.__default()) == Tagclass.Sequences.__default;

const unique Tagclass.Sequences.__default: TyTag;

// Box/unbox axiom for Tclass.Sequences.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Sequences.__default()) } 
  $IsBox(bx, Tclass.Sequences.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Sequences.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Sequences.__default()) } 
  $Is($o, Tclass.Sequences.__default())
     <==> $o == null || dtype($o) == Tclass.Sequences.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Sequences.__default(), $h) } 
  $IsAlloc($o, Tclass.Sequences.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Sequences._default.Last
function Sequences.__default.Last(Sequences._default.Last$E: Ty, run#0: Seq Box) : Box;

function Sequences.__default.Last#canCall(Sequences._default.Last$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Last
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> $IsBox(Sequences.__default.Last(Sequences._default.Last$E, run#0), 
        Sequences._default.Last$E));

function Sequences.__default.Last#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Last
axiom (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.Last#requires(Sequences._default.Last$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Last$E))
     ==> Sequences.__default.Last#requires(Sequences._default.Last$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.Last(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, run#0)
         == Seq#Index(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.Last for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0)) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0))
         == Seq#Index(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.DropLast
function Sequences.__default.DropLast(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : Seq Box;

function Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.DropLast
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> $Is(Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0), 
        TSeq(Sequences._default.DropLast$E)));

function Sequences.__default.DropLast#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.DropLast
axiom (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.DropLast$E))
     ==> Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.DropLast(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0)
         == Seq#Take(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.DropLast for all literals(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0)) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0))
         == Seq#Take(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.Set
function Sequences.__default.Set(Sequences._default.Set$T: Ty, run#0: Seq Box) : Set Box;

function Sequences.__default.Set#canCall(Sequences._default.Set$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Set
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> $Is(Sequences.__default.Set(Sequences._default.Set$T, run#0), 
        TSet(Sequences._default.Set$T)));

function Sequences.__default.Set#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Set
axiom (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Set$T))
     ==> Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) == true);

// definition axiom for Sequences.__default.Set(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.Set$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.Set for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0)) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.Set$T) && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.ISet
function Sequences.__default.ISet(Sequences._default.ISet$T: Ty, run#0: Seq Box) : ISet Box;

function Sequences.__default.ISet#canCall(Sequences._default.ISet$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.ISet
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> $Is(Sequences.__default.ISet(Sequences._default.ISet$T, run#0), 
        TISet(Sequences._default.ISet$T)));

function Sequences.__default.ISet#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.ISet
axiom (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.ISet$T))
     ==> Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) == true);

// definition axiom for Sequences.__default.ISet(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.ISet$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.ISet for all literals(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0)) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.ISet$T)
             && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.NoDupes
function Sequences.__default.NoDupes(Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box) : bool;

function Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, AsFuelBottom($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LZ, a#0));

// consequence axiom for Sequences.__default.NoDupes
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> true);

function Sequences.__default.NoDupes#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.NoDupes
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0) } 
  $Is(a#0, TSeq(Sequences._default.NoDupes$T))
     ==> Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.NoDupes(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
         == (forall i#0: int, j#0: int :: 
          { Seq#Index(a#0, j#0), Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 < Seq#Length(a#0)
               && 
              LitInt(0) <= j#0
               && j#0 < Seq#Length(a#0)
               && i#0 != j#0
             ==> Seq#Index(a#0, i#0) != Seq#Index(a#0, j#0)));

// definition axiom for Sequences.__default.NoDupes for all literals(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0)) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, Lit(a#0))
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0))
         == (forall i#1: int, j#1: int :: 
          { Seq#Index(a#0, j#1), Seq#Index(a#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1 < Seq#Length(Lit(a#0))
               && 
              LitInt(0) <= j#1
               && j#1 < Seq#Length(Lit(a#0))
               && i#1 != j#1
             ==> Seq#Index(Lit(a#0), i#1) != Seq#Index(Lit(a#0), j#1)));

// function declaration for Sequences._default.IndexOf
function Sequences.__default.IndexOf(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : int;

function Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : bool;

// consequence axiom for Sequences.__default.IndexOf
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> LitInt(0) <= Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           < Seq#Length(s#0)
         && Seq#Index(s#0, Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0))
           == e#0);

function Sequences.__default.IndexOf#requires(Ty, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.IndexOf
axiom (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
  { Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
       && $IsBox(e#0, Sequences._default.IndexOf$T)
     ==> Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0)
       == Seq#Contains(s#0, e#0));

function $let#0_i(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : int;

function $let#0$canCall(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : bool;

axiom (forall Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box :: 
  { $let#0_i(Sequences._default.IndexOf$T, s, e) } 
  $let#0$canCall(Sequences._default.IndexOf$T, s, e)
     ==> LitInt(0) <= $let#0_i(Sequences._default.IndexOf$T, s, e)
       && $let#0_i(Sequences._default.IndexOf$T, s, e) < Seq#Length(s)
       && Seq#Index(s, $let#0_i(Sequences._default.IndexOf$T, s, e)) == e);

// definition axiom for Sequences.__default.IndexOf(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           == (var i#0 := $let#0_i(Sequences._default.IndexOf$T, s#0, e#0); i#0));

// definition axiom for Sequences.__default.IndexOf for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0)
           == (var i#1 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), e#0); i#1));

// definition axiom for Sequences.__default.IndexOf for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
           == (var i#2 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)); i#2));

// function declaration for Sequences._default.Range
function Sequences.__default.Range($ly: LayerType, n#0: int) : Seq Box;

function Sequences.__default.Range#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range($LS($ly), n#0) } 
  Sequences.__default.Range($LS($ly), n#0) == Sequences.__default.Range($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range(AsFuelBottom($ly), n#0) } 
  Sequences.__default.Range($ly, n#0) == Sequences.__default.Range($LZ, n#0));

// consequence axiom for Sequences.__default.Range
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($ly, n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> Seq#Length(Sequences.__default.Range($ly, n#0)) == n#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int == i#0)
         && $Is(Sequences.__default.Range($ly, n#0), TSeq(TInt)));

function Sequences.__default.Range#requires(LayerType, int) : bool;

// #requires axiom for Sequences.__default.Range
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range#requires($ly, n#0) } 
  Sequences.__default.Range#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.Range(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($LS($ly), n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0) ==> Sequences.__default.Range#canCall(n#0 - 1))
         && Sequences.__default.Range($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($ly, n#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(n#0 - 1)))));

// definition axiom for Sequences.__default.Range for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { Sequences.__default.Range($LS($ly), LitInt(n#0)) } 
    Sequences.__default.Range#canCall(LitInt(n#0)) || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.Range#canCall(LitInt(n#0 - 1)))
         && Sequences.__default.Range($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($LS($ly), LitInt(n#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(n#0 - 1))))));

// function declaration for Sequences._default.Apply
function Sequences.__default.Apply(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Apply#canCall(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $h0, f#0, run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h0, f#0, run#0)
       == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Apply
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
                i#2)
               == Apply1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Apply$R)));

function Sequences.__default.Apply#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
       && $Is(run#0, TSeq(Sequences._default.Apply$E))
     ==> Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.Apply(revealed)
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, 
        Sequences._default.Apply$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Apply#canCall(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Apply(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                Apply1(Sequences._default.Apply$E, 
                  Sequences._default.Apply$R, 
                  $Heap, 
                  f#0, 
                  Seq#Index(run#0, LitInt(0)))), 
              Sequences.__default.Apply(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $ly, 
                $Heap, 
                f#0, 
                Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.ApplyOpaque
function Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LZ, 
      $Heap, 
      f#0, 
      run#0));

// frame axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $h1, 
      f#0, 
      run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $h0, 
          f#0, 
          run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h0, 
        f#0, 
        run#0)
       == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h1, 
        f#0, 
        run#0));

// consequence axiom for Sequences.__default.ApplyOpaque
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
              Sequences._default.ApplyOpaque$R, 
              $ly, 
              $Heap, 
              f#0, 
              run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $ly, 
                $Heap, 
                f#0, 
                run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                  Sequences._default.ApplyOpaque$R, 
                  $ly, 
                  $Heap, 
                  f#0, 
                  run#0), 
                i#2)
               == Apply1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $ly, 
            $Heap, 
            f#0, 
            run#0), 
          TSeq(Sequences._default.ApplyOpaque$R)));

function Sequences.__default.ApplyOpaque#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
       && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
     ==> Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.ApplyOpaque(revealed)
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> Sequences.__default.Apply#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         && Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == Sequences.__default.Apply(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($LZ), 
            $Heap, 
            f#0, 
            run#0));

// function declaration for Sequences._default.Filter
function Sequences.__default.Filter(Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Filter#canCall(Sequences._default.Filter$E: Ty, $heap: Heap, f#0: HandleType, run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, AsFuelBottom($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $h0, f#0, run#0)
         || ($Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists _x0#0: Box, _o0#0: ref :: 
            $IsBox(_x0#0, Sequences._default.Filter$E)
               && $Is(_o0#0, Tclass._System.object?())
               && Reads1(Sequences._default.Filter$E, TBool, $h0, f#0, _x0#0)[$Box(_o0#0)]
               && $Box($o) == $Box(_o0#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h0, f#0, run#0)
       == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Filter
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#0))))
       ==> Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
           <= Seq#Length(run#0)
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
              i#1) } 
          LitInt(0) <= i#1
             ==> 
            i#1
                 < Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
               && Requires1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))
             ==> $Unbox(Apply1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))): bool)
         && $Is(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Filter$E)));

function Sequences.__default.Filter#requires(Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
       && $Is(run#0, TSeq(Sequences._default.Filter$E))
     ==> Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
       == (forall i#2: int :: 
        { Seq#Index(run#0, i#2) } 
        true
           ==> 
          LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))));

// definition axiom for Sequences.__default.Filter(revealed)
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#2: int :: 
            { Seq#Index(run#0, i#2) } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append((if $Unbox(Apply1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, LitInt(0)))): bool
                 then Seq#Build(Seq#Empty(): Seq Box, Seq#Index(run#0, LitInt(0)))
                 else Seq#Empty(): Seq Box), 
              Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.FoldLeft
function Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldLeft
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> $IsBox(Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldLeft$A));

function Sequences.__default.FoldLeft#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldLeft
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Sequences._default.FoldLeft$A))
       && $IsBox(init#0, Sequences._default.FoldLeft$A)
       && $Is(run#0, TSeq(Sequences._default.FoldLeft$E))
     ==> Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldLeft(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(run#0, LitInt(0))), 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $ly, 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(run#0, LitInt(0))), 
              Seq#Drop(run#0, LitInt(1)))));

// definition axiom for Sequences.__default.FoldLeft for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// definition axiom for Sequences.__default.FoldLeft for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            Lit(f#0), 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              Lit(f#0), 
              Lit(init#0), 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              Lit(f#0), 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                Lit(f#0), 
                Lit(init#0), 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// function declaration for Sequences._default.FoldRight
function Sequences.__default.FoldRight(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldRight
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> $IsBox(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldRight$A));

function Sequences.__default.FoldRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldRight
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Sequences._default.FoldRight$A))
       && $IsBox(init#0, Sequences._default.FoldRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldRight$E))
     ==> Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Seq#Drop(run#0, LitInt(1))), 
              Seq#Index(run#0, LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Seq#Drop(Lit(run#0), LitInt(1)))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            Lit(f#0), 
            Lit(init#0), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                  Sequences._default.FoldRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Seq#Drop(Lit(run#0), LitInt(1))))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// function declaration for Sequences._default.FoldFromRight
function Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldFromRight
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> $IsBox(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldFromRight$A));

function Sequences.__default.FoldFromRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldFromRight
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Sequences._default.FoldFromRight$A))
       && $IsBox(init#0, Sequences._default.FoldFromRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E))
     ==> Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldFromRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, run#0)
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, run#0))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0)), 
              Sequences.__default.Last(Sequences._default.FoldFromRight$E, run#0))));

// definition axiom for Sequences.__default.FoldFromRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0)))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// definition axiom for Sequences.__default.FoldFromRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Lit(f#0), 
              Lit(init#0), 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                  Sequences._default.FoldFromRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// function declaration for Sequences._default.remove
function Sequences.__default.remove(Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int)
   : Seq Box;

function Sequences.__default.remove#canCall(Sequences._default.remove$A: Ty, s#0: Seq Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, AsFuelBottom($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $LZ, s#0, pos#0));

// consequence axiom for Sequences.__default.remove
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1) } 
          pos#0 <= i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1)
               == Seq#Index(s#0, i#1 + 1))
         && $Is(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), 
          TSeq(Sequences._default.remove$A)));

function Sequences.__default.remove#requires(Ty, LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.remove
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.remove$A))
     ==> Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.remove(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
         == Seq#Append(Seq#Take(s#0, pos#0), Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.remove for all literals(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    {:weight 3} { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0)) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, Lit(s#0), LitInt(pos#0))
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0))
         == Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.insert
function Sequences.__default.insert(Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.insert#canCall(Sequences._default.insert$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.insert
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 <= i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.insert$A)));

function Sequences.__default.insert#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.insert
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.insert$A))
       && $IsBox(a#0, Sequences._default.insert$A)
     ==> Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 <= Seq#Length(s#0)));

// definition axiom for Sequences.__default.insert(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0)));

// definition axiom for Sequences.__default.insert for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// definition axiom for Sequences.__default.insert for all literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// function declaration for Sequences._default.replace1with2
function Sequences.__default.replace1with2(Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A: Ty, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, AsFuelBottom($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LZ, s#0, a#0, b#0, pos#0));

// consequence axiom for Sequences.__default.replace1with2
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0)
           == a#0
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0 + 1)
           == b#0
         && $Is(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
          TSeq(Sequences._default.replace1with2$A)));

function Sequences.__default.replace1with2#requires(Ty, LayerType, Seq Box, Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace1with2
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace1with2$A))
       && $IsBox(a#0, Sequences._default.replace1with2$A)
       && $IsBox(b#0, Sequences._default.replace1with2$A)
     ==> Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.replace1with2(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.replace1with2 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), a#0, b#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// definition axiom for Sequences.__default.replace1with2 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
        $LS($ly), 
        Lit(s#0), 
        Lit(a#0), 
        Lit(b#0), 
        LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), Lit(a#0), Lit(b#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
          $LS($ly), 
          Lit(s#0), 
          Lit(a#0), 
          Lit(b#0), 
          LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, Lit(a#0)), Lit(b#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.replace2with1
function Sequences.__default.replace2with1(Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.replace2with1
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Seq#Length(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#1)
               == Seq#Index(s#0, i#1 + 1))
         && Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.replace2with1$A)));

function Sequences.__default.replace2with1#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace2with1
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace2with1$A))
       && $IsBox(a#0, Sequences._default.replace2with1$A)
     ==> Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0) - 1));

// definition axiom for Sequences.__default.replace2with1(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0 + 2)));

// definition axiom for Sequences.__default.replace2with1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// definition axiom for Sequences.__default.replace2with1 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// function declaration for Sequences._default.concat
function Sequences.__default.concat(Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat#canCall(Sequences._default.concat$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.concat
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Seq#Length(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0))
           == Seq#Length(a#0) + Seq#Length(b#0)
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0))
         && (forall i#1: int :: 
          { Seq#Index(b#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(b#0)
             ==> Seq#Index(b#0, i#1)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
                Seq#Length(a#0) + i#1))
         && $Is(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
          TSeq(Sequences._default.concat$A)));

function Sequences.__default.concat#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.concat$A))
       && $Is(b#0, TSeq(Sequences._default.concat$A))
     ==> Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.concat(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
         == Seq#Append(a#0, b#0));

// definition axiom for Sequences.__default.concat for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0))
         == Seq#Append(a#0, b#0));

// function declaration for Sequences._default.concat3
function Sequences.__default.concat3(Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat3#canCall(Sequences._default.concat3$A: Ty, a#0: Seq Box, b#0: Box, c#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, AsFuelBottom($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $LZ, a#0, b#0, c#0));

// consequence axiom for Sequences.__default.concat3
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Seq#Length(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0))
           == Seq#Length(a#0) + Seq#Length(c#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
              i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                i#0))
         && Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
            Seq#Length(a#0))
           == b#0
         && (forall i#1: int :: 
          { Seq#Index(c#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(c#0)
             ==> Seq#Index(c#0, i#1)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                Seq#Length(a#0) + 1 + i#1))
         && $Is(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
          TSeq(Sequences._default.concat3$A)));

function Sequences.__default.concat3#requires(Ty, LayerType, Seq Box, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat3
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
  $Is(a#0, TSeq(Sequences._default.concat3$A))
       && $IsBox(b#0, Sequences._default.concat3$A)
       && $Is(c#0, TSeq(Sequences._default.concat3$A))
     ==> Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
       == true);

// definition axiom for Sequences.__default.concat3(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), b#0, Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), Lit(b#0), Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, Lit(b#0))), c#0));

// function declaration for Sequences._default.concatSeq
function Sequences.__default.concatSeq(Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box) : Seq Box;

function Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, AsFuelBottom($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LZ, a#0));

// consequence axiom for Sequences.__default.concatSeq
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> $Is(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0), 
        TSeq(Sequences._default.concatSeq$A)));

function Sequences.__default.concatSeq#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.concatSeq
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0) } 
  $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
     ==> Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.concatSeq(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), a#0)
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), a#0))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), a#0)): Seq Box)));

// definition axiom for Sequences.__default.concatSeq for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0)) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, Lit(a#0))
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0))
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), Lit(a#0))): Seq Box)));

// function declaration for Sequences._default.IsPrefix
function Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsPrefix
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> 
      Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       ==> Seq#Length(a#0) <= Seq#Length(b#0));

function Sequences.__default.IsPrefix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsPrefix
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsPrefix$A))
       && $Is(b#0, TSeq(Sequences._default.IsPrefix$A))
     ==> Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsPrefix(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Take(b#0, Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsPrefix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Take(Lit(b#0), Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.IsSuffix
function Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsSuffix
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> true);

function Sequences.__default.IsSuffix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsSuffix
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsSuffix$A))
       && $Is(b#0, TSeq(Sequences._default.IsSuffix$A))
     ==> Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsSuffix(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Drop(b#0, Seq#Length(b#0) - Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsSuffix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.SeqIndexIterate
function Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : DatatypeType;

function Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A: Ty, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, AsFuelBottom($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LZ, run#0, needle#0, i#0));

// consequence axiom for Sequences.__default.SeqIndexIterate
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> (forall j#0: int :: 
            { Seq#Index(run#0, j#0) } 
            i#0 <= j#0 && j#0 < Seq#Length(run#0) ==> Seq#Index(run#0, j#0) != needle#0))
         && $Is(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndexIterate#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.SeqIndexIterate
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
       && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
     ==> Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(run#0)));

// definition axiom for Sequences.__default.SeqIndexIterate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (i#0 != Seq#Length(run#0)
           ==> 
          Seq#Index(run#0, i#0) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0 + 1))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
           == (if i#0 == Seq#Length(run#0)
             then #Options.Option.None()
             else (if Seq#Index(run#0, i#0) == needle#0
               then #Options.Option.Some($Box(i#0))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        needle#0, 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            needle#0, 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == needle#0
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                needle#0, 
                LitInt(i#0 + 1)))));

// definition axiom for Sequences.__default.SeqIndexIterate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        Lit(needle#0), 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != Lit(needle#0)
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == Lit(needle#0)
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                Lit(needle#0), 
                LitInt(i#0 + 1)))));

// function declaration for Sequences._default.SeqIndex
function Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box)
   : DatatypeType;

function Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A: Ty, run#0: Seq Box, needle#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, AsFuelBottom($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LZ, run#0, needle#0));

// consequence axiom for Sequences.__default.SeqIndex
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Seq#Index(run#0, i#0) != needle#0))
         && $Is(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndex#requires(Ty, LayerType, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndex
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndex$A))
       && $IsBox(needle#0, Sequences._default.SeqIndex$A)
     ==> Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
       == true);

// definition axiom for Sequences.__default.SeqIndex(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, run#0, needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            run#0, 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0)) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0))
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0), LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0))
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(0)));

// function declaration for Sequences._default.SeqOfLength
function Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box)
   : Seq Box;

function Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V: Ty, length#0: int, v#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, AsFuelBottom($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LZ, length#0, v#0));

// consequence axiom for Sequences.__default.SeqOfLength
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
           == length#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
              i#0) } 
          LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
             ==> Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
                i#0)
               == v#0)
         && $Is(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
          TSeq(Sequences._default.SeqOfLength$V)));

function Sequences.__default.SeqOfLength#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqOfLength
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
  LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V)
     ==> Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
       == true);

// definition axiom for Sequences.__default.SeqOfLength(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (length#0 != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0 - 1, v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
           == (if length#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0 - 1, v#0))));

// definition axiom for Sequences.__default.SeqOfLength for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0)
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), v#0))));

// definition axiom for Sequences.__default.SeqOfLength for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0)) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), Lit(v#0))
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), Lit(v#0)))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0))
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, Lit(v#0)), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), Lit(v#0)))));

// function declaration for Sequences._default.SeqIndexUpdate
function Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box)
   : Seq Box;

function Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T: Ty, s#0: Seq Box, i#0: int, t#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, AsFuelBottom($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LZ, s#0, i#0, t#0));

// consequence axiom for Sequences.__default.SeqIndexUpdate
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Seq#Equal(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          Seq#Update(s#0, i#0, t#0))
         && $Is(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          TSeq(Sequences._default.SeqIndexUpdate$T)));

function Sequences.__default.SeqIndexUpdate#requires(Ty, LayerType, Seq Box, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndexUpdate
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
  $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
     ==> Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
       == (i#0 + 1 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.SeqIndexUpdate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(s#0, i#0 + 1)));

// definition axiom for Sequences.__default.SeqIndexUpdate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0)
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexUpdate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0)) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), Lit(t#0))
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(t#0))), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// function declaration for Sequences._default.Zip
function Sequences.__default.Zip(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : Seq Box;

function Sequences.__default.Zip#canCall(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.Zip
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
           == Seq#Length(a#0)
         && (forall i#0: int :: 
          { Seq#Index(b#0, i#0) } 
            { Seq#Index(a#0, i#0) } 
            { $Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                i#0)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
             ==> _System.Tuple2#Equal($Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                  i#0)): DatatypeType, 
              #_System._tuple#2._#Make2(Seq#Index(a#0, i#0), Seq#Index(b#0, i#0))))
         && $Is(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
          TSeq(Tclass._System.Tuple2(Sequences._default.Zip$A, Sequences._default.Zip$B))));

function Sequences.__default.Zip#requires(Ty, Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.Zip
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.Zip$A))
       && $Is(b#0, TSeq(Sequences._default.Zip$B))
     ==> Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
       == 
      (Seq#Length(a#0)
       == Seq#Length(b#0)));

// definition axiom for Sequences.__default.Zip(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, b#0)
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
              Sequences.__default.DropLast(Sequences._default.Zip$B, b#0))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, b#0))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $ly, 
                Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
                Sequences.__default.DropLast(Sequences._default.Zip$B, b#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#_System._tuple#2._#Make2(Sequences.__default.Last(Sequences._default.Zip$A, a#0), 
                    Sequences.__default.Last(Sequences._default.Zip$B, b#0)))))));

// definition axiom for Sequences.__default.Zip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(Lit(a#0)) == Seq#Length(Lit(b#0)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, Lit(b#0))
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0))))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, Lit(b#0)))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#_System._tuple#2._#Make2(Lit(Sequences.__default.Last(Sequences._default.Zip$A, Lit(a#0))), 
                      Lit(Sequences.__default.Last(Sequences._default.Zip$B, Lit(b#0))))))))));

// function declaration for Sequences._default.Unzip
function Sequences.__default.Unzip(Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box)
   : DatatypeType;

function Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A: Ty, Sequences._default.Unzip$B: Ty, z#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0));

// fuel synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, AsFuelBottom($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LZ, z#0));

// consequence axiom for Sequences.__default.Unzip
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> Seq#Length($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
         && Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length(z#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(z#0, i#0)): DatatypeType } 
            { Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
            { Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(z#0)
             ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0), 
                Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0)), 
              $Unbox(Seq#Index(z#0, i#0)): DatatypeType))
         && $Is(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0), 
          Tclass._System.Tuple2(TSeq(Sequences._default.Unzip$A), TSeq(Sequences._default.Unzip$B))));

function Sequences.__default.Unzip#requires(Ty, Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Unzip
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
  $Is(z#0, 
      TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
     ==> Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
       == true);

// definition axiom for Sequences.__default.Unzip(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(z#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                z#0))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType)
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
           == (if Seq#Length(z#0) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#0, b#0 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._0($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType)))), 
                $Box(Seq#Append(b#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._1($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType))))))));

// definition axiom for Sequences.__default.Unzip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0)) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, Lit(z#0))
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(Lit(z#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  Lit(z#0))))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType)))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0))
           == (if Seq#Length(Lit(z#0)) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#1, b#1 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._0(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType)))))), 
                $Box(Seq#Append(b#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._1(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType))))))))));

// function declaration for Sequences._default.FlattenShape
function Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box)
   : Seq Box;

function Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.FlattenShape
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
           == Seq#Length(seqs#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(seqs#0, i#0)): Seq Box } 
            { $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
             ==> $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                  i#0)): int
               == Seq#Length($Unbox(Seq#Index(seqs#0, i#0)): Seq Box))
         && $Is(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
          TSeq(Tclass._System.nat())));

function Sequences.__default.FlattenShape#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenShape
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
     ==> Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0)
       == true);

// definition axiom for Sequences.__default.FlattenShape(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0)
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), seqs#0)): Seq Box))))));

// definition axiom for Sequences.__default.FlattenShape for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length(Lit($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))): Seq Box)))))));

// function declaration for Sequences._default.FlattenLength
function Sequences.__default.FlattenLength($ly: LayerType, shape#0: Seq Box) : int;

function Sequences.__default.FlattenLength#canCall(shape#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
  Sequences.__default.FlattenLength($LS($ly), shape#0)
     == Sequences.__default.FlattenLength($ly, shape#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength(AsFuelBottom($ly), shape#0) } 
  Sequences.__default.FlattenLength($ly, shape#0)
     == Sequences.__default.FlattenLength($LZ, shape#0));

// consequence axiom for Sequences.__default.FlattenLength
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($ly, shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) == LitInt(0)
           ==> Sequences.__default.FlattenLength($ly, shape#0) == LitInt(0))
         && LitInt(0) <= Sequences.__default.FlattenLength($ly, shape#0));

function Sequences.__default.FlattenLength#requires(LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenLength
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength#requires($ly, shape#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat()))
     ==> Sequences.__default.FlattenLength#requires($ly, shape#0) == true);

// definition axiom for Sequences.__default.FlattenLength(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), shape#0))
         && Sequences.__default.FlattenLength($LS($ly), shape#0)
           == (if Seq#Length(shape#0) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), shape#0)): int));

// definition axiom for Sequences.__default.FlattenLength for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenLength($LS($ly), Lit(shape#0)) } 
    Sequences.__default.FlattenLength#canCall(Lit(shape#0))
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(Lit(shape#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), Lit(shape#0)))
         && Sequences.__default.FlattenLength($LS($ly), Lit(shape#0))
           == (if Seq#Length(Lit(shape#0)) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($LS($ly), Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), Lit(shape#0))): int));

// function declaration for Sequences._default.Flatten
function Sequences.__default.Flatten(Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box) : Seq Box;

function Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.Flatten
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Sequences._default.Flatten$A, StartFuel_Sequences._default.FlattenShape, seqs#0))
         && (Seq#Length(seqs#0) == LitInt(0)
           ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
             == LitInt(0))
         && $Is(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0), 
          TSeq(Sequences._default.Flatten$A)));

function Sequences.__default.Flatten#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Flatten
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
     ==> Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0)
       == true);

const MoreFuel_Sequences._default.FlattenShape0: LayerType;

// definition axiom for Sequences.__default.Flatten(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), seqs#0)
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), seqs#0))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape0)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape0)
           == MoreFuel_Sequences._default.FlattenShape0
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), seqs#0)): Seq Box)));

const MoreFuel_Sequences._default.FlattenShape1: LayerType;

// definition axiom for Sequences.__default.Flatten for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape1)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape1)
           == MoreFuel_Sequences._default.FlattenShape1
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))): Seq Box)));

// function declaration for Sequences._default.FlattenIndex
function Sequences.__default.FlattenIndex(shape#0: Seq Box, i#0: int, j#0: int) : int;

function Sequences.__default.FlattenIndex#canCall(shape#0: Seq Box, i#0: int, j#0: int) : bool;

// consequence axiom for Sequences.__default.FlattenIndex
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> LitInt(0) <= Sequences.__default.FlattenIndex(shape#0, i#0, j#0));

function Sequences.__default.FlattenIndex#requires(Seq Box, int, int) : bool;

// #requires axiom for Sequences.__default.FlattenIndex
axiom (forall shape#0: Seq Box, i#0: int, j#0: int :: 
  { Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0 && LitInt(0) <= j#0
     ==> Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0)
       == (i#0 < Seq#Length(shape#0) && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int));

// definition axiom for Sequences.__default.FlattenIndex(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> Sequences.__default.FlattenLength#canCall(Seq#Take(shape#0, i#0))
         && Sequences.__default.FlattenIndex(shape#0, i#0, j#0)
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Seq#Take(shape#0, i#0))
             + j#0);

// definition axiom for Sequences.__default.FlattenIndex for all literals(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    {:weight 3} { Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0)) } 
    Sequences.__default.FlattenIndex#canCall(Lit(shape#0), LitInt(i#0), LitInt(j#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(Lit(shape#0))
           && j#0 < $Unbox(Seq#Index(Lit(shape#0), LitInt(i#0))): int)
       ==> Sequences.__default.FlattenLength#canCall(Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
         && Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
             + j#0);

// function declaration for Sequences._default.UnflattenIndex
function Sequences.__default.UnflattenIndex($ly: LayerType, shape#0: Seq Box, i#0: int) : DatatypeType;

function Sequences.__default.UnflattenIndex#canCall(shape#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
     == Sequences.__default.UnflattenIndex($ly, shape#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex(AsFuelBottom($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($ly, shape#0, i#0)
     == Sequences.__default.UnflattenIndex($LZ, shape#0, i#0));

// consequence axiom for Sequences.__default.UnflattenIndex
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($ly, shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> $Is(Sequences.__default.UnflattenIndex($ly, shape#0, i#0), 
        Tclass._System.Tuple2(Tclass._System.nat(), Tclass._System.nat())));

function Sequences.__default.UnflattenIndex#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.UnflattenIndex
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0
     ==> Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0)
       == (i#0
         < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0)));

const MoreFuel_Sequences._default.FlattenLength0: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
         && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.UnflattenIndex#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0)))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength0)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength0)
           == MoreFuel_Sequences._default.FlattenLength0
         && Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             then Sequences.__default.UnflattenIndex($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0)
             else #_System._tuple#2._#Make2($Box(Seq#Length(shape#0) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Sequences.__default.DropLast(Tclass._System.nat(), shape#0))))));

const MoreFuel_Sequences._default.FlattenLength1: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    {:weight 3} { Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0)) } 
    Sequences.__default.UnflattenIndex#canCall(Lit(shape#0), LitInt(i#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Lit(shape#0)))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
         && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.UnflattenIndex#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0)))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0)))))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength1)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength1)
           == MoreFuel_Sequences._default.FlattenLength1
         && Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0))
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             then Sequences.__default.UnflattenIndex($LS($ly), 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0))
             else #_System._tuple#2._#Make2($Box(Seq#Length(Lit(shape#0)) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))))));

// function declaration for Sequences._default.fill
function Sequences.__default.fill(Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box) : Seq Box;

function Sequences.__default.fill#canCall(Sequences._default.fill$T: Ty, n#0: int, t#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, AsFuelBottom($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $LZ, n#0, t#0));

// consequence axiom for Sequences.__default.fill
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> Seq#Length(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0))
           == n#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0)
               == t#0)
         && $Is(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), 
          TSeq(Sequences._default.fill$T)));

function Sequences.__default.fill#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.fill
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0) } 
  $IsBox(t#0, Sequences._default.fill$T)
     ==> Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0)
       == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.fill(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> (n#0 != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0 - 1, t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0 - 1, t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0)
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for all literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0)) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), Lit(t#0))
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), Lit(t#0)))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), Lit(t#0)), 
              Seq#Build(Seq#Empty(): Seq Box, Lit(t#0)))));

const unique class.SeqComparison.__default: ClassName;

function Tclass.SeqComparison.__default() : Ty;

// Tclass.SeqComparison.__default Tag
axiom Tag(Tclass.SeqComparison.__default()) == Tagclass.SeqComparison.__default;

const unique Tagclass.SeqComparison.__default: TyTag;

// Box/unbox axiom for Tclass.SeqComparison.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SeqComparison.__default()) } 
  $IsBox(bx, Tclass.SeqComparison.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.SeqComparison.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.SeqComparison.__default()) } 
  $Is($o, Tclass.SeqComparison.__default())
     <==> $o == null || dtype($o) == Tclass.SeqComparison.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.SeqComparison.__default(), $h) } 
  $IsAlloc($o, Tclass.SeqComparison.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for SeqComparison._default.lte
function SeqComparison.__default.lte($ly: LayerType, a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
  SeqComparison.__default.lte($LS($ly), a#0, b#0)
     == SeqComparison.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  SeqComparison.__default.lte($ly, a#0, b#0)
     == SeqComparison.__default.lte($LZ, a#0, b#0));

// consequence axiom for SeqComparison.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($ly, a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lte
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte#requires($ly, a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lte#requires($ly, a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int <= $Unbox(Seq#Index(a#0, LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(a#0, LitInt(0))): int <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(a#0, LitInt(0))): int < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int < $Unbox(Seq#Index(a#0, LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($ly, Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0)
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(Lit(b#0)) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(Lit(b#0)) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))))));

// function declaration for SeqComparison._default.lt
function SeqComparison.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for SeqComparison.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lt#requires(a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && SeqComparison.__default.lt(a#0, b#0)
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0)
             && !Seq#Equal(a#0, b#0)));

// definition axiom for SeqComparison.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lt(Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && SeqComparison.__default.lt(Lit(a#0), Lit(b#0))
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

const unique class.NativeArrays.__default: ClassName;

function Tclass.NativeArrays.__default() : Ty;

// Tclass.NativeArrays.__default Tag
axiom Tag(Tclass.NativeArrays.__default()) == Tagclass.NativeArrays.__default;

const unique Tagclass.NativeArrays.__default: TyTag;

// Box/unbox axiom for Tclass.NativeArrays.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeArrays.__default()) } 
  $IsBox(bx, Tclass.NativeArrays.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeArrays.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeArrays.__default()) } 
  $Is($o, Tclass.NativeArrays.__default())
     <==> $o == null || dtype($o) == Tclass.NativeArrays.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeArrays.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeArrays.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

procedure {:extern "NativeArrays_Compile", "newArrayFill"} CheckWellformed$$NativeArrays.__default.newArrayFill(NativeArrays._default.newArrayFill$T: Ty, 
    n#0: int where LitInt(0) <= n#0 && n#0 < 18446744073709551616, 
    t#0: Box
       where $IsBox(t#0, NativeArrays._default.newArrayFill$T)
         && $IsAllocBox(t#0, NativeArrays._default.newArrayFill$T, $Heap))
   returns (ar#0: ref
       where $Is(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T))
         && $IsAlloc(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:extern "NativeArrays_Compile", "newArrayFill"} Call$$NativeArrays.__default.newArrayFill(NativeArrays._default.newArrayFill$T: Ty, 
    n#0: int where LitInt(0) <= n#0 && n#0 < 18446744073709551616, 
    t#0: Box
       where $IsBox(t#0, NativeArrays._default.newArrayFill$T)
         && $IsAllocBox(t#0, NativeArrays._default.newArrayFill$T, $Heap))
   returns (ar#0: ref
       where $Is(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T))
         && $IsAlloc(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures _System.array.Length(ar#0) == n#0;
  free ensures true;
  ensures (forall i#0: int :: 
    { read($Heap, ar#0, IndexField(i#0)) } 
    LitInt(0) <= i#0 && i#0 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < n#0
       ==> read($Heap, ar#0, IndexField(i#0)) == t#0);
  free ensures true;
  ensures ar#0 != null && !read(old($Heap), ar#0, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:extern "NativeArrays_Compile", "CopyArrayIntoDifferentArray"} CheckWellformed$$NativeArrays.__default.CopyArrayIntoDifferentArray(NativeArrays._default.CopyArrayIntoDifferentArray$A: Ty, 
    src#0: ref
       where $Is(src#0, Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A))
         && $IsAlloc(src#0, 
          Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A), 
          $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A))
         && $IsAlloc(dst#0, 
          Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A), 
          $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:extern "NativeArrays_Compile", "CopyArrayIntoDifferentArray"} Call$$NativeArrays.__default.CopyArrayIntoDifferentArray(NativeArrays._default.CopyArrayIntoDifferentArray$A: Ty, 
    src#0: ref
       where $Is(src#0, Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A))
         && $IsAlloc(src#0, 
          Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A), 
          $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A))
         && $IsAlloc(dst#0, 
          Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A), 
          $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  // user-defined preconditions
  requires srcIndex#0 + len#0 <= _System.array.Length(src#0);
  requires dstIndex#0 + len#0 <= _System.array.Length(dst#0);
  requires src#0 != dst#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall i#0: int :: 
    { Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0) } 
      { read($Heap, dst#0, IndexField(i#0)) } 
    true
       ==> 
      LitInt(0) <= i#0 && i#0 < _System.array.Length(dst#0)
       ==> read($Heap, dst#0, IndexField(i#0))
         == (if dstIndex#0 <= i#0 && i#0 < dstIndex#0 + len#0
           then read(old($Heap), src#0, IndexField(i#0 - dstIndex#0 + srcIndex#0))
           else Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0)));
  free ensures true;
  ensures (forall i#1: int :: 
    { read(old($Heap), src#0, IndexField(i#1)) } 
    true
       ==> 
      srcIndex#0 <= i#1 && i#1 < srcIndex#0 + len#0
       ==> read(old($Heap), src#0, IndexField(i#1))
         == read($Heap, dst#0, IndexField(i#1 - srcIndex#0 + dstIndex#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == dst#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// ValueType.Value: subset type $Is
axiom (forall s#0: Seq Box :: 
  { $Is(s#0, Tclass.ValueType.Value()) } 
  $Is(s#0, Tclass.ValueType.Value())
     <==> $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) <= LitInt(1024));

// ValueType.Value: subset type $IsAlloc
axiom (forall s#0: Seq Box, $h: Heap :: 
  { $IsAlloc(s#0, Tclass.ValueType.Value(), $h) } 
  $IsAlloc(s#0, Tclass.ValueType.Value(), $h)
     <==> $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $h));

const unique class.ValueType.__default: ClassName;

function Tclass.ValueType.__default() : Ty;

// Tclass.ValueType.__default Tag
axiom Tag(Tclass.ValueType.__default()) == Tagclass.ValueType.__default;

const unique Tagclass.ValueType.__default: TyTag;

// Box/unbox axiom for Tclass.ValueType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.__default()) } 
  $IsBox(bx, Tclass.ValueType.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueType.__default()) } 
  $Is($o, Tclass.ValueType.__default())
     <==> $o == null || dtype($o) == Tclass.ValueType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueType.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueType._default.MaxLen
function ValueType.__default.MaxLen() : int;

function ValueType.__default.MaxLen#canCall() : bool;

// consequence axiom for ValueType.__default.MaxLen
axiom true
   ==> 
  true
   ==> LitInt(0) <= ValueType.__default.MaxLen()
     && ValueType.__default.MaxLen() < 18446744073709551616;

function ValueType.__default.MaxLen#requires() : bool;

// #requires axiom for ValueType.__default.MaxLen
axiom ValueType.__default.MaxLen#requires() == true;

// definition axiom for ValueType.__default.MaxLen(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// definition axiom for ValueType.__default.MaxLen for all literals(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// function declaration for ValueType._default.DefaultValue
function ValueType.__default.DefaultValue() : Seq Box;

function ValueType.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueType.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueType.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueType.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueType.__default.DefaultValue
axiom ValueType.__default.DefaultValue#requires() == true;

// definition axiom for ValueType.__default.DefaultValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// definition axiom for ValueType.__default.DefaultValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// function declaration for ValueType._default.Len
function ValueType.__default.Len(v#0: Seq Box) : int;

function ValueType.__default.Len#canCall(v#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.Len
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> LitInt(0) <= ValueType.__default.Len(v#0));

function ValueType.__default.Len#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.Len
axiom (forall v#0: Seq Box :: 
  { ValueType.__default.Len#requires(v#0) } 
  $Is(v#0, Tclass.ValueType.Value())
     ==> ValueType.__default.Len#requires(v#0) == true);

// definition axiom for ValueType.__default.Len(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(v#0) == Seq#Length(v#0));

// definition axiom for ValueType.__default.Len for all literals(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    {:weight 3} { ValueType.__default.Len(Lit(v#0)) } 
    ValueType.__default.Len#canCall(Lit(v#0)) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(Lit(v#0)) == Seq#Length(Lit(v#0)));

// function declaration for ValueType._default.ValidMessageBytestring
function ValueType.__default.ValidMessageBytestring(s#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestring#canCall(s#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestring
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function ValueType.__default.ValidMessageBytestring#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestring
axiom (forall s#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestring#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueType.__default.ValidMessageBytestring#requires(s#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestring(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(s#0)
           == (Seq#Length(s#0) <= LitInt(ValueType.__default.MaxLen())));

// definition axiom for ValueType.__default.ValidMessageBytestring for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestring(Lit(s#0)) } 
    ValueType.__default.ValidMessageBytestring#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(Lit(s#0))
           == (Seq#Length(Lit(s#0)) <= LitInt(ValueType.__default.MaxLen())));

// function declaration for ValueType._default.ValidMessageBytestrings
function ValueType.__default.ValidMessageBytestrings(strs#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestrings#canCall(strs#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestrings
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function ValueType.__default.ValidMessageBytestrings#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestrings
axiom (forall strs#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestrings#requires(strs#0) } 
  $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueType.__default.ValidMessageBytestrings#requires(strs#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestrings(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#0: int :: 
          { $Unbox(Seq#Index(strs#0, i#0)): Seq Box } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(strs#0)
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(strs#0, i#0)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(strs#0)
           == (forall i#0: int :: 
            { $Unbox(Seq#Index(strs#0, i#0)): Seq Box } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(strs#0)
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(strs#0, i#0)): Seq Box)));

// definition axiom for ValueType.__default.ValidMessageBytestrings for all literals(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestrings(Lit(strs#0)) } 
    ValueType.__default.ValidMessageBytestrings#canCall(Lit(strs#0))
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(strs#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(strs#0))
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(Lit(strs#0), i#1)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(Lit(strs#0))
           == (forall i#1: int :: 
            { $Unbox(Seq#Index(strs#0, i#1)): Seq Box } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(strs#0))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(Lit(strs#0), i#1)): Seq Box)));

const #$Delta: Ty;

const unique class.ValueMessage.Delta: ClassName;

const unique class.ValueMessage.__default: ClassName;

function Tclass.ValueMessage.__default() : Ty;

// Tclass.ValueMessage.__default Tag
axiom Tag(Tclass.ValueMessage.__default()) == Tagclass.ValueMessage.__default;

const unique Tagclass.ValueMessage.__default: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.__default()) } 
  $IsBox(bx, Tclass.ValueMessage.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueMessage.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueMessage.__default()) } 
  $Is($o, Tclass.ValueMessage.__default())
     <==> $o == null || dtype($o) == Tclass.ValueMessage.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueMessage.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueMessage.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueMessage._default.NopDelta
function ValueMessage.__default.NopDelta() : Box;

function ValueMessage.__default.NopDelta#canCall() : bool;

function Tclass.ValueMessage.Delta() : Ty;

// Tclass.ValueMessage.Delta Tag
axiom Tag(Tclass.ValueMessage.Delta()) == Tagclass.ValueMessage.Delta;

const unique Tagclass.ValueMessage.Delta: TyTag;

// consequence axiom for ValueMessage.__default.NopDelta
axiom true
   ==> 
  true
   ==> $IsBox(ValueMessage.__default.NopDelta(), Tclass.ValueMessage.Delta());

function ValueMessage.__default.NopDelta#requires() : bool;

// #requires axiom for ValueMessage.__default.NopDelta
axiom ValueMessage.__default.NopDelta#requires() == true;

// function declaration for ValueMessage._default.DefaultValue
function ValueMessage.__default.DefaultValue() : Seq Box;

function ValueMessage.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueMessage.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueMessage.__default.DefaultValue
axiom ValueMessage.__default.DefaultValue#requires() == true;

// function declaration for ValueMessage._default.CombineDeltas
function ValueMessage.__default.CombineDeltas(newdelta#0: Box, olddelta#0: Box) : Box;

function ValueMessage.__default.CombineDeltas#canCall(newdelta#0: Box, olddelta#0: Box) : bool;

// consequence axiom for ValueMessage.__default.CombineDeltas
axiom true
   ==> (forall newdelta#0: Box, olddelta#0: Box :: 
    { ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) } 
    ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)
         || ($IsBox(newdelta#0, Tclass.ValueMessage.Delta())
           && $IsBox(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> (newdelta#0 == ValueMessage.__default.NopDelta()
           ==> ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) == olddelta#0)
         && (olddelta#0 == ValueMessage.__default.NopDelta()
           ==> ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) == newdelta#0)
         && $IsBox(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), 
          Tclass.ValueMessage.Delta()));

function ValueMessage.__default.CombineDeltas#requires(Box, Box) : bool;

// #requires axiom for ValueMessage.__default.CombineDeltas
axiom (forall newdelta#0: Box, olddelta#0: Box :: 
  { ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) } 
  $IsBox(newdelta#0, Tclass.ValueMessage.Delta())
       && $IsBox(olddelta#0, Tclass.ValueMessage.Delta())
     ==> ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) == true);

// function declaration for ValueMessage._default.ApplyDelta
function ValueMessage.__default.ApplyDelta(delta#0: Box, value#0: Seq Box) : Seq Box;

function ValueMessage.__default.ApplyDelta#canCall(delta#0: Box, value#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.ApplyDelta
axiom true
   ==> (forall delta#0: Box, value#0: Seq Box :: 
    { ValueMessage.__default.ApplyDelta(delta#0, value#0) } 
    ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0)
         || ($IsBox(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> (delta#0 == ValueMessage.__default.NopDelta()
           ==> Seq#Equal(ValueMessage.__default.ApplyDelta(delta#0, value#0), value#0))
         && $Is(ValueMessage.__default.ApplyDelta(delta#0, value#0), Tclass.ValueType.Value()));

function ValueMessage.__default.ApplyDelta#requires(Box, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.ApplyDelta
axiom (forall delta#0: Box, value#0: Seq Box :: 
  { ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) } 
  $IsBox(delta#0, Tclass.ValueMessage.Delta())
       && $Is(value#0, Tclass.ValueType.Value())
     ==> ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) == true);

// function declaration for ValueMessage._default.bytestring_to_Message
function ValueMessage.__default.bytestring__to__Message(s#0: Seq Box) : DatatypeType;

function ValueMessage.__default.bytestring__to__Message#canCall(s#0: Seq Box) : bool;

function Tclass.ValueMessage.Message() : Ty;

// Tclass.ValueMessage.Message Tag
axiom Tag(Tclass.ValueMessage.Message()) == Tagclass.ValueMessage.Message;

const unique Tagclass.ValueMessage.Message: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.Message
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.Message()) } 
  $IsBox(bx, Tclass.ValueMessage.Message())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.ValueMessage.Message()));

// consequence axiom for ValueMessage.__default.bytestring__to__Message
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueMessage.__default.bytestring__to__Message(s#0) } 
    ValueMessage.__default.bytestring__to__Message#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) < 4294967296)
       ==> $Is(ValueMessage.__default.bytestring__to__Message(s#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.bytestring__to__Message#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestring__to__Message
axiom (forall s#0: Seq Box :: 
  { ValueMessage.__default.bytestring__to__Message#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueMessage.__default.bytestring__to__Message#requires(s#0)
       == (Seq#Length(s#0) < 4294967296));

// function declaration for ValueMessage._default.EncodableMessage
function ValueMessage.__default.EncodableMessage(msg#0: DatatypeType) : bool;

function ValueMessage.__default.EncodableMessage#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessage
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.EncodableMessage(msg#0) } 
    ValueMessage.__default.EncodableMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> true);

function ValueMessage.__default.EncodableMessage#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessage
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.EncodableMessage#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.EncodableMessage#requires(msg#0) == true);

// function declaration for ValueMessage._default.EncodableMessageSeq
function ValueMessage.__default.EncodableMessageSeq(msgs#0: Seq Box) : bool;

function ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessageSeq
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { ValueMessage.__default.EncodableMessageSeq(msgs#0) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> true);

function ValueMessage.__default.EncodableMessageSeq#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessageSeq
axiom (forall msgs#0: Seq Box :: 
  { ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) == true);

// function declaration for ValueMessage._default.Message_to_bytestring
function ValueMessage.__default.Message__to__bytestring(msg#0: DatatypeType) : Seq Box;

function ValueMessage.__default.Message__to__bytestring#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Message__to__bytestring
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.Message__to__bytestring(msg#0) } 
    ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && ValueMessage.Message.Define_q(msg#0))
       ==> $Is(ValueMessage.__default.Message__to__bytestring(msg#0), 
        TSeq(Tclass.NativeTypes.byte())));

function ValueMessage.__default.Message__to__bytestring#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Message__to__bytestring
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.Message__to__bytestring#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Message__to__bytestring#requires(msg#0)
       == ValueMessage.Message.Define_q(msg#0));

// function declaration for ValueMessage._default.messageSeq_to_bytestringSeq
function ValueMessage.__default.messageSeq__to__bytestringSeq($ly: LayerType, msgs#0: Seq Box) : Seq Box;

function ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq(AsFuelBottom($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($LZ, msgs#0));

// consequence axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0)
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && ValueMessage.__default.EncodableMessageSeq(msgs#0))
       ==> Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
           == Seq#Length(msgs#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(msgs#0, i#0)): DatatypeType } 
            { $Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0
                 < Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
             ==> Seq#Equal($Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#0)): Seq Box, 
              ValueMessage.__default.Message__to__bytestring($Unbox(Seq#Index(msgs#0, i#0)): DatatypeType)))
         && $Is(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function ValueMessage.__default.messageSeq__to__bytestringSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0)
       == ValueMessage.__default.EncodableMessageSeq(msgs#0));

// function declaration for ValueMessage._default.bytestringSeq_to_MessageSeq
function ValueMessage.__default.bytestringSeq__to__MessageSeq($ly: LayerType, strings#0: Seq Box) : Seq Box;

function ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq(AsFuelBottom($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($LZ, strings#0));

// consequence axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    { ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0)
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(strings#0, i#0)): Seq Box } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(strings#0)
               ==> Seq#Length($Unbox(Seq#Index(strings#0, i#0)): Seq Box) < 4294967296))
       ==> Seq#Length(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0))
           == Seq#Length(strings#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(strings#0, i#1)): Seq Box } 
            { $Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(strings#0)
             ==> ValueMessage.Message#Equal($Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#1)): DatatypeType, 
              ValueMessage.__default.bytestring__to__Message($Unbox(Seq#Index(strings#0, i#1)): Seq Box)))
         && $Is(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), 
          TSeq(Tclass.ValueMessage.Message())));

function ValueMessage.__default.bytestringSeq__to__MessageSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0) } 
  $Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0)
       == (forall i#2: int :: 
        { $Unbox(Seq#Index(strings#0, i#2)): Seq Box } 
        LitInt(0) <= i#2 && i#2 < Seq#Length(strings#0)
           ==> Seq#Length($Unbox(Seq#Index(strings#0, i#2)): Seq Box) < 4294967296));

// function declaration for ValueMessage._default.Merge
function ValueMessage.__default.Merge(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : DatatypeType;

function ValueMessage.__default.Merge#canCall(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Merge
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> $Is(ValueMessage.__default.Merge(newmessage#0, oldmessage#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.Merge#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Merge
axiom (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
  { ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) } 
  $Is(newmessage#0, Tclass.ValueMessage.Message())
       && $Is(oldmessage#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) == true);

// definition axiom for ValueMessage.__default.Merge(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
         && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0))))
         && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
             && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var value#0 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var delta#0 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0))))
             && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var olddelta#0 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var newdelta#0 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)))))
         && ValueMessage.__default.Merge(newmessage#0, oldmessage#0)
           == (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
             then (var newvalue#1 := ValueMessage.Message.value($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
              #ValueMessage.Message.Define(newvalue#1))
             else (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               then (var value#1 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var delta#1 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Define(ValueMessage.__default.ApplyDelta(delta#1, value#1))))
               else (var olddelta#1 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var newdelta#1 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Update(ValueMessage.__default.CombineDeltas(newdelta#1, olddelta#1)))))));

// definition axiom for ValueMessage.__default.Merge for all literals(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0)) } 
    ValueMessage.__default.Merge#canCall(Lit(newmessage#0), Lit(oldmessage#0))
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
         && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0))))))
         && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
             && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var value#2 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var delta#2 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#2, value#2))))
             && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var olddelta#2 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var newdelta#2 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#2, olddelta#2)))))
         && ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0))
           == (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
             then (var newvalue#3 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
              Lit(#ValueMessage.Message.Define(newvalue#3)))
             else (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
               then (var value#3 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var delta#3 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  #ValueMessage.Message.Define(ValueMessage.__default.ApplyDelta(delta#3, value#3))))
               else (var olddelta#3 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var newdelta#3 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  #ValueMessage.Message.Update(ValueMessage.__default.CombineDeltas(newdelta#3, olddelta#3)))))));

// function declaration for ValueMessage._default.IdentityMessage
function ValueMessage.__default.IdentityMessage() : DatatypeType;

function ValueMessage.__default.IdentityMessage#canCall() : bool;

// consequence axiom for ValueMessage.__default.IdentityMessage
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.IdentityMessage(), Tclass.ValueMessage.Message());

function ValueMessage.__default.IdentityMessage#requires() : bool;

// #requires axiom for ValueMessage.__default.IdentityMessage
axiom ValueMessage.__default.IdentityMessage#requires() == true;

// definition axiom for ValueMessage.__default.IdentityMessage(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == #ValueMessage.Message.Update(ValueMessage.__default.NopDelta());

// definition axiom for ValueMessage.__default.IdentityMessage for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == #ValueMessage.Message.Update(ValueMessage.__default.NopDelta());

// function declaration for ValueMessage._default.DefineDefault
function ValueMessage.__default.DefineDefault() : DatatypeType;

function ValueMessage.__default.DefineDefault#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefineDefault
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefineDefault(), Tclass.ValueMessage.Message());

function ValueMessage.__default.DefineDefault#requires() : bool;

// #requires axiom for ValueMessage.__default.DefineDefault
axiom ValueMessage.__default.DefineDefault#requires() == true;

// definition axiom for ValueMessage.__default.DefineDefault(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == #ValueMessage.Message.Define(ValueMessage.__default.DefaultValue());

// definition axiom for ValueMessage.__default.DefineDefault for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == #ValueMessage.Message.Define(ValueMessage.__default.DefaultValue());

// Constructor function declaration
function #ValueMessage.Message.Define(Seq Box) : DatatypeType;

const unique ##ValueMessage.Message.Define: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#0#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Define(a#0#0#0))
     == ##ValueMessage.Message.Define);

function ValueMessage.Message.Define_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Define);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     ==> (exists a#1#0#0: Seq Box :: d == #ValueMessage.Message.Define(a#1#0#0)));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box :: 
  { $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message())
     <==> $Is(a#2#0#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Define_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(Lit(a#4#0#0)) } 
  #ValueMessage.Message.Define(Lit(a#4#0#0))
     == Lit(#ValueMessage.Message.Define(a#4#0#0)));

function ValueMessage.Message.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#5#0#0) } 
  ValueMessage.Message.value(#ValueMessage.Message.Define(a#5#0#0)) == a#5#0#0);

// Constructor function declaration
function #ValueMessage.Message.Update(Box) : DatatypeType;

const unique ##ValueMessage.Message.Update: DtCtorId;

// Constructor identifier
axiom (forall a#6#0#0: Box :: 
  { #ValueMessage.Message.Update(a#6#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Update(a#6#0#0))
     == ##ValueMessage.Message.Update);

function ValueMessage.Message.Update_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Update);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     ==> (exists a#7#0#0: Box :: d == #ValueMessage.Message.Update(a#7#0#0)));

// Constructor $Is
axiom (forall a#8#0#0: Box :: 
  { $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message())
     <==> $IsBox(a#8#0#0, Tclass.ValueMessage.Delta()));

// Constructor $IsAlloc
axiom (forall a#9#0#0: Box, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAllocBox(a#9#0#0, Tclass.ValueMessage.Delta(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAllocBox(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Update_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAllocBox(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h));

// Constructor literal
axiom (forall a#10#0#0: Box :: 
  { #ValueMessage.Message.Update(Lit(a#10#0#0)) } 
  #ValueMessage.Message.Update(Lit(a#10#0#0))
     == Lit(#ValueMessage.Message.Update(a#10#0#0)));

function ValueMessage.Message.delta(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#11#0#0: Box :: 
  { #ValueMessage.Message.Update(a#11#0#0) } 
  ValueMessage.Message.delta(#ValueMessage.Message.Update(a#11#0#0)) == a#11#0#0);

// Depth-one case-split function
function $IsA#ValueMessage.Message(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#ValueMessage.Message(d) } 
  $IsA#ValueMessage.Message(d)
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
    { ValueMessage.Message.Define_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
  $Is(d, Tclass.ValueMessage.Message())
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Datatype extensional equality declaration
function ValueMessage.Message#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #ValueMessage.Message.Define
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(b) } 
  ValueMessage.Message.Define_q(a) && ValueMessage.Message.Define_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> Seq#Equal(ValueMessage.Message.value(a), ValueMessage.Message.value(b))));

// Datatype extensional equality definition: #ValueMessage.Message.Update
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(b) } 
  ValueMessage.Message.Update_q(a) && ValueMessage.Message.Update_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> ValueMessage.Message.delta(a) == ValueMessage.Message.delta(b)));

// Datatype extensionality axiom: ValueMessage.Message
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b) } 
  ValueMessage.Message#Equal(a, b) <==> a == b);

const unique class.ValueMessage.Message: ClassName;

// Constructor function declaration
function #UI.RangeStart.SInclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeStart.SInclusive: DtCtorId;

// Constructor identifier
axiom (forall a#12#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(a#12#0#0) } 
  DatatypeCtorId(#UI.RangeStart.SInclusive(a#12#0#0))
     == ##UI.RangeStart.SInclusive);

function UI.RangeStart.SInclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SInclusive_q(d) } 
  UI.RangeStart.SInclusive_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.SInclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SInclusive_q(d) } 
  UI.RangeStart.SInclusive_q(d)
     ==> (exists a#13#0#0: Seq Box :: d == #UI.RangeStart.SInclusive(a#13#0#0)));

function Tclass.UI.RangeStart() : Ty;

// Tclass.UI.RangeStart Tag
axiom Tag(Tclass.UI.RangeStart()) == Tagclass.UI.RangeStart;

const unique Tagclass.UI.RangeStart: TyTag;

// Box/unbox axiom for Tclass.UI.RangeStart
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.RangeStart()) } 
  $IsBox(bx, Tclass.UI.RangeStart())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.RangeStart()));

// Constructor $Is
axiom (forall a#14#0#0: Seq Box :: 
  { $Is(#UI.RangeStart.SInclusive(a#14#0#0), Tclass.UI.RangeStart()) } 
  $Is(#UI.RangeStart.SInclusive(a#14#0#0), Tclass.UI.RangeStart())
     <==> $Is(a#14#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#15#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.SInclusive(a#15#0#0), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeStart.SInclusive(a#15#0#0), Tclass.UI.RangeStart(), $h)
       <==> $IsAlloc(a#15#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeStart.SInclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeStart(), $h)
     ==> $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#16#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(Lit(a#16#0#0)) } 
  #UI.RangeStart.SInclusive(Lit(a#16#0#0))
     == Lit(#UI.RangeStart.SInclusive(a#16#0#0)));

function UI.RangeStart.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#17#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(a#17#0#0) } 
  UI.RangeStart.key(#UI.RangeStart.SInclusive(a#17#0#0)) == a#17#0#0);

// Constructor function declaration
function #UI.RangeStart.SExclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeStart.SExclusive: DtCtorId;

// Constructor identifier
axiom (forall a#18#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(a#18#0#0) } 
  DatatypeCtorId(#UI.RangeStart.SExclusive(a#18#0#0))
     == ##UI.RangeStart.SExclusive);

function UI.RangeStart.SExclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SExclusive_q(d) } 
  UI.RangeStart.SExclusive_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.SExclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SExclusive_q(d) } 
  UI.RangeStart.SExclusive_q(d)
     ==> (exists a#19#0#0: Seq Box :: d == #UI.RangeStart.SExclusive(a#19#0#0)));

// Constructor $Is
axiom (forall a#20#0#0: Seq Box :: 
  { $Is(#UI.RangeStart.SExclusive(a#20#0#0), Tclass.UI.RangeStart()) } 
  $Is(#UI.RangeStart.SExclusive(a#20#0#0), Tclass.UI.RangeStart())
     <==> $Is(a#20#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#21#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.SExclusive(a#21#0#0), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeStart.SExclusive(a#21#0#0), Tclass.UI.RangeStart(), $h)
       <==> $IsAlloc(a#21#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeStart.SExclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeStart(), $h)
     ==> $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#22#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(Lit(a#22#0#0)) } 
  #UI.RangeStart.SExclusive(Lit(a#22#0#0))
     == Lit(#UI.RangeStart.SExclusive(a#22#0#0)));

// Constructor injectivity
axiom (forall a#23#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(a#23#0#0) } 
  UI.RangeStart.key(#UI.RangeStart.SExclusive(a#23#0#0)) == a#23#0#0);

// Constructor function declaration
function #UI.RangeStart.NegativeInf() : DatatypeType;

const unique ##UI.RangeStart.NegativeInf: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.RangeStart.NegativeInf()) == ##UI.RangeStart.NegativeInf;

function UI.RangeStart.NegativeInf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d) } 
  UI.RangeStart.NegativeInf_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.NegativeInf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d) } 
  UI.RangeStart.NegativeInf_q(d) ==> d == #UI.RangeStart.NegativeInf());

// Constructor $Is
axiom $Is(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart(), $h));

// Constructor literal
axiom #UI.RangeStart.NegativeInf() == Lit(#UI.RangeStart.NegativeInf());

// Depth-one case-split function
function $IsA#UI.RangeStart(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.RangeStart(d) } 
  $IsA#UI.RangeStart(d)
     ==> UI.RangeStart.SInclusive_q(d)
       || UI.RangeStart.SExclusive_q(d)
       || UI.RangeStart.NegativeInf_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d), $Is(d, Tclass.UI.RangeStart()) } 
    { UI.RangeStart.SExclusive_q(d), $Is(d, Tclass.UI.RangeStart()) } 
    { UI.RangeStart.SInclusive_q(d), $Is(d, Tclass.UI.RangeStart()) } 
  $Is(d, Tclass.UI.RangeStart())
     ==> UI.RangeStart.SInclusive_q(d)
       || UI.RangeStart.SExclusive_q(d)
       || UI.RangeStart.NegativeInf_q(d));

// Datatype extensional equality declaration
function UI.RangeStart#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.RangeStart.SInclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.SInclusive_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.SInclusive_q(b) } 
  UI.RangeStart.SInclusive_q(a) && UI.RangeStart.SInclusive_q(b)
     ==> (UI.RangeStart#Equal(a, b)
       <==> Seq#Equal(UI.RangeStart.key(a), UI.RangeStart.key(b))));

// Datatype extensional equality definition: #UI.RangeStart.SExclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.SExclusive_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.SExclusive_q(b) } 
  UI.RangeStart.SExclusive_q(a) && UI.RangeStart.SExclusive_q(b)
     ==> (UI.RangeStart#Equal(a, b)
       <==> Seq#Equal(UI.RangeStart.key(a), UI.RangeStart.key(b))));

// Datatype extensional equality definition: #UI.RangeStart.NegativeInf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.NegativeInf_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.NegativeInf_q(b) } 
  UI.RangeStart.NegativeInf_q(a) && UI.RangeStart.NegativeInf_q(b)
     ==> (UI.RangeStart#Equal(a, b) <==> true));

// Datatype extensionality axiom: UI.RangeStart
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b) } 
  UI.RangeStart#Equal(a, b) <==> a == b);

const unique class.UI.RangeStart: ClassName;

// Constructor function declaration
function #UI.RangeEnd.EInclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeEnd.EInclusive: DtCtorId;

// Constructor identifier
axiom (forall a#29#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(a#29#0#0) } 
  DatatypeCtorId(#UI.RangeEnd.EInclusive(a#29#0#0)) == ##UI.RangeEnd.EInclusive);

function UI.RangeEnd.EInclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EInclusive_q(d) } 
  UI.RangeEnd.EInclusive_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.EInclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EInclusive_q(d) } 
  UI.RangeEnd.EInclusive_q(d)
     ==> (exists a#30#0#0: Seq Box :: d == #UI.RangeEnd.EInclusive(a#30#0#0)));

function Tclass.UI.RangeEnd() : Ty;

// Tclass.UI.RangeEnd Tag
axiom Tag(Tclass.UI.RangeEnd()) == Tagclass.UI.RangeEnd;

const unique Tagclass.UI.RangeEnd: TyTag;

// Box/unbox axiom for Tclass.UI.RangeEnd
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.RangeEnd()) } 
  $IsBox(bx, Tclass.UI.RangeEnd())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.RangeEnd()));

// Constructor $Is
axiom (forall a#31#0#0: Seq Box :: 
  { $Is(#UI.RangeEnd.EInclusive(a#31#0#0), Tclass.UI.RangeEnd()) } 
  $Is(#UI.RangeEnd.EInclusive(a#31#0#0), Tclass.UI.RangeEnd())
     <==> $Is(a#31#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#32#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.EInclusive(a#32#0#0), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeEnd.EInclusive(a#32#0#0), Tclass.UI.RangeEnd(), $h)
       <==> $IsAlloc(a#32#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeEnd.EInclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeEnd(), $h)
     ==> $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#33#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(Lit(a#33#0#0)) } 
  #UI.RangeEnd.EInclusive(Lit(a#33#0#0)) == Lit(#UI.RangeEnd.EInclusive(a#33#0#0)));

function UI.RangeEnd.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#34#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(a#34#0#0) } 
  UI.RangeEnd.key(#UI.RangeEnd.EInclusive(a#34#0#0)) == a#34#0#0);

// Constructor function declaration
function #UI.RangeEnd.EExclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeEnd.EExclusive: DtCtorId;

// Constructor identifier
axiom (forall a#35#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(a#35#0#0) } 
  DatatypeCtorId(#UI.RangeEnd.EExclusive(a#35#0#0)) == ##UI.RangeEnd.EExclusive);

function UI.RangeEnd.EExclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EExclusive_q(d) } 
  UI.RangeEnd.EExclusive_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.EExclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EExclusive_q(d) } 
  UI.RangeEnd.EExclusive_q(d)
     ==> (exists a#36#0#0: Seq Box :: d == #UI.RangeEnd.EExclusive(a#36#0#0)));

// Constructor $Is
axiom (forall a#37#0#0: Seq Box :: 
  { $Is(#UI.RangeEnd.EExclusive(a#37#0#0), Tclass.UI.RangeEnd()) } 
  $Is(#UI.RangeEnd.EExclusive(a#37#0#0), Tclass.UI.RangeEnd())
     <==> $Is(a#37#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#38#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.EExclusive(a#38#0#0), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeEnd.EExclusive(a#38#0#0), Tclass.UI.RangeEnd(), $h)
       <==> $IsAlloc(a#38#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeEnd.EExclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeEnd(), $h)
     ==> $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#39#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(Lit(a#39#0#0)) } 
  #UI.RangeEnd.EExclusive(Lit(a#39#0#0)) == Lit(#UI.RangeEnd.EExclusive(a#39#0#0)));

// Constructor injectivity
axiom (forall a#40#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(a#40#0#0) } 
  UI.RangeEnd.key(#UI.RangeEnd.EExclusive(a#40#0#0)) == a#40#0#0);

// Constructor function declaration
function #UI.RangeEnd.PositiveInf() : DatatypeType;

const unique ##UI.RangeEnd.PositiveInf: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.RangeEnd.PositiveInf()) == ##UI.RangeEnd.PositiveInf;

function UI.RangeEnd.PositiveInf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d) } 
  UI.RangeEnd.PositiveInf_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.PositiveInf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d) } 
  UI.RangeEnd.PositiveInf_q(d) ==> d == #UI.RangeEnd.PositiveInf());

// Constructor $Is
axiom $Is(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom #UI.RangeEnd.PositiveInf() == Lit(#UI.RangeEnd.PositiveInf());

// Depth-one case-split function
function $IsA#UI.RangeEnd(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.RangeEnd(d) } 
  $IsA#UI.RangeEnd(d)
     ==> UI.RangeEnd.EInclusive_q(d)
       || UI.RangeEnd.EExclusive_q(d)
       || UI.RangeEnd.PositiveInf_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
    { UI.RangeEnd.EExclusive_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
    { UI.RangeEnd.EInclusive_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
  $Is(d, Tclass.UI.RangeEnd())
     ==> UI.RangeEnd.EInclusive_q(d)
       || UI.RangeEnd.EExclusive_q(d)
       || UI.RangeEnd.PositiveInf_q(d));

// Datatype extensional equality declaration
function UI.RangeEnd#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.RangeEnd.EInclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EInclusive_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EInclusive_q(b) } 
  UI.RangeEnd.EInclusive_q(a) && UI.RangeEnd.EInclusive_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> Seq#Equal(UI.RangeEnd.key(a), UI.RangeEnd.key(b))));

// Datatype extensional equality definition: #UI.RangeEnd.EExclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EExclusive_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EExclusive_q(b) } 
  UI.RangeEnd.EExclusive_q(a) && UI.RangeEnd.EExclusive_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> Seq#Equal(UI.RangeEnd.key(a), UI.RangeEnd.key(b))));

// Datatype extensional equality definition: #UI.RangeEnd.PositiveInf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.PositiveInf_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.PositiveInf_q(b) } 
  UI.RangeEnd.PositiveInf_q(a) && UI.RangeEnd.PositiveInf_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> true));

// Datatype extensionality axiom: UI.RangeEnd
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b) } 
  UI.RangeEnd#Equal(a, b) <==> a == b);

const unique class.UI.RangeEnd: ClassName;

// Constructor function declaration
function #UI.SuccResult.SuccResult(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.SuccResult.SuccResult: DtCtorId;

// Constructor identifier
axiom (forall a#46#0#0: Seq Box, a#46#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#46#0#0, a#46#1#0) } 
  DatatypeCtorId(#UI.SuccResult.SuccResult(a#46#0#0, a#46#1#0))
     == ##UI.SuccResult.SuccResult);

function UI.SuccResult.SuccResult_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d) } 
  UI.SuccResult.SuccResult_q(d)
     <==> DatatypeCtorId(d) == ##UI.SuccResult.SuccResult);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d) } 
  UI.SuccResult.SuccResult_q(d)
     ==> (exists a#47#0#0: Seq Box, a#47#1#0: Seq Box :: 
      d == #UI.SuccResult.SuccResult(a#47#0#0, a#47#1#0)));

function Tclass.UI.SuccResult() : Ty;

// Tclass.UI.SuccResult Tag
axiom Tag(Tclass.UI.SuccResult()) == Tagclass.UI.SuccResult;

const unique Tagclass.UI.SuccResult: TyTag;

// Box/unbox axiom for Tclass.UI.SuccResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.SuccResult()) } 
  $IsBox(bx, Tclass.UI.SuccResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.SuccResult()));

// Constructor $Is
axiom (forall a#48#0#0: Seq Box, a#48#1#0: Seq Box :: 
  { $Is(#UI.SuccResult.SuccResult(a#48#0#0, a#48#1#0), Tclass.UI.SuccResult()) } 
  $Is(#UI.SuccResult.SuccResult(a#48#0#0, a#48#1#0), Tclass.UI.SuccResult())
     <==> $Is(a#48#0#0, Tclass.KeyType.Key()) && $Is(a#48#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#49#0#0: Seq Box, a#49#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.SuccResult.SuccResult(a#49#0#0, a#49#1#0), Tclass.UI.SuccResult(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.SuccResult.SuccResult(a#49#0#0, a#49#1#0), Tclass.UI.SuccResult(), $h)
       <==> $IsAlloc(a#49#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#49#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResult.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResult.SuccResult_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResult(), $h)
     ==> $IsAlloc(UI.SuccResult.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResult.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResult.SuccResult_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResult(), $h)
     ==> $IsAlloc(UI.SuccResult.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#50#0#0: Seq Box, a#50#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(Lit(a#50#0#0), Lit(a#50#1#0)) } 
  #UI.SuccResult.SuccResult(Lit(a#50#0#0), Lit(a#50#1#0))
     == Lit(#UI.SuccResult.SuccResult(a#50#0#0, a#50#1#0)));

function UI.SuccResult.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#51#0#0: Seq Box, a#51#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#51#0#0, a#51#1#0) } 
  UI.SuccResult.key(#UI.SuccResult.SuccResult(a#51#0#0, a#51#1#0)) == a#51#0#0);

function UI.SuccResult.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#52#0#0: Seq Box, a#52#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#52#0#0, a#52#1#0) } 
  UI.SuccResult.value(#UI.SuccResult.SuccResult(a#52#0#0, a#52#1#0)) == a#52#1#0);

// Depth-one case-split function
function $IsA#UI.SuccResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.SuccResult(d) } 
  $IsA#UI.SuccResult(d) ==> UI.SuccResult.SuccResult_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d), $Is(d, Tclass.UI.SuccResult()) } 
  $Is(d, Tclass.UI.SuccResult()) ==> UI.SuccResult.SuccResult_q(d));

// Datatype extensional equality declaration
function UI.SuccResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.SuccResult.SuccResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResult#Equal(a, b) } 
  true
     ==> (UI.SuccResult#Equal(a, b)
       <==> Seq#Equal(UI.SuccResult.key(a), UI.SuccResult.key(b))
         && Seq#Equal(UI.SuccResult.value(a), UI.SuccResult.value(b))));

// Datatype extensionality axiom: UI.SuccResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResult#Equal(a, b) } 
  UI.SuccResult#Equal(a, b) <==> a == b);

const unique class.UI.SuccResult: ClassName;

// Constructor function declaration
function #UI.SuccResultList.SuccResultList(Seq Box, DatatypeType) : DatatypeType;

const unique ##UI.SuccResultList.SuccResultList: DtCtorId;

// Constructor identifier
axiom (forall a#53#0#0: Seq Box, a#53#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#53#0#0, a#53#1#0) } 
  DatatypeCtorId(#UI.SuccResultList.SuccResultList(a#53#0#0, a#53#1#0))
     == ##UI.SuccResultList.SuccResultList);

function UI.SuccResultList.SuccResultList_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d) } 
  UI.SuccResultList.SuccResultList_q(d)
     <==> DatatypeCtorId(d) == ##UI.SuccResultList.SuccResultList);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d) } 
  UI.SuccResultList.SuccResultList_q(d)
     ==> (exists a#54#0#0: Seq Box, a#54#1#0: DatatypeType :: 
      d == #UI.SuccResultList.SuccResultList(a#54#0#0, a#54#1#0)));

function Tclass.UI.SuccResultList() : Ty;

// Tclass.UI.SuccResultList Tag
axiom Tag(Tclass.UI.SuccResultList()) == Tagclass.UI.SuccResultList;

const unique Tagclass.UI.SuccResultList: TyTag;

// Box/unbox axiom for Tclass.UI.SuccResultList
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.SuccResultList()) } 
  $IsBox(bx, Tclass.UI.SuccResultList())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.SuccResultList()));

// Constructor $Is
axiom (forall a#55#0#0: Seq Box, a#55#1#0: DatatypeType :: 
  { $Is(#UI.SuccResultList.SuccResultList(a#55#0#0, a#55#1#0), 
      Tclass.UI.SuccResultList()) } 
  $Is(#UI.SuccResultList.SuccResultList(a#55#0#0, a#55#1#0), 
      Tclass.UI.SuccResultList())
     <==> $Is(a#55#0#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#55#1#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#56#0#0: Seq Box, a#56#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#UI.SuccResultList.SuccResultList(a#56#0#0, a#56#1#0), 
      Tclass.UI.SuccResultList(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.SuccResultList.SuccResultList(a#56#0#0, a#56#1#0), 
        Tclass.UI.SuccResultList(), 
        $h)
       <==> $IsAlloc(a#56#0#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#56#1#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResultList.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResultList.SuccResultList_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResultList(), $h)
     ==> $IsAlloc(UI.SuccResultList.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResultList.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResultList.SuccResultList_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResultList(), $h)
     ==> $IsAlloc(UI.SuccResultList.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#57#0#0: Seq Box, a#57#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(Lit(a#57#0#0), Lit(a#57#1#0)) } 
  #UI.SuccResultList.SuccResultList(Lit(a#57#0#0), Lit(a#57#1#0))
     == Lit(#UI.SuccResultList.SuccResultList(a#57#0#0, a#57#1#0)));

function UI.SuccResultList.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#58#0#0: Seq Box, a#58#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#58#0#0, a#58#1#0) } 
  UI.SuccResultList.results(#UI.SuccResultList.SuccResultList(a#58#0#0, a#58#1#0))
     == a#58#0#0);

// Inductive seq element rank
axiom (forall a#59#0#0: Seq Box, a#59#1#0: DatatypeType, i: int :: 
  { Seq#Index(a#59#0#0, i), #UI.SuccResultList.SuccResultList(a#59#0#0, a#59#1#0) } 
  0 <= i && i < Seq#Length(a#59#0#0)
     ==> DtRank($Unbox(Seq#Index(a#59#0#0, i)): DatatypeType)
       < DtRank(#UI.SuccResultList.SuccResultList(a#59#0#0, a#59#1#0)));

// Inductive seq rank
axiom (forall a#60#0#0: Seq Box, a#60#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#60#0#0, a#60#1#0) } 
  Seq#Rank(a#60#0#0)
     < DtRank(#UI.SuccResultList.SuccResultList(a#60#0#0, a#60#1#0)));

function UI.SuccResultList.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#61#0#0: Seq Box, a#61#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#61#0#0, a#61#1#0) } 
  UI.SuccResultList.end(#UI.SuccResultList.SuccResultList(a#61#0#0, a#61#1#0))
     == a#61#1#0);

// Inductive rank
axiom (forall a#62#0#0: Seq Box, a#62#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#62#0#0, a#62#1#0) } 
  DtRank(a#62#1#0) < DtRank(#UI.SuccResultList.SuccResultList(a#62#0#0, a#62#1#0)));

// Depth-one case-split function
function $IsA#UI.SuccResultList(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.SuccResultList(d) } 
  $IsA#UI.SuccResultList(d) ==> UI.SuccResultList.SuccResultList_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d), $Is(d, Tclass.UI.SuccResultList()) } 
  $Is(d, Tclass.UI.SuccResultList()) ==> UI.SuccResultList.SuccResultList_q(d));

// Datatype extensional equality declaration
function UI.SuccResultList#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.SuccResultList.SuccResultList
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResultList#Equal(a, b) } 
  true
     ==> (UI.SuccResultList#Equal(a, b)
       <==> Seq#Equal(UI.SuccResultList.results(a), UI.SuccResultList.results(b))
         && UI.RangeEnd#Equal(UI.SuccResultList.end(a), UI.SuccResultList.end(b))));

// Datatype extensionality axiom: UI.SuccResultList
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResultList#Equal(a, b) } 
  UI.SuccResultList#Equal(a, b) <==> a == b);

const unique class.UI.SuccResultList: ClassName;

// Constructor function declaration
function #UI.Op.NoOp() : DatatypeType;

const unique ##UI.Op.NoOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.NoOp()) == ##UI.Op.NoOp;

function UI.Op.NoOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.NoOp_q(d) } 
  UI.Op.NoOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.NoOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.NoOp_q(d) } 
  UI.Op.NoOp_q(d) ==> d == #UI.Op.NoOp());

function Tclass.UI.Op() : Ty;

// Tclass.UI.Op Tag
axiom Tag(Tclass.UI.Op()) == Tagclass.UI.Op;

const unique Tagclass.UI.Op: TyTag;

// Box/unbox axiom for Tclass.UI.Op
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.Op()) } 
  $IsBox(bx, Tclass.UI.Op())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.Op()));

// Constructor $Is
axiom $Is(#UI.Op.NoOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.NoOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.NoOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.NoOp() == Lit(#UI.Op.NoOp());

// Constructor function declaration
function #UI.Op.SyncOp() : DatatypeType;

const unique ##UI.Op.SyncOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.SyncOp()) == ##UI.Op.SyncOp;

function UI.Op.SyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.SyncOp_q(d) } 
  UI.Op.SyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.SyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.SyncOp_q(d) } 
  UI.Op.SyncOp_q(d) ==> d == #UI.Op.SyncOp());

// Constructor $Is
axiom $Is(#UI.Op.SyncOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.SyncOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.SyncOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.SyncOp() == Lit(#UI.Op.SyncOp());

// Constructor function declaration
function #UI.Op.CrashOp() : DatatypeType;

const unique ##UI.Op.CrashOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.CrashOp()) == ##UI.Op.CrashOp;

function UI.Op.CrashOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.CrashOp_q(d) } 
  UI.Op.CrashOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.CrashOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.CrashOp_q(d) } 
  UI.Op.CrashOp_q(d) ==> d == #UI.Op.CrashOp());

// Constructor $Is
axiom $Is(#UI.Op.CrashOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.CrashOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.CrashOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.CrashOp() == Lit(#UI.Op.CrashOp());

// Constructor function declaration
function #UI.Op.PushSyncOp(int) : DatatypeType;

const unique ##UI.Op.PushSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#78#0#0: int :: 
  { #UI.Op.PushSyncOp(a#78#0#0) } 
  DatatypeCtorId(#UI.Op.PushSyncOp(a#78#0#0)) == ##UI.Op.PushSyncOp);

function UI.Op.PushSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PushSyncOp_q(d) } 
  UI.Op.PushSyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PushSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PushSyncOp_q(d) } 
  UI.Op.PushSyncOp_q(d)
     ==> (exists a#79#0#0: int :: d == #UI.Op.PushSyncOp(a#79#0#0)));

// Constructor $Is
axiom (forall a#80#0#0: int :: 
  { $Is(#UI.Op.PushSyncOp(a#80#0#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PushSyncOp(a#80#0#0), Tclass.UI.Op()) <==> $Is(a#80#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#81#0#0: int, $h: Heap :: 
  { $IsAlloc(#UI.Op.PushSyncOp(a#81#0#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PushSyncOp(a#81#0#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#81#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.id(d), TInt, $h) } 
  $IsGoodHeap($h) && UI.Op.PushSyncOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.id(d), TInt, $h));

// Constructor literal
axiom (forall a#82#0#0: int :: 
  { #UI.Op.PushSyncOp(LitInt(a#82#0#0)) } 
  #UI.Op.PushSyncOp(LitInt(a#82#0#0)) == Lit(#UI.Op.PushSyncOp(a#82#0#0)));

function UI.Op.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#83#0#0: int :: 
  { #UI.Op.PushSyncOp(a#83#0#0) } 
  UI.Op.id(#UI.Op.PushSyncOp(a#83#0#0)) == a#83#0#0);

// Constructor function declaration
function #UI.Op.PopSyncOp(int) : DatatypeType;

const unique ##UI.Op.PopSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#84#0#0: int :: 
  { #UI.Op.PopSyncOp(a#84#0#0) } 
  DatatypeCtorId(#UI.Op.PopSyncOp(a#84#0#0)) == ##UI.Op.PopSyncOp);

function UI.Op.PopSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PopSyncOp_q(d) } 
  UI.Op.PopSyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PopSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PopSyncOp_q(d) } 
  UI.Op.PopSyncOp_q(d)
     ==> (exists a#85#0#0: int :: d == #UI.Op.PopSyncOp(a#85#0#0)));

// Constructor $Is
axiom (forall a#86#0#0: int :: 
  { $Is(#UI.Op.PopSyncOp(a#86#0#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PopSyncOp(a#86#0#0), Tclass.UI.Op()) <==> $Is(a#86#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#87#0#0: int, $h: Heap :: 
  { $IsAlloc(#UI.Op.PopSyncOp(a#87#0#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PopSyncOp(a#87#0#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#87#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.id(d), TInt, $h) } 
  $IsGoodHeap($h) && UI.Op.PopSyncOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.id(d), TInt, $h));

// Constructor literal
axiom (forall a#88#0#0: int :: 
  { #UI.Op.PopSyncOp(LitInt(a#88#0#0)) } 
  #UI.Op.PopSyncOp(LitInt(a#88#0#0)) == Lit(#UI.Op.PopSyncOp(a#88#0#0)));

// Constructor injectivity
axiom (forall a#89#0#0: int :: 
  { #UI.Op.PopSyncOp(a#89#0#0) } 
  UI.Op.id(#UI.Op.PopSyncOp(a#89#0#0)) == a#89#0#0);

// Constructor function declaration
function #UI.Op.GetOp(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.Op.GetOp: DtCtorId;

// Constructor identifier
axiom (forall a#90#0#0: Seq Box, a#90#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#90#0#0, a#90#1#0) } 
  DatatypeCtorId(#UI.Op.GetOp(a#90#0#0, a#90#1#0)) == ##UI.Op.GetOp);

function UI.Op.GetOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.GetOp_q(d) } 
  UI.Op.GetOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.GetOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.GetOp_q(d) } 
  UI.Op.GetOp_q(d)
     ==> (exists a#91#0#0: Seq Box, a#91#1#0: Seq Box :: 
      d == #UI.Op.GetOp(a#91#0#0, a#91#1#0)));

// Constructor $Is
axiom (forall a#92#0#0: Seq Box, a#92#1#0: Seq Box :: 
  { $Is(#UI.Op.GetOp(a#92#0#0, a#92#1#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.GetOp(a#92#0#0, a#92#1#0), Tclass.UI.Op())
     <==> $Is(a#92#0#0, Tclass.KeyType.Key()) && $Is(a#92#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#93#0#0: Seq Box, a#93#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.Op.GetOp(a#93#0#0, a#93#1#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.GetOp(a#93#0#0, a#93#1#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#93#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#93#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h) && UI.Op.GetOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h) && UI.Op.GetOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#94#0#0: Seq Box, a#94#1#0: Seq Box :: 
  { #UI.Op.GetOp(Lit(a#94#0#0), Lit(a#94#1#0)) } 
  #UI.Op.GetOp(Lit(a#94#0#0), Lit(a#94#1#0))
     == Lit(#UI.Op.GetOp(a#94#0#0, a#94#1#0)));

function UI.Op.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#95#0#0: Seq Box, a#95#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#95#0#0, a#95#1#0) } 
  UI.Op.key(#UI.Op.GetOp(a#95#0#0, a#95#1#0)) == a#95#0#0);

function UI.Op.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#96#0#0: Seq Box, a#96#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#96#0#0, a#96#1#0) } 
  UI.Op.value(#UI.Op.GetOp(a#96#0#0, a#96#1#0)) == a#96#1#0);

// Constructor function declaration
function #UI.Op.PutOp(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.Op.PutOp: DtCtorId;

// Constructor identifier
axiom (forall a#97#0#0: Seq Box, a#97#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#97#0#0, a#97#1#0) } 
  DatatypeCtorId(#UI.Op.PutOp(a#97#0#0, a#97#1#0)) == ##UI.Op.PutOp);

function UI.Op.PutOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PutOp_q(d) } 
  UI.Op.PutOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PutOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PutOp_q(d) } 
  UI.Op.PutOp_q(d)
     ==> (exists a#98#0#0: Seq Box, a#98#1#0: Seq Box :: 
      d == #UI.Op.PutOp(a#98#0#0, a#98#1#0)));

// Constructor $Is
axiom (forall a#99#0#0: Seq Box, a#99#1#0: Seq Box :: 
  { $Is(#UI.Op.PutOp(a#99#0#0, a#99#1#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PutOp(a#99#0#0, a#99#1#0), Tclass.UI.Op())
     <==> $Is(a#99#0#0, Tclass.KeyType.Key()) && $Is(a#99#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#100#0#0: Seq Box, a#100#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.Op.PutOp(a#100#0#0, a#100#1#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PutOp(a#100#0#0, a#100#1#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#100#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#100#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h) && UI.Op.PutOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h) && UI.Op.PutOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#101#0#0: Seq Box, a#101#1#0: Seq Box :: 
  { #UI.Op.PutOp(Lit(a#101#0#0), Lit(a#101#1#0)) } 
  #UI.Op.PutOp(Lit(a#101#0#0), Lit(a#101#1#0))
     == Lit(#UI.Op.PutOp(a#101#0#0, a#101#1#0)));

// Constructor injectivity
axiom (forall a#102#0#0: Seq Box, a#102#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#102#0#0, a#102#1#0) } 
  UI.Op.key(#UI.Op.PutOp(a#102#0#0, a#102#1#0)) == a#102#0#0);

// Constructor injectivity
axiom (forall a#103#0#0: Seq Box, a#103#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#103#0#0, a#103#1#0) } 
  UI.Op.value(#UI.Op.PutOp(a#103#0#0, a#103#1#0)) == a#103#1#0);

// Constructor function declaration
function #UI.Op.SuccOp(DatatypeType, Seq Box, DatatypeType) : DatatypeType;

const unique ##UI.Op.SuccOp: DtCtorId;

// Constructor identifier
axiom (forall a#104#0#0: DatatypeType, a#104#1#0: Seq Box, a#104#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#104#0#0, a#104#1#0, a#104#2#0) } 
  DatatypeCtorId(#UI.Op.SuccOp(a#104#0#0, a#104#1#0, a#104#2#0)) == ##UI.Op.SuccOp);

function UI.Op.SuccOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d) } 
  UI.Op.SuccOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.SuccOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d) } 
  UI.Op.SuccOp_q(d)
     ==> (exists a#105#0#0: DatatypeType, a#105#1#0: Seq Box, a#105#2#0: DatatypeType :: 
      d == #UI.Op.SuccOp(a#105#0#0, a#105#1#0, a#105#2#0)));

// Constructor $Is
axiom (forall a#106#0#0: DatatypeType, a#106#1#0: Seq Box, a#106#2#0: DatatypeType :: 
  { $Is(#UI.Op.SuccOp(a#106#0#0, a#106#1#0, a#106#2#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.SuccOp(a#106#0#0, a#106#1#0, a#106#2#0), Tclass.UI.Op())
     <==> $Is(a#106#0#0, Tclass.UI.RangeStart())
       && $Is(a#106#1#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#106#2#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#107#0#0: DatatypeType, a#107#1#0: Seq Box, a#107#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#UI.Op.SuccOp(a#107#0#0, a#107#1#0, a#107#2#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.SuccOp(a#107#0#0, a#107#1#0, a#107#2#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#107#0#0, Tclass.UI.RangeStart(), $h)
         && $IsAlloc(a#107#1#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#107#2#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.start(d), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.start(d), Tclass.UI.RangeStart(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#108#0#0: DatatypeType, a#108#1#0: Seq Box, a#108#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(Lit(a#108#0#0), Lit(a#108#1#0), Lit(a#108#2#0)) } 
  #UI.Op.SuccOp(Lit(a#108#0#0), Lit(a#108#1#0), Lit(a#108#2#0))
     == Lit(#UI.Op.SuccOp(a#108#0#0, a#108#1#0, a#108#2#0)));

function UI.Op.start(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#109#0#0: DatatypeType, a#109#1#0: Seq Box, a#109#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#109#0#0, a#109#1#0, a#109#2#0) } 
  UI.Op.start(#UI.Op.SuccOp(a#109#0#0, a#109#1#0, a#109#2#0)) == a#109#0#0);

// Inductive rank
axiom (forall a#110#0#0: DatatypeType, a#110#1#0: Seq Box, a#110#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#110#0#0, a#110#1#0, a#110#2#0) } 
  DtRank(a#110#0#0) < DtRank(#UI.Op.SuccOp(a#110#0#0, a#110#1#0, a#110#2#0)));

function UI.Op.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#111#0#0: DatatypeType, a#111#1#0: Seq Box, a#111#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#111#0#0, a#111#1#0, a#111#2#0) } 
  UI.Op.results(#UI.Op.SuccOp(a#111#0#0, a#111#1#0, a#111#2#0)) == a#111#1#0);

// Inductive seq element rank
axiom (forall a#112#0#0: DatatypeType, a#112#1#0: Seq Box, a#112#2#0: DatatypeType, i: int :: 
  { Seq#Index(a#112#1#0, i), #UI.Op.SuccOp(a#112#0#0, a#112#1#0, a#112#2#0) } 
  0 <= i && i < Seq#Length(a#112#1#0)
     ==> DtRank($Unbox(Seq#Index(a#112#1#0, i)): DatatypeType)
       < DtRank(#UI.Op.SuccOp(a#112#0#0, a#112#1#0, a#112#2#0)));

// Inductive seq rank
axiom (forall a#113#0#0: DatatypeType, a#113#1#0: Seq Box, a#113#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#113#0#0, a#113#1#0, a#113#2#0) } 
  Seq#Rank(a#113#1#0) < DtRank(#UI.Op.SuccOp(a#113#0#0, a#113#1#0, a#113#2#0)));

function UI.Op.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#114#0#0: DatatypeType, a#114#1#0: Seq Box, a#114#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#114#0#0, a#114#1#0, a#114#2#0) } 
  UI.Op.end(#UI.Op.SuccOp(a#114#0#0, a#114#1#0, a#114#2#0)) == a#114#2#0);

// Inductive rank
axiom (forall a#115#0#0: DatatypeType, a#115#1#0: Seq Box, a#115#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#115#0#0, a#115#1#0, a#115#2#0) } 
  DtRank(a#115#2#0) < DtRank(#UI.Op.SuccOp(a#115#0#0, a#115#1#0, a#115#2#0)));

// Depth-one case-split function
function $IsA#UI.Op(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.Op(d) } 
  $IsA#UI.Op(d)
     ==> UI.Op.NoOp_q(d)
       || UI.Op.SyncOp_q(d)
       || UI.Op.CrashOp_q(d)
       || UI.Op.PushSyncOp_q(d)
       || UI.Op.PopSyncOp_q(d)
       || UI.Op.GetOp_q(d)
       || UI.Op.PutOp_q(d)
       || UI.Op.SuccOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PutOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.GetOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PopSyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PushSyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.CrashOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.SyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.NoOp_q(d), $Is(d, Tclass.UI.Op()) } 
  $Is(d, Tclass.UI.Op())
     ==> UI.Op.NoOp_q(d)
       || UI.Op.SyncOp_q(d)
       || UI.Op.CrashOp_q(d)
       || UI.Op.PushSyncOp_q(d)
       || UI.Op.PopSyncOp_q(d)
       || UI.Op.GetOp_q(d)
       || UI.Op.PutOp_q(d)
       || UI.Op.SuccOp_q(d));

// Datatype extensional equality declaration
function UI.Op#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.Op.NoOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.NoOp_q(a) } { UI.Op#Equal(a, b), UI.Op.NoOp_q(b) } 
  UI.Op.NoOp_q(a) && UI.Op.NoOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.SyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.SyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.SyncOp_q(b) } 
  UI.Op.SyncOp_q(a) && UI.Op.SyncOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.CrashOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.CrashOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.CrashOp_q(b) } 
  UI.Op.CrashOp_q(a) && UI.Op.CrashOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.PushSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PushSyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.PushSyncOp_q(b) } 
  UI.Op.PushSyncOp_q(a) && UI.Op.PushSyncOp_q(b)
     ==> (UI.Op#Equal(a, b) <==> UI.Op.id(a) == UI.Op.id(b)));

// Datatype extensional equality definition: #UI.Op.PopSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PopSyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.PopSyncOp_q(b) } 
  UI.Op.PopSyncOp_q(a) && UI.Op.PopSyncOp_q(b)
     ==> (UI.Op#Equal(a, b) <==> UI.Op.id(a) == UI.Op.id(b)));

// Datatype extensional equality definition: #UI.Op.GetOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.GetOp_q(a) } { UI.Op#Equal(a, b), UI.Op.GetOp_q(b) } 
  UI.Op.GetOp_q(a) && UI.Op.GetOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> Seq#Equal(UI.Op.key(a), UI.Op.key(b))
         && Seq#Equal(UI.Op.value(a), UI.Op.value(b))));

// Datatype extensional equality definition: #UI.Op.PutOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PutOp_q(a) } { UI.Op#Equal(a, b), UI.Op.PutOp_q(b) } 
  UI.Op.PutOp_q(a) && UI.Op.PutOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> Seq#Equal(UI.Op.key(a), UI.Op.key(b))
         && Seq#Equal(UI.Op.value(a), UI.Op.value(b))));

// Datatype extensional equality definition: #UI.Op.SuccOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.SuccOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.SuccOp_q(b) } 
  UI.Op.SuccOp_q(a) && UI.Op.SuccOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> UI.RangeStart#Equal(UI.Op.start(a), UI.Op.start(b))
         && Seq#Equal(UI.Op.results(a), UI.Op.results(b))
         && UI.RangeEnd#Equal(UI.Op.end(a), UI.Op.end(b))));

// Datatype extensionality axiom: UI.Op
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b) } 
  UI.Op#Equal(a, b) <==> a == b);

const unique class.UI.Op: ClassName;

const unique class.UI.__default: ClassName;

function Tclass.UI.__default() : Ty;

// Tclass.UI.__default Tag
axiom Tag(Tclass.UI.__default()) == Tagclass.UI.__default;

const unique Tagclass.UI.__default: TyTag;

// Box/unbox axiom for Tclass.UI.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.__default()) } 
  $IsBox(bx, Tclass.UI.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.UI.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.UI.__default()) } 
  $Is($o, Tclass.UI.__default())
     <==> $o == null || dtype($o) == Tclass.UI.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.UI.__default(), $h) } 
  $IsAlloc($o, Tclass.UI.__default(), $h) <==> $o == null || read($h, $o, alloc));

// Constructor function declaration
function #Journal.JournalEntry.JournalInsert(Seq Box, Seq Box) : DatatypeType;

const unique ##Journal.JournalEntry.JournalInsert: DtCtorId;

// Constructor identifier
axiom (forall a#116#0#0: Seq Box, a#116#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(a#116#0#0, a#116#1#0) } 
  DatatypeCtorId(#Journal.JournalEntry.JournalInsert(a#116#0#0, a#116#1#0))
     == ##Journal.JournalEntry.JournalInsert);

function Journal.JournalEntry.JournalInsert_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Journal.JournalEntry.JournalInsert_q(d) } 
  Journal.JournalEntry.JournalInsert_q(d)
     <==> DatatypeCtorId(d) == ##Journal.JournalEntry.JournalInsert);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Journal.JournalEntry.JournalInsert_q(d) } 
  Journal.JournalEntry.JournalInsert_q(d)
     ==> (exists a#117#0#0: Seq Box, a#117#1#0: Seq Box :: 
      d == #Journal.JournalEntry.JournalInsert(a#117#0#0, a#117#1#0)));

// Constructor $Is
axiom (forall a#118#0#0: Seq Box, a#118#1#0: Seq Box :: 
  { $Is(#Journal.JournalEntry.JournalInsert(a#118#0#0, a#118#1#0), 
      Tclass.Journal.JournalEntry()) } 
  $Is(#Journal.JournalEntry.JournalInsert(a#118#0#0, a#118#1#0), 
      Tclass.Journal.JournalEntry())
     <==> $Is(a#118#0#0, Tclass.KeyType.Key()) && $Is(a#118#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#119#0#0: Seq Box, a#119#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#Journal.JournalEntry.JournalInsert(a#119#0#0, a#119#1#0), 
      Tclass.Journal.JournalEntry(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Journal.JournalEntry.JournalInsert(a#119#0#0, a#119#1#0), 
        Tclass.Journal.JournalEntry(), 
        $h)
       <==> $IsAlloc(a#119#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#119#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(Journal.JournalEntry.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      Journal.JournalEntry.JournalInsert_q(d)
       && $IsAlloc(d, Tclass.Journal.JournalEntry(), $h)
     ==> $IsAlloc(Journal.JournalEntry.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(Journal.JournalEntry.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      Journal.JournalEntry.JournalInsert_q(d)
       && $IsAlloc(d, Tclass.Journal.JournalEntry(), $h)
     ==> $IsAlloc(Journal.JournalEntry.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#120#0#0: Seq Box, a#120#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(Lit(a#120#0#0), Lit(a#120#1#0)) } 
  #Journal.JournalEntry.JournalInsert(Lit(a#120#0#0), Lit(a#120#1#0))
     == Lit(#Journal.JournalEntry.JournalInsert(a#120#0#0, a#120#1#0)));

function Journal.JournalEntry.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#121#0#0: Seq Box, a#121#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(a#121#0#0, a#121#1#0) } 
  Journal.JournalEntry.key(#Journal.JournalEntry.JournalInsert(a#121#0#0, a#121#1#0))
     == a#121#0#0);

function Journal.JournalEntry.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#122#0#0: Seq Box, a#122#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(a#122#0#0, a#122#1#0) } 
  Journal.JournalEntry.value(#Journal.JournalEntry.JournalInsert(a#122#0#0, a#122#1#0))
     == a#122#1#0);

// Depth-one case-split function
function $IsA#Journal.JournalEntry(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Journal.JournalEntry(d) } 
  $IsA#Journal.JournalEntry(d) ==> Journal.JournalEntry.JournalInsert_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { Journal.JournalEntry.JournalInsert_q(d), $Is(d, Tclass.Journal.JournalEntry()) } 
  $Is(d, Tclass.Journal.JournalEntry())
     ==> Journal.JournalEntry.JournalInsert_q(d));

// Datatype extensional equality declaration
function Journal.JournalEntry#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Journal.JournalEntry.JournalInsert
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Journal.JournalEntry#Equal(a, b) } 
  true
     ==> (Journal.JournalEntry#Equal(a, b)
       <==> Seq#Equal(Journal.JournalEntry.key(a), Journal.JournalEntry.key(b))
         && Seq#Equal(Journal.JournalEntry.value(a), Journal.JournalEntry.value(b))));

// Datatype extensionality axiom: Journal.JournalEntry
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Journal.JournalEntry#Equal(a, b) } 
  Journal.JournalEntry#Equal(a, b) <==> a == b);

const unique class.Journal.JournalEntry: ClassName;

const unique class.Journal.__default: ClassName;

function Tclass.Journal.__default() : Ty;

// Tclass.Journal.__default Tag
axiom Tag(Tclass.Journal.__default()) == Tagclass.Journal.__default;

const unique Tagclass.Journal.__default: TyTag;

// Box/unbox axiom for Tclass.Journal.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Journal.__default()) } 
  $IsBox(bx, Tclass.Journal.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Journal.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Journal.__default()) } 
  $Is($o, Tclass.Journal.__default())
     <==> $o == null || dtype($o) == Tclass.Journal.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Journal.__default(), $h) } 
  $IsAlloc($o, Tclass.Journal.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Journal._default.JournalEntriesForUIOp
function Journal.__default.JournalEntriesForUIOp(uiop#0: DatatypeType) : Seq Box;

function Journal.__default.JournalEntriesForUIOp#canCall(uiop#0: DatatypeType) : bool;

// consequence axiom for Journal.__default.JournalEntriesForUIOp
axiom true
   ==> (forall uiop#0: DatatypeType :: 
    { Journal.__default.JournalEntriesForUIOp(uiop#0) } 
    Journal.__default.JournalEntriesForUIOp#canCall(uiop#0)
         || $Is(uiop#0, Tclass.UI.Op())
       ==> $Is(Journal.__default.JournalEntriesForUIOp(uiop#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function Journal.__default.JournalEntriesForUIOp#requires(DatatypeType) : bool;

// #requires axiom for Journal.__default.JournalEntriesForUIOp
axiom (forall uiop#0: DatatypeType :: 
  { Journal.__default.JournalEntriesForUIOp#requires(uiop#0) } 
  $Is(uiop#0, Tclass.UI.Op())
     ==> Journal.__default.JournalEntriesForUIOp#requires(uiop#0) == true);

// definition axiom for Journal.__default.JournalEntriesForUIOp(revealed)
axiom true
   ==> (forall uiop#0: DatatypeType :: 
    { Journal.__default.JournalEntriesForUIOp(uiop#0) } 
    Journal.__default.JournalEntriesForUIOp#canCall(uiop#0)
         || $Is(uiop#0, Tclass.UI.Op())
       ==> Journal.__default.JournalEntriesForUIOp(uiop#0)
         == (if UI.Op.PutOp_q(uiop#0)
           then Seq#Build(Seq#Empty(): Seq Box, 
            $Box(#Journal.JournalEntry.JournalInsert(UI.Op.key(uiop#0), UI.Op.value(uiop#0))))
           else Seq#Empty(): Seq Box));

// definition axiom for Journal.__default.JournalEntriesForUIOp for all literals(revealed)
axiom true
   ==> (forall uiop#0: DatatypeType :: 
    {:weight 3} { Journal.__default.JournalEntriesForUIOp(Lit(uiop#0)) } 
    Journal.__default.JournalEntriesForUIOp#canCall(Lit(uiop#0))
         || $Is(uiop#0, Tclass.UI.Op())
       ==> Journal.__default.JournalEntriesForUIOp(Lit(uiop#0))
         == (if UI.Op.PutOp_q(Lit(uiop#0))
           then Seq#Build(Seq#Empty(): Seq Box, 
            $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(UI.Op.key(Lit(uiop#0))), Lit(UI.Op.value(Lit(uiop#0)))))))
           else Seq#Empty(): Seq Box));

// function declaration for Journal._default.JournalEntriesForUIOps
function Journal.__default.JournalEntriesForUIOps($ly: LayerType, uiops#0: Seq Box) : Seq Box;

function Journal.__default.JournalEntriesForUIOps#canCall(uiops#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, uiops#0: Seq Box :: 
  { Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0) } 
  Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0)
     == Journal.__default.JournalEntriesForUIOps($ly, uiops#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, uiops#0: Seq Box :: 
  { Journal.__default.JournalEntriesForUIOps(AsFuelBottom($ly), uiops#0) } 
  Journal.__default.JournalEntriesForUIOps($ly, uiops#0)
     == Journal.__default.JournalEntriesForUIOps($LZ, uiops#0));

// consequence axiom for Journal.__default.JournalEntriesForUIOps
axiom true
   ==> (forall $ly: LayerType, uiops#0: Seq Box :: 
    { Journal.__default.JournalEntriesForUIOps($ly, uiops#0) } 
    Journal.__default.JournalEntriesForUIOps#canCall(uiops#0)
         || $Is(uiops#0, TSeq(Tclass.UI.Op()))
       ==> $Is(Journal.__default.JournalEntriesForUIOps($ly, uiops#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function Journal.__default.JournalEntriesForUIOps#requires(LayerType, Seq Box) : bool;

// #requires axiom for Journal.__default.JournalEntriesForUIOps
axiom (forall $ly: LayerType, uiops#0: Seq Box :: 
  { Journal.__default.JournalEntriesForUIOps#requires($ly, uiops#0) } 
  $Is(uiops#0, TSeq(Tclass.UI.Op()))
     ==> Journal.__default.JournalEntriesForUIOps#requires($ly, uiops#0) == true);

// definition axiom for Journal.__default.JournalEntriesForUIOps(revealed)
axiom true
   ==> (forall $ly: LayerType, uiops#0: Seq Box :: 
    { Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0) } 
    Journal.__default.JournalEntriesForUIOps#canCall(uiops#0)
         || $Is(uiops#0, TSeq(Tclass.UI.Op()))
       ==> (!Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.UI.Op(), uiops#0)
             && Journal.__default.JournalEntriesForUIOps#canCall(Sequences.__default.DropLast(Tclass.UI.Op(), uiops#0))
             && 
            Sequences.__default.Last#canCall(Tclass.UI.Op(), uiops#0)
             && Journal.__default.JournalEntriesForUIOp#canCall($Unbox(Sequences.__default.Last(Tclass.UI.Op(), uiops#0)): DatatypeType))
         && Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0)
           == (if Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
             then Seq#Empty(): Seq Box
             else Seq#Append(Journal.__default.JournalEntriesForUIOps($ly, Sequences.__default.DropLast(Tclass.UI.Op(), uiops#0)), 
              Journal.__default.JournalEntriesForUIOp($Unbox(Sequences.__default.Last(Tclass.UI.Op(), uiops#0)): DatatypeType))));

// definition axiom for Journal.__default.JournalEntriesForUIOps for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, uiops#0: Seq Box :: 
    {:weight 3} { Journal.__default.JournalEntriesForUIOps($LS($ly), Lit(uiops#0)) } 
    Journal.__default.JournalEntriesForUIOps#canCall(Lit(uiops#0))
         || $Is(uiops#0, TSeq(Tclass.UI.Op()))
       ==> (!Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.UI.Op(), Lit(uiops#0))
             && Journal.__default.JournalEntriesForUIOps#canCall(Lit(Sequences.__default.DropLast(Tclass.UI.Op(), Lit(uiops#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.UI.Op(), Lit(uiops#0))
             && Journal.__default.JournalEntriesForUIOp#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.UI.Op(), Lit(uiops#0))): DatatypeType)))
         && Journal.__default.JournalEntriesForUIOps($LS($ly), Lit(uiops#0))
           == (if Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
             then Seq#Empty(): Seq Box
             else Seq#Append(Journal.__default.JournalEntriesForUIOps($LS($ly), Lit(Sequences.__default.DropLast(Tclass.UI.Op(), Lit(uiops#0)))), 
              Journal.__default.JournalEntriesForUIOp(Lit($Unbox(Sequences.__default.Last(Tclass.UI.Op(), Lit(uiops#0))): DatatypeType)))));

const unique class.NativePackedInts.__default: ClassName;

function Tclass.NativePackedInts.__default() : Ty;

// Tclass.NativePackedInts.__default Tag
axiom Tag(Tclass.NativePackedInts.__default()) == Tagclass.NativePackedInts.__default;

const unique Tagclass.NativePackedInts.__default: TyTag;

// Box/unbox axiom for Tclass.NativePackedInts.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativePackedInts.__default()) } 
  $IsBox(bx, Tclass.NativePackedInts.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativePackedInts.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativePackedInts.__default()) } 
  $Is($o, Tclass.NativePackedInts.__default())
     <==> $o == null || dtype($o) == Tclass.NativePackedInts.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativePackedInts.__default(), $h) } 
  $IsAlloc($o, Tclass.NativePackedInts.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32
function NativePackedInts.__default.unpack__LittleEndian__Uint32($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) < 4294967296);

function NativePackedInts.__default.unpack__LittleEndian__Uint32#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(4)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64
function NativePackedInts.__default.unpack__LittleEndian__Uint64($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
           < 18446744073709551616);

function NativePackedInts.__default.unpack__LittleEndian__Uint64#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(8)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(7))): int, LitInt(72057594037927936)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                i#0)): int } 
          LitInt(0) <= i#0 && i#0 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                  i#0)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), i#0) + 4), Mul(LitInt(4), i#0))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint32())));

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(4))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(4))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))))));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                i#0)): int } 
          LitInt(0) <= i#0 && i#0 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                  i#0)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), i#0) + 8), Mul(LitInt(8), i#0))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint64())));

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(8))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(8))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))))));

// Constructor function declaration
function #JournalRanges.Header.Header(int, int) : DatatypeType;

const unique ##JournalRanges.Header.Header: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: int :: 
  { #JournalRanges.Header.Header(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#JournalRanges.Header.Header(a#0#0#0, a#0#1#0))
     == ##JournalRanges.Header.Header);

function JournalRanges.Header.Header_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalRanges.Header.Header_q(d) } 
  JournalRanges.Header.Header_q(d)
     <==> DatatypeCtorId(d) == ##JournalRanges.Header.Header);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalRanges.Header.Header_q(d) } 
  JournalRanges.Header.Header_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: int :: 
      d == #JournalRanges.Header.Header(a#1#0#0, a#1#1#0)));

function Tclass.JournalRanges.Header() : Ty;

// Tclass.JournalRanges.Header Tag
axiom Tag(Tclass.JournalRanges.Header()) == Tagclass.JournalRanges.Header;

const unique Tagclass.JournalRanges.Header: TyTag;

// Box/unbox axiom for Tclass.JournalRanges.Header
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalRanges.Header()) } 
  $IsBox(bx, Tclass.JournalRanges.Header())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalRanges.Header()));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: int :: 
  { $Is(#JournalRanges.Header.Header(a#2#0#0, a#2#1#0), Tclass.JournalRanges.Header()) } 
  $Is(#JournalRanges.Header.Header(a#2#0#0, a#2#1#0), Tclass.JournalRanges.Header())
     <==> $Is(a#2#0#0, TInt) && $Is(a#2#1#0, TInt));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: int, $h: Heap :: 
  { $IsAlloc(#JournalRanges.Header.Header(a#3#0#0, a#3#1#0), 
      Tclass.JournalRanges.Header(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalRanges.Header.Header(a#3#0#0, a#3#1#0), 
        Tclass.JournalRanges.Header(), 
        $h)
       <==> $IsAlloc(a#3#0#0, TInt, $h) && $IsAlloc(a#3#1#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalRanges.Header.nentries(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalRanges.Header.Header_q(d)
       && $IsAlloc(d, Tclass.JournalRanges.Header(), $h)
     ==> $IsAlloc(JournalRanges.Header.nentries(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalRanges.Header.nblocks(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalRanges.Header.Header_q(d)
       && $IsAlloc(d, Tclass.JournalRanges.Header(), $h)
     ==> $IsAlloc(JournalRanges.Header.nblocks(d), TInt, $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: int :: 
  { #JournalRanges.Header.Header(LitInt(a#4#0#0), LitInt(a#4#1#0)) } 
  #JournalRanges.Header.Header(LitInt(a#4#0#0), LitInt(a#4#1#0))
     == Lit(#JournalRanges.Header.Header(a#4#0#0, a#4#1#0)));

function JournalRanges.Header.nentries(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: int :: 
  { #JournalRanges.Header.Header(a#5#0#0, a#5#1#0) } 
  JournalRanges.Header.nentries(#JournalRanges.Header.Header(a#5#0#0, a#5#1#0))
     == a#5#0#0);

function JournalRanges.Header.nblocks(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: int :: 
  { #JournalRanges.Header.Header(a#6#0#0, a#6#1#0) } 
  JournalRanges.Header.nblocks(#JournalRanges.Header.Header(a#6#0#0, a#6#1#0))
     == a#6#1#0);

// Depth-one case-split function
function $IsA#JournalRanges.Header(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalRanges.Header(d) } 
  $IsA#JournalRanges.Header(d) ==> JournalRanges.Header.Header_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalRanges.Header.Header_q(d), $Is(d, Tclass.JournalRanges.Header()) } 
  $Is(d, Tclass.JournalRanges.Header()) ==> JournalRanges.Header.Header_q(d));

// Datatype extensional equality declaration
function JournalRanges.Header#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalRanges.Header.Header
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalRanges.Header#Equal(a, b) } 
  true
     ==> (JournalRanges.Header#Equal(a, b)
       <==> JournalRanges.Header.nentries(a) == JournalRanges.Header.nentries(b)
         && JournalRanges.Header.nblocks(a) == JournalRanges.Header.nblocks(b)));

// Datatype extensionality axiom: JournalRanges.Header
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalRanges.Header#Equal(a, b) } 
  JournalRanges.Header#Equal(a, b) <==> a == b);

const unique class.JournalRanges.Header: ClassName;

const unique class.JournalRanges.__default: ClassName;

function Tclass.JournalRanges.__default() : Ty;

// Tclass.JournalRanges.__default Tag
axiom Tag(Tclass.JournalRanges.__default()) == Tagclass.JournalRanges.__default;

const unique Tagclass.JournalRanges.__default: TyTag;

// Box/unbox axiom for Tclass.JournalRanges.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalRanges.__default()) } 
  $IsBox(bx, Tclass.JournalRanges.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalRanges.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalRanges.__default()) } 
  $Is($o, Tclass.JournalRanges.__default())
     <==> $o == null || dtype($o) == Tclass.JournalRanges.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalRanges.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalRanges.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalRanges._default.JournalRangeLen
function JournalRanges.__default.JournalRangeLen(jr#0: Seq Box) : int;

function JournalRanges.__default.JournalRangeLen#canCall(jr#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeLen
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeLen(jr#0) } 
    JournalRanges.__default.JournalRangeLen#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalRangeLen(jr#0) >= LitInt(0));

function JournalRanges.__default.JournalRangeLen#requires(Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeLen
axiom (forall jr#0: Seq Box :: 
  { JournalRanges.__default.JournalRangeLen#requires(jr#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalRangeLen#requires(jr#0) == true);

// definition axiom for JournalRanges.__default.JournalRangeLen(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeLen(jr#0) } 
    JournalRanges.__default.JournalRangeLen#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalRangeLen(jr#0) == Seq#Length(jr#0));

// definition axiom for JournalRanges.__default.JournalRangeLen for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalRangeLen(Lit(jr#0)) } 
    JournalRanges.__default.JournalRangeLen#canCall(Lit(jr#0))
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalRangeLen(Lit(jr#0)) == Seq#Length(Lit(jr#0)));

// function declaration for JournalRanges._default.JournalRangePrefix
function JournalRanges.__default.JournalRangePrefix(jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalRangePrefix#canCall(jr#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalRanges.__default.JournalRangePrefix
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangePrefix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangePrefix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangeLen(JournalRanges.__default.JournalRangePrefix(jr#0, i#0))
           == i#0
         && $Is(JournalRanges.__default.JournalRangePrefix(jr#0, i#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function JournalRanges.__default.JournalRangePrefix#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalRangePrefix
axiom (forall jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalRangePrefix#requires(jr#0, i#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalRangePrefix#requires(jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0)));

// definition axiom for JournalRanges.__default.JournalRangePrefix(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangePrefix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangePrefix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangePrefix(jr#0, i#0) == Seq#Take(jr#0, i#0));

// definition axiom for JournalRanges.__default.JournalRangePrefix for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalRanges.__default.JournalRangePrefix(Lit(jr#0), LitInt(i#0)) } 
    JournalRanges.__default.JournalRangePrefix#canCall(Lit(jr#0), LitInt(i#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(JournalRanges.__default.JournalRangeLen(Lit(jr#0))))
       ==> JournalRanges.__default.JournalRangePrefix(Lit(jr#0), LitInt(i#0))
         == Lit(Seq#Take(Lit(jr#0), LitInt(i#0))));

// function declaration for JournalRanges._default.JournalRangeSuffix
function JournalRanges.__default.JournalRangeSuffix(jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalRangeSuffix#canCall(jr#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeSuffix
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangeSuffix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangeSuffix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangeLen(JournalRanges.__default.JournalRangeSuffix(jr#0, i#0))
           == JournalRanges.__default.JournalRangeLen(jr#0) - i#0
         && $Is(JournalRanges.__default.JournalRangeSuffix(jr#0, i#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function JournalRanges.__default.JournalRangeSuffix#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeSuffix
axiom (forall jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalRangeSuffix#requires(jr#0, i#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalRangeSuffix#requires(jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0)));

// definition axiom for JournalRanges.__default.JournalRangeSuffix(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangeSuffix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangeSuffix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangeSuffix(jr#0, i#0) == Seq#Drop(jr#0, i#0));

// definition axiom for JournalRanges.__default.JournalRangeSuffix for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalRanges.__default.JournalRangeSuffix(Lit(jr#0), LitInt(i#0)) } 
    JournalRanges.__default.JournalRangeSuffix#canCall(Lit(jr#0), LitInt(i#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(JournalRanges.__default.JournalRangeLen(Lit(jr#0))))
       ==> JournalRanges.__default.JournalRangeSuffix(Lit(jr#0), LitInt(i#0))
         == Lit(Seq#Drop(Lit(jr#0), LitInt(i#0))));

// function declaration for JournalRanges._default.JournalRangeConcat
function JournalRanges.__default.JournalRangeConcat(jr1#0: Seq Box, jr2#0: Seq Box) : Seq Box;

function JournalRanges.__default.JournalRangeConcat#canCall(jr1#0: Seq Box, jr2#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeConcat
axiom true
   ==> (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0) } 
    JournalRanges.__default.JournalRangeConcat#canCall(jr1#0, jr2#0)
         || ($Is(jr1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jr2#0, TSeq(TSeq(Tclass.NativeTypes.byte()))))
       ==> $Is(JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0), 
        TSeq(TSeq(Tclass.NativeTypes.byte()))));

function JournalRanges.__default.JournalRangeConcat#requires(Seq Box, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeConcat
axiom (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
  { JournalRanges.__default.JournalRangeConcat#requires(jr1#0, jr2#0) } 
  $Is(jr1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(jr2#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalRangeConcat#requires(jr1#0, jr2#0) == true);

// definition axiom for JournalRanges.__default.JournalRangeConcat(revealed)
axiom true
   ==> (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0) } 
    JournalRanges.__default.JournalRangeConcat#canCall(jr1#0, jr2#0)
         || ($Is(jr1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jr2#0, TSeq(TSeq(Tclass.NativeTypes.byte()))))
       ==> JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0)
         == Seq#Append(jr1#0, jr2#0));

// definition axiom for JournalRanges.__default.JournalRangeConcat for all literals(revealed)
axiom true
   ==> (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalRangeConcat(Lit(jr1#0), Lit(jr2#0)) } 
    JournalRanges.__default.JournalRangeConcat#canCall(Lit(jr1#0), Lit(jr2#0))
         || ($Is(jr1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jr2#0, TSeq(TSeq(Tclass.NativeTypes.byte()))))
       ==> JournalRanges.__default.JournalRangeConcat(Lit(jr1#0), Lit(jr2#0))
         == Seq#Append(jr1#0, jr2#0));

// function declaration for JournalRanges._default.JournalRangeEmpty
function JournalRanges.__default.JournalRangeEmpty() : Seq Box;

function JournalRanges.__default.JournalRangeEmpty#canCall() : bool;

// consequence axiom for JournalRanges.__default.JournalRangeEmpty
axiom true
   ==> 
  true
   ==> $Is(JournalRanges.__default.JournalRangeEmpty(), 
    TSeq(TSeq(Tclass.NativeTypes.byte())));

function JournalRanges.__default.JournalRangeEmpty#requires() : bool;

// #requires axiom for JournalRanges.__default.JournalRangeEmpty
axiom JournalRanges.__default.JournalRangeEmpty#requires() == true;

// definition axiom for JournalRanges.__default.JournalRangeEmpty(revealed)
axiom true
   ==> 
  true
   ==> JournalRanges.__default.JournalRangeEmpty() == Lit(Seq#Empty(): Seq Box);

// definition axiom for JournalRanges.__default.JournalRangeEmpty for all literals(revealed)
axiom true
   ==> 
  true
   ==> JournalRanges.__default.JournalRangeEmpty() == Lit(Seq#Empty(): Seq Box);

// function declaration for JournalRanges._default.JournalBlocksI
function JournalRanges.__default.JournalBlocksI($ly: LayerType, jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalBlocksI#canCall(jr#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalBlocksI($LS($ly), jr#0, i#0) } 
  JournalRanges.__default.JournalBlocksI($LS($ly), jr#0, i#0)
     == JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalBlocksI(AsFuelBottom($ly), jr#0, i#0) } 
  JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0)
     == JournalRanges.__default.JournalBlocksI($LZ, jr#0, i#0));

// consequence axiom for JournalRanges.__default.JournalBlocksI
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0) } 
    JournalRanges.__default.JournalBlocksI#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(jr#0))
       ==> Seq#Length(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0)) == i#0
         && (forall j#0: int :: 
          { $Unbox(Seq#Index(jr#0, j#0)): Seq Box } 
            { $Unbox(Seq#Index(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0), j#0)): Seq Box } 
          LitInt(0) <= j#0 && j#0 < i#0
             ==> Seq#Equal($Unbox(Seq#Index(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0), j#0)): Seq Box, 
              Seq#Build(Seq#Empty(): Seq Box, Seq#Index(jr#0, j#0))))
         && $Is(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0), 
          TSeq(TSeq(TSeq(Tclass.NativeTypes.byte())))));

function JournalRanges.__default.JournalBlocksI#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalBlocksI
axiom (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalBlocksI#requires($ly, jr#0, i#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalBlocksI#requires($ly, jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(jr#0)));

// definition axiom for JournalRanges.__default.JournalBlocksI(revealed)
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlocksI($LS($ly), jr#0, i#0) } 
    JournalRanges.__default.JournalBlocksI#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(jr#0))
       ==> (i#0 != LitInt(0)
           ==> JournalRanges.__default.JournalBlocksI#canCall(jr#0, i#0 - 1))
         && JournalRanges.__default.JournalBlocksI($LS($ly), jr#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Build(Seq#Empty(): Seq Box, Seq#Index(jr#0, i#0 - 1)))))));

// definition axiom for JournalRanges.__default.JournalBlocksI for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalRanges.__default.JournalBlocksI($LS($ly), Lit(jr#0), LitInt(i#0)) } 
    JournalRanges.__default.JournalBlocksI#canCall(Lit(jr#0), LitInt(i#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(jr#0)))
       ==> (LitInt(i#0) != LitInt(0)
           ==> JournalRanges.__default.JournalBlocksI#canCall(Lit(jr#0), LitInt(i#0 - 1)))
         && JournalRanges.__default.JournalBlocksI($LS($ly), Lit(jr#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(JournalRanges.__default.JournalBlocksI($LS($ly), Lit(jr#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Build(Seq#Empty(): Seq Box, Seq#Index(Lit(jr#0), LitInt(i#0 - 1))))))));

// function declaration for JournalRanges._default.JournalBlocks
function JournalRanges.__default.JournalBlocks(jr#0: Seq Box) : Seq Box;

function JournalRanges.__default.JournalBlocks#canCall(jr#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalBlocks
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalBlocks(jr#0) } 
    JournalRanges.__default.JournalBlocks#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Seq#Length(JournalRanges.__default.JournalBlocks(jr#0))
           == JournalRanges.__default.JournalRangeLen(jr#0)
         && $Is(JournalRanges.__default.JournalBlocks(jr#0), 
          TSeq(TSeq(TSeq(Tclass.NativeTypes.byte())))));

function JournalRanges.__default.JournalBlocks#requires(Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalBlocks
axiom (forall jr#0: Seq Box :: 
  { JournalRanges.__default.JournalBlocks#requires(jr#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalBlocks#requires(jr#0) == true);

// definition axiom for JournalRanges.__default.JournalBlocks(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalBlocks(jr#0) } 
    JournalRanges.__default.JournalBlocks#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalBlocksI#canCall(jr#0, Seq#Length(jr#0))
         && JournalRanges.__default.JournalBlocks(jr#0)
           == JournalRanges.__default.JournalBlocksI($LS($LZ), jr#0, Seq#Length(jr#0)));

// definition axiom for JournalRanges.__default.JournalBlocks for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalBlocks(Lit(jr#0)) } 
    JournalRanges.__default.JournalBlocks#canCall(Lit(jr#0))
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalBlocksI#canCall(Lit(jr#0), Seq#Length(Lit(jr#0)))
         && JournalRanges.__default.JournalBlocks(Lit(jr#0))
           == JournalRanges.__default.JournalBlocksI($LS($LZ), Lit(jr#0), Seq#Length(Lit(jr#0))));

// function declaration for JournalRanges._default.JournalBlockGet
function JournalRanges.__default.JournalBlockGet(jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalBlockGet#canCall(jr#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalRanges.__default.JournalBlockGet
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlockGet(jr#0, i#0) } 
    JournalRanges.__default.JournalBlockGet#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 < JournalRanges.__default.JournalRangeLen(jr#0))
       ==> $Is(JournalRanges.__default.JournalBlockGet(jr#0, i#0), 
        TSeq(TSeq(Tclass.NativeTypes.byte()))));

function JournalRanges.__default.JournalBlockGet#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalBlockGet
axiom (forall jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalBlockGet#requires(jr#0, i#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalBlockGet#requires(jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 < JournalRanges.__default.JournalRangeLen(jr#0)));

// definition axiom for JournalRanges.__default.JournalBlockGet(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlockGet(jr#0, i#0) } 
    JournalRanges.__default.JournalBlockGet#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 < JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalBlocks#canCall(jr#0)
         && JournalRanges.__default.JournalBlockGet(jr#0, i#0)
           == $Unbox(Seq#Index(JournalRanges.__default.JournalBlocks(jr#0), i#0)): Seq Box);

// definition axiom for JournalRanges.__default.JournalBlockGet for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalRanges.__default.JournalBlockGet(Lit(jr#0), LitInt(i#0)) } 
    JournalRanges.__default.JournalBlockGet#canCall(Lit(jr#0), LitInt(i#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < JournalRanges.__default.JournalRangeLen(Lit(jr#0)))
       ==> JournalRanges.__default.JournalBlocks#canCall(Lit(jr#0))
         && JournalRanges.__default.JournalBlockGet(Lit(jr#0), LitInt(i#0))
           == $Unbox(Seq#Index(Lit(JournalRanges.__default.JournalBlocks(Lit(jr#0))), LitInt(i#0))): Seq Box);

// function declaration for JournalRanges._default.parseHeader
function JournalRanges.__default.parseHeader($ly: LayerType, s#0: Seq Box) : DatatypeType;

function JournalRanges.__default.parseHeader#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.parseHeader($LS($ly), s#0) } 
  JournalRanges.__default.parseHeader($LS($ly), s#0)
     == JournalRanges.__default.parseHeader($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.parseHeader(AsFuelBottom($ly), s#0) } 
  JournalRanges.__default.parseHeader($ly, s#0)
     == JournalRanges.__default.parseHeader($LZ, s#0));

// consequence axiom for JournalRanges.__default.parseHeader
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.parseHeader($ly, s#0) } 
    JournalRanges.__default.parseHeader#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) >= LitInt(8))
       ==> $Is(JournalRanges.__default.parseHeader($ly, s#0), Tclass.JournalRanges.Header()));

function JournalRanges.__default.parseHeader#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.parseHeader
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.parseHeader#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalRanges.__default.parseHeader#requires($ly, s#0)
       == (Seq#Length(s#0) >= LitInt(8)));

// definition axiom for JournalRanges.__default.parseHeader(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.parseHeader($LS($ly), s#0) } 
    JournalRanges.__default.parseHeader#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) >= LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, LitInt(4)), LitInt(0)))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, LitInt(8)), LitInt(4)))
         && JournalRanges.__default.parseHeader($LS($ly), s#0)
           == #JournalRanges.Header.Header(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
              Seq#Drop(Seq#Take(s#0, LitInt(4)), LitInt(0))), 
            NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
              Seq#Drop(Seq#Take(s#0, LitInt(8)), LitInt(4)))));

// definition axiom for JournalRanges.__default.parseHeader for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.parseHeader($LS($ly), Lit(s#0)) } 
    JournalRanges.__default.parseHeader#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) >= LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4)), LitInt(0))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(8)), LitInt(4))))
         && JournalRanges.__default.parseHeader($LS($ly), Lit(s#0))
           == #JournalRanges.Header.Header(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
              Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4)), LitInt(0)))), 
            NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
              Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(8)), LitInt(4))))));

// function declaration for JournalRanges._default.parseEntries
function JournalRanges.__default.parseEntries($ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int) : DatatypeType;

function JournalRanges.__default.parseEntries#canCall(s#0: Seq Box, len#0: int, idx#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
  { JournalRanges.__default.parseEntries($LS($ly), s#0, len#0, idx#0) } 
  JournalRanges.__default.parseEntries($LS($ly), s#0, len#0, idx#0)
     == JournalRanges.__default.parseEntries($ly, s#0, len#0, idx#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
  { JournalRanges.__default.parseEntries(AsFuelBottom($ly), s#0, len#0, idx#0) } 
  JournalRanges.__default.parseEntries($ly, s#0, len#0, idx#0)
     == JournalRanges.__default.parseEntries($LZ, s#0, len#0, idx#0));

// consequence axiom for JournalRanges.__default.parseEntries
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
    { JournalRanges.__default.parseEntries($ly, s#0, len#0, idx#0) } 
    JournalRanges.__default.parseEntries#canCall(s#0, len#0, idx#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= idx#0
           && idx#0 <= Seq#Length(s#0)
           && LitInt(0) <= len#0)
       ==> $Is(JournalRanges.__default.parseEntries($ly, s#0, len#0, idx#0), 
        Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry()))));

function JournalRanges.__default.parseEntries#requires(LayerType, Seq Box, int, int) : bool;

// #requires axiom for JournalRanges.__default.parseEntries
axiom (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
  { JournalRanges.__default.parseEntries#requires($ly, s#0, len#0, idx#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalRanges.__default.parseEntries#requires($ly, s#0, len#0, idx#0)
       == (LitInt(0) <= idx#0 && idx#0 <= Seq#Length(s#0) && LitInt(0) <= len#0));

// definition axiom for JournalRanges.__default.parseEntries(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
    { JournalRanges.__default.parseEntries($LS($ly), s#0, len#0, idx#0) } 
    JournalRanges.__default.parseEntries#canCall(s#0, len#0, idx#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= idx#0
           && idx#0 <= Seq#Length(s#0)
           && LitInt(0) <= len#0)
       ==> (len#0 != LitInt(0)
           ==> 
          idx#0 + 4 <= Seq#Length(s#0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0))
             && (var keyLen#0 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                  Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0)); 
              (idx#0 + 4 + keyLen#0 + 4 <= Seq#Length(s#0)
                   ==> KeyType.__default.MaxLen#canCall())
                 && (idx#0 + 4 + keyLen#0 + 4 <= Seq#Length(s#0)
                     && keyLen#0 <= LitInt(KeyType.__default.MaxLen())
                   ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0 + 4), idx#0 + 4 + keyLen#0))
                     && (var valueLen#0 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0 + 4), idx#0 + 4 + keyLen#0)); 
                      (idx#0 + 4 + keyLen#0 + 4 + valueLen#0 <= Seq#Length(s#0)
                           ==> ValueType.__default.MaxLen#canCall())
                         && (idx#0 + 4 + keyLen#0 + 4 + valueLen#0 <= Seq#Length(s#0)
                             && valueLen#0 <= LitInt(ValueType.__default.MaxLen())
                           ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0 - 1, idx#0 + 4 + keyLen#0 + 4 + valueLen#0))))))
         && JournalRanges.__default.parseEntries($LS($ly), s#0, len#0, idx#0)
           == (if len#0 == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if idx#0 + 4 <= Seq#Length(s#0)
               then (var keyLen#0 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0)); 
                (if idx#0 + 4 + keyLen#0 + 4 <= Seq#Length(s#0)
                     && keyLen#0 <= LitInt(KeyType.__default.MaxLen())
                   then (var key#0 := Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0), idx#0 + 4); 
                    (var valueLen#0 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0 + 4), idx#0 + 4 + keyLen#0)); 
                      (if idx#0 + 4 + keyLen#0 + 4 + valueLen#0 <= Seq#Length(s#0)
                           && valueLen#0 <= LitInt(ValueType.__default.MaxLen())
                         then (var value#0 := Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0 + 4 + valueLen#0), idx#0 + 4 + keyLen#0 + 4); 
                          (var je#0 := #Journal.JournalEntry.JournalInsert(key#0, value#0); 
                            (var rest#0 := JournalRanges.__default.parseEntries($ly, s#0, len#0 - 1, idx#0 + 4 + keyLen#0 + 4 + valueLen#0); 
                              (if Options.Option.Some_q(rest#0)
                                 then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(je#0)), 
                                      $Unbox(Options.Option.value(rest#0)): Seq Box)))
                                 else #Options.Option.None()))))
                         else #Options.Option.None())))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// definition axiom for JournalRanges.__default.parseEntries for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
    {:weight 3} { JournalRanges.__default.parseEntries($LS($ly), s#0, LitInt(len#0), idx#0) } 
    JournalRanges.__default.parseEntries#canCall(s#0, LitInt(len#0), idx#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= idx#0
           && idx#0 <= Seq#Length(s#0)
           && LitInt(0) <= LitInt(len#0))
       ==> (LitInt(len#0) != LitInt(0)
           ==> 
          idx#0 + 4 <= Seq#Length(s#0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0))
             && (var keyLen#1 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                  Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0)); 
              (idx#0 + 4 + keyLen#1 + 4 <= Seq#Length(s#0)
                   ==> KeyType.__default.MaxLen#canCall())
                 && (idx#0 + 4 + keyLen#1 + 4 <= Seq#Length(s#0)
                     && keyLen#1 <= LitInt(KeyType.__default.MaxLen())
                   ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1 + 4), idx#0 + 4 + keyLen#1))
                     && (var valueLen#1 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1 + 4), idx#0 + 4 + keyLen#1)); 
                      (idx#0 + 4 + keyLen#1 + 4 + valueLen#1 <= Seq#Length(s#0)
                           ==> ValueType.__default.MaxLen#canCall())
                         && (idx#0 + 4 + keyLen#1 + 4 + valueLen#1 <= Seq#Length(s#0)
                             && valueLen#1 <= LitInt(ValueType.__default.MaxLen())
                           ==> JournalRanges.__default.parseEntries#canCall(s#0, LitInt(len#0 - 1), idx#0 + 4 + keyLen#1 + 4 + valueLen#1))))))
         && JournalRanges.__default.parseEntries($LS($ly), s#0, LitInt(len#0), idx#0)
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if idx#0 + 4 <= Seq#Length(s#0)
               then (var keyLen#1 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0)); 
                (if idx#0 + 4 + keyLen#1 + 4 <= Seq#Length(s#0)
                     && keyLen#1 <= LitInt(KeyType.__default.MaxLen())
                   then (var key#1 := Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1), idx#0 + 4); 
                    (var valueLen#1 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1 + 4), idx#0 + 4 + keyLen#1)); 
                      (if idx#0 + 4 + keyLen#1 + 4 + valueLen#1 <= Seq#Length(s#0)
                           && valueLen#1 <= LitInt(ValueType.__default.MaxLen())
                         then (var value#1 := Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1 + 4 + valueLen#1), idx#0 + 4 + keyLen#1 + 4); 
                          (var je#1 := #Journal.JournalEntry.JournalInsert(key#1, value#1); 
                            (var rest#1 := JournalRanges.__default.parseEntries($LS($ly), s#0, LitInt(len#0 - 1), idx#0 + 4 + keyLen#1 + 4 + valueLen#1); 
                              (if Options.Option.Some_q(rest#1)
                                 then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(je#1)), 
                                      $Unbox(Options.Option.value(rest#1)): Seq Box)))
                                 else #Options.Option.None()))))
                         else #Options.Option.None())))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// definition axiom for JournalRanges.__default.parseEntries for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
    {:weight 3} { JournalRanges.__default.parseEntries($LS($ly), Lit(s#0), LitInt(len#0), LitInt(idx#0)) } 
    JournalRanges.__default.parseEntries#canCall(Lit(s#0), LitInt(len#0), LitInt(idx#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(idx#0)
           && LitInt(idx#0) <= Seq#Length(Lit(s#0))
           && LitInt(0) <= LitInt(len#0))
       ==> (LitInt(len#0) != LitInt(0)
           ==> 
          LitInt(idx#0 + 4) <= Seq#Length(Lit(s#0))
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(idx#0 + 4)), LitInt(idx#0))))
             && (var keyLen#2 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                  Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(idx#0 + 4)), LitInt(idx#0)))); 
              (idx#0 + 4 + keyLen#2 + 4 <= Seq#Length(Lit(s#0))
                   ==> KeyType.__default.MaxLen#canCall())
                 && (idx#0 + 4 + keyLen#2 + 4 <= Seq#Length(Lit(s#0))
                     && keyLen#2 <= LitInt(KeyType.__default.MaxLen())
                   ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2 + 4), idx#0 + 4 + keyLen#2))
                     && (var valueLen#2 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2 + 4), idx#0 + 4 + keyLen#2)); 
                      (idx#0 + 4 + keyLen#2 + 4 + valueLen#2 <= Seq#Length(Lit(s#0))
                           ==> ValueType.__default.MaxLen#canCall())
                         && (idx#0 + 4 + keyLen#2 + 4 + valueLen#2 <= Seq#Length(Lit(s#0))
                             && valueLen#2 <= LitInt(ValueType.__default.MaxLen())
                           ==> JournalRanges.__default.parseEntries#canCall(Lit(s#0), LitInt(len#0 - 1), idx#0 + 4 + keyLen#2 + 4 + valueLen#2))))))
         && JournalRanges.__default.parseEntries($LS($ly), Lit(s#0), LitInt(len#0), LitInt(idx#0))
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if LitInt(idx#0 + 4) <= Seq#Length(Lit(s#0))
               then (var keyLen#2 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(idx#0 + 4)), LitInt(idx#0)))); 
                (if idx#0 + 4 + keyLen#2 + 4 <= Seq#Length(Lit(s#0))
                     && keyLen#2 <= LitInt(KeyType.__default.MaxLen())
                   then (var key#2 := Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2), LitInt(idx#0 + 4)); 
                    (var valueLen#2 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2 + 4), idx#0 + 4 + keyLen#2)); 
                      (if idx#0 + 4 + keyLen#2 + 4 + valueLen#2 <= Seq#Length(Lit(s#0))
                           && valueLen#2 <= LitInt(ValueType.__default.MaxLen())
                         then (var value#2 := Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2 + 4 + valueLen#2), 
                              idx#0 + 4 + keyLen#2 + 4); 
                          (var je#2 := #Journal.JournalEntry.JournalInsert(key#2, value#2); 
                            (var rest#2 := JournalRanges.__default.parseEntries($LS($ly), Lit(s#0), LitInt(len#0 - 1), idx#0 + 4 + keyLen#2 + 4 + valueLen#2); 
                              (if Options.Option.Some_q(rest#2)
                                 then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(je#2)), 
                                      $Unbox(Options.Option.value(rest#2)): Seq Box)))
                                 else #Options.Option.None()))))
                         else #Options.Option.None())))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// function declaration for JournalRanges._default.parseJournalRangeOfBytes
function JournalRanges.__default.parseJournalRangeOfBytes(s#0: Seq Box, len#0: int) : DatatypeType;

function JournalRanges.__default.parseJournalRangeOfBytes#canCall(s#0: Seq Box, len#0: int) : bool;

// consequence axiom for JournalRanges.__default.parseJournalRangeOfBytes
axiom true
   ==> (forall s#0: Seq Box, len#0: int :: 
    { JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0) } 
    JournalRanges.__default.parseJournalRangeOfBytes#canCall(s#0, len#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(s#0) >= LitInt(8)
           && LitInt(0) <= len#0)
       ==> $Is(JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0), 
        Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry()))));

function JournalRanges.__default.parseJournalRangeOfBytes#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.parseJournalRangeOfBytes
axiom (forall s#0: Seq Box, len#0: int :: 
  { JournalRanges.__default.parseJournalRangeOfBytes#requires(s#0, len#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalRanges.__default.parseJournalRangeOfBytes#requires(s#0, len#0)
       == (Seq#Length(s#0) >= LitInt(8) && LitInt(0) <= len#0));

// definition axiom for JournalRanges.__default.parseJournalRangeOfBytes(revealed)
axiom true
   ==> (forall s#0: Seq Box, len#0: int :: 
    { JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0) } 
    JournalRanges.__default.parseJournalRangeOfBytes#canCall(s#0, len#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(s#0) >= LitInt(8)
           && LitInt(0) <= len#0)
       ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8))
         && JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0)
           == JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)));

// definition axiom for JournalRanges.__default.parseJournalRangeOfBytes for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box, len#0: int :: 
    {:weight 3} { JournalRanges.__default.parseJournalRangeOfBytes(Lit(s#0), LitInt(len#0)) } 
    JournalRanges.__default.parseJournalRangeOfBytes#canCall(Lit(s#0), LitInt(len#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(Lit(s#0)) >= LitInt(8)
           && LitInt(0) <= LitInt(len#0))
       ==> JournalRanges.__default.parseEntries#canCall(Lit(s#0), LitInt(len#0), LitInt(8))
         && JournalRanges.__default.parseJournalRangeOfBytes(Lit(s#0), LitInt(len#0))
           == Lit(JournalRanges.__default.parseEntries($LS($LZ), Lit(s#0), LitInt(len#0), LitInt(8))));

// function declaration for JournalRanges._default.parseJournalRange
function JournalRanges.__default.parseJournalRange($ly: LayerType, jr#0: Seq Box) : DatatypeType;

function JournalRanges.__default.parseJournalRange#canCall(jr#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box :: 
  { JournalRanges.__default.parseJournalRange($LS($ly), jr#0) } 
  JournalRanges.__default.parseJournalRange($LS($ly), jr#0)
     == JournalRanges.__default.parseJournalRange($ly, jr#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box :: 
  { JournalRanges.__default.parseJournalRange(AsFuelBottom($ly), jr#0) } 
  JournalRanges.__default.parseJournalRange($ly, jr#0)
     == JournalRanges.__default.parseJournalRange($LZ, jr#0));

// consequence axiom for JournalRanges.__default.parseJournalRange
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box :: 
    { JournalRanges.__default.parseJournalRange($ly, jr#0) } 
    JournalRanges.__default.parseJournalRange#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(JournalRanges.__default.parseJournalRange($ly, jr#0), 
        Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry()))));

function JournalRanges.__default.parseJournalRange#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.parseJournalRange
axiom (forall $ly: LayerType, jr#0: Seq Box :: 
  { JournalRanges.__default.parseJournalRange#requires($ly, jr#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.parseJournalRange#requires($ly, jr#0) == true);

// definition axiom for JournalRanges.__default.parseJournalRange(revealed)
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box :: 
    { JournalRanges.__default.parseJournalRange($LS($ly), jr#0) } 
    JournalRanges.__default.parseJournalRange#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(jr#0) != LitInt(0)
           ==> 
          Seq#Length($Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box) >= LitInt(8)
           ==> JournalRanges.__default.parseHeader#canCall($Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box)
             && (var header#0 := JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, 
                  $Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box); 
              JournalRanges.Header.Header_q(header#0)
                 && (LitInt(0) <= JournalRanges.Header.nentries(header#0)
                   ==> JournalRanges.Header.Header_q(header#0)
                     && (LitInt(1) <= JournalRanges.Header.nblocks(header#0)
                       ==> JournalRanges.Header.Header_q(header#0)))
                 && (LitInt(0) <= JournalRanges.Header.nentries(header#0)
                     && 
                    LitInt(1) <= JournalRanges.Header.nblocks(header#0)
                     && JournalRanges.Header.nblocks(header#0) <= Seq#Length(jr#0)
                   ==> JournalRanges.Header.Header_q(header#0)
                     && Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), 
                      Seq#Take(jr#0, JournalRanges.Header.nblocks(header#0)))
                     && JournalRanges.Header.Header_q(header#0)
                     && JournalRanges.__default.parseJournalRangeOfBytes#canCall(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                        StartFuel_Sequences._default.concatSeq, 
                        Seq#Take(jr#0, JournalRanges.Header.nblocks(header#0))), 
                      JournalRanges.Header.nentries(header#0))
                     && (var p1#0 := JournalRanges.__default.parseJournalRangeOfBytes(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                            StartFuel_Sequences._default.concatSeq, 
                            Seq#Take(jr#0, JournalRanges.Header.nblocks(header#0))), 
                          JournalRanges.Header.nentries(header#0)); 
                      Options.Option.Some_q(p1#0)
                         ==> JournalRanges.Header.Header_q(header#0)
                           && JournalRanges.__default.parseJournalRange#canCall(Seq#Drop(jr#0, JournalRanges.Header.nblocks(header#0)))))))
         && JournalRanges.__default.parseJournalRange($LS($ly), jr#0)
           == (if Seq#Length(jr#0) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if Seq#Length($Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box) >= LitInt(8)
               then (var header#0 := JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, 
                    $Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box); 
                (if LitInt(0) <= JournalRanges.Header.nentries(header#0)
                     && 
                    LitInt(1) <= JournalRanges.Header.nblocks(header#0)
                     && JournalRanges.Header.nblocks(header#0) <= Seq#Length(jr#0)
                   then (var p1#0 := JournalRanges.__default.parseJournalRangeOfBytes(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                          StartFuel_Sequences._default.concatSeq, 
                          Seq#Take(jr#0, JournalRanges.Header.nblocks(header#0))), 
                        JournalRanges.Header.nentries(header#0)); 
                    (if Options.Option.Some_q(p1#0)
                       then (var p2#0 := JournalRanges.__default.parseJournalRange($ly, Seq#Drop(jr#0, JournalRanges.Header.nblocks(header#0))); 
                        (if Options.Option.Some_q(p2#0)
                           then #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(p1#0)): Seq Box, 
                                $Unbox(Options.Option.value(p2#0)): Seq Box)))
                           else #Options.Option.None()))
                       else #Options.Option.None()))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// definition axiom for JournalRanges.__default.parseJournalRange for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.parseJournalRange($LS($ly), Lit(jr#0)) } 
    JournalRanges.__default.parseJournalRange#canCall(Lit(jr#0))
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(jr#0)) != LitInt(0)
           ==> 
          Seq#Length($Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box) >= LitInt(8)
           ==> JournalRanges.__default.parseHeader#canCall($Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box)
             && (var header#1 := JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, 
                  $Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box); 
              JournalRanges.Header.Header_q(header#1)
                 && (LitInt(0) <= JournalRanges.Header.nentries(header#1)
                   ==> JournalRanges.Header.Header_q(header#1)
                     && (LitInt(1) <= JournalRanges.Header.nblocks(header#1)
                       ==> JournalRanges.Header.Header_q(header#1)))
                 && (LitInt(0) <= JournalRanges.Header.nentries(header#1)
                     && 
                    LitInt(1) <= JournalRanges.Header.nblocks(header#1)
                     && JournalRanges.Header.nblocks(header#1) <= Seq#Length(Lit(jr#0))
                   ==> JournalRanges.Header.Header_q(header#1)
                     && Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), 
                      Seq#Take(Lit(jr#0), JournalRanges.Header.nblocks(header#1)))
                     && JournalRanges.Header.Header_q(header#1)
                     && JournalRanges.__default.parseJournalRangeOfBytes#canCall(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                        StartFuel_Sequences._default.concatSeq, 
                        Seq#Take(Lit(jr#0), JournalRanges.Header.nblocks(header#1))), 
                      JournalRanges.Header.nentries(header#1))
                     && (var p1#1 := JournalRanges.__default.parseJournalRangeOfBytes(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                            StartFuel_Sequences._default.concatSeq, 
                            Seq#Take(Lit(jr#0), JournalRanges.Header.nblocks(header#1))), 
                          JournalRanges.Header.nentries(header#1)); 
                      Options.Option.Some_q(p1#1)
                         ==> JournalRanges.Header.Header_q(header#1)
                           && JournalRanges.__default.parseJournalRange#canCall(Seq#Drop(Lit(jr#0), JournalRanges.Header.nblocks(header#1)))))))
         && JournalRanges.__default.parseJournalRange($LS($ly), Lit(jr#0))
           == (if Seq#Length(Lit(jr#0)) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if Seq#Length($Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box) >= LitInt(8)
               then (var header#1 := JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, 
                    $Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box); 
                (if LitInt(0) <= JournalRanges.Header.nentries(header#1)
                     && 
                    LitInt(1) <= JournalRanges.Header.nblocks(header#1)
                     && JournalRanges.Header.nblocks(header#1) <= Seq#Length(Lit(jr#0))
                   then (var p1#1 := JournalRanges.__default.parseJournalRangeOfBytes(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                          StartFuel_Sequences._default.concatSeq, 
                          Seq#Take(Lit(jr#0), JournalRanges.Header.nblocks(header#1))), 
                        JournalRanges.Header.nentries(header#1)); 
                    (if Options.Option.Some_q(p1#1)
                       then (var p2#1 := JournalRanges.__default.parseJournalRange($LS($ly), Seq#Drop(Lit(jr#0), JournalRanges.Header.nblocks(header#1))); 
                        (if Options.Option.Some_q(p2#1)
                           then #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(p1#1)): Seq Box, 
                                $Unbox(Options.Option.value(p2#1)): Seq Box)))
                           else #Options.Option.None()))
                       else #Options.Option.None()))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// function declaration for JournalRanges._default.JournalRangeParses
function JournalRanges.__default.JournalRangeParses(jr#0: Seq Box, jes#0: Seq Box) : bool;

function JournalRanges.__default.JournalRangeParses#canCall(jr#0: Seq Box, jes#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeParses
axiom true
   ==> (forall jr#0: Seq Box, jes#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeParses(jr#0, jes#0) } 
    JournalRanges.__default.JournalRangeParses#canCall(jr#0, jes#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> true);

function JournalRanges.__default.JournalRangeParses#requires(Seq Box, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeParses
axiom (forall jr#0: Seq Box, jes#0: Seq Box :: 
  { JournalRanges.__default.JournalRangeParses#requires(jr#0, jes#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalRanges.__default.JournalRangeParses#requires(jr#0, jes#0) == true);

// definition axiom for JournalRanges.__default.JournalRangeParses(revealed)
axiom true
   ==> (forall jr#0: Seq Box, jes#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeParses(jr#0, jes#0) } 
    JournalRanges.__default.JournalRangeParses#canCall(jr#0, jes#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> $IsA#Options.Option(JournalRanges.__default.parseJournalRange($LS($LZ), jr#0))
         && JournalRanges.__default.parseJournalRange#canCall(jr#0)
         && JournalRanges.__default.JournalRangeParses(jr#0, jes#0)
           == Options.Option#Equal(JournalRanges.__default.parseJournalRange($LS($LZ), jr#0), 
            #Options.Option.Some($Box(jes#0))));

// definition axiom for JournalRanges.__default.JournalRangeParses for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, jes#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalRangeParses(Lit(jr#0), Lit(jes#0)) } 
    JournalRanges.__default.JournalRangeParses#canCall(Lit(jr#0), Lit(jes#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> $IsA#Options.Option(Lit(JournalRanges.__default.parseJournalRange($LS($LZ), Lit(jr#0))))
         && JournalRanges.__default.parseJournalRange#canCall(Lit(jr#0))
         && JournalRanges.__default.JournalRangeParses(Lit(jr#0), Lit(jes#0))
           == Options.Option#Equal(JournalRanges.__default.parseJournalRange($LS($LZ), Lit(jr#0)), 
            #Options.Option.Some($Box(Lit(jes#0)))));

// function declaration for JournalRanges._default.WeightJournalEntryUint64
function JournalRanges.__default.WeightJournalEntryUint64(s#0: DatatypeType) : int;

function JournalRanges.__default.WeightJournalEntryUint64#canCall(s#0: DatatypeType) : bool;

// consequence axiom for JournalRanges.__default.WeightJournalEntryUint64
axiom true
   ==> (forall s#0: DatatypeType :: 
    { JournalRanges.__default.WeightJournalEntryUint64(s#0) } 
    JournalRanges.__default.WeightJournalEntryUint64#canCall(s#0)
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> LitInt(0) <= JournalRanges.__default.WeightJournalEntryUint64(s#0)
         && JournalRanges.__default.WeightJournalEntryUint64(s#0) < 18446744073709551616);

function JournalRanges.__default.WeightJournalEntryUint64#requires(DatatypeType) : bool;

// #requires axiom for JournalRanges.__default.WeightJournalEntryUint64
axiom (forall s#0: DatatypeType :: 
  { JournalRanges.__default.WeightJournalEntryUint64#requires(s#0) } 
  $Is(s#0, Tclass.Journal.JournalEntry())
     ==> JournalRanges.__default.WeightJournalEntryUint64#requires(s#0) == true);

// definition axiom for JournalRanges.__default.WeightJournalEntryUint64(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    { JournalRanges.__default.WeightJournalEntryUint64(s#0) } 
    JournalRanges.__default.WeightJournalEntryUint64#canCall(s#0)
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> Journal.JournalEntry.JournalInsert_q(s#0)
         && Journal.JournalEntry.JournalInsert_q(s#0)
         && JournalRanges.__default.WeightJournalEntryUint64(s#0)
           == 8
             + Seq#Length(Journal.JournalEntry.key(s#0))
             + Seq#Length(Journal.JournalEntry.value(s#0)));

// definition axiom for JournalRanges.__default.WeightJournalEntryUint64 for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    {:weight 3} { JournalRanges.__default.WeightJournalEntryUint64(Lit(s#0)) } 
    JournalRanges.__default.WeightJournalEntryUint64#canCall(Lit(s#0))
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> Journal.JournalEntry.JournalInsert_q(Lit(s#0))
         && Journal.JournalEntry.JournalInsert_q(Lit(s#0))
         && JournalRanges.__default.WeightJournalEntryUint64(Lit(s#0))
           == 8
             + Seq#Length(Lit(Journal.JournalEntry.key(Lit(s#0))))
             + Seq#Length(Lit(Journal.JournalEntry.value(Lit(s#0)))));

// function declaration for JournalRanges._default.WeightJournalEntry
function JournalRanges.__default.WeightJournalEntry(s#0: DatatypeType) : int;

function JournalRanges.__default.WeightJournalEntry#canCall(s#0: DatatypeType) : bool;

// consequence axiom for JournalRanges.__default.WeightJournalEntry
axiom true
   ==> (forall s#0: DatatypeType :: 
    { JournalRanges.__default.WeightJournalEntry(s#0) } 
    JournalRanges.__default.WeightJournalEntry#canCall(s#0)
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> true);

function JournalRanges.__default.WeightJournalEntry#requires(DatatypeType) : bool;

// #requires axiom for JournalRanges.__default.WeightJournalEntry
axiom (forall s#0: DatatypeType :: 
  { JournalRanges.__default.WeightJournalEntry#requires(s#0) } 
  $Is(s#0, Tclass.Journal.JournalEntry())
     ==> JournalRanges.__default.WeightJournalEntry#requires(s#0) == true);

// definition axiom for JournalRanges.__default.WeightJournalEntry(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    { JournalRanges.__default.WeightJournalEntry(s#0) } 
    JournalRanges.__default.WeightJournalEntry#canCall(s#0)
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> Journal.JournalEntry.JournalInsert_q(s#0)
         && Journal.JournalEntry.JournalInsert_q(s#0)
         && JournalRanges.__default.WeightJournalEntry(s#0)
           == 8
             + Seq#Length(Journal.JournalEntry.key(s#0))
             + Seq#Length(Journal.JournalEntry.value(s#0)));

// definition axiom for JournalRanges.__default.WeightJournalEntry for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    {:weight 3} { JournalRanges.__default.WeightJournalEntry(Lit(s#0)) } 
    JournalRanges.__default.WeightJournalEntry#canCall(Lit(s#0))
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> Journal.JournalEntry.JournalInsert_q(Lit(s#0))
         && Journal.JournalEntry.JournalInsert_q(Lit(s#0))
         && JournalRanges.__default.WeightJournalEntry(Lit(s#0))
           == 8
             + Seq#Length(Lit(Journal.JournalEntry.key(Lit(s#0))))
             + Seq#Length(Lit(Journal.JournalEntry.value(Lit(s#0)))));

// function declaration for JournalRanges._default.SumJournalEntries
function JournalRanges.__default.SumJournalEntries($ly: LayerType, s#0: Seq Box) : int;

function JournalRanges.__default.SumJournalEntries#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.SumJournalEntries($LS($ly), s#0) } 
  JournalRanges.__default.SumJournalEntries($LS($ly), s#0)
     == JournalRanges.__default.SumJournalEntries($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.SumJournalEntries(AsFuelBottom($ly), s#0) } 
  JournalRanges.__default.SumJournalEntries($ly, s#0)
     == JournalRanges.__default.SumJournalEntries($LZ, s#0));

// consequence axiom for JournalRanges.__default.SumJournalEntries
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.SumJournalEntries($ly, s#0) } 
    JournalRanges.__default.SumJournalEntries#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> JournalRanges.__default.SumJournalEntries($ly, s#0) >= LitInt(0));

function JournalRanges.__default.SumJournalEntries#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.SumJournalEntries
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.SumJournalEntries#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalRanges.__default.SumJournalEntries#requires($ly, s#0) == true);

// definition axiom for JournalRanges.__default.SumJournalEntries(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.SumJournalEntries($LS($ly), s#0) } 
    JournalRanges.__default.SumJournalEntries#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> (Seq#Length(s#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.Journal.JournalEntry(), s#0)
             && JournalRanges.__default.SumJournalEntries#canCall(Sequences.__default.DropLast(Tclass.Journal.JournalEntry(), s#0))
             && 
            Sequences.__default.Last#canCall(Tclass.Journal.JournalEntry(), s#0)
             && JournalRanges.__default.WeightJournalEntry#canCall($Unbox(Sequences.__default.Last(Tclass.Journal.JournalEntry(), s#0)): DatatypeType))
         && JournalRanges.__default.SumJournalEntries($LS($ly), s#0)
           == (if Seq#Length(s#0) == LitInt(0)
             then 0
             else JournalRanges.__default.SumJournalEntries($ly, Sequences.__default.DropLast(Tclass.Journal.JournalEntry(), s#0))
               + JournalRanges.__default.WeightJournalEntry($Unbox(Sequences.__default.Last(Tclass.Journal.JournalEntry(), s#0)): DatatypeType)));

// definition axiom for JournalRanges.__default.SumJournalEntries for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.SumJournalEntries($LS($ly), Lit(s#0)) } 
    JournalRanges.__default.SumJournalEntries#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> (Seq#Length(Lit(s#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.Journal.JournalEntry(), Lit(s#0))
             && JournalRanges.__default.SumJournalEntries#canCall(Lit(Sequences.__default.DropLast(Tclass.Journal.JournalEntry(), Lit(s#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.Journal.JournalEntry(), Lit(s#0))
             && JournalRanges.__default.WeightJournalEntry#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.Journal.JournalEntry(), Lit(s#0))): DatatypeType)))
         && JournalRanges.__default.SumJournalEntries($LS($ly), Lit(s#0))
           == (if Seq#Length(Lit(s#0)) == LitInt(0)
             then 0
             else JournalRanges.__default.SumJournalEntries($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.Journal.JournalEntry(), Lit(s#0))))
               + JournalRanges.__default.WeightJournalEntry(Lit($Unbox(Sequences.__default.Last(Tclass.Journal.JournalEntry(), Lit(s#0))): DatatypeType))));

// function declaration for JournalRanges._default.WeightJournalEntries
function JournalRanges.__default.WeightJournalEntries($ly: LayerType, s#0: Seq Box) : int;

function JournalRanges.__default.WeightJournalEntries#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.WeightJournalEntries($LS($ly), s#0) } 
  JournalRanges.__default.WeightJournalEntries($LS($ly), s#0)
     == JournalRanges.__default.WeightJournalEntries($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.WeightJournalEntries(AsFuelBottom($ly), s#0) } 
  JournalRanges.__default.WeightJournalEntries($ly, s#0)
     == JournalRanges.__default.WeightJournalEntries($LZ, s#0));

// consequence axiom for JournalRanges.__default.WeightJournalEntries
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.WeightJournalEntries($ly, s#0) } 
    JournalRanges.__default.WeightJournalEntries#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> JournalRanges.__default.WeightJournalEntries($ly, s#0) >= LitInt(0));

function JournalRanges.__default.WeightJournalEntries#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.WeightJournalEntries
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.WeightJournalEntries#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalRanges.__default.WeightJournalEntries#requires($ly, s#0) == true);

// definition axiom for JournalRanges.__default.WeightJournalEntries(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.WeightJournalEntries($LS($ly), s#0) } 
    JournalRanges.__default.WeightJournalEntries#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> (Seq#Length(s#0) != LitInt(0)
           ==> JournalRanges.__default.SumJournalEntries#canCall(s#0))
         && JournalRanges.__default.WeightJournalEntries($LS($ly), s#0)
           == (if Seq#Length(s#0) == LitInt(0)
             then 0
             else JournalRanges.__default.SumJournalEntries($LS($LZ), s#0) + 8));

// definition axiom for JournalRanges.__default.WeightJournalEntries for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.WeightJournalEntries($LS($ly), Lit(s#0)) } 
    JournalRanges.__default.WeightJournalEntries#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> (Seq#Length(Lit(s#0)) != LitInt(0)
           ==> JournalRanges.__default.SumJournalEntries#canCall(Lit(s#0)))
         && JournalRanges.__default.WeightJournalEntries($LS($ly), Lit(s#0))
           == (if Seq#Length(Lit(s#0)) == LitInt(0)
             then 0
             else JournalRanges.__default.SumJournalEntries($LS($LZ), Lit(s#0)) + 8));

procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalRanges.__default.reveal__WeightJournalEntries();
  free requires 39 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalRanges._default.WeightJournalEntries0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalRanges.__default.reveal__WeightJournalEntries();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalRanges._default.WeightJournalEntries
     == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries0);
  free ensures StartFuelAssert_JournalRanges._default.WeightJournalEntries
     == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries0)
     == MoreFuel_JournalRanges._default.WeightJournalEntries0;



const unique class.Maps.__default: ClassName;

function Tclass.Maps.__default() : Ty;

// Tclass.Maps.__default Tag
axiom Tag(Tclass.Maps.__default()) == Tagclass.Maps.__default;

const unique Tagclass.Maps.__default: TyTag;

// Box/unbox axiom for Tclass.Maps.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Maps.__default()) } 
  $IsBox(bx, Tclass.Maps.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Maps.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Maps.__default()) } 
  $Is($o, Tclass.Maps.__default())
     <==> $o == null || dtype($o) == Tclass.Maps.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Maps.__default(), $h) } 
  $IsAlloc($o, Tclass.Maps.__default(), $h) <==> $o == null || read($h, $o, alloc));

// function declaration for Maps._default.IMapsTo
function Maps.__default.IMapsTo(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsTo
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> true);

function Maps.__default.IMapsTo#requires(Ty, Ty, IMap Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsTo
axiom (forall Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
       && $IsBox(k#0, Maps._default.IMapsTo$K)
       && $IsBox(v#0, Maps._default.IMapsTo$V)
     ==> Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.IMapsTo(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.IMapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsTo
function Maps.__default.MapsTo(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsTo
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> true);

function Maps.__default.MapsTo#requires(Ty, Ty, Map Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.MapsTo
axiom (forall Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
       && $IsBox(k#0, Maps._default.MapsTo$K)
       && $IsBox(v#0, Maps._default.MapsTo$V)
     ==> Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.MapsTo(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsAgreeOnKey
function Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsAgreeOnKey
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> true);

function Maps.__default.MapsAgreeOnKey#requires(Ty, Ty, Map Box Box, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapsAgreeOnKey
axiom (forall Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K)
     ==> Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.MapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(m#0)[k#0] == Map#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[k#0] == Map#Elements(Lit(m'#0))[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[Lit(k#0)] == Map#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IMapsAgreeOnKey
function Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsAgreeOnKey
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> true);

function Maps.__default.IMapsAgreeOnKey#requires(Ty, Ty, IMap Box Box, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsAgreeOnKey
axiom (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K)
     ==> Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(m#0)[k#0] == IMap#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.IMapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
        Maps._default.IMapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(Lit(m#0))[Lit(k#0)] == IMap#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IsSubIMap
function Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

function Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubIMap
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> true);

function Maps.__default.IsSubIMap#requires(Ty, Ty, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IsSubIMap
axiom (forall Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box :: 
  { Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
  $Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
       && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
     ==> Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubIMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
           ==> (forall key#0: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0) } 
              { IMap#Domain(sub#0)[key#0] } 
            $IsBox(key#0, Maps._default.IsSubIMap$K)
               ==> 
              IMap#Domain(sub#0)[key#0]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
           == (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
             && (forall key#0: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0) } 
                { IMap#Domain(sub#0)[key#0] } 
              $IsBox(key#0, Maps._default.IsSubIMap$K)
                 ==> 
                IMap#Domain(sub#0)[key#0]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0))));

// definition axiom for Maps.__default.IsSubIMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
           ==> (forall key#1: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#1) } 
              { IMap#Domain(sub#0)[key#1] } 
            $IsBox(key#1, Maps._default.IsSubIMap$K)
               ==> 
              Lit(IMap#Domain(Lit(sub#0)))[key#1]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, 
                Maps._default.IsSubIMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#1)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
           == (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
             && (forall key#1: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#1) } 
                { IMap#Domain(sub#0)[key#1] } 
              $IsBox(key#1, Maps._default.IsSubIMap$K)
                 ==> 
                Lit(IMap#Domain(Lit(sub#0)))[key#1]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, 
                  Maps._default.IsSubIMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#1))));

// function declaration for Maps._default.IsSubMap
function Maps.__default.IsSubMap(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

function Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubMap
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> true);

function Maps.__default.IsSubMap#requires(Ty, Ty, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.IsSubMap
axiom (forall Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box :: 
  { Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
  $Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
       && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
     ==> Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
           ==> (forall key#0: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0) } 
              { Map#Domain(sub#0)[key#0] } 
            $IsBox(key#0, Maps._default.IsSubMap$K)
               ==> 
              Map#Domain(sub#0)[key#0]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
           == (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
             && (forall key#0: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0) } 
                { Map#Domain(sub#0)[key#0] } 
              $IsBox(key#0, Maps._default.IsSubMap$K)
                 ==> 
                Map#Domain(sub#0)[key#0]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0))));

// definition axiom for Maps.__default.IsSubMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    {:weight 3} { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
           ==> (forall key#1: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#1) } 
              { Map#Domain(sub#0)[key#1] } 
            $IsBox(key#1, Maps._default.IsSubMap$K)
               ==> 
              Lit(Map#Domain(Lit(sub#0)))[key#1]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, 
                Maps._default.IsSubMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#1)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
           == (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
             && (forall key#1: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#1) } 
                { Map#Domain(sub#0)[key#1] } 
              $IsBox(key#1, Maps._default.IsSubMap$K)
                 ==> 
                Lit(Map#Domain(Lit(sub#0)))[key#1]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, 
                  Maps._default.IsSubMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#1))));

// function declaration for Maps._default.MapRemove
function Maps.__default.MapRemove(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
      Maps._default.MapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemove
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> (forall k#0: Box :: 
          { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#0] } 
            { ks#0[k#0] } 
            { Map#Domain(m#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(m#0)[k#0] && !ks#0[k#0]
             ==> Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#0])
         && (forall k#1: Box :: 
          { ks#0[k#1] } 
            { Map#Domain(m#0)[k#1] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapRemove$K)
             ==> (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1]
                 ==> Map#Domain(m#0)[k#1])
               && (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1]
                 ==> !ks#0[k#1]))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)));

function Maps.__default.MapRemove#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemove
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
       && $Is(ks#0, TSet(Maps._default.MapRemove$K))
     ==> Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRemove(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
         == (var m'#0 := Map#Glue((lambda $w#1: Box :: 
                $IsBox($w#1, Maps._default.MapRemove$K) && Map#Domain(m#0)[$w#1] && !ks#0[$w#1]), 
              (lambda $w#1: Box :: Map#Elements(m#0)[$w#1]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#0));

// definition axiom for Maps.__default.MapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
        Maps._default.MapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, 
          Maps._default.MapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == (var m'#1 := Map#Glue((lambda $w#3: Box :: 
                $IsBox($w#3, Maps._default.MapRemove$K)
                   && 
                  Map#Domain(m#0)[$w#3]
                   && !Lit(ks#0)[$w#3]), 
              (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#1));

// function declaration for Maps._default.MapRemoveStrong
function Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemoveStrong
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)), 
          Set#Difference(Map#Domain(m#0), ks#0))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemoveStrong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V)));

function Maps.__default.MapRemoveStrong#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemoveStrong
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
       && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K))
     ==> Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
       == true);

const MoreFuel_Maps._default.MapRemove0: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        m#0, 
        ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove0)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove0))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove0)
           == MoreFuel_Maps._default.MapRemove0
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            m#0, 
            ks#0)
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            m#0, 
            ks#0));

const MoreFuel_Maps._default.MapRemove1: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove1)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove1))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove1)
           == MoreFuel_Maps._default.MapRemove1
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(ks#0))
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            Lit(m#0), 
            Lit(ks#0)));

// function declaration for Maps._default.MapRemove1
function Maps.__default.MapRemove1(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
      Maps._default.MapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.MapRemove1
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> (forall j#0: Box :: 
          { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#0] } 
            { Map#Domain(m#0)[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(m#0)[j#0] && j#0 != k#0
             ==> Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#0])
         && (forall j#1: Box :: 
          { Map#Domain(m#0)[j#1] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1] } 
          $IsBox(j#1, Maps._default.MapRemove1$K)
             ==> (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1]
                 ==> Map#Domain(m#0)[j#1])
               && (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1]
                 ==> j#1 != k#0))
         && (forall j#2: Box :: 
          { Map#Elements(m#0)[j#2] } 
            { Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2] } 
          $IsBox(j#2, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2]
             ==> Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2]
               == Map#Elements(m#0)[j#2])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)))
           <= Set#Card(Map#Domain(m#0))
         && (Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0) - 1)
         && (!Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0))
         && $Is(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0), 
          TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)));

function Maps.__default.MapRemove1#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
       && $IsBox(k#0, Maps._default.MapRemove1$K)
     ==> Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.MapRemove1(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
         == (var m'#0 := Map#Glue((lambda $w#1: Box :: 
                $IsBox($w#1, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#1] && $w#1 != k#0), 
              (lambda $w#1: Box :: Map#Elements(m#0)[$w#1]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#0));

// definition axiom for Maps.__default.MapRemove1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0)
         == (var m'#1 := Map#Glue((lambda $w#3: Box :: 
                $IsBox($w#3, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#3] && $w#3 != k#0), 
              (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#1));

// definition axiom for Maps.__default.MapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
        Maps._default.MapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
          Maps._default.MapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == (var m'#2 := Map#Glue((lambda $w#5: Box :: 
                $IsBox($w#5, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#5] && $w#5 != k#0), 
              (lambda $w#5: Box :: Map#Elements(Lit(m#0))[$w#5]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#2));

// function declaration for Maps._default.MapRemove1Strong
function Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LZ, 
      m#0, 
      k#0));

// consequence axiom for Maps.__default.MapRemove1Strong
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0)), 
          Set#Difference(Map#Domain(m#0), Set#UnionOne(Set#Empty(): Set Box, k#0)))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove1Strong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                  Maps._default.MapRemove1Strong$V, 
                  $ly, 
                  m#0, 
                  k#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $ly, 
            m#0, 
            k#0), 
          TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V)));

function Maps.__default.MapRemove1Strong#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1Strong
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
       && $IsBox(k#0, Maps._default.MapRemove1Strong$K)
     ==> Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0)
       == true);

const MoreFuel_Maps._default.MapRemove10: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove10)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove10))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove10)
           == MoreFuel_Maps._default.MapRemove10
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            m#0, 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            m#0, 
            k#0));

const MoreFuel_Maps._default.MapRemove11: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove11)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove11))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove11)
           == MoreFuel_Maps._default.MapRemove11
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            k#0));

const MoreFuel_Maps._default.MapRemove12: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove12)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove12))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove12)
           == MoreFuel_Maps._default.MapRemove12
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(k#0))
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            Lit(k#0)));

// function declaration for Maps._default.IMapRemove
function Maps.__default.IMapRemove(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
      Maps._default.IMapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.IMapRemove
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)), 
          ISet#Difference(IMap#Domain(m#0), ks#0))
         && (forall j#0: Box :: 
          { IMap#Elements(m#0)[j#0] } 
            { IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0] } 
            { IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.IMapRemove$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0]
             ==> IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0]
               == IMap#Elements(m#0)[j#0])
         && $Is(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

function Maps.__default.IMapRemove#requires(Ty, Ty, LayerType, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRemove
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
       && $Is(ks#0, TISet(Maps._default.IMapRemove$K))
     ==> Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRemove(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#0]
               && !ks#0[$w#0]), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// definition axiom for Maps.__default.IMapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
        Maps._default.IMapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
          Maps._default.IMapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#1]
               && !Lit(ks#0)[$w#1]), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// function declaration for Maps._default.IMapRemove1
function Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box)
   : IMap Box Box;

function Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
      Maps._default.IMapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.IMapRemove1
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)), 
          ISet#Difference(IMap#Domain(m#0), ISet#UnionOne(ISet#Empty(): ISet Box, k#0)))
         && (forall j#0: Box :: 
          { IMap#Elements(m#0)[j#0] } 
            { IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0] } 
            { IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0] } 
          $IsBox(j#0, Maps._default.IMapRemove1$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0]
             ==> IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0]
               == IMap#Elements(m#0)[j#0])
         && $Is(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

function Maps.__default.IMapRemove1#requires(Ty, Ty, LayerType, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapRemove1
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
       && $IsBox(k#0, Maps._default.IMapRemove1$K)
     ==> Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapRemove1(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#0]
               && $w#0 != k#0), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// definition axiom for Maps.__default.IMapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
        Maps._default.IMapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
          Maps._default.IMapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#1]
               && $w#1 != k#0), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// function declaration for Maps._default.MapRestrict
function Maps.__default.MapRestrict(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// consequence axiom for Maps.__default.MapRestrict
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> $Is(Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

function Maps.__default.MapRestrict#requires(Ty, Ty, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRestrict
axiom (forall Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
       && $Is(ks#0, TSet(Maps._default.MapRestrict$K))
     ==> Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapRestrict$K) && ks#0[$w#0] && Map#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// definition axiom for Maps.__default.MapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapRestrict$K)
               && 
              Lit(ks#0)[$w#1]
               && Map#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// function declaration for Maps._default.MapIRestrict
function Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : Map Box Box;

function Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.MapIRestrict
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> $Is(Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

function Maps.__default.MapIRestrict#requires(Ty, Ty, Map Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.MapIRestrict
axiom (forall Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
       && $Is(ks#0, TISet(Maps._default.MapIRestrict$K))
     ==> Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapIRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#0]
               && ks#0[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#1]
               && ks#0[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#2]
               && Lit(ks#0)[$w#2]), 
          (lambda $w#2: Box :: Map#Elements(Lit(m#0))[$w#2]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// function declaration for Maps._default.IMapRestrict
function Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.IMapRestrict
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> $Is(Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0), 
        TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

function Maps.__default.IMapRestrict#requires(Ty, Ty, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRestrict
axiom (forall Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
       && $Is(ks#0, TISet(Maps._default.IMapRestrict$K))
     ==> Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRestrict(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRestrict$K)
               && 
              ks#0[$w#0]
               && IMap#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// definition axiom for Maps.__default.IMapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRestrict$K)
               && 
              Lit(ks#0)[$w#1]
               && IMap#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// function declaration for Maps._default.MapDisjointUnion
function Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapDisjointUnion
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
              Maps._default.MapDisjointUnion$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
            { Map#Domain(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1])
         && $Is(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
            Maps._default.MapDisjointUnion$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

function Maps.__default.MapDisjointUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
     ==> Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)));

// definition axiom for Maps.__default.MapDisjointUnion(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapDisjointUnion$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else Map#Elements(mapb#0)[$w#0])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// definition axiom for Maps.__default.MapDisjointUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapDisjointUnion$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else Map#Elements(Lit(mapb#0))[$w#1])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// function declaration for Maps._default.MapUnionPreferA
function Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferA
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
              Maps._default.MapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(mapa#0)[k#0] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == Map#Elements(mapa#0)[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(mapb#0)[k#1] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapb#0)[k#1] && !Map#Domain(mapa#0)[k#1]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == Map#Elements(mapb#0)[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Domain(mapb#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && !Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == Map#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
            Maps._default.MapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

function Maps.__default.MapUnionPreferA#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferA
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
     ==> Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapUnionPreferA$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else Map#Elements(mapb#0)[$w#0])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// definition axiom for Maps.__default.MapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapUnionPreferA$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else Map#Elements(Lit(mapb#0))[$w#1])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// function declaration for Maps._default.MapUnionPreferB
function Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferB
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
              Maps._default.MapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(mapb#0)[k#0] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Domain(mapb#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapb#0)[k#0]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == Map#Elements(mapb#0)[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(mapa#0)[k#1] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#1] && !Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == Map#Elements(mapa#0)[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Domain(mapb#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && !Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == Map#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
            Maps._default.MapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

function Maps.__default.MapUnionPreferB#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferB
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
     ==> Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapUnionPreferB$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapb#0)[$w#0]
               then Map#Elements(mapb#0)[$w#0]
               else Map#Elements(mapa#0)[$w#0])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// definition axiom for Maps.__default.MapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapUnionPreferB$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapb#0)[$w#1]
               then Map#Elements(Lit(mapb#0))[$w#1]
               else Map#Elements(Lit(mapa#0))[$w#1])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// function declaration for Maps._default.MapUnion
function Maps.__default.MapUnion(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
      Maps._default.MapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.MapUnion
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#0] && !Map#Domain(mapb#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#1] && !Map#Domain(mapa#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2] } 
            { Map#Elements(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(mapb#0)[k#2]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2]
               || Map#Elements(mapa#0)[k#2]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2])
         && $Is(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0), 
          TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)));

function Maps.__default.MapUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnion
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
     ==> Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnion(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.MapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
        Maps._default.MapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.IMapUnionPreferA
function Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferA
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
              Maps._default.IMapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(mapa#0)[k#0] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { IMap#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapa#0)[k#0]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == IMap#Elements(mapa#0)[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(mapb#0)[k#1] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#1] && !IMap#Domain(mapa#0)[k#1]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == IMap#Elements(mapb#0)[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapb#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { IMap#Domain(mapa#0)[k#2] } 
            { IMap#Domain(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#2] && !IMap#Domain(mapa#0)[k#2]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == IMap#Elements(mapb#0)[k#2])
         && $Is(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
            Maps._default.IMapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

function Maps.__default.IMapUnionPreferA#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferA
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
     ==> Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapUnionPreferA$U)
               && (IMap#Domain(mapa#0)[$w#0] || IMap#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if IMap#Domain(mapa#0)[$w#0]
               then IMap#Elements(mapa#0)[$w#0]
               else IMap#Elements(mapb#0)[$w#0])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// definition axiom for Maps.__default.IMapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapUnionPreferA$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#1] || Lit(IMap#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if IMap#Domain(mapa#0)[$w#1]
               then IMap#Elements(Lit(mapa#0))[$w#1]
               else IMap#Elements(Lit(mapb#0))[$w#1])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// function declaration for Maps._default.IMapUnionPreferB
function Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferB
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
              Maps._default.IMapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(mapb#0)[k#0] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { IMap#Domain(mapb#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapb#0)[k#0]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == IMap#Elements(mapb#0)[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(mapa#0)[k#1] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#1] && !IMap#Domain(mapb#0)[k#1]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == IMap#Elements(mapa#0)[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapa#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { IMap#Domain(mapb#0)[k#2] } 
            { IMap#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#2] && !IMap#Domain(mapb#0)[k#2]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == IMap#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
            Maps._default.IMapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

function Maps.__default.IMapUnionPreferB#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferB
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
     ==> Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapUnionPreferB$U)
               && (IMap#Domain(mapa#0)[$w#0] || IMap#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if IMap#Domain(mapb#0)[$w#0]
               then IMap#Elements(mapb#0)[$w#0]
               else IMap#Elements(mapa#0)[$w#0])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// definition axiom for Maps.__default.IMapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapUnionPreferB$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#1] || Lit(IMap#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if IMap#Domain(mapb#0)[$w#1]
               then IMap#Elements(Lit(mapb#0))[$w#1]
               else IMap#Elements(Lit(mapa#0))[$w#1])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// function declaration for Maps._default.IMapUnion
function Maps.__default.IMapUnion(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
      Maps._default.IMapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.IMapUnion
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#0] } 
            { IMap#Elements(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#0] && !IMap#Domain(mapb#0)[k#0]
             ==> IMap#Elements(mapa#0)[k#0]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#1] } 
            { IMap#Elements(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapb#0)[k#1] && !IMap#Domain(mapa#0)[k#1]
             ==> IMap#Elements(mapb#0)[k#1]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapa#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2] } 
            { IMap#Elements(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#2] && IMap#Domain(mapb#0)[k#2]
             ==> IMap#Elements(mapb#0)[k#2]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2]
               || IMap#Elements(mapa#0)[k#2]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2])
         && $Is(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0), 
          TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)));

function Maps.__default.IMapUnion#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnion
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
       && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
     ==> Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnion(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.IMapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
        Maps._default.IMapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.MapDisjointUnion3
function Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LZ, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// consequence axiom for Maps.__default.MapDisjointUnion3
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              $ly, 
              mapa#0, 
              mapb#0, 
              mapc#0)), 
          Set#Union(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
         && (!Set#Equal(Map#Domain(mapa#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapb#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapc#0), Set#Empty(): Set Box)
           ==> !Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0)), 
            Set#Empty(): Set Box))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
            { Map#Domain(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#2] } 
            { Map#Elements(mapc#0)[k#2] } 
            { Map#Domain(mapc#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapc#0)[k#2]
             ==> Map#Elements(mapc#0)[k#2]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#2])
         && 
        Map#Equal(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)))
         && Map#Equal(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapa#0, 
              mapb#0), 
            mapc#0))
         && $Is(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

function Maps.__default.MapDisjointUnion3#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion3
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  $Is(mapa#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapb#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapc#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
     ==> Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0)
       == (
        Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0))));

// definition axiom for Maps.__default.MapDisjointUnion3(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0, 
          mapc#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapDisjointUnion3$U)
               && (
                Map#Domain(mapa#0)[$w#0]
                 || Map#Domain(mapb#0)[$w#0]
                 || Map#Domain(mapc#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else (if Map#Domain(mapb#0)[$w#0]
                 then Map#Elements(mapb#0)[$w#0]
                 else Map#Elements(mapc#0)[$w#0]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// definition axiom for Maps.__default.MapDisjointUnion3 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0), 
        Lit(mapc#0)) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Set#Union(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))), 
            Map#Domain(Lit(mapc#0))))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapDisjointUnion3$U)
               && (
                Lit(Map#Domain(Lit(mapa#0)))[$w#1]
                 || Lit(Map#Domain(Lit(mapb#0)))[$w#1]
                 || Lit(Map#Domain(Lit(mapc#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else (if Map#Domain(mapb#0)[$w#1]
                 then Map#Elements(Lit(mapb#0))[$w#1]
                 else Map#Elements(Lit(mapc#0))[$w#1]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// function declaration for Maps._default.MapToImap
function Maps.__default.MapToImap(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : IMap Box Box;

function Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.MapToImap
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> $Is(Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0), 
        TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

function Maps.__default.MapToImap#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapToImap
axiom (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
  { Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
  $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
     ==> Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
       == true);

// definition axiom for Maps.__default.MapToImap(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// definition axiom for Maps.__default.MapToImap for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0)) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// function declaration for Maps._default.MapLookupOption
function Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapLookupOption
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> $Is(Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.MapLookupOption$V)));

function Maps.__default.MapLookupOption#requires(Ty, Ty, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapLookupOption
axiom (forall Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box :: 
  { Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
       && $IsBox(key#0, Maps._default.MapLookupOption$K)
     ==> Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.MapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

// function declaration for Maps._default.ImapLookupOption
function Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.ImapLookupOption
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> $Is(Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.ImapLookupOption$V)));

function Maps.__default.ImapLookupOption#requires(Ty, Ty, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.ImapLookupOption
axiom (forall Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box :: 
  { Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
       && $IsBox(key#0, Maps._default.ImapLookupOption$K)
     ==> Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.ImapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.ImapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
        Maps._default.ImapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

const unique class.Crypto.__default: ClassName;

function Tclass.Crypto.__default() : Ty;

// Tclass.Crypto.__default Tag
axiom Tag(Tclass.Crypto.__default()) == Tagclass.Crypto.__default;

const unique Tagclass.Crypto.__default: TyTag;

// Box/unbox axiom for Tclass.Crypto.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Crypto.__default()) } 
  $IsBox(bx, Tclass.Crypto.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Crypto.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Crypto.__default()) } 
  $Is($o, Tclass.Crypto.__default())
     <==> $o == null || dtype($o) == Tclass.Crypto.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Crypto.__default(), $h) } 
  $IsAlloc($o, Tclass.Crypto.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Crypto._default.Sha256
function Crypto.__default.Sha256(t#0: Seq Box) : Seq Box;

function Crypto.__default.Sha256#canCall(t#0: Seq Box) : bool;

// consequence axiom for Crypto.__default.Sha256
axiom true
   ==> (forall t#0: Seq Box :: 
    { Crypto.__default.Sha256(t#0) } 
    Crypto.__default.Sha256#canCall(t#0)
         || $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Seq#Length(Crypto.__default.Sha256(t#0)) == LitInt(32)
         && $Is(Crypto.__default.Sha256(t#0), TSeq(Tclass.NativeTypes.byte())));

function Crypto.__default.Sha256#requires(Seq Box) : bool;

// #requires axiom for Crypto.__default.Sha256
axiom (forall t#0: Seq Box :: 
  { Crypto.__default.Sha256#requires(t#0) } 
  $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Crypto.__default.Sha256#requires(t#0) == true);

// function declaration for Crypto._default.Crc32C
function Crypto.__default.Crc32C(t#0: Seq Box) : Seq Box;

function Crypto.__default.Crc32C#canCall(t#0: Seq Box) : bool;

// consequence axiom for Crypto.__default.Crc32C
axiom true
   ==> (forall t#0: Seq Box :: 
    { Crypto.__default.Crc32C(t#0) } 
    Crypto.__default.Crc32C#canCall(t#0)
         || $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Seq#Length(Crypto.__default.Crc32C(t#0)) == LitInt(32)
         && $Is(Crypto.__default.Crc32C(t#0), TSeq(Tclass.NativeTypes.byte())));

function Crypto.__default.Crc32C#requires(Seq Box) : bool;

// #requires axiom for Crypto.__default.Crc32C
axiom (forall t#0: Seq Box :: 
  { Crypto.__default.Crc32C#requires(t#0) } 
  $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Crypto.__default.Crc32C#requires(t#0) == true);

// Constructor function declaration
function #AsyncDisk.ReqRead.ReqRead(int, int) : DatatypeType;

const unique ##AsyncDisk.ReqRead.ReqRead: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: int :: 
  { #AsyncDisk.ReqRead.ReqRead(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#AsyncDisk.ReqRead.ReqRead(a#0#0#0, a#0#1#0))
     == ##AsyncDisk.ReqRead.ReqRead);

function AsyncDisk.ReqRead.ReqRead_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqRead.ReqRead_q(d) } 
  AsyncDisk.ReqRead.ReqRead_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.ReqRead.ReqRead);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqRead.ReqRead_q(d) } 
  AsyncDisk.ReqRead.ReqRead_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: int :: 
      d == #AsyncDisk.ReqRead.ReqRead(a#1#0#0, a#1#1#0)));

function Tclass.AsyncDisk.ReqRead() : Ty;

// Tclass.AsyncDisk.ReqRead Tag
axiom Tag(Tclass.AsyncDisk.ReqRead()) == Tagclass.AsyncDisk.ReqRead;

const unique Tagclass.AsyncDisk.ReqRead: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.ReqRead
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.ReqRead()) } 
  $IsBox(bx, Tclass.AsyncDisk.ReqRead())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.ReqRead()));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: int :: 
  { $Is(#AsyncDisk.ReqRead.ReqRead(a#2#0#0, a#2#1#0), Tclass.AsyncDisk.ReqRead()) } 
  $Is(#AsyncDisk.ReqRead.ReqRead(a#2#0#0, a#2#1#0), Tclass.AsyncDisk.ReqRead())
     <==> $Is(a#2#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.ReqRead.ReqRead(a#3#0#0, a#3#1#0), Tclass.AsyncDisk.ReqRead(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.ReqRead.ReqRead(a#3#0#0, a#3#1#0), Tclass.AsyncDisk.ReqRead(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.ReqRead.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.ReqRead.ReqRead_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.ReqRead(), $h)
     ==> $IsAlloc(AsyncDisk.ReqRead.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.ReqRead.len(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.ReqRead.ReqRead_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.ReqRead(), $h)
     ==> $IsAlloc(AsyncDisk.ReqRead.len(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: int :: 
  { #AsyncDisk.ReqRead.ReqRead(LitInt(a#4#0#0), LitInt(a#4#1#0)) } 
  #AsyncDisk.ReqRead.ReqRead(LitInt(a#4#0#0), LitInt(a#4#1#0))
     == Lit(#AsyncDisk.ReqRead.ReqRead(a#4#0#0, a#4#1#0)));

function AsyncDisk.ReqRead.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: int :: 
  { #AsyncDisk.ReqRead.ReqRead(a#5#0#0, a#5#1#0) } 
  AsyncDisk.ReqRead.addr(#AsyncDisk.ReqRead.ReqRead(a#5#0#0, a#5#1#0)) == a#5#0#0);

function AsyncDisk.ReqRead.len(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: int :: 
  { #AsyncDisk.ReqRead.ReqRead(a#6#0#0, a#6#1#0) } 
  AsyncDisk.ReqRead.len(#AsyncDisk.ReqRead.ReqRead(a#6#0#0, a#6#1#0)) == a#6#1#0);

// Depth-one case-split function
function $IsA#AsyncDisk.ReqRead(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.ReqRead(d) } 
  $IsA#AsyncDisk.ReqRead(d) ==> AsyncDisk.ReqRead.ReqRead_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqRead.ReqRead_q(d), $Is(d, Tclass.AsyncDisk.ReqRead()) } 
  $Is(d, Tclass.AsyncDisk.ReqRead()) ==> AsyncDisk.ReqRead.ReqRead_q(d));

// Datatype extensional equality declaration
function AsyncDisk.ReqRead#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.ReqRead.ReqRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.ReqRead#Equal(a, b) } 
  true
     ==> (AsyncDisk.ReqRead#Equal(a, b)
       <==> AsyncDisk.ReqRead.addr(a) == AsyncDisk.ReqRead.addr(b)
         && AsyncDisk.ReqRead.len(a) == AsyncDisk.ReqRead.len(b)));

// Datatype extensionality axiom: AsyncDisk.ReqRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.ReqRead#Equal(a, b) } 
  AsyncDisk.ReqRead#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.ReqRead: ClassName;

// Constructor function declaration
function #AsyncDisk.ReqWrite.ReqWrite(int, Seq Box) : DatatypeType;

const unique ##AsyncDisk.ReqWrite.ReqWrite: DtCtorId;

// Constructor identifier
axiom (forall a#7#0#0: int, a#7#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(a#7#0#0, a#7#1#0) } 
  DatatypeCtorId(#AsyncDisk.ReqWrite.ReqWrite(a#7#0#0, a#7#1#0))
     == ##AsyncDisk.ReqWrite.ReqWrite);

function AsyncDisk.ReqWrite.ReqWrite_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqWrite.ReqWrite_q(d) } 
  AsyncDisk.ReqWrite.ReqWrite_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.ReqWrite.ReqWrite);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqWrite.ReqWrite_q(d) } 
  AsyncDisk.ReqWrite.ReqWrite_q(d)
     ==> (exists a#8#0#0: int, a#8#1#0: Seq Box :: 
      d == #AsyncDisk.ReqWrite.ReqWrite(a#8#0#0, a#8#1#0)));

function Tclass.AsyncDisk.ReqWrite() : Ty;

// Tclass.AsyncDisk.ReqWrite Tag
axiom Tag(Tclass.AsyncDisk.ReqWrite()) == Tagclass.AsyncDisk.ReqWrite;

const unique Tagclass.AsyncDisk.ReqWrite: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.ReqWrite
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.ReqWrite()) } 
  $IsBox(bx, Tclass.AsyncDisk.ReqWrite())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.ReqWrite()));

// Constructor $Is
axiom (forall a#9#0#0: int, a#9#1#0: Seq Box :: 
  { $Is(#AsyncDisk.ReqWrite.ReqWrite(a#9#0#0, a#9#1#0), Tclass.AsyncDisk.ReqWrite()) } 
  $Is(#AsyncDisk.ReqWrite.ReqWrite(a#9#0#0, a#9#1#0), Tclass.AsyncDisk.ReqWrite())
     <==> $Is(a#9#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#9#1#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#10#0#0: int, a#10#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.ReqWrite.ReqWrite(a#10#0#0, a#10#1#0), 
      Tclass.AsyncDisk.ReqWrite(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.ReqWrite.ReqWrite(a#10#0#0, a#10#1#0), 
        Tclass.AsyncDisk.ReqWrite(), 
        $h)
       <==> $IsAlloc(a#10#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#10#1#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.ReqWrite.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.ReqWrite.ReqWrite_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.ReqWrite(), $h)
     ==> $IsAlloc(AsyncDisk.ReqWrite.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.ReqWrite.bytes(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.ReqWrite.ReqWrite_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.ReqWrite(), $h)
     ==> $IsAlloc(AsyncDisk.ReqWrite.bytes(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#11#0#0: int, a#11#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(LitInt(a#11#0#0), Lit(a#11#1#0)) } 
  #AsyncDisk.ReqWrite.ReqWrite(LitInt(a#11#0#0), Lit(a#11#1#0))
     == Lit(#AsyncDisk.ReqWrite.ReqWrite(a#11#0#0, a#11#1#0)));

function AsyncDisk.ReqWrite.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#12#0#0: int, a#12#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(a#12#0#0, a#12#1#0) } 
  AsyncDisk.ReqWrite.addr(#AsyncDisk.ReqWrite.ReqWrite(a#12#0#0, a#12#1#0))
     == a#12#0#0);

function AsyncDisk.ReqWrite.bytes(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#13#0#0: int, a#13#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(a#13#0#0, a#13#1#0) } 
  AsyncDisk.ReqWrite.bytes(#AsyncDisk.ReqWrite.ReqWrite(a#13#0#0, a#13#1#0))
     == a#13#1#0);

// Inductive seq element rank
axiom (forall a#14#0#0: int, a#14#1#0: Seq Box, i: int :: 
  { Seq#Index(a#14#1#0, i), #AsyncDisk.ReqWrite.ReqWrite(a#14#0#0, a#14#1#0) } 
  0 <= i && i < Seq#Length(a#14#1#0)
     ==> DtRank($Unbox(Seq#Index(a#14#1#0, i)): DatatypeType)
       < DtRank(#AsyncDisk.ReqWrite.ReqWrite(a#14#0#0, a#14#1#0)));

// Inductive seq rank
axiom (forall a#15#0#0: int, a#15#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(a#15#0#0, a#15#1#0) } 
  Seq#Rank(a#15#1#0) < DtRank(#AsyncDisk.ReqWrite.ReqWrite(a#15#0#0, a#15#1#0)));

// Depth-one case-split function
function $IsA#AsyncDisk.ReqWrite(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.ReqWrite(d) } 
  $IsA#AsyncDisk.ReqWrite(d) ==> AsyncDisk.ReqWrite.ReqWrite_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqWrite.ReqWrite_q(d), $Is(d, Tclass.AsyncDisk.ReqWrite()) } 
  $Is(d, Tclass.AsyncDisk.ReqWrite()) ==> AsyncDisk.ReqWrite.ReqWrite_q(d));

// Datatype extensional equality declaration
function AsyncDisk.ReqWrite#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.ReqWrite.ReqWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.ReqWrite#Equal(a, b) } 
  true
     ==> (AsyncDisk.ReqWrite#Equal(a, b)
       <==> AsyncDisk.ReqWrite.addr(a) == AsyncDisk.ReqWrite.addr(b)
         && Seq#Equal(AsyncDisk.ReqWrite.bytes(a), AsyncDisk.ReqWrite.bytes(b))));

// Datatype extensionality axiom: AsyncDisk.ReqWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.ReqWrite#Equal(a, b) } 
  AsyncDisk.ReqWrite#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.ReqWrite: ClassName;

// Constructor function declaration
function #AsyncDisk.RespRead.RespRead(int, Seq Box) : DatatypeType;

const unique ##AsyncDisk.RespRead.RespRead: DtCtorId;

// Constructor identifier
axiom (forall a#16#0#0: int, a#16#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(a#16#0#0, a#16#1#0) } 
  DatatypeCtorId(#AsyncDisk.RespRead.RespRead(a#16#0#0, a#16#1#0))
     == ##AsyncDisk.RespRead.RespRead);

function AsyncDisk.RespRead.RespRead_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespRead.RespRead_q(d) } 
  AsyncDisk.RespRead.RespRead_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.RespRead.RespRead);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespRead.RespRead_q(d) } 
  AsyncDisk.RespRead.RespRead_q(d)
     ==> (exists a#17#0#0: int, a#17#1#0: Seq Box :: 
      d == #AsyncDisk.RespRead.RespRead(a#17#0#0, a#17#1#0)));

function Tclass.AsyncDisk.RespRead() : Ty;

// Tclass.AsyncDisk.RespRead Tag
axiom Tag(Tclass.AsyncDisk.RespRead()) == Tagclass.AsyncDisk.RespRead;

const unique Tagclass.AsyncDisk.RespRead: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.RespRead
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.RespRead()) } 
  $IsBox(bx, Tclass.AsyncDisk.RespRead())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.RespRead()));

// Constructor $Is
axiom (forall a#18#0#0: int, a#18#1#0: Seq Box :: 
  { $Is(#AsyncDisk.RespRead.RespRead(a#18#0#0, a#18#1#0), Tclass.AsyncDisk.RespRead()) } 
  $Is(#AsyncDisk.RespRead.RespRead(a#18#0#0, a#18#1#0), Tclass.AsyncDisk.RespRead())
     <==> $Is(a#18#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#18#1#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#19#0#0: int, a#19#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.RespRead.RespRead(a#19#0#0, a#19#1#0), 
      Tclass.AsyncDisk.RespRead(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.RespRead.RespRead(a#19#0#0, a#19#1#0), 
        Tclass.AsyncDisk.RespRead(), 
        $h)
       <==> $IsAlloc(a#19#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#19#1#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.RespRead.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.RespRead.RespRead_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.RespRead(), $h)
     ==> $IsAlloc(AsyncDisk.RespRead.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.RespRead.bytes(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.RespRead.RespRead_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.RespRead(), $h)
     ==> $IsAlloc(AsyncDisk.RespRead.bytes(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#20#0#0: int, a#20#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(LitInt(a#20#0#0), Lit(a#20#1#0)) } 
  #AsyncDisk.RespRead.RespRead(LitInt(a#20#0#0), Lit(a#20#1#0))
     == Lit(#AsyncDisk.RespRead.RespRead(a#20#0#0, a#20#1#0)));

function AsyncDisk.RespRead.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#21#0#0: int, a#21#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(a#21#0#0, a#21#1#0) } 
  AsyncDisk.RespRead.addr(#AsyncDisk.RespRead.RespRead(a#21#0#0, a#21#1#0))
     == a#21#0#0);

function AsyncDisk.RespRead.bytes(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#22#0#0: int, a#22#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(a#22#0#0, a#22#1#0) } 
  AsyncDisk.RespRead.bytes(#AsyncDisk.RespRead.RespRead(a#22#0#0, a#22#1#0))
     == a#22#1#0);

// Inductive seq element rank
axiom (forall a#23#0#0: int, a#23#1#0: Seq Box, i: int :: 
  { Seq#Index(a#23#1#0, i), #AsyncDisk.RespRead.RespRead(a#23#0#0, a#23#1#0) } 
  0 <= i && i < Seq#Length(a#23#1#0)
     ==> DtRank($Unbox(Seq#Index(a#23#1#0, i)): DatatypeType)
       < DtRank(#AsyncDisk.RespRead.RespRead(a#23#0#0, a#23#1#0)));

// Inductive seq rank
axiom (forall a#24#0#0: int, a#24#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(a#24#0#0, a#24#1#0) } 
  Seq#Rank(a#24#1#0) < DtRank(#AsyncDisk.RespRead.RespRead(a#24#0#0, a#24#1#0)));

// Depth-one case-split function
function $IsA#AsyncDisk.RespRead(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.RespRead(d) } 
  $IsA#AsyncDisk.RespRead(d) ==> AsyncDisk.RespRead.RespRead_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespRead.RespRead_q(d), $Is(d, Tclass.AsyncDisk.RespRead()) } 
  $Is(d, Tclass.AsyncDisk.RespRead()) ==> AsyncDisk.RespRead.RespRead_q(d));

// Datatype extensional equality declaration
function AsyncDisk.RespRead#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.RespRead.RespRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.RespRead#Equal(a, b) } 
  true
     ==> (AsyncDisk.RespRead#Equal(a, b)
       <==> AsyncDisk.RespRead.addr(a) == AsyncDisk.RespRead.addr(b)
         && Seq#Equal(AsyncDisk.RespRead.bytes(a), AsyncDisk.RespRead.bytes(b))));

// Datatype extensionality axiom: AsyncDisk.RespRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.RespRead#Equal(a, b) } 
  AsyncDisk.RespRead#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.RespRead: ClassName;

// Constructor function declaration
function #AsyncDisk.RespWrite.RespWrite(int, int) : DatatypeType;

const unique ##AsyncDisk.RespWrite.RespWrite: DtCtorId;

// Constructor identifier
axiom (forall a#25#0#0: int, a#25#1#0: int :: 
  { #AsyncDisk.RespWrite.RespWrite(a#25#0#0, a#25#1#0) } 
  DatatypeCtorId(#AsyncDisk.RespWrite.RespWrite(a#25#0#0, a#25#1#0))
     == ##AsyncDisk.RespWrite.RespWrite);

function AsyncDisk.RespWrite.RespWrite_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespWrite.RespWrite_q(d) } 
  AsyncDisk.RespWrite.RespWrite_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.RespWrite.RespWrite);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespWrite.RespWrite_q(d) } 
  AsyncDisk.RespWrite.RespWrite_q(d)
     ==> (exists a#26#0#0: int, a#26#1#0: int :: 
      d == #AsyncDisk.RespWrite.RespWrite(a#26#0#0, a#26#1#0)));

function Tclass.AsyncDisk.RespWrite() : Ty;

// Tclass.AsyncDisk.RespWrite Tag
axiom Tag(Tclass.AsyncDisk.RespWrite()) == Tagclass.AsyncDisk.RespWrite;

const unique Tagclass.AsyncDisk.RespWrite: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.RespWrite
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.RespWrite()) } 
  $IsBox(bx, Tclass.AsyncDisk.RespWrite())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.RespWrite()));

// Constructor $Is
axiom (forall a#27#0#0: int, a#27#1#0: int :: 
  { $Is(#AsyncDisk.RespWrite.RespWrite(a#27#0#0, a#27#1#0), Tclass.AsyncDisk.RespWrite()) } 
  $Is(#AsyncDisk.RespWrite.RespWrite(a#27#0#0, a#27#1#0), Tclass.AsyncDisk.RespWrite())
     <==> $Is(a#27#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#27#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#28#0#0: int, a#28#1#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.RespWrite.RespWrite(a#28#0#0, a#28#1#0), 
      Tclass.AsyncDisk.RespWrite(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.RespWrite.RespWrite(a#28#0#0, a#28#1#0), 
        Tclass.AsyncDisk.RespWrite(), 
        $h)
       <==> $IsAlloc(a#28#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#28#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.RespWrite.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.RespWrite.RespWrite_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.RespWrite(), $h)
     ==> $IsAlloc(AsyncDisk.RespWrite.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.RespWrite.len(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.RespWrite.RespWrite_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.RespWrite(), $h)
     ==> $IsAlloc(AsyncDisk.RespWrite.len(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#29#0#0: int, a#29#1#0: int :: 
  { #AsyncDisk.RespWrite.RespWrite(LitInt(a#29#0#0), LitInt(a#29#1#0)) } 
  #AsyncDisk.RespWrite.RespWrite(LitInt(a#29#0#0), LitInt(a#29#1#0))
     == Lit(#AsyncDisk.RespWrite.RespWrite(a#29#0#0, a#29#1#0)));

function AsyncDisk.RespWrite.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#30#0#0: int, a#30#1#0: int :: 
  { #AsyncDisk.RespWrite.RespWrite(a#30#0#0, a#30#1#0) } 
  AsyncDisk.RespWrite.addr(#AsyncDisk.RespWrite.RespWrite(a#30#0#0, a#30#1#0))
     == a#30#0#0);

function AsyncDisk.RespWrite.len(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#31#0#0: int, a#31#1#0: int :: 
  { #AsyncDisk.RespWrite.RespWrite(a#31#0#0, a#31#1#0) } 
  AsyncDisk.RespWrite.len(#AsyncDisk.RespWrite.RespWrite(a#31#0#0, a#31#1#0))
     == a#31#1#0);

// Depth-one case-split function
function $IsA#AsyncDisk.RespWrite(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.RespWrite(d) } 
  $IsA#AsyncDisk.RespWrite(d) ==> AsyncDisk.RespWrite.RespWrite_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespWrite.RespWrite_q(d), $Is(d, Tclass.AsyncDisk.RespWrite()) } 
  $Is(d, Tclass.AsyncDisk.RespWrite()) ==> AsyncDisk.RespWrite.RespWrite_q(d));

// Datatype extensional equality declaration
function AsyncDisk.RespWrite#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.RespWrite.RespWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.RespWrite#Equal(a, b) } 
  true
     ==> (AsyncDisk.RespWrite#Equal(a, b)
       <==> AsyncDisk.RespWrite.addr(a) == AsyncDisk.RespWrite.addr(b)
         && AsyncDisk.RespWrite.len(a) == AsyncDisk.RespWrite.len(b)));

// Datatype extensionality axiom: AsyncDisk.RespWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.RespWrite#Equal(a, b) } 
  AsyncDisk.RespWrite#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.RespWrite: ClassName;

// Constructor function declaration
function #AsyncDisk.DiskOp.ReqReadOp(int, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.ReqReadOp: DtCtorId;

// Constructor identifier
axiom (forall a#32#0#0: int, a#32#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(a#32#0#0, a#32#1#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.ReqReadOp(a#32#0#0, a#32#1#0))
     == ##AsyncDisk.DiskOp.ReqReadOp);

function AsyncDisk.DiskOp.ReqReadOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqReadOp_q(d) } 
  AsyncDisk.DiskOp.ReqReadOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.ReqReadOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqReadOp_q(d) } 
  AsyncDisk.DiskOp.ReqReadOp_q(d)
     ==> (exists a#33#0#0: int, a#33#1#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.ReqReadOp(a#33#0#0, a#33#1#0)));

function Tclass.AsyncDisk.DiskOp() : Ty;

// Tclass.AsyncDisk.DiskOp Tag
axiom Tag(Tclass.AsyncDisk.DiskOp()) == Tagclass.AsyncDisk.DiskOp;

const unique Tagclass.AsyncDisk.DiskOp: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.DiskOp
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.DiskOp()) } 
  $IsBox(bx, Tclass.AsyncDisk.DiskOp())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.DiskOp()));

// Constructor $Is
axiom (forall a#34#0#0: int, a#34#1#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.ReqReadOp(a#34#0#0, a#34#1#0), Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.ReqReadOp(a#34#0#0, a#34#1#0), Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#34#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#34#1#0, Tclass.AsyncDisk.ReqRead()));

// Constructor $IsAlloc
axiom (forall a#35#0#0: int, a#35#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.ReqReadOp(a#35#0#0, a#35#1#0), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.ReqReadOp(a#35#0#0, a#35#1#0), Tclass.AsyncDisk.DiskOp(), $h)
       <==> $IsAlloc(a#35#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#35#1#0, Tclass.AsyncDisk.ReqRead(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqReadOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.reqRead(d), Tclass.AsyncDisk.ReqRead(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqReadOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.reqRead(d), Tclass.AsyncDisk.ReqRead(), $h));

// Constructor literal
axiom (forall a#36#0#0: int, a#36#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(LitInt(a#36#0#0), Lit(a#36#1#0)) } 
  #AsyncDisk.DiskOp.ReqReadOp(LitInt(a#36#0#0), Lit(a#36#1#0))
     == Lit(#AsyncDisk.DiskOp.ReqReadOp(a#36#0#0, a#36#1#0)));

function AsyncDisk.DiskOp.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#37#0#0: int, a#37#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(a#37#0#0, a#37#1#0) } 
  AsyncDisk.DiskOp.id(#AsyncDisk.DiskOp.ReqReadOp(a#37#0#0, a#37#1#0)) == a#37#0#0);

function AsyncDisk.DiskOp.reqRead(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#38#0#0: int, a#38#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(a#38#0#0, a#38#1#0) } 
  AsyncDisk.DiskOp.reqRead(#AsyncDisk.DiskOp.ReqReadOp(a#38#0#0, a#38#1#0))
     == a#38#1#0);

// Inductive rank
axiom (forall a#39#0#0: int, a#39#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(a#39#0#0, a#39#1#0) } 
  DtRank(a#39#1#0) < DtRank(#AsyncDisk.DiskOp.ReqReadOp(a#39#0#0, a#39#1#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.ReqWriteOp(int, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.ReqWriteOp: DtCtorId;

// Constructor identifier
axiom (forall a#40#0#0: int, a#40#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(a#40#0#0, a#40#1#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.ReqWriteOp(a#40#0#0, a#40#1#0))
     == ##AsyncDisk.DiskOp.ReqWriteOp);

function AsyncDisk.DiskOp.ReqWriteOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqWriteOp_q(d) } 
  AsyncDisk.DiskOp.ReqWriteOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.ReqWriteOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqWriteOp_q(d) } 
  AsyncDisk.DiskOp.ReqWriteOp_q(d)
     ==> (exists a#41#0#0: int, a#41#1#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.ReqWriteOp(a#41#0#0, a#41#1#0)));

// Constructor $Is
axiom (forall a#42#0#0: int, a#42#1#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.ReqWriteOp(a#42#0#0, a#42#1#0), Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.ReqWriteOp(a#42#0#0, a#42#1#0), Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#42#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#42#1#0, Tclass.AsyncDisk.ReqWrite()));

// Constructor $IsAlloc
axiom (forall a#43#0#0: int, a#43#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.ReqWriteOp(a#43#0#0, a#43#1#0), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.ReqWriteOp(a#43#0#0, a#43#1#0), Tclass.AsyncDisk.DiskOp(), $h)
       <==> $IsAlloc(a#43#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#43#1#0, Tclass.AsyncDisk.ReqWrite(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWriteOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.reqWrite(d), Tclass.AsyncDisk.ReqWrite(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWriteOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.reqWrite(d), Tclass.AsyncDisk.ReqWrite(), $h));

// Constructor literal
axiom (forall a#44#0#0: int, a#44#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(LitInt(a#44#0#0), Lit(a#44#1#0)) } 
  #AsyncDisk.DiskOp.ReqWriteOp(LitInt(a#44#0#0), Lit(a#44#1#0))
     == Lit(#AsyncDisk.DiskOp.ReqWriteOp(a#44#0#0, a#44#1#0)));

// Constructor injectivity
axiom (forall a#45#0#0: int, a#45#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(a#45#0#0, a#45#1#0) } 
  AsyncDisk.DiskOp.id(#AsyncDisk.DiskOp.ReqWriteOp(a#45#0#0, a#45#1#0))
     == a#45#0#0);

function AsyncDisk.DiskOp.reqWrite(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#46#0#0: int, a#46#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(a#46#0#0, a#46#1#0) } 
  AsyncDisk.DiskOp.reqWrite(#AsyncDisk.DiskOp.ReqWriteOp(a#46#0#0, a#46#1#0))
     == a#46#1#0);

// Inductive rank
axiom (forall a#47#0#0: int, a#47#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(a#47#0#0, a#47#1#0) } 
  DtRank(a#47#1#0) < DtRank(#AsyncDisk.DiskOp.ReqWriteOp(a#47#0#0, a#47#1#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.ReqWrite2Op(int, int, DatatypeType, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.ReqWrite2Op: DtCtorId;

// Constructor identifier
axiom (forall a#48#0#0: int, a#48#1#0: int, a#48#2#0: DatatypeType, a#48#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#48#0#0, a#48#1#0, a#48#2#0, a#48#3#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.ReqWrite2Op(a#48#0#0, a#48#1#0, a#48#2#0, a#48#3#0))
     == ##AsyncDisk.DiskOp.ReqWrite2Op);

function AsyncDisk.DiskOp.ReqWrite2Op_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqWrite2Op_q(d) } 
  AsyncDisk.DiskOp.ReqWrite2Op_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.ReqWrite2Op);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqWrite2Op_q(d) } 
  AsyncDisk.DiskOp.ReqWrite2Op_q(d)
     ==> (exists a#49#0#0: int, a#49#1#0: int, a#49#2#0: DatatypeType, a#49#3#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.ReqWrite2Op(a#49#0#0, a#49#1#0, a#49#2#0, a#49#3#0)));

// Constructor $Is
axiom (forall a#50#0#0: int, a#50#1#0: int, a#50#2#0: DatatypeType, a#50#3#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.ReqWrite2Op(a#50#0#0, a#50#1#0, a#50#2#0, a#50#3#0), 
      Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.ReqWrite2Op(a#50#0#0, a#50#1#0, a#50#2#0, a#50#3#0), 
      Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#50#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#50#1#0, Tclass.NativeTypes.uint64())
       && $Is(a#50#2#0, Tclass.AsyncDisk.ReqWrite())
       && $Is(a#50#3#0, Tclass.AsyncDisk.ReqWrite()));

// Constructor $IsAlloc
axiom (forall a#51#0#0: int, 
    a#51#1#0: int, 
    a#51#2#0: DatatypeType, 
    a#51#3#0: DatatypeType, 
    $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.ReqWrite2Op(a#51#0#0, a#51#1#0, a#51#2#0, a#51#3#0), 
      Tclass.AsyncDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.ReqWrite2Op(a#51#0#0, a#51#1#0, a#51#2#0, a#51#3#0), 
        Tclass.AsyncDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#51#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#51#1#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#51#2#0, Tclass.AsyncDisk.ReqWrite(), $h)
         && $IsAlloc(a#51#3#0, Tclass.AsyncDisk.ReqWrite(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id1(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id1(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id2(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id2(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.reqWrite1(d), Tclass.AsyncDisk.ReqWrite(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.reqWrite1(d), Tclass.AsyncDisk.ReqWrite(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.reqWrite2(d), Tclass.AsyncDisk.ReqWrite(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.reqWrite2(d), Tclass.AsyncDisk.ReqWrite(), $h));

// Constructor literal
axiom (forall a#52#0#0: int, a#52#1#0: int, a#52#2#0: DatatypeType, a#52#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(LitInt(a#52#0#0), LitInt(a#52#1#0), Lit(a#52#2#0), Lit(a#52#3#0)) } 
  #AsyncDisk.DiskOp.ReqWrite2Op(LitInt(a#52#0#0), LitInt(a#52#1#0), Lit(a#52#2#0), Lit(a#52#3#0))
     == Lit(#AsyncDisk.DiskOp.ReqWrite2Op(a#52#0#0, a#52#1#0, a#52#2#0, a#52#3#0)));

function AsyncDisk.DiskOp.id1(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#53#0#0: int, a#53#1#0: int, a#53#2#0: DatatypeType, a#53#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#53#0#0, a#53#1#0, a#53#2#0, a#53#3#0) } 
  AsyncDisk.DiskOp.id1(#AsyncDisk.DiskOp.ReqWrite2Op(a#53#0#0, a#53#1#0, a#53#2#0, a#53#3#0))
     == a#53#0#0);

function AsyncDisk.DiskOp.id2(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#54#0#0: int, a#54#1#0: int, a#54#2#0: DatatypeType, a#54#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#54#0#0, a#54#1#0, a#54#2#0, a#54#3#0) } 
  AsyncDisk.DiskOp.id2(#AsyncDisk.DiskOp.ReqWrite2Op(a#54#0#0, a#54#1#0, a#54#2#0, a#54#3#0))
     == a#54#1#0);

function AsyncDisk.DiskOp.reqWrite1(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#55#0#0: int, a#55#1#0: int, a#55#2#0: DatatypeType, a#55#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#55#0#0, a#55#1#0, a#55#2#0, a#55#3#0) } 
  AsyncDisk.DiskOp.reqWrite1(#AsyncDisk.DiskOp.ReqWrite2Op(a#55#0#0, a#55#1#0, a#55#2#0, a#55#3#0))
     == a#55#2#0);

// Inductive rank
axiom (forall a#56#0#0: int, a#56#1#0: int, a#56#2#0: DatatypeType, a#56#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#56#0#0, a#56#1#0, a#56#2#0, a#56#3#0) } 
  DtRank(a#56#2#0)
     < DtRank(#AsyncDisk.DiskOp.ReqWrite2Op(a#56#0#0, a#56#1#0, a#56#2#0, a#56#3#0)));

function AsyncDisk.DiskOp.reqWrite2(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#57#0#0: int, a#57#1#0: int, a#57#2#0: DatatypeType, a#57#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#57#0#0, a#57#1#0, a#57#2#0, a#57#3#0) } 
  AsyncDisk.DiskOp.reqWrite2(#AsyncDisk.DiskOp.ReqWrite2Op(a#57#0#0, a#57#1#0, a#57#2#0, a#57#3#0))
     == a#57#3#0);

// Inductive rank
axiom (forall a#58#0#0: int, a#58#1#0: int, a#58#2#0: DatatypeType, a#58#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#58#0#0, a#58#1#0, a#58#2#0, a#58#3#0) } 
  DtRank(a#58#3#0)
     < DtRank(#AsyncDisk.DiskOp.ReqWrite2Op(a#58#0#0, a#58#1#0, a#58#2#0, a#58#3#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.RespReadOp(int, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.RespReadOp: DtCtorId;

// Constructor identifier
axiom (forall a#59#0#0: int, a#59#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(a#59#0#0, a#59#1#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.RespReadOp(a#59#0#0, a#59#1#0))
     == ##AsyncDisk.DiskOp.RespReadOp);

function AsyncDisk.DiskOp.RespReadOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.RespReadOp_q(d) } 
  AsyncDisk.DiskOp.RespReadOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.RespReadOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.RespReadOp_q(d) } 
  AsyncDisk.DiskOp.RespReadOp_q(d)
     ==> (exists a#60#0#0: int, a#60#1#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.RespReadOp(a#60#0#0, a#60#1#0)));

// Constructor $Is
axiom (forall a#61#0#0: int, a#61#1#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.RespReadOp(a#61#0#0, a#61#1#0), Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.RespReadOp(a#61#0#0, a#61#1#0), Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#61#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#61#1#0, Tclass.AsyncDisk.RespRead()));

// Constructor $IsAlloc
axiom (forall a#62#0#0: int, a#62#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.RespReadOp(a#62#0#0, a#62#1#0), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.RespReadOp(a#62#0#0, a#62#1#0), Tclass.AsyncDisk.DiskOp(), $h)
       <==> $IsAlloc(a#62#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#62#1#0, Tclass.AsyncDisk.RespRead(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.RespReadOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.respRead(d), Tclass.AsyncDisk.RespRead(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.RespReadOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.respRead(d), Tclass.AsyncDisk.RespRead(), $h));

// Constructor literal
axiom (forall a#63#0#0: int, a#63#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(LitInt(a#63#0#0), Lit(a#63#1#0)) } 
  #AsyncDisk.DiskOp.RespReadOp(LitInt(a#63#0#0), Lit(a#63#1#0))
     == Lit(#AsyncDisk.DiskOp.RespReadOp(a#63#0#0, a#63#1#0)));

// Constructor injectivity
axiom (forall a#64#0#0: int, a#64#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(a#64#0#0, a#64#1#0) } 
  AsyncDisk.DiskOp.id(#AsyncDisk.DiskOp.RespReadOp(a#64#0#0, a#64#1#0))
     == a#64#0#0);

function AsyncDisk.DiskOp.respRead(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#65#0#0: int, a#65#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(a#65#0#0, a#65#1#0) } 
  AsyncDisk.DiskOp.respRead(#AsyncDisk.DiskOp.RespReadOp(a#65#0#0, a#65#1#0))
     == a#65#1#0);

// Inductive rank
axiom (forall a#66#0#0: int, a#66#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(a#66#0#0, a#66#1#0) } 
  DtRank(a#66#1#0) < DtRank(#AsyncDisk.DiskOp.RespReadOp(a#66#0#0, a#66#1#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.RespWriteOp(int, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.RespWriteOp: DtCtorId;

// Constructor identifier
axiom (forall a#67#0#0: int, a#67#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(a#67#0#0, a#67#1#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.RespWriteOp(a#67#0#0, a#67#1#0))
     == ##AsyncDisk.DiskOp.RespWriteOp);

function AsyncDisk.DiskOp.RespWriteOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.RespWriteOp_q(d) } 
  AsyncDisk.DiskOp.RespWriteOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.RespWriteOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.RespWriteOp_q(d) } 
  AsyncDisk.DiskOp.RespWriteOp_q(d)
     ==> (exists a#68#0#0: int, a#68#1#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.RespWriteOp(a#68#0#0, a#68#1#0)));

// Constructor $Is
axiom (forall a#69#0#0: int, a#69#1#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.RespWriteOp(a#69#0#0, a#69#1#0), Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.RespWriteOp(a#69#0#0, a#69#1#0), Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#69#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#69#1#0, Tclass.AsyncDisk.RespWrite()));

// Constructor $IsAlloc
axiom (forall a#70#0#0: int, a#70#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.RespWriteOp(a#70#0#0, a#70#1#0), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.RespWriteOp(a#70#0#0, a#70#1#0), Tclass.AsyncDisk.DiskOp(), $h)
       <==> $IsAlloc(a#70#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#70#1#0, Tclass.AsyncDisk.RespWrite(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.RespWriteOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.respWrite(d), Tclass.AsyncDisk.RespWrite(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.RespWriteOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.respWrite(d), Tclass.AsyncDisk.RespWrite(), $h));

// Constructor literal
axiom (forall a#71#0#0: int, a#71#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(LitInt(a#71#0#0), Lit(a#71#1#0)) } 
  #AsyncDisk.DiskOp.RespWriteOp(LitInt(a#71#0#0), Lit(a#71#1#0))
     == Lit(#AsyncDisk.DiskOp.RespWriteOp(a#71#0#0, a#71#1#0)));

// Constructor injectivity
axiom (forall a#72#0#0: int, a#72#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(a#72#0#0, a#72#1#0) } 
  AsyncDisk.DiskOp.id(#AsyncDisk.DiskOp.RespWriteOp(a#72#0#0, a#72#1#0))
     == a#72#0#0);

function AsyncDisk.DiskOp.respWrite(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#73#0#0: int, a#73#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(a#73#0#0, a#73#1#0) } 
  AsyncDisk.DiskOp.respWrite(#AsyncDisk.DiskOp.RespWriteOp(a#73#0#0, a#73#1#0))
     == a#73#1#0);

// Inductive rank
axiom (forall a#74#0#0: int, a#74#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(a#74#0#0, a#74#1#0) } 
  DtRank(a#74#1#0) < DtRank(#AsyncDisk.DiskOp.RespWriteOp(a#74#0#0, a#74#1#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.NoDiskOp() : DatatypeType;

const unique ##AsyncDisk.DiskOp.NoDiskOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.DiskOp.NoDiskOp()) == ##AsyncDisk.DiskOp.NoDiskOp;

function AsyncDisk.DiskOp.NoDiskOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.NoDiskOp_q(d) } 
  AsyncDisk.DiskOp.NoDiskOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.NoDiskOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.NoDiskOp_q(d) } 
  AsyncDisk.DiskOp.NoDiskOp_q(d) ==> d == #AsyncDisk.DiskOp.NoDiskOp());

// Constructor $Is
axiom $Is(#AsyncDisk.DiskOp.NoDiskOp(), Tclass.AsyncDisk.DiskOp());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.NoDiskOp(), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.DiskOp.NoDiskOp(), Tclass.AsyncDisk.DiskOp(), $h));

// Constructor literal
axiom #AsyncDisk.DiskOp.NoDiskOp() == Lit(#AsyncDisk.DiskOp.NoDiskOp());

// Depth-one case-split function
function $IsA#AsyncDisk.DiskOp(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.DiskOp(d) } 
  $IsA#AsyncDisk.DiskOp(d)
     ==> AsyncDisk.DiskOp.ReqReadOp_q(d)
       || AsyncDisk.DiskOp.ReqWriteOp_q(d)
       || AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       || AsyncDisk.DiskOp.RespReadOp_q(d)
       || AsyncDisk.DiskOp.RespWriteOp_q(d)
       || AsyncDisk.DiskOp.NoDiskOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.NoDiskOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.RespWriteOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.RespReadOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.ReqWrite2Op_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.ReqWriteOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.ReqReadOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
  $Is(d, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.DiskOp.ReqReadOp_q(d)
       || AsyncDisk.DiskOp.ReqWriteOp_q(d)
       || AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       || AsyncDisk.DiskOp.RespReadOp_q(d)
       || AsyncDisk.DiskOp.RespWriteOp_q(d)
       || AsyncDisk.DiskOp.NoDiskOp_q(d));

// Datatype extensional equality declaration
function AsyncDisk.DiskOp#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.DiskOp.ReqReadOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqReadOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqReadOp_q(b) } 
  AsyncDisk.DiskOp.ReqReadOp_q(a) && AsyncDisk.DiskOp.ReqReadOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id(a) == AsyncDisk.DiskOp.id(b)
         && AsyncDisk.ReqRead#Equal(AsyncDisk.DiskOp.reqRead(a), AsyncDisk.DiskOp.reqRead(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.ReqWriteOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqWriteOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqWriteOp_q(b) } 
  AsyncDisk.DiskOp.ReqWriteOp_q(a) && AsyncDisk.DiskOp.ReqWriteOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id(a) == AsyncDisk.DiskOp.id(b)
         && AsyncDisk.ReqWrite#Equal(AsyncDisk.DiskOp.reqWrite(a), AsyncDisk.DiskOp.reqWrite(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.ReqWrite2Op
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqWrite2Op_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqWrite2Op_q(b) } 
  AsyncDisk.DiskOp.ReqWrite2Op_q(a) && AsyncDisk.DiskOp.ReqWrite2Op_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id1(a) == AsyncDisk.DiskOp.id1(b)
         && AsyncDisk.DiskOp.id2(a) == AsyncDisk.DiskOp.id2(b)
         && AsyncDisk.ReqWrite#Equal(AsyncDisk.DiskOp.reqWrite1(a), AsyncDisk.DiskOp.reqWrite1(b))
         && AsyncDisk.ReqWrite#Equal(AsyncDisk.DiskOp.reqWrite2(a), AsyncDisk.DiskOp.reqWrite2(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.RespReadOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.RespReadOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.RespReadOp_q(b) } 
  AsyncDisk.DiskOp.RespReadOp_q(a) && AsyncDisk.DiskOp.RespReadOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id(a) == AsyncDisk.DiskOp.id(b)
         && AsyncDisk.RespRead#Equal(AsyncDisk.DiskOp.respRead(a), AsyncDisk.DiskOp.respRead(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.RespWriteOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.RespWriteOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.RespWriteOp_q(b) } 
  AsyncDisk.DiskOp.RespWriteOp_q(a) && AsyncDisk.DiskOp.RespWriteOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id(a) == AsyncDisk.DiskOp.id(b)
         && AsyncDisk.RespWrite#Equal(AsyncDisk.DiskOp.respWrite(a), AsyncDisk.DiskOp.respWrite(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.NoDiskOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.NoDiskOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.NoDiskOp_q(b) } 
  AsyncDisk.DiskOp.NoDiskOp_q(a) && AsyncDisk.DiskOp.NoDiskOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b) <==> true));

// Datatype extensionality axiom: AsyncDisk.DiskOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b) } 
  AsyncDisk.DiskOp#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.DiskOp: ClassName;

// Constructor function declaration
function #AsyncDisk.Constants.Constants() : DatatypeType;

const unique ##AsyncDisk.Constants.Constants: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Constants.Constants())
   == ##AsyncDisk.Constants.Constants;

function AsyncDisk.Constants.Constants_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Constants.Constants_q(d) } 
  AsyncDisk.Constants.Constants_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Constants.Constants);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Constants.Constants_q(d) } 
  AsyncDisk.Constants.Constants_q(d) ==> d == #AsyncDisk.Constants.Constants());

function Tclass.AsyncDisk.Constants() : Ty;

// Tclass.AsyncDisk.Constants Tag
axiom Tag(Tclass.AsyncDisk.Constants()) == Tagclass.AsyncDisk.Constants;

const unique Tagclass.AsyncDisk.Constants: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.Constants
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.Constants()) } 
  $IsBox(bx, Tclass.AsyncDisk.Constants())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.Constants()));

// Constructor $Is
axiom $Is(#AsyncDisk.Constants.Constants(), Tclass.AsyncDisk.Constants());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Constants.Constants(), Tclass.AsyncDisk.Constants(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Constants.Constants(), Tclass.AsyncDisk.Constants(), $h));

// Constructor literal
axiom #AsyncDisk.Constants.Constants() == Lit(#AsyncDisk.Constants.Constants());

// Depth-one case-split function
function $IsA#AsyncDisk.Constants(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.Constants(d) } 
  $IsA#AsyncDisk.Constants(d) ==> AsyncDisk.Constants.Constants_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Constants.Constants_q(d), $Is(d, Tclass.AsyncDisk.Constants()) } 
  $Is(d, Tclass.AsyncDisk.Constants()) ==> AsyncDisk.Constants.Constants_q(d));

// Datatype extensional equality declaration
function AsyncDisk.Constants#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.Constants.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Constants#Equal(a, b) } 
  true ==> (AsyncDisk.Constants#Equal(a, b) <==> true));

// Datatype extensionality axiom: AsyncDisk.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Constants#Equal(a, b) } 
  AsyncDisk.Constants#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.Constants: ClassName;

// Constructor function declaration
function #AsyncDisk.Variables.Variables(Map Box Box, Map Box Box, Map Box Box, Map Box Box, Seq Box) : DatatypeType;

const unique ##AsyncDisk.Variables.Variables: DtCtorId;

// Constructor identifier
axiom (forall a#85#0#0: Map Box Box, 
    a#85#1#0: Map Box Box, 
    a#85#2#0: Map Box Box, 
    a#85#3#0: Map Box Box, 
    a#85#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#85#0#0, a#85#1#0, a#85#2#0, a#85#3#0, a#85#4#0) } 
  DatatypeCtorId(#AsyncDisk.Variables.Variables(a#85#0#0, a#85#1#0, a#85#2#0, a#85#3#0, a#85#4#0))
     == ##AsyncDisk.Variables.Variables);

function AsyncDisk.Variables.Variables_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Variables.Variables_q(d) } 
  AsyncDisk.Variables.Variables_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Variables.Variables);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Variables.Variables_q(d) } 
  AsyncDisk.Variables.Variables_q(d)
     ==> (exists a#86#0#0: Map Box Box, 
        a#86#1#0: Map Box Box, 
        a#86#2#0: Map Box Box, 
        a#86#3#0: Map Box Box, 
        a#86#4#0: Seq Box :: 
      d
         == #AsyncDisk.Variables.Variables(a#86#0#0, a#86#1#0, a#86#2#0, a#86#3#0, a#86#4#0)));

function Tclass.AsyncDisk.Variables() : Ty;

// Tclass.AsyncDisk.Variables Tag
axiom Tag(Tclass.AsyncDisk.Variables()) == Tagclass.AsyncDisk.Variables;

const unique Tagclass.AsyncDisk.Variables: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.Variables
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.Variables()) } 
  $IsBox(bx, Tclass.AsyncDisk.Variables())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.Variables()));

// Constructor $Is
axiom (forall a#87#0#0: Map Box Box, 
    a#87#1#0: Map Box Box, 
    a#87#2#0: Map Box Box, 
    a#87#3#0: Map Box Box, 
    a#87#4#0: Seq Box :: 
  { $Is(#AsyncDisk.Variables.Variables(a#87#0#0, a#87#1#0, a#87#2#0, a#87#3#0, a#87#4#0), 
      Tclass.AsyncDisk.Variables()) } 
  $Is(#AsyncDisk.Variables.Variables(a#87#0#0, a#87#1#0, a#87#2#0, a#87#3#0, a#87#4#0), 
      Tclass.AsyncDisk.Variables())
     <==> $Is(a#87#0#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqRead()))
       && $Is(a#87#1#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqWrite()))
       && $Is(a#87#2#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespRead()))
       && $Is(a#87#3#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespWrite()))
       && $Is(a#87#4#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#88#0#0: Map Box Box, 
    a#88#1#0: Map Box Box, 
    a#88#2#0: Map Box Box, 
    a#88#3#0: Map Box Box, 
    a#88#4#0: Seq Box, 
    $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Variables.Variables(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0, a#88#4#0), 
      Tclass.AsyncDisk.Variables(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.Variables.Variables(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0, a#88#4#0), 
        Tclass.AsyncDisk.Variables(), 
        $h)
       <==> $IsAlloc(a#88#0#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqRead()), $h)
         && $IsAlloc(a#88#1#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqWrite()), $h)
         && $IsAlloc(a#88#2#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespRead()), $h)
         && $IsAlloc(a#88#3#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespWrite()), $h)
         && $IsAlloc(a#88#4#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.reqReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqRead()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.reqReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqRead()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.reqWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqWrite()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.reqWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqWrite()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.respReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespRead()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.respReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespRead()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.respWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespWrite()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.respWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespWrite()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.contents(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.contents(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#89#0#0: Map Box Box, 
    a#89#1#0: Map Box Box, 
    a#89#2#0: Map Box Box, 
    a#89#3#0: Map Box Box, 
    a#89#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(Lit(a#89#0#0), Lit(a#89#1#0), Lit(a#89#2#0), Lit(a#89#3#0), Lit(a#89#4#0)) } 
  #AsyncDisk.Variables.Variables(Lit(a#89#0#0), Lit(a#89#1#0), Lit(a#89#2#0), Lit(a#89#3#0), Lit(a#89#4#0))
     == Lit(#AsyncDisk.Variables.Variables(a#89#0#0, a#89#1#0, a#89#2#0, a#89#3#0, a#89#4#0)));

function AsyncDisk.Variables.reqReads(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#90#0#0: Map Box Box, 
    a#90#1#0: Map Box Box, 
    a#90#2#0: Map Box Box, 
    a#90#3#0: Map Box Box, 
    a#90#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#90#0#0, a#90#1#0, a#90#2#0, a#90#3#0, a#90#4#0) } 
  AsyncDisk.Variables.reqReads(#AsyncDisk.Variables.Variables(a#90#0#0, a#90#1#0, a#90#2#0, a#90#3#0, a#90#4#0))
     == a#90#0#0);

// Inductive map key rank
axiom (forall a#91#0#0: Map Box Box, 
    a#91#1#0: Map Box Box, 
    a#91#2#0: Map Box Box, 
    a#91#3#0: Map Box Box, 
    a#91#4#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#91#0#0)[$Box(d)], #AsyncDisk.Variables.Variables(a#91#0#0, a#91#1#0, a#91#2#0, a#91#3#0, a#91#4#0) } 
  Map#Domain(a#91#0#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#AsyncDisk.Variables.Variables(a#91#0#0, a#91#1#0, a#91#2#0, a#91#3#0, a#91#4#0)));

// Inductive map value rank
axiom (forall a#92#0#0: Map Box Box, 
    a#92#1#0: Map Box Box, 
    a#92#2#0: Map Box Box, 
    a#92#3#0: Map Box Box, 
    a#92#4#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#92#0#0)[bx], #AsyncDisk.Variables.Variables(a#92#0#0, a#92#1#0, a#92#2#0, a#92#3#0, a#92#4#0) } 
  Map#Domain(a#92#0#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#92#0#0)[bx]): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#92#0#0, a#92#1#0, a#92#2#0, a#92#3#0, a#92#4#0)));

function AsyncDisk.Variables.reqWrites(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#93#0#0: Map Box Box, 
    a#93#1#0: Map Box Box, 
    a#93#2#0: Map Box Box, 
    a#93#3#0: Map Box Box, 
    a#93#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#93#0#0, a#93#1#0, a#93#2#0, a#93#3#0, a#93#4#0) } 
  AsyncDisk.Variables.reqWrites(#AsyncDisk.Variables.Variables(a#93#0#0, a#93#1#0, a#93#2#0, a#93#3#0, a#93#4#0))
     == a#93#1#0);

// Inductive map key rank
axiom (forall a#94#0#0: Map Box Box, 
    a#94#1#0: Map Box Box, 
    a#94#2#0: Map Box Box, 
    a#94#3#0: Map Box Box, 
    a#94#4#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#94#1#0)[$Box(d)], #AsyncDisk.Variables.Variables(a#94#0#0, a#94#1#0, a#94#2#0, a#94#3#0, a#94#4#0) } 
  Map#Domain(a#94#1#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#AsyncDisk.Variables.Variables(a#94#0#0, a#94#1#0, a#94#2#0, a#94#3#0, a#94#4#0)));

// Inductive map value rank
axiom (forall a#95#0#0: Map Box Box, 
    a#95#1#0: Map Box Box, 
    a#95#2#0: Map Box Box, 
    a#95#3#0: Map Box Box, 
    a#95#4#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#95#1#0)[bx], #AsyncDisk.Variables.Variables(a#95#0#0, a#95#1#0, a#95#2#0, a#95#3#0, a#95#4#0) } 
  Map#Domain(a#95#1#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#95#1#0)[bx]): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#95#0#0, a#95#1#0, a#95#2#0, a#95#3#0, a#95#4#0)));

function AsyncDisk.Variables.respReads(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#96#0#0: Map Box Box, 
    a#96#1#0: Map Box Box, 
    a#96#2#0: Map Box Box, 
    a#96#3#0: Map Box Box, 
    a#96#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#96#0#0, a#96#1#0, a#96#2#0, a#96#3#0, a#96#4#0) } 
  AsyncDisk.Variables.respReads(#AsyncDisk.Variables.Variables(a#96#0#0, a#96#1#0, a#96#2#0, a#96#3#0, a#96#4#0))
     == a#96#2#0);

// Inductive map key rank
axiom (forall a#97#0#0: Map Box Box, 
    a#97#1#0: Map Box Box, 
    a#97#2#0: Map Box Box, 
    a#97#3#0: Map Box Box, 
    a#97#4#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#97#2#0)[$Box(d)], #AsyncDisk.Variables.Variables(a#97#0#0, a#97#1#0, a#97#2#0, a#97#3#0, a#97#4#0) } 
  Map#Domain(a#97#2#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#AsyncDisk.Variables.Variables(a#97#0#0, a#97#1#0, a#97#2#0, a#97#3#0, a#97#4#0)));

// Inductive map value rank
axiom (forall a#98#0#0: Map Box Box, 
    a#98#1#0: Map Box Box, 
    a#98#2#0: Map Box Box, 
    a#98#3#0: Map Box Box, 
    a#98#4#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#98#2#0)[bx], #AsyncDisk.Variables.Variables(a#98#0#0, a#98#1#0, a#98#2#0, a#98#3#0, a#98#4#0) } 
  Map#Domain(a#98#2#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#98#2#0)[bx]): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#98#0#0, a#98#1#0, a#98#2#0, a#98#3#0, a#98#4#0)));

function AsyncDisk.Variables.respWrites(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#99#0#0: Map Box Box, 
    a#99#1#0: Map Box Box, 
    a#99#2#0: Map Box Box, 
    a#99#3#0: Map Box Box, 
    a#99#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#99#0#0, a#99#1#0, a#99#2#0, a#99#3#0, a#99#4#0) } 
  AsyncDisk.Variables.respWrites(#AsyncDisk.Variables.Variables(a#99#0#0, a#99#1#0, a#99#2#0, a#99#3#0, a#99#4#0))
     == a#99#3#0);

// Inductive map key rank
axiom (forall a#100#0#0: Map Box Box, 
    a#100#1#0: Map Box Box, 
    a#100#2#0: Map Box Box, 
    a#100#3#0: Map Box Box, 
    a#100#4#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#100#3#0)[$Box(d)], #AsyncDisk.Variables.Variables(a#100#0#0, a#100#1#0, a#100#2#0, a#100#3#0, a#100#4#0) } 
  Map#Domain(a#100#3#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#AsyncDisk.Variables.Variables(a#100#0#0, a#100#1#0, a#100#2#0, a#100#3#0, a#100#4#0)));

// Inductive map value rank
axiom (forall a#101#0#0: Map Box Box, 
    a#101#1#0: Map Box Box, 
    a#101#2#0: Map Box Box, 
    a#101#3#0: Map Box Box, 
    a#101#4#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#101#3#0)[bx], #AsyncDisk.Variables.Variables(a#101#0#0, a#101#1#0, a#101#2#0, a#101#3#0, a#101#4#0) } 
  Map#Domain(a#101#3#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#101#3#0)[bx]): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#101#0#0, a#101#1#0, a#101#2#0, a#101#3#0, a#101#4#0)));

function AsyncDisk.Variables.contents(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#102#0#0: Map Box Box, 
    a#102#1#0: Map Box Box, 
    a#102#2#0: Map Box Box, 
    a#102#3#0: Map Box Box, 
    a#102#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#102#0#0, a#102#1#0, a#102#2#0, a#102#3#0, a#102#4#0) } 
  AsyncDisk.Variables.contents(#AsyncDisk.Variables.Variables(a#102#0#0, a#102#1#0, a#102#2#0, a#102#3#0, a#102#4#0))
     == a#102#4#0);

// Inductive seq element rank
axiom (forall a#103#0#0: Map Box Box, 
    a#103#1#0: Map Box Box, 
    a#103#2#0: Map Box Box, 
    a#103#3#0: Map Box Box, 
    a#103#4#0: Seq Box, 
    i: int :: 
  { Seq#Index(a#103#4#0, i), #AsyncDisk.Variables.Variables(a#103#0#0, a#103#1#0, a#103#2#0, a#103#3#0, a#103#4#0) } 
  0 <= i && i < Seq#Length(a#103#4#0)
     ==> DtRank($Unbox(Seq#Index(a#103#4#0, i)): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#103#0#0, a#103#1#0, a#103#2#0, a#103#3#0, a#103#4#0)));

// Inductive seq rank
axiom (forall a#104#0#0: Map Box Box, 
    a#104#1#0: Map Box Box, 
    a#104#2#0: Map Box Box, 
    a#104#3#0: Map Box Box, 
    a#104#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#104#0#0, a#104#1#0, a#104#2#0, a#104#3#0, a#104#4#0) } 
  Seq#Rank(a#104#4#0)
     < DtRank(#AsyncDisk.Variables.Variables(a#104#0#0, a#104#1#0, a#104#2#0, a#104#3#0, a#104#4#0)));

// Depth-one case-split function
function $IsA#AsyncDisk.Variables(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.Variables(d) } 
  $IsA#AsyncDisk.Variables(d) ==> AsyncDisk.Variables.Variables_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Variables.Variables_q(d), $Is(d, Tclass.AsyncDisk.Variables()) } 
  $Is(d, Tclass.AsyncDisk.Variables()) ==> AsyncDisk.Variables.Variables_q(d));

// Datatype extensional equality declaration
function AsyncDisk.Variables#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.Variables.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Variables#Equal(a, b) } 
  true
     ==> (AsyncDisk.Variables#Equal(a, b)
       <==> Map#Equal(AsyncDisk.Variables.reqReads(a), AsyncDisk.Variables.reqReads(b))
         && Map#Equal(AsyncDisk.Variables.reqWrites(a), AsyncDisk.Variables.reqWrites(b))
         && Map#Equal(AsyncDisk.Variables.respReads(a), AsyncDisk.Variables.respReads(b))
         && Map#Equal(AsyncDisk.Variables.respWrites(a), AsyncDisk.Variables.respWrites(b))
         && Seq#Equal(AsyncDisk.Variables.contents(a), AsyncDisk.Variables.contents(b))));

// Datatype extensionality axiom: AsyncDisk.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Variables#Equal(a, b) } 
  AsyncDisk.Variables#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.Variables: ClassName;

// Constructor function declaration
function #AsyncDisk.Step.RecvReadStep() : DatatypeType;

const unique ##AsyncDisk.Step.RecvReadStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.RecvReadStep()) == ##AsyncDisk.Step.RecvReadStep;

function AsyncDisk.Step.RecvReadStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvReadStep_q(d) } 
  AsyncDisk.Step.RecvReadStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.RecvReadStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvReadStep_q(d) } 
  AsyncDisk.Step.RecvReadStep_q(d) ==> d == #AsyncDisk.Step.RecvReadStep());

function Tclass.AsyncDisk.Step() : Ty;

// Tclass.AsyncDisk.Step Tag
axiom Tag(Tclass.AsyncDisk.Step()) == Tagclass.AsyncDisk.Step;

const unique Tagclass.AsyncDisk.Step: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.Step
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.Step()) } 
  $IsBox(bx, Tclass.AsyncDisk.Step())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.Step()));

// Constructor $Is
axiom $Is(#AsyncDisk.Step.RecvReadStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.RecvReadStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.RecvReadStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.RecvReadStep() == Lit(#AsyncDisk.Step.RecvReadStep());

// Constructor function declaration
function #AsyncDisk.Step.RecvWriteStep() : DatatypeType;

const unique ##AsyncDisk.Step.RecvWriteStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.RecvWriteStep())
   == ##AsyncDisk.Step.RecvWriteStep;

function AsyncDisk.Step.RecvWriteStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvWriteStep_q(d) } 
  AsyncDisk.Step.RecvWriteStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.RecvWriteStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvWriteStep_q(d) } 
  AsyncDisk.Step.RecvWriteStep_q(d) ==> d == #AsyncDisk.Step.RecvWriteStep());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.RecvWriteStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.RecvWriteStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.RecvWriteStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.RecvWriteStep() == Lit(#AsyncDisk.Step.RecvWriteStep());

// Constructor function declaration
function #AsyncDisk.Step.RecvWrite2Step() : DatatypeType;

const unique ##AsyncDisk.Step.RecvWrite2Step: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.RecvWrite2Step())
   == ##AsyncDisk.Step.RecvWrite2Step;

function AsyncDisk.Step.RecvWrite2Step_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvWrite2Step_q(d) } 
  AsyncDisk.Step.RecvWrite2Step_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.RecvWrite2Step);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvWrite2Step_q(d) } 
  AsyncDisk.Step.RecvWrite2Step_q(d) ==> d == #AsyncDisk.Step.RecvWrite2Step());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.RecvWrite2Step(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.RecvWrite2Step(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.RecvWrite2Step(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.RecvWrite2Step() == Lit(#AsyncDisk.Step.RecvWrite2Step());

// Constructor function declaration
function #AsyncDisk.Step.AckReadStep() : DatatypeType;

const unique ##AsyncDisk.Step.AckReadStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.AckReadStep()) == ##AsyncDisk.Step.AckReadStep;

function AsyncDisk.Step.AckReadStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.AckReadStep_q(d) } 
  AsyncDisk.Step.AckReadStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.AckReadStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.AckReadStep_q(d) } 
  AsyncDisk.Step.AckReadStep_q(d) ==> d == #AsyncDisk.Step.AckReadStep());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.AckReadStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.AckReadStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.AckReadStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.AckReadStep() == Lit(#AsyncDisk.Step.AckReadStep());

// Constructor function declaration
function #AsyncDisk.Step.AckWriteStep() : DatatypeType;

const unique ##AsyncDisk.Step.AckWriteStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.AckWriteStep()) == ##AsyncDisk.Step.AckWriteStep;

function AsyncDisk.Step.AckWriteStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.AckWriteStep_q(d) } 
  AsyncDisk.Step.AckWriteStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.AckWriteStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.AckWriteStep_q(d) } 
  AsyncDisk.Step.AckWriteStep_q(d) ==> d == #AsyncDisk.Step.AckWriteStep());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.AckWriteStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.AckWriteStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.AckWriteStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.AckWriteStep() == Lit(#AsyncDisk.Step.AckWriteStep());

// Constructor function declaration
function #AsyncDisk.Step.StutterStep() : DatatypeType;

const unique ##AsyncDisk.Step.StutterStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.StutterStep()) == ##AsyncDisk.Step.StutterStep;

function AsyncDisk.Step.StutterStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.StutterStep_q(d) } 
  AsyncDisk.Step.StutterStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.StutterStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.StutterStep_q(d) } 
  AsyncDisk.Step.StutterStep_q(d) ==> d == #AsyncDisk.Step.StutterStep());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.StutterStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.StutterStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.StutterStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.StutterStep() == Lit(#AsyncDisk.Step.StutterStep());

// Depth-one case-split function
function $IsA#AsyncDisk.Step(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.Step(d) } 
  $IsA#AsyncDisk.Step(d)
     ==> AsyncDisk.Step.RecvReadStep_q(d)
       || AsyncDisk.Step.RecvWriteStep_q(d)
       || AsyncDisk.Step.RecvWrite2Step_q(d)
       || AsyncDisk.Step.AckReadStep_q(d)
       || AsyncDisk.Step.AckWriteStep_q(d)
       || AsyncDisk.Step.StutterStep_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.StutterStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.AckWriteStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.AckReadStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.RecvWrite2Step_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.RecvWriteStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.RecvReadStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
  $Is(d, Tclass.AsyncDisk.Step())
     ==> AsyncDisk.Step.RecvReadStep_q(d)
       || AsyncDisk.Step.RecvWriteStep_q(d)
       || AsyncDisk.Step.RecvWrite2Step_q(d)
       || AsyncDisk.Step.AckReadStep_q(d)
       || AsyncDisk.Step.AckWriteStep_q(d)
       || AsyncDisk.Step.StutterStep_q(d));

// Datatype extensional equality declaration
function AsyncDisk.Step#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.Step.RecvReadStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvReadStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvReadStep_q(b) } 
  AsyncDisk.Step.RecvReadStep_q(a) && AsyncDisk.Step.RecvReadStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.RecvWriteStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvWriteStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvWriteStep_q(b) } 
  AsyncDisk.Step.RecvWriteStep_q(a) && AsyncDisk.Step.RecvWriteStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.RecvWrite2Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvWrite2Step_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvWrite2Step_q(b) } 
  AsyncDisk.Step.RecvWrite2Step_q(a) && AsyncDisk.Step.RecvWrite2Step_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.AckReadStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.AckReadStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.AckReadStep_q(b) } 
  AsyncDisk.Step.AckReadStep_q(a) && AsyncDisk.Step.AckReadStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.AckWriteStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.AckWriteStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.AckWriteStep_q(b) } 
  AsyncDisk.Step.AckWriteStep_q(a) && AsyncDisk.Step.AckWriteStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.StutterStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.StutterStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.StutterStep_q(b) } 
  AsyncDisk.Step.StutterStep_q(a) && AsyncDisk.Step.StutterStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensionality axiom: AsyncDisk.Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b) } 
  AsyncDisk.Step#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.Step: ClassName;

// Constructor function declaration
function #AsyncDisk.InternalStep.ProcessReadFailureStep(int, Seq Box) : DatatypeType;

const unique ##AsyncDisk.InternalStep.ProcessReadFailureStep: DtCtorId;

// Constructor identifier
axiom (forall a#135#0#0: int, a#135#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(a#135#0#0, a#135#1#0) } 
  DatatypeCtorId(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#135#0#0, a#135#1#0))
     == ##AsyncDisk.InternalStep.ProcessReadFailureStep);

function AsyncDisk.InternalStep.ProcessReadFailureStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.ProcessReadFailureStep_q(d) } 
  AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.InternalStep.ProcessReadFailureStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.ProcessReadFailureStep_q(d) } 
  AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
     ==> (exists a#136#0#0: int, a#136#1#0: Seq Box :: 
      d == #AsyncDisk.InternalStep.ProcessReadFailureStep(a#136#0#0, a#136#1#0)));

function Tclass.AsyncDisk.InternalStep() : Ty;

// Tclass.AsyncDisk.InternalStep Tag
axiom Tag(Tclass.AsyncDisk.InternalStep()) == Tagclass.AsyncDisk.InternalStep;

const unique Tagclass.AsyncDisk.InternalStep: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.InternalStep
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.InternalStep()) } 
  $IsBox(bx, Tclass.AsyncDisk.InternalStep())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.InternalStep()));

// Constructor $Is
axiom (forall a#137#0#0: int, a#137#1#0: Seq Box :: 
  { $Is(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#137#0#0, a#137#1#0), 
      Tclass.AsyncDisk.InternalStep()) } 
  $Is(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#137#0#0, a#137#1#0), 
      Tclass.AsyncDisk.InternalStep())
     <==> $Is(a#137#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#137#1#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#138#0#0: int, a#138#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#138#0#0, a#138#1#0), 
      Tclass.AsyncDisk.InternalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#138#0#0, a#138#1#0), 
        Tclass.AsyncDisk.InternalStep(), 
        $h)
       <==> $IsAlloc(a#138#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#138#1#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.fakeContents(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.fakeContents(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#139#0#0: int, a#139#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(LitInt(a#139#0#0), Lit(a#139#1#0)) } 
  #AsyncDisk.InternalStep.ProcessReadFailureStep(LitInt(a#139#0#0), Lit(a#139#1#0))
     == Lit(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#139#0#0, a#139#1#0)));

function AsyncDisk.InternalStep.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#140#0#0: int, a#140#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(a#140#0#0, a#140#1#0) } 
  AsyncDisk.InternalStep.id(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#140#0#0, a#140#1#0))
     == a#140#0#0);

function AsyncDisk.InternalStep.fakeContents(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#141#0#0: int, a#141#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(a#141#0#0, a#141#1#0) } 
  AsyncDisk.InternalStep.fakeContents(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#141#0#0, a#141#1#0))
     == a#141#1#0);

// Inductive seq element rank
axiom (forall a#142#0#0: int, a#142#1#0: Seq Box, i: int :: 
  { Seq#Index(a#142#1#0, i), #AsyncDisk.InternalStep.ProcessReadFailureStep(a#142#0#0, a#142#1#0) } 
  0 <= i && i < Seq#Length(a#142#1#0)
     ==> DtRank($Unbox(Seq#Index(a#142#1#0, i)): DatatypeType)
       < DtRank(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#142#0#0, a#142#1#0)));

// Inductive seq rank
axiom (forall a#143#0#0: int, a#143#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(a#143#0#0, a#143#1#0) } 
  Seq#Rank(a#143#1#0)
     < DtRank(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#143#0#0, a#143#1#0)));

// Constructor function declaration
function #AsyncDisk.InternalStep.ProcessWriteStep(int) : DatatypeType;

const unique ##AsyncDisk.InternalStep.ProcessWriteStep: DtCtorId;

// Constructor identifier
axiom (forall a#144#0#0: int :: 
  { #AsyncDisk.InternalStep.ProcessWriteStep(a#144#0#0) } 
  DatatypeCtorId(#AsyncDisk.InternalStep.ProcessWriteStep(a#144#0#0))
     == ##AsyncDisk.InternalStep.ProcessWriteStep);

function AsyncDisk.InternalStep.ProcessWriteStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.ProcessWriteStep_q(d) } 
  AsyncDisk.InternalStep.ProcessWriteStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.InternalStep.ProcessWriteStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.ProcessWriteStep_q(d) } 
  AsyncDisk.InternalStep.ProcessWriteStep_q(d)
     ==> (exists a#145#0#0: int :: 
      d == #AsyncDisk.InternalStep.ProcessWriteStep(a#145#0#0)));

// Constructor $Is
axiom (forall a#146#0#0: int :: 
  { $Is(#AsyncDisk.InternalStep.ProcessWriteStep(a#146#0#0), 
      Tclass.AsyncDisk.InternalStep()) } 
  $Is(#AsyncDisk.InternalStep.ProcessWriteStep(a#146#0#0), 
      Tclass.AsyncDisk.InternalStep())
     <==> $Is(a#146#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#147#0#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.InternalStep.ProcessWriteStep(a#147#0#0), 
      Tclass.AsyncDisk.InternalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.InternalStep.ProcessWriteStep(a#147#0#0), 
        Tclass.AsyncDisk.InternalStep(), 
        $h)
       <==> $IsAlloc(a#147#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.ProcessWriteStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#148#0#0: int :: 
  { #AsyncDisk.InternalStep.ProcessWriteStep(LitInt(a#148#0#0)) } 
  #AsyncDisk.InternalStep.ProcessWriteStep(LitInt(a#148#0#0))
     == Lit(#AsyncDisk.InternalStep.ProcessWriteStep(a#148#0#0)));

// Constructor injectivity
axiom (forall a#149#0#0: int :: 
  { #AsyncDisk.InternalStep.ProcessWriteStep(a#149#0#0) } 
  AsyncDisk.InternalStep.id(#AsyncDisk.InternalStep.ProcessWriteStep(a#149#0#0))
     == a#149#0#0);

// Constructor function declaration
function #AsyncDisk.InternalStep.HavocConflictingWritesStep(int, int) : DatatypeType;

const unique ##AsyncDisk.InternalStep.HavocConflictingWritesStep: DtCtorId;

// Constructor identifier
axiom (forall a#150#0#0: int, a#150#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWritesStep(a#150#0#0, a#150#1#0) } 
  DatatypeCtorId(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#150#0#0, a#150#1#0))
     == ##AsyncDisk.InternalStep.HavocConflictingWritesStep);

function AsyncDisk.InternalStep.HavocConflictingWritesStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d) } 
  AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.InternalStep.HavocConflictingWritesStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d) } 
  AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
     ==> (exists a#151#0#0: int, a#151#1#0: int :: 
      d == #AsyncDisk.InternalStep.HavocConflictingWritesStep(a#151#0#0, a#151#1#0)));

// Constructor $Is
axiom (forall a#152#0#0: int, a#152#1#0: int :: 
  { $Is(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#152#0#0, a#152#1#0), 
      Tclass.AsyncDisk.InternalStep()) } 
  $Is(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#152#0#0, a#152#1#0), 
      Tclass.AsyncDisk.InternalStep())
     <==> $Is(a#152#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#152#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#153#0#0: int, a#153#1#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#153#0#0, a#153#1#0), 
      Tclass.AsyncDisk.InternalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#153#0#0, a#153#1#0), 
        Tclass.AsyncDisk.InternalStep(), 
        $h)
       <==> $IsAlloc(a#153#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#153#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id_k(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id_k(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#154#0#0: int, a#154#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWritesStep(LitInt(a#154#0#0), LitInt(a#154#1#0)) } 
  #AsyncDisk.InternalStep.HavocConflictingWritesStep(LitInt(a#154#0#0), LitInt(a#154#1#0))
     == Lit(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#154#0#0, a#154#1#0)));

// Constructor injectivity
axiom (forall a#155#0#0: int, a#155#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWritesStep(a#155#0#0, a#155#1#0) } 
  AsyncDisk.InternalStep.id(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#155#0#0, a#155#1#0))
     == a#155#0#0);

function AsyncDisk.InternalStep.id_k(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#156#0#0: int, a#156#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWritesStep(a#156#0#0, a#156#1#0) } 
  AsyncDisk.InternalStep.id_k(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#156#0#0, a#156#1#0))
     == a#156#1#0);

// Constructor function declaration
function #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(int, int) : DatatypeType;

const unique ##AsyncDisk.InternalStep.HavocConflictingWriteReadStep: DtCtorId;

// Constructor identifier
axiom (forall a#157#0#0: int, a#157#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#157#0#0, a#157#1#0) } 
  DatatypeCtorId(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#157#0#0, a#157#1#0))
     == ##AsyncDisk.InternalStep.HavocConflictingWriteReadStep);

function AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d) } 
  AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.InternalStep.HavocConflictingWriteReadStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d) } 
  AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d)
     ==> (exists a#158#0#0: int, a#158#1#0: int :: 
      d == #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#158#0#0, a#158#1#0)));

// Constructor $Is
axiom (forall a#159#0#0: int, a#159#1#0: int :: 
  { $Is(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#159#0#0, a#159#1#0), 
      Tclass.AsyncDisk.InternalStep()) } 
  $Is(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#159#0#0, a#159#1#0), 
      Tclass.AsyncDisk.InternalStep())
     <==> $Is(a#159#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#159#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#160#0#0: int, a#160#1#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#160#0#0, a#160#1#0), 
      Tclass.AsyncDisk.InternalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#160#0#0, a#160#1#0), 
        Tclass.AsyncDisk.InternalStep(), 
        $h)
       <==> $IsAlloc(a#160#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#160#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id_k(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id_k(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#161#0#0: int, a#161#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(LitInt(a#161#0#0), LitInt(a#161#1#0)) } 
  #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(LitInt(a#161#0#0), LitInt(a#161#1#0))
     == Lit(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#161#0#0, a#161#1#0)));

// Constructor injectivity
axiom (forall a#162#0#0: int, a#162#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#162#0#0, a#162#1#0) } 
  AsyncDisk.InternalStep.id(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#162#0#0, a#162#1#0))
     == a#162#0#0);

// Constructor injectivity
axiom (forall a#163#0#0: int, a#163#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#163#0#0, a#163#1#0) } 
  AsyncDisk.InternalStep.id_k(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#163#0#0, a#163#1#0))
     == a#163#1#0);

// Depth-one case-split function
function $IsA#AsyncDisk.InternalStep(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.InternalStep(d) } 
  $IsA#AsyncDisk.InternalStep(d)
     ==> AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
       || AsyncDisk.InternalStep.ProcessWriteStep_q(d)
       || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
       || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d), $Is(d, Tclass.AsyncDisk.InternalStep()) } 
    { AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d), $Is(d, Tclass.AsyncDisk.InternalStep()) } 
    { AsyncDisk.InternalStep.ProcessWriteStep_q(d), $Is(d, Tclass.AsyncDisk.InternalStep()) } 
    { AsyncDisk.InternalStep.ProcessReadFailureStep_q(d), $Is(d, Tclass.AsyncDisk.InternalStep()) } 
  $Is(d, Tclass.AsyncDisk.InternalStep())
     ==> AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
       || AsyncDisk.InternalStep.ProcessWriteStep_q(d)
       || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
       || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d));

// Datatype extensional equality declaration
function AsyncDisk.InternalStep#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.InternalStep.ProcessReadFailureStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.ProcessReadFailureStep_q(a) } 
    { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.ProcessReadFailureStep_q(b) } 
  AsyncDisk.InternalStep.ProcessReadFailureStep_q(a)
       && AsyncDisk.InternalStep.ProcessReadFailureStep_q(b)
     ==> (AsyncDisk.InternalStep#Equal(a, b)
       <==> AsyncDisk.InternalStep.id(a) == AsyncDisk.InternalStep.id(b)
         && Seq#Equal(AsyncDisk.InternalStep.fakeContents(a), AsyncDisk.InternalStep.fakeContents(b))));

// Datatype extensional equality definition: #AsyncDisk.InternalStep.ProcessWriteStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.ProcessWriteStep_q(a) } 
    { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.ProcessWriteStep_q(b) } 
  AsyncDisk.InternalStep.ProcessWriteStep_q(a)
       && AsyncDisk.InternalStep.ProcessWriteStep_q(b)
     ==> (AsyncDisk.InternalStep#Equal(a, b)
       <==> AsyncDisk.InternalStep.id(a) == AsyncDisk.InternalStep.id(b)));

// Datatype extensional equality definition: #AsyncDisk.InternalStep.HavocConflictingWritesStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.HavocConflictingWritesStep_q(a) } 
    { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.HavocConflictingWritesStep_q(b) } 
  AsyncDisk.InternalStep.HavocConflictingWritesStep_q(a)
       && AsyncDisk.InternalStep.HavocConflictingWritesStep_q(b)
     ==> (AsyncDisk.InternalStep#Equal(a, b)
       <==> AsyncDisk.InternalStep.id(a) == AsyncDisk.InternalStep.id(b)
         && AsyncDisk.InternalStep.id_k(a) == AsyncDisk.InternalStep.id_k(b)));

// Datatype extensional equality definition: #AsyncDisk.InternalStep.HavocConflictingWriteReadStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(a) } 
    { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(b) } 
  AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(a)
       && AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(b)
     ==> (AsyncDisk.InternalStep#Equal(a, b)
       <==> AsyncDisk.InternalStep.id(a) == AsyncDisk.InternalStep.id(b)
         && AsyncDisk.InternalStep.id_k(a) == AsyncDisk.InternalStep.id_k(b)));

// Datatype extensionality axiom: AsyncDisk.InternalStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b) } 
  AsyncDisk.InternalStep#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.InternalStep: ClassName;

const unique class.AsyncDisk.__default: ClassName;

function Tclass.AsyncDisk.__default() : Ty;

// Tclass.AsyncDisk.__default Tag
axiom Tag(Tclass.AsyncDisk.__default()) == Tagclass.AsyncDisk.__default;

const unique Tagclass.AsyncDisk.__default: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.__default()) } 
  $IsBox(bx, Tclass.AsyncDisk.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.AsyncDisk.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.AsyncDisk.__default()) } 
  $Is($o, Tclass.AsyncDisk.__default())
     <==> $o == null || dtype($o) == Tclass.AsyncDisk.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.AsyncDisk.__default(), $h) } 
  $IsAlloc($o, Tclass.AsyncDisk.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for AsyncDisk._default.Init
function AsyncDisk.__default.Init(k#0: DatatypeType, s#0: DatatypeType) : bool;

function AsyncDisk.__default.Init#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for AsyncDisk.__default.Init
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { AsyncDisk.__default.Init(k#0, s#0) } 
    AsyncDisk.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables()))
       ==> true);

function AsyncDisk.__default.Init#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.Init
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { AsyncDisk.__default.Init#requires(k#0, s#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants()) && $Is(s#0, Tclass.AsyncDisk.Variables())
     ==> AsyncDisk.__default.Init#requires(k#0, s#0) == true);

// definition axiom for AsyncDisk.__default.Init(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { AsyncDisk.__default.Init(k#0, s#0) } 
    AsyncDisk.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables()))
       ==> AsyncDisk.Variables.Variables_q(s#0)
         && (Map#Equal(AsyncDisk.Variables.reqReads(s#0), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Equal(AsyncDisk.Variables.reqWrites(s#0), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Equal(AsyncDisk.Variables.respReads(s#0), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && AsyncDisk.__default.Init(k#0, s#0)
           == (
            Map#Equal(AsyncDisk.Variables.reqReads(s#0), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.reqWrites(s#0), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.respReads(s#0), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.respWrites(s#0), Map#Empty(): Map Box Box)));

// definition axiom for AsyncDisk.__default.Init for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.Init(Lit(k#0), Lit(s#0)) } 
    AsyncDisk.__default.Init#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables()))
       ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
         && (Map#Equal(AsyncDisk.Variables.reqReads(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Equal(AsyncDisk.Variables.reqWrites(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Equal(AsyncDisk.Variables.respReads(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && AsyncDisk.__default.Init(Lit(k#0), Lit(s#0))
           == (
            Map#Equal(AsyncDisk.Variables.reqReads(Lit(s#0)), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.reqWrites(Lit(s#0)), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.respReads(Lit(s#0)), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.respWrites(Lit(s#0)), Map#Empty(): Map Box Box)));

// function declaration for AsyncDisk._default.RecvRead
function AsyncDisk.__default.RecvRead(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.RecvRead#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.RecvRead
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvRead(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvRead#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.RecvRead#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.RecvRead
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.RecvRead#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.RecvRead#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.RecvRead(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvRead(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvRead#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.ReqReadOp_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqReads#0#0 := Map#Build(AsyncDisk.Variables.reqReads(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqRead(dop#0))); 
                  #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.RecvRead(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.ReqReadOp_q(dop#0)
             && !Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqReads#0#0 := Map#Build(AsyncDisk.Variables.reqReads(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqRead(dop#0))); 
                  #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.RecvRead for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.RecvRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.RecvRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.ReqReadOp_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.respReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqReads#0#1 := Map#Build(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqRead(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.RecvRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.ReqReadOp_q(Lit(dop#0))
             && !Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.respReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqReads#0#1 := Map#Build(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqRead(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.RecvWrite
function AsyncDisk.__default.RecvWrite(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.RecvWrite#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.RecvWrite
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvWrite(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvWrite#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.RecvWrite#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.RecvWrite
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.RecvWrite#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.RecvWrite#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.RecvWrite(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvWrite(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvWrite#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.ReqWriteOp_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqWrites#0#0 := Map#Build(AsyncDisk.Variables.reqWrites(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqWrite(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    dt_update#reqWrites#0#0, 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.RecvWrite(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.ReqWriteOp_q(dop#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqWrites#0#0 := Map#Build(AsyncDisk.Variables.reqWrites(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqWrite(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    dt_update#reqWrites#0#0, 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.RecvWrite for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.RecvWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.RecvWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.ReqWriteOp_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqWrite(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    dt_update#reqWrites#0#1, 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.RecvWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.ReqWriteOp_q(Lit(dop#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqWrite(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    dt_update#reqWrites#0#1, 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.RecvWrite2
function AsyncDisk.__default.RecvWrite2(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.RecvWrite2#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.RecvWrite2
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvWrite2(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvWrite2#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.RecvWrite2#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.RecvWrite2
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.RecvWrite2#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.RecvWrite2#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.RecvWrite2(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvWrite2(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvWrite2#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.ReqWrite2Op_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id1(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id1(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id2(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.DiskOp.id1(dop#0) != AsyncDisk.DiskOp.id2(dop#0)
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqWrites#0#0 := Map#Build(Map#Build(AsyncDisk.Variables.reqWrites(s#0), 
                        $Box(AsyncDisk.DiskOp.id1(dop#0)), 
                        $Box(AsyncDisk.DiskOp.reqWrite1(dop#0))), 
                      $Box(AsyncDisk.DiskOp.id2(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqWrite2(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    dt_update#reqWrites#0#0, 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.RecvWrite2(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.ReqWrite2Op_q(dop#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id1(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id1(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id2(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id2(dop#0))]
             && AsyncDisk.DiskOp.id1(dop#0) != AsyncDisk.DiskOp.id2(dop#0)
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqWrites#0#0 := Map#Build(Map#Build(AsyncDisk.Variables.reqWrites(s#0), 
                        $Box(AsyncDisk.DiskOp.id1(dop#0)), 
                        $Box(AsyncDisk.DiskOp.reqWrite1(dop#0))), 
                      $Box(AsyncDisk.DiskOp.id2(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqWrite2(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    dt_update#reqWrites#0#0, 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.RecvWrite2 for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.RecvWrite2(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.RecvWrite2#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.ReqWrite2Op_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id1(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id1(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id2(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (Lit(AsyncDisk.DiskOp.id1(Lit(dop#0)) != AsyncDisk.DiskOp.id2(Lit(dop#0)))
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqWrites#0#1 := Map#Build(Map#Build(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                        $Box(LitInt(AsyncDisk.DiskOp.id1(Lit(dop#0)))), 
                        $Box(Lit(AsyncDisk.DiskOp.reqWrite1(Lit(dop#0))))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id2(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqWrite2(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    dt_update#reqWrites#0#1, 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.RecvWrite2(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.ReqWrite2Op_q(Lit(dop#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id1(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id1(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id2(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id2(Lit(dop#0)))]
             && AsyncDisk.DiskOp.id1(Lit(dop#0)) != AsyncDisk.DiskOp.id2(Lit(dop#0))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqWrites#0#1 := Map#Build(Map#Build(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                        $Box(LitInt(AsyncDisk.DiskOp.id1(Lit(dop#0)))), 
                        $Box(Lit(AsyncDisk.DiskOp.reqWrite1(Lit(dop#0))))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id2(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqWrite2(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    dt_update#reqWrites#0#1, 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.AckRead
function AsyncDisk.__default.AckRead(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.AckRead#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.AckRead
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.AckRead(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.AckRead#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.AckRead#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.AckRead
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.AckRead#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.AckRead#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.AckRead(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.AckRead(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.AckRead#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.RespReadOp_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> $IsA#AsyncDisk.RespRead($Unbox(Map#Elements(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType)
             && $IsA#AsyncDisk.RespRead(AsyncDisk.DiskOp.respRead(dop#0))
             && AsyncDisk.Variables.Variables_q(s#0))
         && ($IsA#AsyncDisk.RespRead($Unbox(Map#Elements(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType)
             && $IsA#AsyncDisk.RespRead(AsyncDisk.DiskOp.respRead(dop#0))
             && AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.RespRead#Equal($Unbox(Map#Elements(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType, 
              AsyncDisk.DiskOp.respRead(dop#0))
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#respReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespRead(), 
                      StartFuel_Maps._default.MapRemove1, 
                      AsyncDisk.Variables.respReads(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    dt_update#respReads#0#0, 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.AsyncDisk.RespRead(), 
                  AsyncDisk.Variables.respReads(s#0), 
                  $Box(AsyncDisk.DiskOp.id(dop#0)))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.AckRead(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.RespReadOp_q(dop#0)
             && Map#Domain(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && AsyncDisk.RespRead#Equal($Unbox(Map#Elements(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType, 
              AsyncDisk.DiskOp.respRead(dop#0))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#respReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespRead(), 
                      StartFuel_Maps._default.MapRemove1, 
                      AsyncDisk.Variables.respReads(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    dt_update#respReads#0#0, 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.AckRead for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.AckRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.AckRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.RespReadOp_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.respReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#AsyncDisk.RespRead($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respReads(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType)
             && $IsA#AsyncDisk.RespRead(Lit(AsyncDisk.DiskOp.respRead(Lit(dop#0))))
             && AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && ($IsA#AsyncDisk.RespRead($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respReads(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType)
             && $IsA#AsyncDisk.RespRead(Lit(AsyncDisk.DiskOp.respRead(Lit(dop#0))))
             && AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.RespRead#Equal($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respReads(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType, 
              AsyncDisk.DiskOp.respRead(Lit(dop#0)))
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#respReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespRead(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    dt_update#respReads#0#1, 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.AsyncDisk.RespRead(), 
                  Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                  $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.AckRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.RespReadOp_q(Lit(dop#0))
             && Map#Domain(AsyncDisk.Variables.respReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && AsyncDisk.RespRead#Equal($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respReads(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType, 
              AsyncDisk.DiskOp.respRead(Lit(dop#0)))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#respReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespRead(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    dt_update#respReads#0#1, 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.AckWrite
function AsyncDisk.__default.AckWrite(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.AckWrite#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.AckWrite
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.AckWrite(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.AckWrite#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.AckWrite#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.AckWrite
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.AckWrite#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.AckWrite#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.AckWrite(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.AckWrite(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.AckWrite#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.RespWriteOp_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> $IsA#AsyncDisk.RespWrite($Unbox(Map#Elements(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType)
             && $IsA#AsyncDisk.RespWrite(AsyncDisk.DiskOp.respWrite(dop#0))
             && AsyncDisk.Variables.Variables_q(s#0))
         && ($IsA#AsyncDisk.RespWrite($Unbox(Map#Elements(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType)
             && $IsA#AsyncDisk.RespWrite(AsyncDisk.DiskOp.respWrite(dop#0))
             && AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.RespWrite#Equal($Unbox(Map#Elements(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType, 
              AsyncDisk.DiskOp.respWrite(dop#0))
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#respWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      AsyncDisk.Variables.respWrites(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    dt_update#respWrites#0#0, 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.AsyncDisk.RespWrite(), 
                  AsyncDisk.Variables.respWrites(s#0), 
                  $Box(AsyncDisk.DiskOp.id(dop#0)))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.AckWrite(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.RespWriteOp_q(dop#0)
             && Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && AsyncDisk.RespWrite#Equal($Unbox(Map#Elements(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType, 
              AsyncDisk.DiskOp.respWrite(dop#0))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#respWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      AsyncDisk.Variables.respWrites(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    dt_update#respWrites#0#0, 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.AckWrite for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.AckWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.AckWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.RespWriteOp_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#AsyncDisk.RespWrite($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType)
             && $IsA#AsyncDisk.RespWrite(Lit(AsyncDisk.DiskOp.respWrite(Lit(dop#0))))
             && AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && ($IsA#AsyncDisk.RespWrite($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType)
             && $IsA#AsyncDisk.RespWrite(Lit(AsyncDisk.DiskOp.respWrite(Lit(dop#0))))
             && AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.RespWrite#Equal($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType, 
              AsyncDisk.DiskOp.respWrite(Lit(dop#0)))
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#respWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    dt_update#respWrites#0#1, 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.AsyncDisk.RespWrite(), 
                  Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                  $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.AckWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.RespWriteOp_q(Lit(dop#0))
             && Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && AsyncDisk.RespWrite#Equal($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType, 
              AsyncDisk.DiskOp.respWrite(Lit(dop#0)))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#respWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    dt_update#respWrites#0#1, 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.Stutter
function AsyncDisk.__default.Stutter(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.Stutter#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.Stutter
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.Stutter(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.Stutter#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.Stutter
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.Stutter#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.Stutter#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.Stutter(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.Stutter(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> $IsA#AsyncDisk.Variables(s'#0) && $IsA#AsyncDisk.Variables(s#0))
         && AsyncDisk.__default.Stutter(k#0, s#0, s'#0, dop#0)
           == (AsyncDisk.DiskOp.NoDiskOp_q(dop#0) && AsyncDisk.Variables#Equal(s'#0, s#0)));

// definition axiom for AsyncDisk.__default.Stutter for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0)) && $IsA#AsyncDisk.Variables(Lit(s#0)))
         && AsyncDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (AsyncDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && AsyncDisk.Variables#Equal(s'#0, s#0)));

// function declaration for AsyncDisk._default.NextStep
function AsyncDisk.__default.NextStep(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

function AsyncDisk.__default.NextStep#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.NextStep
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0) } 
    AsyncDisk.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, step#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
           && $Is(step#0, Tclass.AsyncDisk.Step()))
       ==> true);

function AsyncDisk.__default.NextStep#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.NextStep
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    step#0: DatatypeType :: 
  { AsyncDisk.__default.NextStep#requires(k#0, s#0, s'#0, dop#0, step#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
       && $Is(step#0, Tclass.AsyncDisk.Step())
     ==> AsyncDisk.__default.NextStep#requires(k#0, s#0, s'#0, dop#0, step#0) == true);

// definition axiom for AsyncDisk.__default.NextStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0) } 
    AsyncDisk.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, step#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
           && $Is(step#0, Tclass.AsyncDisk.Step()))
       ==> (AsyncDisk.Step.RecvReadStep_q(step#0)
           ==> AsyncDisk.__default.RecvRead#canCall(k#0, s#0, s'#0, dop#0))
         && (!AsyncDisk.Step.RecvReadStep_q(step#0)
           ==> (AsyncDisk.Step.RecvWriteStep_q(step#0)
               ==> AsyncDisk.__default.RecvWrite#canCall(k#0, s#0, s'#0, dop#0))
             && (!AsyncDisk.Step.RecvWriteStep_q(step#0)
               ==> (AsyncDisk.Step.RecvWrite2Step_q(step#0)
                   ==> AsyncDisk.__default.RecvWrite2#canCall(k#0, s#0, s'#0, dop#0))
                 && (!AsyncDisk.Step.RecvWrite2Step_q(step#0)
                   ==> (AsyncDisk.Step.AckReadStep_q(step#0)
                       ==> AsyncDisk.__default.AckRead#canCall(k#0, s#0, s'#0, dop#0))
                     && (!AsyncDisk.Step.AckReadStep_q(step#0)
                       ==> (AsyncDisk.Step.AckWriteStep_q(step#0)
                           ==> AsyncDisk.__default.AckWrite#canCall(k#0, s#0, s'#0, dop#0))
                         && (!AsyncDisk.Step.AckWriteStep_q(step#0)
                           ==> AsyncDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0))))))
         && AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0)
           == (if AsyncDisk.Step.RecvReadStep_q(step#0)
             then AsyncDisk.__default.RecvRead(k#0, s#0, s'#0, dop#0)
             else (if AsyncDisk.Step.RecvWriteStep_q(step#0)
               then AsyncDisk.__default.RecvWrite(k#0, s#0, s'#0, dop#0)
               else (if AsyncDisk.Step.RecvWrite2Step_q(step#0)
                 then AsyncDisk.__default.RecvWrite2(k#0, s#0, s'#0, dop#0)
                 else (if AsyncDisk.Step.AckReadStep_q(step#0)
                   then AsyncDisk.__default.AckRead(k#0, s#0, s'#0, dop#0)
                   else (if AsyncDisk.Step.AckWriteStep_q(step#0)
                     then AsyncDisk.__default.AckWrite(k#0, s#0, s'#0, dop#0)
                     else AsyncDisk.__default.Stutter(k#0, s#0, s'#0, dop#0)))))));

// definition axiom for AsyncDisk.__default.NextStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      step#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(step#0)) } 
    AsyncDisk.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(step#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
           && $Is(step#0, Tclass.AsyncDisk.Step()))
       ==> (Lit(AsyncDisk.Step.RecvReadStep_q(Lit(step#0)))
           ==> AsyncDisk.__default.RecvRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && (!Lit(AsyncDisk.Step.RecvReadStep_q(Lit(step#0)))
           ==> (Lit(AsyncDisk.Step.RecvWriteStep_q(Lit(step#0)))
               ==> AsyncDisk.__default.RecvWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && (!Lit(AsyncDisk.Step.RecvWriteStep_q(Lit(step#0)))
               ==> (Lit(AsyncDisk.Step.RecvWrite2Step_q(Lit(step#0)))
                   ==> AsyncDisk.__default.RecvWrite2#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
                 && (!Lit(AsyncDisk.Step.RecvWrite2Step_q(Lit(step#0)))
                   ==> (Lit(AsyncDisk.Step.AckReadStep_q(Lit(step#0)))
                       ==> AsyncDisk.__default.AckRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
                     && (!Lit(AsyncDisk.Step.AckReadStep_q(Lit(step#0)))
                       ==> (Lit(AsyncDisk.Step.AckWriteStep_q(Lit(step#0)))
                           ==> AsyncDisk.__default.AckWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
                         && (!Lit(AsyncDisk.Step.AckWriteStep_q(Lit(step#0)))
                           ==> AsyncDisk.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))))))
         && AsyncDisk.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(step#0))
           == (if AsyncDisk.Step.RecvReadStep_q(Lit(step#0))
             then AsyncDisk.__default.RecvRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
             else (if AsyncDisk.Step.RecvWriteStep_q(Lit(step#0))
               then AsyncDisk.__default.RecvWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
               else (if AsyncDisk.Step.RecvWrite2Step_q(Lit(step#0))
                 then AsyncDisk.__default.RecvWrite2(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
                 else (if AsyncDisk.Step.AckReadStep_q(Lit(step#0))
                   then AsyncDisk.__default.AckRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
                   else (if AsyncDisk.Step.AckWriteStep_q(Lit(step#0))
                     then AsyncDisk.__default.AckWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
                     else AsyncDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))))))));

// function declaration for AsyncDisk._default.Next
function AsyncDisk.__default.Next(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.Next#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.Next
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.Next(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.Next#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.Next#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.Next
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.Next#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.Next#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.Next(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.Next(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.Next#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (forall step#0: DatatypeType :: 
          { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0) } 
          $Is(step#0, Tclass.AsyncDisk.Step())
             ==> AsyncDisk.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, step#0))
         && AsyncDisk.__default.Next(k#0, s#0, s'#0, dop#0)
           == (exists step#0: DatatypeType :: 
            { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0) } 
            $Is(step#0, Tclass.AsyncDisk.Step())
               && AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0)));

// definition axiom for AsyncDisk.__default.Next for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.Next#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (forall step#1: DatatypeType :: 
          { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#1) } 
          $Is(step#1, Tclass.AsyncDisk.Step())
             ==> AsyncDisk.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), step#1))
         && AsyncDisk.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (exists step#1: DatatypeType :: 
            { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#1) } 
            $Is(step#1, Tclass.AsyncDisk.Step())
               && AsyncDisk.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), step#1)));

// function declaration for AsyncDisk._default.ChecksumChecksOut
function AsyncDisk.__default.ChecksumChecksOut($ly: LayerType, s#0: Seq Box) : bool;

function AsyncDisk.__default.ChecksumChecksOut#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { AsyncDisk.__default.ChecksumChecksOut($LS($ly), s#0) } 
  AsyncDisk.__default.ChecksumChecksOut($LS($ly), s#0)
     == AsyncDisk.__default.ChecksumChecksOut($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { AsyncDisk.__default.ChecksumChecksOut(AsFuelBottom($ly), s#0) } 
  AsyncDisk.__default.ChecksumChecksOut($ly, s#0)
     == AsyncDisk.__default.ChecksumChecksOut($LZ, s#0));

// consequence axiom for AsyncDisk.__default.ChecksumChecksOut
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { AsyncDisk.__default.ChecksumChecksOut($ly, s#0) } 
    AsyncDisk.__default.ChecksumChecksOut#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function AsyncDisk.__default.ChecksumChecksOut#requires(LayerType, Seq Box) : bool;

// #requires axiom for AsyncDisk.__default.ChecksumChecksOut
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { AsyncDisk.__default.ChecksumChecksOut#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.ChecksumChecksOut#requires($ly, s#0) == true);

// definition axiom for AsyncDisk.__default.ChecksumChecksOut(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { AsyncDisk.__default.ChecksumChecksOut($LS($ly), s#0) } 
    AsyncDisk.__default.ChecksumChecksOut#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(s#0) >= LitInt(32)
           ==> Crypto.__default.Crc32C#canCall(Seq#Drop(s#0, LitInt(32))))
         && AsyncDisk.__default.ChecksumChecksOut($LS($ly), s#0)
           == (Seq#Length(s#0) >= LitInt(32)
             && Seq#Equal(Seq#Drop(Seq#Take(s#0, LitInt(32)), LitInt(0)), 
              Crypto.__default.Crc32C(Seq#Drop(s#0, LitInt(32))))));

// definition axiom for AsyncDisk.__default.ChecksumChecksOut for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { AsyncDisk.__default.ChecksumChecksOut($LS($ly), Lit(s#0)) } 
    AsyncDisk.__default.ChecksumChecksOut#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(Lit(s#0)) >= LitInt(32)
           ==> Crypto.__default.Crc32C#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(32)))))
         && AsyncDisk.__default.ChecksumChecksOut($LS($ly), Lit(s#0))
           == (Seq#Length(Lit(s#0)) >= LitInt(32)
             && Seq#Equal(Seq#Drop(Seq#Take(Lit(s#0), LitInt(32)), LitInt(0)), 
              Crypto.__default.Crc32C(Lit(Seq#Drop(Lit(s#0), LitInt(32)))))));

// function declaration for AsyncDisk._default.ChecksumsCheckOutForSlice
function AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int) : bool;

function AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int) : bool;

// consequence axiom for AsyncDisk.__default.ChecksumsCheckOutForSlice
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int :: 
    { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0) } 
    AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(realContents#0, fakeContents#0, i#0, j#0)
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(realContents#0) == Seq#Length(fakeContents#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= j#0
           && j#0 <= Seq#Length(realContents#0))
       ==> true);

function AsyncDisk.__default.ChecksumsCheckOutForSlice#requires(Seq Box, Seq Box, int, int) : bool;

// #requires axiom for AsyncDisk.__default.ChecksumsCheckOutForSlice
axiom (forall realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int :: 
  { AsyncDisk.__default.ChecksumsCheckOutForSlice#requires(realContents#0, fakeContents#0, i#0, j#0) } 
  $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.ChecksumsCheckOutForSlice#requires(realContents#0, fakeContents#0, i#0, j#0)
       == (Seq#Length(realContents#0) == Seq#Length(fakeContents#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= j#0
         && j#0 <= Seq#Length(realContents#0)));

// definition axiom for AsyncDisk.__default.ChecksumsCheckOutForSlice(revealed)
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int :: 
    { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0) } 
    AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(realContents#0, fakeContents#0, i#0, j#0)
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(realContents#0) == Seq#Length(fakeContents#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= j#0
           && j#0 <= Seq#Length(realContents#0))
       ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Seq#Drop(Seq#Take(realContents#0, j#0), i#0))
         && (AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
            Seq#Drop(Seq#Take(realContents#0, j#0), i#0))
           ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Seq#Drop(Seq#Take(fakeContents#0, j#0), i#0)))
         && AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0)
           == (AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
                Seq#Drop(Seq#Take(realContents#0, j#0), i#0))
               && AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
                Seq#Drop(Seq#Take(fakeContents#0, j#0), i#0))
             ==> Seq#Equal(Seq#Drop(Seq#Take(realContents#0, j#0), i#0), 
              Seq#Drop(Seq#Take(fakeContents#0, j#0), i#0))));

// definition axiom for AsyncDisk.__default.ChecksumsCheckOutForSlice for all literals(revealed)
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int :: 
    {:weight 3} { AsyncDisk.__default.ChecksumsCheckOutForSlice(Lit(realContents#0), Lit(fakeContents#0), LitInt(i#0), LitInt(j#0)) } 
    AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(Lit(realContents#0), Lit(fakeContents#0), LitInt(i#0), LitInt(j#0))
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(Lit(realContents#0)) == Seq#Length(Lit(fakeContents#0))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(j#0)
           && LitInt(j#0) <= Seq#Length(Lit(realContents#0)))
       ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Lit(Seq#Drop(Seq#Take(Lit(realContents#0), LitInt(j#0)), LitInt(i#0))))
         && (AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
            Lit(Seq#Drop(Seq#Take(Lit(realContents#0), LitInt(j#0)), LitInt(i#0))))
           ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Lit(Seq#Drop(Seq#Take(Lit(fakeContents#0), LitInt(j#0)), LitInt(i#0)))))
         && AsyncDisk.__default.ChecksumsCheckOutForSlice(Lit(realContents#0), Lit(fakeContents#0), LitInt(i#0), LitInt(j#0))
           == (AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
                Lit(Seq#Drop(Seq#Take(Lit(realContents#0), LitInt(j#0)), LitInt(i#0))))
               && AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
                Lit(Seq#Drop(Seq#Take(Lit(fakeContents#0), LitInt(j#0)), LitInt(i#0))))
             ==> Seq#Equal(Seq#Drop(Seq#Take(Lit(realContents#0), LitInt(j#0)), LitInt(i#0)), 
              Seq#Drop(Seq#Take(Lit(fakeContents#0), LitInt(j#0)), LitInt(i#0)))));

// function declaration for AsyncDisk._default.AllChecksumsCheckOut
function AsyncDisk.__default.AllChecksumsCheckOut(realContents#0: Seq Box, fakeContents#0: Seq Box) : bool;

function AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0: Seq Box, fakeContents#0: Seq Box) : bool;

// consequence axiom for AsyncDisk.__default.AllChecksumsCheckOut
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box :: 
    { AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0) } 
    AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0, fakeContents#0)
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(realContents#0) == Seq#Length(fakeContents#0))
       ==> true);

function AsyncDisk.__default.AllChecksumsCheckOut#requires(Seq Box, Seq Box) : bool;

// #requires axiom for AsyncDisk.__default.AllChecksumsCheckOut
axiom (forall realContents#0: Seq Box, fakeContents#0: Seq Box :: 
  { AsyncDisk.__default.AllChecksumsCheckOut#requires(realContents#0, fakeContents#0) } 
  $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.AllChecksumsCheckOut#requires(realContents#0, fakeContents#0)
       == 
      (Seq#Length(realContents#0)
       == Seq#Length(fakeContents#0)));

// definition axiom for AsyncDisk.__default.AllChecksumsCheckOut(revealed)
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box :: 
    { AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0) } 
    AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0, fakeContents#0)
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(realContents#0) == Seq#Length(fakeContents#0))
       ==> (forall i#0: int, j#0: int :: 
          { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0) } 
          LitInt(0) <= i#0 && i#0 <= j#0 && j#0 <= Seq#Length(realContents#0)
             ==> AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(realContents#0, fakeContents#0, i#0, j#0))
         && AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0)
           == (forall i#0: int, j#0: int :: 
            { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0) } 
            LitInt(0) <= i#0 && i#0 <= j#0 && j#0 <= Seq#Length(realContents#0)
               ==> AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0)));

// definition axiom for AsyncDisk.__default.AllChecksumsCheckOut for all literals(revealed)
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box :: 
    {:weight 3} { AsyncDisk.__default.AllChecksumsCheckOut(Lit(realContents#0), Lit(fakeContents#0)) } 
    AsyncDisk.__default.AllChecksumsCheckOut#canCall(Lit(realContents#0), Lit(fakeContents#0))
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(realContents#0)) == Seq#Length(Lit(fakeContents#0)))
       ==> (forall i#1: int, j#1: int :: 
          { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#1, j#1) } 
          LitInt(0) <= i#1 && i#1 <= j#1 && j#1 <= Seq#Length(Lit(realContents#0))
             ==> AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(Lit(realContents#0), Lit(fakeContents#0), i#1, j#1))
         && AsyncDisk.__default.AllChecksumsCheckOut(Lit(realContents#0), Lit(fakeContents#0))
           == (forall i#1: int, j#1: int :: 
            { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#1, j#1) } 
            LitInt(0) <= i#1 && i#1 <= j#1 && j#1 <= Seq#Length(Lit(realContents#0))
               ==> AsyncDisk.__default.ChecksumsCheckOutForSlice(Lit(realContents#0), Lit(fakeContents#0), i#1, j#1)));

// function declaration for AsyncDisk._default.ProcessReadFailure
function AsyncDisk.__default.ProcessReadFailure(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    id#0: int, 
    fakeContents#0: Seq Box)
   : bool;

function AsyncDisk.__default.ProcessReadFailure#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    id#0: int, 
    fakeContents#0: Seq Box)
   : bool;

// consequence axiom for AsyncDisk.__default.ProcessReadFailure
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      id#0: int, 
      fakeContents#0: Seq Box :: 
    { AsyncDisk.__default.ProcessReadFailure(k#0, s#0, s'#0, id#0, fakeContents#0) } 
    AsyncDisk.__default.ProcessReadFailure#canCall(k#0, s#0, s'#0, id#0, fakeContents#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function AsyncDisk.__default.ProcessReadFailure#requires(DatatypeType, DatatypeType, DatatypeType, int, Seq Box) : bool;

// #requires axiom for AsyncDisk.__default.ProcessReadFailure
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    id#0: int, 
    fakeContents#0: Seq Box :: 
  { AsyncDisk.__default.ProcessReadFailure#requires(k#0, s#0, s'#0, id#0, fakeContents#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
       && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.ProcessReadFailure#requires(k#0, s#0, s'#0, id#0, fakeContents#0)
       == true);

// definition axiom for AsyncDisk.__default.ProcessReadFailure(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      id#0: int, 
      fakeContents#0: Seq Box :: 
    { AsyncDisk.__default.ProcessReadFailure(k#0, s#0, s'#0, id#0, fakeContents#0) } 
    AsyncDisk.__default.ProcessReadFailure#canCall(k#0, s#0, s'#0, id#0, fakeContents#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte())))
       ==> AsyncDisk.Variables.Variables_q(s#0)
         && (Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0)
             && (var req#0 := $Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id#0)]): DatatypeType; 
              AsyncDisk.ReqRead.ReqRead_q(req#0)
                 && (LitInt(0) <= AsyncDisk.ReqRead.addr(req#0)
                   ==> AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0))
                 && (AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.addr(req#0)
                       <= AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)
                   ==> AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.Variables.Variables_q(s#0))
                 && (AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.Variables.Variables_q(s#0)
                     && AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)
                       <= Seq#Length(AsyncDisk.Variables.contents(s#0))
                   ==> AsyncDisk.Variables.Variables_q(s#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && (var realContents#0 := Seq#Drop(Seq#Take(AsyncDisk.Variables.contents(s#0), 
                            AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)), 
                          AsyncDisk.ReqRead.addr(req#0)); 
                      (!Seq#Equal(fakeContents#0, realContents#0)
                           ==> AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0, fakeContents#0))
                         && (AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0, fakeContents#0)
                             && AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0)
                           ==> $IsA#AsyncDisk.Variables(s'#0)
                             && $IsA#AsyncDisk.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                    (var dt_update#reqReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                          Tclass.AsyncDisk.ReqRead(), 
                                          StartFuel_Maps._default.MapRemove1, 
                                          AsyncDisk.Variables.reqReads(s#0), 
                                          $Box(id#0)); 
                                      #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                                        AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                                        AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                        AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                        AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                                (var dt_update#respReads#0#0 := Map#Build(AsyncDisk.Variables.respReads(s#0), 
                                      $Box(id#0), 
                                      $Box(#AsyncDisk.RespRead.RespRead(AsyncDisk.ReqRead.addr(req#0), fakeContents#0))); 
                                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                                    AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                                    dt_update#respReads#0#0, 
                                    AsyncDisk.Variables.respWrites(dt_update_tmp#1#0), 
                                    AsyncDisk.Variables.contents(dt_update_tmp#1#0)))))
                             && 
                            (var dt_update_tmp#0#0 := s#0; 
                              AsyncDisk.Variables.Variables_q(s#0)
                                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqRead(), 
                                  AsyncDisk.Variables.reqReads(s#0), 
                                  $Box(id#0))
                                 && 
                                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0))
                             && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                  (var dt_update#reqReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                        Tclass.AsyncDisk.ReqRead(), 
                                        StartFuel_Maps._default.MapRemove1, 
                                        AsyncDisk.Variables.reqReads(s#0), 
                                        $Box(id#0)); 
                                    #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                                      AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                                      AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                      AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                      AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                              AsyncDisk.Variables.Variables_q(s#0)
                                 && AsyncDisk.ReqRead.ReqRead_q(req#0)
                                 && 
                                AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)))))))
         && AsyncDisk.__default.ProcessReadFailure(k#0, s#0, s'#0, id#0, fakeContents#0)
           == (Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(id#0)]
             && (var req#0 := $Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id#0)]): DatatypeType; 
              LitInt(0) <= AsyncDisk.ReqRead.addr(req#0)
                 && AsyncDisk.ReqRead.addr(req#0)
                   <= AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)
                 && AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)
                   <= Seq#Length(AsyncDisk.Variables.contents(s#0))
                 && (var realContents#0 := Seq#Drop(Seq#Take(AsyncDisk.Variables.contents(s#0), 
                        AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)), 
                      AsyncDisk.ReqRead.addr(req#0)); 
                  Seq#Length(fakeContents#0) == Seq#Length(realContents#0)
                     && !Seq#Equal(fakeContents#0, realContents#0)
                     && AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0)
                     && AsyncDisk.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#reqReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqRead(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  AsyncDisk.Variables.reqReads(s#0), 
                                  $Box(id#0)); 
                              #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                                AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                        (var dt_update#respReads#0#0 := Map#Build(AsyncDisk.Variables.respReads(s#0), 
                              $Box(id#0), 
                              $Box(#AsyncDisk.RespRead.RespRead(AsyncDisk.ReqRead.addr(req#0), fakeContents#0))); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                            dt_update#respReads#0#0, 
                            AsyncDisk.Variables.respWrites(dt_update_tmp#1#0), 
                            AsyncDisk.Variables.contents(dt_update_tmp#1#0)))))))));

// definition axiom for AsyncDisk.__default.ProcessReadFailure for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      id#0: int, 
      fakeContents#0: Seq Box :: 
    {:weight 3} { AsyncDisk.__default.ProcessReadFailure(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), Lit(fakeContents#0)) } 
    AsyncDisk.__default.ProcessReadFailure#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), Lit(fakeContents#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte())))
       ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
         && (Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
             && (var req#1 := $Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType; 
              AsyncDisk.ReqRead.ReqRead_q(req#1)
                 && (LitInt(0) <= AsyncDisk.ReqRead.addr(req#1)
                   ==> AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1))
                 && (AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.addr(req#1)
                       <= AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)
                   ==> AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.Variables.Variables_q(Lit(s#0)))
                 && (AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.Variables.Variables_q(Lit(s#0))
                     && AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)
                       <= Seq#Length(Lit(AsyncDisk.Variables.contents(Lit(s#0))))
                   ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && (var realContents#1 := Seq#Drop(Seq#Take(Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                            AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)), 
                          AsyncDisk.ReqRead.addr(req#1)); 
                      (!Seq#Equal(fakeContents#0, realContents#1)
                           ==> AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#1, Lit(fakeContents#0)))
                         && (AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#1, Lit(fakeContents#0))
                             && AsyncDisk.__default.AllChecksumsCheckOut(realContents#1, Lit(fakeContents#0))
                           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
                             && $IsA#AsyncDisk.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                    (var dt_update#reqReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                          Tclass.AsyncDisk.ReqRead(), 
                                          StartFuel_Maps._default.MapRemove1, 
                                          Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                                          $Box(LitInt(id#0))); 
                                      #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                                        Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                                        Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                        Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                        Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                                (var dt_update#respReads#0#1 := Map#Build(Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                                      $Box(LitInt(id#0)), 
                                      $Box(#AsyncDisk.RespRead.RespRead(AsyncDisk.ReqRead.addr(req#1), Lit(fakeContents#0)))); 
                                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                                    AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                                    dt_update#respReads#0#1, 
                                    AsyncDisk.Variables.respWrites(dt_update_tmp#1#1), 
                                    AsyncDisk.Variables.contents(dt_update_tmp#1#1)))))
                             && 
                            (var dt_update_tmp#0#1 := Lit(s#0); 
                              AsyncDisk.Variables.Variables_q(Lit(s#0))
                                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqRead(), 
                                  Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                                  $Box(LitInt(id#0)))
                                 && 
                                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1))
                             && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                  (var dt_update#reqReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                        Tclass.AsyncDisk.ReqRead(), 
                                        StartFuel_Maps._default.MapRemove1, 
                                        Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                                        $Box(LitInt(id#0))); 
                                    #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                                      Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                                      Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                      Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                      Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                              AsyncDisk.Variables.Variables_q(Lit(s#0))
                                 && AsyncDisk.ReqRead.ReqRead_q(req#1)
                                 && 
                                AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)))))))
         && AsyncDisk.__default.ProcessReadFailure(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), Lit(fakeContents#0))
           == (Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(id#0)]
             && (var req#1 := $Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType; 
              LitInt(0) <= AsyncDisk.ReqRead.addr(req#1)
                 && AsyncDisk.ReqRead.addr(req#1)
                   <= AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)
                 && AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)
                   <= Seq#Length(Lit(AsyncDisk.Variables.contents(Lit(s#0))))
                 && (var realContents#1 := Seq#Drop(Seq#Take(Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                        AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)), 
                      AsyncDisk.ReqRead.addr(req#1)); 
                  Seq#Length(Lit(fakeContents#0)) == Seq#Length(realContents#1)
                     && !Seq#Equal(fakeContents#0, realContents#1)
                     && AsyncDisk.__default.AllChecksumsCheckOut(realContents#1, Lit(fakeContents#0))
                     && AsyncDisk.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#reqReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqRead(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                                  $Box(LitInt(id#0))); 
                              #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                                Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                        (var dt_update#respReads#0#1 := Map#Build(Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                              $Box(LitInt(id#0)), 
                              $Box(#AsyncDisk.RespRead.RespRead(AsyncDisk.ReqRead.addr(req#1), Lit(fakeContents#0)))); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                            dt_update#respReads#0#1, 
                            AsyncDisk.Variables.respWrites(dt_update_tmp#1#1), 
                            AsyncDisk.Variables.contents(dt_update_tmp#1#1)))))))));

// function declaration for AsyncDisk._default.splice
function AsyncDisk.__default.splice($ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box) : Seq Box;

function AsyncDisk.__default.splice#canCall(bytes#0: Seq Box, start#0: int, ins#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
  { AsyncDisk.__default.splice($LS($ly), bytes#0, start#0, ins#0) } 
  AsyncDisk.__default.splice($LS($ly), bytes#0, start#0, ins#0)
     == AsyncDisk.__default.splice($ly, bytes#0, start#0, ins#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
  { AsyncDisk.__default.splice(AsFuelBottom($ly), bytes#0, start#0, ins#0) } 
  AsyncDisk.__default.splice($ly, bytes#0, start#0, ins#0)
     == AsyncDisk.__default.splice($LZ, bytes#0, start#0, ins#0));

// consequence axiom for AsyncDisk.__default.splice
axiom true
   ==> (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
    { AsyncDisk.__default.splice($ly, bytes#0, start#0, ins#0) } 
    AsyncDisk.__default.splice#canCall(bytes#0, start#0, ins#0)
         || (
          $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= start#0
           && start#0 + Seq#Length(ins#0) <= Seq#Length(bytes#0))
       ==> $Is(AsyncDisk.__default.splice($ly, bytes#0, start#0, ins#0), 
        TSeq(Tclass.NativeTypes.byte())));

function AsyncDisk.__default.splice#requires(LayerType, Seq Box, int, Seq Box) : bool;

// #requires axiom for AsyncDisk.__default.splice
axiom (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
  { AsyncDisk.__default.splice#requires($ly, bytes#0, start#0, ins#0) } 
  $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.splice#requires($ly, bytes#0, start#0, ins#0)
       == (LitInt(0) <= start#0 && start#0 + Seq#Length(ins#0) <= Seq#Length(bytes#0)));

// definition axiom for AsyncDisk.__default.splice(revealed)
axiom true
   ==> (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
    { AsyncDisk.__default.splice($LS($ly), bytes#0, start#0, ins#0) } 
    AsyncDisk.__default.splice#canCall(bytes#0, start#0, ins#0)
         || (
          $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= start#0
           && start#0 + Seq#Length(ins#0) <= Seq#Length(bytes#0))
       ==> AsyncDisk.__default.splice($LS($ly), bytes#0, start#0, ins#0)
         == Seq#Append(Seq#Append(Seq#Take(bytes#0, start#0), ins#0), 
          Seq#Drop(bytes#0, start#0 + Seq#Length(ins#0))));

// definition axiom for AsyncDisk.__default.splice for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
    {:weight 3} { AsyncDisk.__default.splice($LS($ly), Lit(bytes#0), LitInt(start#0), Lit(ins#0)) } 
    AsyncDisk.__default.splice#canCall(Lit(bytes#0), LitInt(start#0), Lit(ins#0))
         || (
          $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 + Seq#Length(Lit(ins#0)) <= Seq#Length(Lit(bytes#0)))
       ==> AsyncDisk.__default.splice($LS($ly), Lit(bytes#0), LitInt(start#0), Lit(ins#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(bytes#0), LitInt(start#0)), ins#0), 
          Seq#Drop(Lit(bytes#0), start#0 + Seq#Length(Lit(ins#0)))));

// function declaration for AsyncDisk._default.ProcessWrite
function AsyncDisk.__default.ProcessWrite(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int) : bool;

function AsyncDisk.__default.ProcessWrite#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int) : bool;

// consequence axiom for AsyncDisk.__default.ProcessWrite
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int :: 
    { AsyncDisk.__default.ProcessWrite(k#0, s#0, s'#0, id#0) } 
    AsyncDisk.__default.ProcessWrite#canCall(k#0, s#0, s'#0, id#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> true);

function AsyncDisk.__default.ProcessWrite#requires(DatatypeType, DatatypeType, DatatypeType, int) : bool;

// #requires axiom for AsyncDisk.__default.ProcessWrite
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int :: 
  { AsyncDisk.__default.ProcessWrite#requires(k#0, s#0, s'#0, id#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
     ==> AsyncDisk.__default.ProcessWrite#requires(k#0, s#0, s'#0, id#0) == true);

// definition axiom for AsyncDisk.__default.ProcessWrite(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int :: 
    { AsyncDisk.__default.ProcessWrite(k#0, s#0, s'#0, id#0) } 
    AsyncDisk.__default.ProcessWrite#canCall(k#0, s#0, s'#0, id#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> AsyncDisk.Variables.Variables_q(s#0)
         && (Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0)
             && (var req#0 := $Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType; 
              AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                 && (LitInt(0) <= AsyncDisk.ReqWrite.addr(req#0)
                   ==> AsyncDisk.ReqWrite.ReqWrite_q(req#0))
                 && (AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && Seq#Length(AsyncDisk.ReqWrite.bytes(req#0)) < 18446744073709551616
                   ==> AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && AsyncDisk.Variables.Variables_q(s#0))
                 && (AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && AsyncDisk.Variables.Variables_q(s#0)
                     && AsyncDisk.ReqWrite.addr(req#0) + Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))
                       <= Seq#Length(AsyncDisk.Variables.contents(s#0))
                   ==> $IsA#AsyncDisk.Variables(s'#0)
                     && $IsA#AsyncDisk.Variables((var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                (var dt_update#reqWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                      Tclass.AsyncDisk.ReqWrite(), 
                                      StartFuel_Maps._default.MapRemove1, 
                                      AsyncDisk.Variables.reqWrites(s#0), 
                                      $Box(id#0)); 
                                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                                    dt_update#reqWrites#0#0, 
                                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                            (var dt_update#respWrites#0#0 := Map#Build(AsyncDisk.Variables.respWrites(s#0), 
                                  $Box(id#0), 
                                  $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#0), Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))))); 
                              #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                                AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                                AsyncDisk.Variables.respReads(dt_update_tmp#1#0), 
                                dt_update#respWrites#0#0, 
                                AsyncDisk.Variables.contents(dt_update_tmp#1#0)))); 
                        (var dt_update#contents#0#0 := AsyncDisk.__default.splice(StartFuel_AsyncDisk._default.splice, 
                              AsyncDisk.Variables.contents(s#0), 
                              AsyncDisk.ReqWrite.addr(req#0), 
                              AsyncDisk.ReqWrite.bytes(req#0)); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#2#0), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#2#0), 
                            AsyncDisk.Variables.respReads(dt_update_tmp#2#0), 
                            AsyncDisk.Variables.respWrites(dt_update_tmp#2#0), 
                            dt_update#contents#0#0))))
                     && 
                    (var dt_update_tmp#0#0 := s#0; 
                      AsyncDisk.Variables.Variables_q(s#0)
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.AsyncDisk.ReqWrite(), 
                          AsyncDisk.Variables.reqWrites(s#0), 
                          $Box(id#0))
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0))
                     && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                          (var dt_update#reqWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                Tclass.AsyncDisk.ReqWrite(), 
                                StartFuel_Maps._default.MapRemove1, 
                                AsyncDisk.Variables.reqWrites(s#0), 
                                $Box(id#0)); 
                            #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                              dt_update#reqWrites#0#0, 
                              AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                              AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                              AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                      AsyncDisk.Variables.Variables_q(s#0)
                         && 
                        AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0))
                     && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                              (var dt_update#reqWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                    Tclass.AsyncDisk.ReqWrite(), 
                                    StartFuel_Maps._default.MapRemove1, 
                                    AsyncDisk.Variables.reqWrites(s#0), 
                                    $Box(id#0)); 
                                #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                                  dt_update#reqWrites#0#0, 
                                  AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                  AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                  AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                          (var dt_update#respWrites#0#0 := Map#Build(AsyncDisk.Variables.respWrites(s#0), 
                                $Box(id#0), 
                                $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#0), Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))))); 
                            #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                              AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                              AsyncDisk.Variables.respReads(dt_update_tmp#1#0), 
                              dt_update#respWrites#0#0, 
                              AsyncDisk.Variables.contents(dt_update_tmp#1#0)))); 
                      AsyncDisk.Variables.Variables_q(s#0)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                         && AsyncDisk.__default.splice#canCall(AsyncDisk.Variables.contents(s#0), 
                          AsyncDisk.ReqWrite.addr(req#0), 
                          AsyncDisk.ReqWrite.bytes(req#0))
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#2#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#0)))))
         && AsyncDisk.__default.ProcessWrite(k#0, s#0, s'#0, id#0)
           == (Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
             && (var req#0 := $Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType; 
              LitInt(0) <= AsyncDisk.ReqWrite.addr(req#0)
                 && Seq#Length(AsyncDisk.ReqWrite.bytes(req#0)) < 18446744073709551616
                 && AsyncDisk.ReqWrite.addr(req#0) + Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))
                   <= Seq#Length(AsyncDisk.Variables.contents(s#0))
                 && AsyncDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#reqWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqWrite(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  AsyncDisk.Variables.reqWrites(s#0), 
                                  $Box(id#0)); 
                              #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                                dt_update#reqWrites#0#0, 
                                AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                        (var dt_update#respWrites#0#0 := Map#Build(AsyncDisk.Variables.respWrites(s#0), 
                              $Box(id#0), 
                              $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#0), Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))))); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                            AsyncDisk.Variables.respReads(dt_update_tmp#1#0), 
                            dt_update#respWrites#0#0, 
                            AsyncDisk.Variables.contents(dt_update_tmp#1#0)))); 
                    (var dt_update#contents#0#0 := AsyncDisk.__default.splice(StartFuel_AsyncDisk._default.splice, 
                          AsyncDisk.Variables.contents(s#0), 
                          AsyncDisk.ReqWrite.addr(req#0), 
                          AsyncDisk.ReqWrite.bytes(req#0)); 
                      #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#2#0), 
                        AsyncDisk.Variables.reqWrites(dt_update_tmp#2#0), 
                        AsyncDisk.Variables.respReads(dt_update_tmp#2#0), 
                        AsyncDisk.Variables.respWrites(dt_update_tmp#2#0), 
                        dt_update#contents#0#0)))))));

// definition axiom for AsyncDisk.__default.ProcessWrite for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int :: 
    {:weight 3} { AsyncDisk.__default.ProcessWrite(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0)) } 
    AsyncDisk.__default.ProcessWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
         && (Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
             && (var req#1 := $Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType; 
              AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                 && (LitInt(0) <= AsyncDisk.ReqWrite.addr(req#1)
                   ==> AsyncDisk.ReqWrite.ReqWrite_q(req#1))
                 && (AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && Seq#Length(AsyncDisk.ReqWrite.bytes(req#1)) < 18446744073709551616
                   ==> AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && AsyncDisk.Variables.Variables_q(Lit(s#0)))
                 && (AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && AsyncDisk.Variables.Variables_q(Lit(s#0))
                     && AsyncDisk.ReqWrite.addr(req#1) + Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))
                       <= Seq#Length(Lit(AsyncDisk.Variables.contents(Lit(s#0))))
                   ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
                     && $IsA#AsyncDisk.Variables((var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                (var dt_update#reqWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                      Tclass.AsyncDisk.ReqWrite(), 
                                      StartFuel_Maps._default.MapRemove1, 
                                      Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                                      $Box(LitInt(id#0))); 
                                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                                    dt_update#reqWrites#0#1, 
                                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                            (var dt_update#respWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                                  $Box(LitInt(id#0)), 
                                  $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#1), Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))))); 
                              #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                                AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                                AsyncDisk.Variables.respReads(dt_update_tmp#1#1), 
                                dt_update#respWrites#0#1, 
                                AsyncDisk.Variables.contents(dt_update_tmp#1#1)))); 
                        (var dt_update#contents#0#1 := AsyncDisk.__default.splice(StartFuel_AsyncDisk._default.splice, 
                              Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                              AsyncDisk.ReqWrite.addr(req#1), 
                              AsyncDisk.ReqWrite.bytes(req#1)); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#2#1), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#2#1), 
                            AsyncDisk.Variables.respReads(dt_update_tmp#2#1), 
                            AsyncDisk.Variables.respWrites(dt_update_tmp#2#1), 
                            dt_update#contents#0#1))))
                     && 
                    (var dt_update_tmp#0#1 := Lit(s#0); 
                      AsyncDisk.Variables.Variables_q(Lit(s#0))
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.AsyncDisk.ReqWrite(), 
                          Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                          $Box(LitInt(id#0)))
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1))
                     && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                          (var dt_update#reqWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                Tclass.AsyncDisk.ReqWrite(), 
                                StartFuel_Maps._default.MapRemove1, 
                                Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                                $Box(LitInt(id#0))); 
                            #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                              dt_update#reqWrites#0#1, 
                              Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                              Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                              Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                      AsyncDisk.Variables.Variables_q(Lit(s#0))
                         && 
                        AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1))
                     && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                              (var dt_update#reqWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                    Tclass.AsyncDisk.ReqWrite(), 
                                    StartFuel_Maps._default.MapRemove1, 
                                    Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                                    $Box(LitInt(id#0))); 
                                #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                                  dt_update#reqWrites#0#1, 
                                  Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                  Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                  Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                          (var dt_update#respWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                                $Box(LitInt(id#0)), 
                                $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#1), Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))))); 
                            #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                              AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                              AsyncDisk.Variables.respReads(dt_update_tmp#1#1), 
                              dt_update#respWrites#0#1, 
                              AsyncDisk.Variables.contents(dt_update_tmp#1#1)))); 
                      AsyncDisk.Variables.Variables_q(Lit(s#0))
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                         && AsyncDisk.__default.splice#canCall(Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                          AsyncDisk.ReqWrite.addr(req#1), 
                          AsyncDisk.ReqWrite.bytes(req#1))
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#2#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#1)))))
         && AsyncDisk.__default.ProcessWrite(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0))
           == (Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
             && (var req#1 := $Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType; 
              LitInt(0) <= AsyncDisk.ReqWrite.addr(req#1)
                 && Seq#Length(AsyncDisk.ReqWrite.bytes(req#1)) < 18446744073709551616
                 && AsyncDisk.ReqWrite.addr(req#1) + Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))
                   <= Seq#Length(Lit(AsyncDisk.Variables.contents(Lit(s#0))))
                 && AsyncDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#reqWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqWrite(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                                  $Box(LitInt(id#0))); 
                              #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                                dt_update#reqWrites#0#1, 
                                Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                        (var dt_update#respWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                              $Box(LitInt(id#0)), 
                              $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#1), Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))))); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                            AsyncDisk.Variables.respReads(dt_update_tmp#1#1), 
                            dt_update#respWrites#0#1, 
                            AsyncDisk.Variables.contents(dt_update_tmp#1#1)))); 
                    (var dt_update#contents#0#1 := AsyncDisk.__default.splice(StartFuel_AsyncDisk._default.splice, 
                          Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                          AsyncDisk.ReqWrite.addr(req#1), 
                          AsyncDisk.ReqWrite.bytes(req#1)); 
                      #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#2#1), 
                        AsyncDisk.Variables.reqWrites(dt_update_tmp#2#1), 
                        AsyncDisk.Variables.respReads(dt_update_tmp#2#1), 
                        AsyncDisk.Variables.respWrites(dt_update_tmp#2#1), 
                        dt_update#contents#0#1)))))));

// function declaration for AsyncDisk._default.overlap
function AsyncDisk.__default.overlap(start#0: int, len#0: int, start'#0: int, len'#0: int) : bool;

function AsyncDisk.__default.overlap#canCall(start#0: int, len#0: int, start'#0: int, len'#0: int) : bool;

// consequence axiom for AsyncDisk.__default.overlap
axiom true
   ==> (forall start#0: int, len#0: int, start'#0: int, len'#0: int :: 
    { AsyncDisk.__default.overlap(start#0, len#0, start'#0, len'#0) } 
    true ==> true);

function AsyncDisk.__default.overlap#requires(int, int, int, int) : bool;

// #requires axiom for AsyncDisk.__default.overlap
axiom (forall start#0: int, len#0: int, start'#0: int, len'#0: int :: 
  { AsyncDisk.__default.overlap#requires(start#0, len#0, start'#0, len'#0) } 
  AsyncDisk.__default.overlap#requires(start#0, len#0, start'#0, len'#0) == true);

// definition axiom for AsyncDisk.__default.overlap(revealed)
axiom true
   ==> (forall start#0: int, len#0: int, start'#0: int, len'#0: int :: 
    { AsyncDisk.__default.overlap(start#0, len#0, start'#0, len'#0) } 
    true
       ==> AsyncDisk.__default.overlap(start#0, len#0, start'#0, len'#0)
         == (start#0 + len#0 > start'#0 && start'#0 + len'#0 > start#0));

// definition axiom for AsyncDisk.__default.overlap for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int, start'#0: int, len'#0: int :: 
    {:weight 3} { AsyncDisk.__default.overlap(LitInt(start#0), LitInt(len#0), LitInt(start'#0), LitInt(len'#0)) } 
    true
       ==> AsyncDisk.__default.overlap(LitInt(start#0), LitInt(len#0), LitInt(start'#0), LitInt(len'#0))
         == Lit(start#0 + len#0 > start'#0 && start'#0 + len'#0 > start#0));

// function declaration for AsyncDisk._default.HavocConflictingWrites
function AsyncDisk.__default.HavocConflictingWrites(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int)
   : bool;

function AsyncDisk.__default.HavocConflictingWrites#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int)
   : bool;

// consequence axiom for AsyncDisk.__default.HavocConflictingWrites
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    { AsyncDisk.__default.HavocConflictingWrites(k#0, s#0, s'#0, id#0, id'#0) } 
    AsyncDisk.__default.HavocConflictingWrites#canCall(k#0, s#0, s'#0, id#0, id'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> true);

function AsyncDisk.__default.HavocConflictingWrites#requires(DatatypeType, DatatypeType, DatatypeType, int, int) : bool;

// #requires axiom for AsyncDisk.__default.HavocConflictingWrites
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
  { AsyncDisk.__default.HavocConflictingWrites#requires(k#0, s#0, s'#0, id#0, id'#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
       && 
      LitInt(0) <= id'#0
       && id'#0 < 18446744073709551616
     ==> AsyncDisk.__default.HavocConflictingWrites#requires(k#0, s#0, s'#0, id#0, id'#0)
       == true);

// definition axiom for AsyncDisk.__default.HavocConflictingWrites(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    { AsyncDisk.__default.HavocConflictingWrites(k#0, s#0, s'#0, id#0, id'#0) } 
    AsyncDisk.__default.HavocConflictingWrites#canCall(k#0, s#0, s'#0, id#0, id'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> (id#0 != id'#0 ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType)
             && AsyncDisk.__default.overlap#canCall(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)), 
              AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType))))
         && AsyncDisk.__default.HavocConflictingWrites(k#0, s#0, s'#0, id#0, id'#0)
           == (
            id#0 != id'#0
             && Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
             && Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]
             && AsyncDisk.__default.overlap(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)), 
              AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType)))));

// definition axiom for AsyncDisk.__default.HavocConflictingWrites for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    {:weight 3} { AsyncDisk.__default.HavocConflictingWrites(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0)) } 
    AsyncDisk.__default.HavocConflictingWrites#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> (Lit(id#0 != id'#0) ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id'#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)
             && AsyncDisk.__default.overlap#canCall(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)), 
              AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType))))
         && AsyncDisk.__default.HavocConflictingWrites(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0))
           == (
            id#0 != id'#0
             && Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
             && Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id'#0)]
             && AsyncDisk.__default.overlap(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)), 
              AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)))));

// function declaration for AsyncDisk._default.HavocConflictingWriteRead
function AsyncDisk.__default.HavocConflictingWriteRead(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int)
   : bool;

function AsyncDisk.__default.HavocConflictingWriteRead#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int)
   : bool;

// consequence axiom for AsyncDisk.__default.HavocConflictingWriteRead
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    { AsyncDisk.__default.HavocConflictingWriteRead(k#0, s#0, s'#0, id#0, id'#0) } 
    AsyncDisk.__default.HavocConflictingWriteRead#canCall(k#0, s#0, s'#0, id#0, id'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> true);

function AsyncDisk.__default.HavocConflictingWriteRead#requires(DatatypeType, DatatypeType, DatatypeType, int, int) : bool;

// #requires axiom for AsyncDisk.__default.HavocConflictingWriteRead
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
  { AsyncDisk.__default.HavocConflictingWriteRead#requires(k#0, s#0, s'#0, id#0, id'#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
       && 
      LitInt(0) <= id'#0
       && id'#0 < 18446744073709551616
     ==> AsyncDisk.__default.HavocConflictingWriteRead#requires(k#0, s#0, s'#0, id#0, id'#0)
       == true);

// definition axiom for AsyncDisk.__default.HavocConflictingWriteRead(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    { AsyncDisk.__default.HavocConflictingWriteRead(k#0, s#0, s'#0, id#0, id'#0) } 
    AsyncDisk.__default.HavocConflictingWriteRead#canCall(k#0, s#0, s'#0, id#0, id'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> AsyncDisk.Variables.Variables_q(s#0)
         && (Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqRead.ReqRead_q($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqRead.ReqRead_q($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType)
             && AsyncDisk.__default.overlap#canCall(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)), 
              AsyncDisk.ReqRead.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType), 
              AsyncDisk.ReqRead.len($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType)))
         && AsyncDisk.__default.HavocConflictingWriteRead(k#0, s#0, s'#0, id#0, id'#0)
           == (
            Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
             && Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]
             && AsyncDisk.__default.overlap(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)), 
              AsyncDisk.ReqRead.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType), 
              AsyncDisk.ReqRead.len($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType))));

// definition axiom for AsyncDisk.__default.HavocConflictingWriteRead for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    {:weight 3} { AsyncDisk.__default.HavocConflictingWriteRead(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0)) } 
    AsyncDisk.__default.HavocConflictingWriteRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
         && (Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(id'#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqRead.ReqRead_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqRead.ReqRead_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)
             && AsyncDisk.__default.overlap#canCall(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)), 
              AsyncDisk.ReqRead.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType), 
              AsyncDisk.ReqRead.len($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)))
         && AsyncDisk.__default.HavocConflictingWriteRead(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0))
           == (
            Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
             && Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(id'#0)]
             && AsyncDisk.__default.overlap(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)), 
              AsyncDisk.ReqRead.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType), 
              AsyncDisk.ReqRead.len($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType))));

// function declaration for AsyncDisk._default.NextInternalStep
function AsyncDisk.__default.NextInternalStep(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType)
   : bool;

function AsyncDisk.__default.NextInternalStep#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.NextInternalStep
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
    { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
    AsyncDisk.__default.NextInternalStep#canCall(k#0, s#0, s'#0, step#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(step#0, Tclass.AsyncDisk.InternalStep()))
       ==> true);

function AsyncDisk.__default.NextInternalStep#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.NextInternalStep
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
  { AsyncDisk.__default.NextInternalStep#requires(k#0, s#0, s'#0, step#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(step#0, Tclass.AsyncDisk.InternalStep())
     ==> AsyncDisk.__default.NextInternalStep#requires(k#0, s#0, s'#0, step#0) == true);

// definition axiom for AsyncDisk.__default.NextInternalStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
    { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
    AsyncDisk.__default.NextInternalStep#canCall(k#0, s#0, s'#0, step#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(step#0, Tclass.AsyncDisk.InternalStep()))
       ==> (AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
           ==> (var fakeContents#0 := AsyncDisk.InternalStep.fakeContents(step#0); 
            (
                AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
                 || AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
                 || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                 || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(step#0))
               && (var id#0 := AsyncDisk.InternalStep.id(step#0); 
                AsyncDisk.__default.ProcessReadFailure#canCall(k#0, s#0, s'#0, id#0, fakeContents#0))))
         && (!AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
           ==> (AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
               ==> (
                  AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
                   || AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
                   || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                   || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(step#0))
                 && (var id#1 := AsyncDisk.InternalStep.id(step#0); 
                  AsyncDisk.__default.ProcessWrite#canCall(k#0, s#0, s'#0, id#1)))
             && (!AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
               ==> (AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                   ==> (var id'#0 := AsyncDisk.InternalStep.id_k(step#0); 
                    (
                        AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
                         || AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
                         || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                         || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(step#0))
                       && (var id#2 := AsyncDisk.InternalStep.id(step#0); 
                        AsyncDisk.__default.HavocConflictingWrites#canCall(k#0, s#0, s'#0, id#2, id'#0))))
                 && (!AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                   ==> (var id'#1 := AsyncDisk.InternalStep.id_k(step#0); 
                    (
                        AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
                         || AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
                         || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                         || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(step#0))
                       && (var id#3 := AsyncDisk.InternalStep.id(step#0); 
                        AsyncDisk.__default.HavocConflictingWriteRead#canCall(k#0, s#0, s'#0, id#3, id'#1))))))
         && AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0)
           == (if AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
             then (var fakeContents#1 := AsyncDisk.InternalStep.fakeContents(step#0); 
              (var id#4 := AsyncDisk.InternalStep.id(step#0); 
                AsyncDisk.__default.ProcessReadFailure(k#0, s#0, s'#0, id#4, fakeContents#1)))
             else (if AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
               then (var id#5 := AsyncDisk.InternalStep.id(step#0); 
                AsyncDisk.__default.ProcessWrite(k#0, s#0, s'#0, id#5))
               else (if AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                 then (var id'#2 := AsyncDisk.InternalStep.id_k(step#0); 
                  (var id#6 := AsyncDisk.InternalStep.id(step#0); 
                    AsyncDisk.__default.HavocConflictingWrites(k#0, s#0, s'#0, id#6, id'#2)))
                 else (var id'#3 := AsyncDisk.InternalStep.id_k(step#0); 
                  (var id#7 := AsyncDisk.InternalStep.id(step#0); 
                    AsyncDisk.__default.HavocConflictingWriteRead(k#0, s#0, s'#0, id#7, id'#3)))))));

// definition axiom for AsyncDisk.__default.NextInternalStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.NextInternalStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(step#0)) } 
    AsyncDisk.__default.NextInternalStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(step#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(step#0, Tclass.AsyncDisk.InternalStep()))
       ==> (Lit(AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0)))
           ==> (var fakeContents#2 := Lit(AsyncDisk.InternalStep.fakeContents(Lit(step#0))); 
            (
                AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
                 || AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
                 || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                 || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(Lit(step#0)))
               && (var id#8 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                AsyncDisk.__default.ProcessReadFailure#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), id#8, fakeContents#2))))
         && (!Lit(AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0)))
           ==> (Lit(AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0)))
               ==> (
                  AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
                   || AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
                   || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                   || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(Lit(step#0)))
                 && (var id#9 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                  AsyncDisk.__default.ProcessWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), id#9)))
             && (!Lit(AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0)))
               ==> (Lit(AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0)))
                   ==> (var id'#4 := LitInt(AsyncDisk.InternalStep.id_k(Lit(step#0))); 
                    (
                        AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(Lit(step#0)))
                       && (var id#10 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                        AsyncDisk.__default.HavocConflictingWrites#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), id#10, id'#4))))
                 && (!Lit(AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0)))
                   ==> (var id'#5 := LitInt(AsyncDisk.InternalStep.id_k(Lit(step#0))); 
                    (
                        AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(Lit(step#0)))
                       && (var id#11 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                        AsyncDisk.__default.HavocConflictingWriteRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), id#11, id'#5))))))
         && AsyncDisk.__default.NextInternalStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(step#0))
           == (if AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
             then (var fakeContents#3 := Lit(AsyncDisk.InternalStep.fakeContents(Lit(step#0))); 
              (var id#12 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                Lit(AsyncDisk.__default.ProcessReadFailure(Lit(k#0), Lit(s#0), Lit(s'#0), id#12, fakeContents#3))))
             else (if AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
               then (var id#13 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                Lit(AsyncDisk.__default.ProcessWrite(Lit(k#0), Lit(s#0), Lit(s'#0), id#13)))
               else (if AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                 then (var id'#6 := LitInt(AsyncDisk.InternalStep.id_k(Lit(step#0))); 
                  (var id#14 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                    Lit(AsyncDisk.__default.HavocConflictingWrites(Lit(k#0), Lit(s#0), Lit(s'#0), id#14, id'#6))))
                 else (var id'#7 := LitInt(AsyncDisk.InternalStep.id_k(Lit(step#0))); 
                  (var id#15 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                    Lit(AsyncDisk.__default.HavocConflictingWriteRead(Lit(k#0), Lit(s#0), Lit(s'#0), id#15, id'#7))))))));

// function declaration for AsyncDisk._default.NextInternal
function AsyncDisk.__default.NextInternal(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

function AsyncDisk.__default.NextInternal#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

// consequence axiom for AsyncDisk.__default.NextInternal
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { AsyncDisk.__default.NextInternal(k#0, s#0, s'#0) } 
    AsyncDisk.__default.NextInternal#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> true);

function AsyncDisk.__default.NextInternal#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.NextInternal
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
  { AsyncDisk.__default.NextInternal#requires(k#0, s#0, s'#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
     ==> AsyncDisk.__default.NextInternal#requires(k#0, s#0, s'#0) == true);

// definition axiom for AsyncDisk.__default.NextInternal(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { AsyncDisk.__default.NextInternal(k#0, s#0, s'#0) } 
    AsyncDisk.__default.NextInternal#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> (forall step#0: DatatypeType :: 
          { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
          $Is(step#0, Tclass.AsyncDisk.InternalStep())
             ==> AsyncDisk.__default.NextInternalStep#canCall(k#0, s#0, s'#0, step#0))
         && AsyncDisk.__default.NextInternal(k#0, s#0, s'#0)
           == (exists step#0: DatatypeType :: 
            { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
            $Is(step#0, Tclass.AsyncDisk.InternalStep())
               && AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0)));

// definition axiom for AsyncDisk.__default.NextInternal for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.NextInternal(Lit(k#0), Lit(s#0), Lit(s'#0)) } 
    AsyncDisk.__default.NextInternal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> (forall step#1: DatatypeType :: 
          { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#1) } 
          $Is(step#1, Tclass.AsyncDisk.InternalStep())
             ==> AsyncDisk.__default.NextInternalStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), step#1))
         && AsyncDisk.__default.NextInternal(Lit(k#0), Lit(s#0), Lit(s'#0))
           == (exists step#1: DatatypeType :: 
            { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#1) } 
            $Is(step#1, Tclass.AsyncDisk.InternalStep())
               && AsyncDisk.__default.NextInternalStep(Lit(k#0), Lit(s#0), Lit(s'#0), step#1)));

// function declaration for AsyncDisk._default.Crash
function AsyncDisk.__default.Crash(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

function AsyncDisk.__default.Crash#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

// consequence axiom for AsyncDisk.__default.Crash
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { AsyncDisk.__default.Crash(k#0, s#0, s'#0) } 
    AsyncDisk.__default.Crash#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> true);

function AsyncDisk.__default.Crash#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.Crash
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
  { AsyncDisk.__default.Crash#requires(k#0, s#0, s'#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
     ==> AsyncDisk.__default.Crash#requires(k#0, s#0, s'#0) == true);

// definition axiom for AsyncDisk.__default.Crash(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { AsyncDisk.__default.Crash(k#0, s#0, s'#0) } 
    AsyncDisk.__default.Crash#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> $IsA#AsyncDisk.Variables(s'#0)
         && AsyncDisk.Variables.Variables_q(s#0)
         && AsyncDisk.__default.Crash(k#0, s#0, s'#0)
           == AsyncDisk.Variables#Equal(s'#0, 
            #AsyncDisk.Variables.Variables(Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              AsyncDisk.Variables.contents(s#0))));

// definition axiom for AsyncDisk.__default.Crash for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.Crash(Lit(k#0), Lit(s#0), Lit(s'#0)) } 
    AsyncDisk.__default.Crash#canCall(Lit(k#0), Lit(s#0), Lit(s'#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
         && AsyncDisk.Variables.Variables_q(Lit(s#0))
         && AsyncDisk.__default.Crash(Lit(k#0), Lit(s#0), Lit(s'#0))
           == AsyncDisk.Variables#Equal(s'#0, 
            #AsyncDisk.Variables.Variables(Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(AsyncDisk.Variables.contents(Lit(s#0))))));

const unique class.JournalBytes.__default: ClassName;

function Tclass.JournalBytes.__default() : Ty;

// Tclass.JournalBytes.__default Tag
axiom Tag(Tclass.JournalBytes.__default()) == Tagclass.JournalBytes.__default;

const unique Tagclass.JournalBytes.__default: TyTag;

// Box/unbox axiom for Tclass.JournalBytes.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalBytes.__default()) } 
  $IsBox(bx, Tclass.JournalBytes.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalBytes.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalBytes.__default()) } 
  $Is($o, Tclass.JournalBytes.__default())
     <==> $o == null || dtype($o) == Tclass.JournalBytes.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalBytes.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalBytes.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalBytes._default.JournalBlockOfByteSeq
function JournalBytes.__default.JournalBlockOfByteSeq($ly: LayerType, s#0: Seq Box) : DatatypeType;

function JournalBytes.__default.JournalBlockOfByteSeq#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), s#0) } 
  JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), s#0)
     == JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalBlockOfByteSeq(AsFuelBottom($ly), s#0) } 
  JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0)
     == JournalBytes.__default.JournalBlockOfByteSeq($LZ, s#0));

// consequence axiom for JournalBytes.__default.JournalBlockOfByteSeq
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0) } 
    JournalBytes.__default.JournalBlockOfByteSeq#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0))
           ==> Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0))): Seq Box)
             == LitInt(4064))
         && $Is(JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function JournalBytes.__default.JournalBlockOfByteSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalBytes.__default.JournalBlockOfByteSeq
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalBlockOfByteSeq#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalBytes.__default.JournalBlockOfByteSeq#requires($ly, s#0) == true);

// definition axiom for JournalBytes.__default.JournalBlockOfByteSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), s#0) } 
    JournalBytes.__default.JournalBlockOfByteSeq#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(s#0) == LitInt(4096)
           ==> AsyncDisk.__default.ChecksumChecksOut#canCall(s#0))
         && JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), s#0)
           == (if Seq#Length(s#0) == LitInt(4096)
               && AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, s#0)
             then #Options.Option.Some($Box(Seq#Drop(s#0, LitInt(32))))
             else #Options.Option.None()));

// definition axiom for JournalBytes.__default.JournalBlockOfByteSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), Lit(s#0)) } 
    JournalBytes.__default.JournalBlockOfByteSeq#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(Lit(s#0)) == LitInt(4096)
           ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Lit(s#0)))
         && JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), Lit(s#0))
           == (if Seq#Length(Lit(s#0)) == LitInt(4096)
               && AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, Lit(s#0))
             then #Options.Option.Some($Box(Lit(Seq#Drop(Lit(s#0), LitInt(32)))))
             else #Options.Option.None()));

// function declaration for JournalBytes._default.JournalRangeOfByteSeq
function JournalBytes.__default.JournalRangeOfByteSeq($ly: LayerType, s#0: Seq Box) : DatatypeType;

function JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), s#0) } 
  JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), s#0)
     == JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalRangeOfByteSeq(AsFuelBottom($ly), s#0) } 
  JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0)
     == JournalBytes.__default.JournalRangeOfByteSeq($LZ, s#0));

// consequence axiom for JournalBytes.__default.JournalRangeOfByteSeq
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0) } 
    JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))
           ==> Mul(Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))): Seq Box), 
              LitInt(4096))
             == Seq#Length(s#0))
         && (Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))): Seq Box, 
                  i#0)): Seq Box } 
            LitInt(0) <= i#0
                 && i#0
                   < Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))): Seq Box)
               ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))): Seq Box, 
                      i#0)): Seq Box)
                 == LitInt(4064)))
         && $Is(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0), 
          Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte())))));

function JournalBytes.__default.JournalRangeOfByteSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalBytes.__default.JournalRangeOfByteSeq
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalRangeOfByteSeq#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalBytes.__default.JournalRangeOfByteSeq#requires($ly, s#0) == true);

// definition axiom for JournalBytes.__default.JournalRangeOfByteSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), s#0) } 
    JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (!Seq#Equal(s#0, Seq#Empty(): Seq Box)
           ==> (Seq#Length(s#0) >= LitInt(4096)
               ==> JournalBytes.__default.JournalBlockOfByteSeq#canCall(Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))
             && (Seq#Length(s#0) >= LitInt(4096)
                 && Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                    Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))
               ==> JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, LitInt(4096)))
                 && (var rest#0 := JournalBytes.__default.JournalRangeOfByteSeq($ly, Seq#Drop(s#0, LitInt(4096))); 
                  Options.Option.Some_q(rest#0)
                     ==> JournalBytes.__default.JournalBlockOfByteSeq#canCall(Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))))
         && JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), s#0)
           == (if Seq#Equal(s#0, Seq#Empty(): Seq Box)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if Seq#Length(s#0) >= LitInt(4096)
                 && Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                    Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))
               then (var rest#0 := JournalBytes.__default.JournalRangeOfByteSeq($ly, Seq#Drop(s#0, LitInt(4096))); 
                (if Options.Option.Some_q(rest#0)
                   then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                          Options.Option.value(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                              Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))), 
                        $Unbox(Options.Option.value(rest#0)): Seq Box)))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// definition axiom for JournalBytes.__default.JournalRangeOfByteSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), Lit(s#0)) } 
    JournalBytes.__default.JournalRangeOfByteSeq#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (!Seq#Equal(s#0, Seq#Empty(): Seq Box)
           ==> (Seq#Length(Lit(s#0)) >= LitInt(4096)
               ==> JournalBytes.__default.JournalBlockOfByteSeq#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))
             && (Seq#Length(Lit(s#0)) >= LitInt(4096)
                 && Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                    Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))
               ==> JournalBytes.__default.JournalRangeOfByteSeq#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(4096))))
                 && (var rest#1 := JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(4096)))); 
                  Options.Option.Some_q(rest#1)
                     ==> JournalBytes.__default.JournalBlockOfByteSeq#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))))
         && JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), Lit(s#0))
           == (if Seq#Equal(s#0, Seq#Empty(): Seq Box)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if Seq#Length(Lit(s#0)) >= LitInt(4096)
                 && Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                    Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))
               then (var rest#1 := JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(4096)))); 
                (if Options.Option.Some_q(rest#1)
                   then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                          Options.Option.value(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                              Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))), 
                        $Unbox(Options.Option.value(rest#1)): Seq Box)))
                   else #Options.Option.None()))
               else #Options.Option.None())));

const unique class.PackedIntsLib.__default: ClassName;

function Tclass.PackedIntsLib.__default() : Ty;

// Tclass.PackedIntsLib.__default Tag
axiom Tag(Tclass.PackedIntsLib.__default()) == Tagclass.PackedIntsLib.__default;

const unique Tagclass.PackedIntsLib.__default: TyTag;

// Box/unbox axiom for Tclass.PackedIntsLib.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedIntsLib.__default()) } 
  $IsBox(bx, Tclass.PackedIntsLib.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedIntsLib.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedIntsLib.__default()) } 
  $Is($o, Tclass.PackedIntsLib.__default())
     <==> $o == null || dtype($o) == Tclass.PackedIntsLib.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedIntsLib.__default(), $h) } 
  $IsAlloc($o, Tclass.PackedIntsLib.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PackedIntsLib._default.pack_LittleEndian_Uint32
function PackedIntsLib.__default.pack__LittleEndian__Uint32($ly: LayerType, i#0: int) : Seq Box;

function PackedIntsLib.__default.pack__LittleEndian__Uint32#canCall(i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, i#0: int :: 
  { PackedIntsLib.__default.pack__LittleEndian__Uint32($LS($ly), i#0) } 
  PackedIntsLib.__default.pack__LittleEndian__Uint32($LS($ly), i#0)
     == PackedIntsLib.__default.pack__LittleEndian__Uint32($ly, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, i#0: int :: 
  { PackedIntsLib.__default.pack__LittleEndian__Uint32(AsFuelBottom($ly), i#0) } 
  PackedIntsLib.__default.pack__LittleEndian__Uint32($ly, i#0)
     == PackedIntsLib.__default.pack__LittleEndian__Uint32($LZ, i#0));

// consequence axiom for PackedIntsLib.__default.pack__LittleEndian__Uint32
axiom true
   ==> (forall $ly: LayerType, i#0: int :: 
    { PackedIntsLib.__default.pack__LittleEndian__Uint32($ly, i#0) } 
    PackedIntsLib.__default.pack__LittleEndian__Uint32#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 4294967296)
       ==> Seq#Length(PackedIntsLib.__default.pack__LittleEndian__Uint32($ly, i#0))
           == LitInt(4)
         && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
            PackedIntsLib.__default.pack__LittleEndian__Uint32($ly, i#0))
           == i#0
         && $Is(PackedIntsLib.__default.pack__LittleEndian__Uint32($ly, i#0), 
          TSeq(Tclass.NativeTypes.byte())));

function PackedIntsLib.__default.pack__LittleEndian__Uint32#requires(LayerType, int) : bool;

// #requires axiom for PackedIntsLib.__default.pack__LittleEndian__Uint32
axiom (forall $ly: LayerType, i#0: int :: 
  { PackedIntsLib.__default.pack__LittleEndian__Uint32#requires($ly, i#0) } 
  LitInt(0) <= i#0 && i#0 < 4294967296
     ==> PackedIntsLib.__default.pack__LittleEndian__Uint32#requires($ly, i#0) == true);

// definition axiom for PackedIntsLib.__default.pack__LittleEndian__Uint32(revealed)
axiom true
   ==> (forall $ly: LayerType, i#0: int :: 
    { PackedIntsLib.__default.pack__LittleEndian__Uint32($LS($ly), i#0) } 
    PackedIntsLib.__default.pack__LittleEndian__Uint32#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 4294967296)
       ==> PackedIntsLib.__default.pack__LittleEndian__Uint32($LS($ly), i#0)
         == (var d0#0 := Mod(i#0, LitInt(256)); 
          (var i1#0 := Div(i#0 - d0#0, LitInt(256)); 
            (var d1#0 := Mod(i1#0, LitInt(256)); 
              (var i2#0 := Div(i1#0 - d1#0, LitInt(256)); 
                (var d2#0 := Mod(i2#0, LitInt(256)); 
                  (var i3#0 := Div(i2#0 - d2#0, LitInt(256)); 
                    (var d3#0 := Mod(i3#0, LitInt(256)); 
                      Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(d0#0)), $Box(d1#0)), $Box(d2#0)), 
                        $Box(d3#0))))))))));

// definition axiom for PackedIntsLib.__default.pack__LittleEndian__Uint32 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, i#0: int :: 
    {:weight 3} { PackedIntsLib.__default.pack__LittleEndian__Uint32($LS($ly), LitInt(i#0)) } 
    PackedIntsLib.__default.pack__LittleEndian__Uint32#canCall(LitInt(i#0))
         || (LitInt(0) <= i#0 && i#0 < 4294967296)
       ==> PackedIntsLib.__default.pack__LittleEndian__Uint32($LS($ly), LitInt(i#0))
         == (var d0#1 := LitInt(Mod(i#0, LitInt(256))); 
          (var i1#1 := LitInt(Div(i#0 - d0#1, LitInt(256))); 
            (var d1#1 := LitInt(Mod(i1#1, LitInt(256))); 
              (var i2#1 := LitInt(Div(i1#1 - d1#1, LitInt(256))); 
                (var d2#1 := LitInt(Mod(i2#1, LitInt(256))); 
                  (var i3#1 := LitInt(Div(i2#1 - d2#1, LitInt(256))); 
                    (var d3#1 := LitInt(Mod(i3#1, LitInt(256))); 
                      Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(d0#1)), $Box(d1#1)), $Box(d2#1)), 
                          $Box(d3#1)))))))))));

const unique class.JournalistMarshallingModel.__default: ClassName;

function Tclass.JournalistMarshallingModel.__default() : Ty;

// Tclass.JournalistMarshallingModel.__default Tag
axiom Tag(Tclass.JournalistMarshallingModel.__default())
   == Tagclass.JournalistMarshallingModel.__default;

const unique Tagclass.JournalistMarshallingModel.__default: TyTag;

// Box/unbox axiom for Tclass.JournalistMarshallingModel.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistMarshallingModel.__default()) } 
  $IsBox(bx, Tclass.JournalistMarshallingModel.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalistMarshallingModel.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalistMarshallingModel.__default()) } 
  $Is($o, Tclass.JournalistMarshallingModel.__default())
     <==> $o == null || dtype($o) == Tclass.JournalistMarshallingModel.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalistMarshallingModel.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalistMarshallingModel.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalistMarshallingModel._default.cyclicSlice
function JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T: Ty, 
    $ly: LayerType, 
    t#0: Seq Box, 
    start#0: int, 
    l#0: int)
   : Seq Box;

function JournalistMarshallingModel.__default.cyclicSlice#canCall(JournalistMarshallingModel._default.cyclicSlice$T: Ty, 
    t#0: Seq Box, 
    start#0: int, 
    l#0: int)
   : bool;

// layer synonym axiom
axiom (forall JournalistMarshallingModel._default.cyclicSlice$T: Ty, 
    $ly: LayerType, 
    t#0: Seq Box, 
    start#0: int, 
    l#0: int :: 
  { JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $LS($ly), t#0, start#0, l#0) } 
  JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $LS($ly), t#0, start#0, l#0)
     == JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $ly, t#0, start#0, l#0));

// fuel synonym axiom
axiom (forall JournalistMarshallingModel._default.cyclicSlice$T: Ty, 
    $ly: LayerType, 
    t#0: Seq Box, 
    start#0: int, 
    l#0: int :: 
  { JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, 
      AsFuelBottom($ly), 
      t#0, 
      start#0, 
      l#0) } 
  JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $ly, t#0, start#0, l#0)
     == JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $LZ, t#0, start#0, l#0));

// consequence axiom for JournalistMarshallingModel.__default.cyclicSlice
axiom true
   ==> (forall JournalistMarshallingModel._default.cyclicSlice$T: Ty, 
      $ly: LayerType, 
      t#0: Seq Box, 
      start#0: int, 
      l#0: int :: 
    { JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $ly, t#0, start#0, l#0) } 
    JournalistMarshallingModel.__default.cyclicSlice#canCall(JournalistMarshallingModel._default.cyclicSlice$T, t#0, start#0, l#0)
         || (
          $Is(t#0, TSeq(JournalistMarshallingModel._default.cyclicSlice$T))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= l#0
           && l#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < Seq#Length(t#0)
           && 
          LitInt(0) <= l#0
           && l#0 <= Seq#Length(t#0))
       ==> Seq#Length(JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $ly, t#0, start#0, l#0))
           == l#0
         && $Is(JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $ly, t#0, start#0, l#0), 
          TSeq(JournalistMarshallingModel._default.cyclicSlice$T)));

function JournalistMarshallingModel.__default.cyclicSlice#requires(Ty, LayerType, Seq Box, int, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.cyclicSlice
axiom (forall JournalistMarshallingModel._default.cyclicSlice$T: Ty, 
    $ly: LayerType, 
    t#0: Seq Box, 
    start#0: int, 
    l#0: int :: 
  { JournalistMarshallingModel.__default.cyclicSlice#requires(JournalistMarshallingModel._default.cyclicSlice$T, $ly, t#0, start#0, l#0) } 
  $Is(t#0, TSeq(JournalistMarshallingModel._default.cyclicSlice$T))
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= l#0
       && l#0 < 18446744073709551616
     ==> JournalistMarshallingModel.__default.cyclicSlice#requires(JournalistMarshallingModel._default.cyclicSlice$T, $ly, t#0, start#0, l#0)
       == (
        LitInt(0) <= start#0
         && start#0 < Seq#Length(t#0)
         && 
        LitInt(0) <= l#0
         && l#0 <= Seq#Length(t#0)));

// definition axiom for JournalistMarshallingModel.__default.cyclicSlice(revealed)
axiom true
   ==> (forall JournalistMarshallingModel._default.cyclicSlice$T: Ty, 
      $ly: LayerType, 
      t#0: Seq Box, 
      start#0: int, 
      l#0: int :: 
    { JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $LS($ly), t#0, start#0, l#0) } 
    JournalistMarshallingModel.__default.cyclicSlice#canCall(JournalistMarshallingModel._default.cyclicSlice$T, t#0, start#0, l#0)
         || (
          $Is(t#0, TSeq(JournalistMarshallingModel._default.cyclicSlice$T))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= l#0
           && l#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < Seq#Length(t#0)
           && 
          LitInt(0) <= l#0
           && l#0 <= Seq#Length(t#0))
       ==> JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, $LS($ly), t#0, start#0, l#0)
         == (if start#0 + l#0 <= Seq#Length(t#0)
           then Seq#Drop(Seq#Take(t#0, start#0 + l#0), start#0)
           else Seq#Append(Seq#Drop(t#0, start#0), Seq#Take(t#0, start#0 + l#0 - Seq#Length(t#0)))));

// definition axiom for JournalistMarshallingModel.__default.cyclicSlice for all literals(revealed)
axiom true
   ==> (forall JournalistMarshallingModel._default.cyclicSlice$T: Ty, 
      $ly: LayerType, 
      t#0: Seq Box, 
      start#0: int, 
      l#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, 
        $LS($ly), 
        Lit(t#0), 
        LitInt(start#0), 
        LitInt(l#0)) } 
    JournalistMarshallingModel.__default.cyclicSlice#canCall(JournalistMarshallingModel._default.cyclicSlice$T, 
          Lit(t#0), 
          LitInt(start#0), 
          LitInt(l#0))
         || (
          $Is(t#0, TSeq(JournalistMarshallingModel._default.cyclicSlice$T))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= l#0
           && l#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 < Seq#Length(Lit(t#0))
           && 
          LitInt(0) <= LitInt(l#0)
           && LitInt(l#0) <= Seq#Length(Lit(t#0)))
       ==> JournalistMarshallingModel.__default.cyclicSlice(JournalistMarshallingModel._default.cyclicSlice$T, 
          $LS($ly), 
          Lit(t#0), 
          LitInt(start#0), 
          LitInt(l#0))
         == (if LitInt(start#0 + l#0) <= Seq#Length(Lit(t#0))
           then Seq#Drop(Seq#Take(Lit(t#0), LitInt(start#0 + l#0)), LitInt(start#0))
           else Seq#Append(Seq#Drop(Lit(t#0), LitInt(start#0)), 
            Seq#Take(Lit(t#0), start#0 + l#0 - Seq#Length(Lit(t#0))))));

// function declaration for JournalistMarshallingModel._default.withoutChecksums
function JournalistMarshallingModel.__default.withoutChecksums($ly: LayerType, buf#0: Seq Box, numBlocks#0: int) : Seq Box;

function JournalistMarshallingModel.__default.withoutChecksums#canCall(buf#0: Seq Box, numBlocks#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int :: 
  { JournalistMarshallingModel.__default.withoutChecksums($LS($ly), buf#0, numBlocks#0) } 
  JournalistMarshallingModel.__default.withoutChecksums($LS($ly), buf#0, numBlocks#0)
     == JournalistMarshallingModel.__default.withoutChecksums($ly, buf#0, numBlocks#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int :: 
  { JournalistMarshallingModel.__default.withoutChecksums(AsFuelBottom($ly), buf#0, numBlocks#0) } 
  JournalistMarshallingModel.__default.withoutChecksums($ly, buf#0, numBlocks#0)
     == JournalistMarshallingModel.__default.withoutChecksums($LZ, buf#0, numBlocks#0));

// consequence axiom for JournalistMarshallingModel.__default.withoutChecksums
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int :: 
    { JournalistMarshallingModel.__default.withoutChecksums($ly, buf#0, numBlocks#0) } 
    JournalistMarshallingModel.__default.withoutChecksums#canCall(buf#0, numBlocks#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0))
       ==> Seq#Length(JournalistMarshallingModel.__default.withoutChecksums($ly, buf#0, numBlocks#0))
           == Mul(LitInt(4064), numBlocks#0)
         && $Is(JournalistMarshallingModel.__default.withoutChecksums($ly, buf#0, numBlocks#0), 
          TSeq(Tclass.NativeTypes.byte())));

function JournalistMarshallingModel.__default.withoutChecksums#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.withoutChecksums
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int :: 
  { JournalistMarshallingModel.__default.withoutChecksums#requires($ly, buf#0, numBlocks#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= numBlocks#0
       && numBlocks#0 < 18446744073709551616
     ==> JournalistMarshallingModel.__default.withoutChecksums#requires($ly, buf#0, numBlocks#0)
       == 
      (Seq#Length(buf#0)
       == Mul(LitInt(4096), numBlocks#0)));

// definition axiom for JournalistMarshallingModel.__default.withoutChecksums(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int :: 
    { JournalistMarshallingModel.__default.withoutChecksums($LS($ly), buf#0, numBlocks#0) } 
    JournalistMarshallingModel.__default.withoutChecksums#canCall(buf#0, numBlocks#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0))
       ==> (numBlocks#0 != LitInt(0)
           ==> JournalistMarshallingModel.__default.withoutChecksums#canCall(Seq#Drop(buf#0, LitInt(4096)), numBlocks#0 - 1))
         && JournalistMarshallingModel.__default.withoutChecksums($LS($ly), buf#0, numBlocks#0)
           == (if numBlocks#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Drop(Seq#Take(buf#0, LitInt(4096)), LitInt(32)), 
              JournalistMarshallingModel.__default.withoutChecksums($ly, Seq#Drop(buf#0, LitInt(4096)), numBlocks#0 - 1))));

// definition axiom for JournalistMarshallingModel.__default.withoutChecksums for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.withoutChecksums($LS($ly), Lit(buf#0), LitInt(numBlocks#0)) } 
    JournalistMarshallingModel.__default.withoutChecksums#canCall(Lit(buf#0), LitInt(numBlocks#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && Seq#Length(Lit(buf#0)) == LitInt(Mul(LitInt(4096), LitInt(numBlocks#0))))
       ==> (LitInt(numBlocks#0) != LitInt(0)
           ==> JournalistMarshallingModel.__default.withoutChecksums#canCall(Lit(Seq#Drop(Lit(buf#0), LitInt(4096))), LitInt(numBlocks#0 - 1)))
         && JournalistMarshallingModel.__default.withoutChecksums($LS($ly), Lit(buf#0), LitInt(numBlocks#0))
           == (if LitInt(numBlocks#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(4096)), LitInt(32)), 
              JournalistMarshallingModel.__default.withoutChecksums($LS($ly), Lit(Seq#Drop(Lit(buf#0), LitInt(4096))), LitInt(numBlocks#0 - 1)))));

// function declaration for JournalistMarshallingModel._default.splice
function JournalistMarshallingModel.__default.splice($ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box) : Seq Box;

function JournalistMarshallingModel.__default.splice#canCall(bytes#0: Seq Box, start#0: int, ins#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
  { JournalistMarshallingModel.__default.splice($LS($ly), bytes#0, start#0, ins#0) } 
  JournalistMarshallingModel.__default.splice($LS($ly), bytes#0, start#0, ins#0)
     == JournalistMarshallingModel.__default.splice($ly, bytes#0, start#0, ins#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
  { JournalistMarshallingModel.__default.splice(AsFuelBottom($ly), bytes#0, start#0, ins#0) } 
  JournalistMarshallingModel.__default.splice($ly, bytes#0, start#0, ins#0)
     == JournalistMarshallingModel.__default.splice($LZ, bytes#0, start#0, ins#0));

// consequence axiom for JournalistMarshallingModel.__default.splice
axiom true
   ==> (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
    { JournalistMarshallingModel.__default.splice($ly, bytes#0, start#0, ins#0) } 
    JournalistMarshallingModel.__default.splice#canCall(bytes#0, start#0, ins#0)
         || (
          $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= start#0
           && start#0 + Seq#Length(ins#0) <= Seq#Length(bytes#0)
           && Seq#Length(bytes#0) < 18446744073709551616)
       ==> Seq#Length(JournalistMarshallingModel.__default.splice($ly, bytes#0, start#0, ins#0))
           == Seq#Length(bytes#0)
         && $Is(JournalistMarshallingModel.__default.splice($ly, bytes#0, start#0, ins#0), 
          TSeq(Tclass.NativeTypes.byte())));

function JournalistMarshallingModel.__default.splice#requires(LayerType, Seq Box, int, Seq Box) : bool;

// #requires axiom for JournalistMarshallingModel.__default.splice
axiom (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
  { JournalistMarshallingModel.__default.splice#requires($ly, bytes#0, start#0, ins#0) } 
  $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalistMarshallingModel.__default.splice#requires($ly, bytes#0, start#0, ins#0)
       == (
        LitInt(0) <= start#0
         && start#0 + Seq#Length(ins#0) <= Seq#Length(bytes#0)
         && Seq#Length(bytes#0) < 18446744073709551616));

// definition axiom for JournalistMarshallingModel.__default.splice(revealed)
axiom true
   ==> (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
    { JournalistMarshallingModel.__default.splice($LS($ly), bytes#0, start#0, ins#0) } 
    JournalistMarshallingModel.__default.splice#canCall(bytes#0, start#0, ins#0)
         || (
          $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= start#0
           && start#0 + Seq#Length(ins#0) <= Seq#Length(bytes#0)
           && Seq#Length(bytes#0) < 18446744073709551616)
       ==> JournalistMarshallingModel.__default.splice($LS($ly), bytes#0, start#0, ins#0)
         == Seq#Append(Seq#Append(Seq#Take(bytes#0, start#0), ins#0), 
          Seq#Drop(bytes#0, start#0 + Seq#Length(ins#0))));

// definition axiom for JournalistMarshallingModel.__default.splice for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
    {:weight 3} { JournalistMarshallingModel.__default.splice($LS($ly), Lit(bytes#0), LitInt(start#0), Lit(ins#0)) } 
    JournalistMarshallingModel.__default.splice#canCall(Lit(bytes#0), LitInt(start#0), Lit(ins#0))
         || (
          $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 + Seq#Length(Lit(ins#0)) <= Seq#Length(Lit(bytes#0))
           && Seq#Length(Lit(bytes#0)) < 18446744073709551616)
       ==> JournalistMarshallingModel.__default.splice($LS($ly), Lit(bytes#0), LitInt(start#0), Lit(ins#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(bytes#0), LitInt(start#0)), ins#0), 
          Seq#Drop(Lit(bytes#0), start#0 + Seq#Length(Lit(ins#0)))));

// function declaration for JournalistMarshallingModel._default.writeOnto
function JournalistMarshallingModel.__default.writeOnto($ly: LayerType, buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box)
   : Seq Box;

function JournalistMarshallingModel.__default.writeOnto#canCall(buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box :: 
  { JournalistMarshallingModel.__default.writeOnto($LS($ly), buf#0, numBlocks#0, start#0, bytes#0) } 
  JournalistMarshallingModel.__default.writeOnto($LS($ly), buf#0, numBlocks#0, start#0, bytes#0)
     == JournalistMarshallingModel.__default.writeOnto($ly, buf#0, numBlocks#0, start#0, bytes#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box :: 
  { JournalistMarshallingModel.__default.writeOnto(AsFuelBottom($ly), buf#0, numBlocks#0, start#0, bytes#0) } 
  JournalistMarshallingModel.__default.writeOnto($ly, buf#0, numBlocks#0, start#0, bytes#0)
     == JournalistMarshallingModel.__default.writeOnto($LZ, buf#0, numBlocks#0, start#0, bytes#0));

// consequence axiom for JournalistMarshallingModel.__default.writeOnto
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box :: 
    { JournalistMarshallingModel.__default.writeOnto($ly, buf#0, numBlocks#0, start#0, bytes#0) } 
    JournalistMarshallingModel.__default.writeOnto#canCall(buf#0, numBlocks#0, start#0, bytes#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && Seq#Length(bytes#0) <= LitInt(4064)
           && 
          LitInt(0) <= start#0
           && start#0 <= start#0 + Seq#Length(bytes#0)
           && start#0 + Seq#Length(bytes#0) <= Mul(LitInt(4064), numBlocks#0))
       ==> Seq#Length(JournalistMarshallingModel.__default.writeOnto($ly, buf#0, numBlocks#0, start#0, bytes#0))
           == Seq#Length(buf#0)
         && $Is(JournalistMarshallingModel.__default.writeOnto($ly, buf#0, numBlocks#0, start#0, bytes#0), 
          TSeq(Tclass.NativeTypes.byte())));

function JournalistMarshallingModel.__default.writeOnto#requires(LayerType, Seq Box, int, int, Seq Box) : bool;

// #requires axiom for JournalistMarshallingModel.__default.writeOnto
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box :: 
  { JournalistMarshallingModel.__default.writeOnto#requires($ly, buf#0, numBlocks#0, start#0, bytes#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= numBlocks#0
       && numBlocks#0 < 18446744073709551616
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalistMarshallingModel.__default.writeOnto#requires($ly, buf#0, numBlocks#0, start#0, bytes#0)
       == (
        Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
         && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
         && Seq#Length(bytes#0) <= LitInt(4064)
         && 
        LitInt(0) <= start#0
         && start#0 <= start#0 + Seq#Length(bytes#0)
         && start#0 + Seq#Length(bytes#0) <= Mul(LitInt(4064), numBlocks#0)));

// definition axiom for JournalistMarshallingModel.__default.writeOnto(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box :: 
    { JournalistMarshallingModel.__default.writeOnto($LS($ly), buf#0, numBlocks#0, start#0, bytes#0) } 
    JournalistMarshallingModel.__default.writeOnto#canCall(buf#0, numBlocks#0, start#0, bytes#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && Seq#Length(bytes#0) <= LitInt(4064)
           && 
          LitInt(0) <= start#0
           && start#0 <= start#0 + Seq#Length(bytes#0)
           && start#0 + Seq#Length(bytes#0) <= Mul(LitInt(4064), numBlocks#0))
       ==> (Seq#Length(bytes#0) > 0
           ==> (var block#0 := Div(start#0, LitInt(4064)); 
            (var idx#0 := Mod(start#0, LitInt(4064)); 
              (idx#0 + Seq#Length(bytes#0) <= LitInt(4064)
                   ==> JournalistMarshallingModel.__default.splice#canCall(buf#0, Mul(block#0, LitInt(4096)) + 32 + idx#0, bytes#0))
                 && (LitInt(4064) < idx#0 + Seq#Length(bytes#0)
                   ==> JournalistMarshallingModel.__default.splice#canCall(buf#0, Mul(block#0, LitInt(4096)) + 32 + idx#0, Seq#Take(bytes#0, 4064 - idx#0))
                     && (var buf1#0 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                          buf#0, 
                          Mul(block#0, LitInt(4096)) + 32 + idx#0, 
                          Seq#Take(bytes#0, 4064 - idx#0)); 
                      JournalistMarshallingModel.__default.splice#canCall(buf1#0, Mul(block#0 + 1, LitInt(4096)) + 32, Seq#Drop(bytes#0, 4064 - idx#0)))))))
         && JournalistMarshallingModel.__default.writeOnto($LS($ly), buf#0, numBlocks#0, start#0, bytes#0)
           == (if Seq#Length(bytes#0) > 0
             then (var block#0 := Div(start#0, LitInt(4064)); 
              (var idx#0 := Mod(start#0, LitInt(4064)); 
                (if idx#0 + Seq#Length(bytes#0) <= LitInt(4064)
                   then JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                    buf#0, 
                    Mul(block#0, LitInt(4096)) + 32 + idx#0, 
                    bytes#0)
                   else (var buf1#0 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                        buf#0, 
                        Mul(block#0, LitInt(4096)) + 32 + idx#0, 
                        Seq#Take(bytes#0, 4064 - idx#0)); 
                    (var buf2#0 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                          buf1#0, 
                          Mul(block#0 + 1, LitInt(4096)) + 32, 
                          Seq#Drop(bytes#0, 4064 - idx#0)); 
                      buf2#0)))))
             else buf#0));

// definition axiom for JournalistMarshallingModel.__default.writeOnto for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box :: 
    {:weight 3} { JournalistMarshallingModel.__default.writeOnto($LS($ly), Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), Lit(bytes#0)) } 
    JournalistMarshallingModel.__default.writeOnto#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), Lit(bytes#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(Lit(buf#0)) == LitInt(Mul(LitInt(4096), LitInt(numBlocks#0)))
           && LitInt(numBlocks#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && Seq#Length(Lit(bytes#0)) <= LitInt(4064)
           && 
          LitInt(0) <= LitInt(start#0)
           && LitInt(start#0) <= start#0 + Seq#Length(Lit(bytes#0))
           && start#0 + Seq#Length(Lit(bytes#0))
             <= LitInt(Mul(LitInt(4064), LitInt(numBlocks#0))))
       ==> (Seq#Length(Lit(bytes#0)) > 0
           ==> (var block#1 := LitInt(Div(start#0, LitInt(4064))); 
            (var idx#1 := LitInt(Mod(start#0, LitInt(4064))); 
              (idx#1 + Seq#Length(Lit(bytes#0)) <= LitInt(4064)
                   ==> JournalistMarshallingModel.__default.splice#canCall(Lit(buf#0), Mul(block#1, LitInt(4096)) + 32 + idx#1, Lit(bytes#0)))
                 && (LitInt(4064) < idx#1 + Seq#Length(Lit(bytes#0))
                   ==> JournalistMarshallingModel.__default.splice#canCall(Lit(buf#0), 
                      Mul(block#1, LitInt(4096)) + 32 + idx#1, 
                      Seq#Take(Lit(bytes#0), 4064 - idx#1))
                     && (var buf1#1 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                          Lit(buf#0), 
                          Mul(block#1, LitInt(4096)) + 32 + idx#1, 
                          Seq#Take(Lit(bytes#0), 4064 - idx#1)); 
                      JournalistMarshallingModel.__default.splice#canCall(buf1#1, 
                        Mul(block#1 + 1, LitInt(4096)) + 32, 
                        Seq#Drop(Lit(bytes#0), 4064 - idx#1)))))))
         && JournalistMarshallingModel.__default.writeOnto($LS($ly), Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), Lit(bytes#0))
           == (if Seq#Length(Lit(bytes#0)) > 0
             then (var block#1 := LitInt(Div(start#0, LitInt(4064))); 
              (var idx#1 := LitInt(Mod(start#0, LitInt(4064))); 
                (if idx#1 + Seq#Length(Lit(bytes#0)) <= LitInt(4064)
                   then JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                    Lit(buf#0), 
                    LitInt(Mul(block#1, LitInt(4096)) + 32 + idx#1), 
                    Lit(bytes#0))
                   else (var buf1#1 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                        Lit(buf#0), 
                        LitInt(Mul(block#1, LitInt(4096)) + 32 + idx#1), 
                        Lit(Seq#Take(Lit(bytes#0), LitInt(4064 - idx#1)))); 
                    (var buf2#1 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                          buf1#1, 
                          LitInt(Mul(LitInt(block#1 + 1), LitInt(4096)) + 32), 
                          Lit(Seq#Drop(Lit(bytes#0), LitInt(4064 - idx#1)))); 
                      buf2#1)))))
             else buf#0));

// function declaration for JournalistMarshallingModel._default.splice_get
function JournalistMarshallingModel.__default.splice__get(a#0: Seq Box, i#0: int, start#0: int, bytes#0: Seq Box) : int;

function JournalistMarshallingModel.__default.splice__get#canCall(a#0: Seq Box, i#0: int, start#0: int, bytes#0: Seq Box) : bool;

// consequence axiom for JournalistMarshallingModel.__default.splice__get
axiom true
   ==> (forall a#0: Seq Box, i#0: int, start#0: int, bytes#0: Seq Box :: 
    { JournalistMarshallingModel.__default.splice__get(a#0, i#0, start#0, bytes#0) } 
    JournalistMarshallingModel.__default.splice__get#canCall(a#0, i#0, start#0, bytes#0)
         || (
          $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(a#0)
           && 
          LitInt(0) <= start#0
           && start#0 <= start#0 + Seq#Length(bytes#0)
           && start#0 + Seq#Length(bytes#0) <= Seq#Length(a#0))
       ==> LitInt(0)
           <= JournalistMarshallingModel.__default.splice__get(a#0, i#0, start#0, bytes#0)
         && JournalistMarshallingModel.__default.splice__get(a#0, i#0, start#0, bytes#0)
           < 256);

function JournalistMarshallingModel.__default.splice__get#requires(Seq Box, int, int, Seq Box) : bool;

// #requires axiom for JournalistMarshallingModel.__default.splice__get
axiom (forall a#0: Seq Box, i#0: int, start#0: int, bytes#0: Seq Box :: 
  { JournalistMarshallingModel.__default.splice__get#requires(a#0, i#0, start#0, bytes#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalistMarshallingModel.__default.splice__get#requires(a#0, i#0, start#0, bytes#0)
       == (
        LitInt(0) <= i#0
         && i#0 < Seq#Length(a#0)
         && 
        LitInt(0) <= start#0
         && start#0 <= start#0 + Seq#Length(bytes#0)
         && start#0 + Seq#Length(bytes#0) <= Seq#Length(a#0)));

// definition axiom for JournalistMarshallingModel.__default.splice__get(revealed)
axiom true
   ==> (forall a#0: Seq Box, i#0: int, start#0: int, bytes#0: Seq Box :: 
    { JournalistMarshallingModel.__default.splice__get(a#0, i#0, start#0, bytes#0) } 
    JournalistMarshallingModel.__default.splice__get#canCall(a#0, i#0, start#0, bytes#0)
         || (
          $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(a#0)
           && 
          LitInt(0) <= start#0
           && start#0 <= start#0 + Seq#Length(bytes#0)
           && start#0 + Seq#Length(bytes#0) <= Seq#Length(a#0))
       ==> JournalistMarshallingModel.__default.splice__get(a#0, i#0, start#0, bytes#0)
         == (if start#0 <= i#0 && i#0 < start#0 + Seq#Length(bytes#0)
           then $Unbox(Seq#Index(bytes#0, i#0 - start#0)): int
           else $Unbox(Seq#Index(a#0, i#0)): int));

// definition axiom for JournalistMarshallingModel.__default.splice__get for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, i#0: int, start#0: int, bytes#0: Seq Box :: 
    {:weight 3} { JournalistMarshallingModel.__default.splice__get(Lit(a#0), LitInt(i#0), LitInt(start#0), Lit(bytes#0)) } 
    JournalistMarshallingModel.__default.splice__get#canCall(Lit(a#0), LitInt(i#0), LitInt(start#0), Lit(bytes#0))
         || (
          $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(a#0))
           && 
          LitInt(0) <= LitInt(start#0)
           && LitInt(start#0) <= start#0 + Seq#Length(Lit(bytes#0))
           && start#0 + Seq#Length(Lit(bytes#0)) <= Seq#Length(Lit(a#0)))
       ==> JournalistMarshallingModel.__default.splice__get(Lit(a#0), LitInt(i#0), LitInt(start#0), Lit(bytes#0))
         == (if LitInt(start#0) <= LitInt(i#0) && i#0 < start#0 + Seq#Length(Lit(bytes#0))
           then $Unbox(Seq#Index(Lit(bytes#0), LitInt(i#0 - start#0))): int
           else $Unbox(Seq#Index(Lit(a#0), LitInt(i#0))): int));

// function declaration for JournalistMarshallingModel._default.writeIntOnto
function JournalistMarshallingModel.__default.writeIntOnto($ly: LayerType, buf#0: Seq Box, numBlocks#0: int, idx#0: int, val#0: int)
   : Seq Box;

function JournalistMarshallingModel.__default.writeIntOnto#canCall(buf#0: Seq Box, numBlocks#0: int, idx#0: int, val#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, idx#0: int, val#0: int :: 
  { JournalistMarshallingModel.__default.writeIntOnto($LS($ly), buf#0, numBlocks#0, idx#0, val#0) } 
  JournalistMarshallingModel.__default.writeIntOnto($LS($ly), buf#0, numBlocks#0, idx#0, val#0)
     == JournalistMarshallingModel.__default.writeIntOnto($ly, buf#0, numBlocks#0, idx#0, val#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, idx#0: int, val#0: int :: 
  { JournalistMarshallingModel.__default.writeIntOnto(AsFuelBottom($ly), buf#0, numBlocks#0, idx#0, val#0) } 
  JournalistMarshallingModel.__default.writeIntOnto($ly, buf#0, numBlocks#0, idx#0, val#0)
     == JournalistMarshallingModel.__default.writeIntOnto($LZ, buf#0, numBlocks#0, idx#0, val#0));

// consequence axiom for JournalistMarshallingModel.__default.writeIntOnto
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, idx#0: int, val#0: int :: 
    { JournalistMarshallingModel.__default.writeIntOnto($ly, buf#0, numBlocks#0, idx#0, val#0) } 
    JournalistMarshallingModel.__default.writeIntOnto#canCall(buf#0, numBlocks#0, idx#0, val#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && 
          LitInt(0) <= val#0
           && val#0 < 4294967296
           && 
          Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && LitInt(0) <= idx#0
           && idx#0 + 4 <= Mul(numBlocks#0, LitInt(4064)))
       ==> Seq#Length(JournalistMarshallingModel.__default.writeIntOnto($ly, buf#0, numBlocks#0, idx#0, val#0))
           == Seq#Length(buf#0)
         && $Is(JournalistMarshallingModel.__default.writeIntOnto($ly, buf#0, numBlocks#0, idx#0, val#0), 
          TSeq(Tclass.NativeTypes.byte())));

function JournalistMarshallingModel.__default.writeIntOnto#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.writeIntOnto
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, idx#0: int, val#0: int :: 
  { JournalistMarshallingModel.__default.writeIntOnto#requires($ly, buf#0, numBlocks#0, idx#0, val#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= numBlocks#0
       && numBlocks#0 < 18446744073709551616
       && 
      LitInt(0) <= idx#0
       && idx#0 < 18446744073709551616
       && 
      LitInt(0) <= val#0
       && val#0 < 4294967296
     ==> JournalistMarshallingModel.__default.writeIntOnto#requires($ly, buf#0, numBlocks#0, idx#0, val#0)
       == (
        Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
         && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
         && LitInt(0) <= idx#0
         && idx#0 + 4 <= Mul(numBlocks#0, LitInt(4064))));

// definition axiom for JournalistMarshallingModel.__default.writeIntOnto(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, idx#0: int, val#0: int :: 
    { JournalistMarshallingModel.__default.writeIntOnto($LS($ly), buf#0, numBlocks#0, idx#0, val#0) } 
    JournalistMarshallingModel.__default.writeIntOnto#canCall(buf#0, numBlocks#0, idx#0, val#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && 
          LitInt(0) <= val#0
           && val#0 < 4294967296
           && 
          Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && LitInt(0) <= idx#0
           && idx#0 + 4 <= Mul(numBlocks#0, LitInt(4064)))
       ==> PackedIntsLib.__default.pack__LittleEndian__Uint32#canCall(val#0)
         && (var t#0 := PackedIntsLib.__default.pack__LittleEndian__Uint32(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32, val#0); 
          JournalistMarshallingModel.__default.writeOnto#canCall(buf#0, numBlocks#0, idx#0, t#0))
         && JournalistMarshallingModel.__default.writeIntOnto($LS($ly), buf#0, numBlocks#0, idx#0, val#0)
           == (var t#0 := PackedIntsLib.__default.pack__LittleEndian__Uint32(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32, val#0); 
            JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
              buf#0, 
              numBlocks#0, 
              idx#0, 
              t#0)));

// definition axiom for JournalistMarshallingModel.__default.writeIntOnto for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, idx#0: int, val#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.writeIntOnto($LS($ly), Lit(buf#0), LitInt(numBlocks#0), LitInt(idx#0), LitInt(val#0)) } 
    JournalistMarshallingModel.__default.writeIntOnto#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(idx#0), LitInt(val#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && 
          LitInt(0) <= val#0
           && val#0 < 4294967296
           && 
          Seq#Length(Lit(buf#0)) == LitInt(Mul(LitInt(4096), LitInt(numBlocks#0)))
           && LitInt(numBlocks#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && LitInt(0) <= LitInt(idx#0)
           && LitInt(idx#0 + 4) <= LitInt(Mul(LitInt(numBlocks#0), LitInt(4064))))
       ==> PackedIntsLib.__default.pack__LittleEndian__Uint32#canCall(LitInt(val#0))
         && (var t#1 := PackedIntsLib.__default.pack__LittleEndian__Uint32(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32, LitInt(val#0)); 
          JournalistMarshallingModel.__default.writeOnto#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(idx#0), t#1))
         && JournalistMarshallingModel.__default.writeIntOnto($LS($ly), Lit(buf#0), LitInt(numBlocks#0), LitInt(idx#0), LitInt(val#0))
           == (var t#1 := PackedIntsLib.__default.pack__LittleEndian__Uint32(StartFuel_PackedIntsLib._default.pack_LittleEndian_Uint32, LitInt(val#0)); 
            JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
              Lit(buf#0), 
              LitInt(numBlocks#0), 
              LitInt(idx#0), 
              t#1)));

// function declaration for JournalistMarshallingModel._default.writeOntoAgrees
function JournalistMarshallingModel.__default.writeOntoAgrees(buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box, i#0: int)
   : bool;

function JournalistMarshallingModel.__default.writeOntoAgrees#canCall(buf#0: Seq Box, numBlocks#0: int, start#0: int, bytes#0: Seq Box, i#0: int)
   : bool;

function JournalistMarshallingModel.__default.writeOnto#Handle(LayerType) : HandleType;

axiom (forall $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Box, 
    $fh$0x#1: Box, 
    $fh$0x#2: Box, 
    $fh$0x#3: Box :: 
  { Apply4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      TSeq(Tclass.NativeTypes.byte()), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3) } 
  Apply4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      TSeq(Tclass.NativeTypes.byte()), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3)
     == $Box(JournalistMarshallingModel.__default.writeOnto($ly, 
        $Unbox($fh$0x#0): Seq Box, 
        $Unbox($fh$0x#1): int, 
        $Unbox($fh$0x#2): int, 
        $Unbox($fh$0x#3): Seq Box)));

axiom (forall $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Box, 
    $fh$0x#1: Box, 
    $fh$0x#2: Box, 
    $fh$0x#3: Box :: 
  { Requires4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      TSeq(Tclass.NativeTypes.byte()), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3) } 
  Requires4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      TSeq(Tclass.NativeTypes.byte()), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3)
     == JournalistMarshallingModel.__default.writeOnto#requires($ly, 
      $Unbox($fh$0x#0): Seq Box, 
      $Unbox($fh$0x#1): int, 
      $Unbox($fh$0x#2): int, 
      $Unbox($fh$0x#3): Seq Box));

axiom (forall $bx: Box, 
    $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Box, 
    $fh$0x#1: Box, 
    $fh$0x#2: Box, 
    $fh$0x#3: Box :: 
  { Reads4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      TSeq(Tclass.NativeTypes.byte()), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3)[$bx] } 
  Reads4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      TSeq(Tclass.NativeTypes.byte()), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3)[$bx]
     == false);

axiom (forall $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Seq Box, 
    $fh$0x#1: int, 
    $fh$0x#2: int, 
    $fh$0x#3: Seq Box :: 
  { JournalistMarshallingModel.__default.writeOnto($ly, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3), $IsGoodHeap($heap) } 
  JournalistMarshallingModel.__default.writeOnto($ly, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3)
     == $Unbox(Apply4(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.NativeTypes.uint64(), 
        Tclass.NativeTypes.uint64(), 
        TSeq(Tclass.NativeTypes.byte()), 
        TSeq(Tclass.NativeTypes.byte()), 
        $heap, 
        JournalistMarshallingModel.__default.writeOnto#Handle($ly), 
        $Box($fh$0x#0), 
        $Box($fh$0x#1), 
        $Box($fh$0x#2), 
        $Box($fh$0x#3))): Seq Box);

// consequence axiom for JournalistMarshallingModel.__default.writeOntoAgrees
axiom true
   ==> (forall $Heap: Heap, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      start#0: int, 
      bytes#0: Seq Box, 
      i#0: int :: 
    { JournalistMarshallingModel.__default.writeOntoAgrees(buf#0, numBlocks#0, start#0, bytes#0, i#0), $IsGoodHeap($Heap) } 
    JournalistMarshallingModel.__default.writeOntoAgrees#canCall(buf#0, numBlocks#0, start#0, bytes#0, i#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Requires4(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.NativeTypes.uint64(), 
            Tclass.NativeTypes.uint64(), 
            TSeq(Tclass.NativeTypes.byte()), 
            TSeq(Tclass.NativeTypes.byte()), 
            $Heap, 
            JournalistMarshallingModel.__default.writeOnto#Handle(StartFuel_JournalistMarshallingModel._default.writeOnto), 
            $Box(buf#0), 
            $Box(numBlocks#0), 
            $Box(start#0), 
            $Box(bytes#0))
           && 
          LitInt(0) <= i#0
           && i#0 < start#0)
       ==> true);

function JournalistMarshallingModel.__default.writeOntoAgrees#requires(Seq Box, int, int, Seq Box, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.writeOntoAgrees
axiom (forall $Heap: Heap, 
    buf#0: Seq Box, 
    numBlocks#0: int, 
    start#0: int, 
    bytes#0: Seq Box, 
    i#0: int :: 
  { JournalistMarshallingModel.__default.writeOntoAgrees#requires(buf#0, numBlocks#0, start#0, bytes#0, i#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= numBlocks#0
       && numBlocks#0 < 18446744073709551616
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalistMarshallingModel.__default.writeOntoAgrees#requires(buf#0, numBlocks#0, start#0, bytes#0, i#0)
       == (Requires4(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.NativeTypes.uint64(), 
          Tclass.NativeTypes.uint64(), 
          TSeq(Tclass.NativeTypes.byte()), 
          TSeq(Tclass.NativeTypes.byte()), 
          $Heap, 
          JournalistMarshallingModel.__default.writeOnto#Handle(StartFuel_JournalistMarshallingModel._default.writeOnto), 
          $Box(buf#0), 
          $Box(numBlocks#0), 
          $Box(start#0), 
          $Box(bytes#0))
         && 
        LitInt(0) <= i#0
         && i#0 < start#0));

// definition axiom for JournalistMarshallingModel.__default.writeOntoAgrees(revealed)
axiom true
   ==> (forall $Heap: Heap, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      start#0: int, 
      bytes#0: Seq Box, 
      i#0: int :: 
    { JournalistMarshallingModel.__default.writeOntoAgrees(buf#0, numBlocks#0, start#0, bytes#0, i#0), $IsGoodHeap($Heap) } 
    JournalistMarshallingModel.__default.writeOntoAgrees#canCall(buf#0, numBlocks#0, start#0, bytes#0, i#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Requires4(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.NativeTypes.uint64(), 
            Tclass.NativeTypes.uint64(), 
            TSeq(Tclass.NativeTypes.byte()), 
            TSeq(Tclass.NativeTypes.byte()), 
            $Heap, 
            JournalistMarshallingModel.__default.writeOnto#Handle(StartFuel_JournalistMarshallingModel._default.writeOnto), 
            $Box(buf#0), 
            $Box(numBlocks#0), 
            $Box(start#0), 
            $Box(bytes#0))
           && 
          LitInt(0) <= i#0
           && i#0 < start#0)
       ==> JournalistMarshallingModel.__default.writeOnto#canCall(buf#0, numBlocks#0, start#0, bytes#0)
         && JournalistMarshallingModel.__default.withoutChecksums#canCall(JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
            buf#0, 
            numBlocks#0, 
            start#0, 
            bytes#0), 
          numBlocks#0)
         && JournalistMarshallingModel.__default.withoutChecksums#canCall(buf#0, numBlocks#0)
         && JournalistMarshallingModel.__default.writeOntoAgrees(buf#0, numBlocks#0, start#0, bytes#0, i#0)
           == 
          ($Unbox(Seq#Index(JournalistMarshallingModel.__default.withoutChecksums(StartFuel_JournalistMarshallingModel._default.withoutChecksums, 
                JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                  buf#0, 
                  numBlocks#0, 
                  start#0, 
                  bytes#0), 
                numBlocks#0), 
              i#0)): int
           == $Unbox(Seq#Index(JournalistMarshallingModel.__default.withoutChecksums(StartFuel_JournalistMarshallingModel._default.withoutChecksums, 
                buf#0, 
                numBlocks#0), 
              i#0)): int));

// definition axiom for JournalistMarshallingModel.__default.writeOntoAgrees for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      start#0: int, 
      bytes#0: Seq Box, 
      i#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.writeOntoAgrees(Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), Lit(bytes#0), LitInt(i#0)), $IsGoodHeap($Heap) } 
    JournalistMarshallingModel.__default.writeOntoAgrees#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), Lit(bytes#0), LitInt(i#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Requires4(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.NativeTypes.uint64(), 
            Tclass.NativeTypes.uint64(), 
            TSeq(Tclass.NativeTypes.byte()), 
            TSeq(Tclass.NativeTypes.byte()), 
            $Heap, 
            JournalistMarshallingModel.__default.writeOnto#Handle(StartFuel_JournalistMarshallingModel._default.writeOnto), 
            $Box(Lit(buf#0)), 
            $Box(LitInt(numBlocks#0)), 
            $Box(LitInt(start#0)), 
            $Box(Lit(bytes#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < start#0)
       ==> JournalistMarshallingModel.__default.writeOnto#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), Lit(bytes#0))
         && JournalistMarshallingModel.__default.withoutChecksums#canCall(JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
            Lit(buf#0), 
            LitInt(numBlocks#0), 
            LitInt(start#0), 
            Lit(bytes#0)), 
          LitInt(numBlocks#0))
         && JournalistMarshallingModel.__default.withoutChecksums#canCall(Lit(buf#0), LitInt(numBlocks#0))
         && JournalistMarshallingModel.__default.writeOntoAgrees(Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), Lit(bytes#0), LitInt(i#0))
           == 
          ($Unbox(Seq#Index(JournalistMarshallingModel.__default.withoutChecksums(StartFuel_JournalistMarshallingModel._default.withoutChecksums, 
                JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                  Lit(buf#0), 
                  LitInt(numBlocks#0), 
                  LitInt(start#0), 
                  Lit(bytes#0)), 
                LitInt(numBlocks#0)), 
              LitInt(i#0))): int
           == $Unbox(Seq#Index(JournalistMarshallingModel.__default.withoutChecksums(StartFuel_JournalistMarshallingModel._default.withoutChecksums, 
                Lit(buf#0), 
                LitInt(numBlocks#0)), 
              LitInt(i#0))): int));

// function declaration for JournalistMarshallingModel._default.writeIntOntoAgrees
function JournalistMarshallingModel.__default.writeIntOntoAgrees(buf#0: Seq Box, numBlocks#0: int, start#0: int, val#0: int, i#0: int) : bool;

function JournalistMarshallingModel.__default.writeIntOntoAgrees#canCall(buf#0: Seq Box, numBlocks#0: int, start#0: int, val#0: int, i#0: int) : bool;

function JournalistMarshallingModel.__default.writeIntOnto#Handle(LayerType) : HandleType;

axiom (forall $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Box, 
    $fh$0x#1: Box, 
    $fh$0x#2: Box, 
    $fh$0x#3: Box :: 
  { Apply4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint32(), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeIntOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3) } 
  Apply4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint32(), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeIntOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3)
     == $Box(JournalistMarshallingModel.__default.writeIntOnto($ly, 
        $Unbox($fh$0x#0): Seq Box, 
        $Unbox($fh$0x#1): int, 
        $Unbox($fh$0x#2): int, 
        $Unbox($fh$0x#3): int)));

axiom (forall $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Box, 
    $fh$0x#1: Box, 
    $fh$0x#2: Box, 
    $fh$0x#3: Box :: 
  { Requires4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint32(), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeIntOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3) } 
  Requires4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint32(), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeIntOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3)
     == JournalistMarshallingModel.__default.writeIntOnto#requires($ly, 
      $Unbox($fh$0x#0): Seq Box, 
      $Unbox($fh$0x#1): int, 
      $Unbox($fh$0x#2): int, 
      $Unbox($fh$0x#3): int));

axiom (forall $bx: Box, 
    $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Box, 
    $fh$0x#1: Box, 
    $fh$0x#2: Box, 
    $fh$0x#3: Box :: 
  { Reads4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint32(), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeIntOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3)[$bx] } 
  Reads4(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint64(), 
      Tclass.NativeTypes.uint32(), 
      TSeq(Tclass.NativeTypes.byte()), 
      $heap, 
      JournalistMarshallingModel.__default.writeIntOnto#Handle($ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2, 
      $fh$0x#3)[$bx]
     == false);

axiom (forall $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Seq Box, 
    $fh$0x#1: int, 
    $fh$0x#2: int, 
    $fh$0x#3: int :: 
  { JournalistMarshallingModel.__default.writeIntOnto($ly, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3), $IsGoodHeap($heap) } 
  JournalistMarshallingModel.__default.writeIntOnto($ly, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3)
     == $Unbox(Apply4(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.NativeTypes.uint64(), 
        Tclass.NativeTypes.uint64(), 
        Tclass.NativeTypes.uint32(), 
        TSeq(Tclass.NativeTypes.byte()), 
        $heap, 
        JournalistMarshallingModel.__default.writeIntOnto#Handle($ly), 
        $Box($fh$0x#0), 
        $Box($fh$0x#1), 
        $Box($fh$0x#2), 
        $Box($fh$0x#3))): Seq Box);

// consequence axiom for JournalistMarshallingModel.__default.writeIntOntoAgrees
axiom true
   ==> (forall $Heap: Heap, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      start#0: int, 
      val#0: int, 
      i#0: int :: 
    { JournalistMarshallingModel.__default.writeIntOntoAgrees(buf#0, numBlocks#0, start#0, val#0, i#0), $IsGoodHeap($Heap) } 
    JournalistMarshallingModel.__default.writeIntOntoAgrees#canCall(buf#0, numBlocks#0, start#0, val#0, i#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= val#0
           && val#0 < 4294967296
           && 
          Requires4(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.NativeTypes.uint64(), 
            Tclass.NativeTypes.uint64(), 
            Tclass.NativeTypes.uint32(), 
            TSeq(Tclass.NativeTypes.byte()), 
            $Heap, 
            JournalistMarshallingModel.__default.writeIntOnto#Handle(StartFuel_JournalistMarshallingModel._default.writeIntOnto), 
            $Box(buf#0), 
            $Box(numBlocks#0), 
            $Box(start#0), 
            $Box(val#0))
           && 
          LitInt(0) <= i#0
           && i#0 < start#0)
       ==> true);

function JournalistMarshallingModel.__default.writeIntOntoAgrees#requires(Seq Box, int, int, int, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.writeIntOntoAgrees
axiom (forall $Heap: Heap, 
    buf#0: Seq Box, 
    numBlocks#0: int, 
    start#0: int, 
    val#0: int, 
    i#0: int :: 
  { JournalistMarshallingModel.__default.writeIntOntoAgrees#requires(buf#0, numBlocks#0, start#0, val#0, i#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= numBlocks#0
       && numBlocks#0 < 18446744073709551616
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= val#0
       && val#0 < 4294967296
     ==> JournalistMarshallingModel.__default.writeIntOntoAgrees#requires(buf#0, numBlocks#0, start#0, val#0, i#0)
       == (Requires4(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.NativeTypes.uint64(), 
          Tclass.NativeTypes.uint64(), 
          Tclass.NativeTypes.uint32(), 
          TSeq(Tclass.NativeTypes.byte()), 
          $Heap, 
          JournalistMarshallingModel.__default.writeIntOnto#Handle(StartFuel_JournalistMarshallingModel._default.writeIntOnto), 
          $Box(buf#0), 
          $Box(numBlocks#0), 
          $Box(start#0), 
          $Box(val#0))
         && 
        LitInt(0) <= i#0
         && i#0 < start#0));

// definition axiom for JournalistMarshallingModel.__default.writeIntOntoAgrees(revealed)
axiom true
   ==> (forall $Heap: Heap, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      start#0: int, 
      val#0: int, 
      i#0: int :: 
    { JournalistMarshallingModel.__default.writeIntOntoAgrees(buf#0, numBlocks#0, start#0, val#0, i#0), $IsGoodHeap($Heap) } 
    JournalistMarshallingModel.__default.writeIntOntoAgrees#canCall(buf#0, numBlocks#0, start#0, val#0, i#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= val#0
           && val#0 < 4294967296
           && 
          Requires4(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.NativeTypes.uint64(), 
            Tclass.NativeTypes.uint64(), 
            Tclass.NativeTypes.uint32(), 
            TSeq(Tclass.NativeTypes.byte()), 
            $Heap, 
            JournalistMarshallingModel.__default.writeIntOnto#Handle(StartFuel_JournalistMarshallingModel._default.writeIntOnto), 
            $Box(buf#0), 
            $Box(numBlocks#0), 
            $Box(start#0), 
            $Box(val#0))
           && 
          LitInt(0) <= i#0
           && i#0 < start#0)
       ==> JournalistMarshallingModel.__default.writeIntOnto#canCall(buf#0, numBlocks#0, start#0, val#0)
         && JournalistMarshallingModel.__default.withoutChecksums#canCall(JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
            buf#0, 
            numBlocks#0, 
            start#0, 
            val#0), 
          numBlocks#0)
         && JournalistMarshallingModel.__default.withoutChecksums#canCall(buf#0, numBlocks#0)
         && JournalistMarshallingModel.__default.writeIntOntoAgrees(buf#0, numBlocks#0, start#0, val#0, i#0)
           == 
          ($Unbox(Seq#Index(JournalistMarshallingModel.__default.withoutChecksums(StartFuel_JournalistMarshallingModel._default.withoutChecksums, 
                JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                  buf#0, 
                  numBlocks#0, 
                  start#0, 
                  val#0), 
                numBlocks#0), 
              i#0)): int
           == $Unbox(Seq#Index(JournalistMarshallingModel.__default.withoutChecksums(StartFuel_JournalistMarshallingModel._default.withoutChecksums, 
                buf#0, 
                numBlocks#0), 
              i#0)): int));

// definition axiom for JournalistMarshallingModel.__default.writeIntOntoAgrees for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      start#0: int, 
      val#0: int, 
      i#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.writeIntOntoAgrees(Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), LitInt(val#0), LitInt(i#0)), $IsGoodHeap($Heap) } 
    JournalistMarshallingModel.__default.writeIntOntoAgrees#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), LitInt(val#0), LitInt(i#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= val#0
           && val#0 < 4294967296
           && 
          Requires4(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.NativeTypes.uint64(), 
            Tclass.NativeTypes.uint64(), 
            Tclass.NativeTypes.uint32(), 
            TSeq(Tclass.NativeTypes.byte()), 
            $Heap, 
            JournalistMarshallingModel.__default.writeIntOnto#Handle(StartFuel_JournalistMarshallingModel._default.writeIntOnto), 
            $Box(Lit(buf#0)), 
            $Box(LitInt(numBlocks#0)), 
            $Box(LitInt(start#0)), 
            $Box(LitInt(val#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < start#0)
       ==> JournalistMarshallingModel.__default.writeIntOnto#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), LitInt(val#0))
         && JournalistMarshallingModel.__default.withoutChecksums#canCall(JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
            Lit(buf#0), 
            LitInt(numBlocks#0), 
            LitInt(start#0), 
            LitInt(val#0)), 
          LitInt(numBlocks#0))
         && JournalistMarshallingModel.__default.withoutChecksums#canCall(Lit(buf#0), LitInt(numBlocks#0))
         && JournalistMarshallingModel.__default.writeIntOntoAgrees(Lit(buf#0), LitInt(numBlocks#0), LitInt(start#0), LitInt(val#0), LitInt(i#0))
           == 
          ($Unbox(Seq#Index(JournalistMarshallingModel.__default.withoutChecksums(StartFuel_JournalistMarshallingModel._default.withoutChecksums, 
                JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                  Lit(buf#0), 
                  LitInt(numBlocks#0), 
                  LitInt(start#0), 
                  LitInt(val#0)), 
                LitInt(numBlocks#0)), 
              LitInt(i#0))): int
           == $Unbox(Seq#Index(JournalistMarshallingModel.__default.withoutChecksums(StartFuel_JournalistMarshallingModel._default.withoutChecksums, 
                Lit(buf#0), 
                LitInt(numBlocks#0)), 
              LitInt(i#0))): int));

// function declaration for JournalistMarshallingModel._default.writeHeader
function JournalistMarshallingModel.__default.writeHeader(buf#0: Seq Box, numBlocks#0: int, len#0: int) : Seq Box;

function JournalistMarshallingModel.__default.writeHeader#canCall(buf#0: Seq Box, numBlocks#0: int, len#0: int) : bool;

// consequence axiom for JournalistMarshallingModel.__default.writeHeader
axiom true
   ==> (forall buf#0: Seq Box, numBlocks#0: int, len#0: int :: 
    { JournalistMarshallingModel.__default.writeHeader(buf#0, numBlocks#0, len#0) } 
    JournalistMarshallingModel.__default.writeHeader#canCall(buf#0, numBlocks#0, len#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
           && 
          LitInt(1) <= numBlocks#0
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && len#0 <= LitInt(4294967295))
       ==> Seq#Length(JournalistMarshallingModel.__default.writeHeader(buf#0, numBlocks#0, len#0))
           == Seq#Length(buf#0)
         && $Is(JournalistMarshallingModel.__default.writeHeader(buf#0, numBlocks#0, len#0), 
          TSeq(Tclass.NativeTypes.byte())));

function JournalistMarshallingModel.__default.writeHeader#requires(Seq Box, int, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.writeHeader
axiom (forall buf#0: Seq Box, numBlocks#0: int, len#0: int :: 
  { JournalistMarshallingModel.__default.writeHeader#requires(buf#0, numBlocks#0, len#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= numBlocks#0
       && numBlocks#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> JournalistMarshallingModel.__default.writeHeader#requires(buf#0, numBlocks#0, len#0)
       == (
        Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
         && 
        LitInt(1) <= numBlocks#0
         && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
         && len#0 <= LitInt(4294967295)));

// definition axiom for JournalistMarshallingModel.__default.writeHeader(revealed)
axiom true
   ==> (forall buf#0: Seq Box, numBlocks#0: int, len#0: int :: 
    { JournalistMarshallingModel.__default.writeHeader(buf#0, numBlocks#0, len#0) } 
    JournalistMarshallingModel.__default.writeHeader#canCall(buf#0, numBlocks#0, len#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
           && 
          LitInt(1) <= numBlocks#0
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && len#0 <= LitInt(4294967295))
       ==> JournalistMarshallingModel.__default.writeIntOnto#canCall(buf#0, numBlocks#0, LitInt(0), len#0)
         && (var buf1#0 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
              buf#0, 
              numBlocks#0, 
              LitInt(0), 
              len#0); 
          JournalistMarshallingModel.__default.writeIntOnto#canCall(buf1#0, numBlocks#0, LitInt(4), numBlocks#0))
         && JournalistMarshallingModel.__default.writeHeader(buf#0, numBlocks#0, len#0)
           == (var buf1#0 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                buf#0, 
                numBlocks#0, 
                LitInt(0), 
                len#0); 
            (var buf2#0 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                  buf1#0, 
                  numBlocks#0, 
                  LitInt(4), 
                  numBlocks#0); 
              buf2#0)));

// definition axiom for JournalistMarshallingModel.__default.writeHeader for all literals(revealed)
axiom true
   ==> (forall buf#0: Seq Box, numBlocks#0: int, len#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.writeHeader(Lit(buf#0), LitInt(numBlocks#0), LitInt(len#0)) } 
    JournalistMarshallingModel.__default.writeHeader#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(len#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Seq#Length(Lit(buf#0)) == LitInt(Mul(LitInt(4096), LitInt(numBlocks#0)))
           && 
          LitInt(1) <= LitInt(numBlocks#0)
           && LitInt(numBlocks#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && LitInt(len#0) <= LitInt(4294967295))
       ==> JournalistMarshallingModel.__default.writeIntOnto#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(0), LitInt(len#0))
         && (var buf1#1 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
              Lit(buf#0), 
              LitInt(numBlocks#0), 
              LitInt(0), 
              LitInt(len#0)); 
          JournalistMarshallingModel.__default.writeIntOnto#canCall(buf1#1, LitInt(numBlocks#0), LitInt(4), LitInt(numBlocks#0)))
         && JournalistMarshallingModel.__default.writeHeader(Lit(buf#0), LitInt(numBlocks#0), LitInt(len#0))
           == (var buf1#1 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                Lit(buf#0), 
                LitInt(numBlocks#0), 
                LitInt(0), 
                LitInt(len#0)); 
            (var buf2#1 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                  buf1#1, 
                  LitInt(numBlocks#0), 
                  LitInt(4), 
                  LitInt(numBlocks#0)); 
              buf2#1)));

// function declaration for JournalistMarshallingModel._default.writeJournalEntries
function JournalistMarshallingModel.__default.writeJournalEntries($ly: LayerType, 
    buf#0: Seq Box, 
    numBlocks#0: int, 
    idx#0: int, 
    entries#0: Seq Box, 
    start#0: int, 
    len#0: int)
   : Seq Box;

function JournalistMarshallingModel.__default.writeJournalEntries#canCall(buf#0: Seq Box, 
    numBlocks#0: int, 
    idx#0: int, 
    entries#0: Seq Box, 
    start#0: int, 
    len#0: int)
   : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    buf#0: Seq Box, 
    numBlocks#0: int, 
    idx#0: int, 
    entries#0: Seq Box, 
    start#0: int, 
    len#0: int :: 
  { JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0) } 
  JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0)
     == JournalistMarshallingModel.__default.writeJournalEntries($ly, buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    buf#0: Seq Box, 
    numBlocks#0: int, 
    idx#0: int, 
    entries#0: Seq Box, 
    start#0: int, 
    len#0: int :: 
  { JournalistMarshallingModel.__default.writeJournalEntries(AsFuelBottom($ly), buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0) } 
  JournalistMarshallingModel.__default.writeJournalEntries($ly, buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0)
     == JournalistMarshallingModel.__default.writeJournalEntries($LZ, buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0));

// consequence axiom for JournalistMarshallingModel.__default.writeJournalEntries
axiom true
   ==> (forall $ly: LayerType, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      idx#0: int, 
      entries#0: Seq Box, 
      start#0: int, 
      len#0: int :: 
    { JournalistMarshallingModel.__default.writeJournalEntries($ly, buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0) } 
    JournalistMarshallingModel.__default.writeJournalEntries#canCall(buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= start#0
           && start#0 < Seq#Length(entries#0)
           && 
          LitInt(0) <= len#0
           && len#0 <= Seq#Length(entries#0)
           && Seq#Length(entries#0) < 1152921504606846975
           && idx#0
               + JournalRanges.__default.SumJournalEntries($LS($LZ), 
                JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
                  StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
                  entries#0, 
                  start#0, 
                  len#0))
             <= Mul(LitInt(4064), numBlocks#0))
       ==> Seq#Length(JournalistMarshallingModel.__default.writeJournalEntries($ly, buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0))
           == Seq#Length(buf#0)
         && $Is(JournalistMarshallingModel.__default.writeJournalEntries($ly, buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0), 
          TSeq(Tclass.NativeTypes.byte())));

function JournalistMarshallingModel.__default.writeJournalEntries#requires(LayerType, Seq Box, int, int, Seq Box, int, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.writeJournalEntries
axiom (forall $ly: LayerType, 
    buf#0: Seq Box, 
    numBlocks#0: int, 
    idx#0: int, 
    entries#0: Seq Box, 
    start#0: int, 
    len#0: int :: 
  { JournalistMarshallingModel.__default.writeJournalEntries#requires($ly, buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= numBlocks#0
       && numBlocks#0 < 18446744073709551616
       && 
      LitInt(0) <= idx#0
       && idx#0 < 18446744073709551616
       && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> JournalistMarshallingModel.__default.writeJournalEntries#requires($ly, buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0)
       == (
        Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
         && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
         && 
        LitInt(0) <= start#0
         && start#0 < Seq#Length(entries#0)
         && 
        LitInt(0) <= len#0
         && len#0 <= Seq#Length(entries#0)
         && Seq#Length(entries#0) < 1152921504606846975
         && idx#0
             + JournalRanges.__default.SumJournalEntries($LS($LZ), 
              JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
                StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
                entries#0, 
                start#0, 
                len#0))
           <= Mul(LitInt(4064), numBlocks#0)));

// definition axiom for JournalistMarshallingModel.__default.writeJournalEntries(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      idx#0: int, 
      entries#0: Seq Box, 
      start#0: int, 
      len#0: int :: 
    { JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0) } 
    JournalistMarshallingModel.__default.writeJournalEntries#canCall(buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= start#0
           && start#0 < Seq#Length(entries#0)
           && 
          LitInt(0) <= len#0
           && len#0 <= Seq#Length(entries#0)
           && Seq#Length(entries#0) < 1152921504606846975
           && idx#0
               + JournalRanges.__default.SumJournalEntries($LS($LZ), 
                JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
                  StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
                  entries#0, 
                  start#0, 
                  len#0))
             <= Mul(LitInt(4064), numBlocks#0))
       ==> (len#0 != LitInt(0)
           ==> (var start'#0 := (if start#0 + 1 == Seq#Length(entries#0) then 0 else start#0 + 1); 
            Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
               && JournalistMarshallingModel.__default.writeIntOnto#canCall(buf#0, 
                numBlocks#0, 
                idx#0, 
                Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)))
               && (var buf0#0 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                    buf#0, 
                    numBlocks#0, 
                    idx#0, 
                    Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))); 
                (var idx1#0 := idx#0 + 4; 
                  Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                     && JournalistMarshallingModel.__default.writeOnto#canCall(buf0#0, 
                      numBlocks#0, 
                      idx1#0, 
                      Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))
                     && (var buf1#0 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                          buf0#0, 
                          numBlocks#0, 
                          idx1#0, 
                          Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                      Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                         && (var idx2#0 := idx1#0
                               + Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                          Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                             && JournalistMarshallingModel.__default.writeIntOnto#canCall(buf1#0, 
                              numBlocks#0, 
                              idx2#0, 
                              Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)))
                             && (var buf2#0 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                                  buf1#0, 
                                  numBlocks#0, 
                                  idx2#0, 
                                  Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))); 
                              (var idx3#0 := idx2#0 + 4; 
                                Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                                   && JournalistMarshallingModel.__default.writeOnto#canCall(buf2#0, 
                                    numBlocks#0, 
                                    idx3#0, 
                                    Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))
                                   && (var buf3#0 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                                        buf2#0, 
                                        numBlocks#0, 
                                        idx3#0, 
                                        Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                                    Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                                       && (var idx4#0 := idx3#0
                                             + Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                                        JournalistMarshallingModel.__default.writeJournalEntries#canCall(buf3#0, numBlocks#0, idx4#0, entries#0, start'#0, len#0 - 1)))))))))))
         && JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), buf#0, numBlocks#0, idx#0, entries#0, start#0, len#0)
           == (if len#0 == LitInt(0)
             then buf#0
             else (var start'#0 := (if start#0 + 1 == Seq#Length(entries#0) then 0 else start#0 + 1); 
              (var buf0#0 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                    buf#0, 
                    numBlocks#0, 
                    idx#0, 
                    Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))); 
                (var idx1#0 := idx#0 + 4; 
                  (var buf1#0 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                        buf0#0, 
                        numBlocks#0, 
                        idx1#0, 
                        Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                    (var idx2#0 := idx1#0
                           + Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                      (var buf2#0 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                            buf1#0, 
                            numBlocks#0, 
                            idx2#0, 
                            Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))); 
                        (var idx3#0 := idx2#0 + 4; 
                          (var buf3#0 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                                buf2#0, 
                                numBlocks#0, 
                                idx3#0, 
                                Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                            (var idx4#0 := idx3#0
                                   + Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                              JournalistMarshallingModel.__default.writeJournalEntries($ly, buf3#0, numBlocks#0, idx4#0, entries#0, start'#0, len#0 - 1))))))))))));

// definition axiom for JournalistMarshallingModel.__default.writeJournalEntries for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      idx#0: int, 
      entries#0: Seq Box, 
      start#0: int, 
      len#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), buf#0, numBlocks#0, idx#0, entries#0, start#0, LitInt(len#0)) } 
    JournalistMarshallingModel.__default.writeJournalEntries#canCall(buf#0, numBlocks#0, idx#0, entries#0, start#0, LitInt(len#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Seq#Length(buf#0) == Mul(LitInt(4096), numBlocks#0)
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= start#0
           && start#0 < Seq#Length(entries#0)
           && 
          LitInt(0) <= LitInt(len#0)
           && LitInt(len#0) <= Seq#Length(entries#0)
           && Seq#Length(entries#0) < 1152921504606846975
           && idx#0
               + JournalRanges.__default.SumJournalEntries($LS($LZ), 
                JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
                  StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
                  entries#0, 
                  start#0, 
                  LitInt(len#0)))
             <= Mul(LitInt(4064), numBlocks#0))
       ==> (LitInt(len#0) != LitInt(0)
           ==> (var start'#1 := (if start#0 + 1 == Seq#Length(entries#0) then 0 else start#0 + 1); 
            Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
               && JournalistMarshallingModel.__default.writeIntOnto#canCall(buf#0, 
                numBlocks#0, 
                idx#0, 
                Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)))
               && (var buf0#1 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                    buf#0, 
                    numBlocks#0, 
                    idx#0, 
                    Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))); 
                (var idx1#1 := idx#0 + 4; 
                  Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                     && JournalistMarshallingModel.__default.writeOnto#canCall(buf0#1, 
                      numBlocks#0, 
                      idx1#1, 
                      Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))
                     && (var buf1#1 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                          buf0#1, 
                          numBlocks#0, 
                          idx1#1, 
                          Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                      Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                         && (var idx2#1 := idx1#1
                               + Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                          Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                             && JournalistMarshallingModel.__default.writeIntOnto#canCall(buf1#1, 
                              numBlocks#0, 
                              idx2#1, 
                              Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)))
                             && (var buf2#1 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                                  buf1#1, 
                                  numBlocks#0, 
                                  idx2#1, 
                                  Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))); 
                              (var idx3#1 := idx2#1 + 4; 
                                Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                                   && JournalistMarshallingModel.__default.writeOnto#canCall(buf2#1, 
                                    numBlocks#0, 
                                    idx3#1, 
                                    Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))
                                   && (var buf3#1 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                                        buf2#1, 
                                        numBlocks#0, 
                                        idx3#1, 
                                        Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                                    Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)
                                       && (var idx4#1 := idx3#1
                                             + Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                                        JournalistMarshallingModel.__default.writeJournalEntries#canCall(buf3#1, numBlocks#0, idx4#1, entries#0, start'#1, LitInt(len#0 - 1))))))))))))
         && JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), buf#0, numBlocks#0, idx#0, entries#0, start#0, LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then buf#0
             else (var start'#1 := (if start#0 + 1 == Seq#Length(entries#0) then 0 else start#0 + 1); 
              (var buf0#1 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                    buf#0, 
                    numBlocks#0, 
                    idx#0, 
                    Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))); 
                (var idx1#1 := idx#0 + 4; 
                  (var buf1#1 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                        buf0#1, 
                        numBlocks#0, 
                        idx1#1, 
                        Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                    (var idx2#1 := idx1#1
                           + Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                      (var buf2#1 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                            buf1#1, 
                            numBlocks#0, 
                            idx2#1, 
                            Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType))); 
                        (var idx3#1 := idx2#1 + 4; 
                          (var buf3#1 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                                buf2#1, 
                                numBlocks#0, 
                                idx3#1, 
                                Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                            (var idx4#1 := idx3#1
                                   + Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(entries#0, start#0)): DatatypeType)); 
                              JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), buf3#1, numBlocks#0, idx4#1, entries#0, start'#1, LitInt(len#0 - 1)))))))))))));

// definition axiom for JournalistMarshallingModel.__default.writeJournalEntries for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      buf#0: Seq Box, 
      numBlocks#0: int, 
      idx#0: int, 
      entries#0: Seq Box, 
      start#0: int, 
      len#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), 
        Lit(buf#0), 
        LitInt(numBlocks#0), 
        LitInt(idx#0), 
        Lit(entries#0), 
        LitInt(start#0), 
        LitInt(len#0)) } 
    JournalistMarshallingModel.__default.writeJournalEntries#canCall(Lit(buf#0), 
          LitInt(numBlocks#0), 
          LitInt(idx#0), 
          Lit(entries#0), 
          LitInt(start#0), 
          LitInt(len#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Seq#Length(Lit(buf#0)) == LitInt(Mul(LitInt(4096), LitInt(numBlocks#0)))
           && LitInt(numBlocks#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 < Seq#Length(Lit(entries#0))
           && 
          LitInt(0) <= LitInt(len#0)
           && LitInt(len#0) <= Seq#Length(Lit(entries#0))
           && Seq#Length(Lit(entries#0)) < 1152921504606846975
           && idx#0
               + JournalRanges.__default.SumJournalEntries($LS($LZ), 
                JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
                  StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
                  Lit(entries#0), 
                  LitInt(start#0), 
                  LitInt(len#0)))
             <= LitInt(Mul(LitInt(4064), LitInt(numBlocks#0))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> (var start'#2 := (if LitInt(start#0 + 1) == Seq#Length(Lit(entries#0)) then 0 else start#0 + 1); 
            Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)
               && JournalistMarshallingModel.__default.writeIntOnto#canCall(Lit(buf#0), 
                LitInt(numBlocks#0), 
                LitInt(idx#0), 
                Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)))
               && (var buf0#2 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                    Lit(buf#0), 
                    LitInt(numBlocks#0), 
                    LitInt(idx#0), 
                    Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType))); 
                (var idx1#2 := LitInt(idx#0 + 4); 
                  Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)
                     && JournalistMarshallingModel.__default.writeOnto#canCall(buf0#2, 
                      LitInt(numBlocks#0), 
                      idx1#2, 
                      Journal.JournalEntry.key($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType))
                     && (var buf1#2 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                          buf0#2, 
                          LitInt(numBlocks#0), 
                          idx1#2, 
                          Journal.JournalEntry.key($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)); 
                      Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)
                         && (var idx2#2 := idx1#2
                               + Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)); 
                          Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)
                             && JournalistMarshallingModel.__default.writeIntOnto#canCall(buf1#2, 
                              LitInt(numBlocks#0), 
                              idx2#2, 
                              Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)))
                             && (var buf2#2 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                                  buf1#2, 
                                  LitInt(numBlocks#0), 
                                  idx2#2, 
                                  Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType))); 
                              (var idx3#2 := idx2#2 + 4; 
                                Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)
                                   && JournalistMarshallingModel.__default.writeOnto#canCall(buf2#2, 
                                    LitInt(numBlocks#0), 
                                    idx3#2, 
                                    Journal.JournalEntry.value($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType))
                                   && (var buf3#2 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                                        buf2#2, 
                                        LitInt(numBlocks#0), 
                                        idx3#2, 
                                        Journal.JournalEntry.value($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)); 
                                    Journal.JournalEntry.JournalInsert_q($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)
                                       && (var idx4#2 := idx3#2
                                             + Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)); 
                                        JournalistMarshallingModel.__default.writeJournalEntries#canCall(buf3#2, LitInt(numBlocks#0), idx4#2, Lit(entries#0), start'#2, LitInt(len#0 - 1))))))))))))
         && JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), 
            Lit(buf#0), 
            LitInt(numBlocks#0), 
            LitInt(idx#0), 
            Lit(entries#0), 
            LitInt(start#0), 
            LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then buf#0
             else (var start'#2 := (if LitInt(start#0 + 1) == Seq#Length(Lit(entries#0)) then 0 else start#0 + 1); 
              (var buf0#2 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                    Lit(buf#0), 
                    LitInt(numBlocks#0), 
                    LitInt(idx#0), 
                    Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType))); 
                (var idx1#2 := LitInt(idx#0 + 4); 
                  (var buf1#2 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                        buf0#2, 
                        LitInt(numBlocks#0), 
                        idx1#2, 
                        Journal.JournalEntry.key($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)); 
                    (var idx2#2 := idx1#2
                           + Seq#Length(Journal.JournalEntry.key($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)); 
                      (var buf2#2 := JournalistMarshallingModel.__default.writeIntOnto(StartFuel_JournalistMarshallingModel._default.writeIntOnto, 
                            buf1#2, 
                            LitInt(numBlocks#0), 
                            idx2#2, 
                            Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType))); 
                        (var idx3#2 := idx2#2 + 4; 
                          (var buf3#2 := JournalistMarshallingModel.__default.writeOnto(StartFuel_JournalistMarshallingModel._default.writeOnto, 
                                buf2#2, 
                                LitInt(numBlocks#0), 
                                idx3#2, 
                                Journal.JournalEntry.value($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)); 
                            (var idx4#2 := idx3#2
                                   + Seq#Length(Journal.JournalEntry.value($Unbox(Seq#Index(Lit(entries#0), LitInt(start#0))): DatatypeType)); 
                              JournalistMarshallingModel.__default.writeJournalEntries($LS($ly), 
                                buf3#2, 
                                LitInt(numBlocks#0), 
                                idx4#2, 
                                Lit(entries#0), 
                                start'#2, 
                                LitInt(len#0 - 1)))))))))))));

// function declaration for JournalistMarshallingModel._default.fillInChecksums
function JournalistMarshallingModel.__default.fillInChecksums($ly: LayerType, buf#0: Seq Box, numBlocks#0: int, i#0: int) : Seq Box;

function JournalistMarshallingModel.__default.fillInChecksums#canCall(buf#0: Seq Box, numBlocks#0: int, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, i#0: int :: 
  { JournalistMarshallingModel.__default.fillInChecksums($LS($ly), buf#0, numBlocks#0, i#0) } 
  JournalistMarshallingModel.__default.fillInChecksums($LS($ly), buf#0, numBlocks#0, i#0)
     == JournalistMarshallingModel.__default.fillInChecksums($ly, buf#0, numBlocks#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, i#0: int :: 
  { JournalistMarshallingModel.__default.fillInChecksums(AsFuelBottom($ly), buf#0, numBlocks#0, i#0) } 
  JournalistMarshallingModel.__default.fillInChecksums($ly, buf#0, numBlocks#0, i#0)
     == JournalistMarshallingModel.__default.fillInChecksums($LZ, buf#0, numBlocks#0, i#0));

// consequence axiom for JournalistMarshallingModel.__default.fillInChecksums
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, i#0: int :: 
    { JournalistMarshallingModel.__default.fillInChecksums($ly, buf#0, numBlocks#0, i#0) } 
    JournalistMarshallingModel.__default.fillInChecksums#canCall(buf#0, numBlocks#0, i#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Seq#Length(buf#0) == Mul(numBlocks#0, LitInt(4096))
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= i#0
           && i#0 <= numBlocks#0)
       ==> Seq#Length(JournalistMarshallingModel.__default.fillInChecksums($ly, buf#0, numBlocks#0, i#0))
           == Seq#Length(buf#0)
         && $Is(JournalistMarshallingModel.__default.fillInChecksums($ly, buf#0, numBlocks#0, i#0), 
          TSeq(Tclass.NativeTypes.byte())));

function JournalistMarshallingModel.__default.fillInChecksums#requires(LayerType, Seq Box, int, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.fillInChecksums
axiom (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, i#0: int :: 
  { JournalistMarshallingModel.__default.fillInChecksums#requires($ly, buf#0, numBlocks#0, i#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= numBlocks#0
       && numBlocks#0 < 18446744073709551616
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> JournalistMarshallingModel.__default.fillInChecksums#requires($ly, buf#0, numBlocks#0, i#0)
       == (
        Seq#Length(buf#0) == Mul(numBlocks#0, LitInt(4096))
         && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
         && 
        LitInt(0) <= i#0
         && i#0 <= numBlocks#0));

// definition axiom for JournalistMarshallingModel.__default.fillInChecksums(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, i#0: int :: 
    { JournalistMarshallingModel.__default.fillInChecksums($LS($ly), buf#0, numBlocks#0, i#0) } 
    JournalistMarshallingModel.__default.fillInChecksums#canCall(buf#0, numBlocks#0, i#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Seq#Length(buf#0) == Mul(numBlocks#0, LitInt(4096))
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= i#0
           && i#0 <= numBlocks#0)
       ==> (i#0 != numBlocks#0
           ==> Crypto.__default.Crc32C#canCall(Seq#Drop(Seq#Take(buf#0, Mul(LitInt(4096), i#0) + 4096), Mul(LitInt(4096), i#0) + 32))
             && JournalistMarshallingModel.__default.splice#canCall(buf#0, 
              Mul(LitInt(4096), i#0), 
              Crypto.__default.Crc32C(Seq#Drop(Seq#Take(buf#0, Mul(LitInt(4096), i#0) + 4096), Mul(LitInt(4096), i#0) + 32)))
             && (var buf1#0 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                  buf#0, 
                  Mul(LitInt(4096), i#0), 
                  Crypto.__default.Crc32C(Seq#Drop(Seq#Take(buf#0, Mul(LitInt(4096), i#0) + 4096), Mul(LitInt(4096), i#0) + 32))); 
              JournalistMarshallingModel.__default.fillInChecksums#canCall(buf1#0, numBlocks#0, i#0 + 1)))
         && JournalistMarshallingModel.__default.fillInChecksums($LS($ly), buf#0, numBlocks#0, i#0)
           == (if i#0 == numBlocks#0
             then buf#0
             else (var buf1#0 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                  buf#0, 
                  Mul(LitInt(4096), i#0), 
                  Crypto.__default.Crc32C(Seq#Drop(Seq#Take(buf#0, Mul(LitInt(4096), i#0) + 4096), Mul(LitInt(4096), i#0) + 32))); 
              JournalistMarshallingModel.__default.fillInChecksums($ly, buf1#0, numBlocks#0, i#0 + 1))));

// definition axiom for JournalistMarshallingModel.__default.fillInChecksums for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, i#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.fillInChecksums($LS($ly), buf#0, LitInt(numBlocks#0), LitInt(i#0)) } 
    JournalistMarshallingModel.__default.fillInChecksums#canCall(buf#0, LitInt(numBlocks#0), LitInt(i#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Seq#Length(buf#0) == LitInt(Mul(LitInt(numBlocks#0), LitInt(4096)))
           && LitInt(numBlocks#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(numBlocks#0))
       ==> (LitInt(i#0) != LitInt(numBlocks#0)
           ==> Crypto.__default.Crc32C#canCall(Seq#Drop(Seq#Take(buf#0, LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
                LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32)))
             && JournalistMarshallingModel.__default.splice#canCall(buf#0, 
              LitInt(Mul(LitInt(4096), LitInt(i#0))), 
              Crypto.__default.Crc32C(Seq#Drop(Seq#Take(buf#0, LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
                  LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32))))
             && (var buf1#1 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                  buf#0, 
                  LitInt(Mul(LitInt(4096), LitInt(i#0))), 
                  Crypto.__default.Crc32C(Seq#Drop(Seq#Take(buf#0, LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
                      LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32)))); 
              JournalistMarshallingModel.__default.fillInChecksums#canCall(buf1#1, LitInt(numBlocks#0), LitInt(i#0 + 1))))
         && JournalistMarshallingModel.__default.fillInChecksums($LS($ly), buf#0, LitInt(numBlocks#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(numBlocks#0)
             then buf#0
             else (var buf1#1 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                  buf#0, 
                  LitInt(Mul(LitInt(4096), LitInt(i#0))), 
                  Crypto.__default.Crc32C(Seq#Drop(Seq#Take(buf#0, LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
                      LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32)))); 
              JournalistMarshallingModel.__default.fillInChecksums($LS($ly), buf1#1, LitInt(numBlocks#0), LitInt(i#0 + 1)))));

// definition axiom for JournalistMarshallingModel.__default.fillInChecksums for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, numBlocks#0: int, i#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.fillInChecksums($LS($ly), Lit(buf#0), LitInt(numBlocks#0), LitInt(i#0)) } 
    JournalistMarshallingModel.__default.fillInChecksums#canCall(Lit(buf#0), LitInt(numBlocks#0), LitInt(i#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Seq#Length(Lit(buf#0)) == LitInt(Mul(LitInt(numBlocks#0), LitInt(4096)))
           && LitInt(numBlocks#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(numBlocks#0))
       ==> (LitInt(i#0) != LitInt(numBlocks#0)
           ==> Crypto.__default.Crc32C#canCall(Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
                  LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32))))
             && JournalistMarshallingModel.__default.splice#canCall(Lit(buf#0), 
              LitInt(Mul(LitInt(4096), LitInt(i#0))), 
              Crypto.__default.Crc32C(Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
                    LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32)))))
             && (var buf1#2 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                  Lit(buf#0), 
                  LitInt(Mul(LitInt(4096), LitInt(i#0))), 
                  Crypto.__default.Crc32C(Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
                        LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32))))); 
              JournalistMarshallingModel.__default.fillInChecksums#canCall(buf1#2, LitInt(numBlocks#0), LitInt(i#0 + 1))))
         && JournalistMarshallingModel.__default.fillInChecksums($LS($ly), Lit(buf#0), LitInt(numBlocks#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(numBlocks#0)
             then buf#0
             else (var buf1#2 := JournalistMarshallingModel.__default.splice(StartFuel_JournalistMarshallingModel._default.splice, 
                  Lit(buf#0), 
                  LitInt(Mul(LitInt(4096), LitInt(i#0))), 
                  Crypto.__default.Crc32C(Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
                        LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32))))); 
              JournalistMarshallingModel.__default.fillInChecksums($LS($ly), buf1#2, LitInt(numBlocks#0), LitInt(i#0 + 1)))));

// function declaration for JournalistMarshallingModel._default.hasHeader
function JournalistMarshallingModel.__default.hasHeader($ly: LayerType, buf#0: Seq Box, header#0: DatatypeType) : bool;

function JournalistMarshallingModel.__default.hasHeader#canCall(buf#0: Seq Box, header#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, header#0: DatatypeType :: 
  { JournalistMarshallingModel.__default.hasHeader($LS($ly), buf#0, header#0) } 
  JournalistMarshallingModel.__default.hasHeader($LS($ly), buf#0, header#0)
     == JournalistMarshallingModel.__default.hasHeader($ly, buf#0, header#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buf#0: Seq Box, header#0: DatatypeType :: 
  { JournalistMarshallingModel.__default.hasHeader(AsFuelBottom($ly), buf#0, header#0) } 
  JournalistMarshallingModel.__default.hasHeader($ly, buf#0, header#0)
     == JournalistMarshallingModel.__default.hasHeader($LZ, buf#0, header#0));

// consequence axiom for JournalistMarshallingModel.__default.hasHeader
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, header#0: DatatypeType :: 
    { JournalistMarshallingModel.__default.hasHeader($ly, buf#0, header#0) } 
    JournalistMarshallingModel.__default.hasHeader#canCall(buf#0, header#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(header#0, Tclass.JournalRanges.Header()))
       ==> true);

function JournalistMarshallingModel.__default.hasHeader#requires(LayerType, Seq Box, DatatypeType) : bool;

// #requires axiom for JournalistMarshallingModel.__default.hasHeader
axiom (forall $ly: LayerType, buf#0: Seq Box, header#0: DatatypeType :: 
  { JournalistMarshallingModel.__default.hasHeader#requires($ly, buf#0, header#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(header#0, Tclass.JournalRanges.Header())
     ==> JournalistMarshallingModel.__default.hasHeader#requires($ly, buf#0, header#0)
       == true);

// definition axiom for JournalistMarshallingModel.__default.hasHeader(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, header#0: DatatypeType :: 
    { JournalistMarshallingModel.__default.hasHeader($LS($ly), buf#0, header#0) } 
    JournalistMarshallingModel.__default.hasHeader#canCall(buf#0, header#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(header#0, Tclass.JournalRanges.Header()))
       ==> (Seq#Length(buf#0) >= LitInt(8)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(buf#0, LitInt(4)), LitInt(0)))
             && JournalRanges.Header.Header_q(header#0))
         && (NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(buf#0, LitInt(4)), LitInt(0)))
             && JournalRanges.Header.Header_q(header#0)
             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Seq#Drop(Seq#Take(buf#0, LitInt(4)), LitInt(0)))
               == JournalRanges.Header.nentries(header#0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(buf#0, LitInt(8)), LitInt(4)))
             && JournalRanges.Header.Header_q(header#0))
         && JournalistMarshallingModel.__default.hasHeader($LS($ly), buf#0, header#0)
           == (
            Seq#Length(buf#0) >= LitInt(8)
             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Seq#Drop(Seq#Take(buf#0, LitInt(4)), LitInt(0)))
               == JournalRanges.Header.nentries(header#0)
             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Seq#Drop(Seq#Take(buf#0, LitInt(8)), LitInt(4)))
               == JournalRanges.Header.nblocks(header#0)));

// definition axiom for JournalistMarshallingModel.__default.hasHeader for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buf#0: Seq Box, header#0: DatatypeType :: 
    {:weight 3} { JournalistMarshallingModel.__default.hasHeader($LS($ly), Lit(buf#0), Lit(header#0)) } 
    JournalistMarshallingModel.__default.hasHeader#canCall(Lit(buf#0), Lit(header#0))
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(header#0, Tclass.JournalRanges.Header()))
       ==> (Seq#Length(Lit(buf#0)) >= LitInt(8)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(4)), LitInt(0))))
             && JournalRanges.Header.Header_q(Lit(header#0)))
         && (NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(4)), LitInt(0))))
             && JournalRanges.Header.Header_q(Lit(header#0))
             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(4)), LitInt(0))))
               == LitInt(JournalRanges.Header.nentries(Lit(header#0)))
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(8)), LitInt(4))))
             && JournalRanges.Header.Header_q(Lit(header#0)))
         && JournalistMarshallingModel.__default.hasHeader($LS($ly), Lit(buf#0), Lit(header#0))
           == (
            Seq#Length(Lit(buf#0)) >= LitInt(8)
             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(4)), LitInt(0))))
               == LitInt(JournalRanges.Header.nentries(Lit(header#0)))
             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(8)), LitInt(4))))
               == LitInt(JournalRanges.Header.nblocks(Lit(header#0)))));

// function declaration for JournalistMarshallingModel._default.hasEntryAt
function JournalistMarshallingModel.__default.hasEntryAt(buf#0: Seq Box, entry#0: DatatypeType, start#0: int) : bool;

function JournalistMarshallingModel.__default.hasEntryAt#canCall(buf#0: Seq Box, entry#0: DatatypeType, start#0: int) : bool;

// consequence axiom for JournalistMarshallingModel.__default.hasEntryAt
axiom true
   ==> (forall buf#0: Seq Box, entry#0: DatatypeType, start#0: int :: 
    { JournalistMarshallingModel.__default.hasEntryAt(buf#0, entry#0, start#0) } 
    JournalistMarshallingModel.__default.hasEntryAt#canCall(buf#0, entry#0, start#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entry#0, Tclass.Journal.JournalEntry()))
       ==> true);

function JournalistMarshallingModel.__default.hasEntryAt#requires(Seq Box, DatatypeType, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.hasEntryAt
axiom (forall buf#0: Seq Box, entry#0: DatatypeType, start#0: int :: 
  { JournalistMarshallingModel.__default.hasEntryAt#requires(buf#0, entry#0, start#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(entry#0, Tclass.Journal.JournalEntry())
     ==> JournalistMarshallingModel.__default.hasEntryAt#requires(buf#0, entry#0, start#0)
       == true);

// definition axiom for JournalistMarshallingModel.__default.hasEntryAt(revealed)
axiom true
   ==> (forall buf#0: Seq Box, entry#0: DatatypeType, start#0: int :: 
    { JournalistMarshallingModel.__default.hasEntryAt(buf#0, entry#0, start#0) } 
    JournalistMarshallingModel.__default.hasEntryAt#canCall(buf#0, entry#0, start#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entry#0, Tclass.Journal.JournalEntry()))
       ==> (var idx0#0 := start#0; 
          (var idx1#0 := idx0#0 + 4; 
            Journal.JournalEntry.JournalInsert_q(entry#0)
               && (var idx2#0 := idx1#0 + Seq#Length(Journal.JournalEntry.key(entry#0)); 
                (var idx3#0 := idx2#0 + 4; 
                  Journal.JournalEntry.JournalInsert_q(entry#0)
                     && (var idx4#0 := idx3#0 + Seq#Length(Journal.JournalEntry.value(entry#0)); 
                      (idx4#0 <= Seq#Length(buf#0)
                           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(buf#0, idx1#0), idx0#0))
                             && Journal.JournalEntry.JournalInsert_q(entry#0))
                         && (NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(buf#0, idx1#0), idx0#0))
                             && Journal.JournalEntry.JournalInsert_q(entry#0)
                             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                                Seq#Drop(Seq#Take(buf#0, idx1#0), idx0#0))
                               == Seq#Length(Journal.JournalEntry.key(entry#0))
                           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(buf#0, idx3#0), idx2#0))
                             && Journal.JournalEntry.JournalInsert_q(entry#0))
                         && (NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(buf#0, idx3#0), idx2#0))
                             && Journal.JournalEntry.JournalInsert_q(entry#0)
                             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                                Seq#Drop(Seq#Take(buf#0, idx3#0), idx2#0))
                               == Seq#Length(Journal.JournalEntry.value(entry#0))
                           ==> Journal.JournalEntry.JournalInsert_q(entry#0))
                         && (Journal.JournalEntry.JournalInsert_q(entry#0)
                             && Seq#Equal(Seq#Drop(Seq#Take(buf#0, idx2#0), idx1#0), Journal.JournalEntry.key(entry#0))
                           ==> Journal.JournalEntry.JournalInsert_q(entry#0)))))))
         && JournalistMarshallingModel.__default.hasEntryAt(buf#0, entry#0, start#0)
           == (var idx0#0 := start#0; 
            (var idx1#0 := idx0#0 + 4; 
              (var idx2#0 := idx1#0 + Seq#Length(Journal.JournalEntry.key(entry#0)); 
                (var idx3#0 := idx2#0 + 4; 
                  (var idx4#0 := idx3#0 + Seq#Length(Journal.JournalEntry.value(entry#0)); 
                    LitInt(0) <= idx0#0
                       && idx4#0 <= Seq#Length(buf#0)
                       && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(buf#0, idx1#0), idx0#0))
                         == Seq#Length(Journal.JournalEntry.key(entry#0))
                       && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(buf#0, idx3#0), idx2#0))
                         == Seq#Length(Journal.JournalEntry.value(entry#0))
                       && Seq#Equal(Seq#Drop(Seq#Take(buf#0, idx2#0), idx1#0), Journal.JournalEntry.key(entry#0))
                       && Seq#Equal(Seq#Drop(Seq#Take(buf#0, idx4#0), idx3#0), Journal.JournalEntry.value(entry#0))))))));

// definition axiom for JournalistMarshallingModel.__default.hasEntryAt for all literals(revealed)
axiom true
   ==> (forall buf#0: Seq Box, entry#0: DatatypeType, start#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.hasEntryAt(Lit(buf#0), Lit(entry#0), LitInt(start#0)) } 
    JournalistMarshallingModel.__default.hasEntryAt#canCall(Lit(buf#0), Lit(entry#0), LitInt(start#0))
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entry#0, Tclass.Journal.JournalEntry()))
       ==> (var idx0#1 := LitInt(start#0); 
          (var idx1#1 := idx0#1 + 4; 
            Journal.JournalEntry.JournalInsert_q(Lit(entry#0))
               && (var idx2#1 := idx1#1 + Seq#Length(Lit(Journal.JournalEntry.key(Lit(entry#0)))); 
                (var idx3#1 := idx2#1 + 4; 
                  Journal.JournalEntry.JournalInsert_q(Lit(entry#0))
                     && (var idx4#1 := idx3#1 + Seq#Length(Lit(Journal.JournalEntry.value(Lit(entry#0)))); 
                      (idx4#1 <= Seq#Length(Lit(buf#0))
                           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(Lit(buf#0), idx1#1), idx0#1))
                             && Journal.JournalEntry.JournalInsert_q(Lit(entry#0)))
                         && (NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(Lit(buf#0), idx1#1), idx0#1))
                             && Journal.JournalEntry.JournalInsert_q(Lit(entry#0))
                             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                                Seq#Drop(Seq#Take(Lit(buf#0), idx1#1), idx0#1))
                               == Seq#Length(Lit(Journal.JournalEntry.key(Lit(entry#0))))
                           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(Lit(buf#0), idx3#1), idx2#1))
                             && Journal.JournalEntry.JournalInsert_q(Lit(entry#0)))
                         && (NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(Lit(buf#0), idx3#1), idx2#1))
                             && Journal.JournalEntry.JournalInsert_q(Lit(entry#0))
                             && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                                Seq#Drop(Seq#Take(Lit(buf#0), idx3#1), idx2#1))
                               == Seq#Length(Lit(Journal.JournalEntry.value(Lit(entry#0))))
                           ==> Journal.JournalEntry.JournalInsert_q(Lit(entry#0)))
                         && (Journal.JournalEntry.JournalInsert_q(Lit(entry#0))
                             && Seq#Equal(Seq#Drop(Seq#Take(Lit(buf#0), idx2#1), idx1#1), 
                              Journal.JournalEntry.key(Lit(entry#0)))
                           ==> Journal.JournalEntry.JournalInsert_q(Lit(entry#0))))))))
         && JournalistMarshallingModel.__default.hasEntryAt(Lit(buf#0), Lit(entry#0), LitInt(start#0))
           == (var idx0#1 := LitInt(start#0); 
            (var idx1#1 := LitInt(idx0#1 + 4); 
              (var idx2#1 := idx1#1 + Seq#Length(Lit(Journal.JournalEntry.key(Lit(entry#0)))); 
                (var idx3#1 := idx2#1 + 4; 
                  (var idx4#1 := idx3#1 + Seq#Length(Lit(Journal.JournalEntry.value(Lit(entry#0)))); 
                    LitInt(0) <= idx0#1
                       && idx4#1 <= Seq#Length(Lit(buf#0))
                       && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Lit(Seq#Drop(Seq#Take(Lit(buf#0), idx1#1), idx0#1)))
                         == Seq#Length(Lit(Journal.JournalEntry.key(Lit(entry#0))))
                       && NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(Lit(buf#0), idx3#1), idx2#1))
                         == Seq#Length(Lit(Journal.JournalEntry.value(Lit(entry#0))))
                       && Seq#Equal(Seq#Drop(Seq#Take(Lit(buf#0), idx2#1), idx1#1), 
                        Journal.JournalEntry.key(Lit(entry#0)))
                       && Seq#Equal(Seq#Drop(Seq#Take(Lit(buf#0), idx4#1), idx3#1), 
                        Journal.JournalEntry.value(Lit(entry#0)))))))));

// function declaration for JournalistMarshallingModel._default.hasEntry
function JournalistMarshallingModel.__default.hasEntry(buf#0: Seq Box, entries#0: Seq Box, i#0: int) : bool;

function JournalistMarshallingModel.__default.hasEntry#canCall(buf#0: Seq Box, entries#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalistMarshallingModel.__default.hasEntry
axiom true
   ==> (forall buf#0: Seq Box, entries#0: Seq Box, i#0: int :: 
    { JournalistMarshallingModel.__default.hasEntry(buf#0, entries#0, i#0) } 
    JournalistMarshallingModel.__default.hasEntry#canCall(buf#0, entries#0, i#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(entries#0))
       ==> true);

function JournalistMarshallingModel.__default.hasEntry#requires(Seq Box, Seq Box, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.hasEntry
axiom (forall buf#0: Seq Box, entries#0: Seq Box, i#0: int :: 
  { JournalistMarshallingModel.__default.hasEntry#requires(buf#0, entries#0, i#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalistMarshallingModel.__default.hasEntry#requires(buf#0, entries#0, i#0)
       == (LitInt(0) <= i#0 && i#0 < Seq#Length(entries#0)));

// definition axiom for JournalistMarshallingModel.__default.hasEntry(revealed)
axiom true
   ==> (forall buf#0: Seq Box, entries#0: Seq Box, i#0: int :: 
    { JournalistMarshallingModel.__default.hasEntry(buf#0, entries#0, i#0) } 
    JournalistMarshallingModel.__default.hasEntry#canCall(buf#0, entries#0, i#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(entries#0))
       ==> JournalRanges.__default.SumJournalEntries#canCall(Seq#Take(entries#0, i#0))
         && JournalistMarshallingModel.__default.hasEntryAt#canCall(buf#0, 
          $Unbox(Seq#Index(entries#0, i#0)): DatatypeType, 
          8
             + JournalRanges.__default.SumJournalEntries($LS($LZ), Seq#Take(entries#0, i#0)))
         && JournalistMarshallingModel.__default.hasEntry(buf#0, entries#0, i#0)
           == JournalistMarshallingModel.__default.hasEntryAt(buf#0, 
            $Unbox(Seq#Index(entries#0, i#0)): DatatypeType, 
            8
               + JournalRanges.__default.SumJournalEntries($LS($LZ), Seq#Take(entries#0, i#0))));

// definition axiom for JournalistMarshallingModel.__default.hasEntry for all literals(revealed)
axiom true
   ==> (forall buf#0: Seq Box, entries#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.hasEntry(Lit(buf#0), Lit(entries#0), LitInt(i#0)) } 
    JournalistMarshallingModel.__default.hasEntry#canCall(Lit(buf#0), Lit(entries#0), LitInt(i#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(entries#0)))
       ==> JournalRanges.__default.SumJournalEntries#canCall(Lit(Seq#Take(Lit(entries#0), LitInt(i#0))))
         && JournalistMarshallingModel.__default.hasEntryAt#canCall(Lit(buf#0), 
          $Unbox(Seq#Index(Lit(entries#0), LitInt(i#0))): DatatypeType, 
          LitInt(8
               + JournalRanges.__default.SumJournalEntries($LS($LZ), Lit(Seq#Take(Lit(entries#0), LitInt(i#0))))))
         && JournalistMarshallingModel.__default.hasEntry(Lit(buf#0), Lit(entries#0), LitInt(i#0))
           == JournalistMarshallingModel.__default.hasEntryAt(Lit(buf#0), 
            $Unbox(Seq#Index(Lit(entries#0), LitInt(i#0))): DatatypeType, 
            LitInt(8
                 + JournalRanges.__default.SumJournalEntries($LS($LZ), Lit(Seq#Take(Lit(entries#0), LitInt(i#0)))))));

// function declaration for JournalistMarshallingModel._default.hasEntries
function JournalistMarshallingModel.__default.hasEntries(buf#0: Seq Box, entries#0: Seq Box, j#0: int) : bool;

function JournalistMarshallingModel.__default.hasEntries#canCall(buf#0: Seq Box, entries#0: Seq Box, j#0: int) : bool;

// consequence axiom for JournalistMarshallingModel.__default.hasEntries
axiom true
   ==> (forall buf#0: Seq Box, entries#0: Seq Box, j#0: int :: 
    { JournalistMarshallingModel.__default.hasEntries(buf#0, entries#0, j#0) } 
    JournalistMarshallingModel.__default.hasEntries#canCall(buf#0, entries#0, j#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= j#0
           && j#0 <= Seq#Length(entries#0))
       ==> true);

function JournalistMarshallingModel.__default.hasEntries#requires(Seq Box, Seq Box, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.hasEntries
axiom (forall buf#0: Seq Box, entries#0: Seq Box, j#0: int :: 
  { JournalistMarshallingModel.__default.hasEntries#requires(buf#0, entries#0, j#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalistMarshallingModel.__default.hasEntries#requires(buf#0, entries#0, j#0)
       == (LitInt(0) <= j#0 && j#0 <= Seq#Length(entries#0)));

// definition axiom for JournalistMarshallingModel.__default.hasEntries(revealed)
axiom true
   ==> (forall buf#0: Seq Box, entries#0: Seq Box, j#0: int :: 
    { JournalistMarshallingModel.__default.hasEntries(buf#0, entries#0, j#0) } 
    JournalistMarshallingModel.__default.hasEntries#canCall(buf#0, entries#0, j#0)
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= j#0
           && j#0 <= Seq#Length(entries#0))
       ==> (forall i#0: int :: 
          { JournalistMarshallingModel.__default.hasEntry(buf#0, entries#0, i#0) } 
          LitInt(0) <= i#0 && i#0 < j#0
             ==> JournalistMarshallingModel.__default.hasEntry#canCall(buf#0, entries#0, i#0))
         && JournalistMarshallingModel.__default.hasEntries(buf#0, entries#0, j#0)
           == (forall i#0: int :: 
            { JournalistMarshallingModel.__default.hasEntry(buf#0, entries#0, i#0) } 
            LitInt(0) <= i#0 && i#0 < j#0
               ==> JournalistMarshallingModel.__default.hasEntry(buf#0, entries#0, i#0)));

// definition axiom for JournalistMarshallingModel.__default.hasEntries for all literals(revealed)
axiom true
   ==> (forall buf#0: Seq Box, entries#0: Seq Box, j#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.hasEntries(Lit(buf#0), Lit(entries#0), LitInt(j#0)) } 
    JournalistMarshallingModel.__default.hasEntries#canCall(Lit(buf#0), Lit(entries#0), LitInt(j#0))
         || (
          $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= LitInt(j#0)
           && LitInt(j#0) <= Seq#Length(Lit(entries#0)))
       ==> (forall i#1: int :: 
          { JournalistMarshallingModel.__default.hasEntry(buf#0, entries#0, i#1) } 
          LitInt(0) <= i#1 && i#1 < j#0
             ==> JournalistMarshallingModel.__default.hasEntry#canCall(Lit(buf#0), Lit(entries#0), i#1))
         && JournalistMarshallingModel.__default.hasEntries(Lit(buf#0), Lit(entries#0), LitInt(j#0))
           == (forall i#1: int :: 
            { JournalistMarshallingModel.__default.hasEntry(buf#0, entries#0, i#1) } 
            LitInt(0) <= i#1 && i#1 < j#0
               ==> JournalistMarshallingModel.__default.hasEntry(Lit(buf#0), Lit(entries#0), i#1)));

// function declaration for JournalistMarshallingModel._default.hasStuff
function JournalistMarshallingModel.__default.hasStuff(buf#0: Seq Box, numBlocks#0: int, entries#0: Seq Box) : bool;

function JournalistMarshallingModel.__default.hasStuff#canCall(buf#0: Seq Box, numBlocks#0: int, entries#0: Seq Box) : bool;

// consequence axiom for JournalistMarshallingModel.__default.hasStuff
axiom true
   ==> (forall buf#0: Seq Box, numBlocks#0: int, entries#0: Seq Box :: 
    { JournalistMarshallingModel.__default.hasStuff(buf#0, numBlocks#0, entries#0) } 
    JournalistMarshallingModel.__default.hasStuff#canCall(buf#0, numBlocks#0, entries#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> true);

function JournalistMarshallingModel.__default.hasStuff#requires(Seq Box, int, Seq Box) : bool;

// #requires axiom for JournalistMarshallingModel.__default.hasStuff
axiom (forall buf#0: Seq Box, numBlocks#0: int, entries#0: Seq Box :: 
  { JournalistMarshallingModel.__default.hasStuff#requires(buf#0, numBlocks#0, entries#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalistMarshallingModel.__default.hasStuff#requires(buf#0, numBlocks#0, entries#0)
       == true);

// definition axiom for JournalistMarshallingModel.__default.hasStuff(revealed)
axiom true
   ==> (forall buf#0: Seq Box, numBlocks#0: int, entries#0: Seq Box :: 
    { JournalistMarshallingModel.__default.hasStuff(buf#0, numBlocks#0, entries#0) } 
    JournalistMarshallingModel.__default.hasStuff#canCall(buf#0, numBlocks#0, entries#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> JournalistMarshallingModel.__default.hasEntries#canCall(buf#0, entries#0, Seq#Length(entries#0))
         && (JournalistMarshallingModel.__default.hasEntries(buf#0, entries#0, Seq#Length(entries#0))
           ==> JournalistMarshallingModel.__default.hasHeader#canCall(buf#0, #JournalRanges.Header.Header(Seq#Length(entries#0), numBlocks#0)))
         && JournalistMarshallingModel.__default.hasStuff(buf#0, numBlocks#0, entries#0)
           == (JournalistMarshallingModel.__default.hasEntries(buf#0, entries#0, Seq#Length(entries#0))
             && JournalistMarshallingModel.__default.hasHeader(StartFuel_JournalistMarshallingModel._default.hasHeader, 
              buf#0, 
              #JournalRanges.Header.Header(Seq#Length(entries#0), numBlocks#0))));

// definition axiom for JournalistMarshallingModel.__default.hasStuff for all literals(revealed)
axiom true
   ==> (forall buf#0: Seq Box, numBlocks#0: int, entries#0: Seq Box :: 
    {:weight 3} { JournalistMarshallingModel.__default.hasStuff(Lit(buf#0), LitInt(numBlocks#0), Lit(entries#0)) } 
    JournalistMarshallingModel.__default.hasStuff#canCall(Lit(buf#0), LitInt(numBlocks#0), Lit(entries#0))
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(entries#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> JournalistMarshallingModel.__default.hasEntries#canCall(Lit(buf#0), Lit(entries#0), Seq#Length(Lit(entries#0)))
         && (JournalistMarshallingModel.__default.hasEntries(Lit(buf#0), Lit(entries#0), Seq#Length(Lit(entries#0)))
           ==> JournalistMarshallingModel.__default.hasHeader#canCall(Lit(buf#0), 
            #JournalRanges.Header.Header(Seq#Length(Lit(entries#0)), LitInt(numBlocks#0))))
         && JournalistMarshallingModel.__default.hasStuff(Lit(buf#0), LitInt(numBlocks#0), Lit(entries#0))
           == (JournalistMarshallingModel.__default.hasEntries(Lit(buf#0), Lit(entries#0), Seq#Length(Lit(entries#0)))
             && JournalistMarshallingModel.__default.hasHeader(StartFuel_JournalistMarshallingModel._default.hasHeader, 
              Lit(buf#0), 
              #JournalRanges.Header.Header(Seq#Length(Lit(entries#0)), LitInt(numBlocks#0)))));

// function declaration for JournalistMarshallingModel._default.hasChecksumAt
function JournalistMarshallingModel.__default.hasChecksumAt(buf#0: Seq Box, i#0: int) : bool;

function JournalistMarshallingModel.__default.hasChecksumAt#canCall(buf#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalistMarshallingModel.__default.hasChecksumAt
axiom true
   ==> (forall buf#0: Seq Box, i#0: int :: 
    { JournalistMarshallingModel.__default.hasChecksumAt(buf#0, i#0) } 
    JournalistMarshallingModel.__default.hasChecksumAt#canCall(buf#0, i#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= i#0
           && Seq#Length(buf#0) >= Mul(LitInt(4096), i#0 + 1))
       ==> true);

function JournalistMarshallingModel.__default.hasChecksumAt#requires(Seq Box, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.hasChecksumAt
axiom (forall buf#0: Seq Box, i#0: int :: 
  { JournalistMarshallingModel.__default.hasChecksumAt#requires(buf#0, i#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalistMarshallingModel.__default.hasChecksumAt#requires(buf#0, i#0)
       == (LitInt(0) <= i#0 && Seq#Length(buf#0) >= Mul(LitInt(4096), i#0 + 1)));

// definition axiom for JournalistMarshallingModel.__default.hasChecksumAt(revealed)
axiom true
   ==> (forall buf#0: Seq Box, i#0: int :: 
    { JournalistMarshallingModel.__default.hasChecksumAt(buf#0, i#0) } 
    JournalistMarshallingModel.__default.hasChecksumAt#canCall(buf#0, i#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= i#0
           && Seq#Length(buf#0) >= Mul(LitInt(4096), i#0 + 1))
       ==> Crypto.__default.Crc32C#canCall(Seq#Drop(Seq#Take(buf#0, Mul(LitInt(4096), i#0) + 4096), Mul(LitInt(4096), i#0) + 32))
         && JournalistMarshallingModel.__default.hasChecksumAt(buf#0, i#0)
           == Seq#Equal(Crypto.__default.Crc32C(Seq#Drop(Seq#Take(buf#0, Mul(LitInt(4096), i#0) + 4096), Mul(LitInt(4096), i#0) + 32)), 
            Seq#Drop(Seq#Take(buf#0, Mul(LitInt(4096), i#0) + 32), Mul(LitInt(4096), i#0))));

// definition axiom for JournalistMarshallingModel.__default.hasChecksumAt for all literals(revealed)
axiom true
   ==> (forall buf#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.hasChecksumAt(Lit(buf#0), LitInt(i#0)) } 
    JournalistMarshallingModel.__default.hasChecksumAt#canCall(Lit(buf#0), LitInt(i#0))
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(i#0)
           && Seq#Length(Lit(buf#0)) >= LitInt(Mul(LitInt(4096), LitInt(i#0 + 1))))
       ==> Crypto.__default.Crc32C#canCall(Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
              LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32))))
         && JournalistMarshallingModel.__default.hasChecksumAt(Lit(buf#0), LitInt(i#0))
           == Seq#Equal(Crypto.__default.Crc32C(Lit(Seq#Drop(Seq#Take(Lit(buf#0), LitInt(Mul(LitInt(4096), LitInt(i#0)) + 4096)), 
                  LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32)))), 
            Seq#Drop(Seq#Take(Lit(buf#0), LitInt(Mul(LitInt(4096), LitInt(i#0)) + 32)), 
              LitInt(Mul(LitInt(4096), LitInt(i#0))))));

// function declaration for JournalistMarshallingModel._default.hasChecksums
function JournalistMarshallingModel.__default.hasChecksums(buf#0: Seq Box, numBlocks#0: int) : bool;

function JournalistMarshallingModel.__default.hasChecksums#canCall(buf#0: Seq Box, numBlocks#0: int) : bool;

// consequence axiom for JournalistMarshallingModel.__default.hasChecksums
axiom true
   ==> (forall buf#0: Seq Box, numBlocks#0: int :: 
    { JournalistMarshallingModel.__default.hasChecksums(buf#0, numBlocks#0) } 
    JournalistMarshallingModel.__default.hasChecksums#canCall(buf#0, numBlocks#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(buf#0) == Mul(numBlocks#0, LitInt(4096)))
       ==> true);

function JournalistMarshallingModel.__default.hasChecksums#requires(Seq Box, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.hasChecksums
axiom (forall buf#0: Seq Box, numBlocks#0: int :: 
  { JournalistMarshallingModel.__default.hasChecksums#requires(buf#0, numBlocks#0) } 
  $Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalistMarshallingModel.__default.hasChecksums#requires(buf#0, numBlocks#0)
       == 
      (Seq#Length(buf#0)
       == Mul(numBlocks#0, LitInt(4096))));

// definition axiom for JournalistMarshallingModel.__default.hasChecksums(revealed)
axiom true
   ==> (forall buf#0: Seq Box, numBlocks#0: int :: 
    { JournalistMarshallingModel.__default.hasChecksums(buf#0, numBlocks#0) } 
    JournalistMarshallingModel.__default.hasChecksums#canCall(buf#0, numBlocks#0)
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(buf#0) == Mul(numBlocks#0, LitInt(4096)))
       ==> (forall i#0: int :: 
          { JournalistMarshallingModel.__default.hasChecksumAt(buf#0, i#0) } 
          LitInt(0) <= i#0 && i#0 < numBlocks#0
             ==> JournalistMarshallingModel.__default.hasChecksumAt#canCall(buf#0, i#0))
         && JournalistMarshallingModel.__default.hasChecksums(buf#0, numBlocks#0)
           == (forall i#0: int :: 
            { JournalistMarshallingModel.__default.hasChecksumAt(buf#0, i#0) } 
            LitInt(0) <= i#0 && i#0 < numBlocks#0
               ==> JournalistMarshallingModel.__default.hasChecksumAt(buf#0, i#0)));

// definition axiom for JournalistMarshallingModel.__default.hasChecksums for all literals(revealed)
axiom true
   ==> (forall buf#0: Seq Box, numBlocks#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.hasChecksums(Lit(buf#0), LitInt(numBlocks#0)) } 
    JournalistMarshallingModel.__default.hasChecksums#canCall(Lit(buf#0), LitInt(numBlocks#0))
         || ($Is(buf#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(buf#0)) == LitInt(Mul(LitInt(numBlocks#0), LitInt(4096))))
       ==> (forall i#1: int :: 
          { JournalistMarshallingModel.__default.hasChecksumAt(buf#0, i#1) } 
          LitInt(0) <= i#1 && i#1 < numBlocks#0
             ==> JournalistMarshallingModel.__default.hasChecksumAt#canCall(Lit(buf#0), i#1))
         && JournalistMarshallingModel.__default.hasChecksums(Lit(buf#0), LitInt(numBlocks#0))
           == (forall i#1: int :: 
            { JournalistMarshallingModel.__default.hasChecksumAt(buf#0, i#1) } 
            LitInt(0) <= i#1 && i#1 < numBlocks#0
               ==> JournalistMarshallingModel.__default.hasChecksumAt(Lit(buf#0), i#1)));

// function declaration for JournalistMarshallingModel._default.add_mod
function JournalistMarshallingModel.__default.add__mod(a#0: int, b#0: int, c#0: int) : int;

function JournalistMarshallingModel.__default.add__mod#canCall(a#0: int, b#0: int, c#0: int) : bool;

// consequence axiom for JournalistMarshallingModel.__default.add__mod
axiom true
   ==> (forall a#0: int, b#0: int, c#0: int :: 
    { JournalistMarshallingModel.__default.add__mod(a#0, b#0, c#0) } 
    true ==> true);

function JournalistMarshallingModel.__default.add__mod#requires(int, int, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.add__mod
axiom (forall a#0: int, b#0: int, c#0: int :: 
  { JournalistMarshallingModel.__default.add__mod#requires(a#0, b#0, c#0) } 
  JournalistMarshallingModel.__default.add__mod#requires(a#0, b#0, c#0) == true);

// definition axiom for JournalistMarshallingModel.__default.add__mod(revealed)
axiom true
   ==> (forall a#0: int, b#0: int, c#0: int :: 
    { JournalistMarshallingModel.__default.add__mod(a#0, b#0, c#0) } 
    true
       ==> JournalistMarshallingModel.__default.add__mod(a#0, b#0, c#0)
         == (if a#0 + b#0 >= c#0 then a#0 + b#0 - c#0 else a#0 + b#0));

// definition axiom for JournalistMarshallingModel.__default.add__mod for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int, c#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.add__mod(LitInt(a#0), LitInt(b#0), LitInt(c#0)) } 
    true
       ==> JournalistMarshallingModel.__default.add__mod(LitInt(a#0), LitInt(b#0), LitInt(c#0))
         == (if LitInt(a#0 + b#0) >= LitInt(c#0) then a#0 + b#0 - c#0 else a#0 + b#0));

// function declaration for JournalistMarshallingModel._default.marshallJournalEntries
function JournalistMarshallingModel.__default.marshallJournalEntries($ly: LayerType, entries#0: Seq Box, start#0: int, len#0: int, numBlocks#0: int)
   : Seq Box;

function JournalistMarshallingModel.__default.marshallJournalEntries#canCall(entries#0: Seq Box, start#0: int, len#0: int, numBlocks#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, entries#0: Seq Box, start#0: int, len#0: int, numBlocks#0: int :: 
  { JournalistMarshallingModel.__default.marshallJournalEntries($LS($ly), entries#0, start#0, len#0, numBlocks#0) } 
  JournalistMarshallingModel.__default.marshallJournalEntries($LS($ly), entries#0, start#0, len#0, numBlocks#0)
     == JournalistMarshallingModel.__default.marshallJournalEntries($ly, entries#0, start#0, len#0, numBlocks#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, entries#0: Seq Box, start#0: int, len#0: int, numBlocks#0: int :: 
  { JournalistMarshallingModel.__default.marshallJournalEntries(AsFuelBottom($ly), entries#0, start#0, len#0, numBlocks#0) } 
  JournalistMarshallingModel.__default.marshallJournalEntries($ly, entries#0, start#0, len#0, numBlocks#0)
     == JournalistMarshallingModel.__default.marshallJournalEntries($LZ, entries#0, start#0, len#0, numBlocks#0));

// consequence axiom for JournalistMarshallingModel.__default.marshallJournalEntries
axiom true
   ==> (forall $ly: LayerType, entries#0: Seq Box, start#0: int, len#0: int, numBlocks#0: int :: 
    { JournalistMarshallingModel.__default.marshallJournalEntries($ly, entries#0, start#0, len#0, numBlocks#0) } 
    JournalistMarshallingModel.__default.marshallJournalEntries#canCall(entries#0, start#0, len#0, numBlocks#0)
         || (
          $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < Seq#Length(entries#0)
           && 
          LitInt(0) <= len#0
           && len#0 <= Seq#Length(entries#0)
           && Seq#Length(entries#0) <= LitInt(4294967295)
           && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
              JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
                StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
                entries#0, 
                start#0, 
                len#0))
             <= Mul(LitInt(4064), numBlocks#0)
           && 
          LitInt(1) <= numBlocks#0
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, 
            JournalistMarshallingModel.__default.marshallJournalEntries($ly, entries#0, start#0, len#0, numBlocks#0)))
         && Options.Option#Equal(JournalRanges.__default.parseJournalRange($LS($LZ), 
            $Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, 
                  JournalistMarshallingModel.__default.marshallJournalEntries($ly, entries#0, start#0, len#0, numBlocks#0)))): Seq Box), 
          #Options.Option.Some($Box(JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
                StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
                entries#0, 
                start#0, 
                len#0))))
         && Seq#Length(JournalistMarshallingModel.__default.marshallJournalEntries($ly, entries#0, start#0, len#0, numBlocks#0))
           == Mul(numBlocks#0, LitInt(4096))
         && $Is(JournalistMarshallingModel.__default.marshallJournalEntries($ly, entries#0, start#0, len#0, numBlocks#0), 
          TSeq(Tclass.NativeTypes.byte())));

function JournalistMarshallingModel.__default.marshallJournalEntries#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for JournalistMarshallingModel.__default.marshallJournalEntries
axiom (forall $ly: LayerType, entries#0: Seq Box, start#0: int, len#0: int, numBlocks#0: int :: 
  { JournalistMarshallingModel.__default.marshallJournalEntries#requires($ly, entries#0, start#0, len#0, numBlocks#0) } 
  $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
       && 
      LitInt(0) <= numBlocks#0
       && numBlocks#0 < 18446744073709551616
     ==> JournalistMarshallingModel.__default.marshallJournalEntries#requires($ly, entries#0, start#0, len#0, numBlocks#0)
       == (
        LitInt(0) <= start#0
         && start#0 < Seq#Length(entries#0)
         && 
        LitInt(0) <= len#0
         && len#0 <= Seq#Length(entries#0)
         && Seq#Length(entries#0) <= LitInt(4294967295)
         && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
            JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
              StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
              entries#0, 
              start#0, 
              len#0))
           <= Mul(LitInt(4064), numBlocks#0)
         && 
        LitInt(1) <= numBlocks#0
         && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

const MoreFuel_JournalRanges._default.WeightJournalEntries1: LayerType;

// definition axiom for JournalistMarshallingModel.__default.marshallJournalEntries(revealed)
axiom true
   ==> (forall $ly: LayerType, entries#0: Seq Box, start#0: int, len#0: int, numBlocks#0: int :: 
    { JournalistMarshallingModel.__default.marshallJournalEntries($LS($ly), entries#0, start#0, len#0, numBlocks#0) } 
    JournalistMarshallingModel.__default.marshallJournalEntries#canCall(entries#0, start#0, len#0, numBlocks#0)
         || (
          $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < Seq#Length(entries#0)
           && 
          LitInt(0) <= len#0
           && len#0 <= Seq#Length(entries#0)
           && Seq#Length(entries#0) <= LitInt(4294967295)
           && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
              JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
                StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
                entries#0, 
                start#0, 
                len#0))
             <= Mul(LitInt(4064), numBlocks#0)
           && 
          LitInt(1) <= numBlocks#0
           && numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> Sequences.__default.fill#canCall(Tclass.NativeTypes.byte(), Mul(numBlocks#0, LitInt(4096)), $Box(LitInt(0)))
         && (var buf#0 := Sequences.__default.fill(Tclass.NativeTypes.byte(), 
              StartFuel_Sequences._default.fill, 
              Mul(numBlocks#0, LitInt(4096)), 
              $Box(LitInt(0))); 
          JournalistMarshallingModel.__default.writeHeader#canCall(buf#0, numBlocks#0, len#0)
             && (var buf1#0 := JournalistMarshallingModel.__default.writeHeader(buf#0, numBlocks#0, len#0); 
              JournalistMarshallingModel.__default.writeJournalEntries#canCall(buf1#0, numBlocks#0, LitInt(8), entries#0, start#0, len#0)
                 && (var buf2#0 := JournalistMarshallingModel.__default.writeJournalEntries(StartFuel_JournalistMarshallingModel._default.writeJournalEntries, 
                      buf1#0, 
                      numBlocks#0, 
                      LitInt(8), 
                      entries#0, 
                      start#0, 
                      len#0); 
                  JournalistMarshallingModel.__default.fillInChecksums#canCall(buf2#0, numBlocks#0, LitInt(0)))))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries1)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries1))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries1)
           == MoreFuel_JournalRanges._default.WeightJournalEntries1
         && JournalistMarshallingModel.__default.marshallJournalEntries($LS($ly), entries#0, start#0, len#0, numBlocks#0)
           == (var buf#0 := Sequences.__default.fill(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.fill, 
                Mul(numBlocks#0, LitInt(4096)), 
                $Box(LitInt(0))); 
            (var buf1#0 := JournalistMarshallingModel.__default.writeHeader(buf#0, numBlocks#0, len#0); 
              (var buf2#0 := JournalistMarshallingModel.__default.writeJournalEntries(StartFuel_JournalistMarshallingModel._default.writeJournalEntries, 
                    buf1#0, 
                    numBlocks#0, 
                    LitInt(8), 
                    entries#0, 
                    start#0, 
                    len#0); 
                (var buf3#0 := JournalistMarshallingModel.__default.fillInChecksums(StartFuel_JournalistMarshallingModel._default.fillInChecksums, 
                      buf2#0, 
                      numBlocks#0, 
                      LitInt(0)); 
                  buf3#0)))));

const MoreFuel_JournalRanges._default.WeightJournalEntries2: LayerType;

// definition axiom for JournalistMarshallingModel.__default.marshallJournalEntries for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, entries#0: Seq Box, start#0: int, len#0: int, numBlocks#0: int :: 
    {:weight 3} { JournalistMarshallingModel.__default.marshallJournalEntries($LS($ly), Lit(entries#0), LitInt(start#0), LitInt(len#0), LitInt(numBlocks#0)) } 
    JournalistMarshallingModel.__default.marshallJournalEntries#canCall(Lit(entries#0), LitInt(start#0), LitInt(len#0), LitInt(numBlocks#0))
         || (
          $Is(entries#0, TSeq(Tclass.Journal.JournalEntry()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= numBlocks#0
           && numBlocks#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 < Seq#Length(Lit(entries#0))
           && 
          LitInt(0) <= LitInt(len#0)
           && LitInt(len#0) <= Seq#Length(Lit(entries#0))
           && Seq#Length(Lit(entries#0)) <= LitInt(4294967295)
           && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
              JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
                StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
                Lit(entries#0), 
                LitInt(start#0), 
                LitInt(len#0)))
             <= LitInt(Mul(LitInt(4064), LitInt(numBlocks#0)))
           && 
          LitInt(1) <= LitInt(numBlocks#0)
           && LitInt(numBlocks#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> Sequences.__default.fill#canCall(Tclass.NativeTypes.byte(), 
          LitInt(Mul(LitInt(numBlocks#0), LitInt(4096))), 
          $Box(LitInt(0)))
         && (var buf#1 := Sequences.__default.fill(Tclass.NativeTypes.byte(), 
              StartFuel_Sequences._default.fill, 
              LitInt(Mul(LitInt(numBlocks#0), LitInt(4096))), 
              $Box(LitInt(0))); 
          JournalistMarshallingModel.__default.writeHeader#canCall(buf#1, LitInt(numBlocks#0), LitInt(len#0))
             && (var buf1#1 := JournalistMarshallingModel.__default.writeHeader(buf#1, LitInt(numBlocks#0), LitInt(len#0)); 
              JournalistMarshallingModel.__default.writeJournalEntries#canCall(buf1#1, 
                  LitInt(numBlocks#0), 
                  LitInt(8), 
                  Lit(entries#0), 
                  LitInt(start#0), 
                  LitInt(len#0))
                 && (var buf2#1 := JournalistMarshallingModel.__default.writeJournalEntries(StartFuel_JournalistMarshallingModel._default.writeJournalEntries, 
                      buf1#1, 
                      LitInt(numBlocks#0), 
                      LitInt(8), 
                      Lit(entries#0), 
                      LitInt(start#0), 
                      LitInt(len#0)); 
                  JournalistMarshallingModel.__default.fillInChecksums#canCall(buf2#1, LitInt(numBlocks#0), LitInt(0)))))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries2)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries2))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries2)
           == MoreFuel_JournalRanges._default.WeightJournalEntries2
         && JournalistMarshallingModel.__default.marshallJournalEntries($LS($ly), Lit(entries#0), LitInt(start#0), LitInt(len#0), LitInt(numBlocks#0))
           == (var buf#1 := Sequences.__default.fill(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.fill, 
                LitInt(Mul(LitInt(numBlocks#0), LitInt(4096))), 
                $Box(LitInt(0))); 
            (var buf1#1 := JournalistMarshallingModel.__default.writeHeader(buf#1, LitInt(numBlocks#0), LitInt(len#0)); 
              (var buf2#1 := JournalistMarshallingModel.__default.writeJournalEntries(StartFuel_JournalistMarshallingModel._default.writeJournalEntries, 
                    buf1#1, 
                    LitInt(numBlocks#0), 
                    LitInt(8), 
                    Lit(entries#0), 
                    LitInt(start#0), 
                    LitInt(len#0)); 
                (var buf3#1 := JournalistMarshallingModel.__default.fillInChecksums(StartFuel_JournalistMarshallingModel._default.fillInChecksums, 
                      buf2#1, 
                      LitInt(numBlocks#0), 
                      LitInt(0)); 
                  buf3#1)))));

const unique class.JournalistMarshallingImpl.__default: ClassName;

function Tclass.JournalistMarshallingImpl.__default() : Ty;

// Tclass.JournalistMarshallingImpl.__default Tag
axiom Tag(Tclass.JournalistMarshallingImpl.__default())
   == Tagclass.JournalistMarshallingImpl.__default;

const unique Tagclass.JournalistMarshallingImpl.__default: TyTag;

// Box/unbox axiom for Tclass.JournalistMarshallingImpl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistMarshallingImpl.__default()) } 
  $IsBox(bx, Tclass.JournalistMarshallingImpl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalistMarshallingImpl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalistMarshallingImpl.__default()) } 
  $Is($o, Tclass.JournalistMarshallingImpl.__default())
     <==> $o == null || dtype($o) == Tclass.JournalistMarshallingImpl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalistMarshallingImpl.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalistMarshallingImpl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

procedure CheckWellformed$$JournalistMarshallingImpl.__default.MarshallJournalEntries(entries#0: ref
       where $Is(entries#0, Tclass._System.array(Tclass.Journal.JournalEntry()))
         && $IsAlloc(entries#0, Tclass._System.array(Tclass.Journal.JournalEntry()), $Heap), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616, 
    numBlocks#0: int
       where LitInt(0) <= numBlocks#0 && numBlocks#0 < 18446744073709551616)
   returns (res#0: Seq Box
       where $Is(res#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(res#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 11 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$JournalistMarshallingImpl.__default.MarshallJournalEntries(entries#0: ref
       where $Is(entries#0, Tclass._System.array(Tclass.Journal.JournalEntry()))
         && $IsAlloc(entries#0, Tclass._System.array(Tclass.Journal.JournalEntry()), $Heap), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616, 
    numBlocks#0: int
       where LitInt(0) <= numBlocks#0 && numBlocks#0 < 18446744073709551616)
   returns (res#0: Seq Box
       where $Is(res#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(res#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires LitInt(0) <= start#0;
  requires start#0 < _System.array.Length(entries#0);
  requires LitInt(0) <= len#0;
  requires len#0 <= _System.array.Length(entries#0);
  requires _System.array.Length(entries#0) <= LitInt(4294967295);
  requires JournalRanges.__default.WeightJournalEntries(StartFuelAssert_JournalRanges._default.WeightJournalEntries, 
      JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
        StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice, 
        Seq#FromArray($Heap, entries#0), 
        start#0, 
        len#0))
     <= Mul(LitInt(4064), numBlocks#0);
  requires LitInt(1) <= numBlocks#0;
  requires numBlocks#0 <= LitInt(DiskLayout.__default.NumJournalBlocks());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalistMarshallingModel.__default.marshallJournalEntries#canCall(Seq#FromArray($Heap, entries#0), start#0, len#0, numBlocks#0);
  ensures Seq#Equal(res#0, 
    JournalistMarshallingModel.__default.marshallJournalEntries(StartFuelAssert_JournalistMarshallingModel._default.marshallJournalEntries, 
      Seq#FromArray($Heap, entries#0), 
      start#0, 
      len#0, 
      numBlocks#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



const unique class.JournalistParsingImpl.__default: ClassName;

function Tclass.JournalistParsingImpl.__default() : Ty;

// Tclass.JournalistParsingImpl.__default Tag
axiom Tag(Tclass.JournalistParsingImpl.__default())
   == Tagclass.JournalistParsingImpl.__default;

const unique Tagclass.JournalistParsingImpl.__default: TyTag;

// Box/unbox axiom for Tclass.JournalistParsingImpl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistParsingImpl.__default()) } 
  $IsBox(bx, Tclass.JournalistParsingImpl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalistParsingImpl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalistParsingImpl.__default()) } 
  $Is($o, Tclass.JournalistParsingImpl.__default())
     <==> $o == null || dtype($o) == Tclass.JournalistParsingImpl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalistParsingImpl.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalistParsingImpl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

procedure CheckWellformed$$JournalistParsingImpl.__default.ParseJournalRange(jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap));
  free requires 15 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$JournalistParsingImpl.__default.ParseJournalRange(jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap));
  // user-defined preconditions
  requires (forall i#0: int :: 
    { $Unbox(Seq#Index(jr#0, i#0)): Seq Box } 
    LitInt(0) <= i#0 && i#0 < Seq#Length(jr#0)
       ==> Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064));
  requires Seq#Length(jr#0) <= LitInt(4294967296);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Options.Option.Some_q(res#0)
     ==> Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
       <= Mul(Seq#Length(jr#0), LitInt(4064));
  free ensures $IsA#Options.Option(res#0)
     && $IsA#Options.Option(JournalRanges.__default.parseJournalRange($LS($LZ), jr#0))
     && JournalRanges.__default.parseJournalRange#canCall(jr#0);
  ensures Options.Option#Equal(res#0, JournalRanges.__default.parseJournalRange($LS($LS($LZ)), jr#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// Constructor function declaration
function #JournalistModel.JournalInfo.JournalInfo(Seq Box, Seq Box, Seq Box, DatatypeType, DatatypeType, int) : DatatypeType;

const unique ##JournalistModel.JournalInfo.JournalInfo: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box, 
    a#0#1#0: Seq Box, 
    a#0#2#0: Seq Box, 
    a#0#3#0: DatatypeType, 
    a#0#4#0: DatatypeType, 
    a#0#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0, a#0#4#0, a#0#5#0) } 
  DatatypeCtorId(#JournalistModel.JournalInfo.JournalInfo(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0, a#0#4#0, a#0#5#0))
     == ##JournalistModel.JournalInfo.JournalInfo);

function JournalistModel.JournalInfo.JournalInfo_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalistModel.JournalInfo.JournalInfo_q(d) } 
  JournalistModel.JournalInfo.JournalInfo_q(d)
     <==> DatatypeCtorId(d) == ##JournalistModel.JournalInfo.JournalInfo);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalistModel.JournalInfo.JournalInfo_q(d) } 
  JournalistModel.JournalInfo.JournalInfo_q(d)
     ==> (exists a#1#0#0: Seq Box, 
        a#1#1#0: Seq Box, 
        a#1#2#0: Seq Box, 
        a#1#3#0: DatatypeType, 
        a#1#4#0: DatatypeType, 
        a#1#5#0: int :: 
      d
         == #JournalistModel.JournalInfo.JournalInfo(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0, a#1#5#0)));

function Tclass.JournalistModel.JournalInfo() : Ty;

// Tclass.JournalistModel.JournalInfo Tag
axiom Tag(Tclass.JournalistModel.JournalInfo())
   == Tagclass.JournalistModel.JournalInfo;

const unique Tagclass.JournalistModel.JournalInfo: TyTag;

// Box/unbox axiom for Tclass.JournalistModel.JournalInfo
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistModel.JournalInfo()) } 
  $IsBox(bx, Tclass.JournalistModel.JournalInfo())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalistModel.JournalInfo()));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box, 
    a#2#1#0: Seq Box, 
    a#2#2#0: Seq Box, 
    a#2#3#0: DatatypeType, 
    a#2#4#0: DatatypeType, 
    a#2#5#0: int :: 
  { $Is(#JournalistModel.JournalInfo.JournalInfo(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0, a#2#4#0, a#2#5#0), 
      Tclass.JournalistModel.JournalInfo()) } 
  $Is(#JournalistModel.JournalInfo.JournalInfo(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0, a#2#4#0, a#2#5#0), 
      Tclass.JournalistModel.JournalInfo())
     <==> $Is(a#2#0#0, TSeq(Tclass.Journal.JournalEntry()))
       && $Is(a#2#1#0, TSeq(Tclass.Journal.JournalEntry()))
       && $Is(a#2#2#0, TSeq(Tclass.Journal.JournalEntry()))
       && $Is(a#2#3#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))))
       && $Is(a#2#4#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))))
       && $Is(a#2#5#0, TInt));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, 
    a#3#1#0: Seq Box, 
    a#3#2#0: Seq Box, 
    a#3#3#0: DatatypeType, 
    a#3#4#0: DatatypeType, 
    a#3#5#0: int, 
    $h: Heap :: 
  { $IsAlloc(#JournalistModel.JournalInfo.JournalInfo(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0, a#3#5#0), 
      Tclass.JournalistModel.JournalInfo(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalistModel.JournalInfo.JournalInfo(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0, a#3#5#0), 
        Tclass.JournalistModel.JournalInfo(), 
        $h)
       <==> $IsAlloc(a#3#0#0, TSeq(Tclass.Journal.JournalEntry()), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.Journal.JournalEntry()), $h)
         && $IsAlloc(a#3#2#0, TSeq(Tclass.Journal.JournalEntry()), $h)
         && $IsAlloc(a#3#3#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), $h)
         && $IsAlloc(a#3#4#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), $h)
         && $IsAlloc(a#3#5#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalInfo.inMemoryJournalFrozen(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalInfo.JournalInfo_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalInfo(), $h)
     ==> $IsAlloc(JournalistModel.JournalInfo.inMemoryJournalFrozen(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalInfo.inMemoryJournal(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalInfo.JournalInfo_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalInfo(), $h)
     ==> $IsAlloc(JournalistModel.JournalInfo.inMemoryJournal(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalInfo.replayJournal(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalInfo.JournalInfo_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalInfo(), $h)
     ==> $IsAlloc(JournalistModel.JournalInfo.replayJournal(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalInfo.journalFront(d), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalInfo.JournalInfo_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalInfo(), $h)
     ==> $IsAlloc(JournalistModel.JournalInfo.journalFront(d), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalInfo.journalBack(d), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalInfo.JournalInfo_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalInfo(), $h)
     ==> $IsAlloc(JournalistModel.JournalInfo.journalBack(d), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalInfo.writtenJournalLen(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalInfo.JournalInfo_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalInfo(), $h)
     ==> $IsAlloc(JournalistModel.JournalInfo.writtenJournalLen(d), TInt, $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box, 
    a#4#1#0: Seq Box, 
    a#4#2#0: Seq Box, 
    a#4#3#0: DatatypeType, 
    a#4#4#0: DatatypeType, 
    a#4#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(Lit(a#4#0#0), 
      Lit(a#4#1#0), 
      Lit(a#4#2#0), 
      Lit(a#4#3#0), 
      Lit(a#4#4#0), 
      LitInt(a#4#5#0)) } 
  #JournalistModel.JournalInfo.JournalInfo(Lit(a#4#0#0), 
      Lit(a#4#1#0), 
      Lit(a#4#2#0), 
      Lit(a#4#3#0), 
      Lit(a#4#4#0), 
      LitInt(a#4#5#0))
     == Lit(#JournalistModel.JournalInfo.JournalInfo(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0, a#4#5#0)));

function JournalistModel.JournalInfo.inMemoryJournalFrozen(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box, 
    a#5#1#0: Seq Box, 
    a#5#2#0: Seq Box, 
    a#5#3#0: DatatypeType, 
    a#5#4#0: DatatypeType, 
    a#5#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0, a#5#5#0) } 
  JournalistModel.JournalInfo.inMemoryJournalFrozen(#JournalistModel.JournalInfo.JournalInfo(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0, a#5#5#0))
     == a#5#0#0);

// Inductive seq element rank
axiom (forall a#6#0#0: Seq Box, 
    a#6#1#0: Seq Box, 
    a#6#2#0: Seq Box, 
    a#6#3#0: DatatypeType, 
    a#6#4#0: DatatypeType, 
    a#6#5#0: int, 
    i: int :: 
  { Seq#Index(a#6#0#0, i), #JournalistModel.JournalInfo.JournalInfo(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0, a#6#5#0) } 
  0 <= i && i < Seq#Length(a#6#0#0)
     ==> DtRank($Unbox(Seq#Index(a#6#0#0, i)): DatatypeType)
       < DtRank(#JournalistModel.JournalInfo.JournalInfo(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0, a#6#5#0)));

// Inductive seq rank
axiom (forall a#7#0#0: Seq Box, 
    a#7#1#0: Seq Box, 
    a#7#2#0: Seq Box, 
    a#7#3#0: DatatypeType, 
    a#7#4#0: DatatypeType, 
    a#7#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0, a#7#5#0) } 
  Seq#Rank(a#7#0#0)
     < DtRank(#JournalistModel.JournalInfo.JournalInfo(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0, a#7#5#0)));

function JournalistModel.JournalInfo.inMemoryJournal(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#8#0#0: Seq Box, 
    a#8#1#0: Seq Box, 
    a#8#2#0: Seq Box, 
    a#8#3#0: DatatypeType, 
    a#8#4#0: DatatypeType, 
    a#8#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0, a#8#5#0) } 
  JournalistModel.JournalInfo.inMemoryJournal(#JournalistModel.JournalInfo.JournalInfo(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0, a#8#5#0))
     == a#8#1#0);

// Inductive seq element rank
axiom (forall a#9#0#0: Seq Box, 
    a#9#1#0: Seq Box, 
    a#9#2#0: Seq Box, 
    a#9#3#0: DatatypeType, 
    a#9#4#0: DatatypeType, 
    a#9#5#0: int, 
    i: int :: 
  { Seq#Index(a#9#1#0, i), #JournalistModel.JournalInfo.JournalInfo(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0, a#9#5#0) } 
  0 <= i && i < Seq#Length(a#9#1#0)
     ==> DtRank($Unbox(Seq#Index(a#9#1#0, i)): DatatypeType)
       < DtRank(#JournalistModel.JournalInfo.JournalInfo(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0, a#9#5#0)));

// Inductive seq rank
axiom (forall a#10#0#0: Seq Box, 
    a#10#1#0: Seq Box, 
    a#10#2#0: Seq Box, 
    a#10#3#0: DatatypeType, 
    a#10#4#0: DatatypeType, 
    a#10#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0, a#10#5#0) } 
  Seq#Rank(a#10#1#0)
     < DtRank(#JournalistModel.JournalInfo.JournalInfo(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0, a#10#5#0)));

function JournalistModel.JournalInfo.replayJournal(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#11#0#0: Seq Box, 
    a#11#1#0: Seq Box, 
    a#11#2#0: Seq Box, 
    a#11#3#0: DatatypeType, 
    a#11#4#0: DatatypeType, 
    a#11#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0, a#11#5#0) } 
  JournalistModel.JournalInfo.replayJournal(#JournalistModel.JournalInfo.JournalInfo(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0, a#11#5#0))
     == a#11#2#0);

// Inductive seq element rank
axiom (forall a#12#0#0: Seq Box, 
    a#12#1#0: Seq Box, 
    a#12#2#0: Seq Box, 
    a#12#3#0: DatatypeType, 
    a#12#4#0: DatatypeType, 
    a#12#5#0: int, 
    i: int :: 
  { Seq#Index(a#12#2#0, i), #JournalistModel.JournalInfo.JournalInfo(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0, a#12#5#0) } 
  0 <= i && i < Seq#Length(a#12#2#0)
     ==> DtRank($Unbox(Seq#Index(a#12#2#0, i)): DatatypeType)
       < DtRank(#JournalistModel.JournalInfo.JournalInfo(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0, a#12#5#0)));

// Inductive seq rank
axiom (forall a#13#0#0: Seq Box, 
    a#13#1#0: Seq Box, 
    a#13#2#0: Seq Box, 
    a#13#3#0: DatatypeType, 
    a#13#4#0: DatatypeType, 
    a#13#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0, a#13#5#0) } 
  Seq#Rank(a#13#2#0)
     < DtRank(#JournalistModel.JournalInfo.JournalInfo(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0, a#13#5#0)));

function JournalistModel.JournalInfo.journalFront(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#14#0#0: Seq Box, 
    a#14#1#0: Seq Box, 
    a#14#2#0: Seq Box, 
    a#14#3#0: DatatypeType, 
    a#14#4#0: DatatypeType, 
    a#14#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0, a#14#5#0) } 
  JournalistModel.JournalInfo.journalFront(#JournalistModel.JournalInfo.JournalInfo(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0, a#14#5#0))
     == a#14#3#0);

// Inductive rank
axiom (forall a#15#0#0: Seq Box, 
    a#15#1#0: Seq Box, 
    a#15#2#0: Seq Box, 
    a#15#3#0: DatatypeType, 
    a#15#4#0: DatatypeType, 
    a#15#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0, a#15#5#0) } 
  DtRank(a#15#3#0)
     < DtRank(#JournalistModel.JournalInfo.JournalInfo(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0, a#15#5#0)));

function JournalistModel.JournalInfo.journalBack(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#16#0#0: Seq Box, 
    a#16#1#0: Seq Box, 
    a#16#2#0: Seq Box, 
    a#16#3#0: DatatypeType, 
    a#16#4#0: DatatypeType, 
    a#16#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0, a#16#5#0) } 
  JournalistModel.JournalInfo.journalBack(#JournalistModel.JournalInfo.JournalInfo(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0, a#16#5#0))
     == a#16#4#0);

// Inductive rank
axiom (forall a#17#0#0: Seq Box, 
    a#17#1#0: Seq Box, 
    a#17#2#0: Seq Box, 
    a#17#3#0: DatatypeType, 
    a#17#4#0: DatatypeType, 
    a#17#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0, a#17#5#0) } 
  DtRank(a#17#4#0)
     < DtRank(#JournalistModel.JournalInfo.JournalInfo(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0, a#17#5#0)));

function JournalistModel.JournalInfo.writtenJournalLen(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#18#0#0: Seq Box, 
    a#18#1#0: Seq Box, 
    a#18#2#0: Seq Box, 
    a#18#3#0: DatatypeType, 
    a#18#4#0: DatatypeType, 
    a#18#5#0: int :: 
  { #JournalistModel.JournalInfo.JournalInfo(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0, a#18#5#0) } 
  JournalistModel.JournalInfo.writtenJournalLen(#JournalistModel.JournalInfo.JournalInfo(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0, a#18#5#0))
     == a#18#5#0);

// Depth-one case-split function
function $IsA#JournalistModel.JournalInfo(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalistModel.JournalInfo(d) } 
  $IsA#JournalistModel.JournalInfo(d)
     ==> JournalistModel.JournalInfo.JournalInfo_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalistModel.JournalInfo.JournalInfo_q(d), $Is(d, Tclass.JournalistModel.JournalInfo()) } 
  $Is(d, Tclass.JournalistModel.JournalInfo())
     ==> JournalistModel.JournalInfo.JournalInfo_q(d));

// Datatype extensional equality declaration
function JournalistModel.JournalInfo#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalistModel.JournalInfo.JournalInfo
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalistModel.JournalInfo#Equal(a, b) } 
  true
     ==> (JournalistModel.JournalInfo#Equal(a, b)
       <==> Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(a), 
          JournalistModel.JournalInfo.inMemoryJournalFrozen(b))
         && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(a), 
          JournalistModel.JournalInfo.inMemoryJournal(b))
         && Seq#Equal(JournalistModel.JournalInfo.replayJournal(a), 
          JournalistModel.JournalInfo.replayJournal(b))
         && Options.Option#Equal(JournalistModel.JournalInfo.journalFront(a), 
          JournalistModel.JournalInfo.journalFront(b))
         && Options.Option#Equal(JournalistModel.JournalInfo.journalBack(a), 
          JournalistModel.JournalInfo.journalBack(b))
         && JournalistModel.JournalInfo.writtenJournalLen(a)
           == JournalistModel.JournalInfo.writtenJournalLen(b)));

// Datatype extensionality axiom: JournalistModel.JournalInfo
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalistModel.JournalInfo#Equal(a, b) } 
  JournalistModel.JournalInfo#Equal(a, b) <==> a == b);

const unique class.JournalistModel.JournalInfo: ClassName;

// Constructor function declaration
function #JournalistModel.JournalistModel.JournalistModel(Seq Box, int, int, int, Seq Box, int, DatatypeType, DatatypeType, int, int, int)
   : DatatypeType;

const unique ##JournalistModel.JournalistModel.JournalistModel: DtCtorId;

// Constructor identifier
axiom (forall a#19#0#0: Seq Box, 
    a#19#1#0: int, 
    a#19#2#0: int, 
    a#19#3#0: int, 
    a#19#4#0: Seq Box, 
    a#19#5#0: int, 
    a#19#6#0: DatatypeType, 
    a#19#7#0: DatatypeType, 
    a#19#8#0: int, 
    a#19#9#0: int, 
    a#19#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#19#0#0, 
      a#19#1#0, 
      a#19#2#0, 
      a#19#3#0, 
      a#19#4#0, 
      a#19#5#0, 
      a#19#6#0, 
      a#19#7#0, 
      a#19#8#0, 
      a#19#9#0, 
      a#19#10#0) } 
  DatatypeCtorId(#JournalistModel.JournalistModel.JournalistModel(a#19#0#0, 
        a#19#1#0, 
        a#19#2#0, 
        a#19#3#0, 
        a#19#4#0, 
        a#19#5#0, 
        a#19#6#0, 
        a#19#7#0, 
        a#19#8#0, 
        a#19#9#0, 
        a#19#10#0))
     == ##JournalistModel.JournalistModel.JournalistModel);

function JournalistModel.JournalistModel.JournalistModel_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalistModel.JournalistModel.JournalistModel_q(d) } 
  JournalistModel.JournalistModel.JournalistModel_q(d)
     <==> DatatypeCtorId(d) == ##JournalistModel.JournalistModel.JournalistModel);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalistModel.JournalistModel.JournalistModel_q(d) } 
  JournalistModel.JournalistModel.JournalistModel_q(d)
     ==> (exists a#20#0#0: Seq Box, 
        a#20#1#0: int, 
        a#20#2#0: int, 
        a#20#3#0: int, 
        a#20#4#0: Seq Box, 
        a#20#5#0: int, 
        a#20#6#0: DatatypeType, 
        a#20#7#0: DatatypeType, 
        a#20#8#0: int, 
        a#20#9#0: int, 
        a#20#10#0: int :: 
      d
         == #JournalistModel.JournalistModel.JournalistModel(a#20#0#0, 
          a#20#1#0, 
          a#20#2#0, 
          a#20#3#0, 
          a#20#4#0, 
          a#20#5#0, 
          a#20#6#0, 
          a#20#7#0, 
          a#20#8#0, 
          a#20#9#0, 
          a#20#10#0)));

// Constructor $Is
axiom (forall a#21#0#0: Seq Box, 
    a#21#1#0: int, 
    a#21#2#0: int, 
    a#21#3#0: int, 
    a#21#4#0: Seq Box, 
    a#21#5#0: int, 
    a#21#6#0: DatatypeType, 
    a#21#7#0: DatatypeType, 
    a#21#8#0: int, 
    a#21#9#0: int, 
    a#21#10#0: int :: 
  { $Is(#JournalistModel.JournalistModel.JournalistModel(a#21#0#0, 
        a#21#1#0, 
        a#21#2#0, 
        a#21#3#0, 
        a#21#4#0, 
        a#21#5#0, 
        a#21#6#0, 
        a#21#7#0, 
        a#21#8#0, 
        a#21#9#0, 
        a#21#10#0), 
      Tclass.JournalistModel.JournalistModel()) } 
  $Is(#JournalistModel.JournalistModel.JournalistModel(a#21#0#0, 
        a#21#1#0, 
        a#21#2#0, 
        a#21#3#0, 
        a#21#4#0, 
        a#21#5#0, 
        a#21#6#0, 
        a#21#7#0, 
        a#21#8#0, 
        a#21#9#0, 
        a#21#10#0), 
      Tclass.JournalistModel.JournalistModel())
     <==> $Is(a#21#0#0, TSeq(Tclass.Journal.JournalEntry()))
       && $Is(a#21#1#0, Tclass.NativeTypes.uint64())
       && $Is(a#21#2#0, Tclass.NativeTypes.uint64())
       && $Is(a#21#3#0, Tclass.NativeTypes.uint64())
       && $Is(a#21#4#0, TSeq(Tclass.Journal.JournalEntry()))
       && $Is(a#21#5#0, Tclass.NativeTypes.uint64())
       && $Is(a#21#6#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))))
       && $Is(a#21#7#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))))
       && $Is(a#21#8#0, Tclass.NativeTypes.uint64())
       && $Is(a#21#9#0, Tclass.NativeTypes.uint64())
       && $Is(a#21#10#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#22#0#0: Seq Box, 
    a#22#1#0: int, 
    a#22#2#0: int, 
    a#22#3#0: int, 
    a#22#4#0: Seq Box, 
    a#22#5#0: int, 
    a#22#6#0: DatatypeType, 
    a#22#7#0: DatatypeType, 
    a#22#8#0: int, 
    a#22#9#0: int, 
    a#22#10#0: int, 
    $h: Heap :: 
  { $IsAlloc(#JournalistModel.JournalistModel.JournalistModel(a#22#0#0, 
        a#22#1#0, 
        a#22#2#0, 
        a#22#3#0, 
        a#22#4#0, 
        a#22#5#0, 
        a#22#6#0, 
        a#22#7#0, 
        a#22#8#0, 
        a#22#9#0, 
        a#22#10#0), 
      Tclass.JournalistModel.JournalistModel(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalistModel.JournalistModel.JournalistModel(a#22#0#0, 
          a#22#1#0, 
          a#22#2#0, 
          a#22#3#0, 
          a#22#4#0, 
          a#22#5#0, 
          a#22#6#0, 
          a#22#7#0, 
          a#22#8#0, 
          a#22#9#0, 
          a#22#10#0), 
        Tclass.JournalistModel.JournalistModel(), 
        $h)
       <==> $IsAlloc(a#22#0#0, TSeq(Tclass.Journal.JournalEntry()), $h)
         && $IsAlloc(a#22#1#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#22#2#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#22#3#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#22#4#0, TSeq(Tclass.Journal.JournalEntry()), $h)
         && $IsAlloc(a#22#5#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#22#6#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), $h)
         && $IsAlloc(a#22#7#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), $h)
         && $IsAlloc(a#22#8#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#22#9#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#22#10#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.journalEntries(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.journalEntries(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.start(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.start(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.len1(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.len1(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.len2(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.len2(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.replayJournal(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.replayJournal(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.replayIdx(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.replayIdx(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.journalFront(d), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.journalFront(d), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.journalBack(d), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.journalBack(d), 
      Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.writtenJournalBlocks(d), 
      Tclass.NativeTypes.uint64(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.writtenJournalBlocks(d), 
      Tclass.NativeTypes.uint64(), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.frozenJournalBlocks(d), 
      Tclass.NativeTypes.uint64(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.frozenJournalBlocks(d), 
      Tclass.NativeTypes.uint64(), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalistModel.JournalistModel.inMemoryWeight(d), 
      Tclass.NativeTypes.uint64(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalistModel.JournalistModel.JournalistModel_q(d)
       && $IsAlloc(d, Tclass.JournalistModel.JournalistModel(), $h)
     ==> $IsAlloc(JournalistModel.JournalistModel.inMemoryWeight(d), 
      Tclass.NativeTypes.uint64(), 
      $h));

// Constructor literal
axiom (forall a#23#0#0: Seq Box, 
    a#23#1#0: int, 
    a#23#2#0: int, 
    a#23#3#0: int, 
    a#23#4#0: Seq Box, 
    a#23#5#0: int, 
    a#23#6#0: DatatypeType, 
    a#23#7#0: DatatypeType, 
    a#23#8#0: int, 
    a#23#9#0: int, 
    a#23#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(Lit(a#23#0#0), 
      LitInt(a#23#1#0), 
      LitInt(a#23#2#0), 
      LitInt(a#23#3#0), 
      Lit(a#23#4#0), 
      LitInt(a#23#5#0), 
      Lit(a#23#6#0), 
      Lit(a#23#7#0), 
      LitInt(a#23#8#0), 
      LitInt(a#23#9#0), 
      LitInt(a#23#10#0)) } 
  #JournalistModel.JournalistModel.JournalistModel(Lit(a#23#0#0), 
      LitInt(a#23#1#0), 
      LitInt(a#23#2#0), 
      LitInt(a#23#3#0), 
      Lit(a#23#4#0), 
      LitInt(a#23#5#0), 
      Lit(a#23#6#0), 
      Lit(a#23#7#0), 
      LitInt(a#23#8#0), 
      LitInt(a#23#9#0), 
      LitInt(a#23#10#0))
     == Lit(#JournalistModel.JournalistModel.JournalistModel(a#23#0#0, 
        a#23#1#0, 
        a#23#2#0, 
        a#23#3#0, 
        a#23#4#0, 
        a#23#5#0, 
        a#23#6#0, 
        a#23#7#0, 
        a#23#8#0, 
        a#23#9#0, 
        a#23#10#0)));

function JournalistModel.JournalistModel.journalEntries(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#24#0#0: Seq Box, 
    a#24#1#0: int, 
    a#24#2#0: int, 
    a#24#3#0: int, 
    a#24#4#0: Seq Box, 
    a#24#5#0: int, 
    a#24#6#0: DatatypeType, 
    a#24#7#0: DatatypeType, 
    a#24#8#0: int, 
    a#24#9#0: int, 
    a#24#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#24#0#0, 
      a#24#1#0, 
      a#24#2#0, 
      a#24#3#0, 
      a#24#4#0, 
      a#24#5#0, 
      a#24#6#0, 
      a#24#7#0, 
      a#24#8#0, 
      a#24#9#0, 
      a#24#10#0) } 
  JournalistModel.JournalistModel.journalEntries(#JournalistModel.JournalistModel.JournalistModel(a#24#0#0, 
        a#24#1#0, 
        a#24#2#0, 
        a#24#3#0, 
        a#24#4#0, 
        a#24#5#0, 
        a#24#6#0, 
        a#24#7#0, 
        a#24#8#0, 
        a#24#9#0, 
        a#24#10#0))
     == a#24#0#0);

// Inductive seq element rank
axiom (forall a#25#0#0: Seq Box, 
    a#25#1#0: int, 
    a#25#2#0: int, 
    a#25#3#0: int, 
    a#25#4#0: Seq Box, 
    a#25#5#0: int, 
    a#25#6#0: DatatypeType, 
    a#25#7#0: DatatypeType, 
    a#25#8#0: int, 
    a#25#9#0: int, 
    a#25#10#0: int, 
    i: int :: 
  { Seq#Index(a#25#0#0, i), #JournalistModel.JournalistModel.JournalistModel(a#25#0#0, 
      a#25#1#0, 
      a#25#2#0, 
      a#25#3#0, 
      a#25#4#0, 
      a#25#5#0, 
      a#25#6#0, 
      a#25#7#0, 
      a#25#8#0, 
      a#25#9#0, 
      a#25#10#0) } 
  0 <= i && i < Seq#Length(a#25#0#0)
     ==> DtRank($Unbox(Seq#Index(a#25#0#0, i)): DatatypeType)
       < DtRank(#JournalistModel.JournalistModel.JournalistModel(a#25#0#0, 
          a#25#1#0, 
          a#25#2#0, 
          a#25#3#0, 
          a#25#4#0, 
          a#25#5#0, 
          a#25#6#0, 
          a#25#7#0, 
          a#25#8#0, 
          a#25#9#0, 
          a#25#10#0)));

// Inductive seq rank
axiom (forall a#26#0#0: Seq Box, 
    a#26#1#0: int, 
    a#26#2#0: int, 
    a#26#3#0: int, 
    a#26#4#0: Seq Box, 
    a#26#5#0: int, 
    a#26#6#0: DatatypeType, 
    a#26#7#0: DatatypeType, 
    a#26#8#0: int, 
    a#26#9#0: int, 
    a#26#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#26#0#0, 
      a#26#1#0, 
      a#26#2#0, 
      a#26#3#0, 
      a#26#4#0, 
      a#26#5#0, 
      a#26#6#0, 
      a#26#7#0, 
      a#26#8#0, 
      a#26#9#0, 
      a#26#10#0) } 
  Seq#Rank(a#26#0#0)
     < DtRank(#JournalistModel.JournalistModel.JournalistModel(a#26#0#0, 
        a#26#1#0, 
        a#26#2#0, 
        a#26#3#0, 
        a#26#4#0, 
        a#26#5#0, 
        a#26#6#0, 
        a#26#7#0, 
        a#26#8#0, 
        a#26#9#0, 
        a#26#10#0)));

function JournalistModel.JournalistModel.start(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#27#0#0: Seq Box, 
    a#27#1#0: int, 
    a#27#2#0: int, 
    a#27#3#0: int, 
    a#27#4#0: Seq Box, 
    a#27#5#0: int, 
    a#27#6#0: DatatypeType, 
    a#27#7#0: DatatypeType, 
    a#27#8#0: int, 
    a#27#9#0: int, 
    a#27#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#27#0#0, 
      a#27#1#0, 
      a#27#2#0, 
      a#27#3#0, 
      a#27#4#0, 
      a#27#5#0, 
      a#27#6#0, 
      a#27#7#0, 
      a#27#8#0, 
      a#27#9#0, 
      a#27#10#0) } 
  JournalistModel.JournalistModel.start(#JournalistModel.JournalistModel.JournalistModel(a#27#0#0, 
        a#27#1#0, 
        a#27#2#0, 
        a#27#3#0, 
        a#27#4#0, 
        a#27#5#0, 
        a#27#6#0, 
        a#27#7#0, 
        a#27#8#0, 
        a#27#9#0, 
        a#27#10#0))
     == a#27#1#0);

function JournalistModel.JournalistModel.len1(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#28#0#0: Seq Box, 
    a#28#1#0: int, 
    a#28#2#0: int, 
    a#28#3#0: int, 
    a#28#4#0: Seq Box, 
    a#28#5#0: int, 
    a#28#6#0: DatatypeType, 
    a#28#7#0: DatatypeType, 
    a#28#8#0: int, 
    a#28#9#0: int, 
    a#28#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#28#0#0, 
      a#28#1#0, 
      a#28#2#0, 
      a#28#3#0, 
      a#28#4#0, 
      a#28#5#0, 
      a#28#6#0, 
      a#28#7#0, 
      a#28#8#0, 
      a#28#9#0, 
      a#28#10#0) } 
  JournalistModel.JournalistModel.len1(#JournalistModel.JournalistModel.JournalistModel(a#28#0#0, 
        a#28#1#0, 
        a#28#2#0, 
        a#28#3#0, 
        a#28#4#0, 
        a#28#5#0, 
        a#28#6#0, 
        a#28#7#0, 
        a#28#8#0, 
        a#28#9#0, 
        a#28#10#0))
     == a#28#2#0);

function JournalistModel.JournalistModel.len2(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#29#0#0: Seq Box, 
    a#29#1#0: int, 
    a#29#2#0: int, 
    a#29#3#0: int, 
    a#29#4#0: Seq Box, 
    a#29#5#0: int, 
    a#29#6#0: DatatypeType, 
    a#29#7#0: DatatypeType, 
    a#29#8#0: int, 
    a#29#9#0: int, 
    a#29#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#29#0#0, 
      a#29#1#0, 
      a#29#2#0, 
      a#29#3#0, 
      a#29#4#0, 
      a#29#5#0, 
      a#29#6#0, 
      a#29#7#0, 
      a#29#8#0, 
      a#29#9#0, 
      a#29#10#0) } 
  JournalistModel.JournalistModel.len2(#JournalistModel.JournalistModel.JournalistModel(a#29#0#0, 
        a#29#1#0, 
        a#29#2#0, 
        a#29#3#0, 
        a#29#4#0, 
        a#29#5#0, 
        a#29#6#0, 
        a#29#7#0, 
        a#29#8#0, 
        a#29#9#0, 
        a#29#10#0))
     == a#29#3#0);

function JournalistModel.JournalistModel.replayJournal(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#30#0#0: Seq Box, 
    a#30#1#0: int, 
    a#30#2#0: int, 
    a#30#3#0: int, 
    a#30#4#0: Seq Box, 
    a#30#5#0: int, 
    a#30#6#0: DatatypeType, 
    a#30#7#0: DatatypeType, 
    a#30#8#0: int, 
    a#30#9#0: int, 
    a#30#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#30#0#0, 
      a#30#1#0, 
      a#30#2#0, 
      a#30#3#0, 
      a#30#4#0, 
      a#30#5#0, 
      a#30#6#0, 
      a#30#7#0, 
      a#30#8#0, 
      a#30#9#0, 
      a#30#10#0) } 
  JournalistModel.JournalistModel.replayJournal(#JournalistModel.JournalistModel.JournalistModel(a#30#0#0, 
        a#30#1#0, 
        a#30#2#0, 
        a#30#3#0, 
        a#30#4#0, 
        a#30#5#0, 
        a#30#6#0, 
        a#30#7#0, 
        a#30#8#0, 
        a#30#9#0, 
        a#30#10#0))
     == a#30#4#0);

// Inductive seq element rank
axiom (forall a#31#0#0: Seq Box, 
    a#31#1#0: int, 
    a#31#2#0: int, 
    a#31#3#0: int, 
    a#31#4#0: Seq Box, 
    a#31#5#0: int, 
    a#31#6#0: DatatypeType, 
    a#31#7#0: DatatypeType, 
    a#31#8#0: int, 
    a#31#9#0: int, 
    a#31#10#0: int, 
    i: int :: 
  { Seq#Index(a#31#4#0, i), #JournalistModel.JournalistModel.JournalistModel(a#31#0#0, 
      a#31#1#0, 
      a#31#2#0, 
      a#31#3#0, 
      a#31#4#0, 
      a#31#5#0, 
      a#31#6#0, 
      a#31#7#0, 
      a#31#8#0, 
      a#31#9#0, 
      a#31#10#0) } 
  0 <= i && i < Seq#Length(a#31#4#0)
     ==> DtRank($Unbox(Seq#Index(a#31#4#0, i)): DatatypeType)
       < DtRank(#JournalistModel.JournalistModel.JournalistModel(a#31#0#0, 
          a#31#1#0, 
          a#31#2#0, 
          a#31#3#0, 
          a#31#4#0, 
          a#31#5#0, 
          a#31#6#0, 
          a#31#7#0, 
          a#31#8#0, 
          a#31#9#0, 
          a#31#10#0)));

// Inductive seq rank
axiom (forall a#32#0#0: Seq Box, 
    a#32#1#0: int, 
    a#32#2#0: int, 
    a#32#3#0: int, 
    a#32#4#0: Seq Box, 
    a#32#5#0: int, 
    a#32#6#0: DatatypeType, 
    a#32#7#0: DatatypeType, 
    a#32#8#0: int, 
    a#32#9#0: int, 
    a#32#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#32#0#0, 
      a#32#1#0, 
      a#32#2#0, 
      a#32#3#0, 
      a#32#4#0, 
      a#32#5#0, 
      a#32#6#0, 
      a#32#7#0, 
      a#32#8#0, 
      a#32#9#0, 
      a#32#10#0) } 
  Seq#Rank(a#32#4#0)
     < DtRank(#JournalistModel.JournalistModel.JournalistModel(a#32#0#0, 
        a#32#1#0, 
        a#32#2#0, 
        a#32#3#0, 
        a#32#4#0, 
        a#32#5#0, 
        a#32#6#0, 
        a#32#7#0, 
        a#32#8#0, 
        a#32#9#0, 
        a#32#10#0)));

function JournalistModel.JournalistModel.replayIdx(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#33#0#0: Seq Box, 
    a#33#1#0: int, 
    a#33#2#0: int, 
    a#33#3#0: int, 
    a#33#4#0: Seq Box, 
    a#33#5#0: int, 
    a#33#6#0: DatatypeType, 
    a#33#7#0: DatatypeType, 
    a#33#8#0: int, 
    a#33#9#0: int, 
    a#33#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#33#0#0, 
      a#33#1#0, 
      a#33#2#0, 
      a#33#3#0, 
      a#33#4#0, 
      a#33#5#0, 
      a#33#6#0, 
      a#33#7#0, 
      a#33#8#0, 
      a#33#9#0, 
      a#33#10#0) } 
  JournalistModel.JournalistModel.replayIdx(#JournalistModel.JournalistModel.JournalistModel(a#33#0#0, 
        a#33#1#0, 
        a#33#2#0, 
        a#33#3#0, 
        a#33#4#0, 
        a#33#5#0, 
        a#33#6#0, 
        a#33#7#0, 
        a#33#8#0, 
        a#33#9#0, 
        a#33#10#0))
     == a#33#5#0);

function JournalistModel.JournalistModel.journalFront(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#34#0#0: Seq Box, 
    a#34#1#0: int, 
    a#34#2#0: int, 
    a#34#3#0: int, 
    a#34#4#0: Seq Box, 
    a#34#5#0: int, 
    a#34#6#0: DatatypeType, 
    a#34#7#0: DatatypeType, 
    a#34#8#0: int, 
    a#34#9#0: int, 
    a#34#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#34#0#0, 
      a#34#1#0, 
      a#34#2#0, 
      a#34#3#0, 
      a#34#4#0, 
      a#34#5#0, 
      a#34#6#0, 
      a#34#7#0, 
      a#34#8#0, 
      a#34#9#0, 
      a#34#10#0) } 
  JournalistModel.JournalistModel.journalFront(#JournalistModel.JournalistModel.JournalistModel(a#34#0#0, 
        a#34#1#0, 
        a#34#2#0, 
        a#34#3#0, 
        a#34#4#0, 
        a#34#5#0, 
        a#34#6#0, 
        a#34#7#0, 
        a#34#8#0, 
        a#34#9#0, 
        a#34#10#0))
     == a#34#6#0);

// Inductive rank
axiom (forall a#35#0#0: Seq Box, 
    a#35#1#0: int, 
    a#35#2#0: int, 
    a#35#3#0: int, 
    a#35#4#0: Seq Box, 
    a#35#5#0: int, 
    a#35#6#0: DatatypeType, 
    a#35#7#0: DatatypeType, 
    a#35#8#0: int, 
    a#35#9#0: int, 
    a#35#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#35#0#0, 
      a#35#1#0, 
      a#35#2#0, 
      a#35#3#0, 
      a#35#4#0, 
      a#35#5#0, 
      a#35#6#0, 
      a#35#7#0, 
      a#35#8#0, 
      a#35#9#0, 
      a#35#10#0) } 
  DtRank(a#35#6#0)
     < DtRank(#JournalistModel.JournalistModel.JournalistModel(a#35#0#0, 
        a#35#1#0, 
        a#35#2#0, 
        a#35#3#0, 
        a#35#4#0, 
        a#35#5#0, 
        a#35#6#0, 
        a#35#7#0, 
        a#35#8#0, 
        a#35#9#0, 
        a#35#10#0)));

function JournalistModel.JournalistModel.journalBack(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#36#0#0: Seq Box, 
    a#36#1#0: int, 
    a#36#2#0: int, 
    a#36#3#0: int, 
    a#36#4#0: Seq Box, 
    a#36#5#0: int, 
    a#36#6#0: DatatypeType, 
    a#36#7#0: DatatypeType, 
    a#36#8#0: int, 
    a#36#9#0: int, 
    a#36#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#36#0#0, 
      a#36#1#0, 
      a#36#2#0, 
      a#36#3#0, 
      a#36#4#0, 
      a#36#5#0, 
      a#36#6#0, 
      a#36#7#0, 
      a#36#8#0, 
      a#36#9#0, 
      a#36#10#0) } 
  JournalistModel.JournalistModel.journalBack(#JournalistModel.JournalistModel.JournalistModel(a#36#0#0, 
        a#36#1#0, 
        a#36#2#0, 
        a#36#3#0, 
        a#36#4#0, 
        a#36#5#0, 
        a#36#6#0, 
        a#36#7#0, 
        a#36#8#0, 
        a#36#9#0, 
        a#36#10#0))
     == a#36#7#0);

// Inductive rank
axiom (forall a#37#0#0: Seq Box, 
    a#37#1#0: int, 
    a#37#2#0: int, 
    a#37#3#0: int, 
    a#37#4#0: Seq Box, 
    a#37#5#0: int, 
    a#37#6#0: DatatypeType, 
    a#37#7#0: DatatypeType, 
    a#37#8#0: int, 
    a#37#9#0: int, 
    a#37#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#37#0#0, 
      a#37#1#0, 
      a#37#2#0, 
      a#37#3#0, 
      a#37#4#0, 
      a#37#5#0, 
      a#37#6#0, 
      a#37#7#0, 
      a#37#8#0, 
      a#37#9#0, 
      a#37#10#0) } 
  DtRank(a#37#7#0)
     < DtRank(#JournalistModel.JournalistModel.JournalistModel(a#37#0#0, 
        a#37#1#0, 
        a#37#2#0, 
        a#37#3#0, 
        a#37#4#0, 
        a#37#5#0, 
        a#37#6#0, 
        a#37#7#0, 
        a#37#8#0, 
        a#37#9#0, 
        a#37#10#0)));

function JournalistModel.JournalistModel.writtenJournalBlocks(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#38#0#0: Seq Box, 
    a#38#1#0: int, 
    a#38#2#0: int, 
    a#38#3#0: int, 
    a#38#4#0: Seq Box, 
    a#38#5#0: int, 
    a#38#6#0: DatatypeType, 
    a#38#7#0: DatatypeType, 
    a#38#8#0: int, 
    a#38#9#0: int, 
    a#38#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#38#0#0, 
      a#38#1#0, 
      a#38#2#0, 
      a#38#3#0, 
      a#38#4#0, 
      a#38#5#0, 
      a#38#6#0, 
      a#38#7#0, 
      a#38#8#0, 
      a#38#9#0, 
      a#38#10#0) } 
  JournalistModel.JournalistModel.writtenJournalBlocks(#JournalistModel.JournalistModel.JournalistModel(a#38#0#0, 
        a#38#1#0, 
        a#38#2#0, 
        a#38#3#0, 
        a#38#4#0, 
        a#38#5#0, 
        a#38#6#0, 
        a#38#7#0, 
        a#38#8#0, 
        a#38#9#0, 
        a#38#10#0))
     == a#38#8#0);

function JournalistModel.JournalistModel.frozenJournalBlocks(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#39#0#0: Seq Box, 
    a#39#1#0: int, 
    a#39#2#0: int, 
    a#39#3#0: int, 
    a#39#4#0: Seq Box, 
    a#39#5#0: int, 
    a#39#6#0: DatatypeType, 
    a#39#7#0: DatatypeType, 
    a#39#8#0: int, 
    a#39#9#0: int, 
    a#39#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#39#0#0, 
      a#39#1#0, 
      a#39#2#0, 
      a#39#3#0, 
      a#39#4#0, 
      a#39#5#0, 
      a#39#6#0, 
      a#39#7#0, 
      a#39#8#0, 
      a#39#9#0, 
      a#39#10#0) } 
  JournalistModel.JournalistModel.frozenJournalBlocks(#JournalistModel.JournalistModel.JournalistModel(a#39#0#0, 
        a#39#1#0, 
        a#39#2#0, 
        a#39#3#0, 
        a#39#4#0, 
        a#39#5#0, 
        a#39#6#0, 
        a#39#7#0, 
        a#39#8#0, 
        a#39#9#0, 
        a#39#10#0))
     == a#39#9#0);

function JournalistModel.JournalistModel.inMemoryWeight(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#40#0#0: Seq Box, 
    a#40#1#0: int, 
    a#40#2#0: int, 
    a#40#3#0: int, 
    a#40#4#0: Seq Box, 
    a#40#5#0: int, 
    a#40#6#0: DatatypeType, 
    a#40#7#0: DatatypeType, 
    a#40#8#0: int, 
    a#40#9#0: int, 
    a#40#10#0: int :: 
  { #JournalistModel.JournalistModel.JournalistModel(a#40#0#0, 
      a#40#1#0, 
      a#40#2#0, 
      a#40#3#0, 
      a#40#4#0, 
      a#40#5#0, 
      a#40#6#0, 
      a#40#7#0, 
      a#40#8#0, 
      a#40#9#0, 
      a#40#10#0) } 
  JournalistModel.JournalistModel.inMemoryWeight(#JournalistModel.JournalistModel.JournalistModel(a#40#0#0, 
        a#40#1#0, 
        a#40#2#0, 
        a#40#3#0, 
        a#40#4#0, 
        a#40#5#0, 
        a#40#6#0, 
        a#40#7#0, 
        a#40#8#0, 
        a#40#9#0, 
        a#40#10#0))
     == a#40#10#0);

// Depth-one case-split function
function $IsA#JournalistModel.JournalistModel(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalistModel.JournalistModel(d) } 
  $IsA#JournalistModel.JournalistModel(d)
     ==> JournalistModel.JournalistModel.JournalistModel_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalistModel.JournalistModel.JournalistModel_q(d), $Is(d, Tclass.JournalistModel.JournalistModel()) } 
  $Is(d, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.JournalistModel.JournalistModel_q(d));

// Datatype extensional equality declaration
function JournalistModel.JournalistModel#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalistModel.JournalistModel.JournalistModel
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalistModel.JournalistModel#Equal(a, b) } 
  true
     ==> (JournalistModel.JournalistModel#Equal(a, b)
       <==> Seq#Equal(JournalistModel.JournalistModel.journalEntries(a), 
          JournalistModel.JournalistModel.journalEntries(b))
         && JournalistModel.JournalistModel.start(a)
           == JournalistModel.JournalistModel.start(b)
         && JournalistModel.JournalistModel.len1(a)
           == JournalistModel.JournalistModel.len1(b)
         && JournalistModel.JournalistModel.len2(a)
           == JournalistModel.JournalistModel.len2(b)
         && Seq#Equal(JournalistModel.JournalistModel.replayJournal(a), 
          JournalistModel.JournalistModel.replayJournal(b))
         && JournalistModel.JournalistModel.replayIdx(a)
           == JournalistModel.JournalistModel.replayIdx(b)
         && Options.Option#Equal(JournalistModel.JournalistModel.journalFront(a), 
          JournalistModel.JournalistModel.journalFront(b))
         && Options.Option#Equal(JournalistModel.JournalistModel.journalBack(a), 
          JournalistModel.JournalistModel.journalBack(b))
         && JournalistModel.JournalistModel.writtenJournalBlocks(a)
           == JournalistModel.JournalistModel.writtenJournalBlocks(b)
         && JournalistModel.JournalistModel.frozenJournalBlocks(a)
           == JournalistModel.JournalistModel.frozenJournalBlocks(b)
         && JournalistModel.JournalistModel.inMemoryWeight(a)
           == JournalistModel.JournalistModel.inMemoryWeight(b)));

// Datatype extensionality axiom: JournalistModel.JournalistModel
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalistModel.JournalistModel#Equal(a, b) } 
  JournalistModel.JournalistModel#Equal(a, b) <==> a == b);

const unique class.JournalistModel.JournalistModel: ClassName;

const unique class.JournalistModel.__default: ClassName;

function Tclass.JournalistModel.__default() : Ty;

// Tclass.JournalistModel.__default Tag
axiom Tag(Tclass.JournalistModel.__default()) == Tagclass.JournalistModel.__default;

const unique Tagclass.JournalistModel.__default: TyTag;

// Box/unbox axiom for Tclass.JournalistModel.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistModel.__default()) } 
  $IsBox(bx, Tclass.JournalistModel.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalistModel.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalistModel.__default()) } 
  $Is($o, Tclass.JournalistModel.__default())
     <==> $o == null || dtype($o) == Tclass.JournalistModel.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalistModel.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalistModel.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalistModel._default.MaxPossibleEntries
function JournalistModel.__default.MaxPossibleEntries() : int;

function JournalistModel.__default.MaxPossibleEntries#canCall() : bool;

// consequence axiom for JournalistModel.__default.MaxPossibleEntries
axiom true
   ==> 
  true
   ==> LitInt(0) <= JournalistModel.__default.MaxPossibleEntries()
     && JournalistModel.__default.MaxPossibleEntries() < 18446744073709551616;

function JournalistModel.__default.MaxPossibleEntries#requires() : bool;

// #requires axiom for JournalistModel.__default.MaxPossibleEntries
axiom JournalistModel.__default.MaxPossibleEntries#requires() == true;

// definition axiom for JournalistModel.__default.MaxPossibleEntries(revealed)
axiom true
   ==> 
  true
   ==> JournalistModel.__default.MaxPossibleEntries()
     == LitInt(Mul(LitInt(32), LitInt(1048576)));

// definition axiom for JournalistModel.__default.MaxPossibleEntries for all literals(revealed)
axiom true
   ==> 
  true
   ==> JournalistModel.__default.MaxPossibleEntries()
     == LitInt(Mul(LitInt(32), LitInt(1048576)));

// function declaration for JournalistModel._default.basic_mod
function JournalistModel.__default.basic__mod(x#0: int, len#0: int) : int;

function JournalistModel.__default.basic__mod#canCall(x#0: int, len#0: int) : bool;

// consequence axiom for JournalistModel.__default.basic__mod
axiom true
   ==> (forall x#0: int, len#0: int :: 
    { JournalistModel.__default.basic__mod(x#0, len#0) } 
    JournalistModel.__default.basic__mod#canCall(x#0, len#0)
         || (
          LitInt(0) <= x#0
           && x#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && len#0
             <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))))
       ==> LitInt(0) <= JournalistModel.__default.basic__mod(x#0, len#0)
         && JournalistModel.__default.basic__mod(x#0, len#0) < 18446744073709551616);

function JournalistModel.__default.basic__mod#requires(int, int) : bool;

// #requires axiom for JournalistModel.__default.basic__mod
axiom (forall x#0: int, len#0: int :: 
  { JournalistModel.__default.basic__mod#requires(x#0, len#0) } 
  LitInt(0) <= x#0
       && x#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> JournalistModel.__default.basic__mod#requires(x#0, len#0)
       == (len#0
         <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))));

// definition axiom for JournalistModel.__default.basic__mod(revealed)
axiom true
   ==> (forall x#0: int, len#0: int :: 
    { JournalistModel.__default.basic__mod(x#0, len#0) } 
    JournalistModel.__default.basic__mod#canCall(x#0, len#0)
         || (
          LitInt(0) <= x#0
           && x#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && len#0
             <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))))
       ==> JournalistModel.__default.basic__mod(x#0, len#0)
         == (if x#0 >= len#0 then x#0 - len#0 else x#0));

// definition axiom for JournalistModel.__default.basic__mod for all literals(revealed)
axiom true
   ==> (forall x#0: int, len#0: int :: 
    {:weight 3} { JournalistModel.__default.basic__mod(LitInt(x#0), LitInt(len#0)) } 
    JournalistModel.__default.basic__mod#canCall(LitInt(x#0), LitInt(len#0))
         || (
          LitInt(0) <= x#0
           && x#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && LitInt(len#0)
             <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries()))))
       ==> JournalistModel.__default.basic__mod(LitInt(x#0), LitInt(len#0))
         == (if LitInt(x#0) >= LitInt(len#0) then x#0 - len#0 else x#0));

// function declaration for JournalistModel._default.CorrectJournalBlockSizes
function JournalistModel.__default.CorrectJournalBlockSizes(jr#0: Seq Box) : bool;

function JournalistModel.__default.CorrectJournalBlockSizes#canCall(jr#0: Seq Box) : bool;

// consequence axiom for JournalistModel.__default.CorrectJournalBlockSizes
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalistModel.__default.CorrectJournalBlockSizes(jr#0) } 
    JournalistModel.__default.CorrectJournalBlockSizes#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function JournalistModel.__default.CorrectJournalBlockSizes#requires(Seq Box) : bool;

// #requires axiom for JournalistModel.__default.CorrectJournalBlockSizes
axiom (forall jr#0: Seq Box :: 
  { JournalistModel.__default.CorrectJournalBlockSizes#requires(jr#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalistModel.__default.CorrectJournalBlockSizes#requires(jr#0) == true);

// definition axiom for JournalistModel.__default.CorrectJournalBlockSizes(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalistModel.__default.CorrectJournalBlockSizes(jr#0) } 
    JournalistModel.__default.CorrectJournalBlockSizes#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && JournalistModel.__default.CorrectJournalBlockSizes(jr#0)
           == (Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(jr#0, i#0)): Seq Box } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(jr#0)
                 ==> Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064))));

// definition axiom for JournalistModel.__default.CorrectJournalBlockSizes for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    {:weight 3} { JournalistModel.__default.CorrectJournalBlockSizes(Lit(jr#0)) } 
    JournalistModel.__default.CorrectJournalBlockSizes#canCall(Lit(jr#0))
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && JournalistModel.__default.CorrectJournalBlockSizes(Lit(jr#0))
           == (Seq#Length(Lit(jr#0)) <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(jr#0))
                 ==> Seq#Length($Unbox(Seq#Index(Lit(jr#0), i#1)): Seq Box) == LitInt(4064))));

// function declaration for JournalistModel._default.WF
function JournalistModel.__default.WF(jm#0: DatatypeType) : bool;

function JournalistModel.__default.WF#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.WF
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.WF(jm#0) } 
    JournalistModel.__default.WF#canCall(jm#0)
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> true);

function JournalistModel.__default.WF#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.WF
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.WF#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.WF#requires(jm#0) == true);

// definition axiom for JournalistModel.__default.WF(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.WF(jm#0) } 
    JournalistModel.__default.WF#canCall(jm#0)
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && (LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.__default.MaxPossibleEntries#canCall())
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.__default.MaxPossibleEntries#canCall()
             && Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.start(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)))
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.start(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0))
             && 
            LitInt(0) <= JournalistModel.JournalistModel.start(jm#0)
             && JournalistModel.JournalistModel.start(jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.len1(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)))
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.len1(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0))
             && 
            LitInt(0) <= JournalistModel.JournalistModel.len1(jm#0)
             && JournalistModel.JournalistModel.len1(jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.len2(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)))
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.len2(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0))
             && 
            LitInt(0) <= JournalistModel.JournalistModel.len2(jm#0)
             && JournalistModel.JournalistModel.len2(jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0)
                 <= JournalistModel.JournalistModel.len1(jm#0)
                   + JournalistModel.JournalistModel.len2(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)))
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0)
                 <= JournalistModel.JournalistModel.len1(jm#0)
                   + JournalistModel.JournalistModel.len2(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0))
             && 
            LitInt(0)
               <= JournalistModel.JournalistModel.len1(jm#0)
                 + JournalistModel.JournalistModel.len2(jm#0)
             && JournalistModel.JournalistModel.len1(jm#0)
                 + JournalistModel.JournalistModel.len2(jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.replayIdx(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0))
             && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.replayIdx(jm#0)
                   <= Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0))
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.__default.MaxPossibleEntries#canCall()))
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.replayIdx(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0))
             && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.replayIdx(jm#0)
                   <= Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0))
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.__default.MaxPossibleEntries#canCall())
             && 
            LitInt(0) <= JournalistModel.JournalistModel.replayIdx(jm#0)
             && JournalistModel.JournalistModel.replayIdx(jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0))
             && Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries())
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0))
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box)))
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0))
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box))
             && (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0))
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0))
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box)))
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0))
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box))
             && (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0))
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
             && JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)
             && JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(jm#0)
               ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalistModel.__default.WF(jm#0)
           == (
            LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
             && Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
             && 
            LitInt(0) <= JournalistModel.JournalistModel.start(jm#0)
             && JournalistModel.JournalistModel.start(jm#0)
               < Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
             && 
            LitInt(0) <= JournalistModel.JournalistModel.len1(jm#0)
             && JournalistModel.JournalistModel.len1(jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
             && 
            LitInt(0) <= JournalistModel.JournalistModel.len2(jm#0)
             && JournalistModel.JournalistModel.len2(jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
             && 
            LitInt(0)
               <= JournalistModel.JournalistModel.len1(jm#0)
                 + JournalistModel.JournalistModel.len2(jm#0)
             && JournalistModel.JournalistModel.len1(jm#0)
                 + JournalistModel.JournalistModel.len2(jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
             && 
            LitInt(0) <= JournalistModel.JournalistModel.replayIdx(jm#0)
             && JournalistModel.JournalistModel.replayIdx(jm#0)
               <= Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0))
             && Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries())
             && (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0))
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box))
             && (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0))
               ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box))
             && 
            LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
             && JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && 
            LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)
             && JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && 
            LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(jm#0)
             && JournalistModel.JournalistModel.inMemoryWeight(jm#0)
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)))));

// definition axiom for JournalistModel.__default.WF for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.WF(Lit(jm#0)) } 
    JournalistModel.__default.WF#canCall(Lit(jm#0))
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && (LitInt(1)
             <= Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.__default.MaxPossibleEntries#canCall())
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.__default.MaxPossibleEntries#canCall()
             && Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0) <= LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))))
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0) <= LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
             && 
            LitInt(0) <= LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))
             && JournalistModel.JournalistModel.start(Lit(jm#0))
               < Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0) <= LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))))
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0) <= LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
             && 
            LitInt(0) <= LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0)))
               <= Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0) <= LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))))
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0) <= LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
             && 
            LitInt(0) <= LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0)))
               <= Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0)
                 <= LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                     + JournalistModel.JournalistModel.len2(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))))
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0)
                 <= LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                     + JournalistModel.JournalistModel.len2(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
             && 
            LitInt(0)
               <= LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                   + JournalistModel.JournalistModel.len2(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                   + JournalistModel.JournalistModel.len2(Lit(jm#0)))
               <= Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0) <= LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
             && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
                   <= Seq#Length(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0))))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.__default.MaxPossibleEntries#canCall()))
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0) <= LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
             && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
                   <= Seq#Length(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0))))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.__default.MaxPossibleEntries#canCall())
             && 
            LitInt(0) <= LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
               <= Seq#Length(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0))))
             && Seq#Length(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0))))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries())
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0)))))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.__default.CorrectJournalBlockSizes#canCall(Lit($Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))): Seq Box))))
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0)))))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.__default.CorrectJournalBlockSizes#canCall(Lit($Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))): Seq Box)))
             && Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))
                 ==> JournalistModel.__default.CorrectJournalBlockSizes(Lit($Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))): Seq Box)))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0)))))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.__default.CorrectJournalBlockSizes#canCall(Lit($Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))): Seq Box))))
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0)))))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.__default.CorrectJournalBlockSizes#canCall(Lit($Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))): Seq Box)))
             && Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))
                 ==> JournalistModel.__default.CorrectJournalBlockSizes(Lit($Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))): Seq Box)))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0)
                 <= LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0)
                 <= LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0)
               <= LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0)
                 <= LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0)
                 <= LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0)
               <= LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (LitInt(0) <= LitInt(JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)))
               ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalistModel.__default.WF(Lit(jm#0))
           == (
            LitInt(1)
               <= Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
             && Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
               <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
             && 
            LitInt(0) <= LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))
             && JournalistModel.JournalistModel.start(Lit(jm#0))
               < Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
             && 
            LitInt(0) <= LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0)))
               <= Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
             && 
            LitInt(0) <= LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0)))
               <= Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
             && 
            LitInt(0)
               <= LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                   + JournalistModel.JournalistModel.len2(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                   + JournalistModel.JournalistModel.len2(Lit(jm#0)))
               <= Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
             && 
            LitInt(0) <= LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
               <= Seq#Length(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0))))
             && Seq#Length(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0))))
               <= LitInt(JournalistModel.__default.MaxPossibleEntries())
             && (Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))
               ==> JournalistModel.__default.CorrectJournalBlockSizes(Lit($Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))): Seq Box)))
             && (Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))
               ==> JournalistModel.__default.CorrectJournalBlockSizes(Lit($Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))): Seq Box)))
             && 
            LitInt(0)
               <= LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && 
            LitInt(0)
               <= LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && 
            LitInt(0) <= LitInt(JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)))
             && LitInt(JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)))
               <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)))));

// function declaration for JournalistModel._default.start
function JournalistModel.__default.start(jm#0: DatatypeType) : int;

function JournalistModel.__default.start#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.start
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.start(jm#0) } 
    JournalistModel.__default.start#canCall(jm#0)
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> LitInt(0) <= JournalistModel.__default.start(jm#0)
         && JournalistModel.__default.start(jm#0) < 18446744073709551616);

function JournalistModel.__default.start#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.start
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.start#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.start#requires(jm#0) == true);

// definition axiom for JournalistModel.__default.start(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.start(jm#0) } 
    JournalistModel.__default.start#canCall(jm#0)
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.start(jm#0)
           == JournalistModel.JournalistModel.start(jm#0));

// definition axiom for JournalistModel.__default.start for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.start(Lit(jm#0)) } 
    JournalistModel.__default.start#canCall(Lit(jm#0))
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.start(Lit(jm#0))
           == LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))));

// function declaration for JournalistModel._default.mid
function JournalistModel.__default.mid(jm#0: DatatypeType, len#0: int) : int;

function JournalistModel.__default.mid#canCall(jm#0: DatatypeType, len#0: int) : bool;

// consequence axiom for JournalistModel.__default.mid
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    { JournalistModel.__default.mid(jm#0, len#0) } 
    JournalistModel.__default.mid#canCall(jm#0, len#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          len#0
             <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
           && JournalistModel.JournalistModel.start(jm#0) < len#0
           && JournalistModel.JournalistModel.len1(jm#0) <= len#0)
       ==> LitInt(0) <= JournalistModel.__default.mid(jm#0, len#0)
         && JournalistModel.__default.mid(jm#0, len#0) < 18446744073709551616);

function JournalistModel.__default.mid#requires(DatatypeType, int) : bool;

// #requires axiom for JournalistModel.__default.mid
axiom (forall jm#0: DatatypeType, len#0: int :: 
  { JournalistModel.__default.mid#requires(jm#0, len#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> JournalistModel.__default.mid#requires(jm#0, len#0)
       == (
        len#0
           <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
         && JournalistModel.JournalistModel.start(jm#0) < len#0
         && JournalistModel.JournalistModel.len1(jm#0) <= len#0));

// definition axiom for JournalistModel.__default.mid(revealed)
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    { JournalistModel.__default.mid(jm#0, len#0) } 
    JournalistModel.__default.mid#canCall(jm#0, len#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          len#0
             <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
           && JournalistModel.JournalistModel.start(jm#0) < len#0
           && JournalistModel.JournalistModel.len1(jm#0) <= len#0)
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.basic__mod#canCall(JournalistModel.JournalistModel.start(jm#0)
             + JournalistModel.JournalistModel.len1(jm#0), 
          len#0)
         && JournalistModel.__default.mid(jm#0, len#0)
           == JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
               + JournalistModel.JournalistModel.len1(jm#0), 
            len#0));

// definition axiom for JournalistModel.__default.mid for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    {:weight 3} { JournalistModel.__default.mid(Lit(jm#0), LitInt(len#0)) } 
    JournalistModel.__default.mid#canCall(Lit(jm#0), LitInt(len#0))
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(len#0)
             <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
           && Lit(JournalistModel.JournalistModel.start(Lit(jm#0)) < len#0)
           && LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))) <= LitInt(len#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.basic__mod#canCall(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
               + JournalistModel.JournalistModel.len1(Lit(jm#0))), 
          LitInt(len#0))
         && JournalistModel.__default.mid(Lit(jm#0), LitInt(len#0))
           == LitInt(JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                   + JournalistModel.JournalistModel.len1(Lit(jm#0))), 
              LitInt(len#0))));

// function declaration for JournalistModel._default.end
function JournalistModel.__default.end(jm#0: DatatypeType, len#0: int) : int;

function JournalistModel.__default.end#canCall(jm#0: DatatypeType, len#0: int) : bool;

// consequence axiom for JournalistModel.__default.end
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    { JournalistModel.__default.end(jm#0, len#0) } 
    JournalistModel.__default.end#canCall(jm#0, len#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          len#0
             <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
           && JournalistModel.JournalistModel.start(jm#0) < len#0
           && JournalistModel.JournalistModel.len1(jm#0) <= len#0
           && JournalistModel.JournalistModel.len2(jm#0) <= len#0)
       ==> LitInt(0) <= JournalistModel.__default.end(jm#0, len#0)
         && JournalistModel.__default.end(jm#0, len#0) < 18446744073709551616);

function JournalistModel.__default.end#requires(DatatypeType, int) : bool;

// #requires axiom for JournalistModel.__default.end
axiom (forall jm#0: DatatypeType, len#0: int :: 
  { JournalistModel.__default.end#requires(jm#0, len#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> JournalistModel.__default.end#requires(jm#0, len#0)
       == (
        len#0
           <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
         && JournalistModel.JournalistModel.start(jm#0) < len#0
         && JournalistModel.JournalistModel.len1(jm#0) <= len#0
         && JournalistModel.JournalistModel.len2(jm#0) <= len#0));

// definition axiom for JournalistModel.__default.end(revealed)
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    { JournalistModel.__default.end(jm#0, len#0) } 
    JournalistModel.__default.end#canCall(jm#0, len#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          len#0
             <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
           && JournalistModel.JournalistModel.start(jm#0) < len#0
           && JournalistModel.JournalistModel.len1(jm#0) <= len#0
           && JournalistModel.JournalistModel.len2(jm#0) <= len#0)
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.basic__mod#canCall(JournalistModel.JournalistModel.start(jm#0)
             + JournalistModel.JournalistModel.len1(jm#0)
             + JournalistModel.JournalistModel.len2(jm#0), 
          len#0)
         && JournalistModel.__default.end(jm#0, len#0)
           == JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
               + JournalistModel.JournalistModel.len1(jm#0)
               + JournalistModel.JournalistModel.len2(jm#0), 
            len#0));

// definition axiom for JournalistModel.__default.end for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    {:weight 3} { JournalistModel.__default.end(Lit(jm#0), LitInt(len#0)) } 
    JournalistModel.__default.end#canCall(Lit(jm#0), LitInt(len#0))
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(len#0)
             <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())))
           && Lit(JournalistModel.JournalistModel.start(Lit(jm#0)) < len#0)
           && LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))) <= LitInt(len#0)
           && LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0))) <= LitInt(len#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.basic__mod#canCall(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
               + JournalistModel.JournalistModel.len1(Lit(jm#0))
               + JournalistModel.JournalistModel.len2(Lit(jm#0))), 
          LitInt(len#0))
         && JournalistModel.__default.end(Lit(jm#0), LitInt(len#0))
           == LitInt(JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                   + JournalistModel.JournalistModel.len1(Lit(jm#0))
                   + JournalistModel.JournalistModel.len2(Lit(jm#0))), 
              LitInt(len#0))));

// function declaration for JournalistModel._default.InMemoryJournalFrozen
function JournalistModel.__default.InMemoryJournalFrozen(jm#0: DatatypeType) : Seq Box;

function JournalistModel.__default.InMemoryJournalFrozen#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.InMemoryJournalFrozen
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.InMemoryJournalFrozen(jm#0) } 
    JournalistModel.__default.InMemoryJournalFrozen#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> $Is(JournalistModel.__default.InMemoryJournalFrozen(jm#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function JournalistModel.__default.InMemoryJournalFrozen#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.InMemoryJournalFrozen
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.InMemoryJournalFrozen#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.InMemoryJournalFrozen#requires(jm#0)
       == JournalistModel.__default.WF(jm#0));

// definition axiom for JournalistModel.__default.InMemoryJournalFrozen(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.InMemoryJournalFrozen(jm#0) } 
    JournalistModel.__default.InMemoryJournalFrozen#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.start#canCall(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistMarshallingModel.__default.cyclicSlice#canCall(Tclass.Journal.JournalEntry(), 
          JournalistModel.JournalistModel.journalEntries(jm#0), 
          JournalistModel.__default.start(jm#0), 
          JournalistModel.JournalistModel.len1(jm#0))
         && JournalistModel.__default.InMemoryJournalFrozen(jm#0)
           == JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
            StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
            JournalistModel.JournalistModel.journalEntries(jm#0), 
            JournalistModel.__default.start(jm#0), 
            JournalistModel.JournalistModel.len1(jm#0)));

// definition axiom for JournalistModel.__default.InMemoryJournalFrozen for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.InMemoryJournalFrozen(Lit(jm#0)) } 
    JournalistModel.__default.InMemoryJournalFrozen#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.WF(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.start#canCall(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistMarshallingModel.__default.cyclicSlice#canCall(Tclass.Journal.JournalEntry(), 
          Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
          LitInt(JournalistModel.__default.start(Lit(jm#0))), 
          LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))))
         && JournalistModel.__default.InMemoryJournalFrozen(Lit(jm#0))
           == JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
            StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
            Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
            LitInt(JournalistModel.__default.start(Lit(jm#0))), 
            LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0)))));

// function declaration for JournalistModel._default.InMemoryJournal
function JournalistModel.__default.InMemoryJournal(jm#0: DatatypeType) : Seq Box;

function JournalistModel.__default.InMemoryJournal#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.InMemoryJournal
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.InMemoryJournal(jm#0) } 
    JournalistModel.__default.InMemoryJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> $Is(JournalistModel.__default.InMemoryJournal(jm#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function JournalistModel.__default.InMemoryJournal#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.InMemoryJournal
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.InMemoryJournal#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.InMemoryJournal#requires(jm#0)
       == JournalistModel.__default.WF(jm#0));

// definition axiom for JournalistModel.__default.InMemoryJournal(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.InMemoryJournal(jm#0) } 
    JournalistModel.__default.InMemoryJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && 
        JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.mid#canCall(jm#0, Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)))
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistMarshallingModel.__default.cyclicSlice#canCall(Tclass.Journal.JournalEntry(), 
          JournalistModel.JournalistModel.journalEntries(jm#0), 
          JournalistModel.__default.mid(jm#0, Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))), 
          JournalistModel.JournalistModel.len2(jm#0))
         && JournalistModel.__default.InMemoryJournal(jm#0)
           == JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
            StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
            JournalistModel.JournalistModel.journalEntries(jm#0), 
            JournalistModel.__default.mid(jm#0, Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))), 
            JournalistModel.JournalistModel.len2(jm#0)));

// definition axiom for JournalistModel.__default.InMemoryJournal for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.InMemoryJournal(Lit(jm#0)) } 
    JournalistModel.__default.InMemoryJournal#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.WF(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && 
        JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.mid#canCall(Lit(jm#0), 
          Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0)))))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistMarshallingModel.__default.cyclicSlice#canCall(Tclass.Journal.JournalEntry(), 
          Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
          JournalistModel.__default.mid(Lit(jm#0), 
            Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))), 
          LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0))))
         && JournalistModel.__default.InMemoryJournal(Lit(jm#0))
           == JournalistMarshallingModel.__default.cyclicSlice(Tclass.Journal.JournalEntry(), 
            StartFuel_JournalistMarshallingModel._default.cyclicSlice, 
            Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
            JournalistModel.__default.mid(Lit(jm#0), 
              Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))), 
            LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0)))));

// function declaration for JournalistModel._default.ReplayJournal
function JournalistModel.__default.ReplayJournal(jm#0: DatatypeType) : Seq Box;

function JournalistModel.__default.ReplayJournal#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.ReplayJournal
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.ReplayJournal(jm#0) } 
    JournalistModel.__default.ReplayJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= JournalistModel.JournalistModel.replayIdx(jm#0)
           && JournalistModel.JournalistModel.replayIdx(jm#0)
             <= Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0)))
       ==> $Is(JournalistModel.__default.ReplayJournal(jm#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function JournalistModel.__default.ReplayJournal#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.ReplayJournal
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.ReplayJournal#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.ReplayJournal#requires(jm#0)
       == (LitInt(0) <= JournalistModel.JournalistModel.replayIdx(jm#0)
         && JournalistModel.JournalistModel.replayIdx(jm#0)
           <= Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0))));

// definition axiom for JournalistModel.__default.ReplayJournal(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.ReplayJournal(jm#0) } 
    JournalistModel.__default.ReplayJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= JournalistModel.JournalistModel.replayIdx(jm#0)
           && JournalistModel.JournalistModel.replayIdx(jm#0)
             <= Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0)))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.ReplayJournal(jm#0)
           == Seq#Drop(JournalistModel.JournalistModel.replayJournal(jm#0), 
            JournalistModel.JournalistModel.replayIdx(jm#0)));

// definition axiom for JournalistModel.__default.ReplayJournal for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.ReplayJournal(Lit(jm#0)) } 
    JournalistModel.__default.ReplayJournal#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
           && LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
             <= Seq#Length(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0)))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.ReplayJournal(Lit(jm#0))
           == Lit(Seq#Drop(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0))), 
              LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0))))));

// function declaration for JournalistModel._default.JournalFrontRead
function JournalistModel.__default.JournalFrontRead(jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.JournalFrontRead#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.JournalFrontRead
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.JournalFrontRead(jm#0) } 
    JournalistModel.__default.JournalFrontRead#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> $Is(JournalistModel.__default.JournalFrontRead(jm#0), 
        Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte())))));

function JournalistModel.__default.JournalFrontRead#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.JournalFrontRead
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.JournalFrontRead#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.JournalFrontRead#requires(jm#0)
       == JournalistModel.__default.WF(jm#0));

// definition axiom for JournalistModel.__default.JournalFrontRead(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.JournalFrontRead(jm#0) } 
    JournalistModel.__default.JournalFrontRead#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.JournalFrontRead(jm#0)
           == JournalistModel.JournalistModel.journalFront(jm#0));

// definition axiom for JournalistModel.__default.JournalFrontRead for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.JournalFrontRead(Lit(jm#0)) } 
    JournalistModel.__default.JournalFrontRead#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.WF(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.JournalFrontRead(Lit(jm#0))
           == Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))));

// function declaration for JournalistModel._default.JournalBackRead
function JournalistModel.__default.JournalBackRead(jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.JournalBackRead#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.JournalBackRead
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.JournalBackRead(jm#0) } 
    JournalistModel.__default.JournalBackRead#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> $Is(JournalistModel.__default.JournalBackRead(jm#0), 
        Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte())))));

function JournalistModel.__default.JournalBackRead#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.JournalBackRead
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.JournalBackRead#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.JournalBackRead#requires(jm#0)
       == JournalistModel.__default.WF(jm#0));

// definition axiom for JournalistModel.__default.JournalBackRead(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.JournalBackRead(jm#0) } 
    JournalistModel.__default.JournalBackRead#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.JournalBackRead(jm#0)
           == JournalistModel.JournalistModel.journalBack(jm#0));

// definition axiom for JournalistModel.__default.JournalBackRead for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.JournalBackRead(Lit(jm#0)) } 
    JournalistModel.__default.JournalBackRead#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.WF(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.JournalBackRead(Lit(jm#0))
           == Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))));

// function declaration for JournalistModel._default.WrittenJournalLen
function JournalistModel.__default.WrittenJournalLen(jm#0: DatatypeType) : int;

function JournalistModel.__default.WrittenJournalLen#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.WrittenJournalLen
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.WrittenJournalLen(jm#0) } 
    JournalistModel.__default.WrittenJournalLen#canCall(jm#0)
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> true);

function JournalistModel.__default.WrittenJournalLen#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.WrittenJournalLen
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.WrittenJournalLen#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.WrittenJournalLen#requires(jm#0) == true);

// definition axiom for JournalistModel.__default.WrittenJournalLen(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.WrittenJournalLen(jm#0) } 
    JournalistModel.__default.WrittenJournalLen#canCall(jm#0)
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.WrittenJournalLen(jm#0)
           == JournalistModel.JournalistModel.writtenJournalBlocks(jm#0));

// definition axiom for JournalistModel.__default.WrittenJournalLen for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.WrittenJournalLen(Lit(jm#0)) } 
    JournalistModel.__default.WrittenJournalLen#canCall(Lit(jm#0))
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.WrittenJournalLen(Lit(jm#0))
           == LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0))));

// function declaration for JournalistModel._default.Iprivate
function JournalistModel.__default.Iprivate(jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.Iprivate#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.Iprivate
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.Iprivate(jm#0) } 
    JournalistModel.__default.Iprivate#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> $Is(JournalistModel.__default.Iprivate(jm#0), Tclass.JournalistModel.JournalInfo()));

function JournalistModel.__default.Iprivate#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.Iprivate
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.Iprivate#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.Iprivate#requires(jm#0)
       == JournalistModel.__default.WF(jm#0));

// definition axiom for JournalistModel.__default.Iprivate(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.Iprivate(jm#0) } 
    JournalistModel.__default.Iprivate#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> JournalistModel.__default.InMemoryJournalFrozen#canCall(jm#0)
         && JournalistModel.__default.InMemoryJournal#canCall(jm#0)
         && JournalistModel.__default.ReplayJournal#canCall(jm#0)
         && JournalistModel.__default.JournalFrontRead#canCall(jm#0)
         && JournalistModel.__default.JournalBackRead#canCall(jm#0)
         && JournalistModel.__default.WrittenJournalLen#canCall(jm#0)
         && JournalistModel.__default.Iprivate(jm#0)
           == #JournalistModel.JournalInfo.JournalInfo(JournalistModel.__default.InMemoryJournalFrozen(jm#0), 
            JournalistModel.__default.InMemoryJournal(jm#0), 
            JournalistModel.__default.ReplayJournal(jm#0), 
            JournalistModel.__default.JournalFrontRead(jm#0), 
            JournalistModel.__default.JournalBackRead(jm#0), 
            JournalistModel.__default.WrittenJournalLen(jm#0)));

// definition axiom for JournalistModel.__default.Iprivate for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.Iprivate(Lit(jm#0)) } 
    JournalistModel.__default.Iprivate#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.WF(Lit(jm#0))))
       ==> JournalistModel.__default.InMemoryJournalFrozen#canCall(Lit(jm#0))
         && JournalistModel.__default.InMemoryJournal#canCall(Lit(jm#0))
         && JournalistModel.__default.ReplayJournal#canCall(Lit(jm#0))
         && JournalistModel.__default.JournalFrontRead#canCall(Lit(jm#0))
         && JournalistModel.__default.JournalBackRead#canCall(Lit(jm#0))
         && JournalistModel.__default.WrittenJournalLen#canCall(Lit(jm#0))
         && JournalistModel.__default.Iprivate(Lit(jm#0))
           == Lit(#JournalistModel.JournalInfo.JournalInfo(Lit(JournalistModel.__default.InMemoryJournalFrozen(Lit(jm#0))), 
              Lit(JournalistModel.__default.InMemoryJournal(Lit(jm#0))), 
              Lit(JournalistModel.__default.ReplayJournal(Lit(jm#0))), 
              Lit(JournalistModel.__default.JournalFrontRead(Lit(jm#0))), 
              Lit(JournalistModel.__default.JournalBackRead(Lit(jm#0))), 
              LitInt(JournalistModel.__default.WrittenJournalLen(Lit(jm#0))))));

// function declaration for JournalistModel._default.I
function JournalistModel.__default.I(jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.I#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.I
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.I(jm#0) } 
    JournalistModel.__default.I#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> $Is(JournalistModel.__default.I(jm#0), Tclass.JournalistModel.JournalInfo()));

function JournalistModel.__default.I#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.I
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.I#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.I#requires(jm#0) == JournalistModel.__default.WF(jm#0));

// definition axiom for JournalistModel.__default.I(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.I(jm#0) } 
    JournalistModel.__default.I#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.WF(jm#0))
       ==> true);

// definition axiom for JournalistModel.__default.I for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.I(Lit(jm#0)) } 
    JournalistModel.__default.I#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.WF(Lit(jm#0))))
       ==> true);

procedure CheckWellformed$$JournalistModel.__default.reveal__I(jm#0: DatatypeType
       where $Is(jm#0, Tclass.JournalistModel.JournalistModel())
         && $IsAlloc(jm#0, Tclass.JournalistModel.JournalistModel(), $Heap)
         && $IsA#JournalistModel.JournalistModel(jm#0));
  free requires 22 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$JournalistModel.__default.reveal__I(jm#0: DatatypeType
       where $Is(jm#0, Tclass.JournalistModel.JournalistModel())
         && $IsAlloc(jm#0, Tclass.JournalistModel.JournalistModel(), $Heap)
         && $IsA#JournalistModel.JournalistModel(jm#0));
  // user-defined preconditions
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || LitInt(1) <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
         <= LitInt(Mul(LitInt(2), LitInt(JournalistModel.__default.MaxPossibleEntries())));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || LitInt(0) <= JournalistModel.JournalistModel.start(jm#0);
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || JournalistModel.JournalistModel.start(jm#0)
         < Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || LitInt(0) <= JournalistModel.JournalistModel.len1(jm#0);
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || JournalistModel.JournalistModel.len1(jm#0)
         <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || LitInt(0) <= JournalistModel.JournalistModel.len2(jm#0);
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || JournalistModel.JournalistModel.len2(jm#0)
         <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || LitInt(0)
         <= JournalistModel.JournalistModel.len1(jm#0)
           + JournalistModel.JournalistModel.len2(jm#0);
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || JournalistModel.JournalistModel.len1(jm#0)
           + JournalistModel.JournalistModel.len2(jm#0)
         <= Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || LitInt(0) <= JournalistModel.JournalistModel.replayIdx(jm#0);
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || JournalistModel.JournalistModel.replayIdx(jm#0)
         <= Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0))
         <= LitInt(JournalistModel.__default.MaxPossibleEntries());
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0))
         ==> 
        JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box)
         ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box)
           || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box)
             <= LitInt(DiskLayout.__default.NumJournalBlocks()));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0))
         ==> 
        JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box)
         ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box)
           || (forall i#0: int :: 
            { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box, 
                  i#0)): Seq Box } 
            LitInt(0) <= i#0
                 && i#0
                   < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box)
               ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box, 
                      i#0)): Seq Box)
                 == LitInt(4064)));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0))
         ==> 
        JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box)
         ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box)
           || Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box)
             <= LitInt(DiskLayout.__default.NumJournalBlocks()));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0))
         ==> 
        JournalistModel.__default.CorrectJournalBlockSizes#canCall($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box)
         ==> JournalistModel.__default.CorrectJournalBlockSizes($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box)
           || (forall i#1: int :: 
            { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box, 
                  i#1)): Seq Box } 
            LitInt(0) <= i#1
                 && i#1
                   < Seq#Length($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box)
               ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box, 
                      i#1)): Seq Box)
                 == LitInt(4064)));
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || LitInt(0) <= JournalistModel.JournalistModel.writtenJournalBlocks(jm#0);
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
         <= LitInt(DiskLayout.__default.NumJournalBlocks());
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || LitInt(0) <= JournalistModel.JournalistModel.frozenJournalBlocks(jm#0);
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)
         <= LitInt(DiskLayout.__default.NumJournalBlocks());
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || LitInt(0) <= JournalistModel.JournalistModel.inMemoryWeight(jm#0);
  requires JournalistModel.__default.WF#canCall(jm#0)
     ==> JournalistModel.__default.WF(jm#0)
       || JournalistModel.JournalistModel.inMemoryWeight(jm#0)
         <= LitInt(Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#JournalistModel.JournalInfo(JournalistModel.__default.I(jm#0))
     && $IsA#JournalistModel.JournalInfo(JournalistModel.__default.Iprivate(jm#0))
     && 
    JournalistModel.__default.I#canCall(jm#0)
     && JournalistModel.__default.Iprivate#canCall(jm#0);
  ensures JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(jm#0), JournalistModel.__default.Iprivate(jm#0));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for JournalistModel._default.Inv
function JournalistModel.__default.Inv(jm#0: DatatypeType) : bool;

function JournalistModel.__default.Inv#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.Inv
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.Inv(jm#0) } 
    JournalistModel.__default.Inv#canCall(jm#0)
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> true);

function JournalistModel.__default.Inv#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.Inv
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.Inv#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.Inv#requires(jm#0) == true);

// definition axiom for JournalistModel.__default.Inv(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.Inv(jm#0) } 
    JournalistModel.__default.Inv#canCall(jm#0)
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> JournalistModel.__default.WF#canCall(jm#0)
         && (JournalistModel.__default.WF(jm#0)
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && Mul(JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
                     + JournalistModel.JournalistModel.frozenJournalBlocks(jm#0), 
                  LitInt(4064))
                 + JournalistModel.JournalistModel.inMemoryWeight(jm#0)
               <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())))
           ==> JournalistModel.__default.InMemoryJournalFrozen#canCall(jm#0)
             && JournalRanges.__default.WeightJournalEntries#canCall(JournalistModel.__default.InMemoryJournalFrozen(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0))
         && (JournalistModel.__default.InMemoryJournalFrozen#canCall(jm#0)
             && JournalRanges.__default.WeightJournalEntries#canCall(JournalistModel.__default.InMemoryJournalFrozen(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
                JournalistModel.__default.InMemoryJournalFrozen(jm#0))
               <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(jm#0), LitInt(4064))
           ==> JournalistModel.__default.InMemoryJournal#canCall(jm#0)
             && JournalRanges.__default.WeightJournalEntries#canCall(JournalistModel.__default.InMemoryJournal(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0))
         && JournalistModel.__default.Inv(jm#0)
           == (
            JournalistModel.__default.WF(jm#0)
             && Mul(JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
                     + JournalistModel.JournalistModel.frozenJournalBlocks(jm#0), 
                  LitInt(4064))
                 + JournalistModel.JournalistModel.inMemoryWeight(jm#0)
               <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())))
             && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
                JournalistModel.__default.InMemoryJournalFrozen(jm#0))
               <= Mul(JournalistModel.JournalistModel.frozenJournalBlocks(jm#0), LitInt(4064))
             && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
                JournalistModel.__default.InMemoryJournal(jm#0))
               == JournalistModel.JournalistModel.inMemoryWeight(jm#0)));

// definition axiom for JournalistModel.__default.Inv for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.Inv(Lit(jm#0)) } 
    JournalistModel.__default.Inv#canCall(Lit(jm#0))
         || $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       ==> JournalistModel.__default.WF#canCall(Lit(jm#0))
         && (Lit(JournalistModel.__default.WF(Lit(jm#0)))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && LitInt(Mul(LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0))
                         + JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0))), 
                    LitInt(4064))
                   + JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)))
               <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())))
           ==> JournalistModel.__default.InMemoryJournalFrozen#canCall(Lit(jm#0))
             && JournalRanges.__default.WeightJournalEntries#canCall(Lit(JournalistModel.__default.InMemoryJournalFrozen(Lit(jm#0))))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
         && (JournalistModel.__default.InMemoryJournalFrozen#canCall(Lit(jm#0))
             && JournalRanges.__default.WeightJournalEntries#canCall(Lit(JournalistModel.__default.InMemoryJournalFrozen(Lit(jm#0))))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
                Lit(JournalistModel.__default.InMemoryJournalFrozen(Lit(jm#0))))
               <= LitInt(Mul(LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0))), 
                  LitInt(4064)))
           ==> JournalistModel.__default.InMemoryJournal#canCall(Lit(jm#0))
             && JournalRanges.__default.WeightJournalEntries#canCall(Lit(JournalistModel.__default.InMemoryJournal(Lit(jm#0))))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
         && JournalistModel.__default.Inv(Lit(jm#0))
           == (
            JournalistModel.__default.WF(Lit(jm#0))
             && LitInt(Mul(LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0))
                         + JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0))), 
                    LitInt(4064))
                   + JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)))
               <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())))
             && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
                Lit(JournalistModel.__default.InMemoryJournalFrozen(Lit(jm#0))))
               <= LitInt(Mul(LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0))), 
                  LitInt(4064)))
             && JournalRanges.__default.WeightJournalEntries(StartFuel_JournalRanges._default.WeightJournalEntries, 
                Lit(JournalistModel.__default.InMemoryJournal(Lit(jm#0))))
               == LitInt(JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)))));

// function declaration for JournalistModel._default.JournalistConstructor
function JournalistModel.__default.JournalistConstructor($ly: LayerType) : DatatypeType;

function JournalistModel.__default.JournalistConstructor#canCall() : bool;

// layer synonym axiom
axiom (forall $ly: LayerType :: 
  { JournalistModel.__default.JournalistConstructor($LS($ly)) } 
  JournalistModel.__default.JournalistConstructor($LS($ly))
     == JournalistModel.__default.JournalistConstructor($ly));

// fuel synonym axiom
axiom (forall $ly: LayerType :: 
  { JournalistModel.__default.JournalistConstructor(AsFuelBottom($ly)) } 
  JournalistModel.__default.JournalistConstructor($ly)
     == JournalistModel.__default.JournalistConstructor($LZ));

// consequence axiom for JournalistModel.__default.JournalistConstructor
axiom true
   ==> (forall $ly: LayerType :: 
    { JournalistModel.__default.JournalistConstructor($ly) } 
    true
       ==> JournalistModel.__default.Inv(JournalistModel.__default.JournalistConstructor($ly))
         && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(JournalistModel.__default.JournalistConstructor($ly))), 
          Seq#Empty(): Seq Box)
         && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(JournalistModel.__default.JournalistConstructor($ly))), 
          Seq#Empty(): Seq Box)
         && Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(JournalistModel.__default.JournalistConstructor($ly))), 
          Seq#Empty(): Seq Box)
         && Options.Option#Equal(JournalistModel.JournalInfo.journalFront(JournalistModel.__default.I(JournalistModel.__default.JournalistConstructor($ly))), 
          #Options.Option.None())
         && Options.Option#Equal(JournalistModel.JournalInfo.journalBack(JournalistModel.__default.I(JournalistModel.__default.JournalistConstructor($ly))), 
          #Options.Option.None())
         && JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(JournalistModel.__default.JournalistConstructor($ly)))
           == LitInt(0)
         && $Is(JournalistModel.__default.JournalistConstructor($ly), 
          Tclass.JournalistModel.JournalistModel()));

function JournalistModel.__default.JournalistConstructor#requires(LayerType) : bool;

// #requires axiom for JournalistModel.__default.JournalistConstructor
axiom (forall $ly: LayerType :: 
  { JournalistModel.__default.JournalistConstructor#requires($ly) } 
  JournalistModel.__default.JournalistConstructor#requires($ly) == true);

const MoreFuel_JournalistMarshallingModel._default.cyclicSlice0: LayerType;

// definition axiom for JournalistModel.__default.JournalistConstructor(revealed)
axiom true
   ==> (forall $ly: LayerType :: 
    { JournalistModel.__default.JournalistConstructor($LS($ly)) } 
    true
       ==> Sequences.__default.fill#canCall(Tclass.Journal.JournalEntry(), 
          LitInt(4096), 
          $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))
         && 
        StartFuel_JournalistMarshallingModel._default.cyclicSlice
           == $LS(MoreFuel_JournalistMarshallingModel._default.cyclicSlice0)
         && StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice
           == $LS($LS(MoreFuel_JournalistMarshallingModel._default.cyclicSlice0))
         && AsFuelBottom(MoreFuel_JournalistMarshallingModel._default.cyclicSlice0)
           == MoreFuel_JournalistMarshallingModel._default.cyclicSlice0
         && JournalistModel.__default.JournalistConstructor($LS($ly))
           == #JournalistModel.JournalistModel.JournalistModel(Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
              StartFuel_Sequences._default.fill, 
              LitInt(4096), 
              $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box))))), 
            LitInt(0), 
            LitInt(0), 
            LitInt(0), 
            Lit(Seq#Empty(): Seq Box), 
            LitInt(0), 
            Lit(#Options.Option.None()), 
            Lit(#Options.Option.None()), 
            LitInt(0), 
            LitInt(0), 
            LitInt(0)));

const MoreFuel_JournalistMarshallingModel._default.cyclicSlice1: LayerType;

// definition axiom for JournalistModel.__default.JournalistConstructor for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType :: 
    {:weight 3} { JournalistModel.__default.JournalistConstructor($LS($ly)) } 
    true
       ==> Sequences.__default.fill#canCall(Tclass.Journal.JournalEntry(), 
          LitInt(4096), 
          $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))
         && 
        StartFuel_JournalistMarshallingModel._default.cyclicSlice
           == $LS(MoreFuel_JournalistMarshallingModel._default.cyclicSlice1)
         && StartFuelAssert_JournalistMarshallingModel._default.cyclicSlice
           == $LS($LS(MoreFuel_JournalistMarshallingModel._default.cyclicSlice1))
         && AsFuelBottom(MoreFuel_JournalistMarshallingModel._default.cyclicSlice1)
           == MoreFuel_JournalistMarshallingModel._default.cyclicSlice1
         && JournalistModel.__default.JournalistConstructor($LS($ly))
           == #JournalistModel.JournalistModel.JournalistModel(Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
              StartFuel_Sequences._default.fill, 
              LitInt(4096), 
              $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box))))), 
            LitInt(0), 
            LitInt(0), 
            LitInt(0), 
            Lit(Seq#Empty(): Seq Box), 
            LitInt(0), 
            Lit(#Options.Option.None()), 
            Lit(#Options.Option.None()), 
            LitInt(0), 
            LitInt(0), 
            LitInt(0)));

// function declaration for JournalistModel._default.hasFrozenJournal
function JournalistModel.__default.hasFrozenJournal($ly: LayerType, jm#0: DatatypeType) : bool;

function JournalistModel.__default.hasFrozenJournal#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasFrozenJournal($LS($ly), jm#0) } 
  JournalistModel.__default.hasFrozenJournal($LS($ly), jm#0)
     == JournalistModel.__default.hasFrozenJournal($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasFrozenJournal(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.hasFrozenJournal($ly, jm#0)
     == JournalistModel.__default.hasFrozenJournal($LZ, jm#0));

// consequence axiom for JournalistModel.__default.hasFrozenJournal
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.hasFrozenJournal($ly, jm#0) } 
    JournalistModel.__default.hasFrozenJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.__default.hasFrozenJournal($ly, jm#0)
         == !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box));

function JournalistModel.__default.hasFrozenJournal#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.hasFrozenJournal
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasFrozenJournal#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.hasFrozenJournal#requires($ly, jm#0)
       == JournalistModel.__default.Inv(jm#0));

// definition axiom for JournalistModel.__default.hasFrozenJournal(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.hasFrozenJournal($LS($ly), jm#0) } 
    JournalistModel.__default.hasFrozenJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.hasFrozenJournal($LS($ly), jm#0)
           == (JournalistModel.JournalistModel.len1(jm#0) != 0));

// definition axiom for JournalistModel.__default.hasFrozenJournal for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.hasFrozenJournal($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.hasFrozenJournal#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.Inv(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.hasFrozenJournal($LS($ly), Lit(jm#0))
           == Lit(JournalistModel.JournalistModel.len1(Lit(jm#0)) != 0));

// function declaration for JournalistModel._default.hasInMemoryJournal
function JournalistModel.__default.hasInMemoryJournal($ly: LayerType, jm#0: DatatypeType) : bool;

function JournalistModel.__default.hasInMemoryJournal#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasInMemoryJournal($LS($ly), jm#0) } 
  JournalistModel.__default.hasInMemoryJournal($LS($ly), jm#0)
     == JournalistModel.__default.hasInMemoryJournal($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasInMemoryJournal(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.hasInMemoryJournal($ly, jm#0)
     == JournalistModel.__default.hasInMemoryJournal($LZ, jm#0));

// consequence axiom for JournalistModel.__default.hasInMemoryJournal
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.hasInMemoryJournal($ly, jm#0) } 
    JournalistModel.__default.hasInMemoryJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.__default.hasInMemoryJournal($ly, jm#0)
         == !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box));

function JournalistModel.__default.hasInMemoryJournal#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.hasInMemoryJournal
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasInMemoryJournal#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.hasInMemoryJournal#requires($ly, jm#0)
       == JournalistModel.__default.Inv(jm#0));

// definition axiom for JournalistModel.__default.hasInMemoryJournal(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.hasInMemoryJournal($LS($ly), jm#0) } 
    JournalistModel.__default.hasInMemoryJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.hasInMemoryJournal($LS($ly), jm#0)
           == (JournalistModel.JournalistModel.len2(jm#0) != 0));

// definition axiom for JournalistModel.__default.hasInMemoryJournal for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.hasInMemoryJournal($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.hasInMemoryJournal#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.Inv(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.hasInMemoryJournal($LS($ly), Lit(jm#0))
           == Lit(JournalistModel.JournalistModel.len2(Lit(jm#0)) != 0));

// function declaration for JournalistModel._default.packageFrozenJournal
function JournalistModel.__default.packageFrozenJournal($ly: LayerType, jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.packageFrozenJournal#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.packageFrozenJournal($LS($ly), jm#0) } 
  JournalistModel.__default.packageFrozenJournal($LS($ly), jm#0)
     == JournalistModel.__default.packageFrozenJournal($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.packageFrozenJournal(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.packageFrozenJournal($ly, jm#0)
     == JournalistModel.__default.packageFrozenJournal($LZ, jm#0));

// consequence axiom for JournalistModel.__default.packageFrozenJournal
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.packageFrozenJournal($ly, jm#0) } 
    JournalistModel.__default.packageFrozenJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          JournalistModel.__default.Inv(jm#0)
           && !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box))
       ==> (var jm'#0, s#0 := $Unbox(_System.Tuple2._0(JournalistModel.__default.packageFrozenJournal($ly, jm#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(JournalistModel.__default.packageFrozenJournal($ly, jm#0))): Seq Box; 
          JournalistModel.__default.Inv(jm'#0)
             && Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))
             && Options.Option#Equal(JournalRanges.__default.parseJournalRange($LS($LZ), 
                $Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))): Seq Box), 
              #Options.Option.Some($Box(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)))))
             && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(jm'#0), 
              (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
                    (var dt_update#inMemoryJournalFrozen#0#0 := Lit(Seq#Empty(): Seq Box); 
                      #JournalistModel.JournalInfo.JournalInfo(dt_update#inMemoryJournalFrozen#0#0, 
                        JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#0#0), 
                        JournalistModel.JournalInfo.replayJournal(dt_update_tmp#0#0), 
                        JournalistModel.JournalInfo.journalFront(dt_update_tmp#0#0), 
                        JournalistModel.JournalInfo.journalBack(dt_update_tmp#0#0), 
                        JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#0#0)))); 
                #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.replayJournal(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.journalFront(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.journalBack(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(jm#0))
                     + Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))): Seq Box))))
             && Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))): Seq Box)
                 + JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(jm#0))
               <= LitInt(DiskLayout.__default.NumJournalBlocks()))
         && $Is(JournalistModel.__default.packageFrozenJournal($ly, jm#0), 
          Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte()))));

function JournalistModel.__default.packageFrozenJournal#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.packageFrozenJournal
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.packageFrozenJournal#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.packageFrozenJournal#requires($ly, jm#0)
       == (JournalistModel.__default.Inv(jm#0)
         && !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box)));

const MoreFuel_JournalRanges._default.WeightJournalEntries3: LayerType;

// definition axiom for JournalistModel.__default.packageFrozenJournal(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.packageFrozenJournal($LS($ly), jm#0) } 
    JournalistModel.__default.packageFrozenJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          JournalistModel.__default.Inv(jm#0)
           && !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistMarshallingModel.__default.marshallJournalEntries#canCall(JournalistModel.JournalistModel.journalEntries(jm#0), 
          JournalistModel.JournalistModel.start(jm#0), 
          JournalistModel.JournalistModel.len1(jm#0), 
          JournalistModel.JournalistModel.frozenJournalBlocks(jm#0))
         && 
        (var dt_update_tmp#2#0 := jm#0; 
          JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.__default.basic__mod#canCall(JournalistModel.JournalistModel.start(jm#0)
                 + JournalistModel.JournalistModel.len1(jm#0), 
              Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)))
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0))
         && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
              (var dt_update#start#0#0 := JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
                       + JournalistModel.JournalistModel.len1(jm#0), 
                    Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                  dt_update#start#0#0, 
                  JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0))
         && (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                  (var dt_update#start#0#0 := JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
                           + JournalistModel.JournalistModel.len1(jm#0), 
                        Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                      dt_update#start#0#0, 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
              (var dt_update#len1#0#0 := LitInt(0); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                  dt_update#len1#0#0, 
                  JournalistModel.JournalistModel.len2(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0))
         && (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                      (var dt_update#start#0#0 := JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
                               + JournalistModel.JournalistModel.len1(jm#0), 
                            Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                          dt_update#start#0#0, 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
                  (var dt_update#len1#0#0 := LitInt(0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                      dt_update#len1#0#0, 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
              (var dt_update#frozenJournalBlocks#0#0 := LitInt(0); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                  dt_update#frozenJournalBlocks#0#0, 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#0)))); 
          JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries3)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries3))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries3)
           == MoreFuel_JournalRanges._default.WeightJournalEntries3
         && JournalistModel.__default.packageFrozenJournal($LS($ly), jm#0)
           == (var s#1 := JournalistMarshallingModel.__default.marshallJournalEntries(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries, 
                JournalistModel.JournalistModel.journalEntries(jm#0), 
                JournalistModel.JournalistModel.start(jm#0), 
                JournalistModel.JournalistModel.len1(jm#0), 
                JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)); 
            (var jm'#1 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                              (var dt_update#start#0#0 := JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
                                       + JournalistModel.JournalistModel.len1(jm#0), 
                                    Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))); 
                                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                                  dt_update#start#0#0, 
                                  JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                                  JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
                          (var dt_update#len1#0#0 := LitInt(0); 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                              dt_update#len1#0#0, 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
                      (var dt_update#frozenJournalBlocks#0#0 := LitInt(0); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                          JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#0), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                          dt_update#frozenJournalBlocks#0#0, 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#0)))); 
                  (var dt_update#writtenJournalBlocks#0#0 := JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
                         + JournalistModel.JournalistModel.frozenJournalBlocks(jm#0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#0), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#5#0), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#5#0), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#5#0), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#5#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#0), 
                      dt_update#writtenJournalBlocks#0#0, 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#5#0)))); 
              #_System._tuple#2._#Make2($Box(jm'#1), $Box(s#1)))));

const MoreFuel_JournalRanges._default.WeightJournalEntries4: LayerType;

// definition axiom for JournalistModel.__default.packageFrozenJournal for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.packageFrozenJournal($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.packageFrozenJournal#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          Lit(JournalistModel.__default.Inv(Lit(jm#0)))
           && !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(Lit(JournalistModel.__default.I(Lit(jm#0)))), 
            Seq#Empty(): Seq Box))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistMarshallingModel.__default.marshallJournalEntries#canCall(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
          LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))), 
          LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))), 
          LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0))))
         && 
        (var dt_update_tmp#2#1 := Lit(jm#0); 
          JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.__default.basic__mod#canCall(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                   + JournalistModel.JournalistModel.len1(Lit(jm#0))), 
              Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0)))))
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1))
         && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
              (var dt_update#start#0#1 := JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                         + JournalistModel.JournalistModel.len1(Lit(jm#0))), 
                    Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))); 
                #JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                  dt_update#start#0#1, 
                  LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#2#1)), 
                  LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                  Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                  LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                  Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                  Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                  LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                  LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                  LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1))))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1))
         && (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                  (var dt_update#start#0#1 := JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                             + JournalistModel.JournalistModel.len1(Lit(jm#0))), 
                        Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))); 
                    #JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                      dt_update#start#0#1, 
                      LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#2#1)), 
                      LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                      Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                      LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                      Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                      Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                      LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                      LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                      LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1))))); 
              (var dt_update#len1#0#1 := LitInt(0); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                  dt_update#len1#0#1, 
                  JournalistModel.JournalistModel.len2(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1))
         && (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                      (var dt_update#start#0#1 := JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                                 + JournalistModel.JournalistModel.len1(Lit(jm#0))), 
                            Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))); 
                        #JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                          dt_update#start#0#1, 
                          LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#2#1)), 
                          LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                          Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                          LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                          Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                          Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                          LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                          LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                          LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1))))); 
                  (var dt_update#len1#0#1 := LitInt(0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                      dt_update#len1#0#1, 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
              (var dt_update#frozenJournalBlocks#0#1 := LitInt(0); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                  dt_update#frozenJournalBlocks#0#1, 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#1)))); 
          JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries4)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries4))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries4)
           == MoreFuel_JournalRanges._default.WeightJournalEntries4
         && JournalistModel.__default.packageFrozenJournal($LS($ly), Lit(jm#0))
           == (var s#2 := JournalistMarshallingModel.__default.marshallJournalEntries(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries, 
                Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))), 
                LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))), 
                LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0)))); 
            (var jm'#2 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                              (var dt_update#start#0#1 := JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                                         + JournalistModel.JournalistModel.len1(Lit(jm#0))), 
                                    Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))); 
                                #JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                                  dt_update#start#0#1, 
                                  LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                                  Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                                  Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                                  Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1))))); 
                          (var dt_update#len1#0#1 := LitInt(0); 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                              JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                              dt_update#len1#0#1, 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#3#1), 
                              JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
                      (var dt_update#frozenJournalBlocks#0#1 := LitInt(0); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                          JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#1), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                          dt_update#frozenJournalBlocks#0#1, 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#1)))); 
                  (var dt_update#writtenJournalBlocks#0#1 := LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0))
                           + JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0))); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#1), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#5#1), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#5#1), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#5#1), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#5#1), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#1), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#1), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#1), 
                      dt_update#writtenJournalBlocks#0#1, 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#1), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#5#1)))); 
              #_System._tuple#2._#Make2($Box(jm'#2), $Box(s#2)))));

// function declaration for JournalistModel._default.packageInMemoryJournal
function JournalistModel.__default.packageInMemoryJournal($ly: LayerType, jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.packageInMemoryJournal#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.packageInMemoryJournal($LS($ly), jm#0) } 
  JournalistModel.__default.packageInMemoryJournal($LS($ly), jm#0)
     == JournalistModel.__default.packageInMemoryJournal($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.packageInMemoryJournal(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.packageInMemoryJournal($ly, jm#0)
     == JournalistModel.__default.packageInMemoryJournal($LZ, jm#0));

// consequence axiom for JournalistModel.__default.packageInMemoryJournal
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.packageInMemoryJournal($ly, jm#0) } 
    JournalistModel.__default.packageInMemoryJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          JournalistModel.__default.Inv(jm#0)
           && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box)
           && !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box))
       ==> (var jm'#0, s#0 := $Unbox(_System.Tuple2._0(JournalistModel.__default.packageInMemoryJournal($ly, jm#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(JournalistModel.__default.packageInMemoryJournal($ly, jm#0))): Seq Box; 
          JournalistModel.__default.Inv(jm'#0)
             && Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))
             && Options.Option#Equal(JournalRanges.__default.parseJournalRange($LS($LZ), 
                $Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))): Seq Box), 
              #Options.Option.Some($Box(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0)))))
             && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(jm'#0), 
              (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
                    (var dt_update#inMemoryJournal#0#0 := Lit(Seq#Empty(): Seq Box); 
                      #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                        dt_update#inMemoryJournal#0#0, 
                        JournalistModel.JournalInfo.replayJournal(dt_update_tmp#0#0), 
                        JournalistModel.JournalInfo.journalFront(dt_update_tmp#0#0), 
                        JournalistModel.JournalInfo.journalBack(dt_update_tmp#0#0), 
                        JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#0#0)))); 
                #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.replayJournal(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.journalFront(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.journalBack(dt_update_tmp#1#0), 
                  JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(jm#0))
                     + Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))): Seq Box))))
             && Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))): Seq Box)
                 + JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(jm#0))
               <= LitInt(DiskLayout.__default.NumJournalBlocks()))
         && $Is(JournalistModel.__default.packageInMemoryJournal($ly, jm#0), 
          Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TSeq(Tclass.NativeTypes.byte()))));

function JournalistModel.__default.packageInMemoryJournal#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.packageInMemoryJournal
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.packageInMemoryJournal#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.packageInMemoryJournal#requires($ly, jm#0)
       == (
        JournalistModel.__default.Inv(jm#0)
         && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box)
         && !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box)));

const MoreFuel_JournalRanges._default.WeightJournalEntries5: LayerType;

// definition axiom for JournalistModel.__default.packageInMemoryJournal(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.packageInMemoryJournal($LS($ly), jm#0) } 
    JournalistModel.__default.packageInMemoryJournal#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          JournalistModel.__default.Inv(jm#0)
           && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box)
           && !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && (var numBlocks#0 := Div(JournalistModel.JournalistModel.inMemoryWeight(jm#0) + 4064 - 1, LitInt(4064)); 
          JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistMarshallingModel.__default.marshallJournalEntries#canCall(JournalistModel.JournalistModel.journalEntries(jm#0), 
              JournalistModel.JournalistModel.start(jm#0), 
              JournalistModel.JournalistModel.len2(jm#0), 
              numBlocks#0)
             && 
            (var dt_update_tmp#2#0 := jm#0; 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0))
             && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                  (var dt_update#start#0#0 := LitInt(0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                      dt_update#start#0#0, 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0))
             && (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                      (var dt_update#start#0#0 := LitInt(0); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                          dt_update#start#0#0, 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
                  (var dt_update#len2#0#0 := LitInt(0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                      dt_update#len2#0#0, 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0))
             && (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                          (var dt_update#start#0#0 := LitInt(0); 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                              dt_update#start#0#0, 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
                      (var dt_update#len2#0#0 := LitInt(0); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                          dt_update#len2#0#0, 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
                  (var dt_update#inMemoryWeight#0#0 := LitInt(0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#0), 
                      dt_update#inMemoryWeight#0#0))); 
              JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries5)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries5))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries5)
           == MoreFuel_JournalRanges._default.WeightJournalEntries5
         && JournalistModel.__default.packageInMemoryJournal($LS($ly), jm#0)
           == (var numBlocks#0 := Div(JournalistModel.JournalistModel.inMemoryWeight(jm#0) + 4064 - 1, LitInt(4064)); 
            (var s#1 := JournalistMarshallingModel.__default.marshallJournalEntries(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries, 
                  JournalistModel.JournalistModel.journalEntries(jm#0), 
                  JournalistModel.JournalistModel.start(jm#0), 
                  JournalistModel.JournalistModel.len2(jm#0), 
                  numBlocks#0); 
              (var jm'#1 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                                (var dt_update#start#0#0 := LitInt(0); 
                                  #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                                    dt_update#start#0#0, 
                                    JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                                    JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                                    JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                                    JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                                    JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                                    JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                                    JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                                    JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                                    JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
                            (var dt_update#len2#0#0 := LitInt(0); 
                              #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                                JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                                JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                                dt_update#len2#0#0, 
                                JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                                JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                                JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                                JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                                JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                                JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                                JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
                        (var dt_update#inMemoryWeight#0#0 := LitInt(0); 
                          #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                            JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                            JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                            JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                            JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                            JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                            JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                            JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#0), 
                            JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                            JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#0), 
                            dt_update#inMemoryWeight#0#0))); 
                    (var dt_update#writtenJournalBlocks#0#0 := JournalistModel.JournalistModel.writtenJournalBlocks(jm#0) + numBlocks#0; 
                      #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#0), 
                        JournalistModel.JournalistModel.start(dt_update_tmp#5#0), 
                        JournalistModel.JournalistModel.len1(dt_update_tmp#5#0), 
                        JournalistModel.JournalistModel.len2(dt_update_tmp#5#0), 
                        JournalistModel.JournalistModel.replayJournal(dt_update_tmp#5#0), 
                        JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#0), 
                        JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#0), 
                        JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#0), 
                        dt_update#writtenJournalBlocks#0#0, 
                        JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#0), 
                        JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#5#0)))); 
                #_System._tuple#2._#Make2($Box(jm'#1), $Box(s#1))))));

const MoreFuel_JournalRanges._default.WeightJournalEntries6: LayerType;

// definition axiom for JournalistModel.__default.packageInMemoryJournal for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.packageInMemoryJournal($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.packageInMemoryJournal#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          Lit(JournalistModel.__default.Inv(Lit(jm#0)))
           && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(Lit(JournalistModel.__default.I(Lit(jm#0)))), 
            Seq#Empty(): Seq Box)
           && !Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(Lit(JournalistModel.__default.I(Lit(jm#0)))), 
            Seq#Empty(): Seq Box))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && (var numBlocks#1 := LitInt(Div(JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)) + 4064 - 1, 
                LitInt(4064))); 
          JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistMarshallingModel.__default.marshallJournalEntries#canCall(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
              LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))), 
              LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0))), 
              numBlocks#1)
             && 
            (var dt_update_tmp#2#1 := Lit(jm#0); 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1))
             && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                  (var dt_update#start#0#1 := LitInt(0); 
                    Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                        dt_update#start#0#1, 
                        LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                        Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                        Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                        Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))))); 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1))
             && (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                      (var dt_update#start#0#1 := LitInt(0); 
                        Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                            dt_update#start#0#1, 
                            LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                            Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                            Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                            Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))))); 
                  (var dt_update#len2#0#1 := LitInt(0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#3#1), 
                      dt_update#len2#0#1, 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1))
             && (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                          (var dt_update#start#0#1 := LitInt(0); 
                            Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                                dt_update#start#0#1, 
                                LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#2#1)), 
                                LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                                Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                                LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                                Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                                Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                                LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                                LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                                LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))))); 
                      (var dt_update#len2#0#1 := LitInt(0); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#3#1), 
                          dt_update#len2#0#1, 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
                  (var dt_update#inMemoryWeight#0#1 := LitInt(0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#1), 
                      dt_update#inMemoryWeight#0#1))); 
              JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries6)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries6))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries6)
           == MoreFuel_JournalRanges._default.WeightJournalEntries6
         && JournalistModel.__default.packageInMemoryJournal($LS($ly), Lit(jm#0))
           == (var numBlocks#1 := LitInt(Div(JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)) + 4064 - 1, 
                  LitInt(4064))); 
            (var s#2 := JournalistMarshallingModel.__default.marshallJournalEntries(StartFuel_JournalistMarshallingModel._default.marshallJournalEntries, 
                  Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                  LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))), 
                  LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0))), 
                  numBlocks#1); 
              (var jm'#2 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                                (var dt_update#start#0#1 := LitInt(0); 
                                  Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                                      dt_update#start#0#1, 
                                      LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#2#1)), 
                                      LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                                      Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                                      LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                                      Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                                      Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                                      LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                                      LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                                      LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))))); 
                            (var dt_update#len2#0#1 := LitInt(0); 
                              #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                                JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                                JournalistModel.JournalistModel.len1(dt_update_tmp#3#1), 
                                dt_update#len2#0#1, 
                                JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                                JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                                JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                                JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                                JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                                JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                                JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
                        (var dt_update#inMemoryWeight#0#1 := LitInt(0); 
                          #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                            JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                            JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                            JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                            JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                            JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                            JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                            JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#1), 
                            JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                            JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#1), 
                            dt_update#inMemoryWeight#0#1))); 
                    (var dt_update#writtenJournalBlocks#0#1 := LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0)) + numBlocks#1); 
                      #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#1), 
                        JournalistModel.JournalistModel.start(dt_update_tmp#5#1), 
                        JournalistModel.JournalistModel.len1(dt_update_tmp#5#1), 
                        JournalistModel.JournalistModel.len2(dt_update_tmp#5#1), 
                        JournalistModel.JournalistModel.replayJournal(dt_update_tmp#5#1), 
                        JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#1), 
                        JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#1), 
                        JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#1), 
                        dt_update#writtenJournalBlocks#0#1, 
                        JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#1), 
                        JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#5#1)))); 
                #_System._tuple#2._#Make2($Box(jm'#2), $Box(s#2))))));

// function declaration for JournalistModel._default.getWrittenJournalLen
function JournalistModel.__default.getWrittenJournalLen(jm#0: DatatypeType) : int;

function JournalistModel.__default.getWrittenJournalLen#canCall(jm#0: DatatypeType) : bool;

// consequence axiom for JournalistModel.__default.getWrittenJournalLen
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.getWrittenJournalLen(jm#0) } 
    JournalistModel.__default.getWrittenJournalLen#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.__default.getWrittenJournalLen(jm#0)
           == JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(jm#0))
         && 
        LitInt(0) <= JournalistModel.__default.getWrittenJournalLen(jm#0)
         && JournalistModel.__default.getWrittenJournalLen(jm#0) < 18446744073709551616);

function JournalistModel.__default.getWrittenJournalLen#requires(DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.getWrittenJournalLen
axiom (forall jm#0: DatatypeType :: 
  { JournalistModel.__default.getWrittenJournalLen#requires(jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.getWrittenJournalLen#requires(jm#0)
       == JournalistModel.__default.Inv(jm#0));

// definition axiom for JournalistModel.__default.getWrittenJournalLen(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    { JournalistModel.__default.getWrittenJournalLen(jm#0) } 
    JournalistModel.__default.getWrittenJournalLen#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.getWrittenJournalLen(jm#0)
           == JournalistModel.JournalistModel.writtenJournalBlocks(jm#0));

// definition axiom for JournalistModel.__default.getWrittenJournalLen for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.getWrittenJournalLen(Lit(jm#0)) } 
    JournalistModel.__default.getWrittenJournalLen#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.Inv(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.getWrittenJournalLen(Lit(jm#0))
           == LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0))));

// function declaration for JournalistModel._default.setWrittenJournalLen
function JournalistModel.__default.setWrittenJournalLen(jm#0: DatatypeType, len#0: int) : DatatypeType;

function JournalistModel.__default.setWrittenJournalLen#canCall(jm#0: DatatypeType, len#0: int) : bool;

// consequence axiom for JournalistModel.__default.setWrittenJournalLen
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    { JournalistModel.__default.setWrittenJournalLen(jm#0, len#0) } 
    JournalistModel.__default.setWrittenJournalLen#canCall(jm#0, len#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          JournalistModel.__default.Inv(jm#0)
           && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box)
           && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box)
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> JournalistModel.__default.Inv(JournalistModel.__default.setWrittenJournalLen(jm#0, len#0))
         && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(JournalistModel.__default.setWrittenJournalLen(jm#0, len#0)), 
          (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
            #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#0#0), 
              JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#0#0), 
              JournalistModel.JournalInfo.replayJournal(dt_update_tmp#0#0), 
              JournalistModel.JournalInfo.journalFront(dt_update_tmp#0#0), 
              JournalistModel.JournalInfo.journalBack(dt_update_tmp#0#0), 
              len#0)))
         && $Is(JournalistModel.__default.setWrittenJournalLen(jm#0, len#0), 
          Tclass.JournalistModel.JournalistModel()));

function JournalistModel.__default.setWrittenJournalLen#requires(DatatypeType, int) : bool;

// #requires axiom for JournalistModel.__default.setWrittenJournalLen
axiom (forall jm#0: DatatypeType, len#0: int :: 
  { JournalistModel.__default.setWrittenJournalLen#requires(jm#0, len#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> JournalistModel.__default.setWrittenJournalLen#requires(jm#0, len#0)
       == (
        JournalistModel.__default.Inv(jm#0)
         && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box)
         && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box)
         && 
        LitInt(0) <= len#0
         && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

const MoreFuel_JournalRanges._default.WeightJournalEntries7: LayerType;

// definition axiom for JournalistModel.__default.setWrittenJournalLen(revealed)
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    { JournalistModel.__default.setWrittenJournalLen(jm#0, len#0) } 
    JournalistModel.__default.setWrittenJournalLen#canCall(jm#0, len#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          JournalistModel.__default.Inv(jm#0)
           && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box)
           && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box)
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (var dt_update_tmp#1#0 := jm#0; 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0))
         && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := jm#0; 
              (var dt_update#writtenJournalBlocks#0#0 := len#0; 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#0), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                  JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                  JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#0), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#0), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#0), 
                  dt_update#writtenJournalBlocks#0#0, 
                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries7)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries7))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries7)
           == MoreFuel_JournalRanges._default.WeightJournalEntries7
         && JournalistModel.__default.setWrittenJournalLen(jm#0, len#0)
           == (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := jm#0; 
                (var dt_update#writtenJournalBlocks#0#0 := len#0; 
                  #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#0), 
                    JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                    JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                    JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                    JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                    JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#0), 
                    JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#0), 
                    JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#0), 
                    dt_update#writtenJournalBlocks#0#0, 
                    JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                    JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))); 
            (var dt_update#frozenJournalBlocks#0#0 := LitInt(0); 
              #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                JournalistModel.JournalistModel.start(dt_update_tmp#2#0), 
                JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                dt_update#frozenJournalBlocks#0#0, 
                JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))));

const MoreFuel_JournalRanges._default.WeightJournalEntries8: LayerType;

// definition axiom for JournalistModel.__default.setWrittenJournalLen for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    {:weight 3} { JournalistModel.__default.setWrittenJournalLen(Lit(jm#0), LitInt(len#0)) } 
    JournalistModel.__default.setWrittenJournalLen#canCall(Lit(jm#0), LitInt(len#0))
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Lit(JournalistModel.__default.Inv(Lit(jm#0)))
           && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournal(Lit(JournalistModel.__default.I(Lit(jm#0)))), 
            Seq#Empty(): Seq Box)
           && Seq#Equal(JournalistModel.JournalInfo.inMemoryJournalFrozen(Lit(JournalistModel.__default.I(Lit(jm#0)))), 
            Seq#Empty(): Seq Box)
           && 
          LitInt(0) <= LitInt(len#0)
           && LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (var dt_update_tmp#1#1 := Lit(jm#0); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1))
         && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := Lit(jm#0); 
              (var dt_update#writtenJournalBlocks#0#1 := LitInt(len#0); 
                Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#1)), 
                    LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                    LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                    LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                    Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                    LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#1)), 
                    Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#1)), 
                    Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#1)), 
                    dt_update#writtenJournalBlocks#0#1, 
                    LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                    LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1)))))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries8)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries8))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries8)
           == MoreFuel_JournalRanges._default.WeightJournalEntries8
         && JournalistModel.__default.setWrittenJournalLen(Lit(jm#0), LitInt(len#0))
           == (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := Lit(jm#0); 
                (var dt_update#writtenJournalBlocks#0#1 := LitInt(len#0); 
                  Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                      Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#1)), 
                      Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#1)), 
                      Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#1)), 
                      dt_update#writtenJournalBlocks#0#1, 
                      LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1)))))); 
            (var dt_update#frozenJournalBlocks#0#1 := LitInt(0); 
              #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1), 
                JournalistModel.JournalistModel.start(dt_update_tmp#2#1), 
                JournalistModel.JournalistModel.len1(dt_update_tmp#2#1), 
                JournalistModel.JournalistModel.len2(dt_update_tmp#2#1), 
                JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1), 
                JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1), 
                JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1), 
                JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1), 
                JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1), 
                dt_update#frozenJournalBlocks#0#1, 
                JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))));

// function declaration for JournalistModel._default.updateWrittenJournalLen
function JournalistModel.__default.updateWrittenJournalLen(jm#0: DatatypeType, len#0: int) : DatatypeType;

function JournalistModel.__default.updateWrittenJournalLen#canCall(jm#0: DatatypeType, len#0: int) : bool;

// consequence axiom for JournalistModel.__default.updateWrittenJournalLen
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    { JournalistModel.__default.updateWrittenJournalLen(jm#0, len#0) } 
    JournalistModel.__default.updateWrittenJournalLen#canCall(jm#0, len#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          JournalistModel.__default.Inv(jm#0)
           && len#0
             <= JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(jm#0)))
       ==> JournalistModel.__default.Inv(JournalistModel.__default.updateWrittenJournalLen(jm#0, len#0))
         && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(JournalistModel.__default.updateWrittenJournalLen(jm#0, len#0)), 
          (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
            #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#0#0), 
              JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#0#0), 
              JournalistModel.JournalInfo.replayJournal(dt_update_tmp#0#0), 
              JournalistModel.JournalInfo.journalFront(dt_update_tmp#0#0), 
              JournalistModel.JournalInfo.journalBack(dt_update_tmp#0#0), 
              len#0)))
         && $Is(JournalistModel.__default.updateWrittenJournalLen(jm#0, len#0), 
          Tclass.JournalistModel.JournalistModel()));

function JournalistModel.__default.updateWrittenJournalLen#requires(DatatypeType, int) : bool;

// #requires axiom for JournalistModel.__default.updateWrittenJournalLen
axiom (forall jm#0: DatatypeType, len#0: int :: 
  { JournalistModel.__default.updateWrittenJournalLen#requires(jm#0, len#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> JournalistModel.__default.updateWrittenJournalLen#requires(jm#0, len#0)
       == (JournalistModel.__default.Inv(jm#0)
         && len#0
           <= JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(jm#0))));

const MoreFuel_JournalRanges._default.WeightJournalEntries9: LayerType;

// definition axiom for JournalistModel.__default.updateWrittenJournalLen(revealed)
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    { JournalistModel.__default.updateWrittenJournalLen(jm#0, len#0) } 
    JournalistModel.__default.updateWrittenJournalLen#canCall(jm#0, len#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          JournalistModel.__default.Inv(jm#0)
           && len#0
             <= JournalistModel.JournalInfo.writtenJournalLen(JournalistModel.__default.I(jm#0)))
       ==> (var dt_update_tmp#1#0 := jm#0; 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries9)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries9))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries9)
           == MoreFuel_JournalRanges._default.WeightJournalEntries9
         && JournalistModel.__default.updateWrittenJournalLen(jm#0, len#0)
           == (var dt_update_tmp#1#0 := jm#0; 
            (var dt_update#writtenJournalBlocks#0#0 := len#0; 
              #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#0), 
                dt_update#writtenJournalBlocks#0#0, 
                JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))));

const MoreFuel_JournalRanges._default.WeightJournalEntries10: LayerType;

// definition axiom for JournalistModel.__default.updateWrittenJournalLen for all literals(revealed)
axiom true
   ==> (forall jm#0: DatatypeType, len#0: int :: 
    {:weight 3} { JournalistModel.__default.updateWrittenJournalLen(Lit(jm#0), LitInt(len#0)) } 
    JournalistModel.__default.updateWrittenJournalLen#canCall(Lit(jm#0), LitInt(len#0))
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Lit(JournalistModel.__default.Inv(Lit(jm#0)))
           && LitInt(len#0)
             <= LitInt(JournalistModel.JournalInfo.writtenJournalLen(Lit(JournalistModel.__default.I(Lit(jm#0))))))
       ==> (var dt_update_tmp#1#1 := Lit(jm#0); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1))
         && 
        StartFuel_JournalRanges._default.WeightJournalEntries
           == $LS(MoreFuel_JournalRanges._default.WeightJournalEntries10)
         && StartFuelAssert_JournalRanges._default.WeightJournalEntries
           == $LS($LS(MoreFuel_JournalRanges._default.WeightJournalEntries10))
         && AsFuelBottom(MoreFuel_JournalRanges._default.WeightJournalEntries10)
           == MoreFuel_JournalRanges._default.WeightJournalEntries10
         && JournalistModel.__default.updateWrittenJournalLen(Lit(jm#0), LitInt(len#0))
           == (var dt_update_tmp#1#1 := Lit(jm#0); 
            (var dt_update#writtenJournalBlocks#0#1 := LitInt(len#0); 
              Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                  Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#1)), 
                  Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#1)), 
                  Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#1)), 
                  dt_update#writtenJournalBlocks#0#1, 
                  LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1)))))));

// function declaration for JournalistModel._default.freeze
function JournalistModel.__default.freeze($ly: LayerType, jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.freeze#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.freeze($LS($ly), jm#0) } 
  JournalistModel.__default.freeze($LS($ly), jm#0)
     == JournalistModel.__default.freeze($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.freeze(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.freeze($ly, jm#0)
     == JournalistModel.__default.freeze($LZ, jm#0));

// consequence axiom for JournalistModel.__default.freeze
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.freeze($ly, jm#0) } 
    JournalistModel.__default.freeze#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.__default.Inv(JournalistModel.__default.freeze($ly, jm#0))
         && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(JournalistModel.__default.freeze($ly, jm#0)), 
          (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
                (var dt_update#inMemoryJournal#0#0 := Lit(Seq#Empty(): Seq Box); 
                  #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                    dt_update#inMemoryJournal#0#0, 
                    JournalistModel.JournalInfo.replayJournal(dt_update_tmp#0#0), 
                    JournalistModel.JournalInfo.journalFront(dt_update_tmp#0#0), 
                    JournalistModel.JournalInfo.journalBack(dt_update_tmp#0#0), 
                    JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#0#0)))); 
            (var dt_update#inMemoryJournalFrozen#0#0 := Seq#Append(JournalistModel.JournalInfo.inMemoryJournalFrozen(JournalistModel.__default.I(jm#0)), 
                  JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0))); 
              #JournalistModel.JournalInfo.JournalInfo(dt_update#inMemoryJournalFrozen#0#0, 
                JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#1#0), 
                JournalistModel.JournalInfo.replayJournal(dt_update_tmp#1#0), 
                JournalistModel.JournalInfo.journalFront(dt_update_tmp#1#0), 
                JournalistModel.JournalInfo.journalBack(dt_update_tmp#1#0), 
                JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#1#0)))))
         && $Is(JournalistModel.__default.freeze($ly, jm#0), 
          Tclass.JournalistModel.JournalistModel()));

function JournalistModel.__default.freeze#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.freeze
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.freeze#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.freeze#requires($ly, jm#0)
       == JournalistModel.__default.Inv(jm#0));

// definition axiom for JournalistModel.__default.freeze(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.freeze($LS($ly), jm#0) } 
    JournalistModel.__default.freeze#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> (var dt_update_tmp#2#0 := jm#0; 
          JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0))
         && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
              (var dt_update#len1#0#0 := JournalistModel.JournalistModel.len1(jm#0)
                     + JournalistModel.JournalistModel.len2(jm#0); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#2#0), 
                  dt_update#len1#0#0, 
                  JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0))
         && (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                  (var dt_update#len1#0#0 := JournalistModel.JournalistModel.len1(jm#0)
                         + JournalistModel.JournalistModel.len2(jm#0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#2#0), 
                      dt_update#len1#0#0, 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
              (var dt_update#len2#0#0 := LitInt(0); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                  dt_update#len2#0#0, 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
          JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0))
         && (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                      (var dt_update#len1#0#0 := JournalistModel.JournalistModel.len1(jm#0)
                             + JournalistModel.JournalistModel.len2(jm#0); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.start(dt_update_tmp#2#0), 
                          dt_update#len1#0#0, 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
                  (var dt_update#len2#0#0 := LitInt(0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                      dt_update#len2#0#0, 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
              (var dt_update#frozenJournalBlocks#0#0 := JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)
                     + Div(JournalistModel.JournalistModel.inMemoryWeight(jm#0) + 4064 - 1, LitInt(4064)); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#0), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                  dt_update#frozenJournalBlocks#0#0, 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#0)))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0))
         && JournalistModel.__default.freeze($LS($ly), jm#0)
           == (var jm'#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := jm#0; 
                            (var dt_update#len1#0#0 := JournalistModel.JournalistModel.len1(jm#0)
                                   + JournalistModel.JournalistModel.len2(jm#0); 
                              #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                                JournalistModel.JournalistModel.start(dt_update_tmp#2#0), 
                                dt_update#len1#0#0, 
                                JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                                JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                                JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                                JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                                JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                                JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                                JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                                JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
                        (var dt_update#len2#0#0 := LitInt(0); 
                          #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                            JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                            JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                            dt_update#len2#0#0, 
                            JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                            JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                            JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                            JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                            JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                            JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                            JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
                    (var dt_update#frozenJournalBlocks#0#0 := JournalistModel.JournalistModel.frozenJournalBlocks(jm#0)
                           + Div(JournalistModel.JournalistModel.inMemoryWeight(jm#0) + 4064 - 1, LitInt(4064)); 
                      #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                        JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                        JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                        JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                        JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                        JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                        JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                        JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#0), 
                        JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                        dt_update#frozenJournalBlocks#0#0, 
                        JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#0)))); 
                (var dt_update#inMemoryWeight#0#0 := LitInt(0); 
                  #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#0), 
                    JournalistModel.JournalistModel.start(dt_update_tmp#5#0), 
                    JournalistModel.JournalistModel.len1(dt_update_tmp#5#0), 
                    JournalistModel.JournalistModel.len2(dt_update_tmp#5#0), 
                    JournalistModel.JournalistModel.replayJournal(dt_update_tmp#5#0), 
                    JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#0), 
                    JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#0), 
                    JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#0), 
                    JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#5#0), 
                    JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#0), 
                    dt_update#inMemoryWeight#0#0))); 
            jm'#0));

// definition axiom for JournalistModel.__default.freeze for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.freeze($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.freeze#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.Inv(Lit(jm#0))))
       ==> (var dt_update_tmp#2#1 := Lit(jm#0); 
          JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1))
         && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
              (var dt_update#len1#0#1 := LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                       + JournalistModel.JournalistModel.len2(Lit(jm#0))); 
                Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                    LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#2#1)), 
                    dt_update#len1#0#1, 
                    LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                    Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                    LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                    Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                    Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                    LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                    LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                    LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1))
         && (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                  (var dt_update#len1#0#1 := LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                           + JournalistModel.JournalistModel.len2(Lit(jm#0))); 
                    Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#2#1)), 
                        dt_update#len1#0#1, 
                        LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                        Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                        Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                        Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                        LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))))); 
              (var dt_update#len2#0#1 := LitInt(0); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.len1(dt_update_tmp#3#1), 
                  dt_update#len2#0#1, 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
          JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1))
         && (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                      (var dt_update#len1#0#1 := LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                               + JournalistModel.JournalistModel.len2(Lit(jm#0))); 
                        Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#2#1)), 
                            dt_update#len1#0#1, 
                            LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                            Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                            Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                            Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                            LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))))); 
                  (var dt_update#len2#0#1 := LitInt(0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#3#1), 
                      dt_update#len2#0#1, 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
              (var dt_update#frozenJournalBlocks#0#1 := LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0))
                       + Div(JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)) + 4064 - 1, 
                        LitInt(4064))); 
                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#1), 
                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                  dt_update#frozenJournalBlocks#0#1, 
                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#1)))); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1))
         && JournalistModel.__default.freeze($LS($ly), Lit(jm#0))
           == (var jm'#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(jm#0); 
                            (var dt_update#len1#0#1 := LitInt(JournalistModel.JournalistModel.len1(Lit(jm#0))
                                     + JournalistModel.JournalistModel.len2(Lit(jm#0))); 
                              Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#2#1)), 
                                  dt_update#len1#0#1, 
                                  LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#2#1)), 
                                  Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1)), 
                                  Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1)), 
                                  Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1)), 
                                  LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))))); 
                        (var dt_update#len2#0#1 := LitInt(0); 
                          #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                            JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                            JournalistModel.JournalistModel.len1(dt_update_tmp#3#1), 
                            dt_update#len2#0#1, 
                            JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                            JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                            JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                            JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                            JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                            JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                            JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
                    (var dt_update#frozenJournalBlocks#0#1 := LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0))
                             + Div(JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0)) + 4064 - 1, 
                              LitInt(4064))); 
                      #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                        JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                        JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                        JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                        JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                        JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                        JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                        JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#1), 
                        JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                        dt_update#frozenJournalBlocks#0#1, 
                        JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#1)))); 
                (var dt_update#inMemoryWeight#0#1 := LitInt(0); 
                  #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#1), 
                    JournalistModel.JournalistModel.start(dt_update_tmp#5#1), 
                    JournalistModel.JournalistModel.len1(dt_update_tmp#5#1), 
                    JournalistModel.JournalistModel.len2(dt_update_tmp#5#1), 
                    JournalistModel.JournalistModel.replayJournal(dt_update_tmp#5#1), 
                    JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#1), 
                    JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#1), 
                    JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#1), 
                    JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#5#1), 
                    JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#1), 
                    dt_update#inMemoryWeight#0#1))); 
            jm'#1));

// function declaration for JournalistModel._default.canAppend
function JournalistModel.__default.canAppend($ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType) : bool;

function JournalistModel.__default.canAppend#canCall(jm#0: DatatypeType, je#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
  { JournalistModel.__default.canAppend($LS($ly), jm#0, je#0) } 
  JournalistModel.__default.canAppend($LS($ly), jm#0, je#0)
     == JournalistModel.__default.canAppend($ly, jm#0, je#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
  { JournalistModel.__default.canAppend(AsFuelBottom($ly), jm#0, je#0) } 
  JournalistModel.__default.canAppend($ly, jm#0, je#0)
     == JournalistModel.__default.canAppend($LZ, jm#0, je#0));

// consequence axiom for JournalistModel.__default.canAppend
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
    { JournalistModel.__default.canAppend($ly, jm#0, je#0) } 
    JournalistModel.__default.canAppend#canCall(jm#0, je#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(je#0, Tclass.Journal.JournalEntry())
           && JournalistModel.__default.Inv(jm#0))
       ==> true);

function JournalistModel.__default.canAppend#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.canAppend
axiom (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
  { JournalistModel.__default.canAppend#requires($ly, jm#0, je#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       && $Is(je#0, Tclass.Journal.JournalEntry())
     ==> JournalistModel.__default.canAppend#requires($ly, jm#0, je#0)
       == JournalistModel.__default.Inv(jm#0));

// definition axiom for JournalistModel.__default.canAppend(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
    { JournalistModel.__default.canAppend($LS($ly), jm#0, je#0) } 
    JournalistModel.__default.canAppend#canCall(jm#0, je#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(je#0, Tclass.Journal.JournalEntry())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalRanges.__default.WeightJournalEntry#canCall(je#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && JournalistModel.__default.canAppend($LS($ly), jm#0, je#0)
           == (Mul(LitInt(4064), 
                JournalistModel.JournalistModel.writtenJournalBlocks(jm#0)
                   + JournalistModel.JournalistModel.frozenJournalBlocks(jm#0))
               + JournalistModel.JournalistModel.inMemoryWeight(jm#0)
               + JournalRanges.__default.WeightJournalEntry(je#0)
               + (if JournalistModel.JournalistModel.len2(jm#0) == LitInt(0) then 8 else 0)
             <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())))));

// definition axiom for JournalistModel.__default.canAppend for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.canAppend($LS($ly), Lit(jm#0), Lit(je#0)) } 
    JournalistModel.__default.canAppend#canCall(Lit(jm#0), Lit(je#0))
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(je#0, Tclass.Journal.JournalEntry())
           && Lit(JournalistModel.__default.Inv(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalRanges.__default.WeightJournalEntry#canCall(Lit(je#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && JournalistModel.__default.canAppend($LS($ly), Lit(jm#0), Lit(je#0))
           == (Mul(LitInt(4064), 
                LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(Lit(jm#0))
                     + JournalistModel.JournalistModel.frozenJournalBlocks(Lit(jm#0))))
               + JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0))
               + JournalRanges.__default.WeightJournalEntry(Lit(je#0))
               + (if LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0))) == LitInt(0)
                 then 8
                 else 0)
             <= LitInt(Mul(LitInt(4064), LitInt(DiskLayout.__default.NumJournalBlocks())))));

// function declaration for JournalistModel._default.append
function JournalistModel.__default.append($ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.append#canCall(jm#0: DatatypeType, je#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
  { JournalistModel.__default.append($LS($ly), jm#0, je#0) } 
  JournalistModel.__default.append($LS($ly), jm#0, je#0)
     == JournalistModel.__default.append($ly, jm#0, je#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
  { JournalistModel.__default.append(AsFuelBottom($ly), jm#0, je#0) } 
  JournalistModel.__default.append($ly, jm#0, je#0)
     == JournalistModel.__default.append($LZ, jm#0, je#0));

// consequence axiom for JournalistModel.__default.append
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
    { JournalistModel.__default.append($ly, jm#0, je#0) } 
    JournalistModel.__default.append#canCall(jm#0, je#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(je#0, Tclass.Journal.JournalEntry())
           && 
          JournalistModel.__default.Inv(jm#0)
           && JournalistModel.__default.canAppend(StartFuel_JournalistModel._default.canAppend, jm#0, je#0))
       ==> JournalistModel.__default.Inv(JournalistModel.__default.append($ly, jm#0, je#0))
         && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(JournalistModel.__default.append($ly, jm#0, je#0)), 
          (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
            (var dt_update#inMemoryJournal#0#0 := Seq#Append(JournalistModel.JournalInfo.inMemoryJournal(JournalistModel.__default.I(jm#0)), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(je#0))); 
              #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                dt_update#inMemoryJournal#0#0, 
                JournalistModel.JournalInfo.replayJournal(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.journalFront(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.journalBack(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#0#0)))))
         && $Is(JournalistModel.__default.append($ly, jm#0, je#0), 
          Tclass.JournalistModel.JournalistModel()));

function JournalistModel.__default.append#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.append
axiom (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
  { JournalistModel.__default.append#requires($ly, jm#0, je#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       && $Is(je#0, Tclass.Journal.JournalEntry())
     ==> JournalistModel.__default.append#requires($ly, jm#0, je#0)
       == (JournalistModel.__default.Inv(jm#0)
         && JournalistModel.__default.canAppend(StartFuel_JournalistModel._default.canAppend, jm#0, je#0)));

// definition axiom for JournalistModel.__default.append(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
    { JournalistModel.__default.append($LS($ly), jm#0, je#0) } 
    JournalistModel.__default.append#canCall(jm#0, je#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(je#0, Tclass.Journal.JournalEntry())
           && 
          JournalistModel.__default.Inv(jm#0)
           && JournalistModel.__default.canAppend(StartFuel_JournalistModel._default.canAppend, jm#0, je#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && (JournalistModel.JournalistModel.len1(jm#0)
               + JournalistModel.JournalistModel.len2(jm#0)
             < Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.__default.basic__mod#canCall(JournalistModel.JournalistModel.start(jm#0)
                 + JournalistModel.JournalistModel.len1(jm#0)
                 + JournalistModel.JournalistModel.len2(jm#0), 
              Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)))
             && 
            JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && JournalistModel.JournalistModel.JournalistModel_q(jm#0))
         && (Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
             <= JournalistModel.JournalistModel.len1(jm#0)
               + JournalistModel.JournalistModel.len2(jm#0)
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && (var newLen#0 := Mul(Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)), LitInt(2)); 
              JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && Sequences.__default.fill#canCall(Tclass.Journal.JournalEntry(), 
                  newLen#0 - Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)) - 1, 
                  $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))
         && (var start'#0, journalEntries'#0 := $Unbox(_System.Tuple2._0((if JournalistModel.JournalistModel.len1(jm#0)
                       + JournalistModel.JournalistModel.len2(jm#0)
                     < Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
                   then (var idx#0 := JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
                           + JournalistModel.JournalistModel.len1(jm#0)
                           + JournalistModel.JournalistModel.len2(jm#0), 
                        Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))); 
                    #_System._tuple#2._#Make2($Box(JournalistModel.JournalistModel.start(jm#0)), 
                      $Box(Seq#Update(JournalistModel.JournalistModel.journalEntries(jm#0), idx#0, $Box(je#0)))))
                   else (var newLen#0 := Mul(Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)), LitInt(2)); 
                    #_System._tuple#2._#Make2($Box(LitInt(0)), 
                      $Box(Seq#Append(Seq#Append(Seq#Append(Seq#Drop(JournalistModel.JournalistModel.journalEntries(jm#0), 
                                JournalistModel.JournalistModel.start(jm#0)), 
                              Seq#Take(JournalistModel.JournalistModel.journalEntries(jm#0), 
                                JournalistModel.JournalistModel.start(jm#0))), 
                            Seq#Build(Seq#Empty(): Seq Box, $Box(je#0))), 
                          Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
                            StartFuel_Sequences._default.fill, 
                            newLen#0 - Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)) - 1, 
                            $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))))))): int, 
            $Unbox(_System.Tuple2._1((if JournalistModel.JournalistModel.len1(jm#0)
                       + JournalistModel.JournalistModel.len2(jm#0)
                     < Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
                   then (var idx#0 := JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
                           + JournalistModel.JournalistModel.len1(jm#0)
                           + JournalistModel.JournalistModel.len2(jm#0), 
                        Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))); 
                    #_System._tuple#2._#Make2($Box(JournalistModel.JournalistModel.start(jm#0)), 
                      $Box(Seq#Update(JournalistModel.JournalistModel.journalEntries(jm#0), idx#0, $Box(je#0)))))
                   else (var newLen#0 := Mul(Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)), LitInt(2)); 
                    #_System._tuple#2._#Make2($Box(LitInt(0)), 
                      $Box(Seq#Append(Seq#Append(Seq#Append(Seq#Drop(JournalistModel.JournalistModel.journalEntries(jm#0), 
                                JournalistModel.JournalistModel.start(jm#0)), 
                              Seq#Take(JournalistModel.JournalistModel.journalEntries(jm#0), 
                                JournalistModel.JournalistModel.start(jm#0))), 
                            Seq#Build(Seq#Empty(): Seq Box, $Box(je#0))), 
                          Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
                            StartFuel_Sequences._default.fill, 
                            newLen#0 - Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)) - 1, 
                            $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))))))): Seq Box; 
          (var dt_update_tmp#1#0 := jm#0; 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0))
             && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := jm#0; 
                  (var dt_update#journalEntries#0#0 := journalEntries'#0; 
                    #JournalistModel.JournalistModel.JournalistModel(dt_update#journalEntries#0#0, 
                      JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))); 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#0))
             && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := jm#0; 
                      (var dt_update#journalEntries#0#0 := journalEntries'#0; 
                        #JournalistModel.JournalistModel.JournalistModel(dt_update#journalEntries#0#0, 
                          JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#0), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#0), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#0), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#0), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))); 
                  (var dt_update#start#0#0 := start'#0; 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                      dt_update#start#0#0, 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
              JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0))
             && (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := jm#0; 
                          (var dt_update#journalEntries#0#0 := journalEntries'#0; 
                            #JournalistModel.JournalistModel.JournalistModel(dt_update#journalEntries#0#0, 
                              JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                              JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#0), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#0), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#0), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#0), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))); 
                      (var dt_update#start#0#0 := start'#0; 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                          dt_update#start#0#0, 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
                  (var dt_update#len2#0#0 := JournalistModel.JournalistModel.len2(jm#0) + 1; 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                      dt_update#len2#0#0, 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
              JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && JournalRanges.__default.WeightJournalEntry#canCall(je#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)))
         && JournalistModel.__default.append($LS($ly), jm#0, je#0)
           == (var start'#0, journalEntries'#0 := $Unbox(_System.Tuple2._0((if JournalistModel.JournalistModel.len1(jm#0)
                         + JournalistModel.JournalistModel.len2(jm#0)
                       < Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
                     then (var idx#0 := JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
                             + JournalistModel.JournalistModel.len1(jm#0)
                             + JournalistModel.JournalistModel.len2(jm#0), 
                          Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))); 
                      #_System._tuple#2._#Make2($Box(JournalistModel.JournalistModel.start(jm#0)), 
                        $Box(Seq#Update(JournalistModel.JournalistModel.journalEntries(jm#0), idx#0, $Box(je#0)))))
                     else (var newLen#0 := Mul(Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)), LitInt(2)); 
                      #_System._tuple#2._#Make2($Box(LitInt(0)), 
                        $Box(Seq#Append(Seq#Append(Seq#Append(Seq#Drop(JournalistModel.JournalistModel.journalEntries(jm#0), 
                                  JournalistModel.JournalistModel.start(jm#0)), 
                                Seq#Take(JournalistModel.JournalistModel.journalEntries(jm#0), 
                                  JournalistModel.JournalistModel.start(jm#0))), 
                              Seq#Build(Seq#Empty(): Seq Box, $Box(je#0))), 
                            Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
                              StartFuel_Sequences._default.fill, 
                              newLen#0 - Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)) - 1, 
                              $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))))))): int, 
              $Unbox(_System.Tuple2._1((if JournalistModel.JournalistModel.len1(jm#0)
                         + JournalistModel.JournalistModel.len2(jm#0)
                       < Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))
                     then (var idx#0 := JournalistModel.__default.basic__mod(JournalistModel.JournalistModel.start(jm#0)
                             + JournalistModel.JournalistModel.len1(jm#0)
                             + JournalistModel.JournalistModel.len2(jm#0), 
                          Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0))); 
                      #_System._tuple#2._#Make2($Box(JournalistModel.JournalistModel.start(jm#0)), 
                        $Box(Seq#Update(JournalistModel.JournalistModel.journalEntries(jm#0), idx#0, $Box(je#0)))))
                     else (var newLen#0 := Mul(Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)), LitInt(2)); 
                      #_System._tuple#2._#Make2($Box(LitInt(0)), 
                        $Box(Seq#Append(Seq#Append(Seq#Append(Seq#Drop(JournalistModel.JournalistModel.journalEntries(jm#0), 
                                  JournalistModel.JournalistModel.start(jm#0)), 
                                Seq#Take(JournalistModel.JournalistModel.journalEntries(jm#0), 
                                  JournalistModel.JournalistModel.start(jm#0))), 
                              Seq#Build(Seq#Empty(): Seq Box, $Box(je#0))), 
                            Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
                              StartFuel_Sequences._default.fill, 
                              newLen#0 - Seq#Length(JournalistModel.JournalistModel.journalEntries(jm#0)) - 1, 
                              $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))))))): Seq Box; 
            (var jm'#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := jm#0; 
                              (var dt_update#journalEntries#0#0 := journalEntries'#0; 
                                #JournalistModel.JournalistModel.JournalistModel(dt_update#journalEntries#0#0, 
                                  JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                                  JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                                  JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#0), 
                                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#0), 
                                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#0), 
                                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#0), 
                                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))); 
                          (var dt_update#start#0#0 := start'#0; 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#0), 
                              dt_update#start#0#0, 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#0), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#0)))); 
                      (var dt_update#len2#0#0 := JournalistModel.JournalistModel.len2(jm#0) + 1; 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                          dt_update#len2#0#0, 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
                  (var dt_update#inMemoryWeight#0#0 := JournalistModel.JournalistModel.inMemoryWeight(jm#0)
                         + JournalRanges.__default.WeightJournalEntry(je#0)
                         + (if JournalistModel.JournalistModel.len2(jm#0) == LitInt(0) then 8 else 0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#0), 
                      dt_update#inMemoryWeight#0#0))); 
              jm'#0)));

// definition axiom for JournalistModel.__default.append for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, je#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.append($LS($ly), Lit(jm#0), Lit(je#0)) } 
    JournalistModel.__default.append#canCall(Lit(jm#0), Lit(je#0))
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(je#0, Tclass.Journal.JournalEntry())
           && 
          Lit(JournalistModel.__default.Inv(Lit(jm#0)))
           && JournalistModel.__default.canAppend(StartFuel_JournalistModel._default.canAppend, Lit(jm#0), Lit(je#0)))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && (JournalistModel.JournalistModel.len1(Lit(jm#0))
               + JournalistModel.JournalistModel.len2(Lit(jm#0))
             < Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.__default.basic__mod#canCall(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                   + JournalistModel.JournalistModel.len1(Lit(jm#0))
                   + JournalistModel.JournalistModel.len2(Lit(jm#0))), 
              Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0)))))
             && 
            JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
         && (Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
             <= JournalistModel.JournalistModel.len1(Lit(jm#0))
               + JournalistModel.JournalistModel.len2(Lit(jm#0))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && (var newLen#1 := Mul(Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0)))), 
                  LitInt(2)); 
              JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && Sequences.__default.fill#canCall(Tclass.Journal.JournalEntry(), 
                  newLen#1
                     - Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
                     - 1, 
                  $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))
         && (var start'#1, journalEntries'#1 := $Unbox(_System.Tuple2._0((if JournalistModel.JournalistModel.len1(Lit(jm#0))
                       + JournalistModel.JournalistModel.len2(Lit(jm#0))
                     < Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
                   then (var idx#1 := JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                             + JournalistModel.JournalistModel.len1(Lit(jm#0))
                             + JournalistModel.JournalistModel.len2(Lit(jm#0))), 
                        Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))); 
                    #_System._tuple#2._#Make2($Box(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))), 
                      $Box(Seq#Update(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                          idx#1, 
                          $Box(Lit(je#0))))))
                   else (var newLen#1 := Mul(Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0)))), 
                        LitInt(2)); 
                    #_System._tuple#2._#Make2($Box(LitInt(0)), 
                      $Box(Seq#Append(Seq#Append(Seq#Append(Seq#Drop(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                                LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))), 
                              Seq#Take(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                                LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))))), 
                            Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(je#0)))), 
                          Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
                            StartFuel_Sequences._default.fill, 
                            newLen#1
                               - Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
                               - 1, 
                            $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))))))): int, 
            $Unbox(_System.Tuple2._1((if JournalistModel.JournalistModel.len1(Lit(jm#0))
                       + JournalistModel.JournalistModel.len2(Lit(jm#0))
                     < Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
                   then (var idx#1 := JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                             + JournalistModel.JournalistModel.len1(Lit(jm#0))
                             + JournalistModel.JournalistModel.len2(Lit(jm#0))), 
                        Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))); 
                    #_System._tuple#2._#Make2($Box(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))), 
                      $Box(Seq#Update(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                          idx#1, 
                          $Box(Lit(je#0))))))
                   else (var newLen#1 := Mul(Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0)))), 
                        LitInt(2)); 
                    #_System._tuple#2._#Make2($Box(LitInt(0)), 
                      $Box(Seq#Append(Seq#Append(Seq#Append(Seq#Drop(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                                LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))), 
                              Seq#Take(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                                LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))))), 
                            Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(je#0)))), 
                          Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
                            StartFuel_Sequences._default.fill, 
                            newLen#1
                               - Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
                               - 1, 
                            $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))))))): Seq Box; 
          (var dt_update_tmp#1#1 := Lit(jm#0); 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1))
             && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := Lit(jm#0); 
                  (var dt_update#journalEntries#0#1 := journalEntries'#1; 
                    #JournalistModel.JournalistModel.JournalistModel(dt_update#journalEntries#0#1, 
                      LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                      Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#1)), 
                      Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#1)), 
                      Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                      LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1))))); 
              JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#2#1))
             && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := Lit(jm#0); 
                      (var dt_update#journalEntries#0#1 := journalEntries'#1; 
                        #JournalistModel.JournalistModel.JournalistModel(dt_update#journalEntries#0#1, 
                          LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                          LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                          LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                          Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                          LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#1)), 
                          Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#1)), 
                          Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#1)), 
                          LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#1)), 
                          LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                          LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1))))); 
                  (var dt_update#start#0#1 := start'#1; 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1), 
                      dt_update#start#0#1, 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#2#1), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#2#1), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))); 
              JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1))
             && (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := Lit(jm#0); 
                          (var dt_update#journalEntries#0#1 := journalEntries'#1; 
                            #JournalistModel.JournalistModel.JournalistModel(dt_update#journalEntries#0#1, 
                              LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                              LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                              LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                              Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                              LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#1)), 
                              Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#1)), 
                              Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#1)), 
                              LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#1)), 
                              LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                              LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1))))); 
                      (var dt_update#start#0#1 := start'#1; 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1), 
                          dt_update#start#0#1, 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#2#1), 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#2#1), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))); 
                  (var dt_update#len2#0#1 := LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0)) + 1); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#3#1), 
                      dt_update#len2#0#1, 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
              JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && JournalRanges.__default.WeightJournalEntry#canCall(Lit(je#0))
                 && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
                 && 
                JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                 && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)))
         && JournalistModel.__default.append($LS($ly), Lit(jm#0), Lit(je#0))
           == (var start'#1, journalEntries'#1 := $Unbox(_System.Tuple2._0((if JournalistModel.JournalistModel.len1(Lit(jm#0))
                         + JournalistModel.JournalistModel.len2(Lit(jm#0))
                       < Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
                     then (var idx#1 := JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                               + JournalistModel.JournalistModel.len1(Lit(jm#0))
                               + JournalistModel.JournalistModel.len2(Lit(jm#0))), 
                          Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))); 
                      #_System._tuple#2._#Make2($Box(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))), 
                        $Box(Seq#Update(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                            idx#1, 
                            $Box(Lit(je#0))))))
                     else (var newLen#1 := Mul(Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0)))), 
                          LitInt(2)); 
                      #_System._tuple#2._#Make2($Box(LitInt(0)), 
                        $Box(Seq#Append(Seq#Append(Seq#Append(Seq#Drop(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                                  LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))), 
                                Seq#Take(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                                  LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))))), 
                              Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(je#0)))), 
                            Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
                              StartFuel_Sequences._default.fill, 
                              newLen#1
                                 - Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
                                 - 1, 
                              $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))))))): int, 
              $Unbox(_System.Tuple2._1((if JournalistModel.JournalistModel.len1(Lit(jm#0))
                         + JournalistModel.JournalistModel.len2(Lit(jm#0))
                       < Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
                     then (var idx#1 := JournalistModel.__default.basic__mod(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))
                               + JournalistModel.JournalistModel.len1(Lit(jm#0))
                               + JournalistModel.JournalistModel.len2(Lit(jm#0))), 
                          Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))); 
                      #_System._tuple#2._#Make2($Box(LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))), 
                        $Box(Seq#Update(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                            idx#1, 
                            $Box(Lit(je#0))))))
                     else (var newLen#1 := Mul(Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0)))), 
                          LitInt(2)); 
                      #_System._tuple#2._#Make2($Box(LitInt(0)), 
                        $Box(Seq#Append(Seq#Append(Seq#Append(Seq#Drop(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                                  LitInt(JournalistModel.JournalistModel.start(Lit(jm#0)))), 
                                Seq#Take(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))), 
                                  LitInt(JournalistModel.JournalistModel.start(Lit(jm#0))))), 
                              Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(je#0)))), 
                            Sequences.__default.fill(Tclass.Journal.JournalEntry(), 
                              StartFuel_Sequences._default.fill, 
                              newLen#1
                                 - Seq#Length(Lit(JournalistModel.JournalistModel.journalEntries(Lit(jm#0))))
                                 - 1, 
                              $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)))))))))))): Seq Box; 
            (var jm'#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := Lit(jm#0); 
                              (var dt_update#journalEntries#0#1 := journalEntries'#1; 
                                #JournalistModel.JournalistModel.JournalistModel(dt_update#journalEntries#0#1, 
                                  LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                                  LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                                  LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                                  Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                                  LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#1)), 
                                  Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#1)), 
                                  Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#1)), 
                                  LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#1)), 
                                  LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                                  LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1))))); 
                          (var dt_update#start#0#1 := start'#1; 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#2#1), 
                              dt_update#start#0#1, 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#2#1), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#2#1), 
                              JournalistModel.JournalistModel.replayJournal(dt_update_tmp#2#1), 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#2#1), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#2#1), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#2#1), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#2#1), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#2#1), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#2#1)))); 
                      (var dt_update#len2#0#1 := LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0)) + 1); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.start(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#3#1), 
                          dt_update#len2#0#1, 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))); 
                  (var dt_update#inMemoryWeight#0#1 := JournalistModel.JournalistModel.inMemoryWeight(Lit(jm#0))
                         + JournalRanges.__default.WeightJournalEntry(Lit(je#0))
                         + (if LitInt(JournalistModel.JournalistModel.len2(Lit(jm#0))) == LitInt(0)
                           then 8
                           else 0); 
                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#1), 
                      dt_update#inMemoryWeight#0#1))); 
              jm'#1)));

// function declaration for JournalistModel._default.isReplayEmpty
function JournalistModel.__default.isReplayEmpty($ly: LayerType, jm#0: DatatypeType) : bool;

function JournalistModel.__default.isReplayEmpty#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.isReplayEmpty($LS($ly), jm#0) } 
  JournalistModel.__default.isReplayEmpty($LS($ly), jm#0)
     == JournalistModel.__default.isReplayEmpty($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.isReplayEmpty(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.isReplayEmpty($ly, jm#0)
     == JournalistModel.__default.isReplayEmpty($LZ, jm#0));

// consequence axiom for JournalistModel.__default.isReplayEmpty
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.isReplayEmpty($ly, jm#0) } 
    JournalistModel.__default.isReplayEmpty#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.__default.isReplayEmpty($ly, jm#0)
         == Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box));

function JournalistModel.__default.isReplayEmpty#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.isReplayEmpty
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.isReplayEmpty#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.isReplayEmpty#requires($ly, jm#0)
       == JournalistModel.__default.Inv(jm#0));

// definition axiom for JournalistModel.__default.isReplayEmpty(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.isReplayEmpty($LS($ly), jm#0) } 
    JournalistModel.__default.isReplayEmpty#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.isReplayEmpty($LS($ly), jm#0)
           == 
          (JournalistModel.JournalistModel.replayIdx(jm#0)
           == Seq#Length(JournalistModel.JournalistModel.replayJournal(jm#0))));

// definition axiom for JournalistModel.__default.isReplayEmpty for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.isReplayEmpty($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.isReplayEmpty#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.Inv(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.isReplayEmpty($LS($ly), Lit(jm#0))
           == 
          (LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)))
           == Seq#Length(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0))))));

// function declaration for JournalistModel._default.replayJournalTop
function JournalistModel.__default.replayJournalTop($ly: LayerType, jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.replayJournalTop#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.replayJournalTop($LS($ly), jm#0) } 
  JournalistModel.__default.replayJournalTop($LS($ly), jm#0)
     == JournalistModel.__default.replayJournalTop($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.replayJournalTop(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.replayJournalTop($ly, jm#0)
     == JournalistModel.__default.replayJournalTop($LZ, jm#0));

// consequence axiom for JournalistModel.__default.replayJournalTop
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.replayJournalTop($ly, jm#0) } 
    JournalistModel.__default.replayJournalTop#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          JournalistModel.__default.Inv(jm#0)
           && !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box))
       ==> Journal.JournalEntry#Equal(JournalistModel.__default.replayJournalTop($ly, jm#0), 
          $Unbox(Seq#Index(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(jm#0)), 
              LitInt(0))): DatatypeType)
         && $Is(JournalistModel.__default.replayJournalTop($ly, jm#0), 
          Tclass.Journal.JournalEntry()));

function JournalistModel.__default.replayJournalTop#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.replayJournalTop
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.replayJournalTop#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.replayJournalTop#requires($ly, jm#0)
       == (JournalistModel.__default.Inv(jm#0)
         && !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box)));

// definition axiom for JournalistModel.__default.replayJournalTop(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.replayJournalTop($LS($ly), jm#0) } 
    JournalistModel.__default.replayJournalTop#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          JournalistModel.__default.Inv(jm#0)
           && !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.replayJournalTop($LS($ly), jm#0)
           == $Unbox(Seq#Index(JournalistModel.JournalistModel.replayJournal(jm#0), 
              JournalistModel.JournalistModel.replayIdx(jm#0))): DatatypeType);

// definition axiom for JournalistModel.__default.replayJournalTop for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.replayJournalTop($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.replayJournalTop#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          Lit(JournalistModel.__default.Inv(Lit(jm#0)))
           && !Seq#Equal(JournalistModel.JournalInfo.replayJournal(Lit(JournalistModel.__default.I(Lit(jm#0)))), 
            Seq#Empty(): Seq Box))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.replayJournalTop($LS($ly), Lit(jm#0))
           == $Unbox(Seq#Index(Lit(JournalistModel.JournalistModel.replayJournal(Lit(jm#0))), 
              LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0))))): DatatypeType);

// function declaration for JournalistModel._default.replayJournalPop
function JournalistModel.__default.replayJournalPop($ly: LayerType, jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.replayJournalPop#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.replayJournalPop($LS($ly), jm#0) } 
  JournalistModel.__default.replayJournalPop($LS($ly), jm#0)
     == JournalistModel.__default.replayJournalPop($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.replayJournalPop(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.replayJournalPop($ly, jm#0)
     == JournalistModel.__default.replayJournalPop($LZ, jm#0));

// consequence axiom for JournalistModel.__default.replayJournalPop
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.replayJournalPop($ly, jm#0) } 
    JournalistModel.__default.replayJournalPop#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          JournalistModel.__default.Inv(jm#0)
           && !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box))
       ==> JournalistModel.__default.Inv(JournalistModel.__default.replayJournalPop($ly, jm#0))
         && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(JournalistModel.__default.replayJournalPop($ly, jm#0)), 
          (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
            (var dt_update#replayJournal#0#0 := JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(JournalistModel.__default.replayJournalPop($ly, jm#0))); 
              #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#0#0), 
                dt_update#replayJournal#0#0, 
                JournalistModel.JournalInfo.journalFront(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.journalBack(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#0#0)))))
         && Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(jm#0)), 
          Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(JournalistModel.__default.replayJournalTop(StartFuel_JournalistModel._default.replayJournalTop, jm#0))), 
            JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(JournalistModel.__default.replayJournalPop($ly, jm#0)))))
         && $Is(JournalistModel.__default.replayJournalPop($ly, jm#0), 
          Tclass.JournalistModel.JournalistModel()));

function JournalistModel.__default.replayJournalPop#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.replayJournalPop
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.replayJournalPop#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.replayJournalPop#requires($ly, jm#0)
       == (JournalistModel.__default.Inv(jm#0)
         && !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(jm#0)), 
          Seq#Empty(): Seq Box)));

// definition axiom for JournalistModel.__default.replayJournalPop(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.replayJournalPop($LS($ly), jm#0) } 
    JournalistModel.__default.replayJournalPop#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          JournalistModel.__default.Inv(jm#0)
           && !Seq#Equal(JournalistModel.JournalInfo.replayJournal(JournalistModel.__default.I(jm#0)), 
            Seq#Empty(): Seq Box))
       ==> (var dt_update_tmp#1#0 := jm#0; 
          JournalistModel.JournalistModel.JournalistModel_q(jm#0)
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0))
         && JournalistModel.__default.replayJournalPop($LS($ly), jm#0)
           == (var dt_update_tmp#1#0 := jm#0; 
            (var dt_update#replayIdx#0#0 := JournalistModel.JournalistModel.replayIdx(jm#0) + 1; 
              #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                dt_update#replayIdx#0#0, 
                JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))));

// definition axiom for JournalistModel.__default.replayJournalPop for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.replayJournalPop($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.replayJournalPop#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && 
          Lit(JournalistModel.__default.Inv(Lit(jm#0)))
           && !Seq#Equal(JournalistModel.JournalInfo.replayJournal(Lit(JournalistModel.__default.I(Lit(jm#0)))), 
            Seq#Empty(): Seq Box))
       ==> (var dt_update_tmp#1#1 := Lit(jm#0); 
          JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
             && 
            JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1))
         && JournalistModel.__default.replayJournalPop($LS($ly), Lit(jm#0))
           == (var dt_update_tmp#1#1 := Lit(jm#0); 
            (var dt_update#replayIdx#0#1 := LitInt(JournalistModel.JournalistModel.replayIdx(Lit(jm#0)) + 1); 
              Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                  Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                  dt_update#replayIdx#0#1, 
                  Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#1)), 
                  Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1)))))));

// function declaration for JournalistModel._default.setFront
function JournalistModel.__default.setFront($ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box) : DatatypeType;

function JournalistModel.__default.setFront#canCall(jm#0: DatatypeType, jr#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
  { JournalistModel.__default.setFront($LS($ly), jm#0, jr#0) } 
  JournalistModel.__default.setFront($LS($ly), jm#0, jr#0)
     == JournalistModel.__default.setFront($ly, jm#0, jr#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
  { JournalistModel.__default.setFront(AsFuelBottom($ly), jm#0, jr#0) } 
  JournalistModel.__default.setFront($ly, jm#0, jr#0)
     == JournalistModel.__default.setFront($LZ, jm#0, jr#0));

// consequence axiom for JournalistModel.__default.setFront
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
    { JournalistModel.__default.setFront($ly, jm#0, jr#0) } 
    JournalistModel.__default.setFront#canCall(jm#0, jr#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          JournalistModel.__default.Inv(jm#0)
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(jr#0, i#0)): Seq Box } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(jr#0)
               ==> Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064))
           && Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> JournalistModel.__default.Inv(JournalistModel.__default.setFront($ly, jm#0, jr#0))
         && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(JournalistModel.__default.setFront($ly, jm#0, jr#0)), 
          (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
            (var dt_update#journalFront#0#0 := #Options.Option.Some($Box(jr#0)); 
              #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.replayJournal(dt_update_tmp#0#0), 
                dt_update#journalFront#0#0, 
                JournalistModel.JournalInfo.journalBack(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#0#0)))))
         && $Is(JournalistModel.__default.setFront($ly, jm#0, jr#0), 
          Tclass.JournalistModel.JournalistModel()));

function JournalistModel.__default.setFront#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for JournalistModel.__default.setFront
axiom (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
  { JournalistModel.__default.setFront#requires($ly, jm#0, jr#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       && $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalistModel.__default.setFront#requires($ly, jm#0, jr#0)
       == (
        JournalistModel.__default.Inv(jm#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
             ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064))
         && Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalistModel.__default.setFront(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
    { JournalistModel.__default.setFront($LS($ly), jm#0, jr#0) } 
    JournalistModel.__default.setFront#canCall(jm#0, jr#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          JournalistModel.__default.Inv(jm#0)
           && (forall i#1: int :: 
            { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
               ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064))
           && Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (var dt_update_tmp#1#0 := jm#0; 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0))
         && JournalistModel.__default.setFront($LS($ly), jm#0, jr#0)
           == (var dt_update_tmp#1#0 := jm#0; 
            (var dt_update#journalFront#1#0 := #Options.Option.Some($Box(jr#0)); 
              #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#0), 
                dt_update#journalFront#1#0, 
                JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))));

// definition axiom for JournalistModel.__default.setFront for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
    {:weight 3} { JournalistModel.__default.setFront($LS($ly), Lit(jm#0), Lit(jr#0)) } 
    JournalistModel.__default.setFront#canCall(Lit(jm#0), Lit(jr#0))
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          Lit(JournalistModel.__default.Inv(Lit(jm#0)))
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(jr#0, i#2)): Seq Box } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(jr#0))
               ==> Seq#Length($Unbox(Seq#Index(Lit(jr#0), i#2)): Seq Box) == LitInt(4064))
           && Seq#Length(Lit(jr#0)) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (var dt_update_tmp#1#1 := Lit(jm#0); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1))
         && JournalistModel.__default.setFront($LS($ly), Lit(jm#0), Lit(jr#0))
           == (var dt_update_tmp#1#1 := Lit(jm#0); 
            (var dt_update#journalFront#1#1 := Lit(#Options.Option.Some($Box(Lit(jr#0)))); 
              Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                  Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#1)), 
                  dt_update#journalFront#1#1, 
                  Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1)))))));

// function declaration for JournalistModel._default.setBack
function JournalistModel.__default.setBack($ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box) : DatatypeType;

function JournalistModel.__default.setBack#canCall(jm#0: DatatypeType, jr#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
  { JournalistModel.__default.setBack($LS($ly), jm#0, jr#0) } 
  JournalistModel.__default.setBack($LS($ly), jm#0, jr#0)
     == JournalistModel.__default.setBack($ly, jm#0, jr#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
  { JournalistModel.__default.setBack(AsFuelBottom($ly), jm#0, jr#0) } 
  JournalistModel.__default.setBack($ly, jm#0, jr#0)
     == JournalistModel.__default.setBack($LZ, jm#0, jr#0));

// consequence axiom for JournalistModel.__default.setBack
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
    { JournalistModel.__default.setBack($ly, jm#0, jr#0) } 
    JournalistModel.__default.setBack#canCall(jm#0, jr#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          JournalistModel.__default.Inv(jm#0)
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(jr#0, i#0)): Seq Box } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(jr#0)
               ==> Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064))
           && Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> JournalistModel.__default.Inv(JournalistModel.__default.setBack($ly, jm#0, jr#0))
         && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(JournalistModel.__default.setBack($ly, jm#0, jr#0)), 
          (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
            (var dt_update#journalBack#0#0 := #Options.Option.Some($Box(jr#0)); 
              #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.replayJournal(dt_update_tmp#0#0), 
                JournalistModel.JournalInfo.journalFront(dt_update_tmp#0#0), 
                dt_update#journalBack#0#0, 
                JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#0#0)))))
         && $Is(JournalistModel.__default.setBack($ly, jm#0, jr#0), 
          Tclass.JournalistModel.JournalistModel()));

function JournalistModel.__default.setBack#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for JournalistModel.__default.setBack
axiom (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
  { JournalistModel.__default.setBack#requires($ly, jm#0, jr#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
       && $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalistModel.__default.setBack#requires($ly, jm#0, jr#0)
       == (
        JournalistModel.__default.Inv(jm#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
             ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064))
         && Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalistModel.__default.setBack(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
    { JournalistModel.__default.setBack($LS($ly), jm#0, jr#0) } 
    JournalistModel.__default.setBack#canCall(jm#0, jr#0)
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          JournalistModel.__default.Inv(jm#0)
           && (forall i#1: int :: 
            { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
               ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064))
           && Seq#Length(jr#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (var dt_update_tmp#1#0 := jm#0; 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#0))
         && JournalistModel.__default.setBack($LS($ly), jm#0, jr#0)
           == (var dt_update_tmp#1#0 := jm#0; 
            (var dt_update#journalBack#1#0 := #Options.Option.Some($Box(jr#0)); 
              #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.start(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.len1(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.len2(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#0), 
                dt_update#journalBack#1#0, 
                JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#0), 
                JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#0)))));

// definition axiom for JournalistModel.__default.setBack for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType, jr#0: Seq Box :: 
    {:weight 3} { JournalistModel.__default.setBack($LS($ly), Lit(jm#0), Lit(jr#0)) } 
    JournalistModel.__default.setBack#canCall(Lit(jm#0), Lit(jr#0))
         || (
          $Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          Lit(JournalistModel.__default.Inv(Lit(jm#0)))
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(jr#0, i#2)): Seq Box } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(jr#0))
               ==> Seq#Length($Unbox(Seq#Index(Lit(jr#0), i#2)): Seq Box) == LitInt(4064))
           && Seq#Length(Lit(jr#0)) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (var dt_update_tmp#1#1 := Lit(jm#0); 
          JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1)
             && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#1#1))
         && JournalistModel.__default.setBack($LS($ly), Lit(jm#0), Lit(jr#0))
           == (var dt_update_tmp#1#1 := Lit(jm#0); 
            (var dt_update#journalBack#1#1 := Lit(#Options.Option.Some($Box(Lit(jr#0)))); 
              Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#1#1)), 
                  Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#1#1)), 
                  Lit(JournalistModel.JournalistModel.journalFront(dt_update_tmp#1#1)), 
                  dt_update#journalBack#1#1, 
                  LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#1#1)), 
                  LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#1#1)))))));

// function declaration for JournalistModel._default.parseJournals
function JournalistModel.__default.parseJournals($ly: LayerType, jm#0: DatatypeType) : DatatypeType;

function JournalistModel.__default.parseJournals#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.parseJournals($LS($ly), jm#0) } 
  JournalistModel.__default.parseJournals($LS($ly), jm#0)
     == JournalistModel.__default.parseJournals($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.parseJournals(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.parseJournals($ly, jm#0)
     == JournalistModel.__default.parseJournals($LZ, jm#0));

// consequence axiom for JournalistModel.__default.parseJournals
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.parseJournals($ly, jm#0) } 
    JournalistModel.__default.parseJournals#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> (var jm'#0, success#0 := $Unbox(_System.Tuple2._0(JournalistModel.__default.parseJournals($ly, jm#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(JournalistModel.__default.parseJournals($ly, jm#0))): bool; 
          JournalistModel.__default.Inv(jm'#0)
             && (!success#0
               ==> JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(jm#0), JournalistModel.__default.I(jm'#0)))
             && (success#0
               ==> (var fullRange#0 := Seq#Append((if Options.Option.Some_q(JournalistModel.JournalInfo.journalFront(JournalistModel.__default.I(jm#0)))
                       then $Unbox(Options.Option.value(JournalistModel.JournalInfo.journalFront(JournalistModel.__default.I(jm#0)))): Seq Box
                       else Seq#Empty(): Seq Box), 
                    (if Options.Option.Some_q(JournalistModel.JournalInfo.journalBack(JournalistModel.__default.I(jm#0)))
                       then $Unbox(Options.Option.value(JournalistModel.JournalInfo.journalBack(JournalistModel.__default.I(jm#0)))): Seq Box
                       else Seq#Empty(): Seq Box)); 
                Options.Option.Some_q(JournalRanges.__default.parseJournalRange($LS($LZ), fullRange#0))
                   && JournalistModel.JournalInfo#Equal(JournalistModel.__default.I(jm'#0), 
                    (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := JournalistModel.__default.I(jm#0); 
                              (var dt_update#journalFront#0#0 := Lit(#Options.Option.None()); 
                                #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                  JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#0#0), 
                                  JournalistModel.JournalInfo.replayJournal(dt_update_tmp#0#0), 
                                  dt_update#journalFront#0#0, 
                                  JournalistModel.JournalInfo.journalBack(dt_update_tmp#0#0), 
                                  JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#0#0)))); 
                          (var dt_update#journalBack#0#0 := Lit(#Options.Option.None()); 
                            #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                              JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#1#0), 
                              JournalistModel.JournalInfo.replayJournal(dt_update_tmp#1#0), 
                              JournalistModel.JournalInfo.journalFront(dt_update_tmp#1#0), 
                              dt_update#journalBack#0#0, 
                              JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#1#0)))); 
                      (var dt_update#replayJournal#0#0 := $Unbox(Options.Option.value(JournalRanges.__default.parseJournalRange($LS($LZ), fullRange#0))): Seq Box; 
                        #JournalistModel.JournalInfo.JournalInfo(JournalistModel.JournalInfo.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                          JournalistModel.JournalInfo.inMemoryJournal(dt_update_tmp#2#0), 
                          dt_update#replayJournal#0#0, 
                          JournalistModel.JournalInfo.journalFront(dt_update_tmp#2#0), 
                          JournalistModel.JournalInfo.journalBack(dt_update_tmp#2#0), 
                          JournalistModel.JournalInfo.writtenJournalLen(dt_update_tmp#2#0))))))))
         && $Is(JournalistModel.__default.parseJournals($ly, jm#0), 
          Tclass._System.Tuple2(Tclass.JournalistModel.JournalistModel(), TBool)));

function JournalistModel.__default.parseJournals#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.parseJournals
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.parseJournals#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.parseJournals#requires($ly, jm#0)
       == JournalistModel.__default.Inv(jm#0));

// definition axiom for JournalistModel.__default.parseJournals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.parseJournals($LS($ly), jm#0) } 
    JournalistModel.__default.parseJournals#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && (Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0))
         && 
        JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && (Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0))
           ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0))
         && (var fullRange#1 := Seq#Append((if Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0))
                 then $Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box
                 else Seq#Empty(): Seq Box), 
              (if Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0))
                 then $Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box
                 else Seq#Empty(): Seq Box)); 
          JournalRanges.__default.parseJournalRange#canCall(fullRange#1)
             && (var p#0 := JournalRanges.__default.parseJournalRange($LS($LZ), fullRange#1); 
              (Options.Option.Some_q(p#0)
                   ==> JournalistModel.__default.MaxPossibleEntries#canCall())
                 && (Options.Option.Some_q(p#0)
                     && Seq#Length($Unbox(Options.Option.value(p#0)): Seq Box)
                       <= LitInt(JournalistModel.__default.MaxPossibleEntries())
                   ==> (var dt_update_tmp#3#0 := jm#0; 
                      JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#0))
                     && (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := jm#0; 
                          (var dt_update#journalFront#1#0 := Lit(#Options.Option.None()); 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                              dt_update#journalFront#1#0, 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
                      JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#0))
                     && (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := jm#0; 
                              (var dt_update#journalFront#1#0 := Lit(#Options.Option.None()); 
                                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                                  JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                                  JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                                  JournalistModel.JournalistModel.len2(dt_update_tmp#3#0), 
                                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                                  dt_update#journalFront#1#0, 
                                  JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
                          (var dt_update#journalBack#1#0 := Lit(#Options.Option.None()); 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                              JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                              JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                              dt_update#journalBack#1#0, 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#0), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#0)))); 
                      JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#0))
                     && (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := jm#0; 
                                  (var dt_update#journalFront#1#0 := Lit(#Options.Option.None()); 
                                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.len2(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                                      dt_update#journalFront#1#0, 
                                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
                              (var dt_update#journalBack#1#0 := Lit(#Options.Option.None()); 
                                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                                  dt_update#journalBack#1#0, 
                                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#0)))); 
                          (var dt_update#replayJournal#1#0 := $Unbox(Options.Option.value(p#0)): Seq Box; 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.start(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#5#0), 
                              dt_update#replayJournal#1#0, 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#5#0)))); 
                      JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#0)))))
         && JournalistModel.__default.parseJournals($LS($ly), jm#0)
           == (var fullRange#1 := Seq#Append((if Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0))
                   then $Unbox(Options.Option.value(JournalistModel.JournalistModel.journalFront(jm#0))): Seq Box
                   else Seq#Empty(): Seq Box), 
                (if Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0))
                   then $Unbox(Options.Option.value(JournalistModel.JournalistModel.journalBack(jm#0))): Seq Box
                   else Seq#Empty(): Seq Box)); 
            (var p#0 := JournalRanges.__default.parseJournalRange($LS($LZ), fullRange#1); 
              (if Options.Option.Some_q(p#0)
                   && Seq#Length($Unbox(Options.Option.value(p#0)): Seq Box)
                     <= LitInt(JournalistModel.__default.MaxPossibleEntries())
                 then (var jm'#1 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := jm#0; 
                                  (var dt_update#journalFront#1#0 := Lit(#Options.Option.None()); 
                                    #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.start(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.len1(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.len2(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#0), 
                                      dt_update#journalFront#1#0, 
                                      JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#0), 
                                      JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#0)))); 
                              (var dt_update#journalBack#1#0 := Lit(#Options.Option.None()); 
                                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.start(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.len1(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.len2(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#0), 
                                  dt_update#journalBack#1#0, 
                                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#0), 
                                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#0)))); 
                          (var dt_update#replayJournal#1#0 := $Unbox(Options.Option.value(p#0)): Seq Box; 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.start(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#5#0), 
                              dt_update#replayJournal#1#0, 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#0), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#5#0)))); 
                      (var dt_update#replayIdx#0#0 := LitInt(0); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#6#0), 
                          JournalistModel.JournalistModel.start(dt_update_tmp#6#0), 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#6#0), 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#6#0), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#6#0), 
                          dt_update#replayIdx#0#0, 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#6#0), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#6#0), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#6#0), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#6#0), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#6#0)))); 
                  #_System._tuple#2._#Make2($Box(jm'#1), $Box(Lit(true))))
                 else #_System._tuple#2._#Make2($Box(jm#0), $Box(Lit(false)))))));

// definition axiom for JournalistModel.__default.parseJournals for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.parseJournals($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.parseJournals#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.Inv(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && (Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0)))))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
         && 
        JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && (Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0)))))
           ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0)))
         && (var fullRange#2 := Seq#Append((if Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))
                 then $Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))): Seq Box
                 else Seq#Empty(): Seq Box), 
              (if Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))
                 then $Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))): Seq Box
                 else Seq#Empty(): Seq Box)); 
          JournalRanges.__default.parseJournalRange#canCall(fullRange#2)
             && (var p#1 := JournalRanges.__default.parseJournalRange($LS($LZ), fullRange#2); 
              (Options.Option.Some_q(p#1)
                   ==> JournalistModel.__default.MaxPossibleEntries#canCall())
                 && (Options.Option.Some_q(p#1)
                     && Seq#Length($Unbox(Options.Option.value(p#1)): Seq Box)
                       <= LitInt(JournalistModel.__default.MaxPossibleEntries())
                   ==> (var dt_update_tmp#3#1 := Lit(jm#0); 
                      JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#3#1))
                     && (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := Lit(jm#0); 
                          (var dt_update#journalFront#1#1 := Lit(#Options.Option.None()); 
                            Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1)), 
                                LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#3#1)), 
                                LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#3#1)), 
                                LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#3#1)), 
                                Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1)), 
                                LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1)), 
                                dt_update#journalFront#1#1, 
                                Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1)), 
                                LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1)), 
                                LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1)), 
                                LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))))); 
                      JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#4#1))
                     && (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := Lit(jm#0); 
                              (var dt_update#journalFront#1#1 := Lit(#Options.Option.None()); 
                                Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1)), 
                                    LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#3#1)), 
                                    LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#3#1)), 
                                    LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#3#1)), 
                                    Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1)), 
                                    LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1)), 
                                    dt_update#journalFront#1#1, 
                                    Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1)), 
                                    LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1)), 
                                    LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1)), 
                                    LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))))); 
                          (var dt_update#journalBack#1#1 := Lit(#Options.Option.None()); 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                              JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                              JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                              dt_update#journalBack#1#1, 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#1), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#1)))); 
                      JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#5#1))
                     && (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := Lit(jm#0); 
                                  (var dt_update#journalFront#1#1 := Lit(#Options.Option.None()); 
                                    Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#3#1)), 
                                        Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1)), 
                                        dt_update#journalFront#1#1, 
                                        Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))))); 
                              (var dt_update#journalBack#1#1 := Lit(#Options.Option.None()); 
                                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                                  dt_update#journalBack#1#1, 
                                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#1)))); 
                          (var dt_update#replayJournal#1#1 := $Unbox(Options.Option.value(p#1)): Seq Box; 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.start(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#5#1), 
                              dt_update#replayJournal#1#1, 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#5#1)))); 
                      JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)
                         && JournalistModel.JournalistModel.JournalistModel_q(dt_update_tmp#6#1)))))
         && JournalistModel.__default.parseJournals($LS($ly), Lit(jm#0))
           == (var fullRange#2 := Seq#Append((if Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))
                   then $Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))): Seq Box
                   else Seq#Empty(): Seq Box), 
                (if Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))
                   then $Unbox(Options.Option.value(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))): Seq Box
                   else Seq#Empty(): Seq Box)); 
            (var p#1 := JournalRanges.__default.parseJournalRange($LS($LZ), fullRange#2); 
              (if Options.Option.Some_q(p#1)
                   && Seq#Length($Unbox(Options.Option.value(p#1)): Seq Box)
                     <= LitInt(JournalistModel.__default.MaxPossibleEntries())
                 then (var jm'#2 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := Lit(jm#0); 
                                  (var dt_update#journalFront#1#1 := Lit(#Options.Option.None()); 
                                    Lit(#JournalistModel.JournalistModel.JournalistModel(Lit(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.start(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.len1(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.len2(dt_update_tmp#3#1)), 
                                        Lit(JournalistModel.JournalistModel.replayJournal(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.replayIdx(dt_update_tmp#3#1)), 
                                        dt_update#journalFront#1#1, 
                                        Lit(JournalistModel.JournalistModel.journalBack(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#3#1)), 
                                        LitInt(JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#3#1)))))); 
                              (var dt_update#journalBack#1#1 := Lit(#Options.Option.None()); 
                                #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.start(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.len1(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.len2(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.replayJournal(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.replayIdx(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.journalFront(dt_update_tmp#4#1), 
                                  dt_update#journalBack#1#1, 
                                  JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#4#1), 
                                  JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#4#1)))); 
                          (var dt_update#replayJournal#1#1 := $Unbox(Options.Option.value(p#1)): Seq Box; 
                            #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.start(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.len1(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.len2(dt_update_tmp#5#1), 
                              dt_update#replayJournal#1#1, 
                              JournalistModel.JournalistModel.replayIdx(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.journalFront(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.journalBack(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#5#1), 
                              JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#5#1)))); 
                      (var dt_update#replayIdx#0#1 := LitInt(0); 
                        #JournalistModel.JournalistModel.JournalistModel(JournalistModel.JournalistModel.journalEntries(dt_update_tmp#6#1), 
                          JournalistModel.JournalistModel.start(dt_update_tmp#6#1), 
                          JournalistModel.JournalistModel.len1(dt_update_tmp#6#1), 
                          JournalistModel.JournalistModel.len2(dt_update_tmp#6#1), 
                          JournalistModel.JournalistModel.replayJournal(dt_update_tmp#6#1), 
                          dt_update#replayIdx#0#1, 
                          JournalistModel.JournalistModel.journalFront(dt_update_tmp#6#1), 
                          JournalistModel.JournalistModel.journalBack(dt_update_tmp#6#1), 
                          JournalistModel.JournalistModel.writtenJournalBlocks(dt_update_tmp#6#1), 
                          JournalistModel.JournalistModel.frozenJournalBlocks(dt_update_tmp#6#1), 
                          JournalistModel.JournalistModel.inMemoryWeight(dt_update_tmp#6#1)))); 
                  #_System._tuple#2._#Make2($Box(jm'#2), $Box(Lit(true))))
                 else #_System._tuple#2._#Make2($Box(Lit(jm#0)), $Box(Lit(false)))))));

// function declaration for JournalistModel._default.hasFront
function JournalistModel.__default.hasFront($ly: LayerType, jm#0: DatatypeType) : bool;

function JournalistModel.__default.hasFront#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasFront($LS($ly), jm#0) } 
  JournalistModel.__default.hasFront($LS($ly), jm#0)
     == JournalistModel.__default.hasFront($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasFront(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.hasFront($ly, jm#0)
     == JournalistModel.__default.hasFront($LZ, jm#0));

// consequence axiom for JournalistModel.__default.hasFront
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.hasFront($ly, jm#0) } 
    JournalistModel.__default.hasFront#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.__default.hasFront($ly, jm#0)
         == Options.Option.Some_q(JournalistModel.JournalInfo.journalFront(JournalistModel.__default.I(jm#0))));

function JournalistModel.__default.hasFront#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.hasFront
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasFront#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.hasFront#requires($ly, jm#0)
       == JournalistModel.__default.Inv(jm#0));

// definition axiom for JournalistModel.__default.hasFront(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.hasFront($LS($ly), jm#0) } 
    JournalistModel.__default.hasFront#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.hasFront($LS($ly), jm#0)
           == Options.Option.Some_q(JournalistModel.JournalistModel.journalFront(jm#0)));

// definition axiom for JournalistModel.__default.hasFront for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.hasFront($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.hasFront#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.Inv(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.hasFront($LS($ly), Lit(jm#0))
           == Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalFront(Lit(jm#0))))));

// function declaration for JournalistModel._default.hasBack
function JournalistModel.__default.hasBack($ly: LayerType, jm#0: DatatypeType) : bool;

function JournalistModel.__default.hasBack#canCall(jm#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasBack($LS($ly), jm#0) } 
  JournalistModel.__default.hasBack($LS($ly), jm#0)
     == JournalistModel.__default.hasBack($ly, jm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasBack(AsFuelBottom($ly), jm#0) } 
  JournalistModel.__default.hasBack($ly, jm#0)
     == JournalistModel.__default.hasBack($LZ, jm#0));

// consequence axiom for JournalistModel.__default.hasBack
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.hasBack($ly, jm#0) } 
    JournalistModel.__default.hasBack#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.__default.hasBack($ly, jm#0)
         == Options.Option.Some_q(JournalistModel.JournalInfo.journalBack(JournalistModel.__default.I(jm#0))));

function JournalistModel.__default.hasBack#requires(LayerType, DatatypeType) : bool;

// #requires axiom for JournalistModel.__default.hasBack
axiom (forall $ly: LayerType, jm#0: DatatypeType :: 
  { JournalistModel.__default.hasBack#requires($ly, jm#0) } 
  $Is(jm#0, Tclass.JournalistModel.JournalistModel())
     ==> JournalistModel.__default.hasBack#requires($ly, jm#0)
       == JournalistModel.__default.Inv(jm#0));

// definition axiom for JournalistModel.__default.hasBack(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    { JournalistModel.__default.hasBack($LS($ly), jm#0) } 
    JournalistModel.__default.hasBack#canCall(jm#0)
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && JournalistModel.__default.Inv(jm#0))
       ==> JournalistModel.JournalistModel.JournalistModel_q(jm#0)
         && JournalistModel.__default.hasBack($LS($ly), jm#0)
           == Options.Option.Some_q(JournalistModel.JournalistModel.journalBack(jm#0)));

// definition axiom for JournalistModel.__default.hasBack for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jm#0: DatatypeType :: 
    {:weight 3} { JournalistModel.__default.hasBack($LS($ly), Lit(jm#0)) } 
    JournalistModel.__default.hasBack#canCall(Lit(jm#0))
         || ($Is(jm#0, Tclass.JournalistModel.JournalistModel())
           && Lit(JournalistModel.__default.Inv(Lit(jm#0))))
       ==> JournalistModel.JournalistModel.JournalistModel_q(Lit(jm#0))
         && JournalistModel.__default.hasBack($LS($ly), Lit(jm#0))
           == Lit(Options.Option.Some_q(Lit(JournalistModel.JournalistModel.journalBack(Lit(jm#0))))));

procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__JournalistConstructor();
  free requires 47 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.JournalistConstructor0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__JournalistConstructor();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.JournalistConstructor
     == $LS(MoreFuel_JournalistModel._default.JournalistConstructor0);
  free ensures StartFuelAssert_JournalistModel._default.JournalistConstructor
     == $LS($LS(MoreFuel_JournalistModel._default.JournalistConstructor0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.JournalistConstructor0)
     == MoreFuel_JournalistModel._default.JournalistConstructor0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__hasFrozenJournal();
  free requires 48 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.hasFrozenJournal0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__hasFrozenJournal();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.hasFrozenJournal
     == $LS(MoreFuel_JournalistModel._default.hasFrozenJournal0);
  free ensures StartFuelAssert_JournalistModel._default.hasFrozenJournal
     == $LS($LS(MoreFuel_JournalistModel._default.hasFrozenJournal0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.hasFrozenJournal0)
     == MoreFuel_JournalistModel._default.hasFrozenJournal0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__hasInMemoryJournal();
  free requires 49 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.hasInMemoryJournal0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__hasInMemoryJournal();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.hasInMemoryJournal
     == $LS(MoreFuel_JournalistModel._default.hasInMemoryJournal0);
  free ensures StartFuelAssert_JournalistModel._default.hasInMemoryJournal
     == $LS($LS(MoreFuel_JournalistModel._default.hasInMemoryJournal0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.hasInMemoryJournal0)
     == MoreFuel_JournalistModel._default.hasInMemoryJournal0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__packageFrozenJournal();
  free requires 50 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.packageFrozenJournal0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__packageFrozenJournal();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.packageFrozenJournal
     == $LS(MoreFuel_JournalistModel._default.packageFrozenJournal0);
  free ensures StartFuelAssert_JournalistModel._default.packageFrozenJournal
     == $LS($LS(MoreFuel_JournalistModel._default.packageFrozenJournal0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.packageFrozenJournal0)
     == MoreFuel_JournalistModel._default.packageFrozenJournal0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__packageInMemoryJournal();
  free requires 51 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.packageInMemoryJournal0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__packageInMemoryJournal();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.packageInMemoryJournal
     == $LS(MoreFuel_JournalistModel._default.packageInMemoryJournal0);
  free ensures StartFuelAssert_JournalistModel._default.packageInMemoryJournal
     == $LS($LS(MoreFuel_JournalistModel._default.packageInMemoryJournal0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.packageInMemoryJournal0)
     == MoreFuel_JournalistModel._default.packageInMemoryJournal0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__freeze();
  free requires 52 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.freeze0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__freeze();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.freeze
     == $LS(MoreFuel_JournalistModel._default.freeze0);
  free ensures StartFuelAssert_JournalistModel._default.freeze
     == $LS($LS(MoreFuel_JournalistModel._default.freeze0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.freeze0)
     == MoreFuel_JournalistModel._default.freeze0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__canAppend();
  free requires 37 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.canAppend0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__canAppend();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.canAppend
     == $LS(MoreFuel_JournalistModel._default.canAppend0);
  free ensures StartFuelAssert_JournalistModel._default.canAppend
     == $LS($LS(MoreFuel_JournalistModel._default.canAppend0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.canAppend0)
     == MoreFuel_JournalistModel._default.canAppend0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__append();
  free requires 53 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.append0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__append();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.append
     == $LS(MoreFuel_JournalistModel._default.append0);
  free ensures StartFuelAssert_JournalistModel._default.append
     == $LS($LS(MoreFuel_JournalistModel._default.append0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.append0)
     == MoreFuel_JournalistModel._default.append0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__isReplayEmpty();
  free requires 54 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.isReplayEmpty0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__isReplayEmpty();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.isReplayEmpty
     == $LS(MoreFuel_JournalistModel._default.isReplayEmpty0);
  free ensures StartFuelAssert_JournalistModel._default.isReplayEmpty
     == $LS($LS(MoreFuel_JournalistModel._default.isReplayEmpty0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.isReplayEmpty0)
     == MoreFuel_JournalistModel._default.isReplayEmpty0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__replayJournalTop();
  free requires 55 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.replayJournalTop0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__replayJournalTop();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.replayJournalTop
     == $LS(MoreFuel_JournalistModel._default.replayJournalTop0);
  free ensures StartFuelAssert_JournalistModel._default.replayJournalTop
     == $LS($LS(MoreFuel_JournalistModel._default.replayJournalTop0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.replayJournalTop0)
     == MoreFuel_JournalistModel._default.replayJournalTop0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__replayJournalPop();
  free requires 56 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.replayJournalPop0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__replayJournalPop();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.replayJournalPop
     == $LS(MoreFuel_JournalistModel._default.replayJournalPop0);
  free ensures StartFuelAssert_JournalistModel._default.replayJournalPop
     == $LS($LS(MoreFuel_JournalistModel._default.replayJournalPop0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.replayJournalPop0)
     == MoreFuel_JournalistModel._default.replayJournalPop0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__setFront();
  free requires 57 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.setFront0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__setFront();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.setFront
     == $LS(MoreFuel_JournalistModel._default.setFront0);
  free ensures StartFuelAssert_JournalistModel._default.setFront
     == $LS($LS(MoreFuel_JournalistModel._default.setFront0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.setFront0)
     == MoreFuel_JournalistModel._default.setFront0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__setBack();
  free requires 58 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.setBack0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__setBack();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.setBack
     == $LS(MoreFuel_JournalistModel._default.setBack0);
  free ensures StartFuelAssert_JournalistModel._default.setBack
     == $LS($LS(MoreFuel_JournalistModel._default.setBack0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.setBack0)
     == MoreFuel_JournalistModel._default.setBack0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__parseJournals();
  free requires 59 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.parseJournals0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__parseJournals();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.parseJournals
     == $LS(MoreFuel_JournalistModel._default.parseJournals0);
  free ensures StartFuelAssert_JournalistModel._default.parseJournals
     == $LS($LS(MoreFuel_JournalistModel._default.parseJournals0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.parseJournals0)
     == MoreFuel_JournalistModel._default.parseJournals0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__hasFront();
  free requires 60 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.hasFront0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__hasFront();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.hasFront
     == $LS(MoreFuel_JournalistModel._default.hasFront0);
  free ensures StartFuelAssert_JournalistModel._default.hasFront
     == $LS($LS(MoreFuel_JournalistModel._default.hasFront0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.hasFront0)
     == MoreFuel_JournalistModel._default.hasFront0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalistModel.__default.reveal__hasBack();
  free requires 61 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalistModel._default.hasBack0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalistModel.__default.reveal__hasBack();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalistModel._default.hasBack
     == $LS(MoreFuel_JournalistModel._default.hasBack0);
  free ensures StartFuelAssert_JournalistModel._default.hasBack
     == $LS($LS(MoreFuel_JournalistModel._default.hasBack0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalistModel._default.hasBack0)
     == MoreFuel_JournalistModel._default.hasBack0;



const unique field$journalEntries: NameFamily;

const unique field$start: NameFamily;

const unique field$len1: NameFamily;

const unique field$len2: NameFamily;

const unique field$replayJournal: NameFamily;

const unique field$replayIdx: NameFamily;

const unique field$journalFront: NameFamily;

const unique field$journalBack: NameFamily;

const unique field$writtenJournalBlocks: NameFamily;

const unique field$frozenJournalBlocks: NameFamily;

const unique field$inMemoryWeight: NameFamily;

const unique field$Repr: NameFamily;
