// Dafny 2.3.0.10506
// Command Line Options: /compile:0 /timeLimit:1 /print:boogies/Impl-JournalistParsingImpl.i.dfy.bpl /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type Ty;

type Bv0 = int;

const unique TBool: Ty;

const unique TChar: Ty;

const unique TInt: Ty;

const unique TReal: Ty;

const unique TORDINAL: Ty;

function TBitvector(int) : Ty;

function TSet(Ty) : Ty;

function TISet(Ty) : Ty;

function TMultiSet(Ty) : Ty;

function TSeq(Ty) : Ty;

function TMap(Ty, Ty) : Ty;

function TIMap(Ty, Ty) : Ty;

function Inv0_TBitvector(Ty) : int;

axiom (forall w: int :: { TBitvector(w) } Inv0_TBitvector(TBitvector(w)) == w);

function Inv0_TSet(Ty) : Ty;

axiom (forall t: Ty :: { TSet(t) } Inv0_TSet(TSet(t)) == t);

function Inv0_TISet(Ty) : Ty;

axiom (forall t: Ty :: { TISet(t) } Inv0_TISet(TISet(t)) == t);

function Inv0_TSeq(Ty) : Ty;

axiom (forall t: Ty :: { TSeq(t) } Inv0_TSeq(TSeq(t)) == t);

function Inv0_TMultiSet(Ty) : Ty;

axiom (forall t: Ty :: { TMultiSet(t) } Inv0_TMultiSet(TMultiSet(t)) == t);

function Inv0_TMap(Ty) : Ty;

function Inv1_TMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv0_TMap(TMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv1_TMap(TMap(t, u)) == u);

function Inv0_TIMap(Ty) : Ty;

function Inv1_TIMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv0_TIMap(TIMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv1_TIMap(TIMap(t, u)) == u);

type TyTag;

function Tag(Ty) : TyTag;

const unique TagBool: TyTag;

const unique TagChar: TyTag;

const unique TagInt: TyTag;

const unique TagReal: TyTag;

const unique TagORDINAL: TyTag;

const unique TagSet: TyTag;

const unique TagISet: TyTag;

const unique TagMultiSet: TyTag;

const unique TagSeq: TyTag;

const unique TagMap: TyTag;

const unique TagIMap: TyTag;

const unique TagClass: TyTag;

axiom Tag(TBool) == TagBool;

axiom Tag(TChar) == TagChar;

axiom Tag(TInt) == TagInt;

axiom Tag(TReal) == TagReal;

axiom Tag(TORDINAL) == TagORDINAL;

axiom (forall t: Ty :: { TSet(t) } Tag(TSet(t)) == TagSet);

axiom (forall t: Ty :: { TISet(t) } Tag(TISet(t)) == TagISet);

axiom (forall t: Ty :: { TMultiSet(t) } Tag(TMultiSet(t)) == TagMultiSet);

axiom (forall t: Ty :: { TSeq(t) } Tag(TSeq(t)) == TagSeq);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Tag(TMap(t, u)) == TagMap);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Tag(TIMap(t, u)) == TagIMap);

function {:identity} Lit<T>(x: T) : T;

axiom (forall<T> x: T :: {:identity} { Lit(x): T } Lit(x): T == x);

axiom (forall<T> x: T :: { $Box(Lit(x)) } $Box(Lit(x)) == Lit($Box(x)));

function {:identity} LitInt(x: int) : int;

axiom (forall x: int :: {:identity} { LitInt(x): int } LitInt(x): int == x);

axiom (forall x: int :: { $Box(LitInt(x)) } $Box(LitInt(x)) == Lit($Box(x)));

function {:identity} LitReal(x: real) : real;

axiom (forall x: real :: {:identity} { LitReal(x): real } LitReal(x): real == x);

axiom (forall x: real :: { $Box(LitReal(x)) } $Box(LitReal(x)) == Lit($Box(x)));

type char;

function char#FromInt(int) : char;

function char#ToInt(char) : int;

axiom (forall ch: char :: 
  { char#ToInt(ch) } 
  char#FromInt(char#ToInt(ch)) == ch
     && 0 <= char#ToInt(ch)
     && char#ToInt(ch) < 65536);

axiom (forall n: int :: 
  { char#FromInt(n) } 
  0 <= n && n < 65536 ==> char#ToInt(char#FromInt(n)) == n);

function char#Plus(char, char) : char;

function char#Minus(char, char) : char;

axiom (forall a: char, b: char :: 
  { char#Plus(a, b) } 
  char#Plus(a, b) == char#FromInt(char#ToInt(a) + char#ToInt(b)));

axiom (forall a: char, b: char :: 
  { char#Minus(a, b) } 
  char#Minus(a, b) == char#FromInt(char#ToInt(a) - char#ToInt(b)));

type ref;

const null: ref;

function IsTraitParent(classOrTrait: ClassName, traitParent: ClassName) : bool;

type Box;

const $ArbitraryBoxValue: Box;

function $Box<T>(T) : Box;

function $Unbox<T>(Box) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall bx: Box :: 
  { $IsBox(bx, TInt) } 
  $IsBox(bx, TInt) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, TInt));

axiom (forall bx: Box :: 
  { $IsBox(bx, TReal) } 
  $IsBox(bx, TReal)
     ==> $Box($Unbox(bx): real) == bx && $Is($Unbox(bx): real, TReal));

axiom (forall bx: Box :: 
  { $IsBox(bx, TBool) } 
  $IsBox(bx, TBool)
     ==> $Box($Unbox(bx): bool) == bx && $Is($Unbox(bx): bool, TBool));

axiom (forall bx: Box :: 
  { $IsBox(bx, TChar) } 
  $IsBox(bx, TChar)
     ==> $Box($Unbox(bx): char) == bx && $Is($Unbox(bx): char, TChar));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSet(t)) } 
  $IsBox(bx, TSet(t))
     ==> $Box($Unbox(bx): Set Box) == bx && $Is($Unbox(bx): Set Box, TSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TISet(t)) } 
  $IsBox(bx, TISet(t))
     ==> $Box($Unbox(bx): ISet Box) == bx && $Is($Unbox(bx): ISet Box, TISet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TMultiSet(t)) } 
  $IsBox(bx, TMultiSet(t))
     ==> $Box($Unbox(bx): MultiSet Box) == bx
       && $Is($Unbox(bx): MultiSet Box, TMultiSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSeq(t)) } 
  $IsBox(bx, TSeq(t))
     ==> $Box($Unbox(bx): Seq Box) == bx && $Is($Unbox(bx): Seq Box, TSeq(t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TMap(s, t)) } 
  $IsBox(bx, TMap(s, t))
     ==> $Box($Unbox(bx): Map Box Box) == bx && $Is($Unbox(bx): Map Box Box, TMap(s, t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TIMap(s, t)) } 
  $IsBox(bx, TIMap(s, t))
     ==> $Box($Unbox(bx): IMap Box Box) == bx
       && $Is($Unbox(bx): IMap Box Box, TIMap(s, t)));

axiom (forall<T> v: T, t: Ty :: 
  { $IsBox($Box(v), t) } 
  $IsBox($Box(v), t) <==> $Is(v, t));

axiom (forall<T> v: T, t: Ty, h: Heap :: 
  { $IsAllocBox($Box(v), t, h) } 
  $IsAllocBox($Box(v), t, h) <==> $IsAlloc(v, t, h));

function $Is<T>(T, Ty) : bool;

function $IsAlloc<T>(T, Ty, Heap) : bool;

function $IsBox<T>(T, Ty) : bool;

function $IsAllocBox<T>(T, Ty, Heap) : bool;

axiom (forall v: int :: { $Is(v, TInt) } $Is(v, TInt));

axiom (forall v: real :: { $Is(v, TReal) } $Is(v, TReal));

axiom (forall v: bool :: { $Is(v, TBool) } $Is(v, TBool));

axiom (forall v: char :: { $Is(v, TChar) } $Is(v, TChar));

axiom (forall v: ORDINAL :: { $Is(v, TORDINAL) } $Is(v, TORDINAL));

axiom (forall h: Heap, v: int :: { $IsAlloc(v, TInt, h) } $IsAlloc(v, TInt, h));

axiom (forall h: Heap, v: real :: { $IsAlloc(v, TReal, h) } $IsAlloc(v, TReal, h));

axiom (forall h: Heap, v: bool :: { $IsAlloc(v, TBool, h) } $IsAlloc(v, TBool, h));

axiom (forall h: Heap, v: char :: { $IsAlloc(v, TChar, h) } $IsAlloc(v, TChar, h));

axiom (forall h: Heap, v: ORDINAL :: 
  { $IsAlloc(v, TORDINAL, h) } 
  $IsAlloc(v, TORDINAL, h));

axiom (forall v: Set Box, t0: Ty :: 
  { $Is(v, TSet(t0)) } 
  $Is(v, TSet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: ISet Box, t0: Ty :: 
  { $Is(v, TISet(t0)) } 
  $Is(v, TISet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0))
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0)) ==> $IsGoodMultiSet(v));

axiom (forall v: Seq Box, t0: Ty :: 
  { $Is(v, TSeq(t0)) } 
  $Is(v, TSeq(t0))
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsBox(Seq#Index(v, i), t0)));

axiom (forall v: Set Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSet(t0), h) } 
  $IsAlloc(v, TSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: ISet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TISet(t0), h) } 
  $IsAlloc(v, TISet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: MultiSet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TMultiSet(t0), h) } 
  $IsAlloc(v, TMultiSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: Seq Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSeq(t0), h) } 
  $IsAlloc(v, TSeq(t0), h)
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsAllocBox(Seq#Index(v, i), t0, h)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TMap(t0, t1)) } 
  $Is(v, TMap(t0, t1))
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx] ==> $IsBox(Map#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TMap(t0, t1), h) } 
  $IsAlloc(v, TMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx]
         ==> $IsAllocBox(Map#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TIMap(t0, t1)) } 
  $Is(v, TIMap(t0, t1))
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx] ==> $IsBox(IMap#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TIMap(t0, t1), h) } 
  $IsAlloc(v, TIMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx]
         ==> $IsAllocBox(IMap#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

type ClassName;

const unique class._System.int: ClassName;

const unique class._System.bool: ClassName;

const unique class._System.set: ClassName;

const unique class._System.seq: ClassName;

const unique class._System.multiset: ClassName;

function Tclass._System.object?() : Ty;

function dtype(ref) : Ty;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: 
  { TypeTuple(a, b) } 
  TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type HandleType;

function SetRef_to_SetBox(s: [ref]bool) : Set Box;

axiom (forall s: [ref]bool, bx: Box :: 
  { SetRef_to_SetBox(s)[bx] } 
  SetRef_to_SetBox(s)[bx] == s[$Unbox(bx): ref]);

axiom (forall s: [ref]bool :: 
  { SetRef_to_SetBox(s) } 
  $Is(SetRef_to_SetBox(s), TSet(Tclass._System.object?())));

function Apply1(Ty, Ty, Heap, HandleType, Box) : Box;

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

function BoxRank(Box) : int;

axiom (forall d: DatatypeType :: { BoxRank($Box(d)) } BoxRank($Box(d)) == DtRank(d));

type ORDINAL = Box;

function ORD#IsNat(ORDINAL) : bool;

function ORD#Offset(ORDINAL) : int;

axiom (forall o: ORDINAL :: { ORD#Offset(o) } 0 <= ORD#Offset(o));

function {:inline} ORD#IsLimit(o: ORDINAL) : bool
{
  ORD#Offset(o) == 0
}

function {:inline} ORD#IsSucc(o: ORDINAL) : bool
{
  0 < ORD#Offset(o)
}

function ORD#FromNat(int) : ORDINAL;

axiom (forall n: int :: 
  { ORD#FromNat(n) } 
  0 <= n ==> ORD#IsNat(ORD#FromNat(n)) && ORD#Offset(ORD#FromNat(n)) == n);

axiom (forall o: ORDINAL :: 
  { ORD#Offset(o) } { ORD#IsNat(o) } 
  ORD#IsNat(o) ==> o == ORD#FromNat(ORD#Offset(o)));

function ORD#Less(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p) } 
  (ORD#Less(o, p) ==> o != p)
     && (ORD#IsNat(o) && !ORD#IsNat(p) ==> ORD#Less(o, p))
     && (ORD#IsNat(o) && ORD#IsNat(p)
       ==> ORD#Less(o, p) == (ORD#Offset(o) < ORD#Offset(p)))
     && (ORD#Less(o, p) && ORD#IsNat(p) ==> ORD#IsNat(o)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, o) } 
  ORD#Less(o, p) || o == p || ORD#Less(p, o));

axiom (forall o: ORDINAL, p: ORDINAL, r: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, r) } { ORD#Less(o, p), ORD#Less(o, r) } 
  ORD#Less(o, p) && ORD#Less(p, r) ==> ORD#Less(o, r));

function ORD#LessThanLimit(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#LessThanLimit(o, p) } 
  ORD#LessThanLimit(o, p) == ORD#Less(o, p));

function ORD#Plus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (ORD#IsNat(ORD#Plus(o, p)) ==> ORD#IsNat(o) && ORD#IsNat(p))
     && (ORD#IsNat(p)
       ==> ORD#IsNat(ORD#Plus(o, p)) == ORD#IsNat(o)
         && ORD#Offset(ORD#Plus(o, p)) == ORD#Offset(o) + ORD#Offset(p)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#Plus(o, p) || ORD#Less(o, ORD#Plus(o, p)))
     && (p == ORD#Plus(o, p) || ORD#Less(p, ORD#Plus(o, p))));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#FromNat(0) ==> ORD#Plus(o, p) == p)
     && (p == ORD#FromNat(0) ==> ORD#Plus(o, p) == o));

function ORD#Minus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> ORD#IsNat(ORD#Minus(o, p)) == ORD#IsNat(o)
       && ORD#Offset(ORD#Minus(o, p)) == ORD#Offset(o) - ORD#Offset(p));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> (p == ORD#FromNat(0) && ORD#Minus(o, p) == o)
       || (p != ORD#FromNat(0) && ORD#Less(ORD#Minus(o, p), o)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n
     ==> ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Plus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && m + n <= ORD#Offset(o)
     ==> ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Minus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(n - m))));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(n - m))));

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

type LayerType;

const $LZ: LayerType;

function $LS(LayerType) : LayerType;

function AsFuelBottom(LayerType) : LayerType;

function AtLayer<A>([LayerType]A, LayerType) : A;

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, ly) } 
  AtLayer(f, ly) == f[ly]);

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, $LS(ly)) } 
  AtLayer(f, $LS(ly)) == AtLayer(f, ly));

type Field _;

function FDim<T>(Field T) : int;

function IndexField(int) : Field Box;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field Box, int) : Field Box;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  MultiIndexField_Inverse0(MultiIndexField(f, i)) == f
     && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

type NameFamily;

function DeclName<T>(Field T) : NameFamily;

function FieldOfDecl<alpha>(ClassName, NameFamily) : Field alpha;

axiom (forall<T> cl: ClassName, nm: NameFamily :: 
  { FieldOfDecl(cl, nm): Field T } 
  DeclType(FieldOfDecl(cl, nm): Field T) == cl
     && DeclName(FieldOfDecl(cl, nm): Field T) == nm);

function $IsGhostField<T>(Field T) : bool;

axiom (forall<T> h: Heap, k: Heap, v: T, t: Ty :: 
  { $HeapSucc(h, k), $IsAlloc(v, t, h) } 
  $HeapSucc(h, k) ==> $IsAlloc(v, t, h) ==> $IsAlloc(v, t, k));

axiom (forall h: Heap, k: Heap, bx: Box, t: Ty :: 
  { $HeapSucc(h, k), $IsAllocBox(bx, t, h) } 
  $HeapSucc(h, k) ==> $IsAllocBox(bx, t, h) ==> $IsAllocBox(bx, t, k));

const unique alloc: Field bool;

const unique allocName: NameFamily;

axiom FDim(alloc) == 0 && DeclName(alloc) == allocName && !$IsGhostField(alloc);

function _System.array.Length(a: ref) : int;

axiom (forall o: ref :: 0 <= _System.array.Length(o));

function Int(x: real) : int;

axiom (forall x: real :: { Int(x): int } Int(x): int == int(x));

function Real(x: int) : real;

axiom (forall x: int :: { Real(x): real } Real(x): real == real(x));

axiom (forall i: int :: { Int(Real(i)) } Int(Real(i)) == i);

function {:inline} _System.real.Floor(x: real) : int
{
  Int(x)
}

type Heap = [ref]<alpha>[Field alpha]alpha;

function {:inline} read<alpha>(H: Heap, r: ref, f: Field alpha) : alpha
{
  H[r][f]
}

function {:inline} update<alpha>(H: Heap, r: ref, f: Field alpha, v: alpha) : Heap
{
  H[r := H[r][f := v]]
}

function $IsGoodHeap(Heap) : bool;

function $IsHeapAnchor(Heap) : bool;

var $Heap: Heap where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap);

const $OneHeap: Heap;

axiom $IsGoodHeap($OneHeap);

function $HeapSucc(Heap, Heap) : bool;

axiom (forall<alpha> h: Heap, r: ref, f: Field alpha, x: alpha :: 
  { update(h, r, f, x) } 
  $IsGoodHeap(update(h, r, f, x)) ==> $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: Heap, b: Heap, c: Heap :: 
  { $HeapSucc(a, b), $HeapSucc(b, c) } 
  a != c ==> $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: Heap, k: Heap :: 
  { $HeapSucc(h, k) } 
  $HeapSucc(h, k)
     ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

function $HeapSuccGhost(Heap, Heap) : bool;

axiom (forall h: Heap, k: Heap :: 
  { $HeapSuccGhost(h, k) } 
  $HeapSuccGhost(h, k)
     ==> $HeapSucc(h, k)
       && (forall<alpha> o: ref, f: Field alpha :: 
        { read(k, o, f) } 
        !$IsGhostField(f) ==> read(h, o, f) == read(k, o, f)));

type TickType;

var $Tick: TickType;

procedure $YieldHavoc(this: ref, rds: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      $o == this || rds[$Box($o)] || nw[$Box($o)]
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc0(this: ref, rds: Set Box, modi: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      rds[$Box($o)] && !modi[$Box($o)] && $o != this
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc1(this: ref, modi: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)
         || $o == this
         || modi[$Box($o)]
         || nw[$Box($o)]);
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterCollectNewObjects(prevHeap: Heap, newHeap: Heap, this: ref, NW: Field (Set Box))
   returns (s: Set Box);
  ensures (forall bx: Box :: 
    { s[bx] } 
    s[bx]
       <==> read(newHeap, this, NW)[bx]
         || (
          $Unbox(bx) != null
           && !read(prevHeap, $Unbox(bx): ref, alloc)
           && read(newHeap, $Unbox(bx): ref, alloc)));



type Set T = [T]bool;

function Set#Card<T>(Set T) : int;

axiom (forall<T> s: Set T :: { Set#Card(s) } 0 <= Set#Card(s));

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

axiom (forall<T> s: Set T :: 
  { Set#Card(s) } 
  (Set#Card(s) == 0 <==> s == Set#Empty())
     && (Set#Card(s) != 0 ==> (exists x: T :: s[x])));

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: 
  { Set#Singleton(r)[o] } 
  Set#Singleton(r)[o] <==> r == o);

axiom (forall<T> r: T :: 
  { Set#Card(Set#Singleton(r)) } 
  Set#Card(Set#Singleton(r)) == 1);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: 
  { Set#UnionOne(a, x)[o] } 
  Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: 
  { Set#UnionOne(a, x), a[y] } 
  a[y] ==> Set#UnionOne(a, x)[y]);

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a));

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  !a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a) + 1);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Union(a, b)[o] } 
  Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), a[y] } 
  a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), b[y] } 
  b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, b) } 
  Set#Disjoint(a, b)
     ==> Set#Difference(Set#Union(a, b), a) == b
       && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Intersection(a, b)[o] } 
  Set#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(Set#Union(a, b), b) } 
  Set#Union(Set#Union(a, b), b) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, Set#Union(a, b)) } 
  Set#Union(a, Set#Union(a, b)) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(Set#Intersection(a, b), b) } 
  Set#Intersection(Set#Intersection(a, b), b) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(a, Set#Intersection(a, b)) } 
  Set#Intersection(a, Set#Intersection(a, b)) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Union(a, b)) } { Set#Card(Set#Intersection(a, b)) } 
  Set#Card(Set#Union(a, b)) + Set#Card(Set#Intersection(a, b))
     == Set#Card(a) + Set#Card(b));

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Difference(a, b)[o] } 
  Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Difference(a, b), b[y] } 
  b[y] ==> !Set#Difference(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Difference(a, b)) } 
  Set#Card(Set#Difference(a, b))
         + Set#Card(Set#Difference(b, a))
         + Set#Card(Set#Intersection(a, b))
       == Set#Card(Set#Union(a, b))
     && Set#Card(Set#Difference(a, b)) == Set#Card(a) - Set#Card(Set#Intersection(a, b)));

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Subset(a, b) } 
  Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Equal(a, b) } 
  Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Disjoint(a, b) } 
  Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type ISet T = [T]bool;

function ISet#Empty<T>() : Set T;

axiom (forall<T> o: T :: { ISet#Empty()[o] } !ISet#Empty()[o]);

function ISet#UnionOne<T>(ISet T, T) : ISet T;

axiom (forall<T> a: ISet T, x: T, o: T :: 
  { ISet#UnionOne(a, x)[o] } 
  ISet#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: ISet T, x: T :: { ISet#UnionOne(a, x) } ISet#UnionOne(a, x)[x]);

axiom (forall<T> a: ISet T, x: T, y: T :: 
  { ISet#UnionOne(a, x), a[y] } 
  a[y] ==> ISet#UnionOne(a, x)[y]);

function ISet#Union<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Union(a, b)[o] } 
  ISet#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Union(a, b), a[y] } 
  a[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { ISet#Union(a, b), b[y] } 
  b[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(a, b) } 
  ISet#Disjoint(a, b)
     ==> ISet#Difference(ISet#Union(a, b), a) == b
       && ISet#Difference(ISet#Union(a, b), b) == a);

function ISet#Intersection<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Intersection(a, b)[o] } 
  ISet#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(ISet#Union(a, b), b) } 
  ISet#Union(ISet#Union(a, b), b) == ISet#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { ISet#Union(a, ISet#Union(a, b)) } 
  ISet#Union(a, ISet#Union(a, b)) == ISet#Union(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(ISet#Intersection(a, b), b) } 
  ISet#Intersection(ISet#Intersection(a, b), b) == ISet#Intersection(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(a, ISet#Intersection(a, b)) } 
  ISet#Intersection(a, ISet#Intersection(a, b)) == ISet#Intersection(a, b));

function ISet#Difference<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Difference(a, b)[o] } 
  ISet#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Difference(a, b), b[y] } 
  b[y] ==> !ISet#Difference(a, b)[y]);

function ISet#Subset<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Subset(a, b) } 
  ISet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function ISet#Equal<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) ==> a == b);

function ISet#Disjoint<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Disjoint(a, b) } 
  ISet#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

function Math#min(a: int, b: int) : int;

axiom (forall a: int, b: int :: { Math#min(a, b) } a <= b <==> Math#min(a, b) == a);

axiom (forall a: int, b: int :: { Math#min(a, b) } b <= a <==> Math#min(a, b) == b);

axiom (forall a: int, b: int :: 
  { Math#min(a, b) } 
  Math#min(a, b) == a || Math#min(a, b) == b);

function Math#clip(a: int) : int;

axiom (forall a: int :: { Math#clip(a) } 0 <= a ==> Math#clip(a) == a);

axiom (forall a: int :: { Math#clip(a) } a < 0 ==> Math#clip(a) == 0);

type MultiSet T = [T]int;

function $IsGoodMultiSet<T>(ms: MultiSet T) : bool;

axiom (forall<T> ms: MultiSet T :: 
  { $IsGoodMultiSet(ms) } 
  $IsGoodMultiSet(ms)
     <==> (forall bx: T :: { ms[bx] } 0 <= ms[bx] && ms[bx] <= MultiSet#Card(ms)));

function MultiSet#Card<T>(MultiSet T) : int;

axiom (forall<T> s: MultiSet T :: { MultiSet#Card(s) } 0 <= MultiSet#Card(s));

axiom (forall<T> s: MultiSet T, x: T, n: int :: 
  { MultiSet#Card(s[x := n]) } 
  0 <= n ==> MultiSet#Card(s[x := n]) == MultiSet#Card(s) - s[x] + n);

function MultiSet#Empty<T>() : MultiSet T;

axiom (forall<T> o: T :: { MultiSet#Empty()[o] } MultiSet#Empty()[o] == 0);

axiom (forall<T> s: MultiSet T :: 
  { MultiSet#Card(s) } 
  (MultiSet#Card(s) == 0 <==> s == MultiSet#Empty())
     && (MultiSet#Card(s) != 0 ==> (exists x: T :: 0 < s[x])));

function MultiSet#Singleton<T>(T) : MultiSet T;

axiom (forall<T> r: T, o: T :: 
  { MultiSet#Singleton(r)[o] } 
  (MultiSet#Singleton(r)[o] == 1 <==> r == o)
     && (MultiSet#Singleton(r)[o] == 0 <==> r != o));

axiom (forall<T> r: T :: 
  { MultiSet#Singleton(r) } 
  MultiSet#Singleton(r) == MultiSet#UnionOne(MultiSet#Empty(), r));

function MultiSet#UnionOne<T>(MultiSet T, T) : MultiSet T;

axiom (forall<T> a: MultiSet T, x: T, o: T :: 
  { MultiSet#UnionOne(a, x)[o] } 
  0 < MultiSet#UnionOne(a, x)[o] <==> o == x || 0 < a[o]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#UnionOne(a, x) } 
  MultiSet#UnionOne(a, x)[x] == a[x] + 1);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  0 < a[y] ==> 0 < MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  x != y ==> a[y] == MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#Card(MultiSet#UnionOne(a, x)) } 
  MultiSet#Card(MultiSet#UnionOne(a, x)) == MultiSet#Card(a) + 1);

function MultiSet#Union<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Union(a, b)[o] } 
  MultiSet#Union(a, b)[o] == a[o] + b[o]);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Union(a, b)) } 
  MultiSet#Card(MultiSet#Union(a, b)) == MultiSet#Card(a) + MultiSet#Card(b));

function MultiSet#Intersection<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Intersection(a, b)[o] } 
  MultiSet#Intersection(a, b)[o] == Math#min(a[o], b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(MultiSet#Intersection(a, b), b) } 
  MultiSet#Intersection(MultiSet#Intersection(a, b), b)
     == MultiSet#Intersection(a, b));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(a, MultiSet#Intersection(a, b)) } 
  MultiSet#Intersection(a, MultiSet#Intersection(a, b))
     == MultiSet#Intersection(a, b));

function MultiSet#Difference<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Difference(a, b)[o] } 
  MultiSet#Difference(a, b)[o] == Math#clip(a[o] - b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T, y: T :: 
  { MultiSet#Difference(a, b), b[y], a[y] } 
  a[y] <= b[y] ==> MultiSet#Difference(a, b)[y] == 0);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Difference(a, b)) } 
  MultiSet#Card(MultiSet#Difference(a, b))
         + MultiSet#Card(MultiSet#Difference(b, a))
         + 2 * MultiSet#Card(MultiSet#Intersection(a, b))
       == MultiSet#Card(MultiSet#Union(a, b))
     && MultiSet#Card(MultiSet#Difference(a, b))
       == MultiSet#Card(a) - MultiSet#Card(MultiSet#Intersection(a, b)));

function MultiSet#Subset<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Subset(a, b) } 
  MultiSet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <= b[o]));

function MultiSet#Equal<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] == b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) ==> a == b);

function MultiSet#Disjoint<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Disjoint(a, b) } 
  MultiSet#Disjoint(a, b)
     <==> (forall o: T :: { a[o] } { b[o] } a[o] == 0 || b[o] == 0));

function MultiSet#FromSet<T>(Set T) : MultiSet T;

axiom (forall<T> s: Set T, a: T :: 
  { MultiSet#FromSet(s)[a] } 
  (MultiSet#FromSet(s)[a] == 0 <==> !s[a])
     && (MultiSet#FromSet(s)[a] == 1 <==> s[a]));

axiom (forall<T> s: Set T :: 
  { MultiSet#Card(MultiSet#FromSet(s)) } 
  MultiSet#Card(MultiSet#FromSet(s)) == Set#Card(s));

function MultiSet#FromSeq<T>(Seq T) : MultiSet T;

axiom (forall<T> s: Seq T :: 
  { MultiSet#FromSeq(s) } 
  $IsGoodMultiSet(MultiSet#FromSeq(s)));

axiom (forall<T> s: Seq T :: 
  { MultiSet#Card(MultiSet#FromSeq(s)) } 
  MultiSet#Card(MultiSet#FromSeq(s)) == Seq#Length(s));

axiom (forall<T> s: Seq T, v: T :: 
  { MultiSet#FromSeq(Seq#Build(s, v)) } 
  MultiSet#FromSeq(Seq#Build(s, v)) == MultiSet#UnionOne(MultiSet#FromSeq(s), v));

axiom (forall<T>  :: 
  MultiSet#FromSeq(Seq#Empty(): Seq T) == MultiSet#Empty(): MultiSet T);

axiom (forall<T> a: Seq T, b: Seq T :: 
  { MultiSet#FromSeq(Seq#Append(a, b)) } 
  MultiSet#FromSeq(Seq#Append(a, b))
     == MultiSet#Union(MultiSet#FromSeq(a), MultiSet#FromSeq(b)));

axiom (forall<T> s: Seq T, i: int, v: T, x: T :: 
  { MultiSet#FromSeq(Seq#Update(s, i, v))[x] } 
  0 <= i && i < Seq#Length(s)
     ==> MultiSet#FromSeq(Seq#Update(s, i, v))[x]
       == MultiSet#Union(MultiSet#Difference(MultiSet#FromSeq(s), MultiSet#Singleton(Seq#Index(s, i))), 
        MultiSet#Singleton(v))[x]);

axiom (forall<T> s: Seq T, x: T :: 
  { MultiSet#FromSeq(s)[x] } 
  (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && x == Seq#Index(s, i))
     <==> 0 < MultiSet#FromSeq(s)[x]);

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: { Seq#Empty(): Seq T } Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: 
  { Seq#Length(s) } 
  Seq#Length(s) == 0 ==> s == Seq#Empty());

axiom (forall<T> t: Ty :: { $Is(Seq#Empty(): Seq T, t) } $Is(Seq#Empty(): Seq T, t));

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: 
  { Seq#Length(Seq#Singleton(t)) } 
  Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, val: T) : Seq T;

function Seq#Build_inv0<T>(s: Seq T) : Seq T;

function Seq#Build_inv1<T>(s: Seq T) : T;

axiom (forall<T> s: Seq T, val: T :: 
  { Seq#Build(s, val) } 
  Seq#Build_inv0(Seq#Build(s, val)) == s
     && Seq#Build_inv1(Seq#Build(s, val)) == val);

axiom (forall<T> s: Seq T, v: T :: 
  { Seq#Build(s, v) } 
  Seq#Length(Seq#Build(s, v)) == 1 + Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Index(Seq#Build(s, v), i) } 
  (i == Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == v)
     && (i != Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == Seq#Index(s, i)));

axiom (forall s: Seq Box, bx: Box, t: Ty :: 
  { $Is(Seq#Build(s, bx), TSeq(t)) } 
  $Is(s, TSeq(t)) && $IsBox(bx, t) ==> $Is(Seq#Build(s, bx), TSeq(t)));

function Seq#Create(ty: Ty, heap: Heap, len: int, init: HandleType) : Seq Box;

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType :: 
  { Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) } 
  $IsGoodHeap(heap) && 0 <= len
     ==> Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) == len);

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType, i: int :: 
  { Seq#Index(Seq#Create(ty, heap, len, init), i) } 
  $IsGoodHeap(heap) && 0 <= i && i < len
     ==> Seq#Index(Seq#Create(ty, heap, len, init), i)
       == Apply1(TInt, TSeq(ty), heap, init, $Box(i)));

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Length(Seq#Append(s0, s1)) } 
  Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

axiom (forall s0: Seq Box, s1: Seq Box, t: Ty :: 
  { $Is(Seq#Append(s0, s1), t) } 
  $Is(s0, t) && $Is(s1, t) ==> $Is(Seq#Append(s0, s1), t));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: 
  { Seq#Index(Seq#Singleton(t), 0) } 
  Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#Index(Seq#Append(s0, s1), n) } 
  (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n))
     && (Seq#Length(s0) <= n
       ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Length(Seq#Update(s, i, v)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Index(Seq#Update(s, i, v), n) } 
  0 <= n && n < Seq#Length(s)
     ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v)
       && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: 
  { Seq#Contains(s, x) } 
  Seq#Contains(s, x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> x: T :: 
  { Seq#Contains(Seq#Empty(), x) } 
  !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: 
  { Seq#Contains(Seq#Append(s0, s1), x) } 
  Seq#Contains(Seq#Append(s0, s1), x)
     <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, v: T, x: T :: 
  { Seq#Contains(Seq#Build(s, v), x) } 
  Seq#Contains(Seq#Build(s, v), x) <==> v == x || Seq#Contains(s, x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Take(s, n), x) } 
  Seq#Contains(Seq#Take(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Drop(s, n), x) } 
  Seq#Contains(Seq#Drop(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Equal(s0, s1) } 
  Seq#Equal(s0, s1)
     <==> Seq#Length(s0) == Seq#Length(s1)
       && (forall j: int :: 
        { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
        0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#SameUntil(s0, s1, n) } 
  Seq#SameUntil(s0, s1, n)
     <==> (forall j: int :: 
      { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
      0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Take(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Take(s, n), j) } { Seq#Index(s, j), Seq#Take(s, n) } 
  0 <= j && j < n && j < Seq#Length(s)
     ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Drop(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 
  0 <= n && 0 <= j && j < Seq#Length(s) - n
     ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, n: int, k: int :: 
  {:weight 25} { Seq#Index(s, k), Seq#Drop(s, n) } 
  0 <= n && n <= k && k < Seq#Length(s)
     ==> Seq#Index(Seq#Drop(s, n), k - n) == Seq#Index(s, k));

axiom (forall<T> s: Seq T, t: Seq T, n: int :: 
  { Seq#Take(Seq#Append(s, t), n) } { Seq#Drop(Seq#Append(s, t), n) } 
  n == Seq#Length(s)
     ==> Seq#Take(Seq#Append(s, t), n) == s && Seq#Drop(Seq#Append(s, t), n) == t);

function Seq#FromArray(h: Heap, a: ref) : Seq Box;

axiom (forall h: Heap, a: ref :: 
  { Seq#Length(Seq#FromArray(h, a)) } 
  Seq#Length(Seq#FromArray(h, a)) == _System.array.Length(a));

axiom (forall h: Heap, a: ref :: 
  { Seq#FromArray(h, a) } 
  (forall i: int :: 
    { read(h, a, IndexField(i)) } { Seq#Index(Seq#FromArray(h, a): Seq Box, i) } 
    0 <= i && i < Seq#Length(Seq#FromArray(h, a))
       ==> Seq#Index(Seq#FromArray(h, a), i) == read(h, a, IndexField(i))));

axiom (forall h0: Heap, h1: Heap, a: ref :: 
  { Seq#FromArray(h1, a), $HeapSucc(h0, h1) } 
  $IsGoodHeap(h0) && $IsGoodHeap(h1) && $HeapSucc(h0, h1) && h0[a] == h1[a]
     ==> Seq#FromArray(h0, a) == Seq#FromArray(h1, a));

axiom (forall h: Heap, i: int, v: Box, a: ref :: 
  { Seq#FromArray(update(h, a, IndexField(i), v), a) } 
  0 <= i && i < _System.array.Length(a)
     ==> Seq#FromArray(update(h, a, IndexField(i), v), a)
       == Seq#Update(Seq#FromArray(h, a), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n <= Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Update(Seq#Take(s, n), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  n <= i && i < Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Take(s, n));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= n && n <= i && i < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Update(Seq#Drop(s, n), i - n, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Drop(s, n));

axiom (forall h: Heap, a: ref, n0: int, n1: int :: 
  { Seq#Take(Seq#FromArray(h, a), n0), Seq#Take(Seq#FromArray(h, a), n1) } 
  n0 + 1 == n1 && 0 <= n0 && n1 <= _System.array.Length(a)
     ==> Seq#Take(Seq#FromArray(h, a), n1)
       == Seq#Build(Seq#Take(Seq#FromArray(h, a), n0), read(h, a, IndexField(n0): Field Box)));

axiom (forall<T> s: Seq T, v: T, n: int :: 
  { Seq#Drop(Seq#Build(s, v), n) } 
  0 <= n && n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Build(s, v), n) == Seq#Build(Seq#Drop(s, n), v));

function Seq#Rank<T>(Seq T) : int;

axiom (forall s: Seq Box, i: int :: 
  { DtRank($Unbox(Seq#Index(s, i)): DatatypeType) } 
  0 <= i && i < Seq#Length(s)
     ==> DtRank($Unbox(Seq#Index(s, i)): DatatypeType) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Drop(s, i)) } 
  0 < i && i <= Seq#Length(s) ==> Seq#Rank(Seq#Drop(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Take(s, i)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Rank(Seq#Take(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int, j: int :: 
  { Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) } 
  0 <= i && i < j && j <= Seq#Length(s)
     ==> Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) < Seq#Rank(s));

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Drop(s, n) } 
  n == 0 ==> Seq#Drop(s, n) == s);

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Take(s, n) } 
  n == 0 ==> Seq#Take(s, n) == Seq#Empty());

axiom (forall<T> s: Seq T, m: int, n: int :: 
  { Seq#Drop(Seq#Drop(s, m), n) } 
  0 <= m && 0 <= n && m + n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Drop(s, m), n) == Seq#Drop(s, m + n));

type Map _ _;

function Map#Domain<U,V>(Map U V) : Set U;

function Map#Elements<U,V>(Map U V) : [U]V;

function Map#Card<U,V>(Map U V) : int;

axiom (forall<U,V> m: Map U V :: { Map#Card(m) } 0 <= Map#Card(m));

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Domain(m)) } 
  Set#Card(Map#Domain(m)) == Map#Card(m));

function Map#Values<U,V>(Map U V) : Set V;

axiom (forall<U,V> m: Map U V, v: V :: 
  { Map#Values(m)[v] } 
  Map#Values(m)[v]
     == (exists u: U :: 
      { Map#Domain(m)[u] } { Map#Elements(m)[u] } 
      Map#Domain(m)[u] && v == Map#Elements(m)[u]));

function Map#Items<U,V>(Map U V) : Set Box;

function _System.Tuple2._0(DatatypeType) : Box;

function _System.Tuple2._1(DatatypeType) : Box;

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Items(m)) } 
  Set#Card(Map#Items(m)) == Map#Card(m));

axiom (forall m: Map Box Box, item: Box :: 
  { Map#Items(m)[item] } 
  Map#Items(m)[item]
     <==> Map#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && Map#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function Map#Empty<U,V>() : Map U V;

axiom (forall<U,V> u: U :: 
  { Map#Domain(Map#Empty(): Map U V)[u] } 
  !Map#Domain(Map#Empty(): Map U V)[u]);

axiom (forall<U,V> m: Map U V :: 
  { Map#Card(m) } 
  (Map#Card(m) == 0 <==> m == Map#Empty())
     && (Map#Card(m) != 0 ==> (exists x: U :: Map#Domain(m)[x])));

function Map#Glue<U,V>([U]bool, [U]V, Ty) : Map U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Domain(Map#Glue(a, b, t)) } 
  Map#Domain(Map#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Elements(Map#Glue(a, b, t)) } 
  Map#Elements(Map#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(Map#Glue(a, b, t), t) } 
  $Is(Map#Glue(a, b, t), t));

function Map#Build<U,V>(Map U V, U, V) : Map U V;

axiom (forall<U,V> m: Map U V, u: U, u': U, v: V :: 
  { Map#Domain(Map#Build(m, u, v))[u'] } { Map#Elements(Map#Build(m, u, v))[u'] } 
  (u' == u
       ==> Map#Domain(Map#Build(m, u, v))[u'] && Map#Elements(Map#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> Map#Domain(Map#Build(m, u, v))[u'] == Map#Domain(m)[u']
         && Map#Elements(Map#Build(m, u, v))[u'] == Map#Elements(m)[u']));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  !Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m) + 1);

function Map#Equal<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m')
     <==> (forall u: U :: Map#Domain(m)[u] == Map#Domain(m')[u])
       && (forall u: U :: Map#Domain(m)[u] ==> Map#Elements(m)[u] == Map#Elements(m')[u]));

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m') ==> m == m');

function Map#Disjoint<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Disjoint(m, m') } 
  Map#Disjoint(m, m')
     <==> (forall o: U :: 
      { Map#Domain(m)[o] } { Map#Domain(m')[o] } 
      !Map#Domain(m)[o] || !Map#Domain(m')[o]));

type IMap _ _;

function IMap#Domain<U,V>(IMap U V) : Set U;

function IMap#Elements<U,V>(IMap U V) : [U]V;

function IMap#Values<U,V>(IMap U V) : Set V;

axiom (forall<U,V> m: IMap U V, v: V :: 
  { IMap#Values(m)[v] } 
  IMap#Values(m)[v]
     == (exists u: U :: 
      { IMap#Domain(m)[u] } { IMap#Elements(m)[u] } 
      IMap#Domain(m)[u] && v == IMap#Elements(m)[u]));

function IMap#Items<U,V>(IMap U V) : Set Box;

axiom (forall m: IMap Box Box, item: Box :: 
  { IMap#Items(m)[item] } 
  IMap#Items(m)[item]
     <==> IMap#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && IMap#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function IMap#Empty<U,V>() : IMap U V;

axiom (forall<U,V> u: U :: 
  { IMap#Domain(IMap#Empty(): IMap U V)[u] } 
  !IMap#Domain(IMap#Empty(): IMap U V)[u]);

function IMap#Glue<U,V>([U]bool, [U]V, Ty) : IMap U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Domain(IMap#Glue(a, b, t)) } 
  IMap#Domain(IMap#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Elements(IMap#Glue(a, b, t)) } 
  IMap#Elements(IMap#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(IMap#Glue(a, b, t), t) } 
  $Is(IMap#Glue(a, b, t), t));

function IMap#Build<U,V>(IMap U V, U, V) : IMap U V;

axiom (forall<U,V> m: IMap U V, u: U, u': U, v: V :: 
  { IMap#Domain(IMap#Build(m, u, v))[u'] } 
    { IMap#Elements(IMap#Build(m, u, v))[u'] } 
  (u' == u
       ==> IMap#Domain(IMap#Build(m, u, v))[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> IMap#Domain(IMap#Build(m, u, v))[u'] == IMap#Domain(m)[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == IMap#Elements(m)[u']));

function IMap#Equal<U,V>(IMap U V, IMap U V) : bool;

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m')
     <==> (forall u: U :: IMap#Domain(m)[u] == IMap#Domain(m')[u])
       && (forall u: U :: 
        IMap#Domain(m)[u] ==> IMap#Elements(m)[u] == IMap#Elements(m')[u]));

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m') ==> m == m');

function INTERNAL_add_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_add_boogie(x, y): int } 
  INTERNAL_add_boogie(x, y): int == x + y);

function INTERNAL_sub_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_sub_boogie(x, y): int } 
  INTERNAL_sub_boogie(x, y): int == x - y);

function INTERNAL_mul_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mul_boogie(x, y): int } 
  INTERNAL_mul_boogie(x, y): int == x * y);

function INTERNAL_div_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_div_boogie(x, y): int } 
  INTERNAL_div_boogie(x, y): int == x div y);

function INTERNAL_mod_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mod_boogie(x, y): int } 
  INTERNAL_mod_boogie(x, y): int == x mod y);

function {:never_pattern true} INTERNAL_lt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_lt_boogie(x, y): bool } 
  INTERNAL_lt_boogie(x, y): bool == (x < y));

function {:never_pattern true} INTERNAL_le_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_le_boogie(x, y): bool } 
  INTERNAL_le_boogie(x, y): bool == (x <= y));

function {:never_pattern true} INTERNAL_gt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_gt_boogie(x, y): bool } 
  INTERNAL_gt_boogie(x, y): bool == (x > y));

function {:never_pattern true} INTERNAL_ge_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_ge_boogie(x, y): bool } 
  INTERNAL_ge_boogie(x, y): bool == (x >= y));

function Mul(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mul(x, y): int } Mul(x, y): int == x * y);

function Div(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Div(x, y): int } Div(x, y): int == x div y);

function Mod(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mod(x, y): int } Mod(x, y): int == x mod y);

function Add(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Add(x, y): int } Add(x, y): int == x + y);

function Sub(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Sub(x, y): int } Sub(x, y): int == x - y);

function _System.__default.rank__is__less__than(A: Ty, B: Ty, a: Box, b: Box) : bool;

axiom (forall A: Ty, B: Ty, a: Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, a, b) ==> BoxRank(a) < BoxRank(b));

axiom (forall A: Ty, B: Ty, a: Box, b: Seq Box :: 
  { _System.__default.rank__is__less__than(A, B, a, $Box(b)), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, $Box(b)), Seq#Rank(b) } 
  _System.__default.rank__is__less__than(A, B, a, $Box(b))
     ==> BoxRank(a) < Seq#Rank(b));

axiom (forall A: Ty, B: Ty, a: Seq Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, $Box(a), b), Seq#Rank(a) } 
    { _System.__default.rank__is__less__than(A, B, $Box(a), b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, $Box(a), b)
     ==> Seq#Rank(a) < BoxRank(b));

function Tclass._System.nat() : Ty;

// Tclass._System.nat Tag
axiom Tag(Tclass._System.nat()) == Tagclass._System.nat;

const unique Tagclass._System.nat: TyTag;

// Box/unbox axiom for Tclass._System.nat
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.nat()) } 
  $IsBox(bx, Tclass._System.nat())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass._System.nat()));

// _System.nat: subset type $Is
axiom (forall x#0: int :: 
  { $Is(x#0, Tclass._System.nat()) } 
  $Is(x#0, Tclass._System.nat()) <==> LitInt(0) <= x#0);

// _System.nat: subset type $IsAlloc
axiom (forall x#0: int, $h: Heap :: 
  { $IsAlloc(x#0, Tclass._System.nat(), $h) } 
  $IsAlloc(x#0, Tclass._System.nat(), $h));

const unique class._System.object?: ClassName;

// Tclass._System.object? Tag
axiom Tag(Tclass._System.object?()) == Tagclass._System.object?;

const unique Tagclass._System.object?: TyTag;

// Box/unbox axiom for Tclass._System.object?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object?()) } 
  $IsBox(bx, Tclass._System.object?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object?()));

// object: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.object?()) } 
  $Is($o, Tclass._System.object?()));

// object: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.object?(), $h) } 
  $IsAlloc($o, Tclass._System.object?(), $h)
     <==> $o == null || read($h, $o, alloc));

function implements$_System.object(Ty) : bool;

function Tclass._System.object() : Ty;

// Tclass._System.object Tag
axiom Tag(Tclass._System.object()) == Tagclass._System.object;

const unique Tagclass._System.object: TyTag;

// Box/unbox axiom for Tclass._System.object
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object()) } 
  $IsBox(bx, Tclass._System.object())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object()));

// _System.object: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass._System.object()) } 
  $Is(c#0, Tclass._System.object())
     <==> $Is(c#0, Tclass._System.object?()) && c#0 != null);

// _System.object: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.object(), $h) } 
  $IsAlloc(c#0, Tclass._System.object(), $h)
     <==> $IsAlloc(c#0, Tclass._System.object?(), $h));

const unique class._System.array?: ClassName;

function Tclass._System.array?(Ty) : Ty;

// Tclass._System.array? Tag
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tag(Tclass._System.array?(#$arg)) == Tagclass._System.array?);

const unique Tagclass._System.array?: TyTag;

// Tclass._System.array? injectivity 0
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tclass._System.array?_0(Tclass._System.array?(#$arg)) == #$arg);

function Tclass._System.array?_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array?
axiom (forall #$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array?(#$arg)) } 
  $IsBox(bx, Tclass._System.array?(#$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array?(#$arg)));

// array.: Type axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
     ==> $IsBox(read($h, $o, IndexField($i0)), #$arg));

// array.: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
       && read($h, $o, alloc)
     ==> $IsAllocBox(read($h, $o, IndexField($i0)), #$arg, $h));

// array: Class $Is
axiom (forall #$arg: Ty, $o: ref :: 
  { $Is($o, Tclass._System.array?(#$arg)) } 
  $Is($o, Tclass._System.array?(#$arg))
     <==> $o == null || dtype($o) == Tclass._System.array?(#$arg));

// array: Class $IsAlloc
axiom (forall #$arg: Ty, $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.array?(#$arg), $h) } 
  $IsAlloc($o, Tclass._System.array?(#$arg), $h)
     <==> $o == null || read($h, $o, alloc));

// array.Length: Type axiom
axiom (forall #$arg: Ty, $o: ref :: 
  { _System.array.Length($o), Tclass._System.array?(#$arg) } 
  $o != null && dtype($o) == Tclass._System.array?(#$arg)
     ==> $Is(_System.array.Length($o), TInt));

// array.Length: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref :: 
  { _System.array.Length($o), read($h, $o, alloc), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && read($h, $o, alloc)
     ==> $IsAlloc(_System.array.Length($o), TInt, $h));

function Tclass._System.array(Ty) : Ty;

// Tclass._System.array Tag
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tag(Tclass._System.array(_System.array$arg)) == Tagclass._System.array);

const unique Tagclass._System.array: TyTag;

// Tclass._System.array injectivity 0
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tclass._System.array_0(Tclass._System.array(_System.array$arg))
     == _System.array$arg);

function Tclass._System.array_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array
axiom (forall _System.array$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array(_System.array$arg)) } 
  $IsBox(bx, Tclass._System.array(_System.array$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array(_System.array$arg)));

// _System.array: subset type $Is
axiom (forall _System.array$arg: Ty, c#0: ref :: 
  { $Is(c#0, Tclass._System.array(_System.array$arg)) } 
  $Is(c#0, Tclass._System.array(_System.array$arg))
     <==> $Is(c#0, Tclass._System.array?(_System.array$arg)) && c#0 != null);

// _System.array: subset type $IsAlloc
axiom (forall _System.array$arg: Ty, c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h) } 
  $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h)
     <==> $IsAlloc(c#0, Tclass._System.array?(_System.array$arg), $h));

function Tclass._System.___hFunc0(Ty) : Ty;

// Tclass._System.___hFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tag(Tclass._System.___hFunc0(#$R)) == Tagclass._System.___hFunc0);

const unique Tagclass._System.___hFunc0: TyTag;

// Tclass._System.___hFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tclass._System.___hFunc0_0(Tclass._System.___hFunc0(#$R)) == #$R);

function Tclass._System.___hFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc0(#$R)));

function Handle0([Heap]Box, [Heap]bool, [Heap]Set Box) : HandleType;

function Apply0(Ty, Heap, HandleType) : Box;

function Requires0(Ty, Heap, HandleType) : bool;

function Reads0(Ty, Heap, HandleType) : Set Box;

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Apply0(t0, heap, Handle0(h, r, rd)) } 
  Apply0(t0, heap, Handle0(h, r, rd)) == h[heap]);

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Requires0(t0, heap, Handle0(h, r, rd)) } 
  r[heap] ==> Requires0(t0, heap, Handle0(h, r, rd)));

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box, bx: Box :: 
  { Reads0(t0, heap, Handle0(h, r, rd))[bx] } 
  Reads0(t0, heap, Handle0(h, r, rd))[bx] == rd[heap][bx]);

function {:inline} Requires0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

function {:inline} Reads0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// empty-reads property for Reads0 
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Reads0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Reads0(t0, heap, f) } 
  $IsGoodHeap(heap) && $Is(f, Tclass._System.___hFunc0(t0))
     ==> (Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
       <==> Set#Equal(Reads0(t0, heap, f), Set#Empty(): Set Box)));

// empty-reads property for Requires0
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Requires0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Requires0(t0, heap, f) } 
  $IsGoodHeap(heap)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
     ==> Requires0(t0, $OneHeap, f) == Requires0(t0, heap, f));

axiom (forall f: HandleType, t0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
     <==> (forall h: Heap :: 
      { Apply0(t0, h, f) } 
      $IsGoodHeap(h) && Requires0(t0, h, f) ==> $IsBox(Apply0(t0, h, f), t0)));

axiom (forall f: HandleType, t0: Ty, u0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)), $Is(f, Tclass._System.___hFunc0(u0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t0) } { $IsBox(bx, u0) } 
        $IsBox(bx, t0) ==> $IsBox(bx, u0))
     ==> $Is(f, Tclass._System.___hFunc0(u0)));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc0(t0), h)
       <==> Requires0(t0, h, f)
         ==> (forall r: ref :: 
          { Reads0(t0, h, f)[$Box(r)] } 
          r != null && Reads0(t0, h, f)[$Box(r)] ==> read(h, r, alloc))));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc0(t0), h)
     ==> 
    Requires0(t0, h, f)
     ==> $IsAllocBox(Apply0(t0, h, f), t0, h));

function Tclass._System.___hPartialFunc0(Ty) : Ty;

// Tclass._System.___hPartialFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tag(Tclass._System.___hPartialFunc0(#$R)) == Tagclass._System.___hPartialFunc0);

const unique Tagclass._System.___hPartialFunc0: TyTag;

// Tclass._System.___hPartialFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tclass._System.___hPartialFunc0_0(Tclass._System.___hPartialFunc0(#$R)) == #$R);

function Tclass._System.___hPartialFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc0(#$R)));

// _System._#PartialFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hFunc0(#$R))
       && Set#Equal(Reads0(#$R, $OneHeap, f#0), Set#Empty(): Set Box));

// _System._#PartialFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc0(#$R), $h));

function Tclass._System.___hTotalFunc0(Ty) : Ty;

// Tclass._System.___hTotalFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tag(Tclass._System.___hTotalFunc0(#$R)) == Tagclass._System.___hTotalFunc0);

const unique Tagclass._System.___hTotalFunc0: TyTag;

// Tclass._System.___hTotalFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tclass._System.___hTotalFunc0_0(Tclass._System.___hTotalFunc0(#$R)) == #$R);

function Tclass._System.___hTotalFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc0(#$R)));

// _System._#TotalFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) && Requires0(#$R, $OneHeap, f#0));

// _System._#TotalFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h));

const unique class._System.__default: ClassName;

function Tclass._System.__default() : Ty;

// Tclass._System.__default Tag
axiom Tag(Tclass._System.__default()) == Tagclass._System.__default;

const unique Tagclass._System.__default: TyTag;

// Box/unbox axiom for Tclass._System.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.__default()) } 
  $IsBox(bx, Tclass._System.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.__default()) } 
  $Is($o, Tclass._System.__default())
     <==> $o == null || dtype($o) == Tclass._System.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.__default(), $h) } 
  $IsAlloc($o, Tclass._System.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function _System.__default.rank__is__less__than#canCall(#$A: Ty, #$B: Ty, a#0: Box, b#0: Box) : bool;

// consequence axiom for _System.__default.rank__is__less__than
axiom true
   ==> (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
    { _System.__default.rank__is__less__than(#$A, #$B, a#0, b#0) } 
    _System.__default.rank__is__less__than#canCall(#$A, #$B, a#0, b#0)
         || ($IsBox(a#0, #$A) && $IsBox(b#0, #$B))
       ==> true);

function _System.__default.rank__is__less__than#requires(Ty, Ty, Box, Box) : bool;

// #requires axiom for _System.__default.rank__is__less__than
axiom (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
  { _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) } 
  $IsBox(a#0, #$A) && $IsBox(b#0, #$B)
     ==> _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) == true);

function Tclass._System.___hFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hFunc2);

const unique Tagclass._System.___hFunc2: TyTag;

// Tclass._System.___hFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_0(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hFunc2_0(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_1(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hFunc2_1(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_2(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$R);

function Tclass._System.___hFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc2(#$T0, #$T1, #$R)));

function Handle2([Heap,Box,Box]Box, [Heap,Box,Box]bool, [Heap,Box,Box]Set Box) : HandleType;

function Apply2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Box;

function Requires2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : bool;

function Reads2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) == h[heap, bx0, bx1]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  r[heap, bx0, bx1] ==> Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx: Box :: 
  { Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx] } 
  Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx]
     == rd[heap, bx0, bx1][bx]);

function {:inline} Requires2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

function {:inline} Reads2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// empty-reads property for Reads2 
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Reads2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     ==> (Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
       <==> Set#Equal(Reads2(t0, t1, t2, heap, f, bx0, bx1), Set#Empty(): Set Box)));

// empty-reads property for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Requires2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
     ==> Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1)
       == Requires2(t0, t1, t2, heap, f, bx0, bx1));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     <==> (forall h: Heap, bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, u0: Ty, u1: Ty, u2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)), $Is(f, Tclass._System.___hFunc2(u0, u1, u2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, t2) } { $IsBox(bx, u2) } 
        $IsBox(bx, t2) ==> $IsBox(bx, u2))
     ==> $Is(f, Tclass._System.___hFunc2(u0, u1, u2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
       <==> (forall bx0: Box, bx1: Box :: 
        { Apply2(t0, t1, t2, h, f, bx0, bx1) } { Reads2(t0, t1, t2, h, f, bx0, bx1) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && Requires2(t0, t1, t2, h, f, bx0, bx1)
           ==> (forall r: ref :: 
            { Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] } 
            r != null && Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
     ==> (forall bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsAllocBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2, h)));

function Tclass._System.___hPartialFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hPartialFunc2);

const unique Tagclass._System.___hPartialFunc2: TyTag;

// Tclass._System.___hPartialFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_0(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc2_0(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_1(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc2_1(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_2(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hPartialFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)));

// _System._#PartialFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Set#Equal(Reads2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0), Set#Empty(): Set Box)));

// _System._#PartialFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hTotalFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hTotalFunc2);

const unique Tagclass._System.___hTotalFunc2: TyTag;

// Tclass._System.___hTotalFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_0(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc2_0(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_1(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc2_1(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_2(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hTotalFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)));

// _System._#TotalFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Requires2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0)));

// _System._#TotalFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hFunc1(Ty, Ty) : Ty;

// Tclass._System.___hFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hFunc1(#$T0, #$R)) == Tagclass._System.___hFunc1);

const unique Tagclass._System.___hFunc1: TyTag;

// Tclass._System.___hFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_0(Tclass._System.___hFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hFunc1_0(Ty) : Ty;

// Tclass._System.___hFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_1(Tclass._System.___hFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc1(#$T0, #$R)));

function Handle1([Heap,Box]Box, [Heap,Box]bool, [Heap,Box]Set Box) : HandleType;

function Requires1(Ty, Ty, Heap, HandleType, Box) : bool;

function Reads1(Ty, Ty, Heap, HandleType, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) == h[heap, bx0]);

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Requires1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  r[heap, bx0] ==> Requires1(t0, t1, heap, Handle1(h, r, rd), bx0));

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box, 
    bx: Box :: 
  { Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] } 
  Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] == rd[heap, bx0][bx]);

function {:inline} Requires1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

function {:inline} Reads1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// empty-reads property for Reads1 
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Reads1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Reads1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1))
     ==> (Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
       <==> Set#Equal(Reads1(t0, t1, heap, f, bx0), Set#Empty(): Set Box)));

// empty-reads property for Requires1
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Requires1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Requires1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
     ==> Requires1(t0, t1, $OneHeap, f, bx0) == Requires1(t0, t1, heap, f, bx0));

axiom (forall f: HandleType, t0: Ty, t1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
     <==> (forall h: Heap, bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsGoodHeap(h) && $IsBox(bx0, t0) && Requires1(t0, t1, h, f, bx0)
         ==> $IsBox(Apply1(t0, t1, h, f, bx0), t1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, u0: Ty, u1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)), $Is(f, Tclass._System.___hFunc1(u0, u1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t1) } { $IsBox(bx, u1) } 
        $IsBox(bx, t1) ==> $IsBox(bx, u1))
     ==> $Is(f, Tclass._System.___hFunc1(u0, u1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
       <==> (forall bx0: Box :: 
        { Apply1(t0, t1, h, f, bx0) } { Reads1(t0, t1, h, f, bx0) } 
        $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
           ==> (forall r: ref :: 
            { Reads1(t0, t1, h, f, bx0)[$Box(r)] } 
            r != null && Reads1(t0, t1, h, f, bx0)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
     ==> (forall bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
         ==> $IsAllocBox(Apply1(t0, t1, h, f, bx0), t1, h)));

function Tclass._System.___hPartialFunc1(Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == Tagclass._System.___hPartialFunc1);

const unique Tagclass._System.___hPartialFunc1: TyTag;

// Tclass._System.___hPartialFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_0(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc1_0(Ty) : Ty;

// Tclass._System.___hPartialFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_1(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$R);

function Tclass._System.___hPartialFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc1(#$T0, #$R)));

// _System._#PartialFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0)
           ==> Set#Equal(Reads1(#$T0, #$R, $OneHeap, f#0, x0#0), Set#Empty(): Set Box)));

// _System._#PartialFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc1(#$T0, #$R), $h));

function Tclass._System.___hTotalFunc1(Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hTotalFunc1(#$T0, #$R)) == Tagclass._System.___hTotalFunc1);

const unique Tagclass._System.___hTotalFunc1: TyTag;

// Tclass._System.___hTotalFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_0(Tclass._System.___hTotalFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc1_0(Ty) : Ty;

// Tclass._System.___hTotalFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_1(Tclass._System.___hTotalFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hTotalFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc1(#$T0, #$R)));

// _System._#TotalFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0) ==> Requires1(#$T0, #$R, $OneHeap, f#0, x0#0)));

// _System._#TotalFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h));

function Tclass._System.___hFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hFunc3);

const unique Tagclass._System.___hFunc3: TyTag;

// Tclass._System.___hFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_0(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hFunc3_0(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_1(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hFunc3_1(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_2(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hFunc3_2(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_3(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)));

function Handle3([Heap,Box,Box,Box]Box, [Heap,Box,Box,Box]bool, [Heap,Box,Box,Box]Set Box)
   : HandleType;

function Apply3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Box;

function Requires3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : bool;

function Reads3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)
     == h[heap, bx0, bx1, bx2]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  r[heap, bx0, bx1, bx2]
     ==> Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx: Box :: 
  { Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx] } 
  Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx]
     == rd[heap, bx0, bx1, bx2][bx]);

function {:inline} Requires3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

function {:inline} Reads3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// empty-reads property for Reads3 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     ==> (Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
       <==> Set#Equal(Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2), Set#Empty(): Set Box)));

// empty-reads property for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
     ==> Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)), $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, t3) } { $IsBox(bx, u3) } 
        $IsBox(bx, t3) ==> $IsBox(bx, u3))
     ==> $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box :: 
        { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
          { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
           ==> (forall r: ref :: 
            { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)] } 
            r != null && Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsAllocBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3, h)));

function Tclass._System.___hPartialFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hPartialFunc3);

const unique Tagclass._System.___hPartialFunc3: TyTag;

// Tclass._System.___hPartialFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_0(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc3_0(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_1(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc3_1(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_2(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc3_2(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_3(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hPartialFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#PartialFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Set#Equal(Reads3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hTotalFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hTotalFunc3);

const unique Tagclass._System.___hTotalFunc3: TyTag;

// Tclass._System.___hTotalFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_0(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc3_0(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_1(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc3_1(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_2(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc3_2(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_3(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hTotalFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#TotalFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Requires3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0)));

// _System._#TotalFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hFunc4);

const unique Tagclass._System.___hFunc4: TyTag;

// Tclass._System.___hFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_0(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hFunc4_0(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_1(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hFunc4_1(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_2(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hFunc4_2(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_3(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hFunc4_3(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_4(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

function Handle4([Heap,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Box;

function Requires4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : bool;

function Reads4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)
     == h[heap, bx0, bx1, bx2, bx3]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  r[heap, bx0, bx1, bx2, bx3]
     ==> Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx: Box :: 
  { Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx] } 
  Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx]
     == rd[heap, bx0, bx1, bx2, bx3][bx]);

function {:inline} Requires4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

function {:inline} Reads4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// empty-reads property for Reads4 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     ==> (Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set Box)));

// empty-reads property for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
     ==> Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)), $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, t4) } { $IsBox(bx, u4) } 
        $IsBox(bx, t4) ==> $IsBox(bx, u4))
     ==> $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
        { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
          { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
           ==> (forall r: ref :: 
            { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)] } 
            r != null && Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsAllocBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4, h)));

function Tclass._System.___hPartialFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hPartialFunc4);

const unique Tagclass._System.___hPartialFunc4: TyTag;

// Tclass._System.___hPartialFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_0(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc4_0(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_1(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc4_1(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_2(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc4_2(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_3(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc4_3(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_4(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hPartialFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#PartialFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Set#Equal(Reads4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hTotalFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hTotalFunc4);

const unique Tagclass._System.___hTotalFunc4: TyTag;

// Tclass._System.___hTotalFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_0(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc4_0(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_1(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc4_1(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_2(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc4_2(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_3(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc4_3(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_4(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hTotalFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#TotalFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Requires4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0)));

// _System._#TotalFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hFunc5);

const unique Tagclass._System.___hFunc5: TyTag;

// Tclass._System.___hFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_0(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hFunc5_0(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_1(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hFunc5_1(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_2(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hFunc5_2(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_3(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hFunc5_3(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_4(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hFunc5_4(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_5(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

function Handle5([Heap,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Box;

function Requires5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : bool;

function Reads5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } 
  Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)
     == h[heap, bx0, bx1, bx2, bx3, bx4]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } 
  r[heap, bx0, bx1, bx2, bx3, bx4]
     ==> Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx: Box :: 
  { Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx] } 
  Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4][bx]);

function {:inline} Requires5#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box)
   : bool
{
  true
}

function {:inline} Reads5#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box)
   : bool
{
  true
}

// frame axiom for Reads5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Reads5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Apply5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Apply5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// empty-reads property for Reads5 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } 
    { Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
     ==> (Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } 
    { Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)
     ==> Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty :: 
  { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) } 
  $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
      { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
         ==> $IsBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty :: 
  { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)), $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)) } 
  $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, t5) } { $IsBox(bx, u5) } 
        $IsBox(bx, t5) ==> $IsBox(bx, u5))
     ==> $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
        { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
          { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
           ==> (forall r: ref :: 
            { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)] } 
            r != null
                 && Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
      { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
         ==> $IsAllocBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5, h)));

function Tclass._System.___hPartialFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hPartialFunc5);

const unique Tagclass._System.___hPartialFunc5: TyTag;

// Tclass._System.___hPartialFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_0(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc5_0(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_1(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc5_1(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_2(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc5_2(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_3(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc5_3(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_4(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc5_4(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_5(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hPartialFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

// _System._#PartialFunc5: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
           ==> Set#Equal(Reads5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc5: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

function Tclass._System.___hTotalFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hTotalFunc5);

const unique Tagclass._System.___hTotalFunc5: TyTag;

// Tclass._System.___hTotalFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_0(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc5_0(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_1(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc5_1(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_2(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc5_2(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_3(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc5_3(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_4(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc5_4(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_5(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hTotalFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

// _System._#TotalFunc5: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
           ==> Requires5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0)));

// _System._#TotalFunc5: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

function Tclass._System.___hFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hFunc6);

const unique Tagclass._System.___hFunc6: TyTag;

// Tclass._System.___hFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_0(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hFunc6_0(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_1(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hFunc6_1(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_2(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hFunc6_2(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_3(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hFunc6_3(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_4(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hFunc6_4(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_5(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hFunc6_5(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_6(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

function Handle6([Heap,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : Box;

function Requires6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : bool;

function Reads6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Apply6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5) } 
  Apply6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Requires6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5]
     ==> Requires6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx: Box :: 
  { Reads6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)[bx] } 
  Reads6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5][bx]);

function {:inline} Requires6#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box)
   : bool
{
  true
}

function {:inline} Reads6#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box)
   : bool
{
  true
}

// frame axiom for Reads6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Reads6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Apply6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Apply6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// empty-reads property for Reads6 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } 
    { Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
     ==> (Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } 
    { Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty :: 
  { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) } 
  $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
      { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
         ==> $IsBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty :: 
  { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)), $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)) } 
  $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, t6) } { $IsBox(bx, u6) } 
        $IsBox(bx, t6) ==> $IsBox(bx, u6))
     ==> $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
        { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
          { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
           ==> (forall r: ref :: 
            { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)] } 
            r != null
                 && Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
      { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
         ==> $IsAllocBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6, h)));

function Tclass._System.___hPartialFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hPartialFunc6);

const unique Tagclass._System.___hPartialFunc6: TyTag;

// Tclass._System.___hPartialFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_0(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc6_0(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_1(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc6_1(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_2(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc6_2(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_3(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc6_3(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_4(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc6_4(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_5(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc6_5(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_6(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hPartialFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

// _System._#PartialFunc6: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
           ==> Set#Equal(Reads6(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc6: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h));

function Tclass._System.___hTotalFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hTotalFunc6);

const unique Tagclass._System.___hTotalFunc6: TyTag;

// Tclass._System.___hTotalFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_0(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc6_0(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_1(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc6_1(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_2(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc6_2(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_3(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc6_3(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_4(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc6_4(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_5(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc6_5(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_6(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hTotalFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

// _System._#TotalFunc6: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
           ==> Requires6(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0)));

// _System._#TotalFunc6: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h));

function Tclass._System.___hFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hFunc7);

const unique Tagclass._System.___hFunc7: TyTag;

// Tclass._System.___hFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_0(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hFunc7_0(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_1(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hFunc7_1(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_2(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hFunc7_2(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_3(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hFunc7_3(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_4(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hFunc7_4(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_5(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hFunc7_5(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_6(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hFunc7_6(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_7(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

function Handle7([Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Box;

function Requires7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : bool;

function Reads7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Apply7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6) } 
  Apply7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Requires7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6]
     ==> Requires7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx: Box :: 
  { Reads7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)[bx] } 
  Reads7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6][bx]);

function {:inline} Requires7#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box)
   : bool
{
  true
}

function {:inline} Reads7#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box)
   : bool
{
  true
}

// frame axiom for Reads7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Reads7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Apply7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Apply7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// empty-reads property for Reads7 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), $IsGoodHeap(heap) } 
    { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
     ==> (Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Requires7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), $IsGoodHeap(heap) } 
    { Requires7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, t7: Ty :: 
  { $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7)) } 
  $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
      { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && $IsBox(bx6, t6)
           && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
         ==> $IsBox(Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
          t7)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty, 
    u7: Ty :: 
  { $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7)), $Is(f, Tclass._System.___hFunc7(u0, u1, u2, u3, u4, u5, u6, u7)) } 
  $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u6) } { $IsBox(bx, t6) } 
        $IsBox(bx, u6) ==> $IsBox(bx, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, t7) } { $IsBox(bx, u7) } 
        $IsBox(bx, t7) ==> $IsBox(bx, u7))
     ==> $Is(f, Tclass._System.___hFunc7(u0, u1, u2, u3, u4, u5, u6, u7)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
        { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
          { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && 
            $IsBox(bx6, t6)
             && $IsAllocBox(bx6, t6, h)
             && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
           ==> (forall r: ref :: 
            { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(r)] } 
            r != null
                 && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
      { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && $IsAllocBox(bx6, t6, h)
           && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
         ==> $IsAllocBox(Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
          t7, 
          h)));

function Tclass._System.___hPartialFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hPartialFunc7);

const unique Tagclass._System.___hPartialFunc7: TyTag;

// Tclass._System.___hPartialFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_0(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc7_0(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_1(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc7_1(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_2(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc7_2(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_3(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc7_3(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_4(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc7_4(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_5(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc7_5(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_6(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hPartialFunc7_6(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_7(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hPartialFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

// _System._#PartialFunc7: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box, x6#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
           ==> Set#Equal(Reads7(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$T6, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0, 
              x6#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc7: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), $h));

function Tclass._System.___hTotalFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hTotalFunc7);

const unique Tagclass._System.___hTotalFunc7: TyTag;

// Tclass._System.___hTotalFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_0(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc7_0(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_1(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc7_1(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_2(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc7_2(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_3(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc7_3(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_4(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc7_4(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_5(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc7_5(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_6(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hTotalFunc7_6(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_7(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hTotalFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

// _System._#TotalFunc7: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     <==> $Is(f#0, 
        Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box, x6#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
           ==> Requires7(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$T6, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0, 
            x6#0)));

// _System._#TotalFunc7: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h));

// Constructor function declaration
function #_System._tuple#2._#Make2(Box, Box) : DatatypeType;

const unique ##_System._tuple#2._#Make2: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#_System._tuple#2._#Make2(a#0#0#0, a#0#1#0))
     == ##_System._tuple#2._#Make2);

function _System.Tuple2.___hMake2_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#2._#Make2);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     ==> (exists a#1#0#0: Box, a#1#1#0: Box :: 
      d == #_System._tuple#2._#Make2(a#1#0#0, a#1#1#0)));

function Tclass._System.Tuple2(Ty, Ty) : Ty;

// Tclass._System.Tuple2 Tag
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tag(Tclass._System.Tuple2(#$T0, #$T1)) == Tagclass._System.Tuple2);

const unique Tagclass._System.Tuple2: TyTag;

// Tclass._System.Tuple2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_0(Tclass._System.Tuple2(#$T0, #$T1)) == #$T0);

function Tclass._System.Tuple2_0(Ty) : Ty;

// Tclass._System.Tuple2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_1(Tclass._System.Tuple2(#$T0, #$T1)) == #$T1);

function Tclass._System.Tuple2_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.Tuple2
axiom (forall #$T0: Ty, #$T1: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple2(#$T0, #$T1)));

// Constructor $Is
axiom (forall #$T0: Ty, #$T1: Ty, a#2#0#0: Box, a#2#1#0: Box :: 
  { $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1))
     <==> $IsBox(a#2#0#0, #$T0) && $IsBox(a#2#1#0, #$T1));

// Constructor $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, a#3#0#0: Box, a#3#1#0: Box, $h: Heap :: 
  { $IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
      Tclass._System.Tuple2(#$T0, #$T1), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
        Tclass._System.Tuple2(#$T0, #$T1), 
        $h)
       <==> $IsAllocBox(a#3#0#0, #$T0, $h) && $IsAllocBox(a#3#1#0, #$T1, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T0: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._0(d), #$T0, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T1: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._0(d), #$T0, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T1: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._1(d), #$T1, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T0: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._1(d), #$T1, $h));

// Constructor literal
axiom (forall a#4#0#0: Box, a#4#1#0: Box :: 
  { #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#_System._tuple#2._#Make2(a#4#0#0, a#4#1#0)));

// Constructor injectivity
axiom (forall a#5#0#0: Box, a#5#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#5#0#0, a#5#1#0) } 
  _System.Tuple2._0(#_System._tuple#2._#Make2(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: Box, a#6#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#6#0#0, a#6#1#0) } 
  BoxRank(a#6#0#0) < DtRank(#_System._tuple#2._#Make2(a#6#0#0, a#6#1#0)));

// Constructor injectivity
axiom (forall a#7#0#0: Box, a#7#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#7#0#0, a#7#1#0) } 
  _System.Tuple2._1(#_System._tuple#2._#Make2(a#7#0#0, a#7#1#0)) == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: Box, a#8#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#8#0#0, a#8#1#0) } 
  BoxRank(a#8#1#0) < DtRank(#_System._tuple#2._#Make2(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#_System.Tuple2(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple2(d) } 
  $IsA#_System.Tuple2(d) ==> _System.Tuple2.___hMake2_q(d));

// Questionmark data type disjunctivity
axiom (forall #$T0: Ty, #$T1: Ty, d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d), $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) ==> _System.Tuple2.___hMake2_q(d));

// Datatype extensional equality declaration
function _System.Tuple2#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#2._#Make2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  true
     ==> (_System.Tuple2#Equal(a, b)
       <==> _System.Tuple2._0(a) == _System.Tuple2._0(b)
         && _System.Tuple2._1(a) == _System.Tuple2._1(b)));

// Datatype extensionality axiom: _System._tuple#2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  _System.Tuple2#Equal(a, b) <==> a == b);

const unique class._System.Tuple2: ClassName;

// Constructor function declaration
function #_System._tuple#0._#Make0() : DatatypeType;

const unique ##_System._tuple#0._#Make0: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#_System._tuple#0._#Make0()) == ##_System._tuple#0._#Make0;

function _System.Tuple0.___hMake0_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#0._#Make0);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d) ==> d == #_System._tuple#0._#Make0());

function Tclass._System.Tuple0() : Ty;

// Tclass._System.Tuple0 Tag
axiom Tag(Tclass._System.Tuple0()) == Tagclass._System.Tuple0;

const unique Tagclass._System.Tuple0: TyTag;

// Box/unbox axiom for Tclass._System.Tuple0
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple0()) } 
  $IsBox(bx, Tclass._System.Tuple0())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple0()));

// Constructor $Is
axiom $Is(#_System._tuple#0._#Make0(), Tclass._System.Tuple0());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h));

// Constructor literal
axiom #_System._tuple#0._#Make0() == Lit(#_System._tuple#0._#Make0());

// Depth-one case-split function
function $IsA#_System.Tuple0(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple0(d) } 
  $IsA#_System.Tuple0(d) ==> _System.Tuple0.___hMake0_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d), $Is(d, Tclass._System.Tuple0()) } 
  $Is(d, Tclass._System.Tuple0()) ==> _System.Tuple0.___hMake0_q(d));

// Datatype extensional equality declaration
function _System.Tuple0#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#0._#Make0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  true ==> (_System.Tuple0#Equal(a, b) <==> true));

// Datatype extensionality axiom: _System._tuple#0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  _System.Tuple0#Equal(a, b) <==> a == b);

const unique class._System.Tuple0: ClassName;

const BaseFuel_Sequences._default.NoDupes: LayerType;

const StartFuel_Sequences._default.NoDupes: LayerType;

const StartFuelAssert_Sequences._default.NoDupes: LayerType;

const BaseFuel_Sequences._default.Range: LayerType;

const StartFuel_Sequences._default.Range: LayerType;

const StartFuelAssert_Sequences._default.Range: LayerType;

const BaseFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuelAssert_Sequences._default.ApplyOpaque: LayerType;

const BaseFuel_Sequences._default.remove: LayerType;

const StartFuel_Sequences._default.remove: LayerType;

const StartFuelAssert_Sequences._default.remove: LayerType;

const BaseFuel_Sequences._default.insert: LayerType;

const StartFuel_Sequences._default.insert: LayerType;

const StartFuelAssert_Sequences._default.insert: LayerType;

const BaseFuel_Sequences._default.replace1with2: LayerType;

const StartFuel_Sequences._default.replace1with2: LayerType;

const StartFuelAssert_Sequences._default.replace1with2: LayerType;

const BaseFuel_Sequences._default.replace2with1: LayerType;

const StartFuel_Sequences._default.replace2with1: LayerType;

const StartFuelAssert_Sequences._default.replace2with1: LayerType;

const BaseFuel_Sequences._default.concat: LayerType;

const StartFuel_Sequences._default.concat: LayerType;

const StartFuelAssert_Sequences._default.concat: LayerType;

const BaseFuel_Sequences._default.concat3: LayerType;

const StartFuel_Sequences._default.concat3: LayerType;

const StartFuelAssert_Sequences._default.concat3: LayerType;

const BaseFuel_Sequences._default.concatSeq: LayerType;

const StartFuel_Sequences._default.concatSeq: LayerType;

const StartFuelAssert_Sequences._default.concatSeq: LayerType;

const BaseFuel_Sequences._default.IsPrefix: LayerType;

const StartFuel_Sequences._default.IsPrefix: LayerType;

const StartFuelAssert_Sequences._default.IsPrefix: LayerType;

const BaseFuel_Sequences._default.IsSuffix: LayerType;

const StartFuel_Sequences._default.IsSuffix: LayerType;

const StartFuelAssert_Sequences._default.IsSuffix: LayerType;

const BaseFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexIterate: LayerType;

const BaseFuel_Sequences._default.SeqIndex: LayerType;

const StartFuel_Sequences._default.SeqIndex: LayerType;

const StartFuelAssert_Sequences._default.SeqIndex: LayerType;

const BaseFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuelAssert_Sequences._default.SeqOfLength: LayerType;

const BaseFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexUpdate: LayerType;

const BaseFuel_Sequences._default.Zip: LayerType;

const StartFuel_Sequences._default.Zip: LayerType;

const StartFuelAssert_Sequences._default.Zip: LayerType;

const BaseFuel_Sequences._default.Unzip: LayerType;

const StartFuel_Sequences._default.Unzip: LayerType;

const StartFuelAssert_Sequences._default.Unzip: LayerType;

const BaseFuel_Sequences._default.FlattenShape: LayerType;

const StartFuel_Sequences._default.FlattenShape: LayerType;

const StartFuelAssert_Sequences._default.FlattenShape: LayerType;

const BaseFuel_Sequences._default.FlattenLength: LayerType;

const StartFuel_Sequences._default.FlattenLength: LayerType;

const StartFuelAssert_Sequences._default.FlattenLength: LayerType;

const BaseFuel_Sequences._default.Flatten: LayerType;

const StartFuel_Sequences._default.Flatten: LayerType;

const StartFuelAssert_Sequences._default.Flatten: LayerType;

const BaseFuel_Sequences._default.fill: LayerType;

const StartFuel_Sequences._default.fill: LayerType;

const StartFuelAssert_Sequences._default.fill: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const BaseFuel_JournalRanges._default.parseHeader: LayerType;

const StartFuel_JournalRanges._default.parseHeader: LayerType;

const StartFuelAssert_JournalRanges._default.parseHeader: LayerType;

const BaseFuel_JournalRanges._default.WeightJournalEntries: LayerType;

const StartFuel_JournalRanges._default.WeightJournalEntries: LayerType;

const StartFuelAssert_JournalRanges._default.WeightJournalEntries: LayerType;

const BaseFuel_Maps._default.MapRemove: LayerType;

const StartFuel_Maps._default.MapRemove: LayerType;

const StartFuelAssert_Maps._default.MapRemove: LayerType;

const BaseFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuelAssert_Maps._default.MapRemoveStrong: LayerType;

const BaseFuel_Maps._default.MapRemove1: LayerType;

const StartFuel_Maps._default.MapRemove1: LayerType;

const StartFuelAssert_Maps._default.MapRemove1: LayerType;

const BaseFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuelAssert_Maps._default.MapRemove1Strong: LayerType;

const BaseFuel_Maps._default.IMapRemove: LayerType;

const StartFuel_Maps._default.IMapRemove: LayerType;

const StartFuelAssert_Maps._default.IMapRemove: LayerType;

const BaseFuel_Maps._default.IMapRemove1: LayerType;

const StartFuel_Maps._default.IMapRemove1: LayerType;

const StartFuelAssert_Maps._default.IMapRemove1: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion: LayerType;

const BaseFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferA: LayerType;

const BaseFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferB: LayerType;

const BaseFuel_Maps._default.MapUnion: LayerType;

const StartFuel_Maps._default.MapUnion: LayerType;

const StartFuelAssert_Maps._default.MapUnion: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferA: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferB: LayerType;

const BaseFuel_Maps._default.IMapUnion: LayerType;

const StartFuel_Maps._default.IMapUnion: LayerType;

const StartFuelAssert_Maps._default.IMapUnion: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion3: LayerType;

const BaseFuel_AsyncDisk._default.ChecksumChecksOut: LayerType;

const StartFuel_AsyncDisk._default.ChecksumChecksOut: LayerType;

const StartFuelAssert_AsyncDisk._default.ChecksumChecksOut: LayerType;

const BaseFuel_AsyncDisk._default.splice: LayerType;

const StartFuel_AsyncDisk._default.splice: LayerType;

const StartFuelAssert_AsyncDisk._default.splice: LayerType;

const BaseFuel_JournalBytes._default.JournalBlockOfByteSeq: LayerType;

const StartFuel_JournalBytes._default.JournalBlockOfByteSeq: LayerType;

const StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq: LayerType;

const BaseFuel_JournalBytes._default.JournalRangeOfByteSeq: LayerType;

const StartFuel_JournalBytes._default.JournalRangeOfByteSeq: LayerType;

const StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq: LayerType;

const BaseFuel_SeqComparison._default.lte: LayerType;

const StartFuel_SeqComparison._default.lte: LayerType;

const StartFuelAssert_SeqComparison._default.lte: LayerType;

const unique class.JournalistParsingImpl.__default: ClassName;

function Tclass.JournalistParsingImpl.__default() : Ty;

// Tclass.JournalistParsingImpl.__default Tag
axiom Tag(Tclass.JournalistParsingImpl.__default())
   == Tagclass.JournalistParsingImpl.__default;

const unique Tagclass.JournalistParsingImpl.__default: TyTag;

// Box/unbox axiom for Tclass.JournalistParsingImpl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalistParsingImpl.__default()) } 
  $IsBox(bx, Tclass.JournalistParsingImpl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalistParsingImpl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalistParsingImpl.__default()) } 
  $Is($o, Tclass.JournalistParsingImpl.__default())
     <==> $o == null || dtype($o) == Tclass.JournalistParsingImpl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalistParsingImpl.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalistParsingImpl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function Tclass.NativeTypes.byte() : Ty;

// Tclass.NativeTypes.byte Tag
axiom Tag(Tclass.NativeTypes.byte()) == Tagclass.NativeTypes.byte;

const unique Tagclass.NativeTypes.byte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.byte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.byte()) } 
  $IsBox(bx, Tclass.NativeTypes.byte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.byte()));

function Tclass.Options.Option(Ty) : Ty;

// Tclass.Options.Option Tag
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tag(Tclass.Options.Option(Options.Option$V)) == Tagclass.Options.Option);

const unique Tagclass.Options.Option: TyTag;

// Tclass.Options.Option injectivity 0
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tclass.Options.Option_0(Tclass.Options.Option(Options.Option$V))
     == Options.Option$V);

function Tclass.Options.Option_0(Ty) : Ty;

// Box/unbox axiom for Tclass.Options.Option
axiom (forall Options.Option$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.Options.Option(Options.Option$V)) } 
  $IsBox(bx, Tclass.Options.Option(Options.Option$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Options.Option(Options.Option$V)));

procedure CheckWellformed$$JournalistParsingImpl.__default.computeJournalBlockOfByteSeq(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616)
   returns (jb#0: DatatypeType
       where $Is(jb#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jb#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistParsingImpl.__default.computeJournalBlockOfByteSeq(s#0: Seq Box, i#0: int) returns (jb#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##s#0: Seq Box;

    // AddMethodImpl: computeJournalBlockOfByteSeq, CheckWellformed$$JournalistParsingImpl.__default.computeJournalBlockOfByteSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(34,9): initial state"} true;
    assume Seq#Length(s#0) < 18446744073709551615;
    assume i#0 + 4096 <= Seq#Length(s#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc jb#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(38,13): post-state"} true;
    assert 0 <= i#0 && i#0 <= Seq#Length(s#0);
    newtype$check#0 := LitInt(4096);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := i#0 + 4096;
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assert i#0 <= i#0 + 4096 && i#0 + 4096 <= Seq#Length(s#0);
    ##s#0 := Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume JournalBytes.__default.JournalBlockOfByteSeq#canCall(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0));
    assume Options.Option#Equal(jb#0, 
      JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
        Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0)));
}



procedure Call$$JournalistParsingImpl.__default.computeJournalBlockOfByteSeq(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616)
   returns (jb#0: DatatypeType
       where $Is(jb#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jb#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())), $Heap));
  // user-defined preconditions
  requires Seq#Length(s#0) < 18446744073709551615;
  requires i#0 + 4096 <= Seq#Length(s#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(jb#0)
     && $IsA#Options.Option(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
        Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0)))
     && JournalBytes.__default.JournalBlockOfByteSeq#canCall(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0));
  ensures Options.Option#Equal(jb#0, 
    JournalBytes.__default.JournalBlockOfByteSeq(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq, 
      Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistParsingImpl.__default.computeJournalBlockOfByteSeq(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616)
   returns (jb#0: DatatypeType
       where $Is(jb#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jb#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    $_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  // user-defined preconditions
  requires Seq#Length(s#0) < 18446744073709551615;
  requires i#0 + 4096 <= Seq#Length(s#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(jb#0)
     && $IsA#Options.Option(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
        Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0)))
     && JournalBytes.__default.JournalBlockOfByteSeq#canCall(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0));
  ensures Options.Option#Equal(jb#0, 
    JournalBytes.__default.JournalBlockOfByteSeq(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq, 
      Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistParsingImpl.__default.computeJournalBlockOfByteSeq(s#0: Seq Box, i#0: int) returns (jb#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var s##0: Seq Box;
  var i##0: int;
  var j##0: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var k##0: int;
  var l##0: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var s##1: Seq Box;
  var i##1: int;
  var j##1: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var k##1: int;
  var l##1: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var chunk#0: Seq Box
     where $Is(chunk#0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(chunk#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var c#0: Seq Box
     where $Is(c#0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(c#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var ##t#0: Seq Box;
  var newtype$check#20: int;
  var newtype$check#21: int;

    // AddMethodImpl: computeJournalBlockOfByteSeq, Impl$$JournalistParsingImpl.__default.computeJournalBlockOfByteSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(39,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(40,33)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalBytes.__default.reveal__JournalBlockOfByteSeq();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(40,34)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(42,26)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    s##0 := s#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    i##0 := i#0;
    newtype$check#2 := LitInt(4096);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := i#0 + 4096;
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    j##0 := i#0 + 4096;
    assume true;
    // ProcessCallStmt: CheckSubrange
    k##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    l##0 := LitInt(32);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Sequences.__default.lemma__seq__slice__slice(Tclass.NativeTypes.byte(), s##0, i##0, j##0, k##0, l##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(42,62)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(43,5)
    assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(s#0);
    newtype$check#4 := LitInt(32);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    newtype$check#5 := i#0 + 32;
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assert {:subsumption 0} i#0 <= i#0 + 32 && i#0 + 32 <= Seq#Length(s#0);
    assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(s#0);
    newtype$check#6 := LitInt(4096);
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    newtype$check#7 := i#0 + 4096;
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assert {:subsumption 0} i#0 <= i#0 + 4096 && i#0 + 4096 <= Seq#Length(s#0);
    assert {:subsumption 0} 0 <= LitInt(0)
       && LitInt(0) <= Seq#Length(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0));
    assert {:subsumption 0} LitInt(0) <= LitInt(32)
       && LitInt(32) <= Seq#Length(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0));
    assume true;
    assert Seq#Equal(Seq#Drop(Seq#Take(s#0, i#0 + 32), i#0), 
      Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0), LitInt(32)), LitInt(0)));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(46,26)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    s##1 := s#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    i##1 := i#0;
    newtype$check#8 := LitInt(4096);
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    newtype$check#9 := i#0 + 4096;
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    j##1 := i#0 + 4096;
    assume true;
    // ProcessCallStmt: CheckSubrange
    k##1 := LitInt(32);
    assume true;
    // ProcessCallStmt: CheckSubrange
    l##1 := LitInt(4096);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Sequences.__default.lemma__seq__slice__slice(Tclass.NativeTypes.byte(), s##1, i##1, j##1, k##1, l##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(46,65)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(47,5)
    newtype$check#10 := LitInt(32);
    assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
    newtype$check#11 := i#0 + 32;
    assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
    assert {:subsumption 0} 0 <= i#0 + 32 && i#0 + 32 <= Seq#Length(s#0);
    newtype$check#12 := LitInt(4096);
    assert LitInt(0) <= newtype$check#12 && newtype$check#12 < 18446744073709551616;
    newtype$check#13 := i#0 + 4096;
    assert LitInt(0) <= newtype$check#13 && newtype$check#13 < 18446744073709551616;
    assert {:subsumption 0} i#0 + 32 <= i#0 + 4096 && i#0 + 4096 <= Seq#Length(s#0);
    assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(s#0);
    newtype$check#14 := LitInt(4096);
    assert LitInt(0) <= newtype$check#14 && newtype$check#14 < 18446744073709551616;
    newtype$check#15 := i#0 + 4096;
    assert LitInt(0) <= newtype$check#15 && newtype$check#15 < 18446744073709551616;
    assert {:subsumption 0} i#0 <= i#0 + 4096 && i#0 + 4096 <= Seq#Length(s#0);
    assert {:subsumption 0} 0 <= LitInt(32)
       && LitInt(32) <= Seq#Length(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0));
    assert {:subsumption 0} LitInt(32) <= LitInt(4096)
       && LitInt(4096) <= Seq#Length(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0));
    assume true;
    assert Seq#Equal(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0 + 32), 
      Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0), LitInt(4096)), LitInt(32)));
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(50,15)
    assume true;
    newtype$check#16 := LitInt(32);
    assert LitInt(0) <= newtype$check#16 && newtype$check#16 < 18446744073709551616;
    newtype$check#17 := i#0 + 32;
    assert LitInt(0) <= newtype$check#17 && newtype$check#17 < 18446744073709551616;
    assert 0 <= i#0 + 32 && i#0 + 32 <= Seq#Length(s#0);
    newtype$check#18 := LitInt(4096);
    assert LitInt(0) <= newtype$check#18 && newtype$check#18 < 18446744073709551616;
    newtype$check#19 := i#0 + 4096;
    assert LitInt(0) <= newtype$check#19 && newtype$check#19 < 18446744073709551616;
    assert i#0 + 32 <= i#0 + 4096 && i#0 + 4096 <= Seq#Length(s#0);
    assume true;
    chunk#0 := Seq#Drop(Seq#Take(s#0, i#0 + 4096), i#0 + 32);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(50,38)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(51,31)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$AsyncDisk.__default.reveal__ChecksumChecksOut();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(51,32)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(52,11)
    assume true;
    ##t#0 := chunk#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##t#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Crypto.__default.Crc32C#canCall(chunk#0);
    assume Crypto.__default.Crc32C#canCall(chunk#0);
    c#0 := Crypto.__default.Crc32C(chunk#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(52,26)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(53,5)
    assert 0 <= i#0 && i#0 <= Seq#Length(s#0);
    newtype$check#20 := LitInt(32);
    assert LitInt(0) <= newtype$check#20 && newtype$check#20 < 18446744073709551616;
    newtype$check#21 := i#0 + 32;
    assert LitInt(0) <= newtype$check#21 && newtype$check#21 < 18446744073709551616;
    assert i#0 <= i#0 + 32 && i#0 + 32 <= Seq#Length(s#0);
    assume true;
    if (Seq#Equal(c#0, Seq#Drop(Seq#Take(s#0, i#0 + 32), i#0)))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(54,10)
        assume true;
        assume true;
        jb#0 := #Options.Option.Some($Box(chunk#0));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(54,23)"} true;
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(56,10)
        assume true;
        assume true;
        jb#0 := Lit(#Options.Option.None());
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(56,16)"} true;
    }
}



procedure CheckWellformed$$JournalistParsingImpl.__default.computeJournalRangeOfByteSeq(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), $Heap));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistParsingImpl.__default.computeJournalRangeOfByteSeq(s#0: Seq Box) returns (res#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##s#0: Seq Box;
  var i#0: int;

    // AddMethodImpl: computeJournalRangeOfByteSeq, CheckWellformed$$JournalistParsingImpl.__default.computeJournalRangeOfByteSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(60,9): initial state"} true;
    assume Seq#Length(s#0) < 18446744073709551616;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(63,14): post-state"} true;
    ##s#0 := s#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0);
    assume Options.Option#Equal(res#0, 
      JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0));
    if (*)
    {
        assume Options.Option.Some_q(res#0);
        havoc i#0;
        if (*)
        {
            assume LitInt(0) <= i#0;
            assert Options.Option.Some_q(res#0);
            assume i#0 < Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box);
            assert Options.Option.Some_q(res#0);
            assert 0 <= i#0 && i#0 < Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box);
            assume Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#0)): Seq Box)
               == LitInt(4064);
        }
        else
        {
            assume LitInt(0) <= i#0
                 && i#0 < Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
               ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#0)): Seq Box)
                 == LitInt(4064);
        }

        assume (forall i#1: int :: 
          { $Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#1)): Seq Box } 
          LitInt(0) <= i#1
               && i#1 < Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
             ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#1)): Seq Box)
               == LitInt(4064));
    }
    else
    {
        assume Options.Option.Some_q(res#0)
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#1)): Seq Box } 
            LitInt(0) <= i#1
                 && i#1 < Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
               ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#1)): Seq Box)
                 == LitInt(4064));
    }
}



procedure Call$$JournalistParsingImpl.__default.computeJournalRangeOfByteSeq(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), $Heap));
  // user-defined preconditions
  requires Seq#Length(s#0) < 18446744073709551616;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(res#0)
     && $IsA#Options.Option(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))
     && JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0);
  ensures Options.Option#Equal(res#0, 
    JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, s#0));
  free ensures true;
  ensures Options.Option.Some_q(res#0)
     ==> (forall i#1: int :: 
      { $Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#1)): Seq Box } 
      LitInt(0) <= i#1
           && i#1 < Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
         ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#1)): Seq Box)
           == LitInt(4064));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistParsingImpl.__default.computeJournalRangeOfByteSeq(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte()))), $Heap), 
    $_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  // user-defined preconditions
  requires Seq#Length(s#0) < 18446744073709551616;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(res#0)
     && $IsA#Options.Option(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))
     && JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0);
  ensures Options.Option#Equal(res#0, 
    JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, s#0));
  free ensures true;
  ensures Options.Option.Some_q(res#0)
     ==> (forall i#1: int :: 
      { $Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#1)): Seq Box } 
      LitInt(0) <= i#1
           && i#1 < Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
         ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(res#0)): Seq Box, i#1)): Seq Box)
           == LitInt(4064));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistParsingImpl.__default.computeJournalRangeOfByteSeq(s#0: Seq Box) returns (res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var numBlocks#0: int
     where LitInt(0) <= numBlocks#0 && numBlocks#0 < 18446744073709551616;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var i#2: int where LitInt(0) <= i#2 && i#2 < 18446744073709551616;
  var ar#0: ref
     where $Is(ar#0, Tclass._System.array?(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(ar#0, Tclass._System.array?(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var $nw: ref;
  var ##s#1_1_0: Seq Box;
  var newtype$check#1_2_0: int;
  var newtype$check#1_2_1: int;
  var ##s#1_2_0: Seq Box;
  var ##s#1_2_1: Seq Box;
  var newtype$check#1_0: int;
  var newtype$check#1_1: int;
  var ##s#1_0: Seq Box;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var ##s#1: Seq Box;
  var j#0: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var $decr$loop#00: int;
  var cur#2_0: Seq Box
     where $Is(cur#2_0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(cur#2_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var newtype$check#2_0: int;
  var newtype$check#2_1: int;
  var block#2_0: DatatypeType
     where $Is(block#2_0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(block#2_0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var $rhs##2_0: DatatypeType
     where $Is($rhs##2_0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc($rhs##2_0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var s##2_0: Seq Box;
  var i##2_0: int;
  var newtype$check#2_2: int;
  var newtype$check#2_3: int;
  var newtype$check#2_4: int;
  var newtype$check#2_5: int;
  var newtype$check#2_6: int;
  var newtype$check#2_7: int;
  var newtype$check#2_8: int;
  var newtype$check#2_9: int;
  var newtype$check#2_10: int;
  var newtype$check#2_11: int;
  var newtype$check#2_12: int;
  var newtype$check#2_13: int;
  var newtype$check#2_14: int;
  var newtype$check#2_15: int;
  var newtype$check#2_16: int;
  var newtype$check#2_17: int;
  var $rhs#2_0_0: Seq Box where $Is($rhs#2_0_0, TSeq(Tclass.NativeTypes.byte()));
  var newtype$check#2_0_0_1_0: int;
  var newtype$check#2_0_0_1_1: int;
  var ##s#2_0_0_1_0: Seq Box;
  var newtype$check#2_0_0_0: int;
  var newtype$check#2_0_0_1: int;
  var ##s#2_0_0_0: Seq Box;
  var ##s#2_0: Seq Box;
  var ##s#2_1: Seq Box;
  var a##2_1_0: Seq Box;
  var numBlocks##2_1_0: int;
  var split##2_1_0: int;
  var newtype$check#12: int;

    // AddMethodImpl: computeJournalRangeOfByteSeq, Impl$$JournalistParsingImpl.__default.computeJournalRangeOfByteSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(66,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(67,5)
    newtype$check#0 := Seq#Length(s#0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := LitInt(4096);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assert LitInt(4096) != 0;
    newtype$check#2 := Mod(Seq#Length(s#0), LitInt(4096));
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := LitInt(0);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume true;
    if (Mod(Seq#Length(s#0), LitInt(4096)) != 0)
    {
        // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(68,7)
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(68,7)
        assume true;
        assume true;
        res#0 := Lit(#Options.Option.None());
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(68,17)"} true;
        return;
    }
    else
    {
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(70,19)
    assume true;
    newtype$check#4 := Seq#Length(s#0);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    newtype$check#5 := LitInt(4096);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assert LitInt(4096) != 0;
    newtype$check#6 := Div(Seq#Length(s#0), LitInt(4096));
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assume true;
    numBlocks#0 := Div(Seq#Length(s#0), LitInt(4096));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(70,41)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(71,11)
    assume true;
    assume true;
    i#2 := numBlocks#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(71,22)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(72,12)
    assume true;
    assert 0 <= numBlocks#0;
    havoc $nw;
    assume $nw != null
       && dtype($nw) == Tclass._System.array?(TSeq(Tclass.NativeTypes.byte()));
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == numBlocks#0;
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    ar#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(72,41)"} true;
    // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
    // Assume Fuel Constant
    if (*)
    {
        // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        newtype$check#1_0 := LitInt(4096);
        assert LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < 18446744073709551616;
        newtype$check#1_1 := Mul(LitInt(4096), i#2);
        assert LitInt(0) <= newtype$check#1_1 && newtype$check#1_1 < 18446744073709551616;
        assert {:subsumption 0} 0 <= Mul(LitInt(4096), i#2) && Mul(LitInt(4096), i#2) <= Seq#Length(s#0);
        ##s#1_0 := Seq#Drop(s#0, Mul(LitInt(4096), i#2));
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#1_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
        assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        newtype$check#1_2_0 := LitInt(4096);
        assume LitInt(0) <= newtype$check#1_2_0 && newtype$check#1_2_0 < 18446744073709551616;
        newtype$check#1_2_1 := Mul(LitInt(4096), i#2);
        assume LitInt(0) <= newtype$check#1_2_1 && newtype$check#1_2_1 < 18446744073709551616;
        assume {:subsumption 0} 0 <= Mul(LitInt(4096), i#2) && Mul(LitInt(4096), i#2) <= Seq#Length(s#0);
        ##s#1_2_0 := Seq#Drop(s#0, Mul(LitInt(4096), i#2));
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#1_2_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
        assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
        // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        ##s#1_2_1 := Lit(Seq#Empty(): Seq Box);
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#1_2_1, TSeq(Tclass.NativeTypes.byte()), $Heap);
        assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Lit(Seq#Empty(): Seq Box));
        assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Lit(Seq#Empty(): Seq Box));
        // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        assert {:subsumption 0} Options.Option#Equal(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, 
            Seq#Drop(s#0, Mul(LitInt(4096), i#2))), 
          JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, 
            Lit(Seq#Empty(): Seq Box)));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        ##s#1_1_0 := Lit(Seq#Empty(): Seq Box);
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#1_1_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Lit(Seq#Empty(): Seq Box));
        assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Lit(Seq#Empty(): Seq Box));
        // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(77,37)
        // TrCallStmt: Before ProcessCallStmt
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$JournalBytes.__default.reveal__JournalRangeOfByteSeq();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(77,38)"} true;
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        assume true;
        // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        assert {:subsumption 0} Options.Option#Equal(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, 
            Lit(Seq#Empty(): Seq Box)), 
          #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box))));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        assume true;
        // ----- Hint2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(79,9)
        assert ar#0 != null;
        assert {:subsumption 0} 0 <= i#2 && i#2 <= _System.array.Length(ar#0);
        assume true;
        assert Seq#Equal(Seq#Drop(Seq#FromArray($Heap, ar#0), i#2), Seq#Empty(): Seq Box);
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        assert ar#0 != null;
        assert {:subsumption 0} 0 <= i#2 && i#2 <= _System.array.Length(ar#0);
        assume true;
        // ----- assert line2 == line3 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(74,5)
        assert {:subsumption 0} Options.Option#Equal(#Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box))), 
          #Options.Option.Some($Box(Seq#Drop(Seq#FromArray($Heap, ar#0), i#2))));
        assume false;
    }

    assume Options.Option#Equal(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, 
        Seq#Drop(s#0, Mul(LitInt(4096), i#2))), 
      #Options.Option.Some($Box(Seq#Drop(Seq#FromArray($Heap, ar#0), i#2))));
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(83,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := i#2 - 0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= i#2;
      invariant $w$loop#0 ==> i#2 <= numBlocks#0;
      free invariant $w$loop#0
         ==> $IsA#Options.Option(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, 
              Seq#Drop(s#0, Mul(LitInt(4096), i#2))))
           && JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
      invariant $w$loop#0
         ==> Options.Option#Equal(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, 
            Seq#Drop(s#0, Mul(LitInt(4096), i#2))), 
          #Options.Option.Some($Box(Seq#Drop(Seq#FromArray($Heap, ar#0), i#2))));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(read($Heap, ar#0, IndexField(j#1))): Seq Box } 
          LitInt(0) <= j#1
               && j#1 < 18446744073709551616
               && 
              i#2 <= j#1
               && j#1 < numBlocks#0
             ==> Seq#Length($Unbox(read($Heap, ar#0, IndexField(j#1))): Seq Box) == LitInt(4064));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant i#2 - 0 <= $decr_init$loop#00 && (i#2 - 0 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(83,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            newtype$check#7 := LitInt(0);
            assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
            if (LitInt(0) <= i#2)
            {
            }

            assume true;
            assume LitInt(0) <= i#2 && i#2 <= numBlocks#0;
            newtype$check#8 := LitInt(4096);
            assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
            newtype$check#9 := Mul(LitInt(4096), i#2);
            assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
            assert {:subsumption 0} 0 <= Mul(LitInt(4096), i#2) && Mul(LitInt(4096), i#2) <= Seq#Length(s#0);
            ##s#1 := Seq#Drop(s#0, Mul(LitInt(4096), i#2));
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
            assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
            assert ar#0 != null;
            assert {:subsumption 0} 0 <= i#2 && i#2 <= _System.array.Length(ar#0);
            assume $IsA#Options.Option(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, 
                  Seq#Drop(s#0, Mul(LitInt(4096), i#2))))
               && JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
            assume Options.Option#Equal(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, 
                Seq#Drop(s#0, Mul(LitInt(4096), i#2))), 
              #Options.Option.Some($Box(Seq#Drop(Seq#FromArray($Heap, ar#0), i#2))));
            havoc j#0;
            assume LitInt(0) <= j#0 && j#0 < 18446744073709551616;
            // Begin Comprehension WF check
            if (i#2 <= j#0)
            {
            }

            if (i#2 <= j#0 && j#0 < numBlocks#0)
            {
                assert ar#0 != null;
                assert {:subsumption 0} 0 <= j#0 && j#0 < _System.array.Length(ar#0);
            }

            // End Comprehension WF check
            assume true;
            assume (forall j#1: int :: 
              { $Unbox(read($Heap, ar#0, IndexField(j#1))): Seq Box } 
              LitInt(0) <= j#1
                   && j#1 < 18446744073709551616
                   && 
                  i#2 <= j#1
                   && j#1 < numBlocks#0
                 ==> Seq#Length($Unbox(read($Heap, ar#0, IndexField(j#1))): Seq Box) == LitInt(4064));
            newtype$check#10 := LitInt(0);
            assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#11 := LitInt(0);
        assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
        assume true;
        if (0 >= i#2)
        {
            break;
        }

        $decr$loop#00 := i#2 - 0;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(88,21)
        assume true;
        assert ar#0 != null;
        assert 0 <= i#2 && i#2 <= _System.array.Length(ar#0);
        assume true;
        cur#2_0 := Seq#Drop(Seq#FromArray($Heap, ar#0), i#2);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(88,30)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(90,9)
        assume true;
        newtype$check#2_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#2_0 && newtype$check#2_0 < 18446744073709551616;
        newtype$check#2_1 := i#2 - 1;
        assert LitInt(0) <= newtype$check#2_1 && newtype$check#2_1 < 18446744073709551616;
        assume true;
        i#2 := i#2 - 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(90,16)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(91,48)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<JournalBlock>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        s##2_0 := s#0;
        newtype$check#2_2 := LitInt(4096);
        assert LitInt(0) <= newtype$check#2_2 && newtype$check#2_2 < 18446744073709551616;
        newtype$check#2_3 := Mul(LitInt(4096), i#2);
        assert LitInt(0) <= newtype$check#2_3 && newtype$check#2_3 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        i##2_0 := Mul(LitInt(4096), i#2);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##2_0 := Call$$JournalistParsingImpl.__default.computeJournalBlockOfByteSeq(s##2_0, i##2_0);
        // TrCallStmt: After ProcessCallStmt
        block#2_0 := $rhs##2_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(91,58)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(92,7)
        newtype$check#2_4 := LitInt(4096);
        assert LitInt(0) <= newtype$check#2_4 && newtype$check#2_4 < 18446744073709551616;
        newtype$check#2_5 := Mul(LitInt(4096), i#2);
        assert LitInt(0) <= newtype$check#2_5 && newtype$check#2_5 < 18446744073709551616;
        assert {:subsumption 0} 0 <= Mul(LitInt(4096), i#2) && Mul(LitInt(4096), i#2) <= Seq#Length(s#0);
        newtype$check#2_6 := LitInt(4096);
        assert LitInt(0) <= newtype$check#2_6 && newtype$check#2_6 < 18446744073709551616;
        newtype$check#2_7 := LitInt(1);
        assert LitInt(0) <= newtype$check#2_7 && newtype$check#2_7 < 18446744073709551616;
        newtype$check#2_8 := i#2 + 1;
        assert LitInt(0) <= newtype$check#2_8 && newtype$check#2_8 < 18446744073709551616;
        newtype$check#2_9 := Mul(LitInt(4096), i#2 + 1);
        assert LitInt(0) <= newtype$check#2_9 && newtype$check#2_9 < 18446744073709551616;
        assert {:subsumption 0} Mul(LitInt(4096), i#2) <= Mul(LitInt(4096), i#2 + 1)
           && Mul(LitInt(4096), i#2 + 1) <= Seq#Length(s#0);
        newtype$check#2_10 := LitInt(4096);
        assert LitInt(0) <= newtype$check#2_10 && newtype$check#2_10 < 18446744073709551616;
        newtype$check#2_11 := Mul(LitInt(4096), i#2);
        assert LitInt(0) <= newtype$check#2_11 && newtype$check#2_11 < 18446744073709551616;
        assert {:subsumption 0} 0 <= Mul(LitInt(4096), i#2) && Mul(LitInt(4096), i#2) <= Seq#Length(s#0);
        assert {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= Seq#Length(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
        assert {:subsumption 0} LitInt(0) <= LitInt(4096)
           && LitInt(4096) <= Seq#Length(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
        assume true;
        assert Seq#Equal(Seq#Drop(Seq#Take(s#0, Mul(LitInt(4096), i#2 + 1)), Mul(LitInt(4096), i#2)), 
          Seq#Drop(Seq#Take(Seq#Drop(s#0, Mul(LitInt(4096), i#2)), LitInt(4096)), LitInt(0)));
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(94,7)
        newtype$check#2_12 := LitInt(4096);
        assert LitInt(0) <= newtype$check#2_12 && newtype$check#2_12 < 18446744073709551616;
        newtype$check#2_13 := LitInt(1);
        assert LitInt(0) <= newtype$check#2_13 && newtype$check#2_13 < 18446744073709551616;
        newtype$check#2_14 := i#2 + 1;
        assert LitInt(0) <= newtype$check#2_14 && newtype$check#2_14 < 18446744073709551616;
        newtype$check#2_15 := Mul(LitInt(4096), i#2 + 1);
        assert LitInt(0) <= newtype$check#2_15 && newtype$check#2_15 < 18446744073709551616;
        assert {:subsumption 0} 0 <= Mul(LitInt(4096), i#2 + 1) && Mul(LitInt(4096), i#2 + 1) <= Seq#Length(s#0);
        newtype$check#2_16 := LitInt(4096);
        assert LitInt(0) <= newtype$check#2_16 && newtype$check#2_16 < 18446744073709551616;
        newtype$check#2_17 := Mul(LitInt(4096), i#2);
        assert LitInt(0) <= newtype$check#2_17 && newtype$check#2_17 < 18446744073709551616;
        assert {:subsumption 0} 0 <= Mul(LitInt(4096), i#2) && Mul(LitInt(4096), i#2) <= Seq#Length(s#0);
        assert {:subsumption 0} 0 <= LitInt(4096)
           && LitInt(4096) <= Seq#Length(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
        assume true;
        assert Seq#Equal(Seq#Drop(s#0, Mul(LitInt(4096), i#2 + 1)), 
          Seq#Drop(Seq#Drop(s#0, Mul(LitInt(4096), i#2)), LitInt(4096)));
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(96,7)
        assume true;
        if (Options.Option.Some_q(block#2_0))
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(97,9)
            assert Options.Option.Some_q(block#2_0);
            assume true;
            if (*)
            {
                // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(97,9)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(98,44)
                // TrCallStmt: Before ProcessCallStmt
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$JournalBytes.__default.reveal__JournalBlockOfByteSeq();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(98,45)"} true;
                assert Seq#Length($Unbox(Options.Option.value(block#2_0)): Seq Box) == LitInt(4064);
                assume false;
            }

            assume Seq#Length($Unbox(Options.Option.value(block#2_0)): Seq Box) == LitInt(4064);
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(99,15)
            assert ar#0 != null;
            assert 0 <= i#2 && i#2 < _System.array.Length(ar#0);
            assume true;
            assert $_Frame[ar#0, IndexField(i#2)];
            assert Options.Option.Some_q(block#2_0);
            assume true;
            $rhs#2_0_0 := $Unbox(Options.Option.value(block#2_0)): Seq Box;
            $Heap := update($Heap, ar#0, IndexField(i#2), $Box($rhs#2_0_0));
            assume $IsGoodHeap($Heap);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(99,28)"} true;
            // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
            // Assume Fuel Constant
            if (*)
            {
                // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
                newtype$check#2_0_0_0 := LitInt(4096);
                assert LitInt(0) <= newtype$check#2_0_0_0
                   && newtype$check#2_0_0_0 < 18446744073709551616;
                newtype$check#2_0_0_1 := Mul(LitInt(4096), i#2);
                assert LitInt(0) <= newtype$check#2_0_0_1
                   && newtype$check#2_0_0_1 < 18446744073709551616;
                assert {:subsumption 0} 0 <= Mul(LitInt(4096), i#2) && Mul(LitInt(4096), i#2) <= Seq#Length(s#0);
                ##s#2_0_0_0 := Seq#Drop(s#0, Mul(LitInt(4096), i#2));
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#2_0_0_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
                assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
                assume false;
            }
            else if (*)
            {
                // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
                newtype$check#2_0_0_1_0 := LitInt(4096);
                assume LitInt(0) <= newtype$check#2_0_0_1_0
                   && newtype$check#2_0_0_1_0 < 18446744073709551616;
                newtype$check#2_0_0_1_1 := Mul(LitInt(4096), i#2);
                assume LitInt(0) <= newtype$check#2_0_0_1_1
                   && newtype$check#2_0_0_1_1 < 18446744073709551616;
                assume {:subsumption 0} 0 <= Mul(LitInt(4096), i#2) && Mul(LitInt(4096), i#2) <= Seq#Length(s#0);
                ##s#2_0_0_1_0 := Seq#Drop(s#0, Mul(LitInt(4096), i#2));
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#2_0_0_1_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
                assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
                // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(103,41)
                // TrCallStmt: Before ProcessCallStmt
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$JournalBytes.__default.reveal__JournalRangeOfByteSeq();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(103,42)"} true;
                // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
                assert Options.Option.Some_q(block#2_0);
                assume true;
                // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
                assert {:subsumption 0} Options.Option#Equal(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, 
                    Seq#Drop(s#0, Mul(LitInt(4096), i#2))), 
                  #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, Options.Option.value(block#2_0)), cur#2_0))));
                assume false;
            }
            else if (*)
            {
                // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
                assume Options.Option.Some_q(block#2_0);
                assume true;
                // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(105,13)
                assert ar#0 != null;
                assert {:subsumption 0} 0 <= i#2 && i#2 <= _System.array.Length(ar#0);
                assert ar#0 != null;
                assert {:subsumption 0} 0 <= i#2 && i#2 < _System.array.Length(ar#0);
                assume true;
                assert Seq#Equal(Seq#Drop(Seq#FromArray($Heap, ar#0), i#2), 
                  Seq#Append(Seq#Build(Seq#Empty(): Seq Box, read($Heap, ar#0, IndexField(i#2))), cur#2_0));
                // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
                assert ar#0 != null;
                assert {:subsumption 0} 0 <= i#2 && i#2 <= _System.array.Length(ar#0);
                assume true;
                // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(101,9)
                assert {:subsumption 0} Options.Option#Equal(#Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, Options.Option.value(block#2_0)), cur#2_0))), 
                  #Options.Option.Some($Box(Seq#Drop(Seq#FromArray($Heap, ar#0), i#2))));
                assume false;
            }

            assume Options.Option#Equal(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, 
                Seq#Drop(s#0, Mul(LitInt(4096), i#2))), 
              #Options.Option.Some($Box(Seq#Drop(Seq#FromArray($Heap, ar#0), i#2))));
        }
        else
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(109,9)
            ##s#2_0 := s#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#2_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
            assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0);
            assume $IsA#Options.Option(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0))
               && JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0);
            if (*)
            {
                // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(109,9)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(110,39)
                // TrCallStmt: Before ProcessCallStmt
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$JournalBytes.__default.reveal__JournalRangeOfByteSeq();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(110,40)"} true;
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(111,11)
                ##s#2_1 := s#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#2_1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0);
                assume JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0);
                if (Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, s#0)))
                {
                    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(112,30)
                    // TrCallStmt: Before ProcessCallStmt
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    a##2_1_0 := s#0;
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    numBlocks##2_1_0 := numBlocks#0;
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    split##2_1_0 := i#2;
                    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call Call$$JournalBytes.__default.JournalBytesSplit(a##2_1_0, numBlocks##2_1_0, split##2_1_0);
                    // TrCallStmt: After ProcessCallStmt
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(112,60)"} true;
                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(113,13)
                    assume true;
                    assert false;
                }
                else
                {
                }

                assert {:subsumption 0} Options.Option#Equal(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, s#0), 
                  #Options.Option.None());
                assume false;
            }

            assume Options.Option#Equal(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, s#0), 
              #Options.Option.None());
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(116,9)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(116,9)
            assume true;
            assume true;
            res#0 := Lit(#Options.Option.None());
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(116,19)"} true;
            return;
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(83,5)
        assert 0 <= $decr$loop#00 || i#2 - 0 == $decr$loop#00;
        assert i#2 - 0 < $decr$loop#00;
        assume true;
        assume $IsA#Options.Option(JournalBytes.__default.JournalRangeOfByteSeq(StartFuel_JournalBytes._default.JournalRangeOfByteSeq, 
              Seq#Drop(s#0, Mul(LitInt(4096), i#2))))
           && JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, Mul(LitInt(4096), i#2)));
        assume true;
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(120,5)
    newtype$check#12 := LitInt(0);
    assert LitInt(0) <= newtype$check#12 && newtype$check#12 < 18446744073709551616;
    assume true;
    assert i#2 == LitInt(0);
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(122,9)
    assume true;
    assert ar#0 != null;
    assume true;
    res#0 := #Options.Option.Some($Box(Seq#FromArray($Heap, ar#0)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(122,23)"} true;
}



procedure CheckWellformed$$JournalistParsingImpl.__default.doConcat(s#0: Seq Box
       where $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (t#0: Seq Box
       where $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(t#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistParsingImpl.__default.doConcat(s#0: Seq Box) returns (t#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#0: int;
  var ##a#0: Seq Box;

    // AddMethodImpl: doConcat, CheckWellformed$$JournalistParsingImpl.__default.doConcat
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(125,9): initial state"} true;
    havoc i#0;
    if (*)
    {
        assume LitInt(0) <= i#0;
        assume i#0 < Seq#Length(s#0);
        assert 0 <= i#0 && i#0 < Seq#Length(s#0);
        assume Seq#Length($Unbox(Seq#Index(s#0, i#0)): Seq Box) == LitInt(4064);
    }
    else
    {
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
           ==> Seq#Length($Unbox(Seq#Index(s#0, i#0)): Seq Box) == LitInt(4064);
    }

    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(s#0, i#1)): Seq Box } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(s#0)
         ==> Seq#Length($Unbox(Seq#Index(s#0, i#1)): Seq Box) == LitInt(4064));
    assume Mul(LitInt(4064), Seq#Length(s#0)) < 18446744073709551615;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc t#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(129,12): post-state"} true;
    ##a#0 := s#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##a#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), s#0);
    assume Seq#Equal(t#0, 
      Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.concatSeq, s#0));
}



procedure Call$$JournalistParsingImpl.__default.doConcat(s#0: Seq Box
       where $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (t#0: Seq Box
       where $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(t#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(s#0, i#1)): Seq Box } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(s#0)
       ==> Seq#Length($Unbox(Seq#Index(s#0, i#1)): Seq Box) == LitInt(4064));
  requires Mul(LitInt(4064), Seq#Length(s#0)) < 18446744073709551615;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), s#0);
  ensures Seq#Equal(t#0, 
    Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), StartFuelAssert_Sequences._default.concatSeq, s#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistParsingImpl.__default.doConcat(s#0: Seq Box
       where $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (t#0: Seq Box
       where $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(t#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    $_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  // user-defined preconditions
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(s#0, i#1)): Seq Box } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(s#0)
       ==> Seq#Length($Unbox(Seq#Index(s#0, i#1)): Seq Box) == LitInt(4064));
  requires Mul(LitInt(4064), Seq#Length(s#0)) < 18446744073709551615;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), s#0);
  ensures Seq#Equal(t#0, 
    Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), StartFuelAssert_Sequences._default.concatSeq, s#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistParsingImpl.__default.doConcat(s#0: Seq Box) returns (t#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ar#0: ref
     where $Is(ar#0, Tclass._System.array?(Tclass.NativeTypes.byte()))
       && $IsAlloc(ar#0, Tclass._System.array?(Tclass.NativeTypes.byte()), $Heap);
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var $nw: ref;
  var i#2: int where LitInt(0) <= i#2 && i#2 < 18446744073709551616;
  var newtype$check#3: int;
  var ##a#0_0_0: Seq Box;
  var ##a#0_1_0: Seq Box;
  var ##a#0_1_1: Seq Box;
  var ##a#0_0: Seq Box;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var ##a#1: Seq Box;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var $decr$loop#00: int;
  var src##1_0: Seq Box;
  var srcIndex##1_0: int;
  var newtype$check#1_0: int;
  var dst##1_0: ref;
  var dstIndex##1_0: int;
  var newtype$check#1_1: int;
  var newtype$check#1_2: int;
  var len##1_0: int;
  var newtype$check#1_3: int;
  var ##a#1_0_0_0: Seq Box;
  var newtype$check#1_0_0_0: int;
  var newtype$check#1_0_0_1: int;
  var ##run#1_0_0_0: Seq Box;
  var newtype$check#1_0_0_2: int;
  var newtype$check#1_0_0_3: int;
  var ##run#1_0_0_1: Seq Box;
  var newtype$check#1_0_0_4: int;
  var newtype$check#1_0_0_5: int;
  var ##a#1_0_0_1: Seq Box;
  var newtype$check#1_0_1_0: int;
  var newtype$check#1_0_1_1: int;
  var ##a#1_0_1_0: Seq Box;
  var newtype$check#1_0_2_0: int;
  var newtype$check#1_0_2_1: int;
  var newtype$check#1_0_2_2: int;
  var newtype$check#1_0_2_3: int;
  var newtype$check#1_0_2_4: int;
  var newtype$check#1_0_2_5: int;
  var newtype$check#1_0_0: int;
  var newtype$check#1_0_1: int;
  var newtype$check#1_0_2: int;
  var newtype$check#1_0_3: int;
  var newtype$check#1_4: int;
  var newtype$check#1_5: int;

    // AddMethodImpl: doConcat, Impl$$JournalistParsingImpl.__default.doConcat
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(130,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(131,12)
    assume true;
    newtype$check#0 := LitInt(4064);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := Seq#Length(s#0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := Mul(LitInt(4064), Seq#Length(s#0));
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assert 0 <= Mul(LitInt(4064), Seq#Length(s#0));
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.NativeTypes.byte());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == Mul(LitInt(4064), Seq#Length(s#0));
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    ar#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(131,44)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(132,19)
    assume true;
    newtype$check#3 := LitInt(0);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume true;
    i#2 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(132,22)"} true;
    // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
    // Assume Fuel Constant
    if (*)
    {
        // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
        assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
        ##a#0_0 := Seq#Take(s#0, i#2);
        // assume allocatedness for argument to function
        assume $IsAlloc(##a#0_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
        assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
        assume {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
        ##a#0_1_0 := Seq#Take(s#0, i#2);
        // assume allocatedness for argument to function
        assume $IsAlloc(##a#0_1_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
        assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
        // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
        ##a#0_1_1 := Lit(Seq#Empty(): Seq Box);
        // assume allocatedness for argument to function
        assume $IsAlloc(##a#0_1_1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Lit(Seq#Empty(): Seq Box));
        assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Lit(Seq#Empty(): Seq Box));
        // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
        assert {:subsumption 0} Seq#Equal(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
            StartFuelAssert_Sequences._default.concatSeq, 
            Seq#Take(s#0, i#2)), 
          Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
            StartFuelAssert_Sequences._default.concatSeq, 
            Lit(Seq#Empty(): Seq Box)));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
        ##a#0_0_0 := Lit(Seq#Empty(): Seq Box);
        // assume allocatedness for argument to function
        assume $IsAlloc(##a#0_0_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Lit(Seq#Empty(): Seq Box));
        assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Lit(Seq#Empty(): Seq Box));
        // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(137,25)
        // TrCallStmt: Before ProcessCallStmt
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$Sequences.__default.reveal__concatSeq();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(137,26)"} true;
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
        assume true;
        // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(134,5)
        assert {:subsumption 0} Seq#Equal(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
            StartFuelAssert_Sequences._default.concatSeq, 
            Lit(Seq#Empty(): Seq Box)), 
          Seq#Empty(): Seq Box);
        assume false;
    }

    assume Seq#Equal(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
        StartFuel_Sequences._default.concatSeq, 
        Seq#Take(s#0, i#2)), 
      Seq#Empty(): Seq Box);
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(141,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(s#0) - i#2;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= i#2;
      invariant $w$loop#0 ==> i#2 <= Seq#Length(s#0);
      free invariant $w$loop#0
         ==> Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
      invariant $w$loop#0
         ==> Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, ar#0), Mul(LitInt(4064), i#2)), LitInt(0)), 
          Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
            StartFuelAssert_Sequences._default.concatSeq, 
            Seq#Take(s#0, i#2)));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(s#0) - i#2 <= $decr_init$loop#00
         && (Seq#Length(s#0) - i#2 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(141,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            newtype$check#4 := LitInt(0);
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            if (LitInt(0) <= i#2)
            {
                newtype$check#5 := Seq#Length(s#0);
                assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
            }

            assume true;
            assume LitInt(0) <= i#2 && i#2 <= Seq#Length(s#0);
            assert ar#0 != null;
            assert {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= _System.array.Length(ar#0);
            newtype$check#6 := LitInt(4064);
            assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
            newtype$check#7 := Mul(LitInt(4064), i#2);
            assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
            assert {:subsumption 0} LitInt(0) <= Mul(LitInt(4064), i#2)
               && Mul(LitInt(4064), i#2) <= _System.array.Length(ar#0);
            assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
            ##a#1 := Seq#Take(s#0, i#2);
            // assume allocatedness for argument to function
            assume $IsAlloc(##a#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
            assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
            assume Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, ar#0), Mul(LitInt(4064), i#2)), LitInt(0)), 
              Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.concatSeq, 
                Seq#Take(s#0, i#2)));
            newtype$check#8 := Seq#Length(s#0);
            assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#9 := Seq#Length(s#0);
        assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
        assume true;
        if (Seq#Length(s#0) <= i#2)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(s#0) - i#2;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(145,36)
        // TrCallStmt: Before ProcessCallStmt
        assert 0 <= i#2 && i#2 < Seq#Length(s#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        src##1_0 := $Unbox(Seq#Index(s#0, i#2)): Seq Box;
        newtype$check#1_0 := LitInt(0);
        assert LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        srcIndex##1_0 := LitInt(0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        assert $Is(ar#0, Tclass._System.array(Tclass.NativeTypes.byte()));
        dst##1_0 := ar#0;
        newtype$check#1_1 := LitInt(4064);
        assert LitInt(0) <= newtype$check#1_1 && newtype$check#1_1 < 18446744073709551616;
        newtype$check#1_2 := Mul(i#2, LitInt(4064));
        assert LitInt(0) <= newtype$check#1_2 && newtype$check#1_2 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        dstIndex##1_0 := Mul(i#2, LitInt(4064));
        newtype$check#1_3 := LitInt(4064);
        assert LitInt(0) <= newtype$check#1_3 && newtype$check#1_3 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        len##1_0 := LitInt(4064);
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) && $o == dst##1_0 ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$NativeArrays.__default.CopySeqIntoArray(Tclass.NativeTypes.byte(), src##1_0, srcIndex##1_0, dst##1_0, dstIndex##1_0, len##1_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(145,62)"} true;
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            assert ar#0 != null;
            assert {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= _System.array.Length(ar#0);
            newtype$check#1_0_0 := LitInt(4064);
            assert LitInt(0) <= newtype$check#1_0_0 && newtype$check#1_0_0 < 18446744073709551616;
            newtype$check#1_0_1 := LitInt(1);
            assert LitInt(0) <= newtype$check#1_0_1 && newtype$check#1_0_1 < 18446744073709551616;
            newtype$check#1_0_2 := i#2 + 1;
            assert LitInt(0) <= newtype$check#1_0_2 && newtype$check#1_0_2 < 18446744073709551616;
            newtype$check#1_0_3 := Mul(LitInt(4064), i#2 + 1);
            assert LitInt(0) <= newtype$check#1_0_3 && newtype$check#1_0_3 < 18446744073709551616;
            assert {:subsumption 0} LitInt(0) <= Mul(LitInt(4064), i#2 + 1)
               && Mul(LitInt(4064), i#2 + 1) <= _System.array.Length(ar#0);
            assume true;
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            assume ar#0 != null;
            assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= _System.array.Length(ar#0);
            newtype$check#1_0_2_0 := LitInt(4064);
            assume LitInt(0) <= newtype$check#1_0_2_0
               && newtype$check#1_0_2_0 < 18446744073709551616;
            newtype$check#1_0_2_1 := LitInt(1);
            assume LitInt(0) <= newtype$check#1_0_2_1
               && newtype$check#1_0_2_1 < 18446744073709551616;
            newtype$check#1_0_2_2 := i#2 + 1;
            assume LitInt(0) <= newtype$check#1_0_2_2
               && newtype$check#1_0_2_2 < 18446744073709551616;
            newtype$check#1_0_2_3 := Mul(LitInt(4064), i#2 + 1);
            assume LitInt(0) <= newtype$check#1_0_2_3
               && newtype$check#1_0_2_3 < 18446744073709551616;
            assume {:subsumption 0} LitInt(0) <= Mul(LitInt(4064), i#2 + 1)
               && Mul(LitInt(4064), i#2 + 1) <= _System.array.Length(ar#0);
            assume true;
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            assert ar#0 != null;
            assert {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= _System.array.Length(ar#0);
            newtype$check#1_0_2_4 := LitInt(4064);
            assert LitInt(0) <= newtype$check#1_0_2_4
               && newtype$check#1_0_2_4 < 18446744073709551616;
            newtype$check#1_0_2_5 := Mul(LitInt(4064), i#2);
            assert LitInt(0) <= newtype$check#1_0_2_5
               && newtype$check#1_0_2_5 < 18446744073709551616;
            assert {:subsumption 0} LitInt(0) <= Mul(LitInt(4064), i#2)
               && Mul(LitInt(4064), i#2) <= _System.array.Length(ar#0);
            assert {:subsumption 0} 0 <= i#2 && i#2 < Seq#Length(s#0);
            assume true;
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            assert {:subsumption 0} Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, ar#0), Mul(LitInt(4064), i#2 + 1)), LitInt(0)), 
              Seq#Append(Seq#Drop(Seq#Take(Seq#FromArray($Heap, ar#0), Mul(LitInt(4064), i#2)), LitInt(0)), 
                $Unbox(Seq#Index(s#0, i#2)): Seq Box));
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            assume ar#0 != null;
            assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= _System.array.Length(ar#0);
            newtype$check#1_0_1_0 := LitInt(4064);
            assume LitInt(0) <= newtype$check#1_0_1_0
               && newtype$check#1_0_1_0 < 18446744073709551616;
            newtype$check#1_0_1_1 := Mul(LitInt(4064), i#2);
            assume LitInt(0) <= newtype$check#1_0_1_1
               && newtype$check#1_0_1_1 < 18446744073709551616;
            assume {:subsumption 0} LitInt(0) <= Mul(LitInt(4064), i#2)
               && Mul(LitInt(4064), i#2) <= _System.array.Length(ar#0);
            assume {:subsumption 0} 0 <= i#2 && i#2 < Seq#Length(s#0);
            assume true;
            // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
            ##a#1_0_1_0 := Seq#Take(s#0, i#2);
            // assume allocatedness for argument to function
            assume $IsAlloc(##a#1_0_1_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
            assert {:subsumption 0} 0 <= i#2 && i#2 < Seq#Length(s#0);
            assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
            // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            assert {:subsumption 0} Seq#Equal(Seq#Append(Seq#Drop(Seq#Take(Seq#FromArray($Heap, ar#0), Mul(LitInt(4064), i#2)), LitInt(0)), 
                $Unbox(Seq#Index(s#0, i#2)): Seq Box), 
              Seq#Append(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                  StartFuelAssert_Sequences._default.concatSeq, 
                  Seq#Take(s#0, i#2)), 
                $Unbox(Seq#Index(s#0, i#2)): Seq Box));
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            assume {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
            ##a#1_0_0_0 := Seq#Take(s#0, i#2);
            // assume allocatedness for argument to function
            assume $IsAlloc(##a#1_0_0_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
            assume {:subsumption 0} 0 <= i#2 && i#2 < Seq#Length(s#0);
            assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
            // ----- Hint2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(152,27)
            // TrCallStmt: Before ProcessCallStmt
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$Sequences.__default.reveal__concatSeq();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(152,28)"} true;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(153,11)
            newtype$check#1_0_0_0 := LitInt(1);
            assert LitInt(0) <= newtype$check#1_0_0_0
               && newtype$check#1_0_0_0 < 18446744073709551616;
            newtype$check#1_0_0_1 := i#2 + 1;
            assert LitInt(0) <= newtype$check#1_0_0_1
               && newtype$check#1_0_0_1 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(s#0);
            ##run#1_0_0_0 := Seq#Take(s#0, i#2 + 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1_0_0_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#1_0_0_0) > 0;
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Seq#Take(s#0, i#2 + 1));
            assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Seq#Take(s#0, i#2 + 1));
            assert Seq#Equal(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Seq#Take(s#0, i#2 + 1)), 
              Seq#Take(s#0, i#2));
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(154,11)
            newtype$check#1_0_0_2 := LitInt(1);
            assert LitInt(0) <= newtype$check#1_0_0_2
               && newtype$check#1_0_0_2 < 18446744073709551616;
            newtype$check#1_0_0_3 := i#2 + 1;
            assert LitInt(0) <= newtype$check#1_0_0_3
               && newtype$check#1_0_0_3 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(s#0);
            ##run#1_0_0_1 := Seq#Take(s#0, i#2 + 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1_0_0_1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#1_0_0_1) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Seq#Take(s#0, i#2 + 1));
            assert {:subsumption 0} 0 <= i#2 && i#2 < Seq#Length(s#0);
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Seq#Take(s#0, i#2 + 1));
            assert Seq#Equal($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Seq#Take(s#0, i#2 + 1))): Seq Box, 
              $Unbox(Seq#Index(s#0, i#2)): Seq Box);
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            newtype$check#1_0_0_4 := LitInt(1);
            assert LitInt(0) <= newtype$check#1_0_0_4
               && newtype$check#1_0_0_4 < 18446744073709551616;
            newtype$check#1_0_0_5 := i#2 + 1;
            assert LitInt(0) <= newtype$check#1_0_0_5
               && newtype$check#1_0_0_5 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(s#0);
            ##a#1_0_0_1 := Seq#Take(s#0, i#2 + 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##a#1_0_0_1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2 + 1));
            assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2 + 1));
            // ----- assert line2 == line3 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(147,7)
            assert {:subsumption 0} Seq#Equal(Seq#Append(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                  StartFuelAssert_Sequences._default.concatSeq, 
                  Seq#Take(s#0, i#2)), 
                $Unbox(Seq#Index(s#0, i#2)): Seq Box), 
              Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.concatSeq, 
                Seq#Take(s#0, i#2 + 1)));
            assume false;
        }

        assume Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, ar#0), Mul(LitInt(4064), i#2 + 1)), LitInt(0)), 
          Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
            StartFuel_Sequences._default.concatSeq, 
            Seq#Take(s#0, i#2 + 1)));
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(159,9)
        assume true;
        newtype$check#1_4 := LitInt(1);
        assert LitInt(0) <= newtype$check#1_4 && newtype$check#1_4 < 18446744073709551616;
        newtype$check#1_5 := i#2 + 1;
        assert LitInt(0) <= newtype$check#1_5 && newtype$check#1_5 < 18446744073709551616;
        assume true;
        i#2 := i#2 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(159,16)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(141,5)
        assert 0 <= $decr$loop#00 || Seq#Length(s#0) - i#2 == $decr$loop#00;
        assert Seq#Length(s#0) - i#2 < $decr$loop#00;
        assume true;
        assume Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), Seq#Take(s#0, i#2));
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(162,5)
    assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
    assume true;
    assert Seq#Equal(Seq#Take(s#0, i#2), s#0);
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(163,7)
    assume true;
    assert ar#0 != null;
    assume true;
    t#0 := Seq#FromArray($Heap, ar#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(163,15)"} true;
}



procedure CheckWellformed$$JournalistParsingImpl.__default.ParseHeader(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (nentries#0: int where LitInt(0) <= nentries#0 && nentries#0 < 4294967296, 
    nblocks#0: int where LitInt(0) <= nblocks#0 && nblocks#0 < 4294967296);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistParsingImpl.__default.ParseHeader(s#0: Seq Box) returns (nentries#0: int, nblocks#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##s#0: Seq Box;

    // AddMethodImpl: ParseHeader, CheckWellformed$$JournalistParsingImpl.__default.ParseHeader
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(166,9): initial state"} true;
    assume Seq#Length(s#0) >= LitInt(8);
    assume Seq#Length(s#0) < 18446744073709551616;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc nentries#0, nblocks#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(170,25): post-state"} true;
    ##s#0 := s#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} Seq#Length(##s#0) >= LitInt(8);
    assume Seq#Length(##s#0) >= LitInt(8);
    assume JournalRanges.__default.parseHeader#canCall(s#0);
    assume JournalRanges.Header.Header_q(JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, s#0));
    assume JournalRanges.Header#Equal(JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, s#0), 
      #JournalRanges.Header.Header(nentries#0, nblocks#0));
}



procedure Call$$JournalistParsingImpl.__default.ParseHeader(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (nentries#0: int where LitInt(0) <= nentries#0 && nentries#0 < 4294967296, 
    nblocks#0: int where LitInt(0) <= nblocks#0 && nblocks#0 < 4294967296);
  // user-defined preconditions
  requires Seq#Length(s#0) >= LitInt(8);
  requires Seq#Length(s#0) < 18446744073709551616;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#JournalRanges.Header(JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, s#0))
     && JournalRanges.__default.parseHeader#canCall(s#0);
  ensures JournalRanges.Header#Equal(JournalRanges.__default.parseHeader(StartFuelAssert_JournalRanges._default.parseHeader, s#0), 
    #JournalRanges.Header.Header(nentries#0, nblocks#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistParsingImpl.__default.ParseHeader(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (nentries#0: int where LitInt(0) <= nentries#0 && nentries#0 < 4294967296, 
    nblocks#0: int where LitInt(0) <= nblocks#0 && nblocks#0 < 4294967296, 
    $_reverifyPost: bool);
  free requires 10 == $FunctionContextHeight;
  // user-defined preconditions
  requires Seq#Length(s#0) >= LitInt(8);
  requires Seq#Length(s#0) < 18446744073709551616;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#JournalRanges.Header(JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, s#0))
     && JournalRanges.__default.parseHeader#canCall(s#0);
  ensures JournalRanges.Header#Equal(JournalRanges.__default.parseHeader(StartFuelAssert_JournalRanges._default.parseHeader, s#0), 
    #JournalRanges.Header.Header(nentries#0, nblocks#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistParsingImpl.__default.ParseHeader(s#0: Seq Box) returns (nentries#0: int, nblocks#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs##0: int where LitInt(0) <= $rhs##0 && $rhs##0 < 4294967296;
  var packed##0: Seq Box;
  var idx##0: int;
  var newtype$check#0: int;
  var $rhs##1: int where LitInt(0) <= $rhs##1 && $rhs##1 < 4294967296;
  var packed##1: Seq Box;
  var idx##1: int;
  var newtype$check#1: int;

    // AddMethodImpl: ParseHeader, Impl$$JournalistParsingImpl.__default.ParseHeader
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(171,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(172,23)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$JournalRanges.__default.reveal__parseHeader();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(172,24)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(173,43)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type uint32
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    packed##0 := s#0;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    idx##0 := LitInt(0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$NativePackedInts.__default.Unpack__LittleEndian__Uint32(packed##0, idx##0);
    // TrCallStmt: After ProcessCallStmt
    nentries#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(173,48)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(174,42)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type uint32
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    packed##1 := s#0;
    newtype$check#1 := LitInt(4);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    idx##1 := LitInt(4);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##1 := Call$$NativePackedInts.__default.Unpack__LittleEndian__Uint32(packed##1, idx##1);
    // TrCallStmt: After ProcessCallStmt
    nblocks#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(174,47)"} true;
}



function Tclass.Journal.JournalEntry() : Ty;

// Tclass.Journal.JournalEntry Tag
axiom Tag(Tclass.Journal.JournalEntry()) == Tagclass.Journal.JournalEntry;

const unique Tagclass.Journal.JournalEntry: TyTag;

// Box/unbox axiom for Tclass.Journal.JournalEntry
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Journal.JournalEntry()) } 
  $IsBox(bx, Tclass.Journal.JournalEntry())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Journal.JournalEntry()));

procedure CheckWellformed$$JournalistParsingImpl.__default.ParseJournalRangeOfBytes(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616)
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap));
  free requires 14 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistParsingImpl.__default.ParseJournalRangeOfBytes(s#0: Seq Box, len#0: int) returns (res#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var ##s#0: Seq Box;
  var ##len#0: int;

    // AddMethodImpl: ParseJournalRangeOfBytes, CheckWellformed$$JournalistParsingImpl.__default.ParseJournalRangeOfBytes
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(177,9): initial state"} true;
    if (LitInt(0) <= LitInt(8))
    {
    }

    if (LitInt(0) <= LitInt(8) && LitInt(8) <= Seq#Length(s#0))
    {
    }

    assume LitInt(0) <= LitInt(8)
       && LitInt(8) <= Seq#Length(s#0)
       && Seq#Length(s#0) < 18446744073709551616;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume LitInt(0) <= len#0;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(181,14): post-state"} true;
    ##s#0 := s#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    ##len#0 := len#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##len#0, TInt, $Heap);
    assert {:subsumption 0} Seq#Length(##s#0) >= LitInt(8);
    assume Seq#Length(##s#0) >= LitInt(8);
    assert {:subsumption 0} LitInt(0) <= ##len#0;
    assume LitInt(0) <= ##len#0;
    assume JournalRanges.__default.parseJournalRangeOfBytes#canCall(s#0, len#0);
    assume Options.Option#Equal(res#0, JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0));
    if (*)
    {
        assume Options.Option.Some_q(res#0);
        assert Options.Option.Some_q(res#0);
        assume Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box) <= Seq#Length(s#0);
    }
    else
    {
        assume Options.Option.Some_q(res#0)
           ==> Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box) <= Seq#Length(s#0);
    }
}



procedure Call$$JournalistParsingImpl.__default.ParseJournalRangeOfBytes(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616)
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap));
  // user-defined preconditions
  requires LitInt(0) <= LitInt(8);
  requires LitInt(8) <= Seq#Length(s#0);
  requires Seq#Length(s#0) < 18446744073709551616;
  requires LitInt(0) <= len#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(res#0)
     && $IsA#Options.Option(JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0))
     && JournalRanges.__default.parseJournalRangeOfBytes#canCall(s#0, len#0);
  ensures Options.Option#Equal(res#0, JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0));
  free ensures true;
  ensures Options.Option.Some_q(res#0)
     ==> Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box) <= Seq#Length(s#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistParsingImpl.__default.ParseJournalRangeOfBytes(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616)
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap), 
    $_reverifyPost: bool);
  free requires 14 == $FunctionContextHeight;
  // user-defined preconditions
  requires LitInt(0) <= LitInt(8);
  requires LitInt(8) <= Seq#Length(s#0);
  requires Seq#Length(s#0) < 18446744073709551616;
  requires LitInt(0) <= len#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(res#0)
     && $IsA#Options.Option(JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0))
     && JournalRanges.__default.parseJournalRangeOfBytes#canCall(s#0, len#0);
  ensures Options.Option#Equal(res#0, JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0));
  free ensures true;
  ensures Options.Option.Some_q(res#0)
     ==> Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box) <= Seq#Length(s#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



function Tclass.KeyType.Key() : Ty;

// Tclass.KeyType.Key Tag
axiom Tag(Tclass.KeyType.Key()) == Tagclass.KeyType.Key;

const unique Tagclass.KeyType.Key: TyTag;

// Box/unbox axiom for Tclass.KeyType.Key
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KeyType.Key()) } 
  $IsBox(bx, Tclass.KeyType.Key())
     ==> $Box($Unbox(bx): Seq Box) == bx
       && $Is($Unbox(bx): Seq Box, Tclass.KeyType.Key()));

function Tclass.ValueType.Value() : Ty;

// Tclass.ValueType.Value Tag
axiom Tag(Tclass.ValueType.Value()) == Tagclass.ValueType.Value;

const unique Tagclass.ValueType.Value: TyTag;

// Box/unbox axiom for Tclass.ValueType.Value
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.Value()) } 
  $IsBox(bx, Tclass.ValueType.Value())
     ==> $Box($Unbox(bx): Seq Box) == bx
       && $Is($Unbox(bx): Seq Box, Tclass.ValueType.Value()));

implementation Impl$$JournalistParsingImpl.__default.ParseJournalRangeOfBytes(s#0: Seq Box, len#0: int) returns (res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ar#0: ref
     where $Is(ar#0, Tclass._System.array?(Tclass.Journal.JournalEntry()))
       && $IsAlloc(ar#0, Tclass._System.array?(Tclass.Journal.JournalEntry()), $Heap);
  var $nw: ref;
  var i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616;
  var newtype$check#1: int;
  var idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616;
  var newtype$check#2: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##s#1: Seq Box;
  var ##len#1: int;
  var ##idx#0: int;
  var ##s#2: Seq Box;
  var ##len#2: int;
  var ##idx#1: int;
  var newtype$check#5: int;
  var ##s#3: Seq Box;
  var ##len#3: int;
  var ##idx#2: int;
  var ##s#4: Seq Box;
  var ##len#4: int;
  var ##idx#3: int;
  var ##s#5: Seq Box;
  var ##len#5: int;
  var ##idx#4: int;
  var newtype$check#6: int;
  var ##s#6: Seq Box;
  var ##len#6: int;
  var ##idx#5: int;
  var $decr$loop#00: int;
  var idx0#0_0: int where LitInt(0) <= idx0#0_0 && idx0#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var idx1#0_0: int where LitInt(0) <= idx1#0_0 && idx1#0_0 < 18446744073709551616;
  var newtype$check#0_3: int;
  var newtype$check#0_4: int;
  var keyLen#0_0: int where LitInt(0) <= keyLen#0_0 && keyLen#0_0 < 4294967296;
  var $rhs##0_0: int where LitInt(0) <= $rhs##0_0 && $rhs##0_0 < 4294967296;
  var packed##0_0: Seq Box;
  var idx##0_0: int;
  var newtype$check#0_5: int;
  var newtype$check#0_6: int;
  var newtype$check#0_7: int;
  var newtype$check#0_8: int;
  var newtype$check#0_9: int;
  var newtype$check#0_10: int;
  var newtype$check#0_11: int;
  var newtype$check#0_12: int;
  var key#0_0: Seq Box
     where $Is(key#0_0, Tclass.KeyType.Key())
       && $IsAlloc(key#0_0, Tclass.KeyType.Key(), $Heap);
  var newtype$check#0_13: int;
  var newtype$check#0_14: int;
  var idx2#0_0: int where LitInt(0) <= idx2#0_0 && idx2#0_0 < 18446744073709551616;
  var newtype$check#0_15: int;
  var newtype$check#0_16: int;
  var valueLen#0_0: int where LitInt(0) <= valueLen#0_0 && valueLen#0_0 < 4294967296;
  var $rhs##0_1: int where LitInt(0) <= $rhs##0_1 && $rhs##0_1 < 4294967296;
  var packed##0_1: Seq Box;
  var idx##0_1: int;
  var idx3#0_0: int where LitInt(0) <= idx3#0_0 && idx3#0_0 < 18446744073709551616;
  var newtype$check#0_17: int;
  var newtype$check#0_18: int;
  var newtype$check#0_19: int;
  var newtype$check#0_20: int;
  var newtype$check#0_21: int;
  var newtype$check#0_22: int;
  var value#0_0: Seq Box
     where $Is(value#0_0, Tclass.ValueType.Value())
       && $IsAlloc(value#0_0, Tclass.ValueType.Value(), $Heap);
  var newtype$check#0_23: int;
  var newtype$check#0_24: int;
  var idx4#0_0: int where LitInt(0) <= idx4#0_0 && idx4#0_0 < 18446744073709551616;
  var newtype$check#0_25: int;
  var newtype$check#0_26: int;
  var je#0_0: DatatypeType
     where $Is(je#0_0, Tclass.Journal.JournalEntry())
       && $IsAlloc(je#0_0, Tclass.Journal.JournalEntry(), $Heap);
  var $rhs#0_0: DatatypeType where $Is($rhs#0_0, Tclass.Journal.JournalEntry());
  var newtype$check#0_27: int;
  var newtype$check#0_28: int;
  var newtype$check#1_0_0: int;
  var ##s#1_0_0: Seq Box;
  var ##len#1_0_0: int;
  var ##idx#1_0_0: int;
  var ##s#1_0_1: Seq Box;
  var ##len#1_0_1: int;
  var ##idx#1_0_1: int;
  var newtype$check#1_1_0: int;
  var ##s#1_1_0: Seq Box;
  var ##len#1_1_0: int;
  var ##idx#1_1_0: int;
  var newtype$check#1_1_1: int;
  var ##s#1_1_1: Seq Box;
  var ##len#1_1_1: int;
  var ##idx#1_1_1: int;

    // AddMethodImpl: ParseJournalRangeOfBytes, Impl$$JournalistParsingImpl.__default.ParseJournalRangeOfBytes
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(183,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(184,12)
    assume true;
    assert 0 <= len#0;
    havoc $nw;
    assume $nw != null
       && dtype($nw) == Tclass._System.array?(Tclass.Journal.JournalEntry());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == len#0;
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    ar#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(184,35)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(185,11)
    assume true;
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    i#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(185,14)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(186,13)
    assume true;
    newtype$check#2 := LitInt(8);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    idx#0 := LitInt(8);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(186,16)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(188,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := len#0 - i#0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= i#0;
      invariant $w$loop#0 ==> i#0 <= len#0;
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= idx#0;
      invariant $w$loop#0 ==> idx#0 <= Seq#Length(s#0);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> _System.array.Length(ar#0) == len#0;
      free invariant $w$loop#0
         ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0)
           && (Options.Option.None_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
             ==> 
            Lit(true)
             ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8)));
      invariant $w$loop#0
         ==> 
        Options.Option.None_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
         ==> Lit(true);
      invariant $w$loop#0
         ==> 
        Options.Option.None_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
         ==> Options.Option.None_q(JournalRanges.__default.parseEntries($LS($LS($LZ)), s#0, len#0, LitInt(8)));
      free invariant $w$loop#0
         ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0)
           && (Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
             ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8))
               && (Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)))
                 ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8))
                   && JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0)));
      invariant $w$loop#0
         ==> 
        Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
         ==> Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LS($LZ)), s#0, len#0, LitInt(8)));
      invariant $w$loop#0
         ==> 
        Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
         ==> Seq#Equal($Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LS($LZ)), s#0, len#0, LitInt(8)))): Seq Box, 
          Seq#Append(Seq#Take(Seq#FromArray($Heap, ar#0), i#0), 
            $Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LS($LZ)), s#0, len#0 - i#0, idx#0))): Seq Box));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#0 <= idx#0;
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant len#0 - i#0 <= $decr_init$loop#00
         && (len#0 - i#0 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(188,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            newtype$check#3 := LitInt(0);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            if (LitInt(0) <= i#0)
            {
            }

            assume true;
            assume LitInt(0) <= i#0 && i#0 <= len#0;
            if (LitInt(0) <= idx#0)
            {
            }

            assume true;
            assume LitInt(0) <= idx#0 && idx#0 <= Seq#Length(s#0);
            assert {:subsumption 0} ar#0 != null;
            assume true;
            assume _System.array.Length(ar#0) == len#0;
            newtype$check#4 := len#0 - i#0;
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            ##s#1 := s#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
            ##len#1 := len#0 - i#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##len#1, TInt, $Heap);
            ##idx#0 := idx#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##idx#0, TInt, $Heap);
            assert {:subsumption 0} LitInt(0) <= ##idx#0;
            assert {:subsumption 0} ##idx#0 <= Seq#Length(##s#1);
            assert {:subsumption 0} LitInt(0) <= ##len#1;
            assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0);
            if (Options.Option.None_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0)))
            {
                if (Lit(true))
                {
                    ##s#2 := s#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##s#2, TSeq(Tclass.NativeTypes.byte()), $Heap);
                    ##len#2 := len#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##len#2, TInt, $Heap);
                    ##idx#1 := LitInt(8);
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##idx#1, TInt, $Heap);
                    assert {:subsumption 0} LitInt(0) <= ##idx#1;
                    assert {:subsumption 0} ##idx#1 <= Seq#Length(##s#2);
                    assert {:subsumption 0} LitInt(0) <= ##len#2;
                    assume JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8));
                }
            }

            assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0)
               && (Options.Option.None_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
                 ==> 
                Lit(true)
                 ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8)));
            assume Options.Option.None_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
               ==> true
                 && Options.Option.None_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)));
            newtype$check#5 := len#0 - i#0;
            assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
            ##s#3 := s#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#3, TSeq(Tclass.NativeTypes.byte()), $Heap);
            ##len#3 := len#0 - i#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##len#3, TInt, $Heap);
            ##idx#2 := idx#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##idx#2, TInt, $Heap);
            assert {:subsumption 0} LitInt(0) <= ##idx#2;
            assert {:subsumption 0} ##idx#2 <= Seq#Length(##s#3);
            assert {:subsumption 0} LitInt(0) <= ##len#3;
            assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0);
            if (Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0)))
            {
                ##s#4 := s#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##s#4, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##len#4 := len#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##len#4, TInt, $Heap);
                ##idx#3 := LitInt(8);
                // assume allocatedness for argument to function
                assume $IsAlloc(##idx#3, TInt, $Heap);
                assert {:subsumption 0} LitInt(0) <= ##idx#3;
                assert {:subsumption 0} ##idx#3 <= Seq#Length(##s#4);
                assert {:subsumption 0} LitInt(0) <= ##len#4;
                assume JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8));
                if (Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8))))
                {
                    ##s#5 := s#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##s#5, TSeq(Tclass.NativeTypes.byte()), $Heap);
                    ##len#5 := len#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##len#5, TInt, $Heap);
                    ##idx#4 := LitInt(8);
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##idx#4, TInt, $Heap);
                    assert {:subsumption 0} LitInt(0) <= ##idx#4;
                    assert {:subsumption 0} ##idx#4 <= Seq#Length(##s#5);
                    assert {:subsumption 0} LitInt(0) <= ##len#5;
                    assume JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8));
                    assert Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)));
                    assert ar#0 != null;
                    assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(ar#0);
                    newtype$check#6 := len#0 - i#0;
                    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
                    ##s#6 := s#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##s#6, TSeq(Tclass.NativeTypes.byte()), $Heap);
                    ##len#6 := len#0 - i#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##len#6, TInt, $Heap);
                    ##idx#5 := idx#0;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##idx#5, TInt, $Heap);
                    assert {:subsumption 0} LitInt(0) <= ##idx#5;
                    assert {:subsumption 0} ##idx#5 <= Seq#Length(##s#6);
                    assert {:subsumption 0} LitInt(0) <= ##len#6;
                    assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0);
                    assert Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0));
                }
            }

            assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0)
               && (Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
                 ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8))
                   && (Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)))
                     ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8))
                       && JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0)));
            assume Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
               ==> Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)))
                 && Seq#Equal($Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)))): Seq Box, 
                  Seq#Append(Seq#Take(Seq#FromArray($Heap, ar#0), i#0), 
                    $Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))): Seq Box));
            assume true;
            assume i#0 <= idx#0;
            assume true;
            assume false;
        }

        assume true;
        if (len#0 <= i#0)
        {
            break;
        }

        $decr$loop#00 := len#0 - i#0;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(200,16)
        assume true;
        assume true;
        idx0#0_0 := idx#0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(200,21)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(202,7)
        newtype$check#0_0 := LitInt(4);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := Seq#Length(s#0);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        newtype$check#0_2 := Seq#Length(s#0) - idx0#0_0;
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume true;
        if (!(LitInt(4) <= Seq#Length(s#0) - idx0#0_0))
        {
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(203,9)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(203,9)
            assume true;
            assume true;
            res#0 := Lit(#Options.Option.None());
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(203,19)"} true;
            return;
        }
        else
        {
        }

        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(206,16)
        assume true;
        newtype$check#0_3 := LitInt(4);
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        newtype$check#0_4 := idx0#0_0 + 4;
        assert LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
        assume true;
        idx1#0_0 := idx0#0_0 + 4;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(206,26)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(208,47)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type uint32
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        packed##0_0 := s#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        idx##0_0 := idx0#0_0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$NativePackedInts.__default.Unpack__LittleEndian__Uint32(packed##0_0, idx##0_0);
        // TrCallStmt: After ProcessCallStmt
        keyLen#0_0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(208,55)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(209,7)
        newtype$check#0_5 := LitInt(4);
        assert LitInt(0) <= newtype$check#0_5 && newtype$check#0_5 < 18446744073709551616;
        newtype$check#0_6 := keyLen#0_0;
        assert LitInt(0) <= newtype$check#0_6 && newtype$check#0_6 < 18446744073709551616;
        newtype$check#0_7 := 4 + keyLen#0_0;
        assert LitInt(0) <= newtype$check#0_7 && newtype$check#0_7 < 18446744073709551616;
        newtype$check#0_8 := LitInt(4);
        assert LitInt(0) <= newtype$check#0_8 && newtype$check#0_8 < 18446744073709551616;
        newtype$check#0_9 := 4 + keyLen#0_0 + 4;
        assert LitInt(0) <= newtype$check#0_9 && newtype$check#0_9 < 18446744073709551616;
        newtype$check#0_10 := Seq#Length(s#0);
        assert LitInt(0) <= newtype$check#0_10 && newtype$check#0_10 < 18446744073709551616;
        newtype$check#0_11 := Seq#Length(s#0) - idx#0;
        assert LitInt(0) <= newtype$check#0_11 && newtype$check#0_11 < 18446744073709551616;
        if (4 + keyLen#0_0 + 4 <= Seq#Length(s#0) - idx#0)
        {
            newtype$check#0_12 := keyLen#0_0;
            assert LitInt(0) <= newtype$check#0_12 && newtype$check#0_12 < 18446744073709551616;
            assume KeyType.__default.MaxLen#canCall();
        }

        assume 4 + keyLen#0_0 + 4 <= Seq#Length(s#0) - idx#0
           ==> KeyType.__default.MaxLen#canCall();
        if (!(4 + keyLen#0_0 + 4 <= Seq#Length(s#0) - idx#0
           && keyLen#0_0 <= LitInt(KeyType.__default.MaxLen())))
        {
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(212,9)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(212,9)
            assume true;
            assume true;
            res#0 := Lit(#Options.Option.None());
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(212,19)"} true;
            return;
        }
        else
        {
        }

        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(214,20)
        assume true;
        assert 0 <= idx1#0_0 && idx1#0_0 <= Seq#Length(s#0);
        newtype$check#0_13 := keyLen#0_0;
        assert LitInt(0) <= newtype$check#0_13 && newtype$check#0_13 < 18446744073709551616;
        newtype$check#0_14 := idx1#0_0 + keyLen#0_0;
        assert LitInt(0) <= newtype$check#0_14 && newtype$check#0_14 < 18446744073709551616;
        assert idx1#0_0 <= idx1#0_0 + keyLen#0_0 && idx1#0_0 + keyLen#0_0 <= Seq#Length(s#0);
        assume true;
        assert $Is(Seq#Drop(Seq#Take(s#0, idx1#0_0 + keyLen#0_0), idx1#0_0), Tclass.KeyType.Key());
        key#0_0 := Seq#Drop(Seq#Take(s#0, idx1#0_0 + keyLen#0_0), idx1#0_0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(214,52)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(215,16)
        assume true;
        newtype$check#0_15 := keyLen#0_0;
        assert LitInt(0) <= newtype$check#0_15 && newtype$check#0_15 < 18446744073709551616;
        newtype$check#0_16 := idx1#0_0 + keyLen#0_0;
        assert LitInt(0) <= newtype$check#0_16 && newtype$check#0_16 < 18446744073709551616;
        assume true;
        idx2#0_0 := idx1#0_0 + keyLen#0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(215,41)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(217,37)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type uint32
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        packed##0_1 := s#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        idx##0_1 := idx2#0_0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_1 := Call$$NativePackedInts.__default.Unpack__LittleEndian__Uint32(packed##0_1, idx##0_1);
        // TrCallStmt: After ProcessCallStmt
        valueLen#0_0 := $rhs##0_1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(217,45)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(218,16)
        assume true;
        newtype$check#0_17 := LitInt(4);
        assert LitInt(0) <= newtype$check#0_17 && newtype$check#0_17 < 18446744073709551616;
        newtype$check#0_18 := idx2#0_0 + 4;
        assert LitInt(0) <= newtype$check#0_18 && newtype$check#0_18 < 18446744073709551616;
        assume true;
        idx3#0_0 := idx2#0_0 + 4;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(218,26)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(219,7)
        newtype$check#0_19 := valueLen#0_0;
        assert LitInt(0) <= newtype$check#0_19 && newtype$check#0_19 < 18446744073709551616;
        assume ValueType.__default.MaxLen#canCall();
        if (valueLen#0_0 <= LitInt(ValueType.__default.MaxLen()))
        {
            newtype$check#0_20 := valueLen#0_0;
            assert LitInt(0) <= newtype$check#0_20 && newtype$check#0_20 < 18446744073709551616;
            newtype$check#0_21 := Seq#Length(s#0);
            assert LitInt(0) <= newtype$check#0_21 && newtype$check#0_21 < 18446744073709551616;
            newtype$check#0_22 := Seq#Length(s#0) - idx3#0_0;
            assert LitInt(0) <= newtype$check#0_22 && newtype$check#0_22 < 18446744073709551616;
        }

        assume ValueType.__default.MaxLen#canCall();
        if (!(valueLen#0_0 <= LitInt(ValueType.__default.MaxLen())
           && valueLen#0_0 <= Seq#Length(s#0) - idx3#0_0))
        {
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(222,9)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(222,9)
            assume true;
            assume true;
            res#0 := Lit(#Options.Option.None());
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(222,19)"} true;
            return;
        }
        else
        {
        }

        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(224,24)
        assume true;
        assert 0 <= idx3#0_0 && idx3#0_0 <= Seq#Length(s#0);
        newtype$check#0_23 := valueLen#0_0;
        assert LitInt(0) <= newtype$check#0_23 && newtype$check#0_23 < 18446744073709551616;
        newtype$check#0_24 := idx3#0_0 + valueLen#0_0;
        assert LitInt(0) <= newtype$check#0_24 && newtype$check#0_24 < 18446744073709551616;
        assert idx3#0_0 <= idx3#0_0 + valueLen#0_0
           && idx3#0_0 + valueLen#0_0 <= Seq#Length(s#0);
        assume true;
        assert $Is(Seq#Drop(Seq#Take(s#0, idx3#0_0 + valueLen#0_0), idx3#0_0), 
          Tclass.ValueType.Value());
        value#0_0 := Seq#Drop(Seq#Take(s#0, idx3#0_0 + valueLen#0_0), idx3#0_0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(224,58)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(225,16)
        assume true;
        newtype$check#0_25 := valueLen#0_0;
        assert LitInt(0) <= newtype$check#0_25 && newtype$check#0_25 < 18446744073709551616;
        newtype$check#0_26 := idx3#0_0 + valueLen#0_0;
        assert LitInt(0) <= newtype$check#0_26 && newtype$check#0_26 < 18446744073709551616;
        assume true;
        idx4#0_0 := idx3#0_0 + valueLen#0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(225,43)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(227,14)
        assume true;
        assume true;
        je#0_0 := #Journal.JournalEntry.JournalInsert(key#0_0, value#0_0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(227,41)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(229,13)
        assert ar#0 != null;
        assert 0 <= i#0 && i#0 < _System.array.Length(ar#0);
        assume true;
        assert $_Frame[ar#0, IndexField(i#0)];
        assume true;
        $rhs#0_0 := je#0_0;
        $Heap := update($Heap, ar#0, IndexField(i#0), $Box($rhs#0_0));
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(229,17)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(231,9)
        assume true;
        newtype$check#0_27 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_27 && newtype$check#0_27 < 18446744073709551616;
        newtype$check#0_28 := i#0 + 1;
        assert LitInt(0) <= newtype$check#0_28 && newtype$check#0_28 < 18446744073709551616;
        assume true;
        i#0 := i#0 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(231,16)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(232,11)
        assume true;
        assume true;
        idx#0 := idx4#0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(232,17)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(188,5)
        assert 0 <= $decr$loop#00 || len#0 - i#0 == $decr$loop#00;
        assert len#0 - i#0 < $decr$loop#00;
        assume true;
        assume true;
        assume true;
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0)
           && (Options.Option.None_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
             ==> 
            Lit(true)
             ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8)));
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0)
           && (Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))
             ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8))
               && (Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)))
                 ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8))
                   && JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0)));
        assume true;
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(235,9)
    assume true;
    assert ar#0 != null;
    assume true;
    res#0 := #Options.Option.Some($Box(Seq#FromArray($Heap, ar#0)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(235,23)"} true;
    // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
    // Assume Fuel Constant
    if (*)
    {
        // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
        assert ar#0 != null;
        assume true;
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
        assume ar#0 != null;
        assume true;
        // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(240,9)
        newtype$check#1_1_0 := len#0 - i#0;
        assert LitInt(0) <= newtype$check#1_1_0 && newtype$check#1_1_0 < 18446744073709551616;
        ##s#1_1_0 := s#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#1_1_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        ##len#1_1_0 := len#0 - i#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##len#1_1_0, TInt, $Heap);
        ##idx#1_1_0 := idx#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##idx#1_1_0, TInt, $Heap);
        assert {:subsumption 0} LitInt(0) <= ##idx#1_1_0;
        assert {:subsumption 0} ##idx#1_1_0 <= Seq#Length(##s#1_1_0);
        assert {:subsumption 0} LitInt(0) <= ##len#1_1_0;
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0);
        assert Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0));
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0);
        assert {:subsumption 0} Seq#Equal($Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LS($LZ)), s#0, len#0 - i#0, idx#0))): Seq Box, 
          Seq#Empty(): Seq Box);
        assume Seq#Equal($Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0))): Seq Box, 
          Seq#Empty(): Seq Box);
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
        assert ar#0 != null;
        assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(ar#0);
        newtype$check#1_1_1 := len#0 - i#0;
        assert LitInt(0) <= newtype$check#1_1_1 && newtype$check#1_1_1 < 18446744073709551616;
        ##s#1_1_1 := s#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#1_1_1, TSeq(Tclass.NativeTypes.byte()), $Heap);
        ##len#1_1_1 := len#0 - i#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##len#1_1_1, TInt, $Heap);
        ##idx#1_1_1 := idx#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##idx#1_1_1, TInt, $Heap);
        assert {:subsumption 0} LitInt(0) <= ##idx#1_1_1;
        assert {:subsumption 0} ##idx#1_1_1 <= Seq#Length(##s#1_1_1);
        assert {:subsumption 0} LitInt(0) <= ##len#1_1_1;
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0);
        assert Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0));
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0);
        // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
        assert {:subsumption 0} Seq#Equal(Seq#FromArray($Heap, ar#0), 
          Seq#Append(Seq#Take(Seq#FromArray($Heap, ar#0), i#0), 
            $Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LS($LZ)), s#0, len#0 - i#0, idx#0))): Seq Box));
        assume false;
    }
    else if (*)
    {
        // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
        assume ar#0 != null;
        assume {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(ar#0);
        newtype$check#1_0_0 := len#0 - i#0;
        assume LitInt(0) <= newtype$check#1_0_0 && newtype$check#1_0_0 < 18446744073709551616;
        ##s#1_0_0 := s#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#1_0_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        ##len#1_0_0 := len#0 - i#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##len#1_0_0, TInt, $Heap);
        ##idx#1_0_0 := idx#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##idx#1_0_0, TInt, $Heap);
        assume {:subsumption 0} LitInt(0) <= ##idx#1_0_0;
        assume {:subsumption 0} ##idx#1_0_0 <= Seq#Length(##s#1_0_0);
        assume {:subsumption 0} LitInt(0) <= ##len#1_0_0;
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0);
        assume Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0 - i#0, idx#0));
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0 - i#0, idx#0);
        // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
        // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
        ##s#1_0_1 := s#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##s#1_0_1, TSeq(Tclass.NativeTypes.byte()), $Heap);
        ##len#1_0_1 := len#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##len#1_0_1, TInt, $Heap);
        ##idx#1_0_1 := LitInt(8);
        // assume allocatedness for argument to function
        assume $IsAlloc(##idx#1_0_1, TInt, $Heap);
        assert {:subsumption 0} LitInt(0) <= ##idx#1_0_1;
        assert {:subsumption 0} ##idx#1_0_1 <= Seq#Length(##s#1_0_1);
        assert {:subsumption 0} LitInt(0) <= ##len#1_0_1;
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8));
        assert Options.Option.Some_q(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)));
        assume JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8));
        // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(237,5)
        assert {:subsumption 0} Seq#Equal(Seq#Append(Seq#Take(Seq#FromArray($Heap, ar#0), i#0), 
            $Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LS($LZ)), s#0, len#0 - i#0, idx#0))): Seq Box), 
          $Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LS($LZ)), s#0, len#0, LitInt(8)))): Seq Box);
        assume false;
    }

    assume Seq#Equal(Seq#FromArray($Heap, ar#0), 
      $Unbox(Options.Option.value(JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)))): Seq Box);
}



procedure CheckWellformed$$JournalistParsingImpl.__default.ParseJournalRange(jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap));
  free requires 15 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$JournalistParsingImpl.__default.ParseJournalRange(jr#0: Seq Box) returns (res#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#0: int;
  var ##jr#0: Seq Box;

    // AddMethodImpl: ParseJournalRange, CheckWellformed$$JournalistParsingImpl.__default.ParseJournalRange
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(248,9): initial state"} true;
    havoc i#0;
    if (*)
    {
        assume LitInt(0) <= i#0;
        assume i#0 < Seq#Length(jr#0);
        assert 0 <= i#0 && i#0 < Seq#Length(jr#0);
        assume Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064);
    }
    else
    {
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(jr#0)
           ==> Seq#Length($Unbox(Seq#Index(jr#0, i#0)): Seq Box) == LitInt(4064);
    }

    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
         ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064));
    assume Seq#Length(jr#0) <= LitInt(4294967296);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(252,20): post-state"} true;
    if (*)
    {
        assume Options.Option.Some_q(res#0);
        assert Options.Option.Some_q(res#0);
        assume Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
           <= Mul(Seq#Length(jr#0), LitInt(4064));
    }
    else
    {
        assume Options.Option.Some_q(res#0)
           ==> Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
             <= Mul(Seq#Length(jr#0), LitInt(4064));
    }

    ##jr#0 := jr#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assume JournalRanges.__default.parseJournalRange#canCall(jr#0);
    assume Options.Option#Equal(res#0, JournalRanges.__default.parseJournalRange($LS($LZ), jr#0));
}



procedure Call$$JournalistParsingImpl.__default.ParseJournalRange(jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap));
  // user-defined preconditions
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
       ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064));
  requires Seq#Length(jr#0) <= LitInt(4294967296);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Options.Option.Some_q(res#0)
     ==> Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
       <= Mul(Seq#Length(jr#0), LitInt(4064));
  free ensures $IsA#Options.Option(res#0)
     && $IsA#Options.Option(JournalRanges.__default.parseJournalRange($LS($LZ), jr#0))
     && JournalRanges.__default.parseJournalRange#canCall(jr#0);
  ensures Options.Option#Equal(res#0, JournalRanges.__default.parseJournalRange($LS($LS($LZ)), jr#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$JournalistParsingImpl.__default.ParseJournalRange(jr#0: Seq Box
       where $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (res#0: DatatypeType
       where $Is(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
         && $IsAlloc(res#0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap), 
    $_reverifyPost: bool);
  free requires 15 == $FunctionContextHeight;
  // user-defined preconditions
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(jr#0, i#1)): Seq Box } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(jr#0)
       ==> Seq#Length($Unbox(Seq#Index(jr#0, i#1)): Seq Box) == LitInt(4064));
  requires Seq#Length(jr#0) <= LitInt(4294967296);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Options.Option.Some_q(res#0)
     ==> Seq#Length($Unbox(Options.Option.value(res#0)): Seq Box)
       <= Mul(Seq#Length(jr#0), LitInt(4064));
  free ensures $IsA#Options.Option(res#0)
     && $IsA#Options.Option(JournalRanges.__default.parseJournalRange($LS($LZ), jr#0))
     && JournalRanges.__default.parseJournalRange#canCall(jr#0);
  ensures Options.Option#Equal(res#0, JournalRanges.__default.parseJournalRange($LS($LS($LZ)), jr#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$JournalistParsingImpl.__default.ParseJournalRange(jr#0: Seq Box) returns (res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var nentries#0: int where LitInt(0) <= nentries#0 && nentries#0 < 4294967296;
  var nblocks#0: int where LitInt(0) <= nblocks#0 && nblocks#0 < 4294967296;
  var $rhs##0: int where LitInt(0) <= $rhs##0 && $rhs##0 < 4294967296;
  var $rhs##1: int where LitInt(0) <= $rhs##1 && $rhs##1 < 4294967296;
  var s##0: Seq Box;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var a##1_0: Seq Box;
  var i##1_0: int;
  var a##1_1: Seq Box;
  var t##1_0: int;
  var c#1_0: Seq Box
     where $Is(c#1_0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(c#1_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var $rhs##1_0: Seq Box
     where $Is($rhs##1_0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc($rhs##1_0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var s##1_0: Seq Box;
  var p1#1_0: DatatypeType
     where $Is(p1#1_0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
       && $IsAlloc(p1#1_0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap);
  var $rhs##1_1: DatatypeType
     where $Is($rhs##1_1, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
       && $IsAlloc($rhs##1_1, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap);
  var s##1_1: Seq Box;
  var len##1_0: int;
  var newtype$check#1_0: int;
  var p2#1_0_0: DatatypeType
     where $Is(p2#1_0_0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
       && $IsAlloc(p2#1_0_0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap);
  var $rhs##1_0_0: DatatypeType
     where $Is($rhs##1_0_0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())))
       && $IsAlloc($rhs##1_0_0, Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry())), $Heap);
  var jr##1_0_0: Seq Box;

    // AddMethodImpl: ParseJournalRange, Impl$$JournalistParsingImpl.__default.ParseJournalRange
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_JournalRanges._default.parseHeader)
       == StartFuel_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.parseHeader)
       == StartFuelAssert_JournalRanges._default.parseHeader;
    assume AsFuelBottom(StartFuel_JournalRanges._default.WeightJournalEntries)
       == StartFuel_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuelAssert_JournalRanges._default.WeightJournalEntries)
       == StartFuelAssert_JournalRanges._default.WeightJournalEntries;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.ChecksumChecksOut)
       == StartFuel_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.ChecksumChecksOut)
       == StartFuelAssert_AsyncDisk._default.ChecksumChecksOut;
    assume AsFuelBottom(StartFuel_AsyncDisk._default.splice)
       == StartFuel_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuelAssert_AsyncDisk._default.splice)
       == StartFuelAssert_AsyncDisk._default.splice;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuel_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq;
    assume AsFuelBottom(StartFuel_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuel_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq)
       == StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(254,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(255,5)
    newtype$check#0 := Seq#Length(jr#0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    if (Seq#Length(jr#0) == LitInt(0))
    {
        // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(256,7)
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(256,7)
        assume true;
        assume true;
        res#0 := Lit(#Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box))));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(256,21)"} true;
        return;
    }
    else
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(258,43)
        assume true;
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type uint32
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type uint32
        // TrCallStmt: Before ProcessCallStmt
        assert 0 <= LitInt(0) && LitInt(0) < Seq#Length(jr#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        s##0 := $Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0, $rhs##1 := Call$$JournalistParsingImpl.__default.ParseHeader(s##0);
        // TrCallStmt: After ProcessCallStmt
        nentries#0 := $rhs##0;
        nblocks#0 := $rhs##1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(258,49)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(259,7)
        newtype$check#2 := LitInt(0);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 4294967296;
        if (LitInt(0) <= nentries#0)
        {
            newtype$check#3 := LitInt(1);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            newtype$check#4 := nblocks#0;
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            if (LitInt(1) <= nblocks#0)
            {
                newtype$check#5 := nblocks#0;
                assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
                newtype$check#6 := Seq#Length(jr#0);
                assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
            }
        }

        assume true;
        if (LitInt(0) <= nentries#0
           && 
          LitInt(1) <= nblocks#0
           && nblocks#0 <= Seq#Length(jr#0))
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(262,38)
            // TrCallStmt: Before ProcessCallStmt
            assert 0 <= nblocks#0 && nblocks#0 <= Seq#Length(jr#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            a##1_0 := Seq#Take(jr#0, nblocks#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            i##1_0 := LitInt(0);
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$Sequences.__default.lemma__concatSeqLen__ge__elemLen(Tclass.NativeTypes.byte(), a##1_0, i##1_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(262,56)"} true;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(263,34)
            // TrCallStmt: Before ProcessCallStmt
            assert 0 <= nblocks#0 && nblocks#0 <= Seq#Length(jr#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            a##1_1 := Seq#Take(jr#0, nblocks#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            t##1_0 := LitInt(4064);
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$Sequences.__default.lemma__concatSeqLen__le__mul(Tclass.NativeTypes.byte(), a##1_1, t##1_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(263,55)"} true;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(264,26)
            assume true;
            // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type seq<byte>
            // TrCallStmt: Before ProcessCallStmt
            assert 0 <= nblocks#0 && nblocks#0 <= Seq#Length(jr#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            s##1_0 := Seq#Take(jr#0, nblocks#0);
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call $rhs##1_0 := Call$$JournalistParsingImpl.__default.doConcat(s##1_0);
            // TrCallStmt: After ProcessCallStmt
            c#1_0 := $rhs##1_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(264,41)"} true;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(265,43)
            assume true;
            // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<seq<JournalEntry>>
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            s##1_1 := c#1_0;
            newtype$check#1_0 := nentries#0;
            assert LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            len##1_0 := nentries#0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call $rhs##1_1 := Call$$JournalistParsingImpl.__default.ParseJournalRangeOfBytes(s##1_1, len##1_0);
            // TrCallStmt: After ProcessCallStmt
            p1#1_0 := $rhs##1_1;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(265,65)"} true;
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(266,9)
            assume true;
            if (Options.Option.Some_q(p1#1_0))
            {
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(267,38)
                assume true;
                // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<seq<JournalEntry>>
                // TrCallStmt: Before ProcessCallStmt
                assert 0 <= nblocks#0 && nblocks#0 <= Seq#Length(jr#0);
                assume true;
                // ProcessCallStmt: CheckSubrange
                jr##1_0_0 := Seq#Drop(jr#0, nblocks#0);
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                assert Seq#Rank(jr##1_0_0) < Seq#Rank(jr#0);
                // ProcessCallStmt: Make the call
                call $rhs##1_0_0 := Call$$JournalistParsingImpl.__default.ParseJournalRange(jr##1_0_0);
                // TrCallStmt: After ProcessCallStmt
                p2#1_0_0 := $rhs##1_0_0;
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(267,53)"} true;
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(268,11)
                assume true;
                if (Options.Option.Some_q(p2#1_0_0))
                {
                    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(269,13)
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(269,13)
                    assume true;
                    assert Options.Option.Some_q(p1#1_0);
                    assert Options.Option.Some_q(p2#1_0_0);
                    assume true;
                    res#0 := #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(p1#1_0)): Seq Box, 
                          $Unbox(Options.Option.value(p2#1_0_0)): Seq Box)));
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(269,44)"} true;
                    return;
                }
                else
                {
                    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(271,13)
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(271,13)
                    assume true;
                    assume true;
                    res#0 := Lit(#Options.Option.None());
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(271,23)"} true;
                    return;
                }
            }
            else
            {
                // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(274,11)
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(274,11)
                assume true;
                assume true;
                res#0 := Lit(#Options.Option.None());
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(274,21)"} true;
                return;
            }
        }
        else
        {
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(277,9)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(277,9)
            assume true;
            assume true;
            res#0 := Lit(#Options.Option.None());
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/JournalistParsingImpl.i.dfy(277,19)"} true;
            return;
        }
    }
}



function Tclass.NativeTypes.sbyte() : Ty;

// Tclass.NativeTypes.sbyte Tag
axiom Tag(Tclass.NativeTypes.sbyte()) == Tagclass.NativeTypes.sbyte;

const unique Tagclass.NativeTypes.sbyte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.sbyte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.sbyte()) } 
  $IsBox(bx, Tclass.NativeTypes.sbyte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.sbyte()));

// NativeTypes.sbyte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.sbyte()) } 
  $Is(i#0, Tclass.NativeTypes.sbyte()) <==> LitInt(0 - 128) <= i#0 && i#0 < 128);

// NativeTypes.sbyte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h));

const unique class.NativeTypes.sbyte: ClassName;

// NativeTypes.byte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.byte()) } 
  $Is(i#0, Tclass.NativeTypes.byte()) <==> LitInt(0) <= i#0 && i#0 < 256);

// NativeTypes.byte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h));

const unique class.NativeTypes.byte: ClassName;

function Tclass.NativeTypes.int16() : Ty;

// Tclass.NativeTypes.int16 Tag
axiom Tag(Tclass.NativeTypes.int16()) == Tagclass.NativeTypes.int16;

const unique Tagclass.NativeTypes.int16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int16()) } 
  $IsBox(bx, Tclass.NativeTypes.int16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int16()));

// NativeTypes.int16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int16()) } 
  $Is(i#0, Tclass.NativeTypes.int16())
     <==> LitInt(0 - 32768) <= i#0 && i#0 < 32768);

// NativeTypes.int16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h));

const unique class.NativeTypes.int16: ClassName;

function Tclass.NativeTypes.uint16() : Ty;

// Tclass.NativeTypes.uint16 Tag
axiom Tag(Tclass.NativeTypes.uint16()) == Tagclass.NativeTypes.uint16;

const unique Tagclass.NativeTypes.uint16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint16()) } 
  $IsBox(bx, Tclass.NativeTypes.uint16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint16()));

// NativeTypes.uint16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint16()) } 
  $Is(i#0, Tclass.NativeTypes.uint16()) <==> LitInt(0) <= i#0 && i#0 < 65536);

// NativeTypes.uint16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h));

const unique class.NativeTypes.uint16: ClassName;

function Tclass.NativeTypes.int32() : Ty;

// Tclass.NativeTypes.int32 Tag
axiom Tag(Tclass.NativeTypes.int32()) == Tagclass.NativeTypes.int32;

const unique Tagclass.NativeTypes.int32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int32()) } 
  $IsBox(bx, Tclass.NativeTypes.int32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int32()));

// NativeTypes.int32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int32()) } 
  $Is(i#0, Tclass.NativeTypes.int32())
     <==> LitInt(0 - 2147483648) <= i#0 && i#0 < 2147483648);

// NativeTypes.int32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h));

const unique class.NativeTypes.int32: ClassName;

function Tclass.NativeTypes.uint32() : Ty;

// Tclass.NativeTypes.uint32 Tag
axiom Tag(Tclass.NativeTypes.uint32()) == Tagclass.NativeTypes.uint32;

const unique Tagclass.NativeTypes.uint32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint32()) } 
  $IsBox(bx, Tclass.NativeTypes.uint32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint32()));

// NativeTypes.uint32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint32()) } 
  $Is(i#0, Tclass.NativeTypes.uint32()) <==> LitInt(0) <= i#0 && i#0 < 4294967296);

// NativeTypes.uint32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h));

const unique class.NativeTypes.uint32: ClassName;

function Tclass.NativeTypes.int64() : Ty;

// Tclass.NativeTypes.int64 Tag
axiom Tag(Tclass.NativeTypes.int64()) == Tagclass.NativeTypes.int64;

const unique Tagclass.NativeTypes.int64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int64()) } 
  $IsBox(bx, Tclass.NativeTypes.int64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int64()));

// NativeTypes.int64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int64()) } 
  $Is(i#0, Tclass.NativeTypes.int64())
     <==> LitInt(0 - 9223372036854775808) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.int64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h));

const unique class.NativeTypes.int64: ClassName;

function Tclass.NativeTypes.uint64() : Ty;

// Tclass.NativeTypes.uint64 Tag
axiom Tag(Tclass.NativeTypes.uint64()) == Tagclass.NativeTypes.uint64;

const unique Tagclass.NativeTypes.uint64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint64()) } 
  $IsBox(bx, Tclass.NativeTypes.uint64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint64()));

// NativeTypes.uint64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint64()) } 
  $Is(i#0, Tclass.NativeTypes.uint64())
     <==> LitInt(0) <= i#0 && i#0 < 18446744073709551616);

// NativeTypes.uint64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h));

const unique class.NativeTypes.uint64: ClassName;

function Tclass.NativeTypes.nat8() : Ty;

// Tclass.NativeTypes.nat8 Tag
axiom Tag(Tclass.NativeTypes.nat8()) == Tagclass.NativeTypes.nat8;

const unique Tagclass.NativeTypes.nat8: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat8
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat8()) } 
  $IsBox(bx, Tclass.NativeTypes.nat8())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat8()));

// NativeTypes.nat8: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat8()) } 
  $Is(i#0, Tclass.NativeTypes.nat8()) <==> LitInt(0) <= i#0 && i#0 < 128);

// NativeTypes.nat8: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h));

const unique class.NativeTypes.nat8: ClassName;

function Tclass.NativeTypes.nat16() : Ty;

// Tclass.NativeTypes.nat16 Tag
axiom Tag(Tclass.NativeTypes.nat16()) == Tagclass.NativeTypes.nat16;

const unique Tagclass.NativeTypes.nat16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat16()) } 
  $IsBox(bx, Tclass.NativeTypes.nat16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat16()));

// NativeTypes.nat16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat16()) } 
  $Is(i#0, Tclass.NativeTypes.nat16()) <==> LitInt(0) <= i#0 && i#0 < 32768);

// NativeTypes.nat16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h));

const unique class.NativeTypes.nat16: ClassName;

function Tclass.NativeTypes.nat32() : Ty;

// Tclass.NativeTypes.nat32 Tag
axiom Tag(Tclass.NativeTypes.nat32()) == Tagclass.NativeTypes.nat32;

const unique Tagclass.NativeTypes.nat32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat32()) } 
  $IsBox(bx, Tclass.NativeTypes.nat32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat32()));

// NativeTypes.nat32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat32()) } 
  $Is(i#0, Tclass.NativeTypes.nat32()) <==> LitInt(0) <= i#0 && i#0 < 2147483648);

// NativeTypes.nat32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h));

const unique class.NativeTypes.nat32: ClassName;

function Tclass.NativeTypes.nat64() : Ty;

// Tclass.NativeTypes.nat64 Tag
axiom Tag(Tclass.NativeTypes.nat64()) == Tagclass.NativeTypes.nat64;

const unique Tagclass.NativeTypes.nat64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat64()) } 
  $IsBox(bx, Tclass.NativeTypes.nat64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat64()));

// NativeTypes.nat64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat64()) } 
  $Is(i#0, Tclass.NativeTypes.nat64())
     <==> LitInt(0) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.nat64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h));

const unique class.NativeTypes.nat64: ClassName;

const unique class.NativeTypes.__default: ClassName;

function Tclass.NativeTypes.__default() : Ty;

// Tclass.NativeTypes.__default Tag
axiom Tag(Tclass.NativeTypes.__default()) == Tagclass.NativeTypes.__default;

const unique Tagclass.NativeTypes.__default: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.__default()) } 
  $IsBox(bx, Tclass.NativeTypes.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeTypes.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeTypes.__default()) } 
  $Is($o, Tclass.NativeTypes.__default())
     <==> $o == null || dtype($o) == Tclass.NativeTypes.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeTypes.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeTypes.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativeTypes._default.Uint64Size
function NativeTypes.__default.Uint64Size() : int;

function NativeTypes.__default.Uint64Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint64Size()
     && NativeTypes.__default.Uint64Size() < 18446744073709551616;

function NativeTypes.__default.Uint64Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64Size
axiom NativeTypes.__default.Uint64Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint64Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// definition axiom for NativeTypes.__default.Uint64Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// function declaration for NativeTypes._default.Uint32Size
function NativeTypes.__default.Uint32Size() : int;

function NativeTypes.__default.Uint32Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint32Size()
     && NativeTypes.__default.Uint32Size() < 18446744073709551616;

function NativeTypes.__default.Uint32Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32Size
axiom NativeTypes.__default.Uint32Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint32Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// definition axiom for NativeTypes.__default.Uint32Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// function declaration for NativeTypes._default.Uint16Size
function NativeTypes.__default.Uint16Size() : int;

function NativeTypes.__default.Uint16Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint16Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint16Size()
     && NativeTypes.__default.Uint16Size() < 18446744073709551616;

function NativeTypes.__default.Uint16Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint16Size
axiom NativeTypes.__default.Uint16Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint16Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// definition axiom for NativeTypes.__default.Uint16Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// function declaration for NativeTypes._default.Uint64UpperBound
function NativeTypes.__default.Uint64UpperBound() : int;

function NativeTypes.__default.Uint64UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint64UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64UpperBound
axiom NativeTypes.__default.Uint64UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint64UpperBound(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// definition axiom for NativeTypes.__default.Uint64UpperBound for all literals(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// function declaration for NativeTypes._default.Uint32UpperBound
function NativeTypes.__default.Uint32UpperBound() : int;

function NativeTypes.__default.Uint32UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint32UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32UpperBound
axiom NativeTypes.__default.Uint32UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint32UpperBound(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// definition axiom for NativeTypes.__default.Uint32UpperBound for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// KeyType.Key: subset type $Is
axiom (forall s#0: Seq Box :: 
  { $Is(s#0, Tclass.KeyType.Key()) } 
  $Is(s#0, Tclass.KeyType.Key())
     <==> $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) <= LitInt(1024));

// KeyType.Key: subset type $IsAlloc
axiom (forall s#0: Seq Box, $h: Heap :: 
  { $IsAlloc(s#0, Tclass.KeyType.Key(), $h) } 
  $IsAlloc(s#0, Tclass.KeyType.Key(), $h)
     <==> $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $h));

const unique class.KeyType.__default: ClassName;

function Tclass.KeyType.__default() : Ty;

// Tclass.KeyType.__default Tag
axiom Tag(Tclass.KeyType.__default()) == Tagclass.KeyType.__default;

const unique Tagclass.KeyType.__default: TyTag;

// Box/unbox axiom for Tclass.KeyType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KeyType.__default()) } 
  $IsBox(bx, Tclass.KeyType.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.KeyType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.KeyType.__default()) } 
  $Is($o, Tclass.KeyType.__default())
     <==> $o == null || dtype($o) == Tclass.KeyType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.KeyType.__default(), $h) } 
  $IsAlloc($o, Tclass.KeyType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for KeyType._default.MaxLen
function KeyType.__default.MaxLen() : int;

function KeyType.__default.MaxLen#canCall() : bool;

// consequence axiom for KeyType.__default.MaxLen
axiom true
   ==> 
  true
   ==> LitInt(0) <= KeyType.__default.MaxLen()
     && KeyType.__default.MaxLen() < 18446744073709551616;

function KeyType.__default.MaxLen#requires() : bool;

// #requires axiom for KeyType.__default.MaxLen
axiom KeyType.__default.MaxLen#requires() == true;

// definition axiom for KeyType.__default.MaxLen(revealed)
axiom true ==> true ==> KeyType.__default.MaxLen() == LitInt(1024);

// definition axiom for KeyType.__default.MaxLen for all literals(revealed)
axiom true ==> true ==> KeyType.__default.MaxLen() == LitInt(1024);

// ValueType.Value: subset type $Is
axiom (forall s#0: Seq Box :: 
  { $Is(s#0, Tclass.ValueType.Value()) } 
  $Is(s#0, Tclass.ValueType.Value())
     <==> $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) <= LitInt(1024));

// ValueType.Value: subset type $IsAlloc
axiom (forall s#0: Seq Box, $h: Heap :: 
  { $IsAlloc(s#0, Tclass.ValueType.Value(), $h) } 
  $IsAlloc(s#0, Tclass.ValueType.Value(), $h)
     <==> $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $h));

const unique class.ValueType.__default: ClassName;

function Tclass.ValueType.__default() : Ty;

// Tclass.ValueType.__default Tag
axiom Tag(Tclass.ValueType.__default()) == Tagclass.ValueType.__default;

const unique Tagclass.ValueType.__default: TyTag;

// Box/unbox axiom for Tclass.ValueType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.__default()) } 
  $IsBox(bx, Tclass.ValueType.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueType.__default()) } 
  $Is($o, Tclass.ValueType.__default())
     <==> $o == null || dtype($o) == Tclass.ValueType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueType.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueType._default.MaxLen
function ValueType.__default.MaxLen() : int;

function ValueType.__default.MaxLen#canCall() : bool;

// consequence axiom for ValueType.__default.MaxLen
axiom true
   ==> 
  true
   ==> LitInt(0) <= ValueType.__default.MaxLen()
     && ValueType.__default.MaxLen() < 18446744073709551616;

function ValueType.__default.MaxLen#requires() : bool;

// #requires axiom for ValueType.__default.MaxLen
axiom ValueType.__default.MaxLen#requires() == true;

// definition axiom for ValueType.__default.MaxLen(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// definition axiom for ValueType.__default.MaxLen for all literals(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// function declaration for ValueType._default.DefaultValue
function ValueType.__default.DefaultValue() : Seq Box;

function ValueType.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueType.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueType.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueType.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueType.__default.DefaultValue
axiom ValueType.__default.DefaultValue#requires() == true;

// definition axiom for ValueType.__default.DefaultValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// definition axiom for ValueType.__default.DefaultValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// function declaration for ValueType._default.Len
function ValueType.__default.Len(v#0: Seq Box) : int;

function ValueType.__default.Len#canCall(v#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.Len
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> LitInt(0) <= ValueType.__default.Len(v#0));

function ValueType.__default.Len#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.Len
axiom (forall v#0: Seq Box :: 
  { ValueType.__default.Len#requires(v#0) } 
  $Is(v#0, Tclass.ValueType.Value())
     ==> ValueType.__default.Len#requires(v#0) == true);

// definition axiom for ValueType.__default.Len(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(v#0) == Seq#Length(v#0));

// definition axiom for ValueType.__default.Len for all literals(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    {:weight 3} { ValueType.__default.Len(Lit(v#0)) } 
    ValueType.__default.Len#canCall(Lit(v#0)) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(Lit(v#0)) == Seq#Length(Lit(v#0)));

// function declaration for ValueType._default.ValidMessageBytestring
function ValueType.__default.ValidMessageBytestring(s#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestring#canCall(s#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestring
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function ValueType.__default.ValidMessageBytestring#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestring
axiom (forall s#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestring#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueType.__default.ValidMessageBytestring#requires(s#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestring(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(s#0)
           == (Seq#Length(s#0) <= LitInt(ValueType.__default.MaxLen())));

// definition axiom for ValueType.__default.ValidMessageBytestring for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestring(Lit(s#0)) } 
    ValueType.__default.ValidMessageBytestring#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(Lit(s#0))
           == (Seq#Length(Lit(s#0)) <= LitInt(ValueType.__default.MaxLen())));

// function declaration for ValueType._default.ValidMessageBytestrings
function ValueType.__default.ValidMessageBytestrings(strs#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestrings#canCall(strs#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestrings
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function ValueType.__default.ValidMessageBytestrings#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestrings
axiom (forall strs#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestrings#requires(strs#0) } 
  $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueType.__default.ValidMessageBytestrings#requires(strs#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestrings(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#0: int :: 
          { $Unbox(Seq#Index(strs#0, i#0)): Seq Box } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(strs#0)
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(strs#0, i#0)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(strs#0)
           == (forall i#0: int :: 
            { $Unbox(Seq#Index(strs#0, i#0)): Seq Box } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(strs#0)
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(strs#0, i#0)): Seq Box)));

// definition axiom for ValueType.__default.ValidMessageBytestrings for all literals(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestrings(Lit(strs#0)) } 
    ValueType.__default.ValidMessageBytestrings#canCall(Lit(strs#0))
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(strs#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(strs#0))
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(Lit(strs#0), i#1)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(Lit(strs#0))
           == (forall i#1: int :: 
            { $Unbox(Seq#Index(strs#0, i#1)): Seq Box } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(strs#0))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(Lit(strs#0), i#1)): Seq Box)));

// Constructor function declaration
function #Options.Option.None() : DatatypeType;

const unique ##Options.Option.None: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#Options.Option.None()) == ##Options.Option.None;

function Options.Option.None_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) <==> DatatypeCtorId(d) == ##Options.Option.None);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) ==> d == #Options.Option.None());

// Constructor $Is
axiom (forall Options.Option$V: Ty :: 
  { $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, $h: Heap :: 
  { $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h));

// Constructor literal
axiom #Options.Option.None() == Lit(#Options.Option.None());

// Constructor function declaration
function #Options.Option.Some(Box) : DatatypeType;

const unique ##Options.Option.Some: DtCtorId;

// Constructor identifier
axiom (forall a#5#0#0: Box :: 
  { #Options.Option.Some(a#5#0#0) } 
  DatatypeCtorId(#Options.Option.Some(a#5#0#0)) == ##Options.Option.Some);

function Options.Option.Some_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d) <==> DatatypeCtorId(d) == ##Options.Option.Some);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d)
     ==> (exists a#6#0#0: Box :: d == #Options.Option.Some(a#6#0#0)));

// Constructor $Is
axiom (forall Options.Option$V: Ty, a#7#0#0: Box :: 
  { $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V))
     <==> $IsBox(a#7#0#0, Options.Option$V));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, a#8#0#0: Box, $h: Heap :: 
  { $IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h)
       <==> $IsAllocBox(a#8#0#0, Options.Option$V, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, Options.Option$V: Ty, $h: Heap :: 
  { $IsAllocBox(Options.Option.value(d), Options.Option$V, $h) } 
  $IsGoodHeap($h)
       && 
      Options.Option.Some_q(d)
       && $IsAlloc(d, Tclass.Options.Option(Options.Option$V), $h)
     ==> $IsAllocBox(Options.Option.value(d), Options.Option$V, $h));

// Constructor literal
axiom (forall a#9#0#0: Box :: 
  { #Options.Option.Some(Lit(a#9#0#0)) } 
  #Options.Option.Some(Lit(a#9#0#0)) == Lit(#Options.Option.Some(a#9#0#0)));

function Options.Option.value(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#10#0#0: Box :: 
  { #Options.Option.Some(a#10#0#0) } 
  Options.Option.value(#Options.Option.Some(a#10#0#0)) == a#10#0#0);

// Inductive rank
axiom (forall a#11#0#0: Box :: 
  { #Options.Option.Some(a#11#0#0) } 
  BoxRank(a#11#0#0) < DtRank(#Options.Option.Some(a#11#0#0)));

// Depth-one case-split function
function $IsA#Options.Option(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Options.Option(d) } 
  $IsA#Options.Option(d) ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Questionmark data type disjunctivity
axiom (forall Options.Option$V: Ty, d: DatatypeType :: 
  { Options.Option.Some_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
    { Options.Option.None_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
  $Is(d, Tclass.Options.Option(Options.Option$V))
     ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Datatype extensional equality declaration
function Options.Option#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Options.Option.None
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.None_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.None_q(b) } 
  Options.Option.None_q(a) && Options.Option.None_q(b)
     ==> (Options.Option#Equal(a, b) <==> true));

// Datatype extensional equality definition: #Options.Option.Some
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.Some_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.Some_q(b) } 
  Options.Option.Some_q(a) && Options.Option.Some_q(b)
     ==> (Options.Option#Equal(a, b)
       <==> Options.Option.value(a) == Options.Option.value(b)));

// Datatype extensionality axiom: Options.Option
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b) } 
  Options.Option#Equal(a, b) <==> a == b);

const unique class.Options.Option: ClassName;

const unique class.Options.__default: ClassName;

function Tclass.Options.__default() : Ty;

// Tclass.Options.__default Tag
axiom Tag(Tclass.Options.__default()) == Tagclass.Options.__default;

const unique Tagclass.Options.__default: TyTag;

// Box/unbox axiom for Tclass.Options.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Options.__default()) } 
  $IsBox(bx, Tclass.Options.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Options.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Options.__default()) } 
  $Is($o, Tclass.Options.__default())
     <==> $o == null || dtype($o) == Tclass.Options.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Options.__default(), $h) } 
  $IsAlloc($o, Tclass.Options.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Options._default.MapOption
function Options.__default.MapOption(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.MapOption#canCall(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
       == Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0));

// consequence axiom for Options.__default.MapOption
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
           <==> Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)))
         && (Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
           ==> Options.Option.value(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
             == Apply1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0)))
         && $Is(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0), 
          Tclass.Options.Option(Options._default.MapOption$V1)));

function Options.__default.MapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
     ==> Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.MapOption$V0, 
          Options._default.MapOption$V1, 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.MapOption(revealed)
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            #Options.Option.Some(Apply1(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, f#0, v#1)))));

// function declaration for Options._default.FlatMapOption
function Options.__default.FlatMapOption(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $h1, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $h0, 
          opt#0, 
          f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h0, 
        opt#0, 
        f#0)
       == Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h1, 
        opt#0, 
        f#0));

// consequence axiom for Options.__default.FlatMapOption
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.Some_q(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
              Options._default.FlatMapOption$V1, 
              $Heap, 
              opt#0, 
              f#0)))
         && (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.value(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
                Options._default.FlatMapOption$V1, 
                $Heap, 
                opt#0, 
                f#0))
             == Options.Option.value($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType))
         && $Is(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
            Options._default.FlatMapOption$V1, 
            $Heap, 
            opt#0, 
            f#0), 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)));

function Options.__default.FlatMapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $Heap, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)))
     ==> Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1), 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.FlatMapOption(revealed)
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            $Unbox(Apply1(Options._default.FlatMapOption$V0, 
                Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                $Heap, 
                f#0, 
                v#1)): DatatypeType)));

const unique class.Sequences.__default: ClassName;

function Tclass.Sequences.__default() : Ty;

// Tclass.Sequences.__default Tag
axiom Tag(Tclass.Sequences.__default()) == Tagclass.Sequences.__default;

const unique Tagclass.Sequences.__default: TyTag;

// Box/unbox axiom for Tclass.Sequences.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Sequences.__default()) } 
  $IsBox(bx, Tclass.Sequences.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Sequences.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Sequences.__default()) } 
  $Is($o, Tclass.Sequences.__default())
     <==> $o == null || dtype($o) == Tclass.Sequences.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Sequences.__default(), $h) } 
  $IsAlloc($o, Tclass.Sequences.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Sequences._default.Last
function Sequences.__default.Last(Sequences._default.Last$E: Ty, run#0: Seq Box) : Box;

function Sequences.__default.Last#canCall(Sequences._default.Last$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Last
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> $IsBox(Sequences.__default.Last(Sequences._default.Last$E, run#0), 
        Sequences._default.Last$E));

function Sequences.__default.Last#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Last
axiom (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.Last#requires(Sequences._default.Last$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Last$E))
     ==> Sequences.__default.Last#requires(Sequences._default.Last$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.Last(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, run#0)
         == Seq#Index(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.Last for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0)) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0))
         == Seq#Index(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.DropLast
function Sequences.__default.DropLast(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : Seq Box;

function Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.DropLast
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> $Is(Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0), 
        TSeq(Sequences._default.DropLast$E)));

function Sequences.__default.DropLast#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.DropLast
axiom (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.DropLast$E))
     ==> Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.DropLast(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0)
         == Seq#Take(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.DropLast for all literals(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0)) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0))
         == Seq#Take(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.Set
function Sequences.__default.Set(Sequences._default.Set$T: Ty, run#0: Seq Box) : Set Box;

function Sequences.__default.Set#canCall(Sequences._default.Set$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Set
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> $Is(Sequences.__default.Set(Sequences._default.Set$T, run#0), 
        TSet(Sequences._default.Set$T)));

function Sequences.__default.Set#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Set
axiom (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Set$T))
     ==> Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) == true);

// definition axiom for Sequences.__default.Set(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.Set$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.Set for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0)) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.Set$T) && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.ISet
function Sequences.__default.ISet(Sequences._default.ISet$T: Ty, run#0: Seq Box) : ISet Box;

function Sequences.__default.ISet#canCall(Sequences._default.ISet$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.ISet
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> $Is(Sequences.__default.ISet(Sequences._default.ISet$T, run#0), 
        TISet(Sequences._default.ISet$T)));

function Sequences.__default.ISet#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.ISet
axiom (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.ISet$T))
     ==> Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) == true);

// definition axiom for Sequences.__default.ISet(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.ISet$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.ISet for all literals(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0)) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.ISet$T)
             && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.NoDupes
function Sequences.__default.NoDupes(Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box) : bool;

function Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, AsFuelBottom($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LZ, a#0));

// consequence axiom for Sequences.__default.NoDupes
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> true);

function Sequences.__default.NoDupes#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.NoDupes
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0) } 
  $Is(a#0, TSeq(Sequences._default.NoDupes$T))
     ==> Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.NoDupes(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
         == (forall i#0: int, j#0: int :: 
          { Seq#Index(a#0, j#0), Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 < Seq#Length(a#0)
               && 
              LitInt(0) <= j#0
               && j#0 < Seq#Length(a#0)
               && i#0 != j#0
             ==> Seq#Index(a#0, i#0) != Seq#Index(a#0, j#0)));

// definition axiom for Sequences.__default.NoDupes for all literals(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0)) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, Lit(a#0))
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0))
         == (forall i#1: int, j#1: int :: 
          { Seq#Index(a#0, j#1), Seq#Index(a#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1 < Seq#Length(Lit(a#0))
               && 
              LitInt(0) <= j#1
               && j#1 < Seq#Length(Lit(a#0))
               && i#1 != j#1
             ==> Seq#Index(Lit(a#0), i#1) != Seq#Index(Lit(a#0), j#1)));

// function declaration for Sequences._default.IndexOf
function Sequences.__default.IndexOf(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : int;

function Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : bool;

// consequence axiom for Sequences.__default.IndexOf
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> LitInt(0) <= Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           < Seq#Length(s#0)
         && Seq#Index(s#0, Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0))
           == e#0);

function Sequences.__default.IndexOf#requires(Ty, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.IndexOf
axiom (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
  { Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
       && $IsBox(e#0, Sequences._default.IndexOf$T)
     ==> Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0)
       == Seq#Contains(s#0, e#0));

function $let#0_i(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : int;

function $let#0$canCall(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : bool;

axiom (forall Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box :: 
  { $let#0_i(Sequences._default.IndexOf$T, s, e) } 
  $let#0$canCall(Sequences._default.IndexOf$T, s, e)
     ==> LitInt(0) <= $let#0_i(Sequences._default.IndexOf$T, s, e)
       && $let#0_i(Sequences._default.IndexOf$T, s, e) < Seq#Length(s)
       && Seq#Index(s, $let#0_i(Sequences._default.IndexOf$T, s, e)) == e);

// definition axiom for Sequences.__default.IndexOf(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           == (var i#0 := $let#0_i(Sequences._default.IndexOf$T, s#0, e#0); i#0));

// definition axiom for Sequences.__default.IndexOf for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0)
           == (var i#1 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), e#0); i#1));

// definition axiom for Sequences.__default.IndexOf for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
           == (var i#2 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)); i#2));

// function declaration for Sequences._default.Range
function Sequences.__default.Range($ly: LayerType, n#0: int) : Seq Box;

function Sequences.__default.Range#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range($LS($ly), n#0) } 
  Sequences.__default.Range($LS($ly), n#0) == Sequences.__default.Range($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range(AsFuelBottom($ly), n#0) } 
  Sequences.__default.Range($ly, n#0) == Sequences.__default.Range($LZ, n#0));

// consequence axiom for Sequences.__default.Range
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($ly, n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> Seq#Length(Sequences.__default.Range($ly, n#0)) == n#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int == i#0)
         && $Is(Sequences.__default.Range($ly, n#0), TSeq(TInt)));

function Sequences.__default.Range#requires(LayerType, int) : bool;

// #requires axiom for Sequences.__default.Range
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range#requires($ly, n#0) } 
  Sequences.__default.Range#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.Range(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($LS($ly), n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0) ==> Sequences.__default.Range#canCall(n#0 - 1))
         && Sequences.__default.Range($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($ly, n#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(n#0 - 1)))));

// definition axiom for Sequences.__default.Range for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { Sequences.__default.Range($LS($ly), LitInt(n#0)) } 
    Sequences.__default.Range#canCall(LitInt(n#0)) || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.Range#canCall(LitInt(n#0 - 1)))
         && Sequences.__default.Range($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($LS($ly), LitInt(n#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(n#0 - 1))))));

// function declaration for Sequences._default.Apply
function Sequences.__default.Apply(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Apply#canCall(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $h0, f#0, run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h0, f#0, run#0)
       == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Apply
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
                i#2)
               == Apply1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Apply$R)));

function Sequences.__default.Apply#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
       && $Is(run#0, TSeq(Sequences._default.Apply$E))
     ==> Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.Apply(revealed)
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, 
        Sequences._default.Apply$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Apply#canCall(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Apply(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                Apply1(Sequences._default.Apply$E, 
                  Sequences._default.Apply$R, 
                  $Heap, 
                  f#0, 
                  Seq#Index(run#0, LitInt(0)))), 
              Sequences.__default.Apply(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $ly, 
                $Heap, 
                f#0, 
                Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.ApplyOpaque
function Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LZ, 
      $Heap, 
      f#0, 
      run#0));

// frame axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $h1, 
      f#0, 
      run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $h0, 
          f#0, 
          run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h0, 
        f#0, 
        run#0)
       == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h1, 
        f#0, 
        run#0));

// consequence axiom for Sequences.__default.ApplyOpaque
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
              Sequences._default.ApplyOpaque$R, 
              $ly, 
              $Heap, 
              f#0, 
              run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $ly, 
                $Heap, 
                f#0, 
                run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                  Sequences._default.ApplyOpaque$R, 
                  $ly, 
                  $Heap, 
                  f#0, 
                  run#0), 
                i#2)
               == Apply1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $ly, 
            $Heap, 
            f#0, 
            run#0), 
          TSeq(Sequences._default.ApplyOpaque$R)));

function Sequences.__default.ApplyOpaque#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
       && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
     ==> Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.ApplyOpaque(revealed)
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> Sequences.__default.Apply#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         && Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == Sequences.__default.Apply(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($LZ), 
            $Heap, 
            f#0, 
            run#0));

// function declaration for Sequences._default.Filter
function Sequences.__default.Filter(Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Filter#canCall(Sequences._default.Filter$E: Ty, $heap: Heap, f#0: HandleType, run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, AsFuelBottom($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $h0, f#0, run#0)
         || ($Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists _x0#0: Box, _o0#0: ref :: 
            $IsBox(_x0#0, Sequences._default.Filter$E)
               && $Is(_o0#0, Tclass._System.object?())
               && Reads1(Sequences._default.Filter$E, TBool, $h0, f#0, _x0#0)[$Box(_o0#0)]
               && $Box($o) == $Box(_o0#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h0, f#0, run#0)
       == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Filter
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#0))))
       ==> Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
           <= Seq#Length(run#0)
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
              i#1) } 
          LitInt(0) <= i#1
             ==> 
            i#1
                 < Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
               && Requires1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))
             ==> $Unbox(Apply1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))): bool)
         && $Is(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Filter$E)));

function Sequences.__default.Filter#requires(Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
       && $Is(run#0, TSeq(Sequences._default.Filter$E))
     ==> Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
       == (forall i#2: int :: 
        { Seq#Index(run#0, i#2) } 
        true
           ==> 
          LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))));

// definition axiom for Sequences.__default.Filter(revealed)
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#2: int :: 
            { Seq#Index(run#0, i#2) } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append((if $Unbox(Apply1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, LitInt(0)))): bool
                 then Seq#Build(Seq#Empty(): Seq Box, Seq#Index(run#0, LitInt(0)))
                 else Seq#Empty(): Seq Box), 
              Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.FoldLeft
function Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldLeft
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> $IsBox(Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldLeft$A));

function Sequences.__default.FoldLeft#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldLeft
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Sequences._default.FoldLeft$A))
       && $IsBox(init#0, Sequences._default.FoldLeft$A)
       && $Is(run#0, TSeq(Sequences._default.FoldLeft$E))
     ==> Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldLeft(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(run#0, LitInt(0))), 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $ly, 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(run#0, LitInt(0))), 
              Seq#Drop(run#0, LitInt(1)))));

// definition axiom for Sequences.__default.FoldLeft for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// definition axiom for Sequences.__default.FoldLeft for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            Lit(f#0), 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              Lit(f#0), 
              Lit(init#0), 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              Lit(f#0), 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                Lit(f#0), 
                Lit(init#0), 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// function declaration for Sequences._default.FoldRight
function Sequences.__default.FoldRight(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldRight
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> $IsBox(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldRight$A));

function Sequences.__default.FoldRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldRight
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Sequences._default.FoldRight$A))
       && $IsBox(init#0, Sequences._default.FoldRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldRight$E))
     ==> Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Seq#Drop(run#0, LitInt(1))), 
              Seq#Index(run#0, LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Seq#Drop(Lit(run#0), LitInt(1)))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            Lit(f#0), 
            Lit(init#0), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                  Sequences._default.FoldRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Seq#Drop(Lit(run#0), LitInt(1))))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// function declaration for Sequences._default.FoldFromRight
function Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldFromRight
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> $IsBox(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldFromRight$A));

function Sequences.__default.FoldFromRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldFromRight
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Sequences._default.FoldFromRight$A))
       && $IsBox(init#0, Sequences._default.FoldFromRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E))
     ==> Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldFromRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, run#0)
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, run#0))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0)), 
              Sequences.__default.Last(Sequences._default.FoldFromRight$E, run#0))));

// definition axiom for Sequences.__default.FoldFromRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0)))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// definition axiom for Sequences.__default.FoldFromRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Lit(f#0), 
              Lit(init#0), 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                  Sequences._default.FoldFromRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// function declaration for Sequences._default.remove
function Sequences.__default.remove(Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int)
   : Seq Box;

function Sequences.__default.remove#canCall(Sequences._default.remove$A: Ty, s#0: Seq Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, AsFuelBottom($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $LZ, s#0, pos#0));

// consequence axiom for Sequences.__default.remove
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1) } 
          pos#0 <= i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1)
               == Seq#Index(s#0, i#1 + 1))
         && $Is(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), 
          TSeq(Sequences._default.remove$A)));

function Sequences.__default.remove#requires(Ty, LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.remove
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.remove$A))
     ==> Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.remove(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
         == Seq#Append(Seq#Take(s#0, pos#0), Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.remove for all literals(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    {:weight 3} { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0)) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, Lit(s#0), LitInt(pos#0))
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0))
         == Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.insert
function Sequences.__default.insert(Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.insert#canCall(Sequences._default.insert$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.insert
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 <= i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.insert$A)));

function Sequences.__default.insert#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.insert
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.insert$A))
       && $IsBox(a#0, Sequences._default.insert$A)
     ==> Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 <= Seq#Length(s#0)));

// definition axiom for Sequences.__default.insert(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0)));

// definition axiom for Sequences.__default.insert for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// definition axiom for Sequences.__default.insert for all literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// function declaration for Sequences._default.replace1with2
function Sequences.__default.replace1with2(Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A: Ty, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, AsFuelBottom($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LZ, s#0, a#0, b#0, pos#0));

// consequence axiom for Sequences.__default.replace1with2
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0)
           == a#0
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0 + 1)
           == b#0
         && $Is(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
          TSeq(Sequences._default.replace1with2$A)));

function Sequences.__default.replace1with2#requires(Ty, LayerType, Seq Box, Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace1with2
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace1with2$A))
       && $IsBox(a#0, Sequences._default.replace1with2$A)
       && $IsBox(b#0, Sequences._default.replace1with2$A)
     ==> Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.replace1with2(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.replace1with2 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), a#0, b#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// definition axiom for Sequences.__default.replace1with2 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
        $LS($ly), 
        Lit(s#0), 
        Lit(a#0), 
        Lit(b#0), 
        LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), Lit(a#0), Lit(b#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
          $LS($ly), 
          Lit(s#0), 
          Lit(a#0), 
          Lit(b#0), 
          LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, Lit(a#0)), Lit(b#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.replace2with1
function Sequences.__default.replace2with1(Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.replace2with1
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Seq#Length(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#1)
               == Seq#Index(s#0, i#1 + 1))
         && Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.replace2with1$A)));

function Sequences.__default.replace2with1#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace2with1
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace2with1$A))
       && $IsBox(a#0, Sequences._default.replace2with1$A)
     ==> Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0) - 1));

// definition axiom for Sequences.__default.replace2with1(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0 + 2)));

// definition axiom for Sequences.__default.replace2with1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// definition axiom for Sequences.__default.replace2with1 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// function declaration for Sequences._default.concat
function Sequences.__default.concat(Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat#canCall(Sequences._default.concat$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.concat
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Seq#Length(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0))
           == Seq#Length(a#0) + Seq#Length(b#0)
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0))
         && (forall i#1: int :: 
          { Seq#Index(b#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(b#0)
             ==> Seq#Index(b#0, i#1)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
                Seq#Length(a#0) + i#1))
         && $Is(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
          TSeq(Sequences._default.concat$A)));

function Sequences.__default.concat#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.concat$A))
       && $Is(b#0, TSeq(Sequences._default.concat$A))
     ==> Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.concat(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
         == Seq#Append(a#0, b#0));

// definition axiom for Sequences.__default.concat for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0))
         == Seq#Append(a#0, b#0));

// function declaration for Sequences._default.concat3
function Sequences.__default.concat3(Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat3#canCall(Sequences._default.concat3$A: Ty, a#0: Seq Box, b#0: Box, c#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, AsFuelBottom($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $LZ, a#0, b#0, c#0));

// consequence axiom for Sequences.__default.concat3
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Seq#Length(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0))
           == Seq#Length(a#0) + Seq#Length(c#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
              i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                i#0))
         && Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
            Seq#Length(a#0))
           == b#0
         && (forall i#1: int :: 
          { Seq#Index(c#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(c#0)
             ==> Seq#Index(c#0, i#1)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                Seq#Length(a#0) + 1 + i#1))
         && $Is(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
          TSeq(Sequences._default.concat3$A)));

function Sequences.__default.concat3#requires(Ty, LayerType, Seq Box, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat3
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
  $Is(a#0, TSeq(Sequences._default.concat3$A))
       && $IsBox(b#0, Sequences._default.concat3$A)
       && $Is(c#0, TSeq(Sequences._default.concat3$A))
     ==> Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
       == true);

// definition axiom for Sequences.__default.concat3(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), b#0, Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), Lit(b#0), Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, Lit(b#0))), c#0));

// function declaration for Sequences._default.concatSeq
function Sequences.__default.concatSeq(Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box) : Seq Box;

function Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, AsFuelBottom($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LZ, a#0));

// consequence axiom for Sequences.__default.concatSeq
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> $Is(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0), 
        TSeq(Sequences._default.concatSeq$A)));

function Sequences.__default.concatSeq#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.concatSeq
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0) } 
  $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
     ==> Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.concatSeq(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), a#0)
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), a#0))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), a#0)): Seq Box)));

// definition axiom for Sequences.__default.concatSeq for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0)) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, Lit(a#0))
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0))
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), Lit(a#0))): Seq Box)));

procedure {:_induction a#0} CheckWellformed$$Sequences.__default.lemma__concatSeqLen__ge__elemLen(Sequences._default.lemma_concatSeqLen_ge_elemLen$A: Ty, 
    a#0: Seq Box
       where $Is(a#0, TSeq(TSeq(Sequences._default.lemma_concatSeqLen_ge_elemLen$A)))
         && $IsAlloc(a#0, TSeq(TSeq(Sequences._default.lemma_concatSeqLen_ge_elemLen$A)), $Heap), 
    i#0: int);
  free requires 59 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction a#0} Call$$Sequences.__default.lemma__concatSeqLen__ge__elemLen(Sequences._default.lemma_concatSeqLen_ge_elemLen$A: Ty, 
    a#0: Seq Box
       where $Is(a#0, TSeq(TSeq(Sequences._default.lemma_concatSeqLen_ge_elemLen$A)))
         && $IsAlloc(a#0, TSeq(TSeq(Sequences._default.lemma_concatSeqLen_ge_elemLen$A)), $Heap), 
    i#0: int);
  // user-defined preconditions
  requires LitInt(0) <= i#0;
  requires i#0 < Seq#Length(a#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.concatSeq#canCall(Sequences._default.lemma_concatSeqLen_ge_elemLen$A, a#0);
  ensures Seq#Length(Sequences.__default.concatSeq(Sequences._default.lemma_concatSeqLen_ge_elemLen$A, 
        StartFuelAssert_Sequences._default.concatSeq, 
        a#0))
     >= Seq#Length($Unbox(Seq#Index(a#0, i#0)): Seq Box);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction a#0} CheckWellformed$$Sequences.__default.lemma__concatSeqLen__le__mul(Sequences._default.lemma_concatSeqLen_le_mul$A: Ty, 
    a#0: Seq Box
       where $Is(a#0, TSeq(TSeq(Sequences._default.lemma_concatSeqLen_le_mul$A)))
         && $IsAlloc(a#0, TSeq(TSeq(Sequences._default.lemma_concatSeqLen_le_mul$A)), $Heap), 
    t#0: int);
  free requires 60 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction a#0} Call$$Sequences.__default.lemma__concatSeqLen__le__mul(Sequences._default.lemma_concatSeqLen_le_mul$A: Ty, 
    a#0: Seq Box
       where $Is(a#0, TSeq(TSeq(Sequences._default.lemma_concatSeqLen_le_mul$A)))
         && $IsAlloc(a#0, TSeq(TSeq(Sequences._default.lemma_concatSeqLen_le_mul$A)), $Heap), 
    t#0: int);
  // user-defined preconditions
  requires (forall i#0: int :: 
    { $Unbox(Seq#Index(a#0, i#0)): Seq Box } 
    LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
       ==> Seq#Length($Unbox(Seq#Index(a#0, i#0)): Seq Box) <= t#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.concatSeq#canCall(Sequences._default.lemma_concatSeqLen_le_mul$A, a#0);
  ensures Seq#Length(Sequences.__default.concatSeq(Sequences._default.lemma_concatSeqLen_le_mul$A, 
        StartFuelAssert_Sequences._default.concatSeq, 
        a#0))
     <= Mul(Seq#Length(a#0), t#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Sequences._default.IsPrefix
function Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsPrefix
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> 
      Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       ==> Seq#Length(a#0) <= Seq#Length(b#0));

function Sequences.__default.IsPrefix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsPrefix
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsPrefix$A))
       && $Is(b#0, TSeq(Sequences._default.IsPrefix$A))
     ==> Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsPrefix(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Take(b#0, Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsPrefix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Take(Lit(b#0), Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.IsSuffix
function Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsSuffix
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> true);

function Sequences.__default.IsSuffix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsSuffix
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsSuffix$A))
       && $Is(b#0, TSeq(Sequences._default.IsSuffix$A))
     ==> Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsSuffix(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Drop(b#0, Seq#Length(b#0) - Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsSuffix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.SeqIndexIterate
function Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : DatatypeType;

function Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A: Ty, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, AsFuelBottom($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LZ, run#0, needle#0, i#0));

// consequence axiom for Sequences.__default.SeqIndexIterate
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> (forall j#0: int :: 
            { Seq#Index(run#0, j#0) } 
            i#0 <= j#0 && j#0 < Seq#Length(run#0) ==> Seq#Index(run#0, j#0) != needle#0))
         && $Is(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndexIterate#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.SeqIndexIterate
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
       && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
     ==> Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(run#0)));

// definition axiom for Sequences.__default.SeqIndexIterate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (i#0 != Seq#Length(run#0)
           ==> 
          Seq#Index(run#0, i#0) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0 + 1))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
           == (if i#0 == Seq#Length(run#0)
             then #Options.Option.None()
             else (if Seq#Index(run#0, i#0) == needle#0
               then #Options.Option.Some($Box(i#0))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        needle#0, 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            needle#0, 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == needle#0
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                needle#0, 
                LitInt(i#0 + 1)))));

// definition axiom for Sequences.__default.SeqIndexIterate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        Lit(needle#0), 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != Lit(needle#0)
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == Lit(needle#0)
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                Lit(needle#0), 
                LitInt(i#0 + 1)))));

// function declaration for Sequences._default.SeqIndex
function Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box)
   : DatatypeType;

function Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A: Ty, run#0: Seq Box, needle#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, AsFuelBottom($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LZ, run#0, needle#0));

// consequence axiom for Sequences.__default.SeqIndex
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Seq#Index(run#0, i#0) != needle#0))
         && $Is(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndex#requires(Ty, LayerType, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndex
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndex$A))
       && $IsBox(needle#0, Sequences._default.SeqIndex$A)
     ==> Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
       == true);

// definition axiom for Sequences.__default.SeqIndex(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, run#0, needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            run#0, 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0)) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0))
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0), LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0))
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(0)));

// function declaration for Sequences._default.SeqOfLength
function Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box)
   : Seq Box;

function Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V: Ty, length#0: int, v#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, AsFuelBottom($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LZ, length#0, v#0));

// consequence axiom for Sequences.__default.SeqOfLength
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
           == length#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
              i#0) } 
          LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
             ==> Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
                i#0)
               == v#0)
         && $Is(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
          TSeq(Sequences._default.SeqOfLength$V)));

function Sequences.__default.SeqOfLength#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqOfLength
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
  LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V)
     ==> Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
       == true);

// definition axiom for Sequences.__default.SeqOfLength(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (length#0 != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0 - 1, v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
           == (if length#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0 - 1, v#0))));

// definition axiom for Sequences.__default.SeqOfLength for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0)
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), v#0))));

// definition axiom for Sequences.__default.SeqOfLength for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0)) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), Lit(v#0))
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), Lit(v#0)))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0))
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, Lit(v#0)), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), Lit(v#0)))));

// function declaration for Sequences._default.SeqIndexUpdate
function Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box)
   : Seq Box;

function Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T: Ty, s#0: Seq Box, i#0: int, t#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, AsFuelBottom($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LZ, s#0, i#0, t#0));

// consequence axiom for Sequences.__default.SeqIndexUpdate
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Seq#Equal(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          Seq#Update(s#0, i#0, t#0))
         && $Is(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          TSeq(Sequences._default.SeqIndexUpdate$T)));

function Sequences.__default.SeqIndexUpdate#requires(Ty, LayerType, Seq Box, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndexUpdate
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
  $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
     ==> Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
       == (i#0 + 1 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.SeqIndexUpdate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(s#0, i#0 + 1)));

// definition axiom for Sequences.__default.SeqIndexUpdate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0)
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexUpdate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0)) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), Lit(t#0))
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(t#0))), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// function declaration for Sequences._default.Zip
function Sequences.__default.Zip(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : Seq Box;

function Sequences.__default.Zip#canCall(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.Zip
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
           == Seq#Length(a#0)
         && (forall i#0: int :: 
          { Seq#Index(b#0, i#0) } 
            { Seq#Index(a#0, i#0) } 
            { $Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                i#0)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
             ==> _System.Tuple2#Equal($Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                  i#0)): DatatypeType, 
              #_System._tuple#2._#Make2(Seq#Index(a#0, i#0), Seq#Index(b#0, i#0))))
         && $Is(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
          TSeq(Tclass._System.Tuple2(Sequences._default.Zip$A, Sequences._default.Zip$B))));

function Sequences.__default.Zip#requires(Ty, Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.Zip
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.Zip$A))
       && $Is(b#0, TSeq(Sequences._default.Zip$B))
     ==> Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
       == 
      (Seq#Length(a#0)
       == Seq#Length(b#0)));

// definition axiom for Sequences.__default.Zip(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, b#0)
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
              Sequences.__default.DropLast(Sequences._default.Zip$B, b#0))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, b#0))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $ly, 
                Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
                Sequences.__default.DropLast(Sequences._default.Zip$B, b#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#_System._tuple#2._#Make2(Sequences.__default.Last(Sequences._default.Zip$A, a#0), 
                    Sequences.__default.Last(Sequences._default.Zip$B, b#0)))))));

// definition axiom for Sequences.__default.Zip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(Lit(a#0)) == Seq#Length(Lit(b#0)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, Lit(b#0))
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0))))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, Lit(b#0)))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#_System._tuple#2._#Make2(Lit(Sequences.__default.Last(Sequences._default.Zip$A, Lit(a#0))), 
                      Lit(Sequences.__default.Last(Sequences._default.Zip$B, Lit(b#0))))))))));

// function declaration for Sequences._default.Unzip
function Sequences.__default.Unzip(Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box)
   : DatatypeType;

function Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A: Ty, Sequences._default.Unzip$B: Ty, z#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0));

// fuel synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, AsFuelBottom($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LZ, z#0));

// consequence axiom for Sequences.__default.Unzip
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> Seq#Length($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
         && Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length(z#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(z#0, i#0)): DatatypeType } 
            { Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
            { Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(z#0)
             ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0), 
                Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0)), 
              $Unbox(Seq#Index(z#0, i#0)): DatatypeType))
         && $Is(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0), 
          Tclass._System.Tuple2(TSeq(Sequences._default.Unzip$A), TSeq(Sequences._default.Unzip$B))));

function Sequences.__default.Unzip#requires(Ty, Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Unzip
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
  $Is(z#0, 
      TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
     ==> Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
       == true);

// definition axiom for Sequences.__default.Unzip(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(z#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                z#0))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType)
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
           == (if Seq#Length(z#0) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#0, b#0 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._0($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType)))), 
                $Box(Seq#Append(b#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._1($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType))))))));

// definition axiom for Sequences.__default.Unzip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0)) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, Lit(z#0))
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(Lit(z#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  Lit(z#0))))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType)))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0))
           == (if Seq#Length(Lit(z#0)) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#1, b#1 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._0(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType)))))), 
                $Box(Seq#Append(b#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._1(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType))))))))));

// function declaration for Sequences._default.FlattenShape
function Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box)
   : Seq Box;

function Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.FlattenShape
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
           == Seq#Length(seqs#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(seqs#0, i#0)): Seq Box } 
            { $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
             ==> $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                  i#0)): int
               == Seq#Length($Unbox(Seq#Index(seqs#0, i#0)): Seq Box))
         && $Is(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
          TSeq(Tclass._System.nat())));

function Sequences.__default.FlattenShape#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenShape
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
     ==> Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0)
       == true);

// definition axiom for Sequences.__default.FlattenShape(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0)
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), seqs#0)): Seq Box))))));

// definition axiom for Sequences.__default.FlattenShape for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length(Lit($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))): Seq Box)))))));

// function declaration for Sequences._default.FlattenLength
function Sequences.__default.FlattenLength($ly: LayerType, shape#0: Seq Box) : int;

function Sequences.__default.FlattenLength#canCall(shape#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
  Sequences.__default.FlattenLength($LS($ly), shape#0)
     == Sequences.__default.FlattenLength($ly, shape#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength(AsFuelBottom($ly), shape#0) } 
  Sequences.__default.FlattenLength($ly, shape#0)
     == Sequences.__default.FlattenLength($LZ, shape#0));

// consequence axiom for Sequences.__default.FlattenLength
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($ly, shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) == LitInt(0)
           ==> Sequences.__default.FlattenLength($ly, shape#0) == LitInt(0))
         && LitInt(0) <= Sequences.__default.FlattenLength($ly, shape#0));

function Sequences.__default.FlattenLength#requires(LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenLength
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength#requires($ly, shape#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat()))
     ==> Sequences.__default.FlattenLength#requires($ly, shape#0) == true);

// definition axiom for Sequences.__default.FlattenLength(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), shape#0))
         && Sequences.__default.FlattenLength($LS($ly), shape#0)
           == (if Seq#Length(shape#0) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), shape#0)): int));

// definition axiom for Sequences.__default.FlattenLength for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenLength($LS($ly), Lit(shape#0)) } 
    Sequences.__default.FlattenLength#canCall(Lit(shape#0))
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(Lit(shape#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), Lit(shape#0)))
         && Sequences.__default.FlattenLength($LS($ly), Lit(shape#0))
           == (if Seq#Length(Lit(shape#0)) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($LS($ly), Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), Lit(shape#0))): int));

// function declaration for Sequences._default.Flatten
function Sequences.__default.Flatten(Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box) : Seq Box;

function Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.Flatten
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Sequences._default.Flatten$A, StartFuel_Sequences._default.FlattenShape, seqs#0))
         && (Seq#Length(seqs#0) == LitInt(0)
           ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
             == LitInt(0))
         && $Is(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0), 
          TSeq(Sequences._default.Flatten$A)));

function Sequences.__default.Flatten#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Flatten
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
     ==> Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0)
       == true);

const MoreFuel_Sequences._default.FlattenShape0: LayerType;

// definition axiom for Sequences.__default.Flatten(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), seqs#0)
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), seqs#0))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape0)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape0)
           == MoreFuel_Sequences._default.FlattenShape0
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), seqs#0)): Seq Box)));

const MoreFuel_Sequences._default.FlattenShape1: LayerType;

// definition axiom for Sequences.__default.Flatten for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape1)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape1)
           == MoreFuel_Sequences._default.FlattenShape1
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))): Seq Box)));

// function declaration for Sequences._default.FlattenIndex
function Sequences.__default.FlattenIndex(shape#0: Seq Box, i#0: int, j#0: int) : int;

function Sequences.__default.FlattenIndex#canCall(shape#0: Seq Box, i#0: int, j#0: int) : bool;

// consequence axiom for Sequences.__default.FlattenIndex
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> LitInt(0) <= Sequences.__default.FlattenIndex(shape#0, i#0, j#0));

function Sequences.__default.FlattenIndex#requires(Seq Box, int, int) : bool;

// #requires axiom for Sequences.__default.FlattenIndex
axiom (forall shape#0: Seq Box, i#0: int, j#0: int :: 
  { Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0 && LitInt(0) <= j#0
     ==> Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0)
       == (i#0 < Seq#Length(shape#0) && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int));

// definition axiom for Sequences.__default.FlattenIndex(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> Sequences.__default.FlattenLength#canCall(Seq#Take(shape#0, i#0))
         && Sequences.__default.FlattenIndex(shape#0, i#0, j#0)
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Seq#Take(shape#0, i#0))
             + j#0);

// definition axiom for Sequences.__default.FlattenIndex for all literals(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    {:weight 3} { Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0)) } 
    Sequences.__default.FlattenIndex#canCall(Lit(shape#0), LitInt(i#0), LitInt(j#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(Lit(shape#0))
           && j#0 < $Unbox(Seq#Index(Lit(shape#0), LitInt(i#0))): int)
       ==> Sequences.__default.FlattenLength#canCall(Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
         && Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
             + j#0);

// function declaration for Sequences._default.UnflattenIndex
function Sequences.__default.UnflattenIndex($ly: LayerType, shape#0: Seq Box, i#0: int) : DatatypeType;

function Sequences.__default.UnflattenIndex#canCall(shape#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
     == Sequences.__default.UnflattenIndex($ly, shape#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex(AsFuelBottom($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($ly, shape#0, i#0)
     == Sequences.__default.UnflattenIndex($LZ, shape#0, i#0));

// consequence axiom for Sequences.__default.UnflattenIndex
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($ly, shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> $Is(Sequences.__default.UnflattenIndex($ly, shape#0, i#0), 
        Tclass._System.Tuple2(Tclass._System.nat(), Tclass._System.nat())));

function Sequences.__default.UnflattenIndex#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.UnflattenIndex
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0
     ==> Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0)
       == (i#0
         < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0)));

const MoreFuel_Sequences._default.FlattenLength0: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
         && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.UnflattenIndex#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0)))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength0)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength0)
           == MoreFuel_Sequences._default.FlattenLength0
         && Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             then Sequences.__default.UnflattenIndex($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0)
             else #_System._tuple#2._#Make2($Box(Seq#Length(shape#0) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Sequences.__default.DropLast(Tclass._System.nat(), shape#0))))));

const MoreFuel_Sequences._default.FlattenLength1: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    {:weight 3} { Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0)) } 
    Sequences.__default.UnflattenIndex#canCall(Lit(shape#0), LitInt(i#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Lit(shape#0)))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
         && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.UnflattenIndex#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0)))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0)))))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength1)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength1)
           == MoreFuel_Sequences._default.FlattenLength1
         && Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0))
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             then Sequences.__default.UnflattenIndex($LS($ly), 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0))
             else #_System._tuple#2._#Make2($Box(Seq#Length(Lit(shape#0)) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))))));

procedure CheckWellformed$$Sequences.__default.lemma__seq__slice__slice(Sequences._default.lemma_seq_slice_slice$T: Ty, 
    s#0: Seq Box
       where $Is(s#0, TSeq(Sequences._default.lemma_seq_slice_slice$T))
         && $IsAlloc(s#0, TSeq(Sequences._default.lemma_seq_slice_slice$T), $Heap), 
    i#0: int, 
    j#0: int, 
    k#0: int, 
    l#0: int);
  free requires 74 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Sequences.__default.lemma__seq__slice__slice(Sequences._default.lemma_seq_slice_slice$T: Ty, 
    s#0: Seq Box
       where $Is(s#0, TSeq(Sequences._default.lemma_seq_slice_slice$T))
         && $IsAlloc(s#0, TSeq(Sequences._default.lemma_seq_slice_slice$T), $Heap), 
    i#0: int, 
    j#0: int, 
    k#0: int, 
    l#0: int);
  // user-defined preconditions
  requires LitInt(0) <= i#0;
  requires i#0 <= j#0;
  requires j#0 <= Seq#Length(s#0);
  requires LitInt(0) <= k#0;
  requires k#0 <= l#0;
  requires l#0 <= j#0 - i#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Seq#Equal(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(s#0, j#0), i#0), l#0), k#0), 
    Seq#Drop(Seq#Take(s#0, i#0 + l#0), i#0 + k#0));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Sequences._default.fill
function Sequences.__default.fill(Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box) : Seq Box;

function Sequences.__default.fill#canCall(Sequences._default.fill$T: Ty, n#0: int, t#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, AsFuelBottom($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $LZ, n#0, t#0));

// consequence axiom for Sequences.__default.fill
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> Seq#Length(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0))
           == n#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0)
               == t#0)
         && $Is(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), 
          TSeq(Sequences._default.fill$T)));

function Sequences.__default.fill#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.fill
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0) } 
  $IsBox(t#0, Sequences._default.fill$T)
     ==> Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0)
       == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.fill(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> (n#0 != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0 - 1, t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0 - 1, t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0)
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for all literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0)) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), Lit(t#0))
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), Lit(t#0)))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), Lit(t#0)), 
              Seq#Build(Seq#Empty(): Seq Box, Lit(t#0)))));

procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$Sequences.__default.reveal__concatSeq();
  free requires 86 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_Sequences._default.concatSeq0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$Sequences.__default.reveal__concatSeq();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_Sequences._default.concatSeq
     == $LS(MoreFuel_Sequences._default.concatSeq0);
  free ensures StartFuelAssert_Sequences._default.concatSeq
     == $LS($LS(MoreFuel_Sequences._default.concatSeq0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_Sequences._default.concatSeq0)
     == MoreFuel_Sequences._default.concatSeq0;



const #$Delta: Ty;

const unique class.ValueMessage.Delta: ClassName;

const unique class.ValueMessage.__default: ClassName;

function Tclass.ValueMessage.__default() : Ty;

// Tclass.ValueMessage.__default Tag
axiom Tag(Tclass.ValueMessage.__default()) == Tagclass.ValueMessage.__default;

const unique Tagclass.ValueMessage.__default: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.__default()) } 
  $IsBox(bx, Tclass.ValueMessage.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueMessage.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueMessage.__default()) } 
  $Is($o, Tclass.ValueMessage.__default())
     <==> $o == null || dtype($o) == Tclass.ValueMessage.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueMessage.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueMessage.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueMessage._default.NopDelta
function ValueMessage.__default.NopDelta() : Box;

function ValueMessage.__default.NopDelta#canCall() : bool;

function Tclass.ValueMessage.Delta() : Ty;

// Tclass.ValueMessage.Delta Tag
axiom Tag(Tclass.ValueMessage.Delta()) == Tagclass.ValueMessage.Delta;

const unique Tagclass.ValueMessage.Delta: TyTag;

// consequence axiom for ValueMessage.__default.NopDelta
axiom true
   ==> 
  true
   ==> $IsBox(ValueMessage.__default.NopDelta(), Tclass.ValueMessage.Delta());

function ValueMessage.__default.NopDelta#requires() : bool;

// #requires axiom for ValueMessage.__default.NopDelta
axiom ValueMessage.__default.NopDelta#requires() == true;

// function declaration for ValueMessage._default.DefaultValue
function ValueMessage.__default.DefaultValue() : Seq Box;

function ValueMessage.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueMessage.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueMessage.__default.DefaultValue
axiom ValueMessage.__default.DefaultValue#requires() == true;

// function declaration for ValueMessage._default.CombineDeltas
function ValueMessage.__default.CombineDeltas(newdelta#0: Box, olddelta#0: Box) : Box;

function ValueMessage.__default.CombineDeltas#canCall(newdelta#0: Box, olddelta#0: Box) : bool;

// consequence axiom for ValueMessage.__default.CombineDeltas
axiom true
   ==> (forall newdelta#0: Box, olddelta#0: Box :: 
    { ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) } 
    ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)
         || ($IsBox(newdelta#0, Tclass.ValueMessage.Delta())
           && $IsBox(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> (newdelta#0 == ValueMessage.__default.NopDelta()
           ==> ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) == olddelta#0)
         && (olddelta#0 == ValueMessage.__default.NopDelta()
           ==> ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) == newdelta#0)
         && $IsBox(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), 
          Tclass.ValueMessage.Delta()));

function ValueMessage.__default.CombineDeltas#requires(Box, Box) : bool;

// #requires axiom for ValueMessage.__default.CombineDeltas
axiom (forall newdelta#0: Box, olddelta#0: Box :: 
  { ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) } 
  $IsBox(newdelta#0, Tclass.ValueMessage.Delta())
       && $IsBox(olddelta#0, Tclass.ValueMessage.Delta())
     ==> ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) == true);

// function declaration for ValueMessage._default.ApplyDelta
function ValueMessage.__default.ApplyDelta(delta#0: Box, value#0: Seq Box) : Seq Box;

function ValueMessage.__default.ApplyDelta#canCall(delta#0: Box, value#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.ApplyDelta
axiom true
   ==> (forall delta#0: Box, value#0: Seq Box :: 
    { ValueMessage.__default.ApplyDelta(delta#0, value#0) } 
    ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0)
         || ($IsBox(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> (delta#0 == ValueMessage.__default.NopDelta()
           ==> Seq#Equal(ValueMessage.__default.ApplyDelta(delta#0, value#0), value#0))
         && $Is(ValueMessage.__default.ApplyDelta(delta#0, value#0), Tclass.ValueType.Value()));

function ValueMessage.__default.ApplyDelta#requires(Box, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.ApplyDelta
axiom (forall delta#0: Box, value#0: Seq Box :: 
  { ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) } 
  $IsBox(delta#0, Tclass.ValueMessage.Delta())
       && $Is(value#0, Tclass.ValueType.Value())
     ==> ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) == true);

// function declaration for ValueMessage._default.bytestring_to_Message
function ValueMessage.__default.bytestring__to__Message(s#0: Seq Box) : DatatypeType;

function ValueMessage.__default.bytestring__to__Message#canCall(s#0: Seq Box) : bool;

function Tclass.ValueMessage.Message() : Ty;

// Tclass.ValueMessage.Message Tag
axiom Tag(Tclass.ValueMessage.Message()) == Tagclass.ValueMessage.Message;

const unique Tagclass.ValueMessage.Message: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.Message
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.Message()) } 
  $IsBox(bx, Tclass.ValueMessage.Message())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.ValueMessage.Message()));

// consequence axiom for ValueMessage.__default.bytestring__to__Message
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueMessage.__default.bytestring__to__Message(s#0) } 
    ValueMessage.__default.bytestring__to__Message#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) < 4294967296)
       ==> $Is(ValueMessage.__default.bytestring__to__Message(s#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.bytestring__to__Message#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestring__to__Message
axiom (forall s#0: Seq Box :: 
  { ValueMessage.__default.bytestring__to__Message#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueMessage.__default.bytestring__to__Message#requires(s#0)
       == (Seq#Length(s#0) < 4294967296));

// function declaration for ValueMessage._default.EncodableMessage
function ValueMessage.__default.EncodableMessage(msg#0: DatatypeType) : bool;

function ValueMessage.__default.EncodableMessage#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessage
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.EncodableMessage(msg#0) } 
    ValueMessage.__default.EncodableMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> true);

function ValueMessage.__default.EncodableMessage#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessage
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.EncodableMessage#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.EncodableMessage#requires(msg#0) == true);

// function declaration for ValueMessage._default.EncodableMessageSeq
function ValueMessage.__default.EncodableMessageSeq(msgs#0: Seq Box) : bool;

function ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessageSeq
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { ValueMessage.__default.EncodableMessageSeq(msgs#0) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> true);

function ValueMessage.__default.EncodableMessageSeq#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessageSeq
axiom (forall msgs#0: Seq Box :: 
  { ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) == true);

// function declaration for ValueMessage._default.Message_to_bytestring
function ValueMessage.__default.Message__to__bytestring(msg#0: DatatypeType) : Seq Box;

function ValueMessage.__default.Message__to__bytestring#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Message__to__bytestring
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.Message__to__bytestring(msg#0) } 
    ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && ValueMessage.Message.Define_q(msg#0))
       ==> $Is(ValueMessage.__default.Message__to__bytestring(msg#0), 
        TSeq(Tclass.NativeTypes.byte())));

function ValueMessage.__default.Message__to__bytestring#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Message__to__bytestring
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.Message__to__bytestring#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Message__to__bytestring#requires(msg#0)
       == ValueMessage.Message.Define_q(msg#0));

// function declaration for ValueMessage._default.messageSeq_to_bytestringSeq
function ValueMessage.__default.messageSeq__to__bytestringSeq($ly: LayerType, msgs#0: Seq Box) : Seq Box;

function ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq(AsFuelBottom($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($LZ, msgs#0));

// consequence axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0)
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && ValueMessage.__default.EncodableMessageSeq(msgs#0))
       ==> Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
           == Seq#Length(msgs#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(msgs#0, i#0)): DatatypeType } 
            { $Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0
                 < Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
             ==> Seq#Equal($Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#0)): Seq Box, 
              ValueMessage.__default.Message__to__bytestring($Unbox(Seq#Index(msgs#0, i#0)): DatatypeType)))
         && $Is(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function ValueMessage.__default.messageSeq__to__bytestringSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0)
       == ValueMessage.__default.EncodableMessageSeq(msgs#0));

// function declaration for ValueMessage._default.bytestringSeq_to_MessageSeq
function ValueMessage.__default.bytestringSeq__to__MessageSeq($ly: LayerType, strings#0: Seq Box) : Seq Box;

function ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq(AsFuelBottom($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($LZ, strings#0));

// consequence axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    { ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0)
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(strings#0, i#0)): Seq Box } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(strings#0)
               ==> Seq#Length($Unbox(Seq#Index(strings#0, i#0)): Seq Box) < 4294967296))
       ==> Seq#Length(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0))
           == Seq#Length(strings#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(strings#0, i#1)): Seq Box } 
            { $Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(strings#0)
             ==> ValueMessage.Message#Equal($Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#1)): DatatypeType, 
              ValueMessage.__default.bytestring__to__Message($Unbox(Seq#Index(strings#0, i#1)): Seq Box)))
         && $Is(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), 
          TSeq(Tclass.ValueMessage.Message())));

function ValueMessage.__default.bytestringSeq__to__MessageSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0) } 
  $Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0)
       == (forall i#2: int :: 
        { $Unbox(Seq#Index(strings#0, i#2)): Seq Box } 
        LitInt(0) <= i#2 && i#2 < Seq#Length(strings#0)
           ==> Seq#Length($Unbox(Seq#Index(strings#0, i#2)): Seq Box) < 4294967296));

// function declaration for ValueMessage._default.Merge
function ValueMessage.__default.Merge(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : DatatypeType;

function ValueMessage.__default.Merge#canCall(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Merge
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> $Is(ValueMessage.__default.Merge(newmessage#0, oldmessage#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.Merge#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Merge
axiom (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
  { ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) } 
  $Is(newmessage#0, Tclass.ValueMessage.Message())
       && $Is(oldmessage#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) == true);

// definition axiom for ValueMessage.__default.Merge(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
         && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0))))
         && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
             && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var value#0 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var delta#0 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0))))
             && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var olddelta#0 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var newdelta#0 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)))))
         && ValueMessage.__default.Merge(newmessage#0, oldmessage#0)
           == (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
             then (var newvalue#1 := ValueMessage.Message.value($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
              #ValueMessage.Message.Define(newvalue#1))
             else (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               then (var value#1 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var delta#1 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Define(ValueMessage.__default.ApplyDelta(delta#1, value#1))))
               else (var olddelta#1 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var newdelta#1 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Update(ValueMessage.__default.CombineDeltas(newdelta#1, olddelta#1)))))));

// definition axiom for ValueMessage.__default.Merge for all literals(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0)) } 
    ValueMessage.__default.Merge#canCall(Lit(newmessage#0), Lit(oldmessage#0))
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
         && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0))))))
         && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
             && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var value#2 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var delta#2 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#2, value#2))))
             && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var olddelta#2 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var newdelta#2 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#2, olddelta#2)))))
         && ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0))
           == (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
             then (var newvalue#3 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
              Lit(#ValueMessage.Message.Define(newvalue#3)))
             else (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
               then (var value#3 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var delta#3 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  #ValueMessage.Message.Define(ValueMessage.__default.ApplyDelta(delta#3, value#3))))
               else (var olddelta#3 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var newdelta#3 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  #ValueMessage.Message.Update(ValueMessage.__default.CombineDeltas(newdelta#3, olddelta#3)))))));

// function declaration for ValueMessage._default.IdentityMessage
function ValueMessage.__default.IdentityMessage() : DatatypeType;

function ValueMessage.__default.IdentityMessage#canCall() : bool;

// consequence axiom for ValueMessage.__default.IdentityMessage
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.IdentityMessage(), Tclass.ValueMessage.Message());

function ValueMessage.__default.IdentityMessage#requires() : bool;

// #requires axiom for ValueMessage.__default.IdentityMessage
axiom ValueMessage.__default.IdentityMessage#requires() == true;

// definition axiom for ValueMessage.__default.IdentityMessage(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == #ValueMessage.Message.Update(ValueMessage.__default.NopDelta());

// definition axiom for ValueMessage.__default.IdentityMessage for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == #ValueMessage.Message.Update(ValueMessage.__default.NopDelta());

// function declaration for ValueMessage._default.DefineDefault
function ValueMessage.__default.DefineDefault() : DatatypeType;

function ValueMessage.__default.DefineDefault#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefineDefault
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefineDefault(), Tclass.ValueMessage.Message());

function ValueMessage.__default.DefineDefault#requires() : bool;

// #requires axiom for ValueMessage.__default.DefineDefault
axiom ValueMessage.__default.DefineDefault#requires() == true;

// definition axiom for ValueMessage.__default.DefineDefault(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == #ValueMessage.Message.Define(ValueMessage.__default.DefaultValue());

// definition axiom for ValueMessage.__default.DefineDefault for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == #ValueMessage.Message.Define(ValueMessage.__default.DefaultValue());

// Constructor function declaration
function #ValueMessage.Message.Define(Seq Box) : DatatypeType;

const unique ##ValueMessage.Message.Define: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#0#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Define(a#0#0#0))
     == ##ValueMessage.Message.Define);

function ValueMessage.Message.Define_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Define);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     ==> (exists a#1#0#0: Seq Box :: d == #ValueMessage.Message.Define(a#1#0#0)));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box :: 
  { $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message())
     <==> $Is(a#2#0#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Define_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(Lit(a#4#0#0)) } 
  #ValueMessage.Message.Define(Lit(a#4#0#0))
     == Lit(#ValueMessage.Message.Define(a#4#0#0)));

function ValueMessage.Message.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#5#0#0) } 
  ValueMessage.Message.value(#ValueMessage.Message.Define(a#5#0#0)) == a#5#0#0);

// Constructor function declaration
function #ValueMessage.Message.Update(Box) : DatatypeType;

const unique ##ValueMessage.Message.Update: DtCtorId;

// Constructor identifier
axiom (forall a#6#0#0: Box :: 
  { #ValueMessage.Message.Update(a#6#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Update(a#6#0#0))
     == ##ValueMessage.Message.Update);

function ValueMessage.Message.Update_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Update);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     ==> (exists a#7#0#0: Box :: d == #ValueMessage.Message.Update(a#7#0#0)));

// Constructor $Is
axiom (forall a#8#0#0: Box :: 
  { $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message())
     <==> $IsBox(a#8#0#0, Tclass.ValueMessage.Delta()));

// Constructor $IsAlloc
axiom (forall a#9#0#0: Box, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAllocBox(a#9#0#0, Tclass.ValueMessage.Delta(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAllocBox(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Update_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAllocBox(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h));

// Constructor literal
axiom (forall a#10#0#0: Box :: 
  { #ValueMessage.Message.Update(Lit(a#10#0#0)) } 
  #ValueMessage.Message.Update(Lit(a#10#0#0))
     == Lit(#ValueMessage.Message.Update(a#10#0#0)));

function ValueMessage.Message.delta(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#11#0#0: Box :: 
  { #ValueMessage.Message.Update(a#11#0#0) } 
  ValueMessage.Message.delta(#ValueMessage.Message.Update(a#11#0#0)) == a#11#0#0);

// Depth-one case-split function
function $IsA#ValueMessage.Message(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#ValueMessage.Message(d) } 
  $IsA#ValueMessage.Message(d)
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
    { ValueMessage.Message.Define_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
  $Is(d, Tclass.ValueMessage.Message())
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Datatype extensional equality declaration
function ValueMessage.Message#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #ValueMessage.Message.Define
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(b) } 
  ValueMessage.Message.Define_q(a) && ValueMessage.Message.Define_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> Seq#Equal(ValueMessage.Message.value(a), ValueMessage.Message.value(b))));

// Datatype extensional equality definition: #ValueMessage.Message.Update
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(b) } 
  ValueMessage.Message.Update_q(a) && ValueMessage.Message.Update_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> ValueMessage.Message.delta(a) == ValueMessage.Message.delta(b)));

// Datatype extensionality axiom: ValueMessage.Message
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b) } 
  ValueMessage.Message#Equal(a, b) <==> a == b);

const unique class.ValueMessage.Message: ClassName;

// Constructor function declaration
function #UI.RangeStart.SInclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeStart.SInclusive: DtCtorId;

// Constructor identifier
axiom (forall a#12#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(a#12#0#0) } 
  DatatypeCtorId(#UI.RangeStart.SInclusive(a#12#0#0))
     == ##UI.RangeStart.SInclusive);

function UI.RangeStart.SInclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SInclusive_q(d) } 
  UI.RangeStart.SInclusive_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.SInclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SInclusive_q(d) } 
  UI.RangeStart.SInclusive_q(d)
     ==> (exists a#13#0#0: Seq Box :: d == #UI.RangeStart.SInclusive(a#13#0#0)));

function Tclass.UI.RangeStart() : Ty;

// Tclass.UI.RangeStart Tag
axiom Tag(Tclass.UI.RangeStart()) == Tagclass.UI.RangeStart;

const unique Tagclass.UI.RangeStart: TyTag;

// Box/unbox axiom for Tclass.UI.RangeStart
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.RangeStart()) } 
  $IsBox(bx, Tclass.UI.RangeStart())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.RangeStart()));

// Constructor $Is
axiom (forall a#14#0#0: Seq Box :: 
  { $Is(#UI.RangeStart.SInclusive(a#14#0#0), Tclass.UI.RangeStart()) } 
  $Is(#UI.RangeStart.SInclusive(a#14#0#0), Tclass.UI.RangeStart())
     <==> $Is(a#14#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#15#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.SInclusive(a#15#0#0), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeStart.SInclusive(a#15#0#0), Tclass.UI.RangeStart(), $h)
       <==> $IsAlloc(a#15#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeStart.SInclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeStart(), $h)
     ==> $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#16#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(Lit(a#16#0#0)) } 
  #UI.RangeStart.SInclusive(Lit(a#16#0#0))
     == Lit(#UI.RangeStart.SInclusive(a#16#0#0)));

function UI.RangeStart.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#17#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(a#17#0#0) } 
  UI.RangeStart.key(#UI.RangeStart.SInclusive(a#17#0#0)) == a#17#0#0);

// Constructor function declaration
function #UI.RangeStart.SExclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeStart.SExclusive: DtCtorId;

// Constructor identifier
axiom (forall a#18#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(a#18#0#0) } 
  DatatypeCtorId(#UI.RangeStart.SExclusive(a#18#0#0))
     == ##UI.RangeStart.SExclusive);

function UI.RangeStart.SExclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SExclusive_q(d) } 
  UI.RangeStart.SExclusive_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.SExclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SExclusive_q(d) } 
  UI.RangeStart.SExclusive_q(d)
     ==> (exists a#19#0#0: Seq Box :: d == #UI.RangeStart.SExclusive(a#19#0#0)));

// Constructor $Is
axiom (forall a#20#0#0: Seq Box :: 
  { $Is(#UI.RangeStart.SExclusive(a#20#0#0), Tclass.UI.RangeStart()) } 
  $Is(#UI.RangeStart.SExclusive(a#20#0#0), Tclass.UI.RangeStart())
     <==> $Is(a#20#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#21#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.SExclusive(a#21#0#0), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeStart.SExclusive(a#21#0#0), Tclass.UI.RangeStart(), $h)
       <==> $IsAlloc(a#21#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeStart.SExclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeStart(), $h)
     ==> $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#22#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(Lit(a#22#0#0)) } 
  #UI.RangeStart.SExclusive(Lit(a#22#0#0))
     == Lit(#UI.RangeStart.SExclusive(a#22#0#0)));

// Constructor injectivity
axiom (forall a#23#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(a#23#0#0) } 
  UI.RangeStart.key(#UI.RangeStart.SExclusive(a#23#0#0)) == a#23#0#0);

// Constructor function declaration
function #UI.RangeStart.NegativeInf() : DatatypeType;

const unique ##UI.RangeStart.NegativeInf: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.RangeStart.NegativeInf()) == ##UI.RangeStart.NegativeInf;

function UI.RangeStart.NegativeInf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d) } 
  UI.RangeStart.NegativeInf_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.NegativeInf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d) } 
  UI.RangeStart.NegativeInf_q(d) ==> d == #UI.RangeStart.NegativeInf());

// Constructor $Is
axiom $Is(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart(), $h));

// Constructor literal
axiom #UI.RangeStart.NegativeInf() == Lit(#UI.RangeStart.NegativeInf());

// Depth-one case-split function
function $IsA#UI.RangeStart(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.RangeStart(d) } 
  $IsA#UI.RangeStart(d)
     ==> UI.RangeStart.SInclusive_q(d)
       || UI.RangeStart.SExclusive_q(d)
       || UI.RangeStart.NegativeInf_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d), $Is(d, Tclass.UI.RangeStart()) } 
    { UI.RangeStart.SExclusive_q(d), $Is(d, Tclass.UI.RangeStart()) } 
    { UI.RangeStart.SInclusive_q(d), $Is(d, Tclass.UI.RangeStart()) } 
  $Is(d, Tclass.UI.RangeStart())
     ==> UI.RangeStart.SInclusive_q(d)
       || UI.RangeStart.SExclusive_q(d)
       || UI.RangeStart.NegativeInf_q(d));

// Datatype extensional equality declaration
function UI.RangeStart#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.RangeStart.SInclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.SInclusive_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.SInclusive_q(b) } 
  UI.RangeStart.SInclusive_q(a) && UI.RangeStart.SInclusive_q(b)
     ==> (UI.RangeStart#Equal(a, b)
       <==> Seq#Equal(UI.RangeStart.key(a), UI.RangeStart.key(b))));

// Datatype extensional equality definition: #UI.RangeStart.SExclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.SExclusive_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.SExclusive_q(b) } 
  UI.RangeStart.SExclusive_q(a) && UI.RangeStart.SExclusive_q(b)
     ==> (UI.RangeStart#Equal(a, b)
       <==> Seq#Equal(UI.RangeStart.key(a), UI.RangeStart.key(b))));

// Datatype extensional equality definition: #UI.RangeStart.NegativeInf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.NegativeInf_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.NegativeInf_q(b) } 
  UI.RangeStart.NegativeInf_q(a) && UI.RangeStart.NegativeInf_q(b)
     ==> (UI.RangeStart#Equal(a, b) <==> true));

// Datatype extensionality axiom: UI.RangeStart
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b) } 
  UI.RangeStart#Equal(a, b) <==> a == b);

const unique class.UI.RangeStart: ClassName;

// Constructor function declaration
function #UI.RangeEnd.EInclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeEnd.EInclusive: DtCtorId;

// Constructor identifier
axiom (forall a#29#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(a#29#0#0) } 
  DatatypeCtorId(#UI.RangeEnd.EInclusive(a#29#0#0)) == ##UI.RangeEnd.EInclusive);

function UI.RangeEnd.EInclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EInclusive_q(d) } 
  UI.RangeEnd.EInclusive_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.EInclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EInclusive_q(d) } 
  UI.RangeEnd.EInclusive_q(d)
     ==> (exists a#30#0#0: Seq Box :: d == #UI.RangeEnd.EInclusive(a#30#0#0)));

function Tclass.UI.RangeEnd() : Ty;

// Tclass.UI.RangeEnd Tag
axiom Tag(Tclass.UI.RangeEnd()) == Tagclass.UI.RangeEnd;

const unique Tagclass.UI.RangeEnd: TyTag;

// Box/unbox axiom for Tclass.UI.RangeEnd
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.RangeEnd()) } 
  $IsBox(bx, Tclass.UI.RangeEnd())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.RangeEnd()));

// Constructor $Is
axiom (forall a#31#0#0: Seq Box :: 
  { $Is(#UI.RangeEnd.EInclusive(a#31#0#0), Tclass.UI.RangeEnd()) } 
  $Is(#UI.RangeEnd.EInclusive(a#31#0#0), Tclass.UI.RangeEnd())
     <==> $Is(a#31#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#32#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.EInclusive(a#32#0#0), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeEnd.EInclusive(a#32#0#0), Tclass.UI.RangeEnd(), $h)
       <==> $IsAlloc(a#32#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeEnd.EInclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeEnd(), $h)
     ==> $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#33#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(Lit(a#33#0#0)) } 
  #UI.RangeEnd.EInclusive(Lit(a#33#0#0)) == Lit(#UI.RangeEnd.EInclusive(a#33#0#0)));

function UI.RangeEnd.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#34#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(a#34#0#0) } 
  UI.RangeEnd.key(#UI.RangeEnd.EInclusive(a#34#0#0)) == a#34#0#0);

// Constructor function declaration
function #UI.RangeEnd.EExclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeEnd.EExclusive: DtCtorId;

// Constructor identifier
axiom (forall a#35#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(a#35#0#0) } 
  DatatypeCtorId(#UI.RangeEnd.EExclusive(a#35#0#0)) == ##UI.RangeEnd.EExclusive);

function UI.RangeEnd.EExclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EExclusive_q(d) } 
  UI.RangeEnd.EExclusive_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.EExclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EExclusive_q(d) } 
  UI.RangeEnd.EExclusive_q(d)
     ==> (exists a#36#0#0: Seq Box :: d == #UI.RangeEnd.EExclusive(a#36#0#0)));

// Constructor $Is
axiom (forall a#37#0#0: Seq Box :: 
  { $Is(#UI.RangeEnd.EExclusive(a#37#0#0), Tclass.UI.RangeEnd()) } 
  $Is(#UI.RangeEnd.EExclusive(a#37#0#0), Tclass.UI.RangeEnd())
     <==> $Is(a#37#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#38#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.EExclusive(a#38#0#0), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeEnd.EExclusive(a#38#0#0), Tclass.UI.RangeEnd(), $h)
       <==> $IsAlloc(a#38#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeEnd.EExclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeEnd(), $h)
     ==> $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#39#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(Lit(a#39#0#0)) } 
  #UI.RangeEnd.EExclusive(Lit(a#39#0#0)) == Lit(#UI.RangeEnd.EExclusive(a#39#0#0)));

// Constructor injectivity
axiom (forall a#40#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(a#40#0#0) } 
  UI.RangeEnd.key(#UI.RangeEnd.EExclusive(a#40#0#0)) == a#40#0#0);

// Constructor function declaration
function #UI.RangeEnd.PositiveInf() : DatatypeType;

const unique ##UI.RangeEnd.PositiveInf: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.RangeEnd.PositiveInf()) == ##UI.RangeEnd.PositiveInf;

function UI.RangeEnd.PositiveInf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d) } 
  UI.RangeEnd.PositiveInf_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.PositiveInf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d) } 
  UI.RangeEnd.PositiveInf_q(d) ==> d == #UI.RangeEnd.PositiveInf());

// Constructor $Is
axiom $Is(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom #UI.RangeEnd.PositiveInf() == Lit(#UI.RangeEnd.PositiveInf());

// Depth-one case-split function
function $IsA#UI.RangeEnd(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.RangeEnd(d) } 
  $IsA#UI.RangeEnd(d)
     ==> UI.RangeEnd.EInclusive_q(d)
       || UI.RangeEnd.EExclusive_q(d)
       || UI.RangeEnd.PositiveInf_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
    { UI.RangeEnd.EExclusive_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
    { UI.RangeEnd.EInclusive_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
  $Is(d, Tclass.UI.RangeEnd())
     ==> UI.RangeEnd.EInclusive_q(d)
       || UI.RangeEnd.EExclusive_q(d)
       || UI.RangeEnd.PositiveInf_q(d));

// Datatype extensional equality declaration
function UI.RangeEnd#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.RangeEnd.EInclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EInclusive_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EInclusive_q(b) } 
  UI.RangeEnd.EInclusive_q(a) && UI.RangeEnd.EInclusive_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> Seq#Equal(UI.RangeEnd.key(a), UI.RangeEnd.key(b))));

// Datatype extensional equality definition: #UI.RangeEnd.EExclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EExclusive_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EExclusive_q(b) } 
  UI.RangeEnd.EExclusive_q(a) && UI.RangeEnd.EExclusive_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> Seq#Equal(UI.RangeEnd.key(a), UI.RangeEnd.key(b))));

// Datatype extensional equality definition: #UI.RangeEnd.PositiveInf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.PositiveInf_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.PositiveInf_q(b) } 
  UI.RangeEnd.PositiveInf_q(a) && UI.RangeEnd.PositiveInf_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> true));

// Datatype extensionality axiom: UI.RangeEnd
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b) } 
  UI.RangeEnd#Equal(a, b) <==> a == b);

const unique class.UI.RangeEnd: ClassName;

// Constructor function declaration
function #UI.SuccResult.SuccResult(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.SuccResult.SuccResult: DtCtorId;

// Constructor identifier
axiom (forall a#46#0#0: Seq Box, a#46#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#46#0#0, a#46#1#0) } 
  DatatypeCtorId(#UI.SuccResult.SuccResult(a#46#0#0, a#46#1#0))
     == ##UI.SuccResult.SuccResult);

function UI.SuccResult.SuccResult_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d) } 
  UI.SuccResult.SuccResult_q(d)
     <==> DatatypeCtorId(d) == ##UI.SuccResult.SuccResult);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d) } 
  UI.SuccResult.SuccResult_q(d)
     ==> (exists a#47#0#0: Seq Box, a#47#1#0: Seq Box :: 
      d == #UI.SuccResult.SuccResult(a#47#0#0, a#47#1#0)));

function Tclass.UI.SuccResult() : Ty;

// Tclass.UI.SuccResult Tag
axiom Tag(Tclass.UI.SuccResult()) == Tagclass.UI.SuccResult;

const unique Tagclass.UI.SuccResult: TyTag;

// Box/unbox axiom for Tclass.UI.SuccResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.SuccResult()) } 
  $IsBox(bx, Tclass.UI.SuccResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.SuccResult()));

// Constructor $Is
axiom (forall a#48#0#0: Seq Box, a#48#1#0: Seq Box :: 
  { $Is(#UI.SuccResult.SuccResult(a#48#0#0, a#48#1#0), Tclass.UI.SuccResult()) } 
  $Is(#UI.SuccResult.SuccResult(a#48#0#0, a#48#1#0), Tclass.UI.SuccResult())
     <==> $Is(a#48#0#0, Tclass.KeyType.Key()) && $Is(a#48#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#49#0#0: Seq Box, a#49#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.SuccResult.SuccResult(a#49#0#0, a#49#1#0), Tclass.UI.SuccResult(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.SuccResult.SuccResult(a#49#0#0, a#49#1#0), Tclass.UI.SuccResult(), $h)
       <==> $IsAlloc(a#49#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#49#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResult.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResult.SuccResult_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResult(), $h)
     ==> $IsAlloc(UI.SuccResult.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResult.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResult.SuccResult_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResult(), $h)
     ==> $IsAlloc(UI.SuccResult.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#50#0#0: Seq Box, a#50#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(Lit(a#50#0#0), Lit(a#50#1#0)) } 
  #UI.SuccResult.SuccResult(Lit(a#50#0#0), Lit(a#50#1#0))
     == Lit(#UI.SuccResult.SuccResult(a#50#0#0, a#50#1#0)));

function UI.SuccResult.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#51#0#0: Seq Box, a#51#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#51#0#0, a#51#1#0) } 
  UI.SuccResult.key(#UI.SuccResult.SuccResult(a#51#0#0, a#51#1#0)) == a#51#0#0);

function UI.SuccResult.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#52#0#0: Seq Box, a#52#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#52#0#0, a#52#1#0) } 
  UI.SuccResult.value(#UI.SuccResult.SuccResult(a#52#0#0, a#52#1#0)) == a#52#1#0);

// Depth-one case-split function
function $IsA#UI.SuccResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.SuccResult(d) } 
  $IsA#UI.SuccResult(d) ==> UI.SuccResult.SuccResult_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d), $Is(d, Tclass.UI.SuccResult()) } 
  $Is(d, Tclass.UI.SuccResult()) ==> UI.SuccResult.SuccResult_q(d));

// Datatype extensional equality declaration
function UI.SuccResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.SuccResult.SuccResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResult#Equal(a, b) } 
  true
     ==> (UI.SuccResult#Equal(a, b)
       <==> Seq#Equal(UI.SuccResult.key(a), UI.SuccResult.key(b))
         && Seq#Equal(UI.SuccResult.value(a), UI.SuccResult.value(b))));

// Datatype extensionality axiom: UI.SuccResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResult#Equal(a, b) } 
  UI.SuccResult#Equal(a, b) <==> a == b);

const unique class.UI.SuccResult: ClassName;

// Constructor function declaration
function #UI.SuccResultList.SuccResultList(Seq Box, DatatypeType) : DatatypeType;

const unique ##UI.SuccResultList.SuccResultList: DtCtorId;

// Constructor identifier
axiom (forall a#53#0#0: Seq Box, a#53#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#53#0#0, a#53#1#0) } 
  DatatypeCtorId(#UI.SuccResultList.SuccResultList(a#53#0#0, a#53#1#0))
     == ##UI.SuccResultList.SuccResultList);

function UI.SuccResultList.SuccResultList_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d) } 
  UI.SuccResultList.SuccResultList_q(d)
     <==> DatatypeCtorId(d) == ##UI.SuccResultList.SuccResultList);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d) } 
  UI.SuccResultList.SuccResultList_q(d)
     ==> (exists a#54#0#0: Seq Box, a#54#1#0: DatatypeType :: 
      d == #UI.SuccResultList.SuccResultList(a#54#0#0, a#54#1#0)));

function Tclass.UI.SuccResultList() : Ty;

// Tclass.UI.SuccResultList Tag
axiom Tag(Tclass.UI.SuccResultList()) == Tagclass.UI.SuccResultList;

const unique Tagclass.UI.SuccResultList: TyTag;

// Box/unbox axiom for Tclass.UI.SuccResultList
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.SuccResultList()) } 
  $IsBox(bx, Tclass.UI.SuccResultList())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.SuccResultList()));

// Constructor $Is
axiom (forall a#55#0#0: Seq Box, a#55#1#0: DatatypeType :: 
  { $Is(#UI.SuccResultList.SuccResultList(a#55#0#0, a#55#1#0), 
      Tclass.UI.SuccResultList()) } 
  $Is(#UI.SuccResultList.SuccResultList(a#55#0#0, a#55#1#0), 
      Tclass.UI.SuccResultList())
     <==> $Is(a#55#0#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#55#1#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#56#0#0: Seq Box, a#56#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#UI.SuccResultList.SuccResultList(a#56#0#0, a#56#1#0), 
      Tclass.UI.SuccResultList(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.SuccResultList.SuccResultList(a#56#0#0, a#56#1#0), 
        Tclass.UI.SuccResultList(), 
        $h)
       <==> $IsAlloc(a#56#0#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#56#1#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResultList.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResultList.SuccResultList_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResultList(), $h)
     ==> $IsAlloc(UI.SuccResultList.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResultList.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResultList.SuccResultList_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResultList(), $h)
     ==> $IsAlloc(UI.SuccResultList.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#57#0#0: Seq Box, a#57#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(Lit(a#57#0#0), Lit(a#57#1#0)) } 
  #UI.SuccResultList.SuccResultList(Lit(a#57#0#0), Lit(a#57#1#0))
     == Lit(#UI.SuccResultList.SuccResultList(a#57#0#0, a#57#1#0)));

function UI.SuccResultList.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#58#0#0: Seq Box, a#58#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#58#0#0, a#58#1#0) } 
  UI.SuccResultList.results(#UI.SuccResultList.SuccResultList(a#58#0#0, a#58#1#0))
     == a#58#0#0);

// Inductive seq element rank
axiom (forall a#59#0#0: Seq Box, a#59#1#0: DatatypeType, i: int :: 
  { Seq#Index(a#59#0#0, i), #UI.SuccResultList.SuccResultList(a#59#0#0, a#59#1#0) } 
  0 <= i && i < Seq#Length(a#59#0#0)
     ==> DtRank($Unbox(Seq#Index(a#59#0#0, i)): DatatypeType)
       < DtRank(#UI.SuccResultList.SuccResultList(a#59#0#0, a#59#1#0)));

// Inductive seq rank
axiom (forall a#60#0#0: Seq Box, a#60#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#60#0#0, a#60#1#0) } 
  Seq#Rank(a#60#0#0)
     < DtRank(#UI.SuccResultList.SuccResultList(a#60#0#0, a#60#1#0)));

function UI.SuccResultList.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#61#0#0: Seq Box, a#61#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#61#0#0, a#61#1#0) } 
  UI.SuccResultList.end(#UI.SuccResultList.SuccResultList(a#61#0#0, a#61#1#0))
     == a#61#1#0);

// Inductive rank
axiom (forall a#62#0#0: Seq Box, a#62#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#62#0#0, a#62#1#0) } 
  DtRank(a#62#1#0) < DtRank(#UI.SuccResultList.SuccResultList(a#62#0#0, a#62#1#0)));

// Depth-one case-split function
function $IsA#UI.SuccResultList(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.SuccResultList(d) } 
  $IsA#UI.SuccResultList(d) ==> UI.SuccResultList.SuccResultList_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d), $Is(d, Tclass.UI.SuccResultList()) } 
  $Is(d, Tclass.UI.SuccResultList()) ==> UI.SuccResultList.SuccResultList_q(d));

// Datatype extensional equality declaration
function UI.SuccResultList#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.SuccResultList.SuccResultList
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResultList#Equal(a, b) } 
  true
     ==> (UI.SuccResultList#Equal(a, b)
       <==> Seq#Equal(UI.SuccResultList.results(a), UI.SuccResultList.results(b))
         && UI.RangeEnd#Equal(UI.SuccResultList.end(a), UI.SuccResultList.end(b))));

// Datatype extensionality axiom: UI.SuccResultList
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResultList#Equal(a, b) } 
  UI.SuccResultList#Equal(a, b) <==> a == b);

const unique class.UI.SuccResultList: ClassName;

// Constructor function declaration
function #UI.Op.NoOp() : DatatypeType;

const unique ##UI.Op.NoOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.NoOp()) == ##UI.Op.NoOp;

function UI.Op.NoOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.NoOp_q(d) } 
  UI.Op.NoOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.NoOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.NoOp_q(d) } 
  UI.Op.NoOp_q(d) ==> d == #UI.Op.NoOp());

function Tclass.UI.Op() : Ty;

// Tclass.UI.Op Tag
axiom Tag(Tclass.UI.Op()) == Tagclass.UI.Op;

const unique Tagclass.UI.Op: TyTag;

// Box/unbox axiom for Tclass.UI.Op
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.Op()) } 
  $IsBox(bx, Tclass.UI.Op())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.Op()));

// Constructor $Is
axiom $Is(#UI.Op.NoOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.NoOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.NoOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.NoOp() == Lit(#UI.Op.NoOp());

// Constructor function declaration
function #UI.Op.SyncOp() : DatatypeType;

const unique ##UI.Op.SyncOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.SyncOp()) == ##UI.Op.SyncOp;

function UI.Op.SyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.SyncOp_q(d) } 
  UI.Op.SyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.SyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.SyncOp_q(d) } 
  UI.Op.SyncOp_q(d) ==> d == #UI.Op.SyncOp());

// Constructor $Is
axiom $Is(#UI.Op.SyncOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.SyncOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.SyncOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.SyncOp() == Lit(#UI.Op.SyncOp());

// Constructor function declaration
function #UI.Op.CrashOp() : DatatypeType;

const unique ##UI.Op.CrashOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.CrashOp()) == ##UI.Op.CrashOp;

function UI.Op.CrashOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.CrashOp_q(d) } 
  UI.Op.CrashOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.CrashOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.CrashOp_q(d) } 
  UI.Op.CrashOp_q(d) ==> d == #UI.Op.CrashOp());

// Constructor $Is
axiom $Is(#UI.Op.CrashOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.CrashOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.CrashOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.CrashOp() == Lit(#UI.Op.CrashOp());

// Constructor function declaration
function #UI.Op.PushSyncOp(int) : DatatypeType;

const unique ##UI.Op.PushSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#78#0#0: int :: 
  { #UI.Op.PushSyncOp(a#78#0#0) } 
  DatatypeCtorId(#UI.Op.PushSyncOp(a#78#0#0)) == ##UI.Op.PushSyncOp);

function UI.Op.PushSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PushSyncOp_q(d) } 
  UI.Op.PushSyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PushSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PushSyncOp_q(d) } 
  UI.Op.PushSyncOp_q(d)
     ==> (exists a#79#0#0: int :: d == #UI.Op.PushSyncOp(a#79#0#0)));

// Constructor $Is
axiom (forall a#80#0#0: int :: 
  { $Is(#UI.Op.PushSyncOp(a#80#0#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PushSyncOp(a#80#0#0), Tclass.UI.Op()) <==> $Is(a#80#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#81#0#0: int, $h: Heap :: 
  { $IsAlloc(#UI.Op.PushSyncOp(a#81#0#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PushSyncOp(a#81#0#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#81#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.id(d), TInt, $h) } 
  $IsGoodHeap($h) && UI.Op.PushSyncOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.id(d), TInt, $h));

// Constructor literal
axiom (forall a#82#0#0: int :: 
  { #UI.Op.PushSyncOp(LitInt(a#82#0#0)) } 
  #UI.Op.PushSyncOp(LitInt(a#82#0#0)) == Lit(#UI.Op.PushSyncOp(a#82#0#0)));

function UI.Op.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#83#0#0: int :: 
  { #UI.Op.PushSyncOp(a#83#0#0) } 
  UI.Op.id(#UI.Op.PushSyncOp(a#83#0#0)) == a#83#0#0);

// Constructor function declaration
function #UI.Op.PopSyncOp(int) : DatatypeType;

const unique ##UI.Op.PopSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#84#0#0: int :: 
  { #UI.Op.PopSyncOp(a#84#0#0) } 
  DatatypeCtorId(#UI.Op.PopSyncOp(a#84#0#0)) == ##UI.Op.PopSyncOp);

function UI.Op.PopSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PopSyncOp_q(d) } 
  UI.Op.PopSyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PopSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PopSyncOp_q(d) } 
  UI.Op.PopSyncOp_q(d)
     ==> (exists a#85#0#0: int :: d == #UI.Op.PopSyncOp(a#85#0#0)));

// Constructor $Is
axiom (forall a#86#0#0: int :: 
  { $Is(#UI.Op.PopSyncOp(a#86#0#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PopSyncOp(a#86#0#0), Tclass.UI.Op()) <==> $Is(a#86#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#87#0#0: int, $h: Heap :: 
  { $IsAlloc(#UI.Op.PopSyncOp(a#87#0#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PopSyncOp(a#87#0#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#87#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.id(d), TInt, $h) } 
  $IsGoodHeap($h) && UI.Op.PopSyncOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.id(d), TInt, $h));

// Constructor literal
axiom (forall a#88#0#0: int :: 
  { #UI.Op.PopSyncOp(LitInt(a#88#0#0)) } 
  #UI.Op.PopSyncOp(LitInt(a#88#0#0)) == Lit(#UI.Op.PopSyncOp(a#88#0#0)));

// Constructor injectivity
axiom (forall a#89#0#0: int :: 
  { #UI.Op.PopSyncOp(a#89#0#0) } 
  UI.Op.id(#UI.Op.PopSyncOp(a#89#0#0)) == a#89#0#0);

// Constructor function declaration
function #UI.Op.GetOp(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.Op.GetOp: DtCtorId;

// Constructor identifier
axiom (forall a#90#0#0: Seq Box, a#90#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#90#0#0, a#90#1#0) } 
  DatatypeCtorId(#UI.Op.GetOp(a#90#0#0, a#90#1#0)) == ##UI.Op.GetOp);

function UI.Op.GetOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.GetOp_q(d) } 
  UI.Op.GetOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.GetOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.GetOp_q(d) } 
  UI.Op.GetOp_q(d)
     ==> (exists a#91#0#0: Seq Box, a#91#1#0: Seq Box :: 
      d == #UI.Op.GetOp(a#91#0#0, a#91#1#0)));

// Constructor $Is
axiom (forall a#92#0#0: Seq Box, a#92#1#0: Seq Box :: 
  { $Is(#UI.Op.GetOp(a#92#0#0, a#92#1#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.GetOp(a#92#0#0, a#92#1#0), Tclass.UI.Op())
     <==> $Is(a#92#0#0, Tclass.KeyType.Key()) && $Is(a#92#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#93#0#0: Seq Box, a#93#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.Op.GetOp(a#93#0#0, a#93#1#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.GetOp(a#93#0#0, a#93#1#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#93#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#93#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h) && UI.Op.GetOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h) && UI.Op.GetOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#94#0#0: Seq Box, a#94#1#0: Seq Box :: 
  { #UI.Op.GetOp(Lit(a#94#0#0), Lit(a#94#1#0)) } 
  #UI.Op.GetOp(Lit(a#94#0#0), Lit(a#94#1#0))
     == Lit(#UI.Op.GetOp(a#94#0#0, a#94#1#0)));

function UI.Op.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#95#0#0: Seq Box, a#95#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#95#0#0, a#95#1#0) } 
  UI.Op.key(#UI.Op.GetOp(a#95#0#0, a#95#1#0)) == a#95#0#0);

function UI.Op.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#96#0#0: Seq Box, a#96#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#96#0#0, a#96#1#0) } 
  UI.Op.value(#UI.Op.GetOp(a#96#0#0, a#96#1#0)) == a#96#1#0);

// Constructor function declaration
function #UI.Op.PutOp(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.Op.PutOp: DtCtorId;

// Constructor identifier
axiom (forall a#97#0#0: Seq Box, a#97#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#97#0#0, a#97#1#0) } 
  DatatypeCtorId(#UI.Op.PutOp(a#97#0#0, a#97#1#0)) == ##UI.Op.PutOp);

function UI.Op.PutOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PutOp_q(d) } 
  UI.Op.PutOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PutOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PutOp_q(d) } 
  UI.Op.PutOp_q(d)
     ==> (exists a#98#0#0: Seq Box, a#98#1#0: Seq Box :: 
      d == #UI.Op.PutOp(a#98#0#0, a#98#1#0)));

// Constructor $Is
axiom (forall a#99#0#0: Seq Box, a#99#1#0: Seq Box :: 
  { $Is(#UI.Op.PutOp(a#99#0#0, a#99#1#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PutOp(a#99#0#0, a#99#1#0), Tclass.UI.Op())
     <==> $Is(a#99#0#0, Tclass.KeyType.Key()) && $Is(a#99#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#100#0#0: Seq Box, a#100#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.Op.PutOp(a#100#0#0, a#100#1#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PutOp(a#100#0#0, a#100#1#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#100#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#100#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h) && UI.Op.PutOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h) && UI.Op.PutOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#101#0#0: Seq Box, a#101#1#0: Seq Box :: 
  { #UI.Op.PutOp(Lit(a#101#0#0), Lit(a#101#1#0)) } 
  #UI.Op.PutOp(Lit(a#101#0#0), Lit(a#101#1#0))
     == Lit(#UI.Op.PutOp(a#101#0#0, a#101#1#0)));

// Constructor injectivity
axiom (forall a#102#0#0: Seq Box, a#102#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#102#0#0, a#102#1#0) } 
  UI.Op.key(#UI.Op.PutOp(a#102#0#0, a#102#1#0)) == a#102#0#0);

// Constructor injectivity
axiom (forall a#103#0#0: Seq Box, a#103#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#103#0#0, a#103#1#0) } 
  UI.Op.value(#UI.Op.PutOp(a#103#0#0, a#103#1#0)) == a#103#1#0);

// Constructor function declaration
function #UI.Op.SuccOp(DatatypeType, Seq Box, DatatypeType) : DatatypeType;

const unique ##UI.Op.SuccOp: DtCtorId;

// Constructor identifier
axiom (forall a#104#0#0: DatatypeType, a#104#1#0: Seq Box, a#104#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#104#0#0, a#104#1#0, a#104#2#0) } 
  DatatypeCtorId(#UI.Op.SuccOp(a#104#0#0, a#104#1#0, a#104#2#0)) == ##UI.Op.SuccOp);

function UI.Op.SuccOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d) } 
  UI.Op.SuccOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.SuccOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d) } 
  UI.Op.SuccOp_q(d)
     ==> (exists a#105#0#0: DatatypeType, a#105#1#0: Seq Box, a#105#2#0: DatatypeType :: 
      d == #UI.Op.SuccOp(a#105#0#0, a#105#1#0, a#105#2#0)));

// Constructor $Is
axiom (forall a#106#0#0: DatatypeType, a#106#1#0: Seq Box, a#106#2#0: DatatypeType :: 
  { $Is(#UI.Op.SuccOp(a#106#0#0, a#106#1#0, a#106#2#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.SuccOp(a#106#0#0, a#106#1#0, a#106#2#0), Tclass.UI.Op())
     <==> $Is(a#106#0#0, Tclass.UI.RangeStart())
       && $Is(a#106#1#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#106#2#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#107#0#0: DatatypeType, a#107#1#0: Seq Box, a#107#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#UI.Op.SuccOp(a#107#0#0, a#107#1#0, a#107#2#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.SuccOp(a#107#0#0, a#107#1#0, a#107#2#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#107#0#0, Tclass.UI.RangeStart(), $h)
         && $IsAlloc(a#107#1#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#107#2#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.start(d), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.start(d), Tclass.UI.RangeStart(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#108#0#0: DatatypeType, a#108#1#0: Seq Box, a#108#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(Lit(a#108#0#0), Lit(a#108#1#0), Lit(a#108#2#0)) } 
  #UI.Op.SuccOp(Lit(a#108#0#0), Lit(a#108#1#0), Lit(a#108#2#0))
     == Lit(#UI.Op.SuccOp(a#108#0#0, a#108#1#0, a#108#2#0)));

function UI.Op.start(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#109#0#0: DatatypeType, a#109#1#0: Seq Box, a#109#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#109#0#0, a#109#1#0, a#109#2#0) } 
  UI.Op.start(#UI.Op.SuccOp(a#109#0#0, a#109#1#0, a#109#2#0)) == a#109#0#0);

// Inductive rank
axiom (forall a#110#0#0: DatatypeType, a#110#1#0: Seq Box, a#110#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#110#0#0, a#110#1#0, a#110#2#0) } 
  DtRank(a#110#0#0) < DtRank(#UI.Op.SuccOp(a#110#0#0, a#110#1#0, a#110#2#0)));

function UI.Op.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#111#0#0: DatatypeType, a#111#1#0: Seq Box, a#111#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#111#0#0, a#111#1#0, a#111#2#0) } 
  UI.Op.results(#UI.Op.SuccOp(a#111#0#0, a#111#1#0, a#111#2#0)) == a#111#1#0);

// Inductive seq element rank
axiom (forall a#112#0#0: DatatypeType, a#112#1#0: Seq Box, a#112#2#0: DatatypeType, i: int :: 
  { Seq#Index(a#112#1#0, i), #UI.Op.SuccOp(a#112#0#0, a#112#1#0, a#112#2#0) } 
  0 <= i && i < Seq#Length(a#112#1#0)
     ==> DtRank($Unbox(Seq#Index(a#112#1#0, i)): DatatypeType)
       < DtRank(#UI.Op.SuccOp(a#112#0#0, a#112#1#0, a#112#2#0)));

// Inductive seq rank
axiom (forall a#113#0#0: DatatypeType, a#113#1#0: Seq Box, a#113#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#113#0#0, a#113#1#0, a#113#2#0) } 
  Seq#Rank(a#113#1#0) < DtRank(#UI.Op.SuccOp(a#113#0#0, a#113#1#0, a#113#2#0)));

function UI.Op.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#114#0#0: DatatypeType, a#114#1#0: Seq Box, a#114#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#114#0#0, a#114#1#0, a#114#2#0) } 
  UI.Op.end(#UI.Op.SuccOp(a#114#0#0, a#114#1#0, a#114#2#0)) == a#114#2#0);

// Inductive rank
axiom (forall a#115#0#0: DatatypeType, a#115#1#0: Seq Box, a#115#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#115#0#0, a#115#1#0, a#115#2#0) } 
  DtRank(a#115#2#0) < DtRank(#UI.Op.SuccOp(a#115#0#0, a#115#1#0, a#115#2#0)));

// Depth-one case-split function
function $IsA#UI.Op(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.Op(d) } 
  $IsA#UI.Op(d)
     ==> UI.Op.NoOp_q(d)
       || UI.Op.SyncOp_q(d)
       || UI.Op.CrashOp_q(d)
       || UI.Op.PushSyncOp_q(d)
       || UI.Op.PopSyncOp_q(d)
       || UI.Op.GetOp_q(d)
       || UI.Op.PutOp_q(d)
       || UI.Op.SuccOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PutOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.GetOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PopSyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PushSyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.CrashOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.SyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.NoOp_q(d), $Is(d, Tclass.UI.Op()) } 
  $Is(d, Tclass.UI.Op())
     ==> UI.Op.NoOp_q(d)
       || UI.Op.SyncOp_q(d)
       || UI.Op.CrashOp_q(d)
       || UI.Op.PushSyncOp_q(d)
       || UI.Op.PopSyncOp_q(d)
       || UI.Op.GetOp_q(d)
       || UI.Op.PutOp_q(d)
       || UI.Op.SuccOp_q(d));

// Datatype extensional equality declaration
function UI.Op#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.Op.NoOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.NoOp_q(a) } { UI.Op#Equal(a, b), UI.Op.NoOp_q(b) } 
  UI.Op.NoOp_q(a) && UI.Op.NoOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.SyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.SyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.SyncOp_q(b) } 
  UI.Op.SyncOp_q(a) && UI.Op.SyncOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.CrashOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.CrashOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.CrashOp_q(b) } 
  UI.Op.CrashOp_q(a) && UI.Op.CrashOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.PushSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PushSyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.PushSyncOp_q(b) } 
  UI.Op.PushSyncOp_q(a) && UI.Op.PushSyncOp_q(b)
     ==> (UI.Op#Equal(a, b) <==> UI.Op.id(a) == UI.Op.id(b)));

// Datatype extensional equality definition: #UI.Op.PopSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PopSyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.PopSyncOp_q(b) } 
  UI.Op.PopSyncOp_q(a) && UI.Op.PopSyncOp_q(b)
     ==> (UI.Op#Equal(a, b) <==> UI.Op.id(a) == UI.Op.id(b)));

// Datatype extensional equality definition: #UI.Op.GetOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.GetOp_q(a) } { UI.Op#Equal(a, b), UI.Op.GetOp_q(b) } 
  UI.Op.GetOp_q(a) && UI.Op.GetOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> Seq#Equal(UI.Op.key(a), UI.Op.key(b))
         && Seq#Equal(UI.Op.value(a), UI.Op.value(b))));

// Datatype extensional equality definition: #UI.Op.PutOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PutOp_q(a) } { UI.Op#Equal(a, b), UI.Op.PutOp_q(b) } 
  UI.Op.PutOp_q(a) && UI.Op.PutOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> Seq#Equal(UI.Op.key(a), UI.Op.key(b))
         && Seq#Equal(UI.Op.value(a), UI.Op.value(b))));

// Datatype extensional equality definition: #UI.Op.SuccOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.SuccOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.SuccOp_q(b) } 
  UI.Op.SuccOp_q(a) && UI.Op.SuccOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> UI.RangeStart#Equal(UI.Op.start(a), UI.Op.start(b))
         && Seq#Equal(UI.Op.results(a), UI.Op.results(b))
         && UI.RangeEnd#Equal(UI.Op.end(a), UI.Op.end(b))));

// Datatype extensionality axiom: UI.Op
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b) } 
  UI.Op#Equal(a, b) <==> a == b);

const unique class.UI.Op: ClassName;

const unique class.UI.__default: ClassName;

function Tclass.UI.__default() : Ty;

// Tclass.UI.__default Tag
axiom Tag(Tclass.UI.__default()) == Tagclass.UI.__default;

const unique Tagclass.UI.__default: TyTag;

// Box/unbox axiom for Tclass.UI.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.__default()) } 
  $IsBox(bx, Tclass.UI.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.UI.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.UI.__default()) } 
  $Is($o, Tclass.UI.__default())
     <==> $o == null || dtype($o) == Tclass.UI.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.UI.__default(), $h) } 
  $IsAlloc($o, Tclass.UI.__default(), $h) <==> $o == null || read($h, $o, alloc));

// Constructor function declaration
function #Journal.JournalEntry.JournalInsert(Seq Box, Seq Box) : DatatypeType;

const unique ##Journal.JournalEntry.JournalInsert: DtCtorId;

// Constructor identifier
axiom (forall a#116#0#0: Seq Box, a#116#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(a#116#0#0, a#116#1#0) } 
  DatatypeCtorId(#Journal.JournalEntry.JournalInsert(a#116#0#0, a#116#1#0))
     == ##Journal.JournalEntry.JournalInsert);

function Journal.JournalEntry.JournalInsert_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Journal.JournalEntry.JournalInsert_q(d) } 
  Journal.JournalEntry.JournalInsert_q(d)
     <==> DatatypeCtorId(d) == ##Journal.JournalEntry.JournalInsert);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Journal.JournalEntry.JournalInsert_q(d) } 
  Journal.JournalEntry.JournalInsert_q(d)
     ==> (exists a#117#0#0: Seq Box, a#117#1#0: Seq Box :: 
      d == #Journal.JournalEntry.JournalInsert(a#117#0#0, a#117#1#0)));

// Constructor $Is
axiom (forall a#118#0#0: Seq Box, a#118#1#0: Seq Box :: 
  { $Is(#Journal.JournalEntry.JournalInsert(a#118#0#0, a#118#1#0), 
      Tclass.Journal.JournalEntry()) } 
  $Is(#Journal.JournalEntry.JournalInsert(a#118#0#0, a#118#1#0), 
      Tclass.Journal.JournalEntry())
     <==> $Is(a#118#0#0, Tclass.KeyType.Key()) && $Is(a#118#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#119#0#0: Seq Box, a#119#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#Journal.JournalEntry.JournalInsert(a#119#0#0, a#119#1#0), 
      Tclass.Journal.JournalEntry(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Journal.JournalEntry.JournalInsert(a#119#0#0, a#119#1#0), 
        Tclass.Journal.JournalEntry(), 
        $h)
       <==> $IsAlloc(a#119#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#119#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(Journal.JournalEntry.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      Journal.JournalEntry.JournalInsert_q(d)
       && $IsAlloc(d, Tclass.Journal.JournalEntry(), $h)
     ==> $IsAlloc(Journal.JournalEntry.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(Journal.JournalEntry.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      Journal.JournalEntry.JournalInsert_q(d)
       && $IsAlloc(d, Tclass.Journal.JournalEntry(), $h)
     ==> $IsAlloc(Journal.JournalEntry.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#120#0#0: Seq Box, a#120#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(Lit(a#120#0#0), Lit(a#120#1#0)) } 
  #Journal.JournalEntry.JournalInsert(Lit(a#120#0#0), Lit(a#120#1#0))
     == Lit(#Journal.JournalEntry.JournalInsert(a#120#0#0, a#120#1#0)));

function Journal.JournalEntry.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#121#0#0: Seq Box, a#121#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(a#121#0#0, a#121#1#0) } 
  Journal.JournalEntry.key(#Journal.JournalEntry.JournalInsert(a#121#0#0, a#121#1#0))
     == a#121#0#0);

function Journal.JournalEntry.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#122#0#0: Seq Box, a#122#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(a#122#0#0, a#122#1#0) } 
  Journal.JournalEntry.value(#Journal.JournalEntry.JournalInsert(a#122#0#0, a#122#1#0))
     == a#122#1#0);

// Depth-one case-split function
function $IsA#Journal.JournalEntry(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Journal.JournalEntry(d) } 
  $IsA#Journal.JournalEntry(d) ==> Journal.JournalEntry.JournalInsert_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { Journal.JournalEntry.JournalInsert_q(d), $Is(d, Tclass.Journal.JournalEntry()) } 
  $Is(d, Tclass.Journal.JournalEntry())
     ==> Journal.JournalEntry.JournalInsert_q(d));

// Datatype extensional equality declaration
function Journal.JournalEntry#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Journal.JournalEntry.JournalInsert
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Journal.JournalEntry#Equal(a, b) } 
  true
     ==> (Journal.JournalEntry#Equal(a, b)
       <==> Seq#Equal(Journal.JournalEntry.key(a), Journal.JournalEntry.key(b))
         && Seq#Equal(Journal.JournalEntry.value(a), Journal.JournalEntry.value(b))));

// Datatype extensionality axiom: Journal.JournalEntry
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Journal.JournalEntry#Equal(a, b) } 
  Journal.JournalEntry#Equal(a, b) <==> a == b);

const unique class.Journal.JournalEntry: ClassName;

const unique class.Journal.__default: ClassName;

function Tclass.Journal.__default() : Ty;

// Tclass.Journal.__default Tag
axiom Tag(Tclass.Journal.__default()) == Tagclass.Journal.__default;

const unique Tagclass.Journal.__default: TyTag;

// Box/unbox axiom for Tclass.Journal.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Journal.__default()) } 
  $IsBox(bx, Tclass.Journal.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Journal.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Journal.__default()) } 
  $Is($o, Tclass.Journal.__default())
     <==> $o == null || dtype($o) == Tclass.Journal.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Journal.__default(), $h) } 
  $IsAlloc($o, Tclass.Journal.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Journal._default.JournalEntriesForUIOp
function Journal.__default.JournalEntriesForUIOp(uiop#0: DatatypeType) : Seq Box;

function Journal.__default.JournalEntriesForUIOp#canCall(uiop#0: DatatypeType) : bool;

// consequence axiom for Journal.__default.JournalEntriesForUIOp
axiom true
   ==> (forall uiop#0: DatatypeType :: 
    { Journal.__default.JournalEntriesForUIOp(uiop#0) } 
    Journal.__default.JournalEntriesForUIOp#canCall(uiop#0)
         || $Is(uiop#0, Tclass.UI.Op())
       ==> $Is(Journal.__default.JournalEntriesForUIOp(uiop#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function Journal.__default.JournalEntriesForUIOp#requires(DatatypeType) : bool;

// #requires axiom for Journal.__default.JournalEntriesForUIOp
axiom (forall uiop#0: DatatypeType :: 
  { Journal.__default.JournalEntriesForUIOp#requires(uiop#0) } 
  $Is(uiop#0, Tclass.UI.Op())
     ==> Journal.__default.JournalEntriesForUIOp#requires(uiop#0) == true);

// definition axiom for Journal.__default.JournalEntriesForUIOp(revealed)
axiom true
   ==> (forall uiop#0: DatatypeType :: 
    { Journal.__default.JournalEntriesForUIOp(uiop#0) } 
    Journal.__default.JournalEntriesForUIOp#canCall(uiop#0)
         || $Is(uiop#0, Tclass.UI.Op())
       ==> Journal.__default.JournalEntriesForUIOp(uiop#0)
         == (if UI.Op.PutOp_q(uiop#0)
           then Seq#Build(Seq#Empty(): Seq Box, 
            $Box(#Journal.JournalEntry.JournalInsert(UI.Op.key(uiop#0), UI.Op.value(uiop#0))))
           else Seq#Empty(): Seq Box));

// definition axiom for Journal.__default.JournalEntriesForUIOp for all literals(revealed)
axiom true
   ==> (forall uiop#0: DatatypeType :: 
    {:weight 3} { Journal.__default.JournalEntriesForUIOp(Lit(uiop#0)) } 
    Journal.__default.JournalEntriesForUIOp#canCall(Lit(uiop#0))
         || $Is(uiop#0, Tclass.UI.Op())
       ==> Journal.__default.JournalEntriesForUIOp(Lit(uiop#0))
         == (if UI.Op.PutOp_q(Lit(uiop#0))
           then Seq#Build(Seq#Empty(): Seq Box, 
            $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(UI.Op.key(Lit(uiop#0))), Lit(UI.Op.value(Lit(uiop#0)))))))
           else Seq#Empty(): Seq Box));

// function declaration for Journal._default.JournalEntriesForUIOps
function Journal.__default.JournalEntriesForUIOps($ly: LayerType, uiops#0: Seq Box) : Seq Box;

function Journal.__default.JournalEntriesForUIOps#canCall(uiops#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, uiops#0: Seq Box :: 
  { Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0) } 
  Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0)
     == Journal.__default.JournalEntriesForUIOps($ly, uiops#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, uiops#0: Seq Box :: 
  { Journal.__default.JournalEntriesForUIOps(AsFuelBottom($ly), uiops#0) } 
  Journal.__default.JournalEntriesForUIOps($ly, uiops#0)
     == Journal.__default.JournalEntriesForUIOps($LZ, uiops#0));

// consequence axiom for Journal.__default.JournalEntriesForUIOps
axiom true
   ==> (forall $ly: LayerType, uiops#0: Seq Box :: 
    { Journal.__default.JournalEntriesForUIOps($ly, uiops#0) } 
    Journal.__default.JournalEntriesForUIOps#canCall(uiops#0)
         || $Is(uiops#0, TSeq(Tclass.UI.Op()))
       ==> $Is(Journal.__default.JournalEntriesForUIOps($ly, uiops#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function Journal.__default.JournalEntriesForUIOps#requires(LayerType, Seq Box) : bool;

// #requires axiom for Journal.__default.JournalEntriesForUIOps
axiom (forall $ly: LayerType, uiops#0: Seq Box :: 
  { Journal.__default.JournalEntriesForUIOps#requires($ly, uiops#0) } 
  $Is(uiops#0, TSeq(Tclass.UI.Op()))
     ==> Journal.__default.JournalEntriesForUIOps#requires($ly, uiops#0) == true);

// definition axiom for Journal.__default.JournalEntriesForUIOps(revealed)
axiom true
   ==> (forall $ly: LayerType, uiops#0: Seq Box :: 
    { Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0) } 
    Journal.__default.JournalEntriesForUIOps#canCall(uiops#0)
         || $Is(uiops#0, TSeq(Tclass.UI.Op()))
       ==> (!Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.UI.Op(), uiops#0)
             && Journal.__default.JournalEntriesForUIOps#canCall(Sequences.__default.DropLast(Tclass.UI.Op(), uiops#0))
             && 
            Sequences.__default.Last#canCall(Tclass.UI.Op(), uiops#0)
             && Journal.__default.JournalEntriesForUIOp#canCall($Unbox(Sequences.__default.Last(Tclass.UI.Op(), uiops#0)): DatatypeType))
         && Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0)
           == (if Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
             then Seq#Empty(): Seq Box
             else Seq#Append(Journal.__default.JournalEntriesForUIOps($ly, Sequences.__default.DropLast(Tclass.UI.Op(), uiops#0)), 
              Journal.__default.JournalEntriesForUIOp($Unbox(Sequences.__default.Last(Tclass.UI.Op(), uiops#0)): DatatypeType))));

// definition axiom for Journal.__default.JournalEntriesForUIOps for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, uiops#0: Seq Box :: 
    {:weight 3} { Journal.__default.JournalEntriesForUIOps($LS($ly), Lit(uiops#0)) } 
    Journal.__default.JournalEntriesForUIOps#canCall(Lit(uiops#0))
         || $Is(uiops#0, TSeq(Tclass.UI.Op()))
       ==> (!Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.UI.Op(), Lit(uiops#0))
             && Journal.__default.JournalEntriesForUIOps#canCall(Lit(Sequences.__default.DropLast(Tclass.UI.Op(), Lit(uiops#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.UI.Op(), Lit(uiops#0))
             && Journal.__default.JournalEntriesForUIOp#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.UI.Op(), Lit(uiops#0))): DatatypeType)))
         && Journal.__default.JournalEntriesForUIOps($LS($ly), Lit(uiops#0))
           == (if Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
             then Seq#Empty(): Seq Box
             else Seq#Append(Journal.__default.JournalEntriesForUIOps($LS($ly), Lit(Sequences.__default.DropLast(Tclass.UI.Op(), Lit(uiops#0)))), 
              Journal.__default.JournalEntriesForUIOp(Lit($Unbox(Sequences.__default.Last(Tclass.UI.Op(), Lit(uiops#0))): DatatypeType)))));

const unique class.NativePackedInts.__default: ClassName;

function Tclass.NativePackedInts.__default() : Ty;

// Tclass.NativePackedInts.__default Tag
axiom Tag(Tclass.NativePackedInts.__default()) == Tagclass.NativePackedInts.__default;

const unique Tagclass.NativePackedInts.__default: TyTag;

// Box/unbox axiom for Tclass.NativePackedInts.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativePackedInts.__default()) } 
  $IsBox(bx, Tclass.NativePackedInts.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativePackedInts.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativePackedInts.__default()) } 
  $Is($o, Tclass.NativePackedInts.__default())
     <==> $o == null || dtype($o) == Tclass.NativePackedInts.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativePackedInts.__default(), $h) } 
  $IsAlloc($o, Tclass.NativePackedInts.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32
function NativePackedInts.__default.unpack__LittleEndian__Uint32($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) < 4294967296);

function NativePackedInts.__default.unpack__LittleEndian__Uint32#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(4)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64
function NativePackedInts.__default.unpack__LittleEndian__Uint64($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
           < 18446744073709551616);

function NativePackedInts.__default.unpack__LittleEndian__Uint64#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(8)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(7))): int, LitInt(72057594037927936)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                i#0)): int } 
          LitInt(0) <= i#0 && i#0 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                  i#0)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), i#0) + 4), Mul(LitInt(4), i#0))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint32())));

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(4))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(4))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))))));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                i#0)): int } 
          LitInt(0) <= i#0 && i#0 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                  i#0)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), i#0) + 8), Mul(LitInt(8), i#0))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint64())));

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(8))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(8))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))))));

procedure {:extern "NativePackedInts_Compile", "Unpack__LittleEndian__Uint32"} CheckWellformed$$NativePackedInts.__default.Unpack__LittleEndian__Uint32(packed#0: Seq Box
       where $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(packed#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616)
   returns (i#0: int where LitInt(0) <= i#0 && i#0 < 4294967296);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:extern "NativePackedInts_Compile", "Unpack__LittleEndian__Uint32"} Call$$NativePackedInts.__default.Unpack__LittleEndian__Uint32(packed#0: Seq Box
       where $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(packed#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616)
   returns (i#0: int where LitInt(0) <= i#0 && i#0 < 4294967296);
  // user-defined preconditions
  requires LitInt(0) <= idx#0;
  requires idx#0 + 4 <= Seq#Length(packed#0);
  requires Seq#Length(packed#0) < 18446744073709551616;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(packed#0, idx#0 + 4), idx#0));
  ensures i#0
     == NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32, 
      Seq#Drop(Seq#Take(packed#0, idx#0 + 4), idx#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// Constructor function declaration
function #JournalRanges.Header.Header(int, int) : DatatypeType;

const unique ##JournalRanges.Header.Header: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: int :: 
  { #JournalRanges.Header.Header(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#JournalRanges.Header.Header(a#0#0#0, a#0#1#0))
     == ##JournalRanges.Header.Header);

function JournalRanges.Header.Header_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalRanges.Header.Header_q(d) } 
  JournalRanges.Header.Header_q(d)
     <==> DatatypeCtorId(d) == ##JournalRanges.Header.Header);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalRanges.Header.Header_q(d) } 
  JournalRanges.Header.Header_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: int :: 
      d == #JournalRanges.Header.Header(a#1#0#0, a#1#1#0)));

function Tclass.JournalRanges.Header() : Ty;

// Tclass.JournalRanges.Header Tag
axiom Tag(Tclass.JournalRanges.Header()) == Tagclass.JournalRanges.Header;

const unique Tagclass.JournalRanges.Header: TyTag;

// Box/unbox axiom for Tclass.JournalRanges.Header
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalRanges.Header()) } 
  $IsBox(bx, Tclass.JournalRanges.Header())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalRanges.Header()));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: int :: 
  { $Is(#JournalRanges.Header.Header(a#2#0#0, a#2#1#0), Tclass.JournalRanges.Header()) } 
  $Is(#JournalRanges.Header.Header(a#2#0#0, a#2#1#0), Tclass.JournalRanges.Header())
     <==> $Is(a#2#0#0, TInt) && $Is(a#2#1#0, TInt));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: int, $h: Heap :: 
  { $IsAlloc(#JournalRanges.Header.Header(a#3#0#0, a#3#1#0), 
      Tclass.JournalRanges.Header(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalRanges.Header.Header(a#3#0#0, a#3#1#0), 
        Tclass.JournalRanges.Header(), 
        $h)
       <==> $IsAlloc(a#3#0#0, TInt, $h) && $IsAlloc(a#3#1#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalRanges.Header.nentries(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalRanges.Header.Header_q(d)
       && $IsAlloc(d, Tclass.JournalRanges.Header(), $h)
     ==> $IsAlloc(JournalRanges.Header.nentries(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalRanges.Header.nblocks(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalRanges.Header.Header_q(d)
       && $IsAlloc(d, Tclass.JournalRanges.Header(), $h)
     ==> $IsAlloc(JournalRanges.Header.nblocks(d), TInt, $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: int :: 
  { #JournalRanges.Header.Header(LitInt(a#4#0#0), LitInt(a#4#1#0)) } 
  #JournalRanges.Header.Header(LitInt(a#4#0#0), LitInt(a#4#1#0))
     == Lit(#JournalRanges.Header.Header(a#4#0#0, a#4#1#0)));

function JournalRanges.Header.nentries(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: int :: 
  { #JournalRanges.Header.Header(a#5#0#0, a#5#1#0) } 
  JournalRanges.Header.nentries(#JournalRanges.Header.Header(a#5#0#0, a#5#1#0))
     == a#5#0#0);

function JournalRanges.Header.nblocks(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: int :: 
  { #JournalRanges.Header.Header(a#6#0#0, a#6#1#0) } 
  JournalRanges.Header.nblocks(#JournalRanges.Header.Header(a#6#0#0, a#6#1#0))
     == a#6#1#0);

// Depth-one case-split function
function $IsA#JournalRanges.Header(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalRanges.Header(d) } 
  $IsA#JournalRanges.Header(d) ==> JournalRanges.Header.Header_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalRanges.Header.Header_q(d), $Is(d, Tclass.JournalRanges.Header()) } 
  $Is(d, Tclass.JournalRanges.Header()) ==> JournalRanges.Header.Header_q(d));

// Datatype extensional equality declaration
function JournalRanges.Header#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalRanges.Header.Header
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalRanges.Header#Equal(a, b) } 
  true
     ==> (JournalRanges.Header#Equal(a, b)
       <==> JournalRanges.Header.nentries(a) == JournalRanges.Header.nentries(b)
         && JournalRanges.Header.nblocks(a) == JournalRanges.Header.nblocks(b)));

// Datatype extensionality axiom: JournalRanges.Header
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalRanges.Header#Equal(a, b) } 
  JournalRanges.Header#Equal(a, b) <==> a == b);

const unique class.JournalRanges.Header: ClassName;

const unique class.JournalRanges.__default: ClassName;

function Tclass.JournalRanges.__default() : Ty;

// Tclass.JournalRanges.__default Tag
axiom Tag(Tclass.JournalRanges.__default()) == Tagclass.JournalRanges.__default;

const unique Tagclass.JournalRanges.__default: TyTag;

// Box/unbox axiom for Tclass.JournalRanges.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalRanges.__default()) } 
  $IsBox(bx, Tclass.JournalRanges.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalRanges.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalRanges.__default()) } 
  $Is($o, Tclass.JournalRanges.__default())
     <==> $o == null || dtype($o) == Tclass.JournalRanges.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalRanges.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalRanges.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalRanges._default.JournalRangeLen
function JournalRanges.__default.JournalRangeLen(jr#0: Seq Box) : int;

function JournalRanges.__default.JournalRangeLen#canCall(jr#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeLen
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeLen(jr#0) } 
    JournalRanges.__default.JournalRangeLen#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalRangeLen(jr#0) >= LitInt(0));

function JournalRanges.__default.JournalRangeLen#requires(Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeLen
axiom (forall jr#0: Seq Box :: 
  { JournalRanges.__default.JournalRangeLen#requires(jr#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalRangeLen#requires(jr#0) == true);

// definition axiom for JournalRanges.__default.JournalRangeLen(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeLen(jr#0) } 
    JournalRanges.__default.JournalRangeLen#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalRangeLen(jr#0) == Seq#Length(jr#0));

// definition axiom for JournalRanges.__default.JournalRangeLen for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalRangeLen(Lit(jr#0)) } 
    JournalRanges.__default.JournalRangeLen#canCall(Lit(jr#0))
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalRangeLen(Lit(jr#0)) == Seq#Length(Lit(jr#0)));

// function declaration for JournalRanges._default.JournalRangePrefix
function JournalRanges.__default.JournalRangePrefix(jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalRangePrefix#canCall(jr#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalRanges.__default.JournalRangePrefix
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangePrefix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangePrefix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangeLen(JournalRanges.__default.JournalRangePrefix(jr#0, i#0))
           == i#0
         && $Is(JournalRanges.__default.JournalRangePrefix(jr#0, i#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function JournalRanges.__default.JournalRangePrefix#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalRangePrefix
axiom (forall jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalRangePrefix#requires(jr#0, i#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalRangePrefix#requires(jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0)));

// definition axiom for JournalRanges.__default.JournalRangePrefix(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangePrefix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangePrefix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangePrefix(jr#0, i#0) == Seq#Take(jr#0, i#0));

// definition axiom for JournalRanges.__default.JournalRangePrefix for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalRanges.__default.JournalRangePrefix(Lit(jr#0), LitInt(i#0)) } 
    JournalRanges.__default.JournalRangePrefix#canCall(Lit(jr#0), LitInt(i#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(JournalRanges.__default.JournalRangeLen(Lit(jr#0))))
       ==> JournalRanges.__default.JournalRangePrefix(Lit(jr#0), LitInt(i#0))
         == Lit(Seq#Take(Lit(jr#0), LitInt(i#0))));

// function declaration for JournalRanges._default.JournalRangeSuffix
function JournalRanges.__default.JournalRangeSuffix(jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalRangeSuffix#canCall(jr#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeSuffix
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangeSuffix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangeSuffix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangeLen(JournalRanges.__default.JournalRangeSuffix(jr#0, i#0))
           == JournalRanges.__default.JournalRangeLen(jr#0) - i#0
         && $Is(JournalRanges.__default.JournalRangeSuffix(jr#0, i#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function JournalRanges.__default.JournalRangeSuffix#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeSuffix
axiom (forall jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalRangeSuffix#requires(jr#0, i#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalRangeSuffix#requires(jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0)));

// definition axiom for JournalRanges.__default.JournalRangeSuffix(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangeSuffix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangeSuffix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangeSuffix(jr#0, i#0) == Seq#Drop(jr#0, i#0));

// definition axiom for JournalRanges.__default.JournalRangeSuffix for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalRanges.__default.JournalRangeSuffix(Lit(jr#0), LitInt(i#0)) } 
    JournalRanges.__default.JournalRangeSuffix#canCall(Lit(jr#0), LitInt(i#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(JournalRanges.__default.JournalRangeLen(Lit(jr#0))))
       ==> JournalRanges.__default.JournalRangeSuffix(Lit(jr#0), LitInt(i#0))
         == Lit(Seq#Drop(Lit(jr#0), LitInt(i#0))));

// function declaration for JournalRanges._default.JournalRangeConcat
function JournalRanges.__default.JournalRangeConcat(jr1#0: Seq Box, jr2#0: Seq Box) : Seq Box;

function JournalRanges.__default.JournalRangeConcat#canCall(jr1#0: Seq Box, jr2#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeConcat
axiom true
   ==> (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0) } 
    JournalRanges.__default.JournalRangeConcat#canCall(jr1#0, jr2#0)
         || ($Is(jr1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jr2#0, TSeq(TSeq(Tclass.NativeTypes.byte()))))
       ==> $Is(JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0), 
        TSeq(TSeq(Tclass.NativeTypes.byte()))));

function JournalRanges.__default.JournalRangeConcat#requires(Seq Box, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeConcat
axiom (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
  { JournalRanges.__default.JournalRangeConcat#requires(jr1#0, jr2#0) } 
  $Is(jr1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(jr2#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalRangeConcat#requires(jr1#0, jr2#0) == true);

// definition axiom for JournalRanges.__default.JournalRangeConcat(revealed)
axiom true
   ==> (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0) } 
    JournalRanges.__default.JournalRangeConcat#canCall(jr1#0, jr2#0)
         || ($Is(jr1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jr2#0, TSeq(TSeq(Tclass.NativeTypes.byte()))))
       ==> JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0)
         == Seq#Append(jr1#0, jr2#0));

// definition axiom for JournalRanges.__default.JournalRangeConcat for all literals(revealed)
axiom true
   ==> (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalRangeConcat(Lit(jr1#0), Lit(jr2#0)) } 
    JournalRanges.__default.JournalRangeConcat#canCall(Lit(jr1#0), Lit(jr2#0))
         || ($Is(jr1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jr2#0, TSeq(TSeq(Tclass.NativeTypes.byte()))))
       ==> JournalRanges.__default.JournalRangeConcat(Lit(jr1#0), Lit(jr2#0))
         == Seq#Append(jr1#0, jr2#0));

// function declaration for JournalRanges._default.JournalRangeEmpty
function JournalRanges.__default.JournalRangeEmpty() : Seq Box;

function JournalRanges.__default.JournalRangeEmpty#canCall() : bool;

// consequence axiom for JournalRanges.__default.JournalRangeEmpty
axiom true
   ==> 
  true
   ==> $Is(JournalRanges.__default.JournalRangeEmpty(), 
    TSeq(TSeq(Tclass.NativeTypes.byte())));

function JournalRanges.__default.JournalRangeEmpty#requires() : bool;

// #requires axiom for JournalRanges.__default.JournalRangeEmpty
axiom JournalRanges.__default.JournalRangeEmpty#requires() == true;

// definition axiom for JournalRanges.__default.JournalRangeEmpty(revealed)
axiom true
   ==> 
  true
   ==> JournalRanges.__default.JournalRangeEmpty() == Lit(Seq#Empty(): Seq Box);

// definition axiom for JournalRanges.__default.JournalRangeEmpty for all literals(revealed)
axiom true
   ==> 
  true
   ==> JournalRanges.__default.JournalRangeEmpty() == Lit(Seq#Empty(): Seq Box);

// function declaration for JournalRanges._default.JournalBlocksI
function JournalRanges.__default.JournalBlocksI($ly: LayerType, jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalBlocksI#canCall(jr#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalBlocksI($LS($ly), jr#0, i#0) } 
  JournalRanges.__default.JournalBlocksI($LS($ly), jr#0, i#0)
     == JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalBlocksI(AsFuelBottom($ly), jr#0, i#0) } 
  JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0)
     == JournalRanges.__default.JournalBlocksI($LZ, jr#0, i#0));

// consequence axiom for JournalRanges.__default.JournalBlocksI
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0) } 
    JournalRanges.__default.JournalBlocksI#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(jr#0))
       ==> Seq#Length(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0)) == i#0
         && (forall j#0: int :: 
          { $Unbox(Seq#Index(jr#0, j#0)): Seq Box } 
            { $Unbox(Seq#Index(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0), j#0)): Seq Box } 
          LitInt(0) <= j#0 && j#0 < i#0
             ==> Seq#Equal($Unbox(Seq#Index(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0), j#0)): Seq Box, 
              Seq#Build(Seq#Empty(): Seq Box, Seq#Index(jr#0, j#0))))
         && $Is(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0), 
          TSeq(TSeq(TSeq(Tclass.NativeTypes.byte())))));

function JournalRanges.__default.JournalBlocksI#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalBlocksI
axiom (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalBlocksI#requires($ly, jr#0, i#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalBlocksI#requires($ly, jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(jr#0)));

// definition axiom for JournalRanges.__default.JournalBlocksI(revealed)
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlocksI($LS($ly), jr#0, i#0) } 
    JournalRanges.__default.JournalBlocksI#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(jr#0))
       ==> (i#0 != LitInt(0)
           ==> JournalRanges.__default.JournalBlocksI#canCall(jr#0, i#0 - 1))
         && JournalRanges.__default.JournalBlocksI($LS($ly), jr#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(JournalRanges.__default.JournalBlocksI($ly, jr#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Build(Seq#Empty(): Seq Box, Seq#Index(jr#0, i#0 - 1)))))));

// definition axiom for JournalRanges.__default.JournalBlocksI for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalRanges.__default.JournalBlocksI($LS($ly), Lit(jr#0), LitInt(i#0)) } 
    JournalRanges.__default.JournalBlocksI#canCall(Lit(jr#0), LitInt(i#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(jr#0)))
       ==> (LitInt(i#0) != LitInt(0)
           ==> JournalRanges.__default.JournalBlocksI#canCall(Lit(jr#0), LitInt(i#0 - 1)))
         && JournalRanges.__default.JournalBlocksI($LS($ly), Lit(jr#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(JournalRanges.__default.JournalBlocksI($LS($ly), Lit(jr#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Build(Seq#Empty(): Seq Box, Seq#Index(Lit(jr#0), LitInt(i#0 - 1))))))));

// function declaration for JournalRanges._default.JournalBlocks
function JournalRanges.__default.JournalBlocks(jr#0: Seq Box) : Seq Box;

function JournalRanges.__default.JournalBlocks#canCall(jr#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalBlocks
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalBlocks(jr#0) } 
    JournalRanges.__default.JournalBlocks#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Seq#Length(JournalRanges.__default.JournalBlocks(jr#0))
           == JournalRanges.__default.JournalRangeLen(jr#0)
         && $Is(JournalRanges.__default.JournalBlocks(jr#0), 
          TSeq(TSeq(TSeq(Tclass.NativeTypes.byte())))));

function JournalRanges.__default.JournalBlocks#requires(Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalBlocks
axiom (forall jr#0: Seq Box :: 
  { JournalRanges.__default.JournalBlocks#requires(jr#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalBlocks#requires(jr#0) == true);

// definition axiom for JournalRanges.__default.JournalBlocks(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalBlocks(jr#0) } 
    JournalRanges.__default.JournalBlocks#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalBlocksI#canCall(jr#0, Seq#Length(jr#0))
         && JournalRanges.__default.JournalBlocks(jr#0)
           == JournalRanges.__default.JournalBlocksI($LS($LZ), jr#0, Seq#Length(jr#0)));

// definition axiom for JournalRanges.__default.JournalBlocks for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalBlocks(Lit(jr#0)) } 
    JournalRanges.__default.JournalBlocks#canCall(Lit(jr#0))
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> JournalRanges.__default.JournalBlocksI#canCall(Lit(jr#0), Seq#Length(Lit(jr#0)))
         && JournalRanges.__default.JournalBlocks(Lit(jr#0))
           == JournalRanges.__default.JournalBlocksI($LS($LZ), Lit(jr#0), Seq#Length(Lit(jr#0))));

// function declaration for JournalRanges._default.JournalBlockGet
function JournalRanges.__default.JournalBlockGet(jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalBlockGet#canCall(jr#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalRanges.__default.JournalBlockGet
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlockGet(jr#0, i#0) } 
    JournalRanges.__default.JournalBlockGet#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 < JournalRanges.__default.JournalRangeLen(jr#0))
       ==> $Is(JournalRanges.__default.JournalBlockGet(jr#0, i#0), 
        TSeq(TSeq(Tclass.NativeTypes.byte()))));

function JournalRanges.__default.JournalBlockGet#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalBlockGet
axiom (forall jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalBlockGet#requires(jr#0, i#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.JournalBlockGet#requires(jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 < JournalRanges.__default.JournalRangeLen(jr#0)));

// definition axiom for JournalRanges.__default.JournalBlockGet(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlockGet(jr#0, i#0) } 
    JournalRanges.__default.JournalBlockGet#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= i#0
           && i#0 < JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalBlocks#canCall(jr#0)
         && JournalRanges.__default.JournalBlockGet(jr#0, i#0)
           == $Unbox(Seq#Index(JournalRanges.__default.JournalBlocks(jr#0), i#0)): Seq Box);

// definition axiom for JournalRanges.__default.JournalBlockGet for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalRanges.__default.JournalBlockGet(Lit(jr#0), LitInt(i#0)) } 
    JournalRanges.__default.JournalBlockGet#canCall(Lit(jr#0), LitInt(i#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < JournalRanges.__default.JournalRangeLen(Lit(jr#0)))
       ==> JournalRanges.__default.JournalBlocks#canCall(Lit(jr#0))
         && JournalRanges.__default.JournalBlockGet(Lit(jr#0), LitInt(i#0))
           == $Unbox(Seq#Index(Lit(JournalRanges.__default.JournalBlocks(Lit(jr#0))), LitInt(i#0))): Seq Box);

// function declaration for JournalRanges._default.parseHeader
function JournalRanges.__default.parseHeader($ly: LayerType, s#0: Seq Box) : DatatypeType;

function JournalRanges.__default.parseHeader#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.parseHeader($LS($ly), s#0) } 
  JournalRanges.__default.parseHeader($LS($ly), s#0)
     == JournalRanges.__default.parseHeader($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.parseHeader(AsFuelBottom($ly), s#0) } 
  JournalRanges.__default.parseHeader($ly, s#0)
     == JournalRanges.__default.parseHeader($LZ, s#0));

// consequence axiom for JournalRanges.__default.parseHeader
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.parseHeader($ly, s#0) } 
    JournalRanges.__default.parseHeader#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) >= LitInt(8))
       ==> $Is(JournalRanges.__default.parseHeader($ly, s#0), Tclass.JournalRanges.Header()));

function JournalRanges.__default.parseHeader#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.parseHeader
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.parseHeader#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalRanges.__default.parseHeader#requires($ly, s#0)
       == (Seq#Length(s#0) >= LitInt(8)));

// definition axiom for JournalRanges.__default.parseHeader(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.parseHeader($LS($ly), s#0) } 
    JournalRanges.__default.parseHeader#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) >= LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, LitInt(4)), LitInt(0)))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, LitInt(8)), LitInt(4)))
         && JournalRanges.__default.parseHeader($LS($ly), s#0)
           == #JournalRanges.Header.Header(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
              Seq#Drop(Seq#Take(s#0, LitInt(4)), LitInt(0))), 
            NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
              Seq#Drop(Seq#Take(s#0, LitInt(8)), LitInt(4)))));

// definition axiom for JournalRanges.__default.parseHeader for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.parseHeader($LS($ly), Lit(s#0)) } 
    JournalRanges.__default.parseHeader#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) >= LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4)), LitInt(0))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(8)), LitInt(4))))
         && JournalRanges.__default.parseHeader($LS($ly), Lit(s#0))
           == #JournalRanges.Header.Header(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
              Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4)), LitInt(0)))), 
            NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
              Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(8)), LitInt(4))))));

// function declaration for JournalRanges._default.parseEntries
function JournalRanges.__default.parseEntries($ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int) : DatatypeType;

function JournalRanges.__default.parseEntries#canCall(s#0: Seq Box, len#0: int, idx#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
  { JournalRanges.__default.parseEntries($LS($ly), s#0, len#0, idx#0) } 
  JournalRanges.__default.parseEntries($LS($ly), s#0, len#0, idx#0)
     == JournalRanges.__default.parseEntries($ly, s#0, len#0, idx#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
  { JournalRanges.__default.parseEntries(AsFuelBottom($ly), s#0, len#0, idx#0) } 
  JournalRanges.__default.parseEntries($ly, s#0, len#0, idx#0)
     == JournalRanges.__default.parseEntries($LZ, s#0, len#0, idx#0));

// consequence axiom for JournalRanges.__default.parseEntries
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
    { JournalRanges.__default.parseEntries($ly, s#0, len#0, idx#0) } 
    JournalRanges.__default.parseEntries#canCall(s#0, len#0, idx#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= idx#0
           && idx#0 <= Seq#Length(s#0)
           && LitInt(0) <= len#0)
       ==> $Is(JournalRanges.__default.parseEntries($ly, s#0, len#0, idx#0), 
        Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry()))));

function JournalRanges.__default.parseEntries#requires(LayerType, Seq Box, int, int) : bool;

// #requires axiom for JournalRanges.__default.parseEntries
axiom (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
  { JournalRanges.__default.parseEntries#requires($ly, s#0, len#0, idx#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalRanges.__default.parseEntries#requires($ly, s#0, len#0, idx#0)
       == (LitInt(0) <= idx#0 && idx#0 <= Seq#Length(s#0) && LitInt(0) <= len#0));

// definition axiom for JournalRanges.__default.parseEntries(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
    { JournalRanges.__default.parseEntries($LS($ly), s#0, len#0, idx#0) } 
    JournalRanges.__default.parseEntries#canCall(s#0, len#0, idx#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= idx#0
           && idx#0 <= Seq#Length(s#0)
           && LitInt(0) <= len#0)
       ==> (len#0 != LitInt(0)
           ==> 
          idx#0 + 4 <= Seq#Length(s#0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0))
             && (var keyLen#0 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                  Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0)); 
              (idx#0 + 4 + keyLen#0 + 4 <= Seq#Length(s#0)
                   ==> KeyType.__default.MaxLen#canCall())
                 && (idx#0 + 4 + keyLen#0 + 4 <= Seq#Length(s#0)
                     && keyLen#0 <= LitInt(KeyType.__default.MaxLen())
                   ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0 + 4), idx#0 + 4 + keyLen#0))
                     && (var valueLen#0 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0 + 4), idx#0 + 4 + keyLen#0)); 
                      (idx#0 + 4 + keyLen#0 + 4 + valueLen#0 <= Seq#Length(s#0)
                           ==> ValueType.__default.MaxLen#canCall())
                         && (idx#0 + 4 + keyLen#0 + 4 + valueLen#0 <= Seq#Length(s#0)
                             && valueLen#0 <= LitInt(ValueType.__default.MaxLen())
                           ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0 - 1, idx#0 + 4 + keyLen#0 + 4 + valueLen#0))))))
         && JournalRanges.__default.parseEntries($LS($ly), s#0, len#0, idx#0)
           == (if len#0 == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if idx#0 + 4 <= Seq#Length(s#0)
               then (var keyLen#0 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0)); 
                (if idx#0 + 4 + keyLen#0 + 4 <= Seq#Length(s#0)
                     && keyLen#0 <= LitInt(KeyType.__default.MaxLen())
                   then (var key#0 := Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0), idx#0 + 4); 
                    (var valueLen#0 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0 + 4), idx#0 + 4 + keyLen#0)); 
                      (if idx#0 + 4 + keyLen#0 + 4 + valueLen#0 <= Seq#Length(s#0)
                           && valueLen#0 <= LitInt(ValueType.__default.MaxLen())
                         then (var value#0 := Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#0 + 4 + valueLen#0), idx#0 + 4 + keyLen#0 + 4); 
                          (var je#0 := #Journal.JournalEntry.JournalInsert(key#0, value#0); 
                            (var rest#0 := JournalRanges.__default.parseEntries($ly, s#0, len#0 - 1, idx#0 + 4 + keyLen#0 + 4 + valueLen#0); 
                              (if Options.Option.Some_q(rest#0)
                                 then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(je#0)), 
                                      $Unbox(Options.Option.value(rest#0)): Seq Box)))
                                 else #Options.Option.None()))))
                         else #Options.Option.None())))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// definition axiom for JournalRanges.__default.parseEntries for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
    {:weight 3} { JournalRanges.__default.parseEntries($LS($ly), s#0, LitInt(len#0), idx#0) } 
    JournalRanges.__default.parseEntries#canCall(s#0, LitInt(len#0), idx#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= idx#0
           && idx#0 <= Seq#Length(s#0)
           && LitInt(0) <= LitInt(len#0))
       ==> (LitInt(len#0) != LitInt(0)
           ==> 
          idx#0 + 4 <= Seq#Length(s#0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0))
             && (var keyLen#1 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                  Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0)); 
              (idx#0 + 4 + keyLen#1 + 4 <= Seq#Length(s#0)
                   ==> KeyType.__default.MaxLen#canCall())
                 && (idx#0 + 4 + keyLen#1 + 4 <= Seq#Length(s#0)
                     && keyLen#1 <= LitInt(KeyType.__default.MaxLen())
                   ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1 + 4), idx#0 + 4 + keyLen#1))
                     && (var valueLen#1 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1 + 4), idx#0 + 4 + keyLen#1)); 
                      (idx#0 + 4 + keyLen#1 + 4 + valueLen#1 <= Seq#Length(s#0)
                           ==> ValueType.__default.MaxLen#canCall())
                         && (idx#0 + 4 + keyLen#1 + 4 + valueLen#1 <= Seq#Length(s#0)
                             && valueLen#1 <= LitInt(ValueType.__default.MaxLen())
                           ==> JournalRanges.__default.parseEntries#canCall(s#0, LitInt(len#0 - 1), idx#0 + 4 + keyLen#1 + 4 + valueLen#1))))))
         && JournalRanges.__default.parseEntries($LS($ly), s#0, LitInt(len#0), idx#0)
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if idx#0 + 4 <= Seq#Length(s#0)
               then (var keyLen#1 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Seq#Drop(Seq#Take(s#0, idx#0 + 4), idx#0)); 
                (if idx#0 + 4 + keyLen#1 + 4 <= Seq#Length(s#0)
                     && keyLen#1 <= LitInt(KeyType.__default.MaxLen())
                   then (var key#1 := Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1), idx#0 + 4); 
                    (var valueLen#1 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1 + 4), idx#0 + 4 + keyLen#1)); 
                      (if idx#0 + 4 + keyLen#1 + 4 + valueLen#1 <= Seq#Length(s#0)
                           && valueLen#1 <= LitInt(ValueType.__default.MaxLen())
                         then (var value#1 := Seq#Drop(Seq#Take(s#0, idx#0 + 4 + keyLen#1 + 4 + valueLen#1), idx#0 + 4 + keyLen#1 + 4); 
                          (var je#1 := #Journal.JournalEntry.JournalInsert(key#1, value#1); 
                            (var rest#1 := JournalRanges.__default.parseEntries($LS($ly), s#0, LitInt(len#0 - 1), idx#0 + 4 + keyLen#1 + 4 + valueLen#1); 
                              (if Options.Option.Some_q(rest#1)
                                 then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(je#1)), 
                                      $Unbox(Options.Option.value(rest#1)): Seq Box)))
                                 else #Options.Option.None()))))
                         else #Options.Option.None())))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// definition axiom for JournalRanges.__default.parseEntries for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, len#0: int, idx#0: int :: 
    {:weight 3} { JournalRanges.__default.parseEntries($LS($ly), Lit(s#0), LitInt(len#0), LitInt(idx#0)) } 
    JournalRanges.__default.parseEntries#canCall(Lit(s#0), LitInt(len#0), LitInt(idx#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(idx#0)
           && LitInt(idx#0) <= Seq#Length(Lit(s#0))
           && LitInt(0) <= LitInt(len#0))
       ==> (LitInt(len#0) != LitInt(0)
           ==> 
          LitInt(idx#0 + 4) <= Seq#Length(Lit(s#0))
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(idx#0 + 4)), LitInt(idx#0))))
             && (var keyLen#2 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                  Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(idx#0 + 4)), LitInt(idx#0)))); 
              (idx#0 + 4 + keyLen#2 + 4 <= Seq#Length(Lit(s#0))
                   ==> KeyType.__default.MaxLen#canCall())
                 && (idx#0 + 4 + keyLen#2 + 4 <= Seq#Length(Lit(s#0))
                     && keyLen#2 <= LitInt(KeyType.__default.MaxLen())
                   ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2 + 4), idx#0 + 4 + keyLen#2))
                     && (var valueLen#2 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2 + 4), idx#0 + 4 + keyLen#2)); 
                      (idx#0 + 4 + keyLen#2 + 4 + valueLen#2 <= Seq#Length(Lit(s#0))
                           ==> ValueType.__default.MaxLen#canCall())
                         && (idx#0 + 4 + keyLen#2 + 4 + valueLen#2 <= Seq#Length(Lit(s#0))
                             && valueLen#2 <= LitInt(ValueType.__default.MaxLen())
                           ==> JournalRanges.__default.parseEntries#canCall(Lit(s#0), LitInt(len#0 - 1), idx#0 + 4 + keyLen#2 + 4 + valueLen#2))))))
         && JournalRanges.__default.parseEntries($LS($ly), Lit(s#0), LitInt(len#0), LitInt(idx#0))
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if LitInt(idx#0 + 4) <= Seq#Length(Lit(s#0))
               then (var keyLen#2 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(idx#0 + 4)), LitInt(idx#0)))); 
                (if idx#0 + 4 + keyLen#2 + 4 <= Seq#Length(Lit(s#0))
                     && keyLen#2 <= LitInt(KeyType.__default.MaxLen())
                   then (var key#2 := Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2), LitInt(idx#0 + 4)); 
                    (var valueLen#2 := NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                          Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2 + 4), idx#0 + 4 + keyLen#2)); 
                      (if idx#0 + 4 + keyLen#2 + 4 + valueLen#2 <= Seq#Length(Lit(s#0))
                           && valueLen#2 <= LitInt(ValueType.__default.MaxLen())
                         then (var value#2 := Seq#Drop(Seq#Take(Lit(s#0), idx#0 + 4 + keyLen#2 + 4 + valueLen#2), 
                              idx#0 + 4 + keyLen#2 + 4); 
                          (var je#2 := #Journal.JournalEntry.JournalInsert(key#2, value#2); 
                            (var rest#2 := JournalRanges.__default.parseEntries($LS($ly), Lit(s#0), LitInt(len#0 - 1), idx#0 + 4 + keyLen#2 + 4 + valueLen#2); 
                              (if Options.Option.Some_q(rest#2)
                                 then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, $Box(je#2)), 
                                      $Unbox(Options.Option.value(rest#2)): Seq Box)))
                                 else #Options.Option.None()))))
                         else #Options.Option.None())))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// function declaration for JournalRanges._default.parseJournalRangeOfBytes
function JournalRanges.__default.parseJournalRangeOfBytes(s#0: Seq Box, len#0: int) : DatatypeType;

function JournalRanges.__default.parseJournalRangeOfBytes#canCall(s#0: Seq Box, len#0: int) : bool;

// consequence axiom for JournalRanges.__default.parseJournalRangeOfBytes
axiom true
   ==> (forall s#0: Seq Box, len#0: int :: 
    { JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0) } 
    JournalRanges.__default.parseJournalRangeOfBytes#canCall(s#0, len#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(s#0) >= LitInt(8)
           && LitInt(0) <= len#0)
       ==> $Is(JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0), 
        Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry()))));

function JournalRanges.__default.parseJournalRangeOfBytes#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.parseJournalRangeOfBytes
axiom (forall s#0: Seq Box, len#0: int :: 
  { JournalRanges.__default.parseJournalRangeOfBytes#requires(s#0, len#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalRanges.__default.parseJournalRangeOfBytes#requires(s#0, len#0)
       == (Seq#Length(s#0) >= LitInt(8) && LitInt(0) <= len#0));

// definition axiom for JournalRanges.__default.parseJournalRangeOfBytes(revealed)
axiom true
   ==> (forall s#0: Seq Box, len#0: int :: 
    { JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0) } 
    JournalRanges.__default.parseJournalRangeOfBytes#canCall(s#0, len#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(s#0) >= LitInt(8)
           && LitInt(0) <= len#0)
       ==> JournalRanges.__default.parseEntries#canCall(s#0, len#0, LitInt(8))
         && JournalRanges.__default.parseJournalRangeOfBytes(s#0, len#0)
           == JournalRanges.__default.parseEntries($LS($LZ), s#0, len#0, LitInt(8)));

// definition axiom for JournalRanges.__default.parseJournalRangeOfBytes for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box, len#0: int :: 
    {:weight 3} { JournalRanges.__default.parseJournalRangeOfBytes(Lit(s#0), LitInt(len#0)) } 
    JournalRanges.__default.parseJournalRangeOfBytes#canCall(Lit(s#0), LitInt(len#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(Lit(s#0)) >= LitInt(8)
           && LitInt(0) <= LitInt(len#0))
       ==> JournalRanges.__default.parseEntries#canCall(Lit(s#0), LitInt(len#0), LitInt(8))
         && JournalRanges.__default.parseJournalRangeOfBytes(Lit(s#0), LitInt(len#0))
           == Lit(JournalRanges.__default.parseEntries($LS($LZ), Lit(s#0), LitInt(len#0), LitInt(8))));

// function declaration for JournalRanges._default.parseJournalRange
function JournalRanges.__default.parseJournalRange($ly: LayerType, jr#0: Seq Box) : DatatypeType;

function JournalRanges.__default.parseJournalRange#canCall(jr#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box :: 
  { JournalRanges.__default.parseJournalRange($LS($ly), jr#0) } 
  JournalRanges.__default.parseJournalRange($LS($ly), jr#0)
     == JournalRanges.__default.parseJournalRange($ly, jr#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box :: 
  { JournalRanges.__default.parseJournalRange(AsFuelBottom($ly), jr#0) } 
  JournalRanges.__default.parseJournalRange($ly, jr#0)
     == JournalRanges.__default.parseJournalRange($LZ, jr#0));

// consequence axiom for JournalRanges.__default.parseJournalRange
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box :: 
    { JournalRanges.__default.parseJournalRange($ly, jr#0) } 
    JournalRanges.__default.parseJournalRange#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(JournalRanges.__default.parseJournalRange($ly, jr#0), 
        Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry()))));

function JournalRanges.__default.parseJournalRange#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.parseJournalRange
axiom (forall $ly: LayerType, jr#0: Seq Box :: 
  { JournalRanges.__default.parseJournalRange#requires($ly, jr#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> JournalRanges.__default.parseJournalRange#requires($ly, jr#0) == true);

// definition axiom for JournalRanges.__default.parseJournalRange(revealed)
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box :: 
    { JournalRanges.__default.parseJournalRange($LS($ly), jr#0) } 
    JournalRanges.__default.parseJournalRange#canCall(jr#0)
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(jr#0) != LitInt(0)
           ==> 
          Seq#Length($Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box) >= LitInt(8)
           ==> JournalRanges.__default.parseHeader#canCall($Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box)
             && (var header#0 := JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, 
                  $Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box); 
              JournalRanges.Header.Header_q(header#0)
                 && (LitInt(0) <= JournalRanges.Header.nentries(header#0)
                   ==> JournalRanges.Header.Header_q(header#0)
                     && (LitInt(1) <= JournalRanges.Header.nblocks(header#0)
                       ==> JournalRanges.Header.Header_q(header#0)))
                 && (LitInt(0) <= JournalRanges.Header.nentries(header#0)
                     && 
                    LitInt(1) <= JournalRanges.Header.nblocks(header#0)
                     && JournalRanges.Header.nblocks(header#0) <= Seq#Length(jr#0)
                   ==> JournalRanges.Header.Header_q(header#0)
                     && Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), 
                      Seq#Take(jr#0, JournalRanges.Header.nblocks(header#0)))
                     && JournalRanges.Header.Header_q(header#0)
                     && JournalRanges.__default.parseJournalRangeOfBytes#canCall(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                        StartFuel_Sequences._default.concatSeq, 
                        Seq#Take(jr#0, JournalRanges.Header.nblocks(header#0))), 
                      JournalRanges.Header.nentries(header#0))
                     && (var p1#0 := JournalRanges.__default.parseJournalRangeOfBytes(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                            StartFuel_Sequences._default.concatSeq, 
                            Seq#Take(jr#0, JournalRanges.Header.nblocks(header#0))), 
                          JournalRanges.Header.nentries(header#0)); 
                      Options.Option.Some_q(p1#0)
                         ==> JournalRanges.Header.Header_q(header#0)
                           && JournalRanges.__default.parseJournalRange#canCall(Seq#Drop(jr#0, JournalRanges.Header.nblocks(header#0)))))))
         && JournalRanges.__default.parseJournalRange($LS($ly), jr#0)
           == (if Seq#Length(jr#0) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if Seq#Length($Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box) >= LitInt(8)
               then (var header#0 := JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, 
                    $Unbox(Seq#Index(jr#0, LitInt(0))): Seq Box); 
                (if LitInt(0) <= JournalRanges.Header.nentries(header#0)
                     && 
                    LitInt(1) <= JournalRanges.Header.nblocks(header#0)
                     && JournalRanges.Header.nblocks(header#0) <= Seq#Length(jr#0)
                   then (var p1#0 := JournalRanges.__default.parseJournalRangeOfBytes(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                          StartFuel_Sequences._default.concatSeq, 
                          Seq#Take(jr#0, JournalRanges.Header.nblocks(header#0))), 
                        JournalRanges.Header.nentries(header#0)); 
                    (if Options.Option.Some_q(p1#0)
                       then (var p2#0 := JournalRanges.__default.parseJournalRange($ly, Seq#Drop(jr#0, JournalRanges.Header.nblocks(header#0))); 
                        (if Options.Option.Some_q(p2#0)
                           then #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(p1#0)): Seq Box, 
                                $Unbox(Options.Option.value(p2#0)): Seq Box)))
                           else #Options.Option.None()))
                       else #Options.Option.None()))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// definition axiom for JournalRanges.__default.parseJournalRange for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.parseJournalRange($LS($ly), Lit(jr#0)) } 
    JournalRanges.__default.parseJournalRange#canCall(Lit(jr#0))
         || $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(jr#0)) != LitInt(0)
           ==> 
          Seq#Length($Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box) >= LitInt(8)
           ==> JournalRanges.__default.parseHeader#canCall($Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box)
             && (var header#1 := JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, 
                  $Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box); 
              JournalRanges.Header.Header_q(header#1)
                 && (LitInt(0) <= JournalRanges.Header.nentries(header#1)
                   ==> JournalRanges.Header.Header_q(header#1)
                     && (LitInt(1) <= JournalRanges.Header.nblocks(header#1)
                       ==> JournalRanges.Header.Header_q(header#1)))
                 && (LitInt(0) <= JournalRanges.Header.nentries(header#1)
                     && 
                    LitInt(1) <= JournalRanges.Header.nblocks(header#1)
                     && JournalRanges.Header.nblocks(header#1) <= Seq#Length(Lit(jr#0))
                   ==> JournalRanges.Header.Header_q(header#1)
                     && Sequences.__default.concatSeq#canCall(Tclass.NativeTypes.byte(), 
                      Seq#Take(Lit(jr#0), JournalRanges.Header.nblocks(header#1)))
                     && JournalRanges.Header.Header_q(header#1)
                     && JournalRanges.__default.parseJournalRangeOfBytes#canCall(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                        StartFuel_Sequences._default.concatSeq, 
                        Seq#Take(Lit(jr#0), JournalRanges.Header.nblocks(header#1))), 
                      JournalRanges.Header.nentries(header#1))
                     && (var p1#1 := JournalRanges.__default.parseJournalRangeOfBytes(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                            StartFuel_Sequences._default.concatSeq, 
                            Seq#Take(Lit(jr#0), JournalRanges.Header.nblocks(header#1))), 
                          JournalRanges.Header.nentries(header#1)); 
                      Options.Option.Some_q(p1#1)
                         ==> JournalRanges.Header.Header_q(header#1)
                           && JournalRanges.__default.parseJournalRange#canCall(Seq#Drop(Lit(jr#0), JournalRanges.Header.nblocks(header#1)))))))
         && JournalRanges.__default.parseJournalRange($LS($ly), Lit(jr#0))
           == (if Seq#Length(Lit(jr#0)) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if Seq#Length($Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box) >= LitInt(8)
               then (var header#1 := JournalRanges.__default.parseHeader(StartFuel_JournalRanges._default.parseHeader, 
                    $Unbox(Seq#Index(Lit(jr#0), LitInt(0))): Seq Box); 
                (if LitInt(0) <= JournalRanges.Header.nentries(header#1)
                     && 
                    LitInt(1) <= JournalRanges.Header.nblocks(header#1)
                     && JournalRanges.Header.nblocks(header#1) <= Seq#Length(Lit(jr#0))
                   then (var p1#1 := JournalRanges.__default.parseJournalRangeOfBytes(Sequences.__default.concatSeq(Tclass.NativeTypes.byte(), 
                          StartFuel_Sequences._default.concatSeq, 
                          Seq#Take(Lit(jr#0), JournalRanges.Header.nblocks(header#1))), 
                        JournalRanges.Header.nentries(header#1)); 
                    (if Options.Option.Some_q(p1#1)
                       then (var p2#1 := JournalRanges.__default.parseJournalRange($LS($ly), Seq#Drop(Lit(jr#0), JournalRanges.Header.nblocks(header#1))); 
                        (if Options.Option.Some_q(p2#1)
                           then #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(p1#1)): Seq Box, 
                                $Unbox(Options.Option.value(p2#1)): Seq Box)))
                           else #Options.Option.None()))
                       else #Options.Option.None()))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// function declaration for JournalRanges._default.JournalRangeParses
function JournalRanges.__default.JournalRangeParses(jr#0: Seq Box, jes#0: Seq Box) : bool;

function JournalRanges.__default.JournalRangeParses#canCall(jr#0: Seq Box, jes#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeParses
axiom true
   ==> (forall jr#0: Seq Box, jes#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeParses(jr#0, jes#0) } 
    JournalRanges.__default.JournalRangeParses#canCall(jr#0, jes#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> true);

function JournalRanges.__default.JournalRangeParses#requires(Seq Box, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeParses
axiom (forall jr#0: Seq Box, jes#0: Seq Box :: 
  { JournalRanges.__default.JournalRangeParses#requires(jr#0, jes#0) } 
  $Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalRanges.__default.JournalRangeParses#requires(jr#0, jes#0) == true);

// definition axiom for JournalRanges.__default.JournalRangeParses(revealed)
axiom true
   ==> (forall jr#0: Seq Box, jes#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeParses(jr#0, jes#0) } 
    JournalRanges.__default.JournalRangeParses#canCall(jr#0, jes#0)
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> $IsA#Options.Option(JournalRanges.__default.parseJournalRange($LS($LZ), jr#0))
         && JournalRanges.__default.parseJournalRange#canCall(jr#0)
         && JournalRanges.__default.JournalRangeParses(jr#0, jes#0)
           == Options.Option#Equal(JournalRanges.__default.parseJournalRange($LS($LZ), jr#0), 
            #Options.Option.Some($Box(jes#0))));

// definition axiom for JournalRanges.__default.JournalRangeParses for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, jes#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalRangeParses(Lit(jr#0), Lit(jes#0)) } 
    JournalRanges.__default.JournalRangeParses#canCall(Lit(jr#0), Lit(jes#0))
         || ($Is(jr#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> $IsA#Options.Option(Lit(JournalRanges.__default.parseJournalRange($LS($LZ), Lit(jr#0))))
         && JournalRanges.__default.parseJournalRange#canCall(Lit(jr#0))
         && JournalRanges.__default.JournalRangeParses(Lit(jr#0), Lit(jes#0))
           == Options.Option#Equal(JournalRanges.__default.parseJournalRange($LS($LZ), Lit(jr#0)), 
            #Options.Option.Some($Box(Lit(jes#0)))));

// function declaration for JournalRanges._default.WeightJournalEntryUint64
function JournalRanges.__default.WeightJournalEntryUint64(s#0: DatatypeType) : int;

function JournalRanges.__default.WeightJournalEntryUint64#canCall(s#0: DatatypeType) : bool;

// consequence axiom for JournalRanges.__default.WeightJournalEntryUint64
axiom true
   ==> (forall s#0: DatatypeType :: 
    { JournalRanges.__default.WeightJournalEntryUint64(s#0) } 
    JournalRanges.__default.WeightJournalEntryUint64#canCall(s#0)
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> LitInt(0) <= JournalRanges.__default.WeightJournalEntryUint64(s#0)
         && JournalRanges.__default.WeightJournalEntryUint64(s#0) < 18446744073709551616);

function JournalRanges.__default.WeightJournalEntryUint64#requires(DatatypeType) : bool;

// #requires axiom for JournalRanges.__default.WeightJournalEntryUint64
axiom (forall s#0: DatatypeType :: 
  { JournalRanges.__default.WeightJournalEntryUint64#requires(s#0) } 
  $Is(s#0, Tclass.Journal.JournalEntry())
     ==> JournalRanges.__default.WeightJournalEntryUint64#requires(s#0) == true);

// definition axiom for JournalRanges.__default.WeightJournalEntryUint64(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    { JournalRanges.__default.WeightJournalEntryUint64(s#0) } 
    JournalRanges.__default.WeightJournalEntryUint64#canCall(s#0)
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> Journal.JournalEntry.JournalInsert_q(s#0)
         && Journal.JournalEntry.JournalInsert_q(s#0)
         && JournalRanges.__default.WeightJournalEntryUint64(s#0)
           == 8
             + Seq#Length(Journal.JournalEntry.key(s#0))
             + Seq#Length(Journal.JournalEntry.value(s#0)));

// definition axiom for JournalRanges.__default.WeightJournalEntryUint64 for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    {:weight 3} { JournalRanges.__default.WeightJournalEntryUint64(Lit(s#0)) } 
    JournalRanges.__default.WeightJournalEntryUint64#canCall(Lit(s#0))
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> Journal.JournalEntry.JournalInsert_q(Lit(s#0))
         && Journal.JournalEntry.JournalInsert_q(Lit(s#0))
         && JournalRanges.__default.WeightJournalEntryUint64(Lit(s#0))
           == 8
             + Seq#Length(Lit(Journal.JournalEntry.key(Lit(s#0))))
             + Seq#Length(Lit(Journal.JournalEntry.value(Lit(s#0)))));

// function declaration for JournalRanges._default.WeightJournalEntry
function JournalRanges.__default.WeightJournalEntry(s#0: DatatypeType) : int;

function JournalRanges.__default.WeightJournalEntry#canCall(s#0: DatatypeType) : bool;

// consequence axiom for JournalRanges.__default.WeightJournalEntry
axiom true
   ==> (forall s#0: DatatypeType :: 
    { JournalRanges.__default.WeightJournalEntry(s#0) } 
    JournalRanges.__default.WeightJournalEntry#canCall(s#0)
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> true);

function JournalRanges.__default.WeightJournalEntry#requires(DatatypeType) : bool;

// #requires axiom for JournalRanges.__default.WeightJournalEntry
axiom (forall s#0: DatatypeType :: 
  { JournalRanges.__default.WeightJournalEntry#requires(s#0) } 
  $Is(s#0, Tclass.Journal.JournalEntry())
     ==> JournalRanges.__default.WeightJournalEntry#requires(s#0) == true);

// definition axiom for JournalRanges.__default.WeightJournalEntry(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    { JournalRanges.__default.WeightJournalEntry(s#0) } 
    JournalRanges.__default.WeightJournalEntry#canCall(s#0)
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> Journal.JournalEntry.JournalInsert_q(s#0)
         && Journal.JournalEntry.JournalInsert_q(s#0)
         && JournalRanges.__default.WeightJournalEntry(s#0)
           == 8
             + Seq#Length(Journal.JournalEntry.key(s#0))
             + Seq#Length(Journal.JournalEntry.value(s#0)));

// definition axiom for JournalRanges.__default.WeightJournalEntry for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    {:weight 3} { JournalRanges.__default.WeightJournalEntry(Lit(s#0)) } 
    JournalRanges.__default.WeightJournalEntry#canCall(Lit(s#0))
         || $Is(s#0, Tclass.Journal.JournalEntry())
       ==> Journal.JournalEntry.JournalInsert_q(Lit(s#0))
         && Journal.JournalEntry.JournalInsert_q(Lit(s#0))
         && JournalRanges.__default.WeightJournalEntry(Lit(s#0))
           == 8
             + Seq#Length(Lit(Journal.JournalEntry.key(Lit(s#0))))
             + Seq#Length(Lit(Journal.JournalEntry.value(Lit(s#0)))));

// function declaration for JournalRanges._default.SumJournalEntries
function JournalRanges.__default.SumJournalEntries($ly: LayerType, s#0: Seq Box) : int;

function JournalRanges.__default.SumJournalEntries#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.SumJournalEntries($LS($ly), s#0) } 
  JournalRanges.__default.SumJournalEntries($LS($ly), s#0)
     == JournalRanges.__default.SumJournalEntries($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.SumJournalEntries(AsFuelBottom($ly), s#0) } 
  JournalRanges.__default.SumJournalEntries($ly, s#0)
     == JournalRanges.__default.SumJournalEntries($LZ, s#0));

// consequence axiom for JournalRanges.__default.SumJournalEntries
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.SumJournalEntries($ly, s#0) } 
    JournalRanges.__default.SumJournalEntries#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> JournalRanges.__default.SumJournalEntries($ly, s#0) >= LitInt(0));

function JournalRanges.__default.SumJournalEntries#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.SumJournalEntries
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.SumJournalEntries#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalRanges.__default.SumJournalEntries#requires($ly, s#0) == true);

// definition axiom for JournalRanges.__default.SumJournalEntries(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.SumJournalEntries($LS($ly), s#0) } 
    JournalRanges.__default.SumJournalEntries#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> (Seq#Length(s#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.Journal.JournalEntry(), s#0)
             && JournalRanges.__default.SumJournalEntries#canCall(Sequences.__default.DropLast(Tclass.Journal.JournalEntry(), s#0))
             && 
            Sequences.__default.Last#canCall(Tclass.Journal.JournalEntry(), s#0)
             && JournalRanges.__default.WeightJournalEntry#canCall($Unbox(Sequences.__default.Last(Tclass.Journal.JournalEntry(), s#0)): DatatypeType))
         && JournalRanges.__default.SumJournalEntries($LS($ly), s#0)
           == (if Seq#Length(s#0) == LitInt(0)
             then 0
             else JournalRanges.__default.SumJournalEntries($ly, Sequences.__default.DropLast(Tclass.Journal.JournalEntry(), s#0))
               + JournalRanges.__default.WeightJournalEntry($Unbox(Sequences.__default.Last(Tclass.Journal.JournalEntry(), s#0)): DatatypeType)));

// definition axiom for JournalRanges.__default.SumJournalEntries for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.SumJournalEntries($LS($ly), Lit(s#0)) } 
    JournalRanges.__default.SumJournalEntries#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> (Seq#Length(Lit(s#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.Journal.JournalEntry(), Lit(s#0))
             && JournalRanges.__default.SumJournalEntries#canCall(Lit(Sequences.__default.DropLast(Tclass.Journal.JournalEntry(), Lit(s#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.Journal.JournalEntry(), Lit(s#0))
             && JournalRanges.__default.WeightJournalEntry#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.Journal.JournalEntry(), Lit(s#0))): DatatypeType)))
         && JournalRanges.__default.SumJournalEntries($LS($ly), Lit(s#0))
           == (if Seq#Length(Lit(s#0)) == LitInt(0)
             then 0
             else JournalRanges.__default.SumJournalEntries($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.Journal.JournalEntry(), Lit(s#0))))
               + JournalRanges.__default.WeightJournalEntry(Lit($Unbox(Sequences.__default.Last(Tclass.Journal.JournalEntry(), Lit(s#0))): DatatypeType))));

// function declaration for JournalRanges._default.WeightJournalEntries
function JournalRanges.__default.WeightJournalEntries($ly: LayerType, s#0: Seq Box) : int;

function JournalRanges.__default.WeightJournalEntries#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.WeightJournalEntries($LS($ly), s#0) } 
  JournalRanges.__default.WeightJournalEntries($LS($ly), s#0)
     == JournalRanges.__default.WeightJournalEntries($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.WeightJournalEntries(AsFuelBottom($ly), s#0) } 
  JournalRanges.__default.WeightJournalEntries($ly, s#0)
     == JournalRanges.__default.WeightJournalEntries($LZ, s#0));

// consequence axiom for JournalRanges.__default.WeightJournalEntries
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.WeightJournalEntries($ly, s#0) } 
    JournalRanges.__default.WeightJournalEntries#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> JournalRanges.__default.WeightJournalEntries($ly, s#0) >= LitInt(0));

function JournalRanges.__default.WeightJournalEntries#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.WeightJournalEntries
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalRanges.__default.WeightJournalEntries#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalRanges.__default.WeightJournalEntries#requires($ly, s#0) == true);

// definition axiom for JournalRanges.__default.WeightJournalEntries(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalRanges.__default.WeightJournalEntries($LS($ly), s#0) } 
    JournalRanges.__default.WeightJournalEntries#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> (Seq#Length(s#0) != LitInt(0)
           ==> JournalRanges.__default.SumJournalEntries#canCall(s#0))
         && JournalRanges.__default.WeightJournalEntries($LS($ly), s#0)
           == (if Seq#Length(s#0) == LitInt(0)
             then 0
             else JournalRanges.__default.SumJournalEntries($LS($LZ), s#0) + 8));

// definition axiom for JournalRanges.__default.WeightJournalEntries for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.WeightJournalEntries($LS($ly), Lit(s#0)) } 
    JournalRanges.__default.WeightJournalEntries#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.Journal.JournalEntry()))
       ==> (Seq#Length(Lit(s#0)) != LitInt(0)
           ==> JournalRanges.__default.SumJournalEntries#canCall(Lit(s#0)))
         && JournalRanges.__default.WeightJournalEntries($LS($ly), Lit(s#0))
           == (if Seq#Length(Lit(s#0)) == LitInt(0)
             then 0
             else JournalRanges.__default.SumJournalEntries($LS($LZ), Lit(s#0)) + 8));

procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalRanges.__default.reveal__parseHeader();
  free requires 38 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalRanges._default.parseHeader0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalRanges.__default.reveal__parseHeader();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalRanges._default.parseHeader
     == $LS(MoreFuel_JournalRanges._default.parseHeader0);
  free ensures StartFuelAssert_JournalRanges._default.parseHeader
     == $LS($LS(MoreFuel_JournalRanges._default.parseHeader0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalRanges._default.parseHeader0)
     == MoreFuel_JournalRanges._default.parseHeader0;



const unique class.Maps.__default: ClassName;

function Tclass.Maps.__default() : Ty;

// Tclass.Maps.__default Tag
axiom Tag(Tclass.Maps.__default()) == Tagclass.Maps.__default;

const unique Tagclass.Maps.__default: TyTag;

// Box/unbox axiom for Tclass.Maps.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Maps.__default()) } 
  $IsBox(bx, Tclass.Maps.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Maps.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Maps.__default()) } 
  $Is($o, Tclass.Maps.__default())
     <==> $o == null || dtype($o) == Tclass.Maps.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Maps.__default(), $h) } 
  $IsAlloc($o, Tclass.Maps.__default(), $h) <==> $o == null || read($h, $o, alloc));

// function declaration for Maps._default.IMapsTo
function Maps.__default.IMapsTo(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsTo
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> true);

function Maps.__default.IMapsTo#requires(Ty, Ty, IMap Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsTo
axiom (forall Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
       && $IsBox(k#0, Maps._default.IMapsTo$K)
       && $IsBox(v#0, Maps._default.IMapsTo$V)
     ==> Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.IMapsTo(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.IMapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsTo
function Maps.__default.MapsTo(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsTo
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> true);

function Maps.__default.MapsTo#requires(Ty, Ty, Map Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.MapsTo
axiom (forall Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
       && $IsBox(k#0, Maps._default.MapsTo$K)
       && $IsBox(v#0, Maps._default.MapsTo$V)
     ==> Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.MapsTo(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsAgreeOnKey
function Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsAgreeOnKey
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> true);

function Maps.__default.MapsAgreeOnKey#requires(Ty, Ty, Map Box Box, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapsAgreeOnKey
axiom (forall Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K)
     ==> Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.MapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(m#0)[k#0] == Map#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[k#0] == Map#Elements(Lit(m'#0))[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[Lit(k#0)] == Map#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IMapsAgreeOnKey
function Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsAgreeOnKey
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> true);

function Maps.__default.IMapsAgreeOnKey#requires(Ty, Ty, IMap Box Box, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsAgreeOnKey
axiom (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K)
     ==> Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(m#0)[k#0] == IMap#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.IMapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
        Maps._default.IMapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(Lit(m#0))[Lit(k#0)] == IMap#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IsSubIMap
function Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

function Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubIMap
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> true);

function Maps.__default.IsSubIMap#requires(Ty, Ty, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IsSubIMap
axiom (forall Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box :: 
  { Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
  $Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
       && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
     ==> Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubIMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
           ==> (forall key#0: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0) } 
              { IMap#Domain(sub#0)[key#0] } 
            $IsBox(key#0, Maps._default.IsSubIMap$K)
               ==> 
              IMap#Domain(sub#0)[key#0]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
           == (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
             && (forall key#0: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0) } 
                { IMap#Domain(sub#0)[key#0] } 
              $IsBox(key#0, Maps._default.IsSubIMap$K)
                 ==> 
                IMap#Domain(sub#0)[key#0]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0))));

// definition axiom for Maps.__default.IsSubIMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
           ==> (forall key#1: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#1) } 
              { IMap#Domain(sub#0)[key#1] } 
            $IsBox(key#1, Maps._default.IsSubIMap$K)
               ==> 
              Lit(IMap#Domain(Lit(sub#0)))[key#1]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, 
                Maps._default.IsSubIMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#1)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
           == (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
             && (forall key#1: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#1) } 
                { IMap#Domain(sub#0)[key#1] } 
              $IsBox(key#1, Maps._default.IsSubIMap$K)
                 ==> 
                Lit(IMap#Domain(Lit(sub#0)))[key#1]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, 
                  Maps._default.IsSubIMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#1))));

// function declaration for Maps._default.IsSubMap
function Maps.__default.IsSubMap(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

function Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubMap
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> true);

function Maps.__default.IsSubMap#requires(Ty, Ty, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.IsSubMap
axiom (forall Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box :: 
  { Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
  $Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
       && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
     ==> Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
           ==> (forall key#0: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0) } 
              { Map#Domain(sub#0)[key#0] } 
            $IsBox(key#0, Maps._default.IsSubMap$K)
               ==> 
              Map#Domain(sub#0)[key#0]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
           == (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
             && (forall key#0: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0) } 
                { Map#Domain(sub#0)[key#0] } 
              $IsBox(key#0, Maps._default.IsSubMap$K)
                 ==> 
                Map#Domain(sub#0)[key#0]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0))));

// definition axiom for Maps.__default.IsSubMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    {:weight 3} { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
           ==> (forall key#1: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#1) } 
              { Map#Domain(sub#0)[key#1] } 
            $IsBox(key#1, Maps._default.IsSubMap$K)
               ==> 
              Lit(Map#Domain(Lit(sub#0)))[key#1]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, 
                Maps._default.IsSubMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#1)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
           == (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
             && (forall key#1: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#1) } 
                { Map#Domain(sub#0)[key#1] } 
              $IsBox(key#1, Maps._default.IsSubMap$K)
                 ==> 
                Lit(Map#Domain(Lit(sub#0)))[key#1]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, 
                  Maps._default.IsSubMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#1))));

// function declaration for Maps._default.MapRemove
function Maps.__default.MapRemove(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
      Maps._default.MapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemove
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> (forall k#0: Box :: 
          { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#0] } 
            { ks#0[k#0] } 
            { Map#Domain(m#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(m#0)[k#0] && !ks#0[k#0]
             ==> Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#0])
         && (forall k#1: Box :: 
          { ks#0[k#1] } 
            { Map#Domain(m#0)[k#1] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapRemove$K)
             ==> (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1]
                 ==> Map#Domain(m#0)[k#1])
               && (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1]
                 ==> !ks#0[k#1]))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)));

function Maps.__default.MapRemove#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemove
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
       && $Is(ks#0, TSet(Maps._default.MapRemove$K))
     ==> Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRemove(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
         == (var m'#0 := Map#Glue((lambda $w#1: Box :: 
                $IsBox($w#1, Maps._default.MapRemove$K) && Map#Domain(m#0)[$w#1] && !ks#0[$w#1]), 
              (lambda $w#1: Box :: Map#Elements(m#0)[$w#1]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#0));

// definition axiom for Maps.__default.MapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
        Maps._default.MapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, 
          Maps._default.MapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == (var m'#1 := Map#Glue((lambda $w#3: Box :: 
                $IsBox($w#3, Maps._default.MapRemove$K)
                   && 
                  Map#Domain(m#0)[$w#3]
                   && !Lit(ks#0)[$w#3]), 
              (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#1));

// function declaration for Maps._default.MapRemoveStrong
function Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemoveStrong
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)), 
          Set#Difference(Map#Domain(m#0), ks#0))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemoveStrong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V)));

function Maps.__default.MapRemoveStrong#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemoveStrong
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
       && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K))
     ==> Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
       == true);

const MoreFuel_Maps._default.MapRemove0: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        m#0, 
        ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove0)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove0))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove0)
           == MoreFuel_Maps._default.MapRemove0
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            m#0, 
            ks#0)
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            m#0, 
            ks#0));

const MoreFuel_Maps._default.MapRemove1: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove1)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove1))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove1)
           == MoreFuel_Maps._default.MapRemove1
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(ks#0))
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            Lit(m#0), 
            Lit(ks#0)));

// function declaration for Maps._default.MapRemove1
function Maps.__default.MapRemove1(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
      Maps._default.MapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.MapRemove1
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> (forall j#0: Box :: 
          { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#0] } 
            { Map#Domain(m#0)[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(m#0)[j#0] && j#0 != k#0
             ==> Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#0])
         && (forall j#1: Box :: 
          { Map#Domain(m#0)[j#1] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1] } 
          $IsBox(j#1, Maps._default.MapRemove1$K)
             ==> (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1]
                 ==> Map#Domain(m#0)[j#1])
               && (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1]
                 ==> j#1 != k#0))
         && (forall j#2: Box :: 
          { Map#Elements(m#0)[j#2] } 
            { Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2] } 
          $IsBox(j#2, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2]
             ==> Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2]
               == Map#Elements(m#0)[j#2])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)))
           <= Set#Card(Map#Domain(m#0))
         && (Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0) - 1)
         && (!Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0))
         && $Is(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0), 
          TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)));

function Maps.__default.MapRemove1#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
       && $IsBox(k#0, Maps._default.MapRemove1$K)
     ==> Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.MapRemove1(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
         == (var m'#0 := Map#Glue((lambda $w#1: Box :: 
                $IsBox($w#1, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#1] && $w#1 != k#0), 
              (lambda $w#1: Box :: Map#Elements(m#0)[$w#1]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#0));

// definition axiom for Maps.__default.MapRemove1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0)
         == (var m'#1 := Map#Glue((lambda $w#3: Box :: 
                $IsBox($w#3, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#3] && $w#3 != k#0), 
              (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#1));

// definition axiom for Maps.__default.MapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
        Maps._default.MapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
          Maps._default.MapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == (var m'#2 := Map#Glue((lambda $w#5: Box :: 
                $IsBox($w#5, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#5] && $w#5 != k#0), 
              (lambda $w#5: Box :: Map#Elements(Lit(m#0))[$w#5]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#2));

// function declaration for Maps._default.MapRemove1Strong
function Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LZ, 
      m#0, 
      k#0));

// consequence axiom for Maps.__default.MapRemove1Strong
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0)), 
          Set#Difference(Map#Domain(m#0), Set#UnionOne(Set#Empty(): Set Box, k#0)))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove1Strong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                  Maps._default.MapRemove1Strong$V, 
                  $ly, 
                  m#0, 
                  k#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $ly, 
            m#0, 
            k#0), 
          TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V)));

function Maps.__default.MapRemove1Strong#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1Strong
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
       && $IsBox(k#0, Maps._default.MapRemove1Strong$K)
     ==> Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0)
       == true);

const MoreFuel_Maps._default.MapRemove10: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove10)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove10))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove10)
           == MoreFuel_Maps._default.MapRemove10
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            m#0, 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            m#0, 
            k#0));

const MoreFuel_Maps._default.MapRemove11: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove11)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove11))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove11)
           == MoreFuel_Maps._default.MapRemove11
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            k#0));

const MoreFuel_Maps._default.MapRemove12: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove12)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove12))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove12)
           == MoreFuel_Maps._default.MapRemove12
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(k#0))
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            Lit(k#0)));

// function declaration for Maps._default.IMapRemove
function Maps.__default.IMapRemove(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
      Maps._default.IMapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.IMapRemove
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)), 
          ISet#Difference(IMap#Domain(m#0), ks#0))
         && (forall j#0: Box :: 
          { IMap#Elements(m#0)[j#0] } 
            { IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0] } 
            { IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.IMapRemove$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0]
             ==> IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0]
               == IMap#Elements(m#0)[j#0])
         && $Is(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

function Maps.__default.IMapRemove#requires(Ty, Ty, LayerType, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRemove
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
       && $Is(ks#0, TISet(Maps._default.IMapRemove$K))
     ==> Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRemove(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#0]
               && !ks#0[$w#0]), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// definition axiom for Maps.__default.IMapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
        Maps._default.IMapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
          Maps._default.IMapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#1]
               && !Lit(ks#0)[$w#1]), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// function declaration for Maps._default.IMapRemove1
function Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box)
   : IMap Box Box;

function Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
      Maps._default.IMapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.IMapRemove1
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)), 
          ISet#Difference(IMap#Domain(m#0), ISet#UnionOne(ISet#Empty(): ISet Box, k#0)))
         && (forall j#0: Box :: 
          { IMap#Elements(m#0)[j#0] } 
            { IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0] } 
            { IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0] } 
          $IsBox(j#0, Maps._default.IMapRemove1$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0]
             ==> IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0]
               == IMap#Elements(m#0)[j#0])
         && $Is(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

function Maps.__default.IMapRemove1#requires(Ty, Ty, LayerType, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapRemove1
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
       && $IsBox(k#0, Maps._default.IMapRemove1$K)
     ==> Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapRemove1(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#0]
               && $w#0 != k#0), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// definition axiom for Maps.__default.IMapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
        Maps._default.IMapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
          Maps._default.IMapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#1]
               && $w#1 != k#0), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// function declaration for Maps._default.MapRestrict
function Maps.__default.MapRestrict(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// consequence axiom for Maps.__default.MapRestrict
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> $Is(Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

function Maps.__default.MapRestrict#requires(Ty, Ty, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRestrict
axiom (forall Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
       && $Is(ks#0, TSet(Maps._default.MapRestrict$K))
     ==> Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapRestrict$K) && ks#0[$w#0] && Map#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// definition axiom for Maps.__default.MapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapRestrict$K)
               && 
              Lit(ks#0)[$w#1]
               && Map#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// function declaration for Maps._default.MapIRestrict
function Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : Map Box Box;

function Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.MapIRestrict
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> $Is(Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

function Maps.__default.MapIRestrict#requires(Ty, Ty, Map Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.MapIRestrict
axiom (forall Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
       && $Is(ks#0, TISet(Maps._default.MapIRestrict$K))
     ==> Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapIRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#0]
               && ks#0[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#1]
               && ks#0[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#2]
               && Lit(ks#0)[$w#2]), 
          (lambda $w#2: Box :: Map#Elements(Lit(m#0))[$w#2]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// function declaration for Maps._default.IMapRestrict
function Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.IMapRestrict
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> $Is(Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0), 
        TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

function Maps.__default.IMapRestrict#requires(Ty, Ty, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRestrict
axiom (forall Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
       && $Is(ks#0, TISet(Maps._default.IMapRestrict$K))
     ==> Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRestrict(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRestrict$K)
               && 
              ks#0[$w#0]
               && IMap#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// definition axiom for Maps.__default.IMapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRestrict$K)
               && 
              Lit(ks#0)[$w#1]
               && IMap#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// function declaration for Maps._default.MapDisjointUnion
function Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapDisjointUnion
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
              Maps._default.MapDisjointUnion$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
            { Map#Domain(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1])
         && $Is(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
            Maps._default.MapDisjointUnion$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

function Maps.__default.MapDisjointUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
     ==> Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)));

// definition axiom for Maps.__default.MapDisjointUnion(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapDisjointUnion$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else Map#Elements(mapb#0)[$w#0])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// definition axiom for Maps.__default.MapDisjointUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapDisjointUnion$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else Map#Elements(Lit(mapb#0))[$w#1])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// function declaration for Maps._default.MapUnionPreferA
function Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferA
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
              Maps._default.MapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(mapa#0)[k#0] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == Map#Elements(mapa#0)[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(mapb#0)[k#1] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapb#0)[k#1] && !Map#Domain(mapa#0)[k#1]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == Map#Elements(mapb#0)[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Domain(mapb#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && !Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == Map#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
            Maps._default.MapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

function Maps.__default.MapUnionPreferA#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferA
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
     ==> Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapUnionPreferA$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else Map#Elements(mapb#0)[$w#0])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// definition axiom for Maps.__default.MapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapUnionPreferA$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else Map#Elements(Lit(mapb#0))[$w#1])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// function declaration for Maps._default.MapUnionPreferB
function Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferB
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
              Maps._default.MapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(mapb#0)[k#0] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Domain(mapb#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapb#0)[k#0]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == Map#Elements(mapb#0)[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(mapa#0)[k#1] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#1] && !Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == Map#Elements(mapa#0)[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Domain(mapb#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && !Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == Map#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
            Maps._default.MapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

function Maps.__default.MapUnionPreferB#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferB
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
     ==> Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapUnionPreferB$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapb#0)[$w#0]
               then Map#Elements(mapb#0)[$w#0]
               else Map#Elements(mapa#0)[$w#0])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// definition axiom for Maps.__default.MapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapUnionPreferB$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapb#0)[$w#1]
               then Map#Elements(Lit(mapb#0))[$w#1]
               else Map#Elements(Lit(mapa#0))[$w#1])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// function declaration for Maps._default.MapUnion
function Maps.__default.MapUnion(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
      Maps._default.MapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.MapUnion
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#0] && !Map#Domain(mapb#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#1] && !Map#Domain(mapa#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2] } 
            { Map#Elements(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(mapb#0)[k#2]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2]
               || Map#Elements(mapa#0)[k#2]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2])
         && $Is(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0), 
          TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)));

function Maps.__default.MapUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnion
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
     ==> Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnion(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.MapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
        Maps._default.MapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.IMapUnionPreferA
function Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferA
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
              Maps._default.IMapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(mapa#0)[k#0] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { IMap#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapa#0)[k#0]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == IMap#Elements(mapa#0)[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(mapb#0)[k#1] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#1] && !IMap#Domain(mapa#0)[k#1]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == IMap#Elements(mapb#0)[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapb#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { IMap#Domain(mapa#0)[k#2] } 
            { IMap#Domain(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#2] && !IMap#Domain(mapa#0)[k#2]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == IMap#Elements(mapb#0)[k#2])
         && $Is(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
            Maps._default.IMapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

function Maps.__default.IMapUnionPreferA#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferA
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
     ==> Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapUnionPreferA$U)
               && (IMap#Domain(mapa#0)[$w#0] || IMap#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if IMap#Domain(mapa#0)[$w#0]
               then IMap#Elements(mapa#0)[$w#0]
               else IMap#Elements(mapb#0)[$w#0])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// definition axiom for Maps.__default.IMapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapUnionPreferA$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#1] || Lit(IMap#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if IMap#Domain(mapa#0)[$w#1]
               then IMap#Elements(Lit(mapa#0))[$w#1]
               else IMap#Elements(Lit(mapb#0))[$w#1])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// function declaration for Maps._default.IMapUnionPreferB
function Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferB
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
              Maps._default.IMapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(mapb#0)[k#0] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { IMap#Domain(mapb#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapb#0)[k#0]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == IMap#Elements(mapb#0)[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(mapa#0)[k#1] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#1] && !IMap#Domain(mapb#0)[k#1]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == IMap#Elements(mapa#0)[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapa#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { IMap#Domain(mapb#0)[k#2] } 
            { IMap#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#2] && !IMap#Domain(mapb#0)[k#2]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == IMap#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
            Maps._default.IMapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

function Maps.__default.IMapUnionPreferB#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferB
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
     ==> Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapUnionPreferB$U)
               && (IMap#Domain(mapa#0)[$w#0] || IMap#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if IMap#Domain(mapb#0)[$w#0]
               then IMap#Elements(mapb#0)[$w#0]
               else IMap#Elements(mapa#0)[$w#0])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// definition axiom for Maps.__default.IMapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapUnionPreferB$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#1] || Lit(IMap#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if IMap#Domain(mapb#0)[$w#1]
               then IMap#Elements(Lit(mapb#0))[$w#1]
               else IMap#Elements(Lit(mapa#0))[$w#1])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// function declaration for Maps._default.IMapUnion
function Maps.__default.IMapUnion(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
      Maps._default.IMapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.IMapUnion
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#0] } 
            { IMap#Elements(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#0] && !IMap#Domain(mapb#0)[k#0]
             ==> IMap#Elements(mapa#0)[k#0]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#1] } 
            { IMap#Elements(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapb#0)[k#1] && !IMap#Domain(mapa#0)[k#1]
             ==> IMap#Elements(mapb#0)[k#1]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapa#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2] } 
            { IMap#Elements(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#2] && IMap#Domain(mapb#0)[k#2]
             ==> IMap#Elements(mapb#0)[k#2]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2]
               || IMap#Elements(mapa#0)[k#2]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2])
         && $Is(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0), 
          TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)));

function Maps.__default.IMapUnion#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnion
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
       && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
     ==> Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnion(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.IMapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
        Maps._default.IMapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.MapDisjointUnion3
function Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LZ, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// consequence axiom for Maps.__default.MapDisjointUnion3
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              $ly, 
              mapa#0, 
              mapb#0, 
              mapc#0)), 
          Set#Union(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
         && (!Set#Equal(Map#Domain(mapa#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapb#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapc#0), Set#Empty(): Set Box)
           ==> !Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0)), 
            Set#Empty(): Set Box))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
            { Map#Domain(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#2] } 
            { Map#Elements(mapc#0)[k#2] } 
            { Map#Domain(mapc#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapc#0)[k#2]
             ==> Map#Elements(mapc#0)[k#2]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#2])
         && 
        Map#Equal(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)))
         && Map#Equal(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapa#0, 
              mapb#0), 
            mapc#0))
         && $Is(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

function Maps.__default.MapDisjointUnion3#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion3
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  $Is(mapa#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapb#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapc#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
     ==> Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0)
       == (
        Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0))));

// definition axiom for Maps.__default.MapDisjointUnion3(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0, 
          mapc#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapDisjointUnion3$U)
               && (
                Map#Domain(mapa#0)[$w#0]
                 || Map#Domain(mapb#0)[$w#0]
                 || Map#Domain(mapc#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else (if Map#Domain(mapb#0)[$w#0]
                 then Map#Elements(mapb#0)[$w#0]
                 else Map#Elements(mapc#0)[$w#0]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// definition axiom for Maps.__default.MapDisjointUnion3 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0), 
        Lit(mapc#0)) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Set#Union(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))), 
            Map#Domain(Lit(mapc#0))))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapDisjointUnion3$U)
               && (
                Lit(Map#Domain(Lit(mapa#0)))[$w#1]
                 || Lit(Map#Domain(Lit(mapb#0)))[$w#1]
                 || Lit(Map#Domain(Lit(mapc#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else (if Map#Domain(mapb#0)[$w#1]
                 then Map#Elements(Lit(mapb#0))[$w#1]
                 else Map#Elements(Lit(mapc#0))[$w#1]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// function declaration for Maps._default.MapToImap
function Maps.__default.MapToImap(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : IMap Box Box;

function Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.MapToImap
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> $Is(Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0), 
        TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

function Maps.__default.MapToImap#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapToImap
axiom (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
  { Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
  $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
     ==> Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
       == true);

// definition axiom for Maps.__default.MapToImap(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// definition axiom for Maps.__default.MapToImap for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0)) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// function declaration for Maps._default.MapLookupOption
function Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapLookupOption
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> $Is(Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.MapLookupOption$V)));

function Maps.__default.MapLookupOption#requires(Ty, Ty, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapLookupOption
axiom (forall Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box :: 
  { Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
       && $IsBox(key#0, Maps._default.MapLookupOption$K)
     ==> Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.MapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

// function declaration for Maps._default.ImapLookupOption
function Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.ImapLookupOption
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> $Is(Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.ImapLookupOption$V)));

function Maps.__default.ImapLookupOption#requires(Ty, Ty, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.ImapLookupOption
axiom (forall Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box :: 
  { Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
       && $IsBox(key#0, Maps._default.ImapLookupOption$K)
     ==> Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.ImapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.ImapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
        Maps._default.ImapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

const unique class.Crypto.__default: ClassName;

function Tclass.Crypto.__default() : Ty;

// Tclass.Crypto.__default Tag
axiom Tag(Tclass.Crypto.__default()) == Tagclass.Crypto.__default;

const unique Tagclass.Crypto.__default: TyTag;

// Box/unbox axiom for Tclass.Crypto.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Crypto.__default()) } 
  $IsBox(bx, Tclass.Crypto.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Crypto.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Crypto.__default()) } 
  $Is($o, Tclass.Crypto.__default())
     <==> $o == null || dtype($o) == Tclass.Crypto.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Crypto.__default(), $h) } 
  $IsAlloc($o, Tclass.Crypto.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Crypto._default.Sha256
function Crypto.__default.Sha256(t#0: Seq Box) : Seq Box;

function Crypto.__default.Sha256#canCall(t#0: Seq Box) : bool;

// consequence axiom for Crypto.__default.Sha256
axiom true
   ==> (forall t#0: Seq Box :: 
    { Crypto.__default.Sha256(t#0) } 
    Crypto.__default.Sha256#canCall(t#0)
         || $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Seq#Length(Crypto.__default.Sha256(t#0)) == LitInt(32)
         && $Is(Crypto.__default.Sha256(t#0), TSeq(Tclass.NativeTypes.byte())));

function Crypto.__default.Sha256#requires(Seq Box) : bool;

// #requires axiom for Crypto.__default.Sha256
axiom (forall t#0: Seq Box :: 
  { Crypto.__default.Sha256#requires(t#0) } 
  $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Crypto.__default.Sha256#requires(t#0) == true);

// function declaration for Crypto._default.Crc32C
function Crypto.__default.Crc32C(t#0: Seq Box) : Seq Box;

function Crypto.__default.Crc32C#canCall(t#0: Seq Box) : bool;

// consequence axiom for Crypto.__default.Crc32C
axiom true
   ==> (forall t#0: Seq Box :: 
    { Crypto.__default.Crc32C(t#0) } 
    Crypto.__default.Crc32C#canCall(t#0)
         || $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Seq#Length(Crypto.__default.Crc32C(t#0)) == LitInt(32)
         && $Is(Crypto.__default.Crc32C(t#0), TSeq(Tclass.NativeTypes.byte())));

function Crypto.__default.Crc32C#requires(Seq Box) : bool;

// #requires axiom for Crypto.__default.Crc32C
axiom (forall t#0: Seq Box :: 
  { Crypto.__default.Crc32C#requires(t#0) } 
  $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Crypto.__default.Crc32C#requires(t#0) == true);

// Constructor function declaration
function #AsyncDisk.ReqRead.ReqRead(int, int) : DatatypeType;

const unique ##AsyncDisk.ReqRead.ReqRead: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: int :: 
  { #AsyncDisk.ReqRead.ReqRead(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#AsyncDisk.ReqRead.ReqRead(a#0#0#0, a#0#1#0))
     == ##AsyncDisk.ReqRead.ReqRead);

function AsyncDisk.ReqRead.ReqRead_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqRead.ReqRead_q(d) } 
  AsyncDisk.ReqRead.ReqRead_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.ReqRead.ReqRead);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqRead.ReqRead_q(d) } 
  AsyncDisk.ReqRead.ReqRead_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: int :: 
      d == #AsyncDisk.ReqRead.ReqRead(a#1#0#0, a#1#1#0)));

function Tclass.AsyncDisk.ReqRead() : Ty;

// Tclass.AsyncDisk.ReqRead Tag
axiom Tag(Tclass.AsyncDisk.ReqRead()) == Tagclass.AsyncDisk.ReqRead;

const unique Tagclass.AsyncDisk.ReqRead: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.ReqRead
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.ReqRead()) } 
  $IsBox(bx, Tclass.AsyncDisk.ReqRead())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.ReqRead()));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: int :: 
  { $Is(#AsyncDisk.ReqRead.ReqRead(a#2#0#0, a#2#1#0), Tclass.AsyncDisk.ReqRead()) } 
  $Is(#AsyncDisk.ReqRead.ReqRead(a#2#0#0, a#2#1#0), Tclass.AsyncDisk.ReqRead())
     <==> $Is(a#2#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.ReqRead.ReqRead(a#3#0#0, a#3#1#0), Tclass.AsyncDisk.ReqRead(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.ReqRead.ReqRead(a#3#0#0, a#3#1#0), Tclass.AsyncDisk.ReqRead(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.ReqRead.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.ReqRead.ReqRead_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.ReqRead(), $h)
     ==> $IsAlloc(AsyncDisk.ReqRead.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.ReqRead.len(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.ReqRead.ReqRead_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.ReqRead(), $h)
     ==> $IsAlloc(AsyncDisk.ReqRead.len(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: int :: 
  { #AsyncDisk.ReqRead.ReqRead(LitInt(a#4#0#0), LitInt(a#4#1#0)) } 
  #AsyncDisk.ReqRead.ReqRead(LitInt(a#4#0#0), LitInt(a#4#1#0))
     == Lit(#AsyncDisk.ReqRead.ReqRead(a#4#0#0, a#4#1#0)));

function AsyncDisk.ReqRead.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: int :: 
  { #AsyncDisk.ReqRead.ReqRead(a#5#0#0, a#5#1#0) } 
  AsyncDisk.ReqRead.addr(#AsyncDisk.ReqRead.ReqRead(a#5#0#0, a#5#1#0)) == a#5#0#0);

function AsyncDisk.ReqRead.len(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: int :: 
  { #AsyncDisk.ReqRead.ReqRead(a#6#0#0, a#6#1#0) } 
  AsyncDisk.ReqRead.len(#AsyncDisk.ReqRead.ReqRead(a#6#0#0, a#6#1#0)) == a#6#1#0);

// Depth-one case-split function
function $IsA#AsyncDisk.ReqRead(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.ReqRead(d) } 
  $IsA#AsyncDisk.ReqRead(d) ==> AsyncDisk.ReqRead.ReqRead_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqRead.ReqRead_q(d), $Is(d, Tclass.AsyncDisk.ReqRead()) } 
  $Is(d, Tclass.AsyncDisk.ReqRead()) ==> AsyncDisk.ReqRead.ReqRead_q(d));

// Datatype extensional equality declaration
function AsyncDisk.ReqRead#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.ReqRead.ReqRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.ReqRead#Equal(a, b) } 
  true
     ==> (AsyncDisk.ReqRead#Equal(a, b)
       <==> AsyncDisk.ReqRead.addr(a) == AsyncDisk.ReqRead.addr(b)
         && AsyncDisk.ReqRead.len(a) == AsyncDisk.ReqRead.len(b)));

// Datatype extensionality axiom: AsyncDisk.ReqRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.ReqRead#Equal(a, b) } 
  AsyncDisk.ReqRead#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.ReqRead: ClassName;

// Constructor function declaration
function #AsyncDisk.ReqWrite.ReqWrite(int, Seq Box) : DatatypeType;

const unique ##AsyncDisk.ReqWrite.ReqWrite: DtCtorId;

// Constructor identifier
axiom (forall a#7#0#0: int, a#7#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(a#7#0#0, a#7#1#0) } 
  DatatypeCtorId(#AsyncDisk.ReqWrite.ReqWrite(a#7#0#0, a#7#1#0))
     == ##AsyncDisk.ReqWrite.ReqWrite);

function AsyncDisk.ReqWrite.ReqWrite_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqWrite.ReqWrite_q(d) } 
  AsyncDisk.ReqWrite.ReqWrite_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.ReqWrite.ReqWrite);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqWrite.ReqWrite_q(d) } 
  AsyncDisk.ReqWrite.ReqWrite_q(d)
     ==> (exists a#8#0#0: int, a#8#1#0: Seq Box :: 
      d == #AsyncDisk.ReqWrite.ReqWrite(a#8#0#0, a#8#1#0)));

function Tclass.AsyncDisk.ReqWrite() : Ty;

// Tclass.AsyncDisk.ReqWrite Tag
axiom Tag(Tclass.AsyncDisk.ReqWrite()) == Tagclass.AsyncDisk.ReqWrite;

const unique Tagclass.AsyncDisk.ReqWrite: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.ReqWrite
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.ReqWrite()) } 
  $IsBox(bx, Tclass.AsyncDisk.ReqWrite())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.ReqWrite()));

// Constructor $Is
axiom (forall a#9#0#0: int, a#9#1#0: Seq Box :: 
  { $Is(#AsyncDisk.ReqWrite.ReqWrite(a#9#0#0, a#9#1#0), Tclass.AsyncDisk.ReqWrite()) } 
  $Is(#AsyncDisk.ReqWrite.ReqWrite(a#9#0#0, a#9#1#0), Tclass.AsyncDisk.ReqWrite())
     <==> $Is(a#9#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#9#1#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#10#0#0: int, a#10#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.ReqWrite.ReqWrite(a#10#0#0, a#10#1#0), 
      Tclass.AsyncDisk.ReqWrite(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.ReqWrite.ReqWrite(a#10#0#0, a#10#1#0), 
        Tclass.AsyncDisk.ReqWrite(), 
        $h)
       <==> $IsAlloc(a#10#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#10#1#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.ReqWrite.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.ReqWrite.ReqWrite_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.ReqWrite(), $h)
     ==> $IsAlloc(AsyncDisk.ReqWrite.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.ReqWrite.bytes(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.ReqWrite.ReqWrite_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.ReqWrite(), $h)
     ==> $IsAlloc(AsyncDisk.ReqWrite.bytes(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#11#0#0: int, a#11#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(LitInt(a#11#0#0), Lit(a#11#1#0)) } 
  #AsyncDisk.ReqWrite.ReqWrite(LitInt(a#11#0#0), Lit(a#11#1#0))
     == Lit(#AsyncDisk.ReqWrite.ReqWrite(a#11#0#0, a#11#1#0)));

function AsyncDisk.ReqWrite.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#12#0#0: int, a#12#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(a#12#0#0, a#12#1#0) } 
  AsyncDisk.ReqWrite.addr(#AsyncDisk.ReqWrite.ReqWrite(a#12#0#0, a#12#1#0))
     == a#12#0#0);

function AsyncDisk.ReqWrite.bytes(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#13#0#0: int, a#13#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(a#13#0#0, a#13#1#0) } 
  AsyncDisk.ReqWrite.bytes(#AsyncDisk.ReqWrite.ReqWrite(a#13#0#0, a#13#1#0))
     == a#13#1#0);

// Inductive seq element rank
axiom (forall a#14#0#0: int, a#14#1#0: Seq Box, i: int :: 
  { Seq#Index(a#14#1#0, i), #AsyncDisk.ReqWrite.ReqWrite(a#14#0#0, a#14#1#0) } 
  0 <= i && i < Seq#Length(a#14#1#0)
     ==> DtRank($Unbox(Seq#Index(a#14#1#0, i)): DatatypeType)
       < DtRank(#AsyncDisk.ReqWrite.ReqWrite(a#14#0#0, a#14#1#0)));

// Inductive seq rank
axiom (forall a#15#0#0: int, a#15#1#0: Seq Box :: 
  { #AsyncDisk.ReqWrite.ReqWrite(a#15#0#0, a#15#1#0) } 
  Seq#Rank(a#15#1#0) < DtRank(#AsyncDisk.ReqWrite.ReqWrite(a#15#0#0, a#15#1#0)));

// Depth-one case-split function
function $IsA#AsyncDisk.ReqWrite(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.ReqWrite(d) } 
  $IsA#AsyncDisk.ReqWrite(d) ==> AsyncDisk.ReqWrite.ReqWrite_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.ReqWrite.ReqWrite_q(d), $Is(d, Tclass.AsyncDisk.ReqWrite()) } 
  $Is(d, Tclass.AsyncDisk.ReqWrite()) ==> AsyncDisk.ReqWrite.ReqWrite_q(d));

// Datatype extensional equality declaration
function AsyncDisk.ReqWrite#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.ReqWrite.ReqWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.ReqWrite#Equal(a, b) } 
  true
     ==> (AsyncDisk.ReqWrite#Equal(a, b)
       <==> AsyncDisk.ReqWrite.addr(a) == AsyncDisk.ReqWrite.addr(b)
         && Seq#Equal(AsyncDisk.ReqWrite.bytes(a), AsyncDisk.ReqWrite.bytes(b))));

// Datatype extensionality axiom: AsyncDisk.ReqWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.ReqWrite#Equal(a, b) } 
  AsyncDisk.ReqWrite#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.ReqWrite: ClassName;

// Constructor function declaration
function #AsyncDisk.RespRead.RespRead(int, Seq Box) : DatatypeType;

const unique ##AsyncDisk.RespRead.RespRead: DtCtorId;

// Constructor identifier
axiom (forall a#16#0#0: int, a#16#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(a#16#0#0, a#16#1#0) } 
  DatatypeCtorId(#AsyncDisk.RespRead.RespRead(a#16#0#0, a#16#1#0))
     == ##AsyncDisk.RespRead.RespRead);

function AsyncDisk.RespRead.RespRead_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespRead.RespRead_q(d) } 
  AsyncDisk.RespRead.RespRead_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.RespRead.RespRead);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespRead.RespRead_q(d) } 
  AsyncDisk.RespRead.RespRead_q(d)
     ==> (exists a#17#0#0: int, a#17#1#0: Seq Box :: 
      d == #AsyncDisk.RespRead.RespRead(a#17#0#0, a#17#1#0)));

function Tclass.AsyncDisk.RespRead() : Ty;

// Tclass.AsyncDisk.RespRead Tag
axiom Tag(Tclass.AsyncDisk.RespRead()) == Tagclass.AsyncDisk.RespRead;

const unique Tagclass.AsyncDisk.RespRead: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.RespRead
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.RespRead()) } 
  $IsBox(bx, Tclass.AsyncDisk.RespRead())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.RespRead()));

// Constructor $Is
axiom (forall a#18#0#0: int, a#18#1#0: Seq Box :: 
  { $Is(#AsyncDisk.RespRead.RespRead(a#18#0#0, a#18#1#0), Tclass.AsyncDisk.RespRead()) } 
  $Is(#AsyncDisk.RespRead.RespRead(a#18#0#0, a#18#1#0), Tclass.AsyncDisk.RespRead())
     <==> $Is(a#18#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#18#1#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#19#0#0: int, a#19#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.RespRead.RespRead(a#19#0#0, a#19#1#0), 
      Tclass.AsyncDisk.RespRead(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.RespRead.RespRead(a#19#0#0, a#19#1#0), 
        Tclass.AsyncDisk.RespRead(), 
        $h)
       <==> $IsAlloc(a#19#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#19#1#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.RespRead.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.RespRead.RespRead_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.RespRead(), $h)
     ==> $IsAlloc(AsyncDisk.RespRead.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.RespRead.bytes(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.RespRead.RespRead_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.RespRead(), $h)
     ==> $IsAlloc(AsyncDisk.RespRead.bytes(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#20#0#0: int, a#20#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(LitInt(a#20#0#0), Lit(a#20#1#0)) } 
  #AsyncDisk.RespRead.RespRead(LitInt(a#20#0#0), Lit(a#20#1#0))
     == Lit(#AsyncDisk.RespRead.RespRead(a#20#0#0, a#20#1#0)));

function AsyncDisk.RespRead.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#21#0#0: int, a#21#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(a#21#0#0, a#21#1#0) } 
  AsyncDisk.RespRead.addr(#AsyncDisk.RespRead.RespRead(a#21#0#0, a#21#1#0))
     == a#21#0#0);

function AsyncDisk.RespRead.bytes(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#22#0#0: int, a#22#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(a#22#0#0, a#22#1#0) } 
  AsyncDisk.RespRead.bytes(#AsyncDisk.RespRead.RespRead(a#22#0#0, a#22#1#0))
     == a#22#1#0);

// Inductive seq element rank
axiom (forall a#23#0#0: int, a#23#1#0: Seq Box, i: int :: 
  { Seq#Index(a#23#1#0, i), #AsyncDisk.RespRead.RespRead(a#23#0#0, a#23#1#0) } 
  0 <= i && i < Seq#Length(a#23#1#0)
     ==> DtRank($Unbox(Seq#Index(a#23#1#0, i)): DatatypeType)
       < DtRank(#AsyncDisk.RespRead.RespRead(a#23#0#0, a#23#1#0)));

// Inductive seq rank
axiom (forall a#24#0#0: int, a#24#1#0: Seq Box :: 
  { #AsyncDisk.RespRead.RespRead(a#24#0#0, a#24#1#0) } 
  Seq#Rank(a#24#1#0) < DtRank(#AsyncDisk.RespRead.RespRead(a#24#0#0, a#24#1#0)));

// Depth-one case-split function
function $IsA#AsyncDisk.RespRead(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.RespRead(d) } 
  $IsA#AsyncDisk.RespRead(d) ==> AsyncDisk.RespRead.RespRead_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespRead.RespRead_q(d), $Is(d, Tclass.AsyncDisk.RespRead()) } 
  $Is(d, Tclass.AsyncDisk.RespRead()) ==> AsyncDisk.RespRead.RespRead_q(d));

// Datatype extensional equality declaration
function AsyncDisk.RespRead#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.RespRead.RespRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.RespRead#Equal(a, b) } 
  true
     ==> (AsyncDisk.RespRead#Equal(a, b)
       <==> AsyncDisk.RespRead.addr(a) == AsyncDisk.RespRead.addr(b)
         && Seq#Equal(AsyncDisk.RespRead.bytes(a), AsyncDisk.RespRead.bytes(b))));

// Datatype extensionality axiom: AsyncDisk.RespRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.RespRead#Equal(a, b) } 
  AsyncDisk.RespRead#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.RespRead: ClassName;

// Constructor function declaration
function #AsyncDisk.RespWrite.RespWrite(int, int) : DatatypeType;

const unique ##AsyncDisk.RespWrite.RespWrite: DtCtorId;

// Constructor identifier
axiom (forall a#25#0#0: int, a#25#1#0: int :: 
  { #AsyncDisk.RespWrite.RespWrite(a#25#0#0, a#25#1#0) } 
  DatatypeCtorId(#AsyncDisk.RespWrite.RespWrite(a#25#0#0, a#25#1#0))
     == ##AsyncDisk.RespWrite.RespWrite);

function AsyncDisk.RespWrite.RespWrite_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespWrite.RespWrite_q(d) } 
  AsyncDisk.RespWrite.RespWrite_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.RespWrite.RespWrite);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespWrite.RespWrite_q(d) } 
  AsyncDisk.RespWrite.RespWrite_q(d)
     ==> (exists a#26#0#0: int, a#26#1#0: int :: 
      d == #AsyncDisk.RespWrite.RespWrite(a#26#0#0, a#26#1#0)));

function Tclass.AsyncDisk.RespWrite() : Ty;

// Tclass.AsyncDisk.RespWrite Tag
axiom Tag(Tclass.AsyncDisk.RespWrite()) == Tagclass.AsyncDisk.RespWrite;

const unique Tagclass.AsyncDisk.RespWrite: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.RespWrite
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.RespWrite()) } 
  $IsBox(bx, Tclass.AsyncDisk.RespWrite())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.RespWrite()));

// Constructor $Is
axiom (forall a#27#0#0: int, a#27#1#0: int :: 
  { $Is(#AsyncDisk.RespWrite.RespWrite(a#27#0#0, a#27#1#0), Tclass.AsyncDisk.RespWrite()) } 
  $Is(#AsyncDisk.RespWrite.RespWrite(a#27#0#0, a#27#1#0), Tclass.AsyncDisk.RespWrite())
     <==> $Is(a#27#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#27#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#28#0#0: int, a#28#1#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.RespWrite.RespWrite(a#28#0#0, a#28#1#0), 
      Tclass.AsyncDisk.RespWrite(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.RespWrite.RespWrite(a#28#0#0, a#28#1#0), 
        Tclass.AsyncDisk.RespWrite(), 
        $h)
       <==> $IsAlloc(a#28#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#28#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.RespWrite.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.RespWrite.RespWrite_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.RespWrite(), $h)
     ==> $IsAlloc(AsyncDisk.RespWrite.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.RespWrite.len(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.RespWrite.RespWrite_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.RespWrite(), $h)
     ==> $IsAlloc(AsyncDisk.RespWrite.len(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#29#0#0: int, a#29#1#0: int :: 
  { #AsyncDisk.RespWrite.RespWrite(LitInt(a#29#0#0), LitInt(a#29#1#0)) } 
  #AsyncDisk.RespWrite.RespWrite(LitInt(a#29#0#0), LitInt(a#29#1#0))
     == Lit(#AsyncDisk.RespWrite.RespWrite(a#29#0#0, a#29#1#0)));

function AsyncDisk.RespWrite.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#30#0#0: int, a#30#1#0: int :: 
  { #AsyncDisk.RespWrite.RespWrite(a#30#0#0, a#30#1#0) } 
  AsyncDisk.RespWrite.addr(#AsyncDisk.RespWrite.RespWrite(a#30#0#0, a#30#1#0))
     == a#30#0#0);

function AsyncDisk.RespWrite.len(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#31#0#0: int, a#31#1#0: int :: 
  { #AsyncDisk.RespWrite.RespWrite(a#31#0#0, a#31#1#0) } 
  AsyncDisk.RespWrite.len(#AsyncDisk.RespWrite.RespWrite(a#31#0#0, a#31#1#0))
     == a#31#1#0);

// Depth-one case-split function
function $IsA#AsyncDisk.RespWrite(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.RespWrite(d) } 
  $IsA#AsyncDisk.RespWrite(d) ==> AsyncDisk.RespWrite.RespWrite_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.RespWrite.RespWrite_q(d), $Is(d, Tclass.AsyncDisk.RespWrite()) } 
  $Is(d, Tclass.AsyncDisk.RespWrite()) ==> AsyncDisk.RespWrite.RespWrite_q(d));

// Datatype extensional equality declaration
function AsyncDisk.RespWrite#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.RespWrite.RespWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.RespWrite#Equal(a, b) } 
  true
     ==> (AsyncDisk.RespWrite#Equal(a, b)
       <==> AsyncDisk.RespWrite.addr(a) == AsyncDisk.RespWrite.addr(b)
         && AsyncDisk.RespWrite.len(a) == AsyncDisk.RespWrite.len(b)));

// Datatype extensionality axiom: AsyncDisk.RespWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.RespWrite#Equal(a, b) } 
  AsyncDisk.RespWrite#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.RespWrite: ClassName;

// Constructor function declaration
function #AsyncDisk.DiskOp.ReqReadOp(int, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.ReqReadOp: DtCtorId;

// Constructor identifier
axiom (forall a#32#0#0: int, a#32#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(a#32#0#0, a#32#1#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.ReqReadOp(a#32#0#0, a#32#1#0))
     == ##AsyncDisk.DiskOp.ReqReadOp);

function AsyncDisk.DiskOp.ReqReadOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqReadOp_q(d) } 
  AsyncDisk.DiskOp.ReqReadOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.ReqReadOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqReadOp_q(d) } 
  AsyncDisk.DiskOp.ReqReadOp_q(d)
     ==> (exists a#33#0#0: int, a#33#1#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.ReqReadOp(a#33#0#0, a#33#1#0)));

function Tclass.AsyncDisk.DiskOp() : Ty;

// Tclass.AsyncDisk.DiskOp Tag
axiom Tag(Tclass.AsyncDisk.DiskOp()) == Tagclass.AsyncDisk.DiskOp;

const unique Tagclass.AsyncDisk.DiskOp: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.DiskOp
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.DiskOp()) } 
  $IsBox(bx, Tclass.AsyncDisk.DiskOp())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.DiskOp()));

// Constructor $Is
axiom (forall a#34#0#0: int, a#34#1#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.ReqReadOp(a#34#0#0, a#34#1#0), Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.ReqReadOp(a#34#0#0, a#34#1#0), Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#34#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#34#1#0, Tclass.AsyncDisk.ReqRead()));

// Constructor $IsAlloc
axiom (forall a#35#0#0: int, a#35#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.ReqReadOp(a#35#0#0, a#35#1#0), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.ReqReadOp(a#35#0#0, a#35#1#0), Tclass.AsyncDisk.DiskOp(), $h)
       <==> $IsAlloc(a#35#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#35#1#0, Tclass.AsyncDisk.ReqRead(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqReadOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.reqRead(d), Tclass.AsyncDisk.ReqRead(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqReadOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.reqRead(d), Tclass.AsyncDisk.ReqRead(), $h));

// Constructor literal
axiom (forall a#36#0#0: int, a#36#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(LitInt(a#36#0#0), Lit(a#36#1#0)) } 
  #AsyncDisk.DiskOp.ReqReadOp(LitInt(a#36#0#0), Lit(a#36#1#0))
     == Lit(#AsyncDisk.DiskOp.ReqReadOp(a#36#0#0, a#36#1#0)));

function AsyncDisk.DiskOp.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#37#0#0: int, a#37#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(a#37#0#0, a#37#1#0) } 
  AsyncDisk.DiskOp.id(#AsyncDisk.DiskOp.ReqReadOp(a#37#0#0, a#37#1#0)) == a#37#0#0);

function AsyncDisk.DiskOp.reqRead(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#38#0#0: int, a#38#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(a#38#0#0, a#38#1#0) } 
  AsyncDisk.DiskOp.reqRead(#AsyncDisk.DiskOp.ReqReadOp(a#38#0#0, a#38#1#0))
     == a#38#1#0);

// Inductive rank
axiom (forall a#39#0#0: int, a#39#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqReadOp(a#39#0#0, a#39#1#0) } 
  DtRank(a#39#1#0) < DtRank(#AsyncDisk.DiskOp.ReqReadOp(a#39#0#0, a#39#1#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.ReqWriteOp(int, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.ReqWriteOp: DtCtorId;

// Constructor identifier
axiom (forall a#40#0#0: int, a#40#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(a#40#0#0, a#40#1#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.ReqWriteOp(a#40#0#0, a#40#1#0))
     == ##AsyncDisk.DiskOp.ReqWriteOp);

function AsyncDisk.DiskOp.ReqWriteOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqWriteOp_q(d) } 
  AsyncDisk.DiskOp.ReqWriteOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.ReqWriteOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqWriteOp_q(d) } 
  AsyncDisk.DiskOp.ReqWriteOp_q(d)
     ==> (exists a#41#0#0: int, a#41#1#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.ReqWriteOp(a#41#0#0, a#41#1#0)));

// Constructor $Is
axiom (forall a#42#0#0: int, a#42#1#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.ReqWriteOp(a#42#0#0, a#42#1#0), Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.ReqWriteOp(a#42#0#0, a#42#1#0), Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#42#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#42#1#0, Tclass.AsyncDisk.ReqWrite()));

// Constructor $IsAlloc
axiom (forall a#43#0#0: int, a#43#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.ReqWriteOp(a#43#0#0, a#43#1#0), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.ReqWriteOp(a#43#0#0, a#43#1#0), Tclass.AsyncDisk.DiskOp(), $h)
       <==> $IsAlloc(a#43#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#43#1#0, Tclass.AsyncDisk.ReqWrite(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWriteOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.reqWrite(d), Tclass.AsyncDisk.ReqWrite(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWriteOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.reqWrite(d), Tclass.AsyncDisk.ReqWrite(), $h));

// Constructor literal
axiom (forall a#44#0#0: int, a#44#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(LitInt(a#44#0#0), Lit(a#44#1#0)) } 
  #AsyncDisk.DiskOp.ReqWriteOp(LitInt(a#44#0#0), Lit(a#44#1#0))
     == Lit(#AsyncDisk.DiskOp.ReqWriteOp(a#44#0#0, a#44#1#0)));

// Constructor injectivity
axiom (forall a#45#0#0: int, a#45#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(a#45#0#0, a#45#1#0) } 
  AsyncDisk.DiskOp.id(#AsyncDisk.DiskOp.ReqWriteOp(a#45#0#0, a#45#1#0))
     == a#45#0#0);

function AsyncDisk.DiskOp.reqWrite(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#46#0#0: int, a#46#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(a#46#0#0, a#46#1#0) } 
  AsyncDisk.DiskOp.reqWrite(#AsyncDisk.DiskOp.ReqWriteOp(a#46#0#0, a#46#1#0))
     == a#46#1#0);

// Inductive rank
axiom (forall a#47#0#0: int, a#47#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWriteOp(a#47#0#0, a#47#1#0) } 
  DtRank(a#47#1#0) < DtRank(#AsyncDisk.DiskOp.ReqWriteOp(a#47#0#0, a#47#1#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.ReqWrite2Op(int, int, DatatypeType, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.ReqWrite2Op: DtCtorId;

// Constructor identifier
axiom (forall a#48#0#0: int, a#48#1#0: int, a#48#2#0: DatatypeType, a#48#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#48#0#0, a#48#1#0, a#48#2#0, a#48#3#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.ReqWrite2Op(a#48#0#0, a#48#1#0, a#48#2#0, a#48#3#0))
     == ##AsyncDisk.DiskOp.ReqWrite2Op);

function AsyncDisk.DiskOp.ReqWrite2Op_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqWrite2Op_q(d) } 
  AsyncDisk.DiskOp.ReqWrite2Op_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.ReqWrite2Op);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.ReqWrite2Op_q(d) } 
  AsyncDisk.DiskOp.ReqWrite2Op_q(d)
     ==> (exists a#49#0#0: int, a#49#1#0: int, a#49#2#0: DatatypeType, a#49#3#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.ReqWrite2Op(a#49#0#0, a#49#1#0, a#49#2#0, a#49#3#0)));

// Constructor $Is
axiom (forall a#50#0#0: int, a#50#1#0: int, a#50#2#0: DatatypeType, a#50#3#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.ReqWrite2Op(a#50#0#0, a#50#1#0, a#50#2#0, a#50#3#0), 
      Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.ReqWrite2Op(a#50#0#0, a#50#1#0, a#50#2#0, a#50#3#0), 
      Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#50#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#50#1#0, Tclass.NativeTypes.uint64())
       && $Is(a#50#2#0, Tclass.AsyncDisk.ReqWrite())
       && $Is(a#50#3#0, Tclass.AsyncDisk.ReqWrite()));

// Constructor $IsAlloc
axiom (forall a#51#0#0: int, 
    a#51#1#0: int, 
    a#51#2#0: DatatypeType, 
    a#51#3#0: DatatypeType, 
    $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.ReqWrite2Op(a#51#0#0, a#51#1#0, a#51#2#0, a#51#3#0), 
      Tclass.AsyncDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.ReqWrite2Op(a#51#0#0, a#51#1#0, a#51#2#0, a#51#3#0), 
        Tclass.AsyncDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#51#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#51#1#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#51#2#0, Tclass.AsyncDisk.ReqWrite(), $h)
         && $IsAlloc(a#51#3#0, Tclass.AsyncDisk.ReqWrite(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id1(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id1(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id2(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id2(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.reqWrite1(d), Tclass.AsyncDisk.ReqWrite(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.reqWrite1(d), Tclass.AsyncDisk.ReqWrite(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.reqWrite2(d), Tclass.AsyncDisk.ReqWrite(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.reqWrite2(d), Tclass.AsyncDisk.ReqWrite(), $h));

// Constructor literal
axiom (forall a#52#0#0: int, a#52#1#0: int, a#52#2#0: DatatypeType, a#52#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(LitInt(a#52#0#0), LitInt(a#52#1#0), Lit(a#52#2#0), Lit(a#52#3#0)) } 
  #AsyncDisk.DiskOp.ReqWrite2Op(LitInt(a#52#0#0), LitInt(a#52#1#0), Lit(a#52#2#0), Lit(a#52#3#0))
     == Lit(#AsyncDisk.DiskOp.ReqWrite2Op(a#52#0#0, a#52#1#0, a#52#2#0, a#52#3#0)));

function AsyncDisk.DiskOp.id1(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#53#0#0: int, a#53#1#0: int, a#53#2#0: DatatypeType, a#53#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#53#0#0, a#53#1#0, a#53#2#0, a#53#3#0) } 
  AsyncDisk.DiskOp.id1(#AsyncDisk.DiskOp.ReqWrite2Op(a#53#0#0, a#53#1#0, a#53#2#0, a#53#3#0))
     == a#53#0#0);

function AsyncDisk.DiskOp.id2(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#54#0#0: int, a#54#1#0: int, a#54#2#0: DatatypeType, a#54#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#54#0#0, a#54#1#0, a#54#2#0, a#54#3#0) } 
  AsyncDisk.DiskOp.id2(#AsyncDisk.DiskOp.ReqWrite2Op(a#54#0#0, a#54#1#0, a#54#2#0, a#54#3#0))
     == a#54#1#0);

function AsyncDisk.DiskOp.reqWrite1(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#55#0#0: int, a#55#1#0: int, a#55#2#0: DatatypeType, a#55#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#55#0#0, a#55#1#0, a#55#2#0, a#55#3#0) } 
  AsyncDisk.DiskOp.reqWrite1(#AsyncDisk.DiskOp.ReqWrite2Op(a#55#0#0, a#55#1#0, a#55#2#0, a#55#3#0))
     == a#55#2#0);

// Inductive rank
axiom (forall a#56#0#0: int, a#56#1#0: int, a#56#2#0: DatatypeType, a#56#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#56#0#0, a#56#1#0, a#56#2#0, a#56#3#0) } 
  DtRank(a#56#2#0)
     < DtRank(#AsyncDisk.DiskOp.ReqWrite2Op(a#56#0#0, a#56#1#0, a#56#2#0, a#56#3#0)));

function AsyncDisk.DiskOp.reqWrite2(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#57#0#0: int, a#57#1#0: int, a#57#2#0: DatatypeType, a#57#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#57#0#0, a#57#1#0, a#57#2#0, a#57#3#0) } 
  AsyncDisk.DiskOp.reqWrite2(#AsyncDisk.DiskOp.ReqWrite2Op(a#57#0#0, a#57#1#0, a#57#2#0, a#57#3#0))
     == a#57#3#0);

// Inductive rank
axiom (forall a#58#0#0: int, a#58#1#0: int, a#58#2#0: DatatypeType, a#58#3#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.ReqWrite2Op(a#58#0#0, a#58#1#0, a#58#2#0, a#58#3#0) } 
  DtRank(a#58#3#0)
     < DtRank(#AsyncDisk.DiskOp.ReqWrite2Op(a#58#0#0, a#58#1#0, a#58#2#0, a#58#3#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.RespReadOp(int, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.RespReadOp: DtCtorId;

// Constructor identifier
axiom (forall a#59#0#0: int, a#59#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(a#59#0#0, a#59#1#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.RespReadOp(a#59#0#0, a#59#1#0))
     == ##AsyncDisk.DiskOp.RespReadOp);

function AsyncDisk.DiskOp.RespReadOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.RespReadOp_q(d) } 
  AsyncDisk.DiskOp.RespReadOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.RespReadOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.RespReadOp_q(d) } 
  AsyncDisk.DiskOp.RespReadOp_q(d)
     ==> (exists a#60#0#0: int, a#60#1#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.RespReadOp(a#60#0#0, a#60#1#0)));

// Constructor $Is
axiom (forall a#61#0#0: int, a#61#1#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.RespReadOp(a#61#0#0, a#61#1#0), Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.RespReadOp(a#61#0#0, a#61#1#0), Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#61#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#61#1#0, Tclass.AsyncDisk.RespRead()));

// Constructor $IsAlloc
axiom (forall a#62#0#0: int, a#62#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.RespReadOp(a#62#0#0, a#62#1#0), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.RespReadOp(a#62#0#0, a#62#1#0), Tclass.AsyncDisk.DiskOp(), $h)
       <==> $IsAlloc(a#62#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#62#1#0, Tclass.AsyncDisk.RespRead(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.RespReadOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.respRead(d), Tclass.AsyncDisk.RespRead(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.RespReadOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.respRead(d), Tclass.AsyncDisk.RespRead(), $h));

// Constructor literal
axiom (forall a#63#0#0: int, a#63#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(LitInt(a#63#0#0), Lit(a#63#1#0)) } 
  #AsyncDisk.DiskOp.RespReadOp(LitInt(a#63#0#0), Lit(a#63#1#0))
     == Lit(#AsyncDisk.DiskOp.RespReadOp(a#63#0#0, a#63#1#0)));

// Constructor injectivity
axiom (forall a#64#0#0: int, a#64#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(a#64#0#0, a#64#1#0) } 
  AsyncDisk.DiskOp.id(#AsyncDisk.DiskOp.RespReadOp(a#64#0#0, a#64#1#0))
     == a#64#0#0);

function AsyncDisk.DiskOp.respRead(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#65#0#0: int, a#65#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(a#65#0#0, a#65#1#0) } 
  AsyncDisk.DiskOp.respRead(#AsyncDisk.DiskOp.RespReadOp(a#65#0#0, a#65#1#0))
     == a#65#1#0);

// Inductive rank
axiom (forall a#66#0#0: int, a#66#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespReadOp(a#66#0#0, a#66#1#0) } 
  DtRank(a#66#1#0) < DtRank(#AsyncDisk.DiskOp.RespReadOp(a#66#0#0, a#66#1#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.RespWriteOp(int, DatatypeType) : DatatypeType;

const unique ##AsyncDisk.DiskOp.RespWriteOp: DtCtorId;

// Constructor identifier
axiom (forall a#67#0#0: int, a#67#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(a#67#0#0, a#67#1#0) } 
  DatatypeCtorId(#AsyncDisk.DiskOp.RespWriteOp(a#67#0#0, a#67#1#0))
     == ##AsyncDisk.DiskOp.RespWriteOp);

function AsyncDisk.DiskOp.RespWriteOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.RespWriteOp_q(d) } 
  AsyncDisk.DiskOp.RespWriteOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.RespWriteOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.RespWriteOp_q(d) } 
  AsyncDisk.DiskOp.RespWriteOp_q(d)
     ==> (exists a#68#0#0: int, a#68#1#0: DatatypeType :: 
      d == #AsyncDisk.DiskOp.RespWriteOp(a#68#0#0, a#68#1#0)));

// Constructor $Is
axiom (forall a#69#0#0: int, a#69#1#0: DatatypeType :: 
  { $Is(#AsyncDisk.DiskOp.RespWriteOp(a#69#0#0, a#69#1#0), Tclass.AsyncDisk.DiskOp()) } 
  $Is(#AsyncDisk.DiskOp.RespWriteOp(a#69#0#0, a#69#1#0), Tclass.AsyncDisk.DiskOp())
     <==> $Is(a#69#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#69#1#0, Tclass.AsyncDisk.RespWrite()));

// Constructor $IsAlloc
axiom (forall a#70#0#0: int, a#70#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.RespWriteOp(a#70#0#0, a#70#1#0), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.DiskOp.RespWriteOp(a#70#0#0, a#70#1#0), Tclass.AsyncDisk.DiskOp(), $h)
       <==> $IsAlloc(a#70#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#70#1#0, Tclass.AsyncDisk.RespWrite(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.RespWriteOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.DiskOp.respWrite(d), Tclass.AsyncDisk.RespWrite(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.DiskOp.RespWriteOp_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.DiskOp(), $h)
     ==> $IsAlloc(AsyncDisk.DiskOp.respWrite(d), Tclass.AsyncDisk.RespWrite(), $h));

// Constructor literal
axiom (forall a#71#0#0: int, a#71#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(LitInt(a#71#0#0), Lit(a#71#1#0)) } 
  #AsyncDisk.DiskOp.RespWriteOp(LitInt(a#71#0#0), Lit(a#71#1#0))
     == Lit(#AsyncDisk.DiskOp.RespWriteOp(a#71#0#0, a#71#1#0)));

// Constructor injectivity
axiom (forall a#72#0#0: int, a#72#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(a#72#0#0, a#72#1#0) } 
  AsyncDisk.DiskOp.id(#AsyncDisk.DiskOp.RespWriteOp(a#72#0#0, a#72#1#0))
     == a#72#0#0);

function AsyncDisk.DiskOp.respWrite(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#73#0#0: int, a#73#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(a#73#0#0, a#73#1#0) } 
  AsyncDisk.DiskOp.respWrite(#AsyncDisk.DiskOp.RespWriteOp(a#73#0#0, a#73#1#0))
     == a#73#1#0);

// Inductive rank
axiom (forall a#74#0#0: int, a#74#1#0: DatatypeType :: 
  { #AsyncDisk.DiskOp.RespWriteOp(a#74#0#0, a#74#1#0) } 
  DtRank(a#74#1#0) < DtRank(#AsyncDisk.DiskOp.RespWriteOp(a#74#0#0, a#74#1#0)));

// Constructor function declaration
function #AsyncDisk.DiskOp.NoDiskOp() : DatatypeType;

const unique ##AsyncDisk.DiskOp.NoDiskOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.DiskOp.NoDiskOp()) == ##AsyncDisk.DiskOp.NoDiskOp;

function AsyncDisk.DiskOp.NoDiskOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.NoDiskOp_q(d) } 
  AsyncDisk.DiskOp.NoDiskOp_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.DiskOp.NoDiskOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.NoDiskOp_q(d) } 
  AsyncDisk.DiskOp.NoDiskOp_q(d) ==> d == #AsyncDisk.DiskOp.NoDiskOp());

// Constructor $Is
axiom $Is(#AsyncDisk.DiskOp.NoDiskOp(), Tclass.AsyncDisk.DiskOp());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.DiskOp.NoDiskOp(), Tclass.AsyncDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.DiskOp.NoDiskOp(), Tclass.AsyncDisk.DiskOp(), $h));

// Constructor literal
axiom #AsyncDisk.DiskOp.NoDiskOp() == Lit(#AsyncDisk.DiskOp.NoDiskOp());

// Depth-one case-split function
function $IsA#AsyncDisk.DiskOp(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.DiskOp(d) } 
  $IsA#AsyncDisk.DiskOp(d)
     ==> AsyncDisk.DiskOp.ReqReadOp_q(d)
       || AsyncDisk.DiskOp.ReqWriteOp_q(d)
       || AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       || AsyncDisk.DiskOp.RespReadOp_q(d)
       || AsyncDisk.DiskOp.RespWriteOp_q(d)
       || AsyncDisk.DiskOp.NoDiskOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.DiskOp.NoDiskOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.RespWriteOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.RespReadOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.ReqWrite2Op_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.ReqWriteOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
    { AsyncDisk.DiskOp.ReqReadOp_q(d), $Is(d, Tclass.AsyncDisk.DiskOp()) } 
  $Is(d, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.DiskOp.ReqReadOp_q(d)
       || AsyncDisk.DiskOp.ReqWriteOp_q(d)
       || AsyncDisk.DiskOp.ReqWrite2Op_q(d)
       || AsyncDisk.DiskOp.RespReadOp_q(d)
       || AsyncDisk.DiskOp.RespWriteOp_q(d)
       || AsyncDisk.DiskOp.NoDiskOp_q(d));

// Datatype extensional equality declaration
function AsyncDisk.DiskOp#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.DiskOp.ReqReadOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqReadOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqReadOp_q(b) } 
  AsyncDisk.DiskOp.ReqReadOp_q(a) && AsyncDisk.DiskOp.ReqReadOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id(a) == AsyncDisk.DiskOp.id(b)
         && AsyncDisk.ReqRead#Equal(AsyncDisk.DiskOp.reqRead(a), AsyncDisk.DiskOp.reqRead(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.ReqWriteOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqWriteOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqWriteOp_q(b) } 
  AsyncDisk.DiskOp.ReqWriteOp_q(a) && AsyncDisk.DiskOp.ReqWriteOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id(a) == AsyncDisk.DiskOp.id(b)
         && AsyncDisk.ReqWrite#Equal(AsyncDisk.DiskOp.reqWrite(a), AsyncDisk.DiskOp.reqWrite(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.ReqWrite2Op
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqWrite2Op_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.ReqWrite2Op_q(b) } 
  AsyncDisk.DiskOp.ReqWrite2Op_q(a) && AsyncDisk.DiskOp.ReqWrite2Op_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id1(a) == AsyncDisk.DiskOp.id1(b)
         && AsyncDisk.DiskOp.id2(a) == AsyncDisk.DiskOp.id2(b)
         && AsyncDisk.ReqWrite#Equal(AsyncDisk.DiskOp.reqWrite1(a), AsyncDisk.DiskOp.reqWrite1(b))
         && AsyncDisk.ReqWrite#Equal(AsyncDisk.DiskOp.reqWrite2(a), AsyncDisk.DiskOp.reqWrite2(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.RespReadOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.RespReadOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.RespReadOp_q(b) } 
  AsyncDisk.DiskOp.RespReadOp_q(a) && AsyncDisk.DiskOp.RespReadOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id(a) == AsyncDisk.DiskOp.id(b)
         && AsyncDisk.RespRead#Equal(AsyncDisk.DiskOp.respRead(a), AsyncDisk.DiskOp.respRead(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.RespWriteOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.RespWriteOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.RespWriteOp_q(b) } 
  AsyncDisk.DiskOp.RespWriteOp_q(a) && AsyncDisk.DiskOp.RespWriteOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b)
       <==> AsyncDisk.DiskOp.id(a) == AsyncDisk.DiskOp.id(b)
         && AsyncDisk.RespWrite#Equal(AsyncDisk.DiskOp.respWrite(a), AsyncDisk.DiskOp.respWrite(b))));

// Datatype extensional equality definition: #AsyncDisk.DiskOp.NoDiskOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.NoDiskOp_q(a) } 
    { AsyncDisk.DiskOp#Equal(a, b), AsyncDisk.DiskOp.NoDiskOp_q(b) } 
  AsyncDisk.DiskOp.NoDiskOp_q(a) && AsyncDisk.DiskOp.NoDiskOp_q(b)
     ==> (AsyncDisk.DiskOp#Equal(a, b) <==> true));

// Datatype extensionality axiom: AsyncDisk.DiskOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.DiskOp#Equal(a, b) } 
  AsyncDisk.DiskOp#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.DiskOp: ClassName;

// Constructor function declaration
function #AsyncDisk.Constants.Constants() : DatatypeType;

const unique ##AsyncDisk.Constants.Constants: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Constants.Constants())
   == ##AsyncDisk.Constants.Constants;

function AsyncDisk.Constants.Constants_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Constants.Constants_q(d) } 
  AsyncDisk.Constants.Constants_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Constants.Constants);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Constants.Constants_q(d) } 
  AsyncDisk.Constants.Constants_q(d) ==> d == #AsyncDisk.Constants.Constants());

function Tclass.AsyncDisk.Constants() : Ty;

// Tclass.AsyncDisk.Constants Tag
axiom Tag(Tclass.AsyncDisk.Constants()) == Tagclass.AsyncDisk.Constants;

const unique Tagclass.AsyncDisk.Constants: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.Constants
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.Constants()) } 
  $IsBox(bx, Tclass.AsyncDisk.Constants())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.Constants()));

// Constructor $Is
axiom $Is(#AsyncDisk.Constants.Constants(), Tclass.AsyncDisk.Constants());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Constants.Constants(), Tclass.AsyncDisk.Constants(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Constants.Constants(), Tclass.AsyncDisk.Constants(), $h));

// Constructor literal
axiom #AsyncDisk.Constants.Constants() == Lit(#AsyncDisk.Constants.Constants());

// Depth-one case-split function
function $IsA#AsyncDisk.Constants(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.Constants(d) } 
  $IsA#AsyncDisk.Constants(d) ==> AsyncDisk.Constants.Constants_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Constants.Constants_q(d), $Is(d, Tclass.AsyncDisk.Constants()) } 
  $Is(d, Tclass.AsyncDisk.Constants()) ==> AsyncDisk.Constants.Constants_q(d));

// Datatype extensional equality declaration
function AsyncDisk.Constants#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.Constants.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Constants#Equal(a, b) } 
  true ==> (AsyncDisk.Constants#Equal(a, b) <==> true));

// Datatype extensionality axiom: AsyncDisk.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Constants#Equal(a, b) } 
  AsyncDisk.Constants#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.Constants: ClassName;

// Constructor function declaration
function #AsyncDisk.Variables.Variables(Map Box Box, Map Box Box, Map Box Box, Map Box Box, Seq Box) : DatatypeType;

const unique ##AsyncDisk.Variables.Variables: DtCtorId;

// Constructor identifier
axiom (forall a#85#0#0: Map Box Box, 
    a#85#1#0: Map Box Box, 
    a#85#2#0: Map Box Box, 
    a#85#3#0: Map Box Box, 
    a#85#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#85#0#0, a#85#1#0, a#85#2#0, a#85#3#0, a#85#4#0) } 
  DatatypeCtorId(#AsyncDisk.Variables.Variables(a#85#0#0, a#85#1#0, a#85#2#0, a#85#3#0, a#85#4#0))
     == ##AsyncDisk.Variables.Variables);

function AsyncDisk.Variables.Variables_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Variables.Variables_q(d) } 
  AsyncDisk.Variables.Variables_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Variables.Variables);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Variables.Variables_q(d) } 
  AsyncDisk.Variables.Variables_q(d)
     ==> (exists a#86#0#0: Map Box Box, 
        a#86#1#0: Map Box Box, 
        a#86#2#0: Map Box Box, 
        a#86#3#0: Map Box Box, 
        a#86#4#0: Seq Box :: 
      d
         == #AsyncDisk.Variables.Variables(a#86#0#0, a#86#1#0, a#86#2#0, a#86#3#0, a#86#4#0)));

function Tclass.AsyncDisk.Variables() : Ty;

// Tclass.AsyncDisk.Variables Tag
axiom Tag(Tclass.AsyncDisk.Variables()) == Tagclass.AsyncDisk.Variables;

const unique Tagclass.AsyncDisk.Variables: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.Variables
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.Variables()) } 
  $IsBox(bx, Tclass.AsyncDisk.Variables())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.Variables()));

// Constructor $Is
axiom (forall a#87#0#0: Map Box Box, 
    a#87#1#0: Map Box Box, 
    a#87#2#0: Map Box Box, 
    a#87#3#0: Map Box Box, 
    a#87#4#0: Seq Box :: 
  { $Is(#AsyncDisk.Variables.Variables(a#87#0#0, a#87#1#0, a#87#2#0, a#87#3#0, a#87#4#0), 
      Tclass.AsyncDisk.Variables()) } 
  $Is(#AsyncDisk.Variables.Variables(a#87#0#0, a#87#1#0, a#87#2#0, a#87#3#0, a#87#4#0), 
      Tclass.AsyncDisk.Variables())
     <==> $Is(a#87#0#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqRead()))
       && $Is(a#87#1#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqWrite()))
       && $Is(a#87#2#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespRead()))
       && $Is(a#87#3#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespWrite()))
       && $Is(a#87#4#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#88#0#0: Map Box Box, 
    a#88#1#0: Map Box Box, 
    a#88#2#0: Map Box Box, 
    a#88#3#0: Map Box Box, 
    a#88#4#0: Seq Box, 
    $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Variables.Variables(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0, a#88#4#0), 
      Tclass.AsyncDisk.Variables(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.Variables.Variables(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0, a#88#4#0), 
        Tclass.AsyncDisk.Variables(), 
        $h)
       <==> $IsAlloc(a#88#0#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqRead()), $h)
         && $IsAlloc(a#88#1#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqWrite()), $h)
         && $IsAlloc(a#88#2#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespRead()), $h)
         && $IsAlloc(a#88#3#0, TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespWrite()), $h)
         && $IsAlloc(a#88#4#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.reqReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqRead()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.reqReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqRead()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.reqWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqWrite()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.reqWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.ReqWrite()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.respReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespRead()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.respReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespRead()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.respWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespWrite()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.respWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.AsyncDisk.RespWrite()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.Variables.contents(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.Variables(), $h)
     ==> $IsAlloc(AsyncDisk.Variables.contents(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#89#0#0: Map Box Box, 
    a#89#1#0: Map Box Box, 
    a#89#2#0: Map Box Box, 
    a#89#3#0: Map Box Box, 
    a#89#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(Lit(a#89#0#0), Lit(a#89#1#0), Lit(a#89#2#0), Lit(a#89#3#0), Lit(a#89#4#0)) } 
  #AsyncDisk.Variables.Variables(Lit(a#89#0#0), Lit(a#89#1#0), Lit(a#89#2#0), Lit(a#89#3#0), Lit(a#89#4#0))
     == Lit(#AsyncDisk.Variables.Variables(a#89#0#0, a#89#1#0, a#89#2#0, a#89#3#0, a#89#4#0)));

function AsyncDisk.Variables.reqReads(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#90#0#0: Map Box Box, 
    a#90#1#0: Map Box Box, 
    a#90#2#0: Map Box Box, 
    a#90#3#0: Map Box Box, 
    a#90#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#90#0#0, a#90#1#0, a#90#2#0, a#90#3#0, a#90#4#0) } 
  AsyncDisk.Variables.reqReads(#AsyncDisk.Variables.Variables(a#90#0#0, a#90#1#0, a#90#2#0, a#90#3#0, a#90#4#0))
     == a#90#0#0);

// Inductive map key rank
axiom (forall a#91#0#0: Map Box Box, 
    a#91#1#0: Map Box Box, 
    a#91#2#0: Map Box Box, 
    a#91#3#0: Map Box Box, 
    a#91#4#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#91#0#0)[$Box(d)], #AsyncDisk.Variables.Variables(a#91#0#0, a#91#1#0, a#91#2#0, a#91#3#0, a#91#4#0) } 
  Map#Domain(a#91#0#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#AsyncDisk.Variables.Variables(a#91#0#0, a#91#1#0, a#91#2#0, a#91#3#0, a#91#4#0)));

// Inductive map value rank
axiom (forall a#92#0#0: Map Box Box, 
    a#92#1#0: Map Box Box, 
    a#92#2#0: Map Box Box, 
    a#92#3#0: Map Box Box, 
    a#92#4#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#92#0#0)[bx], #AsyncDisk.Variables.Variables(a#92#0#0, a#92#1#0, a#92#2#0, a#92#3#0, a#92#4#0) } 
  Map#Domain(a#92#0#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#92#0#0)[bx]): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#92#0#0, a#92#1#0, a#92#2#0, a#92#3#0, a#92#4#0)));

function AsyncDisk.Variables.reqWrites(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#93#0#0: Map Box Box, 
    a#93#1#0: Map Box Box, 
    a#93#2#0: Map Box Box, 
    a#93#3#0: Map Box Box, 
    a#93#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#93#0#0, a#93#1#0, a#93#2#0, a#93#3#0, a#93#4#0) } 
  AsyncDisk.Variables.reqWrites(#AsyncDisk.Variables.Variables(a#93#0#0, a#93#1#0, a#93#2#0, a#93#3#0, a#93#4#0))
     == a#93#1#0);

// Inductive map key rank
axiom (forall a#94#0#0: Map Box Box, 
    a#94#1#0: Map Box Box, 
    a#94#2#0: Map Box Box, 
    a#94#3#0: Map Box Box, 
    a#94#4#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#94#1#0)[$Box(d)], #AsyncDisk.Variables.Variables(a#94#0#0, a#94#1#0, a#94#2#0, a#94#3#0, a#94#4#0) } 
  Map#Domain(a#94#1#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#AsyncDisk.Variables.Variables(a#94#0#0, a#94#1#0, a#94#2#0, a#94#3#0, a#94#4#0)));

// Inductive map value rank
axiom (forall a#95#0#0: Map Box Box, 
    a#95#1#0: Map Box Box, 
    a#95#2#0: Map Box Box, 
    a#95#3#0: Map Box Box, 
    a#95#4#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#95#1#0)[bx], #AsyncDisk.Variables.Variables(a#95#0#0, a#95#1#0, a#95#2#0, a#95#3#0, a#95#4#0) } 
  Map#Domain(a#95#1#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#95#1#0)[bx]): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#95#0#0, a#95#1#0, a#95#2#0, a#95#3#0, a#95#4#0)));

function AsyncDisk.Variables.respReads(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#96#0#0: Map Box Box, 
    a#96#1#0: Map Box Box, 
    a#96#2#0: Map Box Box, 
    a#96#3#0: Map Box Box, 
    a#96#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#96#0#0, a#96#1#0, a#96#2#0, a#96#3#0, a#96#4#0) } 
  AsyncDisk.Variables.respReads(#AsyncDisk.Variables.Variables(a#96#0#0, a#96#1#0, a#96#2#0, a#96#3#0, a#96#4#0))
     == a#96#2#0);

// Inductive map key rank
axiom (forall a#97#0#0: Map Box Box, 
    a#97#1#0: Map Box Box, 
    a#97#2#0: Map Box Box, 
    a#97#3#0: Map Box Box, 
    a#97#4#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#97#2#0)[$Box(d)], #AsyncDisk.Variables.Variables(a#97#0#0, a#97#1#0, a#97#2#0, a#97#3#0, a#97#4#0) } 
  Map#Domain(a#97#2#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#AsyncDisk.Variables.Variables(a#97#0#0, a#97#1#0, a#97#2#0, a#97#3#0, a#97#4#0)));

// Inductive map value rank
axiom (forall a#98#0#0: Map Box Box, 
    a#98#1#0: Map Box Box, 
    a#98#2#0: Map Box Box, 
    a#98#3#0: Map Box Box, 
    a#98#4#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#98#2#0)[bx], #AsyncDisk.Variables.Variables(a#98#0#0, a#98#1#0, a#98#2#0, a#98#3#0, a#98#4#0) } 
  Map#Domain(a#98#2#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#98#2#0)[bx]): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#98#0#0, a#98#1#0, a#98#2#0, a#98#3#0, a#98#4#0)));

function AsyncDisk.Variables.respWrites(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#99#0#0: Map Box Box, 
    a#99#1#0: Map Box Box, 
    a#99#2#0: Map Box Box, 
    a#99#3#0: Map Box Box, 
    a#99#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#99#0#0, a#99#1#0, a#99#2#0, a#99#3#0, a#99#4#0) } 
  AsyncDisk.Variables.respWrites(#AsyncDisk.Variables.Variables(a#99#0#0, a#99#1#0, a#99#2#0, a#99#3#0, a#99#4#0))
     == a#99#3#0);

// Inductive map key rank
axiom (forall a#100#0#0: Map Box Box, 
    a#100#1#0: Map Box Box, 
    a#100#2#0: Map Box Box, 
    a#100#3#0: Map Box Box, 
    a#100#4#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#100#3#0)[$Box(d)], #AsyncDisk.Variables.Variables(a#100#0#0, a#100#1#0, a#100#2#0, a#100#3#0, a#100#4#0) } 
  Map#Domain(a#100#3#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#AsyncDisk.Variables.Variables(a#100#0#0, a#100#1#0, a#100#2#0, a#100#3#0, a#100#4#0)));

// Inductive map value rank
axiom (forall a#101#0#0: Map Box Box, 
    a#101#1#0: Map Box Box, 
    a#101#2#0: Map Box Box, 
    a#101#3#0: Map Box Box, 
    a#101#4#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#101#3#0)[bx], #AsyncDisk.Variables.Variables(a#101#0#0, a#101#1#0, a#101#2#0, a#101#3#0, a#101#4#0) } 
  Map#Domain(a#101#3#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#101#3#0)[bx]): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#101#0#0, a#101#1#0, a#101#2#0, a#101#3#0, a#101#4#0)));

function AsyncDisk.Variables.contents(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#102#0#0: Map Box Box, 
    a#102#1#0: Map Box Box, 
    a#102#2#0: Map Box Box, 
    a#102#3#0: Map Box Box, 
    a#102#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#102#0#0, a#102#1#0, a#102#2#0, a#102#3#0, a#102#4#0) } 
  AsyncDisk.Variables.contents(#AsyncDisk.Variables.Variables(a#102#0#0, a#102#1#0, a#102#2#0, a#102#3#0, a#102#4#0))
     == a#102#4#0);

// Inductive seq element rank
axiom (forall a#103#0#0: Map Box Box, 
    a#103#1#0: Map Box Box, 
    a#103#2#0: Map Box Box, 
    a#103#3#0: Map Box Box, 
    a#103#4#0: Seq Box, 
    i: int :: 
  { Seq#Index(a#103#4#0, i), #AsyncDisk.Variables.Variables(a#103#0#0, a#103#1#0, a#103#2#0, a#103#3#0, a#103#4#0) } 
  0 <= i && i < Seq#Length(a#103#4#0)
     ==> DtRank($Unbox(Seq#Index(a#103#4#0, i)): DatatypeType)
       < DtRank(#AsyncDisk.Variables.Variables(a#103#0#0, a#103#1#0, a#103#2#0, a#103#3#0, a#103#4#0)));

// Inductive seq rank
axiom (forall a#104#0#0: Map Box Box, 
    a#104#1#0: Map Box Box, 
    a#104#2#0: Map Box Box, 
    a#104#3#0: Map Box Box, 
    a#104#4#0: Seq Box :: 
  { #AsyncDisk.Variables.Variables(a#104#0#0, a#104#1#0, a#104#2#0, a#104#3#0, a#104#4#0) } 
  Seq#Rank(a#104#4#0)
     < DtRank(#AsyncDisk.Variables.Variables(a#104#0#0, a#104#1#0, a#104#2#0, a#104#3#0, a#104#4#0)));

// Depth-one case-split function
function $IsA#AsyncDisk.Variables(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.Variables(d) } 
  $IsA#AsyncDisk.Variables(d) ==> AsyncDisk.Variables.Variables_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Variables.Variables_q(d), $Is(d, Tclass.AsyncDisk.Variables()) } 
  $Is(d, Tclass.AsyncDisk.Variables()) ==> AsyncDisk.Variables.Variables_q(d));

// Datatype extensional equality declaration
function AsyncDisk.Variables#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.Variables.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Variables#Equal(a, b) } 
  true
     ==> (AsyncDisk.Variables#Equal(a, b)
       <==> Map#Equal(AsyncDisk.Variables.reqReads(a), AsyncDisk.Variables.reqReads(b))
         && Map#Equal(AsyncDisk.Variables.reqWrites(a), AsyncDisk.Variables.reqWrites(b))
         && Map#Equal(AsyncDisk.Variables.respReads(a), AsyncDisk.Variables.respReads(b))
         && Map#Equal(AsyncDisk.Variables.respWrites(a), AsyncDisk.Variables.respWrites(b))
         && Seq#Equal(AsyncDisk.Variables.contents(a), AsyncDisk.Variables.contents(b))));

// Datatype extensionality axiom: AsyncDisk.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Variables#Equal(a, b) } 
  AsyncDisk.Variables#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.Variables: ClassName;

// Constructor function declaration
function #AsyncDisk.Step.RecvReadStep() : DatatypeType;

const unique ##AsyncDisk.Step.RecvReadStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.RecvReadStep()) == ##AsyncDisk.Step.RecvReadStep;

function AsyncDisk.Step.RecvReadStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvReadStep_q(d) } 
  AsyncDisk.Step.RecvReadStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.RecvReadStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvReadStep_q(d) } 
  AsyncDisk.Step.RecvReadStep_q(d) ==> d == #AsyncDisk.Step.RecvReadStep());

function Tclass.AsyncDisk.Step() : Ty;

// Tclass.AsyncDisk.Step Tag
axiom Tag(Tclass.AsyncDisk.Step()) == Tagclass.AsyncDisk.Step;

const unique Tagclass.AsyncDisk.Step: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.Step
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.Step()) } 
  $IsBox(bx, Tclass.AsyncDisk.Step())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.Step()));

// Constructor $Is
axiom $Is(#AsyncDisk.Step.RecvReadStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.RecvReadStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.RecvReadStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.RecvReadStep() == Lit(#AsyncDisk.Step.RecvReadStep());

// Constructor function declaration
function #AsyncDisk.Step.RecvWriteStep() : DatatypeType;

const unique ##AsyncDisk.Step.RecvWriteStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.RecvWriteStep())
   == ##AsyncDisk.Step.RecvWriteStep;

function AsyncDisk.Step.RecvWriteStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvWriteStep_q(d) } 
  AsyncDisk.Step.RecvWriteStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.RecvWriteStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvWriteStep_q(d) } 
  AsyncDisk.Step.RecvWriteStep_q(d) ==> d == #AsyncDisk.Step.RecvWriteStep());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.RecvWriteStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.RecvWriteStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.RecvWriteStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.RecvWriteStep() == Lit(#AsyncDisk.Step.RecvWriteStep());

// Constructor function declaration
function #AsyncDisk.Step.RecvWrite2Step() : DatatypeType;

const unique ##AsyncDisk.Step.RecvWrite2Step: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.RecvWrite2Step())
   == ##AsyncDisk.Step.RecvWrite2Step;

function AsyncDisk.Step.RecvWrite2Step_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvWrite2Step_q(d) } 
  AsyncDisk.Step.RecvWrite2Step_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.RecvWrite2Step);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.RecvWrite2Step_q(d) } 
  AsyncDisk.Step.RecvWrite2Step_q(d) ==> d == #AsyncDisk.Step.RecvWrite2Step());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.RecvWrite2Step(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.RecvWrite2Step(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.RecvWrite2Step(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.RecvWrite2Step() == Lit(#AsyncDisk.Step.RecvWrite2Step());

// Constructor function declaration
function #AsyncDisk.Step.AckReadStep() : DatatypeType;

const unique ##AsyncDisk.Step.AckReadStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.AckReadStep()) == ##AsyncDisk.Step.AckReadStep;

function AsyncDisk.Step.AckReadStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.AckReadStep_q(d) } 
  AsyncDisk.Step.AckReadStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.AckReadStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.AckReadStep_q(d) } 
  AsyncDisk.Step.AckReadStep_q(d) ==> d == #AsyncDisk.Step.AckReadStep());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.AckReadStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.AckReadStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.AckReadStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.AckReadStep() == Lit(#AsyncDisk.Step.AckReadStep());

// Constructor function declaration
function #AsyncDisk.Step.AckWriteStep() : DatatypeType;

const unique ##AsyncDisk.Step.AckWriteStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.AckWriteStep()) == ##AsyncDisk.Step.AckWriteStep;

function AsyncDisk.Step.AckWriteStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.AckWriteStep_q(d) } 
  AsyncDisk.Step.AckWriteStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.AckWriteStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.AckWriteStep_q(d) } 
  AsyncDisk.Step.AckWriteStep_q(d) ==> d == #AsyncDisk.Step.AckWriteStep());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.AckWriteStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.AckWriteStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.AckWriteStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.AckWriteStep() == Lit(#AsyncDisk.Step.AckWriteStep());

// Constructor function declaration
function #AsyncDisk.Step.StutterStep() : DatatypeType;

const unique ##AsyncDisk.Step.StutterStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#AsyncDisk.Step.StutterStep()) == ##AsyncDisk.Step.StutterStep;

function AsyncDisk.Step.StutterStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.StutterStep_q(d) } 
  AsyncDisk.Step.StutterStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.Step.StutterStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.StutterStep_q(d) } 
  AsyncDisk.Step.StutterStep_q(d) ==> d == #AsyncDisk.Step.StutterStep());

// Constructor $Is
axiom $Is(#AsyncDisk.Step.StutterStep(), Tclass.AsyncDisk.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#AsyncDisk.Step.StutterStep(), Tclass.AsyncDisk.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#AsyncDisk.Step.StutterStep(), Tclass.AsyncDisk.Step(), $h));

// Constructor literal
axiom #AsyncDisk.Step.StutterStep() == Lit(#AsyncDisk.Step.StutterStep());

// Depth-one case-split function
function $IsA#AsyncDisk.Step(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.Step(d) } 
  $IsA#AsyncDisk.Step(d)
     ==> AsyncDisk.Step.RecvReadStep_q(d)
       || AsyncDisk.Step.RecvWriteStep_q(d)
       || AsyncDisk.Step.RecvWrite2Step_q(d)
       || AsyncDisk.Step.AckReadStep_q(d)
       || AsyncDisk.Step.AckWriteStep_q(d)
       || AsyncDisk.Step.StutterStep_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.Step.StutterStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.AckWriteStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.AckReadStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.RecvWrite2Step_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.RecvWriteStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
    { AsyncDisk.Step.RecvReadStep_q(d), $Is(d, Tclass.AsyncDisk.Step()) } 
  $Is(d, Tclass.AsyncDisk.Step())
     ==> AsyncDisk.Step.RecvReadStep_q(d)
       || AsyncDisk.Step.RecvWriteStep_q(d)
       || AsyncDisk.Step.RecvWrite2Step_q(d)
       || AsyncDisk.Step.AckReadStep_q(d)
       || AsyncDisk.Step.AckWriteStep_q(d)
       || AsyncDisk.Step.StutterStep_q(d));

// Datatype extensional equality declaration
function AsyncDisk.Step#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.Step.RecvReadStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvReadStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvReadStep_q(b) } 
  AsyncDisk.Step.RecvReadStep_q(a) && AsyncDisk.Step.RecvReadStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.RecvWriteStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvWriteStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvWriteStep_q(b) } 
  AsyncDisk.Step.RecvWriteStep_q(a) && AsyncDisk.Step.RecvWriteStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.RecvWrite2Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvWrite2Step_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.RecvWrite2Step_q(b) } 
  AsyncDisk.Step.RecvWrite2Step_q(a) && AsyncDisk.Step.RecvWrite2Step_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.AckReadStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.AckReadStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.AckReadStep_q(b) } 
  AsyncDisk.Step.AckReadStep_q(a) && AsyncDisk.Step.AckReadStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.AckWriteStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.AckWriteStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.AckWriteStep_q(b) } 
  AsyncDisk.Step.AckWriteStep_q(a) && AsyncDisk.Step.AckWriteStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #AsyncDisk.Step.StutterStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.StutterStep_q(a) } 
    { AsyncDisk.Step#Equal(a, b), AsyncDisk.Step.StutterStep_q(b) } 
  AsyncDisk.Step.StutterStep_q(a) && AsyncDisk.Step.StutterStep_q(b)
     ==> (AsyncDisk.Step#Equal(a, b) <==> true));

// Datatype extensionality axiom: AsyncDisk.Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.Step#Equal(a, b) } 
  AsyncDisk.Step#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.Step: ClassName;

// Constructor function declaration
function #AsyncDisk.InternalStep.ProcessReadFailureStep(int, Seq Box) : DatatypeType;

const unique ##AsyncDisk.InternalStep.ProcessReadFailureStep: DtCtorId;

// Constructor identifier
axiom (forall a#135#0#0: int, a#135#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(a#135#0#0, a#135#1#0) } 
  DatatypeCtorId(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#135#0#0, a#135#1#0))
     == ##AsyncDisk.InternalStep.ProcessReadFailureStep);

function AsyncDisk.InternalStep.ProcessReadFailureStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.ProcessReadFailureStep_q(d) } 
  AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.InternalStep.ProcessReadFailureStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.ProcessReadFailureStep_q(d) } 
  AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
     ==> (exists a#136#0#0: int, a#136#1#0: Seq Box :: 
      d == #AsyncDisk.InternalStep.ProcessReadFailureStep(a#136#0#0, a#136#1#0)));

function Tclass.AsyncDisk.InternalStep() : Ty;

// Tclass.AsyncDisk.InternalStep Tag
axiom Tag(Tclass.AsyncDisk.InternalStep()) == Tagclass.AsyncDisk.InternalStep;

const unique Tagclass.AsyncDisk.InternalStep: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.InternalStep
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.InternalStep()) } 
  $IsBox(bx, Tclass.AsyncDisk.InternalStep())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.AsyncDisk.InternalStep()));

// Constructor $Is
axiom (forall a#137#0#0: int, a#137#1#0: Seq Box :: 
  { $Is(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#137#0#0, a#137#1#0), 
      Tclass.AsyncDisk.InternalStep()) } 
  $Is(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#137#0#0, a#137#1#0), 
      Tclass.AsyncDisk.InternalStep())
     <==> $Is(a#137#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#137#1#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#138#0#0: int, a#138#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#138#0#0, a#138#1#0), 
      Tclass.AsyncDisk.InternalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#138#0#0, a#138#1#0), 
        Tclass.AsyncDisk.InternalStep(), 
        $h)
       <==> $IsAlloc(a#138#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#138#1#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.fakeContents(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.fakeContents(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#139#0#0: int, a#139#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(LitInt(a#139#0#0), Lit(a#139#1#0)) } 
  #AsyncDisk.InternalStep.ProcessReadFailureStep(LitInt(a#139#0#0), Lit(a#139#1#0))
     == Lit(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#139#0#0, a#139#1#0)));

function AsyncDisk.InternalStep.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#140#0#0: int, a#140#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(a#140#0#0, a#140#1#0) } 
  AsyncDisk.InternalStep.id(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#140#0#0, a#140#1#0))
     == a#140#0#0);

function AsyncDisk.InternalStep.fakeContents(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#141#0#0: int, a#141#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(a#141#0#0, a#141#1#0) } 
  AsyncDisk.InternalStep.fakeContents(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#141#0#0, a#141#1#0))
     == a#141#1#0);

// Inductive seq element rank
axiom (forall a#142#0#0: int, a#142#1#0: Seq Box, i: int :: 
  { Seq#Index(a#142#1#0, i), #AsyncDisk.InternalStep.ProcessReadFailureStep(a#142#0#0, a#142#1#0) } 
  0 <= i && i < Seq#Length(a#142#1#0)
     ==> DtRank($Unbox(Seq#Index(a#142#1#0, i)): DatatypeType)
       < DtRank(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#142#0#0, a#142#1#0)));

// Inductive seq rank
axiom (forall a#143#0#0: int, a#143#1#0: Seq Box :: 
  { #AsyncDisk.InternalStep.ProcessReadFailureStep(a#143#0#0, a#143#1#0) } 
  Seq#Rank(a#143#1#0)
     < DtRank(#AsyncDisk.InternalStep.ProcessReadFailureStep(a#143#0#0, a#143#1#0)));

// Constructor function declaration
function #AsyncDisk.InternalStep.ProcessWriteStep(int) : DatatypeType;

const unique ##AsyncDisk.InternalStep.ProcessWriteStep: DtCtorId;

// Constructor identifier
axiom (forall a#144#0#0: int :: 
  { #AsyncDisk.InternalStep.ProcessWriteStep(a#144#0#0) } 
  DatatypeCtorId(#AsyncDisk.InternalStep.ProcessWriteStep(a#144#0#0))
     == ##AsyncDisk.InternalStep.ProcessWriteStep);

function AsyncDisk.InternalStep.ProcessWriteStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.ProcessWriteStep_q(d) } 
  AsyncDisk.InternalStep.ProcessWriteStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.InternalStep.ProcessWriteStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.ProcessWriteStep_q(d) } 
  AsyncDisk.InternalStep.ProcessWriteStep_q(d)
     ==> (exists a#145#0#0: int :: 
      d == #AsyncDisk.InternalStep.ProcessWriteStep(a#145#0#0)));

// Constructor $Is
axiom (forall a#146#0#0: int :: 
  { $Is(#AsyncDisk.InternalStep.ProcessWriteStep(a#146#0#0), 
      Tclass.AsyncDisk.InternalStep()) } 
  $Is(#AsyncDisk.InternalStep.ProcessWriteStep(a#146#0#0), 
      Tclass.AsyncDisk.InternalStep())
     <==> $Is(a#146#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#147#0#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.InternalStep.ProcessWriteStep(a#147#0#0), 
      Tclass.AsyncDisk.InternalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.InternalStep.ProcessWriteStep(a#147#0#0), 
        Tclass.AsyncDisk.InternalStep(), 
        $h)
       <==> $IsAlloc(a#147#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.ProcessWriteStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#148#0#0: int :: 
  { #AsyncDisk.InternalStep.ProcessWriteStep(LitInt(a#148#0#0)) } 
  #AsyncDisk.InternalStep.ProcessWriteStep(LitInt(a#148#0#0))
     == Lit(#AsyncDisk.InternalStep.ProcessWriteStep(a#148#0#0)));

// Constructor injectivity
axiom (forall a#149#0#0: int :: 
  { #AsyncDisk.InternalStep.ProcessWriteStep(a#149#0#0) } 
  AsyncDisk.InternalStep.id(#AsyncDisk.InternalStep.ProcessWriteStep(a#149#0#0))
     == a#149#0#0);

// Constructor function declaration
function #AsyncDisk.InternalStep.HavocConflictingWritesStep(int, int) : DatatypeType;

const unique ##AsyncDisk.InternalStep.HavocConflictingWritesStep: DtCtorId;

// Constructor identifier
axiom (forall a#150#0#0: int, a#150#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWritesStep(a#150#0#0, a#150#1#0) } 
  DatatypeCtorId(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#150#0#0, a#150#1#0))
     == ##AsyncDisk.InternalStep.HavocConflictingWritesStep);

function AsyncDisk.InternalStep.HavocConflictingWritesStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d) } 
  AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.InternalStep.HavocConflictingWritesStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d) } 
  AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
     ==> (exists a#151#0#0: int, a#151#1#0: int :: 
      d == #AsyncDisk.InternalStep.HavocConflictingWritesStep(a#151#0#0, a#151#1#0)));

// Constructor $Is
axiom (forall a#152#0#0: int, a#152#1#0: int :: 
  { $Is(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#152#0#0, a#152#1#0), 
      Tclass.AsyncDisk.InternalStep()) } 
  $Is(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#152#0#0, a#152#1#0), 
      Tclass.AsyncDisk.InternalStep())
     <==> $Is(a#152#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#152#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#153#0#0: int, a#153#1#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#153#0#0, a#153#1#0), 
      Tclass.AsyncDisk.InternalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#153#0#0, a#153#1#0), 
        Tclass.AsyncDisk.InternalStep(), 
        $h)
       <==> $IsAlloc(a#153#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#153#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id_k(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id_k(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#154#0#0: int, a#154#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWritesStep(LitInt(a#154#0#0), LitInt(a#154#1#0)) } 
  #AsyncDisk.InternalStep.HavocConflictingWritesStep(LitInt(a#154#0#0), LitInt(a#154#1#0))
     == Lit(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#154#0#0, a#154#1#0)));

// Constructor injectivity
axiom (forall a#155#0#0: int, a#155#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWritesStep(a#155#0#0, a#155#1#0) } 
  AsyncDisk.InternalStep.id(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#155#0#0, a#155#1#0))
     == a#155#0#0);

function AsyncDisk.InternalStep.id_k(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#156#0#0: int, a#156#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWritesStep(a#156#0#0, a#156#1#0) } 
  AsyncDisk.InternalStep.id_k(#AsyncDisk.InternalStep.HavocConflictingWritesStep(a#156#0#0, a#156#1#0))
     == a#156#1#0);

// Constructor function declaration
function #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(int, int) : DatatypeType;

const unique ##AsyncDisk.InternalStep.HavocConflictingWriteReadStep: DtCtorId;

// Constructor identifier
axiom (forall a#157#0#0: int, a#157#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#157#0#0, a#157#1#0) } 
  DatatypeCtorId(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#157#0#0, a#157#1#0))
     == ##AsyncDisk.InternalStep.HavocConflictingWriteReadStep);

function AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d) } 
  AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d)
     <==> DatatypeCtorId(d) == ##AsyncDisk.InternalStep.HavocConflictingWriteReadStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d) } 
  AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d)
     ==> (exists a#158#0#0: int, a#158#1#0: int :: 
      d == #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#158#0#0, a#158#1#0)));

// Constructor $Is
axiom (forall a#159#0#0: int, a#159#1#0: int :: 
  { $Is(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#159#0#0, a#159#1#0), 
      Tclass.AsyncDisk.InternalStep()) } 
  $Is(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#159#0#0, a#159#1#0), 
      Tclass.AsyncDisk.InternalStep())
     <==> $Is(a#159#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#159#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#160#0#0: int, a#160#1#0: int, $h: Heap :: 
  { $IsAlloc(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#160#0#0, a#160#1#0), 
      Tclass.AsyncDisk.InternalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#160#0#0, a#160#1#0), 
        Tclass.AsyncDisk.InternalStep(), 
        $h)
       <==> $IsAlloc(a#160#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#160#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(AsyncDisk.InternalStep.id_k(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d)
       && $IsAlloc(d, Tclass.AsyncDisk.InternalStep(), $h)
     ==> $IsAlloc(AsyncDisk.InternalStep.id_k(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#161#0#0: int, a#161#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(LitInt(a#161#0#0), LitInt(a#161#1#0)) } 
  #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(LitInt(a#161#0#0), LitInt(a#161#1#0))
     == Lit(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#161#0#0, a#161#1#0)));

// Constructor injectivity
axiom (forall a#162#0#0: int, a#162#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#162#0#0, a#162#1#0) } 
  AsyncDisk.InternalStep.id(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#162#0#0, a#162#1#0))
     == a#162#0#0);

// Constructor injectivity
axiom (forall a#163#0#0: int, a#163#1#0: int :: 
  { #AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#163#0#0, a#163#1#0) } 
  AsyncDisk.InternalStep.id_k(#AsyncDisk.InternalStep.HavocConflictingWriteReadStep(a#163#0#0, a#163#1#0))
     == a#163#1#0);

// Depth-one case-split function
function $IsA#AsyncDisk.InternalStep(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#AsyncDisk.InternalStep(d) } 
  $IsA#AsyncDisk.InternalStep(d)
     ==> AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
       || AsyncDisk.InternalStep.ProcessWriteStep_q(d)
       || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
       || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d), $Is(d, Tclass.AsyncDisk.InternalStep()) } 
    { AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d), $Is(d, Tclass.AsyncDisk.InternalStep()) } 
    { AsyncDisk.InternalStep.ProcessWriteStep_q(d), $Is(d, Tclass.AsyncDisk.InternalStep()) } 
    { AsyncDisk.InternalStep.ProcessReadFailureStep_q(d), $Is(d, Tclass.AsyncDisk.InternalStep()) } 
  $Is(d, Tclass.AsyncDisk.InternalStep())
     ==> AsyncDisk.InternalStep.ProcessReadFailureStep_q(d)
       || AsyncDisk.InternalStep.ProcessWriteStep_q(d)
       || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(d)
       || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(d));

// Datatype extensional equality declaration
function AsyncDisk.InternalStep#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #AsyncDisk.InternalStep.ProcessReadFailureStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.ProcessReadFailureStep_q(a) } 
    { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.ProcessReadFailureStep_q(b) } 
  AsyncDisk.InternalStep.ProcessReadFailureStep_q(a)
       && AsyncDisk.InternalStep.ProcessReadFailureStep_q(b)
     ==> (AsyncDisk.InternalStep#Equal(a, b)
       <==> AsyncDisk.InternalStep.id(a) == AsyncDisk.InternalStep.id(b)
         && Seq#Equal(AsyncDisk.InternalStep.fakeContents(a), AsyncDisk.InternalStep.fakeContents(b))));

// Datatype extensional equality definition: #AsyncDisk.InternalStep.ProcessWriteStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.ProcessWriteStep_q(a) } 
    { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.ProcessWriteStep_q(b) } 
  AsyncDisk.InternalStep.ProcessWriteStep_q(a)
       && AsyncDisk.InternalStep.ProcessWriteStep_q(b)
     ==> (AsyncDisk.InternalStep#Equal(a, b)
       <==> AsyncDisk.InternalStep.id(a) == AsyncDisk.InternalStep.id(b)));

// Datatype extensional equality definition: #AsyncDisk.InternalStep.HavocConflictingWritesStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.HavocConflictingWritesStep_q(a) } 
    { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.HavocConflictingWritesStep_q(b) } 
  AsyncDisk.InternalStep.HavocConflictingWritesStep_q(a)
       && AsyncDisk.InternalStep.HavocConflictingWritesStep_q(b)
     ==> (AsyncDisk.InternalStep#Equal(a, b)
       <==> AsyncDisk.InternalStep.id(a) == AsyncDisk.InternalStep.id(b)
         && AsyncDisk.InternalStep.id_k(a) == AsyncDisk.InternalStep.id_k(b)));

// Datatype extensional equality definition: #AsyncDisk.InternalStep.HavocConflictingWriteReadStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(a) } 
    { AsyncDisk.InternalStep#Equal(a, b), AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(b) } 
  AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(a)
       && AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(b)
     ==> (AsyncDisk.InternalStep#Equal(a, b)
       <==> AsyncDisk.InternalStep.id(a) == AsyncDisk.InternalStep.id(b)
         && AsyncDisk.InternalStep.id_k(a) == AsyncDisk.InternalStep.id_k(b)));

// Datatype extensionality axiom: AsyncDisk.InternalStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { AsyncDisk.InternalStep#Equal(a, b) } 
  AsyncDisk.InternalStep#Equal(a, b) <==> a == b);

const unique class.AsyncDisk.InternalStep: ClassName;

const unique class.AsyncDisk.__default: ClassName;

function Tclass.AsyncDisk.__default() : Ty;

// Tclass.AsyncDisk.__default Tag
axiom Tag(Tclass.AsyncDisk.__default()) == Tagclass.AsyncDisk.__default;

const unique Tagclass.AsyncDisk.__default: TyTag;

// Box/unbox axiom for Tclass.AsyncDisk.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.AsyncDisk.__default()) } 
  $IsBox(bx, Tclass.AsyncDisk.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.AsyncDisk.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.AsyncDisk.__default()) } 
  $Is($o, Tclass.AsyncDisk.__default())
     <==> $o == null || dtype($o) == Tclass.AsyncDisk.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.AsyncDisk.__default(), $h) } 
  $IsAlloc($o, Tclass.AsyncDisk.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for AsyncDisk._default.Init
function AsyncDisk.__default.Init(k#0: DatatypeType, s#0: DatatypeType) : bool;

function AsyncDisk.__default.Init#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for AsyncDisk.__default.Init
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { AsyncDisk.__default.Init(k#0, s#0) } 
    AsyncDisk.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables()))
       ==> true);

function AsyncDisk.__default.Init#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.Init
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { AsyncDisk.__default.Init#requires(k#0, s#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants()) && $Is(s#0, Tclass.AsyncDisk.Variables())
     ==> AsyncDisk.__default.Init#requires(k#0, s#0) == true);

// definition axiom for AsyncDisk.__default.Init(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { AsyncDisk.__default.Init(k#0, s#0) } 
    AsyncDisk.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables()))
       ==> AsyncDisk.Variables.Variables_q(s#0)
         && (Map#Equal(AsyncDisk.Variables.reqReads(s#0), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Equal(AsyncDisk.Variables.reqWrites(s#0), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Equal(AsyncDisk.Variables.respReads(s#0), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && AsyncDisk.__default.Init(k#0, s#0)
           == (
            Map#Equal(AsyncDisk.Variables.reqReads(s#0), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.reqWrites(s#0), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.respReads(s#0), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.respWrites(s#0), Map#Empty(): Map Box Box)));

// definition axiom for AsyncDisk.__default.Init for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.Init(Lit(k#0), Lit(s#0)) } 
    AsyncDisk.__default.Init#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables()))
       ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
         && (Map#Equal(AsyncDisk.Variables.reqReads(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Equal(AsyncDisk.Variables.reqWrites(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Equal(AsyncDisk.Variables.respReads(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && AsyncDisk.__default.Init(Lit(k#0), Lit(s#0))
           == (
            Map#Equal(AsyncDisk.Variables.reqReads(Lit(s#0)), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.reqWrites(Lit(s#0)), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.respReads(Lit(s#0)), Map#Empty(): Map Box Box)
             && Map#Equal(AsyncDisk.Variables.respWrites(Lit(s#0)), Map#Empty(): Map Box Box)));

// function declaration for AsyncDisk._default.RecvRead
function AsyncDisk.__default.RecvRead(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.RecvRead#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.RecvRead
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvRead(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvRead#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.RecvRead#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.RecvRead
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.RecvRead#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.RecvRead#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.RecvRead(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvRead(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvRead#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.ReqReadOp_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqReads#0#0 := Map#Build(AsyncDisk.Variables.reqReads(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqRead(dop#0))); 
                  #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.RecvRead(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.ReqReadOp_q(dop#0)
             && !Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqReads#0#0 := Map#Build(AsyncDisk.Variables.reqReads(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqRead(dop#0))); 
                  #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.RecvRead for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.RecvRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.RecvRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.ReqReadOp_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.respReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqReads#0#1 := Map#Build(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqRead(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.RecvRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.ReqReadOp_q(Lit(dop#0))
             && !Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.respReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqReads#0#1 := Map#Build(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqRead(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.RecvWrite
function AsyncDisk.__default.RecvWrite(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.RecvWrite#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.RecvWrite
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvWrite(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvWrite#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.RecvWrite#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.RecvWrite
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.RecvWrite#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.RecvWrite#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.RecvWrite(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvWrite(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvWrite#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.ReqWriteOp_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqWrites#0#0 := Map#Build(AsyncDisk.Variables.reqWrites(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqWrite(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    dt_update#reqWrites#0#0, 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.RecvWrite(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.ReqWriteOp_q(dop#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqWrites#0#0 := Map#Build(AsyncDisk.Variables.reqWrites(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqWrite(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    dt_update#reqWrites#0#0, 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.RecvWrite for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.RecvWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.RecvWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.ReqWriteOp_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqWrite(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    dt_update#reqWrites#0#1, 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.RecvWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.ReqWriteOp_q(Lit(dop#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqWrite(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    dt_update#reqWrites#0#1, 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.RecvWrite2
function AsyncDisk.__default.RecvWrite2(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.RecvWrite2#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.RecvWrite2
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvWrite2(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvWrite2#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.RecvWrite2#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.RecvWrite2
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.RecvWrite2#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.RecvWrite2#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.RecvWrite2(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.RecvWrite2(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.RecvWrite2#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.ReqWrite2Op_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id1(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id1(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id2(dop#0))]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.DiskOp.id1(dop#0) != AsyncDisk.DiskOp.id2(dop#0)
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqWrites#0#0 := Map#Build(Map#Build(AsyncDisk.Variables.reqWrites(s#0), 
                        $Box(AsyncDisk.DiskOp.id1(dop#0)), 
                        $Box(AsyncDisk.DiskOp.reqWrite1(dop#0))), 
                      $Box(AsyncDisk.DiskOp.id2(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqWrite2(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    dt_update#reqWrites#0#0, 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.RecvWrite2(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.ReqWrite2Op_q(dop#0)
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id1(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id1(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(AsyncDisk.DiskOp.id2(dop#0))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id2(dop#0))]
             && AsyncDisk.DiskOp.id1(dop#0) != AsyncDisk.DiskOp.id2(dop#0)
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#reqWrites#0#0 := Map#Build(Map#Build(AsyncDisk.Variables.reqWrites(s#0), 
                        $Box(AsyncDisk.DiskOp.id1(dop#0)), 
                        $Box(AsyncDisk.DiskOp.reqWrite1(dop#0))), 
                      $Box(AsyncDisk.DiskOp.id2(dop#0)), 
                      $Box(AsyncDisk.DiskOp.reqWrite2(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    dt_update#reqWrites#0#0, 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.RecvWrite2 for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.RecvWrite2(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.RecvWrite2#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.ReqWrite2Op_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id1(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id1(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id2(Lit(dop#0)))]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (Lit(AsyncDisk.DiskOp.id1(Lit(dop#0)) != AsyncDisk.DiskOp.id2(Lit(dop#0)))
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqWrites#0#1 := Map#Build(Map#Build(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                        $Box(LitInt(AsyncDisk.DiskOp.id1(Lit(dop#0)))), 
                        $Box(Lit(AsyncDisk.DiskOp.reqWrite1(Lit(dop#0))))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id2(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqWrite2(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    dt_update#reqWrites#0#1, 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.RecvWrite2(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.ReqWrite2Op_q(Lit(dop#0))
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id1(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id1(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id2(Lit(dop#0)))]
             && !Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id2(Lit(dop#0)))]
             && AsyncDisk.DiskOp.id1(Lit(dop#0)) != AsyncDisk.DiskOp.id2(Lit(dop#0))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#reqWrites#0#1 := Map#Build(Map#Build(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                        $Box(LitInt(AsyncDisk.DiskOp.id1(Lit(dop#0)))), 
                        $Box(Lit(AsyncDisk.DiskOp.reqWrite1(Lit(dop#0))))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id2(Lit(dop#0)))), 
                      $Box(Lit(AsyncDisk.DiskOp.reqWrite2(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    dt_update#reqWrites#0#1, 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.AckRead
function AsyncDisk.__default.AckRead(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.AckRead#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.AckRead
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.AckRead(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.AckRead#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.AckRead#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.AckRead
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.AckRead#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.AckRead#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.AckRead(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.AckRead(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.AckRead#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.RespReadOp_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> $IsA#AsyncDisk.RespRead($Unbox(Map#Elements(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType)
             && $IsA#AsyncDisk.RespRead(AsyncDisk.DiskOp.respRead(dop#0))
             && AsyncDisk.Variables.Variables_q(s#0))
         && ($IsA#AsyncDisk.RespRead($Unbox(Map#Elements(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType)
             && $IsA#AsyncDisk.RespRead(AsyncDisk.DiskOp.respRead(dop#0))
             && AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.RespRead#Equal($Unbox(Map#Elements(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType, 
              AsyncDisk.DiskOp.respRead(dop#0))
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#respReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespRead(), 
                      StartFuel_Maps._default.MapRemove1, 
                      AsyncDisk.Variables.respReads(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    dt_update#respReads#0#0, 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.AsyncDisk.RespRead(), 
                  AsyncDisk.Variables.respReads(s#0), 
                  $Box(AsyncDisk.DiskOp.id(dop#0)))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.AckRead(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.RespReadOp_q(dop#0)
             && Map#Domain(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && AsyncDisk.RespRead#Equal($Unbox(Map#Elements(AsyncDisk.Variables.respReads(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType, 
              AsyncDisk.DiskOp.respRead(dop#0))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#respReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespRead(), 
                      StartFuel_Maps._default.MapRemove1, 
                      AsyncDisk.Variables.respReads(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    dt_update#respReads#0#0, 
                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.AckRead for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.AckRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.AckRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.RespReadOp_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.respReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#AsyncDisk.RespRead($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respReads(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType)
             && $IsA#AsyncDisk.RespRead(Lit(AsyncDisk.DiskOp.respRead(Lit(dop#0))))
             && AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && ($IsA#AsyncDisk.RespRead($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respReads(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType)
             && $IsA#AsyncDisk.RespRead(Lit(AsyncDisk.DiskOp.respRead(Lit(dop#0))))
             && AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.RespRead#Equal($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respReads(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType, 
              AsyncDisk.DiskOp.respRead(Lit(dop#0)))
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#respReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespRead(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    dt_update#respReads#0#1, 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.AsyncDisk.RespRead(), 
                  Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                  $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.AckRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.RespReadOp_q(Lit(dop#0))
             && Map#Domain(AsyncDisk.Variables.respReads(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && AsyncDisk.RespRead#Equal($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respReads(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType, 
              AsyncDisk.DiskOp.respRead(Lit(dop#0)))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#respReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespRead(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    dt_update#respReads#0#1, 
                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.AckWrite
function AsyncDisk.__default.AckWrite(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.AckWrite#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.AckWrite
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.AckWrite(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.AckWrite#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.AckWrite#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.AckWrite
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.AckWrite#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.AckWrite#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.AckWrite(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.AckWrite(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.AckWrite#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.RespWriteOp_q(dop#0) ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
           ==> $IsA#AsyncDisk.RespWrite($Unbox(Map#Elements(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType)
             && $IsA#AsyncDisk.RespWrite(AsyncDisk.DiskOp.respWrite(dop#0))
             && AsyncDisk.Variables.Variables_q(s#0))
         && ($IsA#AsyncDisk.RespWrite($Unbox(Map#Elements(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType)
             && $IsA#AsyncDisk.RespWrite(AsyncDisk.DiskOp.respWrite(dop#0))
             && AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.RespWrite#Equal($Unbox(Map#Elements(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType, 
              AsyncDisk.DiskOp.respWrite(dop#0))
           ==> $IsA#AsyncDisk.Variables(s'#0)
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#respWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      AsyncDisk.Variables.respWrites(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    dt_update#respWrites#0#0, 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              AsyncDisk.Variables.Variables_q(s#0)
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.AsyncDisk.RespWrite(), 
                  AsyncDisk.Variables.respWrites(s#0), 
                  $Box(AsyncDisk.DiskOp.id(dop#0)))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && AsyncDisk.__default.AckWrite(k#0, s#0, s'#0, dop#0)
           == (
            AsyncDisk.DiskOp.RespWriteOp_q(dop#0)
             && Map#Domain(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]
             && AsyncDisk.RespWrite#Equal($Unbox(Map#Elements(AsyncDisk.Variables.respWrites(s#0))[$Box(AsyncDisk.DiskOp.id(dop#0))]): DatatypeType, 
              AsyncDisk.DiskOp.respWrite(dop#0))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#respWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      AsyncDisk.Variables.respWrites(s#0), 
                      $Box(AsyncDisk.DiskOp.id(dop#0))); 
                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                    dt_update#respWrites#0#0, 
                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))))));

// definition axiom for AsyncDisk.__default.AckWrite for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.AckWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.AckWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.RespWriteOp_q(Lit(dop#0)))
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#AsyncDisk.RespWrite($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType)
             && $IsA#AsyncDisk.RespWrite(Lit(AsyncDisk.DiskOp.respWrite(Lit(dop#0))))
             && AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && ($IsA#AsyncDisk.RespWrite($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType)
             && $IsA#AsyncDisk.RespWrite(Lit(AsyncDisk.DiskOp.respWrite(Lit(dop#0))))
             && AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.RespWrite#Equal($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType, 
              AsyncDisk.DiskOp.respWrite(Lit(dop#0)))
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
             && $IsA#AsyncDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#respWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    dt_update#respWrites#0#1, 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              AsyncDisk.Variables.Variables_q(Lit(s#0))
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.AsyncDisk.RespWrite(), 
                  Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                  $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0)))))
                 && 
                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && AsyncDisk.__default.AckWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            AsyncDisk.DiskOp.RespWriteOp_q(Lit(dop#0))
             && Map#Domain(AsyncDisk.Variables.respWrites(Lit(s#0)))[$Box(AsyncDisk.DiskOp.id(Lit(dop#0)))]
             && AsyncDisk.RespWrite#Equal($Unbox(Map#Elements(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))))[$Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType, 
              AsyncDisk.DiskOp.respWrite(Lit(dop#0)))
             && AsyncDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#respWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.AsyncDisk.RespWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                      $Box(LitInt(AsyncDisk.DiskOp.id(Lit(dop#0))))); 
                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                    dt_update#respWrites#0#1, 
                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))))));

// function declaration for AsyncDisk._default.Stutter
function AsyncDisk.__default.Stutter(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.Stutter#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.Stutter
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.Stutter(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.Stutter#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.Stutter
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.Stutter#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.Stutter#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.Stutter(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.Stutter(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (AsyncDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> $IsA#AsyncDisk.Variables(s'#0) && $IsA#AsyncDisk.Variables(s#0))
         && AsyncDisk.__default.Stutter(k#0, s#0, s'#0, dop#0)
           == (AsyncDisk.DiskOp.NoDiskOp_q(dop#0) && AsyncDisk.Variables#Equal(s'#0, s#0)));

// definition axiom for AsyncDisk.__default.Stutter for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (Lit(AsyncDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> $IsA#AsyncDisk.Variables(Lit(s'#0)) && $IsA#AsyncDisk.Variables(Lit(s#0)))
         && AsyncDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (AsyncDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && AsyncDisk.Variables#Equal(s'#0, s#0)));

// function declaration for AsyncDisk._default.NextStep
function AsyncDisk.__default.NextStep(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

function AsyncDisk.__default.NextStep#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.NextStep
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0) } 
    AsyncDisk.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, step#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
           && $Is(step#0, Tclass.AsyncDisk.Step()))
       ==> true);

function AsyncDisk.__default.NextStep#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.NextStep
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    step#0: DatatypeType :: 
  { AsyncDisk.__default.NextStep#requires(k#0, s#0, s'#0, dop#0, step#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
       && $Is(step#0, Tclass.AsyncDisk.Step())
     ==> AsyncDisk.__default.NextStep#requires(k#0, s#0, s'#0, dop#0, step#0) == true);

// definition axiom for AsyncDisk.__default.NextStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0) } 
    AsyncDisk.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, step#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
           && $Is(step#0, Tclass.AsyncDisk.Step()))
       ==> (AsyncDisk.Step.RecvReadStep_q(step#0)
           ==> AsyncDisk.__default.RecvRead#canCall(k#0, s#0, s'#0, dop#0))
         && (!AsyncDisk.Step.RecvReadStep_q(step#0)
           ==> (AsyncDisk.Step.RecvWriteStep_q(step#0)
               ==> AsyncDisk.__default.RecvWrite#canCall(k#0, s#0, s'#0, dop#0))
             && (!AsyncDisk.Step.RecvWriteStep_q(step#0)
               ==> (AsyncDisk.Step.RecvWrite2Step_q(step#0)
                   ==> AsyncDisk.__default.RecvWrite2#canCall(k#0, s#0, s'#0, dop#0))
                 && (!AsyncDisk.Step.RecvWrite2Step_q(step#0)
                   ==> (AsyncDisk.Step.AckReadStep_q(step#0)
                       ==> AsyncDisk.__default.AckRead#canCall(k#0, s#0, s'#0, dop#0))
                     && (!AsyncDisk.Step.AckReadStep_q(step#0)
                       ==> (AsyncDisk.Step.AckWriteStep_q(step#0)
                           ==> AsyncDisk.__default.AckWrite#canCall(k#0, s#0, s'#0, dop#0))
                         && (!AsyncDisk.Step.AckWriteStep_q(step#0)
                           ==> AsyncDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0))))))
         && AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0)
           == (if AsyncDisk.Step.RecvReadStep_q(step#0)
             then AsyncDisk.__default.RecvRead(k#0, s#0, s'#0, dop#0)
             else (if AsyncDisk.Step.RecvWriteStep_q(step#0)
               then AsyncDisk.__default.RecvWrite(k#0, s#0, s'#0, dop#0)
               else (if AsyncDisk.Step.RecvWrite2Step_q(step#0)
                 then AsyncDisk.__default.RecvWrite2(k#0, s#0, s'#0, dop#0)
                 else (if AsyncDisk.Step.AckReadStep_q(step#0)
                   then AsyncDisk.__default.AckRead(k#0, s#0, s'#0, dop#0)
                   else (if AsyncDisk.Step.AckWriteStep_q(step#0)
                     then AsyncDisk.__default.AckWrite(k#0, s#0, s'#0, dop#0)
                     else AsyncDisk.__default.Stutter(k#0, s#0, s'#0, dop#0)))))));

// definition axiom for AsyncDisk.__default.NextStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      step#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(step#0)) } 
    AsyncDisk.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(step#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
           && $Is(step#0, Tclass.AsyncDisk.Step()))
       ==> (Lit(AsyncDisk.Step.RecvReadStep_q(Lit(step#0)))
           ==> AsyncDisk.__default.RecvRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && (!Lit(AsyncDisk.Step.RecvReadStep_q(Lit(step#0)))
           ==> (Lit(AsyncDisk.Step.RecvWriteStep_q(Lit(step#0)))
               ==> AsyncDisk.__default.RecvWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && (!Lit(AsyncDisk.Step.RecvWriteStep_q(Lit(step#0)))
               ==> (Lit(AsyncDisk.Step.RecvWrite2Step_q(Lit(step#0)))
                   ==> AsyncDisk.__default.RecvWrite2#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
                 && (!Lit(AsyncDisk.Step.RecvWrite2Step_q(Lit(step#0)))
                   ==> (Lit(AsyncDisk.Step.AckReadStep_q(Lit(step#0)))
                       ==> AsyncDisk.__default.AckRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
                     && (!Lit(AsyncDisk.Step.AckReadStep_q(Lit(step#0)))
                       ==> (Lit(AsyncDisk.Step.AckWriteStep_q(Lit(step#0)))
                           ==> AsyncDisk.__default.AckWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
                         && (!Lit(AsyncDisk.Step.AckWriteStep_q(Lit(step#0)))
                           ==> AsyncDisk.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))))))
         && AsyncDisk.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(step#0))
           == (if AsyncDisk.Step.RecvReadStep_q(Lit(step#0))
             then AsyncDisk.__default.RecvRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
             else (if AsyncDisk.Step.RecvWriteStep_q(Lit(step#0))
               then AsyncDisk.__default.RecvWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
               else (if AsyncDisk.Step.RecvWrite2Step_q(Lit(step#0))
                 then AsyncDisk.__default.RecvWrite2(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
                 else (if AsyncDisk.Step.AckReadStep_q(Lit(step#0))
                   then AsyncDisk.__default.AckRead(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
                   else (if AsyncDisk.Step.AckWriteStep_q(Lit(step#0))
                     then AsyncDisk.__default.AckWrite(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
                     else AsyncDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))))))));

// function declaration for AsyncDisk._default.Next
function AsyncDisk.__default.Next(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function AsyncDisk.__default.Next#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.Next
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.Next(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.Next#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> true);

function AsyncDisk.__default.Next#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.Next
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { AsyncDisk.__default.Next#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(dop#0, Tclass.AsyncDisk.DiskOp())
     ==> AsyncDisk.__default.Next#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for AsyncDisk.__default.Next(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { AsyncDisk.__default.Next(k#0, s#0, s'#0, dop#0) } 
    AsyncDisk.__default.Next#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (forall step#0: DatatypeType :: 
          { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0) } 
          $Is(step#0, Tclass.AsyncDisk.Step())
             ==> AsyncDisk.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, step#0))
         && AsyncDisk.__default.Next(k#0, s#0, s'#0, dop#0)
           == (exists step#0: DatatypeType :: 
            { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0) } 
            $Is(step#0, Tclass.AsyncDisk.Step())
               && AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#0)));

// definition axiom for AsyncDisk.__default.Next for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    AsyncDisk.__default.Next#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(dop#0, Tclass.AsyncDisk.DiskOp()))
       ==> (forall step#1: DatatypeType :: 
          { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#1) } 
          $Is(step#1, Tclass.AsyncDisk.Step())
             ==> AsyncDisk.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), step#1))
         && AsyncDisk.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (exists step#1: DatatypeType :: 
            { AsyncDisk.__default.NextStep(k#0, s#0, s'#0, dop#0, step#1) } 
            $Is(step#1, Tclass.AsyncDisk.Step())
               && AsyncDisk.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), step#1)));

// function declaration for AsyncDisk._default.ChecksumChecksOut
function AsyncDisk.__default.ChecksumChecksOut($ly: LayerType, s#0: Seq Box) : bool;

function AsyncDisk.__default.ChecksumChecksOut#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { AsyncDisk.__default.ChecksumChecksOut($LS($ly), s#0) } 
  AsyncDisk.__default.ChecksumChecksOut($LS($ly), s#0)
     == AsyncDisk.__default.ChecksumChecksOut($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { AsyncDisk.__default.ChecksumChecksOut(AsFuelBottom($ly), s#0) } 
  AsyncDisk.__default.ChecksumChecksOut($ly, s#0)
     == AsyncDisk.__default.ChecksumChecksOut($LZ, s#0));

// consequence axiom for AsyncDisk.__default.ChecksumChecksOut
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { AsyncDisk.__default.ChecksumChecksOut($ly, s#0) } 
    AsyncDisk.__default.ChecksumChecksOut#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function AsyncDisk.__default.ChecksumChecksOut#requires(LayerType, Seq Box) : bool;

// #requires axiom for AsyncDisk.__default.ChecksumChecksOut
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { AsyncDisk.__default.ChecksumChecksOut#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.ChecksumChecksOut#requires($ly, s#0) == true);

// definition axiom for AsyncDisk.__default.ChecksumChecksOut(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { AsyncDisk.__default.ChecksumChecksOut($LS($ly), s#0) } 
    AsyncDisk.__default.ChecksumChecksOut#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(s#0) >= LitInt(32)
           ==> Crypto.__default.Crc32C#canCall(Seq#Drop(s#0, LitInt(32))))
         && AsyncDisk.__default.ChecksumChecksOut($LS($ly), s#0)
           == (Seq#Length(s#0) >= LitInt(32)
             && Seq#Equal(Seq#Drop(Seq#Take(s#0, LitInt(32)), LitInt(0)), 
              Crypto.__default.Crc32C(Seq#Drop(s#0, LitInt(32))))));

// definition axiom for AsyncDisk.__default.ChecksumChecksOut for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { AsyncDisk.__default.ChecksumChecksOut($LS($ly), Lit(s#0)) } 
    AsyncDisk.__default.ChecksumChecksOut#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(Lit(s#0)) >= LitInt(32)
           ==> Crypto.__default.Crc32C#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(32)))))
         && AsyncDisk.__default.ChecksumChecksOut($LS($ly), Lit(s#0))
           == (Seq#Length(Lit(s#0)) >= LitInt(32)
             && Seq#Equal(Seq#Drop(Seq#Take(Lit(s#0), LitInt(32)), LitInt(0)), 
              Crypto.__default.Crc32C(Lit(Seq#Drop(Lit(s#0), LitInt(32)))))));

// function declaration for AsyncDisk._default.ChecksumsCheckOutForSlice
function AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int) : bool;

function AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int) : bool;

// consequence axiom for AsyncDisk.__default.ChecksumsCheckOutForSlice
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int :: 
    { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0) } 
    AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(realContents#0, fakeContents#0, i#0, j#0)
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(realContents#0) == Seq#Length(fakeContents#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= j#0
           && j#0 <= Seq#Length(realContents#0))
       ==> true);

function AsyncDisk.__default.ChecksumsCheckOutForSlice#requires(Seq Box, Seq Box, int, int) : bool;

// #requires axiom for AsyncDisk.__default.ChecksumsCheckOutForSlice
axiom (forall realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int :: 
  { AsyncDisk.__default.ChecksumsCheckOutForSlice#requires(realContents#0, fakeContents#0, i#0, j#0) } 
  $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.ChecksumsCheckOutForSlice#requires(realContents#0, fakeContents#0, i#0, j#0)
       == (Seq#Length(realContents#0) == Seq#Length(fakeContents#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= j#0
         && j#0 <= Seq#Length(realContents#0)));

// definition axiom for AsyncDisk.__default.ChecksumsCheckOutForSlice(revealed)
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int :: 
    { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0) } 
    AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(realContents#0, fakeContents#0, i#0, j#0)
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(realContents#0) == Seq#Length(fakeContents#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= j#0
           && j#0 <= Seq#Length(realContents#0))
       ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Seq#Drop(Seq#Take(realContents#0, j#0), i#0))
         && (AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
            Seq#Drop(Seq#Take(realContents#0, j#0), i#0))
           ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Seq#Drop(Seq#Take(fakeContents#0, j#0), i#0)))
         && AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0)
           == (AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
                Seq#Drop(Seq#Take(realContents#0, j#0), i#0))
               && AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
                Seq#Drop(Seq#Take(fakeContents#0, j#0), i#0))
             ==> Seq#Equal(Seq#Drop(Seq#Take(realContents#0, j#0), i#0), 
              Seq#Drop(Seq#Take(fakeContents#0, j#0), i#0))));

// definition axiom for AsyncDisk.__default.ChecksumsCheckOutForSlice for all literals(revealed)
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box, i#0: int, j#0: int :: 
    {:weight 3} { AsyncDisk.__default.ChecksumsCheckOutForSlice(Lit(realContents#0), Lit(fakeContents#0), LitInt(i#0), LitInt(j#0)) } 
    AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(Lit(realContents#0), Lit(fakeContents#0), LitInt(i#0), LitInt(j#0))
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Seq#Length(Lit(realContents#0)) == Seq#Length(Lit(fakeContents#0))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(j#0)
           && LitInt(j#0) <= Seq#Length(Lit(realContents#0)))
       ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Lit(Seq#Drop(Seq#Take(Lit(realContents#0), LitInt(j#0)), LitInt(i#0))))
         && (AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
            Lit(Seq#Drop(Seq#Take(Lit(realContents#0), LitInt(j#0)), LitInt(i#0))))
           ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Lit(Seq#Drop(Seq#Take(Lit(fakeContents#0), LitInt(j#0)), LitInt(i#0)))))
         && AsyncDisk.__default.ChecksumsCheckOutForSlice(Lit(realContents#0), Lit(fakeContents#0), LitInt(i#0), LitInt(j#0))
           == (AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
                Lit(Seq#Drop(Seq#Take(Lit(realContents#0), LitInt(j#0)), LitInt(i#0))))
               && AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, 
                Lit(Seq#Drop(Seq#Take(Lit(fakeContents#0), LitInt(j#0)), LitInt(i#0))))
             ==> Seq#Equal(Seq#Drop(Seq#Take(Lit(realContents#0), LitInt(j#0)), LitInt(i#0)), 
              Seq#Drop(Seq#Take(Lit(fakeContents#0), LitInt(j#0)), LitInt(i#0)))));

// function declaration for AsyncDisk._default.AllChecksumsCheckOut
function AsyncDisk.__default.AllChecksumsCheckOut(realContents#0: Seq Box, fakeContents#0: Seq Box) : bool;

function AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0: Seq Box, fakeContents#0: Seq Box) : bool;

// consequence axiom for AsyncDisk.__default.AllChecksumsCheckOut
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box :: 
    { AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0) } 
    AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0, fakeContents#0)
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(realContents#0) == Seq#Length(fakeContents#0))
       ==> true);

function AsyncDisk.__default.AllChecksumsCheckOut#requires(Seq Box, Seq Box) : bool;

// #requires axiom for AsyncDisk.__default.AllChecksumsCheckOut
axiom (forall realContents#0: Seq Box, fakeContents#0: Seq Box :: 
  { AsyncDisk.__default.AllChecksumsCheckOut#requires(realContents#0, fakeContents#0) } 
  $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.AllChecksumsCheckOut#requires(realContents#0, fakeContents#0)
       == 
      (Seq#Length(realContents#0)
       == Seq#Length(fakeContents#0)));

// definition axiom for AsyncDisk.__default.AllChecksumsCheckOut(revealed)
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box :: 
    { AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0) } 
    AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0, fakeContents#0)
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(realContents#0) == Seq#Length(fakeContents#0))
       ==> (forall i#0: int, j#0: int :: 
          { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0) } 
          LitInt(0) <= i#0 && i#0 <= j#0 && j#0 <= Seq#Length(realContents#0)
             ==> AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(realContents#0, fakeContents#0, i#0, j#0))
         && AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0)
           == (forall i#0: int, j#0: int :: 
            { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0) } 
            LitInt(0) <= i#0 && i#0 <= j#0 && j#0 <= Seq#Length(realContents#0)
               ==> AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#0, j#0)));

// definition axiom for AsyncDisk.__default.AllChecksumsCheckOut for all literals(revealed)
axiom true
   ==> (forall realContents#0: Seq Box, fakeContents#0: Seq Box :: 
    {:weight 3} { AsyncDisk.__default.AllChecksumsCheckOut(Lit(realContents#0), Lit(fakeContents#0)) } 
    AsyncDisk.__default.AllChecksumsCheckOut#canCall(Lit(realContents#0), Lit(fakeContents#0))
         || (
          $Is(realContents#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(realContents#0)) == Seq#Length(Lit(fakeContents#0)))
       ==> (forall i#1: int, j#1: int :: 
          { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#1, j#1) } 
          LitInt(0) <= i#1 && i#1 <= j#1 && j#1 <= Seq#Length(Lit(realContents#0))
             ==> AsyncDisk.__default.ChecksumsCheckOutForSlice#canCall(Lit(realContents#0), Lit(fakeContents#0), i#1, j#1))
         && AsyncDisk.__default.AllChecksumsCheckOut(Lit(realContents#0), Lit(fakeContents#0))
           == (forall i#1: int, j#1: int :: 
            { AsyncDisk.__default.ChecksumsCheckOutForSlice(realContents#0, fakeContents#0, i#1, j#1) } 
            LitInt(0) <= i#1 && i#1 <= j#1 && j#1 <= Seq#Length(Lit(realContents#0))
               ==> AsyncDisk.__default.ChecksumsCheckOutForSlice(Lit(realContents#0), Lit(fakeContents#0), i#1, j#1)));

// function declaration for AsyncDisk._default.ProcessReadFailure
function AsyncDisk.__default.ProcessReadFailure(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    id#0: int, 
    fakeContents#0: Seq Box)
   : bool;

function AsyncDisk.__default.ProcessReadFailure#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    id#0: int, 
    fakeContents#0: Seq Box)
   : bool;

// consequence axiom for AsyncDisk.__default.ProcessReadFailure
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      id#0: int, 
      fakeContents#0: Seq Box :: 
    { AsyncDisk.__default.ProcessReadFailure(k#0, s#0, s'#0, id#0, fakeContents#0) } 
    AsyncDisk.__default.ProcessReadFailure#canCall(k#0, s#0, s'#0, id#0, fakeContents#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function AsyncDisk.__default.ProcessReadFailure#requires(DatatypeType, DatatypeType, DatatypeType, int, Seq Box) : bool;

// #requires axiom for AsyncDisk.__default.ProcessReadFailure
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    id#0: int, 
    fakeContents#0: Seq Box :: 
  { AsyncDisk.__default.ProcessReadFailure#requires(k#0, s#0, s'#0, id#0, fakeContents#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
       && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.ProcessReadFailure#requires(k#0, s#0, s'#0, id#0, fakeContents#0)
       == true);

// definition axiom for AsyncDisk.__default.ProcessReadFailure(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      id#0: int, 
      fakeContents#0: Seq Box :: 
    { AsyncDisk.__default.ProcessReadFailure(k#0, s#0, s'#0, id#0, fakeContents#0) } 
    AsyncDisk.__default.ProcessReadFailure#canCall(k#0, s#0, s'#0, id#0, fakeContents#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte())))
       ==> AsyncDisk.Variables.Variables_q(s#0)
         && (Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0)
             && (var req#0 := $Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id#0)]): DatatypeType; 
              AsyncDisk.ReqRead.ReqRead_q(req#0)
                 && (LitInt(0) <= AsyncDisk.ReqRead.addr(req#0)
                   ==> AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0))
                 && (AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.addr(req#0)
                       <= AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)
                   ==> AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.Variables.Variables_q(s#0))
                 && (AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.Variables.Variables_q(s#0)
                     && AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)
                       <= Seq#Length(AsyncDisk.Variables.contents(s#0))
                   ==> AsyncDisk.Variables.Variables_q(s#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && AsyncDisk.ReqRead.ReqRead_q(req#0)
                     && (var realContents#0 := Seq#Drop(Seq#Take(AsyncDisk.Variables.contents(s#0), 
                            AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)), 
                          AsyncDisk.ReqRead.addr(req#0)); 
                      (!Seq#Equal(fakeContents#0, realContents#0)
                           ==> AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0, fakeContents#0))
                         && (AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#0, fakeContents#0)
                             && AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0)
                           ==> $IsA#AsyncDisk.Variables(s'#0)
                             && $IsA#AsyncDisk.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                    (var dt_update#reqReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                          Tclass.AsyncDisk.ReqRead(), 
                                          StartFuel_Maps._default.MapRemove1, 
                                          AsyncDisk.Variables.reqReads(s#0), 
                                          $Box(id#0)); 
                                      #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                                        AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                                        AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                        AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                        AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                                (var dt_update#respReads#0#0 := Map#Build(AsyncDisk.Variables.respReads(s#0), 
                                      $Box(id#0), 
                                      $Box(#AsyncDisk.RespRead.RespRead(AsyncDisk.ReqRead.addr(req#0), fakeContents#0))); 
                                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                                    AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                                    dt_update#respReads#0#0, 
                                    AsyncDisk.Variables.respWrites(dt_update_tmp#1#0), 
                                    AsyncDisk.Variables.contents(dt_update_tmp#1#0)))))
                             && 
                            (var dt_update_tmp#0#0 := s#0; 
                              AsyncDisk.Variables.Variables_q(s#0)
                                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqRead(), 
                                  AsyncDisk.Variables.reqReads(s#0), 
                                  $Box(id#0))
                                 && 
                                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0))
                             && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                  (var dt_update#reqReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                        Tclass.AsyncDisk.ReqRead(), 
                                        StartFuel_Maps._default.MapRemove1, 
                                        AsyncDisk.Variables.reqReads(s#0), 
                                        $Box(id#0)); 
                                    #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                                      AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                                      AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                      AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                      AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                              AsyncDisk.Variables.Variables_q(s#0)
                                 && AsyncDisk.ReqRead.ReqRead_q(req#0)
                                 && 
                                AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)))))))
         && AsyncDisk.__default.ProcessReadFailure(k#0, s#0, s'#0, id#0, fakeContents#0)
           == (Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(id#0)]
             && (var req#0 := $Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id#0)]): DatatypeType; 
              LitInt(0) <= AsyncDisk.ReqRead.addr(req#0)
                 && AsyncDisk.ReqRead.addr(req#0)
                   <= AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)
                 && AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)
                   <= Seq#Length(AsyncDisk.Variables.contents(s#0))
                 && (var realContents#0 := Seq#Drop(Seq#Take(AsyncDisk.Variables.contents(s#0), 
                        AsyncDisk.ReqRead.addr(req#0) + AsyncDisk.ReqRead.len(req#0)), 
                      AsyncDisk.ReqRead.addr(req#0)); 
                  Seq#Length(fakeContents#0) == Seq#Length(realContents#0)
                     && !Seq#Equal(fakeContents#0, realContents#0)
                     && AsyncDisk.__default.AllChecksumsCheckOut(realContents#0, fakeContents#0)
                     && AsyncDisk.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#reqReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqRead(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  AsyncDisk.Variables.reqReads(s#0), 
                                  $Box(id#0)); 
                              #AsyncDisk.Variables.Variables(dt_update#reqReads#0#0, 
                                AsyncDisk.Variables.reqWrites(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                        (var dt_update#respReads#0#0 := Map#Build(AsyncDisk.Variables.respReads(s#0), 
                              $Box(id#0), 
                              $Box(#AsyncDisk.RespRead.RespRead(AsyncDisk.ReqRead.addr(req#0), fakeContents#0))); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                            dt_update#respReads#0#0, 
                            AsyncDisk.Variables.respWrites(dt_update_tmp#1#0), 
                            AsyncDisk.Variables.contents(dt_update_tmp#1#0)))))))));

// definition axiom for AsyncDisk.__default.ProcessReadFailure for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      id#0: int, 
      fakeContents#0: Seq Box :: 
    {:weight 3} { AsyncDisk.__default.ProcessReadFailure(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), Lit(fakeContents#0)) } 
    AsyncDisk.__default.ProcessReadFailure#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), Lit(fakeContents#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && $Is(fakeContents#0, TSeq(Tclass.NativeTypes.byte())))
       ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
         && (Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
             && (var req#1 := $Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType; 
              AsyncDisk.ReqRead.ReqRead_q(req#1)
                 && (LitInt(0) <= AsyncDisk.ReqRead.addr(req#1)
                   ==> AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1))
                 && (AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.addr(req#1)
                       <= AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)
                   ==> AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.Variables.Variables_q(Lit(s#0)))
                 && (AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.Variables.Variables_q(Lit(s#0))
                     && AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)
                       <= Seq#Length(Lit(AsyncDisk.Variables.contents(Lit(s#0))))
                   ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && 
                    AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && AsyncDisk.ReqRead.ReqRead_q(req#1)
                     && (var realContents#1 := Seq#Drop(Seq#Take(Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                            AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)), 
                          AsyncDisk.ReqRead.addr(req#1)); 
                      (!Seq#Equal(fakeContents#0, realContents#1)
                           ==> AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#1, Lit(fakeContents#0)))
                         && (AsyncDisk.__default.AllChecksumsCheckOut#canCall(realContents#1, Lit(fakeContents#0))
                             && AsyncDisk.__default.AllChecksumsCheckOut(realContents#1, Lit(fakeContents#0))
                           ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
                             && $IsA#AsyncDisk.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                    (var dt_update#reqReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                          Tclass.AsyncDisk.ReqRead(), 
                                          StartFuel_Maps._default.MapRemove1, 
                                          Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                                          $Box(LitInt(id#0))); 
                                      #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                                        Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                                        Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                        Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                        Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                                (var dt_update#respReads#0#1 := Map#Build(Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                                      $Box(LitInt(id#0)), 
                                      $Box(#AsyncDisk.RespRead.RespRead(AsyncDisk.ReqRead.addr(req#1), Lit(fakeContents#0)))); 
                                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                                    AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                                    dt_update#respReads#0#1, 
                                    AsyncDisk.Variables.respWrites(dt_update_tmp#1#1), 
                                    AsyncDisk.Variables.contents(dt_update_tmp#1#1)))))
                             && 
                            (var dt_update_tmp#0#1 := Lit(s#0); 
                              AsyncDisk.Variables.Variables_q(Lit(s#0))
                                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqRead(), 
                                  Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                                  $Box(LitInt(id#0)))
                                 && 
                                AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1))
                             && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                  (var dt_update#reqReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                        Tclass.AsyncDisk.ReqRead(), 
                                        StartFuel_Maps._default.MapRemove1, 
                                        Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                                        $Box(LitInt(id#0))); 
                                    #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                                      Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                                      Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                      Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                      Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                              AsyncDisk.Variables.Variables_q(Lit(s#0))
                                 && AsyncDisk.ReqRead.ReqRead_q(req#1)
                                 && 
                                AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                                 && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)))))))
         && AsyncDisk.__default.ProcessReadFailure(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), Lit(fakeContents#0))
           == (Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(id#0)]
             && (var req#1 := $Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType; 
              LitInt(0) <= AsyncDisk.ReqRead.addr(req#1)
                 && AsyncDisk.ReqRead.addr(req#1)
                   <= AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)
                 && AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)
                   <= Seq#Length(Lit(AsyncDisk.Variables.contents(Lit(s#0))))
                 && (var realContents#1 := Seq#Drop(Seq#Take(Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                        AsyncDisk.ReqRead.addr(req#1) + AsyncDisk.ReqRead.len(req#1)), 
                      AsyncDisk.ReqRead.addr(req#1)); 
                  Seq#Length(Lit(fakeContents#0)) == Seq#Length(realContents#1)
                     && !Seq#Equal(fakeContents#0, realContents#1)
                     && AsyncDisk.__default.AllChecksumsCheckOut(realContents#1, Lit(fakeContents#0))
                     && AsyncDisk.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#reqReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqRead(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  Lit(AsyncDisk.Variables.reqReads(Lit(s#0))), 
                                  $Box(LitInt(id#0))); 
                              #AsyncDisk.Variables.Variables(dt_update#reqReads#0#1, 
                                Lit(AsyncDisk.Variables.reqWrites(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                        (var dt_update#respReads#0#1 := Map#Build(Lit(AsyncDisk.Variables.respReads(Lit(s#0))), 
                              $Box(LitInt(id#0)), 
                              $Box(#AsyncDisk.RespRead.RespRead(AsyncDisk.ReqRead.addr(req#1), Lit(fakeContents#0)))); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                            dt_update#respReads#0#1, 
                            AsyncDisk.Variables.respWrites(dt_update_tmp#1#1), 
                            AsyncDisk.Variables.contents(dt_update_tmp#1#1)))))))));

// function declaration for AsyncDisk._default.splice
function AsyncDisk.__default.splice($ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box) : Seq Box;

function AsyncDisk.__default.splice#canCall(bytes#0: Seq Box, start#0: int, ins#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
  { AsyncDisk.__default.splice($LS($ly), bytes#0, start#0, ins#0) } 
  AsyncDisk.__default.splice($LS($ly), bytes#0, start#0, ins#0)
     == AsyncDisk.__default.splice($ly, bytes#0, start#0, ins#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
  { AsyncDisk.__default.splice(AsFuelBottom($ly), bytes#0, start#0, ins#0) } 
  AsyncDisk.__default.splice($ly, bytes#0, start#0, ins#0)
     == AsyncDisk.__default.splice($LZ, bytes#0, start#0, ins#0));

// consequence axiom for AsyncDisk.__default.splice
axiom true
   ==> (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
    { AsyncDisk.__default.splice($ly, bytes#0, start#0, ins#0) } 
    AsyncDisk.__default.splice#canCall(bytes#0, start#0, ins#0)
         || (
          $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= start#0
           && start#0 + Seq#Length(ins#0) <= Seq#Length(bytes#0))
       ==> $Is(AsyncDisk.__default.splice($ly, bytes#0, start#0, ins#0), 
        TSeq(Tclass.NativeTypes.byte())));

function AsyncDisk.__default.splice#requires(LayerType, Seq Box, int, Seq Box) : bool;

// #requires axiom for AsyncDisk.__default.splice
axiom (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
  { AsyncDisk.__default.splice#requires($ly, bytes#0, start#0, ins#0) } 
  $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
     ==> AsyncDisk.__default.splice#requires($ly, bytes#0, start#0, ins#0)
       == (LitInt(0) <= start#0 && start#0 + Seq#Length(ins#0) <= Seq#Length(bytes#0)));

// definition axiom for AsyncDisk.__default.splice(revealed)
axiom true
   ==> (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
    { AsyncDisk.__default.splice($LS($ly), bytes#0, start#0, ins#0) } 
    AsyncDisk.__default.splice#canCall(bytes#0, start#0, ins#0)
         || (
          $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= start#0
           && start#0 + Seq#Length(ins#0) <= Seq#Length(bytes#0))
       ==> AsyncDisk.__default.splice($LS($ly), bytes#0, start#0, ins#0)
         == Seq#Append(Seq#Append(Seq#Take(bytes#0, start#0), ins#0), 
          Seq#Drop(bytes#0, start#0 + Seq#Length(ins#0))));

// definition axiom for AsyncDisk.__default.splice for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bytes#0: Seq Box, start#0: int, ins#0: Seq Box :: 
    {:weight 3} { AsyncDisk.__default.splice($LS($ly), Lit(bytes#0), LitInt(start#0), Lit(ins#0)) } 
    AsyncDisk.__default.splice#canCall(Lit(bytes#0), LitInt(start#0), Lit(ins#0))
         || (
          $Is(bytes#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(ins#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 + Seq#Length(Lit(ins#0)) <= Seq#Length(Lit(bytes#0)))
       ==> AsyncDisk.__default.splice($LS($ly), Lit(bytes#0), LitInt(start#0), Lit(ins#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(bytes#0), LitInt(start#0)), ins#0), 
          Seq#Drop(Lit(bytes#0), start#0 + Seq#Length(Lit(ins#0)))));

// function declaration for AsyncDisk._default.ProcessWrite
function AsyncDisk.__default.ProcessWrite(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int) : bool;

function AsyncDisk.__default.ProcessWrite#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int) : bool;

// consequence axiom for AsyncDisk.__default.ProcessWrite
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int :: 
    { AsyncDisk.__default.ProcessWrite(k#0, s#0, s'#0, id#0) } 
    AsyncDisk.__default.ProcessWrite#canCall(k#0, s#0, s'#0, id#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> true);

function AsyncDisk.__default.ProcessWrite#requires(DatatypeType, DatatypeType, DatatypeType, int) : bool;

// #requires axiom for AsyncDisk.__default.ProcessWrite
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int :: 
  { AsyncDisk.__default.ProcessWrite#requires(k#0, s#0, s'#0, id#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
     ==> AsyncDisk.__default.ProcessWrite#requires(k#0, s#0, s'#0, id#0) == true);

// definition axiom for AsyncDisk.__default.ProcessWrite(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int :: 
    { AsyncDisk.__default.ProcessWrite(k#0, s#0, s'#0, id#0) } 
    AsyncDisk.__default.ProcessWrite#canCall(k#0, s#0, s'#0, id#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> AsyncDisk.Variables.Variables_q(s#0)
         && (Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0)
             && (var req#0 := $Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType; 
              AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                 && (LitInt(0) <= AsyncDisk.ReqWrite.addr(req#0)
                   ==> AsyncDisk.ReqWrite.ReqWrite_q(req#0))
                 && (AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && Seq#Length(AsyncDisk.ReqWrite.bytes(req#0)) < 18446744073709551616
                   ==> AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && AsyncDisk.Variables.Variables_q(s#0))
                 && (AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                     && AsyncDisk.Variables.Variables_q(s#0)
                     && AsyncDisk.ReqWrite.addr(req#0) + Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))
                       <= Seq#Length(AsyncDisk.Variables.contents(s#0))
                   ==> $IsA#AsyncDisk.Variables(s'#0)
                     && $IsA#AsyncDisk.Variables((var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                (var dt_update#reqWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                      Tclass.AsyncDisk.ReqWrite(), 
                                      StartFuel_Maps._default.MapRemove1, 
                                      AsyncDisk.Variables.reqWrites(s#0), 
                                      $Box(id#0)); 
                                  #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                                    dt_update#reqWrites#0#0, 
                                    AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                    AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                    AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                            (var dt_update#respWrites#0#0 := Map#Build(AsyncDisk.Variables.respWrites(s#0), 
                                  $Box(id#0), 
                                  $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#0), Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))))); 
                              #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                                AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                                AsyncDisk.Variables.respReads(dt_update_tmp#1#0), 
                                dt_update#respWrites#0#0, 
                                AsyncDisk.Variables.contents(dt_update_tmp#1#0)))); 
                        (var dt_update#contents#0#0 := AsyncDisk.__default.splice(StartFuel_AsyncDisk._default.splice, 
                              AsyncDisk.Variables.contents(s#0), 
                              AsyncDisk.ReqWrite.addr(req#0), 
                              AsyncDisk.ReqWrite.bytes(req#0)); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#2#0), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#2#0), 
                            AsyncDisk.Variables.respReads(dt_update_tmp#2#0), 
                            AsyncDisk.Variables.respWrites(dt_update_tmp#2#0), 
                            dt_update#contents#0#0))))
                     && 
                    (var dt_update_tmp#0#0 := s#0; 
                      AsyncDisk.Variables.Variables_q(s#0)
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.AsyncDisk.ReqWrite(), 
                          AsyncDisk.Variables.reqWrites(s#0), 
                          $Box(id#0))
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#0))
                     && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                          (var dt_update#reqWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                Tclass.AsyncDisk.ReqWrite(), 
                                StartFuel_Maps._default.MapRemove1, 
                                AsyncDisk.Variables.reqWrites(s#0), 
                                $Box(id#0)); 
                            #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                              dt_update#reqWrites#0#0, 
                              AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                              AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                              AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                      AsyncDisk.Variables.Variables_q(s#0)
                         && 
                        AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#0))
                     && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                              (var dt_update#reqWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                    Tclass.AsyncDisk.ReqWrite(), 
                                    StartFuel_Maps._default.MapRemove1, 
                                    AsyncDisk.Variables.reqWrites(s#0), 
                                    $Box(id#0)); 
                                #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                                  dt_update#reqWrites#0#0, 
                                  AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                  AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                  AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                          (var dt_update#respWrites#0#0 := Map#Build(AsyncDisk.Variables.respWrites(s#0), 
                                $Box(id#0), 
                                $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#0), Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))))); 
                            #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                              AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                              AsyncDisk.Variables.respReads(dt_update_tmp#1#0), 
                              dt_update#respWrites#0#0, 
                              AsyncDisk.Variables.contents(dt_update_tmp#1#0)))); 
                      AsyncDisk.Variables.Variables_q(s#0)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#0)
                         && AsyncDisk.__default.splice#canCall(AsyncDisk.Variables.contents(s#0), 
                          AsyncDisk.ReqWrite.addr(req#0), 
                          AsyncDisk.ReqWrite.bytes(req#0))
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#2#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#0)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#0)))))
         && AsyncDisk.__default.ProcessWrite(k#0, s#0, s'#0, id#0)
           == (Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
             && (var req#0 := $Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType; 
              LitInt(0) <= AsyncDisk.ReqWrite.addr(req#0)
                 && Seq#Length(AsyncDisk.ReqWrite.bytes(req#0)) < 18446744073709551616
                 && AsyncDisk.ReqWrite.addr(req#0) + Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))
                   <= Seq#Length(AsyncDisk.Variables.contents(s#0))
                 && AsyncDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#reqWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqWrite(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  AsyncDisk.Variables.reqWrites(s#0), 
                                  $Box(id#0)); 
                              #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#0#0), 
                                dt_update#reqWrites#0#0, 
                                AsyncDisk.Variables.respReads(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.respWrites(dt_update_tmp#0#0), 
                                AsyncDisk.Variables.contents(dt_update_tmp#0#0)))); 
                        (var dt_update#respWrites#0#0 := Map#Build(AsyncDisk.Variables.respWrites(s#0), 
                              $Box(id#0), 
                              $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#0), Seq#Length(AsyncDisk.ReqWrite.bytes(req#0))))); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#0), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#1#0), 
                            AsyncDisk.Variables.respReads(dt_update_tmp#1#0), 
                            dt_update#respWrites#0#0, 
                            AsyncDisk.Variables.contents(dt_update_tmp#1#0)))); 
                    (var dt_update#contents#0#0 := AsyncDisk.__default.splice(StartFuel_AsyncDisk._default.splice, 
                          AsyncDisk.Variables.contents(s#0), 
                          AsyncDisk.ReqWrite.addr(req#0), 
                          AsyncDisk.ReqWrite.bytes(req#0)); 
                      #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#2#0), 
                        AsyncDisk.Variables.reqWrites(dt_update_tmp#2#0), 
                        AsyncDisk.Variables.respReads(dt_update_tmp#2#0), 
                        AsyncDisk.Variables.respWrites(dt_update_tmp#2#0), 
                        dt_update#contents#0#0)))))));

// definition axiom for AsyncDisk.__default.ProcessWrite for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int :: 
    {:weight 3} { AsyncDisk.__default.ProcessWrite(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0)) } 
    AsyncDisk.__default.ProcessWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
         && (Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
             && (var req#1 := $Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType; 
              AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                 && (LitInt(0) <= AsyncDisk.ReqWrite.addr(req#1)
                   ==> AsyncDisk.ReqWrite.ReqWrite_q(req#1))
                 && (AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && Seq#Length(AsyncDisk.ReqWrite.bytes(req#1)) < 18446744073709551616
                   ==> AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && AsyncDisk.Variables.Variables_q(Lit(s#0)))
                 && (AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                     && AsyncDisk.Variables.Variables_q(Lit(s#0))
                     && AsyncDisk.ReqWrite.addr(req#1) + Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))
                       <= Seq#Length(Lit(AsyncDisk.Variables.contents(Lit(s#0))))
                   ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
                     && $IsA#AsyncDisk.Variables((var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                (var dt_update#reqWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                      Tclass.AsyncDisk.ReqWrite(), 
                                      StartFuel_Maps._default.MapRemove1, 
                                      Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                                      $Box(LitInt(id#0))); 
                                  #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                                    dt_update#reqWrites#0#1, 
                                    Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                    Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                    Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                            (var dt_update#respWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                                  $Box(LitInt(id#0)), 
                                  $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#1), Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))))); 
                              #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                                AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                                AsyncDisk.Variables.respReads(dt_update_tmp#1#1), 
                                dt_update#respWrites#0#1, 
                                AsyncDisk.Variables.contents(dt_update_tmp#1#1)))); 
                        (var dt_update#contents#0#1 := AsyncDisk.__default.splice(StartFuel_AsyncDisk._default.splice, 
                              Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                              AsyncDisk.ReqWrite.addr(req#1), 
                              AsyncDisk.ReqWrite.bytes(req#1)); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#2#1), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#2#1), 
                            AsyncDisk.Variables.respReads(dt_update_tmp#2#1), 
                            AsyncDisk.Variables.respWrites(dt_update_tmp#2#1), 
                            dt_update#contents#0#1))))
                     && 
                    (var dt_update_tmp#0#1 := Lit(s#0); 
                      AsyncDisk.Variables.Variables_q(Lit(s#0))
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.AsyncDisk.ReqWrite(), 
                          Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                          $Box(LitInt(id#0)))
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#0#1))
                     && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                          (var dt_update#reqWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                Tclass.AsyncDisk.ReqWrite(), 
                                StartFuel_Maps._default.MapRemove1, 
                                Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                                $Box(LitInt(id#0))); 
                            #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                              dt_update#reqWrites#0#1, 
                              Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                              Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                              Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                      AsyncDisk.Variables.Variables_q(Lit(s#0))
                         && 
                        AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#1#1))
                     && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                              (var dt_update#reqWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                    Tclass.AsyncDisk.ReqWrite(), 
                                    StartFuel_Maps._default.MapRemove1, 
                                    Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                                    $Box(LitInt(id#0))); 
                                #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                                  dt_update#reqWrites#0#1, 
                                  Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                  Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                  Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                          (var dt_update#respWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                                $Box(LitInt(id#0)), 
                                $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#1), Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))))); 
                            #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                              AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                              AsyncDisk.Variables.respReads(dt_update_tmp#1#1), 
                              dt_update#respWrites#0#1, 
                              AsyncDisk.Variables.contents(dt_update_tmp#1#1)))); 
                      AsyncDisk.Variables.Variables_q(Lit(s#0))
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                         && AsyncDisk.ReqWrite.ReqWrite_q(req#1)
                         && AsyncDisk.__default.splice#canCall(Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                          AsyncDisk.ReqWrite.addr(req#1), 
                          AsyncDisk.ReqWrite.bytes(req#1))
                         && 
                        AsyncDisk.Variables.Variables_q(dt_update_tmp#2#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#1)
                         && AsyncDisk.Variables.Variables_q(dt_update_tmp#2#1)))))
         && AsyncDisk.__default.ProcessWrite(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0))
           == (Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
             && (var req#1 := $Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType; 
              LitInt(0) <= AsyncDisk.ReqWrite.addr(req#1)
                 && Seq#Length(AsyncDisk.ReqWrite.bytes(req#1)) < 18446744073709551616
                 && AsyncDisk.ReqWrite.addr(req#1) + Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))
                   <= Seq#Length(Lit(AsyncDisk.Variables.contents(Lit(s#0))))
                 && AsyncDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#reqWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.AsyncDisk.ReqWrite(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))), 
                                  $Box(LitInt(id#0))); 
                              #AsyncDisk.Variables.Variables(Lit(AsyncDisk.Variables.reqReads(dt_update_tmp#0#1)), 
                                dt_update#reqWrites#0#1, 
                                Lit(AsyncDisk.Variables.respReads(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.respWrites(dt_update_tmp#0#1)), 
                                Lit(AsyncDisk.Variables.contents(dt_update_tmp#0#1))))); 
                        (var dt_update#respWrites#0#1 := Map#Build(Lit(AsyncDisk.Variables.respWrites(Lit(s#0))), 
                              $Box(LitInt(id#0)), 
                              $Box(#AsyncDisk.RespWrite.RespWrite(AsyncDisk.ReqWrite.addr(req#1), Seq#Length(AsyncDisk.ReqWrite.bytes(req#1))))); 
                          #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#1#1), 
                            AsyncDisk.Variables.reqWrites(dt_update_tmp#1#1), 
                            AsyncDisk.Variables.respReads(dt_update_tmp#1#1), 
                            dt_update#respWrites#0#1, 
                            AsyncDisk.Variables.contents(dt_update_tmp#1#1)))); 
                    (var dt_update#contents#0#1 := AsyncDisk.__default.splice(StartFuel_AsyncDisk._default.splice, 
                          Lit(AsyncDisk.Variables.contents(Lit(s#0))), 
                          AsyncDisk.ReqWrite.addr(req#1), 
                          AsyncDisk.ReqWrite.bytes(req#1)); 
                      #AsyncDisk.Variables.Variables(AsyncDisk.Variables.reqReads(dt_update_tmp#2#1), 
                        AsyncDisk.Variables.reqWrites(dt_update_tmp#2#1), 
                        AsyncDisk.Variables.respReads(dt_update_tmp#2#1), 
                        AsyncDisk.Variables.respWrites(dt_update_tmp#2#1), 
                        dt_update#contents#0#1)))))));

// function declaration for AsyncDisk._default.overlap
function AsyncDisk.__default.overlap(start#0: int, len#0: int, start'#0: int, len'#0: int) : bool;

function AsyncDisk.__default.overlap#canCall(start#0: int, len#0: int, start'#0: int, len'#0: int) : bool;

// consequence axiom for AsyncDisk.__default.overlap
axiom true
   ==> (forall start#0: int, len#0: int, start'#0: int, len'#0: int :: 
    { AsyncDisk.__default.overlap(start#0, len#0, start'#0, len'#0) } 
    true ==> true);

function AsyncDisk.__default.overlap#requires(int, int, int, int) : bool;

// #requires axiom for AsyncDisk.__default.overlap
axiom (forall start#0: int, len#0: int, start'#0: int, len'#0: int :: 
  { AsyncDisk.__default.overlap#requires(start#0, len#0, start'#0, len'#0) } 
  AsyncDisk.__default.overlap#requires(start#0, len#0, start'#0, len'#0) == true);

// definition axiom for AsyncDisk.__default.overlap(revealed)
axiom true
   ==> (forall start#0: int, len#0: int, start'#0: int, len'#0: int :: 
    { AsyncDisk.__default.overlap(start#0, len#0, start'#0, len'#0) } 
    true
       ==> AsyncDisk.__default.overlap(start#0, len#0, start'#0, len'#0)
         == (start#0 + len#0 > start'#0 && start'#0 + len'#0 > start#0));

// definition axiom for AsyncDisk.__default.overlap for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int, start'#0: int, len'#0: int :: 
    {:weight 3} { AsyncDisk.__default.overlap(LitInt(start#0), LitInt(len#0), LitInt(start'#0), LitInt(len'#0)) } 
    true
       ==> AsyncDisk.__default.overlap(LitInt(start#0), LitInt(len#0), LitInt(start'#0), LitInt(len'#0))
         == Lit(start#0 + len#0 > start'#0 && start'#0 + len'#0 > start#0));

// function declaration for AsyncDisk._default.HavocConflictingWrites
function AsyncDisk.__default.HavocConflictingWrites(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int)
   : bool;

function AsyncDisk.__default.HavocConflictingWrites#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int)
   : bool;

// consequence axiom for AsyncDisk.__default.HavocConflictingWrites
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    { AsyncDisk.__default.HavocConflictingWrites(k#0, s#0, s'#0, id#0, id'#0) } 
    AsyncDisk.__default.HavocConflictingWrites#canCall(k#0, s#0, s'#0, id#0, id'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> true);

function AsyncDisk.__default.HavocConflictingWrites#requires(DatatypeType, DatatypeType, DatatypeType, int, int) : bool;

// #requires axiom for AsyncDisk.__default.HavocConflictingWrites
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
  { AsyncDisk.__default.HavocConflictingWrites#requires(k#0, s#0, s'#0, id#0, id'#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
       && 
      LitInt(0) <= id'#0
       && id'#0 < 18446744073709551616
     ==> AsyncDisk.__default.HavocConflictingWrites#requires(k#0, s#0, s'#0, id#0, id'#0)
       == true);

// definition axiom for AsyncDisk.__default.HavocConflictingWrites(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    { AsyncDisk.__default.HavocConflictingWrites(k#0, s#0, s'#0, id#0, id'#0) } 
    AsyncDisk.__default.HavocConflictingWrites#canCall(k#0, s#0, s'#0, id#0, id'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> (id#0 != id'#0 ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType)
             && AsyncDisk.__default.overlap#canCall(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)), 
              AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType))))
         && AsyncDisk.__default.HavocConflictingWrites(k#0, s#0, s'#0, id#0, id'#0)
           == (
            id#0 != id'#0
             && Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
             && Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]
             && AsyncDisk.__default.overlap(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)), 
              AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id'#0)]): DatatypeType)))));

// definition axiom for AsyncDisk.__default.HavocConflictingWrites for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    {:weight 3} { AsyncDisk.__default.HavocConflictingWrites(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0)) } 
    AsyncDisk.__default.HavocConflictingWrites#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> (Lit(id#0 != id'#0) ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id'#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)
             && AsyncDisk.__default.overlap#canCall(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)), 
              AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType))))
         && AsyncDisk.__default.HavocConflictingWrites(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0))
           == (
            id#0 != id'#0
             && Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
             && Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id'#0)]
             && AsyncDisk.__default.overlap(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)), 
              AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)))));

// function declaration for AsyncDisk._default.HavocConflictingWriteRead
function AsyncDisk.__default.HavocConflictingWriteRead(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int)
   : bool;

function AsyncDisk.__default.HavocConflictingWriteRead#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int)
   : bool;

// consequence axiom for AsyncDisk.__default.HavocConflictingWriteRead
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    { AsyncDisk.__default.HavocConflictingWriteRead(k#0, s#0, s'#0, id#0, id'#0) } 
    AsyncDisk.__default.HavocConflictingWriteRead#canCall(k#0, s#0, s'#0, id#0, id'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> true);

function AsyncDisk.__default.HavocConflictingWriteRead#requires(DatatypeType, DatatypeType, DatatypeType, int, int) : bool;

// #requires axiom for AsyncDisk.__default.HavocConflictingWriteRead
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
  { AsyncDisk.__default.HavocConflictingWriteRead#requires(k#0, s#0, s'#0, id#0, id'#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
       && 
      LitInt(0) <= id'#0
       && id'#0 < 18446744073709551616
     ==> AsyncDisk.__default.HavocConflictingWriteRead#requires(k#0, s#0, s'#0, id#0, id'#0)
       == true);

// definition axiom for AsyncDisk.__default.HavocConflictingWriteRead(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    { AsyncDisk.__default.HavocConflictingWriteRead(k#0, s#0, s'#0, id#0, id'#0) } 
    AsyncDisk.__default.HavocConflictingWriteRead#canCall(k#0, s#0, s'#0, id#0, id'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> AsyncDisk.Variables.Variables_q(s#0)
         && (Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0))
         && (AsyncDisk.Variables.Variables_q(s#0)
             && Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]
           ==> AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqRead.ReqRead_q($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(s#0)
             && AsyncDisk.ReqRead.ReqRead_q($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType)
             && AsyncDisk.__default.overlap#canCall(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)), 
              AsyncDisk.ReqRead.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType), 
              AsyncDisk.ReqRead.len($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType)))
         && AsyncDisk.__default.HavocConflictingWriteRead(k#0, s#0, s'#0, id#0, id'#0)
           == (
            Map#Domain(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]
             && Map#Domain(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]
             && AsyncDisk.__default.overlap(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(AsyncDisk.Variables.reqWrites(s#0))[$Box(id#0)]): DatatypeType)), 
              AsyncDisk.ReqRead.addr($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType), 
              AsyncDisk.ReqRead.len($Unbox(Map#Elements(AsyncDisk.Variables.reqReads(s#0))[$Box(id'#0)]): DatatypeType))));

// definition axiom for AsyncDisk.__default.HavocConflictingWriteRead for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, id#0: int, id'#0: int :: 
    {:weight 3} { AsyncDisk.__default.HavocConflictingWriteRead(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0)) } 
    AsyncDisk.__default.HavocConflictingWriteRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616
           && 
          LitInt(0) <= id'#0
           && id'#0 < 18446744073709551616)
       ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
         && (Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0)))
         && (AsyncDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(id'#0)]
           ==> AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqWrite.ReqWrite_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqRead.ReqRead_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)
             && 
            AsyncDisk.Variables.Variables_q(Lit(s#0))
             && AsyncDisk.ReqRead.ReqRead_q($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)
             && AsyncDisk.__default.overlap#canCall(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)), 
              AsyncDisk.ReqRead.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType), 
              AsyncDisk.ReqRead.len($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType)))
         && AsyncDisk.__default.HavocConflictingWriteRead(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(id#0), LitInt(id'#0))
           == (
            Map#Domain(AsyncDisk.Variables.reqWrites(Lit(s#0)))[$Box(id#0)]
             && Map#Domain(AsyncDisk.Variables.reqReads(Lit(s#0)))[$Box(id'#0)]
             && AsyncDisk.__default.overlap(AsyncDisk.ReqWrite.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType), 
              Seq#Length(AsyncDisk.ReqWrite.bytes($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqWrites(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)), 
              AsyncDisk.ReqRead.addr($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType), 
              AsyncDisk.ReqRead.len($Unbox(Map#Elements(Lit(AsyncDisk.Variables.reqReads(Lit(s#0))))[$Box(LitInt(id'#0))]): DatatypeType))));

// function declaration for AsyncDisk._default.NextInternalStep
function AsyncDisk.__default.NextInternalStep(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType)
   : bool;

function AsyncDisk.__default.NextInternalStep#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType)
   : bool;

// consequence axiom for AsyncDisk.__default.NextInternalStep
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
    { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
    AsyncDisk.__default.NextInternalStep#canCall(k#0, s#0, s'#0, step#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(step#0, Tclass.AsyncDisk.InternalStep()))
       ==> true);

function AsyncDisk.__default.NextInternalStep#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.NextInternalStep
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
  { AsyncDisk.__default.NextInternalStep#requires(k#0, s#0, s'#0, step#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
       && $Is(step#0, Tclass.AsyncDisk.InternalStep())
     ==> AsyncDisk.__default.NextInternalStep#requires(k#0, s#0, s'#0, step#0) == true);

// definition axiom for AsyncDisk.__default.NextInternalStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
    { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
    AsyncDisk.__default.NextInternalStep#canCall(k#0, s#0, s'#0, step#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(step#0, Tclass.AsyncDisk.InternalStep()))
       ==> (AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
           ==> (var fakeContents#0 := AsyncDisk.InternalStep.fakeContents(step#0); 
            (
                AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
                 || AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
                 || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                 || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(step#0))
               && (var id#0 := AsyncDisk.InternalStep.id(step#0); 
                AsyncDisk.__default.ProcessReadFailure#canCall(k#0, s#0, s'#0, id#0, fakeContents#0))))
         && (!AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
           ==> (AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
               ==> (
                  AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
                   || AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
                   || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                   || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(step#0))
                 && (var id#1 := AsyncDisk.InternalStep.id(step#0); 
                  AsyncDisk.__default.ProcessWrite#canCall(k#0, s#0, s'#0, id#1)))
             && (!AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
               ==> (AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                   ==> (var id'#0 := AsyncDisk.InternalStep.id_k(step#0); 
                    (
                        AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
                         || AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
                         || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                         || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(step#0))
                       && (var id#2 := AsyncDisk.InternalStep.id(step#0); 
                        AsyncDisk.__default.HavocConflictingWrites#canCall(k#0, s#0, s'#0, id#2, id'#0))))
                 && (!AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                   ==> (var id'#1 := AsyncDisk.InternalStep.id_k(step#0); 
                    (
                        AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
                         || AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
                         || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                         || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(step#0))
                       && (var id#3 := AsyncDisk.InternalStep.id(step#0); 
                        AsyncDisk.__default.HavocConflictingWriteRead#canCall(k#0, s#0, s'#0, id#3, id'#1))))))
         && AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0)
           == (if AsyncDisk.InternalStep.ProcessReadFailureStep_q(step#0)
             then (var fakeContents#1 := AsyncDisk.InternalStep.fakeContents(step#0); 
              (var id#4 := AsyncDisk.InternalStep.id(step#0); 
                AsyncDisk.__default.ProcessReadFailure(k#0, s#0, s'#0, id#4, fakeContents#1)))
             else (if AsyncDisk.InternalStep.ProcessWriteStep_q(step#0)
               then (var id#5 := AsyncDisk.InternalStep.id(step#0); 
                AsyncDisk.__default.ProcessWrite(k#0, s#0, s'#0, id#5))
               else (if AsyncDisk.InternalStep.HavocConflictingWritesStep_q(step#0)
                 then (var id'#2 := AsyncDisk.InternalStep.id_k(step#0); 
                  (var id#6 := AsyncDisk.InternalStep.id(step#0); 
                    AsyncDisk.__default.HavocConflictingWrites(k#0, s#0, s'#0, id#6, id'#2)))
                 else (var id'#3 := AsyncDisk.InternalStep.id_k(step#0); 
                  (var id#7 := AsyncDisk.InternalStep.id(step#0); 
                    AsyncDisk.__default.HavocConflictingWriteRead(k#0, s#0, s'#0, id#7, id'#3)))))));

// definition axiom for AsyncDisk.__default.NextInternalStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.NextInternalStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(step#0)) } 
    AsyncDisk.__default.NextInternalStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(step#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables())
           && $Is(step#0, Tclass.AsyncDisk.InternalStep()))
       ==> (Lit(AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0)))
           ==> (var fakeContents#2 := Lit(AsyncDisk.InternalStep.fakeContents(Lit(step#0))); 
            (
                AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
                 || AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
                 || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                 || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(Lit(step#0)))
               && (var id#8 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                AsyncDisk.__default.ProcessReadFailure#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), id#8, fakeContents#2))))
         && (!Lit(AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0)))
           ==> (Lit(AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0)))
               ==> (
                  AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
                   || AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
                   || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                   || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(Lit(step#0)))
                 && (var id#9 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                  AsyncDisk.__default.ProcessWrite#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), id#9)))
             && (!Lit(AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0)))
               ==> (Lit(AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0)))
                   ==> (var id'#4 := LitInt(AsyncDisk.InternalStep.id_k(Lit(step#0))); 
                    (
                        AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(Lit(step#0)))
                       && (var id#10 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                        AsyncDisk.__default.HavocConflictingWrites#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), id#10, id'#4))))
                 && (!Lit(AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0)))
                   ==> (var id'#5 := LitInt(AsyncDisk.InternalStep.id_k(Lit(step#0))); 
                    (
                        AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                         || AsyncDisk.InternalStep.HavocConflictingWriteReadStep_q(Lit(step#0)))
                       && (var id#11 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                        AsyncDisk.__default.HavocConflictingWriteRead#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), id#11, id'#5))))))
         && AsyncDisk.__default.NextInternalStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(step#0))
           == (if AsyncDisk.InternalStep.ProcessReadFailureStep_q(Lit(step#0))
             then (var fakeContents#3 := Lit(AsyncDisk.InternalStep.fakeContents(Lit(step#0))); 
              (var id#12 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                Lit(AsyncDisk.__default.ProcessReadFailure(Lit(k#0), Lit(s#0), Lit(s'#0), id#12, fakeContents#3))))
             else (if AsyncDisk.InternalStep.ProcessWriteStep_q(Lit(step#0))
               then (var id#13 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                Lit(AsyncDisk.__default.ProcessWrite(Lit(k#0), Lit(s#0), Lit(s'#0), id#13)))
               else (if AsyncDisk.InternalStep.HavocConflictingWritesStep_q(Lit(step#0))
                 then (var id'#6 := LitInt(AsyncDisk.InternalStep.id_k(Lit(step#0))); 
                  (var id#14 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                    Lit(AsyncDisk.__default.HavocConflictingWrites(Lit(k#0), Lit(s#0), Lit(s'#0), id#14, id'#6))))
                 else (var id'#7 := LitInt(AsyncDisk.InternalStep.id_k(Lit(step#0))); 
                  (var id#15 := LitInt(AsyncDisk.InternalStep.id(Lit(step#0))); 
                    Lit(AsyncDisk.__default.HavocConflictingWriteRead(Lit(k#0), Lit(s#0), Lit(s'#0), id#15, id'#7))))))));

// function declaration for AsyncDisk._default.NextInternal
function AsyncDisk.__default.NextInternal(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

function AsyncDisk.__default.NextInternal#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

// consequence axiom for AsyncDisk.__default.NextInternal
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { AsyncDisk.__default.NextInternal(k#0, s#0, s'#0) } 
    AsyncDisk.__default.NextInternal#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> true);

function AsyncDisk.__default.NextInternal#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.NextInternal
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
  { AsyncDisk.__default.NextInternal#requires(k#0, s#0, s'#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
     ==> AsyncDisk.__default.NextInternal#requires(k#0, s#0, s'#0) == true);

// definition axiom for AsyncDisk.__default.NextInternal(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { AsyncDisk.__default.NextInternal(k#0, s#0, s'#0) } 
    AsyncDisk.__default.NextInternal#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> (forall step#0: DatatypeType :: 
          { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
          $Is(step#0, Tclass.AsyncDisk.InternalStep())
             ==> AsyncDisk.__default.NextInternalStep#canCall(k#0, s#0, s'#0, step#0))
         && AsyncDisk.__default.NextInternal(k#0, s#0, s'#0)
           == (exists step#0: DatatypeType :: 
            { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
            $Is(step#0, Tclass.AsyncDisk.InternalStep())
               && AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0)));

// definition axiom for AsyncDisk.__default.NextInternal for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.NextInternal(Lit(k#0), Lit(s#0), Lit(s'#0)) } 
    AsyncDisk.__default.NextInternal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> (forall step#1: DatatypeType :: 
          { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#1) } 
          $Is(step#1, Tclass.AsyncDisk.InternalStep())
             ==> AsyncDisk.__default.NextInternalStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), step#1))
         && AsyncDisk.__default.NextInternal(Lit(k#0), Lit(s#0), Lit(s'#0))
           == (exists step#1: DatatypeType :: 
            { AsyncDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#1) } 
            $Is(step#1, Tclass.AsyncDisk.InternalStep())
               && AsyncDisk.__default.NextInternalStep(Lit(k#0), Lit(s#0), Lit(s'#0), step#1)));

// function declaration for AsyncDisk._default.Crash
function AsyncDisk.__default.Crash(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

function AsyncDisk.__default.Crash#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

// consequence axiom for AsyncDisk.__default.Crash
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { AsyncDisk.__default.Crash(k#0, s#0, s'#0) } 
    AsyncDisk.__default.Crash#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> true);

function AsyncDisk.__default.Crash#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for AsyncDisk.__default.Crash
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
  { AsyncDisk.__default.Crash#requires(k#0, s#0, s'#0) } 
  $Is(k#0, Tclass.AsyncDisk.Constants())
       && $Is(s#0, Tclass.AsyncDisk.Variables())
       && $Is(s'#0, Tclass.AsyncDisk.Variables())
     ==> AsyncDisk.__default.Crash#requires(k#0, s#0, s'#0) == true);

// definition axiom for AsyncDisk.__default.Crash(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { AsyncDisk.__default.Crash(k#0, s#0, s'#0) } 
    AsyncDisk.__default.Crash#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> $IsA#AsyncDisk.Variables(s'#0)
         && AsyncDisk.Variables.Variables_q(s#0)
         && AsyncDisk.__default.Crash(k#0, s#0, s'#0)
           == AsyncDisk.Variables#Equal(s'#0, 
            #AsyncDisk.Variables.Variables(Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              AsyncDisk.Variables.contents(s#0))));

// definition axiom for AsyncDisk.__default.Crash for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    {:weight 3} { AsyncDisk.__default.Crash(Lit(k#0), Lit(s#0), Lit(s'#0)) } 
    AsyncDisk.__default.Crash#canCall(Lit(k#0), Lit(s#0), Lit(s'#0))
         || (
          $Is(k#0, Tclass.AsyncDisk.Constants())
           && $Is(s#0, Tclass.AsyncDisk.Variables())
           && $Is(s'#0, Tclass.AsyncDisk.Variables()))
       ==> $IsA#AsyncDisk.Variables(Lit(s'#0))
         && AsyncDisk.Variables.Variables_q(Lit(s#0))
         && AsyncDisk.__default.Crash(Lit(k#0), Lit(s#0), Lit(s'#0))
           == AsyncDisk.Variables#Equal(s'#0, 
            #AsyncDisk.Variables.Variables(Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(Map#Empty(): Map Box Box), 
              Lit(AsyncDisk.Variables.contents(Lit(s#0))))));

procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$AsyncDisk.__default.reveal__ChecksumChecksOut();
  free requires 33 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_AsyncDisk._default.ChecksumChecksOut0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$AsyncDisk.__default.reveal__ChecksumChecksOut();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_AsyncDisk._default.ChecksumChecksOut
     == $LS(MoreFuel_AsyncDisk._default.ChecksumChecksOut0);
  free ensures StartFuelAssert_AsyncDisk._default.ChecksumChecksOut
     == $LS($LS(MoreFuel_AsyncDisk._default.ChecksumChecksOut0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_AsyncDisk._default.ChecksumChecksOut0)
     == MoreFuel_AsyncDisk._default.ChecksumChecksOut0;



const unique class.JournalBytes.__default: ClassName;

function Tclass.JournalBytes.__default() : Ty;

// Tclass.JournalBytes.__default Tag
axiom Tag(Tclass.JournalBytes.__default()) == Tagclass.JournalBytes.__default;

const unique Tagclass.JournalBytes.__default: TyTag;

// Box/unbox axiom for Tclass.JournalBytes.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalBytes.__default()) } 
  $IsBox(bx, Tclass.JournalBytes.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalBytes.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalBytes.__default()) } 
  $Is($o, Tclass.JournalBytes.__default())
     <==> $o == null || dtype($o) == Tclass.JournalBytes.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalBytes.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalBytes.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalBytes._default.JournalBlockOfByteSeq
function JournalBytes.__default.JournalBlockOfByteSeq($ly: LayerType, s#0: Seq Box) : DatatypeType;

function JournalBytes.__default.JournalBlockOfByteSeq#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), s#0) } 
  JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), s#0)
     == JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalBlockOfByteSeq(AsFuelBottom($ly), s#0) } 
  JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0)
     == JournalBytes.__default.JournalBlockOfByteSeq($LZ, s#0));

// consequence axiom for JournalBytes.__default.JournalBlockOfByteSeq
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0) } 
    JournalBytes.__default.JournalBlockOfByteSeq#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0))
           ==> Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0))): Seq Box)
             == LitInt(4064))
         && $Is(JournalBytes.__default.JournalBlockOfByteSeq($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function JournalBytes.__default.JournalBlockOfByteSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalBytes.__default.JournalBlockOfByteSeq
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalBlockOfByteSeq#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalBytes.__default.JournalBlockOfByteSeq#requires($ly, s#0) == true);

// definition axiom for JournalBytes.__default.JournalBlockOfByteSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), s#0) } 
    JournalBytes.__default.JournalBlockOfByteSeq#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(s#0) == LitInt(4096)
           ==> AsyncDisk.__default.ChecksumChecksOut#canCall(s#0))
         && JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), s#0)
           == (if Seq#Length(s#0) == LitInt(4096)
               && AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, s#0)
             then #Options.Option.Some($Box(Seq#Drop(s#0, LitInt(32))))
             else #Options.Option.None()));

// definition axiom for JournalBytes.__default.JournalBlockOfByteSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), Lit(s#0)) } 
    JournalBytes.__default.JournalBlockOfByteSeq#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(Lit(s#0)) == LitInt(4096)
           ==> AsyncDisk.__default.ChecksumChecksOut#canCall(Lit(s#0)))
         && JournalBytes.__default.JournalBlockOfByteSeq($LS($ly), Lit(s#0))
           == (if Seq#Length(Lit(s#0)) == LitInt(4096)
               && AsyncDisk.__default.ChecksumChecksOut(StartFuel_AsyncDisk._default.ChecksumChecksOut, Lit(s#0))
             then #Options.Option.Some($Box(Lit(Seq#Drop(Lit(s#0), LitInt(32)))))
             else #Options.Option.None()));

// function declaration for JournalBytes._default.JournalRangeOfByteSeq
function JournalBytes.__default.JournalRangeOfByteSeq($ly: LayerType, s#0: Seq Box) : DatatypeType;

function JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), s#0) } 
  JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), s#0)
     == JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalRangeOfByteSeq(AsFuelBottom($ly), s#0) } 
  JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0)
     == JournalBytes.__default.JournalRangeOfByteSeq($LZ, s#0));

// consequence axiom for JournalBytes.__default.JournalRangeOfByteSeq
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0) } 
    JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))
           ==> Mul(Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))): Seq Box), 
              LitInt(4096))
             == Seq#Length(s#0))
         && (Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))): Seq Box, 
                  i#0)): Seq Box } 
            LitInt(0) <= i#0
                 && i#0
                   < Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))): Seq Box)
               ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0))): Seq Box, 
                      i#0)): Seq Box)
                 == LitInt(4064)))
         && $Is(JournalBytes.__default.JournalRangeOfByteSeq($ly, s#0), 
          Tclass.Options.Option(TSeq(TSeq(Tclass.NativeTypes.byte())))));

function JournalBytes.__default.JournalRangeOfByteSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalBytes.__default.JournalRangeOfByteSeq
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalBytes.__default.JournalRangeOfByteSeq#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> JournalBytes.__default.JournalRangeOfByteSeq#requires($ly, s#0) == true);

// definition axiom for JournalBytes.__default.JournalRangeOfByteSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), s#0) } 
    JournalBytes.__default.JournalRangeOfByteSeq#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (!Seq#Equal(s#0, Seq#Empty(): Seq Box)
           ==> (Seq#Length(s#0) >= LitInt(4096)
               ==> JournalBytes.__default.JournalBlockOfByteSeq#canCall(Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))
             && (Seq#Length(s#0) >= LitInt(4096)
                 && Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                    Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))
               ==> JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(s#0, LitInt(4096)))
                 && (var rest#0 := JournalBytes.__default.JournalRangeOfByteSeq($ly, Seq#Drop(s#0, LitInt(4096))); 
                  Options.Option.Some_q(rest#0)
                     ==> JournalBytes.__default.JournalBlockOfByteSeq#canCall(Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))))
         && JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), s#0)
           == (if Seq#Equal(s#0, Seq#Empty(): Seq Box)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if Seq#Length(s#0) >= LitInt(4096)
                 && Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                    Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))
               then (var rest#0 := JournalBytes.__default.JournalRangeOfByteSeq($ly, Seq#Drop(s#0, LitInt(4096))); 
                (if Options.Option.Some_q(rest#0)
                   then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                          Options.Option.value(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                              Seq#Drop(Seq#Take(s#0, LitInt(4096)), LitInt(0))))), 
                        $Unbox(Options.Option.value(rest#0)): Seq Box)))
                   else #Options.Option.None()))
               else #Options.Option.None())));

// definition axiom for JournalBytes.__default.JournalRangeOfByteSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), Lit(s#0)) } 
    JournalBytes.__default.JournalRangeOfByteSeq#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (!Seq#Equal(s#0, Seq#Empty(): Seq Box)
           ==> (Seq#Length(Lit(s#0)) >= LitInt(4096)
               ==> JournalBytes.__default.JournalBlockOfByteSeq#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))
             && (Seq#Length(Lit(s#0)) >= LitInt(4096)
                 && Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                    Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))
               ==> JournalBytes.__default.JournalRangeOfByteSeq#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(4096))))
                 && (var rest#1 := JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(4096)))); 
                  Options.Option.Some_q(rest#1)
                     ==> JournalBytes.__default.JournalBlockOfByteSeq#canCall(Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))))
         && JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), Lit(s#0))
           == (if Seq#Equal(s#0, Seq#Empty(): Seq Box)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (if Seq#Length(Lit(s#0)) >= LitInt(4096)
                 && Options.Option.Some_q(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                    Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))
               then (var rest#1 := JournalBytes.__default.JournalRangeOfByteSeq($LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(4096)))); 
                (if Options.Option.Some_q(rest#1)
                   then #Options.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                          Options.Option.value(JournalBytes.__default.JournalBlockOfByteSeq(StartFuel_JournalBytes._default.JournalBlockOfByteSeq, 
                              Lit(Seq#Drop(Seq#Take(Lit(s#0), LitInt(4096)), LitInt(0)))))), 
                        $Unbox(Options.Option.value(rest#1)): Seq Box)))
                   else #Options.Option.None()))
               else #Options.Option.None())));

procedure {:_induction a#0} CheckWellformed$$JournalBytes.__default.JournalBytesSplit(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(a#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    numBlocks#0: int, 
    split#0: int);
  free requires 11 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction a#0} Call$$JournalBytes.__default.JournalBytesSplit(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(a#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    numBlocks#0: int, 
    split#0: int);
  // user-defined preconditions
  requires Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, a#0));
  requires Seq#Length($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, a#0))): Seq Box)
     == numBlocks#0;
  requires LitInt(0) <= split#0;
  requires split#0 <= numBlocks#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Take(a#0, Mul(split#0, LitInt(4096))));
  ensures Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, 
      Seq#Take(a#0, Mul(split#0, LitInt(4096)))));
  free ensures JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(a#0, Mul(split#0, LitInt(4096))));
  ensures Options.Option.Some_q(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, 
      Seq#Drop(a#0, Mul(split#0, LitInt(4096)))));
  free ensures JournalBytes.__default.JournalRangeOfByteSeq#canCall(a#0)
     && 
    JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Take(a#0, Mul(split#0, LitInt(4096))))
     && JournalBytes.__default.JournalRangeOfByteSeq#canCall(Seq#Drop(a#0, Mul(split#0, LitInt(4096))));
  ensures Seq#Equal($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, a#0))): Seq Box, 
    Seq#Append($Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, 
            Seq#Take(a#0, Mul(split#0, LitInt(4096)))))): Seq Box, 
      $Unbox(Options.Option.value(JournalBytes.__default.JournalRangeOfByteSeq(StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq, 
            Seq#Drop(a#0, Mul(split#0, LitInt(4096)))))): Seq Box));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalBytes.__default.reveal__JournalBlockOfByteSeq();
  free requires 12 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalBytes._default.JournalBlockOfByteSeq0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalBytes.__default.reveal__JournalBlockOfByteSeq();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalBytes._default.JournalBlockOfByteSeq
     == $LS(MoreFuel_JournalBytes._default.JournalBlockOfByteSeq0);
  free ensures StartFuelAssert_JournalBytes._default.JournalBlockOfByteSeq
     == $LS($LS(MoreFuel_JournalBytes._default.JournalBlockOfByteSeq0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalBytes._default.JournalBlockOfByteSeq0)
     == MoreFuel_JournalBytes._default.JournalBlockOfByteSeq0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$JournalBytes.__default.reveal__JournalRangeOfByteSeq();
  free requires 13 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_JournalBytes._default.JournalRangeOfByteSeq0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$JournalBytes.__default.reveal__JournalRangeOfByteSeq();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_JournalBytes._default.JournalRangeOfByteSeq
     == $LS(MoreFuel_JournalBytes._default.JournalRangeOfByteSeq0);
  free ensures StartFuelAssert_JournalBytes._default.JournalRangeOfByteSeq
     == $LS($LS(MoreFuel_JournalBytes._default.JournalRangeOfByteSeq0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_JournalBytes._default.JournalRangeOfByteSeq0)
     == MoreFuel_JournalBytes._default.JournalRangeOfByteSeq0;



const unique class.SeqComparison.__default: ClassName;

function Tclass.SeqComparison.__default() : Ty;

// Tclass.SeqComparison.__default Tag
axiom Tag(Tclass.SeqComparison.__default()) == Tagclass.SeqComparison.__default;

const unique Tagclass.SeqComparison.__default: TyTag;

// Box/unbox axiom for Tclass.SeqComparison.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SeqComparison.__default()) } 
  $IsBox(bx, Tclass.SeqComparison.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.SeqComparison.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.SeqComparison.__default()) } 
  $Is($o, Tclass.SeqComparison.__default())
     <==> $o == null || dtype($o) == Tclass.SeqComparison.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.SeqComparison.__default(), $h) } 
  $IsAlloc($o, Tclass.SeqComparison.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for SeqComparison._default.lte
function SeqComparison.__default.lte($ly: LayerType, a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
  SeqComparison.__default.lte($LS($ly), a#0, b#0)
     == SeqComparison.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  SeqComparison.__default.lte($ly, a#0, b#0)
     == SeqComparison.__default.lte($LZ, a#0, b#0));

// consequence axiom for SeqComparison.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($ly, a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lte
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte#requires($ly, a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lte#requires($ly, a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int <= $Unbox(Seq#Index(a#0, LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(a#0, LitInt(0))): int <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(a#0, LitInt(0))): int < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int < $Unbox(Seq#Index(a#0, LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($ly, Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0)
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(Lit(b#0)) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(Lit(b#0)) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))))));

// function declaration for SeqComparison._default.lt
function SeqComparison.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for SeqComparison.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lt#requires(a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && SeqComparison.__default.lt(a#0, b#0)
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0)
             && !Seq#Equal(a#0, b#0)));

// definition axiom for SeqComparison.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lt(Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && SeqComparison.__default.lt(Lit(a#0), Lit(b#0))
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

const unique class.NativeArrays.__default: ClassName;

function Tclass.NativeArrays.__default() : Ty;

// Tclass.NativeArrays.__default Tag
axiom Tag(Tclass.NativeArrays.__default()) == Tagclass.NativeArrays.__default;

const unique Tagclass.NativeArrays.__default: TyTag;

// Box/unbox axiom for Tclass.NativeArrays.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeArrays.__default()) } 
  $IsBox(bx, Tclass.NativeArrays.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeArrays.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeArrays.__default()) } 
  $Is($o, Tclass.NativeArrays.__default())
     <==> $o == null || dtype($o) == Tclass.NativeArrays.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeArrays.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeArrays.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

procedure {:extern "NativeArrays_Compile", "CopySeqIntoArray"} CheckWellformed$$NativeArrays.__default.CopySeqIntoArray(NativeArrays._default.CopySeqIntoArray$A: Ty, 
    src#0: Seq Box
       where $Is(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:extern "NativeArrays_Compile", "CopySeqIntoArray"} Call$$NativeArrays.__default.CopySeqIntoArray(NativeArrays._default.CopySeqIntoArray$A: Ty, 
    src#0: Seq Box
       where $Is(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  // user-defined preconditions
  requires srcIndex#0 + len#0 <= Seq#Length(src#0);
  requires dstIndex#0 + len#0 <= _System.array.Length(dst#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall i#0: int :: 
    { Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0) } 
      { read($Heap, dst#0, IndexField(i#0)) } 
    true
       ==> 
      LitInt(0) <= i#0 && i#0 < _System.array.Length(dst#0)
       ==> read($Heap, dst#0, IndexField(i#0))
         == (if dstIndex#0 <= i#0 && i#0 < dstIndex#0 + len#0
           then Seq#Index(src#0, i#0 - dstIndex#0 + srcIndex#0)
           else Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0)));
  free ensures true;
  ensures (forall i#1: int :: 
    { Seq#Index(src#0, i#1) } 
    true
       ==> 
      srcIndex#0 <= i#1 && i#1 < srcIndex#0 + len#0
       ==> Seq#Index(src#0, i#1)
         == read($Heap, dst#0, IndexField(i#1 - srcIndex#0 + dstIndex#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == dst#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);


