// Dafny 2.3.0.10506
// Command Line Options: /compile:0 /timeLimit:1 /print:boogies/lib-Base-Arrays.i.dfy.bpl /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type Ty;

type Bv0 = int;

const unique TBool: Ty;

const unique TChar: Ty;

const unique TInt: Ty;

const unique TReal: Ty;

const unique TORDINAL: Ty;

function TBitvector(int) : Ty;

function TSet(Ty) : Ty;

function TISet(Ty) : Ty;

function TMultiSet(Ty) : Ty;

function TSeq(Ty) : Ty;

function TMap(Ty, Ty) : Ty;

function TIMap(Ty, Ty) : Ty;

function Inv0_TBitvector(Ty) : int;

axiom (forall w: int :: { TBitvector(w) } Inv0_TBitvector(TBitvector(w)) == w);

function Inv0_TSet(Ty) : Ty;

axiom (forall t: Ty :: { TSet(t) } Inv0_TSet(TSet(t)) == t);

function Inv0_TISet(Ty) : Ty;

axiom (forall t: Ty :: { TISet(t) } Inv0_TISet(TISet(t)) == t);

function Inv0_TSeq(Ty) : Ty;

axiom (forall t: Ty :: { TSeq(t) } Inv0_TSeq(TSeq(t)) == t);

function Inv0_TMultiSet(Ty) : Ty;

axiom (forall t: Ty :: { TMultiSet(t) } Inv0_TMultiSet(TMultiSet(t)) == t);

function Inv0_TMap(Ty) : Ty;

function Inv1_TMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv0_TMap(TMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv1_TMap(TMap(t, u)) == u);

function Inv0_TIMap(Ty) : Ty;

function Inv1_TIMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv0_TIMap(TIMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv1_TIMap(TIMap(t, u)) == u);

type TyTag;

function Tag(Ty) : TyTag;

const unique TagBool: TyTag;

const unique TagChar: TyTag;

const unique TagInt: TyTag;

const unique TagReal: TyTag;

const unique TagORDINAL: TyTag;

const unique TagSet: TyTag;

const unique TagISet: TyTag;

const unique TagMultiSet: TyTag;

const unique TagSeq: TyTag;

const unique TagMap: TyTag;

const unique TagIMap: TyTag;

const unique TagClass: TyTag;

axiom Tag(TBool) == TagBool;

axiom Tag(TChar) == TagChar;

axiom Tag(TInt) == TagInt;

axiom Tag(TReal) == TagReal;

axiom Tag(TORDINAL) == TagORDINAL;

axiom (forall t: Ty :: { TSet(t) } Tag(TSet(t)) == TagSet);

axiom (forall t: Ty :: { TISet(t) } Tag(TISet(t)) == TagISet);

axiom (forall t: Ty :: { TMultiSet(t) } Tag(TMultiSet(t)) == TagMultiSet);

axiom (forall t: Ty :: { TSeq(t) } Tag(TSeq(t)) == TagSeq);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Tag(TMap(t, u)) == TagMap);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Tag(TIMap(t, u)) == TagIMap);

function {:identity} Lit<T>(x: T) : T;

axiom (forall<T> x: T :: {:identity} { Lit(x): T } Lit(x): T == x);

axiom (forall<T> x: T :: { $Box(Lit(x)) } $Box(Lit(x)) == Lit($Box(x)));

function {:identity} LitInt(x: int) : int;

axiom (forall x: int :: {:identity} { LitInt(x): int } LitInt(x): int == x);

axiom (forall x: int :: { $Box(LitInt(x)) } $Box(LitInt(x)) == Lit($Box(x)));

function {:identity} LitReal(x: real) : real;

axiom (forall x: real :: {:identity} { LitReal(x): real } LitReal(x): real == x);

axiom (forall x: real :: { $Box(LitReal(x)) } $Box(LitReal(x)) == Lit($Box(x)));

type char;

function char#FromInt(int) : char;

function char#ToInt(char) : int;

axiom (forall ch: char :: 
  { char#ToInt(ch) } 
  char#FromInt(char#ToInt(ch)) == ch
     && 0 <= char#ToInt(ch)
     && char#ToInt(ch) < 65536);

axiom (forall n: int :: 
  { char#FromInt(n) } 
  0 <= n && n < 65536 ==> char#ToInt(char#FromInt(n)) == n);

function char#Plus(char, char) : char;

function char#Minus(char, char) : char;

axiom (forall a: char, b: char :: 
  { char#Plus(a, b) } 
  char#Plus(a, b) == char#FromInt(char#ToInt(a) + char#ToInt(b)));

axiom (forall a: char, b: char :: 
  { char#Minus(a, b) } 
  char#Minus(a, b) == char#FromInt(char#ToInt(a) - char#ToInt(b)));

type ref;

const null: ref;

function IsTraitParent(classOrTrait: ClassName, traitParent: ClassName) : bool;

type Box;

const $ArbitraryBoxValue: Box;

function $Box<T>(T) : Box;

function $Unbox<T>(Box) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall bx: Box :: 
  { $IsBox(bx, TInt) } 
  $IsBox(bx, TInt) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, TInt));

axiom (forall bx: Box :: 
  { $IsBox(bx, TReal) } 
  $IsBox(bx, TReal)
     ==> $Box($Unbox(bx): real) == bx && $Is($Unbox(bx): real, TReal));

axiom (forall bx: Box :: 
  { $IsBox(bx, TBool) } 
  $IsBox(bx, TBool)
     ==> $Box($Unbox(bx): bool) == bx && $Is($Unbox(bx): bool, TBool));

axiom (forall bx: Box :: 
  { $IsBox(bx, TChar) } 
  $IsBox(bx, TChar)
     ==> $Box($Unbox(bx): char) == bx && $Is($Unbox(bx): char, TChar));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSet(t)) } 
  $IsBox(bx, TSet(t))
     ==> $Box($Unbox(bx): Set Box) == bx && $Is($Unbox(bx): Set Box, TSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TISet(t)) } 
  $IsBox(bx, TISet(t))
     ==> $Box($Unbox(bx): ISet Box) == bx && $Is($Unbox(bx): ISet Box, TISet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TMultiSet(t)) } 
  $IsBox(bx, TMultiSet(t))
     ==> $Box($Unbox(bx): MultiSet Box) == bx
       && $Is($Unbox(bx): MultiSet Box, TMultiSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSeq(t)) } 
  $IsBox(bx, TSeq(t))
     ==> $Box($Unbox(bx): Seq Box) == bx && $Is($Unbox(bx): Seq Box, TSeq(t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TMap(s, t)) } 
  $IsBox(bx, TMap(s, t))
     ==> $Box($Unbox(bx): Map Box Box) == bx && $Is($Unbox(bx): Map Box Box, TMap(s, t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TIMap(s, t)) } 
  $IsBox(bx, TIMap(s, t))
     ==> $Box($Unbox(bx): IMap Box Box) == bx
       && $Is($Unbox(bx): IMap Box Box, TIMap(s, t)));

axiom (forall<T> v: T, t: Ty :: 
  { $IsBox($Box(v), t) } 
  $IsBox($Box(v), t) <==> $Is(v, t));

axiom (forall<T> v: T, t: Ty, h: Heap :: 
  { $IsAllocBox($Box(v), t, h) } 
  $IsAllocBox($Box(v), t, h) <==> $IsAlloc(v, t, h));

function $Is<T>(T, Ty) : bool;

function $IsAlloc<T>(T, Ty, Heap) : bool;

function $IsBox<T>(T, Ty) : bool;

function $IsAllocBox<T>(T, Ty, Heap) : bool;

axiom (forall v: int :: { $Is(v, TInt) } $Is(v, TInt));

axiom (forall v: real :: { $Is(v, TReal) } $Is(v, TReal));

axiom (forall v: bool :: { $Is(v, TBool) } $Is(v, TBool));

axiom (forall v: char :: { $Is(v, TChar) } $Is(v, TChar));

axiom (forall v: ORDINAL :: { $Is(v, TORDINAL) } $Is(v, TORDINAL));

axiom (forall h: Heap, v: int :: { $IsAlloc(v, TInt, h) } $IsAlloc(v, TInt, h));

axiom (forall h: Heap, v: real :: { $IsAlloc(v, TReal, h) } $IsAlloc(v, TReal, h));

axiom (forall h: Heap, v: bool :: { $IsAlloc(v, TBool, h) } $IsAlloc(v, TBool, h));

axiom (forall h: Heap, v: char :: { $IsAlloc(v, TChar, h) } $IsAlloc(v, TChar, h));

axiom (forall h: Heap, v: ORDINAL :: 
  { $IsAlloc(v, TORDINAL, h) } 
  $IsAlloc(v, TORDINAL, h));

axiom (forall v: Set Box, t0: Ty :: 
  { $Is(v, TSet(t0)) } 
  $Is(v, TSet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: ISet Box, t0: Ty :: 
  { $Is(v, TISet(t0)) } 
  $Is(v, TISet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0))
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0)) ==> $IsGoodMultiSet(v));

axiom (forall v: Seq Box, t0: Ty :: 
  { $Is(v, TSeq(t0)) } 
  $Is(v, TSeq(t0))
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsBox(Seq#Index(v, i), t0)));

axiom (forall v: Set Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSet(t0), h) } 
  $IsAlloc(v, TSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: ISet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TISet(t0), h) } 
  $IsAlloc(v, TISet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: MultiSet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TMultiSet(t0), h) } 
  $IsAlloc(v, TMultiSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: Seq Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSeq(t0), h) } 
  $IsAlloc(v, TSeq(t0), h)
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsAllocBox(Seq#Index(v, i), t0, h)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TMap(t0, t1)) } 
  $Is(v, TMap(t0, t1))
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx] ==> $IsBox(Map#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TMap(t0, t1), h) } 
  $IsAlloc(v, TMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx]
         ==> $IsAllocBox(Map#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TIMap(t0, t1)) } 
  $Is(v, TIMap(t0, t1))
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx] ==> $IsBox(IMap#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TIMap(t0, t1), h) } 
  $IsAlloc(v, TIMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx]
         ==> $IsAllocBox(IMap#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

type ClassName;

const unique class._System.int: ClassName;

const unique class._System.bool: ClassName;

const unique class._System.set: ClassName;

const unique class._System.seq: ClassName;

const unique class._System.multiset: ClassName;

function Tclass._System.object?() : Ty;

function dtype(ref) : Ty;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: 
  { TypeTuple(a, b) } 
  TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type HandleType;

function SetRef_to_SetBox(s: [ref]bool) : Set Box;

axiom (forall s: [ref]bool, bx: Box :: 
  { SetRef_to_SetBox(s)[bx] } 
  SetRef_to_SetBox(s)[bx] == s[$Unbox(bx): ref]);

axiom (forall s: [ref]bool :: 
  { SetRef_to_SetBox(s) } 
  $Is(SetRef_to_SetBox(s), TSet(Tclass._System.object?())));

function Apply1(Ty, Ty, Heap, HandleType, Box) : Box;

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

function BoxRank(Box) : int;

axiom (forall d: DatatypeType :: { BoxRank($Box(d)) } BoxRank($Box(d)) == DtRank(d));

type ORDINAL = Box;

function ORD#IsNat(ORDINAL) : bool;

function ORD#Offset(ORDINAL) : int;

axiom (forall o: ORDINAL :: { ORD#Offset(o) } 0 <= ORD#Offset(o));

function {:inline} ORD#IsLimit(o: ORDINAL) : bool
{
  ORD#Offset(o) == 0
}

function {:inline} ORD#IsSucc(o: ORDINAL) : bool
{
  0 < ORD#Offset(o)
}

function ORD#FromNat(int) : ORDINAL;

axiom (forall n: int :: 
  { ORD#FromNat(n) } 
  0 <= n ==> ORD#IsNat(ORD#FromNat(n)) && ORD#Offset(ORD#FromNat(n)) == n);

axiom (forall o: ORDINAL :: 
  { ORD#Offset(o) } { ORD#IsNat(o) } 
  ORD#IsNat(o) ==> o == ORD#FromNat(ORD#Offset(o)));

function ORD#Less(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p) } 
  (ORD#Less(o, p) ==> o != p)
     && (ORD#IsNat(o) && !ORD#IsNat(p) ==> ORD#Less(o, p))
     && (ORD#IsNat(o) && ORD#IsNat(p)
       ==> ORD#Less(o, p) == (ORD#Offset(o) < ORD#Offset(p)))
     && (ORD#Less(o, p) && ORD#IsNat(p) ==> ORD#IsNat(o)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, o) } 
  ORD#Less(o, p) || o == p || ORD#Less(p, o));

axiom (forall o: ORDINAL, p: ORDINAL, r: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, r) } { ORD#Less(o, p), ORD#Less(o, r) } 
  ORD#Less(o, p) && ORD#Less(p, r) ==> ORD#Less(o, r));

function ORD#LessThanLimit(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#LessThanLimit(o, p) } 
  ORD#LessThanLimit(o, p) == ORD#Less(o, p));

function ORD#Plus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (ORD#IsNat(ORD#Plus(o, p)) ==> ORD#IsNat(o) && ORD#IsNat(p))
     && (ORD#IsNat(p)
       ==> ORD#IsNat(ORD#Plus(o, p)) == ORD#IsNat(o)
         && ORD#Offset(ORD#Plus(o, p)) == ORD#Offset(o) + ORD#Offset(p)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#Plus(o, p) || ORD#Less(o, ORD#Plus(o, p)))
     && (p == ORD#Plus(o, p) || ORD#Less(p, ORD#Plus(o, p))));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#FromNat(0) ==> ORD#Plus(o, p) == p)
     && (p == ORD#FromNat(0) ==> ORD#Plus(o, p) == o));

function ORD#Minus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> ORD#IsNat(ORD#Minus(o, p)) == ORD#IsNat(o)
       && ORD#Offset(ORD#Minus(o, p)) == ORD#Offset(o) - ORD#Offset(p));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> (p == ORD#FromNat(0) && ORD#Minus(o, p) == o)
       || (p != ORD#FromNat(0) && ORD#Less(ORD#Minus(o, p), o)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n
     ==> ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Plus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && m + n <= ORD#Offset(o)
     ==> ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Minus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(n - m))));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(n - m))));

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

type LayerType;

const $LZ: LayerType;

function $LS(LayerType) : LayerType;

function AsFuelBottom(LayerType) : LayerType;

function AtLayer<A>([LayerType]A, LayerType) : A;

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, ly) } 
  AtLayer(f, ly) == f[ly]);

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, $LS(ly)) } 
  AtLayer(f, $LS(ly)) == AtLayer(f, ly));

type Field _;

function FDim<T>(Field T) : int;

function IndexField(int) : Field Box;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field Box, int) : Field Box;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  MultiIndexField_Inverse0(MultiIndexField(f, i)) == f
     && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

type NameFamily;

function DeclName<T>(Field T) : NameFamily;

function FieldOfDecl<alpha>(ClassName, NameFamily) : Field alpha;

axiom (forall<T> cl: ClassName, nm: NameFamily :: 
  { FieldOfDecl(cl, nm): Field T } 
  DeclType(FieldOfDecl(cl, nm): Field T) == cl
     && DeclName(FieldOfDecl(cl, nm): Field T) == nm);

function $IsGhostField<T>(Field T) : bool;

axiom (forall<T> h: Heap, k: Heap, v: T, t: Ty :: 
  { $HeapSucc(h, k), $IsAlloc(v, t, h) } 
  $HeapSucc(h, k) ==> $IsAlloc(v, t, h) ==> $IsAlloc(v, t, k));

axiom (forall h: Heap, k: Heap, bx: Box, t: Ty :: 
  { $HeapSucc(h, k), $IsAllocBox(bx, t, h) } 
  $HeapSucc(h, k) ==> $IsAllocBox(bx, t, h) ==> $IsAllocBox(bx, t, k));

const unique alloc: Field bool;

const unique allocName: NameFamily;

axiom FDim(alloc) == 0 && DeclName(alloc) == allocName && !$IsGhostField(alloc);

function _System.array.Length(a: ref) : int;

axiom (forall o: ref :: 0 <= _System.array.Length(o));

function Int(x: real) : int;

axiom (forall x: real :: { Int(x): int } Int(x): int == int(x));

function Real(x: int) : real;

axiom (forall x: int :: { Real(x): real } Real(x): real == real(x));

axiom (forall i: int :: { Int(Real(i)) } Int(Real(i)) == i);

function {:inline} _System.real.Floor(x: real) : int
{
  Int(x)
}

type Heap = [ref]<alpha>[Field alpha]alpha;

function {:inline} read<alpha>(H: Heap, r: ref, f: Field alpha) : alpha
{
  H[r][f]
}

function {:inline} update<alpha>(H: Heap, r: ref, f: Field alpha, v: alpha) : Heap
{
  H[r := H[r][f := v]]
}

function $IsGoodHeap(Heap) : bool;

function $IsHeapAnchor(Heap) : bool;

var $Heap: Heap where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap);

const $OneHeap: Heap;

axiom $IsGoodHeap($OneHeap);

function $HeapSucc(Heap, Heap) : bool;

axiom (forall<alpha> h: Heap, r: ref, f: Field alpha, x: alpha :: 
  { update(h, r, f, x) } 
  $IsGoodHeap(update(h, r, f, x)) ==> $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: Heap, b: Heap, c: Heap :: 
  { $HeapSucc(a, b), $HeapSucc(b, c) } 
  a != c ==> $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: Heap, k: Heap :: 
  { $HeapSucc(h, k) } 
  $HeapSucc(h, k)
     ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

function $HeapSuccGhost(Heap, Heap) : bool;

axiom (forall h: Heap, k: Heap :: 
  { $HeapSuccGhost(h, k) } 
  $HeapSuccGhost(h, k)
     ==> $HeapSucc(h, k)
       && (forall<alpha> o: ref, f: Field alpha :: 
        { read(k, o, f) } 
        !$IsGhostField(f) ==> read(h, o, f) == read(k, o, f)));

type TickType;

var $Tick: TickType;

procedure $YieldHavoc(this: ref, rds: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      $o == this || rds[$Box($o)] || nw[$Box($o)]
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc0(this: ref, rds: Set Box, modi: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      rds[$Box($o)] && !modi[$Box($o)] && $o != this
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc1(this: ref, modi: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)
         || $o == this
         || modi[$Box($o)]
         || nw[$Box($o)]);
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterCollectNewObjects(prevHeap: Heap, newHeap: Heap, this: ref, NW: Field (Set Box))
   returns (s: Set Box);
  ensures (forall bx: Box :: 
    { s[bx] } 
    s[bx]
       <==> read(newHeap, this, NW)[bx]
         || (
          $Unbox(bx) != null
           && !read(prevHeap, $Unbox(bx): ref, alloc)
           && read(newHeap, $Unbox(bx): ref, alloc)));



type Set T = [T]bool;

function Set#Card<T>(Set T) : int;

axiom (forall<T> s: Set T :: { Set#Card(s) } 0 <= Set#Card(s));

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

axiom (forall<T> s: Set T :: 
  { Set#Card(s) } 
  (Set#Card(s) == 0 <==> s == Set#Empty())
     && (Set#Card(s) != 0 ==> (exists x: T :: s[x])));

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: 
  { Set#Singleton(r)[o] } 
  Set#Singleton(r)[o] <==> r == o);

axiom (forall<T> r: T :: 
  { Set#Card(Set#Singleton(r)) } 
  Set#Card(Set#Singleton(r)) == 1);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: 
  { Set#UnionOne(a, x)[o] } 
  Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: 
  { Set#UnionOne(a, x), a[y] } 
  a[y] ==> Set#UnionOne(a, x)[y]);

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a));

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  !a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a) + 1);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Union(a, b)[o] } 
  Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), a[y] } 
  a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), b[y] } 
  b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, b) } 
  Set#Disjoint(a, b)
     ==> Set#Difference(Set#Union(a, b), a) == b
       && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Intersection(a, b)[o] } 
  Set#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(Set#Union(a, b), b) } 
  Set#Union(Set#Union(a, b), b) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, Set#Union(a, b)) } 
  Set#Union(a, Set#Union(a, b)) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(Set#Intersection(a, b), b) } 
  Set#Intersection(Set#Intersection(a, b), b) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(a, Set#Intersection(a, b)) } 
  Set#Intersection(a, Set#Intersection(a, b)) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Union(a, b)) } { Set#Card(Set#Intersection(a, b)) } 
  Set#Card(Set#Union(a, b)) + Set#Card(Set#Intersection(a, b))
     == Set#Card(a) + Set#Card(b));

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Difference(a, b)[o] } 
  Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Difference(a, b), b[y] } 
  b[y] ==> !Set#Difference(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Difference(a, b)) } 
  Set#Card(Set#Difference(a, b))
         + Set#Card(Set#Difference(b, a))
         + Set#Card(Set#Intersection(a, b))
       == Set#Card(Set#Union(a, b))
     && Set#Card(Set#Difference(a, b)) == Set#Card(a) - Set#Card(Set#Intersection(a, b)));

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Subset(a, b) } 
  Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Equal(a, b) } 
  Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Disjoint(a, b) } 
  Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type ISet T = [T]bool;

function ISet#Empty<T>() : Set T;

axiom (forall<T> o: T :: { ISet#Empty()[o] } !ISet#Empty()[o]);

function ISet#UnionOne<T>(ISet T, T) : ISet T;

axiom (forall<T> a: ISet T, x: T, o: T :: 
  { ISet#UnionOne(a, x)[o] } 
  ISet#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: ISet T, x: T :: { ISet#UnionOne(a, x) } ISet#UnionOne(a, x)[x]);

axiom (forall<T> a: ISet T, x: T, y: T :: 
  { ISet#UnionOne(a, x), a[y] } 
  a[y] ==> ISet#UnionOne(a, x)[y]);

function ISet#Union<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Union(a, b)[o] } 
  ISet#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Union(a, b), a[y] } 
  a[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { ISet#Union(a, b), b[y] } 
  b[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(a, b) } 
  ISet#Disjoint(a, b)
     ==> ISet#Difference(ISet#Union(a, b), a) == b
       && ISet#Difference(ISet#Union(a, b), b) == a);

function ISet#Intersection<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Intersection(a, b)[o] } 
  ISet#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(ISet#Union(a, b), b) } 
  ISet#Union(ISet#Union(a, b), b) == ISet#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { ISet#Union(a, ISet#Union(a, b)) } 
  ISet#Union(a, ISet#Union(a, b)) == ISet#Union(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(ISet#Intersection(a, b), b) } 
  ISet#Intersection(ISet#Intersection(a, b), b) == ISet#Intersection(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(a, ISet#Intersection(a, b)) } 
  ISet#Intersection(a, ISet#Intersection(a, b)) == ISet#Intersection(a, b));

function ISet#Difference<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Difference(a, b)[o] } 
  ISet#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Difference(a, b), b[y] } 
  b[y] ==> !ISet#Difference(a, b)[y]);

function ISet#Subset<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Subset(a, b) } 
  ISet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function ISet#Equal<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) ==> a == b);

function ISet#Disjoint<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Disjoint(a, b) } 
  ISet#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

function Math#min(a: int, b: int) : int;

axiom (forall a: int, b: int :: { Math#min(a, b) } a <= b <==> Math#min(a, b) == a);

axiom (forall a: int, b: int :: { Math#min(a, b) } b <= a <==> Math#min(a, b) == b);

axiom (forall a: int, b: int :: 
  { Math#min(a, b) } 
  Math#min(a, b) == a || Math#min(a, b) == b);

function Math#clip(a: int) : int;

axiom (forall a: int :: { Math#clip(a) } 0 <= a ==> Math#clip(a) == a);

axiom (forall a: int :: { Math#clip(a) } a < 0 ==> Math#clip(a) == 0);

type MultiSet T = [T]int;

function $IsGoodMultiSet<T>(ms: MultiSet T) : bool;

axiom (forall<T> ms: MultiSet T :: 
  { $IsGoodMultiSet(ms) } 
  $IsGoodMultiSet(ms)
     <==> (forall bx: T :: { ms[bx] } 0 <= ms[bx] && ms[bx] <= MultiSet#Card(ms)));

function MultiSet#Card<T>(MultiSet T) : int;

axiom (forall<T> s: MultiSet T :: { MultiSet#Card(s) } 0 <= MultiSet#Card(s));

axiom (forall<T> s: MultiSet T, x: T, n: int :: 
  { MultiSet#Card(s[x := n]) } 
  0 <= n ==> MultiSet#Card(s[x := n]) == MultiSet#Card(s) - s[x] + n);

function MultiSet#Empty<T>() : MultiSet T;

axiom (forall<T> o: T :: { MultiSet#Empty()[o] } MultiSet#Empty()[o] == 0);

axiom (forall<T> s: MultiSet T :: 
  { MultiSet#Card(s) } 
  (MultiSet#Card(s) == 0 <==> s == MultiSet#Empty())
     && (MultiSet#Card(s) != 0 ==> (exists x: T :: 0 < s[x])));

function MultiSet#Singleton<T>(T) : MultiSet T;

axiom (forall<T> r: T, o: T :: 
  { MultiSet#Singleton(r)[o] } 
  (MultiSet#Singleton(r)[o] == 1 <==> r == o)
     && (MultiSet#Singleton(r)[o] == 0 <==> r != o));

axiom (forall<T> r: T :: 
  { MultiSet#Singleton(r) } 
  MultiSet#Singleton(r) == MultiSet#UnionOne(MultiSet#Empty(), r));

function MultiSet#UnionOne<T>(MultiSet T, T) : MultiSet T;

axiom (forall<T> a: MultiSet T, x: T, o: T :: 
  { MultiSet#UnionOne(a, x)[o] } 
  0 < MultiSet#UnionOne(a, x)[o] <==> o == x || 0 < a[o]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#UnionOne(a, x) } 
  MultiSet#UnionOne(a, x)[x] == a[x] + 1);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  0 < a[y] ==> 0 < MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  x != y ==> a[y] == MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#Card(MultiSet#UnionOne(a, x)) } 
  MultiSet#Card(MultiSet#UnionOne(a, x)) == MultiSet#Card(a) + 1);

function MultiSet#Union<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Union(a, b)[o] } 
  MultiSet#Union(a, b)[o] == a[o] + b[o]);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Union(a, b)) } 
  MultiSet#Card(MultiSet#Union(a, b)) == MultiSet#Card(a) + MultiSet#Card(b));

function MultiSet#Intersection<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Intersection(a, b)[o] } 
  MultiSet#Intersection(a, b)[o] == Math#min(a[o], b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(MultiSet#Intersection(a, b), b) } 
  MultiSet#Intersection(MultiSet#Intersection(a, b), b)
     == MultiSet#Intersection(a, b));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(a, MultiSet#Intersection(a, b)) } 
  MultiSet#Intersection(a, MultiSet#Intersection(a, b))
     == MultiSet#Intersection(a, b));

function MultiSet#Difference<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Difference(a, b)[o] } 
  MultiSet#Difference(a, b)[o] == Math#clip(a[o] - b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T, y: T :: 
  { MultiSet#Difference(a, b), b[y], a[y] } 
  a[y] <= b[y] ==> MultiSet#Difference(a, b)[y] == 0);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Difference(a, b)) } 
  MultiSet#Card(MultiSet#Difference(a, b))
         + MultiSet#Card(MultiSet#Difference(b, a))
         + 2 * MultiSet#Card(MultiSet#Intersection(a, b))
       == MultiSet#Card(MultiSet#Union(a, b))
     && MultiSet#Card(MultiSet#Difference(a, b))
       == MultiSet#Card(a) - MultiSet#Card(MultiSet#Intersection(a, b)));

function MultiSet#Subset<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Subset(a, b) } 
  MultiSet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <= b[o]));

function MultiSet#Equal<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] == b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) ==> a == b);

function MultiSet#Disjoint<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Disjoint(a, b) } 
  MultiSet#Disjoint(a, b)
     <==> (forall o: T :: { a[o] } { b[o] } a[o] == 0 || b[o] == 0));

function MultiSet#FromSet<T>(Set T) : MultiSet T;

axiom (forall<T> s: Set T, a: T :: 
  { MultiSet#FromSet(s)[a] } 
  (MultiSet#FromSet(s)[a] == 0 <==> !s[a])
     && (MultiSet#FromSet(s)[a] == 1 <==> s[a]));

axiom (forall<T> s: Set T :: 
  { MultiSet#Card(MultiSet#FromSet(s)) } 
  MultiSet#Card(MultiSet#FromSet(s)) == Set#Card(s));

function MultiSet#FromSeq<T>(Seq T) : MultiSet T;

axiom (forall<T> s: Seq T :: 
  { MultiSet#FromSeq(s) } 
  $IsGoodMultiSet(MultiSet#FromSeq(s)));

axiom (forall<T> s: Seq T :: 
  { MultiSet#Card(MultiSet#FromSeq(s)) } 
  MultiSet#Card(MultiSet#FromSeq(s)) == Seq#Length(s));

axiom (forall<T> s: Seq T, v: T :: 
  { MultiSet#FromSeq(Seq#Build(s, v)) } 
  MultiSet#FromSeq(Seq#Build(s, v)) == MultiSet#UnionOne(MultiSet#FromSeq(s), v));

axiom (forall<T>  :: 
  MultiSet#FromSeq(Seq#Empty(): Seq T) == MultiSet#Empty(): MultiSet T);

axiom (forall<T> a: Seq T, b: Seq T :: 
  { MultiSet#FromSeq(Seq#Append(a, b)) } 
  MultiSet#FromSeq(Seq#Append(a, b))
     == MultiSet#Union(MultiSet#FromSeq(a), MultiSet#FromSeq(b)));

axiom (forall<T> s: Seq T, i: int, v: T, x: T :: 
  { MultiSet#FromSeq(Seq#Update(s, i, v))[x] } 
  0 <= i && i < Seq#Length(s)
     ==> MultiSet#FromSeq(Seq#Update(s, i, v))[x]
       == MultiSet#Union(MultiSet#Difference(MultiSet#FromSeq(s), MultiSet#Singleton(Seq#Index(s, i))), 
        MultiSet#Singleton(v))[x]);

axiom (forall<T> s: Seq T, x: T :: 
  { MultiSet#FromSeq(s)[x] } 
  (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && x == Seq#Index(s, i))
     <==> 0 < MultiSet#FromSeq(s)[x]);

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: { Seq#Empty(): Seq T } Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: 
  { Seq#Length(s) } 
  Seq#Length(s) == 0 ==> s == Seq#Empty());

axiom (forall<T> t: Ty :: { $Is(Seq#Empty(): Seq T, t) } $Is(Seq#Empty(): Seq T, t));

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: 
  { Seq#Length(Seq#Singleton(t)) } 
  Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, val: T) : Seq T;

function Seq#Build_inv0<T>(s: Seq T) : Seq T;

function Seq#Build_inv1<T>(s: Seq T) : T;

axiom (forall<T> s: Seq T, val: T :: 
  { Seq#Build(s, val) } 
  Seq#Build_inv0(Seq#Build(s, val)) == s
     && Seq#Build_inv1(Seq#Build(s, val)) == val);

axiom (forall<T> s: Seq T, v: T :: 
  { Seq#Build(s, v) } 
  Seq#Length(Seq#Build(s, v)) == 1 + Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Index(Seq#Build(s, v), i) } 
  (i == Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == v)
     && (i != Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == Seq#Index(s, i)));

axiom (forall s: Seq Box, bx: Box, t: Ty :: 
  { $Is(Seq#Build(s, bx), TSeq(t)) } 
  $Is(s, TSeq(t)) && $IsBox(bx, t) ==> $Is(Seq#Build(s, bx), TSeq(t)));

function Seq#Create(ty: Ty, heap: Heap, len: int, init: HandleType) : Seq Box;

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType :: 
  { Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) } 
  $IsGoodHeap(heap) && 0 <= len
     ==> Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) == len);

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType, i: int :: 
  { Seq#Index(Seq#Create(ty, heap, len, init), i) } 
  $IsGoodHeap(heap) && 0 <= i && i < len
     ==> Seq#Index(Seq#Create(ty, heap, len, init), i)
       == Apply1(TInt, TSeq(ty), heap, init, $Box(i)));

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Length(Seq#Append(s0, s1)) } 
  Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

axiom (forall s0: Seq Box, s1: Seq Box, t: Ty :: 
  { $Is(Seq#Append(s0, s1), t) } 
  $Is(s0, t) && $Is(s1, t) ==> $Is(Seq#Append(s0, s1), t));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: 
  { Seq#Index(Seq#Singleton(t), 0) } 
  Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#Index(Seq#Append(s0, s1), n) } 
  (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n))
     && (Seq#Length(s0) <= n
       ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Length(Seq#Update(s, i, v)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Index(Seq#Update(s, i, v), n) } 
  0 <= n && n < Seq#Length(s)
     ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v)
       && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: 
  { Seq#Contains(s, x) } 
  Seq#Contains(s, x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> x: T :: 
  { Seq#Contains(Seq#Empty(), x) } 
  !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: 
  { Seq#Contains(Seq#Append(s0, s1), x) } 
  Seq#Contains(Seq#Append(s0, s1), x)
     <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, v: T, x: T :: 
  { Seq#Contains(Seq#Build(s, v), x) } 
  Seq#Contains(Seq#Build(s, v), x) <==> v == x || Seq#Contains(s, x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Take(s, n), x) } 
  Seq#Contains(Seq#Take(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Drop(s, n), x) } 
  Seq#Contains(Seq#Drop(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Equal(s0, s1) } 
  Seq#Equal(s0, s1)
     <==> Seq#Length(s0) == Seq#Length(s1)
       && (forall j: int :: 
        { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
        0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#SameUntil(s0, s1, n) } 
  Seq#SameUntil(s0, s1, n)
     <==> (forall j: int :: 
      { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
      0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Take(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Take(s, n), j) } { Seq#Index(s, j), Seq#Take(s, n) } 
  0 <= j && j < n && j < Seq#Length(s)
     ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Drop(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 
  0 <= n && 0 <= j && j < Seq#Length(s) - n
     ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, n: int, k: int :: 
  {:weight 25} { Seq#Index(s, k), Seq#Drop(s, n) } 
  0 <= n && n <= k && k < Seq#Length(s)
     ==> Seq#Index(Seq#Drop(s, n), k - n) == Seq#Index(s, k));

axiom (forall<T> s: Seq T, t: Seq T, n: int :: 
  { Seq#Take(Seq#Append(s, t), n) } { Seq#Drop(Seq#Append(s, t), n) } 
  n == Seq#Length(s)
     ==> Seq#Take(Seq#Append(s, t), n) == s && Seq#Drop(Seq#Append(s, t), n) == t);

function Seq#FromArray(h: Heap, a: ref) : Seq Box;

axiom (forall h: Heap, a: ref :: 
  { Seq#Length(Seq#FromArray(h, a)) } 
  Seq#Length(Seq#FromArray(h, a)) == _System.array.Length(a));

axiom (forall h: Heap, a: ref :: 
  { Seq#FromArray(h, a) } 
  (forall i: int :: 
    { read(h, a, IndexField(i)) } { Seq#Index(Seq#FromArray(h, a): Seq Box, i) } 
    0 <= i && i < Seq#Length(Seq#FromArray(h, a))
       ==> Seq#Index(Seq#FromArray(h, a), i) == read(h, a, IndexField(i))));

axiom (forall h0: Heap, h1: Heap, a: ref :: 
  { Seq#FromArray(h1, a), $HeapSucc(h0, h1) } 
  $IsGoodHeap(h0) && $IsGoodHeap(h1) && $HeapSucc(h0, h1) && h0[a] == h1[a]
     ==> Seq#FromArray(h0, a) == Seq#FromArray(h1, a));

axiom (forall h: Heap, i: int, v: Box, a: ref :: 
  { Seq#FromArray(update(h, a, IndexField(i), v), a) } 
  0 <= i && i < _System.array.Length(a)
     ==> Seq#FromArray(update(h, a, IndexField(i), v), a)
       == Seq#Update(Seq#FromArray(h, a), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n <= Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Update(Seq#Take(s, n), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  n <= i && i < Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Take(s, n));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= n && n <= i && i < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Update(Seq#Drop(s, n), i - n, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Drop(s, n));

axiom (forall h: Heap, a: ref, n0: int, n1: int :: 
  { Seq#Take(Seq#FromArray(h, a), n0), Seq#Take(Seq#FromArray(h, a), n1) } 
  n0 + 1 == n1 && 0 <= n0 && n1 <= _System.array.Length(a)
     ==> Seq#Take(Seq#FromArray(h, a), n1)
       == Seq#Build(Seq#Take(Seq#FromArray(h, a), n0), read(h, a, IndexField(n0): Field Box)));

axiom (forall<T> s: Seq T, v: T, n: int :: 
  { Seq#Drop(Seq#Build(s, v), n) } 
  0 <= n && n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Build(s, v), n) == Seq#Build(Seq#Drop(s, n), v));

function Seq#Rank<T>(Seq T) : int;

axiom (forall s: Seq Box, i: int :: 
  { DtRank($Unbox(Seq#Index(s, i)): DatatypeType) } 
  0 <= i && i < Seq#Length(s)
     ==> DtRank($Unbox(Seq#Index(s, i)): DatatypeType) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Drop(s, i)) } 
  0 < i && i <= Seq#Length(s) ==> Seq#Rank(Seq#Drop(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Take(s, i)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Rank(Seq#Take(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int, j: int :: 
  { Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) } 
  0 <= i && i < j && j <= Seq#Length(s)
     ==> Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) < Seq#Rank(s));

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Drop(s, n) } 
  n == 0 ==> Seq#Drop(s, n) == s);

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Take(s, n) } 
  n == 0 ==> Seq#Take(s, n) == Seq#Empty());

axiom (forall<T> s: Seq T, m: int, n: int :: 
  { Seq#Drop(Seq#Drop(s, m), n) } 
  0 <= m && 0 <= n && m + n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Drop(s, m), n) == Seq#Drop(s, m + n));

type Map _ _;

function Map#Domain<U,V>(Map U V) : Set U;

function Map#Elements<U,V>(Map U V) : [U]V;

function Map#Card<U,V>(Map U V) : int;

axiom (forall<U,V> m: Map U V :: { Map#Card(m) } 0 <= Map#Card(m));

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Domain(m)) } 
  Set#Card(Map#Domain(m)) == Map#Card(m));

function Map#Values<U,V>(Map U V) : Set V;

axiom (forall<U,V> m: Map U V, v: V :: 
  { Map#Values(m)[v] } 
  Map#Values(m)[v]
     == (exists u: U :: 
      { Map#Domain(m)[u] } { Map#Elements(m)[u] } 
      Map#Domain(m)[u] && v == Map#Elements(m)[u]));

function Map#Items<U,V>(Map U V) : Set Box;

function _System.Tuple2._0(DatatypeType) : Box;

function _System.Tuple2._1(DatatypeType) : Box;

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Items(m)) } 
  Set#Card(Map#Items(m)) == Map#Card(m));

axiom (forall m: Map Box Box, item: Box :: 
  { Map#Items(m)[item] } 
  Map#Items(m)[item]
     <==> Map#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && Map#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function Map#Empty<U,V>() : Map U V;

axiom (forall<U,V> u: U :: 
  { Map#Domain(Map#Empty(): Map U V)[u] } 
  !Map#Domain(Map#Empty(): Map U V)[u]);

axiom (forall<U,V> m: Map U V :: 
  { Map#Card(m) } 
  (Map#Card(m) == 0 <==> m == Map#Empty())
     && (Map#Card(m) != 0 ==> (exists x: U :: Map#Domain(m)[x])));

function Map#Glue<U,V>([U]bool, [U]V, Ty) : Map U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Domain(Map#Glue(a, b, t)) } 
  Map#Domain(Map#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Elements(Map#Glue(a, b, t)) } 
  Map#Elements(Map#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(Map#Glue(a, b, t), t) } 
  $Is(Map#Glue(a, b, t), t));

function Map#Build<U,V>(Map U V, U, V) : Map U V;

axiom (forall<U,V> m: Map U V, u: U, u': U, v: V :: 
  { Map#Domain(Map#Build(m, u, v))[u'] } { Map#Elements(Map#Build(m, u, v))[u'] } 
  (u' == u
       ==> Map#Domain(Map#Build(m, u, v))[u'] && Map#Elements(Map#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> Map#Domain(Map#Build(m, u, v))[u'] == Map#Domain(m)[u']
         && Map#Elements(Map#Build(m, u, v))[u'] == Map#Elements(m)[u']));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  !Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m) + 1);

function Map#Equal<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m')
     <==> (forall u: U :: Map#Domain(m)[u] == Map#Domain(m')[u])
       && (forall u: U :: Map#Domain(m)[u] ==> Map#Elements(m)[u] == Map#Elements(m')[u]));

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m') ==> m == m');

function Map#Disjoint<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Disjoint(m, m') } 
  Map#Disjoint(m, m')
     <==> (forall o: U :: 
      { Map#Domain(m)[o] } { Map#Domain(m')[o] } 
      !Map#Domain(m)[o] || !Map#Domain(m')[o]));

type IMap _ _;

function IMap#Domain<U,V>(IMap U V) : Set U;

function IMap#Elements<U,V>(IMap U V) : [U]V;

function IMap#Values<U,V>(IMap U V) : Set V;

axiom (forall<U,V> m: IMap U V, v: V :: 
  { IMap#Values(m)[v] } 
  IMap#Values(m)[v]
     == (exists u: U :: 
      { IMap#Domain(m)[u] } { IMap#Elements(m)[u] } 
      IMap#Domain(m)[u] && v == IMap#Elements(m)[u]));

function IMap#Items<U,V>(IMap U V) : Set Box;

axiom (forall m: IMap Box Box, item: Box :: 
  { IMap#Items(m)[item] } 
  IMap#Items(m)[item]
     <==> IMap#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && IMap#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function IMap#Empty<U,V>() : IMap U V;

axiom (forall<U,V> u: U :: 
  { IMap#Domain(IMap#Empty(): IMap U V)[u] } 
  !IMap#Domain(IMap#Empty(): IMap U V)[u]);

function IMap#Glue<U,V>([U]bool, [U]V, Ty) : IMap U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Domain(IMap#Glue(a, b, t)) } 
  IMap#Domain(IMap#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Elements(IMap#Glue(a, b, t)) } 
  IMap#Elements(IMap#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(IMap#Glue(a, b, t), t) } 
  $Is(IMap#Glue(a, b, t), t));

function IMap#Build<U,V>(IMap U V, U, V) : IMap U V;

axiom (forall<U,V> m: IMap U V, u: U, u': U, v: V :: 
  { IMap#Domain(IMap#Build(m, u, v))[u'] } 
    { IMap#Elements(IMap#Build(m, u, v))[u'] } 
  (u' == u
       ==> IMap#Domain(IMap#Build(m, u, v))[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> IMap#Domain(IMap#Build(m, u, v))[u'] == IMap#Domain(m)[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == IMap#Elements(m)[u']));

function IMap#Equal<U,V>(IMap U V, IMap U V) : bool;

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m')
     <==> (forall u: U :: IMap#Domain(m)[u] == IMap#Domain(m')[u])
       && (forall u: U :: 
        IMap#Domain(m)[u] ==> IMap#Elements(m)[u] == IMap#Elements(m')[u]));

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m') ==> m == m');

function INTERNAL_add_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_add_boogie(x, y): int } 
  INTERNAL_add_boogie(x, y): int == x + y);

function INTERNAL_sub_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_sub_boogie(x, y): int } 
  INTERNAL_sub_boogie(x, y): int == x - y);

function INTERNAL_mul_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mul_boogie(x, y): int } 
  INTERNAL_mul_boogie(x, y): int == x * y);

function INTERNAL_div_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_div_boogie(x, y): int } 
  INTERNAL_div_boogie(x, y): int == x div y);

function INTERNAL_mod_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mod_boogie(x, y): int } 
  INTERNAL_mod_boogie(x, y): int == x mod y);

function {:never_pattern true} INTERNAL_lt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_lt_boogie(x, y): bool } 
  INTERNAL_lt_boogie(x, y): bool == (x < y));

function {:never_pattern true} INTERNAL_le_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_le_boogie(x, y): bool } 
  INTERNAL_le_boogie(x, y): bool == (x <= y));

function {:never_pattern true} INTERNAL_gt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_gt_boogie(x, y): bool } 
  INTERNAL_gt_boogie(x, y): bool == (x > y));

function {:never_pattern true} INTERNAL_ge_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_ge_boogie(x, y): bool } 
  INTERNAL_ge_boogie(x, y): bool == (x >= y));

function Mul(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mul(x, y): int } Mul(x, y): int == x * y);

function Div(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Div(x, y): int } Div(x, y): int == x div y);

function Mod(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mod(x, y): int } Mod(x, y): int == x mod y);

function Add(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Add(x, y): int } Add(x, y): int == x + y);

function Sub(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Sub(x, y): int } Sub(x, y): int == x - y);

function _System.__default.rank__is__less__than(A: Ty, B: Ty, a: Box, b: Box) : bool;

axiom (forall A: Ty, B: Ty, a: Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, a, b) ==> BoxRank(a) < BoxRank(b));

axiom (forall A: Ty, B: Ty, a: Box, b: Seq Box :: 
  { _System.__default.rank__is__less__than(A, B, a, $Box(b)), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, $Box(b)), Seq#Rank(b) } 
  _System.__default.rank__is__less__than(A, B, a, $Box(b))
     ==> BoxRank(a) < Seq#Rank(b));

axiom (forall A: Ty, B: Ty, a: Seq Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, $Box(a), b), Seq#Rank(a) } 
    { _System.__default.rank__is__less__than(A, B, $Box(a), b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, $Box(a), b)
     ==> Seq#Rank(a) < BoxRank(b));

function Tclass._System.nat() : Ty;

// Tclass._System.nat Tag
axiom Tag(Tclass._System.nat()) == Tagclass._System.nat;

const unique Tagclass._System.nat: TyTag;

// Box/unbox axiom for Tclass._System.nat
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.nat()) } 
  $IsBox(bx, Tclass._System.nat())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass._System.nat()));

// _System.nat: subset type $Is
axiom (forall x#0: int :: 
  { $Is(x#0, Tclass._System.nat()) } 
  $Is(x#0, Tclass._System.nat()) <==> LitInt(0) <= x#0);

// _System.nat: subset type $IsAlloc
axiom (forall x#0: int, $h: Heap :: 
  { $IsAlloc(x#0, Tclass._System.nat(), $h) } 
  $IsAlloc(x#0, Tclass._System.nat(), $h));

const unique class._System.object?: ClassName;

// Tclass._System.object? Tag
axiom Tag(Tclass._System.object?()) == Tagclass._System.object?;

const unique Tagclass._System.object?: TyTag;

// Box/unbox axiom for Tclass._System.object?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object?()) } 
  $IsBox(bx, Tclass._System.object?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object?()));

// object: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.object?()) } 
  $Is($o, Tclass._System.object?()));

// object: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.object?(), $h) } 
  $IsAlloc($o, Tclass._System.object?(), $h)
     <==> $o == null || read($h, $o, alloc));

function implements$_System.object(Ty) : bool;

function Tclass._System.object() : Ty;

// Tclass._System.object Tag
axiom Tag(Tclass._System.object()) == Tagclass._System.object;

const unique Tagclass._System.object: TyTag;

// Box/unbox axiom for Tclass._System.object
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object()) } 
  $IsBox(bx, Tclass._System.object())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object()));

// _System.object: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass._System.object()) } 
  $Is(c#0, Tclass._System.object())
     <==> $Is(c#0, Tclass._System.object?()) && c#0 != null);

// _System.object: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.object(), $h) } 
  $IsAlloc(c#0, Tclass._System.object(), $h)
     <==> $IsAlloc(c#0, Tclass._System.object?(), $h));

const unique class._System.array?: ClassName;

function Tclass._System.array?(Ty) : Ty;

// Tclass._System.array? Tag
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tag(Tclass._System.array?(#$arg)) == Tagclass._System.array?);

const unique Tagclass._System.array?: TyTag;

// Tclass._System.array? injectivity 0
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tclass._System.array?_0(Tclass._System.array?(#$arg)) == #$arg);

function Tclass._System.array?_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array?
axiom (forall #$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array?(#$arg)) } 
  $IsBox(bx, Tclass._System.array?(#$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array?(#$arg)));

// array.: Type axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
     ==> $IsBox(read($h, $o, IndexField($i0)), #$arg));

// array.: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
       && read($h, $o, alloc)
     ==> $IsAllocBox(read($h, $o, IndexField($i0)), #$arg, $h));

// array: Class $Is
axiom (forall #$arg: Ty, $o: ref :: 
  { $Is($o, Tclass._System.array?(#$arg)) } 
  $Is($o, Tclass._System.array?(#$arg))
     <==> $o == null || dtype($o) == Tclass._System.array?(#$arg));

// array: Class $IsAlloc
axiom (forall #$arg: Ty, $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.array?(#$arg), $h) } 
  $IsAlloc($o, Tclass._System.array?(#$arg), $h)
     <==> $o == null || read($h, $o, alloc));

// array.Length: Type axiom
axiom (forall #$arg: Ty, $o: ref :: 
  { _System.array.Length($o), Tclass._System.array?(#$arg) } 
  $o != null && dtype($o) == Tclass._System.array?(#$arg)
     ==> $Is(_System.array.Length($o), TInt));

// array.Length: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref :: 
  { _System.array.Length($o), read($h, $o, alloc), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && read($h, $o, alloc)
     ==> $IsAlloc(_System.array.Length($o), TInt, $h));

function Tclass._System.array(Ty) : Ty;

// Tclass._System.array Tag
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tag(Tclass._System.array(_System.array$arg)) == Tagclass._System.array);

const unique Tagclass._System.array: TyTag;

// Tclass._System.array injectivity 0
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tclass._System.array_0(Tclass._System.array(_System.array$arg))
     == _System.array$arg);

function Tclass._System.array_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array
axiom (forall _System.array$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array(_System.array$arg)) } 
  $IsBox(bx, Tclass._System.array(_System.array$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array(_System.array$arg)));

// _System.array: subset type $Is
axiom (forall _System.array$arg: Ty, c#0: ref :: 
  { $Is(c#0, Tclass._System.array(_System.array$arg)) } 
  $Is(c#0, Tclass._System.array(_System.array$arg))
     <==> $Is(c#0, Tclass._System.array?(_System.array$arg)) && c#0 != null);

// _System.array: subset type $IsAlloc
axiom (forall _System.array$arg: Ty, c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h) } 
  $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h)
     <==> $IsAlloc(c#0, Tclass._System.array?(_System.array$arg), $h));

function Tclass._System.___hFunc0(Ty) : Ty;

// Tclass._System.___hFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tag(Tclass._System.___hFunc0(#$R)) == Tagclass._System.___hFunc0);

const unique Tagclass._System.___hFunc0: TyTag;

// Tclass._System.___hFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tclass._System.___hFunc0_0(Tclass._System.___hFunc0(#$R)) == #$R);

function Tclass._System.___hFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc0(#$R)));

function Handle0([Heap]Box, [Heap]bool, [Heap]Set Box) : HandleType;

function Apply0(Ty, Heap, HandleType) : Box;

function Requires0(Ty, Heap, HandleType) : bool;

function Reads0(Ty, Heap, HandleType) : Set Box;

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Apply0(t0, heap, Handle0(h, r, rd)) } 
  Apply0(t0, heap, Handle0(h, r, rd)) == h[heap]);

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Requires0(t0, heap, Handle0(h, r, rd)) } 
  r[heap] ==> Requires0(t0, heap, Handle0(h, r, rd)));

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box, bx: Box :: 
  { Reads0(t0, heap, Handle0(h, r, rd))[bx] } 
  Reads0(t0, heap, Handle0(h, r, rd))[bx] == rd[heap][bx]);

function {:inline} Requires0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

function {:inline} Reads0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// empty-reads property for Reads0 
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Reads0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Reads0(t0, heap, f) } 
  $IsGoodHeap(heap) && $Is(f, Tclass._System.___hFunc0(t0))
     ==> (Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
       <==> Set#Equal(Reads0(t0, heap, f), Set#Empty(): Set Box)));

// empty-reads property for Requires0
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Requires0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Requires0(t0, heap, f) } 
  $IsGoodHeap(heap)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
     ==> Requires0(t0, $OneHeap, f) == Requires0(t0, heap, f));

axiom (forall f: HandleType, t0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
     <==> (forall h: Heap :: 
      { Apply0(t0, h, f) } 
      $IsGoodHeap(h) && Requires0(t0, h, f) ==> $IsBox(Apply0(t0, h, f), t0)));

axiom (forall f: HandleType, t0: Ty, u0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)), $Is(f, Tclass._System.___hFunc0(u0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t0) } { $IsBox(bx, u0) } 
        $IsBox(bx, t0) ==> $IsBox(bx, u0))
     ==> $Is(f, Tclass._System.___hFunc0(u0)));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc0(t0), h)
       <==> Requires0(t0, h, f)
         ==> (forall r: ref :: 
          { Reads0(t0, h, f)[$Box(r)] } 
          r != null && Reads0(t0, h, f)[$Box(r)] ==> read(h, r, alloc))));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc0(t0), h)
     ==> 
    Requires0(t0, h, f)
     ==> $IsAllocBox(Apply0(t0, h, f), t0, h));

function Tclass._System.___hPartialFunc0(Ty) : Ty;

// Tclass._System.___hPartialFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tag(Tclass._System.___hPartialFunc0(#$R)) == Tagclass._System.___hPartialFunc0);

const unique Tagclass._System.___hPartialFunc0: TyTag;

// Tclass._System.___hPartialFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tclass._System.___hPartialFunc0_0(Tclass._System.___hPartialFunc0(#$R)) == #$R);

function Tclass._System.___hPartialFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc0(#$R)));

// _System._#PartialFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hFunc0(#$R))
       && Set#Equal(Reads0(#$R, $OneHeap, f#0), Set#Empty(): Set Box));

// _System._#PartialFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc0(#$R), $h));

function Tclass._System.___hTotalFunc0(Ty) : Ty;

// Tclass._System.___hTotalFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tag(Tclass._System.___hTotalFunc0(#$R)) == Tagclass._System.___hTotalFunc0);

const unique Tagclass._System.___hTotalFunc0: TyTag;

// Tclass._System.___hTotalFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tclass._System.___hTotalFunc0_0(Tclass._System.___hTotalFunc0(#$R)) == #$R);

function Tclass._System.___hTotalFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc0(#$R)));

// _System._#TotalFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) && Requires0(#$R, $OneHeap, f#0));

// _System._#TotalFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h));

const unique class._System.__default: ClassName;

function Tclass._System.__default() : Ty;

// Tclass._System.__default Tag
axiom Tag(Tclass._System.__default()) == Tagclass._System.__default;

const unique Tagclass._System.__default: TyTag;

// Box/unbox axiom for Tclass._System.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.__default()) } 
  $IsBox(bx, Tclass._System.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.__default()) } 
  $Is($o, Tclass._System.__default())
     <==> $o == null || dtype($o) == Tclass._System.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.__default(), $h) } 
  $IsAlloc($o, Tclass._System.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function _System.__default.rank__is__less__than#canCall(#$A: Ty, #$B: Ty, a#0: Box, b#0: Box) : bool;

// consequence axiom for _System.__default.rank__is__less__than
axiom true
   ==> (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
    { _System.__default.rank__is__less__than(#$A, #$B, a#0, b#0) } 
    _System.__default.rank__is__less__than#canCall(#$A, #$B, a#0, b#0)
         || ($IsBox(a#0, #$A) && $IsBox(b#0, #$B))
       ==> true);

function _System.__default.rank__is__less__than#requires(Ty, Ty, Box, Box) : bool;

// #requires axiom for _System.__default.rank__is__less__than
axiom (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
  { _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) } 
  $IsBox(a#0, #$A) && $IsBox(b#0, #$B)
     ==> _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) == true);

function Tclass._System.___hFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hFunc2);

const unique Tagclass._System.___hFunc2: TyTag;

// Tclass._System.___hFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_0(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hFunc2_0(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_1(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hFunc2_1(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_2(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$R);

function Tclass._System.___hFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc2(#$T0, #$T1, #$R)));

function Handle2([Heap,Box,Box]Box, [Heap,Box,Box]bool, [Heap,Box,Box]Set Box) : HandleType;

function Apply2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Box;

function Requires2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : bool;

function Reads2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) == h[heap, bx0, bx1]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  r[heap, bx0, bx1] ==> Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx: Box :: 
  { Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx] } 
  Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx]
     == rd[heap, bx0, bx1][bx]);

function {:inline} Requires2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

function {:inline} Reads2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// empty-reads property for Reads2 
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Reads2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     ==> (Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
       <==> Set#Equal(Reads2(t0, t1, t2, heap, f, bx0, bx1), Set#Empty(): Set Box)));

// empty-reads property for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Requires2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
     ==> Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1)
       == Requires2(t0, t1, t2, heap, f, bx0, bx1));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     <==> (forall h: Heap, bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, u0: Ty, u1: Ty, u2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)), $Is(f, Tclass._System.___hFunc2(u0, u1, u2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, t2) } { $IsBox(bx, u2) } 
        $IsBox(bx, t2) ==> $IsBox(bx, u2))
     ==> $Is(f, Tclass._System.___hFunc2(u0, u1, u2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
       <==> (forall bx0: Box, bx1: Box :: 
        { Apply2(t0, t1, t2, h, f, bx0, bx1) } { Reads2(t0, t1, t2, h, f, bx0, bx1) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && Requires2(t0, t1, t2, h, f, bx0, bx1)
           ==> (forall r: ref :: 
            { Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] } 
            r != null && Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
     ==> (forall bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsAllocBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2, h)));

function Tclass._System.___hPartialFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hPartialFunc2);

const unique Tagclass._System.___hPartialFunc2: TyTag;

// Tclass._System.___hPartialFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_0(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc2_0(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_1(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc2_1(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_2(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hPartialFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)));

// _System._#PartialFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Set#Equal(Reads2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0), Set#Empty(): Set Box)));

// _System._#PartialFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hTotalFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hTotalFunc2);

const unique Tagclass._System.___hTotalFunc2: TyTag;

// Tclass._System.___hTotalFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_0(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc2_0(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_1(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc2_1(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_2(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hTotalFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)));

// _System._#TotalFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Requires2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0)));

// _System._#TotalFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hFunc1(Ty, Ty) : Ty;

// Tclass._System.___hFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hFunc1(#$T0, #$R)) == Tagclass._System.___hFunc1);

const unique Tagclass._System.___hFunc1: TyTag;

// Tclass._System.___hFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_0(Tclass._System.___hFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hFunc1_0(Ty) : Ty;

// Tclass._System.___hFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_1(Tclass._System.___hFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc1(#$T0, #$R)));

function Handle1([Heap,Box]Box, [Heap,Box]bool, [Heap,Box]Set Box) : HandleType;

function Requires1(Ty, Ty, Heap, HandleType, Box) : bool;

function Reads1(Ty, Ty, Heap, HandleType, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) == h[heap, bx0]);

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Requires1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  r[heap, bx0] ==> Requires1(t0, t1, heap, Handle1(h, r, rd), bx0));

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box, 
    bx: Box :: 
  { Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] } 
  Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] == rd[heap, bx0][bx]);

function {:inline} Requires1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

function {:inline} Reads1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// empty-reads property for Reads1 
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Reads1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Reads1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1))
     ==> (Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
       <==> Set#Equal(Reads1(t0, t1, heap, f, bx0), Set#Empty(): Set Box)));

// empty-reads property for Requires1
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Requires1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Requires1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
     ==> Requires1(t0, t1, $OneHeap, f, bx0) == Requires1(t0, t1, heap, f, bx0));

axiom (forall f: HandleType, t0: Ty, t1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
     <==> (forall h: Heap, bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsGoodHeap(h) && $IsBox(bx0, t0) && Requires1(t0, t1, h, f, bx0)
         ==> $IsBox(Apply1(t0, t1, h, f, bx0), t1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, u0: Ty, u1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)), $Is(f, Tclass._System.___hFunc1(u0, u1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t1) } { $IsBox(bx, u1) } 
        $IsBox(bx, t1) ==> $IsBox(bx, u1))
     ==> $Is(f, Tclass._System.___hFunc1(u0, u1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
       <==> (forall bx0: Box :: 
        { Apply1(t0, t1, h, f, bx0) } { Reads1(t0, t1, h, f, bx0) } 
        $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
           ==> (forall r: ref :: 
            { Reads1(t0, t1, h, f, bx0)[$Box(r)] } 
            r != null && Reads1(t0, t1, h, f, bx0)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
     ==> (forall bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
         ==> $IsAllocBox(Apply1(t0, t1, h, f, bx0), t1, h)));

function Tclass._System.___hPartialFunc1(Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == Tagclass._System.___hPartialFunc1);

const unique Tagclass._System.___hPartialFunc1: TyTag;

// Tclass._System.___hPartialFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_0(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc1_0(Ty) : Ty;

// Tclass._System.___hPartialFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_1(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$R);

function Tclass._System.___hPartialFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc1(#$T0, #$R)));

// _System._#PartialFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0)
           ==> Set#Equal(Reads1(#$T0, #$R, $OneHeap, f#0, x0#0), Set#Empty(): Set Box)));

// _System._#PartialFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc1(#$T0, #$R), $h));

function Tclass._System.___hTotalFunc1(Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hTotalFunc1(#$T0, #$R)) == Tagclass._System.___hTotalFunc1);

const unique Tagclass._System.___hTotalFunc1: TyTag;

// Tclass._System.___hTotalFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_0(Tclass._System.___hTotalFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc1_0(Ty) : Ty;

// Tclass._System.___hTotalFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_1(Tclass._System.___hTotalFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hTotalFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc1(#$T0, #$R)));

// _System._#TotalFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0) ==> Requires1(#$T0, #$R, $OneHeap, f#0, x0#0)));

// _System._#TotalFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h));

// Constructor function declaration
function #_System._tuple#2._#Make2(Box, Box) : DatatypeType;

const unique ##_System._tuple#2._#Make2: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#_System._tuple#2._#Make2(a#0#0#0, a#0#1#0))
     == ##_System._tuple#2._#Make2);

function _System.Tuple2.___hMake2_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#2._#Make2);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     ==> (exists a#1#0#0: Box, a#1#1#0: Box :: 
      d == #_System._tuple#2._#Make2(a#1#0#0, a#1#1#0)));

function Tclass._System.Tuple2(Ty, Ty) : Ty;

// Tclass._System.Tuple2 Tag
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tag(Tclass._System.Tuple2(#$T0, #$T1)) == Tagclass._System.Tuple2);

const unique Tagclass._System.Tuple2: TyTag;

// Tclass._System.Tuple2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_0(Tclass._System.Tuple2(#$T0, #$T1)) == #$T0);

function Tclass._System.Tuple2_0(Ty) : Ty;

// Tclass._System.Tuple2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_1(Tclass._System.Tuple2(#$T0, #$T1)) == #$T1);

function Tclass._System.Tuple2_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.Tuple2
axiom (forall #$T0: Ty, #$T1: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple2(#$T0, #$T1)));

// Constructor $Is
axiom (forall #$T0: Ty, #$T1: Ty, a#2#0#0: Box, a#2#1#0: Box :: 
  { $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1))
     <==> $IsBox(a#2#0#0, #$T0) && $IsBox(a#2#1#0, #$T1));

// Constructor $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, a#3#0#0: Box, a#3#1#0: Box, $h: Heap :: 
  { $IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
      Tclass._System.Tuple2(#$T0, #$T1), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
        Tclass._System.Tuple2(#$T0, #$T1), 
        $h)
       <==> $IsAllocBox(a#3#0#0, #$T0, $h) && $IsAllocBox(a#3#1#0, #$T1, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T0: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._0(d), #$T0, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T1: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._0(d), #$T0, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T1: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._1(d), #$T1, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T0: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._1(d), #$T1, $h));

// Constructor literal
axiom (forall a#4#0#0: Box, a#4#1#0: Box :: 
  { #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#_System._tuple#2._#Make2(a#4#0#0, a#4#1#0)));

// Constructor injectivity
axiom (forall a#5#0#0: Box, a#5#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#5#0#0, a#5#1#0) } 
  _System.Tuple2._0(#_System._tuple#2._#Make2(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: Box, a#6#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#6#0#0, a#6#1#0) } 
  BoxRank(a#6#0#0) < DtRank(#_System._tuple#2._#Make2(a#6#0#0, a#6#1#0)));

// Constructor injectivity
axiom (forall a#7#0#0: Box, a#7#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#7#0#0, a#7#1#0) } 
  _System.Tuple2._1(#_System._tuple#2._#Make2(a#7#0#0, a#7#1#0)) == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: Box, a#8#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#8#0#0, a#8#1#0) } 
  BoxRank(a#8#1#0) < DtRank(#_System._tuple#2._#Make2(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#_System.Tuple2(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple2(d) } 
  $IsA#_System.Tuple2(d) ==> _System.Tuple2.___hMake2_q(d));

// Questionmark data type disjunctivity
axiom (forall #$T0: Ty, #$T1: Ty, d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d), $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) ==> _System.Tuple2.___hMake2_q(d));

// Datatype extensional equality declaration
function _System.Tuple2#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#2._#Make2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  true
     ==> (_System.Tuple2#Equal(a, b)
       <==> _System.Tuple2._0(a) == _System.Tuple2._0(b)
         && _System.Tuple2._1(a) == _System.Tuple2._1(b)));

// Datatype extensionality axiom: _System._tuple#2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  _System.Tuple2#Equal(a, b) <==> a == b);

const unique class._System.Tuple2: ClassName;

function Tclass._System.___hFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hFunc3);

const unique Tagclass._System.___hFunc3: TyTag;

// Tclass._System.___hFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_0(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hFunc3_0(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_1(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hFunc3_1(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_2(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hFunc3_2(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_3(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)));

function Handle3([Heap,Box,Box,Box]Box, [Heap,Box,Box,Box]bool, [Heap,Box,Box,Box]Set Box)
   : HandleType;

function Apply3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Box;

function Requires3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : bool;

function Reads3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)
     == h[heap, bx0, bx1, bx2]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  r[heap, bx0, bx1, bx2]
     ==> Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx: Box :: 
  { Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx] } 
  Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx]
     == rd[heap, bx0, bx1, bx2][bx]);

function {:inline} Requires3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

function {:inline} Reads3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// empty-reads property for Reads3 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     ==> (Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
       <==> Set#Equal(Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2), Set#Empty(): Set Box)));

// empty-reads property for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
     ==> Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)), $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, t3) } { $IsBox(bx, u3) } 
        $IsBox(bx, t3) ==> $IsBox(bx, u3))
     ==> $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box :: 
        { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
          { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
           ==> (forall r: ref :: 
            { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)] } 
            r != null && Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsAllocBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3, h)));

function Tclass._System.___hPartialFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hPartialFunc3);

const unique Tagclass._System.___hPartialFunc3: TyTag;

// Tclass._System.___hPartialFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_0(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc3_0(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_1(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc3_1(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_2(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc3_2(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_3(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hPartialFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#PartialFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Set#Equal(Reads3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hTotalFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hTotalFunc3);

const unique Tagclass._System.___hTotalFunc3: TyTag;

// Tclass._System.___hTotalFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_0(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc3_0(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_1(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc3_1(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_2(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc3_2(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_3(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hTotalFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#TotalFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Requires3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0)));

// _System._#TotalFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hFunc4);

const unique Tagclass._System.___hFunc4: TyTag;

// Tclass._System.___hFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_0(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hFunc4_0(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_1(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hFunc4_1(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_2(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hFunc4_2(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_3(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hFunc4_3(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_4(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

function Handle4([Heap,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Box;

function Requires4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : bool;

function Reads4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)
     == h[heap, bx0, bx1, bx2, bx3]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  r[heap, bx0, bx1, bx2, bx3]
     ==> Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx: Box :: 
  { Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx] } 
  Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx]
     == rd[heap, bx0, bx1, bx2, bx3][bx]);

function {:inline} Requires4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

function {:inline} Reads4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// empty-reads property for Reads4 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     ==> (Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set Box)));

// empty-reads property for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
     ==> Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)), $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, t4) } { $IsBox(bx, u4) } 
        $IsBox(bx, t4) ==> $IsBox(bx, u4))
     ==> $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
        { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
          { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
           ==> (forall r: ref :: 
            { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)] } 
            r != null && Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsAllocBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4, h)));

function Tclass._System.___hPartialFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hPartialFunc4);

const unique Tagclass._System.___hPartialFunc4: TyTag;

// Tclass._System.___hPartialFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_0(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc4_0(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_1(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc4_1(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_2(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc4_2(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_3(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc4_3(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_4(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hPartialFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#PartialFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Set#Equal(Reads4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hTotalFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hTotalFunc4);

const unique Tagclass._System.___hTotalFunc4: TyTag;

// Tclass._System.___hTotalFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_0(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc4_0(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_1(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc4_1(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_2(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc4_2(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_3(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc4_3(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_4(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hTotalFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#TotalFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Requires4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0)));

// _System._#TotalFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

// Constructor function declaration
function #_System._tuple#0._#Make0() : DatatypeType;

const unique ##_System._tuple#0._#Make0: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#_System._tuple#0._#Make0()) == ##_System._tuple#0._#Make0;

function _System.Tuple0.___hMake0_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#0._#Make0);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d) ==> d == #_System._tuple#0._#Make0());

function Tclass._System.Tuple0() : Ty;

// Tclass._System.Tuple0 Tag
axiom Tag(Tclass._System.Tuple0()) == Tagclass._System.Tuple0;

const unique Tagclass._System.Tuple0: TyTag;

// Box/unbox axiom for Tclass._System.Tuple0
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple0()) } 
  $IsBox(bx, Tclass._System.Tuple0())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple0()));

// Constructor $Is
axiom $Is(#_System._tuple#0._#Make0(), Tclass._System.Tuple0());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h));

// Constructor literal
axiom #_System._tuple#0._#Make0() == Lit(#_System._tuple#0._#Make0());

// Depth-one case-split function
function $IsA#_System.Tuple0(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple0(d) } 
  $IsA#_System.Tuple0(d) ==> _System.Tuple0.___hMake0_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d), $Is(d, Tclass._System.Tuple0()) } 
  $Is(d, Tclass._System.Tuple0()) ==> _System.Tuple0.___hMake0_q(d));

// Datatype extensional equality declaration
function _System.Tuple0#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#0._#Make0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  true ==> (_System.Tuple0#Equal(a, b) <==> true));

// Datatype extensionality axiom: _System._tuple#0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  _System.Tuple0#Equal(a, b) <==> a == b);

const unique class._System.Tuple0: ClassName;

const BaseFuel_Sequences._default.NoDupes: LayerType;

const StartFuel_Sequences._default.NoDupes: LayerType;

const StartFuelAssert_Sequences._default.NoDupes: LayerType;

const BaseFuel_Sequences._default.Range: LayerType;

const StartFuel_Sequences._default.Range: LayerType;

const StartFuelAssert_Sequences._default.Range: LayerType;

const BaseFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuelAssert_Sequences._default.ApplyOpaque: LayerType;

const BaseFuel_Sequences._default.remove: LayerType;

const StartFuel_Sequences._default.remove: LayerType;

const StartFuelAssert_Sequences._default.remove: LayerType;

const BaseFuel_Sequences._default.insert: LayerType;

const StartFuel_Sequences._default.insert: LayerType;

const StartFuelAssert_Sequences._default.insert: LayerType;

const BaseFuel_Sequences._default.replace1with2: LayerType;

const StartFuel_Sequences._default.replace1with2: LayerType;

const StartFuelAssert_Sequences._default.replace1with2: LayerType;

const BaseFuel_Sequences._default.replace2with1: LayerType;

const StartFuel_Sequences._default.replace2with1: LayerType;

const StartFuelAssert_Sequences._default.replace2with1: LayerType;

const BaseFuel_Sequences._default.concat: LayerType;

const StartFuel_Sequences._default.concat: LayerType;

const StartFuelAssert_Sequences._default.concat: LayerType;

const BaseFuel_Sequences._default.concat3: LayerType;

const StartFuel_Sequences._default.concat3: LayerType;

const StartFuelAssert_Sequences._default.concat3: LayerType;

const BaseFuel_Sequences._default.concatSeq: LayerType;

const StartFuel_Sequences._default.concatSeq: LayerType;

const StartFuelAssert_Sequences._default.concatSeq: LayerType;

const BaseFuel_Sequences._default.IsPrefix: LayerType;

const StartFuel_Sequences._default.IsPrefix: LayerType;

const StartFuelAssert_Sequences._default.IsPrefix: LayerType;

const BaseFuel_Sequences._default.IsSuffix: LayerType;

const StartFuel_Sequences._default.IsSuffix: LayerType;

const StartFuelAssert_Sequences._default.IsSuffix: LayerType;

const BaseFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexIterate: LayerType;

const BaseFuel_Sequences._default.SeqIndex: LayerType;

const StartFuel_Sequences._default.SeqIndex: LayerType;

const StartFuelAssert_Sequences._default.SeqIndex: LayerType;

const BaseFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuelAssert_Sequences._default.SeqOfLength: LayerType;

const BaseFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexUpdate: LayerType;

const BaseFuel_Sequences._default.Zip: LayerType;

const StartFuel_Sequences._default.Zip: LayerType;

const StartFuelAssert_Sequences._default.Zip: LayerType;

const BaseFuel_Sequences._default.Unzip: LayerType;

const StartFuel_Sequences._default.Unzip: LayerType;

const StartFuelAssert_Sequences._default.Unzip: LayerType;

const BaseFuel_Sequences._default.FlattenShape: LayerType;

const StartFuel_Sequences._default.FlattenShape: LayerType;

const StartFuelAssert_Sequences._default.FlattenShape: LayerType;

const BaseFuel_Sequences._default.FlattenLength: LayerType;

const StartFuel_Sequences._default.FlattenLength: LayerType;

const StartFuelAssert_Sequences._default.FlattenLength: LayerType;

const BaseFuel_Sequences._default.Flatten: LayerType;

const StartFuel_Sequences._default.Flatten: LayerType;

const StartFuelAssert_Sequences._default.Flatten: LayerType;

const BaseFuel_Sequences._default.fill: LayerType;

const StartFuel_Sequences._default.fill: LayerType;

const StartFuelAssert_Sequences._default.fill: LayerType;

const unique class.Arrays.__default: ClassName;

function Tclass.Arrays.__default() : Ty;

// Tclass.Arrays.__default Tag
axiom Tag(Tclass.Arrays.__default()) == Tagclass.Arrays.__default;

const unique Tagclass.Arrays.__default: TyTag;

// Box/unbox axiom for Tclass.Arrays.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Arrays.__default()) } 
  $IsBox(bx, Tclass.Arrays.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Arrays.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Arrays.__default()) } 
  $Is($o, Tclass.Arrays.__default())
     <==> $o == null || dtype($o) == Tclass.Arrays.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Arrays.__default(), $h) } 
  $IsAlloc($o, Tclass.Arrays.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Arrays._default.Aliases
function Arrays.__default.Aliases(Arrays._default.Aliases$T: Ty, 
    Arrays._default.Aliases$U: Ty, 
    a1#0: ref, 
    a2#0: ref)
   : bool;

function Arrays.__default.Aliases#canCall(Arrays._default.Aliases$T: Ty, 
    Arrays._default.Aliases$U: Ty, 
    a1#0: ref, 
    a2#0: ref)
   : bool;

// consequence axiom for Arrays.__default.Aliases
axiom 1 <= $FunctionContextHeight
   ==> (forall Arrays._default.Aliases$T: Ty, 
      Arrays._default.Aliases$U: Ty, 
      a1#0: ref, 
      a2#0: ref :: 
    { Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0) } 
    Arrays.__default.Aliases#canCall(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0)
         || (1 != $FunctionContextHeight
           && 
          $Is(a1#0, Tclass._System.array(Arrays._default.Aliases$T))
           && $Is(a2#0, Tclass._System.array(Arrays._default.Aliases$U)))
       ==> true);

function Arrays.__default.Aliases#requires(Ty, Ty, ref, ref) : bool;

// #requires axiom for Arrays.__default.Aliases
axiom (forall Arrays._default.Aliases$T: Ty, 
    Arrays._default.Aliases$U: Ty, 
    a1#0: ref, 
    a2#0: ref :: 
  { Arrays.__default.Aliases#requires(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0) } 
  $Is(a1#0, Tclass._System.array(Arrays._default.Aliases$T))
       && $Is(a2#0, Tclass._System.array(Arrays._default.Aliases$U))
     ==> Arrays.__default.Aliases#requires(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0)
       == true);

// definition axiom for Arrays.__default.Aliases(revealed)
axiom 1 <= $FunctionContextHeight
   ==> (forall Arrays._default.Aliases$T: Ty, 
      Arrays._default.Aliases$U: Ty, 
      a1#0: ref, 
      a2#0: ref :: 
    { Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0) } 
    Arrays.__default.Aliases#canCall(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0)
         || (1 != $FunctionContextHeight
           && 
          $Is(a1#0, Tclass._System.array(Arrays._default.Aliases$T))
           && $Is(a2#0, Tclass._System.array(Arrays._default.Aliases$U)))
       ==> Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0)
         == 
        (a1#0
         == a2#0));

// definition axiom for Arrays.__default.Aliases for all literals(revealed)
axiom 1 <= $FunctionContextHeight
   ==> (forall Arrays._default.Aliases$T: Ty, 
      Arrays._default.Aliases$U: Ty, 
      a1#0: ref, 
      a2#0: ref :: 
    {:weight 3} { Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, Lit(a1#0), Lit(a2#0)) } 
    Arrays.__default.Aliases#canCall(Arrays._default.Aliases$T, Arrays._default.Aliases$U, Lit(a1#0), Lit(a2#0))
         || (1 != $FunctionContextHeight
           && 
          $Is(a1#0, Tclass._System.array(Arrays._default.Aliases$T))
           && $Is(a2#0, Tclass._System.array(Arrays._default.Aliases$U)))
       ==> Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, Lit(a1#0), Lit(a2#0))
         == 
        (Lit(a1#0)
         == Lit(a2#0)));

procedure CheckWellformed$$Arrays.__default.Aliases(Arrays._default.Aliases$T: Ty, 
    Arrays._default.Aliases$U: Ty, 
    a1#0: ref where $Is(a1#0, Tclass._System.array(Arrays._default.Aliases$T)), 
    a2#0: ref where $Is(a2#0, Tclass._System.array(Arrays._default.Aliases$U)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure CheckWellformed$$Arrays.__default.SequenceLength(Arrays._default.SequenceLength$T: Ty, 
    a#0: ref
       where $Is(a#0, Tclass._System.array(Arrays._default.SequenceLength$T))
         && $IsAlloc(a#0, Tclass._System.array(Arrays._default.SequenceLength$T), $Heap), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    end#0: int where LitInt(0) <= end#0 && end#0 < 18446744073709551616);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$Arrays.__default.SequenceLength(Arrays._default.SequenceLength$T: Ty, a#0: ref, start#0: int, end#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;

    // AddMethodImpl: SequenceLength, CheckWellformed$$Arrays.__default.SequenceLength
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(16,8): initial state"} true;
    newtype$check#0 := start#0;
    assert LitInt(0) <= newtype$check#0;
    newtype$check#1 := end#0;
    assert LitInt(0) <= newtype$check#1;
    if (start#0 <= end#0)
    {
        newtype$check#2 := end#0;
        assert LitInt(0) <= newtype$check#2;
        assert a#0 != null;
    }

    assume start#0 <= end#0 && end#0 <= _System.array.Length(a#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(18,28): post-state"} true;
    assert a#0 != null;
    assert 0 <= start#0 && start#0 <= _System.array.Length(a#0);
    assert start#0 <= end#0 && end#0 <= _System.array.Length(a#0);
    newtype$check#3 := end#0 - start#0;
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := end#0 - start#0;
    assert LitInt(0) <= newtype$check#4;
    assume Seq#Length(Seq#Drop(Seq#Take(Seq#FromArray($Heap, a#0), end#0), start#0))
       == end#0 - start#0;
}



procedure Call$$Arrays.__default.SequenceLength(Arrays._default.SequenceLength$T: Ty, 
    a#0: ref
       where $Is(a#0, Tclass._System.array(Arrays._default.SequenceLength$T))
         && $IsAlloc(a#0, Tclass._System.array(Arrays._default.SequenceLength$T), $Heap), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    end#0: int where LitInt(0) <= end#0 && end#0 < 18446744073709551616);
  // user-defined preconditions
  requires start#0 <= end#0;
  requires end#0 <= _System.array.Length(a#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Seq#Length(Seq#Drop(Seq#Take(Seq#FromArray($Heap, a#0), end#0), start#0))
     == end#0 - start#0;
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$Arrays.__default.SequenceLength(Arrays._default.SequenceLength$T: Ty, 
    a#0: ref
       where $Is(a#0, Tclass._System.array(Arrays._default.SequenceLength$T))
         && $IsAlloc(a#0, Tclass._System.array(Arrays._default.SequenceLength$T), $Heap), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    end#0: int where LitInt(0) <= end#0 && end#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  // user-defined preconditions
  requires start#0 <= end#0;
  requires end#0 <= _System.array.Length(a#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Seq#Length(Seq#Drop(Seq#Take(Seq#FromArray($Heap, a#0), end#0), start#0))
     == end#0 - start#0;
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$Arrays.__default.SequenceLength(Arrays._default.SequenceLength$T: Ty, a#0: ref, start#0: int, end#0: int)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: SequenceLength, Impl$$Arrays.__default.SequenceLength
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(19,2): initial state"} true;
    $_reverifyPost := false;
}



procedure CheckWellformed$$Arrays.__default.Insert(Arrays._default.Insert$T: Ty, 
    arr#0: ref
       where $Is(arr#0, Tclass._System.array(Arrays._default.Insert$T))
         && $IsAlloc(arr#0, Tclass._System.array(Arrays._default.Insert$T), $Heap), 
    length#0: int where LitInt(0) <= length#0 && length#0 < 18446744073709551616, 
    element#0: Box
       where $IsBox(element#0, Arrays._default.Insert$T)
         && $IsAllocBox(element#0, Arrays._default.Insert$T, $Heap), 
    pos#0: int where LitInt(0) <= pos#0 && pos#0 < 18446744073709551616);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$Arrays.__default.Insert(Arrays._default.Insert$T: Ty, 
    arr#0: ref, 
    length#0: int, 
    element#0: Box, 
    pos#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##s#0: Seq Box;
  var ##a#0: Box;
  var ##pos#0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;

    // AddMethodImpl: Insert, CheckWellformed$$Arrays.__default.Insert
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == arr#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(22,9): initial state"} true;
    if (LitInt(0) <= length#0)
    {
        assert arr#0 != null;
    }

    if (LitInt(0) <= length#0 && length#0 < _System.array.Length(arr#0))
    {
        assert arr#0 != null;
        assume NativeTypes.__default.Uint64UpperBound#canCall();
    }

    assume LitInt(0) <= length#0
       && length#0 < _System.array.Length(arr#0)
       && _System.array.Length(arr#0) < NativeTypes.__default.Uint64UpperBound();
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= pos#0)
    {
    }

    assume LitInt(0) <= pos#0 && pos#0 <= length#0;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o] || $o == arr#0);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(25,28): post-state"} true;
    assert arr#0 != null;
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := length#0 + 1;
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assert 0 <= length#0 + 1 && length#0 + 1 <= _System.array.Length(arr#0);
    assert arr#0 != null;
    assert 0 <= length#0 && length#0 <= _System.array.Length(arr#0);
    ##s#0 := Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Arrays._default.Insert$T), $Heap);
    ##a#0 := element#0;
    // assume allocatedness for argument to function
    assume $IsAllocBox(##a#0, Arrays._default.Insert$T, $Heap);
    ##pos#0 := pos#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pos#0, TInt, $Heap);
    assert {:subsumption 0} LitInt(0) <= ##pos#0;
    assert {:subsumption 0} ##pos#0 <= Seq#Length(##s#0);
    assume LitInt(0) <= ##pos#0 && ##pos#0 <= Seq#Length(##s#0);
    assume Sequences.__default.insert#canCall(Arrays._default.Insert$T, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element#0, 
      pos#0);
    assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, arr#0), length#0 + 1), 
      Sequences.__default.insert(Arrays._default.Insert$T, 
        StartFuel_Sequences._default.insert, 
        Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
        element#0, 
        pos#0));
    assert arr#0 != null;
    newtype$check#3 := LitInt(1);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := length#0 + 1;
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assert 0 <= length#0 + 1 && length#0 + 1 <= _System.array.Length(arr#0);
    assert arr#0 != null;
    newtype$check#5 := LitInt(1);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    newtype$check#6 := length#0 + 1;
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assert 0 <= length#0 + 1 && length#0 + 1 <= _System.array.Length(arr#0);
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, arr#0), length#0 + 1), 
      Seq#Drop(Seq#FromArray(old($Heap), arr#0), length#0 + 1));
}



procedure Call$$Arrays.__default.Insert(Arrays._default.Insert$T: Ty, 
    arr#0: ref
       where $Is(arr#0, Tclass._System.array(Arrays._default.Insert$T))
         && $IsAlloc(arr#0, Tclass._System.array(Arrays._default.Insert$T), $Heap), 
    length#0: int where LitInt(0) <= length#0 && length#0 < 18446744073709551616, 
    element#0: Box
       where $IsBox(element#0, Arrays._default.Insert$T)
         && $IsAllocBox(element#0, Arrays._default.Insert$T, $Heap), 
    pos#0: int where LitInt(0) <= pos#0 && pos#0 < 18446744073709551616);
  // user-defined preconditions
  requires LitInt(0) <= length#0;
  requires length#0 < _System.array.Length(arr#0);
  requires _System.array.Length(arr#0) < NativeTypes.__default.Uint64UpperBound();
  requires LitInt(0) <= pos#0;
  requires pos#0 <= length#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.insert#canCall(Arrays._default.Insert$T, 
    Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
    element#0, 
    pos#0);
  ensures Seq#Equal(Seq#Take(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Sequences.__default.insert(Arrays._default.Insert$T, 
      StartFuelAssert_Sequences._default.insert, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element#0, 
      pos#0));
  free ensures true;
  ensures Seq#Equal(Seq#Drop(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Seq#Drop(Seq#FromArray(old($Heap), arr#0), length#0 + 1));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == arr#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$Arrays.__default.Insert(Arrays._default.Insert$T: Ty, 
    arr#0: ref
       where $Is(arr#0, Tclass._System.array(Arrays._default.Insert$T))
         && $IsAlloc(arr#0, Tclass._System.array(Arrays._default.Insert$T), $Heap), 
    length#0: int where LitInt(0) <= length#0 && length#0 < 18446744073709551616, 
    element#0: Box
       where $IsBox(element#0, Arrays._default.Insert$T)
         && $IsAllocBox(element#0, Arrays._default.Insert$T, $Heap), 
    pos#0: int where LitInt(0) <= pos#0 && pos#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  // user-defined preconditions
  requires LitInt(0) <= length#0;
  requires length#0 < _System.array.Length(arr#0);
  requires _System.array.Length(arr#0) < NativeTypes.__default.Uint64UpperBound();
  requires LitInt(0) <= pos#0;
  requires pos#0 <= length#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.insert#canCall(Arrays._default.Insert$T, 
    Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
    element#0, 
    pos#0);
  ensures Seq#Equal(Seq#Take(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Sequences.__default.insert(Arrays._default.Insert$T, 
      StartFuelAssert_Sequences._default.insert, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element#0, 
      pos#0));
  free ensures true;
  ensures Seq#Equal(Seq#Drop(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Seq#Drop(Seq#FromArray(old($Heap), arr#0), length#0 + 1));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == arr#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$Arrays.__default.Insert(Arrays._default.Insert$T: Ty, 
    arr#0: ref, 
    length#0: int, 
    element#0: Box, 
    pos#0: int)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var oldarr#0: Seq Box
     where $Is(oldarr#0, TSeq(Arrays._default.Insert$T))
       && $IsAlloc(oldarr#0, TSeq(Arrays._default.Insert$T), $Heap);
  var curelement#0: Box
     where $IsBox(curelement#0, Arrays._default.Insert$T)
       && $IsAllocBox(curelement#0, Arrays._default.Insert$T, $Heap);
  var $rhs#0: Box where $IsBox($rhs#0, Arrays._default.Insert$T);
  var i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var j#0: int;
  var newtype$check#13: int;
  var j#2: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var j#4: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var $decr$loop#00: int;
  var tmp#0_0: Box
     where $IsBox(tmp#0_0, Arrays._default.Insert$T)
       && $IsAllocBox(tmp#0_0, Arrays._default.Insert$T, $Heap);
  var $rhs#0_0: Box where $IsBox($rhs#0_0, Arrays._default.Insert$T);
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;

    // AddMethodImpl: Insert, Impl$$Arrays.__default.Insert
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == arr#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(28,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(32,22)
    assume true;
    assert arr#0 != null;
    assume true;
    oldarr#0 := Seq#FromArray($Heap, arr#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(32,31)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(34,20)
    assume true;
    assert arr#0 != null;
    assert 0 <= pos#0 && pos#0 < _System.array.Length(arr#0);
    assume true;
    curelement#0 := read($Heap, arr#0, IndexField(pos#0));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(34,30)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(35,14)
    assert arr#0 != null;
    assert 0 <= pos#0 && pos#0 < _System.array.Length(arr#0);
    assume true;
    assert $_Frame[arr#0, IndexField(pos#0)];
    assume true;
    $rhs#0 := element#0;
    $Heap := update($Heap, arr#0, IndexField(pos#0), $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(35,23)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(37,19)
    assume true;
    newtype$check#7 := LitInt(1);
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    newtype$check#8 := pos#0 + 1;
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    assume true;
    i#0 := pos#0 + 1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(37,26)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(38,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := length#0 - i#0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> pos#0 + 1 <= i#0;
      invariant $w$loop#0 ==> i#0 <= length#0 + 1;
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> arr#0 == arr#0;
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall j#1: int :: 
          { Seq#Index(oldarr#0, j#1) } { read($Heap, arr#0, IndexField(j#1)) } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616
             ==> 
            LitInt(0) <= j#1 && j#1 < pos#0
             ==> read($Heap, arr#0, IndexField(j#1)) == Seq#Index(oldarr#0, j#1));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> read($Heap, arr#0, IndexField(pos#0)) == element#0;
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall j#3: int :: 
          { read($Heap, arr#0, IndexField(j#3)) } 
          LitInt(0) <= j#3 && j#3 < 18446744073709551616
             ==> 
            pos#0 < j#3 && j#3 < i#0
             ==> read($Heap, arr#0, IndexField(j#3)) == Seq#Index(oldarr#0, j#3 - 1));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall j#5: int :: 
          { Seq#Index(oldarr#0, j#5) } { read($Heap, arr#0, IndexField(j#5)) } 
          true
             ==> 
            i#0 <= j#5 && j#5 < _System.array.Length(arr#0)
             ==> read($Heap, arr#0, IndexField(j#5)) == Seq#Index(oldarr#0, j#5));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> curelement#0 == Seq#Index(oldarr#0, i#0 - 1);
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o] || $o == arr#0);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant length#0 - i#0 <= $decr_init$loop#00
         && (length#0 - i#0 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(38,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            newtype$check#9 := LitInt(1);
            assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
            newtype$check#10 := pos#0 + 1;
            assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
            if (pos#0 + 1 <= i#0)
            {
                newtype$check#11 := LitInt(1);
                assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
                newtype$check#12 := length#0 + 1;
                assert LitInt(0) <= newtype$check#12 && newtype$check#12 < 18446744073709551616;
            }

            assume true;
            assume pos#0 + 1 <= i#0 && i#0 <= length#0 + 1;
            assume true;
            assume arr#0 == arr#0;
            havoc j#0;
            assume LitInt(0) <= j#0 && j#0 < 18446744073709551616;
            // Begin Comprehension WF check
            newtype$check#13 := LitInt(0);
            assert LitInt(0) <= newtype$check#13 && newtype$check#13 < 18446744073709551616;
            if (LitInt(0) <= j#0)
            {
            }

            if (LitInt(0) <= j#0 && j#0 < pos#0)
            {
                assert arr#0 != null;
                assert {:subsumption 0} 0 <= j#0 && j#0 < _System.array.Length(arr#0);
                assert {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(oldarr#0);
            }

            // End Comprehension WF check
            assume true;
            assume (forall j#1: int :: 
              { Seq#Index(oldarr#0, j#1) } { read($Heap, arr#0, IndexField(j#1)) } 
              LitInt(0) <= j#1 && j#1 < 18446744073709551616
                 ==> 
                LitInt(0) <= j#1 && j#1 < pos#0
                 ==> read($Heap, arr#0, IndexField(j#1)) == Seq#Index(oldarr#0, j#1));
            assert arr#0 != null;
            assert {:subsumption 0} 0 <= pos#0 && pos#0 < _System.array.Length(arr#0);
            assume true;
            assume read($Heap, arr#0, IndexField(pos#0)) == element#0;
            havoc j#2;
            assume LitInt(0) <= j#2 && j#2 < 18446744073709551616;
            // Begin Comprehension WF check
            if (pos#0 < j#2)
            {
            }

            if (pos#0 < j#2 && j#2 < i#0)
            {
                assert arr#0 != null;
                assert {:subsumption 0} 0 <= j#2 && j#2 < _System.array.Length(arr#0);
                newtype$check#14 := LitInt(1);
                assert LitInt(0) <= newtype$check#14 && newtype$check#14 < 18446744073709551616;
                newtype$check#15 := j#2 - 1;
                assert LitInt(0) <= newtype$check#15 && newtype$check#15 < 18446744073709551616;
                assert {:subsumption 0} 0 <= j#2 - 1 && j#2 - 1 < Seq#Length(oldarr#0);
            }

            // End Comprehension WF check
            assume true;
            assume (forall j#3: int :: 
              { read($Heap, arr#0, IndexField(j#3)) } 
              LitInt(0) <= j#3 && j#3 < 18446744073709551616
                 ==> 
                pos#0 < j#3 && j#3 < i#0
                 ==> read($Heap, arr#0, IndexField(j#3)) == Seq#Index(oldarr#0, j#3 - 1));
            havoc j#4;
            // Begin Comprehension WF check
            if (i#0 <= j#4)
            {
                assert {:subsumption 0} arr#0 != null;
            }

            if (i#0 <= j#4 && j#4 < _System.array.Length(arr#0))
            {
                assert arr#0 != null;
                assert {:subsumption 0} 0 <= j#4 && j#4 < _System.array.Length(arr#0);
                assert {:subsumption 0} 0 <= j#4 && j#4 < Seq#Length(oldarr#0);
            }

            // End Comprehension WF check
            assume true;
            assume (forall j#5: int :: 
              { Seq#Index(oldarr#0, j#5) } { read($Heap, arr#0, IndexField(j#5)) } 
              true
                 ==> 
                i#0 <= j#5 && j#5 < _System.array.Length(arr#0)
                 ==> read($Heap, arr#0, IndexField(j#5)) == Seq#Index(oldarr#0, j#5));
            newtype$check#16 := LitInt(1);
            assert LitInt(0) <= newtype$check#16 && newtype$check#16 < 18446744073709551616;
            newtype$check#17 := i#0 - 1;
            assert LitInt(0) <= newtype$check#17 && newtype$check#17 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 < Seq#Length(oldarr#0);
            assume true;
            assume curelement#0 == Seq#Index(oldarr#0, i#0 - 1);
            assume true;
            assume false;
        }

        assume true;
        if (length#0 < i#0)
        {
            break;
        }

        $decr$loop#00 := length#0 - i#0;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(47,15)
        assume true;
        assert arr#0 != null;
        assert 0 <= i#0 && i#0 < _System.array.Length(arr#0);
        assume true;
        tmp#0_0 := read($Heap, arr#0, IndexField(i#0));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(47,23)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(48,14)
        assert arr#0 != null;
        assert 0 <= i#0 && i#0 < _System.array.Length(arr#0);
        assume true;
        assert $_Frame[arr#0, IndexField(i#0)];
        assume true;
        $rhs#0_0 := curelement#0;
        $Heap := update($Heap, arr#0, IndexField(i#0), $rhs#0_0);
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(48,26)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(49,18)
        assume true;
        assume true;
        curelement#0 := tmp#0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(49,23)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(50,9)
        assume true;
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := i#0 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume true;
        i#0 := i#0 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(50,16)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(38,5)
        assert 0 <= $decr$loop#00 || length#0 - i#0 == $decr$loop#00;
        assert length#0 - i#0 < $decr$loop#00;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
    }
}



procedure CheckWellformed$$Arrays.__default.replace1with2(Arrays._default.replace1with2$T: Ty, 
    arr#0: ref
       where $Is(arr#0, Tclass._System.array(Arrays._default.replace1with2$T))
         && $IsAlloc(arr#0, Tclass._System.array(Arrays._default.replace1with2$T), $Heap), 
    length#0: int where LitInt(0) <= length#0 && length#0 < 18446744073709551616, 
    element1#0: Box
       where $IsBox(element1#0, Arrays._default.replace1with2$T)
         && $IsAllocBox(element1#0, Arrays._default.replace1with2$T, $Heap), 
    element2#0: Box
       where $IsBox(element2#0, Arrays._default.replace1with2$T)
         && $IsAllocBox(element2#0, Arrays._default.replace1with2$T, $Heap), 
    pos#0: int where LitInt(0) <= pos#0 && pos#0 < 18446744073709551616);
  free requires 6 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$Arrays.__default.replace1with2(Arrays._default.replace1with2$T: Ty, 
    arr#0: ref, 
    length#0: int, 
    element1#0: Box, 
    element2#0: Box, 
    pos#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##s#0: Seq Box;
  var ##a#0: Box;
  var ##b#0: Box;
  var ##pos#0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;

    // AddMethodImpl: replace1with2, CheckWellformed$$Arrays.__default.replace1with2
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == arr#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(54,9): initial state"} true;
    if (LitInt(0) <= length#0)
    {
        assert arr#0 != null;
    }

    if (LitInt(0) <= length#0 && length#0 < _System.array.Length(arr#0))
    {
        assert arr#0 != null;
        assume NativeTypes.__default.Uint64UpperBound#canCall();
    }

    assume LitInt(0) <= length#0
       && length#0 < _System.array.Length(arr#0)
       && _System.array.Length(arr#0) < NativeTypes.__default.Uint64UpperBound();
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= pos#0)
    {
    }

    assume LitInt(0) <= pos#0 && pos#0 < length#0;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o] || $o == arr#0);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(57,28): post-state"} true;
    assert arr#0 != null;
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := length#0 + 1;
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assert 0 <= length#0 + 1 && length#0 + 1 <= _System.array.Length(arr#0);
    assert arr#0 != null;
    assert 0 <= length#0 && length#0 <= _System.array.Length(arr#0);
    ##s#0 := Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Arrays._default.replace1with2$T), $Heap);
    ##a#0 := element1#0;
    // assume allocatedness for argument to function
    assume $IsAllocBox(##a#0, Arrays._default.replace1with2$T, $Heap);
    ##b#0 := element2#0;
    // assume allocatedness for argument to function
    assume $IsAllocBox(##b#0, Arrays._default.replace1with2$T, $Heap);
    ##pos#0 := pos#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pos#0, TInt, $Heap);
    assert {:subsumption 0} LitInt(0) <= ##pos#0;
    assert {:subsumption 0} ##pos#0 < Seq#Length(##s#0);
    assume LitInt(0) <= ##pos#0 && ##pos#0 < Seq#Length(##s#0);
    assume Sequences.__default.replace1with2#canCall(Arrays._default.replace1with2$T, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element1#0, 
      element2#0, 
      pos#0);
    assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, arr#0), length#0 + 1), 
      Sequences.__default.replace1with2(Arrays._default.replace1with2$T, 
        StartFuel_Sequences._default.replace1with2, 
        Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
        element1#0, 
        element2#0, 
        pos#0));
    assert arr#0 != null;
    newtype$check#3 := LitInt(1);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := length#0 + 1;
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assert 0 <= length#0 + 1 && length#0 + 1 <= _System.array.Length(arr#0);
    assert arr#0 != null;
    newtype$check#5 := LitInt(1);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    newtype$check#6 := length#0 + 1;
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assert 0 <= length#0 + 1 && length#0 + 1 <= _System.array.Length(arr#0);
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, arr#0), length#0 + 1), 
      Seq#Drop(Seq#FromArray(old($Heap), arr#0), length#0 + 1));
}



procedure Call$$Arrays.__default.replace1with2(Arrays._default.replace1with2$T: Ty, 
    arr#0: ref
       where $Is(arr#0, Tclass._System.array(Arrays._default.replace1with2$T))
         && $IsAlloc(arr#0, Tclass._System.array(Arrays._default.replace1with2$T), $Heap), 
    length#0: int where LitInt(0) <= length#0 && length#0 < 18446744073709551616, 
    element1#0: Box
       where $IsBox(element1#0, Arrays._default.replace1with2$T)
         && $IsAllocBox(element1#0, Arrays._default.replace1with2$T, $Heap), 
    element2#0: Box
       where $IsBox(element2#0, Arrays._default.replace1with2$T)
         && $IsAllocBox(element2#0, Arrays._default.replace1with2$T, $Heap), 
    pos#0: int where LitInt(0) <= pos#0 && pos#0 < 18446744073709551616);
  // user-defined preconditions
  requires LitInt(0) <= length#0;
  requires length#0 < _System.array.Length(arr#0);
  requires _System.array.Length(arr#0) < NativeTypes.__default.Uint64UpperBound();
  requires LitInt(0) <= pos#0;
  requires pos#0 < length#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.replace1with2#canCall(Arrays._default.replace1with2$T, 
    Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
    element1#0, 
    element2#0, 
    pos#0);
  ensures Seq#Equal(Seq#Take(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Sequences.__default.replace1with2(Arrays._default.replace1with2$T, 
      StartFuelAssert_Sequences._default.replace1with2, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element1#0, 
      element2#0, 
      pos#0));
  free ensures true;
  ensures Seq#Equal(Seq#Drop(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Seq#Drop(Seq#FromArray(old($Heap), arr#0), length#0 + 1));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == arr#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$Arrays.__default.replace1with2(Arrays._default.replace1with2$T: Ty, 
    arr#0: ref
       where $Is(arr#0, Tclass._System.array(Arrays._default.replace1with2$T))
         && $IsAlloc(arr#0, Tclass._System.array(Arrays._default.replace1with2$T), $Heap), 
    length#0: int where LitInt(0) <= length#0 && length#0 < 18446744073709551616, 
    element1#0: Box
       where $IsBox(element1#0, Arrays._default.replace1with2$T)
         && $IsAllocBox(element1#0, Arrays._default.replace1with2$T, $Heap), 
    element2#0: Box
       where $IsBox(element2#0, Arrays._default.replace1with2$T)
         && $IsAllocBox(element2#0, Arrays._default.replace1with2$T, $Heap), 
    pos#0: int where LitInt(0) <= pos#0 && pos#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  // user-defined preconditions
  requires LitInt(0) <= length#0;
  requires length#0 < _System.array.Length(arr#0);
  requires _System.array.Length(arr#0) < NativeTypes.__default.Uint64UpperBound();
  requires LitInt(0) <= pos#0;
  requires pos#0 < length#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.replace1with2#canCall(Arrays._default.replace1with2$T, 
    Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
    element1#0, 
    element2#0, 
    pos#0);
  ensures Seq#Equal(Seq#Take(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Sequences.__default.replace1with2(Arrays._default.replace1with2$T, 
      StartFuelAssert_Sequences._default.replace1with2, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element1#0, 
      element2#0, 
      pos#0));
  free ensures true;
  ensures Seq#Equal(Seq#Drop(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Seq#Drop(Seq#FromArray(old($Heap), arr#0), length#0 + 1));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == arr#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$Arrays.__default.replace1with2(Arrays._default.replace1with2$T: Ty, 
    arr#0: ref, 
    length#0: int, 
    element1#0: Box, 
    element2#0: Box, 
    pos#0: int)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var arr##0: ref;
  var length##0: int;
  var element##0: Box;
  var pos##0: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var $rhs#0: Box where $IsBox($rhs#0, Arrays._default.replace1with2$T);
  var replaced#0: Seq Box
     where $Is(replaced#0, TSeq(Arrays._default.replace1with2$T))
       && $IsAlloc(replaced#0, TSeq(Arrays._default.replace1with2$T), $Heap);
  var ##s#1: Seq Box;
  var ##a#1: Box;
  var ##b#1: Box;
  var ##pos#1: int;
  var i#0: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var i#2: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;

    // AddMethodImpl: replace1with2, Impl$$Arrays.__default.replace1with2
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == arr#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(60,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(61,11)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    arr##0 := arr#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    length##0 := length#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    element##0 := element2#0;
    newtype$check#7 := LitInt(1);
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    newtype$check#8 := pos#0 + 1;
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    pos##0 := pos#0 + 1;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == arr##0 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Arrays.__default.Insert(Arrays._default.replace1with2$T, arr##0, length##0, element##0, pos##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(61,40)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(62,14)
    assert arr#0 != null;
    assert 0 <= pos#0 && pos#0 < _System.array.Length(arr#0);
    assume true;
    assert $_Frame[arr#0, IndexField(pos#0)];
    assume true;
    $rhs#0 := element1#0;
    $Heap := update($Heap, arr#0, IndexField(pos#0), $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(62,24)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(64,24)
    assume true;
    assert arr#0 != null;
    assert 0 <= length#0 && length#0 <= _System.array.Length(arr#0);
    ##s#1 := Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#1, TSeq(Arrays._default.replace1with2$T), $Heap);
    ##a#1 := element1#0;
    // assume allocatedness for argument to function
    assume $IsAllocBox(##a#1, Arrays._default.replace1with2$T, $Heap);
    ##b#1 := element2#0;
    // assume allocatedness for argument to function
    assume $IsAllocBox(##b#1, Arrays._default.replace1with2$T, $Heap);
    ##pos#1 := pos#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pos#1, TInt, $Heap);
    assert {:subsumption 0} LitInt(0) <= ##pos#1;
    assert {:subsumption 0} ##pos#1 < Seq#Length(##s#1);
    assume LitInt(0) <= ##pos#1 && ##pos#1 < Seq#Length(##s#1);
    assume Sequences.__default.replace1with2#canCall(Arrays._default.replace1with2$T, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element1#0, 
      element2#0, 
      pos#0);
    assume Sequences.__default.replace1with2#canCall(Arrays._default.replace1with2$T, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element1#0, 
      element2#0, 
      pos#0);
    replaced#0 := Sequences.__default.replace1with2(Arrays._default.replace1with2$T, 
      StartFuel_Sequences._default.replace1with2, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element1#0, 
      element2#0, 
      pos#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(64,95)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(65,5)
    havoc i#0;
    assume LitInt(0) <= i#0 && i#0 < 18446744073709551616;
    // Begin Comprehension WF check
    newtype$check#9 := LitInt(0);
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    if (LitInt(0) <= i#0)
    {
    }

    if (LitInt(0) <= i#0 && i#0 < pos#0)
    {
        assert arr#0 != null;
        assert {:subsumption 0} 0 <= i#0 && i#0 < _System.array.Length(arr#0);
        assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(replaced#0);
    }

    // End Comprehension WF check
    assume true;
    assert (forall i#1: int :: 
      { Seq#Index(replaced#0, i#1) } { read($Heap, arr#0, IndexField(i#1)) } 
      LitInt(0) <= i#1 && i#1 < 18446744073709551616
         ==> 
        LitInt(0) <= i#1 && i#1 < pos#0
         ==> read($Heap, arr#0, IndexField(i#1)) == Seq#Index(replaced#0, i#1));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(66,5)
    assert arr#0 != null;
    assert {:subsumption 0} 0 <= pos#0 && pos#0 < _System.array.Length(arr#0);
    assert {:subsumption 0} 0 <= pos#0 && pos#0 < Seq#Length(replaced#0);
    assume true;
    assert read($Heap, arr#0, IndexField(pos#0)) == Seq#Index(replaced#0, pos#0);
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(67,5)
    assert arr#0 != null;
    newtype$check#10 := LitInt(1);
    assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
    newtype$check#11 := pos#0 + 1;
    assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
    assert {:subsumption 0} 0 <= pos#0 + 1 && pos#0 + 1 < _System.array.Length(arr#0);
    newtype$check#12 := LitInt(1);
    assert LitInt(0) <= newtype$check#12 && newtype$check#12 < 18446744073709551616;
    newtype$check#13 := pos#0 + 1;
    assert LitInt(0) <= newtype$check#13 && newtype$check#13 < 18446744073709551616;
    assert {:subsumption 0} 0 <= pos#0 + 1 && pos#0 + 1 < Seq#Length(replaced#0);
    assume true;
    assert read($Heap, arr#0, IndexField(pos#0 + 1)) == Seq#Index(replaced#0, pos#0 + 1);
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Base/Arrays.i.dfy(68,5)
    havoc i#2;
    assume LitInt(0) <= i#2 && i#2 < 18446744073709551616;
    // Begin Comprehension WF check
    newtype$check#14 := LitInt(2);
    assert LitInt(0) <= newtype$check#14 && newtype$check#14 < 18446744073709551616;
    newtype$check#15 := pos#0 + 2;
    assert LitInt(0) <= newtype$check#15 && newtype$check#15 < 18446744073709551616;
    if (pos#0 + 2 <= i#2)
    {
        newtype$check#16 := LitInt(1);
        assert LitInt(0) <= newtype$check#16 && newtype$check#16 < 18446744073709551616;
        newtype$check#17 := length#0 + 1;
        assert LitInt(0) <= newtype$check#17 && newtype$check#17 < 18446744073709551616;
    }

    if (pos#0 + 2 <= i#2 && i#2 < length#0 + 1)
    {
        assert arr#0 != null;
        assert {:subsumption 0} 0 <= i#2 && i#2 < _System.array.Length(arr#0);
        assert arr#0 != null;
        newtype$check#18 := LitInt(1);
        assert LitInt(0) <= newtype$check#18 && newtype$check#18 < 18446744073709551616;
        newtype$check#19 := i#2 - 1;
        assert LitInt(0) <= newtype$check#19 && newtype$check#19 < 18446744073709551616;
        assert {:subsumption 0} 0 <= i#2 - 1 && i#2 - 1 < _System.array.Length(arr#0);
    }

    // End Comprehension WF check
    assume true;
    assert (forall i#3: int :: 
      { read($Heap, arr#0, IndexField(i#3)) } 
      LitInt(0) <= i#3 && i#3 < 18446744073709551616
         ==> 
        pos#0 + 2 <= i#3 && i#3 < length#0 + 1
         ==> read($Heap, arr#0, IndexField(i#3))
           == read(old($Heap), arr#0, IndexField(i#3 - 1)));
}



// Constructor function declaration
function #Options.Option.None() : DatatypeType;

const unique ##Options.Option.None: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#Options.Option.None()) == ##Options.Option.None;

function Options.Option.None_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) <==> DatatypeCtorId(d) == ##Options.Option.None);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) ==> d == #Options.Option.None());

function Tclass.Options.Option(Ty) : Ty;

// Tclass.Options.Option Tag
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tag(Tclass.Options.Option(Options.Option$V)) == Tagclass.Options.Option);

const unique Tagclass.Options.Option: TyTag;

// Tclass.Options.Option injectivity 0
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tclass.Options.Option_0(Tclass.Options.Option(Options.Option$V))
     == Options.Option$V);

function Tclass.Options.Option_0(Ty) : Ty;

// Box/unbox axiom for Tclass.Options.Option
axiom (forall Options.Option$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.Options.Option(Options.Option$V)) } 
  $IsBox(bx, Tclass.Options.Option(Options.Option$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Options.Option(Options.Option$V)));

// Constructor $Is
axiom (forall Options.Option$V: Ty :: 
  { $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, $h: Heap :: 
  { $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h));

// Constructor literal
axiom #Options.Option.None() == Lit(#Options.Option.None());

// Constructor function declaration
function #Options.Option.Some(Box) : DatatypeType;

const unique ##Options.Option.Some: DtCtorId;

// Constructor identifier
axiom (forall a#5#0#0: Box :: 
  { #Options.Option.Some(a#5#0#0) } 
  DatatypeCtorId(#Options.Option.Some(a#5#0#0)) == ##Options.Option.Some);

function Options.Option.Some_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d) <==> DatatypeCtorId(d) == ##Options.Option.Some);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d)
     ==> (exists a#6#0#0: Box :: d == #Options.Option.Some(a#6#0#0)));

// Constructor $Is
axiom (forall Options.Option$V: Ty, a#7#0#0: Box :: 
  { $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V))
     <==> $IsBox(a#7#0#0, Options.Option$V));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, a#8#0#0: Box, $h: Heap :: 
  { $IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h)
       <==> $IsAllocBox(a#8#0#0, Options.Option$V, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, Options.Option$V: Ty, $h: Heap :: 
  { $IsAllocBox(Options.Option.value(d), Options.Option$V, $h) } 
  $IsGoodHeap($h)
       && 
      Options.Option.Some_q(d)
       && $IsAlloc(d, Tclass.Options.Option(Options.Option$V), $h)
     ==> $IsAllocBox(Options.Option.value(d), Options.Option$V, $h));

// Constructor literal
axiom (forall a#9#0#0: Box :: 
  { #Options.Option.Some(Lit(a#9#0#0)) } 
  #Options.Option.Some(Lit(a#9#0#0)) == Lit(#Options.Option.Some(a#9#0#0)));

function Options.Option.value(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#10#0#0: Box :: 
  { #Options.Option.Some(a#10#0#0) } 
  Options.Option.value(#Options.Option.Some(a#10#0#0)) == a#10#0#0);

// Inductive rank
axiom (forall a#11#0#0: Box :: 
  { #Options.Option.Some(a#11#0#0) } 
  BoxRank(a#11#0#0) < DtRank(#Options.Option.Some(a#11#0#0)));

// Depth-one case-split function
function $IsA#Options.Option(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Options.Option(d) } 
  $IsA#Options.Option(d) ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Questionmark data type disjunctivity
axiom (forall Options.Option$V: Ty, d: DatatypeType :: 
  { Options.Option.Some_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
    { Options.Option.None_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
  $Is(d, Tclass.Options.Option(Options.Option$V))
     ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Datatype extensional equality declaration
function Options.Option#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Options.Option.None
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.None_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.None_q(b) } 
  Options.Option.None_q(a) && Options.Option.None_q(b)
     ==> (Options.Option#Equal(a, b) <==> true));

// Datatype extensional equality definition: #Options.Option.Some
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.Some_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.Some_q(b) } 
  Options.Option.Some_q(a) && Options.Option.Some_q(b)
     ==> (Options.Option#Equal(a, b)
       <==> Options.Option.value(a) == Options.Option.value(b)));

// Datatype extensionality axiom: Options.Option
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b) } 
  Options.Option#Equal(a, b) <==> a == b);

const unique class.Options.Option: ClassName;

const unique class.Options.__default: ClassName;

function Tclass.Options.__default() : Ty;

// Tclass.Options.__default Tag
axiom Tag(Tclass.Options.__default()) == Tagclass.Options.__default;

const unique Tagclass.Options.__default: TyTag;

// Box/unbox axiom for Tclass.Options.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Options.__default()) } 
  $IsBox(bx, Tclass.Options.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Options.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Options.__default()) } 
  $Is($o, Tclass.Options.__default())
     <==> $o == null || dtype($o) == Tclass.Options.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Options.__default(), $h) } 
  $IsAlloc($o, Tclass.Options.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Options._default.MapOption
function Options.__default.MapOption(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.MapOption#canCall(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
       == Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0));

// consequence axiom for Options.__default.MapOption
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
           <==> Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)))
         && (Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
           ==> Options.Option.value(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
             == Apply1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0)))
         && $Is(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0), 
          Tclass.Options.Option(Options._default.MapOption$V1)));

function Options.__default.MapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
     ==> Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.MapOption$V0, 
          Options._default.MapOption$V1, 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.MapOption(revealed)
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            #Options.Option.Some(Apply1(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, f#0, v#1)))));

// function declaration for Options._default.FlatMapOption
function Options.__default.FlatMapOption(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $h1, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $h0, 
          opt#0, 
          f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h0, 
        opt#0, 
        f#0)
       == Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h1, 
        opt#0, 
        f#0));

// consequence axiom for Options.__default.FlatMapOption
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.Some_q(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
              Options._default.FlatMapOption$V1, 
              $Heap, 
              opt#0, 
              f#0)))
         && (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.value(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
                Options._default.FlatMapOption$V1, 
                $Heap, 
                opt#0, 
                f#0))
             == Options.Option.value($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType))
         && $Is(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
            Options._default.FlatMapOption$V1, 
            $Heap, 
            opt#0, 
            f#0), 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)));

function Options.__default.FlatMapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $Heap, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)))
     ==> Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1), 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.FlatMapOption(revealed)
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            $Unbox(Apply1(Options._default.FlatMapOption$V0, 
                Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                $Heap, 
                f#0, 
                v#1)): DatatypeType)));

function Tclass.NativeTypes.sbyte() : Ty;

// Tclass.NativeTypes.sbyte Tag
axiom Tag(Tclass.NativeTypes.sbyte()) == Tagclass.NativeTypes.sbyte;

const unique Tagclass.NativeTypes.sbyte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.sbyte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.sbyte()) } 
  $IsBox(bx, Tclass.NativeTypes.sbyte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.sbyte()));

// NativeTypes.sbyte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.sbyte()) } 
  $Is(i#0, Tclass.NativeTypes.sbyte()) <==> LitInt(0 - 128) <= i#0 && i#0 < 128);

// NativeTypes.sbyte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h));

const unique class.NativeTypes.sbyte: ClassName;

function Tclass.NativeTypes.byte() : Ty;

// Tclass.NativeTypes.byte Tag
axiom Tag(Tclass.NativeTypes.byte()) == Tagclass.NativeTypes.byte;

const unique Tagclass.NativeTypes.byte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.byte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.byte()) } 
  $IsBox(bx, Tclass.NativeTypes.byte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.byte()));

// NativeTypes.byte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.byte()) } 
  $Is(i#0, Tclass.NativeTypes.byte()) <==> LitInt(0) <= i#0 && i#0 < 256);

// NativeTypes.byte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h));

const unique class.NativeTypes.byte: ClassName;

function Tclass.NativeTypes.int16() : Ty;

// Tclass.NativeTypes.int16 Tag
axiom Tag(Tclass.NativeTypes.int16()) == Tagclass.NativeTypes.int16;

const unique Tagclass.NativeTypes.int16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int16()) } 
  $IsBox(bx, Tclass.NativeTypes.int16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int16()));

// NativeTypes.int16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int16()) } 
  $Is(i#0, Tclass.NativeTypes.int16())
     <==> LitInt(0 - 32768) <= i#0 && i#0 < 32768);

// NativeTypes.int16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h));

const unique class.NativeTypes.int16: ClassName;

function Tclass.NativeTypes.uint16() : Ty;

// Tclass.NativeTypes.uint16 Tag
axiom Tag(Tclass.NativeTypes.uint16()) == Tagclass.NativeTypes.uint16;

const unique Tagclass.NativeTypes.uint16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint16()) } 
  $IsBox(bx, Tclass.NativeTypes.uint16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint16()));

// NativeTypes.uint16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint16()) } 
  $Is(i#0, Tclass.NativeTypes.uint16()) <==> LitInt(0) <= i#0 && i#0 < 65536);

// NativeTypes.uint16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h));

const unique class.NativeTypes.uint16: ClassName;

function Tclass.NativeTypes.int32() : Ty;

// Tclass.NativeTypes.int32 Tag
axiom Tag(Tclass.NativeTypes.int32()) == Tagclass.NativeTypes.int32;

const unique Tagclass.NativeTypes.int32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int32()) } 
  $IsBox(bx, Tclass.NativeTypes.int32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int32()));

// NativeTypes.int32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int32()) } 
  $Is(i#0, Tclass.NativeTypes.int32())
     <==> LitInt(0 - 2147483648) <= i#0 && i#0 < 2147483648);

// NativeTypes.int32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h));

const unique class.NativeTypes.int32: ClassName;

function Tclass.NativeTypes.uint32() : Ty;

// Tclass.NativeTypes.uint32 Tag
axiom Tag(Tclass.NativeTypes.uint32()) == Tagclass.NativeTypes.uint32;

const unique Tagclass.NativeTypes.uint32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint32()) } 
  $IsBox(bx, Tclass.NativeTypes.uint32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint32()));

// NativeTypes.uint32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint32()) } 
  $Is(i#0, Tclass.NativeTypes.uint32()) <==> LitInt(0) <= i#0 && i#0 < 4294967296);

// NativeTypes.uint32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h));

const unique class.NativeTypes.uint32: ClassName;

function Tclass.NativeTypes.int64() : Ty;

// Tclass.NativeTypes.int64 Tag
axiom Tag(Tclass.NativeTypes.int64()) == Tagclass.NativeTypes.int64;

const unique Tagclass.NativeTypes.int64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int64()) } 
  $IsBox(bx, Tclass.NativeTypes.int64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int64()));

// NativeTypes.int64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int64()) } 
  $Is(i#0, Tclass.NativeTypes.int64())
     <==> LitInt(0 - 9223372036854775808) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.int64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h));

const unique class.NativeTypes.int64: ClassName;

function Tclass.NativeTypes.uint64() : Ty;

// Tclass.NativeTypes.uint64 Tag
axiom Tag(Tclass.NativeTypes.uint64()) == Tagclass.NativeTypes.uint64;

const unique Tagclass.NativeTypes.uint64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint64()) } 
  $IsBox(bx, Tclass.NativeTypes.uint64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint64()));

// NativeTypes.uint64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint64()) } 
  $Is(i#0, Tclass.NativeTypes.uint64())
     <==> LitInt(0) <= i#0 && i#0 < 18446744073709551616);

// NativeTypes.uint64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h));

const unique class.NativeTypes.uint64: ClassName;

function Tclass.NativeTypes.nat8() : Ty;

// Tclass.NativeTypes.nat8 Tag
axiom Tag(Tclass.NativeTypes.nat8()) == Tagclass.NativeTypes.nat8;

const unique Tagclass.NativeTypes.nat8: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat8
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat8()) } 
  $IsBox(bx, Tclass.NativeTypes.nat8())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat8()));

// NativeTypes.nat8: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat8()) } 
  $Is(i#0, Tclass.NativeTypes.nat8()) <==> LitInt(0) <= i#0 && i#0 < 128);

// NativeTypes.nat8: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h));

const unique class.NativeTypes.nat8: ClassName;

function Tclass.NativeTypes.nat16() : Ty;

// Tclass.NativeTypes.nat16 Tag
axiom Tag(Tclass.NativeTypes.nat16()) == Tagclass.NativeTypes.nat16;

const unique Tagclass.NativeTypes.nat16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat16()) } 
  $IsBox(bx, Tclass.NativeTypes.nat16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat16()));

// NativeTypes.nat16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat16()) } 
  $Is(i#0, Tclass.NativeTypes.nat16()) <==> LitInt(0) <= i#0 && i#0 < 32768);

// NativeTypes.nat16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h));

const unique class.NativeTypes.nat16: ClassName;

function Tclass.NativeTypes.nat32() : Ty;

// Tclass.NativeTypes.nat32 Tag
axiom Tag(Tclass.NativeTypes.nat32()) == Tagclass.NativeTypes.nat32;

const unique Tagclass.NativeTypes.nat32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat32()) } 
  $IsBox(bx, Tclass.NativeTypes.nat32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat32()));

// NativeTypes.nat32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat32()) } 
  $Is(i#0, Tclass.NativeTypes.nat32()) <==> LitInt(0) <= i#0 && i#0 < 2147483648);

// NativeTypes.nat32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h));

const unique class.NativeTypes.nat32: ClassName;

function Tclass.NativeTypes.nat64() : Ty;

// Tclass.NativeTypes.nat64 Tag
axiom Tag(Tclass.NativeTypes.nat64()) == Tagclass.NativeTypes.nat64;

const unique Tagclass.NativeTypes.nat64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat64()) } 
  $IsBox(bx, Tclass.NativeTypes.nat64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat64()));

// NativeTypes.nat64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat64()) } 
  $Is(i#0, Tclass.NativeTypes.nat64())
     <==> LitInt(0) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.nat64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h));

const unique class.NativeTypes.nat64: ClassName;

const unique class.NativeTypes.__default: ClassName;

function Tclass.NativeTypes.__default() : Ty;

// Tclass.NativeTypes.__default Tag
axiom Tag(Tclass.NativeTypes.__default()) == Tagclass.NativeTypes.__default;

const unique Tagclass.NativeTypes.__default: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.__default()) } 
  $IsBox(bx, Tclass.NativeTypes.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeTypes.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeTypes.__default()) } 
  $Is($o, Tclass.NativeTypes.__default())
     <==> $o == null || dtype($o) == Tclass.NativeTypes.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeTypes.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeTypes.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativeTypes._default.Uint64Size
function NativeTypes.__default.Uint64Size() : int;

function NativeTypes.__default.Uint64Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint64Size()
     && NativeTypes.__default.Uint64Size() < 18446744073709551616;

function NativeTypes.__default.Uint64Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64Size
axiom NativeTypes.__default.Uint64Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint64Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// definition axiom for NativeTypes.__default.Uint64Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// function declaration for NativeTypes._default.Uint32Size
function NativeTypes.__default.Uint32Size() : int;

function NativeTypes.__default.Uint32Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint32Size()
     && NativeTypes.__default.Uint32Size() < 18446744073709551616;

function NativeTypes.__default.Uint32Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32Size
axiom NativeTypes.__default.Uint32Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint32Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// definition axiom for NativeTypes.__default.Uint32Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// function declaration for NativeTypes._default.Uint16Size
function NativeTypes.__default.Uint16Size() : int;

function NativeTypes.__default.Uint16Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint16Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint16Size()
     && NativeTypes.__default.Uint16Size() < 18446744073709551616;

function NativeTypes.__default.Uint16Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint16Size
axiom NativeTypes.__default.Uint16Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint16Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// definition axiom for NativeTypes.__default.Uint16Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// function declaration for NativeTypes._default.Uint64UpperBound
function NativeTypes.__default.Uint64UpperBound() : int;

function NativeTypes.__default.Uint64UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint64UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64UpperBound
axiom NativeTypes.__default.Uint64UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint64UpperBound(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// definition axiom for NativeTypes.__default.Uint64UpperBound for all literals(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// function declaration for NativeTypes._default.Uint32UpperBound
function NativeTypes.__default.Uint32UpperBound() : int;

function NativeTypes.__default.Uint32UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint32UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32UpperBound
axiom NativeTypes.__default.Uint32UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint32UpperBound(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// definition axiom for NativeTypes.__default.Uint32UpperBound for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

const unique class.Sequences.__default: ClassName;

function Tclass.Sequences.__default() : Ty;

// Tclass.Sequences.__default Tag
axiom Tag(Tclass.Sequences.__default()) == Tagclass.Sequences.__default;

const unique Tagclass.Sequences.__default: TyTag;

// Box/unbox axiom for Tclass.Sequences.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Sequences.__default()) } 
  $IsBox(bx, Tclass.Sequences.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Sequences.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Sequences.__default()) } 
  $Is($o, Tclass.Sequences.__default())
     <==> $o == null || dtype($o) == Tclass.Sequences.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Sequences.__default(), $h) } 
  $IsAlloc($o, Tclass.Sequences.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Sequences._default.Last
function Sequences.__default.Last(Sequences._default.Last$E: Ty, run#0: Seq Box) : Box;

function Sequences.__default.Last#canCall(Sequences._default.Last$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Last
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> $IsBox(Sequences.__default.Last(Sequences._default.Last$E, run#0), 
        Sequences._default.Last$E));

function Sequences.__default.Last#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Last
axiom (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.Last#requires(Sequences._default.Last$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Last$E))
     ==> Sequences.__default.Last#requires(Sequences._default.Last$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.Last(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, run#0)
         == Seq#Index(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.Last for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0)) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0))
         == Seq#Index(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.DropLast
function Sequences.__default.DropLast(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : Seq Box;

function Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.DropLast
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> $Is(Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0), 
        TSeq(Sequences._default.DropLast$E)));

function Sequences.__default.DropLast#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.DropLast
axiom (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.DropLast$E))
     ==> Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.DropLast(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0)
         == Seq#Take(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.DropLast for all literals(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0)) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0))
         == Seq#Take(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.Set
function Sequences.__default.Set(Sequences._default.Set$T: Ty, run#0: Seq Box) : Set Box;

function Sequences.__default.Set#canCall(Sequences._default.Set$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Set
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> $Is(Sequences.__default.Set(Sequences._default.Set$T, run#0), 
        TSet(Sequences._default.Set$T)));

function Sequences.__default.Set#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Set
axiom (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Set$T))
     ==> Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) == true);

// definition axiom for Sequences.__default.Set(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.Set$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.Set for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0)) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.Set$T) && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.ISet
function Sequences.__default.ISet(Sequences._default.ISet$T: Ty, run#0: Seq Box) : ISet Box;

function Sequences.__default.ISet#canCall(Sequences._default.ISet$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.ISet
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> $Is(Sequences.__default.ISet(Sequences._default.ISet$T, run#0), 
        TISet(Sequences._default.ISet$T)));

function Sequences.__default.ISet#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.ISet
axiom (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.ISet$T))
     ==> Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) == true);

// definition axiom for Sequences.__default.ISet(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.ISet$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.ISet for all literals(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0)) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.ISet$T)
             && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.NoDupes
function Sequences.__default.NoDupes(Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box) : bool;

function Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, AsFuelBottom($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LZ, a#0));

// consequence axiom for Sequences.__default.NoDupes
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> true);

function Sequences.__default.NoDupes#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.NoDupes
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0) } 
  $Is(a#0, TSeq(Sequences._default.NoDupes$T))
     ==> Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.NoDupes(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
         == (forall i#0: int, j#0: int :: 
          { Seq#Index(a#0, j#0), Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 < Seq#Length(a#0)
               && 
              LitInt(0) <= j#0
               && j#0 < Seq#Length(a#0)
               && i#0 != j#0
             ==> Seq#Index(a#0, i#0) != Seq#Index(a#0, j#0)));

// definition axiom for Sequences.__default.NoDupes for all literals(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0)) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, Lit(a#0))
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0))
         == (forall i#1: int, j#1: int :: 
          { Seq#Index(a#0, j#1), Seq#Index(a#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1 < Seq#Length(Lit(a#0))
               && 
              LitInt(0) <= j#1
               && j#1 < Seq#Length(Lit(a#0))
               && i#1 != j#1
             ==> Seq#Index(Lit(a#0), i#1) != Seq#Index(Lit(a#0), j#1)));

// function declaration for Sequences._default.IndexOf
function Sequences.__default.IndexOf(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : int;

function Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : bool;

// consequence axiom for Sequences.__default.IndexOf
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> LitInt(0) <= Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           < Seq#Length(s#0)
         && Seq#Index(s#0, Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0))
           == e#0);

function Sequences.__default.IndexOf#requires(Ty, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.IndexOf
axiom (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
  { Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
       && $IsBox(e#0, Sequences._default.IndexOf$T)
     ==> Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0)
       == Seq#Contains(s#0, e#0));

function $let#0_i(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : int;

function $let#0$canCall(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : bool;

axiom (forall Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box :: 
  { $let#0_i(Sequences._default.IndexOf$T, s, e) } 
  $let#0$canCall(Sequences._default.IndexOf$T, s, e)
     ==> LitInt(0) <= $let#0_i(Sequences._default.IndexOf$T, s, e)
       && $let#0_i(Sequences._default.IndexOf$T, s, e) < Seq#Length(s)
       && Seq#Index(s, $let#0_i(Sequences._default.IndexOf$T, s, e)) == e);

// definition axiom for Sequences.__default.IndexOf(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           == (var i#0 := $let#0_i(Sequences._default.IndexOf$T, s#0, e#0); i#0));

// definition axiom for Sequences.__default.IndexOf for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0)
           == (var i#1 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), e#0); i#1));

// definition axiom for Sequences.__default.IndexOf for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
           == (var i#2 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)); i#2));

// function declaration for Sequences._default.Range
function Sequences.__default.Range($ly: LayerType, n#0: int) : Seq Box;

function Sequences.__default.Range#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range($LS($ly), n#0) } 
  Sequences.__default.Range($LS($ly), n#0) == Sequences.__default.Range($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range(AsFuelBottom($ly), n#0) } 
  Sequences.__default.Range($ly, n#0) == Sequences.__default.Range($LZ, n#0));

// consequence axiom for Sequences.__default.Range
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($ly, n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> Seq#Length(Sequences.__default.Range($ly, n#0)) == n#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int == i#0)
         && $Is(Sequences.__default.Range($ly, n#0), TSeq(TInt)));

function Sequences.__default.Range#requires(LayerType, int) : bool;

// #requires axiom for Sequences.__default.Range
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range#requires($ly, n#0) } 
  Sequences.__default.Range#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.Range(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($LS($ly), n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0) ==> Sequences.__default.Range#canCall(n#0 - 1))
         && Sequences.__default.Range($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($ly, n#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(n#0 - 1)))));

// definition axiom for Sequences.__default.Range for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { Sequences.__default.Range($LS($ly), LitInt(n#0)) } 
    Sequences.__default.Range#canCall(LitInt(n#0)) || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.Range#canCall(LitInt(n#0 - 1)))
         && Sequences.__default.Range($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($LS($ly), LitInt(n#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(n#0 - 1))))));

// function declaration for Sequences._default.Apply
function Sequences.__default.Apply(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Apply#canCall(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $h0, f#0, run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h0, f#0, run#0)
       == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Apply
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
                i#2)
               == Apply1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Apply$R)));

function Sequences.__default.Apply#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
       && $Is(run#0, TSeq(Sequences._default.Apply$E))
     ==> Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.Apply(revealed)
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, 
        Sequences._default.Apply$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Apply#canCall(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Apply(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                Apply1(Sequences._default.Apply$E, 
                  Sequences._default.Apply$R, 
                  $Heap, 
                  f#0, 
                  Seq#Index(run#0, LitInt(0)))), 
              Sequences.__default.Apply(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $ly, 
                $Heap, 
                f#0, 
                Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.ApplyOpaque
function Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LZ, 
      $Heap, 
      f#0, 
      run#0));

// frame axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $h1, 
      f#0, 
      run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $h0, 
          f#0, 
          run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h0, 
        f#0, 
        run#0)
       == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h1, 
        f#0, 
        run#0));

// consequence axiom for Sequences.__default.ApplyOpaque
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
              Sequences._default.ApplyOpaque$R, 
              $ly, 
              $Heap, 
              f#0, 
              run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $ly, 
                $Heap, 
                f#0, 
                run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                  Sequences._default.ApplyOpaque$R, 
                  $ly, 
                  $Heap, 
                  f#0, 
                  run#0), 
                i#2)
               == Apply1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $ly, 
            $Heap, 
            f#0, 
            run#0), 
          TSeq(Sequences._default.ApplyOpaque$R)));

function Sequences.__default.ApplyOpaque#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
       && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
     ==> Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.ApplyOpaque(revealed)
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> Sequences.__default.Apply#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         && Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == Sequences.__default.Apply(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($LZ), 
            $Heap, 
            f#0, 
            run#0));

// function declaration for Sequences._default.Filter
function Sequences.__default.Filter(Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Filter#canCall(Sequences._default.Filter$E: Ty, $heap: Heap, f#0: HandleType, run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, AsFuelBottom($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $h0, f#0, run#0)
         || ($Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists _x0#0: Box, _o0#0: ref :: 
            $IsBox(_x0#0, Sequences._default.Filter$E)
               && $Is(_o0#0, Tclass._System.object?())
               && Reads1(Sequences._default.Filter$E, TBool, $h0, f#0, _x0#0)[$Box(_o0#0)]
               && $Box($o) == $Box(_o0#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h0, f#0, run#0)
       == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Filter
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#0))))
       ==> Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
           <= Seq#Length(run#0)
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
              i#1) } 
          LitInt(0) <= i#1
             ==> 
            i#1
                 < Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
               && Requires1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))
             ==> $Unbox(Apply1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))): bool)
         && $Is(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Filter$E)));

function Sequences.__default.Filter#requires(Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
       && $Is(run#0, TSeq(Sequences._default.Filter$E))
     ==> Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
       == (forall i#2: int :: 
        { Seq#Index(run#0, i#2) } 
        true
           ==> 
          LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))));

// definition axiom for Sequences.__default.Filter(revealed)
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#2: int :: 
            { Seq#Index(run#0, i#2) } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append((if $Unbox(Apply1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, LitInt(0)))): bool
                 then Seq#Build(Seq#Empty(): Seq Box, Seq#Index(run#0, LitInt(0)))
                 else Seq#Empty(): Seq Box), 
              Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.FoldLeft
function Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldLeft
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> $IsBox(Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldLeft$A));

function Sequences.__default.FoldLeft#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldLeft
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Sequences._default.FoldLeft$A))
       && $IsBox(init#0, Sequences._default.FoldLeft$A)
       && $Is(run#0, TSeq(Sequences._default.FoldLeft$E))
     ==> Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldLeft(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(run#0, LitInt(0))), 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $ly, 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(run#0, LitInt(0))), 
              Seq#Drop(run#0, LitInt(1)))));

// definition axiom for Sequences.__default.FoldLeft for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// definition axiom for Sequences.__default.FoldLeft for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            Lit(f#0), 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              Lit(f#0), 
              Lit(init#0), 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              Lit(f#0), 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                Lit(f#0), 
                Lit(init#0), 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// function declaration for Sequences._default.FoldRight
function Sequences.__default.FoldRight(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldRight
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> $IsBox(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldRight$A));

function Sequences.__default.FoldRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldRight
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Sequences._default.FoldRight$A))
       && $IsBox(init#0, Sequences._default.FoldRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldRight$E))
     ==> Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Seq#Drop(run#0, LitInt(1))), 
              Seq#Index(run#0, LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Seq#Drop(Lit(run#0), LitInt(1)))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            Lit(f#0), 
            Lit(init#0), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                  Sequences._default.FoldRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Seq#Drop(Lit(run#0), LitInt(1))))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// function declaration for Sequences._default.FoldFromRight
function Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldFromRight
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> $IsBox(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldFromRight$A));

function Sequences.__default.FoldFromRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldFromRight
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Sequences._default.FoldFromRight$A))
       && $IsBox(init#0, Sequences._default.FoldFromRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E))
     ==> Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldFromRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, run#0)
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, run#0))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0)), 
              Sequences.__default.Last(Sequences._default.FoldFromRight$E, run#0))));

// definition axiom for Sequences.__default.FoldFromRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0)))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// definition axiom for Sequences.__default.FoldFromRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Lit(f#0), 
              Lit(init#0), 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                  Sequences._default.FoldFromRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// function declaration for Sequences._default.remove
function Sequences.__default.remove(Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int)
   : Seq Box;

function Sequences.__default.remove#canCall(Sequences._default.remove$A: Ty, s#0: Seq Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, AsFuelBottom($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $LZ, s#0, pos#0));

// consequence axiom for Sequences.__default.remove
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1) } 
          pos#0 <= i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1)
               == Seq#Index(s#0, i#1 + 1))
         && $Is(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), 
          TSeq(Sequences._default.remove$A)));

function Sequences.__default.remove#requires(Ty, LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.remove
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.remove$A))
     ==> Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.remove(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
         == Seq#Append(Seq#Take(s#0, pos#0), Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.remove for all literals(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    {:weight 3} { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0)) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, Lit(s#0), LitInt(pos#0))
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0))
         == Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.insert
function Sequences.__default.insert(Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.insert#canCall(Sequences._default.insert$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.insert
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 <= i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.insert$A)));

function Sequences.__default.insert#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.insert
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.insert$A))
       && $IsBox(a#0, Sequences._default.insert$A)
     ==> Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 <= Seq#Length(s#0)));

// definition axiom for Sequences.__default.insert(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0)));

// definition axiom for Sequences.__default.insert for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// definition axiom for Sequences.__default.insert for all literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// function declaration for Sequences._default.replace1with2
function Sequences.__default.replace1with2(Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A: Ty, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, AsFuelBottom($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LZ, s#0, a#0, b#0, pos#0));

// consequence axiom for Sequences.__default.replace1with2
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0)
           == a#0
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0 + 1)
           == b#0
         && $Is(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
          TSeq(Sequences._default.replace1with2$A)));

function Sequences.__default.replace1with2#requires(Ty, LayerType, Seq Box, Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace1with2
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace1with2$A))
       && $IsBox(a#0, Sequences._default.replace1with2$A)
       && $IsBox(b#0, Sequences._default.replace1with2$A)
     ==> Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.replace1with2(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.replace1with2 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), a#0, b#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// definition axiom for Sequences.__default.replace1with2 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
        $LS($ly), 
        Lit(s#0), 
        Lit(a#0), 
        Lit(b#0), 
        LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), Lit(a#0), Lit(b#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
          $LS($ly), 
          Lit(s#0), 
          Lit(a#0), 
          Lit(b#0), 
          LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, Lit(a#0)), Lit(b#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.replace2with1
function Sequences.__default.replace2with1(Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.replace2with1
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Seq#Length(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#1)
               == Seq#Index(s#0, i#1 + 1))
         && Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.replace2with1$A)));

function Sequences.__default.replace2with1#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace2with1
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace2with1$A))
       && $IsBox(a#0, Sequences._default.replace2with1$A)
     ==> Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0) - 1));

// definition axiom for Sequences.__default.replace2with1(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0 + 2)));

// definition axiom for Sequences.__default.replace2with1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// definition axiom for Sequences.__default.replace2with1 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// function declaration for Sequences._default.concat
function Sequences.__default.concat(Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat#canCall(Sequences._default.concat$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.concat
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Seq#Length(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0))
           == Seq#Length(a#0) + Seq#Length(b#0)
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0))
         && (forall i#1: int :: 
          { Seq#Index(b#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(b#0)
             ==> Seq#Index(b#0, i#1)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
                Seq#Length(a#0) + i#1))
         && $Is(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
          TSeq(Sequences._default.concat$A)));

function Sequences.__default.concat#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.concat$A))
       && $Is(b#0, TSeq(Sequences._default.concat$A))
     ==> Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.concat(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
         == Seq#Append(a#0, b#0));

// definition axiom for Sequences.__default.concat for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0))
         == Seq#Append(a#0, b#0));

// function declaration for Sequences._default.concat3
function Sequences.__default.concat3(Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat3#canCall(Sequences._default.concat3$A: Ty, a#0: Seq Box, b#0: Box, c#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, AsFuelBottom($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $LZ, a#0, b#0, c#0));

// consequence axiom for Sequences.__default.concat3
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Seq#Length(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0))
           == Seq#Length(a#0) + Seq#Length(c#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
              i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                i#0))
         && Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
            Seq#Length(a#0))
           == b#0
         && (forall i#1: int :: 
          { Seq#Index(c#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(c#0)
             ==> Seq#Index(c#0, i#1)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                Seq#Length(a#0) + 1 + i#1))
         && $Is(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
          TSeq(Sequences._default.concat3$A)));

function Sequences.__default.concat3#requires(Ty, LayerType, Seq Box, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat3
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
  $Is(a#0, TSeq(Sequences._default.concat3$A))
       && $IsBox(b#0, Sequences._default.concat3$A)
       && $Is(c#0, TSeq(Sequences._default.concat3$A))
     ==> Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
       == true);

// definition axiom for Sequences.__default.concat3(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), b#0, Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), Lit(b#0), Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, Lit(b#0))), c#0));

// function declaration for Sequences._default.concatSeq
function Sequences.__default.concatSeq(Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box) : Seq Box;

function Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, AsFuelBottom($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LZ, a#0));

// consequence axiom for Sequences.__default.concatSeq
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> $Is(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0), 
        TSeq(Sequences._default.concatSeq$A)));

function Sequences.__default.concatSeq#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.concatSeq
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0) } 
  $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
     ==> Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.concatSeq(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), a#0)
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), a#0))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), a#0)): Seq Box)));

// definition axiom for Sequences.__default.concatSeq for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0)) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, Lit(a#0))
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0))
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), Lit(a#0))): Seq Box)));

// function declaration for Sequences._default.IsPrefix
function Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsPrefix
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> 
      Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       ==> Seq#Length(a#0) <= Seq#Length(b#0));

function Sequences.__default.IsPrefix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsPrefix
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsPrefix$A))
       && $Is(b#0, TSeq(Sequences._default.IsPrefix$A))
     ==> Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsPrefix(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Take(b#0, Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsPrefix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Take(Lit(b#0), Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.IsSuffix
function Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsSuffix
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> true);

function Sequences.__default.IsSuffix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsSuffix
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsSuffix$A))
       && $Is(b#0, TSeq(Sequences._default.IsSuffix$A))
     ==> Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsSuffix(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Drop(b#0, Seq#Length(b#0) - Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsSuffix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.SeqIndexIterate
function Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : DatatypeType;

function Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A: Ty, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, AsFuelBottom($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LZ, run#0, needle#0, i#0));

// consequence axiom for Sequences.__default.SeqIndexIterate
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> (forall j#0: int :: 
            { Seq#Index(run#0, j#0) } 
            i#0 <= j#0 && j#0 < Seq#Length(run#0) ==> Seq#Index(run#0, j#0) != needle#0))
         && $Is(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndexIterate#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.SeqIndexIterate
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
       && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
     ==> Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(run#0)));

// definition axiom for Sequences.__default.SeqIndexIterate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (i#0 != Seq#Length(run#0)
           ==> 
          Seq#Index(run#0, i#0) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0 + 1))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
           == (if i#0 == Seq#Length(run#0)
             then #Options.Option.None()
             else (if Seq#Index(run#0, i#0) == needle#0
               then #Options.Option.Some($Box(i#0))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        needle#0, 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            needle#0, 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == needle#0
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                needle#0, 
                LitInt(i#0 + 1)))));

// definition axiom for Sequences.__default.SeqIndexIterate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        Lit(needle#0), 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != Lit(needle#0)
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == Lit(needle#0)
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                Lit(needle#0), 
                LitInt(i#0 + 1)))));

// function declaration for Sequences._default.SeqIndex
function Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box)
   : DatatypeType;

function Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A: Ty, run#0: Seq Box, needle#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, AsFuelBottom($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LZ, run#0, needle#0));

// consequence axiom for Sequences.__default.SeqIndex
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Seq#Index(run#0, i#0) != needle#0))
         && $Is(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndex#requires(Ty, LayerType, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndex
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndex$A))
       && $IsBox(needle#0, Sequences._default.SeqIndex$A)
     ==> Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
       == true);

// definition axiom for Sequences.__default.SeqIndex(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, run#0, needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            run#0, 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0)) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0))
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0), LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0))
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(0)));

// function declaration for Sequences._default.SeqOfLength
function Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box)
   : Seq Box;

function Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V: Ty, length#0: int, v#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, AsFuelBottom($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LZ, length#0, v#0));

// consequence axiom for Sequences.__default.SeqOfLength
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
           == length#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
              i#0) } 
          LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
             ==> Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
                i#0)
               == v#0)
         && $Is(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
          TSeq(Sequences._default.SeqOfLength$V)));

function Sequences.__default.SeqOfLength#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqOfLength
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
  LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V)
     ==> Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
       == true);

// definition axiom for Sequences.__default.SeqOfLength(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (length#0 != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0 - 1, v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
           == (if length#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0 - 1, v#0))));

// definition axiom for Sequences.__default.SeqOfLength for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0)
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), v#0))));

// definition axiom for Sequences.__default.SeqOfLength for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0)) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), Lit(v#0))
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), Lit(v#0)))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0))
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, Lit(v#0)), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), Lit(v#0)))));

// function declaration for Sequences._default.SeqIndexUpdate
function Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box)
   : Seq Box;

function Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T: Ty, s#0: Seq Box, i#0: int, t#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, AsFuelBottom($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LZ, s#0, i#0, t#0));

// consequence axiom for Sequences.__default.SeqIndexUpdate
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Seq#Equal(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          Seq#Update(s#0, i#0, t#0))
         && $Is(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          TSeq(Sequences._default.SeqIndexUpdate$T)));

function Sequences.__default.SeqIndexUpdate#requires(Ty, LayerType, Seq Box, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndexUpdate
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
  $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
     ==> Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
       == (i#0 + 1 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.SeqIndexUpdate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(s#0, i#0 + 1)));

// definition axiom for Sequences.__default.SeqIndexUpdate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0)
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexUpdate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0)) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), Lit(t#0))
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(t#0))), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// function declaration for Sequences._default.Zip
function Sequences.__default.Zip(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : Seq Box;

function Sequences.__default.Zip#canCall(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.Zip
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
           == Seq#Length(a#0)
         && (forall i#0: int :: 
          { Seq#Index(b#0, i#0) } 
            { Seq#Index(a#0, i#0) } 
            { $Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                i#0)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
             ==> _System.Tuple2#Equal($Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                  i#0)): DatatypeType, 
              #_System._tuple#2._#Make2(Seq#Index(a#0, i#0), Seq#Index(b#0, i#0))))
         && $Is(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
          TSeq(Tclass._System.Tuple2(Sequences._default.Zip$A, Sequences._default.Zip$B))));

function Sequences.__default.Zip#requires(Ty, Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.Zip
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.Zip$A))
       && $Is(b#0, TSeq(Sequences._default.Zip$B))
     ==> Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
       == 
      (Seq#Length(a#0)
       == Seq#Length(b#0)));

// definition axiom for Sequences.__default.Zip(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, b#0)
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
              Sequences.__default.DropLast(Sequences._default.Zip$B, b#0))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, b#0))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $ly, 
                Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
                Sequences.__default.DropLast(Sequences._default.Zip$B, b#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#_System._tuple#2._#Make2(Sequences.__default.Last(Sequences._default.Zip$A, a#0), 
                    Sequences.__default.Last(Sequences._default.Zip$B, b#0)))))));

// definition axiom for Sequences.__default.Zip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(Lit(a#0)) == Seq#Length(Lit(b#0)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, Lit(b#0))
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0))))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, Lit(b#0)))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#_System._tuple#2._#Make2(Lit(Sequences.__default.Last(Sequences._default.Zip$A, Lit(a#0))), 
                      Lit(Sequences.__default.Last(Sequences._default.Zip$B, Lit(b#0))))))))));

// function declaration for Sequences._default.Unzip
function Sequences.__default.Unzip(Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box)
   : DatatypeType;

function Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A: Ty, Sequences._default.Unzip$B: Ty, z#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0));

// fuel synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, AsFuelBottom($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LZ, z#0));

// consequence axiom for Sequences.__default.Unzip
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> Seq#Length($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
         && Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length(z#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(z#0, i#0)): DatatypeType } 
            { Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
            { Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(z#0)
             ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0), 
                Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0)), 
              $Unbox(Seq#Index(z#0, i#0)): DatatypeType))
         && $Is(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0), 
          Tclass._System.Tuple2(TSeq(Sequences._default.Unzip$A), TSeq(Sequences._default.Unzip$B))));

function Sequences.__default.Unzip#requires(Ty, Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Unzip
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
  $Is(z#0, 
      TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
     ==> Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
       == true);

// definition axiom for Sequences.__default.Unzip(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(z#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                z#0))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType)
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
           == (if Seq#Length(z#0) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#0, b#0 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._0($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType)))), 
                $Box(Seq#Append(b#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._1($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType))))))));

// definition axiom for Sequences.__default.Unzip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0)) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, Lit(z#0))
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(Lit(z#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  Lit(z#0))))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType)))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0))
           == (if Seq#Length(Lit(z#0)) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#1, b#1 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._0(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType)))))), 
                $Box(Seq#Append(b#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._1(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType))))))))));

// function declaration for Sequences._default.FlattenShape
function Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box)
   : Seq Box;

function Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.FlattenShape
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
           == Seq#Length(seqs#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(seqs#0, i#0)): Seq Box } 
            { $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
             ==> $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                  i#0)): int
               == Seq#Length($Unbox(Seq#Index(seqs#0, i#0)): Seq Box))
         && $Is(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
          TSeq(Tclass._System.nat())));

function Sequences.__default.FlattenShape#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenShape
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
     ==> Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0)
       == true);

// definition axiom for Sequences.__default.FlattenShape(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0)
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), seqs#0)): Seq Box))))));

// definition axiom for Sequences.__default.FlattenShape for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length(Lit($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))): Seq Box)))))));

// function declaration for Sequences._default.FlattenLength
function Sequences.__default.FlattenLength($ly: LayerType, shape#0: Seq Box) : int;

function Sequences.__default.FlattenLength#canCall(shape#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
  Sequences.__default.FlattenLength($LS($ly), shape#0)
     == Sequences.__default.FlattenLength($ly, shape#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength(AsFuelBottom($ly), shape#0) } 
  Sequences.__default.FlattenLength($ly, shape#0)
     == Sequences.__default.FlattenLength($LZ, shape#0));

// consequence axiom for Sequences.__default.FlattenLength
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($ly, shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) == LitInt(0)
           ==> Sequences.__default.FlattenLength($ly, shape#0) == LitInt(0))
         && LitInt(0) <= Sequences.__default.FlattenLength($ly, shape#0));

function Sequences.__default.FlattenLength#requires(LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenLength
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength#requires($ly, shape#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat()))
     ==> Sequences.__default.FlattenLength#requires($ly, shape#0) == true);

// definition axiom for Sequences.__default.FlattenLength(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), shape#0))
         && Sequences.__default.FlattenLength($LS($ly), shape#0)
           == (if Seq#Length(shape#0) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), shape#0)): int));

// definition axiom for Sequences.__default.FlattenLength for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenLength($LS($ly), Lit(shape#0)) } 
    Sequences.__default.FlattenLength#canCall(Lit(shape#0))
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(Lit(shape#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), Lit(shape#0)))
         && Sequences.__default.FlattenLength($LS($ly), Lit(shape#0))
           == (if Seq#Length(Lit(shape#0)) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($LS($ly), Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), Lit(shape#0))): int));

// function declaration for Sequences._default.Flatten
function Sequences.__default.Flatten(Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box) : Seq Box;

function Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.Flatten
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Sequences._default.Flatten$A, StartFuel_Sequences._default.FlattenShape, seqs#0))
         && (Seq#Length(seqs#0) == LitInt(0)
           ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
             == LitInt(0))
         && $Is(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0), 
          TSeq(Sequences._default.Flatten$A)));

function Sequences.__default.Flatten#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Flatten
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
     ==> Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0)
       == true);

const MoreFuel_Sequences._default.FlattenShape0: LayerType;

// definition axiom for Sequences.__default.Flatten(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), seqs#0)
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), seqs#0))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape0)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape0)
           == MoreFuel_Sequences._default.FlattenShape0
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), seqs#0)): Seq Box)));

const MoreFuel_Sequences._default.FlattenShape1: LayerType;

// definition axiom for Sequences.__default.Flatten for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape1)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape1)
           == MoreFuel_Sequences._default.FlattenShape1
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))): Seq Box)));

// function declaration for Sequences._default.FlattenIndex
function Sequences.__default.FlattenIndex(shape#0: Seq Box, i#0: int, j#0: int) : int;

function Sequences.__default.FlattenIndex#canCall(shape#0: Seq Box, i#0: int, j#0: int) : bool;

// consequence axiom for Sequences.__default.FlattenIndex
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> LitInt(0) <= Sequences.__default.FlattenIndex(shape#0, i#0, j#0));

function Sequences.__default.FlattenIndex#requires(Seq Box, int, int) : bool;

// #requires axiom for Sequences.__default.FlattenIndex
axiom (forall shape#0: Seq Box, i#0: int, j#0: int :: 
  { Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0 && LitInt(0) <= j#0
     ==> Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0)
       == (i#0 < Seq#Length(shape#0) && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int));

// definition axiom for Sequences.__default.FlattenIndex(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> Sequences.__default.FlattenLength#canCall(Seq#Take(shape#0, i#0))
         && Sequences.__default.FlattenIndex(shape#0, i#0, j#0)
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Seq#Take(shape#0, i#0))
             + j#0);

// definition axiom for Sequences.__default.FlattenIndex for all literals(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    {:weight 3} { Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0)) } 
    Sequences.__default.FlattenIndex#canCall(Lit(shape#0), LitInt(i#0), LitInt(j#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(Lit(shape#0))
           && j#0 < $Unbox(Seq#Index(Lit(shape#0), LitInt(i#0))): int)
       ==> Sequences.__default.FlattenLength#canCall(Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
         && Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
             + j#0);

// function declaration for Sequences._default.UnflattenIndex
function Sequences.__default.UnflattenIndex($ly: LayerType, shape#0: Seq Box, i#0: int) : DatatypeType;

function Sequences.__default.UnflattenIndex#canCall(shape#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
     == Sequences.__default.UnflattenIndex($ly, shape#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex(AsFuelBottom($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($ly, shape#0, i#0)
     == Sequences.__default.UnflattenIndex($LZ, shape#0, i#0));

// consequence axiom for Sequences.__default.UnflattenIndex
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($ly, shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> $Is(Sequences.__default.UnflattenIndex($ly, shape#0, i#0), 
        Tclass._System.Tuple2(Tclass._System.nat(), Tclass._System.nat())));

function Sequences.__default.UnflattenIndex#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.UnflattenIndex
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0
     ==> Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0)
       == (i#0
         < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0)));

const MoreFuel_Sequences._default.FlattenLength0: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
         && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.UnflattenIndex#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0)))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength0)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength0)
           == MoreFuel_Sequences._default.FlattenLength0
         && Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             then Sequences.__default.UnflattenIndex($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0)
             else #_System._tuple#2._#Make2($Box(Seq#Length(shape#0) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Sequences.__default.DropLast(Tclass._System.nat(), shape#0))))));

const MoreFuel_Sequences._default.FlattenLength1: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    {:weight 3} { Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0)) } 
    Sequences.__default.UnflattenIndex#canCall(Lit(shape#0), LitInt(i#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Lit(shape#0)))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
         && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.UnflattenIndex#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0)))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0)))))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength1)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength1)
           == MoreFuel_Sequences._default.FlattenLength1
         && Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0))
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             then Sequences.__default.UnflattenIndex($LS($ly), 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0))
             else #_System._tuple#2._#Make2($Box(Seq#Length(Lit(shape#0)) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))))));

// function declaration for Sequences._default.fill
function Sequences.__default.fill(Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box) : Seq Box;

function Sequences.__default.fill#canCall(Sequences._default.fill$T: Ty, n#0: int, t#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, AsFuelBottom($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $LZ, n#0, t#0));

// consequence axiom for Sequences.__default.fill
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> Seq#Length(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0))
           == n#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0)
               == t#0)
         && $Is(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), 
          TSeq(Sequences._default.fill$T)));

function Sequences.__default.fill#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.fill
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0) } 
  $IsBox(t#0, Sequences._default.fill$T)
     ==> Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0)
       == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.fill(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> (n#0 != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0 - 1, t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0 - 1, t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0)
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for all literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0)) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), Lit(t#0))
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), Lit(t#0)))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), Lit(t#0)), 
              Seq#Build(Seq#Empty(): Seq Box, Lit(t#0)))));
